import { ref as Xe, reactive as M0, nextTick as Bp, openBlock as ri, createElementBlock as ni, normalizeStyle as Ur, createElementVNode as hr, toDisplayString as mn, unref as C0, createCommentVNode as ns, Fragment as os, createTextVNode as k0, renderList as Qa, normalizeClass as A0, defineCustomElement as jp } from "vue";
const fs = {
  //图表配置
  chart: {
    spacingTop: 30,
    backgroundColor: "rgba(0,0,0,0)"
  },
  title: {
    enabled: !1
  },
  exporting: {
    enabled: !1
  },
  boost: {
    useGPUTranslations: !0
  },
  //默认颜色配置
  colors: [
    "#00f",
    "#f00",
    "#999",
    "#000",
    "#7cb5ec",
    "#90ed7d",
    "#f7a35c",
    "#8085e9",
    "#f15c80",
    "#e4d354",
    "#2b908f",
    "#f45b5b",
    "#91e8e1"
  ],
  //版权信息
  credits: { enabled: !1 },
  //数据列通用配置
  plotOptions: {
    series: {
      turboThreshold: 0,
      //不限制数据点个数 
      boostThreshold: 0,
      animation: {
        duration: 1e3
      }
    },
    areaspline: {
      lineWidth: 1,
      stacking: "normal",
      marker: {
        enabled: !1
      }
      // fillOpacity: 0.5,
    },
    column: {
      pointPadding: 0.05,
      stacking: "normal"
    },
    scatter: {
      turboThreshold: 0,
      marker: {
        symbol: "circle",
        radius: 5,
        states: {
          hover: {
            enabled: !0
          }
        }
      },
      states: {
        hover: {
          marker: {
            enabled: !0
          }
        }
      }
    }
  },
  //范围选择器
  rangeSelector: {
    enabled: !1,
    selected: 2
  },
  //悬浮提示框
  tooltip: {
    split: !1,
    shared: !0,
    dateTimeLabelFormats: {
      // 时间格式化字符
      day: "%Y/%m/%d",
      week: "%Y/%m",
      month: "%Y/%m",
      year: "%Y/%m"
    },
    xDateFormat: "%Y/%m/%d",
    className: "chart-tooltips-box"
    // formatter:function(e){
    // 	return `<p>${this.x}</p><p>aaa</p>`
    // 	// return e
    // }
    // outside: true,
    // valueDecimals: 4,
  },
  //图例
  legend: {
    enabled: !0,
    verticalAlign: "top",
    margin: 3
    // layout: 'vertical'
  },
  //滚动条
  scrollbar: {
    enabled: !1
  },
  //导航器
  navigator: {
    enabled: !1
  },
  //范围选择器
  rangeSelector: {
    enabled: !1
  },
  xAxis: {
    tickPosition: "inside",
    lineColor: "#bfbfbf",
    tickColor: "#bfbfbf",
    tickLength: 5,
    type: "datetime",
    ordinal: !1,
    dateTimeLabelFormats: {
      day: "%y/%m",
      week: "%y/%m",
      month: "%y/%m",
      year: "%y/%m"
    }
    // gridLineWidth:0
  }
}, Mn = {
  tickPosition: "inside",
  lineColor: "#bfbfbf",
  tickColor: "#bfbfbf",
  tickLength: 5,
  ordinal: !1,
  type: "linear"
}, Or = {
  tickWidth: 1,
  tickLength: 5,
  lineWidth: 1,
  lineColor: "#bfbfbf",
  tickColor: "#bfbfbf",
  // offset: 0,
  visible: !0,
  gridLineWidth: 0,
  tickPosition: "inside",
  endOnTick: !1,
  startOnTick: !1,
  showLastLabel: !0,
  tickPixelInterval: 50
}, Wp = {
  tickPosition: "inside",
  lineColor: "#bfbfbf",
  tickColor: "#bfbfbf",
  tickLength: 5,
  type: "datetime",
  ordinal: !1,
  dateTimeLabelFormats: {
    day: "%y/%m",
    week: "%y/%m",
    month: "%y/%m",
    year: "%y/%m"
  },
  xDateFormat: "%Y-%m-%d"
}, T0 = {
  年: "Y",
  季: "Q",
  月: "M",
  周: "W",
  天: "D"
}, bp = {
  年: "Year",
  季: "Season",
  月: "Month",
  周: "Week",
  天: "Day"
};
var Hr = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function Cn(r) {
  return r && r.__esModule && Object.prototype.hasOwnProperty.call(r, "default") ? r.default : r;
}
var zp = { exports: {} };
(function(r) {
  (function(g, E) {
    r.exports ? (E.default = E, r.exports = g.document ? E(g) : E) : (g.Highcharts && g.Highcharts.error(16, !0), g.Highcharts = E(g));
  })(typeof window < "u" ? window : Hr, function(g) {
    function E(y, R, I, Z) {
      y.hasOwnProperty(R) || (y[R] = Z.apply(null, I));
    }
    var a = {};
    return E(a, "Core/Globals.js", [], function() {
      var y = typeof g < "u" ? g : typeof window < "u" ? window : {}, R;
      return function(I) {
        I.SVG_NS = "http://www.w3.org/2000/svg", I.product = "Highcharts", I.version = "9.3.3", I.win = y, I.doc = I.win.document, I.svg = I.doc && I.doc.createElementNS && !!I.doc.createElementNS(I.SVG_NS, "svg").createSVGRect, I.userAgent = I.win.navigator && I.win.navigator.userAgent || "", I.isChrome = I.userAgent.indexOf("Chrome") !== -1, I.isFirefox = I.userAgent.indexOf("Firefox") !== -1, I.isMS = /(edge|msie|trident)/i.test(I.userAgent) && !I.win.opera, I.isSafari = !I.isChrome && I.userAgent.indexOf("Safari") !== -1, I.isTouchDevice = /(Mobile|Android|Windows Phone)/.test(I.userAgent), I.isWebKit = I.userAgent.indexOf("AppleWebKit") !== -1, I.deg2rad = 2 * Math.PI / 360, I.hasBidiBug = I.isFirefox && 4 > parseInt(I.userAgent.split("Firefox/")[1], 10), I.hasTouch = !!I.win.TouchEvent, I.marginNames = ["plotTop", "marginRight", "marginBottom", "plotLeft"], I.noop = function() {
        }, I.supportsPassiveEvents = function() {
          var Z = !1;
          if (!I.isMS) {
            var H = Object.defineProperty({}, "passive", { get: function() {
              Z = !0;
            } });
            I.win.addEventListener && I.win.removeEventListener && (I.win.addEventListener(
              "testPassive",
              I.noop,
              H
            ), I.win.removeEventListener("testPassive", I.noop, H));
          }
          return Z;
        }(), I.charts = [], I.dateFormats = {}, I.seriesTypes = {}, I.symbolSizes = {}, I.chartCount = 0;
      }(R || (R = {})), R;
    }), E(a, "Core/Utilities.js", [a["Core/Globals.js"]], function(y) {
      function R(t, n, o, A) {
        var _ = n ? "Highcharts error" : "Highcharts warning";
        t === 32 && (t = _ + ": Deprecated member");
        var D = M(t), j = D ? _ + " #" + t + ": www.highcharts.com/errors/" + t + "/" : t.toString();
        if (typeof A < "u") {
          var T = "";
          D && (j += "?"), b(A, function(X, f) {
            T += `
 - ` + f + ": " + X, D && (j += encodeURI(f) + "=" + encodeURI(X));
          }), j += T;
        }
        x(y, "displayError", { chart: o, code: t, message: j, params: A }, function() {
          if (n)
            throw Error(j);
          p.console && R.messages.indexOf(j) === -1 && console.warn(j);
        }), R.messages.push(j);
      }
      function I(t, n) {
        var o = {};
        return b(t, function(A, _) {
          U(t[_], !0) && !t.nodeType && n[_] ? (A = I(t[_], n[_]), Object.keys(A).length && (o[_] = A)) : (U(t[_]) || t[_] !== n[_]) && (o[_] = t[_]);
        }), o;
      }
      function Z(t, n) {
        return parseInt(t, n || 10);
      }
      function H(t) {
        return typeof t == "string";
      }
      function $(t) {
        return t = Object.prototype.toString.call(t), t === "[object Array]" || t === "[object Array Iterator]";
      }
      function U(t, n) {
        return !!t && typeof t == "object" && (!n || !$(t));
      }
      function W(t) {
        return U(t) && typeof t.nodeType == "number";
      }
      function N(t) {
        var n = t && t.constructor;
        return !(!U(t, !0) || W(t) || !n || !n.name || n.name === "Object");
      }
      function M(t) {
        return typeof t == "number" && !isNaN(t) && 1 / 0 > t && -1 / 0 < t;
      }
      function v(t) {
        return typeof t < "u" && t !== null;
      }
      function u(t, n, o) {
        var A;
        return H(n) ? v(o) ? t.setAttribute(n, o) : t && t.getAttribute && ((A = t.getAttribute(n)) || n !== "class" || (A = t.getAttribute(n + "Name"))) : b(n, function(_, D) {
          v(_) ? t.setAttribute(D, _) : t.removeAttribute(D);
        }), A;
      }
      function d(t, n) {
        var o;
        t || (t = {});
        for (o in n)
          t[o] = n[o];
        return t;
      }
      function P() {
        for (var t = arguments, n = t.length, o = 0; o < n; o++) {
          var A = t[o];
          if (typeof A < "u" && A !== null)
            return A;
        }
      }
      function O(t, n) {
        y.isMS && !y.svg && n && typeof n.opacity < "u" && (n.filter = "alpha(opacity=" + 100 * n.opacity + ")"), d(t.style, n);
      }
      function B(t, n) {
        return 1e14 < t ? t : parseFloat(t.toPrecision(n || 14));
      }
      function C(t, n, o) {
        var A = y.getStyle || C;
        if (n === "width")
          return n = Math.min(t.offsetWidth, t.scrollWidth), o = t.getBoundingClientRect && t.getBoundingClientRect().width, o < n && o >= n - 1 && (n = Math.floor(o)), Math.max(0, n - (A(t, "padding-left", !0) || 0) - (A(t, "padding-right", !0) || 0));
        if (n === "height")
          return Math.max(0, Math.min(t.offsetHeight, t.scrollHeight) - (A(t, "padding-top", !0) || 0) - (A(t, "padding-bottom", !0) || 0));
        if (p.getComputedStyle || R(27, !0), t = p.getComputedStyle(t, void 0)) {
          var _ = t.getPropertyValue(n);
          P(o, n !== "opacity") && (_ = Z(_));
        }
        return _;
      }
      function b(t, n, o) {
        for (var A in t)
          Object.hasOwnProperty.call(t, A) && n.call(o || t[A], t[A], A, t);
      }
      function w(t, n, o) {
        function A(T, X) {
          var f = t.removeEventListener || y.removeEventListenerPolyfill;
          f && f.call(t, T, X, !1);
        }
        function _(T) {
          var X;
          if (t.nodeName) {
            if (n) {
              var f = {};
              f[n] = !0;
            } else
              f = T;
            b(f, function(m, L) {
              if (T[L])
                for (X = T[L].length; X--; )
                  A(L, T[L][X].fn);
            });
          }
        }
        var D = typeof t == "function" && t.prototype || t;
        if (Object.hasOwnProperty.call(D, "hcEvents")) {
          var j = D.hcEvents;
          n ? (D = j[n] || [], o ? (j[n] = D.filter(function(T) {
            return o !== T.fn;
          }), A(n, o)) : (_(j), j[n] = [])) : (_(j), delete D.hcEvents);
        }
      }
      function x(t, n, o, A) {
        if (o = o || {}, c.createEvent && (t.dispatchEvent || t.fireEvent && t !== y)) {
          var _ = c.createEvent("Events");
          _.initEvent(n, !0, !0), o = d(_, o), t.dispatchEvent ? t.dispatchEvent(o) : t.fireEvent(n, o);
        } else if (t.hcEvents) {
          o.target || d(o, { preventDefault: function() {
            o.defaultPrevented = !0;
          }, target: t, type: n }), _ = [];
          for (var D = t, j = !1; D.hcEvents; )
            Object.hasOwnProperty.call(D, "hcEvents") && D.hcEvents[n] && (_.length && (j = !0), _.unshift.apply(_, D.hcEvents[n])), D = Object.getPrototypeOf(D);
          j && _.sort(function(T, X) {
            return T.order - X.order;
          }), _.forEach(function(T) {
            T.fn.call(t, o) === !1 && o.preventDefault();
          });
        }
        A && !o.defaultPrevented && A.call(t, o);
      }
      var h = y.charts, c = y.doc, p = y.win;
      (R || (R = {})).messages = [], Math.easeInOutSine = function(t) {
        return -0.5 * (Math.cos(Math.PI * t) - 1);
      };
      var i = Array.prototype.find ? function(t, n) {
        return t.find(n);
      } : function(t, n) {
        var o, A = t.length;
        for (o = 0; o < A; o++)
          if (n(t[o], o))
            return t[o];
      };
      b({ map: "map", each: "forEach", grep: "filter", reduce: "reduce", some: "some" }, function(t, n) {
        y[n] = function(o) {
          var A;
          return R(32, !1, void 0, (A = {}, A["Highcharts." + n] = "use Array." + t, A)), Array.prototype[t].apply(o, [].slice.call(arguments, 1));
        };
      });
      var l, s = function() {
        var t = Math.random().toString(36).substring(2, 9) + "-", n = 0;
        return function() {
          return "highcharts-" + (l ? "" : t) + n++;
        };
      }();
      return p.jQuery && (p.jQuery.fn.highcharts = function() {
        var t = [].slice.call(arguments);
        if (this[0])
          return t[0] ? (new y[H(t[0]) ? t.shift() : "Chart"](this[0], t[0], t[1]), this) : h[u(this[0], "data-highcharts-chart")];
      }), i = { addEvent: function(t, n, o, A) {
        A === void 0 && (A = {});
        var _ = typeof t == "function" && t.prototype || t;
        Object.hasOwnProperty.call(_, "hcEvents") || (_.hcEvents = {}), _ = _.hcEvents, y.Point && t instanceof y.Point && t.series && t.series.chart && (t.series.chart.runTrackerClick = !0);
        var D = t.addEventListener || y.addEventListenerPolyfill;
        return D && D.call(t, n, o, y.supportsPassiveEvents ? { passive: A.passive === void 0 ? n.indexOf("touch") !== -1 : A.passive, capture: !1 } : !1), _[n] || (_[n] = []), _[n].push({ fn: o, order: typeof A.order == "number" ? A.order : 1 / 0 }), _[n].sort(function(j, T) {
          return j.order - T.order;
        }), function() {
          w(t, n, o);
        };
      }, arrayMax: function(t) {
        for (var n = t.length, o = t[0]; n--; )
          t[n] > o && (o = t[n]);
        return o;
      }, arrayMin: function(t) {
        for (var n = t.length, o = t[0]; n--; )
          t[n] < o && (o = t[n]);
        return o;
      }, attr: u, clamp: function(t, n, o) {
        return t > n ? t < o ? t : o : n;
      }, cleanRecursively: I, clearTimeout: function(t) {
        v(t) && clearTimeout(t);
      }, correctFloat: B, createElement: function(t, n, o, A, _) {
        return t = c.createElement(t), n && d(t, n), _ && O(t, { padding: "0", border: "none", margin: "0" }), o && O(t, o), A && A.appendChild(t), t;
      }, css: O, defined: v, destroyObjectProperties: function(t, n) {
        b(t, function(o, A) {
          o && o !== n && o.destroy && o.destroy(), delete t[A];
        });
      }, discardElement: function(t) {
        t && t.parentElement && t.parentElement.removeChild(t);
      }, erase: function(t, n) {
        for (var o = t.length; o--; )
          if (t[o] === n) {
            t.splice(o, 1);
            break;
          }
      }, error: R, extend: d, extendClass: function(t, n) {
        var o = function() {
        };
        return o.prototype = new t(), d(o.prototype, n), o;
      }, find: i, fireEvent: x, getMagnitude: function(t) {
        return Math.pow(10, Math.floor(Math.log(t) / Math.LN10));
      }, getNestedProperty: function(t, n) {
        for (t = t.split("."); t.length && v(n); ) {
          var o = t.shift();
          if (typeof o > "u" || o === "__proto__" || (n = n[o], !v(n) || typeof n == "function" || typeof n.nodeType == "number" || n === p))
            return;
        }
        return n;
      }, getStyle: C, inArray: function(t, n, o) {
        return R(32, !1, void 0, { "Highcharts.inArray": "use Array.indexOf" }), n.indexOf(t, o);
      }, isArray: $, isClass: N, isDOMElement: W, isFunction: function(t) {
        return typeof t == "function";
      }, isNumber: M, isObject: U, isString: H, keys: function(t) {
        return R(32, !1, void 0, { "Highcharts.keys": "use Object.keys" }), Object.keys(t);
      }, merge: function() {
        var t, n = arguments, o = {}, A = function(D, j) {
          return typeof D != "object" && (D = {}), b(j, function(T, X) {
            X !== "__proto__" && X !== "constructor" && (!U(T, !0) || N(T) || W(T) ? D[X] = j[X] : D[X] = A(D[X] || {}, T));
          }), D;
        };
        n[0] === !0 && (o = n[1], n = Array.prototype.slice.call(n, 2));
        var _ = n.length;
        for (t = 0; t < _; t++)
          o = A(o, n[t]);
        return o;
      }, normalizeTickInterval: function(t, n, o, A, _) {
        var D = t;
        o = P(o, 1);
        var j = t / o;
        for (n || (n = _ ? [1, 1.2, 1.5, 2, 2.5, 3, 4, 5, 6, 8, 10] : [1, 2, 2.5, 5, 10], A === !1 && (o === 1 ? n = n.filter(function(T) {
          return T % 1 === 0;
        }) : 0.1 >= o && (n = [1 / o]))), A = 0; A < n.length && (D = n[A], !(_ && D * o >= t || !_ && j <= (n[A] + (n[A + 1] || n[A])) / 2)); A++)
          ;
        return D = B(D * o, -Math.round(Math.log(1e-3) / Math.LN10));
      }, objectEach: b, offset: function(t) {
        var n = c.documentElement;
        return t = t.parentElement || t.parentNode ? t.getBoundingClientRect() : { top: 0, left: 0, width: 0, height: 0 }, { top: t.top + (p.pageYOffset || n.scrollTop) - (n.clientTop || 0), left: t.left + (p.pageXOffset || n.scrollLeft) - (n.clientLeft || 0), width: t.width, height: t.height };
      }, pad: function(t, n, o) {
        return Array((n || 2) + 1 - String(t).replace("-", "").length).join(o || "0") + t;
      }, pick: P, pInt: Z, relativeLength: function(t, n, o) {
        return /%$/.test(t) ? n * parseFloat(t) / 100 + (o || 0) : parseFloat(t);
      }, removeEvent: w, splat: function(t) {
        return $(t) ? t : [t];
      }, stableSort: function(t, n) {
        var o = t.length, A, _;
        for (_ = 0; _ < o; _++)
          t[_].safeI = _;
        for (t.sort(function(D, j) {
          return A = n(D, j), A === 0 ? D.safeI - j.safeI : A;
        }), _ = 0; _ < o; _++)
          delete t[_].safeI;
      }, syncTimeout: function(t, n, o) {
        return 0 < n ? setTimeout(t, n, o) : (t.call(0, o), -1);
      }, timeUnits: {
        millisecond: 1,
        second: 1e3,
        minute: 6e4,
        hour: 36e5,
        day: 864e5,
        week: 6048e5,
        month: 24192e5,
        year: 314496e5
      }, uniqueKey: s, useSerialIds: function(t) {
        return l = P(t, l);
      }, wrap: function(t, n, o) {
        var A = t[n];
        t[n] = function() {
          var _ = Array.prototype.slice.call(arguments), D = arguments, j = this;
          return j.proceed = function() {
            A.apply(j, arguments.length ? arguments : D);
          }, _.unshift(A), _ = o.apply(this, _), j.proceed = null, _;
        };
      } }, i;
    }), E(a, "Core/Chart/ChartDefaults.js", [], function() {
      return { panning: { enabled: !1, type: "x" }, styledMode: !1, borderRadius: 0, colorCount: 10, defaultSeriesType: "line", ignoreHiddenSeries: !0, spacing: [
        10,
        10,
        15,
        10
      ], resetZoomButton: { theme: { zIndex: 6 }, position: { align: "right", x: -10, y: 10 } }, zoomBySingleTouch: !1, width: null, height: null, borderColor: "#335cad", backgroundColor: "#ffffff", plotBorderColor: "#cccccc" };
    }), E(a, "Core/Color/Color.js", [a["Core/Globals.js"], a["Core/Utilities.js"]], function(y, R) {
      var I = R.isNumber, Z = R.merge, H = R.pInt;
      return R = function() {
        function $(U) {
          this.rgba = [NaN, NaN, NaN, NaN], this.input = U;
          var W = y.Color;
          if (W && W !== $)
            return new W(U);
          if (!(this instanceof $))
            return new $(U);
          this.init(U);
        }
        return $.parse = function(U) {
          return U ? new $(U) : $.None;
        }, $.prototype.init = function(U) {
          var W;
          if (typeof U == "object" && typeof U.stops < "u")
            this.stops = U.stops.map(function(u) {
              return new $(u[1]);
            });
          else if (typeof U == "string") {
            if (this.input = U = $.names[U.toLowerCase()] || U, U.charAt(0) === "#") {
              var N = U.length, M = parseInt(U.substr(1), 16);
              N === 7 ? W = [(M & 16711680) >> 16, (M & 65280) >> 8, M & 255, 1] : N === 4 && (W = [(M & 3840) >> 4 | (M & 3840) >> 8, (M & 240) >> 4 | M & 240, (M & 15) << 4 | M & 15, 1]);
            }
            if (!W)
              for (M = $.parsers.length; M-- && !W; ) {
                var v = $.parsers[M];
                (N = v.regex.exec(U)) && (W = v.parse(N));
              }
          }
          W && (this.rgba = W);
        }, $.prototype.get = function(U) {
          var W = this.input, N = this.rgba;
          if (typeof W == "object" && typeof this.stops < "u") {
            var M = Z(W);
            return M.stops = [].slice.call(M.stops), this.stops.forEach(function(v, u) {
              M.stops[u] = [M.stops[u][0], v.get(U)];
            }), M;
          }
          return N && I(N[0]) ? U === "rgb" || !U && N[3] === 1 ? "rgb(" + N[0] + "," + N[1] + "," + N[2] + ")" : U === "a" ? "" + N[3] : "rgba(" + N.join(",") + ")" : W;
        }, $.prototype.brighten = function(U) {
          var W = this.rgba;
          if (this.stops)
            this.stops.forEach(function(M) {
              M.brighten(U);
            });
          else if (I(U) && U !== 0)
            for (var N = 0; 3 > N; N++)
              W[N] += H(255 * U), 0 > W[N] && (W[N] = 0), 255 < W[N] && (W[N] = 255);
          return this;
        }, $.prototype.setOpacity = function(U) {
          return this.rgba[3] = U, this;
        }, $.prototype.tweenTo = function(U, W) {
          var N = this.rgba, M = U.rgba;
          return !I(N[0]) || !I(M[0]) ? U.input || "none" : (U = M[3] !== 1 || N[3] !== 1, (U ? "rgba(" : "rgb(") + Math.round(M[0] + (N[0] - M[0]) * (1 - W)) + "," + Math.round(M[1] + (N[1] - M[1]) * (1 - W)) + "," + Math.round(M[2] + (N[2] - M[2]) * (1 - W)) + (U ? "," + (M[3] + (N[3] - M[3]) * (1 - W)) : "") + ")");
        }, $.names = { white: "#ffffff", black: "#000000" }, $.parsers = [{
          regex: /rgba\(\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]?(?:\.[0-9]+)?)\s*\)/,
          parse: function(U) {
            return [H(U[1]), H(U[2]), H(U[3]), parseFloat(U[4], 10)];
          }
        }, { regex: /rgb\(\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*\)/, parse: function(U) {
          return [H(U[1]), H(U[2]), H(U[3]), 1];
        } }], $.None = new $(""), $;
      }(), R;
    }), E(a, "Core/Color/Palettes.js", [], function() {
      return { colors: "#7cb5ec #434348 #90ed7d #f7a35c #8085e9 #f15c80 #e4d354 #2b908f #f45b5b #91e8e1".split(" ") };
    }), E(a, "Core/Time.js", [a["Core/Globals.js"], a["Core/Utilities.js"]], function(y, R) {
      var I = y.win, Z = R.defined, H = R.error, $ = R.extend, U = R.isObject, W = R.merge, N = R.objectEach, M = R.pad, v = R.pick, u = R.splat, d = R.timeUnits, P = y.isSafari && I.Intl && I.Intl.DateTimeFormat.prototype.formatRange, O = y.isSafari && I.Intl && !I.Intl.DateTimeFormat.prototype.formatRange;
      return R = function() {
        function B(C) {
          this.options = {}, this.variableTimezone = this.useUTC = !1, this.Date = I.Date, this.getTimezoneOffset = this.timezoneOffsetFunction(), this.update(C);
        }
        return B.prototype.get = function(C, b) {
          if (this.variableTimezone || this.timezoneOffset) {
            var w = b.getTime(), x = w - this.getTimezoneOffset(b);
            return b.setTime(x), C = b["getUTC" + C](), b.setTime(w), C;
          }
          return this.useUTC ? b["getUTC" + C]() : b["get" + C]();
        }, B.prototype.set = function(C, b, w) {
          if (this.variableTimezone || this.timezoneOffset) {
            if (C === "Milliseconds" || C === "Seconds" || C === "Minutes" && this.getTimezoneOffset(b) % 36e5 === 0)
              return b["setUTC" + C](w);
            var x = this.getTimezoneOffset(b);
            return x = b.getTime() - x, b.setTime(x), b["setUTC" + C](w), C = this.getTimezoneOffset(b), x = b.getTime() + C, b.setTime(x);
          }
          return this.useUTC || P && C === "FullYear" ? b["setUTC" + C](w) : b["set" + C](w);
        }, B.prototype.update = function(C) {
          var b = v(C && C.useUTC, !0);
          this.options = C = W(!0, this.options || {}, C), this.Date = C.Date || I.Date || Date, this.timezoneOffset = (this.useUTC = b) && C.timezoneOffset, this.getTimezoneOffset = this.timezoneOffsetFunction(), this.variableTimezone = b && !(!C.getTimezoneOffset && !C.timezone);
        }, B.prototype.makeTime = function(C, b, w, x, h, c) {
          if (this.useUTC) {
            var p = this.Date.UTC.apply(0, arguments), i = this.getTimezoneOffset(p);
            p += i;
            var l = this.getTimezoneOffset(p);
            i !== l ? p += l - i : i - 36e5 !== this.getTimezoneOffset(p - 36e5) || O || (p -= 36e5);
          } else
            p = new this.Date(C, b, v(w, 1), v(x, 0), v(h, 0), v(c, 0)).getTime();
          return p;
        }, B.prototype.timezoneOffsetFunction = function() {
          var C = this, b = this.options, w = b.getTimezoneOffset, x = b.moment || I.moment;
          if (!this.useUTC)
            return function(h) {
              return 6e4 * new Date(h.toString()).getTimezoneOffset();
            };
          if (b.timezone) {
            if (x)
              return function(h) {
                return 6e4 * -x.tz(h, b.timezone).utcOffset();
              };
            H(25);
          }
          return this.useUTC && w ? function(h) {
            return 6e4 * w(h.valueOf());
          } : function() {
            return 6e4 * (C.timezoneOffset || 0);
          };
        }, B.prototype.dateFormat = function(C, b, w) {
          if (!Z(b) || isNaN(b))
            return y.defaultOptions.lang && y.defaultOptions.lang.invalidDate || "";
          C = v(C, "%Y-%m-%d %H:%M:%S");
          var x = this, h = new this.Date(b), c = this.get("Hours", h), p = this.get("Day", h), i = this.get("Date", h), l = this.get("Month", h), s = this.get("FullYear", h), t = y.defaultOptions.lang, n = t && t.weekdays, o = t && t.shortWeekdays;
          return h = $({ a: o ? o[p] : n[p].substr(0, 3), A: n[p], d: M(i), e: M(i, 2, " "), w: p, b: t.shortMonths[l], B: t.months[l], m: M(l + 1), o: l + 1, y: s.toString().substr(2, 2), Y: s, H: M(c), k: c, I: M(c % 12 || 12), l: c % 12 || 12, M: M(this.get("Minutes", h)), p: 12 > c ? "AM" : "PM", P: 12 > c ? "am" : "pm", S: M(h.getSeconds()), L: M(Math.floor(b % 1e3), 3) }, y.dateFormats), N(h, function(A, _) {
            for (; C.indexOf("%" + _) !== -1; )
              C = C.replace("%" + _, typeof A == "function" ? A.call(x, b) : A);
          }), w ? C.substr(0, 1).toUpperCase() + C.substr(1) : C;
        }, B.prototype.resolveDTLFormat = function(C) {
          return U(C, !0) ? C : (C = u(C), { main: C[0], from: C[1], to: C[2] });
        }, B.prototype.getTimeTicks = function(C, b, w, x) {
          var h = this, c = [], p = {}, i = new h.Date(b), l = C.unitRange, s = C.count || 1, t;
          if (x = v(x, 1), Z(b)) {
            if (h.set(
              "Milliseconds",
              i,
              l >= d.second ? 0 : s * Math.floor(h.get("Milliseconds", i) / s)
            ), l >= d.second && h.set("Seconds", i, l >= d.minute ? 0 : s * Math.floor(h.get("Seconds", i) / s)), l >= d.minute && h.set("Minutes", i, l >= d.hour ? 0 : s * Math.floor(h.get("Minutes", i) / s)), l >= d.hour && h.set("Hours", i, l >= d.day ? 0 : s * Math.floor(h.get("Hours", i) / s)), l >= d.day && h.set("Date", i, l >= d.month ? 1 : Math.max(1, s * Math.floor(h.get("Date", i) / s))), l >= d.month) {
              h.set("Month", i, l >= d.year ? 0 : s * Math.floor(h.get("Month", i) / s));
              var n = h.get("FullYear", i);
            }
            l >= d.year && h.set(
              "FullYear",
              i,
              n - n % s
            ), l === d.week && (n = h.get("Day", i), h.set("Date", i, h.get("Date", i) - n + x + (n < x ? -7 : 0))), n = h.get("FullYear", i), x = h.get("Month", i);
            var o = h.get("Date", i), A = h.get("Hours", i);
            for (b = i.getTime(), !h.variableTimezone && h.useUTC || !Z(w) || (t = w - b > 4 * d.month || h.getTimezoneOffset(b) !== h.getTimezoneOffset(w)), b = i.getTime(), i = 1; b < w; )
              c.push(b), b = l === d.year ? h.makeTime(n + i * s, 0) : l === d.month ? h.makeTime(n, x + i * s) : !t || l !== d.day && l !== d.week ? t && l === d.hour && 1 < s ? h.makeTime(n, x, o, A + i * s) : b + l * s : h.makeTime(n, x, o + i * s * (l === d.day ? 1 : 7)), i++;
            c.push(b), l <= d.hour && 1e4 > c.length && c.forEach(function(_) {
              _ % 18e5 === 0 && h.dateFormat("%H%M%S%L", _) === "000000000" && (p[_] = "day");
            });
          }
          return c.info = $(C, { higherRanks: p, totalRange: l * s }), c;
        }, B.prototype.getDateFormat = function(C, b, w, x) {
          var h = this.dateFormat("%m-%d %H:%M:%S.%L", b), c = { millisecond: 15, second: 12, minute: 9, hour: 6, day: 3 }, p = "millisecond";
          for (i in d) {
            if (C === d.week && +this.dateFormat("%w", b) === w && h.substr(6) === "00:00:00.000") {
              var i = "week";
              break;
            }
            if (d[i] > C) {
              i = p;
              break;
            }
            if (c[i] && h.substr(c[i]) !== "01-01 00:00:00.000".substr(c[i]))
              break;
            i !== "week" && (p = i);
          }
          if (i)
            var l = this.resolveDTLFormat(x[i]).main;
          return l;
        }, B;
      }(), R;
    }), E(a, "Core/DefaultOptions.js", [a["Core/Chart/ChartDefaults.js"], a["Core/Color/Color.js"], a["Core/Globals.js"], a["Core/Color/Palettes.js"], a["Core/Time.js"], a["Core/Utilities.js"]], function(y, R, I, Z, H, $) {
      R = R.parse;
      var U = $.merge, W = {
        colors: Z.colors,
        symbols: ["circle", "diamond", "square", "triangle", "triangle-down"],
        lang: {
          loading: "Loading...",
          months: "January February March April May June July August September October November December".split(" "),
          shortMonths: "Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec".split(" "),
          weekdays: "Sunday Monday Tuesday Wednesday Thursday Friday Saturday".split(" "),
          decimalPoint: ".",
          numericSymbols: "kMGTPE".split(""),
          resetZoom: "Reset zoom",
          resetZoomTitle: "Reset zoom level 1:1",
          thousandsSep: " "
        },
        global: {},
        time: { Date: void 0, getTimezoneOffset: void 0, timezone: void 0, timezoneOffset: 0, useUTC: !0 },
        chart: y,
        title: { text: "Chart title", align: "center", margin: 15, widthAdjust: -44 },
        subtitle: { text: "", align: "center", widthAdjust: -44 },
        caption: { margin: 15, text: "", align: "left", verticalAlign: "bottom" },
        plotOptions: {},
        labels: { style: { position: "absolute", color: "#333333" } },
        legend: {
          enabled: !0,
          align: "center",
          alignColumns: !0,
          className: "highcharts-no-tooltip",
          layout: "horizontal",
          labelFormatter: function() {
            return this.name;
          },
          borderColor: "#999999",
          borderRadius: 0,
          navigation: { activeColor: "#003399", inactiveColor: "#cccccc" },
          itemStyle: { color: "#333333", cursor: "pointer", fontSize: "12px", fontWeight: "bold", textOverflow: "ellipsis" },
          itemHoverStyle: { color: "#000000" },
          itemHiddenStyle: { color: "#cccccc" },
          shadow: !1,
          itemCheckboxStyle: { position: "absolute", width: "13px", height: "13px" },
          squareSymbol: !0,
          symbolPadding: 5,
          verticalAlign: "bottom",
          x: 0,
          y: 0,
          title: { style: { fontWeight: "bold" } }
        },
        loading: { labelStyle: { fontWeight: "bold", position: "relative", top: "45%" }, style: { position: "absolute", backgroundColor: "#ffffff", opacity: 0.5, textAlign: "center" } },
        tooltip: {
          enabled: !0,
          animation: I.svg,
          borderRadius: 3,
          dateTimeLabelFormats: {
            millisecond: "%A, %b %e, %H:%M:%S.%L",
            second: "%A, %b %e, %H:%M:%S",
            minute: "%A, %b %e, %H:%M",
            hour: "%A, %b %e, %H:%M",
            day: "%A, %b %e, %Y",
            week: "Week from %A, %b %e, %Y",
            month: "%B %Y",
            year: "%Y"
          },
          footerFormat: "",
          headerShape: "callout",
          hideDelay: 500,
          padding: 8,
          shape: "callout",
          shared: !1,
          snap: I.isTouchDevice ? 25 : 10,
          headerFormat: '<span style="font-size: 10px">{point.key}</span><br/>',
          pointFormat: '<span style="color:{point.color}">●</span> {series.name}: <b>{point.y}</b><br/>',
          backgroundColor: R("#f7f7f7").setOpacity(0.85).get(),
          borderWidth: 1,
          shadow: !0,
          stickOnContact: !1,
          style: { color: "#333333", cursor: "default", fontSize: "12px", whiteSpace: "nowrap" },
          useHTML: !1
        },
        credits: { enabled: !0, href: "https://www.highcharts.com?credits", position: { align: "right", x: -10, verticalAlign: "bottom", y: -5 }, style: { cursor: "pointer", color: "#999999", fontSize: "9px" }, text: "Highcharts.com" }
      };
      W.chart.styledMode = !1;
      var N = new H(U(W.global, W.time));
      return y = { defaultOptions: W, defaultTime: N, getOptions: function() {
        return W;
      }, setOptions: function(M) {
        return U(!0, W, M), (M.time || M.global) && (I.time ? I.time.update(U(
          W.global,
          W.time,
          M.global,
          M.time
        )) : I.time = N), W;
      } }, y;
    }), E(a, "Core/Animation/Fx.js", [a["Core/Color/Color.js"], a["Core/Globals.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = y.parse, H = R.win, $ = I.isNumber, U = I.objectEach;
      return function() {
        function W(N, M, v) {
          this.pos = NaN, this.options = M, this.elem = N, this.prop = v;
        }
        return W.prototype.dSetter = function() {
          var N = this.paths, M = N && N[0];
          N = N && N[1];
          var v = this.now || 0, u = [];
          if (v !== 1 && M && N)
            if (M.length === N.length && 1 > v)
              for (var d = 0; d < N.length; d++) {
                for (var P = M[d], O = N[d], B = [], C = 0; C < O.length; C++) {
                  var b = P[C], w = O[C];
                  $(b) && $(w) && (O[0] !== "A" || C !== 4 && C !== 5) ? B[C] = b + v * (w - b) : B[C] = w;
                }
                u.push(B);
              }
            else
              u = N;
          else
            u = this.toD || [];
          this.elem.attr("d", u, void 0, !0);
        }, W.prototype.update = function() {
          var N = this.elem, M = this.prop, v = this.now, u = this.options.step;
          this[M + "Setter"] ? this[M + "Setter"]() : N.attr ? N.element && N.attr(M, v, null, !0) : N.style[M] = v + this.unit, u && u.call(N, v, this);
        }, W.prototype.run = function(N, M, v) {
          var u = this, d = u.options, P = function(C) {
            return P.stopped ? !1 : u.step(C);
          }, O = H.requestAnimationFrame || function(C) {
            setTimeout(
              C,
              13
            );
          }, B = function() {
            for (var C = 0; C < W.timers.length; C++)
              W.timers[C]() || W.timers.splice(C--, 1);
            W.timers.length && O(B);
          };
          N !== M || this.elem["forceAnimate:" + this.prop] ? (this.startTime = +/* @__PURE__ */ new Date(), this.start = N, this.end = M, this.unit = v, this.now = this.start, this.pos = 0, P.elem = this.elem, P.prop = this.prop, P() && W.timers.push(P) === 1 && O(B)) : (delete d.curAnim[this.prop], d.complete && Object.keys(d.curAnim).length === 0 && d.complete.call(this.elem));
        }, W.prototype.step = function(N) {
          var M = +/* @__PURE__ */ new Date(), v = this.options, u = this.elem, d = v.complete, P = v.duration, O = v.curAnim;
          if (u.attr && !u.element)
            N = !1;
          else if (N || M >= P + this.startTime) {
            this.now = this.end, this.pos = 1, this.update();
            var B = O[this.prop] = !0;
            U(O, function(C) {
              C !== !0 && (B = !1);
            }), B && d && d.call(u), N = !1;
          } else
            this.pos = v.easing((M - this.startTime) / P), this.now = this.start + (this.end - this.start) * this.pos, this.update(), N = !0;
          return N;
        }, W.prototype.initPath = function(N, M, v) {
          function u(h, c) {
            for (; h.length < x; ) {
              var p = h[0], i = c[x - h.length];
              i && p[0] === "M" && (h[0] = i[0] === "C" ? ["C", p[1], p[2], p[1], p[2], p[1], p[2]] : [
                "L",
                p[1],
                p[2]
              ]), h.unshift(p), B && (p = h.pop(), h.push(h[h.length - 1], p));
            }
          }
          function d(h, c) {
            for (; h.length < x; )
              if (c = h[Math.floor(h.length / C) - 1].slice(), c[0] === "C" && (c[1] = c[5], c[2] = c[6]), B) {
                var p = h[Math.floor(h.length / C)].slice();
                h.splice(h.length / 2, 0, c, p);
              } else
                h.push(c);
          }
          var P = N.startX, O = N.endX;
          v = v.slice();
          var B = N.isArea, C = B ? 2 : 1;
          if (M = M && M.slice(), !M)
            return [v, v];
          if (P && O && O.length) {
            for (N = 0; N < P.length; N++)
              if (P[N] === O[0]) {
                var b = N;
                break;
              } else if (P[0] === O[O.length - P.length + N]) {
                b = N;
                var w = !0;
                break;
              } else if (P[P.length - 1] === O[O.length - P.length + N]) {
                b = P.length - N;
                break;
              }
            typeof b > "u" && (M = []);
          }
          if (M.length && $(b)) {
            var x = v.length + b * C;
            w ? (u(M, v), d(v, M)) : (u(v, M), d(M, v));
          }
          return [M, v];
        }, W.prototype.fillSetter = function() {
          W.prototype.strokeSetter.apply(this, arguments);
        }, W.prototype.strokeSetter = function() {
          this.elem.attr(this.prop, Z(this.start).tweenTo(Z(this.end), this.pos), void 0, !0);
        }, W.timers = [], W;
      }();
    }), E(a, "Core/Animation/AnimationUtilities.js", [a["Core/Animation/Fx.js"], a["Core/Utilities.js"]], function(y, R) {
      function I(d) {
        return N(d) ? M({ duration: 500, defer: 0 }, d) : { duration: d ? 500 : 0, defer: 0 };
      }
      function Z(d, P) {
        for (var O = y.timers.length; O--; )
          y.timers[O].elem !== d || P && P !== y.timers[O].prop || (y.timers[O].stopped = !0);
      }
      var H = R.defined, $ = R.getStyle, U = R.isArray, W = R.isNumber, N = R.isObject, M = R.merge, v = R.objectEach, u = R.pick;
      return { animate: function(d, P, O) {
        var B, C = "", b, w;
        if (!N(O)) {
          var x = arguments;
          O = { duration: x[2], easing: x[3], complete: x[4] };
        }
        W(O.duration) || (O.duration = 400), O.easing = typeof O.easing == "function" ? O.easing : Math[O.easing] || Math.easeInOutSine, O.curAnim = M(P), v(P, function(h, c) {
          Z(d, c), w = new y(d, O, c), b = void 0, c === "d" && U(P.d) ? (w.paths = w.initPath(d, d.pathArray, P.d), w.toD = P.d, B = 0, b = 1) : d.attr ? B = d.attr(c) : (B = parseFloat($(d, c)) || 0, c !== "opacity" && (C = "px")), b || (b = h), typeof b == "string" && b.match("px") && (b = b.replace(/px/g, "")), w.run(B, b, C);
        });
      }, animObject: I, getDeferredAnimation: function(d, P, O) {
        var B = I(P), C = 0, b = 0;
        return (O ? [O] : d.series).forEach(function(w) {
          w = I(w.options.animation), C = P && H(P.defer) ? B.defer : Math.max(C, w.duration + w.defer), b = Math.min(B.duration, w.duration);
        }), d.renderer.forExport && (C = 0), { defer: Math.max(0, C - b), duration: Math.min(C, b) };
      }, setAnimation: function(d, P) {
        P.renderer.globalAnimation = u(d, P.options.chart.animation, !0);
      }, stop: Z };
    }), E(a, "Core/Renderer/HTML/AST.js", [a["Core/Globals.js"], a["Core/Utilities.js"]], function(y, R) {
      var I = y.SVG_NS, Z = R.attr, H = R.createElement, $ = R.error, U = R.isFunction, W = R.isString, N = R.objectEach, M = R.splat, v = (R = y.win.trustedTypes) && U(R.createPolicy) && R.createPolicy("highcharts", { createHTML: function(P) {
        return P;
      } }), u = v ? v.createHTML("") : "";
      try {
        var d = !!new DOMParser().parseFromString(u, "text/html");
      } catch {
        d = !1;
      }
      return U = function() {
        function P(O) {
          this.nodes = typeof O == "string" ? this.parseMarkup(O) : O;
        }
        return P.filterUserAttributes = function(O) {
          return N(O, function(B, C) {
            var b = !0;
            P.allowedAttributes.indexOf(C) === -1 && (b = !1), ["background", "dynsrc", "href", "lowsrc", "src"].indexOf(C) !== -1 && (b = W(B) && P.allowedReferences.some(function(w) {
              return B.indexOf(w) === 0;
            })), b || ($("Highcharts warning: Invalid attribute '" + C + "' in config"), delete O[C]);
          }), O;
        }, P.setElementHTML = function(O, B) {
          O.innerHTML = P.emptyHTML, B && new P(B).addToDOM(O);
        }, P.prototype.addToDOM = function(O) {
          function B(C, b) {
            var w;
            return M(C).forEach(function(x) {
              var h = x.tagName, c = x.textContent ? y.doc.createTextNode(x.textContent) : void 0;
              if (h)
                if (h === "#text")
                  var p = c;
                else if (P.allowedTags.indexOf(h) !== -1) {
                  h = y.doc.createElementNS(h === "svg" ? I : b.namespaceURI || I, h);
                  var i = x.attributes || {};
                  N(x, function(l, s) {
                    s !== "tagName" && s !== "attributes" && s !== "children" && s !== "textContent" && (i[s] = l);
                  }), Z(h, P.filterUserAttributes(i)), c && h.appendChild(c), B(x.children || [], h), p = h;
                } else
                  $("Highcharts warning: Invalid tagName " + h + " in config");
              p && b.appendChild(p), w = p;
            }), w;
          }
          return B(this.nodes, O);
        }, P.prototype.parseMarkup = function(O) {
          var B = [];
          if (O = O.trim(), d)
            O = new DOMParser().parseFromString(v ? v.createHTML(O) : O, "text/html");
          else {
            var C = H("div");
            C.innerHTML = O, O = { body: C };
          }
          var b = function(w, x) {
            var h = w.nodeName.toLowerCase(), c = { tagName: h };
            if (h === "#text" && (c.textContent = w.textContent || ""), h = w.attributes) {
              var p = {};
              [].forEach.call(h, function(l) {
                p[l.name] = l.value;
              }), c.attributes = p;
            }
            if (w.childNodes.length) {
              var i = [];
              [].forEach.call(w.childNodes, function(l) {
                b(l, i);
              }), i.length && (c.children = i);
            }
            x.push(c);
          };
          return [].forEach.call(O.body.childNodes, function(w) {
            return b(w, B);
          }), B;
        }, P.allowedAttributes = "aria-controls aria-describedby aria-expanded aria-haspopup aria-hidden aria-label aria-labelledby aria-live aria-pressed aria-readonly aria-roledescription aria-selected class clip-path color colspan cx cy d dx dy disabled fill height href id in markerHeight markerWidth offset opacity orient padding paddingLeft paddingRight patternUnits r refX refY role scope slope src startOffset stdDeviation stroke stroke-linecap stroke-width style tableValues result rowspan summary target tabindex text-align textAnchor textLength title type valign width x x1 x2 y y1 y2 zIndex".split(" "), P.allowedReferences = "https:// http:// mailto: / ../ ./ #".split(" "), P.allowedTags = "a abbr b br button caption circle clipPath code dd defs div dl dt em feComponentTransfer feFuncA feFuncB feFuncG feFuncR feGaussianBlur feOffset feMerge feMergeNode filter h1 h2 h3 h4 h5 h6 hr i img li linearGradient marker ol p path pattern pre rect small span stop strong style sub sup svg table text thead tbody tspan td th tr u ul #text".split(" "), P.emptyHTML = u, P;
      }(), U;
    }), E(
      a,
      "Core/FormatUtilities.js",
      [a["Core/DefaultOptions.js"], a["Core/Utilities.js"]],
      function(y, R) {
        function I(M, v, u, d) {
          M = +M || 0, v = +v;
          var P = Z.lang, O = (M.toString().split(".")[1] || "").split("e")[0].length, B = M.toString().split("e"), C = v;
          if (v === -1)
            v = Math.min(O, 20);
          else if (!U(v))
            v = 2;
          else if (v && B[1] && 0 > B[1]) {
            var b = v + +B[1];
            0 <= b ? (B[0] = (+B[0]).toExponential(b).split("e")[0], v = b) : (B[0] = B[0].split(".")[0] || 0, M = 20 > v ? (B[0] * Math.pow(10, B[1])).toFixed(v) : 0, B[1] = 0);
          }
          b = (Math.abs(B[1] ? B[0] : M) + Math.pow(10, -Math.max(v, O) - 1)).toFixed(v), O = String(N(b));
          var w = 3 < O.length ? O.length % 3 : 0;
          return u = W(u, P.decimalPoint), d = W(d, P.thousandsSep), M = (0 > M ? "-" : "") + (w ? O.substr(0, w) + d : ""), M = 0 > +B[1] && !C ? "0" : M + O.substr(w).replace(/(\d{3})(?=\d)/g, "$1" + d), v && (M += u + b.slice(-v)), B[1] && +M != 0 && (M += "e" + B[1]), M;
        }
        var Z = y.defaultOptions, H = y.defaultTime, $ = R.getNestedProperty, U = R.isNumber, W = R.pick, N = R.pInt;
        return { dateFormat: function(M, v, u) {
          return H.dateFormat(M, v, u);
        }, format: function(M, v, u) {
          var d = "{", P = !1, O = /f$/, B = /\.([0-9])/, C = Z.lang, b = u && u.time || H;
          u = u && u.numberFormatter || I;
          for (var w = []; M; ) {
            var x = M.indexOf(d);
            if (x === -1)
              break;
            var h = M.slice(0, x);
            if (P) {
              if (h = h.split(":"), d = $(h.shift() || "", v), h.length && typeof d == "number")
                if (h = h.join(":"), O.test(h)) {
                  var c = parseInt((h.match(B) || ["", "-1"])[1], 10);
                  d !== null && (d = u(d, c, C.decimalPoint, -1 < h.indexOf(",") ? C.thousandsSep : ""));
                } else
                  d = b.dateFormat(h, d);
              w.push(d);
            } else
              w.push(h);
            M = M.slice(x + 1), d = (P = !P) ? "}" : "{";
          }
          return w.push(M), w.join("");
        }, numberFormat: I };
      }
    ), E(a, "Core/Renderer/RendererUtilities.js", [a["Core/Utilities.js"]], function(y) {
      var R = y.clamp, I = y.pick, Z = y.stableSort, H;
      return function($) {
        function U(W, N, M) {
          var v = W, u = v.reducedLen || N, d = function(w, x) {
            return (x.rank || 0) - (w.rank || 0);
          }, P = function(w, x) {
            return w.target - x.target;
          }, O, B = !0, C = [], b = 0;
          for (O = W.length; O--; )
            b += W[O].size;
          if (b > u) {
            for (Z(W, d), b = O = 0; b <= u; )
              b += W[O].size, O++;
            C = W.splice(O - 1, W.length);
          }
          for (Z(W, P), W = W.map(function(w) {
            return { size: w.size, targets: [w.target], align: I(w.align, 0.5) };
          }); B; ) {
            for (O = W.length; O--; )
              u = W[O], d = (Math.min.apply(0, u.targets) + Math.max.apply(0, u.targets)) / 2, u.pos = R(
                d - u.size * u.align,
                0,
                N - u.size
              );
            for (O = W.length, B = !1; O--; )
              0 < O && W[O - 1].pos + W[O - 1].size > W[O].pos && (W[O - 1].size += W[O].size, W[O - 1].targets = W[O - 1].targets.concat(W[O].targets), W[O - 1].align = 0.5, W[O - 1].pos + W[O - 1].size > N && (W[O - 1].pos = N - W[O - 1].size), W.splice(O, 1), B = !0);
          }
          return v.push.apply(v, C), O = 0, W.some(function(w) {
            var x = 0;
            return (w.targets || []).some(function() {
              return v[O].pos = w.pos + x, typeof M < "u" && Math.abs(v[O].pos - v[O].target) > M ? (v.slice(0, O + 1).forEach(function(h) {
                return delete h.pos;
              }), v.reducedLen = (v.reducedLen || N) - 0.1 * N, v.reducedLen > 0.1 * N && U(v, N, M), !0) : (x += v[O].size, O++, !1);
            });
          }), Z(v, P), v;
        }
        $.distribute = U;
      }(H || (H = {})), H;
    }), E(a, "Core/Renderer/SVG/SVGElement.js", [a["Core/Animation/AnimationUtilities.js"], a["Core/Renderer/HTML/AST.js"], a["Core/Color/Color.js"], a["Core/Globals.js"], a["Core/Utilities.js"]], function(y, R, I, Z, H) {
      var $ = y.animate, U = y.animObject, W = y.stop, N = Z.deg2rad, M = Z.doc, v = Z.noop, u = Z.svg, d = Z.SVG_NS, P = Z.win, O = H.addEvent, B = H.attr, C = H.createElement, b = H.css, w = H.defined, x = H.erase, h = H.extend, c = H.fireEvent, p = H.isArray, i = H.isFunction, l = H.isNumber, s = H.isString, t = H.merge, n = H.objectEach, o = H.pick, A = H.pInt, _ = H.syncTimeout, D = H.uniqueKey;
      return y = function() {
        function j() {
          this.element = void 0, this.onEvents = {}, this.opacity = 1, this.renderer = void 0, this.SVG_NS = d, this.symbolCustomAttribs = "x y width height r start end innerR anchorX anchorY rounded".split(" ");
        }
        return j.prototype._defaultGetter = function(T) {
          return T = o(this[T + "Value"], this[T], this.element ? this.element.getAttribute(T) : null, 0), /^[\-0-9\.]+$/.test(T) && (T = parseFloat(T)), T;
        }, j.prototype._defaultSetter = function(T, X, f) {
          f.setAttribute(X, T);
        }, j.prototype.add = function(T) {
          var X = this.renderer, f = this.element;
          if (T && (this.parentGroup = T), this.parentInverted = T && T.inverted, typeof this.textStr < "u" && this.element.nodeName === "text" && X.buildText(this), this.added = !0, !T || T.handleZ || this.zIndex)
            var m = this.zIndexSetter();
          return m || (T ? T.element : X.box).appendChild(f), this.onAdd && this.onAdd(), this;
        }, j.prototype.addClass = function(T, X) {
          var f = X ? "" : this.attr("class") || "";
          return T = (T || "").split(/ /g).reduce(function(m, L) {
            return f.indexOf(L) === -1 && m.push(L), m;
          }, f ? [f] : []).join(" "), T !== f && this.attr("class", T), this;
        }, j.prototype.afterSetters = function() {
          this.doTransform && (this.updateTransform(), this.doTransform = !1);
        }, j.prototype.align = function(T, X, f) {
          var m = {}, L = this.renderer, Y = L.alignedObjects, F, Q, k;
          T ? (this.alignOptions = T, this.alignByTranslate = X, (!f || s(f)) && (this.alignTo = F = f || "renderer", x(Y, this), Y.push(this), f = void 0)) : (T = this.alignOptions, X = this.alignByTranslate, F = this.alignTo), f = o(f, L[F], F === "scrollablePlotBox" ? L.plotBox : void 0, L), F = T.align;
          var G = T.verticalAlign;
          return L = (f.x || 0) + (T.x || 0), Y = (f.y || 0) + (T.y || 0), F === "right" ? Q = 1 : F === "center" && (Q = 2), Q && (L += (f.width - (T.width || 0)) / Q), m[X ? "translateX" : "x"] = Math.round(L), G === "bottom" ? k = 1 : G === "middle" && (k = 2), k && (Y += (f.height - (T.height || 0)) / k), m[X ? "translateY" : "y"] = Math.round(Y), this[this.placed ? "animate" : "attr"](m), this.placed = !0, this.alignAttr = m, this;
        }, j.prototype.alignSetter = function(T) {
          var X = { left: "start", center: "middle", right: "end" };
          X[T] && (this.alignValue = T, this.element.setAttribute(
            "text-anchor",
            X[T]
          ));
        }, j.prototype.animate = function(T, X, f) {
          var m = this, L = U(o(X, this.renderer.globalAnimation, !0));
          return X = L.defer, o(M.hidden, M.msHidden, M.webkitHidden, !1) && (L.duration = 0), L.duration !== 0 ? (f && (L.complete = f), _(function() {
            m.element && $(m, T, L);
          }, X)) : (this.attr(T, void 0, f), n(T, function(Y, F) {
            L.step && L.step.call(this, Y, { prop: F, pos: 1, elem: this });
          }, this)), this;
        }, j.prototype.applyTextOutline = function(T) {
          var X = this.element;
          T.indexOf("contrast") !== -1 && (T = T.replace(/contrast/g, this.renderer.getContrast(X.style.fill)));
          var f = T.split(" ");
          if (T = f[f.length - 1], (f = f[0]) && f !== "none" && Z.svg) {
            this.fakeTS = !0, this.ySetter = this.xSetter, f = f.replace(/(^[\d\.]+)(.*?)$/g, function(Y, F, Q) {
              return 2 * Number(F) + Q;
            }), this.removeTextOutline();
            var m = M.createElementNS(d, "tspan");
            B(m, { class: "highcharts-text-outline", fill: T, stroke: T, "stroke-width": f, "stroke-linejoin": "round" }), [].forEach.call(X.childNodes, function(Y) {
              var F = Y.cloneNode(!0);
              F.removeAttribute && ["fill", "stroke", "stroke-width", "stroke"].forEach(function(Q) {
                return F.removeAttribute(Q);
              }), m.appendChild(F);
            });
            var L = M.createElementNS(d, "tspan");
            L.textContent = "​", ["x", "y"].forEach(function(Y) {
              var F = X.getAttribute(Y);
              F && L.setAttribute(Y, F);
            }), m.appendChild(L), X.insertBefore(m, X.firstChild);
          }
        }, j.prototype.attr = function(T, X, f, m) {
          var L = this.element, Y = this.symbolCustomAttribs, F, Q = this, k, G;
          if (typeof T == "string" && typeof X < "u") {
            var z = T;
            T = {}, T[z] = X;
          }
          return typeof T == "string" ? Q = (this[T + "Getter"] || this._defaultGetter).call(this, T, L) : (n(T, function(V, q) {
            k = !1, m || W(this, q), this.symbolName && Y.indexOf(q) !== -1 && (F || (this.symbolAttr(T), F = !0), k = !0), !this.rotation || q !== "x" && q !== "y" || (this.doTransform = !0), k || (G = this[q + "Setter"] || this._defaultSetter, G.call(this, V, q, L), !this.styledMode && this.shadows && /^(width|height|visibility|x|y|d|transform|cx|cy|r)$/.test(q) && this.updateShadows(q, V, G));
          }, this), this.afterSetters()), f && f.call(this), Q;
        }, j.prototype.clip = function(T) {
          return this.attr("clip-path", T ? "url(" + this.renderer.url + "#" + T.id + ")" : "none");
        }, j.prototype.crisp = function(T, X) {
          X = X || T.strokeWidth || 0;
          var f = Math.round(X) % 2 / 2;
          return T.x = Math.floor(T.x || this.x || 0) + f, T.y = Math.floor(T.y || this.y || 0) + f, T.width = Math.floor((T.width || this.width || 0) - 2 * f), T.height = Math.floor((T.height || this.height || 0) - 2 * f), w(T.strokeWidth) && (T.strokeWidth = X), T;
        }, j.prototype.complexColor = function(T, X, f) {
          var m = this.renderer, L, Y, F, Q, k, G, z, V, q, it, et = [], nt;
          c(this.renderer, "complexColor", { args: arguments }, function() {
            if (T.radialGradient ? Y = "radialGradient" : T.linearGradient && (Y = "linearGradient"), Y) {
              if (F = T[Y], k = m.gradients, G = T.stops, q = f.radialReference, p(F) && (T[Y] = F = { x1: F[0], y1: F[1], x2: F[2], y2: F[3], gradientUnits: "userSpaceOnUse" }), Y === "radialGradient" && q && !w(F.gradientUnits) && (Q = F, F = t(F, m.getRadialAttr(q, Q), { gradientUnits: "userSpaceOnUse" })), n(F, function(ct, gt) {
                gt !== "id" && et.push(gt, ct);
              }), n(G, function(ct) {
                et.push(ct);
              }), et = et.join(","), k[et])
                it = k[et].attr("id");
              else {
                F.id = it = D();
                var rt = k[et] = m.createElement(Y).attr(F).add(m.defs);
                rt.radAttr = Q, rt.stops = [], G.forEach(function(ct) {
                  ct[1].indexOf("rgba") === 0 ? (L = I.parse(ct[1]), z = L.get("rgb"), V = L.get("a")) : (z = ct[1], V = 1), ct = m.createElement("stop").attr({
                    offset: ct[0],
                    "stop-color": z,
                    "stop-opacity": V
                  }).add(rt), rt.stops.push(ct);
                });
              }
              nt = "url(" + m.url + "#" + it + ")", f.setAttribute(X, nt), f.gradient = et, T.toString = function() {
                return nt;
              };
            }
          });
        }, j.prototype.css = function(T) {
          var X = this.styles, f = {}, m = this.element, L = ["textOutline", "textOverflow", "width"], Y = "", F = !X;
          if (T && T.color && (T.fill = T.color), X && n(T, function(G, z) {
            X && X[z] !== G && (f[z] = G, F = !0);
          }), F) {
            if (X && (T = h(X, f)), T) {
              if (T.width === null || T.width === "auto")
                delete this.textWidth;
              else if (m.nodeName.toLowerCase() === "text" && T.width)
                var Q = this.textWidth = A(T.width);
            }
            if (this.styles = T, Q && !u && this.renderer.forExport && delete T.width, m.namespaceURI === this.SVG_NS) {
              var k = function(G, z) {
                return "-" + z.toLowerCase();
              };
              n(T, function(G, z) {
                L.indexOf(z) === -1 && (Y += z.replace(/([A-Z])/g, k) + ":" + G + ";");
              }), Y && B(m, "style", Y);
            } else
              b(m, T);
            this.added && (this.element.nodeName === "text" && this.renderer.buildText(this), T && T.textOutline && this.applyTextOutline(T.textOutline));
          }
          return this;
        }, j.prototype.dashstyleSetter = function(T) {
          var X = this["stroke-width"];
          if (X === "inherit" && (X = 1), T = T && T.toLowerCase()) {
            var f = T.replace("shortdashdotdot", "3,1,1,1,1,1,").replace("shortdashdot", "3,1,1,1").replace("shortdot", "1,1,").replace("shortdash", "3,1,").replace("longdash", "8,3,").replace(/dot/g, "1,3,").replace("dash", "4,3,").replace(/,$/, "").split(",");
            for (T = f.length; T--; )
              f[T] = "" + A(f[T]) * o(X, NaN);
            T = f.join(",").replace(/NaN/g, "none"), this.element.setAttribute("stroke-dasharray", T);
          }
        }, j.prototype.destroy = function() {
          var T = this, X = T.element || {}, f = T.renderer, m = X.ownerSVGElement, L = f.isSVG && X.nodeName === "SPAN" && T.parentGroup || void 0;
          if (X.onclick = X.onmouseout = X.onmouseover = X.onmousemove = X.point = null, W(T), T.clipPath && m) {
            var Y = T.clipPath;
            [].forEach.call(m.querySelectorAll("[clip-path],[CLIP-PATH]"), function(F) {
              -1 < F.getAttribute("clip-path").indexOf(Y.element.id) && F.removeAttribute("clip-path");
            }), T.clipPath = Y.destroy();
          }
          if (T.stops) {
            for (m = 0; m < T.stops.length; m++)
              T.stops[m].destroy();
            T.stops.length = 0, T.stops = void 0;
          }
          for (T.safeRemoveChild(X), f.styledMode || T.destroyShadows(); L && L.div && L.div.childNodes.length === 0; )
            X = L.parentGroup, T.safeRemoveChild(L.div), delete L.div, L = X;
          T.alignTo && x(f.alignedObjects, T), n(T, function(F, Q) {
            T[Q] && T[Q].parentGroup === T && T[Q].destroy && T[Q].destroy(), delete T[Q];
          });
        }, j.prototype.destroyShadows = function() {
          (this.shadows || []).forEach(function(T) {
            this.safeRemoveChild(T);
          }, this), this.shadows = void 0;
        }, j.prototype.destroyTextPath = function(T, X) {
          var f = T.getElementsByTagName("text")[0];
          if (f) {
            if (f.removeAttribute("dx"), f.removeAttribute("dy"), X.element.setAttribute("id", ""), this.textPathWrapper && f.getElementsByTagName("textPath").length) {
              for (T = this.textPathWrapper.element.childNodes; T.length; )
                f.appendChild(T[0]);
              f.removeChild(this.textPathWrapper.element);
            }
          } else
            (T.getAttribute("dx") || T.getAttribute("dy")) && (T.removeAttribute("dx"), T.removeAttribute("dy"));
          this.textPathWrapper && (this.textPathWrapper = this.textPathWrapper.destroy());
        }, j.prototype.dSetter = function(T, X, f) {
          p(T) && (typeof T[0] == "string" && (T = this.renderer.pathToSegments(T)), this.pathArray = T, T = T.reduce(function(m, L, Y) {
            return L && L.join ? (Y ? m + " " : "") + L.join(" ") : (L || "").toString();
          }, "")), /(NaN| {2}|^$)/.test(T) && (T = "M 0 0"), this[X] !== T && (f.setAttribute(X, T), this[X] = T);
        }, j.prototype.fadeOut = function(T) {
          var X = this;
          X.animate({ opacity: 0 }, { duration: o(T, 150), complete: function() {
            X.attr({ y: -9999 }).hide();
          } });
        }, j.prototype.fillSetter = function(T, X, f) {
          typeof T == "string" ? f.setAttribute(X, T) : T && this.complexColor(T, X, f);
        }, j.prototype.getBBox = function(T, X) {
          var f = this.renderer, m = this.element, L = this.styles, Y = this.textStr, F = f.cache, Q = f.cacheKeys, k = m.namespaceURI === this.SVG_NS;
          X = o(X, this.rotation, 0);
          var G = f.styledMode ? m && j.prototype.getStyle.call(m, "font-size") : L && L.fontSize, z;
          if (w(Y)) {
            var V = Y.toString();
            V.indexOf("<") === -1 && (V = V.replace(/[0-9]/g, "0")), V += ["", X, G, this.textWidth, L && L.textOverflow, L && L.fontWeight].join();
          }
          if (V && !T && (z = F[V]), !z) {
            if (k || f.forExport) {
              try {
                var q = this.fakeTS && function(it) {
                  var et = m.querySelector(".highcharts-text-outline");
                  et && b(et, { display: it });
                };
                i(q) && q("none"), z = m.getBBox ? h({}, m.getBBox()) : { width: m.offsetWidth, height: m.offsetHeight }, i(q) && q("");
              } catch {
              }
              (!z || 0 > z.width) && (z = {
                width: 0,
                height: 0
              });
            } else
              z = this.htmlGetBBox();
            if (f.isSVG && (T = z.width, f = z.height, k && (z.height = f = { "11px,17": 14, "13px,20": 16 }[(G || "") + "," + Math.round(f)] || f), X && (k = X * N, z.width = Math.abs(f * Math.sin(k)) + Math.abs(T * Math.cos(k)), z.height = Math.abs(f * Math.cos(k)) + Math.abs(T * Math.sin(k)))), V && (Y === "" || 0 < z.height)) {
              for (; 250 < Q.length; )
                delete F[Q.shift()];
              F[V] || Q.push(V), F[V] = z;
            }
          }
          return z;
        }, j.prototype.getStyle = function(T) {
          return P.getComputedStyle(this.element || this, "").getPropertyValue(T);
        }, j.prototype.hasClass = function(T) {
          return ("" + this.attr("class")).split(" ").indexOf(T) !== -1;
        }, j.prototype.hide = function(T) {
          return T ? this.attr({ y: -9999 }) : this.attr({ visibility: "hidden" }), this;
        }, j.prototype.htmlGetBBox = function() {
          return { height: 0, width: 0, x: 0, y: 0 };
        }, j.prototype.init = function(T, X) {
          this.element = X === "span" ? C(X) : M.createElementNS(this.SVG_NS, X), this.renderer = T, c(this, "afterInit");
        }, j.prototype.invert = function(T) {
          return this.inverted = T, this.updateTransform(), this;
        }, j.prototype.on = function(T, X) {
          var f = this.onEvents;
          return f[T] && f[T](), f[T] = O(
            this.element,
            T,
            X
          ), this;
        }, j.prototype.opacitySetter = function(T, X, f) {
          this.opacity = T = Number(Number(T).toFixed(3)), f.setAttribute(X, T);
        }, j.prototype.removeClass = function(T) {
          return this.attr("class", ("" + this.attr("class")).replace(s(T) ? new RegExp("(^| )" + T + "( |$)") : T, " ").replace(/ +/g, " ").trim());
        }, j.prototype.removeTextOutline = function() {
          var T = this.element.querySelector("tspan.highcharts-text-outline");
          T && this.safeRemoveChild(T);
        }, j.prototype.safeRemoveChild = function(T) {
          var X = T.parentNode;
          X && X.removeChild(T);
        }, j.prototype.setRadialReference = function(T) {
          var X = this.element.gradient && this.renderer.gradients[this.element.gradient];
          return this.element.radialReference = T, X && X.radAttr && X.animate(this.renderer.getRadialAttr(T, X.radAttr)), this;
        }, j.prototype.setTextPath = function(T, X) {
          var f = this.element, m = this.text ? this.text.element : f, L = { textAnchor: "text-anchor" }, Y = !1, F = this.textPathWrapper, Q = !F;
          X = t(!0, { enabled: !0, attributes: { dy: -5, startOffset: "50%", textAnchor: "middle" } }, X);
          var k = R.filterUserAttributes(X.attributes);
          if (T && X && X.enabled) {
            F && F.element.parentNode === null ? (Q = !0, F = F.destroy()) : F && this.removeTextOutline.call(F.parentGroup), this.options && this.options.padding && (k.dx = -this.options.padding), F || (this.textPathWrapper = F = this.renderer.createElement("textPath"), Y = !0);
            var G = F.element;
            if ((X = T.element.getAttribute("id")) || T.element.setAttribute("id", X = D()), Q)
              for (m.setAttribute("y", 0), l(k.dx) && m.setAttribute("x", -k.dx), T = [].slice.call(m.childNodes), Q = 0; Q < T.length; Q++) {
                var z = T[Q];
                z.nodeType !== P.Node.TEXT_NODE && z.nodeName !== "tspan" || G.appendChild(z);
              }
            Y && F && F.add({ element: m }), G.setAttributeNS("http://www.w3.org/1999/xlink", "href", this.renderer.url + "#" + X), w(k.dy) && (G.parentNode.setAttribute("dy", k.dy), delete k.dy), w(k.dx) && (G.parentNode.setAttribute("dx", k.dx), delete k.dx), n(k, function(V, q) {
              G.setAttribute(L[q] || q, V);
            }), f.removeAttribute("transform"), this.removeTextOutline.call(F), this.text && !this.renderer.styledMode && this.attr({ fill: "none", "stroke-width": 0 }), this.applyTextOutline = this.updateTransform = v;
          } else
            F && (delete this.updateTransform, delete this.applyTextOutline, this.destroyTextPath(f, T), this.updateTransform(), this.options && this.options.rotation && this.applyTextOutline(this.options.style.textOutline));
          return this;
        }, j.prototype.shadow = function(T, X, f) {
          var m = [], L = this.element, Y = this.oldShadowOptions, F = { color: "#000000", offsetX: this.parentInverted ? -1 : 1, offsetY: this.parentInverted ? -1 : 1, opacity: 0.15, width: 3 }, Q = !1, k;
          if (T === !0 ? k = F : typeof T == "object" && (k = h(F, T)), k && (k && Y && n(k, function(it, et) {
            it !== Y[et] && (Q = !0);
          }), Q && this.destroyShadows(), this.oldShadowOptions = k), !k)
            this.destroyShadows();
          else if (!this.shadows) {
            var G = k.opacity / k.width, z = this.parentInverted ? "translate(" + k.offsetY + ", " + k.offsetX + ")" : "translate(" + k.offsetX + ", " + k.offsetY + ")";
            for (F = 1; F <= k.width; F++) {
              var V = L.cloneNode(!1), q = 2 * k.width + 1 - 2 * F;
              B(V, { stroke: T.color || "#000000", "stroke-opacity": G * F, "stroke-width": q, transform: z, fill: "none" }), V.setAttribute("class", (V.getAttribute("class") || "") + " highcharts-shadow"), f && (B(V, "height", Math.max(B(V, "height") - q, 0)), V.cutHeight = q), X ? X.element.appendChild(V) : L.parentNode && L.parentNode.insertBefore(V, L), m.push(V);
            }
            this.shadows = m;
          }
          return this;
        }, j.prototype.show = function(T) {
          return this.attr({ visibility: T ? "inherit" : "visible" });
        }, j.prototype.strokeSetter = function(T, X, f) {
          this[X] = T, this.stroke && this["stroke-width"] ? (j.prototype.fillSetter.call(this, this.stroke, "stroke", f), f.setAttribute("stroke-width", this["stroke-width"]), this.hasStroke = !0) : X === "stroke-width" && T === 0 && this.hasStroke ? (f.removeAttribute("stroke"), this.hasStroke = !1) : this.renderer.styledMode && this["stroke-width"] && (f.setAttribute("stroke-width", this["stroke-width"]), this.hasStroke = !0);
        }, j.prototype.strokeWidth = function() {
          if (!this.renderer.styledMode)
            return this["stroke-width"] || 0;
          var T = this.getStyle("stroke-width"), X = 0;
          if (T.indexOf("px") === T.length - 2)
            X = A(T);
          else if (T !== "") {
            var f = M.createElementNS(d, "rect");
            B(f, { width: T, "stroke-width": 0 }), this.element.parentNode.appendChild(f), X = f.getBBox().width, f.parentNode.removeChild(f);
          }
          return X;
        }, j.prototype.symbolAttr = function(T) {
          var X = this;
          "x y r start end width height innerR anchorX anchorY clockwise".split(" ").forEach(function(f) {
            X[f] = o(T[f], X[f]);
          }), X.attr({ d: X.renderer.symbols[X.symbolName](X.x, X.y, X.width, X.height, X) });
        }, j.prototype.textSetter = function(T) {
          T !== this.textStr && (delete this.textPxLength, this.textStr = T, this.added && this.renderer.buildText(this));
        }, j.prototype.titleSetter = function(T) {
          var X = this.element, f = X.getElementsByTagName("title")[0] || M.createElementNS(this.SVG_NS, "title");
          X.insertBefore ? X.insertBefore(f, X.firstChild) : X.appendChild(f), f.textContent = String(o(T, "")).replace(/<[^>]*>/g, "").replace(/&lt;/g, "<").replace(
            /&gt;/g,
            ">"
          );
        }, j.prototype.toFront = function() {
          var T = this.element;
          return T.parentNode.appendChild(T), this;
        }, j.prototype.translate = function(T, X) {
          return this.attr({ translateX: T, translateY: X });
        }, j.prototype.updateShadows = function(T, X, f) {
          var m = this.shadows;
          if (m)
            for (var L = m.length; L--; )
              f.call(m[L], T === "height" ? Math.max(X - (m[L].cutHeight || 0), 0) : T === "d" ? this.d : X, T, m[L]);
        }, j.prototype.updateTransform = function() {
          var T = this.scaleX, X = this.scaleY, f = this.inverted, m = this.rotation, L = this.matrix, Y = this.element, F = this.translateX || 0, Q = this.translateY || 0;
          f && (F += this.width, Q += this.height), F = ["translate(" + F + "," + Q + ")"], w(L) && F.push("matrix(" + L.join(",") + ")"), f ? F.push("rotate(90) scale(-1,1)") : m && F.push("rotate(" + m + " " + o(this.rotationOriginX, Y.getAttribute("x"), 0) + " " + o(this.rotationOriginY, Y.getAttribute("y") || 0) + ")"), (w(T) || w(X)) && F.push("scale(" + o(T, 1) + " " + o(X, 1) + ")"), F.length && Y.setAttribute("transform", F.join(" "));
        }, j.prototype.visibilitySetter = function(T, X, f) {
          T === "inherit" ? f.removeAttribute(X) : this[X] !== T && f.setAttribute(
            X,
            T
          ), this[X] = T;
        }, j.prototype.xGetter = function(T) {
          return this.element.nodeName === "circle" && (T === "x" ? T = "cx" : T === "y" && (T = "cy")), this._defaultGetter(T);
        }, j.prototype.zIndexSetter = function(T, X) {
          var f = this.renderer, m = this.parentGroup, L = (m || f).element || f.box, Y = this.element;
          f = L === f.box;
          var F = !1, Q = this.added, k;
          if (w(T) ? (Y.setAttribute("data-z-index", T), T = +T, this[X] === T && (Q = !1)) : w(this[X]) && Y.removeAttribute("data-z-index"), this[X] = T, Q) {
            for ((T = this.zIndex) && m && (m.handleZ = !0), X = L.childNodes, k = X.length - 1; 0 <= k && !F; k--) {
              m = X[k], Q = m.getAttribute("data-z-index");
              var G = !w(Q);
              m !== Y && (0 > T && G && !f && !k ? (L.insertBefore(Y, X[k]), F = !0) : (A(Q) <= T || G && (!w(T) || 0 <= T)) && (L.insertBefore(Y, X[k + 1] || null), F = !0));
            }
            F || (L.insertBefore(Y, X[f ? 3 : 0] || null), F = !0);
          }
          return F;
        }, j;
      }(), y.prototype["stroke-widthSetter"] = y.prototype.strokeSetter, y.prototype.yGetter = y.prototype.xGetter, y.prototype.matrixSetter = y.prototype.rotationOriginXSetter = y.prototype.rotationOriginYSetter = y.prototype.rotationSetter = y.prototype.scaleXSetter = y.prototype.scaleYSetter = y.prototype.translateXSetter = y.prototype.translateYSetter = y.prototype.verticalAlignSetter = function(j, T) {
        this[T] = j, this.doTransform = !0;
      }, y;
    }), E(a, "Core/Renderer/RendererRegistry.js", [a["Core/Globals.js"]], function(y) {
      var R;
      return function(I) {
        I.rendererTypes = {};
        var Z;
        I.getRendererType = function(H) {
          return H === void 0 && (H = Z), I.rendererTypes[H] || I.rendererTypes[Z];
        }, I.registerRendererType = function(H, $, U) {
          I.rendererTypes[H] = $, (!Z || U) && (Z = H, y.Renderer = $);
        };
      }(R || (R = {})), R;
    }), E(
      a,
      "Core/Renderer/SVG/SVGLabel.js",
      [a["Core/Renderer/SVG/SVGElement.js"], a["Core/Utilities.js"]],
      function(y, R) {
        var I = this && this.__extends || function() {
          var M = function(v, u) {
            return M = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d, P) {
              d.__proto__ = P;
            } || function(d, P) {
              for (var O in P)
                P.hasOwnProperty(O) && (d[O] = P[O]);
            }, M(v, u);
          };
          return function(v, u) {
            function d() {
              this.constructor = v;
            }
            M(v, u), v.prototype = u === null ? Object.create(u) : (d.prototype = u.prototype, new d());
          };
        }(), Z = R.defined, H = R.extend, $ = R.isNumber, U = R.merge, W = R.pick, N = R.removeEvent;
        return function(M) {
          function v(u, d, P, O, B, C, b, w, x, h) {
            var c = M.call(this) || this;
            c.paddingLeftSetter = c.paddingSetter, c.paddingRightSetter = c.paddingSetter, c.init(u, "g"), c.textStr = d, c.x = P, c.y = O, c.anchorX = C, c.anchorY = b, c.baseline = x, c.className = h, c.addClass(h === "button" ? "highcharts-no-tooltip" : "highcharts-label"), h && c.addClass("highcharts-" + h), c.text = u.text(void 0, 0, 0, w).attr({ zIndex: 1 });
            var p;
            return typeof B == "string" && ((p = /^url\((.*?)\)$/.test(B)) || c.renderer.symbols[B]) && (c.symbolKey = B), c.bBox = v.emptyBBox, c.padding = 3, c.baselineOffset = 0, c.needsBox = u.styledMode || p, c.deferredAttr = {}, c.alignFactor = 0, c;
          }
          return I(v, M), v.prototype.alignSetter = function(u) {
            u = { left: 0, center: 0.5, right: 1 }[u], u !== this.alignFactor && (this.alignFactor = u, this.bBox && $(this.xSetting) && this.attr({ x: this.xSetting }));
          }, v.prototype.anchorXSetter = function(u, d) {
            this.anchorX = u, this.boxAttr(d, Math.round(u) - this.getCrispAdjust() - this.xSetting);
          }, v.prototype.anchorYSetter = function(u, d) {
            this.anchorY = u, this.boxAttr(d, u - this.ySetting);
          }, v.prototype.boxAttr = function(u, d) {
            this.box ? this.box.attr(u, d) : this.deferredAttr[u] = d;
          }, v.prototype.css = function(u) {
            if (u) {
              var d = {};
              u = U(u), v.textProps.forEach(function(O) {
                typeof u[O] < "u" && (d[O] = u[O], delete u[O]);
              }), this.text.css(d);
              var P = "width" in d;
              "fontSize" in d || "fontWeight" in d ? this.updateTextPadding() : P && this.updateBoxSize();
            }
            return y.prototype.css.call(this, u);
          }, v.prototype.destroy = function() {
            N(this.element, "mouseenter"), N(this.element, "mouseleave"), this.text && this.text.destroy(), this.box && (this.box = this.box.destroy()), y.prototype.destroy.call(this);
          }, v.prototype.fillSetter = function(u, d) {
            u && (this.needsBox = !0), this.fill = u, this.boxAttr(d, u);
          }, v.prototype.getBBox = function() {
            this.textStr && this.bBox.width === 0 && this.bBox.height === 0 && this.updateBoxSize();
            var u = this.padding, d = W(this.paddingLeft, u);
            return { width: this.width, height: this.height, x: this.bBox.x - d, y: this.bBox.y - u };
          }, v.prototype.getCrispAdjust = function() {
            return this.renderer.styledMode && this.box ? this.box.strokeWidth() % 2 / 2 : (this["stroke-width"] ? parseInt(
              this["stroke-width"],
              10
            ) : 0) % 2 / 2;
          }, v.prototype.heightSetter = function(u) {
            this.heightSetting = u;
          }, v.prototype.onAdd = function() {
            var u = this.textStr;
            this.text.add(this), this.attr({ text: Z(u) ? u : "", x: this.x, y: this.y }), this.box && Z(this.anchorX) && this.attr({ anchorX: this.anchorX, anchorY: this.anchorY });
          }, v.prototype.paddingSetter = function(u, d) {
            $(u) ? u !== this[d] && (this[d] = u, this.updateTextPadding()) : this[d] = void 0;
          }, v.prototype.rSetter = function(u, d) {
            this.boxAttr(d, u);
          }, v.prototype.shadow = function(u) {
            return u && !this.renderer.styledMode && (this.updateBoxSize(), this.box && this.box.shadow(u)), this;
          }, v.prototype.strokeSetter = function(u, d) {
            this.stroke = u, this.boxAttr(d, u);
          }, v.prototype["stroke-widthSetter"] = function(u, d) {
            u && (this.needsBox = !0), this["stroke-width"] = u, this.boxAttr(d, u);
          }, v.prototype["text-alignSetter"] = function(u) {
            this.textAlign = u;
          }, v.prototype.textSetter = function(u) {
            typeof u < "u" && this.text.attr({ text: u }), this.updateTextPadding();
          }, v.prototype.updateBoxSize = function() {
            var u = this.text.element.style, d = {}, P = this.padding, O = this.bBox = $(this.widthSetting) && $(this.heightSetting) && !this.textAlign || !Z(this.text.textStr) ? v.emptyBBox : this.text.getBBox();
            this.width = this.getPaddedWidth(), this.height = (this.heightSetting || O.height || 0) + 2 * P, u = this.renderer.fontMetrics(u && u.fontSize, this.text), this.baselineOffset = P + Math.min((this.text.firstLineMetrics || u).b, O.height || 1 / 0), this.heightSetting && (this.baselineOffset += (this.heightSetting - u.h) / 2), this.needsBox && (this.box || (P = this.box = this.symbolKey ? this.renderer.symbol(this.symbolKey) : this.renderer.rect(), P.addClass((this.className === "button" ? "" : "highcharts-label-box") + (this.className ? " highcharts-" + this.className + "-box" : "")), P.add(this)), P = this.getCrispAdjust(), d.x = P, d.y = (this.baseline ? -this.baselineOffset : 0) + P, d.width = Math.round(this.width), d.height = Math.round(this.height), this.box.attr(H(d, this.deferredAttr)), this.deferredAttr = {});
          }, v.prototype.updateTextPadding = function() {
            var u = this.text;
            this.updateBoxSize();
            var d = this.baseline ? 0 : this.baselineOffset, P = W(this.paddingLeft, this.padding);
            Z(this.widthSetting) && this.bBox && (this.textAlign === "center" || this.textAlign === "right") && (P += { center: 0.5, right: 1 }[this.textAlign] * (this.widthSetting - this.bBox.width)), (P !== u.x || d !== u.y) && (u.attr("x", P), u.hasBoxWidthChanged && (this.bBox = u.getBBox(!0)), typeof d < "u" && u.attr("y", d)), u.x = P, u.y = d;
          }, v.prototype.widthSetter = function(u) {
            this.widthSetting = $(u) ? u : void 0;
          }, v.prototype.getPaddedWidth = function() {
            var u = this.padding, d = W(this.paddingLeft, u);
            return u = W(this.paddingRight, u), (this.widthSetting || this.bBox.width || 0) + d + u;
          }, v.prototype.xSetter = function(u) {
            this.x = u, this.alignFactor && (u -= this.alignFactor * this.getPaddedWidth(), this["forceAnimate:x"] = !0), this.xSetting = Math.round(u), this.attr("translateX", this.xSetting);
          }, v.prototype.ySetter = function(u) {
            this.ySetting = this.y = Math.round(u), this.attr("translateY", this.ySetting);
          }, v.emptyBBox = { width: 0, height: 0, x: 0, y: 0 }, v.textProps = "color direction fontFamily fontSize fontStyle fontWeight lineHeight textAlign textDecoration textOutline textOverflow width".split(" "), v;
        }(y);
      }
    ), E(
      a,
      "Core/Renderer/SVG/Symbols.js",
      [a["Core/Utilities.js"]],
      function(y) {
        function R(W, N, M, v, u) {
          var d = [];
          if (u) {
            var P = u.start || 0, O = U(u.r, M);
            M = U(u.r, v || M);
            var B = (u.end || 0) - 1e-3;
            v = u.innerR;
            var C = U(u.open, 1e-3 > Math.abs((u.end || 0) - P - 2 * Math.PI)), b = Math.cos(P), w = Math.sin(P), x = Math.cos(B), h = Math.sin(B);
            P = U(u.longArc, 1e-3 > B - P - Math.PI ? 0 : 1), d.push(["M", W + O * b, N + M * w], ["A", O, M, 0, P, U(u.clockwise, 1), W + O * x, N + M * h]), H(v) && d.push(C ? ["M", W + v * x, N + v * h] : ["L", W + v * x, N + v * h], ["A", v, v, 0, P, H(u.clockwise) ? 1 - u.clockwise : 0, W + v * b, N + v * w]), C || d.push(["Z"]);
          }
          return d;
        }
        function I(W, N, M, v, u) {
          return u && u.r ? Z(W, N, M, v, u) : [["M", W, N], ["L", W + M, N], ["L", W + M, N + v], ["L", W, N + v], ["Z"]];
        }
        function Z(W, N, M, v, u) {
          return u = u && u.r || 0, [["M", W + u, N], ["L", W + M - u, N], ["C", W + M, N, W + M, N, W + M, N + u], ["L", W + M, N + v - u], ["C", W + M, N + v, W + M, N + v, W + M - u, N + v], ["L", W + u, N + v], ["C", W, N + v, W, N + v, W, N + v - u], ["L", W, N + u], ["C", W, N, W, N, W + u, N]];
        }
        var H = y.defined, $ = y.isNumber, U = y.pick;
        return { arc: R, callout: function(W, N, M, v, u) {
          var d = Math.min(u && u.r || 0, M, v), P = d + 6, O = u && u.anchorX;
          u = u && u.anchorY || 0;
          var B = Z(W, N, M, v, { r: d });
          return $(O) && (W + O >= M ? u > N + P && u < N + v - P ? B.splice(3, 1, ["L", W + M, u - 6], ["L", W + M + 6, u], ["L", W + M, u + 6], ["L", W + M, N + v - d]) : B.splice(3, 1, ["L", W + M, v / 2], ["L", O, u], ["L", W + M, v / 2], ["L", W + M, N + v - d]) : 0 >= W + O ? u > N + P && u < N + v - P ? B.splice(7, 1, ["L", W, u + 6], ["L", W - 6, u], ["L", W, u - 6], ["L", W, N + d]) : B.splice(7, 1, ["L", W, v / 2], ["L", O, u], ["L", W, v / 2], ["L", W, N + d]) : u && u > v && O > W + P && O < W + M - P ? B.splice(5, 1, ["L", O + 6, N + v], ["L", O, N + v + 6], ["L", O - 6, N + v], ["L", W + d, N + v]) : u && 0 > u && O > W + P && O < W + M - P && B.splice(1, 1, ["L", O - 6, N], ["L", O, N - 6], ["L", O + 6, N], ["L", M - d, N])), B;
        }, circle: function(W, N, M, v) {
          return R(W + M / 2, N + v / 2, M / 2, v / 2, { start: 0.5 * Math.PI, end: 2.5 * Math.PI, open: !1 });
        }, diamond: function(W, N, M, v) {
          return [["M", W + M / 2, N], ["L", W + M, N + v / 2], ["L", W + M / 2, N + v], ["L", W, N + v / 2], ["Z"]];
        }, rect: I, roundedRect: Z, square: I, triangle: function(W, N, M, v) {
          return [["M", W + M / 2, N], ["L", W + M, N + v], ["L", W, N + v], ["Z"]];
        }, "triangle-down": function(W, N, M, v) {
          return [["M", W, N], ["L", W + M, N], ["L", W + M / 2, N + v], ["Z"]];
        } };
      }
    ), E(a, "Core/Renderer/SVG/TextBuilder.js", [a["Core/Renderer/HTML/AST.js"], a["Core/Globals.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = R.doc, H = R.SVG_NS, $ = R.win, U = I.attr, W = I.isString, N = I.objectEach, M = I.pick;
      return function() {
        function v(u) {
          var d = u.styles;
          this.renderer = u.renderer, this.svgElement = u, this.width = u.textWidth, this.textLineHeight = d && d.lineHeight, this.textOutline = d && d.textOutline, this.ellipsis = !(!d || d.textOverflow !== "ellipsis"), this.noWrap = !(!d || d.whiteSpace !== "nowrap"), this.fontSize = d && d.fontSize;
        }
        return v.prototype.buildSVG = function() {
          var u = this.svgElement, d = u.element, P = u.renderer, O = M(u.textStr, "").toString(), B = O.indexOf("<") !== -1, C = d.childNodes;
          P = this.width && !u.added && P.box;
          var b = /<br.*?>/g, w = [O, this.ellipsis, this.noWrap, this.textLineHeight, this.textOutline, this.fontSize, this.width].join();
          if (w !== u.textCache) {
            for (u.textCache = w, delete u.actualWidth, w = C.length; w--; )
              d.removeChild(C[w]);
            B || this.ellipsis || this.width || O.indexOf(" ") !== -1 && (!this.noWrap || b.test(O)) ? O !== "" && (P && P.appendChild(d), O = new y(O), this.modifyTree(O.nodes), O.addToDOM(u.element), this.modifyDOM(), this.ellipsis && (d.textContent || "").indexOf("…") !== -1 && u.attr(
              "title",
              this.unescapeEntities(u.textStr || "", ["&lt;", "&gt;"])
            ), P && P.removeChild(d)) : d.appendChild(Z.createTextNode(this.unescapeEntities(O))), W(this.textOutline) && u.applyTextOutline && u.applyTextOutline(this.textOutline);
          }
        }, v.prototype.modifyDOM = function() {
          var u = this, d = this.svgElement, P = U(d.element, "x");
          d.firstLineMetrics = void 0;
          for (var O; (O = d.element.firstChild) && /^[\s\u200B]*$/.test(O.textContent || " "); )
            d.element.removeChild(O);
          [].forEach.call(d.element.querySelectorAll("tspan.highcharts-br"), function(w, x) {
            w.nextSibling && w.previousSibling && (x === 0 && w.previousSibling.nodeType === 1 && (d.firstLineMetrics = d.renderer.fontMetrics(void 0, w.previousSibling)), U(w, { dy: u.getLineHeight(w.nextSibling), x: P }));
          });
          var B = this.width || 0;
          if (B) {
            var C = function(w, x) {
              var h = w.textContent || "", c = h.replace(/([^\^])-/g, "$1- ").split(" "), p = !u.noWrap && (1 < c.length || 1 < d.element.childNodes.length), i = u.getLineHeight(x), l = 0, s = d.actualWidth;
              if (u.ellipsis)
                h && u.truncate(w, h, void 0, 0, Math.max(0, B - parseInt(u.fontSize || 12, 10)), function(t, n) {
                  return t.substring(
                    0,
                    n
                  ) + "…";
                });
              else if (p) {
                for (h = [], p = []; x.firstChild && x.firstChild !== w; )
                  p.push(x.firstChild), x.removeChild(x.firstChild);
                for (; c.length; )
                  c.length && !u.noWrap && 0 < l && (h.push(w.textContent || ""), w.textContent = c.join(" ").replace(/- /g, "-")), u.truncate(w, void 0, c, l === 0 && s || 0, B, function(t, n) {
                    return c.slice(0, n).join(" ").replace(/- /g, "-");
                  }), s = d.actualWidth, l++;
                p.forEach(function(t) {
                  x.insertBefore(t, w);
                }), h.forEach(function(t) {
                  x.insertBefore(Z.createTextNode(t), w), t = Z.createElementNS(H, "tspan"), t.textContent = "​", U(t, { dy: i, x: P }), x.insertBefore(t, w);
                });
              }
            }, b = function(w) {
              [].slice.call(w.childNodes).forEach(function(x) {
                x.nodeType === $.Node.TEXT_NODE ? C(x, w) : (x.className.baseVal.indexOf("highcharts-br") !== -1 && (d.actualWidth = 0), b(x));
              });
            };
            b(d.element);
          }
        }, v.prototype.getLineHeight = function(u) {
          var d;
          return u = u.nodeType === $.Node.TEXT_NODE ? u.parentElement : u, this.renderer.styledMode || (d = u && /(px|em)$/.test(u.style.fontSize) ? u.style.fontSize : this.fontSize || this.renderer.style.fontSize || 12), this.textLineHeight ? parseInt(
            this.textLineHeight.toString(),
            10
          ) : this.renderer.fontMetrics(d, u || this.svgElement.element).h;
        }, v.prototype.modifyTree = function(u) {
          var d = this, P = function(O, B) {
            var C = O.attributes;
            C = C === void 0 ? {} : C;
            var b = O.children, w = O.tagName, x = d.renderer.styledMode;
            w === "b" || w === "strong" ? x ? C.class = "highcharts-strong" : C.style = "font-weight:bold;" + (C.style || "") : (w === "i" || w === "em") && (x ? C.class = "highcharts-emphasized" : C.style = "font-style:italic;" + (C.style || "")), W(C.style) && (C.style = C.style.replace(/(;| |^)color([ :])/, "$1fill$2")), w === "br" ? (C.class = "highcharts-br", O.textContent = "​", (B = u[B + 1]) && B.textContent && (B.textContent = B.textContent.replace(/^ +/gm, ""))) : w === "a" && b && b.some(function(h) {
              return h.tagName === "#text";
            }) && (O.children = [{ children: b, tagName: "tspan" }]), w !== "#text" && w !== "a" && (O.tagName = "tspan"), O.attributes = C, b && b.filter(function(h) {
              return h.tagName !== "#text";
            }).forEach(P);
          };
          u.forEach(P);
        }, v.prototype.truncate = function(u, d, P, O, B, C) {
          var b = this.svgElement, w = b.renderer, x = b.rotation, h = [], c = P ? 1 : 0, p = (d || P || "").length, i = p, l, s = function(n, o) {
            o = o || n;
            var A = u.parentNode;
            if (A && typeof h[o] > "u")
              if (A.getSubStringLength)
                try {
                  h[o] = O + A.getSubStringLength(0, P ? o + 1 : o);
                } catch {
                }
              else
                w.getSpanWidth && (u.textContent = C(d || P, n), h[o] = O + w.getSpanWidth(b, u));
            return h[o];
          };
          b.rotation = 0;
          var t = s(u.textContent.length);
          if (O + t > B) {
            for (; c <= p; )
              i = Math.ceil((c + p) / 2), P && (l = C(P, i)), t = s(i, l && l.length - 1), c === p ? c = p + 1 : t > B ? p = i - 1 : c = i;
            p === 0 ? u.textContent = "" : d && p === d.length - 1 || (u.textContent = l || C(d || P, i));
          }
          P && P.splice(0, i), b.actualWidth = t, b.rotation = x;
        }, v.prototype.unescapeEntities = function(u, d) {
          return N(this.renderer.escapes, function(P, O) {
            d && d.indexOf(P) !== -1 || (u = u.toString().replace(new RegExp(P, "g"), O));
          }), u;
        }, v;
      }();
    }), E(a, "Core/Renderer/SVG/SVGRenderer.js", [a["Core/Renderer/HTML/AST.js"], a["Core/Color/Color.js"], a["Core/Globals.js"], a["Core/Renderer/RendererRegistry.js"], a["Core/Renderer/SVG/SVGElement.js"], a["Core/Renderer/SVG/SVGLabel.js"], a["Core/Renderer/SVG/Symbols.js"], a["Core/Renderer/SVG/TextBuilder.js"], a["Core/Utilities.js"]], function(y, R, I, Z, H, $, U, W, N) {
      var M = I.charts, v = I.deg2rad, u = I.doc, d = I.isFirefox, P = I.isMS, O = I.isWebKit, B = I.noop, C = I.SVG_NS, b = I.symbolSizes, w = I.win, x = N.addEvent, h = N.attr, c = N.createElement, p = N.css, i = N.defined, l = N.destroyObjectProperties, s = N.extend, t = N.isArray, n = N.isNumber, o = N.isObject, A = N.isString, _ = N.merge, D = N.pick, j = N.pInt, T = N.uniqueKey, X;
      return I = function() {
        function f(m, L, Y, F, Q, k, G) {
          this.width = this.url = this.style = this.isSVG = this.imgCount = this.height = this.gradients = this.globalAnimation = this.defs = this.chartIndex = this.cacheKeys = this.cache = this.boxWrapper = this.box = this.alignedObjects = void 0, this.init(m, L, Y, F, Q, k, G);
        }
        return f.prototype.init = function(m, L, Y, F, Q, k, G) {
          var z = this.createElement("svg").attr({ version: "1.1", class: "highcharts-root" }), V = z.element;
          G || z.css(this.getStyle(F)), m.appendChild(V), h(m, "dir", "ltr"), m.innerHTML.indexOf("xmlns") === -1 && h(V, "xmlns", this.SVG_NS), this.isSVG = !0, this.box = V, this.boxWrapper = z, this.alignedObjects = [], this.url = this.getReferenceURL(), this.createElement("desc").add().element.appendChild(u.createTextNode("Created with Highcharts 9.3.3")), this.defs = this.createElement("defs").add(), this.allowHTML = k, this.forExport = Q, this.styledMode = G, this.gradients = {}, this.cache = {}, this.cacheKeys = [], this.imgCount = 0, this.setSize(L, Y, !1);
          var q;
          d && m.getBoundingClientRect && (L = function() {
            p(m, { left: 0, top: 0 }), q = m.getBoundingClientRect(), p(m, { left: Math.ceil(q.left) - q.left + "px", top: Math.ceil(q.top) - q.top + "px" });
          }, L(), this.unSubPixelFix = x(w, "resize", L));
        }, f.prototype.definition = function(m) {
          return new y([m]).addToDOM(this.defs.element);
        }, f.prototype.getReferenceURL = function() {
          if ((d || O) && u.getElementsByTagName("base").length) {
            if (!i(X)) {
              var m = T();
              m = new y([{ tagName: "svg", attributes: { width: 8, height: 8 }, children: [{ tagName: "defs", children: [{ tagName: "clipPath", attributes: { id: m }, children: [{ tagName: "rect", attributes: { width: 4, height: 4 } }] }] }, { tagName: "rect", attributes: { id: "hitme", width: 8, height: 8, "clip-path": "url(#" + m + ")", fill: "rgba(0,0,0,0.001)" } }] }]).addToDOM(u.body), p(m, { position: "fixed", top: 0, left: 0, zIndex: 9e5 });
              var L = u.elementFromPoint(6, 6);
              X = (L && L.id) === "hitme", u.body.removeChild(m);
            }
            if (X)
              return w.location.href.split("#")[0].replace(/<[^>]*>/g, "").replace(/([\('\)])/g, "\\$1").replace(/ /g, "%20");
          }
          return "";
        }, f.prototype.getStyle = function(m) {
          return this.style = s({ fontFamily: '"Lucida Grande", "Lucida Sans Unicode", Arial, Helvetica, sans-serif', fontSize: "12px" }, m);
        }, f.prototype.setStyle = function(m) {
          this.boxWrapper.css(this.getStyle(m));
        }, f.prototype.isHidden = function() {
          return !this.boxWrapper.getBBox().width;
        }, f.prototype.destroy = function() {
          var m = this.defs;
          return this.box = null, this.boxWrapper = this.boxWrapper.destroy(), l(this.gradients || {}), this.gradients = null, m && (this.defs = m.destroy()), this.unSubPixelFix && this.unSubPixelFix(), this.alignedObjects = null;
        }, f.prototype.createElement = function(m) {
          var L = new this.Element();
          return L.init(this, m), L;
        }, f.prototype.getRadialAttr = function(m, L) {
          return { cx: m[0] - m[2] / 2 + (L.cx || 0) * m[2], cy: m[1] - m[2] / 2 + (L.cy || 0) * m[2], r: (L.r || 0) * m[2] };
        }, f.prototype.buildText = function(m) {
          new W(m).buildSVG();
        }, f.prototype.getContrast = function(m) {
          return m = R.parse(m).rgba, m[0] *= 1, m[1] *= 1.2, m[2] *= 0.5, 459 < m[0] + m[1] + m[2] ? "#000000" : "#FFFFFF";
        }, f.prototype.button = function(m, L, Y, F, Q, k, G, z, V, q) {
          var it = this.label(m, L, Y, V, void 0, void 0, q, void 0, "button"), et = this.styledMode, nt = 0, rt = Q ? _(Q) : {};
          if (m = rt && rt.style || {}, rt = y.filterUserAttributes(rt), it.attr(_({ padding: 8, r: 2 }, rt)), !et) {
            rt = _({ fill: "#f7f7f7", stroke: "#cccccc", "stroke-width": 1, style: { color: "#333333", cursor: "pointer", fontWeight: "normal" } }, { style: m }, rt);
            var ct = rt.style;
            delete rt.style, k = _(rt, { fill: "#e6e6e6" }, y.filterUserAttributes(k || {}));
            var gt = k.style;
            delete k.style, G = _(rt, { fill: "#e6ebf5", style: { color: "#000000", fontWeight: "bold" } }, y.filterUserAttributes(G || {}));
            var dt = G.style;
            delete G.style, z = _(rt, { style: { color: "#cccccc" } }, y.filterUserAttributes(z || {}));
            var lt = z.style;
            delete z.style;
          }
          return x(it.element, P ? "mouseover" : "mouseenter", function() {
            nt !== 3 && it.setState(1);
          }), x(it.element, P ? "mouseout" : "mouseleave", function() {
            nt !== 3 && it.setState(nt);
          }), it.setState = function(at) {
            at !== 1 && (it.state = nt = at), it.removeClass(/highcharts-button-(normal|hover|pressed|disabled)/).addClass("highcharts-button-" + ["normal", "hover", "pressed", "disabled"][at || 0]), et || it.attr([rt, k, G, z][at || 0]).css([ct, gt, dt, lt][at || 0]);
          }, et || it.attr(rt).css(s({ cursor: "default" }, ct)), it.on("touchstart", function(at) {
            return at.stopPropagation();
          }).on("click", function(at) {
            nt !== 3 && F.call(it, at);
          });
        }, f.prototype.crispLine = function(m, L, Y) {
          Y === void 0 && (Y = "round");
          var F = m[0], Q = m[1];
          return i(F[1]) && F[1] === Q[1] && (F[1] = Q[1] = Math[Y](F[1]) - L % 2 / 2), i(F[2]) && F[2] === Q[2] && (F[2] = Q[2] = Math[Y](F[2]) + L % 2 / 2), m;
        }, f.prototype.path = function(m) {
          var L = this.styledMode ? {} : { fill: "none" };
          return t(m) ? L.d = m : o(m) && s(L, m), this.createElement("path").attr(L);
        }, f.prototype.circle = function(m, L, Y) {
          return m = o(m) ? m : typeof m > "u" ? {} : { x: m, y: L, r: Y }, L = this.createElement("circle"), L.xSetter = L.ySetter = function(F, Q, k) {
            k.setAttribute("c" + Q, F);
          }, L.attr(m);
        }, f.prototype.arc = function(m, L, Y, F, Q, k) {
          return o(m) ? (F = m, L = F.y, Y = F.r, m = F.x) : F = { innerR: F, start: Q, end: k }, m = this.symbol("arc", m, L, Y, Y, F), m.r = Y, m;
        }, f.prototype.rect = function(m, L, Y, F, Q, k) {
          Q = o(m) ? m.r : Q;
          var G = this.createElement("rect");
          return m = o(m) ? m : typeof m > "u" ? {} : { x: m, y: L, width: Math.max(Y, 0), height: Math.max(F, 0) }, this.styledMode || (typeof k < "u" && (m["stroke-width"] = k, m = G.crisp(m)), m.fill = "none"), Q && (m.r = Q), G.rSetter = function(z, V, q) {
            G.r = z, h(q, { rx: z, ry: z });
          }, G.rGetter = function() {
            return G.r || 0;
          }, G.attr(m);
        }, f.prototype.setSize = function(m, L, Y) {
          this.width = m, this.height = L, this.boxWrapper.animate({ width: m, height: L }, { step: function() {
            this.attr({ viewBox: "0 0 " + this.attr("width") + " " + this.attr("height") });
          }, duration: D(
            Y,
            !0
          ) ? void 0 : 0 }), this.alignElements();
        }, f.prototype.g = function(m) {
          var L = this.createElement("g");
          return m ? L.attr({ class: "highcharts-" + m }) : L;
        }, f.prototype.image = function(m, L, Y, F, Q, k) {
          var G = { preserveAspectRatio: "none" }, z = function(q, it) {
            q.setAttributeNS ? q.setAttributeNS("http://www.w3.org/1999/xlink", "href", it) : q.setAttribute("hc-svg-href", it);
          };
          n(L) && (G.x = L), n(Y) && (G.y = Y), n(F) && (G.width = F), n(Q) && (G.height = Q);
          var V = this.createElement("image").attr(G);
          return L = function(q) {
            z(V.element, m), k.call(V, q);
          }, k ? (z(
            V.element,
            "data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw=="
          ), Y = new w.Image(), x(Y, "load", L), Y.src = m, Y.complete && L({})) : z(V.element, m), V;
        }, f.prototype.symbol = function(m, L, Y, F, Q, k) {
          var G = this, z = /^url\((.*?)\)$/, V = z.test(m), q = !V && (this.symbols[m] ? m : "circle"), it = q && this.symbols[q], et;
          if (it) {
            typeof L == "number" && (et = it.call(this.symbols, Math.round(L || 0), Math.round(Y || 0), F || 0, Q || 0, k));
            var nt = this.path(et);
            G.styledMode || nt.attr("fill", "none"), s(nt, { symbolName: q || void 0, x: L, y: Y, width: F, height: Q }), k && s(nt, k);
          } else if (V) {
            var rt = m.match(z)[1], ct = nt = this.image(rt);
            ct.imgwidth = D(b[rt] && b[rt].width, k && k.width), ct.imgheight = D(b[rt] && b[rt].height, k && k.height);
            var gt = function(dt) {
              return dt.attr({ width: dt.width, height: dt.height });
            };
            ["width", "height"].forEach(function(dt) {
              ct[dt + "Setter"] = function(lt, at) {
                var J = this["img" + at];
                this[at] = lt, i(J) && (k && k.backgroundSize === "within" && this.width && this.height && (J = Math.round(J * Math.min(this.width / this.imgwidth, this.height / this.imgheight))), this.element && this.element.setAttribute(at, J), this.alignByTranslate || (lt = ((this[at] || 0) - J) / 2, this.attr(at === "width" ? { translateX: lt } : { translateY: lt })));
              };
            }), i(L) && ct.attr({ x: L, y: Y }), ct.isImg = !0, i(ct.imgwidth) && i(ct.imgheight) ? gt(ct) : (ct.attr({ width: 0, height: 0 }), c("img", { onload: function() {
              var dt = M[G.chartIndex];
              this.width === 0 && (p(this, { position: "absolute", top: "-999em" }), u.body.appendChild(this)), b[rt] = { width: this.width, height: this.height }, ct.imgwidth = this.width, ct.imgheight = this.height, ct.element && gt(ct), this.parentNode && this.parentNode.removeChild(this), G.imgCount--, !G.imgCount && dt && !dt.hasLoaded && dt.onload();
            }, src: rt }), this.imgCount++);
          }
          return nt;
        }, f.prototype.clipRect = function(m, L, Y, F) {
          var Q = T() + "-", k = this.createElement("clipPath").attr({ id: Q }).add(this.defs);
          return m = this.rect(m, L, Y, F, 0).add(k), m.id = Q, m.clipPath = k, m.count = 0, m;
        }, f.prototype.text = function(m, L, Y, F) {
          var Q = {};
          return F && (this.allowHTML || !this.forExport) ? this.html(m, L, Y) : (Q.x = Math.round(L || 0), Y && (Q.y = Math.round(Y)), i(m) && (Q.text = m), m = this.createElement("text").attr(Q), (!F || this.forExport && !this.allowHTML) && (m.xSetter = function(k, G, z) {
            for (var V = z.getElementsByTagName("tspan"), q = z.getAttribute(G), it = 0, et; it < V.length; it++)
              et = V[it], et.getAttribute(G) === q && et.setAttribute(G, k);
            z.setAttribute(G, k);
          }), m);
        }, f.prototype.fontMetrics = function(m, L) {
          return m = !this.styledMode && /px/.test(m) || !w.getComputedStyle ? m || L && L.style && L.style.fontSize || this.style && this.style.fontSize : L && H.prototype.getStyle.call(L, "font-size"), m = /px/.test(m) ? j(m) : 12, L = 24 > m ? m + 3 : Math.round(1.2 * m), { h: L, b: Math.round(0.8 * L), f: m };
        }, f.prototype.rotCorr = function(m, L, Y) {
          var F = m;
          return L && Y && (F = Math.max(F * Math.cos(L * v), 4)), { x: -m / 3 * Math.sin(L * v), y: F };
        }, f.prototype.pathToSegments = function(m) {
          for (var L = [], Y = [], F = { A: 8, C: 7, H: 2, L: 3, M: 3, Q: 5, S: 5, T: 3, V: 2 }, Q = 0; Q < m.length; Q++)
            A(Y[0]) && n(m[Q]) && Y.length === F[Y[0].toUpperCase()] && m.splice(Q, 0, Y[0].replace("M", "L").replace("m", "l")), typeof m[Q] == "string" && (Y.length && L.push(Y.slice(0)), Y.length = 0), Y.push(m[Q]);
          return L.push(Y.slice(0)), L;
        }, f.prototype.label = function(m, L, Y, F, Q, k, G, z, V) {
          return new $(this, m, L, Y, F, Q, k, G, z, V);
        }, f.prototype.alignElements = function() {
          this.alignedObjects.forEach(function(m) {
            return m.align();
          });
        }, f;
      }(), s(I.prototype, { Element: H, SVG_NS: C, escapes: { "&": "&amp;", "<": "&lt;", ">": "&gt;", "'": "&#39;", '"': "&quot;" }, symbols: U, draw: B }), Z.registerRendererType("svg", I, !0), I;
    }), E(a, "Core/Renderer/HTML/HTMLElement.js", [a["Core/Globals.js"], a["Core/Renderer/SVG/SVGElement.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = this && this.__extends || function() {
        var P = function(O, B) {
          return P = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(C, b) {
            C.__proto__ = b;
          } || function(C, b) {
            for (var w in b)
              b.hasOwnProperty(w) && (C[w] = b[w]);
          }, P(O, B);
        };
        return function(O, B) {
          function C() {
            this.constructor = O;
          }
          P(O, B), O.prototype = B === null ? Object.create(B) : (C.prototype = B.prototype, new C());
        };
      }(), H = y.isFirefox, $ = y.isMS, U = y.isWebKit, W = y.win, N = I.css, M = I.defined, v = I.extend, u = I.pick, d = I.pInt;
      return function(P) {
        function O() {
          return P !== null && P.apply(this, arguments) || this;
        }
        return Z(O, P), O.compose = function(B) {
          if (O.composedClasses.indexOf(B) === -1) {
            O.composedClasses.push(B);
            var C = O.prototype, b = B.prototype;
            b.getSpanCorrection = C.getSpanCorrection, b.htmlCss = C.htmlCss, b.htmlGetBBox = C.htmlGetBBox, b.htmlUpdateTransform = C.htmlUpdateTransform, b.setSpanRotation = C.setSpanRotation;
          }
          return B;
        }, O.prototype.getSpanCorrection = function(B, C, b) {
          this.xCorr = -B * b, this.yCorr = -C;
        }, O.prototype.htmlCss = function(B) {
          var C = this.element.tagName === "SPAN" && B && "width" in B, b = u(C && B.width, void 0);
          if (C) {
            delete B.width, this.textWidth = b;
            var w = !0;
          }
          return B && B.textOverflow === "ellipsis" && (B.whiteSpace = "nowrap", B.overflow = "hidden"), this.styles = v(this.styles, B), N(this.element, B), w && this.htmlUpdateTransform(), this;
        }, O.prototype.htmlGetBBox = function() {
          var B = this.element;
          return { x: B.offsetLeft, y: B.offsetTop, width: B.offsetWidth, height: B.offsetHeight };
        }, O.prototype.htmlUpdateTransform = function() {
          if (this.added) {
            var B = this.renderer, C = this.element, b = this.translateX || 0, w = this.translateY || 0, x = this.x || 0, h = this.y || 0, c = this.textAlign || "left", p = { left: 0, center: 0.5, right: 1 }[c], i = this.styles;
            if (i = i && i.whiteSpace, N(C, { marginLeft: b, marginTop: w }), !B.styledMode && this.shadows && this.shadows.forEach(function(A) {
              N(A, { marginLeft: b + 1, marginTop: w + 1 });
            }), this.inverted && [].forEach.call(C.childNodes, function(A) {
              B.invertChild(A, C);
            }), C.tagName === "SPAN") {
              var l = this.rotation, s = this.textWidth && d(this.textWidth), t = [l, c, C.innerHTML, this.textWidth, this.textAlign].join(), n = void 0;
              if (n = !1, s !== this.oldTextWidth) {
                if (this.textPxLength)
                  var o = this.textPxLength;
                else
                  N(C, { width: "", whiteSpace: i || "nowrap" }), o = C.offsetWidth;
                (s > this.oldTextWidth || o > s) && (/[ \-]/.test(C.textContent || C.innerText) || C.style.textOverflow === "ellipsis") && (N(C, { width: o > s || l ? s + "px" : "auto", display: "block", whiteSpace: i || "normal" }), this.oldTextWidth = s, n = !0);
              }
              this.hasBoxWidthChanged = n, t !== this.cTT && (n = B.fontMetrics(C.style.fontSize, C).b, !M(l) || l === (this.oldRotation || 0) && c === this.oldAlign || this.setSpanRotation(l, p, n), this.getSpanCorrection(!M(l) && this.textPxLength || C.offsetWidth, n, p, l, c)), N(C, { left: x + (this.xCorr || 0) + "px", top: h + (this.yCorr || 0) + "px" }), this.cTT = t, this.oldRotation = l, this.oldAlign = c;
            }
          } else
            this.alignOnAdd = !0;
        }, O.prototype.setSpanRotation = function(B, C, b) {
          var w = {}, x = $ && !/Edge/.test(W.navigator.userAgent) ? "-ms-transform" : U ? "-webkit-transform" : H ? "MozTransform" : W.opera ? "-o-transform" : void 0;
          x && (w[x] = w.transform = "rotate(" + B + "deg)", w[x + (H ? "Origin" : "-origin")] = w.transformOrigin = 100 * C + "% " + b + "px", N(this.element, w));
        }, O.composedClasses = [], O;
      }(R);
    }), E(
      a,
      "Core/Renderer/HTML/HTMLRenderer.js",
      [a["Core/Renderer/HTML/AST.js"], a["Core/Renderer/SVG/SVGElement.js"], a["Core/Renderer/SVG/SVGRenderer.js"], a["Core/Utilities.js"]],
      function(y, R, I, Z) {
        var H = this && this.__extends || function() {
          var M = function(v, u) {
            return M = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d, P) {
              d.__proto__ = P;
            } || function(d, P) {
              for (var O in P)
                P.hasOwnProperty(O) && (d[O] = P[O]);
            }, M(v, u);
          };
          return function(v, u) {
            function d() {
              this.constructor = v;
            }
            M(v, u), v.prototype = u === null ? Object.create(u) : (d.prototype = u.prototype, new d());
          };
        }(), $ = Z.attr, U = Z.createElement, W = Z.extend, N = Z.pick;
        return function(M) {
          function v() {
            return M !== null && M.apply(this, arguments) || this;
          }
          return H(v, M), v.compose = function(u) {
            return v.composedClasses.indexOf(u) === -1 && (v.composedClasses.push(u), u.prototype.html = v.prototype.html), u;
          }, v.prototype.html = function(u, d, P) {
            var O = this.createElement("span"), B = O.element, C = O.renderer, b = C.isSVG, w = function(x, h) {
              ["opacity", "visibility"].forEach(function(c) {
                x[c + "Setter"] = function(p, i, l) {
                  var s = x.div ? x.div.style : h;
                  R.prototype[c + "Setter"].call(this, p, i, l), s && (s[i] = p);
                };
              }), x.addedSetters = !0;
            };
            return O.textSetter = function(x) {
              x !== this.textStr && (delete this.bBox, delete this.oldTextWidth, y.setElementHTML(this.element, N(x, "")), this.textStr = x, O.doTransform = !0);
            }, b && w(O, O.element.style), O.xSetter = O.ySetter = O.alignSetter = O.rotationSetter = function(x, h) {
              h === "align" ? O.alignValue = O.textAlign = x : O[h] = x, O.doTransform = !0;
            }, O.afterSetters = function() {
              this.doTransform && (this.htmlUpdateTransform(), this.doTransform = !1);
            }, O.attr({ text: u, x: Math.round(d), y: Math.round(P) }).css({ position: "absolute" }), C.styledMode || O.css({ fontFamily: this.style.fontFamily, fontSize: this.style.fontSize }), B.style.whiteSpace = "nowrap", O.css = O.htmlCss, b && (O.add = function(x) {
              var h = C.box.parentNode, c = [];
              if (this.parentGroup = x) {
                var p = x.div;
                if (!p) {
                  for (; x; )
                    c.push(x), x = x.parentGroup;
                  c.reverse().forEach(function(i) {
                    function l(o, A) {
                      i[A] = o, A === "translateX" ? n.left = o + "px" : n.top = o + "px", i.doTransform = !0;
                    }
                    var s = $(i.element, "class"), t = i.styles || {};
                    p = i.div = i.div || U("div", s ? { className: s } : void 0, {
                      position: "absolute",
                      left: (i.translateX || 0) + "px",
                      top: (i.translateY || 0) + "px",
                      display: i.display,
                      opacity: i.opacity,
                      cursor: t.cursor,
                      pointerEvents: t.pointerEvents,
                      visibility: i.visibility
                    }, p || h);
                    var n = p.style;
                    W(i, { classSetter: function(o) {
                      return function(A) {
                        this.element.setAttribute("class", A), o.className = A;
                      };
                    }(p), on: function() {
                      return c[0].div && O.on.apply({ element: c[0].div, onEvents: i.onEvents }, arguments), i;
                    }, translateXSetter: l, translateYSetter: l }), i.addedSetters || w(i);
                  });
                }
              } else
                p = h;
              return p.appendChild(B), O.added = !0, O.alignOnAdd && O.htmlUpdateTransform(), O;
            }), O;
          }, v.composedClasses = [], v;
        }(I);
      }
    ), E(a, "Core/Axis/AxisDefaults.js", [], function() {
      var y;
      return function(R) {
        R.defaultXAxisOptions = { alignTicks: !0, allowDecimals: void 0, panningEnabled: !0, zIndex: 2, zoomEnabled: !0, dateTimeLabelFormats: { millisecond: { main: "%H:%M:%S.%L", range: !1 }, second: { main: "%H:%M:%S", range: !1 }, minute: { main: "%H:%M", range: !1 }, hour: { main: "%H:%M", range: !1 }, day: { main: "%e. %b" }, week: { main: "%e. %b" }, month: { main: "%b '%y" }, year: { main: "%Y" } }, endOnTick: !1, gridLineDashStyle: "Solid", gridZIndex: 1, labels: {
          autoRotation: void 0,
          autoRotationLimit: 80,
          distance: void 0,
          enabled: !0,
          indentation: 10,
          overflow: "justify",
          padding: 5,
          reserveSpace: void 0,
          rotation: void 0,
          staggerLines: 0,
          step: 0,
          useHTML: !1,
          x: 0,
          zIndex: 7,
          style: { color: "#666666", cursor: "default", fontSize: "11px" }
        }, maxPadding: 0.01, minorGridLineDashStyle: "Solid", minorTickLength: 2, minorTickPosition: "outside", minPadding: 0.01, offset: void 0, opposite: !1, reversed: void 0, reversedStacks: !1, showEmpty: !0, showFirstLabel: !0, showLastLabel: !0, startOfWeek: 1, startOnTick: !1, tickLength: 10, tickPixelInterval: 100, tickmarkPlacement: "between", tickPosition: "outside", title: {
          align: "middle",
          rotation: 0,
          useHTML: !1,
          x: 0,
          y: 0,
          style: { color: "#666666" }
        }, type: "linear", uniqueNames: !0, visible: !0, minorGridLineColor: "#f2f2f2", minorGridLineWidth: 1, minorTickColor: "#999999", lineColor: "#ccd6eb", lineWidth: 1, gridLineColor: "#e6e6e6", gridLineWidth: void 0, tickColor: "#ccd6eb" }, R.defaultYAxisOptions = { reversedStacks: !0, endOnTick: !0, maxPadding: 0.05, minPadding: 0.05, tickPixelInterval: 72, showLastLabel: !0, labels: { x: -8 }, startOnTick: !0, title: { rotation: 270, text: "Values" }, stackLabels: {
          animation: {},
          allowOverlap: !1,
          enabled: !1,
          crop: !0,
          overflow: "justify",
          formatter: function() {
            var I = this.axis.chart.numberFormatter;
            return I(this.total, -1);
          },
          style: { color: "#000000", fontSize: "11px", fontWeight: "bold", textOutline: "1px contrast" }
        }, gridLineWidth: 1, lineWidth: 0 }, R.defaultLeftAxisOptions = { labels: { x: -15 }, title: { rotation: 270 } }, R.defaultRightAxisOptions = { labels: { x: 15 }, title: { rotation: 90 } }, R.defaultBottomAxisOptions = { labels: { autoRotation: [-45], x: 0 }, margin: 15, title: { rotation: 0 } }, R.defaultTopAxisOptions = { labels: { autoRotation: [-45], x: 0 }, margin: 15, title: { rotation: 0 } };
      }(y || (y = {})), y;
    }), E(a, "Core/Foundation.js", [a["Core/Utilities.js"]], function(y) {
      var R = y.addEvent, I = y.isFunction, Z = y.objectEach, H = y.removeEvent, $;
      return function(U) {
        U.registerEventOptions = function(W, N) {
          W.eventOptions = W.eventOptions || {}, Z(N.events, function(M, v) {
            W.eventOptions[v] !== M && (W.eventOptions[v] && (H(W, v, W.eventOptions[v]), delete W.eventOptions[v]), I(M) && (W.eventOptions[v] = M, R(W, v, M)));
          });
        };
      }($ || ($ = {})), $;
    }), E(
      a,
      "Core/Axis/Tick.js",
      [a["Core/FormatUtilities.js"], a["Core/Globals.js"], a["Core/Utilities.js"]],
      function(y, R, I) {
        var Z = R.deg2rad, H = I.clamp, $ = I.correctFloat, U = I.defined, W = I.destroyObjectProperties, N = I.extend, M = I.fireEvent, v = I.isNumber, u = I.merge, d = I.objectEach, P = I.pick;
        return R = function() {
          function O(B, C, b, w, x) {
            this.isNewLabel = this.isNew = !0, this.axis = B, this.pos = C, this.type = b || "", this.parameters = x || {}, this.tickmarkOffset = this.parameters.tickmarkOffset, this.options = this.parameters.options, M(this, "init"), b || w || this.addLabel();
          }
          return O.prototype.addLabel = function() {
            var B = this, C = B.axis, b = C.options, w = C.chart, x = C.categories, h = C.logarithmic, c = C.names, p = B.pos, i = P(B.options && B.options.labels, b.labels), l = C.tickPositions, s = p === l[0], t = p === l[l.length - 1], n = (!i.step || i.step === 1) && C.tickInterval === 1;
            l = l.info;
            var o = B.label, A;
            if (x = this.parameters.category || (x ? P(x[p], c[p], p) : p), h && v(x) && (x = $(h.lin2log(x))), C.dateTime)
              if (l)
                var _ = w.time.resolveDTLFormat(b.dateTimeLabelFormats[!b.grid && l.higherRanks[p] || l.unitName]), D = _.main;
              else
                v(x) && (D = C.dateTime.getXDateFormat(x, b.dateTimeLabelFormats || {}));
            B.isFirst = s, B.isLast = t;
            var j = {
              axis: C,
              chart: w,
              dateTimeLabelFormat: D,
              isFirst: s,
              isLast: t,
              pos: p,
              tick: B,
              tickPositionInfo: l,
              value: x
            };
            M(this, "labelFormat", j);
            var T = function(f) {
              return i.formatter ? i.formatter.call(f, f) : i.format ? (f.text = C.defaultLabelFormatter.call(f), y.format(i.format, f, w)) : C.defaultLabelFormatter.call(f, f);
            };
            b = T.call(j, j);
            var X = _ && _.list;
            B.shortenLabel = X ? function() {
              for (A = 0; A < X.length; A++)
                if (N(j, { dateTimeLabelFormat: X[A] }), o.attr({ text: T.call(j, j) }), o.getBBox().width < C.getSlotWidth(B) - 2 * i.padding)
                  return;
              o.attr({ text: "" });
            } : void 0, n && C._addedPlotLB && B.moveLabel(b, i), U(o) || B.movedLabel ? o && o.textStr !== b && !n && (!o.textWidth || i.style.width || o.styles.width || o.css({ width: null }), o.attr({ text: b }), o.textPxLength = o.getBBox().width) : (B.label = o = B.createLabel({ x: 0, y: 0 }, b, i), B.rotation = 0);
          }, O.prototype.createLabel = function(B, C, b) {
            var w = this.axis, x = w.chart;
            return (B = U(C) && b.enabled ? x.renderer.text(C, B.x, B.y, b.useHTML).add(w.labelGroup) : null) && (x.styledMode || B.css(u(b.style)), B.textPxLength = B.getBBox().width), B;
          }, O.prototype.destroy = function() {
            W(
              this,
              this.axis
            );
          }, O.prototype.getPosition = function(B, C, b, w) {
            var x = this.axis, h = x.chart, c = w && h.oldChartHeight || h.chartHeight;
            return B = { x: B ? $(x.translate(C + b, null, null, w) + x.transB) : x.left + x.offset + (x.opposite ? (w && h.oldChartWidth || h.chartWidth) - x.right - x.left : 0), y: B ? c - x.bottom + x.offset - (x.opposite ? x.height : 0) : $(c - x.translate(C + b, null, null, w) - x.transB) }, B.y = H(B.y, -1e5, 1e5), M(this, "afterGetPosition", { pos: B }), B;
          }, O.prototype.getLabelPosition = function(B, C, b, w, x, h, c, p) {
            var i = this.axis, l = i.transA, s = i.isLinked && i.linkedParent ? i.linkedParent.reversed : i.reversed, t = i.staggerLines, n = i.tickRotCorr || { x: 0, y: 0 }, o = w || i.reserveSpaceDefault ? 0 : -i.labelOffset * (i.labelAlign === "center" ? 0.5 : 1), A = {}, _ = x.y;
            return U(_) || (_ = i.side === 0 ? b.rotation ? -8 : -b.getBBox().height : i.side === 2 ? n.y + 8 : Math.cos(b.rotation * Z) * (n.y - b.getBBox(!1, 0).height / 2)), B = B + x.x + o + n.x - (h && w ? h * l * (s ? -1 : 1) : 0), C = C + _ - (h && !w ? h * l * (s ? 1 : -1) : 0), t && (b = c / (p || 1) % t, i.opposite && (b = t - b - 1), C += i.labelOffset / t * b), A.x = B, A.y = Math.round(C), M(this, "afterGetLabelPosition", { pos: A, tickmarkOffset: h, index: c }), A;
          }, O.prototype.getLabelSize = function() {
            return this.label ? this.label.getBBox()[this.axis.horiz ? "height" : "width"] : 0;
          }, O.prototype.getMarkPath = function(B, C, b, w, x, h) {
            return h.crispLine([["M", B, C], ["L", B + (x ? 0 : -b), C + (x ? b : 0)]], w);
          }, O.prototype.handleOverflow = function(B) {
            var C = this.axis, b = C.options.labels, w = B.x, x = C.chart.chartWidth, h = C.chart.spacing, c = P(C.labelLeft, Math.min(C.pos, h[3]));
            h = P(C.labelRight, Math.max(C.isRadial ? 0 : C.pos + C.len, x - h[1]));
            var p = this.label, i = this.rotation, l = { left: 0, center: 0.5, right: 1 }[C.labelAlign || p.attr("align")], s = p.getBBox().width, t = C.getSlotWidth(this), n = {}, o = t, A = 1, _;
            i || b.overflow !== "justify" ? 0 > i && w - l * s < c ? _ = Math.round(w / Math.cos(i * Z) - c) : 0 < i && w + l * s > h && (_ = Math.round((x - w) / Math.cos(i * Z))) : (x = w + (1 - l) * s, w - l * s < c ? o = B.x + o * (1 - l) - c : x > h && (o = h - B.x + o * l, A = -1), o = Math.min(t, o), o < t && C.labelAlign === "center" && (B.x += A * (t - o - l * (t - Math.min(s, o)))), (s > o || C.autoRotation && (p.styles || {}).width) && (_ = o)), _ && (this.shortenLabel ? this.shortenLabel() : (n.width = Math.floor(_) + "px", (b.style || {}).textOverflow || (n.textOverflow = "ellipsis"), p.css(n)));
          }, O.prototype.moveLabel = function(B, C) {
            var b = this, w = b.label, x = b.axis, h = x.reversed, c = !1;
            if (w && w.textStr === B ? (b.movedLabel = w, c = !0, delete b.label) : d(x.ticks, function(i) {
              c || i.isNew || i === b || !i.label || i.label.textStr !== B || (b.movedLabel = i.label, c = !0, i.labelPos = b.movedLabel.xy, delete i.label);
            }), !c && (b.labelPos || w)) {
              var p = b.labelPos || w.xy;
              w = x.horiz ? h ? 0 : x.width + x.left : p.x, x = x.horiz ? p.y : h ? x.width + x.left : 0, b.movedLabel = b.createLabel({ x: w, y: x }, B, C), b.movedLabel && b.movedLabel.attr({ opacity: 0 });
            }
          }, O.prototype.render = function(B, C, b) {
            var w = this.axis, x = w.horiz, h = this.pos, c = P(this.tickmarkOffset, w.tickmarkOffset);
            h = this.getPosition(x, h, c, C), c = h.x;
            var p = h.y;
            w = x && c === w.pos + w.len || !x && p === w.pos ? -1 : 1, x = P(b, this.label && this.label.newOpacity, 1), b = P(b, 1), this.isActive = !0, this.renderGridLine(C, b, w), this.renderMark(h, b, w), this.renderLabel(h, C, x, B), this.isNew = !1, M(this, "afterRender");
          }, O.prototype.renderGridLine = function(B, C, b) {
            var w = this.axis, x = w.options, h = {}, c = this.pos, p = this.type, i = P(
              this.tickmarkOffset,
              w.tickmarkOffset
            ), l = w.chart.renderer, s = this.gridLine, t = x.gridLineWidth, n = x.gridLineColor, o = x.gridLineDashStyle;
            this.type === "minor" && (t = x.minorGridLineWidth, n = x.minorGridLineColor, o = x.minorGridLineDashStyle), s || (w.chart.styledMode || (h.stroke = n, h["stroke-width"] = t || 0, h.dashstyle = o), p || (h.zIndex = 1), B && (C = 0), this.gridLine = s = l.path().attr(h).addClass("highcharts-" + (p ? p + "-" : "") + "grid-line").add(w.gridGroup)), s && (b = w.getPlotLinePath({ value: c + i, lineWidth: s.strokeWidth() * b, force: "pass", old: B })) && s[B || this.isNew ? "attr" : "animate"]({ d: b, opacity: C });
          }, O.prototype.renderMark = function(B, C, b) {
            var w = this.axis, x = w.options, h = w.chart.renderer, c = this.type, p = w.tickSize(c ? c + "Tick" : "tick"), i = B.x;
            B = B.y;
            var l = P(x[c !== "minor" ? "tickWidth" : "minorTickWidth"], !c && w.isXAxis ? 1 : 0);
            x = x[c !== "minor" ? "tickColor" : "minorTickColor"];
            var s = this.mark, t = !s;
            p && (w.opposite && (p[0] = -p[0]), s || (this.mark = s = h.path().addClass("highcharts-" + (c ? c + "-" : "") + "tick").add(w.axisGroup), w.chart.styledMode || s.attr({ stroke: x, "stroke-width": l })), s[t ? "attr" : "animate"]({ d: this.getMarkPath(
              i,
              B,
              p[0],
              s.strokeWidth() * b,
              w.horiz,
              h
            ), opacity: C }));
          }, O.prototype.renderLabel = function(B, C, b, w) {
            var x = this.axis, h = x.horiz, c = x.options, p = this.label, i = c.labels, l = i.step;
            x = P(this.tickmarkOffset, x.tickmarkOffset);
            var s = B.x;
            B = B.y;
            var t = !0;
            p && v(s) && (p.xy = B = this.getLabelPosition(s, B, p, h, i, x, w, l), this.isFirst && !this.isLast && !c.showFirstLabel || this.isLast && !this.isFirst && !c.showLastLabel ? t = !1 : !h || i.step || i.rotation || C || b === 0 || this.handleOverflow(B), l && w % l && (t = !1), t && v(B.y) ? (B.opacity = b, p[this.isNewLabel ? "attr" : "animate"](B), this.isNewLabel = !1) : (p.attr("y", -9999), this.isNewLabel = !0));
          }, O.prototype.replaceMovedLabel = function() {
            var B = this.label, C = this.axis, b = C.reversed;
            if (B && !this.isNew) {
              var w = C.horiz ? b ? C.left : C.width + C.left : B.xy.x;
              b = C.horiz ? B.xy.y : b ? C.width + C.top : C.top, B.animate({ x: w, y: b, opacity: 0 }, void 0, B.destroy), delete this.label;
            }
            C.isDirty = !0, this.label = this.movedLabel, delete this.movedLabel;
          }, O;
        }(), R;
      }
    ), E(a, "Core/Axis/Axis.js", [
      a["Core/Animation/AnimationUtilities.js"],
      a["Core/Axis/AxisDefaults.js"],
      a["Core/Color/Color.js"],
      a["Core/DefaultOptions.js"],
      a["Core/Foundation.js"],
      a["Core/Globals.js"],
      a["Core/Axis/Tick.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I, Z, H, $, U, W) {
      var N = y.animObject, M = Z.defaultOptions, v = H.registerEventOptions, u = $.deg2rad, d = W.arrayMax, P = W.arrayMin, O = W.clamp, B = W.correctFloat, C = W.defined, b = W.destroyObjectProperties, w = W.erase, x = W.error, h = W.extend, c = W.fireEvent, p = W.getMagnitude, i = W.isArray, l = W.isNumber, s = W.isString, t = W.merge, n = W.normalizeTickInterval, o = W.objectEach, A = W.pick, _ = W.relativeLength, D = W.removeEvent, j = W.splat, T = W.syncTimeout;
      return y = function() {
        function X(f, m) {
          this.zoomEnabled = this.width = this.visible = this.userOptions = this.translationSlope = this.transB = this.transA = this.top = this.ticks = this.tickRotCorr = this.tickPositions = this.tickmarkOffset = this.tickInterval = this.tickAmount = this.side = this.series = this.right = this.positiveValuesOnly = this.pos = this.pointRangePadding = this.pointRange = this.plotLinesAndBandsGroups = this.plotLinesAndBands = this.paddedTicks = this.overlap = this.options = this.offset = this.names = this.minPixelPadding = this.minorTicks = this.minorTickInterval = this.min = this.maxLabelLength = this.max = this.len = this.left = this.labelFormatter = this.labelEdge = this.isLinked = this.height = this.hasVisibleSeries = this.hasNames = this.eventOptions = this.coll = this.closestPointRange = this.chart = this.categories = this.bottom = this.alternateBands = void 0, this.init(f, m);
        }
        return X.prototype.init = function(f, m) {
          var L = m.isX;
          this.chart = f, this.horiz = f.inverted && !this.isZAxis ? !L : L, this.isXAxis = L, this.coll = this.coll || (L ? "xAxis" : "yAxis"), c(this, "init", { userOptions: m }), this.opposite = A(m.opposite, this.opposite), this.side = A(m.side, this.side, this.horiz ? this.opposite ? 0 : 2 : this.opposite ? 1 : 3), this.setOptions(m);
          var Y = this.options, F = Y.labels, Q = Y.type;
          this.userOptions = m, this.minPixelPadding = 0, this.reversed = A(Y.reversed, this.reversed), this.visible = Y.visible, this.zoomEnabled = Y.zoomEnabled, this.hasNames = Q === "category" || Y.categories === !0, this.categories = Y.categories || this.hasNames, this.names || (this.names = [], this.names.keys = {}), this.plotLinesAndBandsGroups = {}, this.positiveValuesOnly = !!this.logarithmic, this.isLinked = C(Y.linkedTo), this.ticks = {}, this.labelEdge = [], this.minorTicks = {}, this.plotLinesAndBands = [], this.alternateBands = {}, this.len = 0, this.minRange = this.userMinRange = Y.minRange || Y.maxZoom, this.range = Y.range, this.offset = Y.offset || 0, this.min = this.max = null, m = A(Y.crosshair, j(f.options.tooltip.crosshairs)[L ? 0 : 1]), this.crosshair = m === !0 ? {} : m, f.axes.indexOf(this) === -1 && (L ? f.axes.splice(f.xAxis.length, 0, this) : f.axes.push(this), f[this.coll].push(this)), this.series = this.series || [], f.inverted && !this.isZAxis && L && typeof this.reversed > "u" && (this.reversed = !0), this.labelRotation = l(F.rotation) ? F.rotation : void 0, v(this, Y), c(this, "afterInit");
        }, X.prototype.setOptions = function(f) {
          this.options = t(R.defaultXAxisOptions, this.coll === "yAxis" && R.defaultYAxisOptions, [R.defaultTopAxisOptions, R.defaultRightAxisOptions, R.defaultBottomAxisOptions, R.defaultLeftAxisOptions][this.side], t(M[this.coll], f)), c(this, "afterSetOptions", { userOptions: f });
        }, X.prototype.defaultLabelFormatter = function(f) {
          var m = this.axis;
          f = this.chart.numberFormatter;
          var L = l(this.value) ? this.value : NaN, Y = m.chart.time, F = this.dateTimeLabelFormat, Q = M.lang, k = Q.numericSymbols;
          Q = Q.numericSymbolMagnitude || 1e3;
          var G = m.logarithmic ? Math.abs(L) : m.tickInterval, z = k && k.length;
          if (m.categories)
            var V = "" + this.value;
          else if (F)
            V = Y.dateFormat(F, L);
          else if (z && 1e3 <= G)
            for (; z-- && typeof V > "u"; )
              m = Math.pow(Q, z + 1), G >= m && 10 * L % m === 0 && k[z] !== null && L !== 0 && (V = f(L / m, -1) + k[z]);
          return typeof V > "u" && (V = 1e4 <= Math.abs(L) ? f(L, -1) : f(L, -1, void 0, "")), V;
        }, X.prototype.getSeriesExtremes = function() {
          var f = this, m = f.chart, L;
          c(this, "getSeriesExtremes", null, function() {
            f.hasVisibleSeries = !1, f.dataMin = f.dataMax = f.threshold = null, f.softThreshold = !f.isXAxis, f.stacking && f.stacking.buildStacks(), f.series.forEach(function(Y) {
              if (Y.visible || !m.options.chart.ignoreHiddenSeries) {
                var F = Y.options, Q = F.threshold;
                if (f.hasVisibleSeries = !0, f.positiveValuesOnly && 0 >= Q && (Q = null), f.isXAxis) {
                  if (F = Y.xData, F.length) {
                    F = f.logarithmic ? F.filter(f.validatePositiveValue) : F, L = Y.getXExtremes(F);
                    var k = L.min, G = L.max;
                    l(k) || k instanceof Date || (F = F.filter(l), L = Y.getXExtremes(F), k = L.min, G = L.max), F.length && (f.dataMin = Math.min(A(f.dataMin, k), k), f.dataMax = Math.max(A(f.dataMax, G), G));
                  }
                } else
                  Y = Y.applyExtremes(), l(Y.dataMin) && (k = Y.dataMin, f.dataMin = Math.min(A(f.dataMin, k), k)), l(Y.dataMax) && (G = Y.dataMax, f.dataMax = Math.max(A(f.dataMax, G), G)), C(Q) && (f.threshold = Q), (!F.softThreshold || f.positiveValuesOnly) && (f.softThreshold = !1);
              }
            });
          }), c(this, "afterGetSeriesExtremes");
        }, X.prototype.translate = function(f, m, L, Y, F, Q) {
          var k = this.linkedParent || this, G = Y && k.old ? k.old.min : k.min, z = k.minPixelPadding;
          F = (k.isOrdinal || k.brokenAxis && k.brokenAxis.hasBreaks || k.logarithmic && F) && k.lin2val;
          var V = 1, q = 0;
          return Y = Y && k.old ? k.old.transA : k.transA, Y || (Y = k.transA), L && (V *= -1, q = k.len), k.reversed && (V *= -1, q -= V * (k.sector || k.len)), m ? (f = (f * V + q - z) / Y + G, F && (f = k.lin2val(f))) : (F && (f = k.val2lin(f)), f = l(G) ? V * (f - G) * Y + q + V * z + (l(Q) ? Y * Q : 0) : void 0), f;
        }, X.prototype.toPixels = function(f, m) {
          return this.translate(
            f,
            !1,
            !this.horiz,
            null,
            !0
          ) + (m ? 0 : this.pos);
        }, X.prototype.toValue = function(f, m) {
          return this.translate(f - (m ? 0 : this.pos), !0, !this.horiz, null, !0);
        }, X.prototype.getPlotLinePath = function(f) {
          function m(at, J, tt) {
            return (nt !== "pass" && at < J || at > tt) && (nt ? at = O(at, J, tt) : lt = !0), at;
          }
          var L = this, Y = L.chart, F = L.left, Q = L.top, k = f.old, G = f.value, z = f.lineWidth, V = k && Y.oldChartHeight || Y.chartHeight, q = k && Y.oldChartWidth || Y.chartWidth, it = L.transB, et = f.translatedValue, nt = f.force, rt, ct, gt, dt, lt;
          return f = {
            value: G,
            lineWidth: z,
            old: k,
            force: nt,
            acrossPanes: f.acrossPanes,
            translatedValue: et
          }, c(this, "getPlotLinePath", f, function(at) {
            et = A(et, L.translate(G, null, null, k)), et = O(et, -1e5, 1e5), rt = gt = Math.round(et + it), ct = dt = Math.round(V - et - it), l(et) ? L.horiz ? (ct = Q, dt = V - L.bottom, rt = gt = m(rt, F, F + L.width)) : (rt = F, gt = q - L.right, ct = dt = m(ct, Q, Q + L.height)) : (lt = !0, nt = !1), at.path = lt && !nt ? null : Y.renderer.crispLine([["M", rt, ct], ["L", gt, dt]], z || 1);
          }), f.path;
        }, X.prototype.getLinearTickPositions = function(f, m, L) {
          var Y = B(Math.floor(m / f) * f);
          L = B(Math.ceil(L / f) * f);
          var F = [], Q;
          if (B(Y + f) === Y && (Q = 20), this.single)
            return [m];
          for (m = Y; m <= L && (F.push(m), m = B(m + f, Q), m !== k); )
            var k = m;
          return F;
        }, X.prototype.getMinorTickInterval = function() {
          var f = this.options;
          return f.minorTicks === !0 ? A(f.minorTickInterval, "auto") : f.minorTicks === !1 ? null : f.minorTickInterval;
        }, X.prototype.getMinorTickPositions = function() {
          var f = this.options, m = this.tickPositions, L = this.minorTickInterval, Y = this.pointRangePadding || 0, F = this.min - Y;
          Y = this.max + Y;
          var Q = Y - F, k = [];
          if (Q && Q / L < this.len / 3) {
            var G = this.logarithmic;
            if (G)
              this.paddedTicks.forEach(function(z, V, q) {
                V && k.push.apply(
                  k,
                  G.getLogTickPositions(L, q[V - 1], q[V], !0)
                );
              });
            else if (this.dateTime && this.getMinorTickInterval() === "auto")
              k = k.concat(this.getTimeTicks(this.dateTime.normalizeTimeTickInterval(L), F, Y, f.startOfWeek));
            else
              for (f = F + (m[0] - F) % L; f <= Y && f !== k[0]; f += L)
                k.push(f);
          }
          return k.length !== 0 && this.trimTicks(k), k;
        }, X.prototype.adjustForMinRange = function() {
          var f = this.options, m = this.logarithmic, L = this.min, Y = this.max, F = 0, Q, k, G, z;
          if (this.isXAxis && typeof this.minRange > "u" && !m && (C(f.min) || C(f.max) || C(f.floor) || C(f.ceiling) ? this.minRange = null : (this.series.forEach(function(et) {
            if (G = et.xData, z = et.xIncrement ? 1 : G.length - 1, 1 < G.length)
              for (Q = z; 0 < Q; Q--)
                k = G[Q] - G[Q - 1], (!F || k < F) && (F = k);
          }), this.minRange = Math.min(5 * F, this.dataMax - this.dataMin))), Y - L < this.minRange) {
            var V = this.dataMax - this.dataMin >= this.minRange, q = this.minRange, it = (q - Y + L) / 2;
            it = [L - it, A(f.min, L - it)], V && (it[2] = this.logarithmic ? this.logarithmic.log2lin(this.dataMin) : this.dataMin), L = d(it), Y = [L + q, A(f.max, L + q)], V && (Y[2] = m ? m.log2lin(this.dataMax) : this.dataMax), Y = P(Y), Y - L < q && (it[0] = Y - q, it[1] = A(f.min, Y - q), L = d(it));
          }
          this.min = L, this.max = Y;
        }, X.prototype.getClosest = function() {
          var f;
          return this.categories ? f = 1 : this.series.forEach(function(m) {
            var L = m.closestPointRange, Y = m.visible || !m.chart.options.chart.ignoreHiddenSeries;
            !m.noSharedTooltip && C(L) && Y && (f = C(f) ? Math.min(f, L) : L);
          }), f;
        }, X.prototype.nameToX = function(f) {
          var m = i(this.categories), L = m ? this.categories : this.names, Y = f.options.x;
          if (f.series.requireSorting = !1, C(Y) || (Y = this.options.uniqueNames ? m ? L.indexOf(f.name) : A(L.keys[f.name], -1) : f.series.autoIncrement()), Y === -1) {
            if (!m)
              var F = L.length;
          } else
            F = Y;
          return typeof F < "u" && (this.names[F] = f.name, this.names.keys[f.name] = F), F;
        }, X.prototype.updateNames = function() {
          var f = this, m = this.names;
          0 < m.length && (Object.keys(m.keys).forEach(function(L) {
            delete m.keys[L];
          }), m.length = 0, this.minRange = this.userMinRange, (this.series || []).forEach(function(L) {
            L.xIncrement = null, (!L.points || L.isDirtyData) && (f.max = Math.max(f.max, L.xData.length - 1), L.processData(), L.generatePoints()), L.data.forEach(function(Y, F) {
              if (Y && Y.options && typeof Y.name < "u") {
                var Q = f.nameToX(Y);
                typeof Q < "u" && Q !== Y.x && (Y.x = Q, L.xData[F] = Q);
              }
            });
          }));
        }, X.prototype.setAxisTranslation = function() {
          var f = this, m = f.max - f.min, L = f.linkedParent, Y = !!f.categories, F = f.isXAxis, Q = f.axisPointRange || 0, k = 0, G = 0, z = f.transA;
          if (F || Y || Q) {
            var V = f.getClosest();
            L ? (k = L.minPointOffset, G = L.pointRangePadding) : f.series.forEach(function(q) {
              var it = Y ? 1 : F ? A(q.options.pointRange, V, 0) : f.axisPointRange || 0, et = q.options.pointPlacement;
              Q = Math.max(Q, it), (!f.single || Y) && (q = q.is("xrange") ? !F : F, k = Math.max(k, q && s(et) ? 0 : it / 2), G = Math.max(G, q && et === "on" ? 0 : it));
            }), L = f.ordinal && f.ordinal.slope && V ? f.ordinal.slope / V : 1, f.minPointOffset = k *= L, f.pointRangePadding = G *= L, f.pointRange = Math.min(Q, f.single && Y ? 1 : m), F && (f.closestPointRange = V);
          }
          f.translationSlope = f.transA = z = f.staticScale || f.len / (m + G || 1), f.transB = f.horiz ? f.left : f.bottom, f.minPixelPadding = z * k, c(this, "afterSetAxisTranslation");
        }, X.prototype.minFromRange = function() {
          return this.max - this.range;
        }, X.prototype.setTickInterval = function(f) {
          var m = this.chart, L = this.logarithmic, Y = this.options, F = this.isXAxis, Q = this.isLinked, k = Y.tickPixelInterval, G = this.categories, z = this.softThreshold, V = Y.maxPadding, q = Y.minPadding, it = l(Y.tickInterval) && 0 <= Y.tickInterval ? Y.tickInterval : void 0, et = l(this.threshold) ? this.threshold : null;
          this.dateTime || G || Q || this.getTickAmount();
          var nt = A(this.userMin, Y.min), rt = A(this.userMax, Y.max);
          if (Q) {
            this.linkedParent = m[this.coll][Y.linkedTo];
            var ct = this.linkedParent.getExtremes();
            this.min = A(ct.min, ct.dataMin), this.max = A(ct.max, ct.dataMax), Y.type !== this.linkedParent.options.type && x(11, 1, m);
          } else {
            if (z && C(et)) {
              if (this.dataMin >= et)
                ct = et, q = 0;
              else if (this.dataMax <= et) {
                var gt = et;
                V = 0;
              }
            }
            this.min = A(nt, ct, this.dataMin), this.max = A(rt, gt, this.dataMax);
          }
          if (L && (this.positiveValuesOnly && !f && 0 >= Math.min(this.min, A(this.dataMin, this.min)) && x(10, 1, m), this.min = B(L.log2lin(this.min), 16), this.max = B(L.log2lin(this.max), 16)), this.range && C(this.max) && (this.userMin = this.min = nt = Math.max(this.dataMin, this.minFromRange()), this.userMax = rt = this.max, this.range = null), c(this, "foundExtremes"), this.beforePadding && this.beforePadding(), this.adjustForMinRange(), !(G || this.axisPointRange || this.stacking && this.stacking.usePercentage || Q) && C(this.min) && C(this.max) && (m = this.max - this.min) && (!C(nt) && q && (this.min -= m * q), !C(rt) && V && (this.max += m * V)), l(this.userMin) || (l(Y.softMin) && Y.softMin < this.min && (this.min = nt = Y.softMin), l(Y.floor) && (this.min = Math.max(this.min, Y.floor))), l(this.userMax) || (l(Y.softMax) && Y.softMax > this.max && (this.max = rt = Y.softMax), l(Y.ceiling) && (this.max = Math.min(this.max, Y.ceiling))), z && C(this.dataMin) && (et = et || 0, !C(nt) && this.min < et && this.dataMin >= et ? this.min = this.options.minRange ? Math.min(et, this.max - this.minRange) : et : !C(rt) && this.max > et && this.dataMax <= et && (this.max = this.options.minRange ? Math.max(et, this.min + this.minRange) : et)), l(this.min) && l(this.max) && !this.chart.polar && this.min > this.max && (C(this.options.min) ? this.max = this.min : C(this.options.max) && (this.min = this.max)), this.tickInterval = this.min === this.max || typeof this.min > "u" || typeof this.max > "u" ? 1 : Q && this.linkedParent && !it && k === this.linkedParent.options.tickPixelInterval ? it = this.linkedParent.tickInterval : A(it, this.tickAmount ? (this.max - this.min) / Math.max(this.tickAmount - 1, 1) : void 0, G ? 1 : (this.max - this.min) * k / Math.max(this.len, k)), F && !f) {
            var dt = this.min !== (this.old && this.old.min) || this.max !== (this.old && this.old.max);
            this.series.forEach(function(lt) {
              lt.forceCrop = lt.forceCropping && lt.forceCropping(), lt.processData(dt);
            }), c(this, "postProcessData", { hasExtemesChanged: dt });
          }
          this.setAxisTranslation(), c(this, "initialAxisTranslation"), this.pointRange && !it && (this.tickInterval = Math.max(this.pointRange, this.tickInterval)), f = A(Y.minTickInterval, this.dateTime && !this.series.some(function(lt) {
            return lt.noSharedTooltip;
          }) ? this.closestPointRange : 0), !it && this.tickInterval < f && (this.tickInterval = f), this.dateTime || this.logarithmic || it || (this.tickInterval = n(this.tickInterval, void 0, p(this.tickInterval), A(Y.allowDecimals, 0.5 > this.tickInterval || this.tickAmount !== void 0), !!this.tickAmount)), this.tickAmount || (this.tickInterval = this.unsquish()), this.setTickPositions();
        }, X.prototype.setTickPositions = function() {
          var f = this.options, m = f.tickPositions, L = this.getMinorTickInterval(), Y = this.hasVerticalPanning(), F = this.coll === "colorAxis", Q = (F || !Y) && f.startOnTick;
          Y = (F || !Y) && f.endOnTick, F = f.tickPositioner, this.tickmarkOffset = this.categories && f.tickmarkPlacement === "between" && this.tickInterval === 1 ? 0.5 : 0, this.minorTickInterval = L === "auto" && this.tickInterval ? this.tickInterval / 5 : L, this.single = this.min === this.max && C(this.min) && !this.tickAmount && (parseInt(this.min, 10) === this.min || f.allowDecimals !== !1), this.tickPositions = L = m && m.slice(), !L && (this.ordinal && this.ordinal.positions || !((this.max - this.min) / this.tickInterval > Math.max(2 * this.len, 200)) ? L = this.dateTime ? this.getTimeTicks(this.dateTime.normalizeTimeTickInterval(this.tickInterval, f.units), this.min, this.max, f.startOfWeek, this.ordinal && this.ordinal.positions, this.closestPointRange, !0) : this.logarithmic ? this.logarithmic.getLogTickPositions(this.tickInterval, this.min, this.max) : this.getLinearTickPositions(
            this.tickInterval,
            this.min,
            this.max
          ) : (L = [this.min, this.max], x(19, !1, this.chart)), L.length > this.len && (L = [L[0], L.pop()], L[0] === L[1] && (L.length = 1)), this.tickPositions = L, F && (F = F.apply(this, [this.min, this.max]))) && (this.tickPositions = L = F), this.paddedTicks = L.slice(0), this.trimTicks(L, Q, Y), this.isLinked || (this.single && 2 > L.length && !this.categories && !this.series.some(function(k) {
            return k.is("heatmap") && k.options.pointPlacement === "between";
          }) && (this.min -= 0.5, this.max += 0.5), m || F || this.adjustTickAmount()), c(this, "afterSetTickPositions");
        }, X.prototype.trimTicks = function(f, m, L) {
          var Y = f[0], F = f[f.length - 1], Q = !this.isOrdinal && this.minPointOffset || 0;
          if (c(this, "trimTicks"), !this.isLinked) {
            if (m && Y !== -1 / 0)
              this.min = Y;
            else
              for (; this.min - Q > f[0]; )
                f.shift();
            if (L)
              this.max = F;
            else
              for (; this.max + Q < f[f.length - 1]; )
                f.pop();
            f.length === 0 && C(Y) && !this.options.tickPositions && f.push((F + Y) / 2);
          }
        }, X.prototype.alignToOthers = function() {
          var f = {}, m = this.options, L;
          return this.chart.options.chart.alignTicks !== !1 && m.alignTicks && m.startOnTick !== !1 && m.endOnTick !== !1 && !this.logarithmic && this.chart[this.coll].forEach(function(Y) {
            var F = Y.options;
            F = [Y.horiz ? F.left : F.top, F.width, F.height, F.pane].join(), Y.series.length && (f[F] ? L = !0 : f[F] = 1);
          }), L;
        }, X.prototype.getTickAmount = function() {
          var f = this.options, m = f.tickPixelInterval, L = f.tickAmount;
          !C(f.tickInterval) && !L && this.len < m && !this.isRadial && !this.logarithmic && f.startOnTick && f.endOnTick && (L = 2), !L && this.alignToOthers() && (L = Math.ceil(this.len / m) + 1), 4 > L && (this.finalTickAmt = L, L = 5), this.tickAmount = L;
        }, X.prototype.adjustTickAmount = function() {
          var f = this.options, m = this.tickInterval, L = this.tickPositions, Y = this.tickAmount, F = this.finalTickAmt, Q = L && L.length, k = A(this.threshold, this.softThreshold ? 0 : null);
          if (this.hasData() && l(this.min) && l(this.max)) {
            if (Q < Y) {
              for (; L.length < Y; )
                L.length % 2 || this.min === k ? L.push(B(L[L.length - 1] + m)) : L.unshift(B(L[0] - m));
              this.transA *= (Q - 1) / (Y - 1), this.min = f.startOnTick ? L[0] : Math.min(this.min, L[0]), this.max = f.endOnTick ? L[L.length - 1] : Math.max(this.max, L[L.length - 1]);
            } else
              Q > Y && (this.tickInterval *= 2, this.setTickPositions());
            if (C(F)) {
              for (m = f = L.length; m--; )
                (F === 3 && m % 2 === 1 || 2 >= F && 0 < m && m < f - 1) && L.splice(m, 1);
              this.finalTickAmt = void 0;
            }
          }
        }, X.prototype.setScale = function() {
          var f = !1, m = !1;
          this.series.forEach(function(Y) {
            f = f || Y.isDirtyData || Y.isDirty, m = m || Y.xAxis && Y.xAxis.isDirty || !1;
          }), this.setAxisSize();
          var L = this.len !== (this.old && this.old.len);
          L || f || m || this.isLinked || this.forceRedraw || this.userMin !== (this.old && this.old.userMin) || this.userMax !== (this.old && this.old.userMax) || this.alignToOthers() ? (this.stacking && this.stacking.resetStacks(), this.forceRedraw = !1, this.getSeriesExtremes(), this.setTickInterval(), this.isDirty || (this.isDirty = L || this.min !== (this.old && this.old.min) || this.max !== (this.old && this.old.max))) : this.stacking && this.stacking.cleanStacks(), f && this.panningState && (this.panningState.isDirty = !0), c(this, "afterSetScale");
        }, X.prototype.setExtremes = function(f, m, L, Y, F) {
          var Q = this, k = Q.chart;
          L = A(L, !0), Q.series.forEach(function(G) {
            delete G.kdTree;
          }), F = h(F, { min: f, max: m }), c(Q, "setExtremes", F, function() {
            Q.userMin = f, Q.userMax = m, Q.eventArgs = F, L && k.redraw(Y);
          });
        }, X.prototype.zoom = function(f, m) {
          var L = this, Y = this.dataMin, F = this.dataMax, Q = this.options, k = Math.min(Y, A(Q.min, Y)), G = Math.max(F, A(Q.max, F));
          return f = { newMin: f, newMax: m }, c(this, "zoom", f, function(z) {
            var V = z.newMin, q = z.newMax;
            (V !== L.min || q !== L.max) && (L.allowZoomOutside || (C(Y) && (V < k && (V = k), V > G && (V = G)), C(F) && (q < k && (q = k), q > G && (q = G))), L.displayBtn = typeof V < "u" || typeof q < "u", L.setExtremes(V, q, !1, void 0, { trigger: "zoom" })), z.zoomed = !0;
          }), f.zoomed;
        }, X.prototype.setAxisSize = function() {
          var f = this.chart, m = this.options, L = m.offsets || [0, 0, 0, 0], Y = this.horiz, F = this.width = Math.round(_(A(m.width, f.plotWidth - L[3] + L[1]), f.plotWidth)), Q = this.height = Math.round(_(A(m.height, f.plotHeight - L[0] + L[2]), f.plotHeight)), k = this.top = Math.round(_(A(m.top, f.plotTop + L[0]), f.plotHeight, f.plotTop));
          m = this.left = Math.round(_(A(m.left, f.plotLeft + L[3]), f.plotWidth, f.plotLeft)), this.bottom = f.chartHeight - Q - k, this.right = f.chartWidth - F - m, this.len = Math.max(Y ? F : Q, 0), this.pos = Y ? m : k;
        }, X.prototype.getExtremes = function() {
          var f = this.logarithmic;
          return { min: f ? B(f.lin2log(this.min)) : this.min, max: f ? B(f.lin2log(this.max)) : this.max, dataMin: this.dataMin, dataMax: this.dataMax, userMin: this.userMin, userMax: this.userMax };
        }, X.prototype.getThreshold = function(f) {
          var m = this.logarithmic, L = m ? m.lin2log(this.min) : this.min;
          return m = m ? m.lin2log(this.max) : this.max, f === null || f === -1 / 0 ? f = L : f === 1 / 0 ? f = m : L > f ? f = L : m < f && (f = m), this.translate(f, 0, 1, 0, 1);
        }, X.prototype.autoLabelAlign = function(f) {
          var m = (A(f, 0) - 90 * this.side + 720) % 360;
          return f = { align: "center" }, c(
            this,
            "autoLabelAlign",
            f,
            function(L) {
              15 < m && 165 > m ? L.align = "right" : 195 < m && 345 > m && (L.align = "left");
            }
          ), f.align;
        }, X.prototype.tickSize = function(f) {
          var m = this.options, L = A(m[f === "tick" ? "tickWidth" : "minorTickWidth"], f === "tick" && this.isXAxis && !this.categories ? 1 : 0), Y = m[f === "tick" ? "tickLength" : "minorTickLength"];
          if (L && Y) {
            m[f + "Position"] === "inside" && (Y = -Y);
            var F = [Y, L];
          }
          return f = { tickSize: F }, c(this, "afterTickSize", f), f.tickSize;
        }, X.prototype.labelMetrics = function() {
          var f = this.tickPositions && this.tickPositions[0] || 0;
          return this.chart.renderer.fontMetrics(
            this.options.labels.style.fontSize,
            this.ticks[f] && this.ticks[f].label
          );
        }, X.prototype.unsquish = function() {
          var f = this.options.labels, m = this.horiz, L = this.tickInterval, Y = this.len / (((this.categories ? 1 : 0) + this.max - this.min) / L), F = f.rotation, Q = this.labelMetrics(), k = Math.max(this.max - this.min, 0), G = function(nt) {
            var rt = nt / (Y || 1);
            return rt = 1 < rt ? Math.ceil(rt) : 1, rt * L > k && nt !== 1 / 0 && Y !== 1 / 0 && k && (rt = Math.ceil(k / L)), B(rt * L);
          }, z = L, V, q, it = Number.MAX_VALUE;
          if (m) {
            if (!f.staggerLines && !f.step)
              if (l(F))
                var et = [F];
              else
                Y < f.autoRotationLimit && (et = f.autoRotation);
            et && et.forEach(function(nt) {
              if (nt === F || nt && -90 <= nt && 90 >= nt) {
                q = G(Math.abs(Q.h / Math.sin(u * nt)));
                var rt = q + Math.abs(nt / 360);
                rt < it && (it = rt, V = nt, z = q);
              }
            });
          } else
            f.step || (z = G(Q.h));
          return this.autoRotation = et, this.labelRotation = A(V, l(F) ? F : 0), z;
        }, X.prototype.getSlotWidth = function(f) {
          var m = this.chart, L = this.horiz, Y = this.options.labels, F = Math.max(this.tickPositions.length - (this.categories ? 0 : 1), 1), Q = m.margin[3];
          if (f && l(f.slotWidth))
            return f.slotWidth;
          if (L && 2 > Y.step)
            return Y.rotation ? 0 : (this.staggerLines || 1) * this.len / F;
          if (!L) {
            if (f = Y.style.width, f !== void 0)
              return parseInt(String(f), 10);
            if (Q)
              return Q - m.spacing[3];
          }
          return 0.33 * m.chartWidth;
        }, X.prototype.renderUnsquish = function() {
          var f = this.chart, m = f.renderer, L = this.tickPositions, Y = this.ticks, F = this.options.labels, Q = F.style, k = this.horiz, G = this.getSlotWidth(), z = Math.max(1, Math.round(G - 2 * F.padding)), V = {}, q = this.labelMetrics(), it = Q.textOverflow, et = 0;
          if (s(F.rotation) || (V.rotation = F.rotation || 0), L.forEach(function(gt) {
            gt = Y[gt], gt.movedLabel && gt.replaceMovedLabel(), gt && gt.label && gt.label.textPxLength > et && (et = gt.label.textPxLength);
          }), this.maxLabelLength = et, this.autoRotation)
            et > z && et > q.h ? V.rotation = this.labelRotation : this.labelRotation = 0;
          else if (G) {
            var nt = z;
            if (!it) {
              var rt = "clip";
              for (z = L.length; !k && z--; ) {
                var ct = L[z];
                (ct = Y[ct].label) && (ct.styles && ct.styles.textOverflow === "ellipsis" ? ct.css({ textOverflow: "clip" }) : ct.textPxLength > G && ct.css({ width: G + "px" }), ct.getBBox().height > this.len / L.length - (q.h - q.f) && (ct.specificTextOverflow = "ellipsis"));
              }
            }
          }
          V.rotation && (nt = et > 0.5 * f.chartHeight ? 0.33 * f.chartHeight : et, it || (rt = "ellipsis")), (this.labelAlign = F.align || this.autoLabelAlign(this.labelRotation)) && (V.align = this.labelAlign), L.forEach(function(gt) {
            var dt = (gt = Y[gt]) && gt.label, lt = Q.width, at = {};
            dt && (dt.attr(V), gt.shortenLabel ? gt.shortenLabel() : nt && !lt && Q.whiteSpace !== "nowrap" && (nt < dt.textPxLength || dt.element.tagName === "SPAN") ? (at.width = nt + "px", it || (at.textOverflow = dt.specificTextOverflow || rt), dt.css(at)) : dt.styles && dt.styles.width && !at.width && !lt && dt.css({ width: null }), delete dt.specificTextOverflow, gt.rotation = V.rotation);
          }, this), this.tickRotCorr = m.rotCorr(q.b, this.labelRotation || 0, this.side !== 0);
        }, X.prototype.hasData = function() {
          return this.series.some(function(f) {
            return f.hasData();
          }) || this.options.showEmpty && C(this.min) && C(this.max);
        }, X.prototype.addTitle = function(f) {
          var m = this.chart.renderer, L = this.horiz, Y = this.opposite, F = this.options.title, Q = this.chart.styledMode, k;
          this.axisTitle || ((k = F.textAlign) || (k = (L ? { low: "left", middle: "center", high: "right" } : { low: Y ? "right" : "left", middle: "center", high: Y ? "left" : "right" })[F.align]), this.axisTitle = m.text(F.text || "", 0, 0, F.useHTML).attr({ zIndex: 7, rotation: F.rotation, align: k }).addClass("highcharts-axis-title"), Q || this.axisTitle.css(t(F.style)), this.axisTitle.add(this.axisGroup), this.axisTitle.isNew = !0), Q || F.style.width || this.isRadial || this.axisTitle.css({ width: this.len + "px" }), this.axisTitle[f ? "show" : "hide"](f);
        }, X.prototype.generateTick = function(f) {
          var m = this.ticks;
          m[f] ? m[f].addLabel() : m[f] = new U(this, f);
        }, X.prototype.getOffset = function() {
          var f = this, m = this, L = m.chart, Y = m.horiz, F = m.options, Q = m.side, k = m.ticks, G = m.tickPositions, z = m.coll, V = m.axisParent, q = L.renderer, it = L.inverted && !m.isZAxis ? [1, 0, 3, 2][Q] : Q, et = m.hasData(), nt = F.title, rt = F.labels, ct = L.axisOffset;
          L = L.clipOffset;
          var gt = [
            -1,
            1,
            1,
            -1
          ][Q], dt = F.className, lt, at = 0, J = 0, tt = 0;
          if (m.showAxis = lt = et || F.showEmpty, m.staggerLines = m.horiz && rt.staggerLines || void 0, !m.axisGroup) {
            var st = function(pt, yt, vt) {
              return q.g(pt).attr({ zIndex: vt }).addClass("highcharts-" + z.toLowerCase() + yt + " " + (f.isRadial ? "highcharts-radial-axis" + yt + " " : "") + (dt || "")).add(V);
            };
            m.gridGroup = st("grid", "-grid", F.gridZIndex), m.axisGroup = st("axis", "", F.zIndex), m.labelGroup = st("axis-labels", "-labels", rt.zIndex);
          }
          if (et || m.isLinked ? (G.forEach(function(pt) {
            m.generateTick(pt);
          }), m.renderUnsquish(), m.reserveSpaceDefault = Q === 0 || Q === 2 || { 1: "left", 3: "right" }[Q] === m.labelAlign, A(rt.reserveSpace, m.labelAlign === "center" ? !0 : null, m.reserveSpaceDefault) && G.forEach(function(pt) {
            tt = Math.max(k[pt].getLabelSize(), tt);
          }), m.staggerLines && (tt *= m.staggerLines), m.labelOffset = tt * (m.opposite ? -1 : 1)) : o(k, function(pt, yt) {
            pt.destroy(), delete k[yt];
          }), nt && nt.text && nt.enabled !== !1 && (m.addTitle(lt), lt && nt.reserveSpace !== !1)) {
            m.titleOffset = at = m.axisTitle.getBBox()[Y ? "height" : "width"];
            var ht = nt.offset;
            J = C(ht) ? 0 : A(nt.margin, Y ? 5 : 10);
          }
          m.renderLine(), m.offset = gt * A(
            F.offset,
            ct[Q] ? ct[Q] + (F.margin || 0) : 0
          ), m.tickRotCorr = m.tickRotCorr || { x: 0, y: 0 }, nt = Q === 0 ? -m.labelMetrics().h : Q === 2 ? m.tickRotCorr.y : 0, et = Math.abs(tt) + J, tt && (et = et - nt + gt * (Y ? A(rt.y, m.tickRotCorr.y + 8 * gt) : rt.x)), m.axisTitleMargin = A(ht, et), m.getMaxLabelDimensions && (m.maxLabelDimensions = m.getMaxLabelDimensions(k, G)), z !== "colorAxis" && (Y = this.tickSize("tick"), ct[Q] = Math.max(ct[Q], (m.axisTitleMargin || 0) + at + gt * m.offset, et, G && G.length && Y ? Y[0] + gt * m.offset : 0), F = !m.axisLine || F.offset ? 0 : 2 * Math.floor(m.axisLine.strokeWidth() / 2), L[it] = Math.max(
            L[it],
            F
          )), c(this, "afterGetOffset");
        }, X.prototype.getLinePath = function(f) {
          var m = this.chart, L = this.opposite, Y = this.offset, F = this.horiz, Q = this.left + (L ? this.width : 0) + Y;
          return Y = m.chartHeight - this.bottom - (L ? this.height : 0) + Y, L && (f *= -1), m.renderer.crispLine([["M", F ? this.left : Q, F ? Y : this.top], ["L", F ? m.chartWidth - this.right : Q, F ? Y : m.chartHeight - this.bottom]], f);
        }, X.prototype.renderLine = function() {
          this.axisLine || (this.axisLine = this.chart.renderer.path().addClass("highcharts-axis-line").add(this.axisGroup), this.chart.styledMode || this.axisLine.attr({ stroke: this.options.lineColor, "stroke-width": this.options.lineWidth, zIndex: 7 }));
        }, X.prototype.getTitlePosition = function() {
          var f = this.horiz, m = this.left, L = this.top, Y = this.len, F = this.options.title, Q = f ? m : L, k = this.opposite, G = this.offset, z = F.x, V = F.y, q = this.axisTitle, it = this.chart.renderer.fontMetrics(F.style.fontSize, q);
          return q = Math.max(q.getBBox(null, 0).height - it.h - 1, 0), Y = { low: Q + (f ? 0 : Y), middle: Q + Y / 2, high: Q + (f ? Y : 0) }[F.align], m = (f ? L + this.height : m) + (f ? 1 : -1) * (k ? -1 : 1) * this.axisTitleMargin + [
            -q,
            q,
            it.f,
            -q
          ][this.side], f = { x: f ? Y + z : m + (k ? this.width : 0) + G + z, y: f ? m + V - (k ? this.height : 0) + G : Y + V }, c(this, "afterGetTitlePosition", { titlePosition: f }), f;
        }, X.prototype.renderMinorTick = function(f, m) {
          var L = this.minorTicks;
          L[f] || (L[f] = new U(this, f, "minor")), m && L[f].isNew && L[f].render(null, !0), L[f].render(null, !1, 1);
        }, X.prototype.renderTick = function(f, m, L) {
          var Y = this.ticks;
          (!this.isLinked || f >= this.min && f <= this.max || this.grid && this.grid.isColumn) && (Y[f] || (Y[f] = new U(this, f)), L && Y[f].isNew && Y[f].render(m, !0, -1), Y[f].render(m));
        }, X.prototype.render = function() {
          var f = this, m = f.chart, L = f.logarithmic, Y = f.options, F = f.isLinked, Q = f.tickPositions, k = f.axisTitle, G = f.ticks, z = f.minorTicks, V = f.alternateBands, q = Y.stackLabels, it = Y.alternateGridColor, et = f.tickmarkOffset, nt = f.axisLine, rt = f.showAxis, ct = N(m.renderer.globalAnimation), gt, dt;
          if (f.labelEdge.length = 0, f.overlap = !1, [G, z, V].forEach(function(at) {
            o(at, function(J) {
              J.isActive = !1;
            });
          }), f.hasData() || F) {
            var lt = f.chart.hasRendered && f.old && l(f.old.min);
            f.minorTickInterval && !f.categories && f.getMinorTickPositions().forEach(function(at) {
              f.renderMinorTick(
                at,
                lt
              );
            }), Q.length && (Q.forEach(function(at, J) {
              f.renderTick(at, J, lt);
            }), et && (f.min === 0 || f.single) && (G[-1] || (G[-1] = new U(f, -1, null, !0)), G[-1].render(-1))), it && Q.forEach(function(at, J) {
              dt = typeof Q[J + 1] < "u" ? Q[J + 1] + et : f.max - et, J % 2 === 0 && at < f.max && dt <= f.max + (m.polar ? -et : et) && (V[at] || (V[at] = new $.PlotLineOrBand(f)), gt = at + et, V[at].options = { from: L ? L.lin2log(gt) : gt, to: L ? L.lin2log(dt) : dt, color: it, className: "highcharts-alternate-grid" }, V[at].render(), V[at].isActive = !0);
            }), f._addedPlotLB || (f._addedPlotLB = !0, (Y.plotLines || []).concat(Y.plotBands || []).forEach(function(at) {
              f.addPlotBandOrLine(at);
            }));
          }
          [G, z, V].forEach(function(at) {
            var J = [], tt = ct.duration;
            o(at, function(st, ht) {
              st.isActive || (st.render(ht, !1, 0), st.isActive = !1, J.push(ht));
            }), T(function() {
              for (var st = J.length; st--; )
                at[J[st]] && !at[J[st]].isActive && (at[J[st]].destroy(), delete at[J[st]]);
            }, at !== V && m.hasRendered && tt ? tt : 0);
          }), nt && (nt[nt.isPlaced ? "animate" : "attr"]({ d: this.getLinePath(nt.strokeWidth()) }), nt.isPlaced = !0, nt[rt ? "show" : "hide"](rt)), k && rt && (Y = f.getTitlePosition(), l(Y.y) ? (k[k.isNew ? "attr" : "animate"](Y), k.isNew = !1) : (k.attr(
            "y",
            -9999
          ), k.isNew = !0)), q && q.enabled && f.stacking && f.stacking.renderStackTotals(), f.old = { len: f.len, max: f.max, min: f.min, transA: f.transA, userMax: f.userMax, userMin: f.userMin }, f.isDirty = !1, c(this, "afterRender");
        }, X.prototype.redraw = function() {
          this.visible && (this.render(), this.plotLinesAndBands.forEach(function(f) {
            f.render();
          })), this.series.forEach(function(f) {
            f.isDirty = !0;
          });
        }, X.prototype.getKeepProps = function() {
          return this.keepProps || X.keepProps;
        }, X.prototype.destroy = function(f) {
          var m = this, L = m.plotLinesAndBands, Y = this.eventOptions;
          if (c(this, "destroy", { keepEvents: f }), f || D(m), [m.ticks, m.minorTicks, m.alternateBands].forEach(function(Q) {
            b(Q);
          }), L)
            for (f = L.length; f--; )
              L[f].destroy();
          "axisLine axisTitle axisGroup gridGroup labelGroup cross scrollbar".split(" ").forEach(function(Q) {
            m[Q] && (m[Q] = m[Q].destroy());
          });
          for (var F in m.plotLinesAndBandsGroups)
            m.plotLinesAndBandsGroups[F] = m.plotLinesAndBandsGroups[F].destroy();
          o(m, function(Q, k) {
            m.getKeepProps().indexOf(k) === -1 && delete m[k];
          }), this.eventOptions = Y;
        }, X.prototype.drawCrosshair = function(f, m) {
          var L = this.crosshair, Y = A(L && L.snap, !0), F = this.chart, Q, k = this.cross;
          if (c(this, "drawCrosshair", { e: f, point: m }), f || (f = this.cross && this.cross.e), L && (C(m) || !Y) !== !1) {
            if (Y ? C(m) && (Q = A(this.coll !== "colorAxis" ? m.crosshairPos : null, this.isXAxis ? m.plotX : this.len - m.plotY)) : Q = f && (this.horiz ? f.chartX - this.pos : this.len - f.chartY + this.pos), C(Q)) {
              var G = { value: m && (this.isXAxis ? m.x : A(m.stackY, m.y)), translatedValue: Q };
              F.polar && h(G, { isCrosshair: !0, chartX: f && f.chartX, chartY: f && f.chartY, point: m }), G = this.getPlotLinePath(G) || null;
            }
            if (!C(G)) {
              this.hideCrosshair();
              return;
            }
            Y = this.categories && !this.isRadial, k || (this.cross = k = F.renderer.path().addClass("highcharts-crosshair highcharts-crosshair-" + (Y ? "category " : "thin ") + (L.className || "")).attr({ zIndex: A(L.zIndex, 2) }).add(), F.styledMode || (k.attr({ stroke: L.color || (Y ? I.parse("#ccd6eb").setOpacity(0.25).get() : "#cccccc"), "stroke-width": A(L.width, 1) }).css({ "pointer-events": "none" }), L.dashStyle && k.attr({ dashstyle: L.dashStyle }))), k.show().attr({ d: G }), Y && !L.width && k.attr({ "stroke-width": this.transA }), this.cross.e = f;
          } else
            this.hideCrosshair();
          c(this, "afterDrawCrosshair", { e: f, point: m });
        }, X.prototype.hideCrosshair = function() {
          this.cross && this.cross.hide(), c(this, "afterHideCrosshair");
        }, X.prototype.hasVerticalPanning = function() {
          var f = this.chart.options.chart.panning;
          return !!(f && f.enabled && /y/.test(f.type));
        }, X.prototype.validatePositiveValue = function(f) {
          return l(f) && 0 < f;
        }, X.prototype.update = function(f, m) {
          var L = this.chart;
          f = t(this.userOptions, f), this.destroy(!0), this.init(L, f), L.isDirtyBox = !0, A(m, !0) && L.redraw();
        }, X.prototype.remove = function(f) {
          for (var m = this.chart, L = this.coll, Y = this.series, F = Y.length; F--; )
            Y[F] && Y[F].remove(!1);
          w(m.axes, this), w(m[L], this), m[L].forEach(function(Q, k) {
            Q.options.index = Q.userOptions.index = k;
          }), this.destroy(), m.isDirtyBox = !0, A(f, !0) && m.redraw();
        }, X.prototype.setTitle = function(f, m) {
          this.update({ title: f }, m);
        }, X.prototype.setCategories = function(f, m) {
          this.update({ categories: f }, m);
        }, X.defaultOptions = R.defaultXAxisOptions, X.keepProps = "extKey hcEvents names series userMax userMin".split(" "), X;
      }(), y;
    }), E(a, "Core/Axis/DateTimeAxis.js", [a["Core/Utilities.js"]], function(y) {
      var R = y.addEvent, I = y.getMagnitude, Z = y.normalizeTickInterval, H = y.timeUnits, $;
      return function(U) {
        function W() {
          return this.chart.time.getTimeTicks.apply(this.chart.time, arguments);
        }
        function N(u) {
          u.userOptions.type !== "datetime" ? this.dateTime = void 0 : this.dateTime || (this.dateTime = new v(this));
        }
        var M = [];
        U.compose = function(u) {
          return M.indexOf(u) === -1 && (M.push(u), u.keepProps.push("dateTime"), u.prototype.getTimeTicks = W, R(
            u,
            "init",
            N
          )), u;
        };
        var v = function() {
          function u(d) {
            this.axis = d;
          }
          return u.prototype.normalizeTimeTickInterval = function(d, P) {
            var O = P || [["millisecond", [1, 2, 5, 10, 20, 25, 50, 100, 200, 500]], ["second", [1, 2, 5, 10, 15, 30]], ["minute", [1, 2, 5, 10, 15, 30]], ["hour", [1, 2, 3, 4, 6, 8, 12]], ["day", [1, 2]], ["week", [1, 2]], ["month", [1, 2, 3, 4, 6]], ["year", null]];
            P = O[O.length - 1];
            var B = H[P[0]], C = P[1], b;
            for (b = 0; b < O.length && (P = O[b], B = H[P[0]], C = P[1], !(O[b + 1] && d <= (B * C[C.length - 1] + H[O[b + 1][0]]) / 2)); b++)
              ;
            return B === H.year && d < 5 * B && (C = [1, 2, 5]), d = Z(d / B, C, P[0] === "year" ? Math.max(I(d / B), 1) : 1), { unitRange: B, count: d, unitName: P[0] };
          }, u.prototype.getXDateFormat = function(d, P) {
            var O = this.axis;
            return O.closestPointRange ? O.chart.time.getDateFormat(O.closestPointRange, d, O.options.startOfWeek, P) || P.year : P.day;
          }, u;
        }();
        U.Additions = v;
      }($ || ($ = {})), $;
    }), E(a, "Core/Axis/LogarithmicAxis.js", [a["Core/Utilities.js"]], function(y) {
      var R = y.addEvent, I = y.getMagnitude, Z = y.normalizeTickInterval, H = y.pick, $;
      return function(U) {
        function W(u) {
          var d = this.logarithmic;
          u.userOptions.type !== "logarithmic" ? this.logarithmic = void 0 : d || (this.logarithmic = new v(this));
        }
        function N() {
          var u = this.logarithmic;
          u && (this.lin2val = function(d) {
            return u.lin2log(d);
          }, this.val2lin = function(d) {
            return u.log2lin(d);
          });
        }
        var M = [];
        U.compose = function(u) {
          return M.indexOf(u) === -1 && (M.push(u), u.keepProps.push("logarithmic"), R(u, "init", W), R(u, "afterInit", N)), u;
        };
        var v = function() {
          function u(d) {
            this.axis = d;
          }
          return u.prototype.getLogTickPositions = function(d, P, O, B) {
            var C = this.axis, b = C.len, w = C.options, x = [];
            if (B || (this.minorAutoInterval = void 0), 0.5 <= d)
              d = Math.round(d), x = C.getLinearTickPositions(d, P, O);
            else if (0.08 <= d) {
              var h = Math.floor(P), c, p = w = void 0;
              for (b = 0.3 < d ? [1, 2, 4] : 0.15 < d ? [1, 2, 4, 6, 8] : [1, 2, 3, 4, 5, 6, 7, 8, 9]; h < O + 1 && !p; h++) {
                var i = b.length;
                for (c = 0; c < i && !p; c++) {
                  var l = this.log2lin(this.lin2log(h) * b[c]);
                  l > P && (!B || w <= O) && typeof w < "u" && x.push(w), w > O && (p = !0), w = l;
                }
              }
            } else
              P = this.lin2log(P), O = this.lin2log(O), d = B ? C.getMinorTickInterval() : w.tickInterval, d = H(d === "auto" ? null : d, this.minorAutoInterval, w.tickPixelInterval / (B ? 5 : 1) * (O - P) / ((B ? b / C.tickPositions.length : b) || 1)), d = Z(d, void 0, I(d)), x = C.getLinearTickPositions(d, P, O).map(this.log2lin), B || (this.minorAutoInterval = d / 5);
            return B || (C.tickInterval = d), x;
          }, u.prototype.lin2log = function(d) {
            return Math.pow(10, d);
          }, u.prototype.log2lin = function(d) {
            return Math.log(d) / Math.LN10;
          }, u;
        }();
        U.Additions = v;
      }($ || ($ = {})), $;
    }), E(a, "Core/Axis/PlotLineOrBand/PlotLineOrBandAxis.js", [a["Core/Utilities.js"]], function(y) {
      var R = y.erase, I = y.extend, Z = y.isNumber, H;
      return function($) {
        var U = [], W;
        $.compose = function(M, v) {
          return W || (W = M), U.indexOf(v) === -1 && (U.push(v), I(v.prototype, N.prototype)), v;
        };
        var N = function() {
          function M() {
          }
          return M.prototype.getPlotBandPath = function(v, u, d) {
            d === void 0 && (d = this.options);
            var P = this.getPlotLinePath({ value: u, force: !0, acrossPanes: d.acrossPanes }), O = [], B = this.horiz;
            if (u = !Z(this.min) || !Z(this.max) || v < this.min && u < this.min || v > this.max && u > this.max, v = this.getPlotLinePath({ value: v, force: !0, acrossPanes: d.acrossPanes }), d = 1, v && P) {
              if (u) {
                var C = v.toString() === P.toString();
                d = 0;
              }
              for (u = 0; u < v.length; u += 2) {
                var b = v[u], w = v[u + 1], x = P[u], h = P[u + 1];
                b[0] !== "M" && b[0] !== "L" || w[0] !== "M" && w[0] !== "L" || x[0] !== "M" && x[0] !== "L" || h[0] !== "M" && h[0] !== "L" || (B && x[1] === b[1] ? (x[1] += d, h[1] += d) : B || x[2] !== b[2] || (x[2] += d, h[2] += d), O.push(["M", b[1], b[2]], ["L", w[1], w[2]], ["L", h[1], h[2]], ["L", x[1], x[2]], ["Z"])), O.isFlat = C;
              }
            }
            return O;
          }, M.prototype.addPlotBand = function(v) {
            return this.addPlotBandOrLine(v, "plotBands");
          }, M.prototype.addPlotLine = function(v) {
            return this.addPlotBandOrLine(v, "plotLines");
          }, M.prototype.addPlotBandOrLine = function(v, u) {
            var d = this, P = this.userOptions, O = new W(this, v);
            if (this.visible && (O = O.render()), O) {
              if (this._addedPlotLB || (this._addedPlotLB = !0, (P.plotLines || []).concat(P.plotBands || []).forEach(function(C) {
                d.addPlotBandOrLine(C);
              })), u) {
                var B = P[u] || [];
                B.push(v), P[u] = B;
              }
              this.plotLinesAndBands.push(O);
            }
            return O;
          }, M.prototype.removePlotBandOrLine = function(v) {
            var u = this.plotLinesAndBands, d = this.options, P = this.userOptions;
            if (u) {
              for (var O = u.length; O--; )
                u[O].id === v && u[O].destroy();
              [d.plotLines || [], P.plotLines || [], d.plotBands || [], P.plotBands || []].forEach(function(B) {
                for (O = B.length; O--; )
                  (B[O] || {}).id === v && R(B, B[O]);
              });
            }
          }, M.prototype.removePlotBand = function(v) {
            this.removePlotBandOrLine(v);
          }, M.prototype.removePlotLine = function(v) {
            this.removePlotBandOrLine(v);
          }, M;
        }();
      }(H || (H = {})), H;
    }), E(a, "Core/Axis/PlotLineOrBand/PlotLineOrBand.js", [a["Core/Axis/PlotLineOrBand/PlotLineOrBandAxis.js"], a["Core/Utilities.js"]], function(y, R) {
      var I = R.arrayMax, Z = R.arrayMin, H = R.defined, $ = R.destroyObjectProperties, U = R.erase, W = R.fireEvent, N = R.merge, M = R.objectEach, v = R.pick;
      return R = function() {
        function u(d, P) {
          this.axis = d, P && (this.options = P, this.id = P.id);
        }
        return u.compose = function(d) {
          return y.compose(u, d);
        }, u.prototype.render = function() {
          W(this, "render");
          var d = this, P = d.axis, O = P.horiz, B = P.logarithmic, C = d.options, b = C.color, w = v(C.zIndex, 0), x = C.events, h = {}, c = P.chart.renderer, p = C.label, i = d.label, l = C.to, s = C.from, t = C.value, n = d.svgElem, o = [], A = H(s) && H(l);
          o = H(t);
          var _ = !n, D = { class: "highcharts-plot-" + (A ? "band " : "line ") + (C.className || "") }, j = A ? "bands" : "lines";
          if (B && (s = B.log2lin(s), l = B.log2lin(l), t = B.log2lin(t)), P.chart.styledMode || (o ? (D.stroke = b || "#999999", D["stroke-width"] = v(C.width, 1), C.dashStyle && (D.dashstyle = C.dashStyle)) : A && (D.fill = b || "#e6ebf5", C.borderWidth && (D.stroke = C.borderColor, D["stroke-width"] = C.borderWidth))), h.zIndex = w, j += "-" + w, (B = P.plotLinesAndBandsGroups[j]) || (P.plotLinesAndBandsGroups[j] = B = c.g("plot-" + j).attr(h).add()), _ && (d.svgElem = n = c.path().attr(D).add(B)), o)
            o = P.getPlotLinePath({ value: t, lineWidth: n.strokeWidth(), acrossPanes: C.acrossPanes });
          else if (A)
            o = P.getPlotBandPath(
              s,
              l,
              C
            );
          else
            return;
          return !d.eventsAdded && x && (M(x, function(T, X) {
            n.on(X, function(f) {
              x[X].apply(d, [f]);
            });
          }), d.eventsAdded = !0), (_ || !n.d) && o && o.length ? n.attr({ d: o }) : n && (o ? (n.show(!0), n.animate({ d: o })) : n.d && (n.hide(), i && (d.label = i = i.destroy()))), p && (H(p.text) || H(p.formatter)) && o && o.length && 0 < P.width && 0 < P.height && !o.isFlat ? (p = N({ align: O && A && "center", x: O ? !A && 4 : 10, verticalAlign: !O && A && "middle", y: O ? A ? 16 : 10 : A ? 6 : -4, rotation: O && !A && 90 }, p), this.renderLabel(p, o, A, w)) : i && i.hide(), d;
        }, u.prototype.renderLabel = function(d, P, O, B) {
          var C = this.axis, b = C.chart.renderer, w = this.label;
          w || (this.label = w = b.text(this.getLabelText(d), 0, 0, d.useHTML).attr({ align: d.textAlign || d.align, rotation: d.rotation, class: "highcharts-plot-" + (O ? "band" : "line") + "-label " + (d.className || ""), zIndex: B }).add(), C.chart.styledMode || w.css(N({ textOverflow: "ellipsis" }, d.style))), B = P.xBounds || [P[0][1], P[1][1], O ? P[2][1] : P[0][1]], P = P.yBounds || [P[0][2], P[1][2], O ? P[2][2] : P[0][2]], O = Z(B), b = Z(P), w.align(d, !1, { x: O, y: b, width: I(B) - O, height: I(P) - b }), w.alignValue && w.alignValue !== "left" || w.css({ width: (w.rotation === 90 ? C.height - (w.alignAttr.y - C.top) : C.width - (w.alignAttr.x - C.left)) + "px" }), w.show(!0);
        }, u.prototype.getLabelText = function(d) {
          return H(d.formatter) ? d.formatter.call(this) : d.text;
        }, u.prototype.destroy = function() {
          U(this.axis.plotLinesAndBands, this), delete this.axis, $(this);
        }, u;
      }(), R;
    }), E(
      a,
      "Core/Tooltip.js",
      [a["Core/FormatUtilities.js"], a["Core/Globals.js"], a["Core/Renderer/RendererUtilities.js"], a["Core/Renderer/RendererRegistry.js"], a["Core/Utilities.js"]],
      function(y, R, I, Z, H) {
        var $ = y.format, U = R.doc, W = I.distribute, N = H.addEvent, M = H.clamp, v = H.css, u = H.defined, d = H.discardElement, P = H.extend, O = H.fireEvent, B = H.isArray, C = H.isNumber, b = H.isString, w = H.merge, x = H.pick, h = H.splat, c = H.syncTimeout;
        return y = function() {
          function p(i, l) {
            this.allowShared = !0, this.container = void 0, this.crosshairs = [], this.distance = 0, this.isHidden = !0, this.isSticky = !1, this.now = {}, this.options = {}, this.outside = !1, this.chart = i, this.init(i, l);
          }
          return p.prototype.applyFilter = function() {
            var i = this.chart;
            i.renderer.definition({
              tagName: "filter",
              attributes: { id: "drop-shadow-" + i.index, opacity: 0.5 },
              children: [{ tagName: "feGaussianBlur", attributes: { in: "SourceAlpha", stdDeviation: 1 } }, { tagName: "feOffset", attributes: { dx: 1, dy: 1 } }, { tagName: "feComponentTransfer", children: [{ tagName: "feFuncA", attributes: { type: "linear", slope: 0.3 } }] }, { tagName: "feMerge", children: [{ tagName: "feMergeNode" }, { tagName: "feMergeNode", attributes: { in: "SourceGraphic" } }] }]
            });
          }, p.prototype.bodyFormatter = function(i) {
            return i.map(function(l) {
              var s = l.series.tooltipOptions;
              return (s[(l.point.formatPrefix || "point") + "Formatter"] || l.point.tooltipFormatter).call(l.point, s[(l.point.formatPrefix || "point") + "Format"] || "");
            });
          }, p.prototype.cleanSplit = function(i) {
            this.chart.series.forEach(function(l) {
              var s = l && l.tt;
              s && (!s.isActive || i ? l.tt = s.destroy() : s.isActive = !1);
            });
          }, p.prototype.defaultFormatter = function(i) {
            var l = this.points || h(this), s = [i.tooltipFooterHeaderFormatter(l[0])];
            return s = s.concat(i.bodyFormatter(l)), s.push(i.tooltipFooterHeaderFormatter(l[0], !0)), s;
          }, p.prototype.destroy = function() {
            this.label && (this.label = this.label.destroy()), this.split && this.tt && (this.cleanSplit(!0), this.tt = this.tt.destroy()), this.renderer && (this.renderer = this.renderer.destroy(), d(this.container)), H.clearTimeout(this.hideTimer), H.clearTimeout(this.tooltipTimeout);
          }, p.prototype.getAnchor = function(i, l) {
            var s = this.chart, t = s.pointer, n = s.inverted, o = s.plotTop, A = s.plotLeft, _, D, j = 0, T = 0;
            return i = h(i), this.followPointer && l ? (typeof l.chartX > "u" && (l = t.normalize(l)), t = [l.chartX - A, l.chartY - o]) : i[0].tooltipPos ? t = i[0].tooltipPos : (i.forEach(function(X) {
              _ = X.series.yAxis, D = X.series.xAxis, j += X.plotX || 0, T += X.plotLow ? (X.plotLow + (X.plotHigh || 0)) / 2 : X.plotY || 0, D && _ && (n ? (j += o + s.plotHeight - D.len - D.pos, T += A + s.plotWidth - _.len - _.pos) : (j += D.pos - A, T += _.pos - o));
            }), j /= i.length, T /= i.length, t = [n ? s.plotWidth - T : j, n ? s.plotHeight - j : T], this.shared && 1 < i.length && l && (n ? t[0] = l.chartX - A : t[1] = l.chartY - o)), t.map(Math.round);
          }, p.prototype.getLabel = function() {
            var i = this, l = this.chart.styledMode, s = this.options, t = this.split && this.allowShared, n = "tooltip" + (u(s.className) ? " " + s.className : ""), o = s.style.pointerEvents || (!this.followPointer && s.stickOnContact ? "auto" : "none"), A = function() {
              i.inContact = !0;
            }, _ = function(Y) {
              var F = i.chart.hoverSeries;
              i.inContact = i.shouldStickOnContact() && i.chart.pointer.inClass(Y.relatedTarget, "highcharts-tooltip"), !i.inContact && F && F.onMouseOut && F.onMouseOut();
            }, D, j = this.chart.renderer;
            if (i.label) {
              var T = !i.label.hasClass("highcharts-label");
              (t && !T || !t && T) && i.destroy();
            }
            if (!this.label) {
              if (this.outside) {
                T = this.chart.options.chart.style;
                var X = Z.getRendererType();
                this.container = D = R.doc.createElement("div"), D.className = "highcharts-tooltip-container", v(D, { position: "absolute", top: "1px", pointerEvents: o, zIndex: Math.max(this.options.style.zIndex || 0, (T && T.zIndex || 0) + 3) }), N(D, "mouseenter", A), N(D, "mouseleave", _), R.doc.body.appendChild(D), this.renderer = j = new X(D, 0, 0, T, void 0, void 0, j.styledMode);
              }
              if (t ? this.label = j.g(n) : (this.label = j.label("", 0, 0, s.shape, void 0, void 0, s.useHTML, void 0, n).attr({ padding: s.padding, r: s.borderRadius }), l || this.label.attr({
                fill: s.backgroundColor,
                "stroke-width": s.borderWidth
              }).css(s.style).css({ pointerEvents: o }).shadow(s.shadow)), l && s.shadow && (this.applyFilter(), this.label.attr({ filter: "url(#drop-shadow-" + this.chart.index + ")" })), i.outside && !i.split) {
                var f = this.label, m = f.xSetter, L = f.ySetter;
                f.xSetter = function(Y) {
                  m.call(f, i.distance), D.style.left = Y + "px";
                }, f.ySetter = function(Y) {
                  L.call(f, i.distance), D.style.top = Y + "px";
                };
              }
              this.label.on("mouseenter", A).on("mouseleave", _).attr({ zIndex: 8 }).add();
            }
            return this.label;
          }, p.prototype.getPosition = function(i, l, s) {
            var t = this.chart, n = this.distance, o = {}, A = t.inverted && s.h || 0, _ = this.outside, D = _ ? U.documentElement.clientWidth - 2 * n : t.chartWidth, j = _ ? Math.max(U.body.scrollHeight, U.documentElement.scrollHeight, U.body.offsetHeight, U.documentElement.offsetHeight, U.documentElement.clientHeight) : t.chartHeight, T = t.pointer.getChartPosition(), X = function(z) {
              var V = z === "x";
              return [z, V ? D : j, V ? i : l].concat(_ ? [V ? i * T.scaleX : l * T.scaleY, V ? T.left - n + (s.plotX + t.plotLeft) * T.scaleX : T.top - n + (s.plotY + t.plotTop) * T.scaleY, 0, V ? D : j] : [V ? i : l, V ? s.plotX + t.plotLeft : s.plotY + t.plotTop, V ? t.plotLeft : t.plotTop, V ? t.plotLeft + t.plotWidth : t.plotTop + t.plotHeight]);
            }, f = X("y"), m = X("x"), L;
            X = !!s.negative, !t.polar && t.hoverSeries && t.hoverSeries.yAxis && t.hoverSeries.yAxis.reversed && (X = !X);
            var Y = !this.followPointer && x(s.ttBelow, !t.inverted === X), F = function(z, V, q, it, et, nt, rt) {
              var ct = _ ? z === "y" ? n * T.scaleY : n * T.scaleX : n, gt = (q - it) / 2, dt = it < et - n, lt = et + n + it < V, at = et - ct - q + gt;
              if (et = et + ct - gt, Y && lt)
                o[z] = et;
              else if (!Y && dt)
                o[z] = at;
              else if (dt)
                o[z] = Math.min(rt - it, 0 > at - A ? at : at - A);
              else if (lt)
                o[z] = Math.max(nt, et + A + q > V ? et : et + A);
              else
                return !1;
            }, Q = function(z, V, q, it, et) {
              var nt;
              return et < n || et > V - n ? nt = !1 : o[z] = et < q / 2 ? 1 : et > V - it / 2 ? V - it - 2 : et - q / 2, nt;
            }, k = function(z) {
              var V = f;
              f = m, m = V, L = z;
            }, G = function() {
              F.apply(0, f) !== !1 ? Q.apply(0, m) !== !1 || L || (k(!0), G()) : L ? o.x = o.y = 0 : (k(!0), G());
            };
            return (t.inverted || 1 < this.len) && k(), G(), o;
          }, p.prototype.hide = function(i) {
            var l = this;
            H.clearTimeout(this.hideTimer), i = x(i, this.options.hideDelay), this.isHidden || (this.hideTimer = c(function() {
              l.getLabel().fadeOut(i && void 0), l.isHidden = !0;
            }, i));
          }, p.prototype.init = function(i, l) {
            this.chart = i, this.options = l, this.crosshairs = [], this.now = { x: 0, y: 0 }, this.isHidden = !0, this.split = l.split && !i.inverted && !i.polar, this.shared = l.shared || this.split, this.outside = x(l.outside, !(!i.scrollablePixelsX && !i.scrollablePixelsY));
          }, p.prototype.shouldStickOnContact = function() {
            return !(this.followPointer || !this.options.stickOnContact);
          }, p.prototype.isStickyOnContact = function() {
            return !(!this.shouldStickOnContact() || !this.inContact);
          }, p.prototype.move = function(i, l, s, t) {
            var n = this, o = n.now, A = n.options.animation !== !1 && !n.isHidden && (1 < Math.abs(i - o.x) || 1 < Math.abs(l - o.y)), _ = n.followPointer || 1 < n.len;
            P(o, { x: A ? (2 * o.x + i) / 3 : i, y: A ? (o.y + l) / 2 : l, anchorX: _ ? void 0 : A ? (2 * o.anchorX + s) / 3 : s, anchorY: _ ? void 0 : A ? (o.anchorY + t) / 2 : t }), n.getLabel().attr(o), n.drawTracker(), A && (H.clearTimeout(this.tooltipTimeout), this.tooltipTimeout = setTimeout(function() {
              n && n.move(i, l, s, t);
            }, 32));
          }, p.prototype.refresh = function(i, l) {
            var s = this.chart, t = this.options, n = h(i), o = n[0], A = [], _ = t.formatter || this.defaultFormatter, D = this.shared, j = s.styledMode, T = {};
            if (t.enabled) {
              H.clearTimeout(this.hideTimer), this.allowShared = !(!B(i) && i.series && i.series.noSharedTooltip), this.followPointer = !this.split && o.series.tooltipOptions.followPointer, i = this.getAnchor(i, l);
              var X = i[0], f = i[1];
              if (D && this.allowShared ? (s.pointer.applyInactiveState(n), n.forEach(function(Y) {
                Y.setState("hover"), A.push(Y.getLabelConfig());
              }), T = { x: o.category, y: o.y }, T.points = A) : T = o.getLabelConfig(), this.len = A.length, _ = _.call(T, this), D = o.series, this.distance = x(D.tooltipOptions.distance, 16), _ === !1)
                this.hide();
              else {
                if (this.split && this.allowShared)
                  this.renderSplit(
                    _,
                    n
                  );
                else {
                  var m = X, L = f;
                  if (l && s.pointer.isDirectTouch && (m = l.chartX - s.plotLeft, L = l.chartY - s.plotTop), s.polar || D.options.clip === !1 || n.some(function(Y) {
                    return Y.series.shouldShowTooltip(m, L);
                  }))
                    l = this.getLabel(), t.style.width && !j || l.css({ width: this.chart.spacingBox.width + "px" }), l.attr({ text: _ && _.join ? _.join("") : _ }), l.removeClass(/highcharts-color-[\d]+/g).addClass("highcharts-color-" + x(o.colorIndex, D.colorIndex)), j || l.attr({ stroke: t.borderColor || o.color || D.color || "#666666" }), this.updatePosition({
                      plotX: X,
                      plotY: f,
                      negative: o.negative,
                      ttBelow: o.ttBelow,
                      h: i[2] || 0
                    });
                  else {
                    this.hide();
                    return;
                  }
                }
                this.isHidden && this.label && this.label.attr({ opacity: 1 }).show(), this.isHidden = !1;
              }
              O(this, "refresh");
            }
          }, p.prototype.renderSplit = function(i, l) {
            function s(lt, at, J, tt, st) {
              return st === void 0 && (st = !0), J ? (at = it ? 0 : ct, lt = M(lt - tt / 2, z.left, z.right - tt - (t.outside ? et : 0))) : (at -= nt, lt = st ? lt - tt - Q : lt + Q, lt = M(lt, st ? lt : z.left, z.right)), { x: lt, y: at };
            }
            var t = this, n = t.chart, o = t.chart, A = o.chartWidth, _ = o.chartHeight, D = o.plotHeight, j = o.plotLeft, T = o.plotTop, X = o.pointer, f = o.scrollablePixelsY;
            f = f === void 0 ? 0 : f;
            var m = o.scrollablePixelsX, L = o.scrollingContainer;
            L = L === void 0 ? { scrollLeft: 0, scrollTop: 0 } : L;
            var Y = L.scrollLeft;
            L = L.scrollTop;
            var F = o.styledMode, Q = t.distance, k = t.options, G = t.options.positioner, z = t.outside && typeof m != "number" ? U.documentElement.getBoundingClientRect() : { left: Y, right: Y + A, top: L, bottom: L + _ }, V = t.getLabel(), q = this.renderer || n.renderer, it = !(!n.xAxis[0] || !n.xAxis[0].opposite);
            n = X.getChartPosition();
            var et = n.left;
            n = n.top;
            var nt = T + L, rt = 0, ct = D - f;
            b(i) && (i = [!1, i]), i = i.slice(0, l.length + 1).reduce(function(lt, at, J) {
              if (at !== !1 && at !== "") {
                J = l[J - 1] || { isHeader: !0, plotX: l[0].plotX, plotY: D, series: {} };
                var tt = J.isHeader, st = tt ? t : J.series;
                at = at.toString();
                var ht = st.tt, pt = J.isHeader, yt = J.series, vt = "highcharts-color-" + x(J.colorIndex, yt.colorIndex, "none");
                if (ht || (ht = { padding: k.padding, r: k.borderRadius }, F || (ht.fill = k.backgroundColor, ht["stroke-width"] = k.borderWidth), ht = q.label("", 0, 0, k[pt ? "headerShape" : "shape"], void 0, void 0, k.useHTML).addClass((pt ? "highcharts-tooltip-header " : "") + "highcharts-tooltip-box " + vt).attr(ht).add(V)), ht.isActive = !0, ht.attr({ text: at }), F || ht.css(k.style).shadow(k.shadow).attr({ stroke: k.borderColor || J.color || yt.color || "#333333" }), st = st.tt = ht, pt = st.getBBox(), at = pt.width + st.strokeWidth(), tt && (rt = pt.height, ct += rt, it && (nt -= rt)), yt = J.plotX, yt = yt === void 0 ? 0 : yt, vt = J.plotY, vt = vt === void 0 ? 0 : vt, ht = J.series, J.isHeader) {
                  yt = j + yt;
                  var Ct = T + D / 2;
                } else {
                  var Tt = ht.xAxis, kt = ht.yAxis;
                  yt = Tt.pos + M(yt, -Q, Tt.len + Q), ht.shouldShowTooltip(0, kt.pos - T + vt, { ignoreX: !0 }) && (Ct = kt.pos + vt);
                }
                yt = M(yt, z.left - Q, z.right + Q), typeof Ct == "number" ? (pt = pt.height + 1, vt = G ? G.call(t, at, pt, J) : s(
                  yt,
                  Ct,
                  tt,
                  at
                ), lt.push({ align: G ? 0 : void 0, anchorX: yt, anchorY: Ct, boxWidth: at, point: J, rank: x(vt.rank, tt ? 1 : 0), size: pt, target: vt.y, tt: st, x: vt.x })) : st.isActive = !1;
              }
              return lt;
            }, []), !G && i.some(function(lt) {
              var at = (t.outside ? et : 0) + lt.anchorX;
              return at < z.left && at + lt.boxWidth < z.right ? !0 : at < et - z.left + lt.boxWidth && z.right - at > at;
            }) && (i = i.map(function(lt) {
              var at = s(lt.anchorX, lt.anchorY, lt.point.isHeader, lt.boxWidth, !1);
              return P(lt, { target: at.y, x: at.x });
            })), t.cleanSplit(), W(i, ct);
            var gt = et, dt = et;
            i.forEach(function(lt) {
              var at = lt.x, J = lt.boxWidth;
              lt = lt.isHeader, lt || (t.outside && et + at < gt && (gt = et + at), !lt && t.outside && gt + J > dt && (dt = et + at));
            }), i.forEach(function(lt) {
              var at = lt.x, J = lt.anchorX, tt = lt.pos, st = lt.point.isHeader;
              if (tt = { visibility: typeof tt > "u" ? "hidden" : "inherit", x: at, y: tt + nt, anchorX: J, anchorY: lt.anchorY }, t.outside && at < J) {
                var ht = et - gt;
                0 < ht && (st || (tt.x = at + ht, tt.anchorX = J + ht), st && (tt.x = (dt - gt) / 2, tt.anchorX = J + ht));
              }
              lt.tt.attr(tt);
            }), i = t.container, f = t.renderer, t.outside && i && f && (o = V.getBBox(), f.setSize(o.width + o.x, o.height + o.y, !1), i.style.left = gt + "px", i.style.top = n + "px");
          }, p.prototype.drawTracker = function() {
            if (this.followPointer || !this.options.stickOnContact)
              this.tracker && this.tracker.destroy();
            else {
              var i = this.chart, l = this.label, s = this.shared ? i.hoverPoints : i.hoverPoint;
              if (l && s) {
                var t = { x: 0, y: 0, width: 0, height: 0 };
                s = this.getAnchor(s);
                var n = l.getBBox();
                s[0] += i.plotLeft - l.translateX, s[1] += i.plotTop - l.translateY, t.x = Math.min(0, s[0]), t.y = Math.min(0, s[1]), t.width = 0 > s[0] ? Math.max(Math.abs(s[0]), n.width - s[0]) : Math.max(Math.abs(s[0]), n.width), t.height = 0 > s[1] ? Math.max(Math.abs(s[1]), n.height - Math.abs(s[1])) : Math.max(Math.abs(s[1]), n.height), this.tracker ? this.tracker.attr(t) : (this.tracker = l.renderer.rect(t).addClass("highcharts-tracker").add(l), i.styledMode || this.tracker.attr({ fill: "rgba(0,0,0,0)" }));
              }
            }
          }, p.prototype.styledModeFormat = function(i) {
            return i.replace('style="font-size: 10px"', 'class="highcharts-header"').replace(/style="color:{(point|series)\.color}"/g, 'class="highcharts-color-{$1.colorIndex}"');
          }, p.prototype.tooltipFooterHeaderFormatter = function(i, l) {
            var s = i.series, t = s.tooltipOptions, n = s.xAxis, o = n && n.dateTime;
            n = {
              isFooter: l,
              labelConfig: i
            };
            var A = t.xDateFormat, _ = t[l ? "footerFormat" : "headerFormat"];
            return O(this, "headerFormatter", n, function(D) {
              o && !A && C(i.key) && (A = o.getXDateFormat(i.key, t.dateTimeLabelFormats)), o && A && (i.point && i.point.tooltipDateKeys || ["key"]).forEach(function(j) {
                _ = _.replace("{point." + j + "}", "{point." + j + ":" + A + "}");
              }), s.chart.styledMode && (_ = this.styledModeFormat(_)), D.text = $(_, { point: i, series: s }, this.chart);
            }), n.text;
          }, p.prototype.update = function(i) {
            this.destroy(), w(!0, this.chart.options.tooltip.userOptions, i), this.init(this.chart, w(!0, this.options, i));
          }, p.prototype.updatePosition = function(i) {
            var l = this.chart, s = this.options, t = l.pointer, n = this.getLabel();
            t = t.getChartPosition();
            var o = (s.positioner || this.getPosition).call(this, n.width, n.height, i), A = i.plotX + l.plotLeft;
            i = i.plotY + l.plotTop, this.outside && (s = s.borderWidth + 2 * this.distance, this.renderer.setSize(n.width + s, n.height + s, !1), (t.scaleX !== 1 || t.scaleY !== 1) && (v(this.container, { transform: "scale(" + t.scaleX + ", " + t.scaleY + ")" }), A *= t.scaleX, i *= t.scaleY), A += t.left - o.x, i += t.top - o.y), this.move(Math.round(o.x), Math.round(o.y || 0), A, i);
          }, p;
        }(), y;
      }
    ), E(a, "Core/Series/Point.js", [a["Core/Renderer/HTML/AST.js"], a["Core/Animation/AnimationUtilities.js"], a["Core/DefaultOptions.js"], a["Core/FormatUtilities.js"], a["Core/Utilities.js"]], function(y, R, I, Z, H) {
      var $ = R.animObject, U = I.defaultOptions, W = Z.format, N = H.addEvent, M = H.defined, v = H.erase, u = H.extend, d = H.fireEvent, P = H.getNestedProperty, O = H.isArray, B = H.isFunction, C = H.isNumber, b = H.isObject, w = H.merge, x = H.objectEach, h = H.pick, c = H.syncTimeout, p = H.removeEvent, i = H.uniqueKey;
      return R = function() {
        function l() {
          this.colorIndex = this.category = void 0, this.formatPrefix = "point", this.id = void 0, this.isNull = !1, this.percentage = this.options = this.name = void 0, this.selected = !1, this.total = this.series = void 0, this.visible = !0, this.x = void 0;
        }
        return l.prototype.animateBeforeDestroy = function() {
          var s = this, t = { x: s.startXPos, opacity: 0 }, n = s.getGraphicalProps();
          n.singular.forEach(function(o) {
            s[o] = s[o].animate(o === "dataLabel" ? {
              x: s[o].startXPos,
              y: s[o].startYPos,
              opacity: 0
            } : t);
          }), n.plural.forEach(function(o) {
            s[o].forEach(function(A) {
              A.element && A.animate(u({ x: s.startXPos }, A.startYPos ? { x: A.startXPos, y: A.startYPos } : {}));
            });
          });
        }, l.prototype.applyOptions = function(s, t) {
          var n = this.series, o = n.options.pointValKey || n.pointValKey;
          return s = l.prototype.optionsToObject.call(this, s), u(this, s), this.options = this.options ? u(this.options, s) : s, s.group && delete this.group, s.dataLabels && delete this.dataLabels, o && (this.y = l.prototype.getNestedProperty.call(this, o)), this.formatPrefix = (this.isNull = h(this.isValid && !this.isValid(), this.x === null || !C(this.y))) ? "null" : "point", this.selected && (this.state = "select"), "name" in this && typeof t > "u" && n.xAxis && n.xAxis.hasNames && (this.x = n.xAxis.nameToX(this)), typeof this.x > "u" && n ? this.x = typeof t > "u" ? n.autoIncrement() : t : C(s.x) && n.options.relativeXValue && (this.x = n.autoIncrement(s.x)), this;
        }, l.prototype.destroy = function() {
          function s() {
            (t.graphic || t.dataLabel || t.dataLabels) && (p(t), t.destroyElements());
            for (D in t)
              t[D] = null;
          }
          var t = this, n = t.series, o = n.chart;
          n = n.options.dataSorting;
          var A = o.hoverPoints, _ = $(t.series.chart.renderer.globalAnimation), D;
          t.legendItem && o.legend.destroyItem(t), A && (t.setState(), v(A, t), A.length || (o.hoverPoints = null)), t === o.hoverPoint && t.onMouseOut(), n && n.enabled ? (this.animateBeforeDestroy(), c(s, _.duration)) : s(), o.pointCount--;
        }, l.prototype.destroyElements = function(s) {
          var t = this;
          s = t.getGraphicalProps(s), s.singular.forEach(function(n) {
            t[n] = t[n].destroy();
          }), s.plural.forEach(function(n) {
            t[n].forEach(function(o) {
              o.element && o.destroy();
            }), delete t[n];
          });
        }, l.prototype.firePointEvent = function(s, t, n) {
          var o = this, A = this.series.options;
          (A.point.events[s] || o.options && o.options.events && o.options.events[s]) && o.importEvents(), s === "click" && A.allowPointSelect && (n = function(_) {
            o.select && o.select(null, _.ctrlKey || _.metaKey || _.shiftKey);
          }), d(o, s, t, n);
        }, l.prototype.getClassName = function() {
          return "highcharts-point" + (this.selected ? " highcharts-point-select" : "") + (this.negative ? " highcharts-negative" : "") + (this.isNull ? " highcharts-null-point" : "") + (typeof this.colorIndex < "u" ? " highcharts-color-" + this.colorIndex : "") + (this.options.className ? " " + this.options.className : "") + (this.zone && this.zone.className ? " " + this.zone.className.replace("highcharts-negative", "") : "");
        }, l.prototype.getGraphicalProps = function(s) {
          var t = this, n = [], o = { singular: [], plural: [] }, A;
          for (s = s || { graphic: 1, dataLabel: 1 }, s.graphic && n.push("graphic", "upperGraphic", "shadowGroup"), s.dataLabel && n.push("dataLabel", "dataLabelUpper", "connector"), A = n.length; A--; ) {
            var _ = n[A];
            t[_] && o.singular.push(_);
          }
          return ["dataLabel", "connector"].forEach(function(D) {
            var j = D + "s";
            s[D] && t[j] && o.plural.push(j);
          }), o;
        }, l.prototype.getLabelConfig = function() {
          return { x: this.category, y: this.y, color: this.color, colorIndex: this.colorIndex, key: this.name || this.category, series: this.series, point: this, percentage: this.percentage, total: this.total || this.stackTotal };
        }, l.prototype.getNestedProperty = function(s) {
          if (s)
            return s.indexOf("custom.") === 0 ? P(s, this.options) : this[s];
        }, l.prototype.getZone = function() {
          var s = this.series, t = s.zones;
          s = s.zoneAxis || "y";
          var n, o = 0;
          for (n = t[o]; this[s] >= n.value; )
            n = t[++o];
          return this.nonZonedColor || (this.nonZonedColor = this.color), this.color = n && n.color && !this.options.color ? n.color : this.nonZonedColor, n;
        }, l.prototype.hasNewShapeType = function() {
          return (this.graphic && (this.graphic.symbolName || this.graphic.element.nodeName)) !== this.shapeType;
        }, l.prototype.init = function(s, t, n) {
          return this.series = s, this.applyOptions(t, n), this.id = M(this.id) ? this.id : i(), this.resolveColor(), s.chart.pointCount++, d(this, "afterInit"), this;
        }, l.prototype.optionsToObject = function(s) {
          var t = this.series, n = t.options.keys, o = n || t.pointArrayMap || ["y"], A = o.length, _ = {}, D = 0, j = 0;
          if (C(s) || s === null)
            _[o[0]] = s;
          else if (O(s))
            for (!n && s.length > A && (t = typeof s[0], t === "string" ? _.name = s[0] : t === "number" && (_.x = s[0]), D++); j < A; )
              n && typeof s[D] > "u" || (0 < o[j].indexOf(".") ? l.prototype.setNestedProperty(_, s[D], o[j]) : _[o[j]] = s[D]), D++, j++;
          else
            typeof s == "object" && (_ = s, s.dataLabels && (t._hasPointLabels = !0), s.marker && (t._hasPointMarkers = !0));
          return _;
        }, l.prototype.resolveColor = function() {
          var s = this.series, t = s.chart.styledMode, n = s.chart.options.chart.colorCount;
          if (delete this.nonZonedColor, s.options.colorByPoint) {
            if (!t) {
              n = s.options.colors || s.chart.options.colors;
              var o = n[s.colorCounter];
              n = n.length;
            }
            t = s.colorCounter, s.colorCounter++, s.colorCounter === n && (s.colorCounter = 0);
          } else
            t || (o = s.color), t = s.colorIndex;
          this.colorIndex = h(this.options.colorIndex, t), this.color = h(this.options.color, o);
        }, l.prototype.setNestedProperty = function(s, t, n) {
          return n.split(".").reduce(function(o, A, _, D) {
            return o[A] = D.length - 1 === _ ? t : b(o[A], !0) ? o[A] : {}, o[A];
          }, s), s;
        }, l.prototype.tooltipFormatter = function(s) {
          var t = this.series, n = t.tooltipOptions, o = h(n.valueDecimals, ""), A = n.valuePrefix || "", _ = n.valueSuffix || "";
          return t.chart.styledMode && (s = t.chart.tooltip.styledModeFormat(s)), (t.pointArrayMap || ["y"]).forEach(function(D) {
            D = "{point." + D, (A || _) && (s = s.replace(RegExp(D + "}", "g"), A + D + "}" + _)), s = s.replace(RegExp(D + "}", "g"), D + ":,." + o + "f}");
          }), W(s, { point: this, series: this.series }, t.chart);
        }, l.prototype.update = function(s, t, n, o) {
          function A() {
            _.applyOptions(s);
            var m = j && _.hasDummyGraphic;
            m = _.y === null ? !m : m, j && m && (_.graphic = j.destroy(), delete _.hasDummyGraphic), b(s, !0) && (j && j.element && s && s.marker && typeof s.marker.symbol < "u" && (_.graphic = j.destroy()), s && s.dataLabels && _.dataLabel && (_.dataLabel = _.dataLabel.destroy()), _.connector && (_.connector = _.connector.destroy())), f = _.index, D.updateParallelArrays(_, f), X.data[f] = b(X.data[f], !0) || b(s, !0) ? _.options : h(s, X.data[f]), D.isDirty = D.isDirtyData = !0, !D.fixedBox && D.hasCartesianSeries && (T.isDirtyBox = !0), X.legendType === "point" && (T.isDirtyLegend = !0), t && T.redraw(n);
          }
          var _ = this, D = _.series, j = _.graphic, T = D.chart, X = D.options, f;
          t = h(t, !0), o === !1 ? A() : _.firePointEvent("update", { options: s }, A);
        }, l.prototype.remove = function(s, t) {
          this.series.removePoint(this.series.data.indexOf(this), s, t);
        }, l.prototype.select = function(s, t) {
          var n = this, o = n.series, A = o.chart;
          this.selectedStaging = s = h(s, !n.selected), n.firePointEvent(s ? "select" : "unselect", { accumulate: t }, function() {
            n.selected = n.options.selected = s, o.options.data[o.data.indexOf(n)] = n.options, n.setState(s && "select"), t || A.getSelectedPoints().forEach(function(_) {
              var D = _.series;
              _.selected && _ !== n && (_.selected = _.options.selected = !1, D.options.data[D.data.indexOf(_)] = _.options, _.setState(A.hoverPoints && D.options.inactiveOtherPoints ? "inactive" : ""), _.firePointEvent("unselect"));
            });
          }), delete this.selectedStaging;
        }, l.prototype.onMouseOver = function(s) {
          var t = this.series.chart, n = t.pointer;
          s = s ? n.normalize(s) : n.getChartCoordinatesFromPoint(this, t.inverted), n.runPointActions(
            s,
            this
          );
        }, l.prototype.onMouseOut = function() {
          var s = this.series.chart;
          this.firePointEvent("mouseOut"), this.series.options.inactiveOtherPoints || (s.hoverPoints || []).forEach(function(t) {
            t.setState();
          }), s.hoverPoints = s.hoverPoint = null;
        }, l.prototype.importEvents = function() {
          if (!this.hasImportedEvents) {
            var s = this, t = w(s.series.options.point, s.options).events;
            s.events = t, x(t, function(n, o) {
              B(n) && N(s, o, n);
            }), this.hasImportedEvents = !0;
          }
        }, l.prototype.setState = function(s, t) {
          var n = this.series, o = this.state, A = n.options.states[s || "normal"] || {}, _ = U.plotOptions[n.type].marker && n.options.marker, D = _ && _.enabled === !1, j = _ && _.states && _.states[s || "normal"] || {}, T = j.enabled === !1, X = this.marker || {}, f = n.chart, m = _ && n.markerAttribs, L = n.halo, Y, F = n.stateMarkerGraphic;
          if (s = s || "", !(s === this.state && !t || this.selected && s !== "select" || A.enabled === !1 || s && (T || D && j.enabled === !1) || s && X.states && X.states[s] && X.states[s].enabled === !1)) {
            if (this.state = s, m && (Y = n.markerAttribs(this, s)), this.graphic && !this.hasDummyGraphic) {
              if (o && this.graphic.removeClass("highcharts-point-" + o), s && this.graphic.addClass("highcharts-point-" + s), !f.styledMode) {
                var Q = n.pointAttribs(this, s), k = h(f.options.chart.animation, A.animation);
                n.options.inactiveOtherPoints && C(Q.opacity) && ((this.dataLabels || []).forEach(function(G) {
                  G && G.animate({ opacity: Q.opacity }, k);
                }), this.connector && this.connector.animate({ opacity: Q.opacity }, k)), this.graphic.animate(Q, k);
              }
              Y && this.graphic.animate(Y, h(f.options.chart.animation, j.animation, _.animation)), F && F.hide();
            } else
              s && j && (o = X.symbol || n.symbol, F && F.currentSymbol !== o && (F = F.destroy()), Y && (F ? F[t ? "animate" : "attr"]({ x: Y.x, y: Y.y }) : o && (n.stateMarkerGraphic = F = f.renderer.symbol(o, Y.x, Y.y, Y.width, Y.height).add(n.markerGroup), F.currentSymbol = o)), !f.styledMode && F && this.state !== "inactive" && F.attr(n.pointAttribs(this, s))), F && (F[s && this.isInside ? "show" : "hide"](), F.element.point = this, F.addClass(this.getClassName(), !0));
            A = A.halo, Y = (F = this.graphic || F) && F.visibility || "inherit", A && A.size && F && Y !== "hidden" && !this.isCluster ? (L || (n.halo = L = f.renderer.path().add(F.parentGroup)), L.show()[t ? "animate" : "attr"]({ d: this.haloPath(A.size) }), L.attr({ class: "highcharts-halo highcharts-color-" + h(this.colorIndex, n.colorIndex) + (this.className ? " " + this.className : ""), visibility: Y, zIndex: -1 }), L.point = this, f.styledMode || L.attr(u({ fill: this.color || n.color, "fill-opacity": A.opacity }, y.filterUserAttributes(A.attributes || {})))) : L && L.point && L.point.haloPath && L.animate({ d: L.point.haloPath(0) }, null, L.hide), d(this, "afterSetState", { state: s });
          }
        }, l.prototype.haloPath = function(s) {
          return this.series.chart.renderer.symbols.circle(Math.floor(this.plotX) - s, this.plotY - s, 2 * s, 2 * s);
        }, l;
      }(), R;
    }), E(a, "Core/Pointer.js", [a["Core/Color/Color.js"], a["Core/Globals.js"], a["Core/Tooltip.js"], a["Core/Utilities.js"]], function(y, R, I, Z) {
      var H = y.parse, $ = R.charts, U = R.noop, W = Z.addEvent, N = Z.attr, M = Z.css, v = Z.defined, u = Z.extend, d = Z.find, P = Z.fireEvent, O = Z.isNumber, B = Z.isObject, C = Z.objectEach, b = Z.offset, w = Z.pick, x = Z.splat;
      return y = function() {
        function h(c, p) {
          this.lastValidTouch = {}, this.pinchDown = [], this.runChartClick = !1, this.eventsToUnbind = [], this.chart = c, this.hasDragged = !1, this.options = p, this.init(c, p);
        }
        return h.prototype.applyInactiveState = function(c) {
          var p = [], i;
          (c || []).forEach(function(l) {
            i = l.series, p.push(i), i.linkedParent && p.push(i.linkedParent), i.linkedSeries && (p = p.concat(i.linkedSeries)), i.navigatorSeries && p.push(i.navigatorSeries);
          }), this.chart.series.forEach(function(l) {
            p.indexOf(l) === -1 ? l.setState("inactive", !0) : l.options.inactiveOtherPoints && l.setAllPointsToState("inactive");
          });
        }, h.prototype.destroy = function() {
          var c = this;
          this.eventsToUnbind.forEach(function(p) {
            return p();
          }), this.eventsToUnbind = [], R.chartCount || (h.unbindDocumentMouseUp && (h.unbindDocumentMouseUp = h.unbindDocumentMouseUp()), h.unbindDocumentTouchEnd && (h.unbindDocumentTouchEnd = h.unbindDocumentTouchEnd())), clearInterval(c.tooltipTimeout), C(c, function(p, i) {
            c[i] = void 0;
          });
        }, h.prototype.drag = function(c) {
          var p = this.chart, i = p.options.chart, l = this.zoomHor, s = this.zoomVert, t = p.plotLeft, n = p.plotTop, o = p.plotWidth, A = p.plotHeight, _ = this.mouseDownX || 0, D = this.mouseDownY || 0, j = B(i.panning) ? i.panning && i.panning.enabled : i.panning, T = i.panKey && c[i.panKey + "Key"], X = c.chartX, f = c.chartY, m = this.selectionMarker;
          if ((!m || !m.touch) && (X < t ? X = t : X > t + o && (X = t + o), f < n ? f = n : f > n + A && (f = n + A), this.hasDragged = Math.sqrt(Math.pow(_ - X, 2) + Math.pow(D - f, 2)), 10 < this.hasDragged)) {
            var L = p.isInsidePlot(_ - t, D - n, { visiblePlotOnly: !0 });
            !p.hasCartesianSeries && !p.mapView || !this.zoomX && !this.zoomY || !L || T || m || (this.selectionMarker = m = p.renderer.rect(t, n, l ? 1 : o, s ? 1 : A, 0).attr({ class: "highcharts-selection-marker", zIndex: 7 }).add(), p.styledMode || m.attr({ fill: i.selectionMarkerFill || H("#335cad").setOpacity(0.25).get() })), m && l && (l = X - _, m.attr({ width: Math.abs(l), x: (0 < l ? 0 : l) + _ })), m && s && (l = f - D, m.attr({ height: Math.abs(l), y: (0 < l ? 0 : l) + D })), L && !m && j && p.pan(c, i.panning);
          }
        }, h.prototype.dragStart = function(c) {
          var p = this.chart;
          p.mouseIsDown = c.type, p.cancelClick = !1, p.mouseDownX = this.mouseDownX = c.chartX, p.mouseDownY = this.mouseDownY = c.chartY;
        }, h.prototype.drop = function(c) {
          var p = this, i = this.chart, l = this.hasPinched;
          if (this.selectionMarker) {
            var s = this.selectionMarker, t = s.attr ? s.attr("x") : s.x, n = s.attr ? s.attr("y") : s.y, o = s.attr ? s.attr("width") : s.width, A = s.attr ? s.attr("height") : s.height, _ = { originalEvent: c, xAxis: [], yAxis: [], x: t, y: n, width: o, height: A }, D = !!i.mapView;
            (this.hasDragged || l) && (i.axes.forEach(function(j) {
              if (j.zoomEnabled && v(j.min) && (l || p[{ xAxis: "zoomX", yAxis: "zoomY" }[j.coll]]) && O(t) && O(n)) {
                var T = j.horiz, X = c.type === "touchend" ? j.minPixelPadding : 0, f = j.toValue((T ? t : n) + X);
                T = j.toValue((T ? t + o : n + A) - X), _[j.coll].push({ axis: j, min: Math.min(f, T), max: Math.max(f, T) }), D = !0;
              }
            }), D && P(i, "selection", _, function(j) {
              i.zoom(u(
                j,
                l ? { animation: !1 } : null
              ));
            })), O(i.index) && (this.selectionMarker = this.selectionMarker.destroy()), l && this.scaleGroups();
          }
          i && O(i.index) && (M(i.container, { cursor: i._cursor }), i.cancelClick = 10 < this.hasDragged, i.mouseIsDown = this.hasDragged = this.hasPinched = !1, this.pinchDown = []);
        }, h.prototype.findNearestKDPoint = function(c, p, i) {
          var l = this.chart, s = l.hoverPoint;
          if (l = l.tooltip, s && l && l.isStickyOnContact())
            return s;
          var t;
          return c.forEach(function(n) {
            var o = !(n.noSharedTooltip && p) && 0 > n.options.findNearestPointBy.indexOf("y");
            if (n = n.searchPoint(i, o), (o = B(n, !0) && n.series) && !(o = !B(t, !0))) {
              o = t.distX - n.distX;
              var A = t.dist - n.dist, _ = (n.series.group && n.series.group.zIndex) - (t.series.group && t.series.group.zIndex);
              o = 0 < (o !== 0 && p ? o : A !== 0 ? A : _ !== 0 ? _ : t.series.index > n.series.index ? -1 : 1);
            }
            o && (t = n);
          }), t;
        }, h.prototype.getChartCoordinatesFromPoint = function(c, p) {
          var i = c.series, l = i.xAxis;
          i = i.yAxis;
          var s = c.shapeArgs;
          if (l && i) {
            var t = w(c.clientX, c.plotX), n = c.plotY || 0;
            return c.isNode && s && O(s.x) && O(s.y) && (t = s.x, n = s.y), p ? { chartX: i.len + i.pos - n, chartY: l.len + l.pos - t } : { chartX: t + l.pos, chartY: n + i.pos };
          }
          if (s && s.x && s.y)
            return { chartX: s.x, chartY: s.y };
        }, h.prototype.getChartPosition = function() {
          if (this.chartPosition)
            return this.chartPosition;
          var c = this.chart.container, p = b(c);
          this.chartPosition = { left: p.left, top: p.top, scaleX: 1, scaleY: 1 };
          var i = c.offsetWidth;
          return c = c.offsetHeight, 2 < i && 2 < c && (this.chartPosition.scaleX = p.width / i, this.chartPosition.scaleY = p.height / c), this.chartPosition;
        }, h.prototype.getCoordinates = function(c) {
          var p = { xAxis: [], yAxis: [] };
          return this.chart.axes.forEach(function(i) {
            p[i.isXAxis ? "xAxis" : "yAxis"].push({ axis: i, value: i.toValue(c[i.horiz ? "chartX" : "chartY"]) });
          }), p;
        }, h.prototype.getHoverData = function(c, p, i, l, s, t) {
          var n = [];
          l = !(!l || !c);
          var o = { chartX: t ? t.chartX : void 0, chartY: t ? t.chartY : void 0, shared: s };
          P(this, "beforeGetHoverData", o);
          var A = p && !p.stickyTracking ? [p] : i.filter(function(D) {
            return o.filter ? o.filter(D) : D.visible && !(!s && D.directTouch) && w(D.options.enableMouseTracking, !0) && D.stickyTracking;
          }), _ = l || !t ? c : this.findNearestKDPoint(A, s, t);
          return p = _ && _.series, _ && (s && !p.noSharedTooltip ? (A = i.filter(function(D) {
            return o.filter ? o.filter(D) : D.visible && !(!s && D.directTouch) && w(D.options.enableMouseTracking, !0) && !D.noSharedTooltip;
          }), A.forEach(function(D) {
            var j = d(D.points, function(T) {
              return T.x === _.x && !T.isNull;
            });
            B(j) && (D.chart.isBoosting && (j = D.getPoint(j)), n.push(j));
          })) : n.push(_)), o = { hoverPoint: _ }, P(this, "afterGetHoverData", o), { hoverPoint: o.hoverPoint, hoverSeries: p, hoverPoints: n };
        }, h.prototype.getPointFromEvent = function(c) {
          c = c.target;
          for (var p; c && !p; )
            p = c.point, c = c.parentNode;
          return p;
        }, h.prototype.onTrackerMouseOut = function(c) {
          c = c.relatedTarget || c.toElement;
          var p = this.chart.hoverSeries;
          this.isDirectTouch = !1, !p || !c || p.stickyTracking || this.inClass(c, "highcharts-tooltip") || this.inClass(c, "highcharts-series-" + p.index) && this.inClass(c, "highcharts-tracker") || p.onMouseOut();
        }, h.prototype.inClass = function(c, p) {
          for (var i; c; ) {
            if (i = N(c, "class")) {
              if (i.indexOf(p) !== -1)
                return !0;
              if (i.indexOf("highcharts-container") !== -1)
                return !1;
            }
            c = c.parentNode;
          }
        }, h.prototype.init = function(c, p) {
          this.options = p, this.chart = c, this.runChartClick = !(!p.chart.events || !p.chart.events.click), this.pinchDown = [], this.lastValidTouch = {}, I && (c.tooltip = new I(c, p.tooltip), this.followTouchMove = w(p.tooltip.followTouchMove, !0)), this.setDOMEvents();
        }, h.prototype.normalize = function(c, p) {
          var i = c.touches, l = i ? i.length ? i.item(0) : w(i.changedTouches, c.changedTouches)[0] : c;
          return p || (p = this.getChartPosition()), i = l.pageX - p.left, l = l.pageY - p.top, i /= p.scaleX, l /= p.scaleY, u(c, { chartX: Math.round(i), chartY: Math.round(l) });
        }, h.prototype.onContainerClick = function(c) {
          var p = this.chart, i = p.hoverPoint;
          c = this.normalize(c);
          var l = p.plotLeft, s = p.plotTop;
          p.cancelClick || (i && this.inClass(c.target, "highcharts-tracker") ? (P(i.series, "click", u(c, { point: i })), p.hoverPoint && i.firePointEvent("click", c)) : (u(c, this.getCoordinates(c)), p.isInsidePlot(c.chartX - l, c.chartY - s, { visiblePlotOnly: !0 }) && P(p, "click", c)));
        }, h.prototype.onContainerMouseDown = function(c) {
          var p = ((c.buttons || c.button) & 1) === 1;
          c = this.normalize(c), R.isFirefox && c.button !== 0 && this.onContainerMouseMove(c), (typeof c.button > "u" || p) && (this.zoomOption(c), p && c.preventDefault && c.preventDefault(), this.dragStart(c));
        }, h.prototype.onContainerMouseLeave = function(c) {
          var p = $[w(h.hoverChartIndex, -1)], i = this.chart.tooltip;
          i && i.shouldStickOnContact() && this.inClass(c.relatedTarget, "highcharts-tooltip-container") || (c = this.normalize(c), p && (c.relatedTarget || c.toElement) && (p.pointer.reset(), p.pointer.chartPosition = void 0), i && !i.isHidden && this.reset());
        }, h.prototype.onContainerMouseEnter = function(c) {
          delete this.chartPosition;
        }, h.prototype.onContainerMouseMove = function(c) {
          var p = this.chart;
          c = this.normalize(c), this.setHoverChartIndex(), c.preventDefault || (c.returnValue = !1), (p.mouseIsDown === "mousedown" || this.touchSelect(c)) && this.drag(c), p.openMenu || !this.inClass(c.target, "highcharts-tracker") && !p.isInsidePlot(c.chartX - p.plotLeft, c.chartY - p.plotTop, { visiblePlotOnly: !0 }) || (this.inClass(c.target, "highcharts-no-tooltip") ? this.reset(!1, 0) : this.runPointActions(c));
        }, h.prototype.onDocumentTouchEnd = function(c) {
          var p = $[w(
            h.hoverChartIndex,
            -1
          )];
          p && p.pointer.drop(c);
        }, h.prototype.onContainerTouchMove = function(c) {
          this.touchSelect(c) ? this.onContainerMouseMove(c) : this.touch(c);
        }, h.prototype.onContainerTouchStart = function(c) {
          this.touchSelect(c) ? this.onContainerMouseDown(c) : (this.zoomOption(c), this.touch(c, !0));
        }, h.prototype.onDocumentMouseMove = function(c) {
          var p = this.chart, i = this.chartPosition;
          c = this.normalize(c, i);
          var l = p.tooltip;
          !i || l && l.isStickyOnContact() || p.isInsidePlot(c.chartX - p.plotLeft, c.chartY - p.plotTop, { visiblePlotOnly: !0 }) || this.inClass(c.target, "highcharts-tracker") || this.reset();
        }, h.prototype.onDocumentMouseUp = function(c) {
          var p = $[w(h.hoverChartIndex, -1)];
          p && p.pointer.drop(c);
        }, h.prototype.pinch = function(c) {
          var p = this, i = p.chart, l = p.pinchDown, s = c.touches || [], t = s.length, n = p.lastValidTouch, o = p.hasZoom, A = {}, _ = t === 1 && (p.inClass(c.target, "highcharts-tracker") && i.runTrackerClick || p.runChartClick), D = {}, j = p.selectionMarker;
          1 < t ? p.initiated = !0 : t === 1 && this.followTouchMove && (p.initiated = !1), o && p.initiated && !_ && c.cancelable !== !1 && c.preventDefault(), [].map.call(s, function(T) {
            return p.normalize(T);
          }), c.type === "touchstart" ? ([].forEach.call(s, function(T, X) {
            l[X] = { chartX: T.chartX, chartY: T.chartY };
          }), n.x = [l[0].chartX, l[1] && l[1].chartX], n.y = [l[0].chartY, l[1] && l[1].chartY], i.axes.forEach(function(T) {
            if (T.zoomEnabled) {
              var X = i.bounds[T.horiz ? "h" : "v"], f = T.minPixelPadding, m = T.toPixels(Math.min(w(T.options.min, T.dataMin), T.dataMin)), L = T.toPixels(Math.max(w(T.options.max, T.dataMax), T.dataMax)), Y = Math.max(m, L);
              X.min = Math.min(T.pos, Math.min(
                m,
                L
              ) - f), X.max = Math.max(T.pos + T.len, Y + f);
            }
          }), p.res = !0) : p.followTouchMove && t === 1 ? this.runPointActions(p.normalize(c)) : l.length && (P(i, "touchpan", { originalEvent: c }, function() {
            j || (p.selectionMarker = j = u({ destroy: U, touch: !0 }, i.plotBox)), p.pinchTranslate(l, s, A, j, D, n), p.hasPinched = o, p.scaleGroups(A, D);
          }), p.res && (p.res = !1, this.reset(!1, 0)));
        }, h.prototype.pinchTranslate = function(c, p, i, l, s, t) {
          this.zoomHor && this.pinchTranslateDirection(!0, c, p, i, l, s, t), this.zoomVert && this.pinchTranslateDirection(!1, c, p, i, l, s, t);
        }, h.prototype.pinchTranslateDirection = function(c, p, i, l, s, t, n, o) {
          var A = this.chart, _ = c ? "x" : "y", D = c ? "X" : "Y", j = "chart" + D, T = c ? "width" : "height", X = A["plot" + (c ? "Left" : "Top")], f = A.inverted, m = A.bounds[c ? "h" : "v"], L = p.length === 1, Y = p[0][j], F = !L && p[1][j];
          p = function() {
            typeof V == "number" && 20 < Math.abs(Y - F) && (G = o || Math.abs(z - V) / Math.abs(Y - F)), k = (X - z) / G + Y, Q = A["plot" + (c ? "Width" : "Height")] / G;
          };
          var Q, k, G = o || 1, z = i[0][j], V = !L && i[1][j];
          if (p(), i = k, i < m.min) {
            i = m.min;
            var q = !0;
          } else
            i + Q > m.max && (i = m.max - Q, q = !0);
          q ? (z -= 0.8 * (z - n[_][0]), typeof V == "number" && (V -= 0.8 * (V - n[_][1])), p()) : n[_] = [z, V], f || (t[_] = k - X, t[T] = Q), t = f ? 1 / G : G, s[T] = Q, s[_] = i, l[f ? c ? "scaleY" : "scaleX" : "scale" + D] = G, l["translate" + D] = t * X + (z - t * Y);
        }, h.prototype.reset = function(c, p) {
          var i = this.chart, l = i.hoverSeries, s = i.hoverPoint, t = i.hoverPoints, n = i.tooltip, o = n && n.shared ? t : s;
          c && o && x(o).forEach(function(A) {
            A.series.isCartesian && typeof A.plotX > "u" && (c = !1);
          }), c ? n && o && x(o).length && (n.refresh(o), n.shared && t ? t.forEach(function(A) {
            A.setState(A.state, !0), A.series.isCartesian && (A.series.xAxis.crosshair && A.series.xAxis.drawCrosshair(
              null,
              A
            ), A.series.yAxis.crosshair && A.series.yAxis.drawCrosshair(null, A));
          }) : s && (s.setState(s.state, !0), i.axes.forEach(function(A) {
            A.crosshair && s.series[A.coll] === A && A.drawCrosshair(null, s);
          }))) : (s && s.onMouseOut(), t && t.forEach(function(A) {
            A.setState();
          }), l && l.onMouseOut(), n && n.hide(p), this.unDocMouseMove && (this.unDocMouseMove = this.unDocMouseMove()), i.axes.forEach(function(A) {
            A.hideCrosshair();
          }), this.hoverX = i.hoverPoints = i.hoverPoint = null);
        }, h.prototype.runPointActions = function(c, p) {
          var i = this.chart, l = i.tooltip && i.tooltip.options.enabled ? i.tooltip : void 0, s = l ? l.shared : !1, t = p || i.hoverPoint, n = t && t.series || i.hoverSeries;
          p = this.getHoverData(t, n, i.series, (!c || c.type !== "touchmove") && (!!p || n && n.directTouch && this.isDirectTouch), s, c), t = p.hoverPoint, n = p.hoverSeries;
          var o = p.hoverPoints;
          if (p = n && n.tooltipOptions.followPointer && !n.tooltipOptions.split, s = s && n && !n.noSharedTooltip, t && (t !== i.hoverPoint || l && l.isHidden)) {
            if ((i.hoverPoints || []).forEach(function(A) {
              o.indexOf(A) === -1 && A.setState();
            }), i.hoverSeries !== n && n.onMouseOver(), this.applyInactiveState(o), (o || []).forEach(function(A) {
              A.setState("hover");
            }), i.hoverPoint && i.hoverPoint.firePointEvent("mouseOut"), !t.series)
              return;
            i.hoverPoints = o, i.hoverPoint = t, t.firePointEvent("mouseOver"), l && l.refresh(s ? o : t, c);
          } else
            p && l && !l.isHidden && (t = l.getAnchor([{}], c), i.isInsidePlot(t[0], t[1], { visiblePlotOnly: !0 }) && l.updatePosition({ plotX: t[0], plotY: t[1] }));
          this.unDocMouseMove || (this.unDocMouseMove = W(i.container.ownerDocument, "mousemove", function(A) {
            var _ = $[h.hoverChartIndex];
            _ && _.pointer.onDocumentMouseMove(A);
          }), this.eventsToUnbind.push(this.unDocMouseMove)), i.axes.forEach(function(A) {
            var _ = w((A.crosshair || {}).snap, !0), D;
            _ && ((D = i.hoverPoint) && D.series[A.coll] === A || (D = d(o, function(j) {
              return j.series[A.coll] === A;
            }))), D || !_ ? A.drawCrosshair(c, D) : A.hideCrosshair();
          });
        }, h.prototype.scaleGroups = function(c, p) {
          var i = this.chart;
          i.series.forEach(function(l) {
            var s = c || l.getPlotBox();
            l.group && (l.xAxis && l.xAxis.zoomEnabled || i.mapView) && (l.group.attr(s), l.markerGroup && (l.markerGroup.attr(s), l.markerGroup.clip(p ? i.clipRect : null)), l.dataLabelsGroup && l.dataLabelsGroup.attr(s));
          }), i.clipRect.attr(p || i.clipBox);
        }, h.prototype.setDOMEvents = function() {
          var c = this, p = this.chart.container, i = p.ownerDocument;
          p.onmousedown = this.onContainerMouseDown.bind(this), p.onmousemove = this.onContainerMouseMove.bind(this), p.onclick = this.onContainerClick.bind(this), this.eventsToUnbind.push(W(p, "mouseenter", this.onContainerMouseEnter.bind(this))), this.eventsToUnbind.push(W(p, "mouseleave", this.onContainerMouseLeave.bind(this))), h.unbindDocumentMouseUp || (h.unbindDocumentMouseUp = W(i, "mouseup", this.onDocumentMouseUp.bind(this)));
          for (var l = this.chart.renderTo.parentElement; l && l.tagName !== "BODY"; )
            this.eventsToUnbind.push(W(l, "scroll", function() {
              delete c.chartPosition;
            })), l = l.parentElement;
          R.hasTouch && (this.eventsToUnbind.push(W(p, "touchstart", this.onContainerTouchStart.bind(this), { passive: !1 })), this.eventsToUnbind.push(W(p, "touchmove", this.onContainerTouchMove.bind(this), { passive: !1 })), h.unbindDocumentTouchEnd || (h.unbindDocumentTouchEnd = W(i, "touchend", this.onDocumentTouchEnd.bind(this), { passive: !1 })));
        }, h.prototype.setHoverChartIndex = function() {
          var c = this.chart, p = R.charts[w(h.hoverChartIndex, -1)];
          p && p !== c && p.pointer.onContainerMouseLeave({ relatedTarget: !0 }), p && p.mouseIsDown || (h.hoverChartIndex = c.index);
        }, h.prototype.touch = function(c, p) {
          var i = this.chart;
          if (this.setHoverChartIndex(), c.touches.length === 1)
            if (c = this.normalize(c), i.isInsidePlot(c.chartX - i.plotLeft, c.chartY - i.plotTop, { visiblePlotOnly: !0 }) && !i.openMenu) {
              if (p && this.runPointActions(c), c.type === "touchmove") {
                p = this.pinchDown;
                var l = p[0] ? 4 <= Math.sqrt(Math.pow(p[0].chartX - c.chartX, 2) + Math.pow(p[0].chartY - c.chartY, 2)) : !1;
              }
              w(l, !0) && this.pinch(c);
            } else
              p && this.reset();
          else
            c.touches.length === 2 && this.pinch(c);
        }, h.prototype.touchSelect = function(c) {
          return !(!this.chart.options.chart.zoomBySingleTouch || !c.touches || c.touches.length !== 1);
        }, h.prototype.zoomOption = function(c) {
          var p = this.chart, i = p.options.chart;
          p = p.inverted;
          var l = i.zoomType || "";
          /touch/.test(c.type) && (l = w(i.pinchType, l)), this.zoomX = c = /x/.test(l), this.zoomY = i = /y/.test(l), this.zoomHor = c && !p || i && p, this.zoomVert = i && !p || c && p, this.hasZoom = c || i;
        }, h;
      }(), y;
    }), E(a, "Core/MSPointer.js", [a["Core/Globals.js"], a["Core/Pointer.js"], a["Core/Utilities.js"]], function(y, R, I) {
      function Z() {
        var C = [];
        return C.item = function(b) {
          return this[b];
        }, d(O, function(b) {
          C.push({ pageX: b.pageX, pageY: b.pageY, target: b.target });
        }), C;
      }
      function H(C, b, w, x) {
        var h = U[R.hoverChartIndex || NaN];
        C.pointerType !== "touch" && C.pointerType !== C.MSPOINTER_TYPE_TOUCH || !h || (h = h.pointer, x(C), h[b]({ type: w, target: C.currentTarget, preventDefault: N, touches: Z() }));
      }
      var $ = this && this.__extends || function() {
        var C = function(b, w) {
          return C = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(x, h) {
            x.__proto__ = h;
          } || function(x, h) {
            for (var c in h)
              h.hasOwnProperty(c) && (x[c] = h[c]);
          }, C(b, w);
        };
        return function(b, w) {
          function x() {
            this.constructor = b;
          }
          C(b, w), b.prototype = w === null ? Object.create(w) : (x.prototype = w.prototype, new x());
        };
      }(), U = y.charts, W = y.doc, N = y.noop, M = y.win, v = I.addEvent, u = I.css, d = I.objectEach, P = I.removeEvent, O = {}, B = !!M.PointerEvent;
      return function(C) {
        function b() {
          return C !== null && C.apply(this, arguments) || this;
        }
        return $(b, C), b.isRequired = function() {
          return !(y.hasTouch || !M.PointerEvent && !M.MSPointerEvent);
        }, b.prototype.batchMSEvents = function(w) {
          w(this.chart.container, B ? "pointerdown" : "MSPointerDown", this.onContainerPointerDown), w(this.chart.container, B ? "pointermove" : "MSPointerMove", this.onContainerPointerMove), w(W, B ? "pointerup" : "MSPointerUp", this.onDocumentPointerUp);
        }, b.prototype.destroy = function() {
          this.batchMSEvents(P), C.prototype.destroy.call(this);
        }, b.prototype.init = function(w, x) {
          C.prototype.init.call(this, w, x), this.hasZoom && u(w.container, { "-ms-touch-action": "none", "touch-action": "none" });
        }, b.prototype.onContainerPointerDown = function(w) {
          H(w, "onContainerTouchStart", "touchstart", function(x) {
            O[x.pointerId] = { pageX: x.pageX, pageY: x.pageY, target: x.currentTarget };
          });
        }, b.prototype.onContainerPointerMove = function(w) {
          H(w, "onContainerTouchMove", "touchmove", function(x) {
            O[x.pointerId] = {
              pageX: x.pageX,
              pageY: x.pageY
            }, O[x.pointerId].target || (O[x.pointerId].target = x.currentTarget);
          });
        }, b.prototype.onDocumentPointerUp = function(w) {
          H(w, "onDocumentTouchEnd", "touchend", function(x) {
            delete O[x.pointerId];
          });
        }, b.prototype.setDOMEvents = function() {
          C.prototype.setDOMEvents.call(this), (this.hasZoom || this.followTouchMove) && this.batchMSEvents(v);
        }, b;
      }(R);
    }), E(a, "Core/Legend/Legend.js", [
      a["Core/Animation/AnimationUtilities.js"],
      a["Core/FormatUtilities.js"],
      a["Core/Globals.js"],
      a["Core/Series/Point.js"],
      a["Core/Renderer/RendererUtilities.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I, Z, H, $) {
      var U = y.animObject, W = y.setAnimation, N = R.format;
      y = I.isFirefox;
      var M = I.marginNames;
      I = I.win;
      var v = H.distribute, u = $.addEvent, d = $.createElement, P = $.css, O = $.defined, B = $.discardElement, C = $.find, b = $.fireEvent, w = $.isNumber, x = $.merge, h = $.pick, c = $.relativeLength, p = $.stableSort, i = $.syncTimeout;
      return H = $.wrap, $ = function() {
        function l(s, t) {
          this.allItems = [], this.contentGroup = this.box = void 0, this.display = !1, this.group = void 0, this.offsetWidth = this.maxLegendWidth = this.maxItemWidth = this.legendWidth = this.legendHeight = this.lastLineHeight = this.lastItemY = this.itemY = this.itemX = this.itemMarginTop = this.itemMarginBottom = this.itemHeight = this.initialItemY = 0, this.options = {}, this.padding = 0, this.pages = [], this.proximate = !1, this.scrollGroup = void 0, this.widthOption = this.totalItemWidth = this.titleHeight = this.symbolWidth = this.symbolHeight = 0, this.chart = s, this.init(s, t);
        }
        return l.prototype.init = function(s, t) {
          this.chart = s, this.setOptions(t), t.enabled && (this.render(), u(this.chart, "endResize", function() {
            this.legend.positionCheckboxes();
          }), this.proximate ? this.unchartrender = u(this.chart, "render", function() {
            this.legend.proximatePositions(), this.legend.positionItems();
          }) : this.unchartrender && this.unchartrender());
        }, l.prototype.setOptions = function(s) {
          var t = h(s.padding, 8);
          this.options = s, this.chart.styledMode || (this.itemStyle = s.itemStyle, this.itemHiddenStyle = x(this.itemStyle, s.itemHiddenStyle)), this.itemMarginTop = s.itemMarginTop || 0, this.itemMarginBottom = s.itemMarginBottom || 0, this.padding = t, this.initialItemY = t - 5, this.symbolWidth = h(
            s.symbolWidth,
            16
          ), this.pages = [], this.proximate = s.layout === "proximate" && !this.chart.inverted, this.baseline = void 0;
        }, l.prototype.update = function(s, t) {
          var n = this.chart;
          this.setOptions(x(!0, this.options, s)), this.destroy(), n.isDirtyLegend = n.isDirtyBox = !0, h(t, !0) && n.redraw(), b(this, "afterUpdate");
        }, l.prototype.colorizeItem = function(s, t) {
          if (s.legendGroup[t ? "removeClass" : "addClass"]("highcharts-legend-item-hidden"), !this.chart.styledMode) {
            var n = this.options, o = s.legendItem, A = s.legendLine, _ = s.legendSymbol, D = this.itemHiddenStyle.color;
            n = t ? n.itemStyle.color : D;
            var j = t && s.color || D, T = s.options && s.options.marker, X = { fill: j };
            o && o.css({ fill: n, color: n }), A && A.attr({ stroke: j }), _ && (T && _.isMarker && (X = s.pointAttribs(), t || (X.stroke = X.fill = D)), _.attr(X));
          }
          b(this, "afterColorizeItem", { item: s, visible: t });
        }, l.prototype.positionItems = function() {
          this.allItems.forEach(this.positionItem, this), this.chart.isResizing || this.positionCheckboxes();
        }, l.prototype.positionItem = function(s) {
          var t = this, n = this.options, o = n.symbolPadding, A = !n.rtl, _ = s._legendItemPos;
          n = _[0], _ = _[1];
          var D = s.checkbox, j = s.legendGroup;
          j && j.element && (o = { translateX: A ? n : this.legendWidth - n - 2 * o - 4, translateY: _ }, A = function() {
            b(t, "afterPositionItem", { item: s });
          }, O(j.translateY) ? j.animate(o, void 0, A) : (j.attr(o), A())), D && (D.x = n, D.y = _);
        }, l.prototype.destroyItem = function(s) {
          var t = s.checkbox;
          ["legendItem", "legendLine", "legendSymbol", "legendGroup"].forEach(function(n) {
            s[n] && (s[n] = s[n].destroy());
          }), t && B(s.checkbox);
        }, l.prototype.destroy = function() {
          function s(t) {
            this[t] && (this[t] = this[t].destroy());
          }
          this.getAllItems().forEach(function(t) {
            [
              "legendItem",
              "legendGroup"
            ].forEach(s, t);
          }), "clipRect up down pager nav box title group".split(" ").forEach(s, this), this.display = null;
        }, l.prototype.positionCheckboxes = function() {
          var s = this.group && this.group.alignAttr, t = this.clipHeight || this.legendHeight, n = this.titleHeight;
          if (s) {
            var o = s.translateY;
            this.allItems.forEach(function(A) {
              var _ = A.checkbox;
              if (_) {
                var D = o + n + _.y + (this.scrollOffset || 0) + 3;
                P(_, { left: s.translateX + A.checkboxOffset + _.x - 20 + "px", top: D + "px", display: this.proximate || D > o - 6 && D < o + t - 6 ? "" : "none" });
              }
            }, this);
          }
        }, l.prototype.renderTitle = function() {
          var s = this.options, t = this.padding, n = s.title, o = 0;
          n.text && (this.title || (this.title = this.chart.renderer.label(n.text, t - 3, t - 4, null, null, null, s.useHTML, null, "legend-title").attr({ zIndex: 1 }), this.chart.styledMode || this.title.css(n.style), this.title.add(this.group)), n.width || this.title.css({ width: this.maxLegendWidth + "px" }), s = this.title.getBBox(), o = s.height, this.offsetWidth = s.width, this.contentGroup.attr({ translateY: o })), this.titleHeight = o;
        }, l.prototype.setText = function(s) {
          var t = this.options;
          s.legendItem.attr({ text: t.labelFormat ? N(t.labelFormat, s, this.chart) : t.labelFormatter.call(s) });
        }, l.prototype.renderItem = function(s) {
          var t = this.chart, n = t.renderer, o = this.options, A = this.symbolWidth, _ = o.symbolPadding || 0, D = this.itemStyle, j = this.itemHiddenStyle, T = o.layout === "horizontal" ? h(o.itemDistance, 20) : 0, X = !o.rtl, f = !s.series, m = !f && s.series.drawLegendSymbol ? s.series : s, L = m.options, Y = this.createCheckboxForItem && L && L.showCheckbox, F = o.useHTML, Q = s.options.className, k = s.legendItem;
          L = A + _ + T + (Y ? 20 : 0), k || (s.legendGroup = n.g("legend-item").addClass("highcharts-" + m.type + "-series highcharts-color-" + s.colorIndex + (Q ? " " + Q : "") + (f ? " highcharts-series-" + s.index : "")).attr({ zIndex: 1 }).add(this.scrollGroup), s.legendItem = k = n.text("", X ? A + _ : -_, this.baseline || 0, F), t.styledMode || k.css(x(s.visible ? D : j)), k.attr({ align: X ? "left" : "right", zIndex: 2 }).add(s.legendGroup), this.baseline || (this.fontMetrics = n.fontMetrics(t.styledMode ? 12 : D.fontSize, k), this.baseline = this.fontMetrics.f + 3 + this.itemMarginTop, k.attr("y", this.baseline), this.symbolHeight = o.symbolHeight || this.fontMetrics.f, o.squareSymbol && (this.symbolWidth = h(o.symbolWidth, Math.max(this.symbolHeight, 16)), L = this.symbolWidth + _ + T + (Y ? 20 : 0), X && k.attr("x", this.symbolWidth + _))), m.drawLegendSymbol(this, s), this.setItemEvents && this.setItemEvents(s, k, F)), Y && !s.checkbox && this.createCheckboxForItem && this.createCheckboxForItem(s), this.colorizeItem(s, s.visible), !t.styledMode && D.width || k.css({ width: (o.itemWidth || this.widthOption || t.spacingBox.width) - L + "px" }), this.setText(s), t = k.getBBox(), n = this.fontMetrics && this.fontMetrics.h || 0, s.itemWidth = s.checkboxOffset = o.itemWidth || s.legendItemWidth || t.width + L, this.maxItemWidth = Math.max(this.maxItemWidth, s.itemWidth), this.totalItemWidth += s.itemWidth, this.itemHeight = s.itemHeight = Math.round(s.legendItemHeight || (t.height > 1.5 * n ? t.height : n));
        }, l.prototype.layoutItem = function(s) {
          var t = this.options, n = this.padding, o = t.layout === "horizontal", A = s.itemHeight, _ = this.itemMarginBottom, D = this.itemMarginTop, j = o ? h(t.itemDistance, 20) : 0, T = this.maxLegendWidth;
          t = t.alignColumns && this.totalItemWidth > T ? this.maxItemWidth : s.itemWidth, o && this.itemX - n + t > T && (this.itemX = n, this.lastLineHeight && (this.itemY += D + this.lastLineHeight + _), this.lastLineHeight = 0), this.lastItemY = D + this.itemY + _, this.lastLineHeight = Math.max(A, this.lastLineHeight), s._legendItemPos = [this.itemX, this.itemY], o ? this.itemX += t : (this.itemY += D + A + _, this.lastLineHeight = A), this.offsetWidth = this.widthOption || Math.max((o ? this.itemX - n - (s.checkbox ? 0 : j) : t) + n, this.offsetWidth);
        }, l.prototype.getAllItems = function() {
          var s = [];
          return this.chart.series.forEach(function(t) {
            var n = t && t.options;
            t && h(n.showInLegend, O(n.linkedTo) ? !1 : void 0, !0) && (s = s.concat(t.legendItems || (n.legendType === "point" ? t.data : t)));
          }), b(this, "afterGetAllItems", { allItems: s }), s;
        }, l.prototype.getAlignment = function() {
          var s = this.options;
          return this.proximate ? s.align.charAt(0) + "tv" : s.floating ? "" : s.align.charAt(0) + s.verticalAlign.charAt(0) + s.layout.charAt(0);
        }, l.prototype.adjustMargins = function(s, t) {
          var n = this.chart, o = this.options, A = this.getAlignment();
          A && [/(lth|ct|rth)/, /(rtv|rm|rbv)/, /(rbh|cb|lbh)/, /(lbv|lm|ltv)/].forEach(function(_, D) {
            _.test(A) && !O(s[D]) && (n[M[D]] = Math.max(n[M[D]], n.legend[(D + 1) % 2 ? "legendHeight" : "legendWidth"] + [1, -1, -1, 1][D] * o[D % 2 ? "x" : "y"] + h(o.margin, 12) + t[D] + (n.titleOffset[D] || 0)));
          });
        }, l.prototype.proximatePositions = function() {
          var s = this.chart, t = [], n = this.options.align === "left";
          this.allItems.forEach(function(o) {
            var A, _ = n;
            if (o.yAxis) {
              o.xAxis.options.reversed && (_ = !_), o.points && (A = C(_ ? o.points : o.points.slice(0).reverse(), function(j) {
                return w(j.plotY);
              })), _ = this.itemMarginTop + o.legendItem.getBBox().height + this.itemMarginBottom;
              var D = o.yAxis.top - s.plotTop;
              o.visible ? (A = A ? A.plotY : o.yAxis.height, A += D - 0.3 * _) : A = D + o.yAxis.height, t.push({ target: A, size: _, item: o });
            }
          }, this), v(t, s.plotHeight).forEach(function(o) {
            o.item._legendItemPos && (o.item._legendItemPos[1] = s.plotTop - s.spacing[0] + o.pos);
          });
        }, l.prototype.render = function() {
          var s = this.chart, t = s.renderer, n = this.options, o = this.padding, A = this.getAllItems(), _ = this.group, D = this.box;
          this.itemX = o, this.itemY = this.initialItemY, this.lastItemY = this.offsetWidth = 0, this.widthOption = c(n.width, s.spacingBox.width - o);
          var j = s.spacingBox.width - 2 * o - n.x;
          -1 < ["rm", "lm"].indexOf(this.getAlignment().substring(0, 2)) && (j /= 2), this.maxLegendWidth = this.widthOption || j, _ || (this.group = _ = t.g("legend").addClass(n.className || "").attr({ zIndex: 7 }).add(), this.contentGroup = t.g().attr({ zIndex: 1 }).add(_), this.scrollGroup = t.g().add(this.contentGroup)), this.renderTitle(), p(A, function(X, f) {
            return (X.options && X.options.legendIndex || 0) - (f.options && f.options.legendIndex || 0);
          }), n.reversed && A.reverse(), this.allItems = A, this.display = j = !!A.length, this.itemHeight = this.totalItemWidth = this.maxItemWidth = this.lastLineHeight = 0, A.forEach(this.renderItem, this), A.forEach(this.layoutItem, this), A = (this.widthOption || this.offsetWidth) + o;
          var T = this.lastItemY + this.lastLineHeight + this.titleHeight;
          T = this.handleOverflow(T), T += o, D || (this.box = D = t.rect().addClass("highcharts-legend-box").attr({ r: n.borderRadius }).add(_), D.isNew = !0), s.styledMode || D.attr({ stroke: n.borderColor, "stroke-width": n.borderWidth || 0, fill: n.backgroundColor || "none" }).shadow(n.shadow), 0 < A && 0 < T && (D[D.isNew ? "attr" : "animate"](D.crisp.call({}, { x: 0, y: 0, width: A, height: T }, D.strokeWidth())), D.isNew = !1), D[j ? "show" : "hide"](), s.styledMode && _.getStyle("display") === "none" && (A = T = 0), this.legendWidth = A, this.legendHeight = T, j && this.align(), this.proximate || this.positionItems(), b(this, "afterRender");
        }, l.prototype.align = function(s) {
          s === void 0 && (s = this.chart.spacingBox);
          var t = this.chart, n = this.options, o = s.y;
          /(lth|ct|rth)/.test(this.getAlignment()) && 0 < t.titleOffset[0] ? o += t.titleOffset[0] : /(lbh|cb|rbh)/.test(this.getAlignment()) && 0 < t.titleOffset[2] && (o -= t.titleOffset[2]), o !== s.y && (s = x(s, { y: o })), this.group.align(x(n, { width: this.legendWidth, height: this.legendHeight, verticalAlign: this.proximate ? "top" : n.verticalAlign }), !0, s);
        }, l.prototype.handleOverflow = function(s) {
          var t = this, n = this.chart, o = n.renderer, A = this.options, _ = A.y, D = A.verticalAlign === "top", j = this.padding, T = A.maxHeight, X = A.navigation, f = h(X.animation, !0), m = X.arrowSize || 12, L = this.pages, Y = this.allItems, F = function(q) {
            typeof q == "number" ? V.attr({ height: q }) : V && (t.clipRect = V.destroy(), t.contentGroup.clip()), t.contentGroup.div && (t.contentGroup.div.style.clip = q ? "rect(" + j + "px,9999px," + (j + q) + "px,0)" : "auto");
          }, Q = function(q) {
            return t[q] = o.circle(0, 0, 1.3 * m).translate(m / 2, m / 2).add(z), n.styledMode || t[q].attr("fill", "rgba(0,0,0,0.0001)"), t[q];
          }, k, G;
          _ = n.spacingBox.height + (D ? -_ : _) - j;
          var z = this.nav, V = this.clipRect;
          return A.layout !== "horizontal" || A.verticalAlign === "middle" || A.floating || (_ /= 2), T && (_ = Math.min(_, T)), L.length = 0, s && 0 < _ && s > _ && X.enabled !== !1 ? (this.clipHeight = k = Math.max(_ - 20 - this.titleHeight - j, 0), this.currentPage = h(this.currentPage, 1), this.fullHeight = s, Y.forEach(function(q, it) {
            var et = q._legendItemPos[1], nt = Math.round(q.legendItem.getBBox().height), rt = L.length;
            (!rt || et - L[rt - 1] > k && (G || et) !== L[rt - 1]) && (L.push(G || et), rt++), q.pageIx = rt - 1, G && (Y[it - 1].pageIx = rt - 1), it === Y.length - 1 && et + nt - L[rt - 1] > k && nt <= k && (L.push(et), q.pageIx = rt), et !== G && (G = et);
          }), V || (V = t.clipRect = o.clipRect(0, j, 9999, 0), t.contentGroup.clip(V)), F(k), z || (this.nav = z = o.g().attr({ zIndex: 1 }).add(this.group), this.up = o.symbol("triangle", 0, 0, m, m).add(z), Q("upTracker").on(
            "click",
            function() {
              t.scroll(-1, f);
            }
          ), this.pager = o.text("", 15, 10).addClass("highcharts-legend-navigation"), n.styledMode || this.pager.css(X.style), this.pager.add(z), this.down = o.symbol("triangle-down", 0, 0, m, m).add(z), Q("downTracker").on("click", function() {
            t.scroll(1, f);
          })), t.scroll(0), s = _) : z && (F(), this.nav = z.destroy(), this.scrollGroup.attr({ translateY: 1 }), this.clipHeight = 0), s;
        }, l.prototype.scroll = function(s, t) {
          var n = this, o = this.chart, A = this.pages, _ = A.length, D = this.clipHeight, j = this.options.navigation, T = this.pager, X = this.padding, f = this.currentPage + s;
          f > _ && (f = _), 0 < f && (typeof t < "u" && W(t, o), this.nav.attr({ translateX: X, translateY: D + this.padding + 7 + this.titleHeight, visibility: "visible" }), [this.up, this.upTracker].forEach(function(m) {
            m.attr({ class: f === 1 ? "highcharts-legend-nav-inactive" : "highcharts-legend-nav-active" });
          }), T.attr({ text: f + "/" + _ }), [this.down, this.downTracker].forEach(
            function(m) {
              m.attr({ x: 18 + this.pager.getBBox().width, class: f === _ ? "highcharts-legend-nav-inactive" : "highcharts-legend-nav-active" });
            },
            this
          ), o.styledMode || (this.up.attr({ fill: f === 1 ? j.inactiveColor : j.activeColor }), this.upTracker.css({ cursor: f === 1 ? "default" : "pointer" }), this.down.attr({ fill: f === _ ? j.inactiveColor : j.activeColor }), this.downTracker.css({ cursor: f === _ ? "default" : "pointer" })), this.scrollOffset = -A[f - 1] + this.initialItemY, this.scrollGroup.animate({ translateY: this.scrollOffset }), this.currentPage = f, this.positionCheckboxes(), s = U(h(t, o.renderer.globalAnimation, !0)), i(function() {
            b(n, "afterScroll", { currentPage: f });
          }, s.duration));
        }, l.prototype.setItemEvents = function(s, t, n) {
          var o = this, A = o.chart.renderer.boxWrapper, _ = s instanceof Z, D = "highcharts-legend-" + (_ ? "point" : "series") + "-active", j = o.chart.styledMode, T = function(X) {
            o.allItems.forEach(function(f) {
              s !== f && [f].concat(f.linkedSeries || []).forEach(function(m) {
                m.setState(X, !_);
              });
            });
          };
          (n ? [t, s.legendSymbol] : [s.legendGroup]).forEach(function(X) {
            X && X.on("mouseover", function() {
              s.visible && T("inactive"), s.setState("hover"), s.visible && A.addClass(D), j || t.css(o.options.itemHoverStyle);
            }).on("mouseout", function() {
              o.chart.styledMode || t.css(x(s.visible ? o.itemStyle : o.itemHiddenStyle)), T(""), A.removeClass(D), s.setState();
            }).on("click", function(f) {
              var m = function() {
                s.setVisible && s.setVisible(), T(s.visible ? "inactive" : "");
              };
              A.removeClass(D), f = { browserEvent: f }, s.firePointEvent ? s.firePointEvent("legendItemClick", f, m) : b(s, "legendItemClick", f, m);
            });
          });
        }, l.prototype.createCheckboxForItem = function(s) {
          s.checkbox = d(
            "input",
            { type: "checkbox", className: "highcharts-legend-checkbox", checked: s.selected, defaultChecked: s.selected },
            this.options.itemCheckboxStyle,
            this.chart.container
          ), u(s.checkbox, "click", function(t) {
            b(s.series || s, "checkboxClick", { checked: t.target.checked, item: s }, function() {
              s.select();
            });
          });
        }, l;
      }(), (/Trident\/7\.0/.test(I.navigator && I.navigator.userAgent) || y) && H($.prototype, "positionItem", function(l, s) {
        var t = this, n = function() {
          s._legendItemPos && l.call(t, s);
        };
        n(), t.bubbleLegend || setTimeout(n);
      }), $;
    }), E(
      a,
      "Core/Series/SeriesRegistry.js",
      [a["Core/Globals.js"], a["Core/DefaultOptions.js"], a["Core/Series/Point.js"], a["Core/Utilities.js"]],
      function(y, R, I, Z) {
        var H = R.defaultOptions, $ = Z.error, U = Z.extendClass, W = Z.merge, N;
        return function(M) {
          function v(u, d) {
            var P = H.plotOptions || {}, O = d.defaultOptions;
            d.prototype.pointClass || (d.prototype.pointClass = I), d.prototype.type = u, O && (P[u] = O), M.seriesTypes[u] = d;
          }
          M.seriesTypes = y.seriesTypes, M.getSeries = function(u, d) {
            d === void 0 && (d = {});
            var P = u.options.chart;
            P = d.type || P.type || P.defaultSeriesType || "";
            var O = M.seriesTypes[P];
            return M || $(17, !0, u, { missingModuleFor: P }), P = new O(), typeof P.init == "function" && P.init(u, d), P;
          }, M.registerSeriesType = v, M.seriesType = function(u, d, P, O, B) {
            var C = H.plotOptions || {};
            return d = d || "", C[u] = W(C[d], P), v(u, U(M.seriesTypes[d] || function() {
            }, O)), M.seriesTypes[u].prototype.type = u, B && (M.seriesTypes[u].prototype.pointClass = U(I, B)), M.seriesTypes[u];
          };
        }(N || (N = {})), N;
      }
    ), E(a, "Core/Chart/Chart.js", [
      a["Core/Animation/AnimationUtilities.js"],
      a["Core/Axis/Axis.js"],
      a["Core/FormatUtilities.js"],
      a["Core/Foundation.js"],
      a["Core/Globals.js"],
      a["Core/Legend/Legend.js"],
      a["Core/MSPointer.js"],
      a["Core/DefaultOptions.js"],
      a["Core/Pointer.js"],
      a["Core/Renderer/RendererRegistry.js"],
      a["Core/Series/SeriesRegistry.js"],
      a["Core/Renderer/SVG/SVGRenderer.js"],
      a["Core/Time.js"],
      a["Core/Utilities.js"],
      a["Core/Renderer/HTML/AST.js"]
    ], function(y, R, I, Z, H, $, U, W, N, M, v, u, d, P, O) {
      var B = y.animate, C = y.animObject, b = y.setAnimation, w = I.numberFormat, x = Z.registerEventOptions, h = H.charts, c = H.doc, p = H.marginNames, i = H.svg, l = H.win, s = W.defaultOptions, t = W.defaultTime, n = v.seriesTypes, o = P.addEvent, A = P.attr, _ = P.cleanRecursively, D = P.createElement, j = P.css, T = P.defined, X = P.discardElement, f = P.erase, m = P.error, L = P.extend, Y = P.find, F = P.fireEvent, Q = P.getStyle, k = P.isArray, G = P.isNumber, z = P.isObject, V = P.isString, q = P.merge, it = P.objectEach, et = P.pick, nt = P.pInt, rt = P.relativeLength, ct = P.removeEvent, gt = P.splat, dt = P.syncTimeout, lt = P.uniqueKey;
      return y = function() {
        function at(J, tt, st) {
          this.series = this.renderTo = this.renderer = this.pointer = this.pointCount = this.plotWidth = this.plotTop = this.plotLeft = this.plotHeight = this.plotBox = this.options = this.numberFormatter = this.margin = this.legend = this.labelCollectors = this.isResizing = this.index = this.eventOptions = this.container = this.colorCounter = this.clipBox = this.chartWidth = this.chartHeight = this.bounds = this.axisOffset = this.axes = void 0, this.sharedClips = {}, this.yAxis = this.xAxis = this.userOptions = this.titleOffset = this.time = this.symbolCounter = this.spacingBox = this.spacing = void 0, this.getArgs(J, tt, st);
        }
        return at.chart = function(J, tt, st) {
          return new at(J, tt, st);
        }, at.prototype.getArgs = function(J, tt, st) {
          V(J) || J.nodeName ? (this.renderTo = J, this.init(tt, st)) : this.init(J, tt);
        }, at.prototype.init = function(J, tt) {
          var st = J.plotOptions || {};
          F(this, "init", { args: arguments }, function() {
            var ht = q(s, J), pt = ht.chart;
            it(ht.plotOptions, function(yt, vt) {
              z(yt) && (yt.tooltip = st[vt] && q(st[vt].tooltip) || void 0);
            }), ht.tooltip.userOptions = J.chart && J.chart.forExport && J.tooltip.userOptions || J.tooltip, this.userOptions = J, this.margin = [], this.spacing = [], this.bounds = { h: {}, v: {} }, this.labelCollectors = [], this.callback = tt, this.isResizing = 0, this.options = ht, this.axes = [], this.series = [], this.time = J.time && Object.keys(J.time).length ? new d(J.time) : H.time, this.numberFormatter = pt.numberFormatter || w, this.styledMode = pt.styledMode, this.hasCartesianSeries = pt.showAxes, this.index = h.length, h.push(this), H.chartCount++, x(this, pt), this.xAxis = [], this.yAxis = [], this.pointCount = this.colorCounter = this.symbolCounter = 0, F(this, "afterInit"), this.firstRender();
          });
        }, at.prototype.initSeries = function(J) {
          var tt = this.options.chart;
          tt = J.type || tt.type || tt.defaultSeriesType;
          var st = n[tt];
          return st || m(17, !0, this, { missingModuleFor: tt }), tt = new st(), typeof tt.init == "function" && tt.init(this, J), tt;
        }, at.prototype.setSeriesData = function() {
          this.getSeriesOrderByLinks().forEach(function(J) {
            J.points || J.data || !J.enabledDataSorting || J.setData(J.options.data, !1);
          });
        }, at.prototype.getSeriesOrderByLinks = function() {
          return this.series.concat().sort(function(J, tt) {
            return J.linkedSeries.length || tt.linkedSeries.length ? tt.linkedSeries.length - J.linkedSeries.length : 0;
          });
        }, at.prototype.orderSeries = function(J) {
          var tt = this.series;
          J = J || 0;
          for (var st = tt.length; J < st; ++J)
            tt[J] && (tt[J].index = J, tt[J].name = tt[J].getName());
        }, at.prototype.isInsidePlot = function(J, tt, st) {
          st === void 0 && (st = {});
          var ht = this.inverted, pt = this.plotBox, yt = this.plotLeft, vt = this.plotTop, Ct = this.scrollablePlotBox, Tt = 0, kt = 0;
          st.visiblePlotOnly && this.scrollingContainer && (kt = this.scrollingContainer, Tt = kt.scrollLeft, kt = kt.scrollTop);
          var St = st.series;
          if (pt = st.visiblePlotOnly && Ct || pt, Ct = st.inverted ? tt : J, tt = st.inverted ? J : tt, J = { x: Ct, y: tt, isInsidePlot: !0 }, !st.ignoreX) {
            var _t = St && (ht ? St.yAxis : St.xAxis) || { pos: yt, len: 1 / 0 };
            Ct = st.paneCoordinates ? _t.pos + Ct : yt + Ct, Ct >= Math.max(Tt + yt, _t.pos) && Ct <= Math.min(Tt + yt + pt.width, _t.pos + _t.len) || (J.isInsidePlot = !1);
          }
          return !st.ignoreY && J.isInsidePlot && (ht = St && (ht ? St.xAxis : St.yAxis) || { pos: vt, len: 1 / 0 }, st = st.paneCoordinates ? ht.pos + tt : vt + tt, st >= Math.max(kt + vt, ht.pos) && st <= Math.min(kt + vt + pt.height, ht.pos + ht.len) || (J.isInsidePlot = !1)), F(this, "afterIsInsidePlot", J), J.isInsidePlot;
        }, at.prototype.redraw = function(J) {
          F(this, "beforeRedraw");
          var tt = this.hasCartesianSeries ? this.axes : this.colorAxis || [], st = this.series, ht = this.pointer, pt = this.legend, yt = this.userOptions.legend, vt = this.renderer, Ct = vt.isHidden(), Tt = [], kt = this.isDirtyBox, St = this.isDirtyLegend;
          for (this.setResponsive && this.setResponsive(!1), b(this.hasRendered ? J : !1, this), Ct && this.temporaryDisplay(), this.layOutTitles(), J = st.length; J--; ) {
            var _t = st[J];
            if (_t.options.stacking || _t.options.centerInCategory) {
              var Lt = !0;
              if (_t.isDirty) {
                var Nt = !0;
                break;
              }
            }
          }
          if (Nt)
            for (J = st.length; J--; )
              _t = st[J], _t.options.stacking && (_t.isDirty = !0);
          st.forEach(function(Et) {
            Et.isDirty && (Et.options.legendType === "point" ? (typeof Et.updateTotals == "function" && Et.updateTotals(), St = !0) : yt && (yt.labelFormatter || yt.labelFormat) && (St = !0)), Et.isDirtyData && F(Et, "updatedData");
          }), St && pt && pt.options.enabled && (pt.render(), this.isDirtyLegend = !1), Lt && this.getStacks(), tt.forEach(function(Et) {
            Et.updateNames(), Et.setScale();
          }), this.getMargins(), tt.forEach(function(Et) {
            Et.isDirty && (kt = !0);
          }), tt.forEach(function(Et) {
            var Kt = Et.min + "," + Et.max;
            Et.extKey !== Kt && (Et.extKey = Kt, Tt.push(function() {
              F(Et, "afterSetExtremes", L(Et.eventArgs, Et.getExtremes())), delete Et.eventArgs;
            })), (kt || Lt) && Et.redraw();
          }), kt && this.drawChartBox(), F(this, "predraw"), st.forEach(function(Et) {
            (kt || Et.isDirty) && Et.visible && Et.redraw(), Et.isDirtyData = !1;
          }), ht && ht.reset(!0), vt.draw(), F(this, "redraw"), F(this, "render"), Ct && this.temporaryDisplay(!0), Tt.forEach(function(Et) {
            Et.call();
          });
        }, at.prototype.get = function(J) {
          function tt(yt) {
            return yt.id === J || yt.options && yt.options.id === J;
          }
          for (var st = this.series, ht = Y(this.axes, tt) || Y(this.series, tt), pt = 0; !ht && pt < st.length; pt++)
            ht = Y(st[pt].points || [], tt);
          return ht;
        }, at.prototype.getAxes = function() {
          var J = this, tt = this.options, st = tt.xAxis = gt(tt.xAxis || {});
          tt = tt.yAxis = gt(tt.yAxis || {}), F(this, "getAxes"), st.forEach(function(ht, pt) {
            ht.index = pt, ht.isX = !0;
          }), tt.forEach(function(ht, pt) {
            ht.index = pt;
          }), st.concat(tt).forEach(function(ht) {
            new R(J, ht);
          }), F(this, "afterGetAxes");
        }, at.prototype.getSelectedPoints = function() {
          return this.series.reduce(function(J, tt) {
            return tt.getPointsCollection().forEach(function(st) {
              et(st.selectedStaging, st.selected) && J.push(st);
            }), J;
          }, []);
        }, at.prototype.getSelectedSeries = function() {
          return this.series.filter(function(J) {
            return J.selected;
          });
        }, at.prototype.setTitle = function(J, tt, st) {
          this.applyDescription("title", J), this.applyDescription("subtitle", tt), this.applyDescription("caption", void 0), this.layOutTitles(st);
        }, at.prototype.applyDescription = function(J, tt) {
          var st = this, ht = J === "title" ? { color: "#333333", fontSize: this.options.isStock ? "16px" : "18px" } : { color: "#666666" };
          ht = this.options[J] = q(!this.styledMode && { style: ht }, this.options[J], tt);
          var pt = this[J];
          pt && tt && (this[J] = pt = pt.destroy()), ht && !pt && (pt = this.renderer.text(ht.text, 0, 0, ht.useHTML).attr({ align: ht.align, class: "highcharts-" + J, zIndex: ht.zIndex || 4 }).add(), pt.update = function(yt) {
            st[{ title: "setTitle", subtitle: "setSubtitle", caption: "setCaption" }[J]](yt);
          }, this.styledMode || pt.css(ht.style), this[J] = pt);
        }, at.prototype.layOutTitles = function(J) {
          var tt = [0, 0, 0], st = this.renderer, ht = this.spacingBox;
          ["title", "subtitle", "caption"].forEach(function(yt) {
            var vt = this[yt], Ct = this.options[yt], Tt = Ct.verticalAlign || "top";
            yt = yt === "title" ? Tt === "top" ? -3 : 0 : Tt === "top" ? tt[0] + 2 : 0;
            var kt;
            if (vt) {
              this.styledMode || (kt = Ct.style && Ct.style.fontSize), kt = st.fontMetrics(kt, vt).b, vt.css({ width: (Ct.width || ht.width + (Ct.widthAdjust || 0)) + "px" });
              var St = Math.round(vt.getBBox(Ct.useHTML).height);
              vt.align(
                L({ y: Tt === "bottom" ? kt : yt + kt, height: St }, Ct),
                !1,
                "spacingBox"
              ), Ct.floating || (Tt === "top" ? tt[0] = Math.ceil(tt[0] + St) : Tt === "bottom" && (tt[2] = Math.ceil(tt[2] + St)));
            }
          }, this), tt[0] && (this.options.title.verticalAlign || "top") === "top" && (tt[0] += this.options.title.margin), tt[2] && this.options.caption.verticalAlign === "bottom" && (tt[2] += this.options.caption.margin);
          var pt = !this.titleOffset || this.titleOffset.join(",") !== tt.join(",");
          this.titleOffset = tt, F(this, "afterLayOutTitles"), !this.isDirtyBox && pt && (this.isDirtyBox = this.isDirtyLegend = pt, this.hasRendered && et(J, !0) && this.isDirtyBox && this.redraw());
        }, at.prototype.getChartSize = function() {
          var J = this.options.chart, tt = J.width;
          J = J.height;
          var st = this.renderTo;
          T(tt) || (this.containerWidth = Q(st, "width")), T(J) || (this.containerHeight = Q(st, "height")), this.chartWidth = Math.max(0, tt || this.containerWidth || 600), this.chartHeight = Math.max(0, rt(J, this.chartWidth) || (1 < this.containerHeight ? this.containerHeight : 400));
        }, at.prototype.temporaryDisplay = function(J) {
          var tt = this.renderTo;
          if (J)
            for (; tt && tt.style; )
              tt.hcOrigStyle && (j(tt, tt.hcOrigStyle), delete tt.hcOrigStyle), tt.hcOrigDetached && (c.body.removeChild(tt), tt.hcOrigDetached = !1), tt = tt.parentNode;
          else
            for (; tt && tt.style && (c.body.contains(tt) || tt.parentNode || (tt.hcOrigDetached = !0, c.body.appendChild(tt)), (Q(tt, "display", !1) === "none" || tt.hcOricDetached) && (tt.hcOrigStyle = { display: tt.style.display, height: tt.style.height, overflow: tt.style.overflow }, J = { display: "block", overflow: "hidden" }, tt !== this.renderTo && (J.height = 0), j(tt, J), tt.offsetWidth || tt.style.setProperty("display", "block", "important")), tt = tt.parentNode, tt !== c.body); )
              ;
        }, at.prototype.setClassName = function(J) {
          this.container.className = "highcharts-container " + (J || "");
        }, at.prototype.getContainer = function() {
          var J = this.options, tt = J.chart, st = lt(), ht, pt = this.renderTo;
          pt || (this.renderTo = pt = tt.renderTo), V(pt) && (this.renderTo = pt = c.getElementById(pt)), pt || m(13, !0, this);
          var yt = nt(A(pt, "data-highcharts-chart"));
          G(yt) && h[yt] && h[yt].hasRendered && h[yt].destroy(), A(pt, "data-highcharts-chart", this.index), pt.innerHTML = O.emptyHTML, tt.skipClone || pt.offsetWidth || this.temporaryDisplay(), this.getChartSize(), yt = this.chartWidth;
          var vt = this.chartHeight;
          if (j(pt, { overflow: "hidden" }), this.styledMode || (ht = L({ position: "relative", overflow: "hidden", width: yt + "px", height: vt + "px", textAlign: "left", lineHeight: "normal", zIndex: 0, "-webkit-tap-highlight-color": "rgba(0,0,0,0)", userSelect: "none", "touch-action": "manipulation", outline: "none" }, tt.style || {})), this.container = st = D("div", { id: st }, ht, pt), this._cursor = st.style.cursor, this.renderer = new (tt.renderer || !i ? M.getRendererType(tt.renderer) : u)(st, yt, vt, void 0, tt.forExport, J.exporting && J.exporting.allowHTML, this.styledMode), b(
            void 0,
            this
          ), this.setClassName(tt.className), this.styledMode)
            for (var Ct in J.defs)
              this.renderer.definition(J.defs[Ct]);
          else
            this.renderer.setStyle(tt.style);
          this.renderer.chartIndex = this.index, F(this, "afterGetContainer");
        }, at.prototype.getMargins = function(J) {
          var tt = this.spacing, st = this.margin, ht = this.titleOffset;
          this.resetMargins(), ht[0] && !T(st[0]) && (this.plotTop = Math.max(this.plotTop, ht[0] + tt[0])), ht[2] && !T(st[2]) && (this.marginBottom = Math.max(this.marginBottom, ht[2] + tt[2])), this.legend && this.legend.display && this.legend.adjustMargins(
            st,
            tt
          ), F(this, "getMargins"), J || this.getAxisMargins();
        }, at.prototype.getAxisMargins = function() {
          var J = this, tt = J.axisOffset = [0, 0, 0, 0], st = J.colorAxis, ht = J.margin, pt = function(yt) {
            yt.forEach(function(vt) {
              vt.visible && vt.getOffset();
            });
          };
          J.hasCartesianSeries ? pt(J.axes) : st && st.length && pt(st), p.forEach(function(yt, vt) {
            T(ht[vt]) || (J[yt] += tt[vt]);
          }), J.setChartSize();
        }, at.prototype.reflow = function(J) {
          var tt = this, st = tt.options.chart, ht = tt.renderTo, pt = T(st.width) && T(st.height), yt = st.width || Q(ht, "width");
          st = st.height || Q(ht, "height"), ht = J ? J.target : l, delete tt.pointer.chartPosition, !pt && !tt.isPrinting && yt && st && (ht === l || ht === c) && ((yt !== tt.containerWidth || st !== tt.containerHeight) && (P.clearTimeout(tt.reflowTimeout), tt.reflowTimeout = dt(function() {
            tt.container && tt.setSize(void 0, void 0, !1);
          }, J ? 100 : 0)), tt.containerWidth = yt, tt.containerHeight = st);
        }, at.prototype.setReflow = function(J) {
          var tt = this;
          J === !1 || this.unbindReflow ? J === !1 && this.unbindReflow && (this.unbindReflow = this.unbindReflow()) : (this.unbindReflow = o(l, "resize", function(st) {
            tt.options && tt.reflow(st);
          }), o(this, "destroy", this.unbindReflow));
        }, at.prototype.setSize = function(J, tt, st) {
          var ht = this, pt = ht.renderer;
          ht.isResizing += 1, b(st, ht), st = pt.globalAnimation, ht.oldChartHeight = ht.chartHeight, ht.oldChartWidth = ht.chartWidth, typeof J < "u" && (ht.options.chart.width = J), typeof tt < "u" && (ht.options.chart.height = tt), ht.getChartSize(), ht.styledMode || (st ? B : j)(ht.container, { width: ht.chartWidth + "px", height: ht.chartHeight + "px" }, st), ht.setChartSize(!0), pt.setSize(ht.chartWidth, ht.chartHeight, st), ht.axes.forEach(function(yt) {
            yt.isDirty = !0, yt.setScale();
          }), ht.isDirtyLegend = !0, ht.isDirtyBox = !0, ht.layOutTitles(), ht.getMargins(), ht.redraw(st), ht.oldChartHeight = null, F(ht, "resize"), dt(function() {
            ht && F(ht, "endResize", null, function() {
              --ht.isResizing;
            });
          }, C(st).duration);
        }, at.prototype.setChartSize = function(J) {
          var tt = this.inverted, st = this.renderer, ht = this.chartWidth, pt = this.chartHeight, yt = this.options.chart, vt = this.spacing, Ct = this.clipOffset, Tt, kt, St, _t;
          this.plotLeft = Tt = Math.round(this.plotLeft), this.plotTop = kt = Math.round(this.plotTop), this.plotWidth = St = Math.max(0, Math.round(ht - Tt - this.marginRight)), this.plotHeight = _t = Math.max(0, Math.round(pt - kt - this.marginBottom)), this.plotSizeX = tt ? _t : St, this.plotSizeY = tt ? St : _t, this.plotBorderWidth = yt.plotBorderWidth || 0, this.spacingBox = st.spacingBox = { x: vt[3], y: vt[0], width: ht - vt[3] - vt[1], height: pt - vt[0] - vt[2] }, this.plotBox = st.plotBox = { x: Tt, y: kt, width: St, height: _t }, tt = 2 * Math.floor(this.plotBorderWidth / 2), ht = Math.ceil(Math.max(tt, Ct[3]) / 2), pt = Math.ceil(Math.max(tt, Ct[0]) / 2), this.clipBox = { x: ht, y: pt, width: Math.floor(this.plotSizeX - Math.max(tt, Ct[1]) / 2 - ht), height: Math.max(0, Math.floor(this.plotSizeY - Math.max(tt, Ct[2]) / 2 - pt)) }, J || (this.axes.forEach(function(Lt) {
            Lt.setAxisSize(), Lt.setAxisTranslation();
          }), st.alignElements()), F(this, "afterSetChartSize", { skipAxes: J });
        }, at.prototype.resetMargins = function() {
          F(this, "resetMargins");
          var J = this, tt = J.options.chart;
          ["margin", "spacing"].forEach(function(st) {
            var ht = tt[st], pt = z(ht) ? ht : [ht, ht, ht, ht];
            ["Top", "Right", "Bottom", "Left"].forEach(function(yt, vt) {
              J[st][vt] = et(tt[st + yt], pt[vt]);
            });
          }), p.forEach(function(st, ht) {
            J[st] = et(J.margin[ht], J.spacing[ht]);
          }), J.axisOffset = [0, 0, 0, 0], J.clipOffset = [0, 0, 0, 0];
        }, at.prototype.drawChartBox = function() {
          var J = this.options.chart, tt = this.renderer, st = this.chartWidth, ht = this.chartHeight, pt = this.styledMode, yt = this.plotBGImage, vt = J.backgroundColor, Ct = J.plotBackgroundColor, Tt = J.plotBackgroundImage, kt = this.plotLeft, St = this.plotTop, _t = this.plotWidth, Lt = this.plotHeight, Nt = this.plotBox, Et = this.clipRect, Kt = this.clipBox, Gt = this.chartBackground, Wt = this.plotBackground, Jt = this.plotBorder, be, zt = "animate";
          if (Gt || (this.chartBackground = Gt = tt.rect().addClass("highcharts-background").add(), zt = "attr"), pt)
            var Vt = be = Gt.strokeWidth();
          else
            Vt = J.borderWidth || 0, be = Vt + (J.shadow ? 8 : 0), vt = { fill: vt || "none" }, (Vt || Gt["stroke-width"]) && (vt.stroke = J.borderColor, vt["stroke-width"] = Vt), Gt.attr(vt).shadow(J.shadow);
          Gt[zt]({ x: be / 2, y: be / 2, width: st - be - Vt % 2, height: ht - be - Vt % 2, r: J.borderRadius }), zt = "animate", Wt || (zt = "attr", this.plotBackground = Wt = tt.rect().addClass("highcharts-plot-background").add()), Wt[zt](Nt), pt || (Wt.attr({ fill: Ct || "none" }).shadow(J.plotShadow), Tt && (yt ? (Tt !== yt.attr("href") && yt.attr("href", Tt), yt.animate(Nt)) : this.plotBGImage = tt.image(Tt, kt, St, _t, Lt).add())), Et ? Et.animate({ width: Kt.width, height: Kt.height }) : this.clipRect = tt.clipRect(Kt), zt = "animate", Jt || (zt = "attr", this.plotBorder = Jt = tt.rect().addClass("highcharts-plot-border").attr({ zIndex: 1 }).add()), pt || Jt.attr({ stroke: J.plotBorderColor, "stroke-width": J.plotBorderWidth || 0, fill: "none" }), Jt[zt](Jt.crisp({ x: kt, y: St, width: _t, height: Lt }, -Jt.strokeWidth())), this.isDirtyBox = !1, F(this, "afterDrawChartBox");
        }, at.prototype.propFromSeries = function() {
          var J = this, tt = J.options.chart, st = J.options.series, ht, pt, yt;
          ["inverted", "angular", "polar"].forEach(function(vt) {
            for (pt = n[tt.type || tt.defaultSeriesType], yt = tt[vt] || pt && pt.prototype[vt], ht = st && st.length; !yt && ht--; )
              (pt = n[st[ht].type]) && pt.prototype[vt] && (yt = !0);
            J[vt] = yt;
          });
        }, at.prototype.linkSeries = function() {
          var J = this, tt = J.series;
          tt.forEach(function(st) {
            st.linkedSeries.length = 0;
          }), tt.forEach(function(st) {
            var ht = st.options.linkedTo;
            V(ht) && (ht = ht === ":previous" ? J.series[st.index - 1] : J.get(ht)) && ht.linkedParent !== st && (ht.linkedSeries.push(st), st.linkedParent = ht, ht.enabledDataSorting && st.setDataSortingOptions(), st.visible = et(st.options.visible, ht.options.visible, st.visible));
          }), F(this, "afterLinkSeries");
        }, at.prototype.renderSeries = function() {
          this.series.forEach(function(J) {
            J.translate(), J.render();
          });
        }, at.prototype.renderLabels = function() {
          var J = this, tt = J.options.labels;
          tt.items && tt.items.forEach(function(st) {
            var ht = L(tt.style, st.style), pt = nt(ht.left) + J.plotLeft, yt = nt(ht.top) + J.plotTop + 12;
            delete ht.left, delete ht.top, J.renderer.text(st.html, pt, yt).attr({ zIndex: 2 }).css(ht).add();
          });
        }, at.prototype.render = function() {
          var J = this.axes, tt = this.colorAxis, st = this.renderer, ht = this.options, pt = function(kt) {
            kt.forEach(function(St) {
              St.visible && St.render();
            });
          }, yt = 0;
          this.setTitle(), this.legend = new $(this, ht.legend), this.getStacks && this.getStacks(), this.getMargins(!0), this.setChartSize(), ht = this.plotWidth, J.some(function(kt) {
            if (kt.horiz && kt.visible && kt.options.labels.enabled && kt.series.length)
              return yt = 21, !0;
          });
          var vt = this.plotHeight = Math.max(this.plotHeight - yt, 0);
          J.forEach(function(kt) {
            kt.setScale();
          }), this.getAxisMargins();
          var Ct = 1.1 < ht / this.plotWidth, Tt = 1.05 < vt / this.plotHeight;
          (Ct || Tt) && (J.forEach(function(kt) {
            (kt.horiz && Ct || !kt.horiz && Tt) && kt.setTickInterval(!0);
          }), this.getMargins()), this.drawChartBox(), this.hasCartesianSeries ? pt(J) : tt && tt.length && pt(tt), this.seriesGroup || (this.seriesGroup = st.g("series-group").attr({ zIndex: 3 }).add()), this.renderSeries(), this.renderLabels(), this.addCredits(), this.setResponsive && this.setResponsive(), this.hasRendered = !0;
        }, at.prototype.addCredits = function(J) {
          var tt = this, st = q(!0, this.options.credits, J);
          st.enabled && !this.credits && (this.credits = this.renderer.text(st.text + (this.mapCredits || ""), 0, 0).addClass("highcharts-credits").on("click", function() {
            st.href && (l.location.href = st.href);
          }).attr({ align: st.position.align, zIndex: 8 }), tt.styledMode || this.credits.css(st.style), this.credits.add().align(st.position), this.credits.update = function(ht) {
            tt.credits = tt.credits.destroy(), tt.addCredits(ht);
          });
        }, at.prototype.destroy = function() {
          var J = this, tt = J.axes, st = J.series, ht = J.container, pt = ht && ht.parentNode, yt;
          for (F(J, "destroy"), J.renderer.forExport ? f(h, J) : h[J.index] = void 0, H.chartCount--, J.renderTo.removeAttribute("data-highcharts-chart"), ct(J), yt = tt.length; yt--; )
            tt[yt] = tt[yt].destroy();
          for (this.scroller && this.scroller.destroy && this.scroller.destroy(), yt = st.length; yt--; )
            st[yt] = st[yt].destroy();
          "title subtitle chartBackground plotBackground plotBGImage plotBorder seriesGroup clipRect credits pointer rangeSelector legend resetZoomButton tooltip renderer".split(" ").forEach(function(vt) {
            var Ct = J[vt];
            Ct && Ct.destroy && (J[vt] = Ct.destroy());
          }), ht && (ht.innerHTML = O.emptyHTML, ct(ht), pt && X(ht)), it(J, function(vt, Ct) {
            delete J[Ct];
          });
        }, at.prototype.firstRender = function() {
          var J = this, tt = J.options;
          (!J.isReadyToRender || J.isReadyToRender()) && (J.getContainer(), J.resetMargins(), J.setChartSize(), J.propFromSeries(), J.getAxes(), (k(tt.series) ? tt.series : []).forEach(function(st) {
            J.initSeries(st);
          }), J.linkSeries(), J.setSeriesData(), F(J, "beforeRender"), N && (U.isRequired() ? J.pointer = new U(J, tt) : J.pointer = new N(J, tt)), J.render(), J.pointer.getChartPosition(), !J.renderer.imgCount && !J.hasLoaded && J.onload(), J.temporaryDisplay(!0));
        }, at.prototype.onload = function() {
          this.callbacks.concat([this.callback]).forEach(function(J) {
            J && typeof this.index < "u" && J.apply(this, [this]);
          }, this), F(this, "load"), F(this, "render"), T(this.index) && this.setReflow(this.options.chart.reflow), this.hasLoaded = !0;
        }, at.prototype.addSeries = function(J, tt, st) {
          var ht = this, pt;
          return J && (tt = et(tt, !0), F(ht, "addSeries", { options: J }, function() {
            pt = ht.initSeries(J), ht.isDirtyLegend = !0, ht.linkSeries(), pt.enabledDataSorting && pt.setData(J.data, !1), F(ht, "afterAddSeries", { series: pt }), tt && ht.redraw(st);
          })), pt;
        }, at.prototype.addAxis = function(J, tt, st, ht) {
          return this.createAxis(tt ? "xAxis" : "yAxis", { axis: J, redraw: st, animation: ht });
        }, at.prototype.addColorAxis = function(J, tt, st) {
          return this.createAxis("colorAxis", { axis: J, redraw: tt, animation: st });
        }, at.prototype.createAxis = function(J, tt) {
          return J = new R(this, q(tt.axis, { index: this[J].length, isX: J === "xAxis" })), et(tt.redraw, !0) && this.redraw(tt.animation), J;
        }, at.prototype.showLoading = function(J) {
          var tt = this, st = tt.options, ht = st.loading, pt = function() {
            yt && j(yt, { left: tt.plotLeft + "px", top: tt.plotTop + "px", width: tt.plotWidth + "px", height: tt.plotHeight + "px" });
          }, yt = tt.loadingDiv, vt = tt.loadingSpan;
          yt || (tt.loadingDiv = yt = D("div", { className: "highcharts-loading highcharts-loading-hidden" }, null, tt.container)), vt || (tt.loadingSpan = vt = D(
            "span",
            { className: "highcharts-loading-inner" },
            null,
            yt
          ), o(tt, "redraw", pt)), yt.className = "highcharts-loading", O.setElementHTML(vt, et(J, st.lang.loading, "")), tt.styledMode || (j(yt, L(ht.style, { zIndex: 10 })), j(vt, ht.labelStyle), tt.loadingShown || (j(yt, { opacity: 0, display: "" }), B(yt, { opacity: ht.style.opacity || 0.5 }, { duration: ht.showDuration || 0 }))), tt.loadingShown = !0, pt();
        }, at.prototype.hideLoading = function() {
          var J = this.options, tt = this.loadingDiv;
          tt && (tt.className = "highcharts-loading highcharts-loading-hidden", this.styledMode || B(tt, { opacity: 0 }, {
            duration: J.loading.hideDuration || 100,
            complete: function() {
              j(tt, { display: "none" });
            }
          })), this.loadingShown = !1;
        }, at.prototype.update = function(J, tt, st, ht) {
          var pt = this, yt = { credits: "addCredits", title: "setTitle", subtitle: "setSubtitle", caption: "setCaption" }, vt = J.isResponsiveOptions, Ct = [], Tt, kt;
          F(pt, "update", { options: J }), vt || pt.setResponsive(!1, !0), J = _(J, pt.options), pt.userOptions = q(pt.userOptions, J);
          var St = J.chart;
          if (St) {
            if (q(!0, pt.options.chart, St), "className" in St && pt.setClassName(St.className), "reflow" in St && pt.setReflow(St.reflow), "inverted" in St || "polar" in St || "type" in St) {
              pt.propFromSeries();
              var _t = !0;
            }
            "alignTicks" in St && (_t = !0), "events" in St && x(this, St), it(St, function(Lt, Nt) {
              pt.propsRequireUpdateSeries.indexOf("chart." + Nt) !== -1 && (Tt = !0), pt.propsRequireDirtyBox.indexOf(Nt) !== -1 && (pt.isDirtyBox = !0), pt.propsRequireReflow.indexOf(Nt) !== -1 && (vt ? pt.isDirtyBox = !0 : kt = !0);
            }), !pt.styledMode && St.style && pt.renderer.setStyle(pt.options.chart.style || {});
          }
          !pt.styledMode && J.colors && (this.options.colors = J.colors), J.time && (this.time === t && (this.time = new d(J.time)), q(!0, pt.options.time, J.time)), it(J, function(Lt, Nt) {
            pt[Nt] && typeof pt[Nt].update == "function" ? pt[Nt].update(Lt, !1) : typeof pt[yt[Nt]] == "function" ? pt[yt[Nt]](Lt) : Nt !== "colors" && pt.collectionsWithUpdate.indexOf(Nt) === -1 && q(!0, pt.options[Nt], J[Nt]), Nt !== "chart" && pt.propsRequireUpdateSeries.indexOf(Nt) !== -1 && (Tt = !0);
          }), this.collectionsWithUpdate.forEach(function(Lt) {
            if (J[Lt]) {
              var Nt = [];
              pt[Lt].forEach(function(Et, Kt) {
                Et.options.isInternal || Nt.push(et(Et.options.index, Kt));
              }), gt(J[Lt]).forEach(function(Et, Kt) {
                var Gt = T(Et.id), Wt;
                Gt && (Wt = pt.get(Et.id)), !Wt && pt[Lt] && (Wt = pt[Lt][Nt ? Nt[Kt] : Kt]) && Gt && T(Wt.options.id) && (Wt = void 0), Wt && Wt.coll === Lt && (Wt.update(Et, !1), st && (Wt.touched = !0)), !Wt && st && pt.collectionsWithInit[Lt] && (pt.collectionsWithInit[Lt][0].apply(pt, [Et].concat(pt.collectionsWithInit[Lt][1] || []).concat([!1])).touched = !0);
              }), st && pt[Lt].forEach(function(Et) {
                Et.touched || Et.options.isInternal ? delete Et.touched : Ct.push(Et);
              });
            }
          }), Ct.forEach(function(Lt) {
            Lt.chart && Lt.remove && Lt.remove(!1);
          }), _t && pt.axes.forEach(function(Lt) {
            Lt.update({}, !1);
          }), Tt && pt.getSeriesOrderByLinks().forEach(function(Lt) {
            Lt.chart && Lt.update({}, !1);
          }, this), _t = St && St.width, St = St && (V(St.height) ? rt(St.height, _t || pt.chartWidth) : St.height), kt || G(_t) && _t !== pt.chartWidth || G(St) && St !== pt.chartHeight ? pt.setSize(_t, St, ht) : et(tt, !0) && pt.redraw(ht), F(pt, "afterUpdate", { options: J, redraw: tt, animation: ht });
        }, at.prototype.setSubtitle = function(J, tt) {
          this.applyDescription("subtitle", J), this.layOutTitles(tt);
        }, at.prototype.setCaption = function(J, tt) {
          this.applyDescription("caption", J), this.layOutTitles(tt);
        }, at.prototype.showResetZoom = function() {
          function J() {
            tt.zoomOut();
          }
          var tt = this, st = s.lang, ht = tt.options.chart.resetZoomButton, pt = ht.theme, yt = pt.states, vt = ht.relativeTo === "chart" || ht.relativeTo === "spacingBox" ? null : "scrollablePlotBox";
          F(this, "beforeShowResetZoom", null, function() {
            tt.resetZoomButton = tt.renderer.button(st.resetZoom, null, null, J, pt, yt && yt.hover).attr({ align: ht.position.align, title: st.resetZoomTitle }).addClass("highcharts-reset-zoom").add().align(ht.position, !1, vt);
          }), F(this, "afterShowResetZoom");
        }, at.prototype.zoomOut = function() {
          F(this, "selection", { resetSelection: !0 }, this.zoom);
        }, at.prototype.zoom = function(J) {
          var tt = this, st = tt.pointer, ht = tt.inverted ? st.mouseDownX : st.mouseDownY, pt = !1, yt;
          !J || J.resetSelection ? (tt.axes.forEach(function(Ct) {
            yt = Ct.zoom();
          }), st.initiated = !1) : J.xAxis.concat(J.yAxis).forEach(function(Ct) {
            var Tt = Ct.axis, kt = tt.inverted ? Tt.left : Tt.top, St = tt.inverted ? kt + Tt.width : kt + Tt.height, _t = Tt.isXAxis, Lt = !1;
            (!_t && ht >= kt && ht <= St || _t || !T(ht)) && (Lt = !0), st[_t ? "zoomX" : "zoomY"] && Lt && (yt = Tt.zoom(Ct.min, Ct.max), Tt.displayBtn && (pt = !0));
          });
          var vt = tt.resetZoomButton;
          pt && !vt ? tt.showResetZoom() : !pt && z(vt) && (tt.resetZoomButton = vt.destroy()), yt && tt.redraw(et(
            tt.options.chart.animation,
            J && J.animation,
            100 > tt.pointCount
          ));
        }, at.prototype.pan = function(J, tt) {
          var st = this, ht = st.hoverPoints;
          tt = typeof tt == "object" ? tt : { enabled: tt, type: "x" };
          var pt = st.options.chart, yt = st.options.mapNavigation && st.options.mapNavigation.enabled;
          pt && pt.panning && (pt.panning = tt);
          var vt = tt.type, Ct;
          F(this, "pan", { originalEvent: J }, function() {
            ht && ht.forEach(function(St) {
              St.setState();
            });
            var Tt = st.xAxis;
            vt === "xy" ? Tt = Tt.concat(st.yAxis) : vt === "y" && (Tt = st.yAxis);
            var kt = {};
            Tt.forEach(function(St) {
              if (St.options.panningEnabled && !St.options.isInternal) {
                var _t = St.horiz, Lt = J[_t ? "chartX" : "chartY"];
                _t = _t ? "mouseDownX" : "mouseDownY";
                var Nt = st[_t], Et = St.minPointOffset || 0, Kt = St.reversed && !st.inverted || !St.reversed && st.inverted ? -1 : 1, Gt = St.getExtremes(), Wt = St.toValue(Nt - Lt, !0) + Et * Kt, Jt = St.toValue(Nt + St.len - Lt, !0) - (Et * Kt || St.isXAxis && St.pointRangePadding || 0), be = Jt < Wt;
                Kt = St.hasVerticalPanning(), Nt = be ? Jt : Wt, Wt = be ? Wt : Jt;
                var zt = St.panningState;
                !Kt || St.isXAxis || zt && !zt.isDirty || St.series.forEach(function(Vt) {
                  var Me = Vt.getProcessedData(!0);
                  Me = Vt.getExtremes(Me.yData, !0), zt || (zt = { startMin: Number.MAX_VALUE, startMax: -Number.MAX_VALUE }), G(Me.dataMin) && G(Me.dataMax) && (zt.startMin = Math.min(et(Vt.options.threshold, 1 / 0), Me.dataMin, zt.startMin), zt.startMax = Math.max(et(Vt.options.threshold, -1 / 0), Me.dataMax, zt.startMax));
                }), Kt = Math.min(et(zt && zt.startMin, Gt.dataMin), Et ? Gt.min : St.toValue(St.toPixels(Gt.min) - St.minPixelPadding)), Jt = Math.max(et(zt && zt.startMax, Gt.dataMax), Et ? Gt.max : St.toValue(St.toPixels(Gt.max) + St.minPixelPadding)), St.panningState = zt, St.isOrdinal || (Et = Kt - Nt, 0 < Et && (Wt += Et, Nt = Kt), Et = Wt - Jt, 0 < Et && (Wt = Jt, Nt -= Et), St.series.length && Nt !== Gt.min && Wt !== Gt.max && Nt >= Kt && Wt <= Jt && (St.setExtremes(Nt, Wt, !1, !1, { trigger: "pan" }), st.resetZoomButton || yt || Nt === Kt || Wt === Jt || !vt.match("y") || (st.showResetZoom(), St.displayBtn = !1), Ct = !0), kt[_t] = Lt);
              }
            }), it(kt, function(St, _t) {
              st[_t] = St;
            }), Ct && st.redraw(!1), j(st.container, { cursor: "move" });
          });
        }, at;
      }(), L(y.prototype, {
        callbacks: [],
        collectionsWithInit: { xAxis: [y.prototype.addAxis, [!0]], yAxis: [y.prototype.addAxis, [!1]], series: [y.prototype.addSeries] },
        collectionsWithUpdate: ["xAxis", "yAxis", "series"],
        propsRequireDirtyBox: "backgroundColor borderColor borderWidth borderRadius plotBackgroundColor plotBackgroundImage plotBorderColor plotBorderWidth plotShadow shadow".split(" "),
        propsRequireReflow: "margin marginTop marginRight marginBottom marginLeft spacing spacingTop spacingRight spacingBottom spacingLeft".split(" "),
        propsRequireUpdateSeries: "chart.inverted chart.polar chart.ignoreHiddenSeries chart.type colors plotOptions time tooltip".split(" ")
      }), y;
    }), E(a, "Core/Legend/LegendSymbol.js", [a["Core/Utilities.js"]], function(y) {
      var R = y.merge, I = y.pick, Z;
      return function(H) {
        H.drawLineMarker = function($) {
          var U = this.options, W = $.symbolWidth, N = $.symbolHeight, M = N / 2, v = this.chart.renderer, u = this.legendGroup;
          $ = $.baseline - Math.round(0.3 * $.fontMetrics.b);
          var d = {}, P = U.marker;
          this.chart.styledMode || (d = { "stroke-width": U.lineWidth || 0 }, U.dashStyle && (d.dashstyle = U.dashStyle)), this.legendLine = v.path([["M", 0, $], ["L", W, $]]).addClass("highcharts-graph").attr(d).add(u), P && P.enabled !== !1 && W && (U = Math.min(I(P.radius, M), M), this.symbol.indexOf("url") === 0 && (P = R(P, { width: N, height: N }), U = 0), this.legendSymbol = W = v.symbol(this.symbol, W / 2 - U, $ - U, 2 * U, 2 * U, P).addClass("highcharts-point").add(u), W.isMarker = !0);
        }, H.drawRectangle = function($, U) {
          var W = $.symbolHeight, N = $.options.squareSymbol;
          U.legendSymbol = this.chart.renderer.rect(N ? ($.symbolWidth - W) / 2 : 0, $.baseline - W + 1, N ? W : $.symbolWidth, W, I($.options.symbolRadius, W / 2)).addClass("highcharts-point").attr({ zIndex: 3 }).add(U.legendGroup);
        };
      }(Z || (Z = {})), Z;
    }), E(a, "Core/Series/SeriesDefaults.js", [], function() {
      return { lineWidth: 2, allowPointSelect: !1, crisp: !0, showCheckbox: !1, animation: { duration: 1e3 }, events: {}, marker: { enabledThreshold: 2, lineColor: "#ffffff", lineWidth: 0, radius: 4, states: {
        normal: { animation: !0 },
        hover: { animation: { duration: 50 }, enabled: !0, radiusPlus: 2, lineWidthPlus: 1 },
        select: { fillColor: "#cccccc", lineColor: "#000000", lineWidth: 2 }
      } }, point: { events: {} }, dataLabels: { animation: {}, align: "center", defer: !0, formatter: function() {
        var y = this.series.chart.numberFormatter;
        return typeof this.y != "number" ? "" : y(this.y, -1);
      }, padding: 5, style: { fontSize: "11px", fontWeight: "bold", color: "contrast", textOutline: "1px contrast" }, verticalAlign: "bottom", x: 0, y: 0 }, cropThreshold: 300, opacity: 1, pointRange: 0, softThreshold: !0, states: {
        normal: { animation: !0 },
        hover: { animation: { duration: 50 }, lineWidthPlus: 1, marker: {}, halo: { size: 10, opacity: 0.25 } },
        select: { animation: { duration: 0 } },
        inactive: { animation: { duration: 50 }, opacity: 0.2 }
      }, stickyTracking: !0, turboThreshold: 1e3, findNearestPointBy: "x" };
    }), E(a, "Core/Series/Series.js", [
      a["Core/Animation/AnimationUtilities.js"],
      a["Core/DefaultOptions.js"],
      a["Core/Foundation.js"],
      a["Core/Globals.js"],
      a["Core/Legend/LegendSymbol.js"],
      a["Core/Series/Point.js"],
      a["Core/Series/SeriesDefaults.js"],
      a["Core/Series/SeriesRegistry.js"],
      a["Core/Renderer/SVG/SVGElement.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I, Z, H, $, U, W, N, M) {
      var v = y.animObject, u = y.setAnimation, d = R.defaultOptions, P = I.registerEventOptions, O = Z.hasTouch, B = Z.svg, C = Z.win, b = W.seriesTypes, w = M.addEvent, x = M.arrayMax, h = M.arrayMin, c = M.clamp, p = M.cleanRecursively, i = M.correctFloat, l = M.defined, s = M.erase, t = M.error, n = M.extend, o = M.find, A = M.fireEvent, _ = M.getNestedProperty, D = M.isArray, j = M.isNumber, T = M.isString, X = M.merge, f = M.objectEach, m = M.pick, L = M.removeEvent, Y = M.splat, F = M.syncTimeout;
      return y = function() {
        function Q() {
          this.zones = this.yAxis = this.xAxis = this.userOptions = this.tooltipOptions = this.processedYData = this.processedXData = this.points = this.options = this.linkedSeries = this.index = this.eventsToUnbind = this.eventOptions = this.data = this.chart = this._i = void 0;
        }
        return Q.prototype.init = function(k, G) {
          A(this, "init", { options: G });
          var z = this, V = k.series;
          this.eventsToUnbind = [], z.chart = k, z.options = z.setOptions(G), G = z.options, z.linkedSeries = [], z.bindAxes(), n(z, { name: G.name, state: "", visible: G.visible !== !1, selected: G.selected === !0 }), P(this, G);
          var q = G.events;
          (q && q.click || G.point && G.point.events && G.point.events.click || G.allowPointSelect) && (k.runTrackerClick = !0), z.getColor(), z.getSymbol(), z.parallelArrays.forEach(function(et) {
            z[et + "Data"] || (z[et + "Data"] = []);
          }), z.isCartesian && (k.hasCartesianSeries = !0);
          var it;
          V.length && (it = V[V.length - 1]), z._i = m(it && it._i, -1) + 1, z.opacity = z.options.opacity, k.orderSeries(this.insert(V)), G.dataSorting && G.dataSorting.enabled ? z.setDataSortingOptions() : z.points || z.data || z.setData(G.data, !1), A(this, "afterInit");
        }, Q.prototype.is = function(k) {
          return b[k] && this instanceof b[k];
        }, Q.prototype.insert = function(k) {
          var G = this.options.index, z;
          if (j(G)) {
            for (z = k.length; z--; )
              if (G >= m(k[z].options.index, k[z]._i)) {
                k.splice(z + 1, 0, this);
                break;
              }
            z === -1 && k.unshift(this), z += 1;
          } else
            k.push(this);
          return m(z, k.length - 1);
        }, Q.prototype.bindAxes = function() {
          var k = this, G = k.options, z = k.chart, V;
          A(this, "bindAxes", null, function() {
            (k.axisTypes || []).forEach(function(q) {
              var it = 0;
              z[q].forEach(function(et) {
                V = et.options, (G[q] === it && !V.isInternal || typeof G[q] < "u" && G[q] === V.id || typeof G[q] > "u" && V.index === 0) && (k.insert(et.series), k[q] = et, et.isDirty = !0), V.isInternal || it++;
              }), k[q] || k.optionalAxis === q || t(18, !0, z);
            });
          }), A(this, "afterBindAxes");
        }, Q.prototype.updateParallelArrays = function(k, G) {
          var z = k.series, V = arguments, q = j(G) ? function(it) {
            var et = it === "y" && z.toYData ? z.toYData(k) : k[it];
            z[it + "Data"][G] = et;
          } : function(it) {
            Array.prototype[G].apply(z[it + "Data"], Array.prototype.slice.call(V, 2));
          };
          z.parallelArrays.forEach(q);
        }, Q.prototype.hasData = function() {
          return this.visible && typeof this.dataMax < "u" && typeof this.dataMin < "u" || this.visible && this.yData && 0 < this.yData.length;
        }, Q.prototype.autoIncrement = function(k) {
          var G = this.options, z = G.pointIntervalUnit, V = G.relativeXValue, q = this.chart.time, it = this.xIncrement, et;
          return it = m(it, G.pointStart, 0), this.pointInterval = et = m(this.pointInterval, G.pointInterval, 1), V && j(k) && (et *= k), z && (G = new q.Date(it), z === "day" ? q.set("Date", G, q.get("Date", G) + et) : z === "month" ? q.set("Month", G, q.get("Month", G) + et) : z === "year" && q.set("FullYear", G, q.get("FullYear", G) + et), et = G.getTime() - it), V && j(k) ? it + et : (this.xIncrement = it + et, it);
        }, Q.prototype.setDataSortingOptions = function() {
          var k = this.options;
          n(this, { requireSorting: !1, sorted: !1, enabledDataSorting: !0, allowDG: !1 }), l(k.pointRange) || (k.pointRange = 1);
        }, Q.prototype.setOptions = function(k) {
          var G = this.chart, z = G.options, V = z.plotOptions, q = G.userOptions || {};
          k = X(k), G = G.styledMode;
          var it = { plotOptions: V, userOptions: k };
          A(this, "setOptions", it);
          var et = it.plotOptions[this.type], nt = q.plotOptions || {};
          return this.userOptions = it.userOptions, q = X(et, V.series, q.plotOptions && q.plotOptions[this.type], k), this.tooltipOptions = X(d.tooltip, d.plotOptions.series && d.plotOptions.series.tooltip, d.plotOptions[this.type].tooltip, z.tooltip.userOptions, V.series && V.series.tooltip, V[this.type].tooltip, k.tooltip), this.stickyTracking = m(k.stickyTracking, nt[this.type] && nt[this.type].stickyTracking, nt.series && nt.series.stickyTracking, this.tooltipOptions.shared && !this.noSharedTooltip ? !0 : q.stickyTracking), et.marker === null && delete q.marker, this.zoneAxis = q.zoneAxis, V = this.zones = (q.zones || []).slice(), !q.negativeColor && !q.negativeFillColor || q.zones || (z = { value: q[this.zoneAxis + "Threshold"] || q.threshold || 0, className: "highcharts-negative" }, G || (z.color = q.negativeColor, z.fillColor = q.negativeFillColor), V.push(z)), V.length && l(V[V.length - 1].value) && V.push(G ? {} : { color: this.color, fillColor: this.fillColor }), A(this, "afterSetOptions", { options: q }), q;
        }, Q.prototype.getName = function() {
          return m(this.options.name, "Series " + (this.index + 1));
        }, Q.prototype.getCyclic = function(k, G, z) {
          var V = this.chart, q = this.userOptions, it = k + "Index", et = k + "Counter", nt = z ? z.length : m(V.options.chart[k + "Count"], V[k + "Count"]);
          if (!G) {
            var rt = m(q[it], q["_" + it]);
            l(rt) || (V.series.length || (V[et] = 0), q["_" + it] = rt = V[et] % nt, V[et] += 1), z && (G = z[rt]);
          }
          typeof rt < "u" && (this[it] = rt), this[k] = G;
        }, Q.prototype.getColor = function() {
          this.chart.styledMode ? this.getCyclic("color") : this.options.colorByPoint ? this.color = "#cccccc" : this.getCyclic("color", this.options.color || d.plotOptions[this.type].color, this.chart.options.colors);
        }, Q.prototype.getPointsCollection = function() {
          return (this.hasGroupedData ? this.points : this.data) || [];
        }, Q.prototype.getSymbol = function() {
          this.getCyclic("symbol", this.options.marker.symbol, this.chart.options.symbols);
        }, Q.prototype.findPointIndex = function(k, G) {
          var z = k.id, V = k.x, q = this.points, it = this.options.dataSorting, et, nt;
          if (z)
            it = this.chart.get(z), it instanceof $ && (et = it);
          else if ((this.linkedParent || this.enabledDataSorting || this.options.relativeXValue) && (et = function(ct) {
            return !ct.touched && ct.index === k.index;
          }, it && it.matchByName ? et = function(ct) {
            return !ct.touched && ct.name === k.name;
          } : this.options.relativeXValue && (et = function(ct) {
            return !ct.touched && ct.options.x === k.x;
          }), et = o(q, et), !et))
            return;
          if (et) {
            var rt = et && et.index;
            typeof rt < "u" && (nt = !0);
          }
          return typeof rt > "u" && j(V) && (rt = this.xData.indexOf(V, G)), rt !== -1 && typeof rt < "u" && this.cropped && (rt = rt >= this.cropStart ? rt - this.cropStart : rt), !nt && j(rt) && q[rt] && q[rt].touched && (rt = void 0), rt;
        }, Q.prototype.updateData = function(k, G) {
          var z = this.options, V = z.dataSorting, q = this.points, it = [], et = this.requireSorting, nt = k.length === q.length, rt, ct, gt, dt = !0;
          if (this.xIncrement = null, k.forEach(function(lt, at) {
            var J = l(lt) && this.pointClass.prototype.optionsToObject.call({ series: this }, lt) || {}, tt = J.x;
            J.id || j(tt) ? (J = this.findPointIndex(J, gt), J === -1 || typeof J > "u" ? it.push(lt) : q[J] && lt !== z.data[J] ? (q[J].update(lt, !1, null, !1), q[J].touched = !0, et && (gt = J + 1)) : q[J] && (q[J].touched = !0), (!nt || at !== J || V && V.enabled || this.hasDerivedData) && (rt = !0)) : it.push(lt);
          }, this), rt)
            for (k = q.length; k--; )
              (ct = q[k]) && !ct.touched && ct.remove && ct.remove(!1, G);
          else
            !nt || V && V.enabled ? dt = !1 : (k.forEach(function(lt, at) {
              lt !== q[at].y && q[at].update && q[at].update(
                lt,
                !1,
                null,
                !1
              );
            }), it.length = 0);
          return q.forEach(function(lt) {
            lt && (lt.touched = !1);
          }), dt ? (it.forEach(function(lt) {
            this.addPoint(lt, !1, null, null, !1);
          }, this), this.xIncrement === null && this.xData && this.xData.length && (this.xIncrement = x(this.xData), this.autoIncrement()), !0) : !1;
        }, Q.prototype.setData = function(k, G, z, V) {
          var q = this, it = q.points, et = it && it.length || 0, nt = q.options, rt = q.chart, ct = nt.dataSorting, gt = q.xAxis, dt = nt.turboThreshold, lt = this.xData, at = this.yData, J = q.pointArrayMap;
          J = J && J.length;
          var tt = nt.keys, st, ht = 0, pt = 1, yt = null;
          k = k || [];
          var vt = k.length;
          if (G = m(G, !0), ct && ct.enabled && (k = this.sortData(k)), V !== !1 && vt && et && !q.cropped && !q.hasGroupedData && q.visible && !q.isSeriesBoosting && (st = this.updateData(k, z)), !st) {
            if (q.xIncrement = null, q.colorCounter = 0, this.parallelArrays.forEach(function(Ct) {
              q[Ct + "Data"].length = 0;
            }), dt && vt > dt)
              if (yt = q.getFirstValidPoint(k), j(yt))
                for (z = 0; z < vt; z++)
                  lt[z] = this.autoIncrement(), at[z] = k[z];
              else if (D(yt))
                if (J)
                  if (yt.length === J)
                    for (z = 0; z < vt; z++)
                      lt[z] = this.autoIncrement(), at[z] = k[z];
                  else
                    for (z = 0; z < vt; z++)
                      V = k[z], lt[z] = V[0], at[z] = V.slice(
                        1,
                        J + 1
                      );
                else if (tt && (ht = tt.indexOf("x"), pt = tt.indexOf("y"), ht = 0 <= ht ? ht : 0, pt = 0 <= pt ? pt : 1), yt.length === 1 && (pt = 0), ht === pt)
                  for (z = 0; z < vt; z++)
                    lt[z] = this.autoIncrement(), at[z] = k[z][pt];
                else
                  for (z = 0; z < vt; z++)
                    V = k[z], lt[z] = V[ht], at[z] = V[pt];
              else
                t(12, !1, rt);
            else
              for (z = 0; z < vt; z++)
                typeof k[z] < "u" && (V = { series: q }, q.pointClass.prototype.applyOptions.apply(V, [k[z]]), q.updateParallelArrays(V, z));
            for (at && T(at[0]) && t(14, !0, rt), q.data = [], q.options.data = q.userOptions.data = k, z = et; z--; )
              it[z] && it[z].destroy && it[z].destroy();
            gt && (gt.minRange = gt.userMinRange), q.isDirty = rt.isDirtyBox = !0, q.isDirtyData = !!it, z = !1;
          }
          nt.legendType === "point" && (this.processData(), this.generatePoints()), G && rt.redraw(z);
        }, Q.prototype.sortData = function(k) {
          var G = this, z = G.options.dataSorting.sortKey || "y", V = function(q, it) {
            return l(it) && q.pointClass.prototype.optionsToObject.call({ series: q }, it) || {};
          };
          return k.forEach(function(q, it) {
            k[it] = V(G, q), k[it].index = it;
          }, this), k.concat().sort(function(q, it) {
            return q = _(z, q), it = _(z, it), it < q ? -1 : it > q ? 1 : 0;
          }).forEach(function(q, it) {
            q.x = it;
          }, this), G.linkedSeries && G.linkedSeries.forEach(function(q) {
            var it = q.options, et = it.data;
            it.dataSorting && it.dataSorting.enabled || !et || (et.forEach(function(nt, rt) {
              et[rt] = V(q, nt), k[rt] && (et[rt].x = k[rt].x, et[rt].index = rt);
            }), q.setData(et, !1));
          }), k;
        }, Q.prototype.getProcessedData = function(k) {
          var G = this.xAxis, z = this.options, V = z.cropThreshold, q = k || this.getExtremesFromAll || z.getExtremesFromAll, it = this.isCartesian;
          k = G && G.val2lin, z = !(!G || !G.logarithmic);
          var et = 0, nt = this.xData, rt = this.yData, ct = this.requireSorting, gt = !1, dt = nt.length;
          if (G) {
            gt = G.getExtremes();
            var lt = gt.min, at = gt.max;
            gt = G.categories && !G.names.length;
          }
          if (it && this.sorted && !q && (!V || dt > V || this.forceCrop)) {
            if (nt[dt - 1] < lt || nt[0] > at)
              nt = [], rt = [];
            else if (this.yData && (nt[0] < lt || nt[dt - 1] > at)) {
              var J = this.cropData(this.xData, this.yData, lt, at);
              nt = J.xData, rt = J.yData, et = J.start, J = !0;
            }
          }
          for (V = nt.length || 1; --V; )
            if (G = z ? k(nt[V]) - k(nt[V - 1]) : nt[V] - nt[V - 1], 0 < G && (typeof tt > "u" || G < tt))
              var tt = G;
            else
              0 > G && ct && !gt && (t(15, !1, this.chart), ct = !1);
          return { xData: nt, yData: rt, cropped: J, cropStart: et, closestPointRange: tt };
        }, Q.prototype.processData = function(k) {
          var G = this.xAxis;
          if (this.isCartesian && !this.isDirty && !G.isDirty && !this.yAxis.isDirty && !k)
            return !1;
          k = this.getProcessedData(), this.cropped = k.cropped, this.cropStart = k.cropStart, this.processedXData = k.xData, this.processedYData = k.yData, this.closestPointRange = this.basePointRange = k.closestPointRange, A(this, "afterProcessData");
        }, Q.prototype.cropData = function(k, G, z, V, q) {
          var it = k.length, et, nt = 0, rt = it;
          for (q = m(q, this.cropShoulder), et = 0; et < it; et++)
            if (k[et] >= z) {
              nt = Math.max(0, et - q);
              break;
            }
          for (z = et; z < it; z++)
            if (k[z] > V) {
              rt = z + q;
              break;
            }
          return { xData: k.slice(nt, rt), yData: G.slice(
            nt,
            rt
          ), start: nt, end: rt };
        }, Q.prototype.generatePoints = function() {
          var k = this.options, G = k.data, z = this.processedXData, V = this.processedYData, q = this.pointClass, it = z.length, et = this.cropStart || 0, nt = this.hasGroupedData, rt = k.keys, ct = [];
          k = k.dataGrouping && k.dataGrouping.groupAll ? et : 0;
          var gt, dt, lt = this.data;
          if (!lt && !nt) {
            var at = [];
            at.length = G.length, lt = this.data = at;
          }
          for (rt && nt && (this.options.keys = !1), dt = 0; dt < it; dt++) {
            if (at = et + dt, nt) {
              var J = new q().init(this, [z[dt]].concat(Y(V[dt])));
              J.dataGroup = this.groupMap[k + dt], J.dataGroup.options && (J.options = J.dataGroup.options, n(J, J.dataGroup.options), delete J.dataLabels);
            } else
              (J = lt[at]) || typeof G[at] > "u" || (lt[at] = J = new q().init(this, G[at], z[dt]));
            J && (J.index = nt ? k + dt : at, ct[dt] = J);
          }
          if (this.options.keys = rt, lt && (it !== (gt = lt.length) || nt))
            for (dt = 0; dt < gt; dt++)
              dt !== et || nt || (dt += it), lt[dt] && (lt[dt].destroyElements(), lt[dt].plotX = void 0);
          this.data = lt, this.points = ct, A(this, "afterGeneratePoints");
        }, Q.prototype.getXExtremes = function(k) {
          return { min: h(k), max: x(k) };
        }, Q.prototype.getExtremes = function(k, G) {
          var z = this.xAxis, V = this.yAxis, q = this.processedXData || this.xData, it = [], et = this.requireSorting ? this.cropShoulder : 0;
          V = V ? V.positiveValuesOnly : !1;
          var nt, rt = 0, ct = 0, gt = 0;
          k = k || this.stackedYData || this.processedYData || [];
          var dt = k.length;
          if (z) {
            var lt = z.getExtremes();
            rt = lt.min, ct = lt.max;
          }
          for (nt = 0; nt < dt; nt++) {
            var at = q[nt];
            lt = k[nt];
            var J = (j(lt) || D(lt)) && (lt.length || 0 < lt || !V);
            if (at = G || this.getExtremesFromAll || this.options.getExtremesFromAll || this.cropped || !z || (q[nt + et] || at) >= rt && (q[nt - et] || at) <= ct, J && at)
              if (J = lt.length)
                for (; J--; )
                  j(lt[J]) && (it[gt++] = lt[J]);
              else
                it[gt++] = lt;
          }
          return k = { activeYData: it, dataMin: h(it), dataMax: x(it) }, A(this, "afterGetExtremes", { dataExtremes: k }), k;
        }, Q.prototype.applyExtremes = function() {
          var k = this.getExtremes();
          return this.dataMin = k.dataMin, this.dataMax = k.dataMax, k;
        }, Q.prototype.getFirstValidPoint = function(k) {
          for (var G = k.length, z = 0, V = null; V === null && z < G; )
            V = k[z], z++;
          return V;
        }, Q.prototype.translate = function() {
          this.processedXData || this.processData(), this.generatePoints();
          var k = this.options, G = k.stacking, z = this.xAxis, V = z.categories, q = this.enabledDataSorting, it = this.yAxis, et = this.points, nt = et.length, rt = this.pointPlacementToXValue(), ct = !!rt, gt = k.threshold, dt = k.startFromThreshold ? gt : 0, lt = this.zoneAxis || "y", at, J, tt = Number.MAX_VALUE;
          for (at = 0; at < nt; at++) {
            var st = et[at], ht = st.x, pt = void 0, yt = void 0, vt = st.y, Ct = st.low, Tt = G && it.stacking && it.stacking.stacks[(this.negStacks && vt < (dt ? 0 : gt) ? "-" : "") + this.stackKey];
            if ((it.positiveValuesOnly && !it.validatePositiveValue(vt) || z.positiveValuesOnly && !z.validatePositiveValue(ht)) && (st.isNull = !0), st.plotX = J = i(c(z.translate(ht, 0, 0, 0, 1, rt, this.type === "flags"), -1e5, 1e5)), G && this.visible && Tt && Tt[ht]) {
              var kt = this.getStackIndicator(
                kt,
                ht,
                this.index
              );
              st.isNull || (pt = Tt[ht], yt = pt.points[kt.key]);
            }
            if (D(yt) && (Ct = yt[0], vt = yt[1], Ct === dt && kt.key === Tt[ht].base && (Ct = m(j(gt) && gt, it.min)), it.positiveValuesOnly && 0 >= Ct && (Ct = null), st.total = st.stackTotal = pt.total, st.percentage = pt.total && st.y / pt.total * 100, st.stackY = vt, this.irregularWidths || pt.setOffset(this.pointXOffset || 0, this.barW || 0)), st.yBottom = l(Ct) ? c(it.translate(Ct, 0, 1, 0, 1), -1e5, 1e5) : null, this.dataModify && (vt = this.dataModify.modifyValue(vt, at)), st.plotY = void 0, j(vt) && (pt = it.translate(vt, !1, !0, !1, !0), typeof pt < "u" && (st.plotY = c(
              pt,
              -1e5,
              1e5
            ))), st.isInside = this.isPointInside(st), st.clientX = ct ? i(z.translate(ht, 0, 0, 0, 1, rt)) : J, st.negative = st[lt] < (k[lt + "Threshold"] || gt || 0), st.category = V && typeof V[st.x] < "u" ? V[st.x] : st.x, !st.isNull && st.visible !== !1) {
              typeof St < "u" && (tt = Math.min(tt, Math.abs(J - St)));
              var St = J;
            }
            st.zone = this.zones.length ? st.getZone() : void 0, !st.graphic && this.group && q && (st.isNew = !0);
          }
          this.closestPointRangePx = tt, A(this, "afterTranslate");
        }, Q.prototype.getValidPoints = function(k, G, z) {
          var V = this.chart;
          return (k || this.points || []).filter(function(q) {
            return G && !V.isInsidePlot(q.plotX, q.plotY, { inverted: V.inverted }) ? !1 : q.visible !== !1 && (z || !q.isNull);
          });
        }, Q.prototype.getClipBox = function() {
          var k = this.chart, G = this.xAxis, z = this.yAxis, V = X(k.clipBox);
          return G && G.len !== k.plotSizeX && (V.width = G.len), z && z.len !== k.plotSizeY && (V.height = z.len), V;
        }, Q.prototype.getSharedClipKey = function() {
          return this.sharedClipKey = (this.options.xAxis || 0) + "," + (this.options.yAxis || 0);
        }, Q.prototype.setClip = function() {
          var k = this.chart, G = this.group, z = this.markerGroup, V = k.sharedClips;
          k = k.renderer;
          var q = this.getClipBox(), it = this.getSharedClipKey(), et = V[it];
          et ? et.animate(q) : V[it] = et = k.clipRect(q), G && G.clip(this.options.clip === !1 ? void 0 : et), z && z.clip();
        }, Q.prototype.animate = function(k) {
          var G = this.chart, z = this.group, V = this.markerGroup, q = G.inverted, it = v(this.options.animation), et = [this.getSharedClipKey(), it.duration, it.easing, it.defer].join(), nt = G.sharedClips[et], rt = G.sharedClips[et + "m"];
          if (k && z)
            it = this.getClipBox(), nt ? nt.attr("height", it.height) : (it.width = 0, q && (it.x = G.plotHeight), nt = G.renderer.clipRect(it), G.sharedClips[et] = nt, rt = G.renderer.clipRect({ x: q ? (G.plotSizeX || 0) + 99 : -99, y: q ? -G.plotLeft : -G.plotTop, width: 99, height: q ? G.chartWidth : G.chartHeight }), G.sharedClips[et + "m"] = rt), z.clip(nt), V && V.clip(rt);
          else if (nt && !nt.hasClass("highcharts-animating")) {
            G = this.getClipBox();
            var ct = it.step;
            V && V.element.childNodes.length && (it.step = function(gt, dt) {
              ct && ct.apply(dt, arguments), rt && rt.element && rt.attr(dt.prop, dt.prop === "width" ? gt + 99 : gt);
            }), nt.addClass("highcharts-animating").animate(G, it);
          }
        }, Q.prototype.afterAnimate = function() {
          var k = this;
          this.setClip(), f(
            this.chart.sharedClips,
            function(G, z, V) {
              G && !k.chart.container.querySelector('[clip-path="url(#' + G.id + ')"]') && (G.destroy(), delete V[z]);
            }
          ), this.finishedAnimating = !0, A(this, "afterAnimate");
        }, Q.prototype.drawPoints = function() {
          var k = this.points, G = this.chart, z = this.options.marker, V = this[this.specialGroup] || this.markerGroup, q = this.xAxis, it = m(z.enabled, !q || q.isRadial ? !0 : null, this.closestPointRangePx >= z.enabledThreshold * z.radius), et, nt;
          if (z.enabled !== !1 || this._hasPointMarkers)
            for (et = 0; et < k.length; et++) {
              var rt = k[et], ct = (nt = rt.graphic) ? "animate" : "attr", gt = rt.marker || {}, dt = !!rt.marker;
              if ((it && typeof gt.enabled > "u" || gt.enabled) && !rt.isNull && rt.visible !== !1) {
                var lt = m(gt.symbol, this.symbol, "rect"), at = this.markerAttribs(rt, rt.selected && "select");
                this.enabledDataSorting && (rt.startXPos = q.reversed ? -(at.width || 0) : q.width);
                var J = rt.isInside !== !1;
                nt ? nt[J ? "show" : "hide"](J).animate(at) : J && (0 < (at.width || 0) || rt.hasImage) && (rt.graphic = nt = G.renderer.symbol(lt, at.x, at.y, at.width, at.height, dt ? gt : z).add(V), this.enabledDataSorting && G.hasRendered && (nt.attr({ x: rt.startXPos }), ct = "animate")), nt && ct === "animate" && nt[J ? "show" : "hide"](J).animate(at), nt && !G.styledMode && nt[ct](this.pointAttribs(rt, rt.selected && "select")), nt && nt.addClass(rt.getClassName(), !0);
              } else
                nt && (rt.graphic = nt.destroy());
            }
        }, Q.prototype.markerAttribs = function(k, G) {
          var z = this.options, V = z.marker, q = k.marker || {}, it = q.symbol || V.symbol, et = m(q.radius, V.radius);
          return G && (V = V.states[G], G = q.states && q.states[G], et = m(G && G.radius, V && V.radius, et + (V && V.radiusPlus || 0))), k.hasImage = it && it.indexOf("url") === 0, k.hasImage && (et = 0), k = { x: z.crisp ? Math.floor(k.plotX - et) : k.plotX - et, y: k.plotY - et }, et && (k.width = k.height = 2 * et), k;
        }, Q.prototype.pointAttribs = function(k, G) {
          var z = this.options.marker, V = k && k.options, q = V && V.marker || {}, it = V && V.color, et = k && k.color, nt = k && k.zone && k.zone.color, rt = this.color;
          return k = m(q.lineWidth, z.lineWidth), V = 1, rt = it || nt || et || rt, it = q.fillColor || z.fillColor || rt, et = q.lineColor || z.lineColor || rt, G = G || "normal", z = z.states[G] || {}, G = q.states && q.states[G] || {}, k = m(G.lineWidth, z.lineWidth, k + m(G.lineWidthPlus, z.lineWidthPlus, 0)), it = G.fillColor || z.fillColor || it, et = G.lineColor || z.lineColor || et, V = m(G.opacity, z.opacity, V), { stroke: et, "stroke-width": k, fill: it, opacity: V };
        }, Q.prototype.destroy = function(k) {
          var G = this, z = G.chart, V = /AppleWebKit\/533/.test(C.navigator.userAgent), q = G.data || [], it, et, nt, rt;
          for (A(G, "destroy"), this.removeEvents(k), (G.axisTypes || []).forEach(function(ct) {
            (rt = G[ct]) && rt.series && (s(rt.series, G), rt.isDirty = rt.forceRedraw = !0);
          }), G.legendItem && G.chart.legend.destroyItem(G), et = q.length; et--; )
            (nt = q[et]) && nt.destroy && nt.destroy();
          G.clips && G.clips.forEach(function(ct) {
            return ct.destroy();
          }), M.clearTimeout(G.animationTimeout), f(G, function(ct, gt) {
            ct instanceof N && !ct.survive && (it = V && gt === "group" ? "hide" : "destroy", ct[it]());
          }), z.hoverSeries === G && (z.hoverSeries = void 0), s(z.series, G), z.orderSeries(), f(G, function(ct, gt) {
            k && gt === "hcEvents" || delete G[gt];
          });
        }, Q.prototype.applyZones = function() {
          var k = this, G = this.chart, z = G.renderer, V = this.zones, q = this.clips || [], it = this.graph, et = this.area, nt = Math.max(G.chartWidth, G.chartHeight), rt = this[(this.zoneAxis || "y") + "Axis"], ct = G.inverted, gt, dt, lt, at, J, tt, st, ht, pt = !1;
          if (V.length && (it || et) && rt && typeof rt.min < "u") {
            var yt = rt.reversed, vt = rt.horiz;
            it && !this.showLine && it.hide(), et && et.hide();
            var Ct = rt.getExtremes();
            V.forEach(function(Tt, kt) {
              gt = yt ? vt ? G.plotWidth : 0 : vt ? 0 : rt.toPixels(Ct.min) || 0, gt = c(m(dt, gt), 0, nt), dt = c(Math.round(rt.toPixels(m(Tt.value, Ct.max), !0) || 0), 0, nt), pt && (gt = dt = rt.toPixels(Ct.max)), at = Math.abs(gt - dt), J = Math.min(gt, dt), tt = Math.max(gt, dt), rt.isXAxis ? (lt = { x: ct ? tt : J, y: 0, width: at, height: nt }, vt || (lt.x = G.plotHeight - lt.x)) : (lt = { x: 0, y: ct ? tt : J, width: nt, height: at }, vt && (lt.y = G.plotWidth - lt.y)), ct && z.isVML && (lt = rt.isXAxis ? {
                x: 0,
                y: yt ? J : tt,
                height: lt.width,
                width: G.chartWidth
              } : { x: lt.y - G.plotLeft - G.spacingBox.x, y: 0, width: lt.height, height: G.chartHeight }), q[kt] ? q[kt].animate(lt) : q[kt] = z.clipRect(lt), st = k["zone-area-" + kt], ht = k["zone-graph-" + kt], it && ht && ht.clip(q[kt]), et && st && st.clip(q[kt]), pt = Tt.value > Ct.max, k.resetZones && dt === 0 && (dt = void 0);
            }), this.clips = q;
          } else
            k.visible && (it && it.show(!0), et && et.show(!0));
        }, Q.prototype.invertGroups = function(k) {
          function G() {
            ["group", "markerGroup"].forEach(function(q) {
              z[q] && (V.renderer.isVML && z[q].attr({ width: z.yAxis.len, height: z.xAxis.len }), z[q].width = z.yAxis.len, z[q].height = z.xAxis.len, z[q].invert(z.isRadialSeries ? !1 : k));
            });
          }
          var z = this, V = z.chart;
          z.xAxis && (z.eventsToUnbind.push(w(V, "resize", G)), G(), z.invertGroups = G);
        }, Q.prototype.plotGroup = function(k, G, z, V, q) {
          var it = this[k], et = !it;
          return z = { visibility: z, zIndex: V || 0.1 }, typeof this.opacity > "u" || this.chart.styledMode || this.state === "inactive" || (z.opacity = this.opacity), et && (this[k] = it = this.chart.renderer.g().add(q)), it.addClass("highcharts-" + G + " highcharts-series-" + this.index + " highcharts-" + this.type + "-series " + (l(this.colorIndex) ? "highcharts-color-" + this.colorIndex + " " : "") + (this.options.className || "") + (it.hasClass("highcharts-tracker") ? " highcharts-tracker" : ""), !0), it.attr(z)[et ? "attr" : "animate"](this.getPlotBox()), it;
        }, Q.prototype.getPlotBox = function() {
          var k = this.chart, G = this.xAxis, z = this.yAxis;
          return k.inverted && (G = z, z = this.xAxis), { translateX: G ? G.left : k.plotLeft, translateY: z ? z.top : k.plotTop, scaleX: 1, scaleY: 1 };
        }, Q.prototype.removeEvents = function(k) {
          k || L(this), this.eventsToUnbind.length && (this.eventsToUnbind.forEach(function(G) {
            G();
          }), this.eventsToUnbind.length = 0);
        }, Q.prototype.render = function() {
          var k = this, G = k.chart, z = k.options, V = v(z.animation), q = k.visible ? "inherit" : "hidden", it = z.zIndex, et = k.hasRendered, nt = G.seriesGroup, rt = G.inverted;
          G = !k.finishedAnimating && G.renderer.isSVG ? V.duration : 0, A(this, "render");
          var ct = k.plotGroup("group", "series", q, it, nt);
          k.markerGroup = k.plotGroup("markerGroup", "markers", q, it, nt), z.clip !== !1 && k.setClip(), k.animate && G && k.animate(!0), ct.inverted = m(k.invertible, k.isCartesian) ? rt : !1, k.drawGraph && (k.drawGraph(), k.applyZones()), k.visible && k.drawPoints(), k.drawDataLabels && k.drawDataLabels(), k.redrawPoints && k.redrawPoints(), k.drawTracker && k.options.enableMouseTracking !== !1 && k.drawTracker(), k.invertGroups(rt), k.animate && G && k.animate(), et || (G && V.defer && (G += V.defer), k.animationTimeout = F(function() {
            k.afterAnimate();
          }, G || 0)), k.isDirty = !1, k.hasRendered = !0, A(k, "afterRender");
        }, Q.prototype.redraw = function() {
          var k = this.chart, G = this.isDirty || this.isDirtyData, z = this.group, V = this.xAxis, q = this.yAxis;
          z && (k.inverted && z.attr({
            width: k.plotWidth,
            height: k.plotHeight
          }), z.animate({ translateX: m(V && V.left, k.plotLeft), translateY: m(q && q.top, k.plotTop) })), this.translate(), this.render(), G && delete this.kdTree;
        }, Q.prototype.searchPoint = function(k, G) {
          var z = this.xAxis, V = this.yAxis, q = this.chart.inverted;
          return this.searchKDTree({ clientX: q ? z.len - k.chartY + z.pos : k.chartX - z.pos, plotY: q ? V.len - k.chartX + V.pos : k.chartY - V.pos }, G, k);
        }, Q.prototype.buildKDTree = function(k) {
          function G(q, it, et) {
            var nt = q && q.length;
            if (nt) {
              var rt = z.kdAxisArray[it % et];
              return q.sort(function(ct, gt) {
                return ct[rt] - gt[rt];
              }), nt = Math.floor(nt / 2), { point: q[nt], left: G(q.slice(0, nt), it + 1, et), right: G(q.slice(nt + 1), it + 1, et) };
            }
          }
          this.buildingKdTree = !0;
          var z = this, V = -1 < z.options.findNearestPointBy.indexOf("y") ? 2 : 1;
          delete z.kdTree, F(function() {
            z.kdTree = G(z.getValidPoints(null, !z.directTouch), V, V), z.buildingKdTree = !1;
          }, z.options.kdNow || k && k.type === "touchstart" ? 0 : 1);
        }, Q.prototype.searchKDTree = function(k, G, z) {
          function V(rt, ct, gt, dt) {
            var lt = ct.point, at = q.kdAxisArray[gt % dt], J = lt, tt = l(rt[it]) && l(lt[it]) ? Math.pow(rt[it] - lt[it], 2) : null, st = l(rt[et]) && l(lt[et]) ? Math.pow(rt[et] - lt[et], 2) : null;
            return st = (tt || 0) + (st || 0), lt.dist = l(st) ? Math.sqrt(st) : Number.MAX_VALUE, lt.distX = l(tt) ? Math.sqrt(tt) : Number.MAX_VALUE, at = rt[at] - lt[at], st = 0 > at ? "left" : "right", tt = 0 > at ? "right" : "left", ct[st] && (st = V(rt, ct[st], gt + 1, dt), J = st[nt] < J[nt] ? st : lt), ct[tt] && Math.sqrt(at * at) < J[nt] && (rt = V(rt, ct[tt], gt + 1, dt), J = rt[nt] < J[nt] ? rt : J), J;
          }
          var q = this, it = this.kdAxisArray[0], et = this.kdAxisArray[1], nt = G ? "distX" : "dist";
          if (G = -1 < q.options.findNearestPointBy.indexOf("y") ? 2 : 1, this.kdTree || this.buildingKdTree || this.buildKDTree(z), this.kdTree)
            return V(
              k,
              this.kdTree,
              G,
              G
            );
        }, Q.prototype.pointPlacementToXValue = function() {
          var k = this.options, G = k.pointRange, z = this.xAxis;
          return k = k.pointPlacement, k === "between" && (k = z.reversed ? -0.5 : 0.5), j(k) ? k * (G || z.pointRange) : 0;
        }, Q.prototype.isPointInside = function(k) {
          var G = this.chart, z = this.xAxis, V = this.yAxis;
          return typeof k.plotY < "u" && typeof k.plotX < "u" && 0 <= k.plotY && k.plotY <= (V ? V.len : G.plotHeight) && 0 <= k.plotX && k.plotX <= (z ? z.len : G.plotWidth);
        }, Q.prototype.drawTracker = function() {
          var k = this, G = k.options, z = G.trackByArea, V = [].concat(z ? k.areaPath : k.graphPath), q = k.chart, it = q.pointer, et = q.renderer, nt = q.options.tooltip.snap, rt = k.tracker, ct = function(dt) {
            q.hoverSeries !== k && k.onMouseOver();
          }, gt = "rgba(192,192,192," + (B ? 1e-4 : 2e-3) + ")";
          rt ? rt.attr({ d: V }) : k.graph && (k.tracker = et.path(V).attr({ visibility: k.visible ? "visible" : "hidden", zIndex: 2 }).addClass(z ? "highcharts-tracker-area" : "highcharts-tracker-line").add(k.group), q.styledMode || k.tracker.attr({ "stroke-linecap": "round", "stroke-linejoin": "round", stroke: gt, fill: z ? gt : "none", "stroke-width": k.graph.strokeWidth() + (z ? 0 : 2 * nt) }), [k.tracker, k.markerGroup, k.dataLabelsGroup].forEach(function(dt) {
            dt && (dt.addClass("highcharts-tracker").on("mouseover", ct).on("mouseout", function(lt) {
              it.onTrackerMouseOut(lt);
            }), G.cursor && !q.styledMode && dt.css({ cursor: G.cursor }), O) && dt.on("touchstart", ct);
          })), A(this, "afterDrawTracker");
        }, Q.prototype.addPoint = function(k, G, z, V, q) {
          var it = this.options, et = this.data, nt = this.chart, rt = this.xAxis;
          rt = rt && rt.hasNames && rt.names;
          var ct = it.data, gt = this.xData, dt;
          G = m(G, !0);
          var lt = { series: this };
          this.pointClass.prototype.applyOptions.apply(
            lt,
            [k]
          );
          var at = lt.x, J = gt.length;
          if (this.requireSorting && at < gt[J - 1])
            for (dt = !0; J && gt[J - 1] > at; )
              J--;
          this.updateParallelArrays(lt, "splice", J, 0, 0), this.updateParallelArrays(lt, J), rt && lt.name && (rt[at] = lt.name), ct.splice(J, 0, k), dt && (this.data.splice(J, 0, null), this.processData()), it.legendType === "point" && this.generatePoints(), z && (et[0] && et[0].remove ? et[0].remove(!1) : (et.shift(), this.updateParallelArrays(lt, "shift"), ct.shift())), q !== !1 && A(this, "addPoint", { point: lt }), this.isDirtyData = this.isDirty = !0, G && nt.redraw(V);
        }, Q.prototype.removePoint = function(k, G, z) {
          var V = this, q = V.data, it = q[k], et = V.points, nt = V.chart, rt = function() {
            et && et.length === q.length && et.splice(k, 1), q.splice(k, 1), V.options.data.splice(k, 1), V.updateParallelArrays(it || { series: V }, "splice", k, 1), it && it.destroy(), V.isDirty = !0, V.isDirtyData = !0, G && nt.redraw();
          };
          u(z, nt), G = m(G, !0), it ? it.firePointEvent("remove", null, rt) : rt();
        }, Q.prototype.remove = function(k, G, z, V) {
          function q() {
            it.destroy(V), et.isDirtyLegend = et.isDirtyBox = !0, et.linkSeries(), m(k, !0) && et.redraw(G);
          }
          var it = this, et = it.chart;
          z !== !1 ? A(
            it,
            "remove",
            null,
            q
          ) : q();
        }, Q.prototype.update = function(k, G) {
          k = p(k, this.userOptions), A(this, "update", { options: k });
          var z = this, V = z.chart, q = z.userOptions, it = z.initialType || z.type, et = V.options.plotOptions, nt = b[it].prototype, rt = z.finishedAnimating && { animation: !1 }, ct = {}, gt, dt = ["eventOptions", "navigatorSeries", "baseSeries"], lt = k.type || q.type || V.options.chart.type, at = !(this.hasDerivedData || lt && lt !== this.type || typeof k.pointStart < "u" || typeof k.pointInterval < "u" || typeof k.relativeXValue < "u" || z.hasOptionChanged("dataGrouping") || z.hasOptionChanged("pointStart") || z.hasOptionChanged("pointInterval") || z.hasOptionChanged("pointIntervalUnit") || z.hasOptionChanged("keys"));
          if (lt = lt || it, at && (dt.push("data", "isDirtyData", "points", "processedXData", "processedYData", "xIncrement", "cropped", "_hasPointMarkers", "_hasPointLabels", "clips", "nodes", "layout", "mapMap", "mapData", "minY", "maxY", "minX", "maxX"), k.visible !== !1 && dt.push("area", "graph"), z.parallelArrays.forEach(function(tt) {
            dt.push(tt + "Data");
          }), k.data && (k.dataSorting && n(z.options.dataSorting, k.dataSorting), this.setData(k.data, !1))), k = X(q, rt, { index: typeof q.index > "u" ? z.index : q.index, pointStart: m(et && et.series && et.series.pointStart, q.pointStart, z.xData[0]) }, !at && { data: z.options.data }, k), at && k.data && (k.data = z.options.data), dt = ["group", "markerGroup", "dataLabelsGroup", "transformGroup"].concat(dt), dt.forEach(function(tt) {
            dt[tt] = z[tt], delete z[tt];
          }), et = !1, b[lt]) {
            if (et = lt !== z.type, z.remove(!1, !1, !1, !0), et)
              if (Object.setPrototypeOf)
                Object.setPrototypeOf(z, b[lt].prototype);
              else {
                rt = Object.hasOwnProperty.call(z, "hcEvents") && z.hcEvents;
                for (gt in nt)
                  z[gt] = void 0;
                n(z, b[lt].prototype), rt ? z.hcEvents = rt : delete z.hcEvents;
              }
          } else
            t(17, !0, V, { missingModuleFor: lt });
          if (dt.forEach(function(tt) {
            z[tt] = dt[tt];
          }), z.init(V, k), at && this.points) {
            var J = z.options;
            J.visible === !1 ? (ct.graphic = 1, ct.dataLabel = 1) : z._hasPointLabels || (k = J.marker, nt = J.dataLabels, !k || k.enabled !== !1 && (q.marker && q.marker.symbol) === k.symbol || (ct.graphic = 1), nt && nt.enabled === !1 && (ct.dataLabel = 1)), this.points.forEach(function(tt) {
              tt && tt.series && (tt.resolveColor(), Object.keys(ct).length && tt.destroyElements(ct), J.showInLegend === !1 && tt.legendItem && V.legend.destroyItem(tt));
            }, this);
          }
          z.initialType = it, V.linkSeries(), et && z.linkedSeries.length && (z.isDirtyData = !0), A(this, "afterUpdate"), m(G, !0) && V.redraw(at ? void 0 : !1);
        }, Q.prototype.setName = function(k) {
          this.name = this.options.name = this.userOptions.name = k, this.chart.isDirtyLegend = !0;
        }, Q.prototype.hasOptionChanged = function(k) {
          var G = this.options[k], z = this.chart.options.plotOptions, V = this.userOptions[k];
          return V ? G !== V : G !== m(
            z && z[this.type] && z[this.type][k],
            z && z.series && z.series[k],
            G
          );
        }, Q.prototype.onMouseOver = function() {
          var k = this.chart, G = k.hoverSeries;
          k.pointer.setHoverChartIndex(), G && G !== this && G.onMouseOut(), this.options.events.mouseOver && A(this, "mouseOver"), this.setState("hover"), k.hoverSeries = this;
        }, Q.prototype.onMouseOut = function() {
          var k = this.options, G = this.chart, z = G.tooltip, V = G.hoverPoint;
          G.hoverSeries = null, V && V.onMouseOut(), this && k.events.mouseOut && A(this, "mouseOut"), !z || this.stickyTracking || z.shared && !this.noSharedTooltip || z.hide(), G.series.forEach(function(q) {
            q.setState(
              "",
              !0
            );
          });
        }, Q.prototype.setState = function(k, G) {
          var z = this, V = z.options, q = z.graph, it = V.inactiveOtherPoints, et = V.states, nt = m(et[k || "normal"] && et[k || "normal"].animation, z.chart.options.chart.animation), rt = V.lineWidth, ct = 0, gt = V.opacity;
          if (k = k || "", z.state !== k && ([z.group, z.markerGroup, z.dataLabelsGroup].forEach(function(dt) {
            dt && (z.state && dt.removeClass("highcharts-series-" + z.state), k && dt.addClass("highcharts-series-" + k));
          }), z.state = k, !z.chart.styledMode)) {
            if (et[k] && et[k].enabled === !1)
              return;
            if (k && (rt = et[k].lineWidth || rt + (et[k].lineWidthPlus || 0), gt = m(et[k].opacity, gt)), q && !q.dashstyle)
              for (V = { "stroke-width": rt }, q.animate(V, nt); z["zone-graph-" + ct]; )
                z["zone-graph-" + ct].animate(V, nt), ct += 1;
            it || [z.group, z.markerGroup, z.dataLabelsGroup, z.labelBySeries].forEach(function(dt) {
              dt && dt.animate({ opacity: gt }, nt);
            });
          }
          G && it && z.points && z.setAllPointsToState(k || void 0);
        }, Q.prototype.setAllPointsToState = function(k) {
          this.points.forEach(function(G) {
            G.setState && G.setState(k);
          });
        }, Q.prototype.setVisible = function(k, G) {
          var z = this, V = z.chart, q = z.legendItem, it = V.options.chart.ignoreHiddenSeries, et = z.visible, nt = (z.visible = k = z.options.visible = z.userOptions.visible = typeof k > "u" ? !et : k) ? "show" : "hide";
          ["group", "dataLabelsGroup", "markerGroup", "tracker", "tt"].forEach(function(rt) {
            z[rt] && z[rt][nt]();
          }), (V.hoverSeries === z || (V.hoverPoint && V.hoverPoint.series) === z) && z.onMouseOut(), q && V.legend.colorizeItem(z, k), z.isDirty = !0, z.options.stacking && V.series.forEach(function(rt) {
            rt.options.stacking && rt.visible && (rt.isDirty = !0);
          }), z.linkedSeries.forEach(function(rt) {
            rt.setVisible(k, !1);
          }), it && (V.isDirtyBox = !0), A(z, nt), G !== !1 && V.redraw();
        }, Q.prototype.show = function() {
          this.setVisible(!0);
        }, Q.prototype.hide = function() {
          this.setVisible(!1);
        }, Q.prototype.select = function(k) {
          this.selected = k = this.options.selected = typeof k > "u" ? !this.selected : k, this.checkbox && (this.checkbox.checked = k), A(this, k ? "select" : "unselect");
        }, Q.prototype.shouldShowTooltip = function(k, G, z) {
          return z === void 0 && (z = {}), z.series = this, z.visiblePlotOnly = !0, this.chart.isInsidePlot(k, G, z);
        }, Q.defaultOptions = U, Q;
      }(), n(y.prototype, { axisTypes: [
        "xAxis",
        "yAxis"
      ], coll: "series", colorCounter: 0, cropShoulder: 1, directTouch: !1, drawLegendSymbol: H.drawLineMarker, isCartesian: !0, kdAxisArray: ["clientX", "plotY"], parallelArrays: ["x", "y"], pointClass: $, requireSorting: !0, sorted: !0 }), W.series = y, y;
    }), E(a, "Extensions/ScrollablePlotArea.js", [a["Core/Animation/AnimationUtilities.js"], a["Core/Axis/Axis.js"], a["Core/Chart/Chart.js"], a["Core/Series/Series.js"], a["Core/Renderer/RendererRegistry.js"], a["Core/Utilities.js"]], function(y, R, I, Z, H, $) {
      var U = y.stop, W = $.addEvent, N = $.createElement, M = $.merge, v = $.pick;
      W(I, "afterSetChartSize", function(u) {
        var d = this.options.chart.scrollablePlotArea, P = d && d.minWidth;
        if (d = d && d.minHeight, !this.renderer.forExport) {
          if (P) {
            if (this.scrollablePixelsX = P = Math.max(0, P - this.chartWidth)) {
              this.scrollablePlotBox = this.renderer.scrollablePlotBox = M(this.plotBox), this.plotBox.width = this.plotWidth += P, this.inverted ? this.clipBox.height += P : this.clipBox.width += P;
              var O = { 1: { name: "right", value: P } };
            }
          } else
            d && (this.scrollablePixelsY = P = Math.max(
              0,
              d - this.chartHeight
            )) && (this.scrollablePlotBox = this.renderer.scrollablePlotBox = M(this.plotBox), this.plotBox.height = this.plotHeight += P, this.inverted ? this.clipBox.width += P : this.clipBox.height += P, O = { 2: { name: "bottom", value: P } });
          O && !u.skipAxes && this.axes.forEach(function(B) {
            O[B.side] ? B.getPlotLinePath = function() {
              var C = O[B.side].name, b = this[C];
              this[C] = b - O[B.side].value;
              var w = R.prototype.getPlotLinePath.apply(this, arguments);
              return this[C] = b, w;
            } : (B.setAxisSize(), B.setAxisTranslation());
          });
        }
      }), W(I, "render", function() {
        this.scrollablePixelsX || this.scrollablePixelsY ? (this.setUpScrolling && this.setUpScrolling(), this.applyFixed()) : this.fixedDiv && this.applyFixed();
      }), I.prototype.setUpScrolling = function() {
        var u = this, d = { WebkitOverflowScrolling: "touch", overflowX: "hidden", overflowY: "hidden" };
        this.scrollablePixelsX && (d.overflowX = "auto"), this.scrollablePixelsY && (d.overflowY = "auto"), this.scrollingParent = N("div", { className: "highcharts-scrolling-parent" }, { position: "relative" }, this.renderTo), this.scrollingContainer = N(
          "div",
          { className: "highcharts-scrolling" },
          d,
          this.scrollingParent
        ), W(this.scrollingContainer, "scroll", function() {
          u.pointer && delete u.pointer.chartPosition;
        }), this.innerContainer = N("div", { className: "highcharts-inner-container" }, null, this.scrollingContainer), this.innerContainer.appendChild(this.container), this.setUpScrolling = null;
      }, I.prototype.moveFixedElements = function() {
        var u = this.container, d = this.fixedRenderer, P = ".highcharts-contextbutton .highcharts-credits .highcharts-legend .highcharts-legend-checkbox .highcharts-navigator-series .highcharts-navigator-xaxis .highcharts-navigator-yaxis .highcharts-navigator .highcharts-reset-zoom .highcharts-drillup-button .highcharts-scrollbar .highcharts-subtitle .highcharts-title".split(" "), O;
        this.scrollablePixelsX && !this.inverted ? O = ".highcharts-yaxis" : this.scrollablePixelsX && this.inverted || this.scrollablePixelsY && !this.inverted ? O = ".highcharts-xaxis" : this.scrollablePixelsY && this.inverted && (O = ".highcharts-yaxis"), O && P.push(O + ":not(.highcharts-radial-axis)", O + "-labels:not(.highcharts-radial-axis-labels)"), P.forEach(function(B) {
          [].forEach.call(u.querySelectorAll(B), function(C) {
            (C.namespaceURI === d.SVG_NS ? d.box : d.box.parentNode).appendChild(C), C.style.pointerEvents = "auto";
          });
        });
      }, I.prototype.applyFixed = function() {
        var u = !this.fixedDiv, d = this.options.chart, P = d.scrollablePlotArea, O = H.getRendererType();
        u ? (this.fixedDiv = N("div", { className: "highcharts-fixed" }, { position: "absolute", overflow: "hidden", pointerEvents: "none", zIndex: (d.style && d.style.zIndex || 0) + 2, top: 0 }, null, !0), this.scrollingContainer && this.scrollingContainer.parentNode.insertBefore(this.fixedDiv, this.scrollingContainer), this.renderTo.style.overflow = "visible", this.fixedRenderer = d = new O(
          this.fixedDiv,
          this.chartWidth,
          this.chartHeight,
          this.options.chart.style
        ), this.scrollableMask = d.path().attr({ fill: this.options.chart.backgroundColor || "#fff", "fill-opacity": v(P.opacity, 0.85), zIndex: -1 }).addClass("highcharts-scrollable-mask").add(), W(this, "afterShowResetZoom", this.moveFixedElements), W(this, "afterDrilldown", this.moveFixedElements), W(this, "afterLayOutTitles", this.moveFixedElements)) : this.fixedRenderer.setSize(this.chartWidth, this.chartHeight), (this.scrollableDirty || u) && (this.scrollableDirty = !1, this.moveFixedElements()), d = this.chartWidth + (this.scrollablePixelsX || 0), O = this.chartHeight + (this.scrollablePixelsY || 0), U(this.container), this.container.style.width = d + "px", this.container.style.height = O + "px", this.renderer.boxWrapper.attr({ width: d, height: O, viewBox: [0, 0, d, O].join(" ") }), this.chartBackground.attr({ width: d, height: O }), this.scrollingContainer.style.height = this.chartHeight + "px", u && (P.scrollPositionX && (this.scrollingContainer.scrollLeft = this.scrollablePixelsX * P.scrollPositionX), P.scrollPositionY && (this.scrollingContainer.scrollTop = this.scrollablePixelsY * P.scrollPositionY)), O = this.axisOffset, u = this.plotTop - O[0] - 1, P = this.plotLeft - O[3] - 1, d = this.plotTop + this.plotHeight + O[2] + 1, O = this.plotLeft + this.plotWidth + O[1] + 1;
        var B = this.plotLeft + this.plotWidth - (this.scrollablePixelsX || 0), C = this.plotTop + this.plotHeight - (this.scrollablePixelsY || 0);
        u = this.scrollablePixelsX ? [["M", 0, u], ["L", this.plotLeft - 1, u], ["L", this.plotLeft - 1, d], ["L", 0, d], ["Z"], ["M", B, u], ["L", this.chartWidth, u], ["L", this.chartWidth, d], ["L", B, d], ["Z"]] : this.scrollablePixelsY ? [["M", P, 0], ["L", P, this.plotTop - 1], ["L", O, this.plotTop - 1], ["L", O, 0], ["Z"], ["M", P, C], ["L", P, this.chartHeight], ["L", O, this.chartHeight], ["L", O, C], ["Z"]] : [["M", 0, 0]], this.redrawTrigger !== "adjustHeight" && this.scrollableMask.attr({ d: u });
      }, W(R, "afterInit", function() {
        this.chart.scrollableDirty = !0;
      }), W(Z, "show", function() {
        this.chart.scrollableDirty = !0;
      });
    }), E(a, "Core/Axis/StackingAxis.js", [a["Core/Animation/AnimationUtilities.js"], a["Core/Axis/Axis.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = y.getDeferredAnimation, H = I.addEvent, $ = I.destroyObjectProperties, U = I.fireEvent, W = I.isNumber, N = I.objectEach, M;
      return function(v) {
        function u() {
          var B = this.stacking;
          if (B) {
            var C = B.stacks;
            N(C, function(b, w) {
              $(b), C[w] = null;
            }), B && B.stackTotalGroup && B.stackTotalGroup.destroy();
          }
        }
        function d() {
          this.stacking || (this.stacking = new O(this));
        }
        var P = [];
        v.compose = function(B) {
          return P.indexOf(B) === -1 && (P.push(B), H(B, "init", d), H(B, "destroy", u)), B;
        };
        var O = function() {
          function B(C) {
            this.oldStacks = {}, this.stacks = {}, this.stacksTouched = 0, this.axis = C;
          }
          return B.prototype.buildStacks = function() {
            var C = this.axis, b = C.series, w = C.options.reversedStacks, x = b.length, h;
            if (!C.isXAxis) {
              for (this.usePercentage = !1, h = x; h--; ) {
                var c = b[w ? h : x - h - 1];
                c.setStackedPoints(), c.setGroupedPoints();
              }
              for (h = 0; h < x; h++)
                b[h].modifyStacks();
              U(C, "afterBuildStacks");
            }
          }, B.prototype.cleanStacks = function() {
            if (!this.axis.isXAxis) {
              if (this.oldStacks)
                var C = this.stacks = this.oldStacks;
              N(C, function(b) {
                N(b, function(w) {
                  w.cumulative = w.total;
                });
              });
            }
          }, B.prototype.resetStacks = function() {
            var C = this, b = C.stacks;
            C.axis.isXAxis || N(b, function(w) {
              N(
                w,
                function(x, h) {
                  W(x.touched) && x.touched < C.stacksTouched ? (x.destroy(), delete w[h]) : (x.total = null, x.cumulative = null);
                }
              );
            });
          }, B.prototype.renderStackTotals = function() {
            var C = this.axis, b = C.chart, w = b.renderer, x = this.stacks;
            C = Z(b, C.options.stackLabels && C.options.stackLabels.animation || !1);
            var h = this.stackTotalGroup = this.stackTotalGroup || w.g("stack-labels").attr({ visibility: "visible", zIndex: 6, opacity: 0 }).add();
            h.translate(b.plotLeft, b.plotTop), N(x, function(c) {
              N(c, function(p) {
                p.render(h);
              });
            }), h.animate(
              { opacity: 1 },
              C
            );
          }, B;
        }();
        v.Additions = O;
      }(M || (M = {})), M;
    }), E(a, "Extensions/Stacking.js", [a["Core/Axis/Axis.js"], a["Core/Chart/Chart.js"], a["Core/FormatUtilities.js"], a["Core/Globals.js"], a["Core/Series/Series.js"], a["Core/Axis/StackingAxis.js"], a["Core/Utilities.js"]], function(y, R, I, Z, H, $, U) {
      var W = I.format, N = U.correctFloat, M = U.defined, v = U.destroyObjectProperties, u = U.isArray, d = U.isNumber, P = U.objectEach, O = U.pick, B = function() {
        function C(b, w, x, h, c) {
          var p = b.chart.inverted;
          this.axis = b, this.isNegative = x, this.options = w = w || {}, this.x = h, this.total = null, this.points = {}, this.hasValidPoints = !1, this.stack = c, this.rightCliff = this.leftCliff = 0, this.alignOptions = { align: w.align || (p ? x ? "left" : "right" : "center"), verticalAlign: w.verticalAlign || (p ? "middle" : x ? "bottom" : "top"), y: w.y, x: w.x }, this.textAlign = w.textAlign || (p ? x ? "right" : "left" : "center");
        }
        return C.prototype.destroy = function() {
          v(this, this.axis);
        }, C.prototype.render = function(b) {
          var w = this.axis.chart, x = this.options, h = x.format;
          h = h ? W(h, this, w) : x.formatter.call(this), this.label ? this.label.attr({
            text: h,
            visibility: "hidden"
          }) : (this.label = w.renderer.label(h, null, null, x.shape, null, null, x.useHTML, !1, "stack-labels"), h = { r: x.borderRadius || 0, text: h, rotation: x.rotation, padding: O(x.padding, 5), visibility: "hidden" }, w.styledMode || (h.fill = x.backgroundColor, h.stroke = x.borderColor, h["stroke-width"] = x.borderWidth, this.label.css(x.style)), this.label.attr(h), this.label.added || this.label.add(b)), this.label.labelrank = w.plotSizeY;
        }, C.prototype.setOffset = function(b, w, x, h, c) {
          var p = this.axis, i = p.chart;
          h = p.translate(p.stacking.usePercentage ? 100 : h || this.total, 0, 0, 0, 1), x = p.translate(x || 0), x = M(h) && Math.abs(h - x), b = O(c, i.xAxis[0].translate(this.x)) + b, p = M(h) && this.getStackBox(i, this, b, h, w, x, p), w = this.label, x = this.isNegative, b = O(this.options.overflow, "justify") === "justify";
          var l = this.textAlign;
          w && p && (c = w.getBBox(), h = w.padding, l = l === "left" ? i.inverted ? -h : h : l === "right" ? c.width : i.inverted && l === "center" ? c.width / 2 : i.inverted ? x ? c.width + h : -h : c.width / 2, x = i.inverted ? c.height / 2 : x ? -h : c.height, this.alignOptions.x = O(this.options.x, 0), this.alignOptions.y = O(this.options.y, 0), p.x -= l, p.y -= x, w.align(this.alignOptions, null, p), i.isInsidePlot(w.alignAttr.x + l - this.alignOptions.x, w.alignAttr.y + x - this.alignOptions.y) ? w.show() : (w.alignAttr.y = -9999, b = !1), b && H.prototype.justifyDataLabel.call(this.axis, w, this.alignOptions, w.alignAttr, c, p), w.attr({ x: w.alignAttr.x, y: w.alignAttr.y }), O(!b && this.options.crop, !0) && ((i = d(w.x) && d(w.y) && i.isInsidePlot(w.x - h + w.width, w.y) && i.isInsidePlot(w.x + h, w.y)) || w.hide()));
        }, C.prototype.getStackBox = function(b, w, x, h, c, p, i) {
          var l = w.axis.reversed, s = b.inverted, t = i.height + i.pos - (s ? b.plotLeft : b.plotTop);
          return w = w.isNegative && !l || !w.isNegative && l, { x: s ? w ? h - i.right : h - p + i.pos - b.plotLeft : x + b.xAxis[0].transB - b.plotLeft, y: s ? i.height - x - c : w ? t - h - p : t - h, width: s ? p : c, height: s ? c : p };
        }, C;
      }();
      return R.prototype.getStacks = function() {
        var C = this, b = C.inverted;
        C.yAxis.forEach(function(w) {
          w.stacking && w.stacking.stacks && w.hasVisibleSeries && (w.stacking.oldStacks = w.stacking.stacks);
        }), C.series.forEach(function(w) {
          var x = w.xAxis && w.xAxis.options || {};
          !w.options.stacking || w.visible !== !0 && C.options.chart.ignoreHiddenSeries !== !1 || (w.stackKey = [w.type, O(w.options.stack, ""), b ? x.top : x.left, b ? x.height : x.width].join());
        });
      }, $.compose(y), H.prototype.setGroupedPoints = function() {
        var C = this.yAxis.stacking;
        this.options.centerInCategory && (this.is("column") || this.is("columnrange")) && !this.options.stacking && 1 < this.chart.series.length ? H.prototype.setStackedPoints.call(this, "group") : C && P(C.stacks, function(b, w) {
          w.slice(-5) === "group" && (P(b, function(x) {
            return x.destroy();
          }), delete C.stacks[w]);
        });
      }, H.prototype.setStackedPoints = function(C) {
        var b = C || this.options.stacking;
        if (b && (this.visible === !0 || this.chart.options.chart.ignoreHiddenSeries === !1)) {
          var w = this.processedXData, x = this.processedYData, h = [], c = x.length, p = this.options, i = p.threshold, l = O(p.startFromThreshold && i, 0);
          p = p.stack, C = C ? this.type + "," + b : this.stackKey;
          var s = "-" + C, t = this.negStacks, n = this.yAxis, o = n.stacking.stacks, A = n.stacking.oldStacks, _, D;
          for (n.stacking.stacksTouched += 1, D = 0; D < c; D++) {
            var j = w[D], T = x[D], X = this.getStackIndicator(
              X,
              j,
              this.index
            ), f = X.key, m = (_ = t && T < (l ? 0 : i)) ? s : C;
            o[m] || (o[m] = {}), o[m][j] || (A[m] && A[m][j] ? (o[m][j] = A[m][j], o[m][j].total = null) : o[m][j] = new B(n, n.options.stackLabels, _, j, p)), m = o[m][j], T !== null ? (m.points[f] = m.points[this.index] = [O(m.cumulative, l)], M(m.cumulative) || (m.base = f), m.touched = n.stacking.stacksTouched, 0 < X.index && this.singleStacks === !1 && (m.points[f][0] = m.points[this.index + "," + j + ",0"][0])) : m.points[f] = m.points[this.index] = null, b === "percent" ? (_ = _ ? C : s, t && o[_] && o[_][j] ? (_ = o[_][j], m.total = _.total = Math.max(_.total, m.total) + Math.abs(T) || 0) : m.total = N(m.total + (Math.abs(T) || 0))) : b === "group" ? (u(T) && (T = T[0]), T !== null && (m.total = (m.total || 0) + 1)) : m.total = N(m.total + (T || 0)), m.cumulative = b === "group" ? (m.total || 1) - 1 : O(m.cumulative, l) + (T || 0), T !== null && (m.points[f].push(m.cumulative), h[D] = m.cumulative, m.hasValidPoints = !0);
          }
          b === "percent" && (n.stacking.usePercentage = !0), b !== "group" && (this.stackedYData = h), n.stacking.oldStacks = {};
        }
      }, H.prototype.modifyStacks = function() {
        var C = this, b = C.stackKey, w = C.yAxis.stacking.stacks, x = C.processedXData, h, c = C.options.stacking;
        C[c + "Stacker"] && [b, "-" + b].forEach(function(p) {
          for (var i = x.length, l, s; i--; )
            l = x[i], h = C.getStackIndicator(h, l, C.index, p), (s = (l = w[p] && w[p][l]) && l.points[h.key]) && C[c + "Stacker"](s, l, i);
        });
      }, H.prototype.percentStacker = function(C, b, w) {
        b = b.total ? 100 / b.total : 0, C[0] = N(C[0] * b), C[1] = N(C[1] * b), this.stackedYData[w] = C[1];
      }, H.prototype.getStackIndicator = function(C, b, w, x) {
        return !M(C) || C.x !== b || x && C.key !== x ? C = { x: b, index: 0, key: x } : C.index++, C.key = [w, b, C.index].join(), C;
      }, Z.StackItem = B, Z.StackItem;
    }), E(a, "Series/Line/LineSeries.js", [a["Core/Series/Series.js"], a["Core/Series/SeriesRegistry.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = this && this.__extends || function() {
        var U = function(W, N) {
          return U = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(M, v) {
            M.__proto__ = v;
          } || function(M, v) {
            for (var u in v)
              v.hasOwnProperty(u) && (M[u] = v[u]);
          }, U(W, N);
        };
        return function(W, N) {
          function M() {
            this.constructor = W;
          }
          U(W, N), W.prototype = N === null ? Object.create(N) : (M.prototype = N.prototype, new M());
        };
      }(), H = I.defined, $ = I.merge;
      return I = function(U) {
        function W() {
          var N = U !== null && U.apply(this, arguments) || this;
          return N.data = void 0, N.options = void 0, N.points = void 0, N;
        }
        return Z(W, U), W.prototype.drawGraph = function() {
          var N = this, M = this.options, v = (this.gappedPath || this.getGraphPath).call(this), u = this.chart.styledMode, d = [["graph", "highcharts-graph"]];
          u || d[0].push(M.lineColor || this.color || "#cccccc", M.dashStyle), d = N.getZonesGraphs(d), d.forEach(function(P, O) {
            var B = P[0], C = N[B], b = C ? "animate" : "attr";
            C ? (C.endX = N.preventGraphAnimation ? null : v.xMap, C.animate({ d: v })) : v.length && (N[B] = C = N.chart.renderer.path(v).addClass(P[1]).attr({ zIndex: 1 }).add(N.group)), C && !u && (B = { stroke: P[2], "stroke-width": M.lineWidth, fill: N.fillGraph && N.color || "none" }, P[3] ? B.dashstyle = P[3] : M.linecap !== "square" && (B["stroke-linecap"] = B["stroke-linejoin"] = "round"), C[b](B).shadow(2 > O && M.shadow)), C && (C.startX = v.xMap, C.isArea = v.isArea);
          });
        }, W.prototype.getGraphPath = function(N, M, v) {
          var u = this, d = u.options, P = [], O = [], B, C = d.step;
          N = N || u.points;
          var b = N.reversed;
          return b && N.reverse(), (C = { right: 1, center: 2 }[C] || C && 3) && b && (C = 4 - C), N = this.getValidPoints(N, !1, !(d.connectNulls && !M && !v)), N.forEach(function(w, x) {
            var h = w.plotX, c = w.plotY, p = N[x - 1];
            (w.leftCliff || p && p.rightCliff) && !v && (B = !0), w.isNull && !H(M) && 0 < x ? B = !d.connectNulls : w.isNull && !M ? B = !0 : (x === 0 || B ? x = [["M", w.plotX, w.plotY]] : u.getPointSpline ? x = [u.getPointSpline(N, w, x)] : C ? (x = C === 1 ? [["L", p.plotX, c]] : C === 2 ? [["L", (p.plotX + h) / 2, p.plotY], ["L", (p.plotX + h) / 2, c]] : [["L", h, p.plotY]], x.push(["L", h, c])) : x = [["L", h, c]], O.push(w.x), C && (O.push(w.x), C === 2 && O.push(w.x)), P.push.apply(P, x), B = !1);
          }), P.xMap = O, u.graphPath = P;
        }, W.prototype.getZonesGraphs = function(N) {
          return this.zones.forEach(function(M, v) {
            v = ["zone-graph-" + v, "highcharts-graph highcharts-zone-graph-" + v + " " + (M.className || "")], this.chart.styledMode || v.push(M.color || this.color, M.dashStyle || this.options.dashStyle), N.push(v);
          }, this), N;
        }, W.defaultOptions = $(y.defaultOptions, {}), W;
      }(y), R.registerSeriesType("line", I), I;
    }), E(a, "Series/Area/AreaSeries.js", [
      a["Core/Color/Color.js"],
      a["Core/Legend/LegendSymbol.js"],
      a["Core/Series/SeriesRegistry.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I, Z) {
      var H = this && this.__extends || function() {
        var v = function(u, d) {
          return v = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(P, O) {
            P.__proto__ = O;
          } || function(P, O) {
            for (var B in O)
              O.hasOwnProperty(B) && (P[B] = O[B]);
          }, v(u, d);
        };
        return function(u, d) {
          function P() {
            this.constructor = u;
          }
          v(u, d), u.prototype = d === null ? Object.create(d) : (P.prototype = d.prototype, new P());
        };
      }(), $ = y.parse, U = I.seriesTypes.line;
      y = Z.extend;
      var W = Z.merge, N = Z.objectEach, M = Z.pick;
      return Z = function(v) {
        function u() {
          var d = v !== null && v.apply(this, arguments) || this;
          return d.data = void 0, d.options = void 0, d.points = void 0, d;
        }
        return H(u, v), u.prototype.drawGraph = function() {
          this.areaPath = [], v.prototype.drawGraph.apply(this);
          var d = this, P = this.areaPath, O = this.options, B = [["area", "highcharts-area", this.color, O.fillColor]];
          this.zones.forEach(function(C, b) {
            B.push(["zone-area-" + b, "highcharts-area highcharts-zone-area-" + b + " " + C.className, C.color || d.color, C.fillColor || O.fillColor]);
          }), B.forEach(function(C) {
            var b = C[0], w = d[b], x = w ? "animate" : "attr", h = {};
            w ? (w.endX = d.preventGraphAnimation ? null : P.xMap, w.animate({ d: P })) : (h.zIndex = 0, w = d[b] = d.chart.renderer.path(P).addClass(C[1]).add(d.group), w.isArea = !0), d.chart.styledMode || (h.fill = M(C[3], $(C[2]).setOpacity(M(O.fillOpacity, 0.75)).get())), w[x](h), w.startX = P.xMap, w.shiftUnit = O.step ? 2 : 1;
          });
        }, u.prototype.getGraphPath = function(d) {
          var P = U.prototype.getGraphPath, O = this.options, B = O.stacking, C = this.yAxis, b, w = [], x = [], h = this.index, c = C.stacking.stacks[this.stackKey], p = O.threshold, i = Math.round(C.getThreshold(O.threshold));
          O = M(O.connectNulls, B === "percent");
          var l = function(o, A, _) {
            var D = d[o];
            o = B && c[D.x].points[h];
            var j = D[_ + "Null"] || 0;
            if (_ = D[_ + "Cliff"] || 0, D = !0, _ || j) {
              var T = (j ? o[0] : o[1]) + _, X = o[0] + _;
              D = !!j;
            } else
              !B && d[A] && d[A].isNull && (T = X = p);
            typeof T < "u" && (x.push({ plotX: t, plotY: T === null ? i : C.getThreshold(T), isNull: D, isCliff: !0 }), w.push({ plotX: t, plotY: X === null ? i : C.getThreshold(X), doCurve: !1 }));
          };
          for (d = d || this.points, B && (d = this.getStackPoints(d)), b = 0; b < d.length; b++) {
            B || (d[b].leftCliff = d[b].rightCliff = d[b].leftNull = d[b].rightNull = void 0);
            var s = d[b].isNull, t = M(d[b].rectPlotX, d[b].plotX), n = B ? M(d[b].yBottom, i) : i;
            (!s || O) && (O || l(b, b - 1, "left"), s && !B && O || (x.push(d[b]), w.push({ x: b, plotX: t, plotY: n })), O || l(b, b + 1, "right"));
          }
          return b = P.call(this, x, !0, !0), w.reversed = !0, s = P.call(this, w, !0, !0), (n = s[0]) && n[0] === "M" && (s[0] = ["L", n[1], n[2]]), s = b.concat(s), s.length && s.push(["Z"]), P = P.call(this, x, !1, O), s.xMap = b.xMap, this.areaPath = s, P;
        }, u.prototype.getStackPoints = function(d) {
          var P = this, O = [], B = [], C = this.xAxis, b = this.yAxis, w = b.stacking.stacks[this.stackKey], x = {}, h = b.series, c = h.length, p = b.options.reversedStacks ? 1 : -1, i = h.indexOf(P);
          if (d = d || this.points, this.options.stacking) {
            for (var l = 0; l < d.length; l++)
              d[l].leftNull = d[l].rightNull = void 0, x[d[l].x] = d[l];
            N(w, function(t, n) {
              t.total !== null && B.push(n);
            }), B.sort(function(t, n) {
              return t - n;
            });
            var s = h.map(function(t) {
              return t.visible;
            });
            B.forEach(function(t, n) {
              var o = 0, A, _;
              if (x[t] && !x[t].isNull)
                O.push(x[t]), [-1, 1].forEach(function(j) {
                  var T = j === 1 ? "rightNull" : "leftNull", X = 0, f = w[B[n + j]];
                  if (f)
                    for (var m = i; 0 <= m && m < c; ) {
                      var L = h[m].index;
                      A = f.points[L], A || (L === P.index ? x[t][T] = !0 : s[m] && (_ = w[t].points[L]) && (X -= _[1] - _[0])), m += p;
                    }
                  x[t][j === 1 ? "rightCliff" : "leftCliff"] = X;
                });
              else {
                for (var D = i; 0 <= D && D < c; ) {
                  if (A = w[t].points[h[D].index]) {
                    o = A[1];
                    break;
                  }
                  D += p;
                }
                o = M(o, 0), o = b.translate(o, 0, 1, 0, 1), O.push({ isNull: !0, plotX: C.translate(t, 0, 0, 0, 1), x: t, plotY: o, yBottom: o });
              }
            });
          }
          return O;
        }, u.defaultOptions = W(U.defaultOptions, { threshold: 0 }), u;
      }(U), y(Z.prototype, {
        singleStacks: !1,
        drawLegendSymbol: R.drawRectangle
      }), I.registerSeriesType("area", Z), Z;
    }), E(a, "Series/Spline/SplineSeries.js", [a["Core/Series/SeriesRegistry.js"], a["Core/Utilities.js"]], function(y, R) {
      var I = this && this.__extends || function() {
        var U = function(W, N) {
          return U = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(M, v) {
            M.__proto__ = v;
          } || function(M, v) {
            for (var u in v)
              v.hasOwnProperty(u) && (M[u] = v[u]);
          }, U(W, N);
        };
        return function(W, N) {
          function M() {
            this.constructor = W;
          }
          U(W, N), W.prototype = N === null ? Object.create(N) : (M.prototype = N.prototype, new M());
        };
      }(), Z = y.seriesTypes.line, H = R.merge, $ = R.pick;
      return R = function(U) {
        function W() {
          var N = U !== null && U.apply(this, arguments) || this;
          return N.data = void 0, N.options = void 0, N.points = void 0, N;
        }
        return I(W, U), W.prototype.getPointSpline = function(N, M, v) {
          var u = M.plotX || 0, d = M.plotY || 0, P = N[v - 1];
          if (v = N[v + 1], P && !P.isNull && P.doCurve !== !1 && !M.isCliff && v && !v.isNull && v.doCurve !== !1 && !M.isCliff) {
            N = P.plotY || 0;
            var O = v.plotX || 0;
            v = v.plotY || 0;
            var B = 0, C = (1.5 * u + (P.plotX || 0)) / 2.5, b = (1.5 * d + N) / 2.5;
            O = (1.5 * u + O) / 2.5;
            var w = (1.5 * d + v) / 2.5;
            O !== C && (B = (w - b) * (O - u) / (O - C) + d - w), b += B, w += B, b > N && b > d ? (b = Math.max(N, d), w = 2 * d - b) : b < N && b < d && (b = Math.min(N, d), w = 2 * d - b), w > v && w > d ? (w = Math.max(v, d), b = 2 * d - w) : w < v && w < d && (w = Math.min(v, d), b = 2 * d - w), M.rightContX = O, M.rightContY = w;
          }
          return M = ["C", $(P.rightContX, P.plotX, 0), $(P.rightContY, P.plotY, 0), $(C, u, 0), $(b, d, 0), u, d], P.rightContX = P.rightContY = void 0, M;
        }, W.defaultOptions = H(Z.defaultOptions), W;
      }(Z), y.registerSeriesType("spline", R), R;
    }), E(
      a,
      "Series/AreaSpline/AreaSplineSeries.js",
      [a["Series/Area/AreaSeries.js"], a["Series/Spline/SplineSeries.js"], a["Core/Legend/LegendSymbol.js"], a["Core/Series/SeriesRegistry.js"], a["Core/Utilities.js"]],
      function(y, R, I, Z, H) {
        var $ = this && this.__extends || function() {
          var M = function(v, u) {
            return M = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d, P) {
              d.__proto__ = P;
            } || function(d, P) {
              for (var O in P)
                P.hasOwnProperty(O) && (d[O] = P[O]);
            }, M(v, u);
          };
          return function(v, u) {
            function d() {
              this.constructor = v;
            }
            M(v, u), v.prototype = u === null ? Object.create(u) : (d.prototype = u.prototype, new d());
          };
        }(), U = y.prototype, W = H.extend, N = H.merge;
        return H = function(M) {
          function v() {
            var u = M !== null && M.apply(this, arguments) || this;
            return u.data = void 0, u.points = void 0, u.options = void 0, u;
          }
          return $(v, M), v.defaultOptions = N(R.defaultOptions, y.defaultOptions), v;
        }(R), W(H.prototype, { getGraphPath: U.getGraphPath, getStackPoints: U.getStackPoints, drawGraph: U.drawGraph, drawLegendSymbol: I.drawRectangle }), Z.registerSeriesType("areaspline", H), H;
      }
    ), E(a, "Series/Column/ColumnSeries.js", [
      a["Core/Animation/AnimationUtilities.js"],
      a["Core/Color/Color.js"],
      a["Core/Globals.js"],
      a["Core/Legend/LegendSymbol.js"],
      a["Core/Series/Series.js"],
      a["Core/Series/SeriesRegistry.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I, Z, H, $, U) {
      var W = this && this.__extends || function() {
        var c = function(p, i) {
          return c = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(l, s) {
            l.__proto__ = s;
          } || function(l, s) {
            for (var t in s)
              s.hasOwnProperty(t) && (l[t] = s[t]);
          }, c(p, i);
        };
        return function(p, i) {
          function l() {
            this.constructor = p;
          }
          c(p, i), p.prototype = i === null ? Object.create(i) : (l.prototype = i.prototype, new l());
        };
      }(), N = y.animObject, M = R.parse, v = I.hasTouch;
      y = I.noop;
      var u = U.clamp, d = U.css, P = U.defined, O = U.extend, B = U.fireEvent, C = U.isArray, b = U.isNumber, w = U.merge, x = U.pick, h = U.objectEach;
      return U = function(c) {
        function p() {
          var i = c !== null && c.apply(this, arguments) || this;
          return i.borderWidth = void 0, i.data = void 0, i.group = void 0, i.options = void 0, i.points = void 0, i;
        }
        return W(p, c), p.prototype.animate = function(i) {
          var l = this, s = this.yAxis, t = l.options, n = this.chart.inverted, o = {}, A = n ? "translateX" : "translateY";
          if (i)
            o.scaleY = 1e-3, i = u(s.toPixels(t.threshold), s.pos, s.pos + s.len), n ? o.translateX = i - s.len : o.translateY = i, l.clipBox && l.setClip(), l.group.attr(o);
          else {
            var _ = Number(l.group.attr(A));
            l.group.animate({ scaleY: 1 }, O(N(l.options.animation), { step: function(D, j) {
              l.group && (o[A] = _ + j.pos * (s.pos - _), l.group.attr(o));
            } }));
          }
        }, p.prototype.init = function(i, l) {
          c.prototype.init.apply(this, arguments);
          var s = this;
          i = s.chart, i.hasRendered && i.series.forEach(function(t) {
            t.type === s.type && (t.isDirty = !0);
          });
        }, p.prototype.getColumnMetrics = function() {
          var i = this, l = i.options, s = i.xAxis, t = i.yAxis, n = s.options.reversedStacks;
          n = s.reversed && !n || !s.reversed && n;
          var o = {}, A, _ = 0;
          l.grouping === !1 ? _ = 1 : i.chart.series.forEach(function(X) {
            var f = X.yAxis, m = X.options;
            if (X.type === i.type && (X.visible || !i.chart.options.chart.ignoreHiddenSeries) && t.len === f.len && t.pos === f.pos) {
              if (m.stacking && m.stacking !== "group") {
                A = X.stackKey, typeof o[A] > "u" && (o[A] = _++);
                var L = o[A];
              } else
                m.grouping !== !1 && (L = _++);
              X.columnIndex = L;
            }
          });
          var D = Math.min(Math.abs(s.transA) * (s.ordinal && s.ordinal.slope || l.pointRange || s.closestPointRange || s.tickInterval || 1), s.len), j = D * l.groupPadding, T = (D - 2 * j) / (_ || 1);
          return l = Math.min(l.maxPointWidth || s.len, x(l.pointWidth, T * (1 - 2 * l.pointPadding))), i.columnMetrics = { width: l, offset: (T - l) / 2 + (j + ((i.columnIndex || 0) + (n ? 1 : 0)) * T - D / 2) * (n ? -1 : 1), paddedWidth: T, columnCount: _ }, i.columnMetrics;
        }, p.prototype.crispCol = function(i, l, s, t) {
          var n = this.chart, o = this.borderWidth, A = -(o % 2 ? 0.5 : 0);
          return o = o % 2 ? 0.5 : 1, n.inverted && n.renderer.isVML && (o += 1), this.options.crisp && (s = Math.round(i + s) + A, i = Math.round(i) + A, s -= i), t = Math.round(l + t) + o, A = 0.5 >= Math.abs(l) && 0.5 < t, l = Math.round(l) + o, t -= l, A && t && (--l, t += 1), { x: i, y: l, width: s, height: t };
        }, p.prototype.adjustForMissingColumns = function(i, l, s, t) {
          var n = this, o = this.options.stacking;
          if (!s.isNull && 1 < t.columnCount) {
            var A = 0, _ = 0;
            h(this.yAxis.stacking && this.yAxis.stacking.stacks, function(D) {
              if (typeof s.x == "number" && (D = D[s.x.toString()])) {
                var j = D.points[n.index], T = D.total;
                o ? (j && (A = _), D.hasValidPoints && _++) : C(j) && (A = j[1], _ = T || 0);
              }
            }), i = (s.plotX || 0) + ((_ - 1) * t.paddedWidth + l) / 2 - l - A * t.paddedWidth;
          }
          return i;
        }, p.prototype.translate = function() {
          var i = this, l = i.chart, s = i.options, t = i.dense = 2 > i.closestPointRange * i.xAxis.transA;
          t = i.borderWidth = x(s.borderWidth, t ? 0 : 1);
          var n = i.xAxis, o = i.yAxis, A = s.threshold, _ = i.translatedThreshold = o.getThreshold(A), D = x(s.minPointLength, 5), j = i.getColumnMetrics(), T = j.width, X = i.pointXOffset = j.offset, f = i.dataMin, m = i.dataMax, L = i.barW = Math.max(T, 1 + 2 * t);
          l.inverted && (_ -= 0.5), s.pointPadding && (L = Math.ceil(L)), H.prototype.translate.apply(i), i.points.forEach(function(Y) {
            var F = x(Y.yBottom, _), Q = 999 + Math.abs(F), k = Y.plotX || 0;
            Q = u(Y.plotY, -Q, o.len + Q);
            var G = Math.min(Q, F), z = Math.max(Q, F) - G, V = T, q = k + X, it = L;
            D && Math.abs(z) < D && (z = D, k = !o.reversed && !Y.negative || o.reversed && Y.negative, b(A) && b(m) && Y.y === A && m <= A && (o.min || 0) < A && (f !== m || (o.max || 0) <= A) && (k = !k), G = Math.abs(G - _) > D ? F - D : _ - (k ? D : 0)), P(Y.options.pointWidth) && (V = it = Math.ceil(Y.options.pointWidth), q -= Math.round((V - T) / 2)), s.centerInCategory && (q = i.adjustForMissingColumns(q, V, Y, j)), Y.barX = q, Y.pointWidth = V, Y.tooltipPos = l.inverted ? [u(o.len + o.pos - l.plotLeft - Q, o.pos - l.plotLeft, o.len + o.pos - l.plotLeft), n.len + n.pos - l.plotTop - q - it / 2, z] : [n.left - l.plotLeft + q + it / 2, u(Q + o.pos - l.plotTop, o.pos - l.plotTop, o.len + o.pos - l.plotTop), z], Y.shapeType = i.pointClass.prototype.shapeType || "rect", Y.shapeArgs = i.crispCol.apply(i, Y.isNull ? [q, _, it, 0] : [q, G, it, z]);
          });
        }, p.prototype.drawGraph = function() {
          this.group[this.dense ? "addClass" : "removeClass"]("highcharts-dense-data");
        }, p.prototype.pointAttribs = function(i, l) {
          var s = this.options, t = this.pointAttrToOptions || {}, n = t.stroke || "borderColor", o = t["stroke-width"] || "borderWidth", A = i && i.color || this.color, _ = i && i[n] || s[n] || A;
          t = i && i.options.dashStyle || s.dashStyle;
          var D = i && i[o] || s[o] || this[o] || 0, j = x(i && i.opacity, s.opacity, 1);
          if (i && this.zones.length) {
            var T = i.getZone();
            A = i.options.color || T && (T.color || i.nonZonedColor) || this.color, T && (_ = T.borderColor || _, t = T.dashStyle || t, D = T.borderWidth || D);
          }
          return l && i && (i = w(s.states[l], i.options.states && i.options.states[l] || {}), l = i.brightness, A = i.color || typeof l < "u" && M(A).brighten(i.brightness).get() || A, _ = i[n] || _, D = i[o] || D, t = i.dashStyle || t, j = x(i.opacity, j)), n = { fill: A, stroke: _, "stroke-width": D, opacity: j }, t && (n.dashstyle = t), n;
        }, p.prototype.drawPoints = function() {
          var i = this, l = this.chart, s = i.options, t = l.renderer, n = s.animationLimit || 250, o;
          i.points.forEach(function(A) {
            var _ = A.graphic, D = !!_, j = _ && l.pointCount < n ? "animate" : "attr";
            b(A.plotY) && A.y !== null ? (o = A.shapeArgs, _ && A.hasNewShapeType() && (_ = _.destroy()), i.enabledDataSorting && (A.startXPos = i.xAxis.reversed ? -(o && o.width || 0) : i.xAxis.width), _ || (A.graphic = _ = t[A.shapeType](o).add(A.group || i.group)) && i.enabledDataSorting && l.hasRendered && l.pointCount < n && (_.attr({ x: A.startXPos }), D = !0, j = "animate"), _ && D && _[j](w(o)), s.borderRadius && _[j]({ r: s.borderRadius }), l.styledMode || _[j](i.pointAttribs(A, A.selected && "select")).shadow(A.allowShadow !== !1 && s.shadow, null, s.stacking && !s.borderRadius), _ && (_.addClass(A.getClassName(), !0), _.attr({ visibility: A.visible ? "inherit" : "hidden" }))) : _ && (A.graphic = _.destroy());
          });
        }, p.prototype.drawTracker = function() {
          var i = this, l = i.chart, s = l.pointer, t = function(o) {
            var A = s.getPointFromEvent(o);
            typeof A < "u" && (s.isDirectTouch = !0, A.onMouseOver(o));
          }, n;
          i.points.forEach(function(o) {
            n = C(o.dataLabels) ? o.dataLabels : o.dataLabel ? [o.dataLabel] : [], o.graphic && (o.graphic.element.point = o), n.forEach(function(A) {
              A.div ? A.div.point = o : A.element.point = o;
            });
          }), i._hasTracking || (i.trackerGroups.forEach(function(o) {
            i[o] && (i[o].addClass("highcharts-tracker").on("mouseover", t).on("mouseout", function(A) {
              s.onTrackerMouseOut(A);
            }), v && i[o].on(
              "touchstart",
              t
            ), !l.styledMode && i.options.cursor && i[o].css(d).css({ cursor: i.options.cursor }));
          }), i._hasTracking = !0), B(this, "afterDrawTracker");
        }, p.prototype.remove = function() {
          var i = this, l = i.chart;
          l.hasRendered && l.series.forEach(function(s) {
            s.type === i.type && (s.isDirty = !0);
          }), H.prototype.remove.apply(i, arguments);
        }, p.defaultOptions = w(H.defaultOptions, { borderRadius: 0, centerInCategory: !1, groupPadding: 0.2, marker: null, pointPadding: 0.1, minPointLength: 0, cropThreshold: 50, pointRange: null, states: {
          hover: { halo: !1, brightness: 0.1 },
          select: { color: "#cccccc", borderColor: "#000000" }
        }, dataLabels: { align: void 0, verticalAlign: void 0, y: void 0 }, startFromThreshold: !0, stickyTracking: !1, tooltip: { distance: 6 }, threshold: 0, borderColor: "#ffffff" }), p;
      }(H), O(U.prototype, { cropShoulder: 0, directTouch: !0, drawLegendSymbol: Z.drawRectangle, getSymbol: y, negStacks: !0, trackerGroups: ["group", "dataLabelsGroup"] }), $.registerSeriesType("column", U), U;
    }), E(a, "Core/Series/DataLabel.js", [
      a["Core/Animation/AnimationUtilities.js"],
      a["Core/FormatUtilities.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I) {
      var Z = y.getDeferredAnimation, H = R.format, $ = I.defined, U = I.extend, W = I.fireEvent, N = I.isArray, M = I.merge, v = I.objectEach, u = I.pick, d = I.splat, P;
      return function(O) {
        function B(p, i, l, s, t) {
          var n = this, o = this.chart, A = this.isCartesian && o.inverted, _ = this.enabledDataSorting, D = u(p.dlBox && p.dlBox.centerX, p.plotX, -9999), j = u(p.plotY, -9999), T = i.getBBox(), X = l.rotation, f = l.align, m = o.isInsidePlot(D, Math.round(j), { inverted: A, paneCoordinates: !0, series: n }), L = function(k) {
            _ && n.xAxis && !Y && n.setDataLabelStartPos(
              p,
              i,
              t,
              m,
              k
            );
          }, Y = u(l.overflow, _ ? "none" : "justify") === "justify", F = this.visible && p.visible !== !1 && (p.series.forceDL || _ && !Y || m || u(l.inside, !!this.options.stacking) && s && o.isInsidePlot(D, A ? s.x + 1 : s.y + s.height - 1, { inverted: A, paneCoordinates: !0, series: n }));
          if (F) {
            var Q = o.renderer.fontMetrics(o.styledMode ? void 0 : l.style.fontSize, i).b;
            s = U({ x: A ? this.yAxis.len - j : D, y: Math.round(A ? this.xAxis.len - D : j), width: 0, height: 0 }, s), U(l, { width: T.width, height: T.height }), X ? (Y = !1, D = o.renderer.rotCorr(Q, X), D = { x: s.x + (l.x || 0) + s.width / 2 + D.x, y: s.y + (l.y || 0) + { top: 0, middle: 0.5, bottom: 1 }[l.verticalAlign] * s.height }, L(D), i[t ? "attr" : "animate"](D).attr({ align: f }), L = (X + 720) % 360, L = 180 < L && 360 > L, f === "left" ? D.y -= L ? T.height : 0 : f === "center" ? (D.x -= T.width / 2, D.y -= T.height / 2) : f === "right" && (D.x -= T.width, D.y -= L ? 0 : T.height), i.placed = !0, i.alignAttr = D) : (L(s), i.align(l, void 0, s), D = i.alignAttr), Y && 0 <= s.height ? this.justifyDataLabel(i, l, D, T, s, t) : u(l.crop, !0) && (F = o.isInsidePlot(D.x, D.y, { paneCoordinates: !0, series: n }) && o.isInsidePlot(D.x + T.width, D.y + T.height, {
              paneCoordinates: !0,
              series: n
            })), l.shape && !X && i[t ? "attr" : "animate"]({ anchorX: A ? o.plotWidth - p.plotY : p.plotX, anchorY: A ? o.plotHeight - p.plotX : p.plotY });
          }
          t && _ && (i.placed = !1), F || _ && !Y || (i.hide(!0), i.placed = !1);
        }
        function C(p, i) {
          var l = i.filter;
          return l ? (i = l.operator, p = p[l.property], l = l.value, i === ">" && p > l || i === "<" && p < l || i === ">=" && p >= l || i === "<=" && p <= l || i === "==" && p == l || i === "===" && p === l) : !0;
        }
        function b() {
          var p = this, i = p.chart, l = p.options, s = p.points, t = p.hasRendered || 0, n = i.renderer, o = l.dataLabels, A, _ = o.animation;
          if (_ = o.defer ? Z(
            i,
            _,
            p
          ) : { defer: 0, duration: 0 }, o = x(x(i.options.plotOptions && i.options.plotOptions.series && i.options.plotOptions.series.dataLabels, i.options.plotOptions && i.options.plotOptions[p.type] && i.options.plotOptions[p.type].dataLabels), o), W(this, "drawDataLabels"), N(o) || o.enabled || p._hasPointLabels) {
            var D = p.plotGroup("dataLabelsGroup", "data-labels", t ? "inherit" : "hidden", o.zIndex || 6);
            D.attr({ opacity: +t }), !t && (t = p.dataLabelsGroup) && (p.visible && D.show(!0), t[l.animation ? "animate" : "attr"]({ opacity: 1 }, _)), s.forEach(function(j) {
              A = d(x(o, j.dlOptions || j.options && j.options.dataLabels)), A.forEach(function(T, X) {
                var f = T.enabled && (!j.isNull || j.dataLabelOnNull) && C(j, T), m = j.connectors ? j.connectors[X] : j.connector, L = j.dataLabels ? j.dataLabels[X] : j.dataLabel, Y = u(T.distance, j.labelDistance), F = !L;
                if (f) {
                  var Q = j.getLabelConfig(), k = u(T[j.formatPrefix + "Format"], T.format);
                  Q = $(k) ? H(k, Q, i) : (T[j.formatPrefix + "Formatter"] || T.formatter).call(Q, T), k = T.style;
                  var G = T.rotation;
                  i.styledMode || (k.color = u(T.color, k.color, p.color, "#000000"), k.color === "contrast" ? (j.contrastColor = n.getContrast(j.color || p.color), k.color = !$(Y) && T.inside || 0 > Y || l.stacking ? j.contrastColor : "#000000") : delete j.contrastColor, l.cursor && (k.cursor = l.cursor));
                  var z = { r: T.borderRadius || 0, rotation: G, padding: T.padding, zIndex: 1 };
                  i.styledMode || (z.fill = T.backgroundColor, z.stroke = T.borderColor, z["stroke-width"] = T.borderWidth), v(z, function(V, q) {
                    typeof V > "u" && delete z[q];
                  });
                }
                !L || f && $(Q) && !!L.div == !!T.useHTML || (j.dataLabel = L = j.dataLabel && j.dataLabel.destroy(), j.dataLabels && (j.dataLabels.length === 1 ? delete j.dataLabels : delete j.dataLabels[X]), X || delete j.dataLabel, m && (j.connector = j.connector.destroy(), j.connectors && (j.connectors.length === 1 ? delete j.connectors : delete j.connectors[X]))), f && $(Q) && (L ? z.text = Q : (j.dataLabels = j.dataLabels || [], L = j.dataLabels[X] = G ? n.text(Q, 0, -9999, T.useHTML).addClass("highcharts-data-label") : n.label(Q, 0, -9999, T.shape, null, null, T.useHTML, null, "data-label"), X || (j.dataLabel = L), L.addClass(" highcharts-data-label-color-" + j.colorIndex + " " + (T.className || "") + (T.useHTML ? " highcharts-tracker" : ""))), L.options = T, L.attr(z), i.styledMode || L.css(k).shadow(T.shadow), L.added || L.add(D), T.textPath && !T.useHTML && (L.setTextPath(j.getDataLabelPath && j.getDataLabelPath(L) || j.graphic, T.textPath), j.dataLabelPath && !T.textPath.enabled && (j.dataLabelPath = j.dataLabelPath.destroy())), p.alignDataLabel(j, L, T, null, F));
              });
            });
          }
          W(this, "afterDrawDataLabels");
        }
        function w(p, i, l, s, t, n) {
          var o = this.chart, A = i.align, _ = i.verticalAlign, D = p.box ? 0 : p.padding || 0, j = i.x;
          j = j === void 0 ? 0 : j;
          var T = i.y;
          T = T === void 0 ? 0 : T;
          var X = (l.x || 0) + D;
          if (0 > X) {
            A === "right" && 0 <= j ? (i.align = "left", i.inside = !0) : j -= X;
            var f = !0;
          }
          return X = (l.x || 0) + s.width - D, X > o.plotWidth && (A === "left" && 0 >= j ? (i.align = "right", i.inside = !0) : j += o.plotWidth - X, f = !0), X = l.y + D, 0 > X && (_ === "bottom" && 0 <= T ? (i.verticalAlign = "top", i.inside = !0) : T -= X, f = !0), X = (l.y || 0) + s.height - D, X > o.plotHeight && (_ === "top" && 0 >= T ? (i.verticalAlign = "bottom", i.inside = !0) : T += o.plotHeight - X, f = !0), f && (i.x = j, i.y = T, p.placed = !n, p.align(i, void 0, t)), f;
        }
        function x(p, i) {
          var l = [], s;
          if (N(p) && !N(i))
            l = p.map(function(t) {
              return M(t, i);
            });
          else if (N(i) && !N(p))
            l = i.map(function(t) {
              return M(p, t);
            });
          else if (N(p) || N(i))
            for (s = Math.max(p.length, i.length); s--; )
              l[s] = M(p[s], i[s]);
          else
            l = M(p, i);
          return l;
        }
        function h(p, i, l, s, t) {
          var n = this.chart, o = n.inverted, A = this.xAxis, _ = A.reversed, D = o ? i.height / 2 : i.width / 2;
          p = (p = p.pointWidth) ? p / 2 : 0, i.startXPos = o ? t.x : _ ? -D - p : A.width - D + p, i.startYPos = o ? _ ? this.yAxis.height - D + p : -D - p : t.y, s ? i.visibility === "hidden" && (i.show(), i.attr({ opacity: 0 }).animate({ opacity: 1 })) : i.attr({ opacity: 1 }).animate(
            { opacity: 0 },
            void 0,
            i.hide
          ), n.hasRendered && (l && i.attr({ x: i.startXPos, y: i.startYPos }), i.placed = !0);
        }
        var c = [];
        O.compose = function(p) {
          if (c.indexOf(p) === -1) {
            var i = p.prototype;
            c.push(p), i.alignDataLabel = B, i.drawDataLabels = b, i.justifyDataLabel = w, i.setDataLabelStartPos = h;
          }
        };
      }(P || (P = {})), P;
    }), E(a, "Series/Column/ColumnDataLabel.js", [a["Core/Series/DataLabel.js"], a["Core/Series/SeriesRegistry.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = R.series, H = I.merge, $ = I.pick, U;
      return function(W) {
        function N(v, u, d, P, O) {
          var B = this.chart.inverted, C = v.series, b = (C.xAxis ? C.xAxis.len : this.chart.plotSizeX) || 0;
          C = (C.yAxis ? C.yAxis.len : this.chart.plotSizeY) || 0;
          var w = v.dlBox || v.shapeArgs, x = $(v.below, v.plotY > $(this.translatedThreshold, C)), h = $(d.inside, !!this.options.stacking);
          w && (P = H(w), 0 > P.y && (P.height += P.y, P.y = 0), w = P.y + P.height - C, 0 < w && w < P.height && (P.height -= w), B && (P = { x: C - P.y - P.height, y: b - P.x - P.width, width: P.height, height: P.width }), h || (B ? (P.x += x ? 0 : P.width, P.width = 0) : (P.y += x ? P.height : 0, P.height = 0))), d.align = $(d.align, !B || h ? "center" : x ? "right" : "left"), d.verticalAlign = $(d.verticalAlign, B || h ? "middle" : x ? "top" : "bottom"), Z.prototype.alignDataLabel.call(this, v, u, d, P, O), d.inside && v.contrastColor && u.css({ color: v.contrastColor });
        }
        var M = [];
        W.compose = function(v) {
          y.compose(Z), M.indexOf(v) === -1 && (M.push(v), v.prototype.alignDataLabel = N);
        };
      }(U || (U = {})), U;
    }), E(a, "Series/Bar/BarSeries.js", [a["Series/Column/ColumnSeries.js"], a["Core/Series/SeriesRegistry.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = this && this.__extends || function() {
        var U = function(W, N) {
          return U = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(M, v) {
            M.__proto__ = v;
          } || function(M, v) {
            for (var u in v)
              v.hasOwnProperty(u) && (M[u] = v[u]);
          }, U(W, N);
        };
        return function(W, N) {
          function M() {
            this.constructor = W;
          }
          U(W, N), W.prototype = N === null ? Object.create(N) : (M.prototype = N.prototype, new M());
        };
      }(), H = I.extend, $ = I.merge;
      return I = function(U) {
        function W() {
          var N = U !== null && U.apply(this, arguments) || this;
          return N.data = void 0, N.options = void 0, N.points = void 0, N;
        }
        return Z(W, U), W.defaultOptions = $(
          y.defaultOptions,
          {}
        ), W;
      }(y), H(I.prototype, { inverted: !0 }), R.registerSeriesType("bar", I), I;
    }), E(a, "Series/Scatter/ScatterSeries.js", [a["Series/Column/ColumnSeries.js"], a["Series/Line/LineSeries.js"], a["Core/Series/SeriesRegistry.js"], a["Core/Utilities.js"]], function(y, R, I, Z) {
      var H = this && this.__extends || function() {
        var N = function(M, v) {
          return N = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(u, d) {
            u.__proto__ = d;
          } || function(u, d) {
            for (var P in d)
              d.hasOwnProperty(P) && (u[P] = d[P]);
          }, N(M, v);
        };
        return function(M, v) {
          function u() {
            this.constructor = M;
          }
          N(M, v), M.prototype = v === null ? Object.create(v) : (u.prototype = v.prototype, new u());
        };
      }(), $ = Z.addEvent, U = Z.extend, W = Z.merge;
      return Z = function(N) {
        function M() {
          var v = N !== null && N.apply(this, arguments) || this;
          return v.data = void 0, v.options = void 0, v.points = void 0, v;
        }
        return H(M, N), M.prototype.applyJitter = function() {
          var v = this, u = this.options.jitter, d = this.points.length;
          u && this.points.forEach(function(P, O) {
            ["x", "y"].forEach(function(B, C) {
              var b = "plot" + B.toUpperCase();
              if (u[B] && !P.isNull) {
                var w = v[B + "Axis"], x = u[B] * w.transA;
                if (w && !w.isLog) {
                  var h = Math.max(0, P[b] - x);
                  w = Math.min(w.len, P[b] + x), C = 1e4 * Math.sin(O + C * d), P[b] = h + (w - h) * (C - Math.floor(C)), B === "x" && (P.clientX = P.plotX);
                }
              }
            });
          });
        }, M.prototype.drawGraph = function() {
          this.options.lineWidth ? N.prototype.drawGraph.call(this) : this.graph && (this.graph = this.graph.destroy());
        }, M.defaultOptions = W(R.defaultOptions, { lineWidth: 0, findNearestPointBy: "xy", jitter: { x: 0, y: 0 }, marker: { enabled: !0 }, tooltip: {
          headerFormat: '<span style="color:{point.color}">●</span> <span style="font-size: 10px"> {series.name}</span><br/>',
          pointFormat: "x: <b>{point.x}</b><br/>y: <b>{point.y}</b><br/>"
        } }), M;
      }(R), U(Z.prototype, { drawTracker: y.prototype.drawTracker, sorted: !1, requireSorting: !1, noSharedTooltip: !0, trackerGroups: ["group", "markerGroup", "dataLabelsGroup"], takeOrdinalPosition: !1 }), $(Z, "afterTranslate", function() {
        this.applyJitter();
      }), I.registerSeriesType("scatter", Z), Z;
    }), E(a, "Series/CenteredUtilities.js", [a["Core/Globals.js"], a["Core/Series/Series.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = y.deg2rad, H = I.isNumber, $ = I.pick, U = I.relativeLength, W;
      return function(N) {
        N.getCenter = function() {
          var M = this.options, v = this.chart, u = 2 * (M.slicedOffset || 0), d = v.plotWidth - 2 * u, P = v.plotHeight - 2 * u, O = M.center, B = Math.min(d, P), C = M.size, b = M.innerSize || 0;
          for (typeof C == "string" && (C = parseFloat(C)), typeof b == "string" && (b = parseFloat(b)), M = [$(O[0], "50%"), $(O[1], "50%"), $(C && 0 > C ? void 0 : M.size, "100%"), $(b && 0 > b ? void 0 : M.innerSize || 0, "0%")], !v.angular || this instanceof R || (M[3] = 0), O = 0; 4 > O; ++O)
            C = M[O], v = 2 > O || O === 2 && /%$/.test(C), M[O] = U(C, [d, P, B, M[2]][O]) + (v ? u : 0);
          return M[3] > M[2] && (M[3] = M[2]), M;
        }, N.getStartAndEndRadians = function(M, v) {
          return M = H(M) ? M : 0, v = H(v) && v > M && 360 > v - M ? v : M + 360, { start: Z * (M + -90), end: Z * (v + -90) };
        };
      }(W || (W = {})), W;
    }), E(a, "Series/Pie/PiePoint.js", [a["Core/Animation/AnimationUtilities.js"], a["Core/Series/Point.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = this && this.__extends || function() {
        var v = function(u, d) {
          return v = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(P, O) {
            P.__proto__ = O;
          } || function(P, O) {
            for (var B in O)
              O.hasOwnProperty(B) && (P[B] = O[B]);
          }, v(u, d);
        };
        return function(u, d) {
          function P() {
            this.constructor = u;
          }
          v(u, d), u.prototype = d === null ? Object.create(d) : (P.prototype = d.prototype, new P());
        };
      }(), H = y.setAnimation, $ = I.addEvent, U = I.defined;
      y = I.extend;
      var W = I.isNumber, N = I.pick, M = I.relativeLength;
      return R = function(v) {
        function u() {
          var d = v !== null && v.apply(this, arguments) || this;
          return d.labelDistance = void 0, d.options = void 0, d.series = void 0, d;
        }
        return Z(u, v), u.prototype.getConnectorPath = function() {
          var d = this.labelPosition, P = this.series.options.dataLabels, O = this.connectorShapes, B = P.connectorShape;
          return O[B] && (B = O[B]), B.call(this, { x: d.final.x, y: d.final.y, alignment: d.alignment }, d.connectorPosition, P);
        }, u.prototype.getTranslate = function() {
          return this.sliced ? this.slicedTranslation : { translateX: 0, translateY: 0 };
        }, u.prototype.haloPath = function(d) {
          var P = this.shapeArgs;
          return this.sliced || !this.visible ? [] : this.series.chart.renderer.symbols.arc(P.x, P.y, P.r + d, P.r + d, { innerR: P.r - 1, start: P.start, end: P.end });
        }, u.prototype.init = function() {
          var d = this;
          v.prototype.init.apply(
            this,
            arguments
          ), this.name = N(this.name, "Slice");
          var P = function(O) {
            d.slice(O.type === "select");
          };
          return $(this, "select", P), $(this, "unselect", P), this;
        }, u.prototype.isValid = function() {
          return W(this.y) && 0 <= this.y;
        }, u.prototype.setVisible = function(d, P) {
          var O = this, B = this.series, C = B.chart, b = B.options.ignoreHiddenPoint;
          P = N(P, b), d !== this.visible && (this.visible = this.options.visible = d = typeof d > "u" ? !this.visible : d, B.options.data[B.data.indexOf(this)] = this.options, ["graphic", "dataLabel", "connector", "shadowGroup"].forEach(function(w) {
            O[w] && O[w][d ? "show" : "hide"](d);
          }), this.legendItem && C.legend.colorizeItem(this, d), d || this.state !== "hover" || this.setState(""), b && (B.isDirty = !0), P && C.redraw());
        }, u.prototype.slice = function(d, P, O) {
          var B = this.series;
          H(O, B.chart), N(P, !0), this.sliced = this.options.sliced = U(d) ? d : !this.sliced, B.options.data[B.data.indexOf(this)] = this.options, this.graphic && this.graphic.animate(this.getTranslate()), this.shadowGroup && this.shadowGroup.animate(this.getTranslate());
        }, u;
      }(R), y(R.prototype, { connectorShapes: { fixedOffset: function(v, u, d) {
        var P = u.breakAt;
        return u = u.touchingSliceAt, [["M", v.x, v.y], d.softConnector ? ["C", v.x + (v.alignment === "left" ? -5 : 5), v.y, 2 * P.x - u.x, 2 * P.y - u.y, P.x, P.y] : ["L", P.x, P.y], ["L", u.x, u.y]];
      }, straight: function(v, u) {
        return u = u.touchingSliceAt, [["M", v.x, v.y], ["L", u.x, u.y]];
      }, crookedLine: function(v, u, d) {
        u = u.touchingSliceAt;
        var P = this.series, O = P.center[0], B = P.chart.plotWidth, C = P.chart.plotLeft;
        P = v.alignment;
        var b = this.shapeArgs.r;
        return d = M(d.crookDistance, 1), B = P === "left" ? O + b + (B + C - O - b) * (1 - d) : C + (O - b) * d, d = ["L", B, v.y], O = !0, (P === "left" ? B > v.x || B < u.x : B < v.x || B > u.x) && (O = !1), v = [["M", v.x, v.y]], O && v.push(d), v.push(["L", u.x, u.y]), v;
      } } }), R;
    }), E(a, "Series/Pie/PieSeries.js", [a["Series/CenteredUtilities.js"], a["Series/Column/ColumnSeries.js"], a["Core/Globals.js"], a["Core/Legend/LegendSymbol.js"], a["Series/Pie/PiePoint.js"], a["Core/Series/Series.js"], a["Core/Series/SeriesRegistry.js"], a["Core/Renderer/SVG/Symbols.js"], a["Core/Utilities.js"]], function(y, R, I, Z, H, $, U, W, N) {
      var M = this && this.__extends || function() {
        var b = function(w, x) {
          return b = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(h, c) {
            h.__proto__ = c;
          } || function(h, c) {
            for (var p in c)
              c.hasOwnProperty(p) && (h[p] = c[p]);
          }, b(w, x);
        };
        return function(w, x) {
          function h() {
            this.constructor = w;
          }
          b(w, x), w.prototype = x === null ? Object.create(x) : (h.prototype = x.prototype, new h());
        };
      }(), v = y.getStartAndEndRadians;
      I = I.noop;
      var u = N.clamp, d = N.extend, P = N.fireEvent, O = N.merge, B = N.pick, C = N.relativeLength;
      return N = function(b) {
        function w() {
          var x = b !== null && b.apply(this, arguments) || this;
          return x.center = void 0, x.data = void 0, x.maxLabelDistance = void 0, x.options = void 0, x.points = void 0, x;
        }
        return M(w, b), w.prototype.animate = function(x) {
          var h = this, c = h.points, p = h.startAngleRad;
          x || c.forEach(function(i) {
            var l = i.graphic, s = i.shapeArgs;
            l && s && (l.attr({ r: B(i.startR, h.center && h.center[3] / 2), start: p, end: p }), l.animate({ r: s.r, start: s.start, end: s.end }, h.options.animation));
          });
        }, w.prototype.drawEmpty = function() {
          var x = this.startAngleRad, h = this.endAngleRad, c = this.options;
          if (this.total === 0 && this.center) {
            var p = this.center[0], i = this.center[1];
            this.graph || (this.graph = this.chart.renderer.arc(p, i, this.center[1] / 2, 0, x, h).addClass("highcharts-empty-series").add(this.group)), this.graph.attr({ d: W.arc(p, i, this.center[2] / 2, 0, { start: x, end: h, innerR: this.center[3] / 2 }) }), this.chart.styledMode || this.graph.attr({ "stroke-width": c.borderWidth, fill: c.fillColor || "none", stroke: c.color || "#cccccc" });
          } else
            this.graph && (this.graph = this.graph.destroy());
        }, w.prototype.drawPoints = function() {
          var x = this.chart.renderer;
          this.points.forEach(function(h) {
            h.graphic && h.hasNewShapeType() && (h.graphic = h.graphic.destroy()), h.graphic || (h.graphic = x[h.shapeType](h.shapeArgs).add(h.series.group), h.delayedRendering = !0);
          });
        }, w.prototype.generatePoints = function() {
          b.prototype.generatePoints.call(this), this.updateTotals();
        }, w.prototype.getX = function(x, h, c) {
          var p = this.center, i = this.radii ? this.radii[c.index] || 0 : p[2] / 2;
          return x = Math.asin(u((x - p[1]) / (i + c.labelDistance), -1, 1)), p[0] + (h ? -1 : 1) * Math.cos(x) * (i + c.labelDistance) + (0 < c.labelDistance ? (h ? -1 : 1) * this.options.dataLabels.padding : 0);
        }, w.prototype.hasData = function() {
          return !!this.processedXData.length;
        }, w.prototype.redrawPoints = function() {
          var x = this, h = x.chart, c = h.renderer, p = x.options.shadow, i, l, s, t;
          this.drawEmpty(), !p || x.shadowGroup || h.styledMode || (x.shadowGroup = c.g("shadow").attr({ zIndex: -1 }).add(x.group)), x.points.forEach(function(n) {
            var o = {};
            if (l = n.graphic, !n.isNull && l) {
              var A = void 0;
              t = n.shapeArgs, i = n.getTranslate(), h.styledMode || (A = n.shadowGroup, p && !A && (A = n.shadowGroup = c.g("shadow").add(x.shadowGroup)), A && A.attr(i), s = x.pointAttribs(n, n.selected && "select")), n.delayedRendering ? (l.setRadialReference(x.center).attr(t).attr(i), h.styledMode || l.attr(s).attr({ "stroke-linejoin": "round" }).shadow(p, A), n.delayedRendering = !1) : (l.setRadialReference(x.center), h.styledMode || O(!0, o, s), O(!0, o, t, i), l.animate(o)), l.attr({ visibility: n.visible ? "inherit" : "hidden" }), l.addClass(n.getClassName(), !0);
            } else
              l && (n.graphic = l.destroy());
          });
        }, w.prototype.sortByAngle = function(x, h) {
          x.sort(function(c, p) {
            return typeof c.angle < "u" && (p.angle - c.angle) * h;
          });
        }, w.prototype.translate = function(x) {
          this.generatePoints();
          var h = this.options, c = h.slicedOffset, p = c + (h.borderWidth || 0), i = v(h.startAngle, h.endAngle), l = this.startAngleRad = i.start;
          i = (this.endAngleRad = i.end) - l;
          var s = this.points, t = h.dataLabels.distance;
          h = h.ignoreHiddenPoint;
          var n = s.length, o, A = 0;
          for (x || (this.center = x = this.getCenter()), o = 0; o < n; o++) {
            var _ = s[o], D = l + A * i;
            !_.isValid() || h && !_.visible || (A += _.percentage / 100);
            var j = l + A * i, T = { x: x[0], y: x[1], r: x[2] / 2, innerR: x[3] / 2, start: Math.round(1e3 * D) / 1e3, end: Math.round(1e3 * j) / 1e3 };
            _.shapeType = "arc", _.shapeArgs = T, _.labelDistance = B(_.options.dataLabels && _.options.dataLabels.distance, t), _.labelDistance = C(_.labelDistance, T.r), this.maxLabelDistance = Math.max(this.maxLabelDistance || 0, _.labelDistance), j = (j + D) / 2, j > 1.5 * Math.PI ? j -= 2 * Math.PI : j < -Math.PI / 2 && (j += 2 * Math.PI), _.slicedTranslation = { translateX: Math.round(Math.cos(j) * c), translateY: Math.round(Math.sin(j) * c) }, T = Math.cos(j) * x[2] / 2;
            var X = Math.sin(j) * x[2] / 2;
            _.tooltipPos = [x[0] + 0.7 * T, x[1] + 0.7 * X], _.half = j < -Math.PI / 2 || j > Math.PI / 2 ? 1 : 0, _.angle = j, D = Math.min(p, _.labelDistance / 5), _.labelPosition = { natural: { x: x[0] + T + Math.cos(j) * _.labelDistance, y: x[1] + X + Math.sin(j) * _.labelDistance }, final: {}, alignment: 0 > _.labelDistance ? "center" : _.half ? "right" : "left", connectorPosition: { breakAt: { x: x[0] + T + Math.cos(j) * D, y: x[1] + X + Math.sin(j) * D }, touchingSliceAt: { x: x[0] + T, y: x[1] + X } } };
          }
          P(this, "afterTranslate");
        }, w.prototype.updateTotals = function() {
          var x = this.points, h = x.length, c = this.options.ignoreHiddenPoint, p, i = 0;
          for (p = 0; p < h; p++) {
            var l = x[p];
            !l.isValid() || c && !l.visible || (i += l.y);
          }
          for (this.total = i, p = 0; p < h; p++)
            l = x[p], l.percentage = 0 < i && (l.visible || !c) ? l.y / i * 100 : 0, l.total = i;
        }, w.defaultOptions = O($.defaultOptions, {
          center: [null, null],
          clip: !1,
          colorByPoint: !0,
          dataLabels: { allowOverlap: !0, connectorPadding: 5, connectorShape: "fixedOffset", crookDistance: "70%", distance: 30, enabled: !0, formatter: function() {
            return this.point.isNull ? void 0 : this.point.name;
          }, softConnector: !0, x: 0 },
          fillColor: void 0,
          ignoreHiddenPoint: !0,
          inactiveOtherPoints: !0,
          legendType: "point",
          marker: null,
          size: null,
          showInLegend: !1,
          slicedOffset: 10,
          stickyTracking: !1,
          tooltip: { followPointer: !0 },
          borderColor: "#ffffff",
          borderWidth: 1,
          lineWidth: void 0,
          states: { hover: { brightness: 0.1 } }
        }), w;
      }($), d(N.prototype, { axisTypes: [], directTouch: !0, drawGraph: void 0, drawLegendSymbol: Z.drawRectangle, drawTracker: R.prototype.drawTracker, getCenter: y.getCenter, getSymbol: I, isCartesian: !1, noSharedTooltip: !0, pointAttribs: R.prototype.pointAttribs, pointClass: H, requireSorting: !1, searchPoint: I, trackerGroups: ["group", "dataLabelsGroup"] }), U.registerSeriesType("pie", N), N;
    }), E(a, "Series/Pie/PieDataLabel.js", [
      a["Core/Series/DataLabel.js"],
      a["Core/Globals.js"],
      a["Core/Renderer/RendererUtilities.js"],
      a["Core/Series/SeriesRegistry.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I, Z, H) {
      var $ = R.noop, U = I.distribute, W = Z.series, N = H.arrayMax, M = H.clamp, v = H.defined, u = H.merge, d = H.pick, P = H.relativeLength, O;
      return function(B) {
        function C() {
          var c = this, p = c.data, i = c.chart, l = c.options.dataLabels || {}, s = l.connectorPadding, t = i.plotWidth, n = i.plotHeight, o = i.plotLeft, A = Math.round(i.chartWidth / 3), _ = c.center, D = _[2] / 2, j = _[1], T = [[], []], X = [0, 0, 0, 0], f = c.dataLabelPositioners, m, L, Y, F, Q, k, G, z, V, q, it, et;
          c.visible && (l.enabled || c._hasPointLabels) && (p.forEach(function(nt) {
            nt.dataLabel && nt.visible && nt.dataLabel.shortened && (nt.dataLabel.attr({ width: "auto" }).css({ width: "auto", textOverflow: "clip" }), nt.dataLabel.shortened = !1);
          }), W.prototype.drawDataLabels.apply(c), p.forEach(function(nt) {
            nt.dataLabel && (nt.visible ? (T[nt.half].push(nt), nt.dataLabel._pos = null, !v(l.style.width) && !v(nt.options.dataLabels && nt.options.dataLabels.style && nt.options.dataLabels.style.width) && nt.dataLabel.getBBox().width > A && (nt.dataLabel.css({ width: Math.round(0.7 * A) + "px" }), nt.dataLabel.shortened = !0)) : (nt.dataLabel = nt.dataLabel.destroy(), nt.dataLabels && nt.dataLabels.length === 1 && delete nt.dataLabels));
          }), T.forEach(function(nt, rt) {
            var ct = nt.length, gt = [], dt;
            if (ct) {
              if (c.sortByAngle(nt, rt - 0.5), 0 < c.maxLabelDistance) {
                var lt = Math.max(0, j - D - c.maxLabelDistance), at = Math.min(j + D + c.maxLabelDistance, i.plotHeight);
                nt.forEach(function(J) {
                  0 < J.labelDistance && J.dataLabel && (J.top = Math.max(0, j - D - J.labelDistance), J.bottom = Math.min(j + D + J.labelDistance, i.plotHeight), dt = J.dataLabel.getBBox().height || 21, J.distributeBox = { target: J.labelPosition.natural.y - J.top + dt / 2, size: dt, rank: J.y }, gt.push(J.distributeBox));
                }), lt = at + dt - lt, U(gt, lt, lt / 5);
              }
              for (it = 0; it < ct; it++) {
                if (m = nt[it], k = m.labelPosition, F = m.dataLabel, q = m.visible === !1 ? "hidden" : "inherit", V = lt = k.natural.y, gt && v(m.distributeBox) && (typeof m.distributeBox.pos > "u" ? q = "hidden" : (G = m.distributeBox.size, V = f.radialDistributionY(m))), delete m.positionIndex, l.justify)
                  z = f.justify(m, D, _);
                else
                  switch (l.alignTo) {
                    case "connectors":
                      z = f.alignToConnectors(nt, rt, t, o);
                      break;
                    case "plotEdges":
                      z = f.alignToPlotEdges(F, rt, t, o);
                      break;
                    default:
                      z = f.radialDistributionX(c, m, V, lt);
                  }
                F._attr = { visibility: q, align: k.alignment }, et = m.options.dataLabels || {}, F._pos = { x: z + d(et.x, l.x) + ({ left: s, right: -s }[k.alignment] || 0), y: V + d(et.y, l.y) - 10 }, k.final.x = z, k.final.y = V, d(l.crop, !0) && (Q = F.getBBox().width, lt = null, z - Q < s && rt === 1 ? (lt = Math.round(Q - z + s), X[3] = Math.max(lt, X[3])) : z + Q > t - s && rt === 0 && (lt = Math.round(z + Q - t + s), X[1] = Math.max(lt, X[1])), 0 > V - G / 2 ? X[0] = Math.max(Math.round(-V + G / 2), X[0]) : V + G / 2 > n && (X[2] = Math.max(Math.round(V + G / 2 - n), X[2])), F.sideOverflow = lt);
              }
            }
          }), N(X) === 0 || this.verifyDataLabelOverflow(X)) && (this.placeDataLabels(), this.points.forEach(function(nt) {
            if (et = u(l, nt.options.dataLabels), L = d(et.connectorWidth, 1)) {
              var rt;
              Y = nt.connector, (F = nt.dataLabel) && F._pos && nt.visible && 0 < nt.labelDistance ? (q = F._attr.visibility, (rt = !Y) && (nt.connector = Y = i.renderer.path().addClass("highcharts-data-label-connector  highcharts-color-" + nt.colorIndex + (nt.className ? " " + nt.className : "")).add(c.dataLabelsGroup), i.styledMode || Y.attr({ "stroke-width": L, stroke: et.connectorColor || nt.color || "#666666" })), Y[rt ? "attr" : "animate"]({ d: nt.getConnectorPath() }), Y.attr("visibility", q)) : Y && (nt.connector = Y.destroy());
            }
          }));
        }
        function b() {
          this.points.forEach(function(c) {
            var p = c.dataLabel, i;
            p && c.visible && ((i = p._pos) ? (p.sideOverflow && (p._attr.width = Math.max(p.getBBox().width - p.sideOverflow, 0), p.css({ width: p._attr.width + "px", textOverflow: (this.options.dataLabels.style || {}).textOverflow || "ellipsis" }), p.shortened = !0), p.attr(p._attr), p[p.moved ? "animate" : "attr"](i), p.moved = !0) : p && p.attr({ y: -9999 })), delete c.distributeBox;
          }, this);
        }
        function w(c) {
          var p = this.center, i = this.options, l = i.center, s = i.minSize || 80, t = i.size !== null;
          if (!t) {
            if (l[0] !== null)
              var n = Math.max(p[2] - Math.max(c[1], c[3]), s);
            else
              n = Math.max(p[2] - c[1] - c[3], s), p[0] += (c[3] - c[1]) / 2;
            l[1] !== null ? n = M(n, s, p[2] - Math.max(c[0], c[2])) : (n = M(n, s, p[2] - c[0] - c[2]), p[1] += (c[0] - c[2]) / 2), n < p[2] ? (p[2] = n, p[3] = Math.min(P(i.innerSize || 0, n), n), this.translate(p), this.drawDataLabels && this.drawDataLabels()) : t = !0;
          }
          return t;
        }
        var x = [], h = { radialDistributionY: function(c) {
          return c.top + c.distributeBox.pos;
        }, radialDistributionX: function(c, p, i, l) {
          return c.getX(i < p.top + 2 || i > p.bottom - 2 ? l : i, p.half, p);
        }, justify: function(c, p, i) {
          return i[0] + (c.half ? -1 : 1) * (p + c.labelDistance);
        }, alignToPlotEdges: function(c, p, i, l) {
          return c = c.getBBox().width, p ? c + l : i - c - l;
        }, alignToConnectors: function(c, p, i, l) {
          var s = 0, t;
          return c.forEach(function(n) {
            t = n.dataLabel.getBBox().width, t > s && (s = t);
          }), p ? s + l : i - s - l;
        } };
        B.compose = function(c) {
          y.compose(W), x.indexOf(c) === -1 && (x.push(c), c = c.prototype, c.dataLabelPositioners = h, c.alignDataLabel = $, c.drawDataLabels = C, c.placeDataLabels = b, c.verifyDataLabelOverflow = w);
        };
      }(O || (O = {})), O;
    }), E(a, "Extensions/OverlappingDataLabels.js", [a["Core/Chart/Chart.js"], a["Core/Utilities.js"]], function(y, R) {
      function I(M, v) {
        var u = !1;
        if (M) {
          var d = M.newOpacity;
          M.oldOpacity !== d && (M.alignAttr && M.placed ? (M[d ? "removeClass" : "addClass"]("highcharts-data-label-hidden"), u = !0, M.alignAttr.opacity = d, M[M.isOld ? "animate" : "attr"](M.alignAttr, null, function() {
            v.styledMode || M.css({ pointerEvents: d ? "auto" : "none" });
          }), H(v, "afterHideOverlappingLabel")) : M.attr({ opacity: d })), M.isOld = !0;
        }
        return u;
      }
      var Z = R.addEvent, H = R.fireEvent, $ = R.isArray, U = R.isNumber, W = R.objectEach, N = R.pick;
      Z(y, "render", function() {
        var M = this, v = [];
        (this.labelCollectors || []).forEach(function(u) {
          v = v.concat(u());
        }), (this.yAxis || []).forEach(function(u) {
          u.stacking && u.options.stackLabels && !u.options.stackLabels.allowOverlap && W(u.stacking.stacks, function(d) {
            W(d, function(P) {
              P.label && P.label.visibility !== "hidden" && v.push(P.label);
            });
          });
        }), (this.series || []).forEach(function(u) {
          var d = u.options.dataLabels;
          u.visible && (d.enabled !== !1 || u._hasPointLabels) && (d = function(P) {
            return P.forEach(function(O) {
              O.visible && ($(O.dataLabels) ? O.dataLabels : O.dataLabel ? [O.dataLabel] : []).forEach(function(B) {
                var C = B.options;
                B.labelrank = N(C.labelrank, O.labelrank, O.shapeArgs && O.shapeArgs.height), C.allowOverlap ? (B.oldOpacity = B.opacity, B.newOpacity = 1, I(B, M)) : v.push(B);
              });
            });
          }, d(u.nodes || []), d(u.points));
        }), this.hideOverlappingLabels(v);
      }), y.prototype.hideOverlappingLabels = function(M) {
        var v = this, u = M.length, d = v.renderer, P, O, B, C = !1, b = function(h) {
          var c, p = h.box ? 0 : h.padding || 0, i = c = 0, l;
          if (h && (!h.alignAttr || h.placed)) {
            var s = h.alignAttr || { x: h.attr("x"), y: h.attr("y") }, t = h.parentGroup;
            h.width || (c = h.getBBox(), h.width = c.width, h.height = c.height, c = d.fontMetrics(null, h.element).h);
            var n = h.width - 2 * p;
            return (l = { left: "0", center: "0.5", right: "1" }[h.alignValue]) ? i = +l * n : U(h.x) && Math.round(h.x) !== h.translateX && (i = h.x - h.translateX), { x: s.x + (t.translateX || 0) + p - (i || 0), y: s.y + (t.translateY || 0) + p - c, width: h.width - 2 * p, height: h.height - 2 * p };
          }
        };
        for (O = 0; O < u; O++)
          (P = M[O]) && (P.oldOpacity = P.opacity, P.newOpacity = 1, P.absoluteBox = b(P));
        for (M.sort(function(h, c) {
          return (c.labelrank || 0) - (h.labelrank || 0);
        }), O = 0; O < u; O++) {
          var w = (b = M[O]) && b.absoluteBox;
          for (P = O + 1; P < u; ++P) {
            var x = (B = M[P]) && B.absoluteBox;
            !w || !x || b === B || b.newOpacity === 0 || B.newOpacity === 0 || x.x >= w.x + w.width || x.x + x.width <= w.x || x.y >= w.y + w.height || x.y + x.height <= w.y || ((b.labelrank < B.labelrank ? b : B).newOpacity = 0);
          }
        }
        M.forEach(function(h) {
          I(h, v) && (C = !0);
        }), C && H(v, "afterHideAllOverlappingLabels");
      };
    }), E(
      a,
      "Core/Responsive.js",
      [a["Core/Utilities.js"]],
      function(y) {
        var R = y.extend, I = y.find, Z = y.isArray, H = y.isObject, $ = y.merge, U = y.objectEach, W = y.pick, N = y.splat, M = y.uniqueKey, v;
        return function(u) {
          var d = [];
          u.compose = function(O) {
            return d.indexOf(O) === -1 && (d.push(O), R(O.prototype, P.prototype)), O;
          };
          var P = function() {
            function O() {
            }
            return O.prototype.currentOptions = function(B) {
              function C(x, h, c, p) {
                var i;
                U(x, function(l, s) {
                  if (!p && -1 < b.collectionsWithUpdate.indexOf(s) && h[s])
                    for (l = N(l), c[s] = [], i = 0; i < Math.max(l.length, h[s].length); i++)
                      h[s][i] && (l[i] === void 0 ? c[s][i] = h[s][i] : (c[s][i] = {}, C(l[i], h[s][i], c[s][i], p + 1)));
                  else
                    H(l) ? (c[s] = Z(l) ? [] : {}, C(l, h[s] || {}, c[s], p + 1)) : c[s] = typeof h[s] > "u" ? null : h[s];
                });
              }
              var b = this, w = {};
              return C(B, this.options, w, 0), w;
            }, O.prototype.matchResponsiveRule = function(B, C) {
              var b = B.condition;
              (b.callback || function() {
                return this.chartWidth <= W(b.maxWidth, Number.MAX_VALUE) && this.chartHeight <= W(b.maxHeight, Number.MAX_VALUE) && this.chartWidth >= W(b.minWidth, 0) && this.chartHeight >= W(b.minHeight, 0);
              }).call(this) && C.push(B._id);
            }, O.prototype.setResponsive = function(B, C) {
              var b = this, w = this.options.responsive, x = this.currentResponsive, h = [];
              !C && w && w.rules && w.rules.forEach(function(c) {
                typeof c._id > "u" && (c._id = M()), b.matchResponsiveRule(c, h);
              }, this), C = $.apply(void 0, h.map(function(c) {
                return I((w || {}).rules || [], function(p) {
                  return p._id === c;
                });
              }).map(function(c) {
                return c && c.chartOptions;
              })), C.isResponsiveOptions = !0, h = h.toString() || void 0, h !== (x && x.ruleIds) && (x && this.update(x.undoOptions, B, !0), h ? (x = this.currentOptions(C), x.isResponsiveOptions = !0, this.currentResponsive = { ruleIds: h, mergedOptions: C, undoOptions: x }, this.update(C, B, !0)) : this.currentResponsive = void 0);
            }, O;
          }();
        }(v || (v = {})), v;
      }
    ), E(a, "masters/highcharts.src.js", [
      a["Core/Globals.js"],
      a["Core/Utilities.js"],
      a["Core/DefaultOptions.js"],
      a["Core/Animation/Fx.js"],
      a["Core/Animation/AnimationUtilities.js"],
      a["Core/Renderer/HTML/AST.js"],
      a["Core/FormatUtilities.js"],
      a["Core/Renderer/RendererUtilities.js"],
      a["Core/Renderer/SVG/SVGElement.js"],
      a["Core/Renderer/SVG/SVGRenderer.js"],
      a["Core/Renderer/HTML/HTMLElement.js"],
      a["Core/Renderer/HTML/HTMLRenderer.js"],
      a["Core/Axis/Axis.js"],
      a["Core/Axis/DateTimeAxis.js"],
      a["Core/Axis/LogarithmicAxis.js"],
      a["Core/Axis/PlotLineOrBand/PlotLineOrBand.js"],
      a["Core/Axis/Tick.js"],
      a["Core/Tooltip.js"],
      a["Core/Series/Point.js"],
      a["Core/Pointer.js"],
      a["Core/MSPointer.js"],
      a["Core/Legend/Legend.js"],
      a["Core/Chart/Chart.js"],
      a["Core/Series/Series.js"],
      a["Core/Series/SeriesRegistry.js"],
      a["Series/Column/ColumnSeries.js"],
      a["Series/Column/ColumnDataLabel.js"],
      a["Series/Pie/PieSeries.js"],
      a["Series/Pie/PieDataLabel.js"],
      a["Core/Series/DataLabel.js"],
      a["Core/Responsive.js"],
      a["Core/Color/Color.js"],
      a["Core/Time.js"]
    ], function(y, R, I, Z, H, $, U, W, N, M, v, u, d, P, O, B, C, b, w, x, h, c, p, i, l, s, t, n, o, A, _, D, j) {
      return y.animate = H.animate, y.animObject = H.animObject, y.getDeferredAnimation = H.getDeferredAnimation, y.setAnimation = H.setAnimation, y.stop = H.stop, y.timers = Z.timers, y.AST = $, y.Axis = d, y.Chart = p, y.chart = p.chart, y.Fx = Z, y.Legend = c, y.PlotLineOrBand = B, y.Point = w, y.Pointer = h.isRequired() ? h : x, y.Series = i, y.SVGElement = N, y.SVGRenderer = M, y.Tick = C, y.Time = j, y.Tooltip = b, y.Color = D, y.color = D.parse, u.compose(M), v.compose(N), y.defaultOptions = I.defaultOptions, y.getOptions = I.getOptions, y.time = I.defaultTime, y.setOptions = I.setOptions, y.dateFormat = U.dateFormat, y.format = U.format, y.numberFormat = U.numberFormat, y.addEvent = R.addEvent, y.arrayMax = R.arrayMax, y.arrayMin = R.arrayMin, y.attr = R.attr, y.clearTimeout = R.clearTimeout, y.correctFloat = R.correctFloat, y.createElement = R.createElement, y.css = R.css, y.defined = R.defined, y.destroyObjectProperties = R.destroyObjectProperties, y.discardElement = R.discardElement, y.distribute = W.distribute, y.erase = R.erase, y.error = R.error, y.extend = R.extend, y.extendClass = R.extendClass, y.find = R.find, y.fireEvent = R.fireEvent, y.getMagnitude = R.getMagnitude, y.getStyle = R.getStyle, y.inArray = R.inArray, y.isArray = R.isArray, y.isClass = R.isClass, y.isDOMElement = R.isDOMElement, y.isFunction = R.isFunction, y.isNumber = R.isNumber, y.isObject = R.isObject, y.isString = R.isString, y.keys = R.keys, y.merge = R.merge, y.normalizeTickInterval = R.normalizeTickInterval, y.objectEach = R.objectEach, y.offset = R.offset, y.pad = R.pad, y.pick = R.pick, y.pInt = R.pInt, y.relativeLength = R.relativeLength, y.removeEvent = R.removeEvent, y.seriesType = l.seriesType, y.splat = R.splat, y.stableSort = R.stableSort, y.syncTimeout = R.syncTimeout, y.timeUnits = R.timeUnits, y.uniqueKey = R.uniqueKey, y.useSerialIds = R.useSerialIds, y.wrap = R.wrap, t.compose(s), A.compose(i), P.compose(d), O.compose(d), o.compose(n), B.compose(d), _.compose(p), y;
    }), E(a, "Core/Axis/OrdinalAxis.js", [
      a["Core/Axis/Axis.js"],
      a["Core/Globals.js"],
      a["Core/Series/Series.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I, Z) {
      var H = Z.addEvent, $ = Z.correctFloat, U = Z.css, W = Z.defined, N = Z.error, M = Z.pick, v = Z.timeUnits, u = [], d;
      return function(P) {
        function O(t, n, o, A, _, D, j) {
          _ === void 0 && (_ = []), D === void 0 && (D = 0);
          var T = {}, X = this.options.tickPixelInterval, f = this.chart.time, m = [], L, Y, F = 0, Q = [], k = -Number.MAX_VALUE;
          if (!this.options.ordinal && !this.options.breaks || !_ || 3 > _.length || typeof n > "u")
            return f.getTimeTicks.apply(f, arguments);
          var G = _.length;
          for (L = 0; L < G; L++) {
            var z = L && _[L - 1] > o;
            if (_[L] < n && (F = L), L === G - 1 || _[L + 1] - _[L] > 5 * D || z) {
              if (_[L] > k) {
                for (Y = f.getTimeTicks(t, _[F], _[L], A); Y.length && Y[0] <= k; )
                  Y.shift();
                Y.length && (k = Y[Y.length - 1]), m.push(Q.length), Q = Q.concat(Y);
              }
              F = L + 1;
            }
            if (z)
              break;
          }
          if (Y) {
            if (Y = Y.info, j && Y.unitRange <= v.hour) {
              for (L = Q.length - 1, F = 1; F < L; F++)
                if (f.dateFormat("%d", Q[F]) !== f.dateFormat("%d", Q[F - 1])) {
                  T[Q[F]] = "day";
                  var V = !0;
                }
              V && (T[Q[0]] = "day"), Y.higherRanks = T;
            }
            Y.segmentStarts = m, Q.info = Y;
          } else
            N(12, !1, this.chart);
          if (j && W(X)) {
            for (Y = Q.length, f = [], F = [], L = void 0, V = Y; V--; )
              m = this.translate(Q[V]), L && (F[V] = L - m), f[V] = L = m;
            for (F.sort(), F = F[Math.floor(F.length / 2)], F < 0.6 * X && (F = null), V = Q[Y - 1] > o ? Y - 1 : Y, L = void 0; V--; )
              m = f[V], Y = Math.abs(L - m), L && Y < 0.8 * X && (F === null || Y < 0.8 * F) ? (T[Q[V]] && !T[Q[V + 1]] ? (Y = V + 1, L = m) : Y = V, Q.splice(Y, 1)) : L = m;
          }
          return Q;
        }
        function B(t) {
          var n = this.ordinal.positions;
          if (!n)
            return t;
          var o = n.length - 1;
          if (0 > t)
            t = n[0];
          else if (t > o)
            t = n[o];
          else {
            o = Math.floor(t);
            var A = t - o;
          }
          return typeof A < "u" && typeof n[o] < "u" ? n[o] + (A ? A * (n[o + 1] - n[o]) : 0) : t;
        }
        function C(t) {
          var n = this.ordinal, o = n.positions;
          if (!o)
            return t;
          var A = (t - (this.old ? this.old.min : this.min)) * (this.old ? this.old.transA : this.transA) + this.minPixelPadding;
          if (0 < A && A < this.left + this.len || (n.extendedOrdinalPositions || (n.extendedOrdinalPositions = n.getExtendedPositions()), o = n.extendedOrdinalPositions), o && o.length) {
            if (t = n.getIndexOfPoint(A, o), n = $(t % 1), 0 <= t && t < o.length - 1)
              return o[Math.floor(t)] + n * (o[Math.ceil(t)] - o[Math.floor(t)]);
            n = o.length, A = o[0], o = o[n - 1];
            var _ = (o - A) / (n - 1);
            return 0 > t ? A + _ * t : o + _ * (t - n);
          }
          return t;
        }
        function b(t, n) {
          var o = P.Additions.findIndexOf(t, n, !0);
          return t[o] === n ? o : o + (n - t[o]) / (t[o + 1] - t[o]);
        }
        function w() {
          this.ordinal || (this.ordinal = new P.Additions(this));
        }
        function x() {
          this.isXAxis && W(this.options.overscroll) && this.max === this.dataMax && (!this.chart.mouseIsDown || this.isInternal) && (!this.eventArgs || this.eventArgs && this.eventArgs.trigger !== "navigator") && (this.max += this.options.overscroll, !this.isInternal && W(this.userMin) && (this.min += this.options.overscroll));
        }
        function h() {
          this.horiz && !this.isDirty && (this.isDirty = this.isOrdinal && this.chart.navigator && !this.chart.navigator.adaptToUpdatedData);
        }
        function c() {
          this.ordinal && (this.ordinal.beforeSetTickPositions(), this.tickInterval = this.ordinal.postProcessTickInterval(this.tickInterval));
        }
        function p(t) {
          var n = this.xAxis[0], o = n.options.overscroll, A = t.originalEvent.chartX, _ = this.options.chart.panning, D = !1;
          if (_ && _.type !== "y" && n.options.ordinal && n.series.length) {
            var j = this.mouseDownX, T = n.getExtremes(), X = T.dataMax, f = T.min, m = T.max, L = this.hoverPoints, Y = n.closestPointRange || n.ordinal && n.ordinal.overscrollPointsRange;
            j = (j - A) / (n.translationSlope * (n.ordinal.slope || Y)), Y = { ordinal: { positions: n.ordinal.getExtendedPositions() } };
            var F = n.index2val, Q = n.val2lin, k = void 0, G = k = void 0, z = void 0;
            Y.ordinal.positions ? 1 < Math.abs(j) && (L && L.forEach(function(V) {
              V.setState();
            }), 0 > j ? (G = Y, z = n.ordinal.positions ? n : Y) : (G = n.ordinal.positions ? n : Y, z = Y), k = z.ordinal.positions, X > k[k.length - 1] && k.push(X), this.fixedRange = m - f, k = n.navigatorAxis.toFixedRange(void 0, void 0, F.apply(G, [Q.apply(G, [f, !0]) + j]), F.apply(z, [Q.apply(z, [m, !0]) + j])), k.min >= Math.min(
              T.dataMin,
              f
            ) && k.max <= Math.max(X, m) + o && n.setExtremes(k.min, k.max, !0, !1, { trigger: "pan" }), this.mouseDownX = A, U(this.container, { cursor: "move" })) : D = !0;
          } else
            D = !0;
          D || _ && /y/.test(_.type) ? o && (n.max = n.dataMax + o) : t.preventDefault();
        }
        function i() {
          var t = this.xAxis;
          t && t.options.ordinal && (delete t.ordinal.index, delete t.ordinal.extendedOrdinalPositions);
        }
        function l(t, n) {
          var o = this.ordinal, A = o.positions, _ = o.slope, D = o.extendedOrdinalPositions;
          if (!A)
            return t;
          var j = A.length;
          if (A[0] <= t && A[j - 1] >= t)
            t = b(A, t);
          else {
            if (D || (D = o.getExtendedPositions && o.getExtendedPositions(), o.extendedOrdinalPositions = D), !D || !D.length)
              return t;
            j = D.length, _ || (_ = (D[j - 1] - D[0]) / j), A = b(D, A[0]), t >= D[0] && t <= D[j - 1] ? t = b(D, t) - A : t < D[0] ? (t = D[0] - t, t = -A - t / _) : (t -= D[j - 1], t = t / _ + j - A);
          }
          return n ? t : _ * (t || 0) + o.offset;
        }
        P.compose = function(t, n, o) {
          if (u.indexOf(t) === -1) {
            u.push(t);
            var A = t.prototype;
            A.getTimeTicks = O, A.index2val = B, A.lin2val = C, A.val2lin = l, A.ordinal2lin = A.val2lin, H(t, "afterInit", w), H(t, "foundExtremes", x), H(t, "afterSetScale", h), H(t, "initialAxisTranslation", c);
          }
          return u.indexOf(o) === -1 && (u.push(o), H(o, "pan", p)), u.indexOf(n) === -1 && (u.push(n), H(n, "updatedData", i)), t;
        };
        var s = function() {
          function t(n) {
            this.index = {}, this.axis = n;
          }
          return t.prototype.beforeSetTickPositions = function() {
            var n = this.axis, o = n.ordinal, A = n.getExtremes(), _ = A.min, D = A.max, j = n.isXAxis && !!n.options.breaks;
            A = n.options.ordinal;
            var T = n.chart.options.chart.ignoreHiddenSeries, X, f, m = [], L = Number.MAX_VALUE, Y = !1;
            if (A || j) {
              n.series.forEach(function(k, G) {
                if (X = [], !(T && k.visible === !1 || k.takeOrdinalPosition === !1 && !j) && (m = m.concat(k.processedXData), F = m.length, m.sort(function(z, V) {
                  return z - V;
                }), L = Math.min(L, M(k.closestPointRange, L)), F)) {
                  for (G = 0; G < F - 1; )
                    m[G] !== m[G + 1] && X.push(m[G + 1]), G++;
                  X[0] !== m[0] && X.unshift(m[0]), m = X;
                }
              });
              var F = m.length;
              if (2 < F) {
                var Q = m[1] - m[0];
                for (f = F - 1; f-- && !Y; )
                  m[f + 1] - m[f] !== Q && (Y = !0);
                !n.options.keepOrdinalPadding && (m[0] - _ > Q || D - m[m.length - 1] > Q) && (Y = !0);
              } else
                n.options.overscroll && (F === 2 ? L = m[1] - m[0] : F === 1 ? (L = n.options.overscroll, m = [m[0], m[0] + L]) : L = o.overscrollPointsRange);
              Y || n.forceOrdinal ? (n.options.overscroll && (o.overscrollPointsRange = L, m = m.concat(o.getOverscrollPositions())), o.positions = m, Q = n.ordinal2lin(Math.max(_, m[0]), !0), f = Math.max(n.ordinal2lin(Math.min(D, m[m.length - 1]), !0), 1), o.slope = D = (D - _) / (f - Q), o.offset = _ - Q * D) : (o.overscrollPointsRange = M(n.closestPointRange, o.overscrollPointsRange), o.positions = n.ordinal.slope = o.offset = void 0);
            }
            n.isOrdinal = A && Y, o.groupIntervalFactor = null;
          }, t.findIndexOf = function(n, o, A) {
            for (var _ = 0, D = n.length - 1, j; _ < D; )
              j = Math.ceil((_ + D) / 2), n[j] <= o ? _ = j : D = j - 1;
            return n[_] === o || A ? _ : -1;
          }, t.prototype.getExtendedPositions = function() {
            var n = this, o = n.axis, A = o.constructor.prototype, _ = o.chart, D = o.series[0].currentDataGrouping, j = D ? D.count + D.unitName : "raw", T = o.options.overscroll, X = o.getExtremes(), f = void 0, m = n.index;
            if (m || (m = n.index = {}), !m[j]) {
              var L = {
                series: [],
                chart: _,
                forceOrdinal: !1,
                getExtremes: function() {
                  return { min: X.dataMin, max: X.dataMax + T };
                },
                getGroupPixelWidth: A.getGroupPixelWidth,
                getTimeTicks: A.getTimeTicks,
                options: { ordinal: !0 },
                ordinal: { getGroupIntervalFactor: this.getGroupIntervalFactor },
                ordinal2lin: A.ordinal2lin,
                getIndexOfPoint: A.getIndexOfPoint,
                val2lin: A.val2lin
              };
              L.ordinal.axis = L, o.series.forEach(function(Y) {
                f = { xAxis: L, xData: Y.xData.slice(), chart: _, destroyGroupedData: R.noop, getProcessedData: I.prototype.getProcessedData, applyGrouping: I.prototype.applyGrouping }, f.xData = f.xData.concat(n.getOverscrollPositions()), f.options = { dataGrouping: D ? { firstAnchor: "firstPoint", anchor: "middle", lastAnchor: "lastPoint", enabled: !0, forced: !0, approximation: "open", units: [[D.unitName, [D.count]]] } : { enabled: !1 } }, L.series.push(f), Y.processData.apply(f);
              }), f.closestPointRange !== f.basePointRange && f.currentDataGrouping && (L.forceOrdinal = !0), o.ordinal.beforeSetTickPositions.apply({ axis: L }), m[j] = L.ordinal.positions;
            }
            return m[j];
          }, t.prototype.getGroupIntervalFactor = function(n, o, A) {
            A = A.processedXData;
            var _ = A.length, D = [], j = this.groupIntervalFactor;
            if (!j) {
              for (j = 0; j < _ - 1; j++)
                D[j] = A[j + 1] - A[j];
              D.sort(function(T, X) {
                return T - X;
              }), D = D[Math.floor(_ / 2)], n = Math.max(n, A[0]), o = Math.min(o, A[_ - 1]), this.groupIntervalFactor = j = _ * D / (o - n);
            }
            return j;
          }, t.prototype.getIndexOfPoint = function(n, o) {
            var A = this.axis, _ = this.positions ? this.positions[0] : 0, D = A.series[0].points && A.series[0].points[0] && A.series[0].points[0].plotX || A.minPixelPadding;
            return 1 < A.series.length && A.series.forEach(function(j) {
              j.points && W(j.points[0]) && W(j.points[0].plotX) && j.points[0].plotX < D && (D = j.points[0].plotX);
            }), n = (n - D) / (A.translationSlope * (this.slope || A.closestPointRange || this.overscrollPointsRange)), t.findIndexOf(o, _) + n;
          }, t.prototype.getOverscrollPositions = function() {
            var n = this.axis, o = n.options.overscroll, A = this.overscrollPointsRange, _ = [], D = n.dataMax;
            if (W(A))
              for (; D <= n.dataMax + o; )
                D += A, _.push(D);
            return _;
          }, t.prototype.postProcessTickInterval = function(n) {
            var o = this.axis, A = this.slope;
            return A ? o.options.breaks ? o.closestPointRange || n : n / (A / o.closestPointRange) : n;
          }, t;
        }();
        P.Additions = s;
      }(d || (d = {})), d;
    }), E(a, "Series/DataModifyComposition.js", [a["Core/Axis/Axis.js"], a["Core/Series/Point.js"], a["Core/Series/Series.js"], a["Core/Utilities.js"]], function(y, R, I, Z) {
      var H = R.prototype.tooltipFormatter, $ = Z.addEvent, U = Z.arrayMax, W = Z.arrayMin, N = Z.correctFloat, M = Z.defined, v = Z.isArray, u = Z.isNumber, d = Z.isString, P = Z.pick, O;
      return function(B) {
        function C(n, o, A) {
          this.isXAxis || (this.series.forEach(function(_) {
            n === "compare" && typeof o != "boolean" ? _.setCompare(o, !1) : n !== "cumulative" || d(o) || _.setCumulative(o, !1);
          }), P(A, !0) && this.chart.redraw());
        }
        function b(n) {
          var o = this, A = o.series.chart.numberFormatter, _ = function(D) {
            n = n.replace("{point." + D + "}", (0 < o[D] && D === "change" ? "+" : "") + A(o[D], P(o.series.tooltipOptions.changeDecimals, 2)));
          };
          return M(o.change) && _("change"), M(o.cumulativeSum) && _("cumulativeSum"), H.apply(this, [n]);
        }
        function w() {
          var n = this.options.compare;
          if (n === "percent" || n === "value" || this.options.cumulative) {
            var o = new t(this);
            n === "percent" || n === "value" ? o.initCompare(n) : o.initCumulative();
          }
          this.dataModify = o;
        }
        function x(n) {
          n = n.dataExtremes;
          var o = n.activeYData;
          if (this.dataModify && n) {
            var A = void 0;
            this.options.compare ? A = [this.dataModify.modifyValue(n.dataMin), this.dataModify.modifyValue(n.dataMax)] : this.options.cumulative && v(o) && 2 <= o.length && (A = t.getCumulativeExtremes(o)), A && (n.dataMin = W(A), n.dataMax = U(A));
          }
        }
        function h(n, o) {
          this.options.compare = this.userOptions.compare = n, this.update({}, P(o, !0)), !this.dataModify || n !== "value" && n !== "percent" ? this.points.forEach(function(A) {
            delete A.change;
          }) : this.dataModify.initCompare(n);
        }
        function c() {
          if (this.xAxis && this.processedYData && this.dataModify) {
            var n = this.processedXData, o = this.processedYData, A = o.length, _ = this.options.compareStart === !0 ? 0 : 1, D = -1, j;
            for (this.pointArrayMap && (D = this.pointArrayMap.indexOf(this.options.pointValKey || this.pointValKey || "y")), j = 0; j < A - _; j++) {
              var T = o[j] && -1 < D ? o[j][D] : o[j];
              if (u(T) && T !== 0 && n[j + _] >= (this.xAxis.min || 0)) {
                this.dataModify.compareValue = T;
                break;
              }
            }
          }
        }
        function p(n, o) {
          this.setModifier("compare", n, o);
        }
        function i(n, o) {
          n = P(n, !1), this.options.cumulative = this.userOptions.cumulative = n, this.update({}, P(o, !0)), this.dataModify ? this.dataModify.initCumulative() : this.points.forEach(function(A) {
            delete A.cumulativeSum;
          });
        }
        function l(n, o) {
          this.setModifier("cumulative", n, o);
        }
        var s = [];
        B.compose = function(n, o, A) {
          if (s.indexOf(n) === -1) {
            s.push(n);
            var _ = n.prototype;
            _.setCompare = h, _.setCumulative = i, $(n, "afterInit", w), $(n, "afterGetExtremes", x), $(n, "afterProcessData", c);
          }
          return s.indexOf(o) === -1 && (s.push(o), o = o.prototype, o.setCompare = p, o.setModifier = C, o.setCumulative = l), s.indexOf(A) === -1 && (s.push(A), A.prototype.tooltipFormatter = b), n;
        };
        var t = function() {
          function n(o) {
            this.series = o;
          }
          return n.prototype.modifyValue = function() {
            return 0;
          }, n.getCumulativeExtremes = function(o) {
            var A = 1 / 0, _ = -1 / 0;
            return o.reduce(function(D, j) {
              return j = D + j, A = Math.min(A, j, D), _ = Math.max(
                _,
                j,
                D
              ), j;
            }), [A, _];
          }, n.prototype.initCompare = function(o) {
            this.modifyValue = function(A, _) {
              A === null && (A = 0);
              var D = this.compareValue;
              return typeof A < "u" && typeof D < "u" ? (A = o === "value" ? A - D : A / D * 100 - (this.series.options.compareBase === 100 ? 0 : 100), typeof _ < "u" && (_ = this.series.points[_]) && (_.change = A), A) : 0;
            };
          }, n.prototype.initCumulative = function() {
            this.modifyValue = function(o, A) {
              if (o === null && (o = 0), o !== void 0 && A !== void 0) {
                var _ = 0 < A ? this.series.points[A - 1] : null;
                return _ && _.cumulativeSum && (o = N(_.cumulativeSum + o)), (A = this.series.points[A]) && (A.cumulativeSum = o), o;
              }
              return 0;
            };
          }, n;
        }();
        B.Additions = t;
      }(O || (O = {})), O;
    }), E(a, "Core/Axis/BrokenAxis.js", [a["Extensions/Stacking.js"], a["Core/Utilities.js"]], function(y, R) {
      var I = R.addEvent, Z = R.find, H = R.fireEvent, $ = R.isArray, U = R.isNumber, W = R.pick, N;
      return function(M) {
        function v() {
          typeof this.brokenAxis < "u" && this.brokenAxis.setBreaks(this.options.breaks, !1);
        }
        function u() {
          this.brokenAxis && this.brokenAxis.hasBreaks && (this.options.ordinal = !1);
        }
        function d() {
          var h = this.brokenAxis;
          if (h && h.hasBreaks) {
            for (var c = this.tickPositions, p = this.tickPositions.info, i = [], l = 0; l < c.length; l++)
              h.isInAnyBreak(c[l]) || i.push(c[l]);
            this.tickPositions = i, this.tickPositions.info = p;
          }
        }
        function P() {
          this.brokenAxis || (this.brokenAxis = new x(this));
        }
        function O() {
          var h = this.options.connectNulls, c = this.points, p = this.xAxis, i = this.yAxis;
          if (this.isDirty)
            for (var l = c.length; l--; ) {
              var s = c[l], t = !(s.y === null && h === !1) && (p && p.brokenAxis && p.brokenAxis.isInAnyBreak(s.x, !0) || i && i.brokenAxis && i.brokenAxis.isInAnyBreak(s.y, !0));
              s.visible = t ? !1 : s.options.visible !== !1;
            }
        }
        function B() {
          this.drawBreaks(this.xAxis, ["x"]), this.drawBreaks(this.yAxis, W(this.pointArrayMap, ["y"]));
        }
        function C(h, c) {
          var p = this, i = p.points, l, s, t, n;
          if (h && h.brokenAxis && h.brokenAxis.hasBreaks) {
            var o = h.brokenAxis;
            c.forEach(function(A) {
              l = o && o.breakArray || [], s = h.isXAxis ? h.min : W(p.options.threshold, h.min), i.forEach(function(_) {
                n = W(_["stack" + A.toUpperCase()], _[A]), l.forEach(function(D) {
                  U(s) && U(n) && (t = !1, s < D.from && n > D.to || s > D.from && n < D.from ? t = "pointBreak" : (s < D.from && n > D.from && n < D.to || s > D.from && n > D.to && n < D.from) && (t = "pointInBreak"), t && H(h, t, { point: _, brk: D }));
                });
              });
            });
          }
        }
        function b() {
          var h = this.currentDataGrouping, c = h && h.gapSize;
          h = this.points.slice();
          var p = this.yAxis, i = this.options.gapSize, l = h.length - 1, s;
          if (i && 0 < l)
            for (this.options.gapUnit !== "value" && (i *= this.basePointRange), c && c > i && c >= this.basePointRange && (i = c), s = void 0; l--; )
              s && s.visible !== !1 || (s = h[l + 1]), c = h[l], s.visible !== !1 && c.visible !== !1 && (s.x - c.x > i && (s = (c.x + s.x) / 2, h.splice(l + 1, 0, { isNull: !0, x: s }), p.stacking && this.options.stacking && (s = p.stacking.stacks[this.stackKey][s] = new y(p, p.options.stackLabels, !1, s, this.stack), s.total = 0)), s = c);
          return this.getGraphPath(h);
        }
        var w = [];
        M.compose = function(h, c) {
          if (w.indexOf(h) === -1 && (w.push(h), h.keepProps.push("brokenAxis"), I(h, "init", P), I(h, "afterInit", v), I(h, "afterSetTickPositions", d), I(h, "afterSetOptions", u)), w.indexOf(c) === -1) {
            w.push(c);
            var p = c.prototype;
            p.drawBreaks = C, p.gappedPath = b, I(c, "afterGeneratePoints", O), I(
              c,
              "afterRender",
              B
            );
          }
          return h;
        };
        var x = function() {
          function h(c) {
            this.hasBreaks = !1, this.axis = c;
          }
          return h.isInBreak = function(c, p) {
            var i = c.repeat || 1 / 0, l = c.from, s = c.to - c.from;
            return p = p >= l ? (p - l) % i : i - (l - p) % i, c.inclusive ? p <= s : p < s && p !== 0;
          }, h.lin2Val = function(c) {
            var p = this.brokenAxis;
            if (p = p && p.breakArray, !p || !U(c))
              return c;
            var i;
            for (i = 0; i < p.length; i++) {
              var l = p[i];
              if (l.from >= c)
                break;
              (l.to < c || h.isInBreak(l, c)) && (c += l.len);
            }
            return c;
          }, h.val2Lin = function(c) {
            var p = this.brokenAxis;
            if (p = p && p.breakArray, !p || !U(c))
              return c;
            var i = c, l;
            for (l = 0; l < p.length; l++) {
              var s = p[l];
              if (s.to <= c)
                i -= s.len;
              else {
                if (s.from >= c)
                  break;
                if (h.isInBreak(s, c)) {
                  i -= c - s.from;
                  break;
                }
              }
            }
            return i;
          }, h.prototype.findBreakAt = function(c, p) {
            return Z(p, function(i) {
              return i.from < c && c < i.to;
            });
          }, h.prototype.isInAnyBreak = function(c, p) {
            var i = this.axis, l = i.options.breaks || [], s = l.length, t;
            if (s && U(c)) {
              for (; s--; )
                if (h.isInBreak(l[s], c)) {
                  var n = !0;
                  t || (t = W(l[s].showPoints, !i.isXAxis));
                }
              var o = n && p ? n && !t : n;
            }
            return o;
          }, h.prototype.setBreaks = function(c, p) {
            var i = this, l = i.axis, s = $(c) && !!c.length;
            l.isDirty = i.hasBreaks !== s, i.hasBreaks = s, l.options.breaks = l.userOptions.breaks = c, l.forceRedraw = !0, l.series.forEach(function(t) {
              t.isDirty = !0;
            }), s || l.val2lin !== h.val2Lin || (delete l.val2lin, delete l.lin2val), s && (l.userOptions.ordinal = !1, l.lin2val = h.lin2Val, l.val2lin = h.val2Lin, l.setExtremes = function(t, n, o, A, _) {
              if (i.hasBreaks) {
                for (var D = this.options.breaks || [], j; j = i.findBreakAt(t, D); )
                  t = j.to;
                for (; j = i.findBreakAt(n, D); )
                  n = j.from;
                n < t && (n = t);
              }
              l.constructor.prototype.setExtremes.call(this, t, n, o, A, _);
            }, l.setAxisTranslation = function() {
              if (l.constructor.prototype.setAxisTranslation.call(this), i.unitLength = void 0, i.hasBreaks) {
                var t = l.options.breaks || [], n = [], o = [], A = W(l.pointRangePadding, 0), _ = 0, D, j = l.userMin || l.min, T = l.userMax || l.max, X;
                t.forEach(function(L) {
                  D = L.repeat || 1 / 0, U(j) && U(T) && (h.isInBreak(L, j) && (j += L.to % D - j % D), h.isInBreak(L, T) && (T -= T % D - L.from % D));
                }), t.forEach(function(L) {
                  if (m = L.from, D = L.repeat || 1 / 0, U(j) && U(T)) {
                    for (; m - D > j; )
                      m -= D;
                    for (; m < j; )
                      m += D;
                    for (X = m; X < T; X += D)
                      n.push({ value: X, move: "in" }), n.push({ value: X + L.to - L.from, move: "out", size: L.breakSize });
                  }
                }), n.sort(function(L, Y) {
                  return L.value === Y.value ? (L.move === "in" ? 0 : 1) - (Y.move === "in" ? 0 : 1) : L.value - Y.value;
                });
                var f = 0, m = j;
                n.forEach(function(L) {
                  f += L.move === "in" ? 1 : -1, f === 1 && L.move === "in" && (m = L.value), f === 0 && U(m) && (o.push({ from: m, to: L.value, len: L.value - m - (L.size || 0) }), _ += L.value - m - (L.size || 0));
                }), i.breakArray = o, U(j) && U(T) && U(l.min) && (i.unitLength = T - j - _ + A, H(l, "afterBreaks"), l.staticScale ? l.transA = l.staticScale : i.unitLength && (l.transA *= (T - l.min + A) / i.unitLength), A && (l.minPixelPadding = l.transA * (l.minPointOffset || 0)), l.min = j, l.max = T);
              }
            }), W(p, !0) && l.chart.redraw();
          }, h;
        }();
        M.Additions = x;
      }(N || (N = {})), N;
    }), E(a, "masters/modules/broken-axis.src.js", [a["Core/Globals.js"], a["Core/Axis/BrokenAxis.js"]], function(y, R) {
      R.compose(y.Axis, y.Series);
    }), E(a, "Extensions/DataGrouping.js", [
      a["Core/Axis/Axis.js"],
      a["Core/Axis/DateTimeAxis.js"],
      a["Core/FormatUtilities.js"],
      a["Core/Globals.js"],
      a["Core/Series/Point.js"],
      a["Core/Series/Series.js"],
      a["Core/Tooltip.js"],
      a["Core/DefaultOptions.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I, Z, H, $, U, W, N) {
      var M = I.format, v = $.prototype;
      I = N.addEvent;
      var u = N.arrayMax, d = N.arrayMin, P = N.correctFloat, O = N.defined, B = N.error, C = N.extend, b = N.isNumber, w = N.merge, x = N.pick, h = Z.approximations = {
        sum: function(t) {
          var n = t.length;
          if (!n && t.hasNulls)
            var o = null;
          else if (n)
            for (o = 0; n--; )
              o += t[n];
          return o;
        },
        average: function(t) {
          var n = t.length;
          return t = h.sum(t), b(t) && n && (t = P(t / n)), t;
        },
        averages: function() {
          var t = [];
          return [].forEach.call(arguments, function(n) {
            t.push(h.average(n));
          }), typeof t[0] > "u" ? void 0 : t;
        },
        open: function(t) {
          return t.length ? t[0] : t.hasNulls ? null : void 0;
        },
        high: function(t) {
          return t.length ? u(t) : t.hasNulls ? null : void 0;
        },
        low: function(t) {
          return t.length ? d(t) : t.hasNulls ? null : void 0;
        },
        close: function(t) {
          return t.length ? t[t.length - 1] : t.hasNulls ? null : void 0;
        },
        hlc: function(t, n, o) {
          if (t = h.high(t), n = h.low(n), o = h.close(o), b(t) || b(n) || b(o))
            return [t, n, o];
        },
        ohlc: function(t, n, o, A) {
          if (t = h.open(t), n = h.high(n), o = h.low(o), A = h.close(A), b(t) || b(n) || b(o) || b(A))
            return [t, n, o, A];
        },
        range: function(t, n) {
          if (t = h.low(t), n = h.high(n), b(t) || b(n))
            return [t, n];
          if (t === null && n === null)
            return null;
        }
      };
      N = function(t, n, o, A) {
        var _ = this, D = _.data, j = _.options && _.options.data, T = [], X = [], f = [], m = t.length, L = !!n, Y = [], F = _.pointArrayMap, Q = F && F.length, k = ["x"].concat(F || ["y"]), G = this.options.dataGrouping && this.options.dataGrouping.groupAll, z = 0, V = 0, q;
        A = typeof A == "function" ? A : h[A] ? h[A] : h[_.getDGApproximation && _.getDGApproximation() || "average"], Q ? F.forEach(function() {
          Y.push([]);
        }) : Y.push([]);
        var it = Q || 1;
        for (q = 0; q <= m && !(t[q] >= o[0]); q++)
          ;
        for (q; q <= m; q++) {
          for (; typeof o[z + 1] < "u" && t[q] >= o[z + 1] || q === m; ) {
            var et = o[z];
            _.dataGroupInfo = { start: G ? V : _.cropStart + V, length: Y[0].length };
            var nt = A.apply(_, Y);
            for (_.pointClass && !O(_.dataGroupInfo.options) && (_.dataGroupInfo.options = w(_.pointClass.prototype.optionsToObject.call({ series: _ }, _.options.data[_.cropStart + V])), k.forEach(function(ct) {
              delete _.dataGroupInfo.options[ct];
            })), typeof nt < "u" && (T.push(et), X.push(nt), f.push(_.dataGroupInfo)), V = q, et = 0; et < it; et++)
              Y[et].length = 0, Y[et].hasNulls = !1;
            if (z += 1, q === m)
              break;
          }
          if (q === m)
            break;
          if (F) {
            et = _.options.dataGrouping && _.options.dataGrouping.groupAll ? q : _.cropStart + q, nt = D && D[et] || _.pointClass.prototype.applyOptions.apply({ series: _ }, [j[et]]);
            var rt = void 0;
            for (et = 0; et < Q; et++)
              rt = nt[F[et]], b(rt) ? Y[et].push(rt) : rt === null && (Y[et].hasNulls = !0);
          } else
            et = L ? n[q] : null, b(et) ? Y[0].push(et) : et === null && (Y[0].hasNulls = !0);
        }
        return { groupedXData: T, groupedYData: X, groupMap: f };
      };
      var c = { approximations: h, groupData: N }, p = v.generatePoints, i = { groupPixelWidth: 2, dateTimeLabelFormats: { millisecond: [
        "%A, %b %e, %H:%M:%S.%L",
        "%A, %b %e, %H:%M:%S.%L",
        "-%H:%M:%S.%L"
      ], second: ["%A, %b %e, %H:%M:%S", "%A, %b %e, %H:%M:%S", "-%H:%M:%S"], minute: ["%A, %b %e, %H:%M", "%A, %b %e, %H:%M", "-%H:%M"], hour: ["%A, %b %e, %H:%M", "%A, %b %e, %H:%M", "-%H:%M"], day: ["%A, %b %e, %Y", "%A, %b %e", "-%A, %b %e, %Y"], week: ["Week from %A, %b %e, %Y", "%A, %b %e", "-%A, %b %e, %Y"], month: ["%B %Y", "%B", "-%B %Y"], year: ["%Y", "%Y", "-%Y"] } }, l = {
        line: {},
        spline: {},
        area: {},
        areaspline: {},
        arearange: {},
        column: { groupPixelWidth: 10 },
        columnrange: { groupPixelWidth: 10 },
        candlestick: { groupPixelWidth: 10 },
        ohlc: { groupPixelWidth: 5 },
        hlc: { groupPixelWidth: 5 },
        heikinashi: { groupPixelWidth: 10 }
      }, s = Z.defaultDataGroupingUnits = [["millisecond", [1, 2, 5, 10, 20, 25, 50, 100, 200, 500]], ["second", [1, 2, 5, 10, 15, 30]], ["minute", [1, 2, 5, 10, 15, 30]], ["hour", [1, 2, 3, 4, 6, 8, 12]], ["day", [1]], ["week", [1]], ["month", [1, 3, 6]], ["year", null]];
      return v.getDGApproximation = function() {
        return this.is("arearange") ? "range" : this.is("ohlc") ? "ohlc" : this.is("hlc") ? "hlc" : this.is("column") ? "sum" : "average";
      }, v.groupData = N, v.applyGrouping = function(t) {
        var n = this.chart, o = this.options.dataGrouping, A = this.allowDG !== !1 && o && x(o.enabled, n.options.isStock), _ = this.visible || !n.options.chart.ignoreHiddenSeries, D, j = this.currentDataGrouping, T = !1;
        if (A && !this.requireSorting && (this.requireSorting = T = !0), t = !!(this.isCartesian && !this.isDirty && !this.xAxis.isDirty && !this.yAxis.isDirty && !t) || !A, T && (this.requireSorting = !1), !t) {
          this.destroyGroupedData(), A = o.groupAll ? this.xData : this.processedXData;
          var X = o.groupAll ? this.yData : this.processedYData;
          t = n.plotSizeX, T = this.xAxis;
          var f = T.options.ordinal, m = this.groupPixelWidth;
          if (m && A && A.length) {
            this.isDirty = D = !0, this.points = null;
            var L = T.getExtremes(), Y = L.min;
            L = L.max, f = f && T.ordinal && T.ordinal.getGroupIntervalFactor(Y, L, this) || 1, t = T.getTimeTicks(R.Additions.prototype.normalizeTimeTickInterval(m * (L - Y) / t * f, o.units || s), Math.min(Y, A[0]), Math.max(L, A[A.length - 1]), T.options.startOfWeek, A, this.closestPointRange), m = v.groupData.apply(this, [A, X, t, o.approximation]), A = m.groupedXData, X = m.groupedYData, f = 0, o && o.smoothed && A.length && (o.firstAnchor = "firstPoint", o.anchor = "middle", o.lastAnchor = "lastPoint", B(32, !1, n, { "dataGrouping.smoothed": "use dataGrouping.anchor" })), n = A;
            var F = this.options.dataGrouping;
            if (Y = this.currentDataGrouping && this.currentDataGrouping.gapSize, F && this.xData && Y && this.groupMap) {
              var Q = n.length - 1, k = F.anchor, G = x(F.firstAnchor, k);
              if (F = x(F.lastAnchor, k), k && k !== "start") {
                var z = Y * { middle: 0.5, end: 1 }[k];
                for (k = n.length - 1; k-- && 0 < k; )
                  n[k] += z;
              }
              if (G && G !== "start" && this.xData[0] >= n[0]) {
                k = this.groupMap[0].start, z = this.groupMap[0].length;
                var V = void 0;
                b(k) && b(z) && (V = k + (z - 1)), n[0] = { middle: n[0] + 0.5 * Y, end: n[0] + Y, firstPoint: this.xData[0], lastPoint: V && this.xData[V] }[G];
              }
              F && F !== "start" && Y && n[Q] >= L - Y && (L = this.groupMap[this.groupMap.length - 1].start, n[Q] = { middle: n[Q] + 0.5 * Y, end: n[Q] + Y, firstPoint: L && this.xData[L], lastPoint: this.xData[this.xData.length - 1] }[F]);
            }
            for (L = 1; L < t.length; L++)
              t.info.segmentStarts && t.info.segmentStarts.indexOf(L) !== -1 || (f = Math.max(t[L] - t[L - 1], f));
            L = t.info, L.gapSize = f, this.closestPointRange = t.info.totalRange, this.groupMap = m.groupMap, _ && (_ = A, O(_[0]) && b(T.min) && b(T.dataMin) && _[0] < T.min && ((!O(T.options.min) && T.min <= T.dataMin || T.min === T.dataMin) && (T.min = Math.min(_[0], T.min)), T.dataMin = Math.min(_[0], T.dataMin)), O(_[_.length - 1]) && b(T.max) && b(T.dataMax) && _[_.length - 1] > T.max && ((!O(T.options.max) && b(T.dataMax) && T.max >= T.dataMax || T.max === T.dataMax) && (T.max = Math.max(_[_.length - 1], T.max)), T.dataMax = Math.max(_[_.length - 1], T.dataMax))), o.groupAll && (this.allGroupedData = X, o = this.cropData(A, X, T.min, T.max, 1), A = o.xData, X = o.yData, this.cropStart = o.start), this.processedXData = A, this.processedYData = X;
          } else
            this.groupMap = null;
          this.hasGroupedData = D, this.currentDataGrouping = L, this.preventGraphAnimation = (j && j.totalRange) !== (L && L.totalRange);
        }
      }, v.destroyGroupedData = function() {
        this.groupedData && (this.groupedData.forEach(function(t, n) {
          t && (this.groupedData[n] = t.destroy ? t.destroy() : null);
        }, this), this.groupedData.length = 0);
      }, v.generatePoints = function() {
        p.apply(this), this.destroyGroupedData(), this.groupedData = this.hasGroupedData ? this.points : null;
      }, y.prototype.applyGrouping = function(t) {
        var n = this;
        n.series.forEach(function(o) {
          o.groupPixelWidth = void 0, o.groupPixelWidth = n.getGroupPixelWidth && n.getGroupPixelWidth(), o.groupPixelWidth && (o.hasProcessed = !0), o.applyGrouping(!!t.hasExtemesChanged);
        });
      }, y.prototype.getGroupPixelWidth = function() {
        var t = this.series, n = t.length, o, A = 0, _ = !1, D;
        for (o = n; o--; )
          (D = t[o].options.dataGrouping) && (A = Math.max(A, x(D.groupPixelWidth, i.groupPixelWidth)));
        for (o = n; o--; )
          (D = t[o].options.dataGrouping) && (n = (t[o].processedXData || t[o].data).length, (t[o].groupPixelWidth || n > this.chart.plotSizeX / A || n && D.forced) && (_ = !0));
        return _ ? A : 0;
      }, y.prototype.setDataGrouping = function(t, n) {
        var o;
        if (n = x(n, !0), t || (t = { forced: !1, units: null }), this instanceof y)
          for (o = this.series.length; o--; )
            this.series[o].update({ dataGrouping: t }, !1);
        else
          this.chart.options.series.forEach(function(A) {
            A.dataGrouping = t;
          }, !1);
        this.ordinal && (this.ordinal.slope = void 0), n && this.chart.redraw();
      }, I(y, "postProcessData", y.prototype.applyGrouping), I(H, "update", function() {
        if (this.dataGroup)
          return B(
            24,
            !1,
            this.series.chart
          ), !1;
      }), I(U, "headerFormatter", function(t) {
        var n = this.chart, o = n.time, A = t.labelConfig, _ = A.series, D = _.tooltipOptions, j = _.options.dataGrouping, T = D.xDateFormat, X = _.xAxis, f = D[t.isFooter ? "footerFormat" : "headerFormat"];
        if (X && X.options.type === "datetime" && j && b(A.key)) {
          var m = _.currentDataGrouping;
          if (j = j.dateTimeLabelFormats || i.dateTimeLabelFormats, m)
            if (D = j[m.unitName], m.count === 1)
              T = D[0];
            else {
              T = D[1];
              var L = D[2];
            }
          else
            !T && j && X.dateTime && (T = X.dateTime.getXDateFormat(A.x, D.dateTimeLabelFormats));
          T = o.dateFormat(T, A.key), L && (T += o.dateFormat(L, A.key + m.totalRange - 1)), _.chart.styledMode && (f = this.styledModeFormat(f)), t.text = M(f, { point: C(A.point, { key: T }), series: _ }, n), t.preventDefault();
        }
      }), I($, "destroy", v.destroyGroupedData), I($, "afterSetOptions", function(t) {
        t = t.options;
        var n = this.type, o = this.chart.options.plotOptions, A = W.defaultOptions.plotOptions[n].dataGrouping, _ = this.useCommonDataGrouping && i;
        if (o && (l[n] || _)) {
          A || (A = w(i, l[n]));
          var D = this.chart.rangeSelector;
          t.dataGrouping = w(
            _,
            A,
            o.series && o.series.dataGrouping,
            o[n].dataGrouping,
            this.userOptions.dataGrouping,
            !t.isInternal && D && b(D.selected) && D.buttonOptions[D.selected].dataGrouping
          );
        }
      }), I(y, "afterSetScale", function() {
        this.series.forEach(function(t) {
          t.hasProcessed = !1;
        });
      }), Z.dataGrouping = c, c;
    }), E(a, "Series/HLC/HLCPoint.js", [a["Core/Series/SeriesRegistry.js"]], function(y) {
      var R = this && this.__extends || function() {
        var I = function(Z, H) {
          return I = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function($, U) {
            $.__proto__ = U;
          } || function($, U) {
            for (var W in U)
              U.hasOwnProperty(W) && ($[W] = U[W]);
          }, I(Z, H);
        };
        return function(Z, H) {
          function $() {
            this.constructor = Z;
          }
          I(Z, H), Z.prototype = H === null ? Object.create(H) : ($.prototype = H.prototype, new $());
        };
      }();
      return function(I) {
        function Z() {
          var H = I !== null && I.apply(this, arguments) || this;
          return H.close = void 0, H.high = void 0, H.low = void 0, H.options = void 0, H.plotClose = void 0, H.series = void 0, H;
        }
        return R(Z, I), Z;
      }(y.seriesTypes.column.prototype.pointClass);
    }), E(
      a,
      "Series/HLC/HLCSeries.js",
      [a["Series/HLC/HLCPoint.js"], a["Core/Series/SeriesRegistry.js"], a["Core/Utilities.js"]],
      function(y, R, I) {
        var Z = this && this.__extends || function() {
          var W = function(N, M) {
            return W = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(v, u) {
              v.__proto__ = u;
            } || function(v, u) {
              for (var d in u)
                u.hasOwnProperty(d) && (v[d] = u[d]);
            }, W(N, M);
          };
          return function(N, M) {
            function v() {
              this.constructor = N;
            }
            W(N, M), N.prototype = M === null ? Object.create(M) : (v.prototype = M.prototype, new v());
          };
        }(), H = R.seriesTypes.column, $ = I.extend, U = I.merge;
        return I = function(W) {
          function N() {
            var M = W !== null && W.apply(this, arguments) || this;
            return M.data = void 0, M.options = void 0, M.points = void 0, M.yData = void 0, M;
          }
          return Z(N, W), N.prototype.extendStem = function(M, v, u) {
            var d = M[0];
            M = M[1], typeof d[2] == "number" && (d[2] = Math.max(u + v, d[2])), typeof M[2] == "number" && (M[2] = Math.min(u - v, M[2]));
          }, N.prototype.getPointPath = function(M, v) {
            v = v.strokeWidth();
            var u = M.series, d = v % 2 / 2, P = Math.round(M.plotX) - d, O = Math.round(M.shapeArgs.width / 2), B = [["M", P, Math.round(M.yBottom)], ["L", P, Math.round(M.plotHigh)]];
            return M.close !== null && (M = Math.round(M.plotClose) + d, B.push(["M", P, M], ["L", P + O, M]), u.extendStem(B, v / 2, M)), B;
          }, N.prototype.drawSinglePoint = function(M) {
            var v = M.series, u = v.chart, d = M.graphic, P = !d;
            typeof M.plotY < "u" && (d || (M.graphic = d = u.renderer.path().add(v.group)), u.styledMode || d.attr(v.pointAttribs(M, M.selected && "select")), v = v.getPointPath(M, d), d[P ? "attr" : "animate"]({ d: v }).addClass(M.getClassName(), !0));
          }, N.prototype.drawPoints = function() {
            this.points.forEach(this.drawSinglePoint);
          }, N.prototype.init = function() {
            W.prototype.init.apply(this, arguments), this.options.stacking = void 0;
          }, N.prototype.pointAttribs = function(M, v) {
            return M = W.prototype.pointAttribs.call(this, M, v), delete M.fill, M;
          }, N.prototype.toYData = function(M) {
            return [M.high, M.low, M.close];
          }, N.prototype.translate = function() {
            var M = this, v = M.yAxis, u = this.pointArrayMap && this.pointArrayMap.slice() || [], d = u.map(function(P) {
              return "plot" + (P.charAt(0).toUpperCase() + P.slice(1));
            });
            d.push("yBottom"), u.push("low"), W.prototype.translate.apply(M), M.points.forEach(function(P) {
              u.forEach(function(O, B) {
                O = P[O], O !== null && (M.dataModify && (O = M.dataModify.modifyValue(O)), P[d[B]] = v.toPixels(O, !0));
              }), P.tooltipPos[1] = P.plotHigh + v.pos - M.chart.plotTop;
            });
          }, N.defaultOptions = U(H.defaultOptions, { lineWidth: 1, tooltip: { pointFormat: '<span style="color:{point.color}">●</span> <b> {series.name}</b><br/>High: {point.high}<br/>Low: {point.low}<br/>Close: {point.close}<br/>' }, threshold: null, states: { hover: { lineWidth: 3 } }, stickyTracking: !0 }), N;
        }(H), $(I.prototype, { animate: null, directTouch: !1, pointArrayMap: ["high", "low", "close"], pointAttrToOptions: {
          stroke: "color",
          "stroke-width": "lineWidth"
        }, pointValKey: "close" }), I.prototype.pointClass = y, R.registerSeriesType("hlc", I), I;
      }
    ), E(a, "Series/OHLC/OHLCPoint.js", [a["Core/Series/SeriesRegistry.js"]], function(y) {
      var R = this && this.__extends || function() {
        var I = function(Z, H) {
          return I = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function($, U) {
            $.__proto__ = U;
          } || function($, U) {
            for (var W in U)
              U.hasOwnProperty(W) && ($[W] = U[W]);
          }, I(Z, H);
        };
        return function(Z, H) {
          function $() {
            this.constructor = Z;
          }
          I(Z, H), Z.prototype = H === null ? Object.create(H) : ($.prototype = H.prototype, new $());
        };
      }();
      return function(I) {
        function Z() {
          var H = I !== null && I.apply(this, arguments) || this;
          return H.open = void 0, H.options = void 0, H.plotOpen = void 0, H.series = void 0, H;
        }
        return R(Z, I), Z.prototype.getClassName = function() {
          return I.prototype.getClassName.call(this) + (this.open < this.close ? " highcharts-point-up" : " highcharts-point-down");
        }, Z.prototype.resolveUpColor = function() {
          this.open < this.close && !this.options.color && this.series.options.upColor && (this.color = this.series.options.upColor);
        }, Z.prototype.resolveColor = function() {
          I.prototype.resolveColor.call(this), this.resolveUpColor();
        }, Z.prototype.getZone = function() {
          var H = I.prototype.getZone.call(this);
          return this.resolveUpColor(), H;
        }, Z.prototype.applyOptions = function() {
          return I.prototype.applyOptions.apply(this, arguments), this.resolveColor && this.resolveColor(), this;
        }, Z;
      }(y.seriesTypes.hlc.prototype.pointClass);
    }), E(
      a,
      "Series/OHLC/OHLCSeries.js",
      [a["Series/OHLC/OHLCPoint.js"], a["Core/Series/SeriesRegistry.js"], a["Core/Utilities.js"]],
      function(y, R, I) {
        var Z = this && this.__extends || function() {
          var v = function(u, d) {
            return v = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(P, O) {
              P.__proto__ = O;
            } || function(P, O) {
              for (var B in O)
                O.hasOwnProperty(B) && (P[B] = O[B]);
            }, v(u, d);
          };
          return function(u, d) {
            function P() {
              this.constructor = u;
            }
            v(u, d), u.prototype = d === null ? Object.create(d) : (P.prototype = d.prototype, new P());
          };
        }(), H = R.series, $ = R.seriesTypes.hlc, U = I.addEvent, W = I.extend, N = I.merge, M = function(v) {
          function u() {
            var d = v !== null && v.apply(this, arguments) || this;
            return d.data = void 0, d.options = void 0, d.points = void 0, d;
          }
          return Z(u, v), u.prototype.getPointPath = function(d, P) {
            var O = v.prototype.getPointPath.call(this, d, P);
            P = P.strokeWidth();
            var B = P % 2 / 2, C = Math.round(d.plotX) - B, b = Math.round(d.shapeArgs.width / 2);
            return d.open !== null && (d = Math.round(d.plotOpen) + B, O.push(["M", C, d], ["L", C - b, d]), v.prototype.extendStem.call(this, O, P / 2, d)), O;
          }, u.prototype.pointAttribs = function(d, P) {
            P = v.prototype.pointAttribs.call(this, d, P);
            var O = this.options;
            return delete P.fill, !d.options.color && O.upColor && d.open < d.close && (P.stroke = O.upColor), P;
          }, u.prototype.toYData = function(d) {
            return [d.open, d.high, d.low, d.close];
          }, u.defaultOptions = N($.defaultOptions, { tooltip: { pointFormat: '<span style="color:{point.color}">●</span> <b> {series.name}</b><br/>Open: {point.open}<br/>High: {point.high}<br/>Low: {point.low}<br/>Close: {point.close}<br/>' } }), u;
        }($);
        return W(M.prototype, { pointArrayMap: ["open", "high", "low", "close"] }), M.prototype.pointClass = y, R.registerSeriesType("ohlc", M), U(H, "init", function(v) {
          v = v.options, v.useOhlcData && v.id !== "highcharts-navigator-series" && W(this, { pointValKey: M.prototype.pointValKey, pointArrayMap: M.prototype.pointArrayMap, toYData: M.prototype.toYData });
        }), U(H, "afterSetOptions", function(v) {
          v = v.options;
          var u = v.dataGrouping;
          u && v.useOhlcData && v.id !== "highcharts-navigator-series" && (u.approximation = "ohlc");
        }), M;
      }
    ), E(a, "Series/Candlestick/CandlestickSeries.js", [a["Core/DefaultOptions.js"], a["Core/Series/SeriesRegistry.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = this && this.__extends || function() {
        var N = function(M, v) {
          return N = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(u, d) {
            u.__proto__ = d;
          } || function(u, d) {
            for (var P in d)
              d.hasOwnProperty(P) && (u[P] = d[P]);
          }, N(M, v);
        };
        return function(M, v) {
          function u() {
            this.constructor = M;
          }
          N(M, v), M.prototype = v === null ? Object.create(v) : (u.prototype = v.prototype, new u());
        };
      }(), H = y.defaultOptions;
      y = R.seriesTypes;
      var $ = y.column, U = y.ohlc, W = I.merge;
      return I = function(N) {
        function M() {
          var v = N !== null && N.apply(this, arguments) || this;
          return v.data = void 0, v.options = void 0, v.points = void 0, v;
        }
        return Z(M, N), M.prototype.pointAttribs = function(v, u) {
          var d = $.prototype.pointAttribs.call(this, v, u), P = this.options, O = v.open < v.close, B = P.lineColor || this.color, C = v.color || this.color;
          return d["stroke-width"] = P.lineWidth, d.fill = v.options.color || O && P.upColor || C, d.stroke = v.options.lineColor || O && P.upLineColor || B, u && (v = P.states[u], d.fill = v.color || d.fill, d.stroke = v.lineColor || d.stroke, d["stroke-width"] = v.lineWidth || d["stroke-width"]), d;
        }, M.prototype.drawPoints = function() {
          var v = this, u = v.chart, d = v.yAxis.reversed;
          v.points.forEach(function(P) {
            var O = P.graphic, B = !O;
            if (typeof P.plotY < "u") {
              O || (P.graphic = O = u.renderer.path().add(v.group)), v.chart.styledMode || O.attr(v.pointAttribs(P, P.selected && "select")).shadow(v.options.shadow);
              var C = O.strokeWidth() % 2 / 2, b = Math.round(P.plotX) - C, w = P.plotOpen, x = P.plotClose, h = Math.min(w, x);
              w = Math.max(w, x);
              var c = Math.round(P.shapeArgs.width / 2);
              x = d ? w !== P.yBottom : Math.round(h) !== Math.round(P.plotHigh);
              var p = d ? Math.round(h) !== Math.round(P.plotHigh) : w !== P.yBottom;
              h = Math.round(h) + C, w = Math.round(w) + C, C = [], C.push(["M", b - c, w], ["L", b - c, h], ["L", b + c, h], ["L", b + c, w], ["Z"], ["M", b, h], ["L", b, x ? Math.round(d ? P.yBottom : P.plotHigh) : h], ["M", b, w], ["L", b, p ? Math.round(d ? P.plotHigh : P.yBottom) : w]), O[B ? "attr" : "animate"]({ d: C }).addClass(P.getClassName(), !0);
            }
          });
        }, M.defaultOptions = W(U.defaultOptions, H.plotOptions, { states: { hover: { lineWidth: 2 } }, tooltip: H.plotOptions.ohlc.tooltip, threshold: null, lineColor: "#000000", lineWidth: 1, upColor: "#ffffff", stickyTracking: !0 }), M;
      }(U), R.registerSeriesType("candlestick", I), I;
    }), E(a, "Series/Flags/FlagsPoint.js", [a["Core/Series/SeriesRegistry.js"], a["Core/Utilities.js"]], function(y, R) {
      var I = this && this.__extends || function() {
        var H = function($, U) {
          return H = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(W, N) {
            W.__proto__ = N;
          } || function(W, N) {
            for (var M in N)
              N.hasOwnProperty(M) && (W[M] = N[M]);
          }, H($, U);
        };
        return function($, U) {
          function W() {
            this.constructor = $;
          }
          H($, U), $.prototype = U === null ? Object.create(U) : (W.prototype = U.prototype, new W());
        };
      }(), Z = R.isNumber;
      return function(H) {
        function $() {
          var U = H !== null && H.apply(this, arguments) || this;
          return U.options = void 0, U.series = void 0, U;
        }
        return I($, H), $.prototype.isValid = function() {
          return Z(this.y) || typeof this.y > "u";
        }, $.prototype.hasNewShapeType = function() {
          var U = this.options.shape || this.series.options.shape;
          return this.graphic && U && U !== this.graphic.symbolKey;
        }, $;
      }(y.seriesTypes.column.prototype.pointClass);
    }), E(a, "Series/OnSeriesComposition.js", [
      a["Series/Column/ColumnSeries.js"],
      a["Core/Series/Series.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I) {
      var Z = y.prototype, H = R.prototype, $ = I.defined, U = I.stableSort, W;
      return function(N) {
        function M() {
          return H.getPlotBox.call(this.options.onSeries && this.chart.get(this.options.onSeries) || this);
        }
        function v() {
          Z.translate.apply(this);
          var d = this, P = d.options, O = d.chart, B = d.points, C = P.onSeries, b = (C = C && O.get(C)) && C.options.step, w = C && C.points, x = O.inverted, h = d.xAxis, c = d.yAxis;
          O = B.length - 1;
          var p;
          P = P.onKey || "y";
          var i = w && w.length, l = 0, s;
          if (C && C.visible && i) {
            l = (C.pointXOffset || 0) + (C.barW || 0) / 2;
            var t = C.currentDataGrouping, n = w[i - 1].x + (t ? t.totalRange : 0);
            for (U(B, function(_, D) {
              return _.x - D.x;
            }), P = "plot" + P[0].toUpperCase() + P.substr(1); i-- && B[O]; ) {
              var o = w[i];
              if (t = B[O], t.y = o.y, o.x <= t.x && typeof o[P] < "u") {
                if (t.x <= n && (t.plotY = o[P], o.x < t.x && !b && (s = w[i + 1]) && typeof s[P] < "u")) {
                  var A = (t.x - o.x) / (s.x - o.x);
                  t.plotY += A * (s[P] - o[P]), t.y += A * (s.y - o.y);
                }
                if (O--, i++, 0 > O)
                  break;
              }
            }
          }
          B.forEach(function(_, D) {
            if (_.plotX += l, (typeof _.plotY > "u" || x) && (0 <= _.plotX && _.plotX <= h.len ? x ? (_.plotY = h.translate(_.x, 0, 1, 0, 1), _.plotX = $(_.y) ? c.translate(_.y, 0, 0, 0, 1) : 0) : _.plotY = (h.opposite ? 0 : d.yAxis.len) + h.offset : _.shapeArgs = {}), (p = B[D - 1]) && p.plotX === _.plotX) {
              typeof p.stackIndex > "u" && (p.stackIndex = 0);
              var j = p.stackIndex + 1;
            }
            _.stackIndex = j;
          }), this.onSeries = C;
        }
        var u = [];
        N.compose = function(d) {
          if (u.indexOf(d) === -1) {
            u.push(d);
            var P = d.prototype;
            P.getPlotBox = M, P.translate = v;
          }
          return d;
        }, N.getPlotBox = M, N.translate = v;
      }(W || (W = {})), W;
    }), E(
      a,
      "Series/Flags/FlagsSymbols.js",
      [a["Core/Renderer/RendererRegistry.js"], a["Core/Renderer/SVG/SVGRenderer.js"]],
      function(y, R) {
        function I(H) {
          Z[H + "pin"] = function($, U, W, N, M) {
            var v = M && M.anchorX;
            M = M && M.anchorY, H === "circle" && N > W && ($ -= Math.round((N - W) / 2), W = N);
            var u = Z[H]($, U, W, N);
            if (v && M) {
              var d = v;
              H === "circle" ? d = $ + W / 2 : ($ = u[0], W = u[1], $[0] === "M" && W[0] === "L" && (d = ($[1] + W[1]) / 2)), u.push(["M", d, U > M ? U : U + N], ["L", v, M]), u = u.concat(Z.circle(v - 1, M - 1, 2, 2));
            }
            return u;
          };
        }
        var Z = R.prototype.symbols;
        return Z.flag = function(H, $, U, W, N) {
          var M = N && N.anchorX || H;
          N = N && N.anchorY || $;
          var v = Z.circle(M - 1, N - 1, 2, 2);
          return v.push(["M", M, N], ["L", H, $ + W], ["L", H, $], ["L", H + U, $], ["L", H + U, $ + W], ["L", H, $ + W], ["Z"]), v;
        }, I("circle"), I("square"), y = y.getRendererType(), y !== R && (y.prototype.symbols.circlepin = Z.circlepin, y.prototype.symbols.flag = Z.flag, y.prototype.symbols.squarepin = Z.squarepin), Z;
      }
    ), E(a, "Series/Flags/FlagsSeries.js", [
      a["Series/Flags/FlagsPoint.js"],
      a["Core/Globals.js"],
      a["Series/OnSeriesComposition.js"],
      a["Core/Renderer/RendererUtilities.js"],
      a["Core/Series/SeriesRegistry.js"],
      a["Core/Renderer/SVG/SVGElement.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I, Z, H, $, U) {
      var W = this && this.__extends || function() {
        var C = function(b, w) {
          return C = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(x, h) {
            x.__proto__ = h;
          } || function(x, h) {
            for (var c in h)
              h.hasOwnProperty(c) && (x[c] = h[c]);
          }, C(b, w);
        };
        return function(b, w) {
          function x() {
            this.constructor = b;
          }
          C(b, w), b.prototype = w === null ? Object.create(w) : (x.prototype = w.prototype, new x());
        };
      }();
      R = R.noop;
      var N = Z.distribute, M = H.series, v = H.seriesTypes.column, u = U.addEvent, d = U.defined;
      Z = U.extend;
      var P = U.merge, O = U.objectEach, B = U.wrap;
      return U = function(C) {
        function b() {
          var w = C !== null && C.apply(this, arguments) || this;
          return w.data = void 0, w.options = void 0, w.points = void 0, w;
        }
        return W(b, C), b.prototype.animate = function(w) {
          w && this.setClip();
        }, b.prototype.drawPoints = function() {
          var w = this.points, x = this.chart, h = x.renderer, c = x.inverted, p = this.options, i = p.y, l, s = this.yAxis, t = {}, n = [];
          for (l = w.length; l--; ) {
            var o = w[l], A = (c ? o.plotY : o.plotX) > this.xAxis.len, _ = o.plotX, D = o.stackIndex, j = o.options.shape || p.shape, T = o.plotY;
            typeof T < "u" && (T = o.plotY + i - (typeof D < "u" && D * p.stackDistance)), o.anchorX = D ? void 0 : o.plotX;
            var X = D ? void 0 : o.plotY, f = j !== "flag";
            D = o.graphic, typeof T < "u" && 0 <= _ && !A ? (D && o.hasNewShapeType() && (D = D.destroy()), D || (D = o.graphic = h.label("", null, null, j, null, null, p.useHTML).addClass("highcharts-point").add(this.markerGroup), o.graphic.div && (o.graphic.div.point = o), D.isNew = !0), D.attr({
              align: f ? "center" : "left",
              width: p.width,
              height: p.height,
              "text-align": p.textAlign
            }), x.styledMode || D.attr(this.pointAttribs(o)).css(P(p.style, o.style)).shadow(p.shadow), 0 < _ && (_ -= D.strokeWidth() % 2), j = { y: T, anchorY: X }, p.allowOverlapX && (j.x = _, j.anchorX = o.anchorX), D.attr({ text: o.options.title || p.title || "A" })[D.isNew ? "attr" : "animate"](j), p.allowOverlapX || (t[o.plotX] ? t[o.plotX].size = Math.max(t[o.plotX].size, D.width) : t[o.plotX] = { align: f ? 0.5 : 0, size: D.width, target: _, anchorX: _ }), o.tooltipPos = [_, T + s.pos - x.plotTop]) : D && (o.graphic = D.destroy());
          }
          if (!p.allowOverlapX) {
            var m = 100;
            O(t, function(L) {
              L.plotX = L.anchorX, n.push(L), m = Math.max(L.size, m);
            }), N(n, c ? s.len : this.xAxis.len, m), w.forEach(function(L) {
              var Y = L.graphic && t[L.plotX];
              Y && (L.graphic[L.graphic.isNew ? "attr" : "animate"]({ x: Y.pos + Y.align * Y.size, anchorX: L.anchorX }), d(Y.pos) ? L.graphic.isNew = !1 : (L.graphic.attr({ x: -9999, anchorX: -9999 }), L.graphic.isNew = !0));
            });
          }
          p.useHTML && B(this.markerGroup, "on", function(L) {
            return $.prototype.on.apply(L.apply(this, [].slice.call(arguments, 1)), [].slice.call(arguments, 1));
          });
        }, b.prototype.drawTracker = function() {
          var w = this.points;
          C.prototype.drawTracker.call(this), w.forEach(function(x) {
            var h = x.graphic;
            h && (x.unbindMouseOver && x.unbindMouseOver(), x.unbindMouseOver = u(h.element, "mouseover", function() {
              0 < x.stackIndex && !x.raised && (x._y = h.y, h.attr({ y: x._y - 8 }), x.raised = !0), w.forEach(function(c) {
                c !== x && c.raised && c.graphic && (c.graphic.attr({ y: c._y }), c.raised = !1);
              });
            }));
          });
        }, b.prototype.pointAttribs = function(w, x) {
          var h = this.options, c = w && w.color || this.color, p = h.lineColor, i = w && w.lineWidth;
          return w = w && w.fillColor || h.fillColor, x && (w = h.states[x].fillColor, p = h.states[x].lineColor, i = h.states[x].lineWidth), { fill: w || c, stroke: p || c, "stroke-width": i || h.lineWidth || 0 };
        }, b.prototype.setClip = function() {
          M.prototype.setClip.apply(this, arguments), this.options.clip !== !1 && this.sharedClipKey && this.markerGroup && this.markerGroup.clip(this.chart.sharedClips[this.sharedClipKey]);
        }, b.defaultOptions = P(v.defaultOptions, {
          pointRange: 0,
          allowOverlapX: !1,
          shape: "flag",
          stackDistance: 12,
          textAlign: "center",
          tooltip: { pointFormat: "{point.text}" },
          threshold: null,
          y: -30,
          fillColor: "#ffffff",
          lineWidth: 1,
          states: { hover: { lineColor: "#000000", fillColor: "#ccd6eb" } },
          style: { fontSize: "11px", fontWeight: "bold" }
        }), b;
      }(v), I.compose(U), Z(U.prototype, { allowDG: !1, forceCrop: !0, invertible: !1, noSharedTooltip: !0, pointClass: y, sorted: !1, takeOrdinalPosition: !1, trackerGroups: ["markerGroup"], buildKDTree: R, init: M.prototype.init, invertGroups: R }), H.registerSeriesType("flags", U), U;
    }), E(a, "Core/Axis/ScrollbarAxis.js", [a["Core/Utilities.js"]], function(y) {
      var R = y.addEvent, I = y.defined, Z = y.pick;
      return function() {
        function H() {
        }
        return H.compose = function($, U) {
          if (H.composed.indexOf($) === -1)
            H.composed.push($);
          else
            return $;
          var W = function(N) {
            var M = Z(N.options && N.options.min, N.min), v = Z(N.options && N.options.max, N.max);
            return { axisMin: M, axisMax: v, scrollMin: I(N.dataMin) ? Math.min(M, N.min, N.dataMin, Z(N.threshold, 1 / 0)) : M, scrollMax: I(N.dataMax) ? Math.max(v, N.max, N.dataMax, Z(N.threshold, -1 / 0)) : v };
          };
          return R($, "afterInit", function() {
            var N = this;
            N.options && N.options.scrollbar && N.options.scrollbar.enabled && (N.options.scrollbar.vertical = !N.horiz, N.options.startOnTick = N.options.endOnTick = !1, N.scrollbar = new U(N.chart.renderer, N.options.scrollbar, N.chart), R(N.scrollbar, "changed", function(M) {
              var v = W(N), u = v.axisMax, d = v.scrollMin, P = v.scrollMax - d;
              I(v.axisMin) && I(u) && (N.horiz && !N.reversed || !N.horiz && N.reversed ? (v = d + P * this.to, d += P * this.from) : (v = d + P * (1 - this.from), d += P * (1 - this.to)), this.shouldUpdateExtremes(M.DOMType) ? N.setExtremes(d, v, !0, M.DOMType !== "mousemove" && M.DOMType !== "touchmove", M) : this.setRange(
                this.from,
                this.to
              ));
            }));
          }), R($, "afterRender", function() {
            var N = W(this), M = N.scrollMin, v = N.scrollMax;
            N = this.scrollbar;
            var u = this.axisTitleMargin + (this.titleOffset || 0), d = this.chart.scrollbarsOffsets, P = this.options.margin || 0;
            N && (this.horiz ? (this.opposite || (d[1] += u), N.position(this.left, this.top + this.height + 2 + d[1] - (this.opposite ? P : 0), this.width, this.height), this.opposite || (d[1] += P), u = 1) : (this.opposite && (d[0] += u), N.position(
              N.options.opposite ? this.left + this.width + 2 + d[0] - (this.opposite ? 0 : P) : this.opposite ? 0 : P,
              this.top,
              this.width,
              this.height
            ), this.opposite && (d[0] += P), u = 0), d[u] += N.size + N.options.margin, isNaN(M) || isNaN(v) || !I(this.min) || !I(this.max) || this.min === this.max ? N.setRange(0, 1) : (d = (this.min - M) / (v - M), M = (this.max - M) / (v - M), this.horiz && !this.reversed || !this.horiz && this.reversed ? N.setRange(d, M) : N.setRange(1 - M, 1 - d)));
          }), R($, "afterGetOffset", function() {
            var N = this.scrollbar && !this.scrollbar.options.opposite;
            N = this.horiz ? 2 : N ? 3 : 1;
            var M = this.scrollbar;
            M && (this.chart.scrollbarsOffsets = [0, 0], this.chart.axisOffset[N] += M.size + M.options.margin);
          }), $;
        }, H.composed = [], H;
      }();
    }), E(a, "Core/ScrollbarDefaults.js", [a["Core/Globals.js"]], function(y) {
      return {
        height: y.isTouchDevice ? 20 : 14,
        barBorderRadius: 0,
        buttonBorderRadius: 0,
        liveRedraw: void 0,
        margin: 10,
        minWidth: 6,
        opposite: !0,
        step: 0.2,
        zIndex: 3,
        barBackgroundColor: "#cccccc",
        barBorderWidth: 1,
        barBorderColor: "#cccccc",
        buttonArrowColor: "#333333",
        buttonBackgroundColor: "#e6e6e6",
        buttonBorderColor: "#cccccc",
        buttonBorderWidth: 1,
        rifleColor: "#333333",
        trackBackgroundColor: "#f2f2f2",
        trackBorderColor: "#f2f2f2",
        trackBorderWidth: 1
      };
    }), E(a, "Core/Scrollbar.js", [a["Core/DefaultOptions.js"], a["Core/Globals.js"], a["Core/Axis/ScrollbarAxis.js"], a["Core/ScrollbarDefaults.js"], a["Core/Utilities.js"]], function(y, R, I, Z, H) {
      var $ = y.defaultOptions, U = H.addEvent, W = H.correctFloat, N = H.defined, M = H.destroyObjectProperties, v = H.fireEvent, u = H.merge, d = H.pick, P = H.removeEvent;
      return y = function() {
        function O(B, C, b) {
          this._events = [], this.chart = void 0, this.from = this.chartY = this.chartX = 0, this.scrollbar = this.renderer = this.options = this.group = void 0, this.scrollbarButtons = [], this.scrollbarGroup = void 0, this.scrollbarLeft = 0, this.scrollbarRifles = void 0, this.scrollbarStrokeWidth = 1, this.to = this.size = this.scrollbarTop = 0, this.track = void 0, this.trackBorderWidth = 1, this.userOptions = void 0, this.y = this.x = 0, this.init(B, C, b);
        }
        return O.compose = function(B) {
          I.compose(B, O);
        }, O.swapXY = function(B, C) {
          return C && B.forEach(function(b) {
            for (var w = b.length, x, h = 0; h < w; h += 2)
              x = b[h + 1], typeof x == "number" && (b[h + 1] = b[h + 2], b[h + 2] = x);
          }), B;
        }, O.prototype.addEvents = function() {
          var B = this.options.inverted ? [1, 0] : [0, 1], C = this.scrollbarButtons, b = this.scrollbarGroup.element, w = this.track.element, x = this.mouseDownHandler.bind(this), h = this.mouseMoveHandler.bind(this), c = this.mouseUpHandler.bind(this);
          B = [[C[B[0]].element, "click", this.buttonToMinClick.bind(this)], [C[B[1]].element, "click", this.buttonToMaxClick.bind(this)], [w, "click", this.trackClick.bind(this)], [b, "mousedown", x], [b.ownerDocument, "mousemove", h], [b.ownerDocument, "mouseup", c]], R.hasTouch && B.push(
            [b, "touchstart", x],
            [b.ownerDocument, "touchmove", h],
            [b.ownerDocument, "touchend", c]
          ), B.forEach(function(p) {
            U.apply(null, p);
          }), this._events = B;
        }, O.prototype.buttonToMaxClick = function(B) {
          var C = (this.to - this.from) * d(this.options.step, 0.2);
          this.updatePosition(this.from + C, this.to + C), v(this, "changed", { from: this.from, to: this.to, trigger: "scrollbar", DOMEvent: B });
        }, O.prototype.buttonToMinClick = function(B) {
          var C = W(this.to - this.from) * d(this.options.step, 0.2);
          this.updatePosition(W(this.from - C), W(this.to - C)), v(this, "changed", {
            from: this.from,
            to: this.to,
            trigger: "scrollbar",
            DOMEvent: B
          });
        }, O.prototype.cursorToScrollbarPosition = function(B) {
          var C = this.options;
          return C = C.minWidth > this.calculatedWidth ? C.minWidth : 0, { chartX: (B.chartX - this.x - this.xOffset) / (this.barWidth - C), chartY: (B.chartY - this.y - this.yOffset) / (this.barWidth - C) };
        }, O.prototype.destroy = function() {
          var B = this, C = B.chart.scroller;
          B.removeEvents(), ["track", "scrollbarRifles", "scrollbar", "scrollbarGroup", "group"].forEach(function(b) {
            B[b] && B[b].destroy && (B[b] = B[b].destroy());
          }), C && B === C.scrollbar && (C.scrollbar = null, M(C.scrollbarButtons));
        }, O.prototype.drawScrollbarButton = function(B) {
          var C = this.renderer, b = this.scrollbarButtons, w = this.options, x = this.size, h = C.g().add(this.group);
          b.push(h), h = C.rect().addClass("highcharts-scrollbar-button").add(h), this.chart.styledMode || h.attr({ stroke: w.buttonBorderColor, "stroke-width": w.buttonBorderWidth, fill: w.buttonBackgroundColor }), h.attr(h.crisp({ x: -0.5, y: -0.5, width: x + 1, height: x + 1, r: w.buttonBorderRadius }, h.strokeWidth())), h = C.path(O.swapXY([["M", x / 2 + (B ? -1 : 1), x / 2 - 3], ["L", x / 2 + (B ? -1 : 1), x / 2 + 3], ["L", x / 2 + (B ? 2 : -2), x / 2]], w.vertical)).addClass("highcharts-scrollbar-arrow").add(b[B]), this.chart.styledMode || h.attr({ fill: w.buttonArrowColor });
        }, O.prototype.init = function(B, C, b) {
          this.scrollbarButtons = [], this.renderer = B, this.userOptions = C, this.options = u(Z, $.scrollbar, C), this.chart = b, this.size = d(this.options.size, this.options.height), C.enabled && (this.render(), this.addEvents());
        }, O.prototype.mouseDownHandler = function(B) {
          B = this.chart.pointer.normalize(B), B = this.cursorToScrollbarPosition(B), this.chartX = B.chartX, this.chartY = B.chartY, this.initPositions = [this.from, this.to], this.grabbedCenter = !0;
        }, O.prototype.mouseMoveHandler = function(B) {
          var C = this.chart.pointer.normalize(B), b = this.options.vertical ? "chartY" : "chartX", w = this.initPositions || [];
          !this.grabbedCenter || B.touches && B.touches[0][b] === 0 || (C = this.cursorToScrollbarPosition(C)[b], b = this[b], b = C - b, this.hasDragged = !0, this.updatePosition(w[0] + b, w[1] + b), this.hasDragged && v(this, "changed", { from: this.from, to: this.to, trigger: "scrollbar", DOMType: B.type, DOMEvent: B }));
        }, O.prototype.mouseUpHandler = function(B) {
          this.hasDragged && v(this, "changed", { from: this.from, to: this.to, trigger: "scrollbar", DOMType: B.type, DOMEvent: B }), this.grabbedCenter = this.hasDragged = this.chartX = this.chartY = null;
        }, O.prototype.position = function(B, C, b, w) {
          var x = this.options.vertical, h = this.rendered ? "animate" : "attr", c = 0;
          this.x = B, this.y = C + this.trackBorderWidth, this.width = b, this.xOffset = this.height = w, this.yOffset = c, x ? (this.width = this.yOffset = b = c = this.size, this.xOffset = C = 0, this.barWidth = w - 2 * b, this.x = B += this.options.margin) : (this.height = this.xOffset = w = C = this.size, this.barWidth = b - 2 * w, this.y += this.options.margin), this.group[h]({ translateX: B, translateY: this.y }), this.track[h]({ width: b, height: w }), this.scrollbarButtons[1][h]({ translateX: x ? 0 : b - C, translateY: x ? w - c : 0 });
        }, O.prototype.removeEvents = function() {
          this._events.forEach(function(B) {
            P.apply(null, B);
          }), this._events.length = 0;
        }, O.prototype.render = function() {
          var B = this.renderer, C = this.options, b = this.size, w = this.chart.styledMode, x = B.g("scrollbar").attr({ zIndex: C.zIndex, translateY: -99999 }).add();
          this.group = x, this.track = B.rect().addClass("highcharts-scrollbar-track").attr({ x: 0, r: C.trackBorderRadius || 0, height: b, width: b }).add(x), w || this.track.attr({ fill: C.trackBackgroundColor, stroke: C.trackBorderColor, "stroke-width": C.trackBorderWidth }), this.trackBorderWidth = this.track.strokeWidth(), this.track.attr({ y: -this.trackBorderWidth % 2 / 2 }), this.scrollbarGroup = B.g().add(x), this.scrollbar = B.rect().addClass("highcharts-scrollbar-thumb").attr({ height: b, width: b, r: C.barBorderRadius || 0 }).add(this.scrollbarGroup), this.scrollbarRifles = B.path(O.swapXY([["M", -3, b / 4], ["L", -3, 2 * b / 3], ["M", 0, b / 4], ["L", 0, 2 * b / 3], ["M", 3, b / 4], ["L", 3, 2 * b / 3]], C.vertical)).addClass("highcharts-scrollbar-rifles").add(this.scrollbarGroup), w || (this.scrollbar.attr({ fill: C.barBackgroundColor, stroke: C.barBorderColor, "stroke-width": C.barBorderWidth }), this.scrollbarRifles.attr({ stroke: C.rifleColor, "stroke-width": 1 })), this.scrollbarStrokeWidth = this.scrollbar.strokeWidth(), this.scrollbarGroup.translate(-this.scrollbarStrokeWidth % 2 / 2, -this.scrollbarStrokeWidth % 2 / 2), this.drawScrollbarButton(0), this.drawScrollbarButton(1);
        }, O.prototype.setRange = function(B, C) {
          var b = this.options, w = b.vertical, x = b.minWidth, h = this.barWidth, c = !this.rendered || this.hasDragged || this.chart.navigator && this.chart.navigator.hasDragged ? "attr" : "animate";
          if (N(h)) {
            var p = h * Math.min(C, 1);
            B = Math.max(B, 0);
            var i = Math.ceil(h * B);
            this.calculatedWidth = p = W(p - i), p < x && (i = (h - x + p) * B, p = x), x = Math.floor(i + this.xOffset + this.yOffset), h = p / 2 - 0.5, this.from = B, this.to = C, w ? (this.scrollbarGroup[c]({ translateY: x }), this.scrollbar[c]({ height: p }), this.scrollbarRifles[c]({ translateY: h }), this.scrollbarTop = x, this.scrollbarLeft = 0) : (this.scrollbarGroup[c]({ translateX: x }), this.scrollbar[c]({ width: p }), this.scrollbarRifles[c]({ translateX: h }), this.scrollbarLeft = x, this.scrollbarTop = 0), 12 >= p ? this.scrollbarRifles.hide() : this.scrollbarRifles.show(!0), b.showFull === !1 && (0 >= B && 1 <= C ? this.group.hide() : this.group.show()), this.rendered = !0;
          }
        }, O.prototype.shouldUpdateExtremes = function(B) {
          return d(this.options.liveRedraw, R.svg && !R.isTouchDevice && !this.chart.isBoosting) || B === "mouseup" || B === "touchend" || !N(B);
        }, O.prototype.trackClick = function(B) {
          var C = this.chart.pointer.normalize(B), b = this.to - this.from, w = this.y + this.scrollbarTop, x = this.x + this.scrollbarLeft;
          this.options.vertical && C.chartY > w || !this.options.vertical && C.chartX > x ? this.updatePosition(this.from + b, this.to + b) : this.updatePosition(this.from - b, this.to - b), v(this, "changed", { from: this.from, to: this.to, trigger: "scrollbar", DOMEvent: B });
        }, O.prototype.update = function(B) {
          this.destroy(), this.init(this.chart.renderer, u(
            !0,
            this.options,
            B
          ), this.chart);
        }, O.prototype.updatePosition = function(B, C) {
          1 < C && (B = W(1 - W(C - B)), C = 1), 0 > B && (C = W(C - B), B = 0), this.from = B, this.to = C;
        }, O.defaultOptions = Z, O;
      }(), $.scrollbar = u(!0, y.defaultOptions, $.scrollbar), y;
    }), E(a, "Core/Axis/NavigatorAxis.js", [a["Core/Globals.js"], a["Core/Utilities.js"]], function(y, R) {
      var I = y.isTouchDevice, Z = R.addEvent, H = R.correctFloat, $ = R.defined, U = R.isNumber, W = R.pick, N = function() {
        function M(v) {
          this.axis = v;
        }
        return M.prototype.destroy = function() {
          this.axis = void 0;
        }, M.prototype.toFixedRange = function(v, u, d, P) {
          var O = this.axis, B = O.chart;
          B = B && B.fixedRange;
          var C = (O.pointRange || 0) / 2;
          return v = W(d, O.translate(v, !0, !O.horiz)), u = W(P, O.translate(u, !0, !O.horiz)), O = B && (u - v) / B, $(d) || (v = H(v + C)), $(P) || (u = H(u - C)), 0.7 < O && 1.3 > O && (P ? v = u - B : u = v + B), U(v) && U(u) || (v = u = void 0), { min: v, max: u };
        }, M;
      }();
      return function() {
        function M() {
        }
        return M.compose = function(v) {
          v.keepProps.push("navigatorAxis"), Z(v, "init", function() {
            this.navigatorAxis || (this.navigatorAxis = new N(this));
          }), Z(v, "zoom", function(u) {
            var d = this.chart.options, P = d.navigator, O = this.navigatorAxis, B = d.chart.pinchType, C = d.rangeSelector;
            d = d.chart.zoomType, this.isXAxis && (P && P.enabled || C && C.enabled) && (d === "y" ? u.zoomed = !1 : (!I && d === "xy" || I && B === "xy") && this.options.range && (P = O.previousZoom, $(u.newMin) ? O.previousZoom = [this.min, this.max] : P && (u.newMin = P[0], u.newMax = P[1], O.previousZoom = void 0))), typeof u.zoomed < "u" && u.preventDefault();
          });
        }, M.AdditionsClass = N, M;
      }();
    }), E(a, "Core/Navigator.js", [
      a["Core/Axis/Axis.js"],
      a["Core/Chart/Chart.js"],
      a["Core/Color/Color.js"],
      a["Core/Globals.js"],
      a["Core/Axis/NavigatorAxis.js"],
      a["Core/DefaultOptions.js"],
      a["Core/Renderer/RendererRegistry.js"],
      a["Core/Scrollbar.js"],
      a["Core/Series/Series.js"],
      a["Core/Series/SeriesRegistry.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I, Z, H, $, U, W, N, M, v) {
      I = I.parse;
      var u = Z.hasTouch, d = Z.isTouchDevice, P = $.defaultOptions, O = v.addEvent, B = v.clamp, C = v.correctFloat, b = v.defined, w = v.destroyObjectProperties, x = v.erase, h = v.extend, c = v.find, p = v.isArray, i = v.isNumber, l = v.merge, s = v.pick, t = v.removeEvent, n = v.splat, o = function(_) {
        for (var D = [], j = 1; j < arguments.length; j++)
          D[j - 1] = arguments[j];
        if (D = [].filter.call(D, i), D.length)
          return Math[_].apply(0, D);
      };
      $ = typeof M.seriesTypes.areaspline > "u" ? "line" : "areaspline", h(P, { navigator: { height: 40, margin: 25, maskInside: !0, handles: { width: 7, height: 15, symbols: ["navigator-handle", "navigator-handle"], enabled: !0, lineWidth: 1, backgroundColor: "#f2f2f2", borderColor: "#999999" }, maskFill: I("#6685c2").setOpacity(0.3).get(), outlineColor: "#cccccc", outlineWidth: 1, series: {
        type: $,
        fillOpacity: 0.05,
        lineWidth: 1,
        compare: null,
        dataGrouping: { approximation: "average", enabled: !0, groupPixelWidth: 2, firstAnchor: "firstPoint", anchor: "middle", lastAnchor: "lastPoint", units: [["millisecond", [1, 2, 5, 10, 20, 25, 50, 100, 200, 500]], ["second", [1, 2, 5, 10, 15, 30]], ["minute", [1, 2, 5, 10, 15, 30]], ["hour", [1, 2, 3, 4, 6, 8, 12]], ["day", [1, 2, 3, 4]], ["week", [1, 2, 3]], ["month", [1, 3, 6]], ["year", null]] },
        dataLabels: { enabled: !1, zIndex: 2 },
        id: "highcharts-navigator-series",
        className: "highcharts-navigator-series",
        lineColor: null,
        marker: { enabled: !1 },
        threshold: null
      }, xAxis: { overscroll: 0, className: "highcharts-navigator-xaxis", tickLength: 0, lineWidth: 0, gridLineColor: "#e6e6e6", gridLineWidth: 1, tickPixelInterval: 200, labels: { align: "left", style: { color: "#999999" }, x: 3, y: -4 }, crosshair: !1 }, yAxis: { className: "highcharts-navigator-yaxis", gridLineWidth: 0, startOnTick: !1, endOnTick: !1, minPadding: 0.1, maxPadding: 0.1, labels: { enabled: !1 }, crosshair: !1, title: { text: null }, tickLength: 0, tickWidth: 0 } } }), U.getRendererType().prototype.symbols["navigator-handle"] = function(_, D, j, T, X) {
        return _ = (X && X.width || 0) / 2, D = Math.round(_ / 3) + 0.5, X = X && X.height || 0, [["M", -_ - 1, 0.5], ["L", _, 0.5], ["L", _, X + 0.5], ["L", -_ - 1, X + 0.5], ["L", -_ - 1, 0.5], ["M", -D, 4], ["L", -D, X - 3], ["M", D - 1, 4], ["L", D - 1, X - 3]];
      };
      var A = function() {
        function _(D) {
          this.zoomedMin = this.zoomedMax = this.yAxis = this.xAxis = this.top = this.size = this.shades = this.rendered = this.range = this.outlineHeight = this.outline = this.opposite = this.navigatorSize = this.navigatorSeries = this.navigatorOptions = this.navigatorGroup = this.navigatorEnabled = this.left = this.height = this.handles = this.chart = this.baseSeries = void 0, this.init(D);
        }
        return _.prototype.drawHandle = function(D, j, T, X) {
          var f = this.navigatorOptions.handles.height;
          this.handles[j][X](T ? { translateX: Math.round(this.left + this.height / 2), translateY: Math.round(this.top + parseInt(D, 10) + 0.5 - f) } : { translateX: Math.round(this.left + parseInt(D, 10)), translateY: Math.round(this.top + this.height / 2 - f / 2 - 1) });
        }, _.prototype.drawOutline = function(D, j, T, X) {
          var f = this.navigatorOptions.maskInside, m = this.outline.strokeWidth(), L = m / 2, Y = m % 2 / 2;
          m = this.outlineHeight;
          var F = this.scrollbarHeight || 0, Q = this.size, k = this.left - F, G = this.top;
          T ? (k -= L, T = G + j + Y, j = G + D + Y, Y = [["M", k + m, G - F - Y], ["L", k + m, T], ["L", k, T], ["L", k, j], ["L", k + m, j], ["L", k + m, G + Q + F]], f && Y.push(["M", k + m, T - L], ["L", k + m, j + L])) : (D += k + F - Y, j += k + F - Y, G += L, Y = [["M", k, G], ["L", D, G], ["L", D, G + m], ["L", j, G + m], ["L", j, G], ["L", k + Q + 2 * F, G]], f && Y.push(["M", D - L, G], ["L", j + L, G])), this.outline[X]({ d: Y });
        }, _.prototype.drawMasks = function(D, j, T, X) {
          var f = this.left, m = this.top, L = this.height;
          if (T)
            var Y = [f, f, f], F = [m, m + D, m + j], Q = [L, L, L], k = [D, j - D, this.size - j];
          else
            Y = [f, f + D, f + j], F = [m, m, m], Q = [D, j - D, this.size - j], k = [L, L, L];
          this.shades.forEach(function(G, z) {
            G[X]({ x: Y[z], y: F[z], width: Q[z], height: k[z] });
          });
        }, _.prototype.renderElements = function() {
          var D = this, j = D.navigatorOptions, T = j.maskInside, X = D.chart, f = X.renderer, m, L = { cursor: X.inverted ? "ns-resize" : "ew-resize" };
          D.navigatorGroup = m = f.g("navigator").attr({ zIndex: 8, visibility: "hidden" }).add(), [!T, T, !T].forEach(function(Y, F) {
            D.shades[F] = f.rect().addClass("highcharts-navigator-mask" + (F === 1 ? "-inside" : "-outside")).add(m), X.styledMode || D.shades[F].attr({ fill: Y ? j.maskFill : "rgba(0,0,0,0)" }).css(F === 1 && L);
          }), D.outline = f.path().addClass("highcharts-navigator-outline").add(m), X.styledMode || D.outline.attr({ "stroke-width": j.outlineWidth, stroke: j.outlineColor }), j.handles.enabled && [0, 1].forEach(function(Y) {
            if (j.handles.inverted = X.inverted, D.handles[Y] = f.symbol(j.handles.symbols[Y], -j.handles.width / 2 - 1, 0, j.handles.width, j.handles.height, j.handles), D.handles[Y].attr({ zIndex: 7 - Y }).addClass("highcharts-navigator-handle highcharts-navigator-handle-" + ["left", "right"][Y]).add(m), !X.styledMode) {
              var F = j.handles;
              D.handles[Y].attr({ fill: F.backgroundColor, stroke: F.borderColor, "stroke-width": F.lineWidth }).css(L);
            }
          });
        }, _.prototype.update = function(D) {
          (this.series || []).forEach(function(j) {
            j.baseSeries && delete j.baseSeries.navigatorSeries;
          }), this.destroy(), l(!0, this.chart.options.navigator, this.options, D), this.init(this.chart);
        }, _.prototype.render = function(D, j, T, X) {
          var f = this.chart, m = this.scrollbarHeight, L, Y = this.xAxis, F = Y.pointRange || 0, Q = Y.navigatorAxis.fake ? f.xAxis[0] : Y, k = this.navigatorEnabled, G, z = this.rendered, V = f.inverted, q = f.xAxis[0].minRange, it = f.xAxis[0].options.maxRange;
          if (!this.hasDragged || b(T)) {
            if (D = C(D - F / 2), j = C(j + F / 2), !i(D) || !i(j))
              if (z)
                T = 0, X = s(Y.width, Q.width);
              else
                return;
            this.left = s(Y.left, f.plotLeft + m + (V ? f.plotWidth : 0)), this.size = G = L = s(Y.len, (V ? f.plotHeight : f.plotWidth) - 2 * m), f = V ? m : L + 2 * m, T = s(T, Y.toPixels(D, !0)), X = s(X, Y.toPixels(j, !0)), i(T) && Math.abs(T) !== 1 / 0 || (T = 0, X = f), D = Y.toValue(T, !0), j = Y.toValue(X, !0);
            var et = Math.abs(C(j - D));
            et < q ? this.grabbedLeft ? T = Y.toPixels(j - q - F, !0) : this.grabbedRight && (X = Y.toPixels(D + q + F, !0)) : b(it) && C(et - F) > it && (this.grabbedLeft ? T = Y.toPixels(j - it - F, !0) : this.grabbedRight && (X = Y.toPixels(D + it + F, !0))), this.zoomedMax = B(Math.max(T, X), 0, G), this.zoomedMin = B(this.fixedWidth ? this.zoomedMax - this.fixedWidth : Math.min(T, X), 0, G), this.range = this.zoomedMax - this.zoomedMin, G = Math.round(this.zoomedMax), T = Math.round(this.zoomedMin), k && (this.navigatorGroup.attr({ visibility: "visible" }), z = z && !this.hasDragged ? "animate" : "attr", this.drawMasks(T, G, V, z), this.drawOutline(T, G, V, z), this.navigatorOptions.handles.enabled && (this.drawHandle(T, 0, V, z), this.drawHandle(G, 1, V, z))), this.scrollbar && (V ? (V = this.top - m, Q = this.left - m + (k || !Q.opposite ? 0 : (Q.titleOffset || 0) + Q.axisTitleMargin), m = L + 2 * m) : (V = this.top + (k ? this.height : -m), Q = this.left - m), this.scrollbar.position(Q, V, f, m), this.scrollbar.setRange(this.zoomedMin / (L || 1), this.zoomedMax / (L || 1))), this.rendered = !0;
          }
        }, _.prototype.addMouseEvents = function() {
          var D = this, j = D.chart, T = j.container, X = [], f, m;
          D.mouseMoveHandler = f = function(L) {
            D.onMouseMove(L);
          }, D.mouseUpHandler = m = function(L) {
            D.onMouseUp(L);
          }, X = D.getPartsEvents("mousedown"), X.push(O(j.renderTo, "mousemove", f), O(T.ownerDocument, "mouseup", m)), u && (X.push(O(j.renderTo, "touchmove", f), O(T.ownerDocument, "touchend", m)), X.concat(D.getPartsEvents("touchstart"))), D.eventsToUnbind = X, D.series && D.series[0] && X.push(O(D.series[0].xAxis, "foundExtremes", function() {
            j.navigator.modifyNavigatorAxisExtremes();
          }));
        }, _.prototype.getPartsEvents = function(D) {
          var j = this, T = [];
          return ["shades", "handles"].forEach(function(X) {
            j[X].forEach(function(f, m) {
              T.push(O(f.element, D, function(L) {
                j[X + "Mousedown"](L, m);
              }));
            });
          }), T;
        }, _.prototype.shadesMousedown = function(D, j) {
          D = this.chart.pointer.normalize(D);
          var T = this.chart, X = this.xAxis, f = this.zoomedMin, m = this.left, L = this.size, Y = this.range, F = D.chartX;
          if (T.inverted && (F = D.chartY, m = this.top), j === 1)
            this.grabbedCenter = F, this.fixedWidth = Y, this.dragOffset = F - f;
          else {
            if (D = F - m - Y / 2, j === 0)
              D = Math.max(0, D);
            else if (j === 2 && D + Y >= L)
              if (D = L - Y, this.reversedExtremes) {
                D -= Y;
                var Q = this.getUnionExtremes().dataMin;
              } else
                var k = this.getUnionExtremes().dataMax;
            D !== f && (this.fixedWidth = Y, j = X.navigatorAxis.toFixedRange(D, D + Y, Q, k), b(j.min) && T.xAxis[0].setExtremes(Math.min(j.min, j.max), Math.max(j.min, j.max), !0, null, { trigger: "navigator" }));
          }
        }, _.prototype.handlesMousedown = function(D, j) {
          this.chart.pointer.normalize(D), D = this.chart;
          var T = D.xAxis[0], X = this.reversedExtremes;
          j === 0 ? (this.grabbedLeft = !0, this.otherHandlePos = this.zoomedMax, this.fixedExtreme = X ? T.min : T.max) : (this.grabbedRight = !0, this.otherHandlePos = this.zoomedMin, this.fixedExtreme = X ? T.max : T.min), D.fixedRange = null;
        }, _.prototype.onMouseMove = function(D) {
          var j = this, T = j.chart, X = j.left, f = j.navigatorSize, m = j.range, L = j.dragOffset, Y = T.inverted;
          D.touches && D.touches[0].pageX === 0 || (D = T.pointer.normalize(D), T = D.chartX, Y && (X = j.top, T = D.chartY), j.grabbedLeft ? (j.hasDragged = !0, j.render(0, 0, T - X, j.otherHandlePos)) : j.grabbedRight ? (j.hasDragged = !0, j.render(0, 0, j.otherHandlePos, T - X)) : j.grabbedCenter && (j.hasDragged = !0, T < L ? T = L : T > f + L - m && (T = f + L - m), j.render(0, 0, T - L, T - L + m)), j.hasDragged && j.scrollbar && s(j.scrollbar.options.liveRedraw, Z.svg && !d && !this.chart.isBoosting) && (D.DOMType = D.type, setTimeout(function() {
            j.onMouseUp(D);
          }, 0)));
        }, _.prototype.onMouseUp = function(D) {
          var j = this.chart, T = this.xAxis, X = this.scrollbar, f = D.DOMEvent || D, m = j.inverted, L = this.rendered && !this.hasDragged ? "animate" : "attr";
          if (this.hasDragged && (!X || !X.hasDragged) || D.trigger === "scrollbar") {
            if (X = this.getUnionExtremes(), this.zoomedMin === this.otherHandlePos)
              var Y = this.fixedExtreme;
            else if (this.zoomedMax === this.otherHandlePos)
              var F = this.fixedExtreme;
            this.zoomedMax === this.size && (F = this.reversedExtremes ? X.dataMin : X.dataMax), this.zoomedMin === 0 && (Y = this.reversedExtremes ? X.dataMax : X.dataMin), T = T.navigatorAxis.toFixedRange(this.zoomedMin, this.zoomedMax, Y, F), b(T.min) && j.xAxis[0].setExtremes(Math.min(T.min, T.max), Math.max(T.min, T.max), !0, this.hasDragged ? !1 : null, { trigger: "navigator", triggerOp: "navigator-drag", DOMEvent: f });
          }
          D.DOMType !== "mousemove" && D.DOMType !== "touchmove" && (this.grabbedLeft = this.grabbedRight = this.grabbedCenter = this.fixedWidth = this.fixedExtreme = this.otherHandlePos = this.hasDragged = this.dragOffset = null), this.navigatorEnabled && i(this.zoomedMin) && i(this.zoomedMax) && (j = Math.round(this.zoomedMin), D = Math.round(this.zoomedMax), this.shades && this.drawMasks(j, D, m, L), this.outline && this.drawOutline(j, D, m, L), this.navigatorOptions.handles.enabled && Object.keys(this.handles).length === this.handles.length && (this.drawHandle(j, 0, m, L), this.drawHandle(D, 1, m, L)));
        }, _.prototype.removeEvents = function() {
          this.eventsToUnbind && (this.eventsToUnbind.forEach(function(D) {
            D();
          }), this.eventsToUnbind = void 0), this.removeBaseSeriesEvents();
        }, _.prototype.removeBaseSeriesEvents = function() {
          var D = this.baseSeries || [];
          this.navigatorEnabled && D[0] && (this.navigatorOptions.adaptToUpdatedData !== !1 && D.forEach(function(j) {
            t(j, "updatedData", this.updatedDataHandler);
          }, this), D[0].xAxis && t(D[0].xAxis, "foundExtremes", this.modifyBaseAxisExtremes));
        }, _.prototype.init = function(D) {
          var j = D.options, T = j.navigator, X = T.enabled, f = j.scrollbar, m = f.enabled;
          j = X ? T.height : 0;
          var L = m ? f.height : 0;
          this.handles = [], this.shades = [], this.chart = D, this.setBaseSeries(), this.height = j, this.scrollbarHeight = L, this.scrollbarEnabled = m, this.navigatorEnabled = X, this.navigatorOptions = T, this.scrollbarOptions = f, this.outlineHeight = j + L, this.opposite = s(T.opposite, !(X || !D.inverted));
          var Y = this;
          X = Y.baseSeries, f = D.xAxis.length, m = D.yAxis.length;
          var F = X && X[0] && X[0].xAxis || D.xAxis[0] || { options: {} };
          D.isDirtyBox = !0, Y.navigatorEnabled ? (Y.xAxis = new y(D, l(
            { breaks: F.options.breaks, ordinal: F.options.ordinal },
            T.xAxis,
            { id: "navigator-x-axis", yAxis: "navigator-y-axis", isX: !0, type: "datetime", index: f, isInternal: !0, offset: 0, keepOrdinalPadding: !0, startOnTick: !1, endOnTick: !1, minPadding: 0, maxPadding: 0, zoomEnabled: !1 },
            D.inverted ? { offsets: [L, 0, -L, 0], width: j } : { offsets: [0, -L, 0, L], height: j }
          )), Y.yAxis = new y(D, l(T.yAxis, { id: "navigator-y-axis", alignTicks: !1, offset: 0, index: m, isInternal: !0, reversed: s(T.yAxis && T.yAxis.reversed, D.yAxis[0] && D.yAxis[0].reversed, !1), zoomEnabled: !1 }, D.inverted ? { width: j } : { height: j })), X || T.series.data ? Y.updateNavigatorSeries(!1) : D.series.length === 0 && (Y.unbindRedraw = O(D, "beforeRedraw", function() {
            0 < D.series.length && !Y.series && (Y.setBaseSeries(), Y.unbindRedraw());
          })), Y.reversedExtremes = D.inverted && !Y.xAxis.reversed || !D.inverted && Y.xAxis.reversed, Y.renderElements(), Y.addMouseEvents()) : (Y.xAxis = {
            chart: D,
            navigatorAxis: { fake: !0 },
            translate: function(Q, k) {
              var G = D.xAxis[0], z = G.getExtremes(), V = G.len - 2 * L, q = o("min", G.options.min, z.dataMin);
              return G = o("max", G.options.max, z.dataMax) - q, k ? Q * G / V + q : V * (Q - q) / G;
            },
            toPixels: function(Q) {
              return this.translate(Q);
            },
            toValue: function(Q) {
              return this.translate(Q, !0);
            }
          }, Y.xAxis.navigatorAxis.axis = Y.xAxis, Y.xAxis.navigatorAxis.toFixedRange = H.AdditionsClass.prototype.toFixedRange.bind(Y.xAxis.navigatorAxis)), D.options.scrollbar.enabled && (D.scrollbar = Y.scrollbar = new W(D.renderer, l(D.options.scrollbar, { margin: Y.navigatorEnabled ? 0 : 10, vertical: D.inverted }), D), O(Y.scrollbar, "changed", function(Q) {
            var k = Y.size, G = k * this.to;
            k *= this.from, Y.hasDragged = Y.scrollbar.hasDragged, Y.render(0, 0, k, G), this.shouldUpdateExtremes(Q.DOMType) && setTimeout(function() {
              Y.onMouseUp(Q);
            });
          })), Y.addBaseSeriesEvents(), Y.addChartEvents();
        }, _.prototype.getUnionExtremes = function(D) {
          var j = this.chart.xAxis[0], T = this.xAxis, X = T.options, f = j.options, m;
          return D && j.dataMin === null || (m = { dataMin: s(X && X.min, o("min", f.min, j.dataMin, T.dataMin, T.min)), dataMax: s(X && X.max, o("max", f.max, j.dataMax, T.dataMax, T.max)) }), m;
        }, _.prototype.setBaseSeries = function(D, j) {
          var T = this.chart, X = this.baseSeries = [];
          D = D || T.options && T.options.navigator.baseSeries || (T.series.length ? c(
            T.series,
            function(f) {
              return !f.options.isInternal;
            }
          ).index : 0), (T.series || []).forEach(function(f, m) {
            f.options.isInternal || !f.options.showInNavigator && (m !== D && f.options.id !== D || f.options.showInNavigator === !1) || X.push(f);
          }), this.xAxis && !this.xAxis.navigatorAxis.fake && this.updateNavigatorSeries(!0, j);
        }, _.prototype.updateNavigatorSeries = function(D, j) {
          var T = this, X = T.chart, f = T.baseSeries, m, L, Y = T.navigatorOptions.series, F, Q = {
            enableMouseTracking: !1,
            index: null,
            linkedTo: null,
            group: "nav",
            padXAxis: !1,
            xAxis: "navigator-x-axis",
            yAxis: "navigator-y-axis",
            showInLegend: !1,
            stacking: void 0,
            isInternal: !0,
            states: { inactive: { opacity: 1 } }
          }, k = T.series = (T.series || []).filter(function(G) {
            var z = G.baseSeries;
            return 0 > f.indexOf(z) ? (z && (t(z, "updatedData", T.updatedDataHandler), delete z.navigatorSeries), G.chart && G.destroy(), !1) : !0;
          });
          f && f.length && f.forEach(function(G) {
            var z = G.navigatorSeries, V = h({ color: G.color, visible: G.visible }, p(Y) ? P.navigator.series : Y);
            z && T.navigatorOptions.adaptToUpdatedData === !1 || (Q.name = "Navigator " + f.length, m = G.options || {}, F = m.navigatorOptions || {}, V.dataLabels = n(V.dataLabels), L = l(m, Q, V, F), L.pointRange = s(V.pointRange, F.pointRange, P.plotOptions[L.type || "line"].pointRange), V = F.data || V.data, T.hasNavigatorData = T.hasNavigatorData || !!V, L.data = V || m.data && m.data.slice(0), z && z.options ? z.update(L, j) : (G.navigatorSeries = X.initSeries(L), G.navigatorSeries.baseSeries = G, k.push(G.navigatorSeries)));
          }), (Y.data && (!f || !f.length) || p(Y)) && (T.hasNavigatorData = !1, Y = n(Y), Y.forEach(function(G, z) {
            Q.name = "Navigator " + (k.length + 1), L = l(
              P.navigator.series,
              { color: X.series[z] && !X.series[z].options.isInternal && X.series[z].color || X.options.colors[z] || X.options.colors[0] },
              Q,
              G
            ), L.data = G.data, L.data && (T.hasNavigatorData = !0, k.push(X.initSeries(L)));
          })), D && this.addBaseSeriesEvents();
        }, _.prototype.addBaseSeriesEvents = function() {
          var D = this, j = D.baseSeries || [];
          j[0] && j[0].xAxis && j[0].eventsToUnbind.push(O(j[0].xAxis, "foundExtremes", this.modifyBaseAxisExtremes)), j.forEach(function(T) {
            T.eventsToUnbind.push(O(T, "show", function() {
              this.navigatorSeries && this.navigatorSeries.setVisible(
                !0,
                !1
              );
            })), T.eventsToUnbind.push(O(T, "hide", function() {
              this.navigatorSeries && this.navigatorSeries.setVisible(!1, !1);
            })), this.navigatorOptions.adaptToUpdatedData !== !1 && T.xAxis && T.eventsToUnbind.push(O(T, "updatedData", this.updatedDataHandler)), T.eventsToUnbind.push(O(T, "remove", function() {
              this.navigatorSeries && (x(D.series, this.navigatorSeries), b(this.navigatorSeries.options) && this.navigatorSeries.remove(!1), delete this.navigatorSeries);
            }));
          }, this);
        }, _.prototype.getBaseSeriesMin = function(D) {
          return this.baseSeries.reduce(function(j, T) {
            return Math.min(j, T.xData ? T.xData[0] : j);
          }, D);
        }, _.prototype.modifyNavigatorAxisExtremes = function() {
          var D = this.xAxis, j;
          typeof D.getExtremes < "u" && (!(j = this.getUnionExtremes(!0)) || j.dataMin === D.min && j.dataMax === D.max || (D.min = j.dataMin, D.max = j.dataMax));
        }, _.prototype.modifyBaseAxisExtremes = function() {
          var D = this.chart.navigator, j = this.getExtremes(), T = j.dataMin, X = j.dataMax;
          j = j.max - j.min;
          var f = D.stickToMin, m = D.stickToMax, L = s(this.options.overscroll, 0), Y = D.series && D.series[0], F = !!this.setExtremes;
          if (!this.eventArgs || this.eventArgs.trigger !== "rangeSelectorButton") {
            if (f)
              var Q = T, k = Q + j;
            m && (k = X + L, f || (Q = Math.max(T, k - j, D.getBaseSeriesMin(Y && Y.xData ? Y.xData[0] : -Number.MAX_VALUE)))), F && (f || m) && i(Q) && (this.min = this.userMin = Q, this.max = this.userMax = k);
          }
          D.stickToMin = D.stickToMax = null;
        }, _.prototype.updatedDataHandler = function() {
          var D = this.chart.navigator, j = this.navigatorSeries;
          D.stickToMax = D.reversedExtremes ? Math.round(D.zoomedMin) === 0 : Math.round(D.zoomedMax) >= Math.round(D.size), D.stickToMin = D.shouldStickToMin(
            this,
            D
          ), j && !D.hasNavigatorData && (j.options.pointStart = this.xData[0], j.setData(this.options.data, !1, null, !1));
        }, _.prototype.shouldStickToMin = function(D, j) {
          j = j.getBaseSeriesMin(D.xData[0]);
          var T = D.xAxis;
          D = T.max;
          var X = T.min;
          return T = T.options.range, i(D) && i(X) ? T && 0 < D - j ? D - j < T : X <= j : !1;
        }, _.prototype.addChartEvents = function() {
          this.eventsToUnbind || (this.eventsToUnbind = []), this.eventsToUnbind.push(O(this.chart, "redraw", function() {
            var D = this.navigator, j = D && (D.baseSeries && D.baseSeries[0] && D.baseSeries[0].xAxis || this.xAxis[0]);
            j && D.render(j.min, j.max);
          }), O(this.chart, "getMargins", function() {
            var D = this.navigator, j = D.opposite ? "plotTop" : "marginBottom";
            this.inverted && (j = D.opposite ? "marginRight" : "plotLeft"), this[j] = (this[j] || 0) + (D.navigatorEnabled || !this.inverted ? D.outlineHeight : 0) + D.navigatorOptions.margin;
          }));
        }, _.prototype.destroy = function() {
          this.removeEvents(), this.xAxis && (x(this.chart.xAxis, this.xAxis), x(this.chart.axes, this.xAxis)), this.yAxis && (x(this.chart.yAxis, this.yAxis), x(this.chart.axes, this.yAxis)), (this.series || []).forEach(function(D) {
            D.destroy && D.destroy();
          }), "series xAxis yAxis shades outline scrollbarTrack scrollbarRifles scrollbarGroup scrollbar navigatorGroup rendered".split(" ").forEach(function(D) {
            this[D] && this[D].destroy && this[D].destroy(), this[D] = null;
          }, this), [this.handles].forEach(function(D) {
            w(D);
          }, this);
        }, _;
      }();
      return Z.Navigator || (Z.Navigator = A, H.compose(y), O(R, "beforeShowResetZoom", function() {
        var _ = this.options, D = _.navigator, j = _.rangeSelector;
        if ((D && D.enabled || j && j.enabled) && (!d && _.chart.zoomType === "x" || d && _.chart.pinchType === "x"))
          return !1;
      }), O(R, "beforeRender", function() {
        var _ = this.options;
        (_.navigator.enabled || _.scrollbar.enabled) && (this.scroller = this.navigator = new A(this));
      }), O(R, "afterSetChartSize", function() {
        var _ = this.legend, D = this.navigator;
        if (D) {
          var j = _ && _.options, T = D.xAxis, X = D.yAxis, f = D.scrollbarHeight;
          this.inverted ? (D.left = D.opposite ? this.chartWidth - f - D.height : this.spacing[3] + f, D.top = this.plotTop + f) : (D.left = s(T.left, this.plotLeft + f), D.top = D.navigatorOptions.top || this.chartHeight - D.height - f - this.spacing[2] - (this.rangeSelector && this.extraBottomMargin ? this.rangeSelector.getHeight() : 0) - (j && j.verticalAlign === "bottom" && j.layout !== "proximate" && j.enabled && !j.floating ? _.legendHeight + s(j.margin, 10) : 0) - (this.titleOffset ? this.titleOffset[2] : 0)), T && X && (this.inverted ? T.options.left = X.options.left = D.left : T.options.top = X.options.top = D.top, T.setAxisSize(), X.setAxisSize());
        }
      }), O(R, "update", function(_) {
        var D = _.options.navigator || {}, j = _.options.scrollbar || {};
        this.navigator || this.scroller || !D.enabled && !j.enabled || (l(
          !0,
          this.options.navigator,
          D
        ), l(!0, this.options.scrollbar, j), delete _.options.navigator, delete _.options.scrollbar);
      }), O(R, "afterUpdate", function(_) {
        this.navigator || this.scroller || !this.options.navigator.enabled && !this.options.scrollbar.enabled || (this.scroller = this.navigator = new A(this), s(_.redraw, !0) && this.redraw(_.animation));
      }), O(R, "afterAddSeries", function() {
        this.navigator && this.navigator.setBaseSeries(null, !1);
      }), O(N, "afterUpdate", function() {
        this.chart.navigator && !this.options.isInternal && this.chart.navigator.setBaseSeries(
          null,
          !1
        );
      }), R.prototype.callbacks.push(function(_) {
        var D = _.navigator;
        D && _.xAxis[0] && (_ = _.xAxis[0].getExtremes(), D.render(_.min, _.max));
      })), Z.Navigator = A, Z.Navigator;
    }), E(a, "Extensions/RangeSelector.js", [a["Core/Axis/Axis.js"], a["Core/Chart/Chart.js"], a["Core/Globals.js"], a["Core/DefaultOptions.js"], a["Core/Renderer/SVG/SVGElement.js"], a["Core/Utilities.js"]], function(y, R, I, Z, H, $) {
      function U(n) {
        if (n.indexOf("%L") !== -1)
          return "text";
        var o = "aAdewbBmoyY".split("").some(function(_) {
          return n.indexOf("%" + _) !== -1;
        }), A = "HkIlMS".split("").some(function(_) {
          return n.indexOf("%" + _) !== -1;
        });
        return o && A ? "datetime-local" : o ? "date" : A ? "time" : "text";
      }
      var W = Z.defaultOptions, N = $.addEvent, M = $.createElement, v = $.css, u = $.defined, d = $.destroyObjectProperties, P = $.discardElement, O = $.extend, B = $.find, C = $.fireEvent, b = $.isNumber, w = $.merge, x = $.objectEach, h = $.pad, c = $.pick, p = $.pInt, i = $.splat;
      O(W, { rangeSelector: { allButtonsEnabled: !1, buttons: void 0, buttonSpacing: 5, dropdown: "responsive", enabled: void 0, verticalAlign: "top", buttonTheme: {
        width: 28,
        height: 18,
        padding: 2,
        zIndex: 7
      }, floating: !1, x: 0, y: 0, height: void 0, inputBoxBorderColor: "none", inputBoxHeight: 17, inputBoxWidth: void 0, inputDateFormat: "%b %e, %Y", inputDateParser: void 0, inputEditDateFormat: "%Y-%m-%d", inputEnabled: !0, inputPosition: { align: "right", x: 0, y: 0 }, inputSpacing: 5, selected: void 0, buttonPosition: { align: "left", x: 0, y: 0 }, inputStyle: { color: "#335cad", cursor: "pointer" }, labelStyle: { color: "#666666" } } }), O(W.lang, { rangeSelectorZoom: "Zoom", rangeSelectorFrom: "", rangeSelectorTo: "→" });
      var l = function() {
        function n(o) {
          this.buttons = void 0, this.buttonOptions = n.prototype.defaultButtons, this.initialButtonGroupWidth = 0, this.options = void 0, this.chart = o, this.init(o);
        }
        return n.prototype.clickButton = function(o, A) {
          var _ = this.chart, D = this.buttonOptions[o], j = _.xAxis[0], T = _.scroller && _.scroller.getUnionExtremes() || j || {}, X = T.dataMin, f = T.dataMax, m = j && Math.round(Math.min(j.max, c(f, j.max))), L = D.type;
          T = D._range;
          var Y, F = D.dataGrouping;
          if (X !== null && f !== null) {
            if (_.fixedRange = T, this.setSelected(o), F && (this.forcedDataGrouping = !0, y.prototype.setDataGrouping.call(j || { chart: this.chart }, F, !1), this.frozenStates = D.preserveDataGrouping), L === "month" || L === "year")
              if (j) {
                L = { range: D, max: m, chart: _, dataMin: X, dataMax: f };
                var Q = j.minFromRange.call(L);
                b(L.newMax) && (m = L.newMax);
              } else
                T = D;
            else if (T)
              Q = Math.max(m - T, X), m = Math.min(Q + T, f);
            else if (L === "ytd")
              if (j)
                typeof f > "u" && (X = Number.MAX_VALUE, f = Number.MIN_VALUE, _.series.forEach(function(V) {
                  V = V.xData, X = Math.min(V[0], X), f = Math.max(V[V.length - 1], f);
                }), A = !1), m = this.getYTDExtremes(
                  f,
                  X,
                  _.time.useUTC
                ), Q = Y = m.min, m = m.max;
              else {
                this.deferredYTDClick = o;
                return;
              }
            else
              L === "all" && j && (_.navigator && _.navigator.baseSeries[0] && (_.navigator.baseSeries[0].xAxis.options.range = void 0), Q = X, m = f);
            if (u(Q) && (Q += D._offsetMin), u(m) && (m += D._offsetMax), this.dropdown && (this.dropdown.selectedIndex = o + 1), j)
              j.setExtremes(Q, m, c(A, !0), void 0, { trigger: "rangeSelectorButton", rangeSelectorButton: D });
            else {
              var k = i(_.options.xAxis)[0], G = k.range;
              k.range = T;
              var z = k.min;
              k.min = Y, N(_, "load", function() {
                k.range = G, k.min = z;
              });
            }
            C(
              this,
              "afterBtnClick"
            );
          }
        }, n.prototype.setSelected = function(o) {
          this.selected = this.options.selected = o;
        }, n.prototype.init = function(o) {
          var A = this, _ = o.options.rangeSelector, D = _.buttons || A.defaultButtons.slice(), j = _.selected, T = function() {
            var X = A.minInput, f = A.maxInput;
            X && X.blur && C(X, "blur"), f && f.blur && C(f, "blur");
          };
          A.chart = o, A.options = _, A.buttons = [], A.buttonOptions = D, this.eventsToUnbind = [], this.eventsToUnbind.push(N(o.container, "mousedown", T)), this.eventsToUnbind.push(N(o, "resize", T)), D.forEach(A.computeButtonRange), typeof j < "u" && D[j] && this.clickButton(j, !1), this.eventsToUnbind.push(N(o, "load", function() {
            o.xAxis && o.xAxis[0] && N(o.xAxis[0], "setExtremes", function(X) {
              this.max - this.min !== o.fixedRange && X.trigger !== "rangeSelectorButton" && X.trigger !== "updatedData" && A.forcedDataGrouping && !A.frozenStates && this.setDataGrouping(!1, !1);
            });
          }));
        }, n.prototype.updateButtonStates = function() {
          var o = this, A = this.chart, _ = this.dropdown, D = A.xAxis[0], j = Math.round(D.max - D.min), T = !D.hasVisibleSeries, X = A.scroller && A.scroller.getUnionExtremes() || D, f = X.dataMin, m = X.dataMax;
          A = o.getYTDExtremes(m, f, A.time.useUTC);
          var L = A.min, Y = A.max, F = o.selected, Q = b(F), k = o.options.allButtonsEnabled, G = o.buttons;
          o.buttonOptions.forEach(function(z, V) {
            var q = z._range, it = z.type, et = z.count || 1, nt = G[V], rt = 0, ct = z._offsetMax - z._offsetMin;
            z = V === F;
            var gt = q > m - f, dt = q < D.minRange, lt = !1, at = !1;
            q = q === j, (it === "month" || it === "year") && j + 36e5 >= 864e5 * { month: 28, year: 365 }[it] * et - ct && j - 36e5 <= 864e5 * { month: 31, year: 366 }[it] * et + ct ? q = !0 : it === "ytd" ? (q = Y - L + ct === j, lt = !z) : it === "all" && (q = D.max - D.min >= m - f, at = !z && Q && q), it = !k && (gt || dt || at || T), et = z && q || q && !Q && !lt || z && o.frozenStates, it ? rt = 3 : et && (Q = !0, rt = 2), nt.state !== rt && (nt.setState(rt), _ && (_.options[V + 1].disabled = it, rt === 2 && (_.selectedIndex = V + 1)), rt === 0 && F === V && o.setSelected());
          });
        }, n.prototype.computeButtonRange = function(o) {
          var A = o.type, _ = o.count || 1, D = { millisecond: 1, second: 1e3, minute: 6e4, hour: 36e5, day: 864e5, week: 6048e5 };
          D[A] ? o._range = D[A] * _ : (A === "month" || A === "year") && (o._range = 864e5 * { month: 30, year: 365 }[A] * _), o._offsetMin = c(o.offsetMin, 0), o._offsetMax = c(o.offsetMax, 0), o._range += o._offsetMax - o._offsetMin;
        }, n.prototype.getInputValue = function(o) {
          o = o === "min" ? this.minInput : this.maxInput;
          var A = this.chart.options.rangeSelector, _ = this.chart.time;
          return o ? (o.type === "text" && A.inputDateParser || this.defaultInputDateParser)(o.value, _.useUTC, _) : 0;
        }, n.prototype.setInputValue = function(o, A) {
          var _ = this.options, D = this.chart.time, j = o === "min" ? this.minInput : this.maxInput;
          if (o = o === "min" ? this.minDateBox : this.maxDateBox, j) {
            var T = j.getAttribute("data-hc-time");
            T = u(T) ? Number(T) : void 0, u(A) && (u(T) && j.setAttribute("data-hc-time-previous", T), j.setAttribute("data-hc-time", A), T = A), j.value = D.dateFormat(this.inputTypeFormats[j.type] || _.inputEditDateFormat, T), o && o.attr({ text: D.dateFormat(_.inputDateFormat, T) });
          }
        }, n.prototype.setInputExtremes = function(o, A, _) {
          if (o = o === "min" ? this.minInput : this.maxInput) {
            var D = this.inputTypeFormats[o.type], j = this.chart.time;
            D && (A = j.dateFormat(D, A), o.min !== A && (o.min = A), _ = j.dateFormat(D, _), o.max !== _ && (o.max = _));
          }
        }, n.prototype.showInput = function(o) {
          var A = o === "min" ? this.minDateBox : this.maxDateBox;
          if ((o = o === "min" ? this.minInput : this.maxInput) && A && this.inputGroup) {
            var _ = o.type === "text", D = this.inputGroup, j = D.translateX;
            D = D.translateY;
            var T = this.options.inputBoxWidth;
            v(o, { width: _ ? A.width + (T ? -2 : 20) + "px" : "auto", height: _ ? A.height - 2 + "px" : "auto", border: "2px solid silver" }), _ && T ? v(o, { left: j + A.x + "px", top: D + "px" }) : v(o, { left: Math.min(Math.round(A.x + j - (o.offsetWidth - A.width) / 2), this.chart.chartWidth - o.offsetWidth) + "px", top: D - (o.offsetHeight - A.height) / 2 + "px" });
          }
        }, n.prototype.hideInput = function(o) {
          (o = o === "min" ? this.minInput : this.maxInput) && v(o, { top: "-9999em", border: 0, width: "1px", height: "1px" });
        }, n.prototype.defaultInputDateParser = function(o, A, _) {
          var D = o.split("/").join("-").split(" ").join("T");
          if (D.indexOf("T") === -1 && (D += "T00:00"), A)
            D += "Z";
          else {
            var j;
            (j = I.isSafari) && (j = D, j = !(6 < j.length && (j.lastIndexOf("-") === j.length - 6 || j.lastIndexOf("+") === j.length - 6))), j && (j = new Date(D).getTimezoneOffset() / 60, D += 0 >= j ? "+" + h(-j) + ":00" : "-" + h(j) + ":00");
          }
          return D = Date.parse(D), b(D) || (o = o.split("-"), D = Date.UTC(p(o[0]), p(o[1]) - 1, p(o[2]))), _ && A && b(D) && (D += _.getTimezoneOffset(D)), D;
        }, n.prototype.drawInput = function(o) {
          function A() {
            var k = T.getInputValue(o), G = _.xAxis[0], z = _.scroller && _.scroller.xAxis ? _.scroller.xAxis : G, V = z.dataMin;
            z = z.dataMax;
            var q = T.maxInput, it = T.minInput;
            k !== Number(F.getAttribute("data-hc-time-previous")) && b(k) && (F.setAttribute("data-hc-time-previous", k), L && q && b(V) ? k > Number(q.getAttribute("data-hc-time")) ? k = void 0 : k < V && (k = V) : it && b(z) && (k < Number(it.getAttribute("data-hc-time")) ? k = void 0 : k > z && (k = z)), typeof k < "u" && G.setExtremes(L ? k : G.min, L ? G.max : k, void 0, void 0, { trigger: "rangeSelectorInput" }));
          }
          var _ = this.chart, D = this.div, j = this.inputGroup, T = this, X = _.renderer.style || {}, f = _.renderer, m = _.options.rangeSelector, L = o === "min", Y = W.lang[L ? "rangeSelectorFrom" : "rangeSelectorTo"] || "";
          Y = f.label(Y, 0).addClass("highcharts-range-label").attr({ padding: Y ? 2 : 0, height: Y ? m.inputBoxHeight : 0 }).add(j), f = f.label("", 0).addClass("highcharts-range-input").attr({ padding: 2, width: m.inputBoxWidth, height: m.inputBoxHeight, "text-align": "center" }).on(
            "click",
            function() {
              T.showInput(o), T[o + "Input"].focus();
            }
          ), _.styledMode || f.attr({ stroke: m.inputBoxBorderColor, "stroke-width": 1 }), f.add(j);
          var F = M("input", { name: o, className: "highcharts-range-selector" }, void 0, D);
          F.setAttribute("type", U(m.inputDateFormat || "%b %e, %Y")), _.styledMode || (Y.css(w(X, m.labelStyle)), f.css(w({ color: "#333333" }, X, m.inputStyle)), v(F, O({
            position: "absolute",
            border: 0,
            boxShadow: "0 0 15px rgba(0,0,0,0.3)",
            width: "1px",
            height: "1px",
            padding: 0,
            textAlign: "center",
            fontSize: X.fontSize,
            fontFamily: X.fontFamily,
            top: "-9999em"
          }, m.inputStyle))), F.onfocus = function() {
            T.showInput(o);
          }, F.onblur = function() {
            F === I.doc.activeElement && A(), T.hideInput(o), T.setInputValue(o), F.blur();
          };
          var Q = !1;
          return F.onchange = function() {
            Q || (A(), T.hideInput(o), F.blur());
          }, F.onkeypress = function(k) {
            k.keyCode === 13 && A();
          }, F.onkeydown = function(k) {
            Q = !0, k.keyCode !== 38 && k.keyCode !== 40 || A();
          }, F.onkeyup = function() {
            Q = !1;
          }, { dateBox: f, input: F, label: Y };
        }, n.prototype.getPosition = function() {
          var o = this.chart, A = o.options.rangeSelector;
          return o = A.verticalAlign === "top" ? o.plotTop - o.axisOffset[0] : 0, { buttonTop: o + A.buttonPosition.y, inputTop: o + A.inputPosition.y - 10 };
        }, n.prototype.getYTDExtremes = function(o, A, _) {
          var D = this.chart.time, j = new D.Date(o), T = D.get("FullYear", j);
          return _ = _ ? D.Date.UTC(T, 0, 1) : +new D.Date(T, 0, 1), A = Math.max(A, _), j = j.getTime(), { max: Math.min(o || j, j), min: A };
        }, n.prototype.render = function(o, A) {
          var _ = this.chart, D = _.renderer, j = _.container, T = _.options, X = T.rangeSelector, f = c(T.chart.style && T.chart.style.zIndex, 0) + 1;
          if (T = X.inputEnabled, X.enabled !== !1) {
            if (this.rendered || (this.group = D.g("range-selector-group").attr({ zIndex: 7 }).add(), this.div = M("div", void 0, { position: "relative", height: 0, zIndex: f }), this.buttonOptions.length && this.renderButtons(), j.parentNode && j.parentNode.insertBefore(this.div, j), T && (this.inputGroup = D.g("input-group").add(this.group), D = this.drawInput("min"), this.minDateBox = D.dateBox, this.minLabel = D.label, this.minInput = D.input, D = this.drawInput("max"), this.maxDateBox = D.dateBox, this.maxLabel = D.label, this.maxInput = D.input)), T && (this.setInputValue(
              "min",
              o
            ), this.setInputValue("max", A), o = _.scroller && _.scroller.getUnionExtremes() || _.xAxis[0] || {}, u(o.dataMin) && u(o.dataMax) && (_ = _.xAxis[0].minRange || 0, this.setInputExtremes("min", o.dataMin, Math.min(o.dataMax, this.getInputValue("max")) - _), this.setInputExtremes("max", Math.max(o.dataMin, this.getInputValue("min")) + _, o.dataMax)), this.inputGroup)) {
              var m = 0;
              [this.minLabel, this.minDateBox, this.maxLabel, this.maxDateBox].forEach(function(L) {
                if (L) {
                  var Y = L.getBBox().width;
                  Y && (L.attr({ x: m }), m += Y + X.inputSpacing);
                }
              });
            }
            this.alignElements(), this.rendered = !0;
          }
        }, n.prototype.renderButtons = function() {
          var o = this, A = this.buttons, _ = this.options, D = W.lang, j = this.chart.renderer, T = w(_.buttonTheme), X = T && T.states, f = T.width || 28;
          delete T.width, delete T.states, this.buttonGroup = j.g("range-selector-buttons").add(this.group);
          var m = this.dropdown = M("select", void 0, { position: "absolute", width: "1px", height: "1px", padding: 0, border: 0, top: "-9999em", cursor: "pointer", opacity: 1e-4 }, this.div);
          N(m, "touchstart", function() {
            m.style.fontSize = "16px";
          }), [[I.isMS ? "mouseover" : "mouseenter"], [I.isMS ? "mouseout" : "mouseleave"], ["change", "click"]].forEach(function(L) {
            var Y = L[0], F = L[1];
            N(m, Y, function() {
              var Q = A[o.currentButtonIndex()];
              Q && C(Q.element, F || Y);
            });
          }), this.zoomText = j.label(D && D.rangeSelectorZoom || "", 0).attr({ padding: _.buttonTheme.padding, height: _.buttonTheme.height, paddingLeft: 0, paddingRight: 0 }).add(this.buttonGroup), this.chart.styledMode || (this.zoomText.css(_.labelStyle), T["stroke-width"] = c(T["stroke-width"], 0)), M(
            "option",
            { textContent: this.zoomText.textStr, disabled: !0 },
            void 0,
            m
          ), this.buttonOptions.forEach(function(L, Y) {
            M("option", { textContent: L.title || L.text }, void 0, m), A[Y] = j.button(L.text, 0, 0, function(F) {
              var Q = L.events && L.events.click, k;
              Q && (k = Q.call(L, F)), k !== !1 && o.clickButton(Y), o.isActive = !0;
            }, T, X && X.hover, X && X.select, X && X.disabled).attr({ "text-align": "center", width: f }).add(o.buttonGroup), L.title && A[Y].attr("title", L.title);
          });
        }, n.prototype.alignElements = function() {
          var o = this, A = this.buttonGroup, _ = this.buttons, D = this.chart, j = this.group, T = this.inputGroup, X = this.options, f = this.zoomText, m = D.options, L = m.exporting && m.exporting.enabled !== !1 && m.navigation && m.navigation.buttonOptions;
          m = X.buttonPosition;
          var Y = X.inputPosition, F = X.verticalAlign, Q = function(V, q) {
            return L && o.titleCollision(D) && F === "top" && q.align === "right" && q.y - V.getBBox().height - 12 < (L.y || 0) + (L.height || 0) + D.spacing[0] ? -40 : 0;
          }, k = D.plotLeft;
          if (j && m && Y) {
            var G = m.x - D.spacing[3];
            if (A) {
              if (this.positionButtons(), !this.initialButtonGroupWidth) {
                var z = 0;
                f && (z += f.getBBox().width + 5), _.forEach(function(V, q) {
                  z += V.width, q !== _.length - 1 && (z += X.buttonSpacing);
                }), this.initialButtonGroupWidth = z;
              }
              k -= D.spacing[3], this.updateButtonStates(), f = Q(A, m), this.alignButtonGroup(f), j.placed = A.placed = D.hasLoaded;
            }
            A = 0, T && (A = Q(T, Y), Y.align === "left" ? G = k : Y.align === "right" && (G = -Math.max(D.axisOffset[1], -A)), T.align({ y: Y.y, width: T.getBBox().width, align: Y.align, x: Y.x + G - 2 }, !0, D.spacingBox), T.placed = D.hasLoaded), this.handleCollision(A), j.align({ verticalAlign: F }, !0, D.spacingBox), T = j.alignAttr.translateY, A = j.getBBox().height + 20, Q = 0, F === "bottom" && (Q = (Q = D.legend && D.legend.options) && Q.verticalAlign === "bottom" && Q.enabled && !Q.floating ? D.legend.legendHeight + c(Q.margin, 10) : 0, A = A + Q - 20, Q = T - A - (X.floating ? 0 : X.y) - (D.titleOffset ? D.titleOffset[2] : 0) - 10), F === "top" ? (X.floating && (Q = 0), D.titleOffset && D.titleOffset[0] && (Q = D.titleOffset[0]), Q += D.margin[0] - D.spacing[0] || 0) : F === "middle" && (Y.y === m.y ? Q = T : (Y.y || m.y) && (Q = 0 > Y.y || 0 > m.y ? Q - Math.min(Y.y, m.y) : T - A)), j.translate(X.x, X.y + Math.floor(Q)), m = this.minInput, Y = this.maxInput, T = this.dropdown, X.inputEnabled && m && Y && (m.style.marginTop = j.translateY + "px", Y.style.marginTop = j.translateY + "px"), T && (T.style.marginTop = j.translateY + "px");
          }
        }, n.prototype.alignButtonGroup = function(o, A) {
          var _ = this.chart, D = this.buttonGroup, j = this.options.buttonPosition, T = _.plotLeft - _.spacing[3], X = j.x - _.spacing[3];
          j.align === "right" ? X += o - T : j.align === "center" && (X -= T / 2), D && D.align({ y: j.y, width: c(A, this.initialButtonGroupWidth), align: j.align, x: X }, !0, _.spacingBox);
        }, n.prototype.positionButtons = function() {
          var o = this.buttons, A = this.chart, _ = this.options, D = this.zoomText, j = A.hasLoaded ? "animate" : "attr", T = _.buttonPosition, X = A.plotLeft, f = X;
          D && D.visibility !== "hidden" && (D[j]({ x: c(X + T.x, X) }), f += T.x + D.getBBox().width + 5), this.buttonOptions.forEach(function(m, L) {
            o[L].visibility !== "hidden" ? (o[L][j]({ x: f }), f += o[L].width + _.buttonSpacing) : o[L][j]({ x: X });
          });
        }, n.prototype.handleCollision = function(o) {
          var A = this, _ = this.chart, D = this.buttonGroup, j = this.inputGroup, T = this.options, X = T.buttonPosition, f = T.dropdown, m = T.inputPosition;
          T = function() {
            var F = 0;
            return A.buttons.forEach(function(Q) {
              Q = Q.getBBox(), Q.width > F && (F = Q.width);
            }), F;
          };
          var L = function(F) {
            if (j && D) {
              var Q = j.alignAttr.translateX + j.alignOptions.x - o + j.getBBox().x + 2, k = j.alignOptions.width, G = D.alignAttr.translateX + D.getBBox().x;
              return G + F > Q && Q + k > G && X.y < m.y + j.getBBox().height;
            }
            return !1;
          }, Y = function() {
            j && D && j.attr({ translateX: j.alignAttr.translateX + (_.axisOffset[1] >= -o ? 0 : -o), translateY: j.alignAttr.translateY + D.getBBox().height + 10 });
          };
          if (D) {
            if (f === "always") {
              this.collapseButtons(o), L(T()) && Y();
              return;
            }
            f === "never" && this.expandButtons();
          }
          j && D ? m.align === X.align || L(this.initialButtonGroupWidth + 20) ? f === "responsive" ? (this.collapseButtons(o), L(T()) && Y()) : Y() : f === "responsive" && this.expandButtons() : D && f === "responsive" && (this.initialButtonGroupWidth > _.plotWidth ? this.collapseButtons(o) : this.expandButtons());
        }, n.prototype.collapseButtons = function(o) {
          var A = this.buttons, _ = this.buttonOptions, D = this.chart, j = this.dropdown, T = this.options, X = this.zoomText, f = D.userOptions.rangeSelector && D.userOptions.rangeSelector.buttonTheme || {}, m = function(Y) {
            return { text: Y ? Y + " ▾" : "▾", width: "auto", paddingLeft: c(T.buttonTheme.paddingLeft, f.padding, 8), paddingRight: c(T.buttonTheme.paddingRight, f.padding, 8) };
          };
          X && X.hide();
          var L = !1;
          _.forEach(function(Y, F) {
            F = A[F], F.state !== 2 ? F.hide() : (F.show(), F.attr(m(Y.text)), L = !0);
          }), L || (j && (j.selectedIndex = 0), A[0].show(), A[0].attr(m(this.zoomText && this.zoomText.textStr))), _ = T.buttonPosition.align, this.positionButtons(), _ !== "right" && _ !== "center" || this.alignButtonGroup(o, A[this.currentButtonIndex()].getBBox().width), this.showDropdown();
        }, n.prototype.expandButtons = function() {
          var o = this.buttons, A = this.buttonOptions, _ = this.options, D = this.zoomText;
          this.hideDropdown(), D && D.show(), A.forEach(function(j, T) {
            T = o[T], T.show(), T.attr({ text: j.text, width: _.buttonTheme.width || 28, paddingLeft: c(_.buttonTheme.paddingLeft, "unset"), paddingRight: c(_.buttonTheme.paddingRight, "unset") }), 2 > T.state && T.setState(0);
          }), this.positionButtons();
        }, n.prototype.currentButtonIndex = function() {
          var o = this.dropdown;
          return o && 0 < o.selectedIndex ? o.selectedIndex - 1 : 0;
        }, n.prototype.showDropdown = function() {
          var o = this.buttonGroup, A = this.buttons, _ = this.chart, D = this.dropdown;
          if (o && D) {
            var j = o.translateX;
            o = o.translateY, A = A[this.currentButtonIndex()].getBBox(), v(D, { left: _.plotLeft + j + "px", top: o + 0.5 + "px", width: A.width + "px", height: A.height + "px" }), this.hasVisibleDropdown = !0;
          }
        }, n.prototype.hideDropdown = function() {
          var o = this.dropdown;
          o && (v(o, { top: "-9999em", width: "1px", height: "1px" }), this.hasVisibleDropdown = !1);
        }, n.prototype.getHeight = function() {
          var o = this.options, A = this.group, _ = o.y, D = o.buttonPosition.y, j = o.inputPosition.y;
          return o.height ? o.height : (this.alignElements(), o = A ? A.getBBox(!0).height + 13 + _ : 0, A = Math.min(j, D), (0 > j && 0 > D || 0 < j && 0 < D) && (o += Math.abs(A)), o);
        }, n.prototype.titleCollision = function(o) {
          return !(o.options.title.text || o.options.subtitle.text);
        }, n.prototype.update = function(o) {
          var A = this.chart;
          w(!0, A.options.rangeSelector, o), this.destroy(), this.init(A), this.render();
        }, n.prototype.destroy = function() {
          var o = this, A = o.minInput, _ = o.maxInput;
          o.eventsToUnbind && (o.eventsToUnbind.forEach(function(D) {
            return D();
          }), o.eventsToUnbind = void 0), d(o.buttons), A && (A.onfocus = A.onblur = A.onchange = null), _ && (_.onfocus = _.onblur = _.onchange = null), x(o, function(D, j) {
            D && j !== "chart" && (D instanceof H ? D.destroy() : D instanceof window.HTMLElement && P(D)), D !== n.prototype[j] && (o[j] = null);
          }, this);
        }, n;
      }();
      if (l.prototype.defaultButtons = [
        { type: "month", count: 1, text: "1m", title: "View 1 month" },
        { type: "month", count: 3, text: "3m", title: "View 3 months" },
        { type: "month", count: 6, text: "6m", title: "View 6 months" },
        { type: "ytd", text: "YTD", title: "View year to date" },
        { type: "year", count: 1, text: "1y", title: "View 1 year" },
        { type: "all", text: "All", title: "View all" }
      ], l.prototype.inputTypeFormats = { "datetime-local": "%Y-%m-%dT%H:%M:%S", date: "%Y-%m-%d", time: "%H:%M:%S" }, y.prototype.minFromRange = function() {
        var n = this.range, o = n.type, A = this.max, _ = this.chart.time, D = function(f, m) {
          var L = o === "year" ? "FullYear" : "Month", Y = new _.Date(f), F = _.get(L, Y);
          return _.set(L, Y, F + m), F === _.get(L, Y) && _.set("Date", Y, 0), Y.getTime() - f;
        };
        if (b(n))
          var j = A - n, T = n;
        else
          j = A + D(A, -n.count), this.chart && (this.chart.fixedRange = A - j);
        var X = c(this.dataMin, Number.MIN_VALUE);
        return b(j) || (j = X), j <= X && (j = X, typeof T > "u" && (T = D(j, n.count)), this.newMax = Math.min(j + T, this.dataMax)), b(A) || (j = void 0), j;
      }, !I.RangeSelector) {
        var s = [], t = function(n) {
          function o() {
            _ && (A = n.xAxis[0].getExtremes(), D = n.legend, T = _ && _.options.verticalAlign, b(A.min) && _.render(A.min, A.max), D.display && T === "top" && T === D.options.verticalAlign && (j = w(n.spacingBox), j.y = D.options.layout === "vertical" ? n.plotTop : j.y + _.getHeight(), D.group.placed = !1, D.align(j)));
          }
          var A, _ = n.rangeSelector, D, j, T;
          _ && (B(s, function(X) {
            return X[0] === n;
          }) || s.push([n, [N(n.xAxis[0], "afterSetExtremes", function(X) {
            _ && _.render(X.min, X.max);
          }), N(n, "redraw", o)]]), o());
        };
        N(R, "afterGetContainer", function() {
          this.options.rangeSelector && this.options.rangeSelector.enabled && (this.rangeSelector = new l(this));
        }), N(R, "beforeRender", function() {
          var n = this.axes, o = this.rangeSelector;
          o && (b(o.deferredYTDClick) && (o.clickButton(o.deferredYTDClick), delete o.deferredYTDClick), n.forEach(function(A) {
            A.updateNames(), A.setScale();
          }), this.getAxisMargins(), o.render(), n = o.options.verticalAlign, o.options.floating || (n === "bottom" ? this.extraBottomMargin = !0 : n !== "middle" && (this.extraTopMargin = !0)));
        }), N(R, "update", function(n) {
          var o = n.options.rangeSelector;
          n = this.rangeSelector;
          var A = this.extraBottomMargin, _ = this.extraTopMargin;
          o && o.enabled && !u(n) && this.options.rangeSelector && (this.options.rangeSelector.enabled = !0, this.rangeSelector = n = new l(this)), this.extraTopMargin = this.extraBottomMargin = !1, n && (t(this), o = o && o.verticalAlign || n.options && n.options.verticalAlign, n.options.floating || (o === "bottom" ? this.extraBottomMargin = !0 : o !== "middle" && (this.extraTopMargin = !0)), this.extraBottomMargin !== A || this.extraTopMargin !== _) && (this.isDirtyBox = !0);
        }), N(R, "render", function() {
          var n = this.rangeSelector;
          n && !n.options.floating && (n.render(), n = n.options.verticalAlign, n === "bottom" ? this.extraBottomMargin = !0 : n !== "middle" && (this.extraTopMargin = !0));
        }), N(R, "getMargins", function() {
          var n = this.rangeSelector;
          n && (n = n.getHeight(), this.extraTopMargin && (this.plotTop += n), this.extraBottomMargin && (this.marginBottom += n));
        }), R.prototype.callbacks.push(t), N(R, "destroy", function() {
          for (var n = 0; n < s.length; n++) {
            var o = s[n];
            if (o[0] === this) {
              o[1].forEach(function(A) {
                return A();
              }), s.splice(n, 1);
              break;
            }
          }
        }), I.RangeSelector = l;
      }
      return l;
    }), E(
      a,
      "Core/Chart/StockChart.js",
      [a["Core/Animation/AnimationUtilities.js"], a["Core/Axis/Axis.js"], a["Core/Chart/Chart.js"], a["Core/FormatUtilities.js"], a["Core/DefaultOptions.js"], a["Core/Series/Series.js"], a["Core/Renderer/SVG/SVGRenderer.js"], a["Core/Utilities.js"]],
      function(y, R, I, Z, H, $, U, W) {
        function N(p, i) {
          return p === "xAxis" ? { minPadding: 0, maxPadding: 0, overscroll: 0, ordinal: !0, title: { text: null }, labels: { overflow: "justify" }, showLastLabel: !0 } : p === "yAxis" ? { labels: { y: -2 }, opposite: h(i.opposite, !0), showLastLabel: !(!i.categories && i.type !== "category"), title: { text: null } } : {};
        }
        function M(p, i) {
          if (p === "xAxis") {
            p = d();
            var l = { type: "datetime", categories: void 0 };
            return h(i.navigator && i.navigator.enabled, p.navigator.enabled, !0) && (l.startOnTick = !1, l.endOnTick = !1), l;
          }
          return {};
        }
        var v = this && this.__extends || function() {
          var p = function(i, l) {
            return p = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(s, t) {
              s.__proto__ = t;
            } || function(s, t) {
              for (var n in t)
                t.hasOwnProperty(n) && (s[n] = t[n]);
            }, p(i, l);
          };
          return function(i, l) {
            function s() {
              this.constructor = i;
            }
            p(i, l), i.prototype = l === null ? Object.create(l) : (s.prototype = l.prototype, new s());
          };
        }(), u = Z.format, d = H.getOptions;
        y = W.addEvent;
        var P = W.clamp, O = W.defined, B = W.extend, C = W.find, b = W.isNumber, w = W.isString, x = W.merge, h = W.pick, c = W.splat;
        return W = function(p) {
          function i() {
            return p !== null && p.apply(this, arguments) || this;
          }
          return v(i, p), i.prototype.init = function(l, s) {
            var t = d(), n = l.xAxis, o = l.yAxis, A = h(l.navigator && l.navigator.enabled, t.navigator.enabled, !0);
            l.xAxis = l.yAxis = void 0, A = x({ chart: { panning: { enabled: !0, type: "x" }, pinchType: "x" }, navigator: { enabled: A }, scrollbar: { enabled: h(t.scrollbar && t.scrollbar.enabled, !0) }, rangeSelector: { enabled: h(t.rangeSelector.enabled, !0) }, title: { text: null }, tooltip: { split: h(t.tooltip.split, !0), crosshairs: !0 }, legend: { enabled: !1 } }, l, { isStock: !0 }), l.xAxis = n, l.yAxis = o, A.xAxis = c(l.xAxis || {}).map(function(_, D) {
              return x(N("xAxis", _), t.xAxis, t.xAxis && t.xAxis[D], _, M("xAxis", l));
            }), A.yAxis = c(l.yAxis || {}).map(function(_, D) {
              return x(N("yAxis", _), t.yAxis, t.yAxis && t.yAxis[D], _);
            }), p.prototype.init.call(this, A, s);
          }, i.prototype.createAxis = function(l, s) {
            return s.axis = x(N(l, s.axis), s.axis, M(l, this.userOptions)), p.prototype.createAxis.call(this, l, s);
          }, i;
        }(I), function(p) {
          p.stockChart = function(i, l, s) {
            return new p(i, l, s);
          };
        }(W || (W = {})), y($, "setOptions", function(p) {
          var i;
          this.chart.options.isStock && (this.is("column") || this.is("columnrange") ? i = { borderWidth: 0, shadow: !1 } : this.is("scatter") || this.is("sma") || (i = { marker: { enabled: !1, radius: 2 } }), i && (p.plotOptions[this.type] = x(p.plotOptions[this.type], i)));
        }), y(R, "autoLabelAlign", function(p) {
          var i = this.chart, l = this.options;
          i = i._labelPanes = i._labelPanes || {};
          var s = this.options.labels;
          this.chart.options.isStock && this.coll === "yAxis" && (l = l.top + "," + l.height, !i[l] && s.enabled && (s.x === 15 && (s.x = 0), typeof s.align > "u" && (s.align = "right"), i[l] = this, p.align = "right", p.preventDefault()));
        }), y(R, "destroy", function() {
          var p = this.chart, i = this.options && this.options.top + "," + this.options.height;
          i && p._labelPanes && p._labelPanes[i] === this && delete p._labelPanes[i];
        }), y(R, "getPlotLinePath", function(p) {
          function i(G) {
            var z = G === "xAxis" ? "yAxis" : "xAxis";
            return G = l.options[z], b(G) ? [t[z][G]] : w(G) ? [t.get(G)] : s.map(function(V) {
              return V[z];
            });
          }
          var l = this, s = this.isLinked && !this.series ? this.linkedParent.series : this.series, t = l.chart, n = t.renderer, o = l.left, A = l.top, _, D, j, T, X = [], f = [], m = p.translatedValue, L = p.value, Y = p.force;
          if (t.options.isStock && p.acrossPanes !== !1 && l.coll === "xAxis" || l.coll === "yAxis") {
            p.preventDefault(), f = i(l.coll);
            var F = l.isXAxis ? t.yAxis : t.xAxis;
            F.forEach(function(G) {
              if (!O(G.options.id) || G.options.id.indexOf("navigator") === -1) {
                var z = G.isXAxis ? "yAxis" : "xAxis";
                z = O(G.options[z]) ? t[z][G.options[z]] : t[z][0], l === z && f.push(G);
              }
            });
            var Q = f.length ? [] : [l.isXAxis ? t.yAxis[0] : t.xAxis[0]];
            f.forEach(function(G) {
              Q.indexOf(G) !== -1 || C(Q, function(z) {
                return z.pos === G.pos && z.len === G.len;
              }) || Q.push(G);
            });
            var k = h(m, l.translate(L, null, null, p.old));
            b(k) && (l.horiz ? Q.forEach(function(G) {
              var z;
              D = G.pos, T = D + G.len, _ = j = Math.round(k + l.transB), Y !== "pass" && (_ < o || _ > o + l.width) && (Y ? _ = j = P(_, o, o + l.width) : z = !0), z || X.push(["M", _, D], ["L", j, T]);
            }) : Q.forEach(function(G) {
              var z;
              _ = G.pos, j = _ + G.len, D = T = Math.round(A + l.height - k), Y !== "pass" && (D < A || D > A + l.height) && (Y ? D = T = P(D, A, A + l.height) : z = !0), z || X.push(["M", _, D], ["L", j, T]);
            })), p.path = 0 < X.length ? n.crispPolyLine(X, p.lineWidth || 1) : null;
          }
        }), U.prototype.crispPolyLine = function(p, i) {
          for (var l = 0; l < p.length; l += 2) {
            var s = p[l], t = p[l + 1];
            s[1] === t[1] && (s[1] = t[1] = Math.round(s[1]) - i % 2 / 2), s[2] === t[2] && (s[2] = t[2] = Math.round(s[2]) + i % 2 / 2);
          }
          return p;
        }, y(R, "afterHideCrosshair", function() {
          this.crossLabel && (this.crossLabel = this.crossLabel.hide());
        }), y(R, "afterDrawCrosshair", function(p) {
          var i, l;
          if (this.crosshair && this.crosshair.label && this.crosshair.label.enabled && this.cross && b(this.min) && b(this.max)) {
            var s = this.chart, t = this.logarithmic, n = this.crosshair.label, o = this.horiz, A = this.opposite, _ = this.left, D = this.top, j = this.crossLabel, T = n.format, X = "", f = this.options.tickPosition === "inside", m = this.crosshair.snap !== !1, L = 0, Y = p.e || this.cross && this.cross.e;
            p = p.point;
            var F = this.min, Q = this.max;
            t && (F = t.lin2log(F), Q = t.lin2log(Q)), t = o ? "center" : A ? this.labelAlign === "right" ? "right" : "left" : this.labelAlign === "left" ? "left" : "center", j || (j = this.crossLabel = s.renderer.label("", 0, void 0, n.shape || "callout").addClass("highcharts-crosshair-label highcharts-color-" + (p ? p.series.colorIndex : this.series[0] && this.series[0].colorIndex)).attr({ align: n.align || t, padding: h(n.padding, 8), r: h(n.borderRadius, 3), zIndex: 2 }).add(this.labelGroup), s.styledMode || j.attr({ fill: n.backgroundColor || p && p.series && p.series.color || "#666666", stroke: n.borderColor || "", "stroke-width": n.borderWidth || 0 }).css(B({ color: "#ffffff", fontWeight: "normal", fontSize: "11px", textAlign: "center" }, n.style || {}))), o ? (t = m ? (p.plotX || 0) + _ : Y.chartX, D += A ? 0 : this.height) : (t = A ? this.width + _ : 0, D = m ? (p.plotY || 0) + D : Y.chartY), T || n.formatter || (this.dateTime && (X = "%b %d, %Y"), T = "{value" + (X ? ":" + X : "") + "}"), X = m ? this.isXAxis ? p.x : p.y : this.toValue(o ? Y.chartX : Y.chartY), m = p ? p.series.isPointInside(p) : b(X) && X > F && X < Q, Y = "", T ? Y = u(T, { value: X }, s) : n.formatter && b(X) && (Y = n.formatter.call(this, X)), j.attr({ text: Y, x: t, y: D, visibility: m ? "visible" : "hidden" }), n = j.getBBox(), b(j.y) && (o ? (f && !A || !f && A) && (D = j.y - n.height) : D = j.y - n.height / 2), o ? (i = _ - n.x, l = _ + this.width - n.x) : (i = this.labelAlign === "left" ? _ : 0, l = this.labelAlign === "right" ? _ + this.width : s.chartWidth), j.translateX < i && (L = i - j.translateX), j.translateX + n.width >= l && (L = -(j.translateX + n.width - l)), j.attr({ x: t + L, y: D, anchorX: o ? t : this.opposite ? 0 : s.chartWidth, anchorY: o ? this.opposite ? s.chartHeight : 0 : D + n.height / 2 });
          }
        }), $.prototype.forceCropping = function() {
          var p = this.chart, i = this.options.dataGrouping;
          return this.allowDG !== !1 && i && h(i.enabled, p.options.isStock);
        }, y(I, "update", function(p) {
          p = p.options, "scrollbar" in p && this.navigator && (x(!0, this.options.scrollbar, p.scrollbar), this.navigator.update({}, !1), delete p.scrollbar);
        }), W;
      }
    ), E(a, "masters/modules/stock.src.js", [
      a["Core/Globals.js"],
      a["Core/Axis/OrdinalAxis.js"],
      a["Series/DataModifyComposition.js"],
      a["Core/Scrollbar.js"],
      a["Core/Chart/StockChart.js"]
    ], function(y, R, I, Z, H) {
      y.Scrollbar = Z, y.StockChart = y.stockChart = H.stockChart, Z.compose(y.Axis), R.compose(y.Axis, y.Series, y.Chart), I.compose(y.Series, y.Axis, y.Point);
    }), E(a, "masters/highstock.src.js", [a["masters/highcharts.src.js"]], function(y) {
      return y.product = "Highstock", y;
    }), a["masters/highstock.src.js"]._modules = a, a["masters/highstock.src.js"];
  });
})(zp);
var P0 = zp.exports;
const Sn = /* @__PURE__ */ Cn(P0);
var Yp = { exports: {} };
(function(r) {
  (function(g, E) {
    r.exports ? (E.default = E, r.exports = g.document ? E(g) : E) : (g.Highcharts && g.Highcharts.error(16, !0), g.Highcharts = E(g));
  })(typeof window < "u" ? window : Hr, function(g) {
    function E(y, R, I, Z) {
      y.hasOwnProperty(R) || (y[R] = Z.apply(null, I));
    }
    var a = {};
    return E(a, "Core/Globals.js", [], function() {
      var y = typeof g < "u" ? g : typeof window < "u" ? window : {}, R;
      return function(I) {
        I.SVG_NS = "http://www.w3.org/2000/svg", I.product = "Highcharts", I.version = "9.3.3", I.win = y, I.doc = I.win.document, I.svg = I.doc && I.doc.createElementNS && !!I.doc.createElementNS(I.SVG_NS, "svg").createSVGRect, I.userAgent = I.win.navigator && I.win.navigator.userAgent || "", I.isChrome = I.userAgent.indexOf("Chrome") !== -1, I.isFirefox = I.userAgent.indexOf("Firefox") !== -1, I.isMS = /(edge|msie|trident)/i.test(I.userAgent) && !I.win.opera, I.isSafari = !I.isChrome && I.userAgent.indexOf("Safari") !== -1, I.isTouchDevice = /(Mobile|Android|Windows Phone)/.test(I.userAgent), I.isWebKit = I.userAgent.indexOf("AppleWebKit") !== -1, I.deg2rad = 2 * Math.PI / 360, I.hasBidiBug = I.isFirefox && 4 > parseInt(I.userAgent.split("Firefox/")[1], 10), I.hasTouch = !!I.win.TouchEvent, I.marginNames = ["plotTop", "marginRight", "marginBottom", "plotLeft"], I.noop = function() {
        }, I.supportsPassiveEvents = function() {
          var Z = !1;
          if (!I.isMS) {
            var H = Object.defineProperty({}, "passive", { get: function() {
              Z = !0;
            } });
            I.win.addEventListener && I.win.removeEventListener && (I.win.addEventListener(
              "testPassive",
              I.noop,
              H
            ), I.win.removeEventListener("testPassive", I.noop, H));
          }
          return Z;
        }(), I.charts = [], I.dateFormats = {}, I.seriesTypes = {}, I.symbolSizes = {}, I.chartCount = 0;
      }(R || (R = {})), R;
    }), E(a, "Core/Utilities.js", [a["Core/Globals.js"]], function(y) {
      function R(t, n, o, A) {
        var _ = n ? "Highcharts error" : "Highcharts warning";
        t === 32 && (t = _ + ": Deprecated member");
        var D = M(t), j = D ? _ + " #" + t + ": www.highcharts.com/errors/" + t + "/" : t.toString();
        if (typeof A < "u") {
          var T = "";
          D && (j += "?"), b(A, function(X, f) {
            T += `
 - ` + f + ": " + X, D && (j += encodeURI(f) + "=" + encodeURI(X));
          }), j += T;
        }
        x(y, "displayError", { chart: o, code: t, message: j, params: A }, function() {
          if (n)
            throw Error(j);
          p.console && R.messages.indexOf(j) === -1 && console.warn(j);
        }), R.messages.push(j);
      }
      function I(t, n) {
        var o = {};
        return b(t, function(A, _) {
          U(t[_], !0) && !t.nodeType && n[_] ? (A = I(t[_], n[_]), Object.keys(A).length && (o[_] = A)) : (U(t[_]) || t[_] !== n[_]) && (o[_] = t[_]);
        }), o;
      }
      function Z(t, n) {
        return parseInt(t, n || 10);
      }
      function H(t) {
        return typeof t == "string";
      }
      function $(t) {
        return t = Object.prototype.toString.call(t), t === "[object Array]" || t === "[object Array Iterator]";
      }
      function U(t, n) {
        return !!t && typeof t == "object" && (!n || !$(t));
      }
      function W(t) {
        return U(t) && typeof t.nodeType == "number";
      }
      function N(t) {
        var n = t && t.constructor;
        return !(!U(t, !0) || W(t) || !n || !n.name || n.name === "Object");
      }
      function M(t) {
        return typeof t == "number" && !isNaN(t) && 1 / 0 > t && -1 / 0 < t;
      }
      function v(t) {
        return typeof t < "u" && t !== null;
      }
      function u(t, n, o) {
        var A;
        return H(n) ? v(o) ? t.setAttribute(n, o) : t && t.getAttribute && ((A = t.getAttribute(n)) || n !== "class" || (A = t.getAttribute(n + "Name"))) : b(n, function(_, D) {
          v(_) ? t.setAttribute(D, _) : t.removeAttribute(D);
        }), A;
      }
      function d(t, n) {
        var o;
        t || (t = {});
        for (o in n)
          t[o] = n[o];
        return t;
      }
      function P() {
        for (var t = arguments, n = t.length, o = 0; o < n; o++) {
          var A = t[o];
          if (typeof A < "u" && A !== null)
            return A;
        }
      }
      function O(t, n) {
        y.isMS && !y.svg && n && typeof n.opacity < "u" && (n.filter = "alpha(opacity=" + 100 * n.opacity + ")"), d(t.style, n);
      }
      function B(t, n) {
        return 1e14 < t ? t : parseFloat(t.toPrecision(n || 14));
      }
      function C(t, n, o) {
        var A = y.getStyle || C;
        if (n === "width")
          return n = Math.min(t.offsetWidth, t.scrollWidth), o = t.getBoundingClientRect && t.getBoundingClientRect().width, o < n && o >= n - 1 && (n = Math.floor(o)), Math.max(0, n - (A(t, "padding-left", !0) || 0) - (A(t, "padding-right", !0) || 0));
        if (n === "height")
          return Math.max(0, Math.min(t.offsetHeight, t.scrollHeight) - (A(t, "padding-top", !0) || 0) - (A(t, "padding-bottom", !0) || 0));
        if (p.getComputedStyle || R(27, !0), t = p.getComputedStyle(t, void 0)) {
          var _ = t.getPropertyValue(n);
          P(o, n !== "opacity") && (_ = Z(_));
        }
        return _;
      }
      function b(t, n, o) {
        for (var A in t)
          Object.hasOwnProperty.call(t, A) && n.call(o || t[A], t[A], A, t);
      }
      function w(t, n, o) {
        function A(T, X) {
          var f = t.removeEventListener || y.removeEventListenerPolyfill;
          f && f.call(t, T, X, !1);
        }
        function _(T) {
          var X;
          if (t.nodeName) {
            if (n) {
              var f = {};
              f[n] = !0;
            } else
              f = T;
            b(f, function(m, L) {
              if (T[L])
                for (X = T[L].length; X--; )
                  A(L, T[L][X].fn);
            });
          }
        }
        var D = typeof t == "function" && t.prototype || t;
        if (Object.hasOwnProperty.call(D, "hcEvents")) {
          var j = D.hcEvents;
          n ? (D = j[n] || [], o ? (j[n] = D.filter(function(T) {
            return o !== T.fn;
          }), A(n, o)) : (_(j), j[n] = [])) : (_(j), delete D.hcEvents);
        }
      }
      function x(t, n, o, A) {
        if (o = o || {}, c.createEvent && (t.dispatchEvent || t.fireEvent && t !== y)) {
          var _ = c.createEvent("Events");
          _.initEvent(n, !0, !0), o = d(_, o), t.dispatchEvent ? t.dispatchEvent(o) : t.fireEvent(n, o);
        } else if (t.hcEvents) {
          o.target || d(o, { preventDefault: function() {
            o.defaultPrevented = !0;
          }, target: t, type: n }), _ = [];
          for (var D = t, j = !1; D.hcEvents; )
            Object.hasOwnProperty.call(D, "hcEvents") && D.hcEvents[n] && (_.length && (j = !0), _.unshift.apply(_, D.hcEvents[n])), D = Object.getPrototypeOf(D);
          j && _.sort(function(T, X) {
            return T.order - X.order;
          }), _.forEach(function(T) {
            T.fn.call(t, o) === !1 && o.preventDefault();
          });
        }
        A && !o.defaultPrevented && A.call(t, o);
      }
      var h = y.charts, c = y.doc, p = y.win;
      (R || (R = {})).messages = [], Math.easeInOutSine = function(t) {
        return -0.5 * (Math.cos(Math.PI * t) - 1);
      };
      var i = Array.prototype.find ? function(t, n) {
        return t.find(n);
      } : function(t, n) {
        var o, A = t.length;
        for (o = 0; o < A; o++)
          if (n(t[o], o))
            return t[o];
      };
      b({ map: "map", each: "forEach", grep: "filter", reduce: "reduce", some: "some" }, function(t, n) {
        y[n] = function(o) {
          var A;
          return R(32, !1, void 0, (A = {}, A["Highcharts." + n] = "use Array." + t, A)), Array.prototype[t].apply(o, [].slice.call(arguments, 1));
        };
      });
      var l, s = function() {
        var t = Math.random().toString(36).substring(2, 9) + "-", n = 0;
        return function() {
          return "highcharts-" + (l ? "" : t) + n++;
        };
      }();
      return p.jQuery && (p.jQuery.fn.highcharts = function() {
        var t = [].slice.call(arguments);
        if (this[0])
          return t[0] ? (new y[H(t[0]) ? t.shift() : "Chart"](this[0], t[0], t[1]), this) : h[u(this[0], "data-highcharts-chart")];
      }), i = { addEvent: function(t, n, o, A) {
        A === void 0 && (A = {});
        var _ = typeof t == "function" && t.prototype || t;
        Object.hasOwnProperty.call(_, "hcEvents") || (_.hcEvents = {}), _ = _.hcEvents, y.Point && t instanceof y.Point && t.series && t.series.chart && (t.series.chart.runTrackerClick = !0);
        var D = t.addEventListener || y.addEventListenerPolyfill;
        return D && D.call(t, n, o, y.supportsPassiveEvents ? { passive: A.passive === void 0 ? n.indexOf("touch") !== -1 : A.passive, capture: !1 } : !1), _[n] || (_[n] = []), _[n].push({ fn: o, order: typeof A.order == "number" ? A.order : 1 / 0 }), _[n].sort(function(j, T) {
          return j.order - T.order;
        }), function() {
          w(t, n, o);
        };
      }, arrayMax: function(t) {
        for (var n = t.length, o = t[0]; n--; )
          t[n] > o && (o = t[n]);
        return o;
      }, arrayMin: function(t) {
        for (var n = t.length, o = t[0]; n--; )
          t[n] < o && (o = t[n]);
        return o;
      }, attr: u, clamp: function(t, n, o) {
        return t > n ? t < o ? t : o : n;
      }, cleanRecursively: I, clearTimeout: function(t) {
        v(t) && clearTimeout(t);
      }, correctFloat: B, createElement: function(t, n, o, A, _) {
        return t = c.createElement(t), n && d(t, n), _ && O(t, { padding: "0", border: "none", margin: "0" }), o && O(t, o), A && A.appendChild(t), t;
      }, css: O, defined: v, destroyObjectProperties: function(t, n) {
        b(t, function(o, A) {
          o && o !== n && o.destroy && o.destroy(), delete t[A];
        });
      }, discardElement: function(t) {
        t && t.parentElement && t.parentElement.removeChild(t);
      }, erase: function(t, n) {
        for (var o = t.length; o--; )
          if (t[o] === n) {
            t.splice(o, 1);
            break;
          }
      }, error: R, extend: d, extendClass: function(t, n) {
        var o = function() {
        };
        return o.prototype = new t(), d(o.prototype, n), o;
      }, find: i, fireEvent: x, getMagnitude: function(t) {
        return Math.pow(10, Math.floor(Math.log(t) / Math.LN10));
      }, getNestedProperty: function(t, n) {
        for (t = t.split("."); t.length && v(n); ) {
          var o = t.shift();
          if (typeof o > "u" || o === "__proto__" || (n = n[o], !v(n) || typeof n == "function" || typeof n.nodeType == "number" || n === p))
            return;
        }
        return n;
      }, getStyle: C, inArray: function(t, n, o) {
        return R(32, !1, void 0, { "Highcharts.inArray": "use Array.indexOf" }), n.indexOf(t, o);
      }, isArray: $, isClass: N, isDOMElement: W, isFunction: function(t) {
        return typeof t == "function";
      }, isNumber: M, isObject: U, isString: H, keys: function(t) {
        return R(32, !1, void 0, { "Highcharts.keys": "use Object.keys" }), Object.keys(t);
      }, merge: function() {
        var t, n = arguments, o = {}, A = function(D, j) {
          return typeof D != "object" && (D = {}), b(j, function(T, X) {
            X !== "__proto__" && X !== "constructor" && (!U(T, !0) || N(T) || W(T) ? D[X] = j[X] : D[X] = A(D[X] || {}, T));
          }), D;
        };
        n[0] === !0 && (o = n[1], n = Array.prototype.slice.call(n, 2));
        var _ = n.length;
        for (t = 0; t < _; t++)
          o = A(o, n[t]);
        return o;
      }, normalizeTickInterval: function(t, n, o, A, _) {
        var D = t;
        o = P(o, 1);
        var j = t / o;
        for (n || (n = _ ? [1, 1.2, 1.5, 2, 2.5, 3, 4, 5, 6, 8, 10] : [1, 2, 2.5, 5, 10], A === !1 && (o === 1 ? n = n.filter(function(T) {
          return T % 1 === 0;
        }) : 0.1 >= o && (n = [1 / o]))), A = 0; A < n.length && (D = n[A], !(_ && D * o >= t || !_ && j <= (n[A] + (n[A + 1] || n[A])) / 2)); A++)
          ;
        return D = B(D * o, -Math.round(Math.log(1e-3) / Math.LN10));
      }, objectEach: b, offset: function(t) {
        var n = c.documentElement;
        return t = t.parentElement || t.parentNode ? t.getBoundingClientRect() : { top: 0, left: 0, width: 0, height: 0 }, { top: t.top + (p.pageYOffset || n.scrollTop) - (n.clientTop || 0), left: t.left + (p.pageXOffset || n.scrollLeft) - (n.clientLeft || 0), width: t.width, height: t.height };
      }, pad: function(t, n, o) {
        return Array((n || 2) + 1 - String(t).replace("-", "").length).join(o || "0") + t;
      }, pick: P, pInt: Z, relativeLength: function(t, n, o) {
        return /%$/.test(t) ? n * parseFloat(t) / 100 + (o || 0) : parseFloat(t);
      }, removeEvent: w, splat: function(t) {
        return $(t) ? t : [t];
      }, stableSort: function(t, n) {
        var o = t.length, A, _;
        for (_ = 0; _ < o; _++)
          t[_].safeI = _;
        for (t.sort(function(D, j) {
          return A = n(D, j), A === 0 ? D.safeI - j.safeI : A;
        }), _ = 0; _ < o; _++)
          delete t[_].safeI;
      }, syncTimeout: function(t, n, o) {
        return 0 < n ? setTimeout(t, n, o) : (t.call(0, o), -1);
      }, timeUnits: {
        millisecond: 1,
        second: 1e3,
        minute: 6e4,
        hour: 36e5,
        day: 864e5,
        week: 6048e5,
        month: 24192e5,
        year: 314496e5
      }, uniqueKey: s, useSerialIds: function(t) {
        return l = P(t, l);
      }, wrap: function(t, n, o) {
        var A = t[n];
        t[n] = function() {
          var _ = Array.prototype.slice.call(arguments), D = arguments, j = this;
          return j.proceed = function() {
            A.apply(j, arguments.length ? arguments : D);
          }, _.unshift(A), _ = o.apply(this, _), j.proceed = null, _;
        };
      } }, i;
    }), E(a, "Core/Chart/ChartDefaults.js", [], function() {
      return { panning: { enabled: !1, type: "x" }, styledMode: !1, borderRadius: 0, colorCount: 10, defaultSeriesType: "line", ignoreHiddenSeries: !0, spacing: [
        10,
        10,
        15,
        10
      ], resetZoomButton: { theme: { zIndex: 6 }, position: { align: "right", x: -10, y: 10 } }, zoomBySingleTouch: !1, width: null, height: null, borderColor: "#335cad", backgroundColor: "#ffffff", plotBorderColor: "#cccccc" };
    }), E(a, "Core/Color/Color.js", [a["Core/Globals.js"], a["Core/Utilities.js"]], function(y, R) {
      var I = R.isNumber, Z = R.merge, H = R.pInt;
      return R = function() {
        function $(U) {
          this.rgba = [NaN, NaN, NaN, NaN], this.input = U;
          var W = y.Color;
          if (W && W !== $)
            return new W(U);
          if (!(this instanceof $))
            return new $(U);
          this.init(U);
        }
        return $.parse = function(U) {
          return U ? new $(U) : $.None;
        }, $.prototype.init = function(U) {
          var W;
          if (typeof U == "object" && typeof U.stops < "u")
            this.stops = U.stops.map(function(u) {
              return new $(u[1]);
            });
          else if (typeof U == "string") {
            if (this.input = U = $.names[U.toLowerCase()] || U, U.charAt(0) === "#") {
              var N = U.length, M = parseInt(U.substr(1), 16);
              N === 7 ? W = [(M & 16711680) >> 16, (M & 65280) >> 8, M & 255, 1] : N === 4 && (W = [(M & 3840) >> 4 | (M & 3840) >> 8, (M & 240) >> 4 | M & 240, (M & 15) << 4 | M & 15, 1]);
            }
            if (!W)
              for (M = $.parsers.length; M-- && !W; ) {
                var v = $.parsers[M];
                (N = v.regex.exec(U)) && (W = v.parse(N));
              }
          }
          W && (this.rgba = W);
        }, $.prototype.get = function(U) {
          var W = this.input, N = this.rgba;
          if (typeof W == "object" && typeof this.stops < "u") {
            var M = Z(W);
            return M.stops = [].slice.call(M.stops), this.stops.forEach(function(v, u) {
              M.stops[u] = [M.stops[u][0], v.get(U)];
            }), M;
          }
          return N && I(N[0]) ? U === "rgb" || !U && N[3] === 1 ? "rgb(" + N[0] + "," + N[1] + "," + N[2] + ")" : U === "a" ? "" + N[3] : "rgba(" + N.join(",") + ")" : W;
        }, $.prototype.brighten = function(U) {
          var W = this.rgba;
          if (this.stops)
            this.stops.forEach(function(M) {
              M.brighten(U);
            });
          else if (I(U) && U !== 0)
            for (var N = 0; 3 > N; N++)
              W[N] += H(255 * U), 0 > W[N] && (W[N] = 0), 255 < W[N] && (W[N] = 255);
          return this;
        }, $.prototype.setOpacity = function(U) {
          return this.rgba[3] = U, this;
        }, $.prototype.tweenTo = function(U, W) {
          var N = this.rgba, M = U.rgba;
          return !I(N[0]) || !I(M[0]) ? U.input || "none" : (U = M[3] !== 1 || N[3] !== 1, (U ? "rgba(" : "rgb(") + Math.round(M[0] + (N[0] - M[0]) * (1 - W)) + "," + Math.round(M[1] + (N[1] - M[1]) * (1 - W)) + "," + Math.round(M[2] + (N[2] - M[2]) * (1 - W)) + (U ? "," + (M[3] + (N[3] - M[3]) * (1 - W)) : "") + ")");
        }, $.names = { white: "#ffffff", black: "#000000" }, $.parsers = [{
          regex: /rgba\(\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]?(?:\.[0-9]+)?)\s*\)/,
          parse: function(U) {
            return [H(U[1]), H(U[2]), H(U[3]), parseFloat(U[4], 10)];
          }
        }, { regex: /rgb\(\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*\)/, parse: function(U) {
          return [H(U[1]), H(U[2]), H(U[3]), 1];
        } }], $.None = new $(""), $;
      }(), R;
    }), E(a, "Core/Color/Palettes.js", [], function() {
      return { colors: "#7cb5ec #434348 #90ed7d #f7a35c #8085e9 #f15c80 #e4d354 #2b908f #f45b5b #91e8e1".split(" ") };
    }), E(a, "Core/Time.js", [a["Core/Globals.js"], a["Core/Utilities.js"]], function(y, R) {
      var I = y.win, Z = R.defined, H = R.error, $ = R.extend, U = R.isObject, W = R.merge, N = R.objectEach, M = R.pad, v = R.pick, u = R.splat, d = R.timeUnits, P = y.isSafari && I.Intl && I.Intl.DateTimeFormat.prototype.formatRange, O = y.isSafari && I.Intl && !I.Intl.DateTimeFormat.prototype.formatRange;
      return R = function() {
        function B(C) {
          this.options = {}, this.variableTimezone = this.useUTC = !1, this.Date = I.Date, this.getTimezoneOffset = this.timezoneOffsetFunction(), this.update(C);
        }
        return B.prototype.get = function(C, b) {
          if (this.variableTimezone || this.timezoneOffset) {
            var w = b.getTime(), x = w - this.getTimezoneOffset(b);
            return b.setTime(x), C = b["getUTC" + C](), b.setTime(w), C;
          }
          return this.useUTC ? b["getUTC" + C]() : b["get" + C]();
        }, B.prototype.set = function(C, b, w) {
          if (this.variableTimezone || this.timezoneOffset) {
            if (C === "Milliseconds" || C === "Seconds" || C === "Minutes" && this.getTimezoneOffset(b) % 36e5 === 0)
              return b["setUTC" + C](w);
            var x = this.getTimezoneOffset(b);
            return x = b.getTime() - x, b.setTime(x), b["setUTC" + C](w), C = this.getTimezoneOffset(b), x = b.getTime() + C, b.setTime(x);
          }
          return this.useUTC || P && C === "FullYear" ? b["setUTC" + C](w) : b["set" + C](w);
        }, B.prototype.update = function(C) {
          var b = v(C && C.useUTC, !0);
          this.options = C = W(!0, this.options || {}, C), this.Date = C.Date || I.Date || Date, this.timezoneOffset = (this.useUTC = b) && C.timezoneOffset, this.getTimezoneOffset = this.timezoneOffsetFunction(), this.variableTimezone = b && !(!C.getTimezoneOffset && !C.timezone);
        }, B.prototype.makeTime = function(C, b, w, x, h, c) {
          if (this.useUTC) {
            var p = this.Date.UTC.apply(0, arguments), i = this.getTimezoneOffset(p);
            p += i;
            var l = this.getTimezoneOffset(p);
            i !== l ? p += l - i : i - 36e5 !== this.getTimezoneOffset(p - 36e5) || O || (p -= 36e5);
          } else
            p = new this.Date(C, b, v(w, 1), v(x, 0), v(h, 0), v(c, 0)).getTime();
          return p;
        }, B.prototype.timezoneOffsetFunction = function() {
          var C = this, b = this.options, w = b.getTimezoneOffset, x = b.moment || I.moment;
          if (!this.useUTC)
            return function(h) {
              return 6e4 * new Date(h.toString()).getTimezoneOffset();
            };
          if (b.timezone) {
            if (x)
              return function(h) {
                return 6e4 * -x.tz(h, b.timezone).utcOffset();
              };
            H(25);
          }
          return this.useUTC && w ? function(h) {
            return 6e4 * w(h.valueOf());
          } : function() {
            return 6e4 * (C.timezoneOffset || 0);
          };
        }, B.prototype.dateFormat = function(C, b, w) {
          if (!Z(b) || isNaN(b))
            return y.defaultOptions.lang && y.defaultOptions.lang.invalidDate || "";
          C = v(C, "%Y-%m-%d %H:%M:%S");
          var x = this, h = new this.Date(b), c = this.get("Hours", h), p = this.get("Day", h), i = this.get("Date", h), l = this.get("Month", h), s = this.get("FullYear", h), t = y.defaultOptions.lang, n = t && t.weekdays, o = t && t.shortWeekdays;
          return h = $({ a: o ? o[p] : n[p].substr(0, 3), A: n[p], d: M(i), e: M(i, 2, " "), w: p, b: t.shortMonths[l], B: t.months[l], m: M(l + 1), o: l + 1, y: s.toString().substr(2, 2), Y: s, H: M(c), k: c, I: M(c % 12 || 12), l: c % 12 || 12, M: M(this.get("Minutes", h)), p: 12 > c ? "AM" : "PM", P: 12 > c ? "am" : "pm", S: M(h.getSeconds()), L: M(Math.floor(b % 1e3), 3) }, y.dateFormats), N(h, function(A, _) {
            for (; C.indexOf("%" + _) !== -1; )
              C = C.replace("%" + _, typeof A == "function" ? A.call(x, b) : A);
          }), w ? C.substr(0, 1).toUpperCase() + C.substr(1) : C;
        }, B.prototype.resolveDTLFormat = function(C) {
          return U(C, !0) ? C : (C = u(C), { main: C[0], from: C[1], to: C[2] });
        }, B.prototype.getTimeTicks = function(C, b, w, x) {
          var h = this, c = [], p = {}, i = new h.Date(b), l = C.unitRange, s = C.count || 1, t;
          if (x = v(x, 1), Z(b)) {
            if (h.set(
              "Milliseconds",
              i,
              l >= d.second ? 0 : s * Math.floor(h.get("Milliseconds", i) / s)
            ), l >= d.second && h.set("Seconds", i, l >= d.minute ? 0 : s * Math.floor(h.get("Seconds", i) / s)), l >= d.minute && h.set("Minutes", i, l >= d.hour ? 0 : s * Math.floor(h.get("Minutes", i) / s)), l >= d.hour && h.set("Hours", i, l >= d.day ? 0 : s * Math.floor(h.get("Hours", i) / s)), l >= d.day && h.set("Date", i, l >= d.month ? 1 : Math.max(1, s * Math.floor(h.get("Date", i) / s))), l >= d.month) {
              h.set("Month", i, l >= d.year ? 0 : s * Math.floor(h.get("Month", i) / s));
              var n = h.get("FullYear", i);
            }
            l >= d.year && h.set(
              "FullYear",
              i,
              n - n % s
            ), l === d.week && (n = h.get("Day", i), h.set("Date", i, h.get("Date", i) - n + x + (n < x ? -7 : 0))), n = h.get("FullYear", i), x = h.get("Month", i);
            var o = h.get("Date", i), A = h.get("Hours", i);
            for (b = i.getTime(), !h.variableTimezone && h.useUTC || !Z(w) || (t = w - b > 4 * d.month || h.getTimezoneOffset(b) !== h.getTimezoneOffset(w)), b = i.getTime(), i = 1; b < w; )
              c.push(b), b = l === d.year ? h.makeTime(n + i * s, 0) : l === d.month ? h.makeTime(n, x + i * s) : !t || l !== d.day && l !== d.week ? t && l === d.hour && 1 < s ? h.makeTime(n, x, o, A + i * s) : b + l * s : h.makeTime(n, x, o + i * s * (l === d.day ? 1 : 7)), i++;
            c.push(b), l <= d.hour && 1e4 > c.length && c.forEach(function(_) {
              _ % 18e5 === 0 && h.dateFormat("%H%M%S%L", _) === "000000000" && (p[_] = "day");
            });
          }
          return c.info = $(C, { higherRanks: p, totalRange: l * s }), c;
        }, B.prototype.getDateFormat = function(C, b, w, x) {
          var h = this.dateFormat("%m-%d %H:%M:%S.%L", b), c = { millisecond: 15, second: 12, minute: 9, hour: 6, day: 3 }, p = "millisecond";
          for (i in d) {
            if (C === d.week && +this.dateFormat("%w", b) === w && h.substr(6) === "00:00:00.000") {
              var i = "week";
              break;
            }
            if (d[i] > C) {
              i = p;
              break;
            }
            if (c[i] && h.substr(c[i]) !== "01-01 00:00:00.000".substr(c[i]))
              break;
            i !== "week" && (p = i);
          }
          if (i)
            var l = this.resolveDTLFormat(x[i]).main;
          return l;
        }, B;
      }(), R;
    }), E(a, "Core/DefaultOptions.js", [a["Core/Chart/ChartDefaults.js"], a["Core/Color/Color.js"], a["Core/Globals.js"], a["Core/Color/Palettes.js"], a["Core/Time.js"], a["Core/Utilities.js"]], function(y, R, I, Z, H, $) {
      R = R.parse;
      var U = $.merge, W = {
        colors: Z.colors,
        symbols: ["circle", "diamond", "square", "triangle", "triangle-down"],
        lang: {
          loading: "Loading...",
          months: "January February March April May June July August September October November December".split(" "),
          shortMonths: "Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec".split(" "),
          weekdays: "Sunday Monday Tuesday Wednesday Thursday Friday Saturday".split(" "),
          decimalPoint: ".",
          numericSymbols: "kMGTPE".split(""),
          resetZoom: "Reset zoom",
          resetZoomTitle: "Reset zoom level 1:1",
          thousandsSep: " "
        },
        global: {},
        time: { Date: void 0, getTimezoneOffset: void 0, timezone: void 0, timezoneOffset: 0, useUTC: !0 },
        chart: y,
        title: { text: "Chart title", align: "center", margin: 15, widthAdjust: -44 },
        subtitle: { text: "", align: "center", widthAdjust: -44 },
        caption: { margin: 15, text: "", align: "left", verticalAlign: "bottom" },
        plotOptions: {},
        labels: { style: { position: "absolute", color: "#333333" } },
        legend: {
          enabled: !0,
          align: "center",
          alignColumns: !0,
          className: "highcharts-no-tooltip",
          layout: "horizontal",
          labelFormatter: function() {
            return this.name;
          },
          borderColor: "#999999",
          borderRadius: 0,
          navigation: { activeColor: "#003399", inactiveColor: "#cccccc" },
          itemStyle: { color: "#333333", cursor: "pointer", fontSize: "12px", fontWeight: "bold", textOverflow: "ellipsis" },
          itemHoverStyle: { color: "#000000" },
          itemHiddenStyle: { color: "#cccccc" },
          shadow: !1,
          itemCheckboxStyle: { position: "absolute", width: "13px", height: "13px" },
          squareSymbol: !0,
          symbolPadding: 5,
          verticalAlign: "bottom",
          x: 0,
          y: 0,
          title: { style: { fontWeight: "bold" } }
        },
        loading: { labelStyle: { fontWeight: "bold", position: "relative", top: "45%" }, style: { position: "absolute", backgroundColor: "#ffffff", opacity: 0.5, textAlign: "center" } },
        tooltip: {
          enabled: !0,
          animation: I.svg,
          borderRadius: 3,
          dateTimeLabelFormats: {
            millisecond: "%A, %b %e, %H:%M:%S.%L",
            second: "%A, %b %e, %H:%M:%S",
            minute: "%A, %b %e, %H:%M",
            hour: "%A, %b %e, %H:%M",
            day: "%A, %b %e, %Y",
            week: "Week from %A, %b %e, %Y",
            month: "%B %Y",
            year: "%Y"
          },
          footerFormat: "",
          headerShape: "callout",
          hideDelay: 500,
          padding: 8,
          shape: "callout",
          shared: !1,
          snap: I.isTouchDevice ? 25 : 10,
          headerFormat: '<span style="font-size: 10px">{point.key}</span><br/>',
          pointFormat: '<span style="color:{point.color}">●</span> {series.name}: <b>{point.y}</b><br/>',
          backgroundColor: R("#f7f7f7").setOpacity(0.85).get(),
          borderWidth: 1,
          shadow: !0,
          stickOnContact: !1,
          style: { color: "#333333", cursor: "default", fontSize: "12px", whiteSpace: "nowrap" },
          useHTML: !1
        },
        credits: { enabled: !0, href: "https://www.highcharts.com?credits", position: { align: "right", x: -10, verticalAlign: "bottom", y: -5 }, style: { cursor: "pointer", color: "#999999", fontSize: "9px" }, text: "Highcharts.com" }
      };
      W.chart.styledMode = !1;
      var N = new H(U(W.global, W.time));
      return y = { defaultOptions: W, defaultTime: N, getOptions: function() {
        return W;
      }, setOptions: function(M) {
        return U(!0, W, M), (M.time || M.global) && (I.time ? I.time.update(U(
          W.global,
          W.time,
          M.global,
          M.time
        )) : I.time = N), W;
      } }, y;
    }), E(a, "Core/Animation/Fx.js", [a["Core/Color/Color.js"], a["Core/Globals.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = y.parse, H = R.win, $ = I.isNumber, U = I.objectEach;
      return function() {
        function W(N, M, v) {
          this.pos = NaN, this.options = M, this.elem = N, this.prop = v;
        }
        return W.prototype.dSetter = function() {
          var N = this.paths, M = N && N[0];
          N = N && N[1];
          var v = this.now || 0, u = [];
          if (v !== 1 && M && N)
            if (M.length === N.length && 1 > v)
              for (var d = 0; d < N.length; d++) {
                for (var P = M[d], O = N[d], B = [], C = 0; C < O.length; C++) {
                  var b = P[C], w = O[C];
                  $(b) && $(w) && (O[0] !== "A" || C !== 4 && C !== 5) ? B[C] = b + v * (w - b) : B[C] = w;
                }
                u.push(B);
              }
            else
              u = N;
          else
            u = this.toD || [];
          this.elem.attr("d", u, void 0, !0);
        }, W.prototype.update = function() {
          var N = this.elem, M = this.prop, v = this.now, u = this.options.step;
          this[M + "Setter"] ? this[M + "Setter"]() : N.attr ? N.element && N.attr(M, v, null, !0) : N.style[M] = v + this.unit, u && u.call(N, v, this);
        }, W.prototype.run = function(N, M, v) {
          var u = this, d = u.options, P = function(C) {
            return P.stopped ? !1 : u.step(C);
          }, O = H.requestAnimationFrame || function(C) {
            setTimeout(
              C,
              13
            );
          }, B = function() {
            for (var C = 0; C < W.timers.length; C++)
              W.timers[C]() || W.timers.splice(C--, 1);
            W.timers.length && O(B);
          };
          N !== M || this.elem["forceAnimate:" + this.prop] ? (this.startTime = +/* @__PURE__ */ new Date(), this.start = N, this.end = M, this.unit = v, this.now = this.start, this.pos = 0, P.elem = this.elem, P.prop = this.prop, P() && W.timers.push(P) === 1 && O(B)) : (delete d.curAnim[this.prop], d.complete && Object.keys(d.curAnim).length === 0 && d.complete.call(this.elem));
        }, W.prototype.step = function(N) {
          var M = +/* @__PURE__ */ new Date(), v = this.options, u = this.elem, d = v.complete, P = v.duration, O = v.curAnim;
          if (u.attr && !u.element)
            N = !1;
          else if (N || M >= P + this.startTime) {
            this.now = this.end, this.pos = 1, this.update();
            var B = O[this.prop] = !0;
            U(O, function(C) {
              C !== !0 && (B = !1);
            }), B && d && d.call(u), N = !1;
          } else
            this.pos = v.easing((M - this.startTime) / P), this.now = this.start + (this.end - this.start) * this.pos, this.update(), N = !0;
          return N;
        }, W.prototype.initPath = function(N, M, v) {
          function u(h, c) {
            for (; h.length < x; ) {
              var p = h[0], i = c[x - h.length];
              i && p[0] === "M" && (h[0] = i[0] === "C" ? ["C", p[1], p[2], p[1], p[2], p[1], p[2]] : [
                "L",
                p[1],
                p[2]
              ]), h.unshift(p), B && (p = h.pop(), h.push(h[h.length - 1], p));
            }
          }
          function d(h, c) {
            for (; h.length < x; )
              if (c = h[Math.floor(h.length / C) - 1].slice(), c[0] === "C" && (c[1] = c[5], c[2] = c[6]), B) {
                var p = h[Math.floor(h.length / C)].slice();
                h.splice(h.length / 2, 0, c, p);
              } else
                h.push(c);
          }
          var P = N.startX, O = N.endX;
          v = v.slice();
          var B = N.isArea, C = B ? 2 : 1;
          if (M = M && M.slice(), !M)
            return [v, v];
          if (P && O && O.length) {
            for (N = 0; N < P.length; N++)
              if (P[N] === O[0]) {
                var b = N;
                break;
              } else if (P[0] === O[O.length - P.length + N]) {
                b = N;
                var w = !0;
                break;
              } else if (P[P.length - 1] === O[O.length - P.length + N]) {
                b = P.length - N;
                break;
              }
            typeof b > "u" && (M = []);
          }
          if (M.length && $(b)) {
            var x = v.length + b * C;
            w ? (u(M, v), d(v, M)) : (u(v, M), d(M, v));
          }
          return [M, v];
        }, W.prototype.fillSetter = function() {
          W.prototype.strokeSetter.apply(this, arguments);
        }, W.prototype.strokeSetter = function() {
          this.elem.attr(this.prop, Z(this.start).tweenTo(Z(this.end), this.pos), void 0, !0);
        }, W.timers = [], W;
      }();
    }), E(a, "Core/Animation/AnimationUtilities.js", [a["Core/Animation/Fx.js"], a["Core/Utilities.js"]], function(y, R) {
      function I(d) {
        return N(d) ? M({ duration: 500, defer: 0 }, d) : { duration: d ? 500 : 0, defer: 0 };
      }
      function Z(d, P) {
        for (var O = y.timers.length; O--; )
          y.timers[O].elem !== d || P && P !== y.timers[O].prop || (y.timers[O].stopped = !0);
      }
      var H = R.defined, $ = R.getStyle, U = R.isArray, W = R.isNumber, N = R.isObject, M = R.merge, v = R.objectEach, u = R.pick;
      return { animate: function(d, P, O) {
        var B, C = "", b, w;
        if (!N(O)) {
          var x = arguments;
          O = { duration: x[2], easing: x[3], complete: x[4] };
        }
        W(O.duration) || (O.duration = 400), O.easing = typeof O.easing == "function" ? O.easing : Math[O.easing] || Math.easeInOutSine, O.curAnim = M(P), v(P, function(h, c) {
          Z(d, c), w = new y(d, O, c), b = void 0, c === "d" && U(P.d) ? (w.paths = w.initPath(d, d.pathArray, P.d), w.toD = P.d, B = 0, b = 1) : d.attr ? B = d.attr(c) : (B = parseFloat($(d, c)) || 0, c !== "opacity" && (C = "px")), b || (b = h), typeof b == "string" && b.match("px") && (b = b.replace(/px/g, "")), w.run(B, b, C);
        });
      }, animObject: I, getDeferredAnimation: function(d, P, O) {
        var B = I(P), C = 0, b = 0;
        return (O ? [O] : d.series).forEach(function(w) {
          w = I(w.options.animation), C = P && H(P.defer) ? B.defer : Math.max(C, w.duration + w.defer), b = Math.min(B.duration, w.duration);
        }), d.renderer.forExport && (C = 0), { defer: Math.max(0, C - b), duration: Math.min(C, b) };
      }, setAnimation: function(d, P) {
        P.renderer.globalAnimation = u(d, P.options.chart.animation, !0);
      }, stop: Z };
    }), E(a, "Core/Renderer/HTML/AST.js", [a["Core/Globals.js"], a["Core/Utilities.js"]], function(y, R) {
      var I = y.SVG_NS, Z = R.attr, H = R.createElement, $ = R.error, U = R.isFunction, W = R.isString, N = R.objectEach, M = R.splat, v = (R = y.win.trustedTypes) && U(R.createPolicy) && R.createPolicy("highcharts", { createHTML: function(P) {
        return P;
      } }), u = v ? v.createHTML("") : "";
      try {
        var d = !!new DOMParser().parseFromString(u, "text/html");
      } catch {
        d = !1;
      }
      return U = function() {
        function P(O) {
          this.nodes = typeof O == "string" ? this.parseMarkup(O) : O;
        }
        return P.filterUserAttributes = function(O) {
          return N(O, function(B, C) {
            var b = !0;
            P.allowedAttributes.indexOf(C) === -1 && (b = !1), ["background", "dynsrc", "href", "lowsrc", "src"].indexOf(C) !== -1 && (b = W(B) && P.allowedReferences.some(function(w) {
              return B.indexOf(w) === 0;
            })), b || ($("Highcharts warning: Invalid attribute '" + C + "' in config"), delete O[C]);
          }), O;
        }, P.setElementHTML = function(O, B) {
          O.innerHTML = P.emptyHTML, B && new P(B).addToDOM(O);
        }, P.prototype.addToDOM = function(O) {
          function B(C, b) {
            var w;
            return M(C).forEach(function(x) {
              var h = x.tagName, c = x.textContent ? y.doc.createTextNode(x.textContent) : void 0;
              if (h)
                if (h === "#text")
                  var p = c;
                else if (P.allowedTags.indexOf(h) !== -1) {
                  h = y.doc.createElementNS(h === "svg" ? I : b.namespaceURI || I, h);
                  var i = x.attributes || {};
                  N(x, function(l, s) {
                    s !== "tagName" && s !== "attributes" && s !== "children" && s !== "textContent" && (i[s] = l);
                  }), Z(h, P.filterUserAttributes(i)), c && h.appendChild(c), B(x.children || [], h), p = h;
                } else
                  $("Highcharts warning: Invalid tagName " + h + " in config");
              p && b.appendChild(p), w = p;
            }), w;
          }
          return B(this.nodes, O);
        }, P.prototype.parseMarkup = function(O) {
          var B = [];
          if (O = O.trim(), d)
            O = new DOMParser().parseFromString(v ? v.createHTML(O) : O, "text/html");
          else {
            var C = H("div");
            C.innerHTML = O, O = { body: C };
          }
          var b = function(w, x) {
            var h = w.nodeName.toLowerCase(), c = { tagName: h };
            if (h === "#text" && (c.textContent = w.textContent || ""), h = w.attributes) {
              var p = {};
              [].forEach.call(h, function(l) {
                p[l.name] = l.value;
              }), c.attributes = p;
            }
            if (w.childNodes.length) {
              var i = [];
              [].forEach.call(w.childNodes, function(l) {
                b(l, i);
              }), i.length && (c.children = i);
            }
            x.push(c);
          };
          return [].forEach.call(O.body.childNodes, function(w) {
            return b(w, B);
          }), B;
        }, P.allowedAttributes = "aria-controls aria-describedby aria-expanded aria-haspopup aria-hidden aria-label aria-labelledby aria-live aria-pressed aria-readonly aria-roledescription aria-selected class clip-path color colspan cx cy d dx dy disabled fill height href id in markerHeight markerWidth offset opacity orient padding paddingLeft paddingRight patternUnits r refX refY role scope slope src startOffset stdDeviation stroke stroke-linecap stroke-width style tableValues result rowspan summary target tabindex text-align textAnchor textLength title type valign width x x1 x2 y y1 y2 zIndex".split(" "), P.allowedReferences = "https:// http:// mailto: / ../ ./ #".split(" "), P.allowedTags = "a abbr b br button caption circle clipPath code dd defs div dl dt em feComponentTransfer feFuncA feFuncB feFuncG feFuncR feGaussianBlur feOffset feMerge feMergeNode filter h1 h2 h3 h4 h5 h6 hr i img li linearGradient marker ol p path pattern pre rect small span stop strong style sub sup svg table text thead tbody tspan td th tr u ul #text".split(" "), P.emptyHTML = u, P;
      }(), U;
    }), E(
      a,
      "Core/FormatUtilities.js",
      [a["Core/DefaultOptions.js"], a["Core/Utilities.js"]],
      function(y, R) {
        function I(M, v, u, d) {
          M = +M || 0, v = +v;
          var P = Z.lang, O = (M.toString().split(".")[1] || "").split("e")[0].length, B = M.toString().split("e"), C = v;
          if (v === -1)
            v = Math.min(O, 20);
          else if (!U(v))
            v = 2;
          else if (v && B[1] && 0 > B[1]) {
            var b = v + +B[1];
            0 <= b ? (B[0] = (+B[0]).toExponential(b).split("e")[0], v = b) : (B[0] = B[0].split(".")[0] || 0, M = 20 > v ? (B[0] * Math.pow(10, B[1])).toFixed(v) : 0, B[1] = 0);
          }
          b = (Math.abs(B[1] ? B[0] : M) + Math.pow(10, -Math.max(v, O) - 1)).toFixed(v), O = String(N(b));
          var w = 3 < O.length ? O.length % 3 : 0;
          return u = W(u, P.decimalPoint), d = W(d, P.thousandsSep), M = (0 > M ? "-" : "") + (w ? O.substr(0, w) + d : ""), M = 0 > +B[1] && !C ? "0" : M + O.substr(w).replace(/(\d{3})(?=\d)/g, "$1" + d), v && (M += u + b.slice(-v)), B[1] && +M != 0 && (M += "e" + B[1]), M;
        }
        var Z = y.defaultOptions, H = y.defaultTime, $ = R.getNestedProperty, U = R.isNumber, W = R.pick, N = R.pInt;
        return { dateFormat: function(M, v, u) {
          return H.dateFormat(M, v, u);
        }, format: function(M, v, u) {
          var d = "{", P = !1, O = /f$/, B = /\.([0-9])/, C = Z.lang, b = u && u.time || H;
          u = u && u.numberFormatter || I;
          for (var w = []; M; ) {
            var x = M.indexOf(d);
            if (x === -1)
              break;
            var h = M.slice(0, x);
            if (P) {
              if (h = h.split(":"), d = $(h.shift() || "", v), h.length && typeof d == "number")
                if (h = h.join(":"), O.test(h)) {
                  var c = parseInt((h.match(B) || ["", "-1"])[1], 10);
                  d !== null && (d = u(d, c, C.decimalPoint, -1 < h.indexOf(",") ? C.thousandsSep : ""));
                } else
                  d = b.dateFormat(h, d);
              w.push(d);
            } else
              w.push(h);
            M = M.slice(x + 1), d = (P = !P) ? "}" : "{";
          }
          return w.push(M), w.join("");
        }, numberFormat: I };
      }
    ), E(a, "Core/Renderer/RendererUtilities.js", [a["Core/Utilities.js"]], function(y) {
      var R = y.clamp, I = y.pick, Z = y.stableSort, H;
      return function($) {
        function U(W, N, M) {
          var v = W, u = v.reducedLen || N, d = function(w, x) {
            return (x.rank || 0) - (w.rank || 0);
          }, P = function(w, x) {
            return w.target - x.target;
          }, O, B = !0, C = [], b = 0;
          for (O = W.length; O--; )
            b += W[O].size;
          if (b > u) {
            for (Z(W, d), b = O = 0; b <= u; )
              b += W[O].size, O++;
            C = W.splice(O - 1, W.length);
          }
          for (Z(W, P), W = W.map(function(w) {
            return { size: w.size, targets: [w.target], align: I(w.align, 0.5) };
          }); B; ) {
            for (O = W.length; O--; )
              u = W[O], d = (Math.min.apply(0, u.targets) + Math.max.apply(0, u.targets)) / 2, u.pos = R(
                d - u.size * u.align,
                0,
                N - u.size
              );
            for (O = W.length, B = !1; O--; )
              0 < O && W[O - 1].pos + W[O - 1].size > W[O].pos && (W[O - 1].size += W[O].size, W[O - 1].targets = W[O - 1].targets.concat(W[O].targets), W[O - 1].align = 0.5, W[O - 1].pos + W[O - 1].size > N && (W[O - 1].pos = N - W[O - 1].size), W.splice(O, 1), B = !0);
          }
          return v.push.apply(v, C), O = 0, W.some(function(w) {
            var x = 0;
            return (w.targets || []).some(function() {
              return v[O].pos = w.pos + x, typeof M < "u" && Math.abs(v[O].pos - v[O].target) > M ? (v.slice(0, O + 1).forEach(function(h) {
                return delete h.pos;
              }), v.reducedLen = (v.reducedLen || N) - 0.1 * N, v.reducedLen > 0.1 * N && U(v, N, M), !0) : (x += v[O].size, O++, !1);
            });
          }), Z(v, P), v;
        }
        $.distribute = U;
      }(H || (H = {})), H;
    }), E(a, "Core/Renderer/SVG/SVGElement.js", [a["Core/Animation/AnimationUtilities.js"], a["Core/Renderer/HTML/AST.js"], a["Core/Color/Color.js"], a["Core/Globals.js"], a["Core/Utilities.js"]], function(y, R, I, Z, H) {
      var $ = y.animate, U = y.animObject, W = y.stop, N = Z.deg2rad, M = Z.doc, v = Z.noop, u = Z.svg, d = Z.SVG_NS, P = Z.win, O = H.addEvent, B = H.attr, C = H.createElement, b = H.css, w = H.defined, x = H.erase, h = H.extend, c = H.fireEvent, p = H.isArray, i = H.isFunction, l = H.isNumber, s = H.isString, t = H.merge, n = H.objectEach, o = H.pick, A = H.pInt, _ = H.syncTimeout, D = H.uniqueKey;
      return y = function() {
        function j() {
          this.element = void 0, this.onEvents = {}, this.opacity = 1, this.renderer = void 0, this.SVG_NS = d, this.symbolCustomAttribs = "x y width height r start end innerR anchorX anchorY rounded".split(" ");
        }
        return j.prototype._defaultGetter = function(T) {
          return T = o(this[T + "Value"], this[T], this.element ? this.element.getAttribute(T) : null, 0), /^[\-0-9\.]+$/.test(T) && (T = parseFloat(T)), T;
        }, j.prototype._defaultSetter = function(T, X, f) {
          f.setAttribute(X, T);
        }, j.prototype.add = function(T) {
          var X = this.renderer, f = this.element;
          if (T && (this.parentGroup = T), this.parentInverted = T && T.inverted, typeof this.textStr < "u" && this.element.nodeName === "text" && X.buildText(this), this.added = !0, !T || T.handleZ || this.zIndex)
            var m = this.zIndexSetter();
          return m || (T ? T.element : X.box).appendChild(f), this.onAdd && this.onAdd(), this;
        }, j.prototype.addClass = function(T, X) {
          var f = X ? "" : this.attr("class") || "";
          return T = (T || "").split(/ /g).reduce(function(m, L) {
            return f.indexOf(L) === -1 && m.push(L), m;
          }, f ? [f] : []).join(" "), T !== f && this.attr("class", T), this;
        }, j.prototype.afterSetters = function() {
          this.doTransform && (this.updateTransform(), this.doTransform = !1);
        }, j.prototype.align = function(T, X, f) {
          var m = {}, L = this.renderer, Y = L.alignedObjects, F, Q, k;
          T ? (this.alignOptions = T, this.alignByTranslate = X, (!f || s(f)) && (this.alignTo = F = f || "renderer", x(Y, this), Y.push(this), f = void 0)) : (T = this.alignOptions, X = this.alignByTranslate, F = this.alignTo), f = o(f, L[F], F === "scrollablePlotBox" ? L.plotBox : void 0, L), F = T.align;
          var G = T.verticalAlign;
          return L = (f.x || 0) + (T.x || 0), Y = (f.y || 0) + (T.y || 0), F === "right" ? Q = 1 : F === "center" && (Q = 2), Q && (L += (f.width - (T.width || 0)) / Q), m[X ? "translateX" : "x"] = Math.round(L), G === "bottom" ? k = 1 : G === "middle" && (k = 2), k && (Y += (f.height - (T.height || 0)) / k), m[X ? "translateY" : "y"] = Math.round(Y), this[this.placed ? "animate" : "attr"](m), this.placed = !0, this.alignAttr = m, this;
        }, j.prototype.alignSetter = function(T) {
          var X = { left: "start", center: "middle", right: "end" };
          X[T] && (this.alignValue = T, this.element.setAttribute(
            "text-anchor",
            X[T]
          ));
        }, j.prototype.animate = function(T, X, f) {
          var m = this, L = U(o(X, this.renderer.globalAnimation, !0));
          return X = L.defer, o(M.hidden, M.msHidden, M.webkitHidden, !1) && (L.duration = 0), L.duration !== 0 ? (f && (L.complete = f), _(function() {
            m.element && $(m, T, L);
          }, X)) : (this.attr(T, void 0, f), n(T, function(Y, F) {
            L.step && L.step.call(this, Y, { prop: F, pos: 1, elem: this });
          }, this)), this;
        }, j.prototype.applyTextOutline = function(T) {
          var X = this.element;
          T.indexOf("contrast") !== -1 && (T = T.replace(/contrast/g, this.renderer.getContrast(X.style.fill)));
          var f = T.split(" ");
          if (T = f[f.length - 1], (f = f[0]) && f !== "none" && Z.svg) {
            this.fakeTS = !0, this.ySetter = this.xSetter, f = f.replace(/(^[\d\.]+)(.*?)$/g, function(Y, F, Q) {
              return 2 * Number(F) + Q;
            }), this.removeTextOutline();
            var m = M.createElementNS(d, "tspan");
            B(m, { class: "highcharts-text-outline", fill: T, stroke: T, "stroke-width": f, "stroke-linejoin": "round" }), [].forEach.call(X.childNodes, function(Y) {
              var F = Y.cloneNode(!0);
              F.removeAttribute && ["fill", "stroke", "stroke-width", "stroke"].forEach(function(Q) {
                return F.removeAttribute(Q);
              }), m.appendChild(F);
            });
            var L = M.createElementNS(d, "tspan");
            L.textContent = "​", ["x", "y"].forEach(function(Y) {
              var F = X.getAttribute(Y);
              F && L.setAttribute(Y, F);
            }), m.appendChild(L), X.insertBefore(m, X.firstChild);
          }
        }, j.prototype.attr = function(T, X, f, m) {
          var L = this.element, Y = this.symbolCustomAttribs, F, Q = this, k, G;
          if (typeof T == "string" && typeof X < "u") {
            var z = T;
            T = {}, T[z] = X;
          }
          return typeof T == "string" ? Q = (this[T + "Getter"] || this._defaultGetter).call(this, T, L) : (n(T, function(V, q) {
            k = !1, m || W(this, q), this.symbolName && Y.indexOf(q) !== -1 && (F || (this.symbolAttr(T), F = !0), k = !0), !this.rotation || q !== "x" && q !== "y" || (this.doTransform = !0), k || (G = this[q + "Setter"] || this._defaultSetter, G.call(this, V, q, L), !this.styledMode && this.shadows && /^(width|height|visibility|x|y|d|transform|cx|cy|r)$/.test(q) && this.updateShadows(q, V, G));
          }, this), this.afterSetters()), f && f.call(this), Q;
        }, j.prototype.clip = function(T) {
          return this.attr("clip-path", T ? "url(" + this.renderer.url + "#" + T.id + ")" : "none");
        }, j.prototype.crisp = function(T, X) {
          X = X || T.strokeWidth || 0;
          var f = Math.round(X) % 2 / 2;
          return T.x = Math.floor(T.x || this.x || 0) + f, T.y = Math.floor(T.y || this.y || 0) + f, T.width = Math.floor((T.width || this.width || 0) - 2 * f), T.height = Math.floor((T.height || this.height || 0) - 2 * f), w(T.strokeWidth) && (T.strokeWidth = X), T;
        }, j.prototype.complexColor = function(T, X, f) {
          var m = this.renderer, L, Y, F, Q, k, G, z, V, q, it, et = [], nt;
          c(this.renderer, "complexColor", { args: arguments }, function() {
            if (T.radialGradient ? Y = "radialGradient" : T.linearGradient && (Y = "linearGradient"), Y) {
              if (F = T[Y], k = m.gradients, G = T.stops, q = f.radialReference, p(F) && (T[Y] = F = { x1: F[0], y1: F[1], x2: F[2], y2: F[3], gradientUnits: "userSpaceOnUse" }), Y === "radialGradient" && q && !w(F.gradientUnits) && (Q = F, F = t(F, m.getRadialAttr(q, Q), { gradientUnits: "userSpaceOnUse" })), n(F, function(ct, gt) {
                gt !== "id" && et.push(gt, ct);
              }), n(G, function(ct) {
                et.push(ct);
              }), et = et.join(","), k[et])
                it = k[et].attr("id");
              else {
                F.id = it = D();
                var rt = k[et] = m.createElement(Y).attr(F).add(m.defs);
                rt.radAttr = Q, rt.stops = [], G.forEach(function(ct) {
                  ct[1].indexOf("rgba") === 0 ? (L = I.parse(ct[1]), z = L.get("rgb"), V = L.get("a")) : (z = ct[1], V = 1), ct = m.createElement("stop").attr({
                    offset: ct[0],
                    "stop-color": z,
                    "stop-opacity": V
                  }).add(rt), rt.stops.push(ct);
                });
              }
              nt = "url(" + m.url + "#" + it + ")", f.setAttribute(X, nt), f.gradient = et, T.toString = function() {
                return nt;
              };
            }
          });
        }, j.prototype.css = function(T) {
          var X = this.styles, f = {}, m = this.element, L = ["textOutline", "textOverflow", "width"], Y = "", F = !X;
          if (T && T.color && (T.fill = T.color), X && n(T, function(G, z) {
            X && X[z] !== G && (f[z] = G, F = !0);
          }), F) {
            if (X && (T = h(X, f)), T) {
              if (T.width === null || T.width === "auto")
                delete this.textWidth;
              else if (m.nodeName.toLowerCase() === "text" && T.width)
                var Q = this.textWidth = A(T.width);
            }
            if (this.styles = T, Q && !u && this.renderer.forExport && delete T.width, m.namespaceURI === this.SVG_NS) {
              var k = function(G, z) {
                return "-" + z.toLowerCase();
              };
              n(T, function(G, z) {
                L.indexOf(z) === -1 && (Y += z.replace(/([A-Z])/g, k) + ":" + G + ";");
              }), Y && B(m, "style", Y);
            } else
              b(m, T);
            this.added && (this.element.nodeName === "text" && this.renderer.buildText(this), T && T.textOutline && this.applyTextOutline(T.textOutline));
          }
          return this;
        }, j.prototype.dashstyleSetter = function(T) {
          var X = this["stroke-width"];
          if (X === "inherit" && (X = 1), T = T && T.toLowerCase()) {
            var f = T.replace("shortdashdotdot", "3,1,1,1,1,1,").replace("shortdashdot", "3,1,1,1").replace("shortdot", "1,1,").replace("shortdash", "3,1,").replace("longdash", "8,3,").replace(/dot/g, "1,3,").replace("dash", "4,3,").replace(/,$/, "").split(",");
            for (T = f.length; T--; )
              f[T] = "" + A(f[T]) * o(X, NaN);
            T = f.join(",").replace(/NaN/g, "none"), this.element.setAttribute("stroke-dasharray", T);
          }
        }, j.prototype.destroy = function() {
          var T = this, X = T.element || {}, f = T.renderer, m = X.ownerSVGElement, L = f.isSVG && X.nodeName === "SPAN" && T.parentGroup || void 0;
          if (X.onclick = X.onmouseout = X.onmouseover = X.onmousemove = X.point = null, W(T), T.clipPath && m) {
            var Y = T.clipPath;
            [].forEach.call(m.querySelectorAll("[clip-path],[CLIP-PATH]"), function(F) {
              -1 < F.getAttribute("clip-path").indexOf(Y.element.id) && F.removeAttribute("clip-path");
            }), T.clipPath = Y.destroy();
          }
          if (T.stops) {
            for (m = 0; m < T.stops.length; m++)
              T.stops[m].destroy();
            T.stops.length = 0, T.stops = void 0;
          }
          for (T.safeRemoveChild(X), f.styledMode || T.destroyShadows(); L && L.div && L.div.childNodes.length === 0; )
            X = L.parentGroup, T.safeRemoveChild(L.div), delete L.div, L = X;
          T.alignTo && x(f.alignedObjects, T), n(T, function(F, Q) {
            T[Q] && T[Q].parentGroup === T && T[Q].destroy && T[Q].destroy(), delete T[Q];
          });
        }, j.prototype.destroyShadows = function() {
          (this.shadows || []).forEach(function(T) {
            this.safeRemoveChild(T);
          }, this), this.shadows = void 0;
        }, j.prototype.destroyTextPath = function(T, X) {
          var f = T.getElementsByTagName("text")[0];
          if (f) {
            if (f.removeAttribute("dx"), f.removeAttribute("dy"), X.element.setAttribute("id", ""), this.textPathWrapper && f.getElementsByTagName("textPath").length) {
              for (T = this.textPathWrapper.element.childNodes; T.length; )
                f.appendChild(T[0]);
              f.removeChild(this.textPathWrapper.element);
            }
          } else
            (T.getAttribute("dx") || T.getAttribute("dy")) && (T.removeAttribute("dx"), T.removeAttribute("dy"));
          this.textPathWrapper && (this.textPathWrapper = this.textPathWrapper.destroy());
        }, j.prototype.dSetter = function(T, X, f) {
          p(T) && (typeof T[0] == "string" && (T = this.renderer.pathToSegments(T)), this.pathArray = T, T = T.reduce(function(m, L, Y) {
            return L && L.join ? (Y ? m + " " : "") + L.join(" ") : (L || "").toString();
          }, "")), /(NaN| {2}|^$)/.test(T) && (T = "M 0 0"), this[X] !== T && (f.setAttribute(X, T), this[X] = T);
        }, j.prototype.fadeOut = function(T) {
          var X = this;
          X.animate({ opacity: 0 }, { duration: o(T, 150), complete: function() {
            X.attr({ y: -9999 }).hide();
          } });
        }, j.prototype.fillSetter = function(T, X, f) {
          typeof T == "string" ? f.setAttribute(X, T) : T && this.complexColor(T, X, f);
        }, j.prototype.getBBox = function(T, X) {
          var f = this.renderer, m = this.element, L = this.styles, Y = this.textStr, F = f.cache, Q = f.cacheKeys, k = m.namespaceURI === this.SVG_NS;
          X = o(X, this.rotation, 0);
          var G = f.styledMode ? m && j.prototype.getStyle.call(m, "font-size") : L && L.fontSize, z;
          if (w(Y)) {
            var V = Y.toString();
            V.indexOf("<") === -1 && (V = V.replace(/[0-9]/g, "0")), V += ["", X, G, this.textWidth, L && L.textOverflow, L && L.fontWeight].join();
          }
          if (V && !T && (z = F[V]), !z) {
            if (k || f.forExport) {
              try {
                var q = this.fakeTS && function(it) {
                  var et = m.querySelector(".highcharts-text-outline");
                  et && b(et, { display: it });
                };
                i(q) && q("none"), z = m.getBBox ? h({}, m.getBBox()) : { width: m.offsetWidth, height: m.offsetHeight }, i(q) && q("");
              } catch {
              }
              (!z || 0 > z.width) && (z = {
                width: 0,
                height: 0
              });
            } else
              z = this.htmlGetBBox();
            if (f.isSVG && (T = z.width, f = z.height, k && (z.height = f = { "11px,17": 14, "13px,20": 16 }[(G || "") + "," + Math.round(f)] || f), X && (k = X * N, z.width = Math.abs(f * Math.sin(k)) + Math.abs(T * Math.cos(k)), z.height = Math.abs(f * Math.cos(k)) + Math.abs(T * Math.sin(k)))), V && (Y === "" || 0 < z.height)) {
              for (; 250 < Q.length; )
                delete F[Q.shift()];
              F[V] || Q.push(V), F[V] = z;
            }
          }
          return z;
        }, j.prototype.getStyle = function(T) {
          return P.getComputedStyle(this.element || this, "").getPropertyValue(T);
        }, j.prototype.hasClass = function(T) {
          return ("" + this.attr("class")).split(" ").indexOf(T) !== -1;
        }, j.prototype.hide = function(T) {
          return T ? this.attr({ y: -9999 }) : this.attr({ visibility: "hidden" }), this;
        }, j.prototype.htmlGetBBox = function() {
          return { height: 0, width: 0, x: 0, y: 0 };
        }, j.prototype.init = function(T, X) {
          this.element = X === "span" ? C(X) : M.createElementNS(this.SVG_NS, X), this.renderer = T, c(this, "afterInit");
        }, j.prototype.invert = function(T) {
          return this.inverted = T, this.updateTransform(), this;
        }, j.prototype.on = function(T, X) {
          var f = this.onEvents;
          return f[T] && f[T](), f[T] = O(
            this.element,
            T,
            X
          ), this;
        }, j.prototype.opacitySetter = function(T, X, f) {
          this.opacity = T = Number(Number(T).toFixed(3)), f.setAttribute(X, T);
        }, j.prototype.removeClass = function(T) {
          return this.attr("class", ("" + this.attr("class")).replace(s(T) ? new RegExp("(^| )" + T + "( |$)") : T, " ").replace(/ +/g, " ").trim());
        }, j.prototype.removeTextOutline = function() {
          var T = this.element.querySelector("tspan.highcharts-text-outline");
          T && this.safeRemoveChild(T);
        }, j.prototype.safeRemoveChild = function(T) {
          var X = T.parentNode;
          X && X.removeChild(T);
        }, j.prototype.setRadialReference = function(T) {
          var X = this.element.gradient && this.renderer.gradients[this.element.gradient];
          return this.element.radialReference = T, X && X.radAttr && X.animate(this.renderer.getRadialAttr(T, X.radAttr)), this;
        }, j.prototype.setTextPath = function(T, X) {
          var f = this.element, m = this.text ? this.text.element : f, L = { textAnchor: "text-anchor" }, Y = !1, F = this.textPathWrapper, Q = !F;
          X = t(!0, { enabled: !0, attributes: { dy: -5, startOffset: "50%", textAnchor: "middle" } }, X);
          var k = R.filterUserAttributes(X.attributes);
          if (T && X && X.enabled) {
            F && F.element.parentNode === null ? (Q = !0, F = F.destroy()) : F && this.removeTextOutline.call(F.parentGroup), this.options && this.options.padding && (k.dx = -this.options.padding), F || (this.textPathWrapper = F = this.renderer.createElement("textPath"), Y = !0);
            var G = F.element;
            if ((X = T.element.getAttribute("id")) || T.element.setAttribute("id", X = D()), Q)
              for (m.setAttribute("y", 0), l(k.dx) && m.setAttribute("x", -k.dx), T = [].slice.call(m.childNodes), Q = 0; Q < T.length; Q++) {
                var z = T[Q];
                z.nodeType !== P.Node.TEXT_NODE && z.nodeName !== "tspan" || G.appendChild(z);
              }
            Y && F && F.add({ element: m }), G.setAttributeNS("http://www.w3.org/1999/xlink", "href", this.renderer.url + "#" + X), w(k.dy) && (G.parentNode.setAttribute("dy", k.dy), delete k.dy), w(k.dx) && (G.parentNode.setAttribute("dx", k.dx), delete k.dx), n(k, function(V, q) {
              G.setAttribute(L[q] || q, V);
            }), f.removeAttribute("transform"), this.removeTextOutline.call(F), this.text && !this.renderer.styledMode && this.attr({ fill: "none", "stroke-width": 0 }), this.applyTextOutline = this.updateTransform = v;
          } else
            F && (delete this.updateTransform, delete this.applyTextOutline, this.destroyTextPath(f, T), this.updateTransform(), this.options && this.options.rotation && this.applyTextOutline(this.options.style.textOutline));
          return this;
        }, j.prototype.shadow = function(T, X, f) {
          var m = [], L = this.element, Y = this.oldShadowOptions, F = { color: "#000000", offsetX: this.parentInverted ? -1 : 1, offsetY: this.parentInverted ? -1 : 1, opacity: 0.15, width: 3 }, Q = !1, k;
          if (T === !0 ? k = F : typeof T == "object" && (k = h(F, T)), k && (k && Y && n(k, function(it, et) {
            it !== Y[et] && (Q = !0);
          }), Q && this.destroyShadows(), this.oldShadowOptions = k), !k)
            this.destroyShadows();
          else if (!this.shadows) {
            var G = k.opacity / k.width, z = this.parentInverted ? "translate(" + k.offsetY + ", " + k.offsetX + ")" : "translate(" + k.offsetX + ", " + k.offsetY + ")";
            for (F = 1; F <= k.width; F++) {
              var V = L.cloneNode(!1), q = 2 * k.width + 1 - 2 * F;
              B(V, { stroke: T.color || "#000000", "stroke-opacity": G * F, "stroke-width": q, transform: z, fill: "none" }), V.setAttribute("class", (V.getAttribute("class") || "") + " highcharts-shadow"), f && (B(V, "height", Math.max(B(V, "height") - q, 0)), V.cutHeight = q), X ? X.element.appendChild(V) : L.parentNode && L.parentNode.insertBefore(V, L), m.push(V);
            }
            this.shadows = m;
          }
          return this;
        }, j.prototype.show = function(T) {
          return this.attr({ visibility: T ? "inherit" : "visible" });
        }, j.prototype.strokeSetter = function(T, X, f) {
          this[X] = T, this.stroke && this["stroke-width"] ? (j.prototype.fillSetter.call(this, this.stroke, "stroke", f), f.setAttribute("stroke-width", this["stroke-width"]), this.hasStroke = !0) : X === "stroke-width" && T === 0 && this.hasStroke ? (f.removeAttribute("stroke"), this.hasStroke = !1) : this.renderer.styledMode && this["stroke-width"] && (f.setAttribute("stroke-width", this["stroke-width"]), this.hasStroke = !0);
        }, j.prototype.strokeWidth = function() {
          if (!this.renderer.styledMode)
            return this["stroke-width"] || 0;
          var T = this.getStyle("stroke-width"), X = 0;
          if (T.indexOf("px") === T.length - 2)
            X = A(T);
          else if (T !== "") {
            var f = M.createElementNS(d, "rect");
            B(f, { width: T, "stroke-width": 0 }), this.element.parentNode.appendChild(f), X = f.getBBox().width, f.parentNode.removeChild(f);
          }
          return X;
        }, j.prototype.symbolAttr = function(T) {
          var X = this;
          "x y r start end width height innerR anchorX anchorY clockwise".split(" ").forEach(function(f) {
            X[f] = o(T[f], X[f]);
          }), X.attr({ d: X.renderer.symbols[X.symbolName](X.x, X.y, X.width, X.height, X) });
        }, j.prototype.textSetter = function(T) {
          T !== this.textStr && (delete this.textPxLength, this.textStr = T, this.added && this.renderer.buildText(this));
        }, j.prototype.titleSetter = function(T) {
          var X = this.element, f = X.getElementsByTagName("title")[0] || M.createElementNS(this.SVG_NS, "title");
          X.insertBefore ? X.insertBefore(f, X.firstChild) : X.appendChild(f), f.textContent = String(o(T, "")).replace(/<[^>]*>/g, "").replace(/&lt;/g, "<").replace(
            /&gt;/g,
            ">"
          );
        }, j.prototype.toFront = function() {
          var T = this.element;
          return T.parentNode.appendChild(T), this;
        }, j.prototype.translate = function(T, X) {
          return this.attr({ translateX: T, translateY: X });
        }, j.prototype.updateShadows = function(T, X, f) {
          var m = this.shadows;
          if (m)
            for (var L = m.length; L--; )
              f.call(m[L], T === "height" ? Math.max(X - (m[L].cutHeight || 0), 0) : T === "d" ? this.d : X, T, m[L]);
        }, j.prototype.updateTransform = function() {
          var T = this.scaleX, X = this.scaleY, f = this.inverted, m = this.rotation, L = this.matrix, Y = this.element, F = this.translateX || 0, Q = this.translateY || 0;
          f && (F += this.width, Q += this.height), F = ["translate(" + F + "," + Q + ")"], w(L) && F.push("matrix(" + L.join(",") + ")"), f ? F.push("rotate(90) scale(-1,1)") : m && F.push("rotate(" + m + " " + o(this.rotationOriginX, Y.getAttribute("x"), 0) + " " + o(this.rotationOriginY, Y.getAttribute("y") || 0) + ")"), (w(T) || w(X)) && F.push("scale(" + o(T, 1) + " " + o(X, 1) + ")"), F.length && Y.setAttribute("transform", F.join(" "));
        }, j.prototype.visibilitySetter = function(T, X, f) {
          T === "inherit" ? f.removeAttribute(X) : this[X] !== T && f.setAttribute(
            X,
            T
          ), this[X] = T;
        }, j.prototype.xGetter = function(T) {
          return this.element.nodeName === "circle" && (T === "x" ? T = "cx" : T === "y" && (T = "cy")), this._defaultGetter(T);
        }, j.prototype.zIndexSetter = function(T, X) {
          var f = this.renderer, m = this.parentGroup, L = (m || f).element || f.box, Y = this.element;
          f = L === f.box;
          var F = !1, Q = this.added, k;
          if (w(T) ? (Y.setAttribute("data-z-index", T), T = +T, this[X] === T && (Q = !1)) : w(this[X]) && Y.removeAttribute("data-z-index"), this[X] = T, Q) {
            for ((T = this.zIndex) && m && (m.handleZ = !0), X = L.childNodes, k = X.length - 1; 0 <= k && !F; k--) {
              m = X[k], Q = m.getAttribute("data-z-index");
              var G = !w(Q);
              m !== Y && (0 > T && G && !f && !k ? (L.insertBefore(Y, X[k]), F = !0) : (A(Q) <= T || G && (!w(T) || 0 <= T)) && (L.insertBefore(Y, X[k + 1] || null), F = !0));
            }
            F || (L.insertBefore(Y, X[f ? 3 : 0] || null), F = !0);
          }
          return F;
        }, j;
      }(), y.prototype["stroke-widthSetter"] = y.prototype.strokeSetter, y.prototype.yGetter = y.prototype.xGetter, y.prototype.matrixSetter = y.prototype.rotationOriginXSetter = y.prototype.rotationOriginYSetter = y.prototype.rotationSetter = y.prototype.scaleXSetter = y.prototype.scaleYSetter = y.prototype.translateXSetter = y.prototype.translateYSetter = y.prototype.verticalAlignSetter = function(j, T) {
        this[T] = j, this.doTransform = !0;
      }, y;
    }), E(a, "Core/Renderer/RendererRegistry.js", [a["Core/Globals.js"]], function(y) {
      var R;
      return function(I) {
        I.rendererTypes = {};
        var Z;
        I.getRendererType = function(H) {
          return H === void 0 && (H = Z), I.rendererTypes[H] || I.rendererTypes[Z];
        }, I.registerRendererType = function(H, $, U) {
          I.rendererTypes[H] = $, (!Z || U) && (Z = H, y.Renderer = $);
        };
      }(R || (R = {})), R;
    }), E(
      a,
      "Core/Renderer/SVG/SVGLabel.js",
      [a["Core/Renderer/SVG/SVGElement.js"], a["Core/Utilities.js"]],
      function(y, R) {
        var I = this && this.__extends || function() {
          var M = function(v, u) {
            return M = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d, P) {
              d.__proto__ = P;
            } || function(d, P) {
              for (var O in P)
                P.hasOwnProperty(O) && (d[O] = P[O]);
            }, M(v, u);
          };
          return function(v, u) {
            function d() {
              this.constructor = v;
            }
            M(v, u), v.prototype = u === null ? Object.create(u) : (d.prototype = u.prototype, new d());
          };
        }(), Z = R.defined, H = R.extend, $ = R.isNumber, U = R.merge, W = R.pick, N = R.removeEvent;
        return function(M) {
          function v(u, d, P, O, B, C, b, w, x, h) {
            var c = M.call(this) || this;
            c.paddingLeftSetter = c.paddingSetter, c.paddingRightSetter = c.paddingSetter, c.init(u, "g"), c.textStr = d, c.x = P, c.y = O, c.anchorX = C, c.anchorY = b, c.baseline = x, c.className = h, c.addClass(h === "button" ? "highcharts-no-tooltip" : "highcharts-label"), h && c.addClass("highcharts-" + h), c.text = u.text(void 0, 0, 0, w).attr({ zIndex: 1 });
            var p;
            return typeof B == "string" && ((p = /^url\((.*?)\)$/.test(B)) || c.renderer.symbols[B]) && (c.symbolKey = B), c.bBox = v.emptyBBox, c.padding = 3, c.baselineOffset = 0, c.needsBox = u.styledMode || p, c.deferredAttr = {}, c.alignFactor = 0, c;
          }
          return I(v, M), v.prototype.alignSetter = function(u) {
            u = { left: 0, center: 0.5, right: 1 }[u], u !== this.alignFactor && (this.alignFactor = u, this.bBox && $(this.xSetting) && this.attr({ x: this.xSetting }));
          }, v.prototype.anchorXSetter = function(u, d) {
            this.anchorX = u, this.boxAttr(d, Math.round(u) - this.getCrispAdjust() - this.xSetting);
          }, v.prototype.anchorYSetter = function(u, d) {
            this.anchorY = u, this.boxAttr(d, u - this.ySetting);
          }, v.prototype.boxAttr = function(u, d) {
            this.box ? this.box.attr(u, d) : this.deferredAttr[u] = d;
          }, v.prototype.css = function(u) {
            if (u) {
              var d = {};
              u = U(u), v.textProps.forEach(function(O) {
                typeof u[O] < "u" && (d[O] = u[O], delete u[O]);
              }), this.text.css(d);
              var P = "width" in d;
              "fontSize" in d || "fontWeight" in d ? this.updateTextPadding() : P && this.updateBoxSize();
            }
            return y.prototype.css.call(this, u);
          }, v.prototype.destroy = function() {
            N(this.element, "mouseenter"), N(this.element, "mouseleave"), this.text && this.text.destroy(), this.box && (this.box = this.box.destroy()), y.prototype.destroy.call(this);
          }, v.prototype.fillSetter = function(u, d) {
            u && (this.needsBox = !0), this.fill = u, this.boxAttr(d, u);
          }, v.prototype.getBBox = function() {
            this.textStr && this.bBox.width === 0 && this.bBox.height === 0 && this.updateBoxSize();
            var u = this.padding, d = W(this.paddingLeft, u);
            return { width: this.width, height: this.height, x: this.bBox.x - d, y: this.bBox.y - u };
          }, v.prototype.getCrispAdjust = function() {
            return this.renderer.styledMode && this.box ? this.box.strokeWidth() % 2 / 2 : (this["stroke-width"] ? parseInt(
              this["stroke-width"],
              10
            ) : 0) % 2 / 2;
          }, v.prototype.heightSetter = function(u) {
            this.heightSetting = u;
          }, v.prototype.onAdd = function() {
            var u = this.textStr;
            this.text.add(this), this.attr({ text: Z(u) ? u : "", x: this.x, y: this.y }), this.box && Z(this.anchorX) && this.attr({ anchorX: this.anchorX, anchorY: this.anchorY });
          }, v.prototype.paddingSetter = function(u, d) {
            $(u) ? u !== this[d] && (this[d] = u, this.updateTextPadding()) : this[d] = void 0;
          }, v.prototype.rSetter = function(u, d) {
            this.boxAttr(d, u);
          }, v.prototype.shadow = function(u) {
            return u && !this.renderer.styledMode && (this.updateBoxSize(), this.box && this.box.shadow(u)), this;
          }, v.prototype.strokeSetter = function(u, d) {
            this.stroke = u, this.boxAttr(d, u);
          }, v.prototype["stroke-widthSetter"] = function(u, d) {
            u && (this.needsBox = !0), this["stroke-width"] = u, this.boxAttr(d, u);
          }, v.prototype["text-alignSetter"] = function(u) {
            this.textAlign = u;
          }, v.prototype.textSetter = function(u) {
            typeof u < "u" && this.text.attr({ text: u }), this.updateTextPadding();
          }, v.prototype.updateBoxSize = function() {
            var u = this.text.element.style, d = {}, P = this.padding, O = this.bBox = $(this.widthSetting) && $(this.heightSetting) && !this.textAlign || !Z(this.text.textStr) ? v.emptyBBox : this.text.getBBox();
            this.width = this.getPaddedWidth(), this.height = (this.heightSetting || O.height || 0) + 2 * P, u = this.renderer.fontMetrics(u && u.fontSize, this.text), this.baselineOffset = P + Math.min((this.text.firstLineMetrics || u).b, O.height || 1 / 0), this.heightSetting && (this.baselineOffset += (this.heightSetting - u.h) / 2), this.needsBox && (this.box || (P = this.box = this.symbolKey ? this.renderer.symbol(this.symbolKey) : this.renderer.rect(), P.addClass((this.className === "button" ? "" : "highcharts-label-box") + (this.className ? " highcharts-" + this.className + "-box" : "")), P.add(this)), P = this.getCrispAdjust(), d.x = P, d.y = (this.baseline ? -this.baselineOffset : 0) + P, d.width = Math.round(this.width), d.height = Math.round(this.height), this.box.attr(H(d, this.deferredAttr)), this.deferredAttr = {});
          }, v.prototype.updateTextPadding = function() {
            var u = this.text;
            this.updateBoxSize();
            var d = this.baseline ? 0 : this.baselineOffset, P = W(this.paddingLeft, this.padding);
            Z(this.widthSetting) && this.bBox && (this.textAlign === "center" || this.textAlign === "right") && (P += { center: 0.5, right: 1 }[this.textAlign] * (this.widthSetting - this.bBox.width)), (P !== u.x || d !== u.y) && (u.attr("x", P), u.hasBoxWidthChanged && (this.bBox = u.getBBox(!0)), typeof d < "u" && u.attr("y", d)), u.x = P, u.y = d;
          }, v.prototype.widthSetter = function(u) {
            this.widthSetting = $(u) ? u : void 0;
          }, v.prototype.getPaddedWidth = function() {
            var u = this.padding, d = W(this.paddingLeft, u);
            return u = W(this.paddingRight, u), (this.widthSetting || this.bBox.width || 0) + d + u;
          }, v.prototype.xSetter = function(u) {
            this.x = u, this.alignFactor && (u -= this.alignFactor * this.getPaddedWidth(), this["forceAnimate:x"] = !0), this.xSetting = Math.round(u), this.attr("translateX", this.xSetting);
          }, v.prototype.ySetter = function(u) {
            this.ySetting = this.y = Math.round(u), this.attr("translateY", this.ySetting);
          }, v.emptyBBox = { width: 0, height: 0, x: 0, y: 0 }, v.textProps = "color direction fontFamily fontSize fontStyle fontWeight lineHeight textAlign textDecoration textOutline textOverflow width".split(" "), v;
        }(y);
      }
    ), E(
      a,
      "Core/Renderer/SVG/Symbols.js",
      [a["Core/Utilities.js"]],
      function(y) {
        function R(W, N, M, v, u) {
          var d = [];
          if (u) {
            var P = u.start || 0, O = U(u.r, M);
            M = U(u.r, v || M);
            var B = (u.end || 0) - 1e-3;
            v = u.innerR;
            var C = U(u.open, 1e-3 > Math.abs((u.end || 0) - P - 2 * Math.PI)), b = Math.cos(P), w = Math.sin(P), x = Math.cos(B), h = Math.sin(B);
            P = U(u.longArc, 1e-3 > B - P - Math.PI ? 0 : 1), d.push(["M", W + O * b, N + M * w], ["A", O, M, 0, P, U(u.clockwise, 1), W + O * x, N + M * h]), H(v) && d.push(C ? ["M", W + v * x, N + v * h] : ["L", W + v * x, N + v * h], ["A", v, v, 0, P, H(u.clockwise) ? 1 - u.clockwise : 0, W + v * b, N + v * w]), C || d.push(["Z"]);
          }
          return d;
        }
        function I(W, N, M, v, u) {
          return u && u.r ? Z(W, N, M, v, u) : [["M", W, N], ["L", W + M, N], ["L", W + M, N + v], ["L", W, N + v], ["Z"]];
        }
        function Z(W, N, M, v, u) {
          return u = u && u.r || 0, [["M", W + u, N], ["L", W + M - u, N], ["C", W + M, N, W + M, N, W + M, N + u], ["L", W + M, N + v - u], ["C", W + M, N + v, W + M, N + v, W + M - u, N + v], ["L", W + u, N + v], ["C", W, N + v, W, N + v, W, N + v - u], ["L", W, N + u], ["C", W, N, W, N, W + u, N]];
        }
        var H = y.defined, $ = y.isNumber, U = y.pick;
        return { arc: R, callout: function(W, N, M, v, u) {
          var d = Math.min(u && u.r || 0, M, v), P = d + 6, O = u && u.anchorX;
          u = u && u.anchorY || 0;
          var B = Z(W, N, M, v, { r: d });
          return $(O) && (W + O >= M ? u > N + P && u < N + v - P ? B.splice(3, 1, ["L", W + M, u - 6], ["L", W + M + 6, u], ["L", W + M, u + 6], ["L", W + M, N + v - d]) : B.splice(3, 1, ["L", W + M, v / 2], ["L", O, u], ["L", W + M, v / 2], ["L", W + M, N + v - d]) : 0 >= W + O ? u > N + P && u < N + v - P ? B.splice(7, 1, ["L", W, u + 6], ["L", W - 6, u], ["L", W, u - 6], ["L", W, N + d]) : B.splice(7, 1, ["L", W, v / 2], ["L", O, u], ["L", W, v / 2], ["L", W, N + d]) : u && u > v && O > W + P && O < W + M - P ? B.splice(5, 1, ["L", O + 6, N + v], ["L", O, N + v + 6], ["L", O - 6, N + v], ["L", W + d, N + v]) : u && 0 > u && O > W + P && O < W + M - P && B.splice(1, 1, ["L", O - 6, N], ["L", O, N - 6], ["L", O + 6, N], ["L", M - d, N])), B;
        }, circle: function(W, N, M, v) {
          return R(W + M / 2, N + v / 2, M / 2, v / 2, { start: 0.5 * Math.PI, end: 2.5 * Math.PI, open: !1 });
        }, diamond: function(W, N, M, v) {
          return [["M", W + M / 2, N], ["L", W + M, N + v / 2], ["L", W + M / 2, N + v], ["L", W, N + v / 2], ["Z"]];
        }, rect: I, roundedRect: Z, square: I, triangle: function(W, N, M, v) {
          return [["M", W + M / 2, N], ["L", W + M, N + v], ["L", W, N + v], ["Z"]];
        }, "triangle-down": function(W, N, M, v) {
          return [["M", W, N], ["L", W + M, N], ["L", W + M / 2, N + v], ["Z"]];
        } };
      }
    ), E(a, "Core/Renderer/SVG/TextBuilder.js", [a["Core/Renderer/HTML/AST.js"], a["Core/Globals.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = R.doc, H = R.SVG_NS, $ = R.win, U = I.attr, W = I.isString, N = I.objectEach, M = I.pick;
      return function() {
        function v(u) {
          var d = u.styles;
          this.renderer = u.renderer, this.svgElement = u, this.width = u.textWidth, this.textLineHeight = d && d.lineHeight, this.textOutline = d && d.textOutline, this.ellipsis = !(!d || d.textOverflow !== "ellipsis"), this.noWrap = !(!d || d.whiteSpace !== "nowrap"), this.fontSize = d && d.fontSize;
        }
        return v.prototype.buildSVG = function() {
          var u = this.svgElement, d = u.element, P = u.renderer, O = M(u.textStr, "").toString(), B = O.indexOf("<") !== -1, C = d.childNodes;
          P = this.width && !u.added && P.box;
          var b = /<br.*?>/g, w = [O, this.ellipsis, this.noWrap, this.textLineHeight, this.textOutline, this.fontSize, this.width].join();
          if (w !== u.textCache) {
            for (u.textCache = w, delete u.actualWidth, w = C.length; w--; )
              d.removeChild(C[w]);
            B || this.ellipsis || this.width || O.indexOf(" ") !== -1 && (!this.noWrap || b.test(O)) ? O !== "" && (P && P.appendChild(d), O = new y(O), this.modifyTree(O.nodes), O.addToDOM(u.element), this.modifyDOM(), this.ellipsis && (d.textContent || "").indexOf("…") !== -1 && u.attr(
              "title",
              this.unescapeEntities(u.textStr || "", ["&lt;", "&gt;"])
            ), P && P.removeChild(d)) : d.appendChild(Z.createTextNode(this.unescapeEntities(O))), W(this.textOutline) && u.applyTextOutline && u.applyTextOutline(this.textOutline);
          }
        }, v.prototype.modifyDOM = function() {
          var u = this, d = this.svgElement, P = U(d.element, "x");
          d.firstLineMetrics = void 0;
          for (var O; (O = d.element.firstChild) && /^[\s\u200B]*$/.test(O.textContent || " "); )
            d.element.removeChild(O);
          [].forEach.call(d.element.querySelectorAll("tspan.highcharts-br"), function(w, x) {
            w.nextSibling && w.previousSibling && (x === 0 && w.previousSibling.nodeType === 1 && (d.firstLineMetrics = d.renderer.fontMetrics(void 0, w.previousSibling)), U(w, { dy: u.getLineHeight(w.nextSibling), x: P }));
          });
          var B = this.width || 0;
          if (B) {
            var C = function(w, x) {
              var h = w.textContent || "", c = h.replace(/([^\^])-/g, "$1- ").split(" "), p = !u.noWrap && (1 < c.length || 1 < d.element.childNodes.length), i = u.getLineHeight(x), l = 0, s = d.actualWidth;
              if (u.ellipsis)
                h && u.truncate(w, h, void 0, 0, Math.max(0, B - parseInt(u.fontSize || 12, 10)), function(t, n) {
                  return t.substring(
                    0,
                    n
                  ) + "…";
                });
              else if (p) {
                for (h = [], p = []; x.firstChild && x.firstChild !== w; )
                  p.push(x.firstChild), x.removeChild(x.firstChild);
                for (; c.length; )
                  c.length && !u.noWrap && 0 < l && (h.push(w.textContent || ""), w.textContent = c.join(" ").replace(/- /g, "-")), u.truncate(w, void 0, c, l === 0 && s || 0, B, function(t, n) {
                    return c.slice(0, n).join(" ").replace(/- /g, "-");
                  }), s = d.actualWidth, l++;
                p.forEach(function(t) {
                  x.insertBefore(t, w);
                }), h.forEach(function(t) {
                  x.insertBefore(Z.createTextNode(t), w), t = Z.createElementNS(H, "tspan"), t.textContent = "​", U(t, { dy: i, x: P }), x.insertBefore(t, w);
                });
              }
            }, b = function(w) {
              [].slice.call(w.childNodes).forEach(function(x) {
                x.nodeType === $.Node.TEXT_NODE ? C(x, w) : (x.className.baseVal.indexOf("highcharts-br") !== -1 && (d.actualWidth = 0), b(x));
              });
            };
            b(d.element);
          }
        }, v.prototype.getLineHeight = function(u) {
          var d;
          return u = u.nodeType === $.Node.TEXT_NODE ? u.parentElement : u, this.renderer.styledMode || (d = u && /(px|em)$/.test(u.style.fontSize) ? u.style.fontSize : this.fontSize || this.renderer.style.fontSize || 12), this.textLineHeight ? parseInt(
            this.textLineHeight.toString(),
            10
          ) : this.renderer.fontMetrics(d, u || this.svgElement.element).h;
        }, v.prototype.modifyTree = function(u) {
          var d = this, P = function(O, B) {
            var C = O.attributes;
            C = C === void 0 ? {} : C;
            var b = O.children, w = O.tagName, x = d.renderer.styledMode;
            w === "b" || w === "strong" ? x ? C.class = "highcharts-strong" : C.style = "font-weight:bold;" + (C.style || "") : (w === "i" || w === "em") && (x ? C.class = "highcharts-emphasized" : C.style = "font-style:italic;" + (C.style || "")), W(C.style) && (C.style = C.style.replace(/(;| |^)color([ :])/, "$1fill$2")), w === "br" ? (C.class = "highcharts-br", O.textContent = "​", (B = u[B + 1]) && B.textContent && (B.textContent = B.textContent.replace(/^ +/gm, ""))) : w === "a" && b && b.some(function(h) {
              return h.tagName === "#text";
            }) && (O.children = [{ children: b, tagName: "tspan" }]), w !== "#text" && w !== "a" && (O.tagName = "tspan"), O.attributes = C, b && b.filter(function(h) {
              return h.tagName !== "#text";
            }).forEach(P);
          };
          u.forEach(P);
        }, v.prototype.truncate = function(u, d, P, O, B, C) {
          var b = this.svgElement, w = b.renderer, x = b.rotation, h = [], c = P ? 1 : 0, p = (d || P || "").length, i = p, l, s = function(n, o) {
            o = o || n;
            var A = u.parentNode;
            if (A && typeof h[o] > "u")
              if (A.getSubStringLength)
                try {
                  h[o] = O + A.getSubStringLength(0, P ? o + 1 : o);
                } catch {
                }
              else
                w.getSpanWidth && (u.textContent = C(d || P, n), h[o] = O + w.getSpanWidth(b, u));
            return h[o];
          };
          b.rotation = 0;
          var t = s(u.textContent.length);
          if (O + t > B) {
            for (; c <= p; )
              i = Math.ceil((c + p) / 2), P && (l = C(P, i)), t = s(i, l && l.length - 1), c === p ? c = p + 1 : t > B ? p = i - 1 : c = i;
            p === 0 ? u.textContent = "" : d && p === d.length - 1 || (u.textContent = l || C(d || P, i));
          }
          P && P.splice(0, i), b.actualWidth = t, b.rotation = x;
        }, v.prototype.unescapeEntities = function(u, d) {
          return N(this.renderer.escapes, function(P, O) {
            d && d.indexOf(P) !== -1 || (u = u.toString().replace(new RegExp(P, "g"), O));
          }), u;
        }, v;
      }();
    }), E(a, "Core/Renderer/SVG/SVGRenderer.js", [a["Core/Renderer/HTML/AST.js"], a["Core/Color/Color.js"], a["Core/Globals.js"], a["Core/Renderer/RendererRegistry.js"], a["Core/Renderer/SVG/SVGElement.js"], a["Core/Renderer/SVG/SVGLabel.js"], a["Core/Renderer/SVG/Symbols.js"], a["Core/Renderer/SVG/TextBuilder.js"], a["Core/Utilities.js"]], function(y, R, I, Z, H, $, U, W, N) {
      var M = I.charts, v = I.deg2rad, u = I.doc, d = I.isFirefox, P = I.isMS, O = I.isWebKit, B = I.noop, C = I.SVG_NS, b = I.symbolSizes, w = I.win, x = N.addEvent, h = N.attr, c = N.createElement, p = N.css, i = N.defined, l = N.destroyObjectProperties, s = N.extend, t = N.isArray, n = N.isNumber, o = N.isObject, A = N.isString, _ = N.merge, D = N.pick, j = N.pInt, T = N.uniqueKey, X;
      return I = function() {
        function f(m, L, Y, F, Q, k, G) {
          this.width = this.url = this.style = this.isSVG = this.imgCount = this.height = this.gradients = this.globalAnimation = this.defs = this.chartIndex = this.cacheKeys = this.cache = this.boxWrapper = this.box = this.alignedObjects = void 0, this.init(m, L, Y, F, Q, k, G);
        }
        return f.prototype.init = function(m, L, Y, F, Q, k, G) {
          var z = this.createElement("svg").attr({ version: "1.1", class: "highcharts-root" }), V = z.element;
          G || z.css(this.getStyle(F)), m.appendChild(V), h(m, "dir", "ltr"), m.innerHTML.indexOf("xmlns") === -1 && h(V, "xmlns", this.SVG_NS), this.isSVG = !0, this.box = V, this.boxWrapper = z, this.alignedObjects = [], this.url = this.getReferenceURL(), this.createElement("desc").add().element.appendChild(u.createTextNode("Created with Highcharts 9.3.3")), this.defs = this.createElement("defs").add(), this.allowHTML = k, this.forExport = Q, this.styledMode = G, this.gradients = {}, this.cache = {}, this.cacheKeys = [], this.imgCount = 0, this.setSize(L, Y, !1);
          var q;
          d && m.getBoundingClientRect && (L = function() {
            p(m, { left: 0, top: 0 }), q = m.getBoundingClientRect(), p(m, { left: Math.ceil(q.left) - q.left + "px", top: Math.ceil(q.top) - q.top + "px" });
          }, L(), this.unSubPixelFix = x(w, "resize", L));
        }, f.prototype.definition = function(m) {
          return new y([m]).addToDOM(this.defs.element);
        }, f.prototype.getReferenceURL = function() {
          if ((d || O) && u.getElementsByTagName("base").length) {
            if (!i(X)) {
              var m = T();
              m = new y([{ tagName: "svg", attributes: { width: 8, height: 8 }, children: [{ tagName: "defs", children: [{ tagName: "clipPath", attributes: { id: m }, children: [{ tagName: "rect", attributes: { width: 4, height: 4 } }] }] }, { tagName: "rect", attributes: { id: "hitme", width: 8, height: 8, "clip-path": "url(#" + m + ")", fill: "rgba(0,0,0,0.001)" } }] }]).addToDOM(u.body), p(m, { position: "fixed", top: 0, left: 0, zIndex: 9e5 });
              var L = u.elementFromPoint(6, 6);
              X = (L && L.id) === "hitme", u.body.removeChild(m);
            }
            if (X)
              return w.location.href.split("#")[0].replace(/<[^>]*>/g, "").replace(/([\('\)])/g, "\\$1").replace(/ /g, "%20");
          }
          return "";
        }, f.prototype.getStyle = function(m) {
          return this.style = s({ fontFamily: '"Lucida Grande", "Lucida Sans Unicode", Arial, Helvetica, sans-serif', fontSize: "12px" }, m);
        }, f.prototype.setStyle = function(m) {
          this.boxWrapper.css(this.getStyle(m));
        }, f.prototype.isHidden = function() {
          return !this.boxWrapper.getBBox().width;
        }, f.prototype.destroy = function() {
          var m = this.defs;
          return this.box = null, this.boxWrapper = this.boxWrapper.destroy(), l(this.gradients || {}), this.gradients = null, m && (this.defs = m.destroy()), this.unSubPixelFix && this.unSubPixelFix(), this.alignedObjects = null;
        }, f.prototype.createElement = function(m) {
          var L = new this.Element();
          return L.init(this, m), L;
        }, f.prototype.getRadialAttr = function(m, L) {
          return { cx: m[0] - m[2] / 2 + (L.cx || 0) * m[2], cy: m[1] - m[2] / 2 + (L.cy || 0) * m[2], r: (L.r || 0) * m[2] };
        }, f.prototype.buildText = function(m) {
          new W(m).buildSVG();
        }, f.prototype.getContrast = function(m) {
          return m = R.parse(m).rgba, m[0] *= 1, m[1] *= 1.2, m[2] *= 0.5, 459 < m[0] + m[1] + m[2] ? "#000000" : "#FFFFFF";
        }, f.prototype.button = function(m, L, Y, F, Q, k, G, z, V, q) {
          var it = this.label(m, L, Y, V, void 0, void 0, q, void 0, "button"), et = this.styledMode, nt = 0, rt = Q ? _(Q) : {};
          if (m = rt && rt.style || {}, rt = y.filterUserAttributes(rt), it.attr(_({ padding: 8, r: 2 }, rt)), !et) {
            rt = _({ fill: "#f7f7f7", stroke: "#cccccc", "stroke-width": 1, style: { color: "#333333", cursor: "pointer", fontWeight: "normal" } }, { style: m }, rt);
            var ct = rt.style;
            delete rt.style, k = _(rt, { fill: "#e6e6e6" }, y.filterUserAttributes(k || {}));
            var gt = k.style;
            delete k.style, G = _(rt, { fill: "#e6ebf5", style: { color: "#000000", fontWeight: "bold" } }, y.filterUserAttributes(G || {}));
            var dt = G.style;
            delete G.style, z = _(rt, { style: { color: "#cccccc" } }, y.filterUserAttributes(z || {}));
            var lt = z.style;
            delete z.style;
          }
          return x(it.element, P ? "mouseover" : "mouseenter", function() {
            nt !== 3 && it.setState(1);
          }), x(it.element, P ? "mouseout" : "mouseleave", function() {
            nt !== 3 && it.setState(nt);
          }), it.setState = function(at) {
            at !== 1 && (it.state = nt = at), it.removeClass(/highcharts-button-(normal|hover|pressed|disabled)/).addClass("highcharts-button-" + ["normal", "hover", "pressed", "disabled"][at || 0]), et || it.attr([rt, k, G, z][at || 0]).css([ct, gt, dt, lt][at || 0]);
          }, et || it.attr(rt).css(s({ cursor: "default" }, ct)), it.on("touchstart", function(at) {
            return at.stopPropagation();
          }).on("click", function(at) {
            nt !== 3 && F.call(it, at);
          });
        }, f.prototype.crispLine = function(m, L, Y) {
          Y === void 0 && (Y = "round");
          var F = m[0], Q = m[1];
          return i(F[1]) && F[1] === Q[1] && (F[1] = Q[1] = Math[Y](F[1]) - L % 2 / 2), i(F[2]) && F[2] === Q[2] && (F[2] = Q[2] = Math[Y](F[2]) + L % 2 / 2), m;
        }, f.prototype.path = function(m) {
          var L = this.styledMode ? {} : { fill: "none" };
          return t(m) ? L.d = m : o(m) && s(L, m), this.createElement("path").attr(L);
        }, f.prototype.circle = function(m, L, Y) {
          return m = o(m) ? m : typeof m > "u" ? {} : { x: m, y: L, r: Y }, L = this.createElement("circle"), L.xSetter = L.ySetter = function(F, Q, k) {
            k.setAttribute("c" + Q, F);
          }, L.attr(m);
        }, f.prototype.arc = function(m, L, Y, F, Q, k) {
          return o(m) ? (F = m, L = F.y, Y = F.r, m = F.x) : F = { innerR: F, start: Q, end: k }, m = this.symbol("arc", m, L, Y, Y, F), m.r = Y, m;
        }, f.prototype.rect = function(m, L, Y, F, Q, k) {
          Q = o(m) ? m.r : Q;
          var G = this.createElement("rect");
          return m = o(m) ? m : typeof m > "u" ? {} : { x: m, y: L, width: Math.max(Y, 0), height: Math.max(F, 0) }, this.styledMode || (typeof k < "u" && (m["stroke-width"] = k, m = G.crisp(m)), m.fill = "none"), Q && (m.r = Q), G.rSetter = function(z, V, q) {
            G.r = z, h(q, { rx: z, ry: z });
          }, G.rGetter = function() {
            return G.r || 0;
          }, G.attr(m);
        }, f.prototype.setSize = function(m, L, Y) {
          this.width = m, this.height = L, this.boxWrapper.animate({ width: m, height: L }, { step: function() {
            this.attr({ viewBox: "0 0 " + this.attr("width") + " " + this.attr("height") });
          }, duration: D(
            Y,
            !0
          ) ? void 0 : 0 }), this.alignElements();
        }, f.prototype.g = function(m) {
          var L = this.createElement("g");
          return m ? L.attr({ class: "highcharts-" + m }) : L;
        }, f.prototype.image = function(m, L, Y, F, Q, k) {
          var G = { preserveAspectRatio: "none" }, z = function(q, it) {
            q.setAttributeNS ? q.setAttributeNS("http://www.w3.org/1999/xlink", "href", it) : q.setAttribute("hc-svg-href", it);
          };
          n(L) && (G.x = L), n(Y) && (G.y = Y), n(F) && (G.width = F), n(Q) && (G.height = Q);
          var V = this.createElement("image").attr(G);
          return L = function(q) {
            z(V.element, m), k.call(V, q);
          }, k ? (z(
            V.element,
            "data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw=="
          ), Y = new w.Image(), x(Y, "load", L), Y.src = m, Y.complete && L({})) : z(V.element, m), V;
        }, f.prototype.symbol = function(m, L, Y, F, Q, k) {
          var G = this, z = /^url\((.*?)\)$/, V = z.test(m), q = !V && (this.symbols[m] ? m : "circle"), it = q && this.symbols[q], et;
          if (it) {
            typeof L == "number" && (et = it.call(this.symbols, Math.round(L || 0), Math.round(Y || 0), F || 0, Q || 0, k));
            var nt = this.path(et);
            G.styledMode || nt.attr("fill", "none"), s(nt, { symbolName: q || void 0, x: L, y: Y, width: F, height: Q }), k && s(nt, k);
          } else if (V) {
            var rt = m.match(z)[1], ct = nt = this.image(rt);
            ct.imgwidth = D(b[rt] && b[rt].width, k && k.width), ct.imgheight = D(b[rt] && b[rt].height, k && k.height);
            var gt = function(dt) {
              return dt.attr({ width: dt.width, height: dt.height });
            };
            ["width", "height"].forEach(function(dt) {
              ct[dt + "Setter"] = function(lt, at) {
                var J = this["img" + at];
                this[at] = lt, i(J) && (k && k.backgroundSize === "within" && this.width && this.height && (J = Math.round(J * Math.min(this.width / this.imgwidth, this.height / this.imgheight))), this.element && this.element.setAttribute(at, J), this.alignByTranslate || (lt = ((this[at] || 0) - J) / 2, this.attr(at === "width" ? { translateX: lt } : { translateY: lt })));
              };
            }), i(L) && ct.attr({ x: L, y: Y }), ct.isImg = !0, i(ct.imgwidth) && i(ct.imgheight) ? gt(ct) : (ct.attr({ width: 0, height: 0 }), c("img", { onload: function() {
              var dt = M[G.chartIndex];
              this.width === 0 && (p(this, { position: "absolute", top: "-999em" }), u.body.appendChild(this)), b[rt] = { width: this.width, height: this.height }, ct.imgwidth = this.width, ct.imgheight = this.height, ct.element && gt(ct), this.parentNode && this.parentNode.removeChild(this), G.imgCount--, !G.imgCount && dt && !dt.hasLoaded && dt.onload();
            }, src: rt }), this.imgCount++);
          }
          return nt;
        }, f.prototype.clipRect = function(m, L, Y, F) {
          var Q = T() + "-", k = this.createElement("clipPath").attr({ id: Q }).add(this.defs);
          return m = this.rect(m, L, Y, F, 0).add(k), m.id = Q, m.clipPath = k, m.count = 0, m;
        }, f.prototype.text = function(m, L, Y, F) {
          var Q = {};
          return F && (this.allowHTML || !this.forExport) ? this.html(m, L, Y) : (Q.x = Math.round(L || 0), Y && (Q.y = Math.round(Y)), i(m) && (Q.text = m), m = this.createElement("text").attr(Q), (!F || this.forExport && !this.allowHTML) && (m.xSetter = function(k, G, z) {
            for (var V = z.getElementsByTagName("tspan"), q = z.getAttribute(G), it = 0, et; it < V.length; it++)
              et = V[it], et.getAttribute(G) === q && et.setAttribute(G, k);
            z.setAttribute(G, k);
          }), m);
        }, f.prototype.fontMetrics = function(m, L) {
          return m = !this.styledMode && /px/.test(m) || !w.getComputedStyle ? m || L && L.style && L.style.fontSize || this.style && this.style.fontSize : L && H.prototype.getStyle.call(L, "font-size"), m = /px/.test(m) ? j(m) : 12, L = 24 > m ? m + 3 : Math.round(1.2 * m), { h: L, b: Math.round(0.8 * L), f: m };
        }, f.prototype.rotCorr = function(m, L, Y) {
          var F = m;
          return L && Y && (F = Math.max(F * Math.cos(L * v), 4)), { x: -m / 3 * Math.sin(L * v), y: F };
        }, f.prototype.pathToSegments = function(m) {
          for (var L = [], Y = [], F = { A: 8, C: 7, H: 2, L: 3, M: 3, Q: 5, S: 5, T: 3, V: 2 }, Q = 0; Q < m.length; Q++)
            A(Y[0]) && n(m[Q]) && Y.length === F[Y[0].toUpperCase()] && m.splice(Q, 0, Y[0].replace("M", "L").replace("m", "l")), typeof m[Q] == "string" && (Y.length && L.push(Y.slice(0)), Y.length = 0), Y.push(m[Q]);
          return L.push(Y.slice(0)), L;
        }, f.prototype.label = function(m, L, Y, F, Q, k, G, z, V) {
          return new $(this, m, L, Y, F, Q, k, G, z, V);
        }, f.prototype.alignElements = function() {
          this.alignedObjects.forEach(function(m) {
            return m.align();
          });
        }, f;
      }(), s(I.prototype, { Element: H, SVG_NS: C, escapes: { "&": "&amp;", "<": "&lt;", ">": "&gt;", "'": "&#39;", '"': "&quot;" }, symbols: U, draw: B }), Z.registerRendererType("svg", I, !0), I;
    }), E(a, "Core/Renderer/HTML/HTMLElement.js", [a["Core/Globals.js"], a["Core/Renderer/SVG/SVGElement.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = this && this.__extends || function() {
        var P = function(O, B) {
          return P = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(C, b) {
            C.__proto__ = b;
          } || function(C, b) {
            for (var w in b)
              b.hasOwnProperty(w) && (C[w] = b[w]);
          }, P(O, B);
        };
        return function(O, B) {
          function C() {
            this.constructor = O;
          }
          P(O, B), O.prototype = B === null ? Object.create(B) : (C.prototype = B.prototype, new C());
        };
      }(), H = y.isFirefox, $ = y.isMS, U = y.isWebKit, W = y.win, N = I.css, M = I.defined, v = I.extend, u = I.pick, d = I.pInt;
      return function(P) {
        function O() {
          return P !== null && P.apply(this, arguments) || this;
        }
        return Z(O, P), O.compose = function(B) {
          if (O.composedClasses.indexOf(B) === -1) {
            O.composedClasses.push(B);
            var C = O.prototype, b = B.prototype;
            b.getSpanCorrection = C.getSpanCorrection, b.htmlCss = C.htmlCss, b.htmlGetBBox = C.htmlGetBBox, b.htmlUpdateTransform = C.htmlUpdateTransform, b.setSpanRotation = C.setSpanRotation;
          }
          return B;
        }, O.prototype.getSpanCorrection = function(B, C, b) {
          this.xCorr = -B * b, this.yCorr = -C;
        }, O.prototype.htmlCss = function(B) {
          var C = this.element.tagName === "SPAN" && B && "width" in B, b = u(C && B.width, void 0);
          if (C) {
            delete B.width, this.textWidth = b;
            var w = !0;
          }
          return B && B.textOverflow === "ellipsis" && (B.whiteSpace = "nowrap", B.overflow = "hidden"), this.styles = v(this.styles, B), N(this.element, B), w && this.htmlUpdateTransform(), this;
        }, O.prototype.htmlGetBBox = function() {
          var B = this.element;
          return { x: B.offsetLeft, y: B.offsetTop, width: B.offsetWidth, height: B.offsetHeight };
        }, O.prototype.htmlUpdateTransform = function() {
          if (this.added) {
            var B = this.renderer, C = this.element, b = this.translateX || 0, w = this.translateY || 0, x = this.x || 0, h = this.y || 0, c = this.textAlign || "left", p = { left: 0, center: 0.5, right: 1 }[c], i = this.styles;
            if (i = i && i.whiteSpace, N(C, { marginLeft: b, marginTop: w }), !B.styledMode && this.shadows && this.shadows.forEach(function(A) {
              N(A, { marginLeft: b + 1, marginTop: w + 1 });
            }), this.inverted && [].forEach.call(C.childNodes, function(A) {
              B.invertChild(A, C);
            }), C.tagName === "SPAN") {
              var l = this.rotation, s = this.textWidth && d(this.textWidth), t = [l, c, C.innerHTML, this.textWidth, this.textAlign].join(), n = void 0;
              if (n = !1, s !== this.oldTextWidth) {
                if (this.textPxLength)
                  var o = this.textPxLength;
                else
                  N(C, { width: "", whiteSpace: i || "nowrap" }), o = C.offsetWidth;
                (s > this.oldTextWidth || o > s) && (/[ \-]/.test(C.textContent || C.innerText) || C.style.textOverflow === "ellipsis") && (N(C, { width: o > s || l ? s + "px" : "auto", display: "block", whiteSpace: i || "normal" }), this.oldTextWidth = s, n = !0);
              }
              this.hasBoxWidthChanged = n, t !== this.cTT && (n = B.fontMetrics(C.style.fontSize, C).b, !M(l) || l === (this.oldRotation || 0) && c === this.oldAlign || this.setSpanRotation(l, p, n), this.getSpanCorrection(!M(l) && this.textPxLength || C.offsetWidth, n, p, l, c)), N(C, { left: x + (this.xCorr || 0) + "px", top: h + (this.yCorr || 0) + "px" }), this.cTT = t, this.oldRotation = l, this.oldAlign = c;
            }
          } else
            this.alignOnAdd = !0;
        }, O.prototype.setSpanRotation = function(B, C, b) {
          var w = {}, x = $ && !/Edge/.test(W.navigator.userAgent) ? "-ms-transform" : U ? "-webkit-transform" : H ? "MozTransform" : W.opera ? "-o-transform" : void 0;
          x && (w[x] = w.transform = "rotate(" + B + "deg)", w[x + (H ? "Origin" : "-origin")] = w.transformOrigin = 100 * C + "% " + b + "px", N(this.element, w));
        }, O.composedClasses = [], O;
      }(R);
    }), E(
      a,
      "Core/Renderer/HTML/HTMLRenderer.js",
      [a["Core/Renderer/HTML/AST.js"], a["Core/Renderer/SVG/SVGElement.js"], a["Core/Renderer/SVG/SVGRenderer.js"], a["Core/Utilities.js"]],
      function(y, R, I, Z) {
        var H = this && this.__extends || function() {
          var M = function(v, u) {
            return M = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d, P) {
              d.__proto__ = P;
            } || function(d, P) {
              for (var O in P)
                P.hasOwnProperty(O) && (d[O] = P[O]);
            }, M(v, u);
          };
          return function(v, u) {
            function d() {
              this.constructor = v;
            }
            M(v, u), v.prototype = u === null ? Object.create(u) : (d.prototype = u.prototype, new d());
          };
        }(), $ = Z.attr, U = Z.createElement, W = Z.extend, N = Z.pick;
        return function(M) {
          function v() {
            return M !== null && M.apply(this, arguments) || this;
          }
          return H(v, M), v.compose = function(u) {
            return v.composedClasses.indexOf(u) === -1 && (v.composedClasses.push(u), u.prototype.html = v.prototype.html), u;
          }, v.prototype.html = function(u, d, P) {
            var O = this.createElement("span"), B = O.element, C = O.renderer, b = C.isSVG, w = function(x, h) {
              ["opacity", "visibility"].forEach(function(c) {
                x[c + "Setter"] = function(p, i, l) {
                  var s = x.div ? x.div.style : h;
                  R.prototype[c + "Setter"].call(this, p, i, l), s && (s[i] = p);
                };
              }), x.addedSetters = !0;
            };
            return O.textSetter = function(x) {
              x !== this.textStr && (delete this.bBox, delete this.oldTextWidth, y.setElementHTML(this.element, N(x, "")), this.textStr = x, O.doTransform = !0);
            }, b && w(O, O.element.style), O.xSetter = O.ySetter = O.alignSetter = O.rotationSetter = function(x, h) {
              h === "align" ? O.alignValue = O.textAlign = x : O[h] = x, O.doTransform = !0;
            }, O.afterSetters = function() {
              this.doTransform && (this.htmlUpdateTransform(), this.doTransform = !1);
            }, O.attr({ text: u, x: Math.round(d), y: Math.round(P) }).css({ position: "absolute" }), C.styledMode || O.css({ fontFamily: this.style.fontFamily, fontSize: this.style.fontSize }), B.style.whiteSpace = "nowrap", O.css = O.htmlCss, b && (O.add = function(x) {
              var h = C.box.parentNode, c = [];
              if (this.parentGroup = x) {
                var p = x.div;
                if (!p) {
                  for (; x; )
                    c.push(x), x = x.parentGroup;
                  c.reverse().forEach(function(i) {
                    function l(o, A) {
                      i[A] = o, A === "translateX" ? n.left = o + "px" : n.top = o + "px", i.doTransform = !0;
                    }
                    var s = $(i.element, "class"), t = i.styles || {};
                    p = i.div = i.div || U("div", s ? { className: s } : void 0, {
                      position: "absolute",
                      left: (i.translateX || 0) + "px",
                      top: (i.translateY || 0) + "px",
                      display: i.display,
                      opacity: i.opacity,
                      cursor: t.cursor,
                      pointerEvents: t.pointerEvents,
                      visibility: i.visibility
                    }, p || h);
                    var n = p.style;
                    W(i, { classSetter: function(o) {
                      return function(A) {
                        this.element.setAttribute("class", A), o.className = A;
                      };
                    }(p), on: function() {
                      return c[0].div && O.on.apply({ element: c[0].div, onEvents: i.onEvents }, arguments), i;
                    }, translateXSetter: l, translateYSetter: l }), i.addedSetters || w(i);
                  });
                }
              } else
                p = h;
              return p.appendChild(B), O.added = !0, O.alignOnAdd && O.htmlUpdateTransform(), O;
            }), O;
          }, v.composedClasses = [], v;
        }(I);
      }
    ), E(a, "Core/Axis/AxisDefaults.js", [], function() {
      var y;
      return function(R) {
        R.defaultXAxisOptions = { alignTicks: !0, allowDecimals: void 0, panningEnabled: !0, zIndex: 2, zoomEnabled: !0, dateTimeLabelFormats: { millisecond: { main: "%H:%M:%S.%L", range: !1 }, second: { main: "%H:%M:%S", range: !1 }, minute: { main: "%H:%M", range: !1 }, hour: { main: "%H:%M", range: !1 }, day: { main: "%e. %b" }, week: { main: "%e. %b" }, month: { main: "%b '%y" }, year: { main: "%Y" } }, endOnTick: !1, gridLineDashStyle: "Solid", gridZIndex: 1, labels: {
          autoRotation: void 0,
          autoRotationLimit: 80,
          distance: void 0,
          enabled: !0,
          indentation: 10,
          overflow: "justify",
          padding: 5,
          reserveSpace: void 0,
          rotation: void 0,
          staggerLines: 0,
          step: 0,
          useHTML: !1,
          x: 0,
          zIndex: 7,
          style: { color: "#666666", cursor: "default", fontSize: "11px" }
        }, maxPadding: 0.01, minorGridLineDashStyle: "Solid", minorTickLength: 2, minorTickPosition: "outside", minPadding: 0.01, offset: void 0, opposite: !1, reversed: void 0, reversedStacks: !1, showEmpty: !0, showFirstLabel: !0, showLastLabel: !0, startOfWeek: 1, startOnTick: !1, tickLength: 10, tickPixelInterval: 100, tickmarkPlacement: "between", tickPosition: "outside", title: {
          align: "middle",
          rotation: 0,
          useHTML: !1,
          x: 0,
          y: 0,
          style: { color: "#666666" }
        }, type: "linear", uniqueNames: !0, visible: !0, minorGridLineColor: "#f2f2f2", minorGridLineWidth: 1, minorTickColor: "#999999", lineColor: "#ccd6eb", lineWidth: 1, gridLineColor: "#e6e6e6", gridLineWidth: void 0, tickColor: "#ccd6eb" }, R.defaultYAxisOptions = { reversedStacks: !0, endOnTick: !0, maxPadding: 0.05, minPadding: 0.05, tickPixelInterval: 72, showLastLabel: !0, labels: { x: -8 }, startOnTick: !0, title: { rotation: 270, text: "Values" }, stackLabels: {
          animation: {},
          allowOverlap: !1,
          enabled: !1,
          crop: !0,
          overflow: "justify",
          formatter: function() {
            var I = this.axis.chart.numberFormatter;
            return I(this.total, -1);
          },
          style: { color: "#000000", fontSize: "11px", fontWeight: "bold", textOutline: "1px contrast" }
        }, gridLineWidth: 1, lineWidth: 0 }, R.defaultLeftAxisOptions = { labels: { x: -15 }, title: { rotation: 270 } }, R.defaultRightAxisOptions = { labels: { x: 15 }, title: { rotation: 90 } }, R.defaultBottomAxisOptions = { labels: { autoRotation: [-45], x: 0 }, margin: 15, title: { rotation: 0 } }, R.defaultTopAxisOptions = { labels: { autoRotation: [-45], x: 0 }, margin: 15, title: { rotation: 0 } };
      }(y || (y = {})), y;
    }), E(a, "Core/Foundation.js", [a["Core/Utilities.js"]], function(y) {
      var R = y.addEvent, I = y.isFunction, Z = y.objectEach, H = y.removeEvent, $;
      return function(U) {
        U.registerEventOptions = function(W, N) {
          W.eventOptions = W.eventOptions || {}, Z(N.events, function(M, v) {
            W.eventOptions[v] !== M && (W.eventOptions[v] && (H(W, v, W.eventOptions[v]), delete W.eventOptions[v]), I(M) && (W.eventOptions[v] = M, R(W, v, M)));
          });
        };
      }($ || ($ = {})), $;
    }), E(
      a,
      "Core/Axis/Tick.js",
      [a["Core/FormatUtilities.js"], a["Core/Globals.js"], a["Core/Utilities.js"]],
      function(y, R, I) {
        var Z = R.deg2rad, H = I.clamp, $ = I.correctFloat, U = I.defined, W = I.destroyObjectProperties, N = I.extend, M = I.fireEvent, v = I.isNumber, u = I.merge, d = I.objectEach, P = I.pick;
        return R = function() {
          function O(B, C, b, w, x) {
            this.isNewLabel = this.isNew = !0, this.axis = B, this.pos = C, this.type = b || "", this.parameters = x || {}, this.tickmarkOffset = this.parameters.tickmarkOffset, this.options = this.parameters.options, M(this, "init"), b || w || this.addLabel();
          }
          return O.prototype.addLabel = function() {
            var B = this, C = B.axis, b = C.options, w = C.chart, x = C.categories, h = C.logarithmic, c = C.names, p = B.pos, i = P(B.options && B.options.labels, b.labels), l = C.tickPositions, s = p === l[0], t = p === l[l.length - 1], n = (!i.step || i.step === 1) && C.tickInterval === 1;
            l = l.info;
            var o = B.label, A;
            if (x = this.parameters.category || (x ? P(x[p], c[p], p) : p), h && v(x) && (x = $(h.lin2log(x))), C.dateTime)
              if (l)
                var _ = w.time.resolveDTLFormat(b.dateTimeLabelFormats[!b.grid && l.higherRanks[p] || l.unitName]), D = _.main;
              else
                v(x) && (D = C.dateTime.getXDateFormat(x, b.dateTimeLabelFormats || {}));
            B.isFirst = s, B.isLast = t;
            var j = {
              axis: C,
              chart: w,
              dateTimeLabelFormat: D,
              isFirst: s,
              isLast: t,
              pos: p,
              tick: B,
              tickPositionInfo: l,
              value: x
            };
            M(this, "labelFormat", j);
            var T = function(f) {
              return i.formatter ? i.formatter.call(f, f) : i.format ? (f.text = C.defaultLabelFormatter.call(f), y.format(i.format, f, w)) : C.defaultLabelFormatter.call(f, f);
            };
            b = T.call(j, j);
            var X = _ && _.list;
            B.shortenLabel = X ? function() {
              for (A = 0; A < X.length; A++)
                if (N(j, { dateTimeLabelFormat: X[A] }), o.attr({ text: T.call(j, j) }), o.getBBox().width < C.getSlotWidth(B) - 2 * i.padding)
                  return;
              o.attr({ text: "" });
            } : void 0, n && C._addedPlotLB && B.moveLabel(b, i), U(o) || B.movedLabel ? o && o.textStr !== b && !n && (!o.textWidth || i.style.width || o.styles.width || o.css({ width: null }), o.attr({ text: b }), o.textPxLength = o.getBBox().width) : (B.label = o = B.createLabel({ x: 0, y: 0 }, b, i), B.rotation = 0);
          }, O.prototype.createLabel = function(B, C, b) {
            var w = this.axis, x = w.chart;
            return (B = U(C) && b.enabled ? x.renderer.text(C, B.x, B.y, b.useHTML).add(w.labelGroup) : null) && (x.styledMode || B.css(u(b.style)), B.textPxLength = B.getBBox().width), B;
          }, O.prototype.destroy = function() {
            W(
              this,
              this.axis
            );
          }, O.prototype.getPosition = function(B, C, b, w) {
            var x = this.axis, h = x.chart, c = w && h.oldChartHeight || h.chartHeight;
            return B = { x: B ? $(x.translate(C + b, null, null, w) + x.transB) : x.left + x.offset + (x.opposite ? (w && h.oldChartWidth || h.chartWidth) - x.right - x.left : 0), y: B ? c - x.bottom + x.offset - (x.opposite ? x.height : 0) : $(c - x.translate(C + b, null, null, w) - x.transB) }, B.y = H(B.y, -1e5, 1e5), M(this, "afterGetPosition", { pos: B }), B;
          }, O.prototype.getLabelPosition = function(B, C, b, w, x, h, c, p) {
            var i = this.axis, l = i.transA, s = i.isLinked && i.linkedParent ? i.linkedParent.reversed : i.reversed, t = i.staggerLines, n = i.tickRotCorr || { x: 0, y: 0 }, o = w || i.reserveSpaceDefault ? 0 : -i.labelOffset * (i.labelAlign === "center" ? 0.5 : 1), A = {}, _ = x.y;
            return U(_) || (_ = i.side === 0 ? b.rotation ? -8 : -b.getBBox().height : i.side === 2 ? n.y + 8 : Math.cos(b.rotation * Z) * (n.y - b.getBBox(!1, 0).height / 2)), B = B + x.x + o + n.x - (h && w ? h * l * (s ? -1 : 1) : 0), C = C + _ - (h && !w ? h * l * (s ? 1 : -1) : 0), t && (b = c / (p || 1) % t, i.opposite && (b = t - b - 1), C += i.labelOffset / t * b), A.x = B, A.y = Math.round(C), M(this, "afterGetLabelPosition", { pos: A, tickmarkOffset: h, index: c }), A;
          }, O.prototype.getLabelSize = function() {
            return this.label ? this.label.getBBox()[this.axis.horiz ? "height" : "width"] : 0;
          }, O.prototype.getMarkPath = function(B, C, b, w, x, h) {
            return h.crispLine([["M", B, C], ["L", B + (x ? 0 : -b), C + (x ? b : 0)]], w);
          }, O.prototype.handleOverflow = function(B) {
            var C = this.axis, b = C.options.labels, w = B.x, x = C.chart.chartWidth, h = C.chart.spacing, c = P(C.labelLeft, Math.min(C.pos, h[3]));
            h = P(C.labelRight, Math.max(C.isRadial ? 0 : C.pos + C.len, x - h[1]));
            var p = this.label, i = this.rotation, l = { left: 0, center: 0.5, right: 1 }[C.labelAlign || p.attr("align")], s = p.getBBox().width, t = C.getSlotWidth(this), n = {}, o = t, A = 1, _;
            i || b.overflow !== "justify" ? 0 > i && w - l * s < c ? _ = Math.round(w / Math.cos(i * Z) - c) : 0 < i && w + l * s > h && (_ = Math.round((x - w) / Math.cos(i * Z))) : (x = w + (1 - l) * s, w - l * s < c ? o = B.x + o * (1 - l) - c : x > h && (o = h - B.x + o * l, A = -1), o = Math.min(t, o), o < t && C.labelAlign === "center" && (B.x += A * (t - o - l * (t - Math.min(s, o)))), (s > o || C.autoRotation && (p.styles || {}).width) && (_ = o)), _ && (this.shortenLabel ? this.shortenLabel() : (n.width = Math.floor(_) + "px", (b.style || {}).textOverflow || (n.textOverflow = "ellipsis"), p.css(n)));
          }, O.prototype.moveLabel = function(B, C) {
            var b = this, w = b.label, x = b.axis, h = x.reversed, c = !1;
            if (w && w.textStr === B ? (b.movedLabel = w, c = !0, delete b.label) : d(x.ticks, function(i) {
              c || i.isNew || i === b || !i.label || i.label.textStr !== B || (b.movedLabel = i.label, c = !0, i.labelPos = b.movedLabel.xy, delete i.label);
            }), !c && (b.labelPos || w)) {
              var p = b.labelPos || w.xy;
              w = x.horiz ? h ? 0 : x.width + x.left : p.x, x = x.horiz ? p.y : h ? x.width + x.left : 0, b.movedLabel = b.createLabel({ x: w, y: x }, B, C), b.movedLabel && b.movedLabel.attr({ opacity: 0 });
            }
          }, O.prototype.render = function(B, C, b) {
            var w = this.axis, x = w.horiz, h = this.pos, c = P(this.tickmarkOffset, w.tickmarkOffset);
            h = this.getPosition(x, h, c, C), c = h.x;
            var p = h.y;
            w = x && c === w.pos + w.len || !x && p === w.pos ? -1 : 1, x = P(b, this.label && this.label.newOpacity, 1), b = P(b, 1), this.isActive = !0, this.renderGridLine(C, b, w), this.renderMark(h, b, w), this.renderLabel(h, C, x, B), this.isNew = !1, M(this, "afterRender");
          }, O.prototype.renderGridLine = function(B, C, b) {
            var w = this.axis, x = w.options, h = {}, c = this.pos, p = this.type, i = P(
              this.tickmarkOffset,
              w.tickmarkOffset
            ), l = w.chart.renderer, s = this.gridLine, t = x.gridLineWidth, n = x.gridLineColor, o = x.gridLineDashStyle;
            this.type === "minor" && (t = x.minorGridLineWidth, n = x.minorGridLineColor, o = x.minorGridLineDashStyle), s || (w.chart.styledMode || (h.stroke = n, h["stroke-width"] = t || 0, h.dashstyle = o), p || (h.zIndex = 1), B && (C = 0), this.gridLine = s = l.path().attr(h).addClass("highcharts-" + (p ? p + "-" : "") + "grid-line").add(w.gridGroup)), s && (b = w.getPlotLinePath({ value: c + i, lineWidth: s.strokeWidth() * b, force: "pass", old: B })) && s[B || this.isNew ? "attr" : "animate"]({ d: b, opacity: C });
          }, O.prototype.renderMark = function(B, C, b) {
            var w = this.axis, x = w.options, h = w.chart.renderer, c = this.type, p = w.tickSize(c ? c + "Tick" : "tick"), i = B.x;
            B = B.y;
            var l = P(x[c !== "minor" ? "tickWidth" : "minorTickWidth"], !c && w.isXAxis ? 1 : 0);
            x = x[c !== "minor" ? "tickColor" : "minorTickColor"];
            var s = this.mark, t = !s;
            p && (w.opposite && (p[0] = -p[0]), s || (this.mark = s = h.path().addClass("highcharts-" + (c ? c + "-" : "") + "tick").add(w.axisGroup), w.chart.styledMode || s.attr({ stroke: x, "stroke-width": l })), s[t ? "attr" : "animate"]({ d: this.getMarkPath(
              i,
              B,
              p[0],
              s.strokeWidth() * b,
              w.horiz,
              h
            ), opacity: C }));
          }, O.prototype.renderLabel = function(B, C, b, w) {
            var x = this.axis, h = x.horiz, c = x.options, p = this.label, i = c.labels, l = i.step;
            x = P(this.tickmarkOffset, x.tickmarkOffset);
            var s = B.x;
            B = B.y;
            var t = !0;
            p && v(s) && (p.xy = B = this.getLabelPosition(s, B, p, h, i, x, w, l), this.isFirst && !this.isLast && !c.showFirstLabel || this.isLast && !this.isFirst && !c.showLastLabel ? t = !1 : !h || i.step || i.rotation || C || b === 0 || this.handleOverflow(B), l && w % l && (t = !1), t && v(B.y) ? (B.opacity = b, p[this.isNewLabel ? "attr" : "animate"](B), this.isNewLabel = !1) : (p.attr("y", -9999), this.isNewLabel = !0));
          }, O.prototype.replaceMovedLabel = function() {
            var B = this.label, C = this.axis, b = C.reversed;
            if (B && !this.isNew) {
              var w = C.horiz ? b ? C.left : C.width + C.left : B.xy.x;
              b = C.horiz ? B.xy.y : b ? C.width + C.top : C.top, B.animate({ x: w, y: b, opacity: 0 }, void 0, B.destroy), delete this.label;
            }
            C.isDirty = !0, this.label = this.movedLabel, delete this.movedLabel;
          }, O;
        }(), R;
      }
    ), E(a, "Core/Axis/Axis.js", [
      a["Core/Animation/AnimationUtilities.js"],
      a["Core/Axis/AxisDefaults.js"],
      a["Core/Color/Color.js"],
      a["Core/DefaultOptions.js"],
      a["Core/Foundation.js"],
      a["Core/Globals.js"],
      a["Core/Axis/Tick.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I, Z, H, $, U, W) {
      var N = y.animObject, M = Z.defaultOptions, v = H.registerEventOptions, u = $.deg2rad, d = W.arrayMax, P = W.arrayMin, O = W.clamp, B = W.correctFloat, C = W.defined, b = W.destroyObjectProperties, w = W.erase, x = W.error, h = W.extend, c = W.fireEvent, p = W.getMagnitude, i = W.isArray, l = W.isNumber, s = W.isString, t = W.merge, n = W.normalizeTickInterval, o = W.objectEach, A = W.pick, _ = W.relativeLength, D = W.removeEvent, j = W.splat, T = W.syncTimeout;
      return y = function() {
        function X(f, m) {
          this.zoomEnabled = this.width = this.visible = this.userOptions = this.translationSlope = this.transB = this.transA = this.top = this.ticks = this.tickRotCorr = this.tickPositions = this.tickmarkOffset = this.tickInterval = this.tickAmount = this.side = this.series = this.right = this.positiveValuesOnly = this.pos = this.pointRangePadding = this.pointRange = this.plotLinesAndBandsGroups = this.plotLinesAndBands = this.paddedTicks = this.overlap = this.options = this.offset = this.names = this.minPixelPadding = this.minorTicks = this.minorTickInterval = this.min = this.maxLabelLength = this.max = this.len = this.left = this.labelFormatter = this.labelEdge = this.isLinked = this.height = this.hasVisibleSeries = this.hasNames = this.eventOptions = this.coll = this.closestPointRange = this.chart = this.categories = this.bottom = this.alternateBands = void 0, this.init(f, m);
        }
        return X.prototype.init = function(f, m) {
          var L = m.isX;
          this.chart = f, this.horiz = f.inverted && !this.isZAxis ? !L : L, this.isXAxis = L, this.coll = this.coll || (L ? "xAxis" : "yAxis"), c(this, "init", { userOptions: m }), this.opposite = A(m.opposite, this.opposite), this.side = A(m.side, this.side, this.horiz ? this.opposite ? 0 : 2 : this.opposite ? 1 : 3), this.setOptions(m);
          var Y = this.options, F = Y.labels, Q = Y.type;
          this.userOptions = m, this.minPixelPadding = 0, this.reversed = A(Y.reversed, this.reversed), this.visible = Y.visible, this.zoomEnabled = Y.zoomEnabled, this.hasNames = Q === "category" || Y.categories === !0, this.categories = Y.categories || this.hasNames, this.names || (this.names = [], this.names.keys = {}), this.plotLinesAndBandsGroups = {}, this.positiveValuesOnly = !!this.logarithmic, this.isLinked = C(Y.linkedTo), this.ticks = {}, this.labelEdge = [], this.minorTicks = {}, this.plotLinesAndBands = [], this.alternateBands = {}, this.len = 0, this.minRange = this.userMinRange = Y.minRange || Y.maxZoom, this.range = Y.range, this.offset = Y.offset || 0, this.min = this.max = null, m = A(Y.crosshair, j(f.options.tooltip.crosshairs)[L ? 0 : 1]), this.crosshair = m === !0 ? {} : m, f.axes.indexOf(this) === -1 && (L ? f.axes.splice(f.xAxis.length, 0, this) : f.axes.push(this), f[this.coll].push(this)), this.series = this.series || [], f.inverted && !this.isZAxis && L && typeof this.reversed > "u" && (this.reversed = !0), this.labelRotation = l(F.rotation) ? F.rotation : void 0, v(this, Y), c(this, "afterInit");
        }, X.prototype.setOptions = function(f) {
          this.options = t(R.defaultXAxisOptions, this.coll === "yAxis" && R.defaultYAxisOptions, [R.defaultTopAxisOptions, R.defaultRightAxisOptions, R.defaultBottomAxisOptions, R.defaultLeftAxisOptions][this.side], t(M[this.coll], f)), c(this, "afterSetOptions", { userOptions: f });
        }, X.prototype.defaultLabelFormatter = function(f) {
          var m = this.axis;
          f = this.chart.numberFormatter;
          var L = l(this.value) ? this.value : NaN, Y = m.chart.time, F = this.dateTimeLabelFormat, Q = M.lang, k = Q.numericSymbols;
          Q = Q.numericSymbolMagnitude || 1e3;
          var G = m.logarithmic ? Math.abs(L) : m.tickInterval, z = k && k.length;
          if (m.categories)
            var V = "" + this.value;
          else if (F)
            V = Y.dateFormat(F, L);
          else if (z && 1e3 <= G)
            for (; z-- && typeof V > "u"; )
              m = Math.pow(Q, z + 1), G >= m && 10 * L % m === 0 && k[z] !== null && L !== 0 && (V = f(L / m, -1) + k[z]);
          return typeof V > "u" && (V = 1e4 <= Math.abs(L) ? f(L, -1) : f(L, -1, void 0, "")), V;
        }, X.prototype.getSeriesExtremes = function() {
          var f = this, m = f.chart, L;
          c(this, "getSeriesExtremes", null, function() {
            f.hasVisibleSeries = !1, f.dataMin = f.dataMax = f.threshold = null, f.softThreshold = !f.isXAxis, f.stacking && f.stacking.buildStacks(), f.series.forEach(function(Y) {
              if (Y.visible || !m.options.chart.ignoreHiddenSeries) {
                var F = Y.options, Q = F.threshold;
                if (f.hasVisibleSeries = !0, f.positiveValuesOnly && 0 >= Q && (Q = null), f.isXAxis) {
                  if (F = Y.xData, F.length) {
                    F = f.logarithmic ? F.filter(f.validatePositiveValue) : F, L = Y.getXExtremes(F);
                    var k = L.min, G = L.max;
                    l(k) || k instanceof Date || (F = F.filter(l), L = Y.getXExtremes(F), k = L.min, G = L.max), F.length && (f.dataMin = Math.min(A(f.dataMin, k), k), f.dataMax = Math.max(A(f.dataMax, G), G));
                  }
                } else
                  Y = Y.applyExtremes(), l(Y.dataMin) && (k = Y.dataMin, f.dataMin = Math.min(A(f.dataMin, k), k)), l(Y.dataMax) && (G = Y.dataMax, f.dataMax = Math.max(A(f.dataMax, G), G)), C(Q) && (f.threshold = Q), (!F.softThreshold || f.positiveValuesOnly) && (f.softThreshold = !1);
              }
            });
          }), c(this, "afterGetSeriesExtremes");
        }, X.prototype.translate = function(f, m, L, Y, F, Q) {
          var k = this.linkedParent || this, G = Y && k.old ? k.old.min : k.min, z = k.minPixelPadding;
          F = (k.isOrdinal || k.brokenAxis && k.brokenAxis.hasBreaks || k.logarithmic && F) && k.lin2val;
          var V = 1, q = 0;
          return Y = Y && k.old ? k.old.transA : k.transA, Y || (Y = k.transA), L && (V *= -1, q = k.len), k.reversed && (V *= -1, q -= V * (k.sector || k.len)), m ? (f = (f * V + q - z) / Y + G, F && (f = k.lin2val(f))) : (F && (f = k.val2lin(f)), f = l(G) ? V * (f - G) * Y + q + V * z + (l(Q) ? Y * Q : 0) : void 0), f;
        }, X.prototype.toPixels = function(f, m) {
          return this.translate(
            f,
            !1,
            !this.horiz,
            null,
            !0
          ) + (m ? 0 : this.pos);
        }, X.prototype.toValue = function(f, m) {
          return this.translate(f - (m ? 0 : this.pos), !0, !this.horiz, null, !0);
        }, X.prototype.getPlotLinePath = function(f) {
          function m(at, J, tt) {
            return (nt !== "pass" && at < J || at > tt) && (nt ? at = O(at, J, tt) : lt = !0), at;
          }
          var L = this, Y = L.chart, F = L.left, Q = L.top, k = f.old, G = f.value, z = f.lineWidth, V = k && Y.oldChartHeight || Y.chartHeight, q = k && Y.oldChartWidth || Y.chartWidth, it = L.transB, et = f.translatedValue, nt = f.force, rt, ct, gt, dt, lt;
          return f = {
            value: G,
            lineWidth: z,
            old: k,
            force: nt,
            acrossPanes: f.acrossPanes,
            translatedValue: et
          }, c(this, "getPlotLinePath", f, function(at) {
            et = A(et, L.translate(G, null, null, k)), et = O(et, -1e5, 1e5), rt = gt = Math.round(et + it), ct = dt = Math.round(V - et - it), l(et) ? L.horiz ? (ct = Q, dt = V - L.bottom, rt = gt = m(rt, F, F + L.width)) : (rt = F, gt = q - L.right, ct = dt = m(ct, Q, Q + L.height)) : (lt = !0, nt = !1), at.path = lt && !nt ? null : Y.renderer.crispLine([["M", rt, ct], ["L", gt, dt]], z || 1);
          }), f.path;
        }, X.prototype.getLinearTickPositions = function(f, m, L) {
          var Y = B(Math.floor(m / f) * f);
          L = B(Math.ceil(L / f) * f);
          var F = [], Q;
          if (B(Y + f) === Y && (Q = 20), this.single)
            return [m];
          for (m = Y; m <= L && (F.push(m), m = B(m + f, Q), m !== k); )
            var k = m;
          return F;
        }, X.prototype.getMinorTickInterval = function() {
          var f = this.options;
          return f.minorTicks === !0 ? A(f.minorTickInterval, "auto") : f.minorTicks === !1 ? null : f.minorTickInterval;
        }, X.prototype.getMinorTickPositions = function() {
          var f = this.options, m = this.tickPositions, L = this.minorTickInterval, Y = this.pointRangePadding || 0, F = this.min - Y;
          Y = this.max + Y;
          var Q = Y - F, k = [];
          if (Q && Q / L < this.len / 3) {
            var G = this.logarithmic;
            if (G)
              this.paddedTicks.forEach(function(z, V, q) {
                V && k.push.apply(
                  k,
                  G.getLogTickPositions(L, q[V - 1], q[V], !0)
                );
              });
            else if (this.dateTime && this.getMinorTickInterval() === "auto")
              k = k.concat(this.getTimeTicks(this.dateTime.normalizeTimeTickInterval(L), F, Y, f.startOfWeek));
            else
              for (f = F + (m[0] - F) % L; f <= Y && f !== k[0]; f += L)
                k.push(f);
          }
          return k.length !== 0 && this.trimTicks(k), k;
        }, X.prototype.adjustForMinRange = function() {
          var f = this.options, m = this.logarithmic, L = this.min, Y = this.max, F = 0, Q, k, G, z;
          if (this.isXAxis && typeof this.minRange > "u" && !m && (C(f.min) || C(f.max) || C(f.floor) || C(f.ceiling) ? this.minRange = null : (this.series.forEach(function(et) {
            if (G = et.xData, z = et.xIncrement ? 1 : G.length - 1, 1 < G.length)
              for (Q = z; 0 < Q; Q--)
                k = G[Q] - G[Q - 1], (!F || k < F) && (F = k);
          }), this.minRange = Math.min(5 * F, this.dataMax - this.dataMin))), Y - L < this.minRange) {
            var V = this.dataMax - this.dataMin >= this.minRange, q = this.minRange, it = (q - Y + L) / 2;
            it = [L - it, A(f.min, L - it)], V && (it[2] = this.logarithmic ? this.logarithmic.log2lin(this.dataMin) : this.dataMin), L = d(it), Y = [L + q, A(f.max, L + q)], V && (Y[2] = m ? m.log2lin(this.dataMax) : this.dataMax), Y = P(Y), Y - L < q && (it[0] = Y - q, it[1] = A(f.min, Y - q), L = d(it));
          }
          this.min = L, this.max = Y;
        }, X.prototype.getClosest = function() {
          var f;
          return this.categories ? f = 1 : this.series.forEach(function(m) {
            var L = m.closestPointRange, Y = m.visible || !m.chart.options.chart.ignoreHiddenSeries;
            !m.noSharedTooltip && C(L) && Y && (f = C(f) ? Math.min(f, L) : L);
          }), f;
        }, X.prototype.nameToX = function(f) {
          var m = i(this.categories), L = m ? this.categories : this.names, Y = f.options.x;
          if (f.series.requireSorting = !1, C(Y) || (Y = this.options.uniqueNames ? m ? L.indexOf(f.name) : A(L.keys[f.name], -1) : f.series.autoIncrement()), Y === -1) {
            if (!m)
              var F = L.length;
          } else
            F = Y;
          return typeof F < "u" && (this.names[F] = f.name, this.names.keys[f.name] = F), F;
        }, X.prototype.updateNames = function() {
          var f = this, m = this.names;
          0 < m.length && (Object.keys(m.keys).forEach(function(L) {
            delete m.keys[L];
          }), m.length = 0, this.minRange = this.userMinRange, (this.series || []).forEach(function(L) {
            L.xIncrement = null, (!L.points || L.isDirtyData) && (f.max = Math.max(f.max, L.xData.length - 1), L.processData(), L.generatePoints()), L.data.forEach(function(Y, F) {
              if (Y && Y.options && typeof Y.name < "u") {
                var Q = f.nameToX(Y);
                typeof Q < "u" && Q !== Y.x && (Y.x = Q, L.xData[F] = Q);
              }
            });
          }));
        }, X.prototype.setAxisTranslation = function() {
          var f = this, m = f.max - f.min, L = f.linkedParent, Y = !!f.categories, F = f.isXAxis, Q = f.axisPointRange || 0, k = 0, G = 0, z = f.transA;
          if (F || Y || Q) {
            var V = f.getClosest();
            L ? (k = L.minPointOffset, G = L.pointRangePadding) : f.series.forEach(function(q) {
              var it = Y ? 1 : F ? A(q.options.pointRange, V, 0) : f.axisPointRange || 0, et = q.options.pointPlacement;
              Q = Math.max(Q, it), (!f.single || Y) && (q = q.is("xrange") ? !F : F, k = Math.max(k, q && s(et) ? 0 : it / 2), G = Math.max(G, q && et === "on" ? 0 : it));
            }), L = f.ordinal && f.ordinal.slope && V ? f.ordinal.slope / V : 1, f.minPointOffset = k *= L, f.pointRangePadding = G *= L, f.pointRange = Math.min(Q, f.single && Y ? 1 : m), F && (f.closestPointRange = V);
          }
          f.translationSlope = f.transA = z = f.staticScale || f.len / (m + G || 1), f.transB = f.horiz ? f.left : f.bottom, f.minPixelPadding = z * k, c(this, "afterSetAxisTranslation");
        }, X.prototype.minFromRange = function() {
          return this.max - this.range;
        }, X.prototype.setTickInterval = function(f) {
          var m = this.chart, L = this.logarithmic, Y = this.options, F = this.isXAxis, Q = this.isLinked, k = Y.tickPixelInterval, G = this.categories, z = this.softThreshold, V = Y.maxPadding, q = Y.minPadding, it = l(Y.tickInterval) && 0 <= Y.tickInterval ? Y.tickInterval : void 0, et = l(this.threshold) ? this.threshold : null;
          this.dateTime || G || Q || this.getTickAmount();
          var nt = A(this.userMin, Y.min), rt = A(this.userMax, Y.max);
          if (Q) {
            this.linkedParent = m[this.coll][Y.linkedTo];
            var ct = this.linkedParent.getExtremes();
            this.min = A(ct.min, ct.dataMin), this.max = A(ct.max, ct.dataMax), Y.type !== this.linkedParent.options.type && x(11, 1, m);
          } else {
            if (z && C(et)) {
              if (this.dataMin >= et)
                ct = et, q = 0;
              else if (this.dataMax <= et) {
                var gt = et;
                V = 0;
              }
            }
            this.min = A(nt, ct, this.dataMin), this.max = A(rt, gt, this.dataMax);
          }
          if (L && (this.positiveValuesOnly && !f && 0 >= Math.min(this.min, A(this.dataMin, this.min)) && x(10, 1, m), this.min = B(L.log2lin(this.min), 16), this.max = B(L.log2lin(this.max), 16)), this.range && C(this.max) && (this.userMin = this.min = nt = Math.max(this.dataMin, this.minFromRange()), this.userMax = rt = this.max, this.range = null), c(this, "foundExtremes"), this.beforePadding && this.beforePadding(), this.adjustForMinRange(), !(G || this.axisPointRange || this.stacking && this.stacking.usePercentage || Q) && C(this.min) && C(this.max) && (m = this.max - this.min) && (!C(nt) && q && (this.min -= m * q), !C(rt) && V && (this.max += m * V)), l(this.userMin) || (l(Y.softMin) && Y.softMin < this.min && (this.min = nt = Y.softMin), l(Y.floor) && (this.min = Math.max(this.min, Y.floor))), l(this.userMax) || (l(Y.softMax) && Y.softMax > this.max && (this.max = rt = Y.softMax), l(Y.ceiling) && (this.max = Math.min(this.max, Y.ceiling))), z && C(this.dataMin) && (et = et || 0, !C(nt) && this.min < et && this.dataMin >= et ? this.min = this.options.minRange ? Math.min(et, this.max - this.minRange) : et : !C(rt) && this.max > et && this.dataMax <= et && (this.max = this.options.minRange ? Math.max(et, this.min + this.minRange) : et)), l(this.min) && l(this.max) && !this.chart.polar && this.min > this.max && (C(this.options.min) ? this.max = this.min : C(this.options.max) && (this.min = this.max)), this.tickInterval = this.min === this.max || typeof this.min > "u" || typeof this.max > "u" ? 1 : Q && this.linkedParent && !it && k === this.linkedParent.options.tickPixelInterval ? it = this.linkedParent.tickInterval : A(it, this.tickAmount ? (this.max - this.min) / Math.max(this.tickAmount - 1, 1) : void 0, G ? 1 : (this.max - this.min) * k / Math.max(this.len, k)), F && !f) {
            var dt = this.min !== (this.old && this.old.min) || this.max !== (this.old && this.old.max);
            this.series.forEach(function(lt) {
              lt.forceCrop = lt.forceCropping && lt.forceCropping(), lt.processData(dt);
            }), c(this, "postProcessData", { hasExtemesChanged: dt });
          }
          this.setAxisTranslation(), c(this, "initialAxisTranslation"), this.pointRange && !it && (this.tickInterval = Math.max(this.pointRange, this.tickInterval)), f = A(Y.minTickInterval, this.dateTime && !this.series.some(function(lt) {
            return lt.noSharedTooltip;
          }) ? this.closestPointRange : 0), !it && this.tickInterval < f && (this.tickInterval = f), this.dateTime || this.logarithmic || it || (this.tickInterval = n(this.tickInterval, void 0, p(this.tickInterval), A(Y.allowDecimals, 0.5 > this.tickInterval || this.tickAmount !== void 0), !!this.tickAmount)), this.tickAmount || (this.tickInterval = this.unsquish()), this.setTickPositions();
        }, X.prototype.setTickPositions = function() {
          var f = this.options, m = f.tickPositions, L = this.getMinorTickInterval(), Y = this.hasVerticalPanning(), F = this.coll === "colorAxis", Q = (F || !Y) && f.startOnTick;
          Y = (F || !Y) && f.endOnTick, F = f.tickPositioner, this.tickmarkOffset = this.categories && f.tickmarkPlacement === "between" && this.tickInterval === 1 ? 0.5 : 0, this.minorTickInterval = L === "auto" && this.tickInterval ? this.tickInterval / 5 : L, this.single = this.min === this.max && C(this.min) && !this.tickAmount && (parseInt(this.min, 10) === this.min || f.allowDecimals !== !1), this.tickPositions = L = m && m.slice(), !L && (this.ordinal && this.ordinal.positions || !((this.max - this.min) / this.tickInterval > Math.max(2 * this.len, 200)) ? L = this.dateTime ? this.getTimeTicks(this.dateTime.normalizeTimeTickInterval(this.tickInterval, f.units), this.min, this.max, f.startOfWeek, this.ordinal && this.ordinal.positions, this.closestPointRange, !0) : this.logarithmic ? this.logarithmic.getLogTickPositions(this.tickInterval, this.min, this.max) : this.getLinearTickPositions(
            this.tickInterval,
            this.min,
            this.max
          ) : (L = [this.min, this.max], x(19, !1, this.chart)), L.length > this.len && (L = [L[0], L.pop()], L[0] === L[1] && (L.length = 1)), this.tickPositions = L, F && (F = F.apply(this, [this.min, this.max]))) && (this.tickPositions = L = F), this.paddedTicks = L.slice(0), this.trimTicks(L, Q, Y), this.isLinked || (this.single && 2 > L.length && !this.categories && !this.series.some(function(k) {
            return k.is("heatmap") && k.options.pointPlacement === "between";
          }) && (this.min -= 0.5, this.max += 0.5), m || F || this.adjustTickAmount()), c(this, "afterSetTickPositions");
        }, X.prototype.trimTicks = function(f, m, L) {
          var Y = f[0], F = f[f.length - 1], Q = !this.isOrdinal && this.minPointOffset || 0;
          if (c(this, "trimTicks"), !this.isLinked) {
            if (m && Y !== -1 / 0)
              this.min = Y;
            else
              for (; this.min - Q > f[0]; )
                f.shift();
            if (L)
              this.max = F;
            else
              for (; this.max + Q < f[f.length - 1]; )
                f.pop();
            f.length === 0 && C(Y) && !this.options.tickPositions && f.push((F + Y) / 2);
          }
        }, X.prototype.alignToOthers = function() {
          var f = {}, m = this.options, L;
          return this.chart.options.chart.alignTicks !== !1 && m.alignTicks && m.startOnTick !== !1 && m.endOnTick !== !1 && !this.logarithmic && this.chart[this.coll].forEach(function(Y) {
            var F = Y.options;
            F = [Y.horiz ? F.left : F.top, F.width, F.height, F.pane].join(), Y.series.length && (f[F] ? L = !0 : f[F] = 1);
          }), L;
        }, X.prototype.getTickAmount = function() {
          var f = this.options, m = f.tickPixelInterval, L = f.tickAmount;
          !C(f.tickInterval) && !L && this.len < m && !this.isRadial && !this.logarithmic && f.startOnTick && f.endOnTick && (L = 2), !L && this.alignToOthers() && (L = Math.ceil(this.len / m) + 1), 4 > L && (this.finalTickAmt = L, L = 5), this.tickAmount = L;
        }, X.prototype.adjustTickAmount = function() {
          var f = this.options, m = this.tickInterval, L = this.tickPositions, Y = this.tickAmount, F = this.finalTickAmt, Q = L && L.length, k = A(this.threshold, this.softThreshold ? 0 : null);
          if (this.hasData() && l(this.min) && l(this.max)) {
            if (Q < Y) {
              for (; L.length < Y; )
                L.length % 2 || this.min === k ? L.push(B(L[L.length - 1] + m)) : L.unshift(B(L[0] - m));
              this.transA *= (Q - 1) / (Y - 1), this.min = f.startOnTick ? L[0] : Math.min(this.min, L[0]), this.max = f.endOnTick ? L[L.length - 1] : Math.max(this.max, L[L.length - 1]);
            } else
              Q > Y && (this.tickInterval *= 2, this.setTickPositions());
            if (C(F)) {
              for (m = f = L.length; m--; )
                (F === 3 && m % 2 === 1 || 2 >= F && 0 < m && m < f - 1) && L.splice(m, 1);
              this.finalTickAmt = void 0;
            }
          }
        }, X.prototype.setScale = function() {
          var f = !1, m = !1;
          this.series.forEach(function(Y) {
            f = f || Y.isDirtyData || Y.isDirty, m = m || Y.xAxis && Y.xAxis.isDirty || !1;
          }), this.setAxisSize();
          var L = this.len !== (this.old && this.old.len);
          L || f || m || this.isLinked || this.forceRedraw || this.userMin !== (this.old && this.old.userMin) || this.userMax !== (this.old && this.old.userMax) || this.alignToOthers() ? (this.stacking && this.stacking.resetStacks(), this.forceRedraw = !1, this.getSeriesExtremes(), this.setTickInterval(), this.isDirty || (this.isDirty = L || this.min !== (this.old && this.old.min) || this.max !== (this.old && this.old.max))) : this.stacking && this.stacking.cleanStacks(), f && this.panningState && (this.panningState.isDirty = !0), c(this, "afterSetScale");
        }, X.prototype.setExtremes = function(f, m, L, Y, F) {
          var Q = this, k = Q.chart;
          L = A(L, !0), Q.series.forEach(function(G) {
            delete G.kdTree;
          }), F = h(F, { min: f, max: m }), c(Q, "setExtremes", F, function() {
            Q.userMin = f, Q.userMax = m, Q.eventArgs = F, L && k.redraw(Y);
          });
        }, X.prototype.zoom = function(f, m) {
          var L = this, Y = this.dataMin, F = this.dataMax, Q = this.options, k = Math.min(Y, A(Q.min, Y)), G = Math.max(F, A(Q.max, F));
          return f = { newMin: f, newMax: m }, c(this, "zoom", f, function(z) {
            var V = z.newMin, q = z.newMax;
            (V !== L.min || q !== L.max) && (L.allowZoomOutside || (C(Y) && (V < k && (V = k), V > G && (V = G)), C(F) && (q < k && (q = k), q > G && (q = G))), L.displayBtn = typeof V < "u" || typeof q < "u", L.setExtremes(V, q, !1, void 0, { trigger: "zoom" })), z.zoomed = !0;
          }), f.zoomed;
        }, X.prototype.setAxisSize = function() {
          var f = this.chart, m = this.options, L = m.offsets || [0, 0, 0, 0], Y = this.horiz, F = this.width = Math.round(_(A(m.width, f.plotWidth - L[3] + L[1]), f.plotWidth)), Q = this.height = Math.round(_(A(m.height, f.plotHeight - L[0] + L[2]), f.plotHeight)), k = this.top = Math.round(_(A(m.top, f.plotTop + L[0]), f.plotHeight, f.plotTop));
          m = this.left = Math.round(_(A(m.left, f.plotLeft + L[3]), f.plotWidth, f.plotLeft)), this.bottom = f.chartHeight - Q - k, this.right = f.chartWidth - F - m, this.len = Math.max(Y ? F : Q, 0), this.pos = Y ? m : k;
        }, X.prototype.getExtremes = function() {
          var f = this.logarithmic;
          return { min: f ? B(f.lin2log(this.min)) : this.min, max: f ? B(f.lin2log(this.max)) : this.max, dataMin: this.dataMin, dataMax: this.dataMax, userMin: this.userMin, userMax: this.userMax };
        }, X.prototype.getThreshold = function(f) {
          var m = this.logarithmic, L = m ? m.lin2log(this.min) : this.min;
          return m = m ? m.lin2log(this.max) : this.max, f === null || f === -1 / 0 ? f = L : f === 1 / 0 ? f = m : L > f ? f = L : m < f && (f = m), this.translate(f, 0, 1, 0, 1);
        }, X.prototype.autoLabelAlign = function(f) {
          var m = (A(f, 0) - 90 * this.side + 720) % 360;
          return f = { align: "center" }, c(
            this,
            "autoLabelAlign",
            f,
            function(L) {
              15 < m && 165 > m ? L.align = "right" : 195 < m && 345 > m && (L.align = "left");
            }
          ), f.align;
        }, X.prototype.tickSize = function(f) {
          var m = this.options, L = A(m[f === "tick" ? "tickWidth" : "minorTickWidth"], f === "tick" && this.isXAxis && !this.categories ? 1 : 0), Y = m[f === "tick" ? "tickLength" : "minorTickLength"];
          if (L && Y) {
            m[f + "Position"] === "inside" && (Y = -Y);
            var F = [Y, L];
          }
          return f = { tickSize: F }, c(this, "afterTickSize", f), f.tickSize;
        }, X.prototype.labelMetrics = function() {
          var f = this.tickPositions && this.tickPositions[0] || 0;
          return this.chart.renderer.fontMetrics(
            this.options.labels.style.fontSize,
            this.ticks[f] && this.ticks[f].label
          );
        }, X.prototype.unsquish = function() {
          var f = this.options.labels, m = this.horiz, L = this.tickInterval, Y = this.len / (((this.categories ? 1 : 0) + this.max - this.min) / L), F = f.rotation, Q = this.labelMetrics(), k = Math.max(this.max - this.min, 0), G = function(nt) {
            var rt = nt / (Y || 1);
            return rt = 1 < rt ? Math.ceil(rt) : 1, rt * L > k && nt !== 1 / 0 && Y !== 1 / 0 && k && (rt = Math.ceil(k / L)), B(rt * L);
          }, z = L, V, q, it = Number.MAX_VALUE;
          if (m) {
            if (!f.staggerLines && !f.step)
              if (l(F))
                var et = [F];
              else
                Y < f.autoRotationLimit && (et = f.autoRotation);
            et && et.forEach(function(nt) {
              if (nt === F || nt && -90 <= nt && 90 >= nt) {
                q = G(Math.abs(Q.h / Math.sin(u * nt)));
                var rt = q + Math.abs(nt / 360);
                rt < it && (it = rt, V = nt, z = q);
              }
            });
          } else
            f.step || (z = G(Q.h));
          return this.autoRotation = et, this.labelRotation = A(V, l(F) ? F : 0), z;
        }, X.prototype.getSlotWidth = function(f) {
          var m = this.chart, L = this.horiz, Y = this.options.labels, F = Math.max(this.tickPositions.length - (this.categories ? 0 : 1), 1), Q = m.margin[3];
          if (f && l(f.slotWidth))
            return f.slotWidth;
          if (L && 2 > Y.step)
            return Y.rotation ? 0 : (this.staggerLines || 1) * this.len / F;
          if (!L) {
            if (f = Y.style.width, f !== void 0)
              return parseInt(String(f), 10);
            if (Q)
              return Q - m.spacing[3];
          }
          return 0.33 * m.chartWidth;
        }, X.prototype.renderUnsquish = function() {
          var f = this.chart, m = f.renderer, L = this.tickPositions, Y = this.ticks, F = this.options.labels, Q = F.style, k = this.horiz, G = this.getSlotWidth(), z = Math.max(1, Math.round(G - 2 * F.padding)), V = {}, q = this.labelMetrics(), it = Q.textOverflow, et = 0;
          if (s(F.rotation) || (V.rotation = F.rotation || 0), L.forEach(function(gt) {
            gt = Y[gt], gt.movedLabel && gt.replaceMovedLabel(), gt && gt.label && gt.label.textPxLength > et && (et = gt.label.textPxLength);
          }), this.maxLabelLength = et, this.autoRotation)
            et > z && et > q.h ? V.rotation = this.labelRotation : this.labelRotation = 0;
          else if (G) {
            var nt = z;
            if (!it) {
              var rt = "clip";
              for (z = L.length; !k && z--; ) {
                var ct = L[z];
                (ct = Y[ct].label) && (ct.styles && ct.styles.textOverflow === "ellipsis" ? ct.css({ textOverflow: "clip" }) : ct.textPxLength > G && ct.css({ width: G + "px" }), ct.getBBox().height > this.len / L.length - (q.h - q.f) && (ct.specificTextOverflow = "ellipsis"));
              }
            }
          }
          V.rotation && (nt = et > 0.5 * f.chartHeight ? 0.33 * f.chartHeight : et, it || (rt = "ellipsis")), (this.labelAlign = F.align || this.autoLabelAlign(this.labelRotation)) && (V.align = this.labelAlign), L.forEach(function(gt) {
            var dt = (gt = Y[gt]) && gt.label, lt = Q.width, at = {};
            dt && (dt.attr(V), gt.shortenLabel ? gt.shortenLabel() : nt && !lt && Q.whiteSpace !== "nowrap" && (nt < dt.textPxLength || dt.element.tagName === "SPAN") ? (at.width = nt + "px", it || (at.textOverflow = dt.specificTextOverflow || rt), dt.css(at)) : dt.styles && dt.styles.width && !at.width && !lt && dt.css({ width: null }), delete dt.specificTextOverflow, gt.rotation = V.rotation);
          }, this), this.tickRotCorr = m.rotCorr(q.b, this.labelRotation || 0, this.side !== 0);
        }, X.prototype.hasData = function() {
          return this.series.some(function(f) {
            return f.hasData();
          }) || this.options.showEmpty && C(this.min) && C(this.max);
        }, X.prototype.addTitle = function(f) {
          var m = this.chart.renderer, L = this.horiz, Y = this.opposite, F = this.options.title, Q = this.chart.styledMode, k;
          this.axisTitle || ((k = F.textAlign) || (k = (L ? { low: "left", middle: "center", high: "right" } : { low: Y ? "right" : "left", middle: "center", high: Y ? "left" : "right" })[F.align]), this.axisTitle = m.text(F.text || "", 0, 0, F.useHTML).attr({ zIndex: 7, rotation: F.rotation, align: k }).addClass("highcharts-axis-title"), Q || this.axisTitle.css(t(F.style)), this.axisTitle.add(this.axisGroup), this.axisTitle.isNew = !0), Q || F.style.width || this.isRadial || this.axisTitle.css({ width: this.len + "px" }), this.axisTitle[f ? "show" : "hide"](f);
        }, X.prototype.generateTick = function(f) {
          var m = this.ticks;
          m[f] ? m[f].addLabel() : m[f] = new U(this, f);
        }, X.prototype.getOffset = function() {
          var f = this, m = this, L = m.chart, Y = m.horiz, F = m.options, Q = m.side, k = m.ticks, G = m.tickPositions, z = m.coll, V = m.axisParent, q = L.renderer, it = L.inverted && !m.isZAxis ? [1, 0, 3, 2][Q] : Q, et = m.hasData(), nt = F.title, rt = F.labels, ct = L.axisOffset;
          L = L.clipOffset;
          var gt = [
            -1,
            1,
            1,
            -1
          ][Q], dt = F.className, lt, at = 0, J = 0, tt = 0;
          if (m.showAxis = lt = et || F.showEmpty, m.staggerLines = m.horiz && rt.staggerLines || void 0, !m.axisGroup) {
            var st = function(pt, yt, vt) {
              return q.g(pt).attr({ zIndex: vt }).addClass("highcharts-" + z.toLowerCase() + yt + " " + (f.isRadial ? "highcharts-radial-axis" + yt + " " : "") + (dt || "")).add(V);
            };
            m.gridGroup = st("grid", "-grid", F.gridZIndex), m.axisGroup = st("axis", "", F.zIndex), m.labelGroup = st("axis-labels", "-labels", rt.zIndex);
          }
          if (et || m.isLinked ? (G.forEach(function(pt) {
            m.generateTick(pt);
          }), m.renderUnsquish(), m.reserveSpaceDefault = Q === 0 || Q === 2 || { 1: "left", 3: "right" }[Q] === m.labelAlign, A(rt.reserveSpace, m.labelAlign === "center" ? !0 : null, m.reserveSpaceDefault) && G.forEach(function(pt) {
            tt = Math.max(k[pt].getLabelSize(), tt);
          }), m.staggerLines && (tt *= m.staggerLines), m.labelOffset = tt * (m.opposite ? -1 : 1)) : o(k, function(pt, yt) {
            pt.destroy(), delete k[yt];
          }), nt && nt.text && nt.enabled !== !1 && (m.addTitle(lt), lt && nt.reserveSpace !== !1)) {
            m.titleOffset = at = m.axisTitle.getBBox()[Y ? "height" : "width"];
            var ht = nt.offset;
            J = C(ht) ? 0 : A(nt.margin, Y ? 5 : 10);
          }
          m.renderLine(), m.offset = gt * A(F.offset, ct[Q] ? ct[Q] + (F.margin || 0) : 0), m.tickRotCorr = m.tickRotCorr || { x: 0, y: 0 }, nt = Q === 0 ? -m.labelMetrics().h : Q === 2 ? m.tickRotCorr.y : 0, et = Math.abs(tt) + J, tt && (et = et - nt + gt * (Y ? A(rt.y, m.tickRotCorr.y + 8 * gt) : rt.x)), m.axisTitleMargin = A(ht, et), m.getMaxLabelDimensions && (m.maxLabelDimensions = m.getMaxLabelDimensions(k, G)), z !== "colorAxis" && (Y = this.tickSize("tick"), ct[Q] = Math.max(ct[Q], (m.axisTitleMargin || 0) + at + gt * m.offset, et, G && G.length && Y ? Y[0] + gt * m.offset : 0), F = !m.axisLine || F.offset ? 0 : 2 * Math.floor(m.axisLine.strokeWidth() / 2), L[it] = Math.max(L[it], F)), c(this, "afterGetOffset");
        }, X.prototype.getLinePath = function(f) {
          var m = this.chart, L = this.opposite, Y = this.offset, F = this.horiz, Q = this.left + (L ? this.width : 0) + Y;
          return Y = m.chartHeight - this.bottom - (L ? this.height : 0) + Y, L && (f *= -1), m.renderer.crispLine([["M", F ? this.left : Q, F ? Y : this.top], ["L", F ? m.chartWidth - this.right : Q, F ? Y : m.chartHeight - this.bottom]], f);
        }, X.prototype.renderLine = function() {
          this.axisLine || (this.axisLine = this.chart.renderer.path().addClass("highcharts-axis-line").add(this.axisGroup), this.chart.styledMode || this.axisLine.attr({ stroke: this.options.lineColor, "stroke-width": this.options.lineWidth, zIndex: 7 }));
        }, X.prototype.getTitlePosition = function() {
          var f = this.horiz, m = this.left, L = this.top, Y = this.len, F = this.options.title, Q = f ? m : L, k = this.opposite, G = this.offset, z = F.x, V = F.y, q = this.axisTitle, it = this.chart.renderer.fontMetrics(F.style.fontSize, q);
          return q = Math.max(q.getBBox(null, 0).height - it.h - 1, 0), Y = { low: Q + (f ? 0 : Y), middle: Q + Y / 2, high: Q + (f ? Y : 0) }[F.align], m = (f ? L + this.height : m) + (f ? 1 : -1) * (k ? -1 : 1) * this.axisTitleMargin + [-q, q, it.f, -q][this.side], f = { x: f ? Y + z : m + (k ? this.width : 0) + G + z, y: f ? m + V - (k ? this.height : 0) + G : Y + V }, c(this, "afterGetTitlePosition", { titlePosition: f }), f;
        }, X.prototype.renderMinorTick = function(f, m) {
          var L = this.minorTicks;
          L[f] || (L[f] = new U(this, f, "minor")), m && L[f].isNew && L[f].render(null, !0), L[f].render(null, !1, 1);
        }, X.prototype.renderTick = function(f, m, L) {
          var Y = this.ticks;
          (!this.isLinked || f >= this.min && f <= this.max || this.grid && this.grid.isColumn) && (Y[f] || (Y[f] = new U(this, f)), L && Y[f].isNew && Y[f].render(
            m,
            !0,
            -1
          ), Y[f].render(m));
        }, X.prototype.render = function() {
          var f = this, m = f.chart, L = f.logarithmic, Y = f.options, F = f.isLinked, Q = f.tickPositions, k = f.axisTitle, G = f.ticks, z = f.minorTicks, V = f.alternateBands, q = Y.stackLabels, it = Y.alternateGridColor, et = f.tickmarkOffset, nt = f.axisLine, rt = f.showAxis, ct = N(m.renderer.globalAnimation), gt, dt;
          if (f.labelEdge.length = 0, f.overlap = !1, [G, z, V].forEach(function(at) {
            o(at, function(J) {
              J.isActive = !1;
            });
          }), f.hasData() || F) {
            var lt = f.chart.hasRendered && f.old && l(f.old.min);
            f.minorTickInterval && !f.categories && f.getMinorTickPositions().forEach(function(at) {
              f.renderMinorTick(at, lt);
            }), Q.length && (Q.forEach(function(at, J) {
              f.renderTick(at, J, lt);
            }), et && (f.min === 0 || f.single) && (G[-1] || (G[-1] = new U(f, -1, null, !0)), G[-1].render(-1))), it && Q.forEach(function(at, J) {
              dt = typeof Q[J + 1] < "u" ? Q[J + 1] + et : f.max - et, J % 2 === 0 && at < f.max && dt <= f.max + (m.polar ? -et : et) && (V[at] || (V[at] = new $.PlotLineOrBand(f)), gt = at + et, V[at].options = { from: L ? L.lin2log(gt) : gt, to: L ? L.lin2log(dt) : dt, color: it, className: "highcharts-alternate-grid" }, V[at].render(), V[at].isActive = !0);
            }), f._addedPlotLB || (f._addedPlotLB = !0, (Y.plotLines || []).concat(Y.plotBands || []).forEach(function(at) {
              f.addPlotBandOrLine(at);
            }));
          }
          [G, z, V].forEach(function(at) {
            var J = [], tt = ct.duration;
            o(at, function(st, ht) {
              st.isActive || (st.render(ht, !1, 0), st.isActive = !1, J.push(ht));
            }), T(function() {
              for (var st = J.length; st--; )
                at[J[st]] && !at[J[st]].isActive && (at[J[st]].destroy(), delete at[J[st]]);
            }, at !== V && m.hasRendered && tt ? tt : 0);
          }), nt && (nt[nt.isPlaced ? "animate" : "attr"]({ d: this.getLinePath(nt.strokeWidth()) }), nt.isPlaced = !0, nt[rt ? "show" : "hide"](rt)), k && rt && (Y = f.getTitlePosition(), l(Y.y) ? (k[k.isNew ? "attr" : "animate"](Y), k.isNew = !1) : (k.attr("y", -9999), k.isNew = !0)), q && q.enabled && f.stacking && f.stacking.renderStackTotals(), f.old = { len: f.len, max: f.max, min: f.min, transA: f.transA, userMax: f.userMax, userMin: f.userMin }, f.isDirty = !1, c(this, "afterRender");
        }, X.prototype.redraw = function() {
          this.visible && (this.render(), this.plotLinesAndBands.forEach(function(f) {
            f.render();
          })), this.series.forEach(function(f) {
            f.isDirty = !0;
          });
        }, X.prototype.getKeepProps = function() {
          return this.keepProps || X.keepProps;
        }, X.prototype.destroy = function(f) {
          var m = this, L = m.plotLinesAndBands, Y = this.eventOptions;
          if (c(this, "destroy", { keepEvents: f }), f || D(m), [m.ticks, m.minorTicks, m.alternateBands].forEach(function(Q) {
            b(Q);
          }), L)
            for (f = L.length; f--; )
              L[f].destroy();
          "axisLine axisTitle axisGroup gridGroup labelGroup cross scrollbar".split(" ").forEach(function(Q) {
            m[Q] && (m[Q] = m[Q].destroy());
          });
          for (var F in m.plotLinesAndBandsGroups)
            m.plotLinesAndBandsGroups[F] = m.plotLinesAndBandsGroups[F].destroy();
          o(m, function(Q, k) {
            m.getKeepProps().indexOf(k) === -1 && delete m[k];
          }), this.eventOptions = Y;
        }, X.prototype.drawCrosshair = function(f, m) {
          var L = this.crosshair, Y = A(L && L.snap, !0), F = this.chart, Q, k = this.cross;
          if (c(this, "drawCrosshair", { e: f, point: m }), f || (f = this.cross && this.cross.e), L && (C(m) || !Y) !== !1) {
            if (Y ? C(m) && (Q = A(this.coll !== "colorAxis" ? m.crosshairPos : null, this.isXAxis ? m.plotX : this.len - m.plotY)) : Q = f && (this.horiz ? f.chartX - this.pos : this.len - f.chartY + this.pos), C(Q)) {
              var G = { value: m && (this.isXAxis ? m.x : A(m.stackY, m.y)), translatedValue: Q };
              F.polar && h(G, { isCrosshair: !0, chartX: f && f.chartX, chartY: f && f.chartY, point: m }), G = this.getPlotLinePath(G) || null;
            }
            if (!C(G)) {
              this.hideCrosshair();
              return;
            }
            Y = this.categories && !this.isRadial, k || (this.cross = k = F.renderer.path().addClass("highcharts-crosshair highcharts-crosshair-" + (Y ? "category " : "thin ") + (L.className || "")).attr({ zIndex: A(L.zIndex, 2) }).add(), F.styledMode || (k.attr({ stroke: L.color || (Y ? I.parse("#ccd6eb").setOpacity(0.25).get() : "#cccccc"), "stroke-width": A(L.width, 1) }).css({ "pointer-events": "none" }), L.dashStyle && k.attr({ dashstyle: L.dashStyle }))), k.show().attr({ d: G }), Y && !L.width && k.attr({ "stroke-width": this.transA }), this.cross.e = f;
          } else
            this.hideCrosshair();
          c(this, "afterDrawCrosshair", { e: f, point: m });
        }, X.prototype.hideCrosshair = function() {
          this.cross && this.cross.hide(), c(this, "afterHideCrosshair");
        }, X.prototype.hasVerticalPanning = function() {
          var f = this.chart.options.chart.panning;
          return !!(f && f.enabled && /y/.test(f.type));
        }, X.prototype.validatePositiveValue = function(f) {
          return l(f) && 0 < f;
        }, X.prototype.update = function(f, m) {
          var L = this.chart;
          f = t(this.userOptions, f), this.destroy(!0), this.init(L, f), L.isDirtyBox = !0, A(m, !0) && L.redraw();
        }, X.prototype.remove = function(f) {
          for (var m = this.chart, L = this.coll, Y = this.series, F = Y.length; F--; )
            Y[F] && Y[F].remove(!1);
          w(m.axes, this), w(m[L], this), m[L].forEach(function(Q, k) {
            Q.options.index = Q.userOptions.index = k;
          }), this.destroy(), m.isDirtyBox = !0, A(f, !0) && m.redraw();
        }, X.prototype.setTitle = function(f, m) {
          this.update({ title: f }, m);
        }, X.prototype.setCategories = function(f, m) {
          this.update(
            { categories: f },
            m
          );
        }, X.defaultOptions = R.defaultXAxisOptions, X.keepProps = "extKey hcEvents names series userMax userMin".split(" "), X;
      }(), y;
    }), E(a, "Core/Axis/DateTimeAxis.js", [a["Core/Utilities.js"]], function(y) {
      var R = y.addEvent, I = y.getMagnitude, Z = y.normalizeTickInterval, H = y.timeUnits, $;
      return function(U) {
        function W() {
          return this.chart.time.getTimeTicks.apply(this.chart.time, arguments);
        }
        function N(u) {
          u.userOptions.type !== "datetime" ? this.dateTime = void 0 : this.dateTime || (this.dateTime = new v(this));
        }
        var M = [];
        U.compose = function(u) {
          return M.indexOf(u) === -1 && (M.push(u), u.keepProps.push("dateTime"), u.prototype.getTimeTicks = W, R(u, "init", N)), u;
        };
        var v = function() {
          function u(d) {
            this.axis = d;
          }
          return u.prototype.normalizeTimeTickInterval = function(d, P) {
            var O = P || [["millisecond", [1, 2, 5, 10, 20, 25, 50, 100, 200, 500]], ["second", [1, 2, 5, 10, 15, 30]], ["minute", [1, 2, 5, 10, 15, 30]], ["hour", [1, 2, 3, 4, 6, 8, 12]], ["day", [1, 2]], ["week", [1, 2]], ["month", [1, 2, 3, 4, 6]], ["year", null]];
            P = O[O.length - 1];
            var B = H[P[0]], C = P[1], b;
            for (b = 0; b < O.length && (P = O[b], B = H[P[0]], C = P[1], !(O[b + 1] && d <= (B * C[C.length - 1] + H[O[b + 1][0]]) / 2)); b++)
              ;
            return B === H.year && d < 5 * B && (C = [1, 2, 5]), d = Z(d / B, C, P[0] === "year" ? Math.max(I(d / B), 1) : 1), { unitRange: B, count: d, unitName: P[0] };
          }, u.prototype.getXDateFormat = function(d, P) {
            var O = this.axis;
            return O.closestPointRange ? O.chart.time.getDateFormat(O.closestPointRange, d, O.options.startOfWeek, P) || P.year : P.day;
          }, u;
        }();
        U.Additions = v;
      }($ || ($ = {})), $;
    }), E(a, "Core/Axis/LogarithmicAxis.js", [a["Core/Utilities.js"]], function(y) {
      var R = y.addEvent, I = y.getMagnitude, Z = y.normalizeTickInterval, H = y.pick, $;
      return function(U) {
        function W(u) {
          var d = this.logarithmic;
          u.userOptions.type !== "logarithmic" ? this.logarithmic = void 0 : d || (this.logarithmic = new v(this));
        }
        function N() {
          var u = this.logarithmic;
          u && (this.lin2val = function(d) {
            return u.lin2log(d);
          }, this.val2lin = function(d) {
            return u.log2lin(d);
          });
        }
        var M = [];
        U.compose = function(u) {
          return M.indexOf(u) === -1 && (M.push(u), u.keepProps.push("logarithmic"), R(u, "init", W), R(u, "afterInit", N)), u;
        };
        var v = function() {
          function u(d) {
            this.axis = d;
          }
          return u.prototype.getLogTickPositions = function(d, P, O, B) {
            var C = this.axis, b = C.len, w = C.options, x = [];
            if (B || (this.minorAutoInterval = void 0), 0.5 <= d)
              d = Math.round(d), x = C.getLinearTickPositions(d, P, O);
            else if (0.08 <= d) {
              var h = Math.floor(P), c, p = w = void 0;
              for (b = 0.3 < d ? [1, 2, 4] : 0.15 < d ? [1, 2, 4, 6, 8] : [1, 2, 3, 4, 5, 6, 7, 8, 9]; h < O + 1 && !p; h++) {
                var i = b.length;
                for (c = 0; c < i && !p; c++) {
                  var l = this.log2lin(this.lin2log(h) * b[c]);
                  l > P && (!B || w <= O) && typeof w < "u" && x.push(w), w > O && (p = !0), w = l;
                }
              }
            } else
              P = this.lin2log(P), O = this.lin2log(O), d = B ? C.getMinorTickInterval() : w.tickInterval, d = H(d === "auto" ? null : d, this.minorAutoInterval, w.tickPixelInterval / (B ? 5 : 1) * (O - P) / ((B ? b / C.tickPositions.length : b) || 1)), d = Z(d, void 0, I(d)), x = C.getLinearTickPositions(d, P, O).map(this.log2lin), B || (this.minorAutoInterval = d / 5);
            return B || (C.tickInterval = d), x;
          }, u.prototype.lin2log = function(d) {
            return Math.pow(10, d);
          }, u.prototype.log2lin = function(d) {
            return Math.log(d) / Math.LN10;
          }, u;
        }();
        U.Additions = v;
      }($ || ($ = {})), $;
    }), E(a, "Core/Axis/PlotLineOrBand/PlotLineOrBandAxis.js", [a["Core/Utilities.js"]], function(y) {
      var R = y.erase, I = y.extend, Z = y.isNumber, H;
      return function($) {
        var U = [], W;
        $.compose = function(M, v) {
          return W || (W = M), U.indexOf(v) === -1 && (U.push(v), I(v.prototype, N.prototype)), v;
        };
        var N = function() {
          function M() {
          }
          return M.prototype.getPlotBandPath = function(v, u, d) {
            d === void 0 && (d = this.options);
            var P = this.getPlotLinePath({ value: u, force: !0, acrossPanes: d.acrossPanes }), O = [], B = this.horiz;
            if (u = !Z(this.min) || !Z(this.max) || v < this.min && u < this.min || v > this.max && u > this.max, v = this.getPlotLinePath({ value: v, force: !0, acrossPanes: d.acrossPanes }), d = 1, v && P) {
              if (u) {
                var C = v.toString() === P.toString();
                d = 0;
              }
              for (u = 0; u < v.length; u += 2) {
                var b = v[u], w = v[u + 1], x = P[u], h = P[u + 1];
                b[0] !== "M" && b[0] !== "L" || w[0] !== "M" && w[0] !== "L" || x[0] !== "M" && x[0] !== "L" || h[0] !== "M" && h[0] !== "L" || (B && x[1] === b[1] ? (x[1] += d, h[1] += d) : B || x[2] !== b[2] || (x[2] += d, h[2] += d), O.push(["M", b[1], b[2]], ["L", w[1], w[2]], ["L", h[1], h[2]], ["L", x[1], x[2]], ["Z"])), O.isFlat = C;
              }
            }
            return O;
          }, M.prototype.addPlotBand = function(v) {
            return this.addPlotBandOrLine(v, "plotBands");
          }, M.prototype.addPlotLine = function(v) {
            return this.addPlotBandOrLine(
              v,
              "plotLines"
            );
          }, M.prototype.addPlotBandOrLine = function(v, u) {
            var d = this, P = this.userOptions, O = new W(this, v);
            if (this.visible && (O = O.render()), O) {
              if (this._addedPlotLB || (this._addedPlotLB = !0, (P.plotLines || []).concat(P.plotBands || []).forEach(function(C) {
                d.addPlotBandOrLine(C);
              })), u) {
                var B = P[u] || [];
                B.push(v), P[u] = B;
              }
              this.plotLinesAndBands.push(O);
            }
            return O;
          }, M.prototype.removePlotBandOrLine = function(v) {
            var u = this.plotLinesAndBands, d = this.options, P = this.userOptions;
            if (u) {
              for (var O = u.length; O--; )
                u[O].id === v && u[O].destroy();
              [d.plotLines || [], P.plotLines || [], d.plotBands || [], P.plotBands || []].forEach(function(B) {
                for (O = B.length; O--; )
                  (B[O] || {}).id === v && R(B, B[O]);
              });
            }
          }, M.prototype.removePlotBand = function(v) {
            this.removePlotBandOrLine(v);
          }, M.prototype.removePlotLine = function(v) {
            this.removePlotBandOrLine(v);
          }, M;
        }();
      }(H || (H = {})), H;
    }), E(a, "Core/Axis/PlotLineOrBand/PlotLineOrBand.js", [a["Core/Axis/PlotLineOrBand/PlotLineOrBandAxis.js"], a["Core/Utilities.js"]], function(y, R) {
      var I = R.arrayMax, Z = R.arrayMin, H = R.defined, $ = R.destroyObjectProperties, U = R.erase, W = R.fireEvent, N = R.merge, M = R.objectEach, v = R.pick;
      return R = function() {
        function u(d, P) {
          this.axis = d, P && (this.options = P, this.id = P.id);
        }
        return u.compose = function(d) {
          return y.compose(u, d);
        }, u.prototype.render = function() {
          W(this, "render");
          var d = this, P = d.axis, O = P.horiz, B = P.logarithmic, C = d.options, b = C.color, w = v(C.zIndex, 0), x = C.events, h = {}, c = P.chart.renderer, p = C.label, i = d.label, l = C.to, s = C.from, t = C.value, n = d.svgElem, o = [], A = H(s) && H(l);
          o = H(t);
          var _ = !n, D = { class: "highcharts-plot-" + (A ? "band " : "line ") + (C.className || "") }, j = A ? "bands" : "lines";
          if (B && (s = B.log2lin(s), l = B.log2lin(l), t = B.log2lin(t)), P.chart.styledMode || (o ? (D.stroke = b || "#999999", D["stroke-width"] = v(C.width, 1), C.dashStyle && (D.dashstyle = C.dashStyle)) : A && (D.fill = b || "#e6ebf5", C.borderWidth && (D.stroke = C.borderColor, D["stroke-width"] = C.borderWidth))), h.zIndex = w, j += "-" + w, (B = P.plotLinesAndBandsGroups[j]) || (P.plotLinesAndBandsGroups[j] = B = c.g("plot-" + j).attr(h).add()), _ && (d.svgElem = n = c.path().attr(D).add(B)), o)
            o = P.getPlotLinePath({
              value: t,
              lineWidth: n.strokeWidth(),
              acrossPanes: C.acrossPanes
            });
          else if (A)
            o = P.getPlotBandPath(s, l, C);
          else
            return;
          return !d.eventsAdded && x && (M(x, function(T, X) {
            n.on(X, function(f) {
              x[X].apply(d, [f]);
            });
          }), d.eventsAdded = !0), (_ || !n.d) && o && o.length ? n.attr({ d: o }) : n && (o ? (n.show(!0), n.animate({ d: o })) : n.d && (n.hide(), i && (d.label = i = i.destroy()))), p && (H(p.text) || H(p.formatter)) && o && o.length && 0 < P.width && 0 < P.height && !o.isFlat ? (p = N({ align: O && A && "center", x: O ? !A && 4 : 10, verticalAlign: !O && A && "middle", y: O ? A ? 16 : 10 : A ? 6 : -4, rotation: O && !A && 90 }, p), this.renderLabel(
            p,
            o,
            A,
            w
          )) : i && i.hide(), d;
        }, u.prototype.renderLabel = function(d, P, O, B) {
          var C = this.axis, b = C.chart.renderer, w = this.label;
          w || (this.label = w = b.text(this.getLabelText(d), 0, 0, d.useHTML).attr({ align: d.textAlign || d.align, rotation: d.rotation, class: "highcharts-plot-" + (O ? "band" : "line") + "-label " + (d.className || ""), zIndex: B }).add(), C.chart.styledMode || w.css(N({ textOverflow: "ellipsis" }, d.style))), B = P.xBounds || [P[0][1], P[1][1], O ? P[2][1] : P[0][1]], P = P.yBounds || [P[0][2], P[1][2], O ? P[2][2] : P[0][2]], O = Z(B), b = Z(P), w.align(
            d,
            !1,
            { x: O, y: b, width: I(B) - O, height: I(P) - b }
          ), w.alignValue && w.alignValue !== "left" || w.css({ width: (w.rotation === 90 ? C.height - (w.alignAttr.y - C.top) : C.width - (w.alignAttr.x - C.left)) + "px" }), w.show(!0);
        }, u.prototype.getLabelText = function(d) {
          return H(d.formatter) ? d.formatter.call(this) : d.text;
        }, u.prototype.destroy = function() {
          U(this.axis.plotLinesAndBands, this), delete this.axis, $(this);
        }, u;
      }(), R;
    }), E(a, "Core/Tooltip.js", [
      a["Core/FormatUtilities.js"],
      a["Core/Globals.js"],
      a["Core/Renderer/RendererUtilities.js"],
      a["Core/Renderer/RendererRegistry.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I, Z, H) {
      var $ = y.format, U = R.doc, W = I.distribute, N = H.addEvent, M = H.clamp, v = H.css, u = H.defined, d = H.discardElement, P = H.extend, O = H.fireEvent, B = H.isArray, C = H.isNumber, b = H.isString, w = H.merge, x = H.pick, h = H.splat, c = H.syncTimeout;
      return y = function() {
        function p(i, l) {
          this.allowShared = !0, this.container = void 0, this.crosshairs = [], this.distance = 0, this.isHidden = !0, this.isSticky = !1, this.now = {}, this.options = {}, this.outside = !1, this.chart = i, this.init(i, l);
        }
        return p.prototype.applyFilter = function() {
          var i = this.chart;
          i.renderer.definition({ tagName: "filter", attributes: { id: "drop-shadow-" + i.index, opacity: 0.5 }, children: [{ tagName: "feGaussianBlur", attributes: { in: "SourceAlpha", stdDeviation: 1 } }, { tagName: "feOffset", attributes: { dx: 1, dy: 1 } }, { tagName: "feComponentTransfer", children: [{ tagName: "feFuncA", attributes: { type: "linear", slope: 0.3 } }] }, { tagName: "feMerge", children: [{ tagName: "feMergeNode" }, { tagName: "feMergeNode", attributes: { in: "SourceGraphic" } }] }] });
        }, p.prototype.bodyFormatter = function(i) {
          return i.map(function(l) {
            var s = l.series.tooltipOptions;
            return (s[(l.point.formatPrefix || "point") + "Formatter"] || l.point.tooltipFormatter).call(l.point, s[(l.point.formatPrefix || "point") + "Format"] || "");
          });
        }, p.prototype.cleanSplit = function(i) {
          this.chart.series.forEach(function(l) {
            var s = l && l.tt;
            s && (!s.isActive || i ? l.tt = s.destroy() : s.isActive = !1);
          });
        }, p.prototype.defaultFormatter = function(i) {
          var l = this.points || h(this), s = [i.tooltipFooterHeaderFormatter(l[0])];
          return s = s.concat(i.bodyFormatter(l)), s.push(i.tooltipFooterHeaderFormatter(
            l[0],
            !0
          )), s;
        }, p.prototype.destroy = function() {
          this.label && (this.label = this.label.destroy()), this.split && this.tt && (this.cleanSplit(!0), this.tt = this.tt.destroy()), this.renderer && (this.renderer = this.renderer.destroy(), d(this.container)), H.clearTimeout(this.hideTimer), H.clearTimeout(this.tooltipTimeout);
        }, p.prototype.getAnchor = function(i, l) {
          var s = this.chart, t = s.pointer, n = s.inverted, o = s.plotTop, A = s.plotLeft, _, D, j = 0, T = 0;
          return i = h(i), this.followPointer && l ? (typeof l.chartX > "u" && (l = t.normalize(l)), t = [l.chartX - A, l.chartY - o]) : i[0].tooltipPos ? t = i[0].tooltipPos : (i.forEach(function(X) {
            _ = X.series.yAxis, D = X.series.xAxis, j += X.plotX || 0, T += X.plotLow ? (X.plotLow + (X.plotHigh || 0)) / 2 : X.plotY || 0, D && _ && (n ? (j += o + s.plotHeight - D.len - D.pos, T += A + s.plotWidth - _.len - _.pos) : (j += D.pos - A, T += _.pos - o));
          }), j /= i.length, T /= i.length, t = [n ? s.plotWidth - T : j, n ? s.plotHeight - j : T], this.shared && 1 < i.length && l && (n ? t[0] = l.chartX - A : t[1] = l.chartY - o)), t.map(Math.round);
        }, p.prototype.getLabel = function() {
          var i = this, l = this.chart.styledMode, s = this.options, t = this.split && this.allowShared, n = "tooltip" + (u(s.className) ? " " + s.className : ""), o = s.style.pointerEvents || (!this.followPointer && s.stickOnContact ? "auto" : "none"), A = function() {
            i.inContact = !0;
          }, _ = function(Y) {
            var F = i.chart.hoverSeries;
            i.inContact = i.shouldStickOnContact() && i.chart.pointer.inClass(Y.relatedTarget, "highcharts-tooltip"), !i.inContact && F && F.onMouseOut && F.onMouseOut();
          }, D, j = this.chart.renderer;
          if (i.label) {
            var T = !i.label.hasClass("highcharts-label");
            (t && !T || !t && T) && i.destroy();
          }
          if (!this.label) {
            if (this.outside) {
              T = this.chart.options.chart.style;
              var X = Z.getRendererType();
              this.container = D = R.doc.createElement("div"), D.className = "highcharts-tooltip-container", v(D, { position: "absolute", top: "1px", pointerEvents: o, zIndex: Math.max(this.options.style.zIndex || 0, (T && T.zIndex || 0) + 3) }), N(D, "mouseenter", A), N(D, "mouseleave", _), R.doc.body.appendChild(D), this.renderer = j = new X(D, 0, 0, T, void 0, void 0, j.styledMode);
            }
            if (t ? this.label = j.g(n) : (this.label = j.label("", 0, 0, s.shape, void 0, void 0, s.useHTML, void 0, n).attr({ padding: s.padding, r: s.borderRadius }), l || this.label.attr({ fill: s.backgroundColor, "stroke-width": s.borderWidth }).css(s.style).css({ pointerEvents: o }).shadow(s.shadow)), l && s.shadow && (this.applyFilter(), this.label.attr({ filter: "url(#drop-shadow-" + this.chart.index + ")" })), i.outside && !i.split) {
              var f = this.label, m = f.xSetter, L = f.ySetter;
              f.xSetter = function(Y) {
                m.call(f, i.distance), D.style.left = Y + "px";
              }, f.ySetter = function(Y) {
                L.call(f, i.distance), D.style.top = Y + "px";
              };
            }
            this.label.on("mouseenter", A).on("mouseleave", _).attr({ zIndex: 8 }).add();
          }
          return this.label;
        }, p.prototype.getPosition = function(i, l, s) {
          var t = this.chart, n = this.distance, o = {}, A = t.inverted && s.h || 0, _ = this.outside, D = _ ? U.documentElement.clientWidth - 2 * n : t.chartWidth, j = _ ? Math.max(U.body.scrollHeight, U.documentElement.scrollHeight, U.body.offsetHeight, U.documentElement.offsetHeight, U.documentElement.clientHeight) : t.chartHeight, T = t.pointer.getChartPosition(), X = function(z) {
            var V = z === "x";
            return [z, V ? D : j, V ? i : l].concat(_ ? [V ? i * T.scaleX : l * T.scaleY, V ? T.left - n + (s.plotX + t.plotLeft) * T.scaleX : T.top - n + (s.plotY + t.plotTop) * T.scaleY, 0, V ? D : j] : [V ? i : l, V ? s.plotX + t.plotLeft : s.plotY + t.plotTop, V ? t.plotLeft : t.plotTop, V ? t.plotLeft + t.plotWidth : t.plotTop + t.plotHeight]);
          }, f = X("y"), m = X("x"), L;
          X = !!s.negative, !t.polar && t.hoverSeries && t.hoverSeries.yAxis && t.hoverSeries.yAxis.reversed && (X = !X);
          var Y = !this.followPointer && x(s.ttBelow, !t.inverted === X), F = function(z, V, q, it, et, nt, rt) {
            var ct = _ ? z === "y" ? n * T.scaleY : n * T.scaleX : n, gt = (q - it) / 2, dt = it < et - n, lt = et + n + it < V, at = et - ct - q + gt;
            if (et = et + ct - gt, Y && lt)
              o[z] = et;
            else if (!Y && dt)
              o[z] = at;
            else if (dt)
              o[z] = Math.min(rt - it, 0 > at - A ? at : at - A);
            else if (lt)
              o[z] = Math.max(nt, et + A + q > V ? et : et + A);
            else
              return !1;
          }, Q = function(z, V, q, it, et) {
            var nt;
            return et < n || et > V - n ? nt = !1 : o[z] = et < q / 2 ? 1 : et > V - it / 2 ? V - it - 2 : et - q / 2, nt;
          }, k = function(z) {
            var V = f;
            f = m, m = V, L = z;
          }, G = function() {
            F.apply(0, f) !== !1 ? Q.apply(0, m) !== !1 || L || (k(!0), G()) : L ? o.x = o.y = 0 : (k(!0), G());
          };
          return (t.inverted || 1 < this.len) && k(), G(), o;
        }, p.prototype.hide = function(i) {
          var l = this;
          H.clearTimeout(this.hideTimer), i = x(i, this.options.hideDelay), this.isHidden || (this.hideTimer = c(function() {
            l.getLabel().fadeOut(i && void 0), l.isHidden = !0;
          }, i));
        }, p.prototype.init = function(i, l) {
          this.chart = i, this.options = l, this.crosshairs = [], this.now = { x: 0, y: 0 }, this.isHidden = !0, this.split = l.split && !i.inverted && !i.polar, this.shared = l.shared || this.split, this.outside = x(l.outside, !(!i.scrollablePixelsX && !i.scrollablePixelsY));
        }, p.prototype.shouldStickOnContact = function() {
          return !(this.followPointer || !this.options.stickOnContact);
        }, p.prototype.isStickyOnContact = function() {
          return !(!this.shouldStickOnContact() || !this.inContact);
        }, p.prototype.move = function(i, l, s, t) {
          var n = this, o = n.now, A = n.options.animation !== !1 && !n.isHidden && (1 < Math.abs(i - o.x) || 1 < Math.abs(l - o.y)), _ = n.followPointer || 1 < n.len;
          P(o, { x: A ? (2 * o.x + i) / 3 : i, y: A ? (o.y + l) / 2 : l, anchorX: _ ? void 0 : A ? (2 * o.anchorX + s) / 3 : s, anchorY: _ ? void 0 : A ? (o.anchorY + t) / 2 : t }), n.getLabel().attr(o), n.drawTracker(), A && (H.clearTimeout(this.tooltipTimeout), this.tooltipTimeout = setTimeout(function() {
            n && n.move(i, l, s, t);
          }, 32));
        }, p.prototype.refresh = function(i, l) {
          var s = this.chart, t = this.options, n = h(i), o = n[0], A = [], _ = t.formatter || this.defaultFormatter, D = this.shared, j = s.styledMode, T = {};
          if (t.enabled) {
            H.clearTimeout(this.hideTimer), this.allowShared = !(!B(i) && i.series && i.series.noSharedTooltip), this.followPointer = !this.split && o.series.tooltipOptions.followPointer, i = this.getAnchor(i, l);
            var X = i[0], f = i[1];
            if (D && this.allowShared ? (s.pointer.applyInactiveState(n), n.forEach(function(Y) {
              Y.setState("hover"), A.push(Y.getLabelConfig());
            }), T = { x: o.category, y: o.y }, T.points = A) : T = o.getLabelConfig(), this.len = A.length, _ = _.call(T, this), D = o.series, this.distance = x(
              D.tooltipOptions.distance,
              16
            ), _ === !1)
              this.hide();
            else {
              if (this.split && this.allowShared)
                this.renderSplit(_, n);
              else {
                var m = X, L = f;
                if (l && s.pointer.isDirectTouch && (m = l.chartX - s.plotLeft, L = l.chartY - s.plotTop), s.polar || D.options.clip === !1 || n.some(function(Y) {
                  return Y.series.shouldShowTooltip(m, L);
                }))
                  l = this.getLabel(), t.style.width && !j || l.css({ width: this.chart.spacingBox.width + "px" }), l.attr({ text: _ && _.join ? _.join("") : _ }), l.removeClass(/highcharts-color-[\d]+/g).addClass("highcharts-color-" + x(o.colorIndex, D.colorIndex)), j || l.attr({ stroke: t.borderColor || o.color || D.color || "#666666" }), this.updatePosition({ plotX: X, plotY: f, negative: o.negative, ttBelow: o.ttBelow, h: i[2] || 0 });
                else {
                  this.hide();
                  return;
                }
              }
              this.isHidden && this.label && this.label.attr({ opacity: 1 }).show(), this.isHidden = !1;
            }
            O(this, "refresh");
          }
        }, p.prototype.renderSplit = function(i, l) {
          function s(lt, at, J, tt, st) {
            return st === void 0 && (st = !0), J ? (at = it ? 0 : ct, lt = M(lt - tt / 2, z.left, z.right - tt - (t.outside ? et : 0))) : (at -= nt, lt = st ? lt - tt - Q : lt + Q, lt = M(lt, st ? lt : z.left, z.right)), { x: lt, y: at };
          }
          var t = this, n = t.chart, o = t.chart, A = o.chartWidth, _ = o.chartHeight, D = o.plotHeight, j = o.plotLeft, T = o.plotTop, X = o.pointer, f = o.scrollablePixelsY;
          f = f === void 0 ? 0 : f;
          var m = o.scrollablePixelsX, L = o.scrollingContainer;
          L = L === void 0 ? { scrollLeft: 0, scrollTop: 0 } : L;
          var Y = L.scrollLeft;
          L = L.scrollTop;
          var F = o.styledMode, Q = t.distance, k = t.options, G = t.options.positioner, z = t.outside && typeof m != "number" ? U.documentElement.getBoundingClientRect() : { left: Y, right: Y + A, top: L, bottom: L + _ }, V = t.getLabel(), q = this.renderer || n.renderer, it = !(!n.xAxis[0] || !n.xAxis[0].opposite);
          n = X.getChartPosition();
          var et = n.left;
          n = n.top;
          var nt = T + L, rt = 0, ct = D - f;
          b(i) && (i = [!1, i]), i = i.slice(0, l.length + 1).reduce(function(lt, at, J) {
            if (at !== !1 && at !== "") {
              J = l[J - 1] || { isHeader: !0, plotX: l[0].plotX, plotY: D, series: {} };
              var tt = J.isHeader, st = tt ? t : J.series;
              at = at.toString();
              var ht = st.tt, pt = J.isHeader, yt = J.series, vt = "highcharts-color-" + x(J.colorIndex, yt.colorIndex, "none");
              if (ht || (ht = { padding: k.padding, r: k.borderRadius }, F || (ht.fill = k.backgroundColor, ht["stroke-width"] = k.borderWidth), ht = q.label("", 0, 0, k[pt ? "headerShape" : "shape"], void 0, void 0, k.useHTML).addClass((pt ? "highcharts-tooltip-header " : "") + "highcharts-tooltip-box " + vt).attr(ht).add(V)), ht.isActive = !0, ht.attr({ text: at }), F || ht.css(k.style).shadow(k.shadow).attr({ stroke: k.borderColor || J.color || yt.color || "#333333" }), st = st.tt = ht, pt = st.getBBox(), at = pt.width + st.strokeWidth(), tt && (rt = pt.height, ct += rt, it && (nt -= rt)), yt = J.plotX, yt = yt === void 0 ? 0 : yt, vt = J.plotY, vt = vt === void 0 ? 0 : vt, ht = J.series, J.isHeader) {
                yt = j + yt;
                var Ct = T + D / 2;
              } else {
                var Tt = ht.xAxis, kt = ht.yAxis;
                yt = Tt.pos + M(yt, -Q, Tt.len + Q), ht.shouldShowTooltip(0, kt.pos - T + vt, { ignoreX: !0 }) && (Ct = kt.pos + vt);
              }
              yt = M(
                yt,
                z.left - Q,
                z.right + Q
              ), typeof Ct == "number" ? (pt = pt.height + 1, vt = G ? G.call(t, at, pt, J) : s(yt, Ct, tt, at), lt.push({ align: G ? 0 : void 0, anchorX: yt, anchorY: Ct, boxWidth: at, point: J, rank: x(vt.rank, tt ? 1 : 0), size: pt, target: vt.y, tt: st, x: vt.x })) : st.isActive = !1;
            }
            return lt;
          }, []), !G && i.some(function(lt) {
            var at = (t.outside ? et : 0) + lt.anchorX;
            return at < z.left && at + lt.boxWidth < z.right ? !0 : at < et - z.left + lt.boxWidth && z.right - at > at;
          }) && (i = i.map(function(lt) {
            var at = s(lt.anchorX, lt.anchorY, lt.point.isHeader, lt.boxWidth, !1);
            return P(lt, { target: at.y, x: at.x });
          })), t.cleanSplit(), W(i, ct);
          var gt = et, dt = et;
          i.forEach(function(lt) {
            var at = lt.x, J = lt.boxWidth;
            lt = lt.isHeader, lt || (t.outside && et + at < gt && (gt = et + at), !lt && t.outside && gt + J > dt && (dt = et + at));
          }), i.forEach(function(lt) {
            var at = lt.x, J = lt.anchorX, tt = lt.pos, st = lt.point.isHeader;
            if (tt = { visibility: typeof tt > "u" ? "hidden" : "inherit", x: at, y: tt + nt, anchorX: J, anchorY: lt.anchorY }, t.outside && at < J) {
              var ht = et - gt;
              0 < ht && (st || (tt.x = at + ht, tt.anchorX = J + ht), st && (tt.x = (dt - gt) / 2, tt.anchorX = J + ht));
            }
            lt.tt.attr(tt);
          }), i = t.container, f = t.renderer, t.outside && i && f && (o = V.getBBox(), f.setSize(o.width + o.x, o.height + o.y, !1), i.style.left = gt + "px", i.style.top = n + "px");
        }, p.prototype.drawTracker = function() {
          if (this.followPointer || !this.options.stickOnContact)
            this.tracker && this.tracker.destroy();
          else {
            var i = this.chart, l = this.label, s = this.shared ? i.hoverPoints : i.hoverPoint;
            if (l && s) {
              var t = { x: 0, y: 0, width: 0, height: 0 };
              s = this.getAnchor(s);
              var n = l.getBBox();
              s[0] += i.plotLeft - l.translateX, s[1] += i.plotTop - l.translateY, t.x = Math.min(0, s[0]), t.y = Math.min(0, s[1]), t.width = 0 > s[0] ? Math.max(Math.abs(s[0]), n.width - s[0]) : Math.max(
                Math.abs(s[0]),
                n.width
              ), t.height = 0 > s[1] ? Math.max(Math.abs(s[1]), n.height - Math.abs(s[1])) : Math.max(Math.abs(s[1]), n.height), this.tracker ? this.tracker.attr(t) : (this.tracker = l.renderer.rect(t).addClass("highcharts-tracker").add(l), i.styledMode || this.tracker.attr({ fill: "rgba(0,0,0,0)" }));
            }
          }
        }, p.prototype.styledModeFormat = function(i) {
          return i.replace('style="font-size: 10px"', 'class="highcharts-header"').replace(/style="color:{(point|series)\.color}"/g, 'class="highcharts-color-{$1.colorIndex}"');
        }, p.prototype.tooltipFooterHeaderFormatter = function(i, l) {
          var s = i.series, t = s.tooltipOptions, n = s.xAxis, o = n && n.dateTime;
          n = { isFooter: l, labelConfig: i };
          var A = t.xDateFormat, _ = t[l ? "footerFormat" : "headerFormat"];
          return O(this, "headerFormatter", n, function(D) {
            o && !A && C(i.key) && (A = o.getXDateFormat(i.key, t.dateTimeLabelFormats)), o && A && (i.point && i.point.tooltipDateKeys || ["key"]).forEach(function(j) {
              _ = _.replace("{point." + j + "}", "{point." + j + ":" + A + "}");
            }), s.chart.styledMode && (_ = this.styledModeFormat(_)), D.text = $(_, { point: i, series: s }, this.chart);
          }), n.text;
        }, p.prototype.update = function(i) {
          this.destroy(), w(!0, this.chart.options.tooltip.userOptions, i), this.init(this.chart, w(!0, this.options, i));
        }, p.prototype.updatePosition = function(i) {
          var l = this.chart, s = this.options, t = l.pointer, n = this.getLabel();
          t = t.getChartPosition();
          var o = (s.positioner || this.getPosition).call(this, n.width, n.height, i), A = i.plotX + l.plotLeft;
          i = i.plotY + l.plotTop, this.outside && (s = s.borderWidth + 2 * this.distance, this.renderer.setSize(n.width + s, n.height + s, !1), (t.scaleX !== 1 || t.scaleY !== 1) && (v(this.container, { transform: "scale(" + t.scaleX + ", " + t.scaleY + ")" }), A *= t.scaleX, i *= t.scaleY), A += t.left - o.x, i += t.top - o.y), this.move(Math.round(o.x), Math.round(o.y || 0), A, i);
        }, p;
      }(), y;
    }), E(a, "Core/Series/Point.js", [a["Core/Renderer/HTML/AST.js"], a["Core/Animation/AnimationUtilities.js"], a["Core/DefaultOptions.js"], a["Core/FormatUtilities.js"], a["Core/Utilities.js"]], function(y, R, I, Z, H) {
      var $ = R.animObject, U = I.defaultOptions, W = Z.format, N = H.addEvent, M = H.defined, v = H.erase, u = H.extend, d = H.fireEvent, P = H.getNestedProperty, O = H.isArray, B = H.isFunction, C = H.isNumber, b = H.isObject, w = H.merge, x = H.objectEach, h = H.pick, c = H.syncTimeout, p = H.removeEvent, i = H.uniqueKey;
      return R = function() {
        function l() {
          this.colorIndex = this.category = void 0, this.formatPrefix = "point", this.id = void 0, this.isNull = !1, this.percentage = this.options = this.name = void 0, this.selected = !1, this.total = this.series = void 0, this.visible = !0, this.x = void 0;
        }
        return l.prototype.animateBeforeDestroy = function() {
          var s = this, t = { x: s.startXPos, opacity: 0 }, n = s.getGraphicalProps();
          n.singular.forEach(function(o) {
            s[o] = s[o].animate(o === "dataLabel" ? { x: s[o].startXPos, y: s[o].startYPos, opacity: 0 } : t);
          }), n.plural.forEach(function(o) {
            s[o].forEach(function(A) {
              A.element && A.animate(u({ x: s.startXPos }, A.startYPos ? { x: A.startXPos, y: A.startYPos } : {}));
            });
          });
        }, l.prototype.applyOptions = function(s, t) {
          var n = this.series, o = n.options.pointValKey || n.pointValKey;
          return s = l.prototype.optionsToObject.call(this, s), u(this, s), this.options = this.options ? u(this.options, s) : s, s.group && delete this.group, s.dataLabels && delete this.dataLabels, o && (this.y = l.prototype.getNestedProperty.call(
            this,
            o
          )), this.formatPrefix = (this.isNull = h(this.isValid && !this.isValid(), this.x === null || !C(this.y))) ? "null" : "point", this.selected && (this.state = "select"), "name" in this && typeof t > "u" && n.xAxis && n.xAxis.hasNames && (this.x = n.xAxis.nameToX(this)), typeof this.x > "u" && n ? this.x = typeof t > "u" ? n.autoIncrement() : t : C(s.x) && n.options.relativeXValue && (this.x = n.autoIncrement(s.x)), this;
        }, l.prototype.destroy = function() {
          function s() {
            (t.graphic || t.dataLabel || t.dataLabels) && (p(t), t.destroyElements());
            for (D in t)
              t[D] = null;
          }
          var t = this, n = t.series, o = n.chart;
          n = n.options.dataSorting;
          var A = o.hoverPoints, _ = $(t.series.chart.renderer.globalAnimation), D;
          t.legendItem && o.legend.destroyItem(t), A && (t.setState(), v(A, t), A.length || (o.hoverPoints = null)), t === o.hoverPoint && t.onMouseOut(), n && n.enabled ? (this.animateBeforeDestroy(), c(s, _.duration)) : s(), o.pointCount--;
        }, l.prototype.destroyElements = function(s) {
          var t = this;
          s = t.getGraphicalProps(s), s.singular.forEach(function(n) {
            t[n] = t[n].destroy();
          }), s.plural.forEach(function(n) {
            t[n].forEach(function(o) {
              o.element && o.destroy();
            }), delete t[n];
          });
        }, l.prototype.firePointEvent = function(s, t, n) {
          var o = this, A = this.series.options;
          (A.point.events[s] || o.options && o.options.events && o.options.events[s]) && o.importEvents(), s === "click" && A.allowPointSelect && (n = function(_) {
            o.select && o.select(null, _.ctrlKey || _.metaKey || _.shiftKey);
          }), d(o, s, t, n);
        }, l.prototype.getClassName = function() {
          return "highcharts-point" + (this.selected ? " highcharts-point-select" : "") + (this.negative ? " highcharts-negative" : "") + (this.isNull ? " highcharts-null-point" : "") + (typeof this.colorIndex < "u" ? " highcharts-color-" + this.colorIndex : "") + (this.options.className ? " " + this.options.className : "") + (this.zone && this.zone.className ? " " + this.zone.className.replace("highcharts-negative", "") : "");
        }, l.prototype.getGraphicalProps = function(s) {
          var t = this, n = [], o = { singular: [], plural: [] }, A;
          for (s = s || { graphic: 1, dataLabel: 1 }, s.graphic && n.push("graphic", "upperGraphic", "shadowGroup"), s.dataLabel && n.push("dataLabel", "dataLabelUpper", "connector"), A = n.length; A--; ) {
            var _ = n[A];
            t[_] && o.singular.push(_);
          }
          return ["dataLabel", "connector"].forEach(function(D) {
            var j = D + "s";
            s[D] && t[j] && o.plural.push(j);
          }), o;
        }, l.prototype.getLabelConfig = function() {
          return { x: this.category, y: this.y, color: this.color, colorIndex: this.colorIndex, key: this.name || this.category, series: this.series, point: this, percentage: this.percentage, total: this.total || this.stackTotal };
        }, l.prototype.getNestedProperty = function(s) {
          if (s)
            return s.indexOf("custom.") === 0 ? P(s, this.options) : this[s];
        }, l.prototype.getZone = function() {
          var s = this.series, t = s.zones;
          s = s.zoneAxis || "y";
          var n, o = 0;
          for (n = t[o]; this[s] >= n.value; )
            n = t[++o];
          return this.nonZonedColor || (this.nonZonedColor = this.color), this.color = n && n.color && !this.options.color ? n.color : this.nonZonedColor, n;
        }, l.prototype.hasNewShapeType = function() {
          return (this.graphic && (this.graphic.symbolName || this.graphic.element.nodeName)) !== this.shapeType;
        }, l.prototype.init = function(s, t, n) {
          return this.series = s, this.applyOptions(t, n), this.id = M(this.id) ? this.id : i(), this.resolveColor(), s.chart.pointCount++, d(this, "afterInit"), this;
        }, l.prototype.optionsToObject = function(s) {
          var t = this.series, n = t.options.keys, o = n || t.pointArrayMap || ["y"], A = o.length, _ = {}, D = 0, j = 0;
          if (C(s) || s === null)
            _[o[0]] = s;
          else if (O(s))
            for (!n && s.length > A && (t = typeof s[0], t === "string" ? _.name = s[0] : t === "number" && (_.x = s[0]), D++); j < A; )
              n && typeof s[D] > "u" || (0 < o[j].indexOf(".") ? l.prototype.setNestedProperty(_, s[D], o[j]) : _[o[j]] = s[D]), D++, j++;
          else
            typeof s == "object" && (_ = s, s.dataLabels && (t._hasPointLabels = !0), s.marker && (t._hasPointMarkers = !0));
          return _;
        }, l.prototype.resolveColor = function() {
          var s = this.series, t = s.chart.styledMode, n = s.chart.options.chart.colorCount;
          if (delete this.nonZonedColor, s.options.colorByPoint) {
            if (!t) {
              n = s.options.colors || s.chart.options.colors;
              var o = n[s.colorCounter];
              n = n.length;
            }
            t = s.colorCounter, s.colorCounter++, s.colorCounter === n && (s.colorCounter = 0);
          } else
            t || (o = s.color), t = s.colorIndex;
          this.colorIndex = h(this.options.colorIndex, t), this.color = h(this.options.color, o);
        }, l.prototype.setNestedProperty = function(s, t, n) {
          return n.split(".").reduce(function(o, A, _, D) {
            return o[A] = D.length - 1 === _ ? t : b(o[A], !0) ? o[A] : {}, o[A];
          }, s), s;
        }, l.prototype.tooltipFormatter = function(s) {
          var t = this.series, n = t.tooltipOptions, o = h(n.valueDecimals, ""), A = n.valuePrefix || "", _ = n.valueSuffix || "";
          return t.chart.styledMode && (s = t.chart.tooltip.styledModeFormat(s)), (t.pointArrayMap || ["y"]).forEach(function(D) {
            D = "{point." + D, (A || _) && (s = s.replace(RegExp(D + "}", "g"), A + D + "}" + _)), s = s.replace(RegExp(D + "}", "g"), D + ":,." + o + "f}");
          }), W(s, { point: this, series: this.series }, t.chart);
        }, l.prototype.update = function(s, t, n, o) {
          function A() {
            _.applyOptions(s);
            var m = j && _.hasDummyGraphic;
            m = _.y === null ? !m : m, j && m && (_.graphic = j.destroy(), delete _.hasDummyGraphic), b(s, !0) && (j && j.element && s && s.marker && typeof s.marker.symbol < "u" && (_.graphic = j.destroy()), s && s.dataLabels && _.dataLabel && (_.dataLabel = _.dataLabel.destroy()), _.connector && (_.connector = _.connector.destroy())), f = _.index, D.updateParallelArrays(_, f), X.data[f] = b(X.data[f], !0) || b(s, !0) ? _.options : h(s, X.data[f]), D.isDirty = D.isDirtyData = !0, !D.fixedBox && D.hasCartesianSeries && (T.isDirtyBox = !0), X.legendType === "point" && (T.isDirtyLegend = !0), t && T.redraw(n);
          }
          var _ = this, D = _.series, j = _.graphic, T = D.chart, X = D.options, f;
          t = h(t, !0), o === !1 ? A() : _.firePointEvent("update", { options: s }, A);
        }, l.prototype.remove = function(s, t) {
          this.series.removePoint(this.series.data.indexOf(this), s, t);
        }, l.prototype.select = function(s, t) {
          var n = this, o = n.series, A = o.chart;
          this.selectedStaging = s = h(s, !n.selected), n.firePointEvent(s ? "select" : "unselect", { accumulate: t }, function() {
            n.selected = n.options.selected = s, o.options.data[o.data.indexOf(n)] = n.options, n.setState(s && "select"), t || A.getSelectedPoints().forEach(function(_) {
              var D = _.series;
              _.selected && _ !== n && (_.selected = _.options.selected = !1, D.options.data[D.data.indexOf(_)] = _.options, _.setState(A.hoverPoints && D.options.inactiveOtherPoints ? "inactive" : ""), _.firePointEvent("unselect"));
            });
          }), delete this.selectedStaging;
        }, l.prototype.onMouseOver = function(s) {
          var t = this.series.chart, n = t.pointer;
          s = s ? n.normalize(s) : n.getChartCoordinatesFromPoint(this, t.inverted), n.runPointActions(
            s,
            this
          );
        }, l.prototype.onMouseOut = function() {
          var s = this.series.chart;
          this.firePointEvent("mouseOut"), this.series.options.inactiveOtherPoints || (s.hoverPoints || []).forEach(function(t) {
            t.setState();
          }), s.hoverPoints = s.hoverPoint = null;
        }, l.prototype.importEvents = function() {
          if (!this.hasImportedEvents) {
            var s = this, t = w(s.series.options.point, s.options).events;
            s.events = t, x(t, function(n, o) {
              B(n) && N(s, o, n);
            }), this.hasImportedEvents = !0;
          }
        }, l.prototype.setState = function(s, t) {
          var n = this.series, o = this.state, A = n.options.states[s || "normal"] || {}, _ = U.plotOptions[n.type].marker && n.options.marker, D = _ && _.enabled === !1, j = _ && _.states && _.states[s || "normal"] || {}, T = j.enabled === !1, X = this.marker || {}, f = n.chart, m = _ && n.markerAttribs, L = n.halo, Y, F = n.stateMarkerGraphic;
          if (s = s || "", !(s === this.state && !t || this.selected && s !== "select" || A.enabled === !1 || s && (T || D && j.enabled === !1) || s && X.states && X.states[s] && X.states[s].enabled === !1)) {
            if (this.state = s, m && (Y = n.markerAttribs(this, s)), this.graphic && !this.hasDummyGraphic) {
              if (o && this.graphic.removeClass("highcharts-point-" + o), s && this.graphic.addClass("highcharts-point-" + s), !f.styledMode) {
                var Q = n.pointAttribs(this, s), k = h(f.options.chart.animation, A.animation);
                n.options.inactiveOtherPoints && C(Q.opacity) && ((this.dataLabels || []).forEach(function(G) {
                  G && G.animate({ opacity: Q.opacity }, k);
                }), this.connector && this.connector.animate({ opacity: Q.opacity }, k)), this.graphic.animate(Q, k);
              }
              Y && this.graphic.animate(Y, h(f.options.chart.animation, j.animation, _.animation)), F && F.hide();
            } else
              s && j && (o = X.symbol || n.symbol, F && F.currentSymbol !== o && (F = F.destroy()), Y && (F ? F[t ? "animate" : "attr"]({ x: Y.x, y: Y.y }) : o && (n.stateMarkerGraphic = F = f.renderer.symbol(o, Y.x, Y.y, Y.width, Y.height).add(n.markerGroup), F.currentSymbol = o)), !f.styledMode && F && this.state !== "inactive" && F.attr(n.pointAttribs(this, s))), F && (F[s && this.isInside ? "show" : "hide"](), F.element.point = this, F.addClass(this.getClassName(), !0));
            A = A.halo, Y = (F = this.graphic || F) && F.visibility || "inherit", A && A.size && F && Y !== "hidden" && !this.isCluster ? (L || (n.halo = L = f.renderer.path().add(F.parentGroup)), L.show()[t ? "animate" : "attr"]({ d: this.haloPath(A.size) }), L.attr({ class: "highcharts-halo highcharts-color-" + h(this.colorIndex, n.colorIndex) + (this.className ? " " + this.className : ""), visibility: Y, zIndex: -1 }), L.point = this, f.styledMode || L.attr(u({ fill: this.color || n.color, "fill-opacity": A.opacity }, y.filterUserAttributes(A.attributes || {})))) : L && L.point && L.point.haloPath && L.animate({ d: L.point.haloPath(0) }, null, L.hide), d(this, "afterSetState", { state: s });
          }
        }, l.prototype.haloPath = function(s) {
          return this.series.chart.renderer.symbols.circle(Math.floor(this.plotX) - s, this.plotY - s, 2 * s, 2 * s);
        }, l;
      }(), R;
    }), E(a, "Core/Pointer.js", [a["Core/Color/Color.js"], a["Core/Globals.js"], a["Core/Tooltip.js"], a["Core/Utilities.js"]], function(y, R, I, Z) {
      var H = y.parse, $ = R.charts, U = R.noop, W = Z.addEvent, N = Z.attr, M = Z.css, v = Z.defined, u = Z.extend, d = Z.find, P = Z.fireEvent, O = Z.isNumber, B = Z.isObject, C = Z.objectEach, b = Z.offset, w = Z.pick, x = Z.splat;
      return y = function() {
        function h(c, p) {
          this.lastValidTouch = {}, this.pinchDown = [], this.runChartClick = !1, this.eventsToUnbind = [], this.chart = c, this.hasDragged = !1, this.options = p, this.init(c, p);
        }
        return h.prototype.applyInactiveState = function(c) {
          var p = [], i;
          (c || []).forEach(function(l) {
            i = l.series, p.push(i), i.linkedParent && p.push(i.linkedParent), i.linkedSeries && (p = p.concat(i.linkedSeries)), i.navigatorSeries && p.push(i.navigatorSeries);
          }), this.chart.series.forEach(function(l) {
            p.indexOf(l) === -1 ? l.setState("inactive", !0) : l.options.inactiveOtherPoints && l.setAllPointsToState("inactive");
          });
        }, h.prototype.destroy = function() {
          var c = this;
          this.eventsToUnbind.forEach(function(p) {
            return p();
          }), this.eventsToUnbind = [], R.chartCount || (h.unbindDocumentMouseUp && (h.unbindDocumentMouseUp = h.unbindDocumentMouseUp()), h.unbindDocumentTouchEnd && (h.unbindDocumentTouchEnd = h.unbindDocumentTouchEnd())), clearInterval(c.tooltipTimeout), C(c, function(p, i) {
            c[i] = void 0;
          });
        }, h.prototype.drag = function(c) {
          var p = this.chart, i = p.options.chart, l = this.zoomHor, s = this.zoomVert, t = p.plotLeft, n = p.plotTop, o = p.plotWidth, A = p.plotHeight, _ = this.mouseDownX || 0, D = this.mouseDownY || 0, j = B(i.panning) ? i.panning && i.panning.enabled : i.panning, T = i.panKey && c[i.panKey + "Key"], X = c.chartX, f = c.chartY, m = this.selectionMarker;
          if ((!m || !m.touch) && (X < t ? X = t : X > t + o && (X = t + o), f < n ? f = n : f > n + A && (f = n + A), this.hasDragged = Math.sqrt(Math.pow(_ - X, 2) + Math.pow(D - f, 2)), 10 < this.hasDragged)) {
            var L = p.isInsidePlot(_ - t, D - n, { visiblePlotOnly: !0 });
            !p.hasCartesianSeries && !p.mapView || !this.zoomX && !this.zoomY || !L || T || m || (this.selectionMarker = m = p.renderer.rect(t, n, l ? 1 : o, s ? 1 : A, 0).attr({ class: "highcharts-selection-marker", zIndex: 7 }).add(), p.styledMode || m.attr({ fill: i.selectionMarkerFill || H("#335cad").setOpacity(0.25).get() })), m && l && (l = X - _, m.attr({ width: Math.abs(l), x: (0 < l ? 0 : l) + _ })), m && s && (l = f - D, m.attr({ height: Math.abs(l), y: (0 < l ? 0 : l) + D })), L && !m && j && p.pan(c, i.panning);
          }
        }, h.prototype.dragStart = function(c) {
          var p = this.chart;
          p.mouseIsDown = c.type, p.cancelClick = !1, p.mouseDownX = this.mouseDownX = c.chartX, p.mouseDownY = this.mouseDownY = c.chartY;
        }, h.prototype.drop = function(c) {
          var p = this, i = this.chart, l = this.hasPinched;
          if (this.selectionMarker) {
            var s = this.selectionMarker, t = s.attr ? s.attr("x") : s.x, n = s.attr ? s.attr("y") : s.y, o = s.attr ? s.attr("width") : s.width, A = s.attr ? s.attr("height") : s.height, _ = { originalEvent: c, xAxis: [], yAxis: [], x: t, y: n, width: o, height: A }, D = !!i.mapView;
            (this.hasDragged || l) && (i.axes.forEach(function(j) {
              if (j.zoomEnabled && v(j.min) && (l || p[{ xAxis: "zoomX", yAxis: "zoomY" }[j.coll]]) && O(t) && O(n)) {
                var T = j.horiz, X = c.type === "touchend" ? j.minPixelPadding : 0, f = j.toValue((T ? t : n) + X);
                T = j.toValue((T ? t + o : n + A) - X), _[j.coll].push({ axis: j, min: Math.min(f, T), max: Math.max(f, T) }), D = !0;
              }
            }), D && P(i, "selection", _, function(j) {
              i.zoom(u(
                j,
                l ? { animation: !1 } : null
              ));
            })), O(i.index) && (this.selectionMarker = this.selectionMarker.destroy()), l && this.scaleGroups();
          }
          i && O(i.index) && (M(i.container, { cursor: i._cursor }), i.cancelClick = 10 < this.hasDragged, i.mouseIsDown = this.hasDragged = this.hasPinched = !1, this.pinchDown = []);
        }, h.prototype.findNearestKDPoint = function(c, p, i) {
          var l = this.chart, s = l.hoverPoint;
          if (l = l.tooltip, s && l && l.isStickyOnContact())
            return s;
          var t;
          return c.forEach(function(n) {
            var o = !(n.noSharedTooltip && p) && 0 > n.options.findNearestPointBy.indexOf("y");
            if (n = n.searchPoint(i, o), (o = B(n, !0) && n.series) && !(o = !B(t, !0))) {
              o = t.distX - n.distX;
              var A = t.dist - n.dist, _ = (n.series.group && n.series.group.zIndex) - (t.series.group && t.series.group.zIndex);
              o = 0 < (o !== 0 && p ? o : A !== 0 ? A : _ !== 0 ? _ : t.series.index > n.series.index ? -1 : 1);
            }
            o && (t = n);
          }), t;
        }, h.prototype.getChartCoordinatesFromPoint = function(c, p) {
          var i = c.series, l = i.xAxis;
          i = i.yAxis;
          var s = c.shapeArgs;
          if (l && i) {
            var t = w(c.clientX, c.plotX), n = c.plotY || 0;
            return c.isNode && s && O(s.x) && O(s.y) && (t = s.x, n = s.y), p ? { chartX: i.len + i.pos - n, chartY: l.len + l.pos - t } : { chartX: t + l.pos, chartY: n + i.pos };
          }
          if (s && s.x && s.y)
            return { chartX: s.x, chartY: s.y };
        }, h.prototype.getChartPosition = function() {
          if (this.chartPosition)
            return this.chartPosition;
          var c = this.chart.container, p = b(c);
          this.chartPosition = { left: p.left, top: p.top, scaleX: 1, scaleY: 1 };
          var i = c.offsetWidth;
          return c = c.offsetHeight, 2 < i && 2 < c && (this.chartPosition.scaleX = p.width / i, this.chartPosition.scaleY = p.height / c), this.chartPosition;
        }, h.prototype.getCoordinates = function(c) {
          var p = { xAxis: [], yAxis: [] };
          return this.chart.axes.forEach(function(i) {
            p[i.isXAxis ? "xAxis" : "yAxis"].push({ axis: i, value: i.toValue(c[i.horiz ? "chartX" : "chartY"]) });
          }), p;
        }, h.prototype.getHoverData = function(c, p, i, l, s, t) {
          var n = [];
          l = !(!l || !c);
          var o = { chartX: t ? t.chartX : void 0, chartY: t ? t.chartY : void 0, shared: s };
          P(this, "beforeGetHoverData", o);
          var A = p && !p.stickyTracking ? [p] : i.filter(function(D) {
            return o.filter ? o.filter(D) : D.visible && !(!s && D.directTouch) && w(D.options.enableMouseTracking, !0) && D.stickyTracking;
          }), _ = l || !t ? c : this.findNearestKDPoint(A, s, t);
          return p = _ && _.series, _ && (s && !p.noSharedTooltip ? (A = i.filter(function(D) {
            return o.filter ? o.filter(D) : D.visible && !(!s && D.directTouch) && w(D.options.enableMouseTracking, !0) && !D.noSharedTooltip;
          }), A.forEach(function(D) {
            var j = d(D.points, function(T) {
              return T.x === _.x && !T.isNull;
            });
            B(j) && (D.chart.isBoosting && (j = D.getPoint(j)), n.push(j));
          })) : n.push(_)), o = { hoverPoint: _ }, P(this, "afterGetHoverData", o), { hoverPoint: o.hoverPoint, hoverSeries: p, hoverPoints: n };
        }, h.prototype.getPointFromEvent = function(c) {
          c = c.target;
          for (var p; c && !p; )
            p = c.point, c = c.parentNode;
          return p;
        }, h.prototype.onTrackerMouseOut = function(c) {
          c = c.relatedTarget || c.toElement;
          var p = this.chart.hoverSeries;
          this.isDirectTouch = !1, !p || !c || p.stickyTracking || this.inClass(c, "highcharts-tooltip") || this.inClass(c, "highcharts-series-" + p.index) && this.inClass(c, "highcharts-tracker") || p.onMouseOut();
        }, h.prototype.inClass = function(c, p) {
          for (var i; c; ) {
            if (i = N(c, "class")) {
              if (i.indexOf(p) !== -1)
                return !0;
              if (i.indexOf("highcharts-container") !== -1)
                return !1;
            }
            c = c.parentNode;
          }
        }, h.prototype.init = function(c, p) {
          this.options = p, this.chart = c, this.runChartClick = !(!p.chart.events || !p.chart.events.click), this.pinchDown = [], this.lastValidTouch = {}, I && (c.tooltip = new I(c, p.tooltip), this.followTouchMove = w(p.tooltip.followTouchMove, !0)), this.setDOMEvents();
        }, h.prototype.normalize = function(c, p) {
          var i = c.touches, l = i ? i.length ? i.item(0) : w(i.changedTouches, c.changedTouches)[0] : c;
          return p || (p = this.getChartPosition()), i = l.pageX - p.left, l = l.pageY - p.top, i /= p.scaleX, l /= p.scaleY, u(c, { chartX: Math.round(i), chartY: Math.round(l) });
        }, h.prototype.onContainerClick = function(c) {
          var p = this.chart, i = p.hoverPoint;
          c = this.normalize(c);
          var l = p.plotLeft, s = p.plotTop;
          p.cancelClick || (i && this.inClass(c.target, "highcharts-tracker") ? (P(i.series, "click", u(c, { point: i })), p.hoverPoint && i.firePointEvent("click", c)) : (u(c, this.getCoordinates(c)), p.isInsidePlot(c.chartX - l, c.chartY - s, { visiblePlotOnly: !0 }) && P(p, "click", c)));
        }, h.prototype.onContainerMouseDown = function(c) {
          var p = ((c.buttons || c.button) & 1) === 1;
          c = this.normalize(c), R.isFirefox && c.button !== 0 && this.onContainerMouseMove(c), (typeof c.button > "u" || p) && (this.zoomOption(c), p && c.preventDefault && c.preventDefault(), this.dragStart(c));
        }, h.prototype.onContainerMouseLeave = function(c) {
          var p = $[w(h.hoverChartIndex, -1)], i = this.chart.tooltip;
          i && i.shouldStickOnContact() && this.inClass(c.relatedTarget, "highcharts-tooltip-container") || (c = this.normalize(c), p && (c.relatedTarget || c.toElement) && (p.pointer.reset(), p.pointer.chartPosition = void 0), i && !i.isHidden && this.reset());
        }, h.prototype.onContainerMouseEnter = function(c) {
          delete this.chartPosition;
        }, h.prototype.onContainerMouseMove = function(c) {
          var p = this.chart;
          c = this.normalize(c), this.setHoverChartIndex(), c.preventDefault || (c.returnValue = !1), (p.mouseIsDown === "mousedown" || this.touchSelect(c)) && this.drag(c), p.openMenu || !this.inClass(c.target, "highcharts-tracker") && !p.isInsidePlot(c.chartX - p.plotLeft, c.chartY - p.plotTop, { visiblePlotOnly: !0 }) || (this.inClass(c.target, "highcharts-no-tooltip") ? this.reset(!1, 0) : this.runPointActions(c));
        }, h.prototype.onDocumentTouchEnd = function(c) {
          var p = $[w(
            h.hoverChartIndex,
            -1
          )];
          p && p.pointer.drop(c);
        }, h.prototype.onContainerTouchMove = function(c) {
          this.touchSelect(c) ? this.onContainerMouseMove(c) : this.touch(c);
        }, h.prototype.onContainerTouchStart = function(c) {
          this.touchSelect(c) ? this.onContainerMouseDown(c) : (this.zoomOption(c), this.touch(c, !0));
        }, h.prototype.onDocumentMouseMove = function(c) {
          var p = this.chart, i = this.chartPosition;
          c = this.normalize(c, i);
          var l = p.tooltip;
          !i || l && l.isStickyOnContact() || p.isInsidePlot(c.chartX - p.plotLeft, c.chartY - p.plotTop, { visiblePlotOnly: !0 }) || this.inClass(c.target, "highcharts-tracker") || this.reset();
        }, h.prototype.onDocumentMouseUp = function(c) {
          var p = $[w(h.hoverChartIndex, -1)];
          p && p.pointer.drop(c);
        }, h.prototype.pinch = function(c) {
          var p = this, i = p.chart, l = p.pinchDown, s = c.touches || [], t = s.length, n = p.lastValidTouch, o = p.hasZoom, A = {}, _ = t === 1 && (p.inClass(c.target, "highcharts-tracker") && i.runTrackerClick || p.runChartClick), D = {}, j = p.selectionMarker;
          1 < t ? p.initiated = !0 : t === 1 && this.followTouchMove && (p.initiated = !1), o && p.initiated && !_ && c.cancelable !== !1 && c.preventDefault(), [].map.call(s, function(T) {
            return p.normalize(T);
          }), c.type === "touchstart" ? ([].forEach.call(s, function(T, X) {
            l[X] = { chartX: T.chartX, chartY: T.chartY };
          }), n.x = [l[0].chartX, l[1] && l[1].chartX], n.y = [l[0].chartY, l[1] && l[1].chartY], i.axes.forEach(function(T) {
            if (T.zoomEnabled) {
              var X = i.bounds[T.horiz ? "h" : "v"], f = T.minPixelPadding, m = T.toPixels(Math.min(w(T.options.min, T.dataMin), T.dataMin)), L = T.toPixels(Math.max(w(T.options.max, T.dataMax), T.dataMax)), Y = Math.max(m, L);
              X.min = Math.min(T.pos, Math.min(
                m,
                L
              ) - f), X.max = Math.max(T.pos + T.len, Y + f);
            }
          }), p.res = !0) : p.followTouchMove && t === 1 ? this.runPointActions(p.normalize(c)) : l.length && (P(i, "touchpan", { originalEvent: c }, function() {
            j || (p.selectionMarker = j = u({ destroy: U, touch: !0 }, i.plotBox)), p.pinchTranslate(l, s, A, j, D, n), p.hasPinched = o, p.scaleGroups(A, D);
          }), p.res && (p.res = !1, this.reset(!1, 0)));
        }, h.prototype.pinchTranslate = function(c, p, i, l, s, t) {
          this.zoomHor && this.pinchTranslateDirection(!0, c, p, i, l, s, t), this.zoomVert && this.pinchTranslateDirection(!1, c, p, i, l, s, t);
        }, h.prototype.pinchTranslateDirection = function(c, p, i, l, s, t, n, o) {
          var A = this.chart, _ = c ? "x" : "y", D = c ? "X" : "Y", j = "chart" + D, T = c ? "width" : "height", X = A["plot" + (c ? "Left" : "Top")], f = A.inverted, m = A.bounds[c ? "h" : "v"], L = p.length === 1, Y = p[0][j], F = !L && p[1][j];
          p = function() {
            typeof V == "number" && 20 < Math.abs(Y - F) && (G = o || Math.abs(z - V) / Math.abs(Y - F)), k = (X - z) / G + Y, Q = A["plot" + (c ? "Width" : "Height")] / G;
          };
          var Q, k, G = o || 1, z = i[0][j], V = !L && i[1][j];
          if (p(), i = k, i < m.min) {
            i = m.min;
            var q = !0;
          } else
            i + Q > m.max && (i = m.max - Q, q = !0);
          q ? (z -= 0.8 * (z - n[_][0]), typeof V == "number" && (V -= 0.8 * (V - n[_][1])), p()) : n[_] = [z, V], f || (t[_] = k - X, t[T] = Q), t = f ? 1 / G : G, s[T] = Q, s[_] = i, l[f ? c ? "scaleY" : "scaleX" : "scale" + D] = G, l["translate" + D] = t * X + (z - t * Y);
        }, h.prototype.reset = function(c, p) {
          var i = this.chart, l = i.hoverSeries, s = i.hoverPoint, t = i.hoverPoints, n = i.tooltip, o = n && n.shared ? t : s;
          c && o && x(o).forEach(function(A) {
            A.series.isCartesian && typeof A.plotX > "u" && (c = !1);
          }), c ? n && o && x(o).length && (n.refresh(o), n.shared && t ? t.forEach(function(A) {
            A.setState(A.state, !0), A.series.isCartesian && (A.series.xAxis.crosshair && A.series.xAxis.drawCrosshair(
              null,
              A
            ), A.series.yAxis.crosshair && A.series.yAxis.drawCrosshair(null, A));
          }) : s && (s.setState(s.state, !0), i.axes.forEach(function(A) {
            A.crosshair && s.series[A.coll] === A && A.drawCrosshair(null, s);
          }))) : (s && s.onMouseOut(), t && t.forEach(function(A) {
            A.setState();
          }), l && l.onMouseOut(), n && n.hide(p), this.unDocMouseMove && (this.unDocMouseMove = this.unDocMouseMove()), i.axes.forEach(function(A) {
            A.hideCrosshair();
          }), this.hoverX = i.hoverPoints = i.hoverPoint = null);
        }, h.prototype.runPointActions = function(c, p) {
          var i = this.chart, l = i.tooltip && i.tooltip.options.enabled ? i.tooltip : void 0, s = l ? l.shared : !1, t = p || i.hoverPoint, n = t && t.series || i.hoverSeries;
          p = this.getHoverData(t, n, i.series, (!c || c.type !== "touchmove") && (!!p || n && n.directTouch && this.isDirectTouch), s, c), t = p.hoverPoint, n = p.hoverSeries;
          var o = p.hoverPoints;
          if (p = n && n.tooltipOptions.followPointer && !n.tooltipOptions.split, s = s && n && !n.noSharedTooltip, t && (t !== i.hoverPoint || l && l.isHidden)) {
            if ((i.hoverPoints || []).forEach(function(A) {
              o.indexOf(A) === -1 && A.setState();
            }), i.hoverSeries !== n && n.onMouseOver(), this.applyInactiveState(o), (o || []).forEach(function(A) {
              A.setState("hover");
            }), i.hoverPoint && i.hoverPoint.firePointEvent("mouseOut"), !t.series)
              return;
            i.hoverPoints = o, i.hoverPoint = t, t.firePointEvent("mouseOver"), l && l.refresh(s ? o : t, c);
          } else
            p && l && !l.isHidden && (t = l.getAnchor([{}], c), i.isInsidePlot(t[0], t[1], { visiblePlotOnly: !0 }) && l.updatePosition({ plotX: t[0], plotY: t[1] }));
          this.unDocMouseMove || (this.unDocMouseMove = W(i.container.ownerDocument, "mousemove", function(A) {
            var _ = $[h.hoverChartIndex];
            _ && _.pointer.onDocumentMouseMove(A);
          }), this.eventsToUnbind.push(this.unDocMouseMove)), i.axes.forEach(function(A) {
            var _ = w((A.crosshair || {}).snap, !0), D;
            _ && ((D = i.hoverPoint) && D.series[A.coll] === A || (D = d(o, function(j) {
              return j.series[A.coll] === A;
            }))), D || !_ ? A.drawCrosshair(c, D) : A.hideCrosshair();
          });
        }, h.prototype.scaleGroups = function(c, p) {
          var i = this.chart;
          i.series.forEach(function(l) {
            var s = c || l.getPlotBox();
            l.group && (l.xAxis && l.xAxis.zoomEnabled || i.mapView) && (l.group.attr(s), l.markerGroup && (l.markerGroup.attr(s), l.markerGroup.clip(p ? i.clipRect : null)), l.dataLabelsGroup && l.dataLabelsGroup.attr(s));
          }), i.clipRect.attr(p || i.clipBox);
        }, h.prototype.setDOMEvents = function() {
          var c = this, p = this.chart.container, i = p.ownerDocument;
          p.onmousedown = this.onContainerMouseDown.bind(this), p.onmousemove = this.onContainerMouseMove.bind(this), p.onclick = this.onContainerClick.bind(this), this.eventsToUnbind.push(W(p, "mouseenter", this.onContainerMouseEnter.bind(this))), this.eventsToUnbind.push(W(p, "mouseleave", this.onContainerMouseLeave.bind(this))), h.unbindDocumentMouseUp || (h.unbindDocumentMouseUp = W(i, "mouseup", this.onDocumentMouseUp.bind(this)));
          for (var l = this.chart.renderTo.parentElement; l && l.tagName !== "BODY"; )
            this.eventsToUnbind.push(W(l, "scroll", function() {
              delete c.chartPosition;
            })), l = l.parentElement;
          R.hasTouch && (this.eventsToUnbind.push(W(p, "touchstart", this.onContainerTouchStart.bind(this), { passive: !1 })), this.eventsToUnbind.push(W(p, "touchmove", this.onContainerTouchMove.bind(this), { passive: !1 })), h.unbindDocumentTouchEnd || (h.unbindDocumentTouchEnd = W(i, "touchend", this.onDocumentTouchEnd.bind(this), { passive: !1 })));
        }, h.prototype.setHoverChartIndex = function() {
          var c = this.chart, p = R.charts[w(h.hoverChartIndex, -1)];
          p && p !== c && p.pointer.onContainerMouseLeave({ relatedTarget: !0 }), p && p.mouseIsDown || (h.hoverChartIndex = c.index);
        }, h.prototype.touch = function(c, p) {
          var i = this.chart;
          if (this.setHoverChartIndex(), c.touches.length === 1)
            if (c = this.normalize(c), i.isInsidePlot(c.chartX - i.plotLeft, c.chartY - i.plotTop, { visiblePlotOnly: !0 }) && !i.openMenu) {
              if (p && this.runPointActions(c), c.type === "touchmove") {
                p = this.pinchDown;
                var l = p[0] ? 4 <= Math.sqrt(Math.pow(p[0].chartX - c.chartX, 2) + Math.pow(p[0].chartY - c.chartY, 2)) : !1;
              }
              w(l, !0) && this.pinch(c);
            } else
              p && this.reset();
          else
            c.touches.length === 2 && this.pinch(c);
        }, h.prototype.touchSelect = function(c) {
          return !(!this.chart.options.chart.zoomBySingleTouch || !c.touches || c.touches.length !== 1);
        }, h.prototype.zoomOption = function(c) {
          var p = this.chart, i = p.options.chart;
          p = p.inverted;
          var l = i.zoomType || "";
          /touch/.test(c.type) && (l = w(i.pinchType, l)), this.zoomX = c = /x/.test(l), this.zoomY = i = /y/.test(l), this.zoomHor = c && !p || i && p, this.zoomVert = i && !p || c && p, this.hasZoom = c || i;
        }, h;
      }(), y;
    }), E(a, "Core/MSPointer.js", [a["Core/Globals.js"], a["Core/Pointer.js"], a["Core/Utilities.js"]], function(y, R, I) {
      function Z() {
        var C = [];
        return C.item = function(b) {
          return this[b];
        }, d(O, function(b) {
          C.push({ pageX: b.pageX, pageY: b.pageY, target: b.target });
        }), C;
      }
      function H(C, b, w, x) {
        var h = U[R.hoverChartIndex || NaN];
        C.pointerType !== "touch" && C.pointerType !== C.MSPOINTER_TYPE_TOUCH || !h || (h = h.pointer, x(C), h[b]({ type: w, target: C.currentTarget, preventDefault: N, touches: Z() }));
      }
      var $ = this && this.__extends || function() {
        var C = function(b, w) {
          return C = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(x, h) {
            x.__proto__ = h;
          } || function(x, h) {
            for (var c in h)
              h.hasOwnProperty(c) && (x[c] = h[c]);
          }, C(b, w);
        };
        return function(b, w) {
          function x() {
            this.constructor = b;
          }
          C(b, w), b.prototype = w === null ? Object.create(w) : (x.prototype = w.prototype, new x());
        };
      }(), U = y.charts, W = y.doc, N = y.noop, M = y.win, v = I.addEvent, u = I.css, d = I.objectEach, P = I.removeEvent, O = {}, B = !!M.PointerEvent;
      return function(C) {
        function b() {
          return C !== null && C.apply(this, arguments) || this;
        }
        return $(b, C), b.isRequired = function() {
          return !(y.hasTouch || !M.PointerEvent && !M.MSPointerEvent);
        }, b.prototype.batchMSEvents = function(w) {
          w(this.chart.container, B ? "pointerdown" : "MSPointerDown", this.onContainerPointerDown), w(this.chart.container, B ? "pointermove" : "MSPointerMove", this.onContainerPointerMove), w(W, B ? "pointerup" : "MSPointerUp", this.onDocumentPointerUp);
        }, b.prototype.destroy = function() {
          this.batchMSEvents(P), C.prototype.destroy.call(this);
        }, b.prototype.init = function(w, x) {
          C.prototype.init.call(this, w, x), this.hasZoom && u(w.container, { "-ms-touch-action": "none", "touch-action": "none" });
        }, b.prototype.onContainerPointerDown = function(w) {
          H(w, "onContainerTouchStart", "touchstart", function(x) {
            O[x.pointerId] = { pageX: x.pageX, pageY: x.pageY, target: x.currentTarget };
          });
        }, b.prototype.onContainerPointerMove = function(w) {
          H(w, "onContainerTouchMove", "touchmove", function(x) {
            O[x.pointerId] = {
              pageX: x.pageX,
              pageY: x.pageY
            }, O[x.pointerId].target || (O[x.pointerId].target = x.currentTarget);
          });
        }, b.prototype.onDocumentPointerUp = function(w) {
          H(w, "onDocumentTouchEnd", "touchend", function(x) {
            delete O[x.pointerId];
          });
        }, b.prototype.setDOMEvents = function() {
          C.prototype.setDOMEvents.call(this), (this.hasZoom || this.followTouchMove) && this.batchMSEvents(v);
        }, b;
      }(R);
    }), E(a, "Core/Legend/Legend.js", [
      a["Core/Animation/AnimationUtilities.js"],
      a["Core/FormatUtilities.js"],
      a["Core/Globals.js"],
      a["Core/Series/Point.js"],
      a["Core/Renderer/RendererUtilities.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I, Z, H, $) {
      var U = y.animObject, W = y.setAnimation, N = R.format;
      y = I.isFirefox;
      var M = I.marginNames;
      I = I.win;
      var v = H.distribute, u = $.addEvent, d = $.createElement, P = $.css, O = $.defined, B = $.discardElement, C = $.find, b = $.fireEvent, w = $.isNumber, x = $.merge, h = $.pick, c = $.relativeLength, p = $.stableSort, i = $.syncTimeout;
      return H = $.wrap, $ = function() {
        function l(s, t) {
          this.allItems = [], this.contentGroup = this.box = void 0, this.display = !1, this.group = void 0, this.offsetWidth = this.maxLegendWidth = this.maxItemWidth = this.legendWidth = this.legendHeight = this.lastLineHeight = this.lastItemY = this.itemY = this.itemX = this.itemMarginTop = this.itemMarginBottom = this.itemHeight = this.initialItemY = 0, this.options = {}, this.padding = 0, this.pages = [], this.proximate = !1, this.scrollGroup = void 0, this.widthOption = this.totalItemWidth = this.titleHeight = this.symbolWidth = this.symbolHeight = 0, this.chart = s, this.init(s, t);
        }
        return l.prototype.init = function(s, t) {
          this.chart = s, this.setOptions(t), t.enabled && (this.render(), u(this.chart, "endResize", function() {
            this.legend.positionCheckboxes();
          }), this.proximate ? this.unchartrender = u(this.chart, "render", function() {
            this.legend.proximatePositions(), this.legend.positionItems();
          }) : this.unchartrender && this.unchartrender());
        }, l.prototype.setOptions = function(s) {
          var t = h(s.padding, 8);
          this.options = s, this.chart.styledMode || (this.itemStyle = s.itemStyle, this.itemHiddenStyle = x(this.itemStyle, s.itemHiddenStyle)), this.itemMarginTop = s.itemMarginTop || 0, this.itemMarginBottom = s.itemMarginBottom || 0, this.padding = t, this.initialItemY = t - 5, this.symbolWidth = h(
            s.symbolWidth,
            16
          ), this.pages = [], this.proximate = s.layout === "proximate" && !this.chart.inverted, this.baseline = void 0;
        }, l.prototype.update = function(s, t) {
          var n = this.chart;
          this.setOptions(x(!0, this.options, s)), this.destroy(), n.isDirtyLegend = n.isDirtyBox = !0, h(t, !0) && n.redraw(), b(this, "afterUpdate");
        }, l.prototype.colorizeItem = function(s, t) {
          if (s.legendGroup[t ? "removeClass" : "addClass"]("highcharts-legend-item-hidden"), !this.chart.styledMode) {
            var n = this.options, o = s.legendItem, A = s.legendLine, _ = s.legendSymbol, D = this.itemHiddenStyle.color;
            n = t ? n.itemStyle.color : D;
            var j = t && s.color || D, T = s.options && s.options.marker, X = { fill: j };
            o && o.css({ fill: n, color: n }), A && A.attr({ stroke: j }), _ && (T && _.isMarker && (X = s.pointAttribs(), t || (X.stroke = X.fill = D)), _.attr(X));
          }
          b(this, "afterColorizeItem", { item: s, visible: t });
        }, l.prototype.positionItems = function() {
          this.allItems.forEach(this.positionItem, this), this.chart.isResizing || this.positionCheckboxes();
        }, l.prototype.positionItem = function(s) {
          var t = this, n = this.options, o = n.symbolPadding, A = !n.rtl, _ = s._legendItemPos;
          n = _[0], _ = _[1];
          var D = s.checkbox, j = s.legendGroup;
          j && j.element && (o = { translateX: A ? n : this.legendWidth - n - 2 * o - 4, translateY: _ }, A = function() {
            b(t, "afterPositionItem", { item: s });
          }, O(j.translateY) ? j.animate(o, void 0, A) : (j.attr(o), A())), D && (D.x = n, D.y = _);
        }, l.prototype.destroyItem = function(s) {
          var t = s.checkbox;
          ["legendItem", "legendLine", "legendSymbol", "legendGroup"].forEach(function(n) {
            s[n] && (s[n] = s[n].destroy());
          }), t && B(s.checkbox);
        }, l.prototype.destroy = function() {
          function s(t) {
            this[t] && (this[t] = this[t].destroy());
          }
          this.getAllItems().forEach(function(t) {
            [
              "legendItem",
              "legendGroup"
            ].forEach(s, t);
          }), "clipRect up down pager nav box title group".split(" ").forEach(s, this), this.display = null;
        }, l.prototype.positionCheckboxes = function() {
          var s = this.group && this.group.alignAttr, t = this.clipHeight || this.legendHeight, n = this.titleHeight;
          if (s) {
            var o = s.translateY;
            this.allItems.forEach(function(A) {
              var _ = A.checkbox;
              if (_) {
                var D = o + n + _.y + (this.scrollOffset || 0) + 3;
                P(_, { left: s.translateX + A.checkboxOffset + _.x - 20 + "px", top: D + "px", display: this.proximate || D > o - 6 && D < o + t - 6 ? "" : "none" });
              }
            }, this);
          }
        }, l.prototype.renderTitle = function() {
          var s = this.options, t = this.padding, n = s.title, o = 0;
          n.text && (this.title || (this.title = this.chart.renderer.label(n.text, t - 3, t - 4, null, null, null, s.useHTML, null, "legend-title").attr({ zIndex: 1 }), this.chart.styledMode || this.title.css(n.style), this.title.add(this.group)), n.width || this.title.css({ width: this.maxLegendWidth + "px" }), s = this.title.getBBox(), o = s.height, this.offsetWidth = s.width, this.contentGroup.attr({ translateY: o })), this.titleHeight = o;
        }, l.prototype.setText = function(s) {
          var t = this.options;
          s.legendItem.attr({ text: t.labelFormat ? N(t.labelFormat, s, this.chart) : t.labelFormatter.call(s) });
        }, l.prototype.renderItem = function(s) {
          var t = this.chart, n = t.renderer, o = this.options, A = this.symbolWidth, _ = o.symbolPadding || 0, D = this.itemStyle, j = this.itemHiddenStyle, T = o.layout === "horizontal" ? h(o.itemDistance, 20) : 0, X = !o.rtl, f = !s.series, m = !f && s.series.drawLegendSymbol ? s.series : s, L = m.options, Y = this.createCheckboxForItem && L && L.showCheckbox, F = o.useHTML, Q = s.options.className, k = s.legendItem;
          L = A + _ + T + (Y ? 20 : 0), k || (s.legendGroup = n.g("legend-item").addClass("highcharts-" + m.type + "-series highcharts-color-" + s.colorIndex + (Q ? " " + Q : "") + (f ? " highcharts-series-" + s.index : "")).attr({ zIndex: 1 }).add(this.scrollGroup), s.legendItem = k = n.text("", X ? A + _ : -_, this.baseline || 0, F), t.styledMode || k.css(x(s.visible ? D : j)), k.attr({ align: X ? "left" : "right", zIndex: 2 }).add(s.legendGroup), this.baseline || (this.fontMetrics = n.fontMetrics(t.styledMode ? 12 : D.fontSize, k), this.baseline = this.fontMetrics.f + 3 + this.itemMarginTop, k.attr("y", this.baseline), this.symbolHeight = o.symbolHeight || this.fontMetrics.f, o.squareSymbol && (this.symbolWidth = h(o.symbolWidth, Math.max(this.symbolHeight, 16)), L = this.symbolWidth + _ + T + (Y ? 20 : 0), X && k.attr("x", this.symbolWidth + _))), m.drawLegendSymbol(this, s), this.setItemEvents && this.setItemEvents(s, k, F)), Y && !s.checkbox && this.createCheckboxForItem && this.createCheckboxForItem(s), this.colorizeItem(s, s.visible), !t.styledMode && D.width || k.css({ width: (o.itemWidth || this.widthOption || t.spacingBox.width) - L + "px" }), this.setText(s), t = k.getBBox(), n = this.fontMetrics && this.fontMetrics.h || 0, s.itemWidth = s.checkboxOffset = o.itemWidth || s.legendItemWidth || t.width + L, this.maxItemWidth = Math.max(this.maxItemWidth, s.itemWidth), this.totalItemWidth += s.itemWidth, this.itemHeight = s.itemHeight = Math.round(s.legendItemHeight || (t.height > 1.5 * n ? t.height : n));
        }, l.prototype.layoutItem = function(s) {
          var t = this.options, n = this.padding, o = t.layout === "horizontal", A = s.itemHeight, _ = this.itemMarginBottom, D = this.itemMarginTop, j = o ? h(t.itemDistance, 20) : 0, T = this.maxLegendWidth;
          t = t.alignColumns && this.totalItemWidth > T ? this.maxItemWidth : s.itemWidth, o && this.itemX - n + t > T && (this.itemX = n, this.lastLineHeight && (this.itemY += D + this.lastLineHeight + _), this.lastLineHeight = 0), this.lastItemY = D + this.itemY + _, this.lastLineHeight = Math.max(A, this.lastLineHeight), s._legendItemPos = [this.itemX, this.itemY], o ? this.itemX += t : (this.itemY += D + A + _, this.lastLineHeight = A), this.offsetWidth = this.widthOption || Math.max((o ? this.itemX - n - (s.checkbox ? 0 : j) : t) + n, this.offsetWidth);
        }, l.prototype.getAllItems = function() {
          var s = [];
          return this.chart.series.forEach(function(t) {
            var n = t && t.options;
            t && h(n.showInLegend, O(n.linkedTo) ? !1 : void 0, !0) && (s = s.concat(t.legendItems || (n.legendType === "point" ? t.data : t)));
          }), b(this, "afterGetAllItems", { allItems: s }), s;
        }, l.prototype.getAlignment = function() {
          var s = this.options;
          return this.proximate ? s.align.charAt(0) + "tv" : s.floating ? "" : s.align.charAt(0) + s.verticalAlign.charAt(0) + s.layout.charAt(0);
        }, l.prototype.adjustMargins = function(s, t) {
          var n = this.chart, o = this.options, A = this.getAlignment();
          A && [/(lth|ct|rth)/, /(rtv|rm|rbv)/, /(rbh|cb|lbh)/, /(lbv|lm|ltv)/].forEach(function(_, D) {
            _.test(A) && !O(s[D]) && (n[M[D]] = Math.max(n[M[D]], n.legend[(D + 1) % 2 ? "legendHeight" : "legendWidth"] + [1, -1, -1, 1][D] * o[D % 2 ? "x" : "y"] + h(o.margin, 12) + t[D] + (n.titleOffset[D] || 0)));
          });
        }, l.prototype.proximatePositions = function() {
          var s = this.chart, t = [], n = this.options.align === "left";
          this.allItems.forEach(function(o) {
            var A, _ = n;
            if (o.yAxis) {
              o.xAxis.options.reversed && (_ = !_), o.points && (A = C(_ ? o.points : o.points.slice(0).reverse(), function(j) {
                return w(j.plotY);
              })), _ = this.itemMarginTop + o.legendItem.getBBox().height + this.itemMarginBottom;
              var D = o.yAxis.top - s.plotTop;
              o.visible ? (A = A ? A.plotY : o.yAxis.height, A += D - 0.3 * _) : A = D + o.yAxis.height, t.push({ target: A, size: _, item: o });
            }
          }, this), v(t, s.plotHeight).forEach(function(o) {
            o.item._legendItemPos && (o.item._legendItemPos[1] = s.plotTop - s.spacing[0] + o.pos);
          });
        }, l.prototype.render = function() {
          var s = this.chart, t = s.renderer, n = this.options, o = this.padding, A = this.getAllItems(), _ = this.group, D = this.box;
          this.itemX = o, this.itemY = this.initialItemY, this.lastItemY = this.offsetWidth = 0, this.widthOption = c(n.width, s.spacingBox.width - o);
          var j = s.spacingBox.width - 2 * o - n.x;
          -1 < ["rm", "lm"].indexOf(this.getAlignment().substring(0, 2)) && (j /= 2), this.maxLegendWidth = this.widthOption || j, _ || (this.group = _ = t.g("legend").addClass(n.className || "").attr({ zIndex: 7 }).add(), this.contentGroup = t.g().attr({ zIndex: 1 }).add(_), this.scrollGroup = t.g().add(this.contentGroup)), this.renderTitle(), p(A, function(X, f) {
            return (X.options && X.options.legendIndex || 0) - (f.options && f.options.legendIndex || 0);
          }), n.reversed && A.reverse(), this.allItems = A, this.display = j = !!A.length, this.itemHeight = this.totalItemWidth = this.maxItemWidth = this.lastLineHeight = 0, A.forEach(this.renderItem, this), A.forEach(this.layoutItem, this), A = (this.widthOption || this.offsetWidth) + o;
          var T = this.lastItemY + this.lastLineHeight + this.titleHeight;
          T = this.handleOverflow(T), T += o, D || (this.box = D = t.rect().addClass("highcharts-legend-box").attr({ r: n.borderRadius }).add(_), D.isNew = !0), s.styledMode || D.attr({ stroke: n.borderColor, "stroke-width": n.borderWidth || 0, fill: n.backgroundColor || "none" }).shadow(n.shadow), 0 < A && 0 < T && (D[D.isNew ? "attr" : "animate"](D.crisp.call({}, { x: 0, y: 0, width: A, height: T }, D.strokeWidth())), D.isNew = !1), D[j ? "show" : "hide"](), s.styledMode && _.getStyle("display") === "none" && (A = T = 0), this.legendWidth = A, this.legendHeight = T, j && this.align(), this.proximate || this.positionItems(), b(this, "afterRender");
        }, l.prototype.align = function(s) {
          s === void 0 && (s = this.chart.spacingBox);
          var t = this.chart, n = this.options, o = s.y;
          /(lth|ct|rth)/.test(this.getAlignment()) && 0 < t.titleOffset[0] ? o += t.titleOffset[0] : /(lbh|cb|rbh)/.test(this.getAlignment()) && 0 < t.titleOffset[2] && (o -= t.titleOffset[2]), o !== s.y && (s = x(s, { y: o })), this.group.align(x(n, { width: this.legendWidth, height: this.legendHeight, verticalAlign: this.proximate ? "top" : n.verticalAlign }), !0, s);
        }, l.prototype.handleOverflow = function(s) {
          var t = this, n = this.chart, o = n.renderer, A = this.options, _ = A.y, D = A.verticalAlign === "top", j = this.padding, T = A.maxHeight, X = A.navigation, f = h(X.animation, !0), m = X.arrowSize || 12, L = this.pages, Y = this.allItems, F = function(q) {
            typeof q == "number" ? V.attr({ height: q }) : V && (t.clipRect = V.destroy(), t.contentGroup.clip()), t.contentGroup.div && (t.contentGroup.div.style.clip = q ? "rect(" + j + "px,9999px," + (j + q) + "px,0)" : "auto");
          }, Q = function(q) {
            return t[q] = o.circle(0, 0, 1.3 * m).translate(m / 2, m / 2).add(z), n.styledMode || t[q].attr("fill", "rgba(0,0,0,0.0001)"), t[q];
          }, k, G;
          _ = n.spacingBox.height + (D ? -_ : _) - j;
          var z = this.nav, V = this.clipRect;
          return A.layout !== "horizontal" || A.verticalAlign === "middle" || A.floating || (_ /= 2), T && (_ = Math.min(_, T)), L.length = 0, s && 0 < _ && s > _ && X.enabled !== !1 ? (this.clipHeight = k = Math.max(_ - 20 - this.titleHeight - j, 0), this.currentPage = h(this.currentPage, 1), this.fullHeight = s, Y.forEach(function(q, it) {
            var et = q._legendItemPos[1], nt = Math.round(q.legendItem.getBBox().height), rt = L.length;
            (!rt || et - L[rt - 1] > k && (G || et) !== L[rt - 1]) && (L.push(G || et), rt++), q.pageIx = rt - 1, G && (Y[it - 1].pageIx = rt - 1), it === Y.length - 1 && et + nt - L[rt - 1] > k && nt <= k && (L.push(et), q.pageIx = rt), et !== G && (G = et);
          }), V || (V = t.clipRect = o.clipRect(0, j, 9999, 0), t.contentGroup.clip(V)), F(k), z || (this.nav = z = o.g().attr({ zIndex: 1 }).add(this.group), this.up = o.symbol("triangle", 0, 0, m, m).add(z), Q("upTracker").on(
            "click",
            function() {
              t.scroll(-1, f);
            }
          ), this.pager = o.text("", 15, 10).addClass("highcharts-legend-navigation"), n.styledMode || this.pager.css(X.style), this.pager.add(z), this.down = o.symbol("triangle-down", 0, 0, m, m).add(z), Q("downTracker").on("click", function() {
            t.scroll(1, f);
          })), t.scroll(0), s = _) : z && (F(), this.nav = z.destroy(), this.scrollGroup.attr({ translateY: 1 }), this.clipHeight = 0), s;
        }, l.prototype.scroll = function(s, t) {
          var n = this, o = this.chart, A = this.pages, _ = A.length, D = this.clipHeight, j = this.options.navigation, T = this.pager, X = this.padding, f = this.currentPage + s;
          f > _ && (f = _), 0 < f && (typeof t < "u" && W(t, o), this.nav.attr({ translateX: X, translateY: D + this.padding + 7 + this.titleHeight, visibility: "visible" }), [this.up, this.upTracker].forEach(function(m) {
            m.attr({ class: f === 1 ? "highcharts-legend-nav-inactive" : "highcharts-legend-nav-active" });
          }), T.attr({ text: f + "/" + _ }), [this.down, this.downTracker].forEach(
            function(m) {
              m.attr({ x: 18 + this.pager.getBBox().width, class: f === _ ? "highcharts-legend-nav-inactive" : "highcharts-legend-nav-active" });
            },
            this
          ), o.styledMode || (this.up.attr({ fill: f === 1 ? j.inactiveColor : j.activeColor }), this.upTracker.css({ cursor: f === 1 ? "default" : "pointer" }), this.down.attr({ fill: f === _ ? j.inactiveColor : j.activeColor }), this.downTracker.css({ cursor: f === _ ? "default" : "pointer" })), this.scrollOffset = -A[f - 1] + this.initialItemY, this.scrollGroup.animate({ translateY: this.scrollOffset }), this.currentPage = f, this.positionCheckboxes(), s = U(h(t, o.renderer.globalAnimation, !0)), i(function() {
            b(n, "afterScroll", { currentPage: f });
          }, s.duration));
        }, l.prototype.setItemEvents = function(s, t, n) {
          var o = this, A = o.chart.renderer.boxWrapper, _ = s instanceof Z, D = "highcharts-legend-" + (_ ? "point" : "series") + "-active", j = o.chart.styledMode, T = function(X) {
            o.allItems.forEach(function(f) {
              s !== f && [f].concat(f.linkedSeries || []).forEach(function(m) {
                m.setState(X, !_);
              });
            });
          };
          (n ? [t, s.legendSymbol] : [s.legendGroup]).forEach(function(X) {
            X && X.on("mouseover", function() {
              s.visible && T("inactive"), s.setState("hover"), s.visible && A.addClass(D), j || t.css(o.options.itemHoverStyle);
            }).on("mouseout", function() {
              o.chart.styledMode || t.css(x(s.visible ? o.itemStyle : o.itemHiddenStyle)), T(""), A.removeClass(D), s.setState();
            }).on("click", function(f) {
              var m = function() {
                s.setVisible && s.setVisible(), T(s.visible ? "inactive" : "");
              };
              A.removeClass(D), f = { browserEvent: f }, s.firePointEvent ? s.firePointEvent("legendItemClick", f, m) : b(s, "legendItemClick", f, m);
            });
          });
        }, l.prototype.createCheckboxForItem = function(s) {
          s.checkbox = d(
            "input",
            { type: "checkbox", className: "highcharts-legend-checkbox", checked: s.selected, defaultChecked: s.selected },
            this.options.itemCheckboxStyle,
            this.chart.container
          ), u(s.checkbox, "click", function(t) {
            b(s.series || s, "checkboxClick", { checked: t.target.checked, item: s }, function() {
              s.select();
            });
          });
        }, l;
      }(), (/Trident\/7\.0/.test(I.navigator && I.navigator.userAgent) || y) && H($.prototype, "positionItem", function(l, s) {
        var t = this, n = function() {
          s._legendItemPos && l.call(t, s);
        };
        n(), t.bubbleLegend || setTimeout(n);
      }), $;
    }), E(
      a,
      "Core/Series/SeriesRegistry.js",
      [a["Core/Globals.js"], a["Core/DefaultOptions.js"], a["Core/Series/Point.js"], a["Core/Utilities.js"]],
      function(y, R, I, Z) {
        var H = R.defaultOptions, $ = Z.error, U = Z.extendClass, W = Z.merge, N;
        return function(M) {
          function v(u, d) {
            var P = H.plotOptions || {}, O = d.defaultOptions;
            d.prototype.pointClass || (d.prototype.pointClass = I), d.prototype.type = u, O && (P[u] = O), M.seriesTypes[u] = d;
          }
          M.seriesTypes = y.seriesTypes, M.getSeries = function(u, d) {
            d === void 0 && (d = {});
            var P = u.options.chart;
            P = d.type || P.type || P.defaultSeriesType || "";
            var O = M.seriesTypes[P];
            return M || $(17, !0, u, { missingModuleFor: P }), P = new O(), typeof P.init == "function" && P.init(u, d), P;
          }, M.registerSeriesType = v, M.seriesType = function(u, d, P, O, B) {
            var C = H.plotOptions || {};
            return d = d || "", C[u] = W(C[d], P), v(u, U(M.seriesTypes[d] || function() {
            }, O)), M.seriesTypes[u].prototype.type = u, B && (M.seriesTypes[u].prototype.pointClass = U(I, B)), M.seriesTypes[u];
          };
        }(N || (N = {})), N;
      }
    ), E(a, "Core/Chart/Chart.js", [
      a["Core/Animation/AnimationUtilities.js"],
      a["Core/Axis/Axis.js"],
      a["Core/FormatUtilities.js"],
      a["Core/Foundation.js"],
      a["Core/Globals.js"],
      a["Core/Legend/Legend.js"],
      a["Core/MSPointer.js"],
      a["Core/DefaultOptions.js"],
      a["Core/Pointer.js"],
      a["Core/Renderer/RendererRegistry.js"],
      a["Core/Series/SeriesRegistry.js"],
      a["Core/Renderer/SVG/SVGRenderer.js"],
      a["Core/Time.js"],
      a["Core/Utilities.js"],
      a["Core/Renderer/HTML/AST.js"]
    ], function(y, R, I, Z, H, $, U, W, N, M, v, u, d, P, O) {
      var B = y.animate, C = y.animObject, b = y.setAnimation, w = I.numberFormat, x = Z.registerEventOptions, h = H.charts, c = H.doc, p = H.marginNames, i = H.svg, l = H.win, s = W.defaultOptions, t = W.defaultTime, n = v.seriesTypes, o = P.addEvent, A = P.attr, _ = P.cleanRecursively, D = P.createElement, j = P.css, T = P.defined, X = P.discardElement, f = P.erase, m = P.error, L = P.extend, Y = P.find, F = P.fireEvent, Q = P.getStyle, k = P.isArray, G = P.isNumber, z = P.isObject, V = P.isString, q = P.merge, it = P.objectEach, et = P.pick, nt = P.pInt, rt = P.relativeLength, ct = P.removeEvent, gt = P.splat, dt = P.syncTimeout, lt = P.uniqueKey;
      return y = function() {
        function at(J, tt, st) {
          this.series = this.renderTo = this.renderer = this.pointer = this.pointCount = this.plotWidth = this.plotTop = this.plotLeft = this.plotHeight = this.plotBox = this.options = this.numberFormatter = this.margin = this.legend = this.labelCollectors = this.isResizing = this.index = this.eventOptions = this.container = this.colorCounter = this.clipBox = this.chartWidth = this.chartHeight = this.bounds = this.axisOffset = this.axes = void 0, this.sharedClips = {}, this.yAxis = this.xAxis = this.userOptions = this.titleOffset = this.time = this.symbolCounter = this.spacingBox = this.spacing = void 0, this.getArgs(J, tt, st);
        }
        return at.chart = function(J, tt, st) {
          return new at(J, tt, st);
        }, at.prototype.getArgs = function(J, tt, st) {
          V(J) || J.nodeName ? (this.renderTo = J, this.init(tt, st)) : this.init(J, tt);
        }, at.prototype.init = function(J, tt) {
          var st = J.plotOptions || {};
          F(this, "init", { args: arguments }, function() {
            var ht = q(s, J), pt = ht.chart;
            it(ht.plotOptions, function(yt, vt) {
              z(yt) && (yt.tooltip = st[vt] && q(st[vt].tooltip) || void 0);
            }), ht.tooltip.userOptions = J.chart && J.chart.forExport && J.tooltip.userOptions || J.tooltip, this.userOptions = J, this.margin = [], this.spacing = [], this.bounds = { h: {}, v: {} }, this.labelCollectors = [], this.callback = tt, this.isResizing = 0, this.options = ht, this.axes = [], this.series = [], this.time = J.time && Object.keys(J.time).length ? new d(J.time) : H.time, this.numberFormatter = pt.numberFormatter || w, this.styledMode = pt.styledMode, this.hasCartesianSeries = pt.showAxes, this.index = h.length, h.push(this), H.chartCount++, x(this, pt), this.xAxis = [], this.yAxis = [], this.pointCount = this.colorCounter = this.symbolCounter = 0, F(this, "afterInit"), this.firstRender();
          });
        }, at.prototype.initSeries = function(J) {
          var tt = this.options.chart;
          tt = J.type || tt.type || tt.defaultSeriesType;
          var st = n[tt];
          return st || m(17, !0, this, { missingModuleFor: tt }), tt = new st(), typeof tt.init == "function" && tt.init(this, J), tt;
        }, at.prototype.setSeriesData = function() {
          this.getSeriesOrderByLinks().forEach(function(J) {
            J.points || J.data || !J.enabledDataSorting || J.setData(J.options.data, !1);
          });
        }, at.prototype.getSeriesOrderByLinks = function() {
          return this.series.concat().sort(function(J, tt) {
            return J.linkedSeries.length || tt.linkedSeries.length ? tt.linkedSeries.length - J.linkedSeries.length : 0;
          });
        }, at.prototype.orderSeries = function(J) {
          var tt = this.series;
          J = J || 0;
          for (var st = tt.length; J < st; ++J)
            tt[J] && (tt[J].index = J, tt[J].name = tt[J].getName());
        }, at.prototype.isInsidePlot = function(J, tt, st) {
          st === void 0 && (st = {});
          var ht = this.inverted, pt = this.plotBox, yt = this.plotLeft, vt = this.plotTop, Ct = this.scrollablePlotBox, Tt = 0, kt = 0;
          st.visiblePlotOnly && this.scrollingContainer && (kt = this.scrollingContainer, Tt = kt.scrollLeft, kt = kt.scrollTop);
          var St = st.series;
          if (pt = st.visiblePlotOnly && Ct || pt, Ct = st.inverted ? tt : J, tt = st.inverted ? J : tt, J = { x: Ct, y: tt, isInsidePlot: !0 }, !st.ignoreX) {
            var _t = St && (ht ? St.yAxis : St.xAxis) || { pos: yt, len: 1 / 0 };
            Ct = st.paneCoordinates ? _t.pos + Ct : yt + Ct, Ct >= Math.max(Tt + yt, _t.pos) && Ct <= Math.min(Tt + yt + pt.width, _t.pos + _t.len) || (J.isInsidePlot = !1);
          }
          return !st.ignoreY && J.isInsidePlot && (ht = St && (ht ? St.xAxis : St.yAxis) || { pos: vt, len: 1 / 0 }, st = st.paneCoordinates ? ht.pos + tt : vt + tt, st >= Math.max(kt + vt, ht.pos) && st <= Math.min(kt + vt + pt.height, ht.pos + ht.len) || (J.isInsidePlot = !1)), F(this, "afterIsInsidePlot", J), J.isInsidePlot;
        }, at.prototype.redraw = function(J) {
          F(this, "beforeRedraw");
          var tt = this.hasCartesianSeries ? this.axes : this.colorAxis || [], st = this.series, ht = this.pointer, pt = this.legend, yt = this.userOptions.legend, vt = this.renderer, Ct = vt.isHidden(), Tt = [], kt = this.isDirtyBox, St = this.isDirtyLegend;
          for (this.setResponsive && this.setResponsive(!1), b(this.hasRendered ? J : !1, this), Ct && this.temporaryDisplay(), this.layOutTitles(), J = st.length; J--; ) {
            var _t = st[J];
            if (_t.options.stacking || _t.options.centerInCategory) {
              var Lt = !0;
              if (_t.isDirty) {
                var Nt = !0;
                break;
              }
            }
          }
          if (Nt)
            for (J = st.length; J--; )
              _t = st[J], _t.options.stacking && (_t.isDirty = !0);
          st.forEach(function(Et) {
            Et.isDirty && (Et.options.legendType === "point" ? (typeof Et.updateTotals == "function" && Et.updateTotals(), St = !0) : yt && (yt.labelFormatter || yt.labelFormat) && (St = !0)), Et.isDirtyData && F(Et, "updatedData");
          }), St && pt && pt.options.enabled && (pt.render(), this.isDirtyLegend = !1), Lt && this.getStacks(), tt.forEach(function(Et) {
            Et.updateNames(), Et.setScale();
          }), this.getMargins(), tt.forEach(function(Et) {
            Et.isDirty && (kt = !0);
          }), tt.forEach(function(Et) {
            var Kt = Et.min + "," + Et.max;
            Et.extKey !== Kt && (Et.extKey = Kt, Tt.push(function() {
              F(Et, "afterSetExtremes", L(Et.eventArgs, Et.getExtremes())), delete Et.eventArgs;
            })), (kt || Lt) && Et.redraw();
          }), kt && this.drawChartBox(), F(this, "predraw"), st.forEach(function(Et) {
            (kt || Et.isDirty) && Et.visible && Et.redraw(), Et.isDirtyData = !1;
          }), ht && ht.reset(!0), vt.draw(), F(this, "redraw"), F(this, "render"), Ct && this.temporaryDisplay(!0), Tt.forEach(function(Et) {
            Et.call();
          });
        }, at.prototype.get = function(J) {
          function tt(yt) {
            return yt.id === J || yt.options && yt.options.id === J;
          }
          for (var st = this.series, ht = Y(this.axes, tt) || Y(this.series, tt), pt = 0; !ht && pt < st.length; pt++)
            ht = Y(st[pt].points || [], tt);
          return ht;
        }, at.prototype.getAxes = function() {
          var J = this, tt = this.options, st = tt.xAxis = gt(tt.xAxis || {});
          tt = tt.yAxis = gt(tt.yAxis || {}), F(this, "getAxes"), st.forEach(function(ht, pt) {
            ht.index = pt, ht.isX = !0;
          }), tt.forEach(function(ht, pt) {
            ht.index = pt;
          }), st.concat(tt).forEach(function(ht) {
            new R(J, ht);
          }), F(this, "afterGetAxes");
        }, at.prototype.getSelectedPoints = function() {
          return this.series.reduce(function(J, tt) {
            return tt.getPointsCollection().forEach(function(st) {
              et(st.selectedStaging, st.selected) && J.push(st);
            }), J;
          }, []);
        }, at.prototype.getSelectedSeries = function() {
          return this.series.filter(function(J) {
            return J.selected;
          });
        }, at.prototype.setTitle = function(J, tt, st) {
          this.applyDescription("title", J), this.applyDescription("subtitle", tt), this.applyDescription(
            "caption",
            void 0
          ), this.layOutTitles(st);
        }, at.prototype.applyDescription = function(J, tt) {
          var st = this, ht = J === "title" ? { color: "#333333", fontSize: this.options.isStock ? "16px" : "18px" } : { color: "#666666" };
          ht = this.options[J] = q(!this.styledMode && { style: ht }, this.options[J], tt);
          var pt = this[J];
          pt && tt && (this[J] = pt = pt.destroy()), ht && !pt && (pt = this.renderer.text(ht.text, 0, 0, ht.useHTML).attr({ align: ht.align, class: "highcharts-" + J, zIndex: ht.zIndex || 4 }).add(), pt.update = function(yt) {
            st[{ title: "setTitle", subtitle: "setSubtitle", caption: "setCaption" }[J]](yt);
          }, this.styledMode || pt.css(ht.style), this[J] = pt);
        }, at.prototype.layOutTitles = function(J) {
          var tt = [0, 0, 0], st = this.renderer, ht = this.spacingBox;
          ["title", "subtitle", "caption"].forEach(function(yt) {
            var vt = this[yt], Ct = this.options[yt], Tt = Ct.verticalAlign || "top";
            yt = yt === "title" ? Tt === "top" ? -3 : 0 : Tt === "top" ? tt[0] + 2 : 0;
            var kt;
            if (vt) {
              this.styledMode || (kt = Ct.style && Ct.style.fontSize), kt = st.fontMetrics(kt, vt).b, vt.css({ width: (Ct.width || ht.width + (Ct.widthAdjust || 0)) + "px" });
              var St = Math.round(vt.getBBox(Ct.useHTML).height);
              vt.align(L({ y: Tt === "bottom" ? kt : yt + kt, height: St }, Ct), !1, "spacingBox"), Ct.floating || (Tt === "top" ? tt[0] = Math.ceil(tt[0] + St) : Tt === "bottom" && (tt[2] = Math.ceil(tt[2] + St)));
            }
          }, this), tt[0] && (this.options.title.verticalAlign || "top") === "top" && (tt[0] += this.options.title.margin), tt[2] && this.options.caption.verticalAlign === "bottom" && (tt[2] += this.options.caption.margin);
          var pt = !this.titleOffset || this.titleOffset.join(",") !== tt.join(",");
          this.titleOffset = tt, F(this, "afterLayOutTitles"), !this.isDirtyBox && pt && (this.isDirtyBox = this.isDirtyLegend = pt, this.hasRendered && et(J, !0) && this.isDirtyBox && this.redraw());
        }, at.prototype.getChartSize = function() {
          var J = this.options.chart, tt = J.width;
          J = J.height;
          var st = this.renderTo;
          T(tt) || (this.containerWidth = Q(st, "width")), T(J) || (this.containerHeight = Q(st, "height")), this.chartWidth = Math.max(0, tt || this.containerWidth || 600), this.chartHeight = Math.max(0, rt(J, this.chartWidth) || (1 < this.containerHeight ? this.containerHeight : 400));
        }, at.prototype.temporaryDisplay = function(J) {
          var tt = this.renderTo;
          if (J)
            for (; tt && tt.style; )
              tt.hcOrigStyle && (j(tt, tt.hcOrigStyle), delete tt.hcOrigStyle), tt.hcOrigDetached && (c.body.removeChild(tt), tt.hcOrigDetached = !1), tt = tt.parentNode;
          else
            for (; tt && tt.style && (c.body.contains(tt) || tt.parentNode || (tt.hcOrigDetached = !0, c.body.appendChild(tt)), (Q(tt, "display", !1) === "none" || tt.hcOricDetached) && (tt.hcOrigStyle = { display: tt.style.display, height: tt.style.height, overflow: tt.style.overflow }, J = { display: "block", overflow: "hidden" }, tt !== this.renderTo && (J.height = 0), j(tt, J), tt.offsetWidth || tt.style.setProperty("display", "block", "important")), tt = tt.parentNode, tt !== c.body); )
              ;
        }, at.prototype.setClassName = function(J) {
          this.container.className = "highcharts-container " + (J || "");
        }, at.prototype.getContainer = function() {
          var J = this.options, tt = J.chart, st = lt(), ht, pt = this.renderTo;
          pt || (this.renderTo = pt = tt.renderTo), V(pt) && (this.renderTo = pt = c.getElementById(pt)), pt || m(13, !0, this);
          var yt = nt(A(pt, "data-highcharts-chart"));
          G(yt) && h[yt] && h[yt].hasRendered && h[yt].destroy(), A(pt, "data-highcharts-chart", this.index), pt.innerHTML = O.emptyHTML, tt.skipClone || pt.offsetWidth || this.temporaryDisplay(), this.getChartSize(), yt = this.chartWidth;
          var vt = this.chartHeight;
          if (j(pt, { overflow: "hidden" }), this.styledMode || (ht = L({ position: "relative", overflow: "hidden", width: yt + "px", height: vt + "px", textAlign: "left", lineHeight: "normal", zIndex: 0, "-webkit-tap-highlight-color": "rgba(0,0,0,0)", userSelect: "none", "touch-action": "manipulation", outline: "none" }, tt.style || {})), this.container = st = D("div", { id: st }, ht, pt), this._cursor = st.style.cursor, this.renderer = new (tt.renderer || !i ? M.getRendererType(tt.renderer) : u)(st, yt, vt, void 0, tt.forExport, J.exporting && J.exporting.allowHTML, this.styledMode), b(
            void 0,
            this
          ), this.setClassName(tt.className), this.styledMode)
            for (var Ct in J.defs)
              this.renderer.definition(J.defs[Ct]);
          else
            this.renderer.setStyle(tt.style);
          this.renderer.chartIndex = this.index, F(this, "afterGetContainer");
        }, at.prototype.getMargins = function(J) {
          var tt = this.spacing, st = this.margin, ht = this.titleOffset;
          this.resetMargins(), ht[0] && !T(st[0]) && (this.plotTop = Math.max(this.plotTop, ht[0] + tt[0])), ht[2] && !T(st[2]) && (this.marginBottom = Math.max(this.marginBottom, ht[2] + tt[2])), this.legend && this.legend.display && this.legend.adjustMargins(
            st,
            tt
          ), F(this, "getMargins"), J || this.getAxisMargins();
        }, at.prototype.getAxisMargins = function() {
          var J = this, tt = J.axisOffset = [0, 0, 0, 0], st = J.colorAxis, ht = J.margin, pt = function(yt) {
            yt.forEach(function(vt) {
              vt.visible && vt.getOffset();
            });
          };
          J.hasCartesianSeries ? pt(J.axes) : st && st.length && pt(st), p.forEach(function(yt, vt) {
            T(ht[vt]) || (J[yt] += tt[vt]);
          }), J.setChartSize();
        }, at.prototype.reflow = function(J) {
          var tt = this, st = tt.options.chart, ht = tt.renderTo, pt = T(st.width) && T(st.height), yt = st.width || Q(ht, "width");
          st = st.height || Q(ht, "height"), ht = J ? J.target : l, delete tt.pointer.chartPosition, !pt && !tt.isPrinting && yt && st && (ht === l || ht === c) && ((yt !== tt.containerWidth || st !== tt.containerHeight) && (P.clearTimeout(tt.reflowTimeout), tt.reflowTimeout = dt(function() {
            tt.container && tt.setSize(void 0, void 0, !1);
          }, J ? 100 : 0)), tt.containerWidth = yt, tt.containerHeight = st);
        }, at.prototype.setReflow = function(J) {
          var tt = this;
          J === !1 || this.unbindReflow ? J === !1 && this.unbindReflow && (this.unbindReflow = this.unbindReflow()) : (this.unbindReflow = o(l, "resize", function(st) {
            tt.options && tt.reflow(st);
          }), o(this, "destroy", this.unbindReflow));
        }, at.prototype.setSize = function(J, tt, st) {
          var ht = this, pt = ht.renderer;
          ht.isResizing += 1, b(st, ht), st = pt.globalAnimation, ht.oldChartHeight = ht.chartHeight, ht.oldChartWidth = ht.chartWidth, typeof J < "u" && (ht.options.chart.width = J), typeof tt < "u" && (ht.options.chart.height = tt), ht.getChartSize(), ht.styledMode || (st ? B : j)(ht.container, { width: ht.chartWidth + "px", height: ht.chartHeight + "px" }, st), ht.setChartSize(!0), pt.setSize(ht.chartWidth, ht.chartHeight, st), ht.axes.forEach(function(yt) {
            yt.isDirty = !0, yt.setScale();
          }), ht.isDirtyLegend = !0, ht.isDirtyBox = !0, ht.layOutTitles(), ht.getMargins(), ht.redraw(st), ht.oldChartHeight = null, F(ht, "resize"), dt(function() {
            ht && F(ht, "endResize", null, function() {
              --ht.isResizing;
            });
          }, C(st).duration);
        }, at.prototype.setChartSize = function(J) {
          var tt = this.inverted, st = this.renderer, ht = this.chartWidth, pt = this.chartHeight, yt = this.options.chart, vt = this.spacing, Ct = this.clipOffset, Tt, kt, St, _t;
          this.plotLeft = Tt = Math.round(this.plotLeft), this.plotTop = kt = Math.round(this.plotTop), this.plotWidth = St = Math.max(0, Math.round(ht - Tt - this.marginRight)), this.plotHeight = _t = Math.max(0, Math.round(pt - kt - this.marginBottom)), this.plotSizeX = tt ? _t : St, this.plotSizeY = tt ? St : _t, this.plotBorderWidth = yt.plotBorderWidth || 0, this.spacingBox = st.spacingBox = { x: vt[3], y: vt[0], width: ht - vt[3] - vt[1], height: pt - vt[0] - vt[2] }, this.plotBox = st.plotBox = { x: Tt, y: kt, width: St, height: _t }, tt = 2 * Math.floor(this.plotBorderWidth / 2), ht = Math.ceil(Math.max(tt, Ct[3]) / 2), pt = Math.ceil(Math.max(tt, Ct[0]) / 2), this.clipBox = { x: ht, y: pt, width: Math.floor(this.plotSizeX - Math.max(tt, Ct[1]) / 2 - ht), height: Math.max(0, Math.floor(this.plotSizeY - Math.max(tt, Ct[2]) / 2 - pt)) }, J || (this.axes.forEach(function(Lt) {
            Lt.setAxisSize(), Lt.setAxisTranslation();
          }), st.alignElements()), F(this, "afterSetChartSize", { skipAxes: J });
        }, at.prototype.resetMargins = function() {
          F(this, "resetMargins");
          var J = this, tt = J.options.chart;
          ["margin", "spacing"].forEach(function(st) {
            var ht = tt[st], pt = z(ht) ? ht : [ht, ht, ht, ht];
            ["Top", "Right", "Bottom", "Left"].forEach(function(yt, vt) {
              J[st][vt] = et(tt[st + yt], pt[vt]);
            });
          }), p.forEach(function(st, ht) {
            J[st] = et(J.margin[ht], J.spacing[ht]);
          }), J.axisOffset = [0, 0, 0, 0], J.clipOffset = [0, 0, 0, 0];
        }, at.prototype.drawChartBox = function() {
          var J = this.options.chart, tt = this.renderer, st = this.chartWidth, ht = this.chartHeight, pt = this.styledMode, yt = this.plotBGImage, vt = J.backgroundColor, Ct = J.plotBackgroundColor, Tt = J.plotBackgroundImage, kt = this.plotLeft, St = this.plotTop, _t = this.plotWidth, Lt = this.plotHeight, Nt = this.plotBox, Et = this.clipRect, Kt = this.clipBox, Gt = this.chartBackground, Wt = this.plotBackground, Jt = this.plotBorder, be, zt = "animate";
          if (Gt || (this.chartBackground = Gt = tt.rect().addClass("highcharts-background").add(), zt = "attr"), pt)
            var Vt = be = Gt.strokeWidth();
          else
            Vt = J.borderWidth || 0, be = Vt + (J.shadow ? 8 : 0), vt = { fill: vt || "none" }, (Vt || Gt["stroke-width"]) && (vt.stroke = J.borderColor, vt["stroke-width"] = Vt), Gt.attr(vt).shadow(J.shadow);
          Gt[zt]({ x: be / 2, y: be / 2, width: st - be - Vt % 2, height: ht - be - Vt % 2, r: J.borderRadius }), zt = "animate", Wt || (zt = "attr", this.plotBackground = Wt = tt.rect().addClass("highcharts-plot-background").add()), Wt[zt](Nt), pt || (Wt.attr({ fill: Ct || "none" }).shadow(J.plotShadow), Tt && (yt ? (Tt !== yt.attr("href") && yt.attr("href", Tt), yt.animate(Nt)) : this.plotBGImage = tt.image(Tt, kt, St, _t, Lt).add())), Et ? Et.animate({ width: Kt.width, height: Kt.height }) : this.clipRect = tt.clipRect(Kt), zt = "animate", Jt || (zt = "attr", this.plotBorder = Jt = tt.rect().addClass("highcharts-plot-border").attr({ zIndex: 1 }).add()), pt || Jt.attr({ stroke: J.plotBorderColor, "stroke-width": J.plotBorderWidth || 0, fill: "none" }), Jt[zt](Jt.crisp({ x: kt, y: St, width: _t, height: Lt }, -Jt.strokeWidth())), this.isDirtyBox = !1, F(this, "afterDrawChartBox");
        }, at.prototype.propFromSeries = function() {
          var J = this, tt = J.options.chart, st = J.options.series, ht, pt, yt;
          ["inverted", "angular", "polar"].forEach(function(vt) {
            for (pt = n[tt.type || tt.defaultSeriesType], yt = tt[vt] || pt && pt.prototype[vt], ht = st && st.length; !yt && ht--; )
              (pt = n[st[ht].type]) && pt.prototype[vt] && (yt = !0);
            J[vt] = yt;
          });
        }, at.prototype.linkSeries = function() {
          var J = this, tt = J.series;
          tt.forEach(function(st) {
            st.linkedSeries.length = 0;
          }), tt.forEach(function(st) {
            var ht = st.options.linkedTo;
            V(ht) && (ht = ht === ":previous" ? J.series[st.index - 1] : J.get(ht)) && ht.linkedParent !== st && (ht.linkedSeries.push(st), st.linkedParent = ht, ht.enabledDataSorting && st.setDataSortingOptions(), st.visible = et(st.options.visible, ht.options.visible, st.visible));
          }), F(this, "afterLinkSeries");
        }, at.prototype.renderSeries = function() {
          this.series.forEach(function(J) {
            J.translate(), J.render();
          });
        }, at.prototype.renderLabels = function() {
          var J = this, tt = J.options.labels;
          tt.items && tt.items.forEach(function(st) {
            var ht = L(tt.style, st.style), pt = nt(ht.left) + J.plotLeft, yt = nt(ht.top) + J.plotTop + 12;
            delete ht.left, delete ht.top, J.renderer.text(st.html, pt, yt).attr({ zIndex: 2 }).css(ht).add();
          });
        }, at.prototype.render = function() {
          var J = this.axes, tt = this.colorAxis, st = this.renderer, ht = this.options, pt = function(kt) {
            kt.forEach(function(St) {
              St.visible && St.render();
            });
          }, yt = 0;
          this.setTitle(), this.legend = new $(this, ht.legend), this.getStacks && this.getStacks(), this.getMargins(!0), this.setChartSize(), ht = this.plotWidth, J.some(function(kt) {
            if (kt.horiz && kt.visible && kt.options.labels.enabled && kt.series.length)
              return yt = 21, !0;
          });
          var vt = this.plotHeight = Math.max(this.plotHeight - yt, 0);
          J.forEach(function(kt) {
            kt.setScale();
          }), this.getAxisMargins();
          var Ct = 1.1 < ht / this.plotWidth, Tt = 1.05 < vt / this.plotHeight;
          (Ct || Tt) && (J.forEach(function(kt) {
            (kt.horiz && Ct || !kt.horiz && Tt) && kt.setTickInterval(!0);
          }), this.getMargins()), this.drawChartBox(), this.hasCartesianSeries ? pt(J) : tt && tt.length && pt(tt), this.seriesGroup || (this.seriesGroup = st.g("series-group").attr({ zIndex: 3 }).add()), this.renderSeries(), this.renderLabels(), this.addCredits(), this.setResponsive && this.setResponsive(), this.hasRendered = !0;
        }, at.prototype.addCredits = function(J) {
          var tt = this, st = q(!0, this.options.credits, J);
          st.enabled && !this.credits && (this.credits = this.renderer.text(st.text + (this.mapCredits || ""), 0, 0).addClass("highcharts-credits").on("click", function() {
            st.href && (l.location.href = st.href);
          }).attr({ align: st.position.align, zIndex: 8 }), tt.styledMode || this.credits.css(st.style), this.credits.add().align(st.position), this.credits.update = function(ht) {
            tt.credits = tt.credits.destroy(), tt.addCredits(ht);
          });
        }, at.prototype.destroy = function() {
          var J = this, tt = J.axes, st = J.series, ht = J.container, pt = ht && ht.parentNode, yt;
          for (F(J, "destroy"), J.renderer.forExport ? f(h, J) : h[J.index] = void 0, H.chartCount--, J.renderTo.removeAttribute("data-highcharts-chart"), ct(J), yt = tt.length; yt--; )
            tt[yt] = tt[yt].destroy();
          for (this.scroller && this.scroller.destroy && this.scroller.destroy(), yt = st.length; yt--; )
            st[yt] = st[yt].destroy();
          "title subtitle chartBackground plotBackground plotBGImage plotBorder seriesGroup clipRect credits pointer rangeSelector legend resetZoomButton tooltip renderer".split(" ").forEach(function(vt) {
            var Ct = J[vt];
            Ct && Ct.destroy && (J[vt] = Ct.destroy());
          }), ht && (ht.innerHTML = O.emptyHTML, ct(ht), pt && X(ht)), it(J, function(vt, Ct) {
            delete J[Ct];
          });
        }, at.prototype.firstRender = function() {
          var J = this, tt = J.options;
          (!J.isReadyToRender || J.isReadyToRender()) && (J.getContainer(), J.resetMargins(), J.setChartSize(), J.propFromSeries(), J.getAxes(), (k(tt.series) ? tt.series : []).forEach(function(st) {
            J.initSeries(st);
          }), J.linkSeries(), J.setSeriesData(), F(J, "beforeRender"), N && (U.isRequired() ? J.pointer = new U(J, tt) : J.pointer = new N(J, tt)), J.render(), J.pointer.getChartPosition(), !J.renderer.imgCount && !J.hasLoaded && J.onload(), J.temporaryDisplay(!0));
        }, at.prototype.onload = function() {
          this.callbacks.concat([this.callback]).forEach(function(J) {
            J && typeof this.index < "u" && J.apply(this, [this]);
          }, this), F(this, "load"), F(this, "render"), T(this.index) && this.setReflow(this.options.chart.reflow), this.hasLoaded = !0;
        }, at.prototype.addSeries = function(J, tt, st) {
          var ht = this, pt;
          return J && (tt = et(tt, !0), F(ht, "addSeries", { options: J }, function() {
            pt = ht.initSeries(J), ht.isDirtyLegend = !0, ht.linkSeries(), pt.enabledDataSorting && pt.setData(J.data, !1), F(ht, "afterAddSeries", { series: pt }), tt && ht.redraw(st);
          })), pt;
        }, at.prototype.addAxis = function(J, tt, st, ht) {
          return this.createAxis(tt ? "xAxis" : "yAxis", { axis: J, redraw: st, animation: ht });
        }, at.prototype.addColorAxis = function(J, tt, st) {
          return this.createAxis(
            "colorAxis",
            { axis: J, redraw: tt, animation: st }
          );
        }, at.prototype.createAxis = function(J, tt) {
          return J = new R(this, q(tt.axis, { index: this[J].length, isX: J === "xAxis" })), et(tt.redraw, !0) && this.redraw(tt.animation), J;
        }, at.prototype.showLoading = function(J) {
          var tt = this, st = tt.options, ht = st.loading, pt = function() {
            yt && j(yt, { left: tt.plotLeft + "px", top: tt.plotTop + "px", width: tt.plotWidth + "px", height: tt.plotHeight + "px" });
          }, yt = tt.loadingDiv, vt = tt.loadingSpan;
          yt || (tt.loadingDiv = yt = D("div", { className: "highcharts-loading highcharts-loading-hidden" }, null, tt.container)), vt || (tt.loadingSpan = vt = D("span", { className: "highcharts-loading-inner" }, null, yt), o(tt, "redraw", pt)), yt.className = "highcharts-loading", O.setElementHTML(vt, et(J, st.lang.loading, "")), tt.styledMode || (j(yt, L(ht.style, { zIndex: 10 })), j(vt, ht.labelStyle), tt.loadingShown || (j(yt, { opacity: 0, display: "" }), B(yt, { opacity: ht.style.opacity || 0.5 }, { duration: ht.showDuration || 0 }))), tt.loadingShown = !0, pt();
        }, at.prototype.hideLoading = function() {
          var J = this.options, tt = this.loadingDiv;
          tt && (tt.className = "highcharts-loading highcharts-loading-hidden", this.styledMode || B(tt, { opacity: 0 }, { duration: J.loading.hideDuration || 100, complete: function() {
            j(tt, { display: "none" });
          } })), this.loadingShown = !1;
        }, at.prototype.update = function(J, tt, st, ht) {
          var pt = this, yt = { credits: "addCredits", title: "setTitle", subtitle: "setSubtitle", caption: "setCaption" }, vt = J.isResponsiveOptions, Ct = [], Tt, kt;
          F(pt, "update", { options: J }), vt || pt.setResponsive(!1, !0), J = _(J, pt.options), pt.userOptions = q(pt.userOptions, J);
          var St = J.chart;
          if (St) {
            if (q(!0, pt.options.chart, St), "className" in St && pt.setClassName(St.className), "reflow" in St && pt.setReflow(St.reflow), "inverted" in St || "polar" in St || "type" in St) {
              pt.propFromSeries();
              var _t = !0;
            }
            "alignTicks" in St && (_t = !0), "events" in St && x(this, St), it(St, function(Lt, Nt) {
              pt.propsRequireUpdateSeries.indexOf("chart." + Nt) !== -1 && (Tt = !0), pt.propsRequireDirtyBox.indexOf(Nt) !== -1 && (pt.isDirtyBox = !0), pt.propsRequireReflow.indexOf(Nt) !== -1 && (vt ? pt.isDirtyBox = !0 : kt = !0);
            }), !pt.styledMode && St.style && pt.renderer.setStyle(pt.options.chart.style || {});
          }
          !pt.styledMode && J.colors && (this.options.colors = J.colors), J.time && (this.time === t && (this.time = new d(J.time)), q(
            !0,
            pt.options.time,
            J.time
          )), it(J, function(Lt, Nt) {
            pt[Nt] && typeof pt[Nt].update == "function" ? pt[Nt].update(Lt, !1) : typeof pt[yt[Nt]] == "function" ? pt[yt[Nt]](Lt) : Nt !== "colors" && pt.collectionsWithUpdate.indexOf(Nt) === -1 && q(!0, pt.options[Nt], J[Nt]), Nt !== "chart" && pt.propsRequireUpdateSeries.indexOf(Nt) !== -1 && (Tt = !0);
          }), this.collectionsWithUpdate.forEach(function(Lt) {
            if (J[Lt]) {
              var Nt = [];
              pt[Lt].forEach(function(Et, Kt) {
                Et.options.isInternal || Nt.push(et(Et.options.index, Kt));
              }), gt(J[Lt]).forEach(function(Et, Kt) {
                var Gt = T(Et.id), Wt;
                Gt && (Wt = pt.get(Et.id)), !Wt && pt[Lt] && (Wt = pt[Lt][Nt ? Nt[Kt] : Kt]) && Gt && T(Wt.options.id) && (Wt = void 0), Wt && Wt.coll === Lt && (Wt.update(Et, !1), st && (Wt.touched = !0)), !Wt && st && pt.collectionsWithInit[Lt] && (pt.collectionsWithInit[Lt][0].apply(pt, [Et].concat(pt.collectionsWithInit[Lt][1] || []).concat([!1])).touched = !0);
              }), st && pt[Lt].forEach(function(Et) {
                Et.touched || Et.options.isInternal ? delete Et.touched : Ct.push(Et);
              });
            }
          }), Ct.forEach(function(Lt) {
            Lt.chart && Lt.remove && Lt.remove(!1);
          }), _t && pt.axes.forEach(function(Lt) {
            Lt.update({}, !1);
          }), Tt && pt.getSeriesOrderByLinks().forEach(function(Lt) {
            Lt.chart && Lt.update({}, !1);
          }, this), _t = St && St.width, St = St && (V(St.height) ? rt(St.height, _t || pt.chartWidth) : St.height), kt || G(_t) && _t !== pt.chartWidth || G(St) && St !== pt.chartHeight ? pt.setSize(_t, St, ht) : et(tt, !0) && pt.redraw(ht), F(pt, "afterUpdate", { options: J, redraw: tt, animation: ht });
        }, at.prototype.setSubtitle = function(J, tt) {
          this.applyDescription("subtitle", J), this.layOutTitles(tt);
        }, at.prototype.setCaption = function(J, tt) {
          this.applyDescription("caption", J), this.layOutTitles(tt);
        }, at.prototype.showResetZoom = function() {
          function J() {
            tt.zoomOut();
          }
          var tt = this, st = s.lang, ht = tt.options.chart.resetZoomButton, pt = ht.theme, yt = pt.states, vt = ht.relativeTo === "chart" || ht.relativeTo === "spacingBox" ? null : "scrollablePlotBox";
          F(this, "beforeShowResetZoom", null, function() {
            tt.resetZoomButton = tt.renderer.button(st.resetZoom, null, null, J, pt, yt && yt.hover).attr({ align: ht.position.align, title: st.resetZoomTitle }).addClass("highcharts-reset-zoom").add().align(ht.position, !1, vt);
          }), F(this, "afterShowResetZoom");
        }, at.prototype.zoomOut = function() {
          F(this, "selection", { resetSelection: !0 }, this.zoom);
        }, at.prototype.zoom = function(J) {
          var tt = this, st = tt.pointer, ht = tt.inverted ? st.mouseDownX : st.mouseDownY, pt = !1, yt;
          !J || J.resetSelection ? (tt.axes.forEach(function(Ct) {
            yt = Ct.zoom();
          }), st.initiated = !1) : J.xAxis.concat(J.yAxis).forEach(function(Ct) {
            var Tt = Ct.axis, kt = tt.inverted ? Tt.left : Tt.top, St = tt.inverted ? kt + Tt.width : kt + Tt.height, _t = Tt.isXAxis, Lt = !1;
            (!_t && ht >= kt && ht <= St || _t || !T(ht)) && (Lt = !0), st[_t ? "zoomX" : "zoomY"] && Lt && (yt = Tt.zoom(Ct.min, Ct.max), Tt.displayBtn && (pt = !0));
          });
          var vt = tt.resetZoomButton;
          pt && !vt ? tt.showResetZoom() : !pt && z(vt) && (tt.resetZoomButton = vt.destroy()), yt && tt.redraw(et(
            tt.options.chart.animation,
            J && J.animation,
            100 > tt.pointCount
          ));
        }, at.prototype.pan = function(J, tt) {
          var st = this, ht = st.hoverPoints;
          tt = typeof tt == "object" ? tt : { enabled: tt, type: "x" };
          var pt = st.options.chart, yt = st.options.mapNavigation && st.options.mapNavigation.enabled;
          pt && pt.panning && (pt.panning = tt);
          var vt = tt.type, Ct;
          F(this, "pan", { originalEvent: J }, function() {
            ht && ht.forEach(function(St) {
              St.setState();
            });
            var Tt = st.xAxis;
            vt === "xy" ? Tt = Tt.concat(st.yAxis) : vt === "y" && (Tt = st.yAxis);
            var kt = {};
            Tt.forEach(function(St) {
              if (St.options.panningEnabled && !St.options.isInternal) {
                var _t = St.horiz, Lt = J[_t ? "chartX" : "chartY"];
                _t = _t ? "mouseDownX" : "mouseDownY";
                var Nt = st[_t], Et = St.minPointOffset || 0, Kt = St.reversed && !st.inverted || !St.reversed && st.inverted ? -1 : 1, Gt = St.getExtremes(), Wt = St.toValue(Nt - Lt, !0) + Et * Kt, Jt = St.toValue(Nt + St.len - Lt, !0) - (Et * Kt || St.isXAxis && St.pointRangePadding || 0), be = Jt < Wt;
                Kt = St.hasVerticalPanning(), Nt = be ? Jt : Wt, Wt = be ? Wt : Jt;
                var zt = St.panningState;
                !Kt || St.isXAxis || zt && !zt.isDirty || St.series.forEach(function(Vt) {
                  var Me = Vt.getProcessedData(!0);
                  Me = Vt.getExtremes(Me.yData, !0), zt || (zt = { startMin: Number.MAX_VALUE, startMax: -Number.MAX_VALUE }), G(Me.dataMin) && G(Me.dataMax) && (zt.startMin = Math.min(et(Vt.options.threshold, 1 / 0), Me.dataMin, zt.startMin), zt.startMax = Math.max(et(Vt.options.threshold, -1 / 0), Me.dataMax, zt.startMax));
                }), Kt = Math.min(et(zt && zt.startMin, Gt.dataMin), Et ? Gt.min : St.toValue(St.toPixels(Gt.min) - St.minPixelPadding)), Jt = Math.max(et(zt && zt.startMax, Gt.dataMax), Et ? Gt.max : St.toValue(St.toPixels(Gt.max) + St.minPixelPadding)), St.panningState = zt, St.isOrdinal || (Et = Kt - Nt, 0 < Et && (Wt += Et, Nt = Kt), Et = Wt - Jt, 0 < Et && (Wt = Jt, Nt -= Et), St.series.length && Nt !== Gt.min && Wt !== Gt.max && Nt >= Kt && Wt <= Jt && (St.setExtremes(
                  Nt,
                  Wt,
                  !1,
                  !1,
                  { trigger: "pan" }
                ), st.resetZoomButton || yt || Nt === Kt || Wt === Jt || !vt.match("y") || (st.showResetZoom(), St.displayBtn = !1), Ct = !0), kt[_t] = Lt);
              }
            }), it(kt, function(St, _t) {
              st[_t] = St;
            }), Ct && st.redraw(!1), j(st.container, { cursor: "move" });
          });
        }, at;
      }(), L(y.prototype, {
        callbacks: [],
        collectionsWithInit: { xAxis: [y.prototype.addAxis, [!0]], yAxis: [y.prototype.addAxis, [!1]], series: [y.prototype.addSeries] },
        collectionsWithUpdate: ["xAxis", "yAxis", "series"],
        propsRequireDirtyBox: "backgroundColor borderColor borderWidth borderRadius plotBackgroundColor plotBackgroundImage plotBorderColor plotBorderWidth plotShadow shadow".split(" "),
        propsRequireReflow: "margin marginTop marginRight marginBottom marginLeft spacing spacingTop spacingRight spacingBottom spacingLeft".split(" "),
        propsRequireUpdateSeries: "chart.inverted chart.polar chart.ignoreHiddenSeries chart.type colors plotOptions time tooltip".split(" ")
      }), y;
    }), E(a, "Core/Legend/LegendSymbol.js", [a["Core/Utilities.js"]], function(y) {
      var R = y.merge, I = y.pick, Z;
      return function(H) {
        H.drawLineMarker = function($) {
          var U = this.options, W = $.symbolWidth, N = $.symbolHeight, M = N / 2, v = this.chart.renderer, u = this.legendGroup;
          $ = $.baseline - Math.round(0.3 * $.fontMetrics.b);
          var d = {}, P = U.marker;
          this.chart.styledMode || (d = { "stroke-width": U.lineWidth || 0 }, U.dashStyle && (d.dashstyle = U.dashStyle)), this.legendLine = v.path([["M", 0, $], ["L", W, $]]).addClass("highcharts-graph").attr(d).add(u), P && P.enabled !== !1 && W && (U = Math.min(I(P.radius, M), M), this.symbol.indexOf("url") === 0 && (P = R(P, { width: N, height: N }), U = 0), this.legendSymbol = W = v.symbol(this.symbol, W / 2 - U, $ - U, 2 * U, 2 * U, P).addClass("highcharts-point").add(u), W.isMarker = !0);
        }, H.drawRectangle = function($, U) {
          var W = $.symbolHeight, N = $.options.squareSymbol;
          U.legendSymbol = this.chart.renderer.rect(N ? ($.symbolWidth - W) / 2 : 0, $.baseline - W + 1, N ? W : $.symbolWidth, W, I($.options.symbolRadius, W / 2)).addClass("highcharts-point").attr({ zIndex: 3 }).add(U.legendGroup);
        };
      }(Z || (Z = {})), Z;
    }), E(a, "Core/Series/SeriesDefaults.js", [], function() {
      return { lineWidth: 2, allowPointSelect: !1, crisp: !0, showCheckbox: !1, animation: { duration: 1e3 }, events: {}, marker: { enabledThreshold: 2, lineColor: "#ffffff", lineWidth: 0, radius: 4, states: {
        normal: { animation: !0 },
        hover: { animation: { duration: 50 }, enabled: !0, radiusPlus: 2, lineWidthPlus: 1 },
        select: { fillColor: "#cccccc", lineColor: "#000000", lineWidth: 2 }
      } }, point: { events: {} }, dataLabels: { animation: {}, align: "center", defer: !0, formatter: function() {
        var y = this.series.chart.numberFormatter;
        return typeof this.y != "number" ? "" : y(this.y, -1);
      }, padding: 5, style: { fontSize: "11px", fontWeight: "bold", color: "contrast", textOutline: "1px contrast" }, verticalAlign: "bottom", x: 0, y: 0 }, cropThreshold: 300, opacity: 1, pointRange: 0, softThreshold: !0, states: {
        normal: { animation: !0 },
        hover: { animation: { duration: 50 }, lineWidthPlus: 1, marker: {}, halo: { size: 10, opacity: 0.25 } },
        select: { animation: { duration: 0 } },
        inactive: { animation: { duration: 50 }, opacity: 0.2 }
      }, stickyTracking: !0, turboThreshold: 1e3, findNearestPointBy: "x" };
    }), E(a, "Core/Series/Series.js", [
      a["Core/Animation/AnimationUtilities.js"],
      a["Core/DefaultOptions.js"],
      a["Core/Foundation.js"],
      a["Core/Globals.js"],
      a["Core/Legend/LegendSymbol.js"],
      a["Core/Series/Point.js"],
      a["Core/Series/SeriesDefaults.js"],
      a["Core/Series/SeriesRegistry.js"],
      a["Core/Renderer/SVG/SVGElement.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I, Z, H, $, U, W, N, M) {
      var v = y.animObject, u = y.setAnimation, d = R.defaultOptions, P = I.registerEventOptions, O = Z.hasTouch, B = Z.svg, C = Z.win, b = W.seriesTypes, w = M.addEvent, x = M.arrayMax, h = M.arrayMin, c = M.clamp, p = M.cleanRecursively, i = M.correctFloat, l = M.defined, s = M.erase, t = M.error, n = M.extend, o = M.find, A = M.fireEvent, _ = M.getNestedProperty, D = M.isArray, j = M.isNumber, T = M.isString, X = M.merge, f = M.objectEach, m = M.pick, L = M.removeEvent, Y = M.splat, F = M.syncTimeout;
      return y = function() {
        function Q() {
          this.zones = this.yAxis = this.xAxis = this.userOptions = this.tooltipOptions = this.processedYData = this.processedXData = this.points = this.options = this.linkedSeries = this.index = this.eventsToUnbind = this.eventOptions = this.data = this.chart = this._i = void 0;
        }
        return Q.prototype.init = function(k, G) {
          A(this, "init", { options: G });
          var z = this, V = k.series;
          this.eventsToUnbind = [], z.chart = k, z.options = z.setOptions(G), G = z.options, z.linkedSeries = [], z.bindAxes(), n(z, { name: G.name, state: "", visible: G.visible !== !1, selected: G.selected === !0 }), P(this, G);
          var q = G.events;
          (q && q.click || G.point && G.point.events && G.point.events.click || G.allowPointSelect) && (k.runTrackerClick = !0), z.getColor(), z.getSymbol(), z.parallelArrays.forEach(function(et) {
            z[et + "Data"] || (z[et + "Data"] = []);
          }), z.isCartesian && (k.hasCartesianSeries = !0);
          var it;
          V.length && (it = V[V.length - 1]), z._i = m(it && it._i, -1) + 1, z.opacity = z.options.opacity, k.orderSeries(this.insert(V)), G.dataSorting && G.dataSorting.enabled ? z.setDataSortingOptions() : z.points || z.data || z.setData(G.data, !1), A(this, "afterInit");
        }, Q.prototype.is = function(k) {
          return b[k] && this instanceof b[k];
        }, Q.prototype.insert = function(k) {
          var G = this.options.index, z;
          if (j(G)) {
            for (z = k.length; z--; )
              if (G >= m(k[z].options.index, k[z]._i)) {
                k.splice(z + 1, 0, this);
                break;
              }
            z === -1 && k.unshift(this), z += 1;
          } else
            k.push(this);
          return m(z, k.length - 1);
        }, Q.prototype.bindAxes = function() {
          var k = this, G = k.options, z = k.chart, V;
          A(this, "bindAxes", null, function() {
            (k.axisTypes || []).forEach(function(q) {
              var it = 0;
              z[q].forEach(function(et) {
                V = et.options, (G[q] === it && !V.isInternal || typeof G[q] < "u" && G[q] === V.id || typeof G[q] > "u" && V.index === 0) && (k.insert(et.series), k[q] = et, et.isDirty = !0), V.isInternal || it++;
              }), k[q] || k.optionalAxis === q || t(18, !0, z);
            });
          }), A(this, "afterBindAxes");
        }, Q.prototype.updateParallelArrays = function(k, G) {
          var z = k.series, V = arguments, q = j(G) ? function(it) {
            var et = it === "y" && z.toYData ? z.toYData(k) : k[it];
            z[it + "Data"][G] = et;
          } : function(it) {
            Array.prototype[G].apply(z[it + "Data"], Array.prototype.slice.call(V, 2));
          };
          z.parallelArrays.forEach(q);
        }, Q.prototype.hasData = function() {
          return this.visible && typeof this.dataMax < "u" && typeof this.dataMin < "u" || this.visible && this.yData && 0 < this.yData.length;
        }, Q.prototype.autoIncrement = function(k) {
          var G = this.options, z = G.pointIntervalUnit, V = G.relativeXValue, q = this.chart.time, it = this.xIncrement, et;
          return it = m(it, G.pointStart, 0), this.pointInterval = et = m(this.pointInterval, G.pointInterval, 1), V && j(k) && (et *= k), z && (G = new q.Date(it), z === "day" ? q.set("Date", G, q.get("Date", G) + et) : z === "month" ? q.set("Month", G, q.get("Month", G) + et) : z === "year" && q.set("FullYear", G, q.get("FullYear", G) + et), et = G.getTime() - it), V && j(k) ? it + et : (this.xIncrement = it + et, it);
        }, Q.prototype.setDataSortingOptions = function() {
          var k = this.options;
          n(this, { requireSorting: !1, sorted: !1, enabledDataSorting: !0, allowDG: !1 }), l(k.pointRange) || (k.pointRange = 1);
        }, Q.prototype.setOptions = function(k) {
          var G = this.chart, z = G.options, V = z.plotOptions, q = G.userOptions || {};
          k = X(k), G = G.styledMode;
          var it = { plotOptions: V, userOptions: k };
          A(this, "setOptions", it);
          var et = it.plotOptions[this.type], nt = q.plotOptions || {};
          return this.userOptions = it.userOptions, q = X(et, V.series, q.plotOptions && q.plotOptions[this.type], k), this.tooltipOptions = X(d.tooltip, d.plotOptions.series && d.plotOptions.series.tooltip, d.plotOptions[this.type].tooltip, z.tooltip.userOptions, V.series && V.series.tooltip, V[this.type].tooltip, k.tooltip), this.stickyTracking = m(k.stickyTracking, nt[this.type] && nt[this.type].stickyTracking, nt.series && nt.series.stickyTracking, this.tooltipOptions.shared && !this.noSharedTooltip ? !0 : q.stickyTracking), et.marker === null && delete q.marker, this.zoneAxis = q.zoneAxis, V = this.zones = (q.zones || []).slice(), !q.negativeColor && !q.negativeFillColor || q.zones || (z = { value: q[this.zoneAxis + "Threshold"] || q.threshold || 0, className: "highcharts-negative" }, G || (z.color = q.negativeColor, z.fillColor = q.negativeFillColor), V.push(z)), V.length && l(V[V.length - 1].value) && V.push(G ? {} : { color: this.color, fillColor: this.fillColor }), A(this, "afterSetOptions", { options: q }), q;
        }, Q.prototype.getName = function() {
          return m(this.options.name, "Series " + (this.index + 1));
        }, Q.prototype.getCyclic = function(k, G, z) {
          var V = this.chart, q = this.userOptions, it = k + "Index", et = k + "Counter", nt = z ? z.length : m(V.options.chart[k + "Count"], V[k + "Count"]);
          if (!G) {
            var rt = m(q[it], q["_" + it]);
            l(rt) || (V.series.length || (V[et] = 0), q["_" + it] = rt = V[et] % nt, V[et] += 1), z && (G = z[rt]);
          }
          typeof rt < "u" && (this[it] = rt), this[k] = G;
        }, Q.prototype.getColor = function() {
          this.chart.styledMode ? this.getCyclic("color") : this.options.colorByPoint ? this.color = "#cccccc" : this.getCyclic("color", this.options.color || d.plotOptions[this.type].color, this.chart.options.colors);
        }, Q.prototype.getPointsCollection = function() {
          return (this.hasGroupedData ? this.points : this.data) || [];
        }, Q.prototype.getSymbol = function() {
          this.getCyclic("symbol", this.options.marker.symbol, this.chart.options.symbols);
        }, Q.prototype.findPointIndex = function(k, G) {
          var z = k.id, V = k.x, q = this.points, it = this.options.dataSorting, et, nt;
          if (z)
            it = this.chart.get(z), it instanceof $ && (et = it);
          else if ((this.linkedParent || this.enabledDataSorting || this.options.relativeXValue) && (et = function(ct) {
            return !ct.touched && ct.index === k.index;
          }, it && it.matchByName ? et = function(ct) {
            return !ct.touched && ct.name === k.name;
          } : this.options.relativeXValue && (et = function(ct) {
            return !ct.touched && ct.options.x === k.x;
          }), et = o(q, et), !et))
            return;
          if (et) {
            var rt = et && et.index;
            typeof rt < "u" && (nt = !0);
          }
          return typeof rt > "u" && j(V) && (rt = this.xData.indexOf(V, G)), rt !== -1 && typeof rt < "u" && this.cropped && (rt = rt >= this.cropStart ? rt - this.cropStart : rt), !nt && j(rt) && q[rt] && q[rt].touched && (rt = void 0), rt;
        }, Q.prototype.updateData = function(k, G) {
          var z = this.options, V = z.dataSorting, q = this.points, it = [], et = this.requireSorting, nt = k.length === q.length, rt, ct, gt, dt = !0;
          if (this.xIncrement = null, k.forEach(function(lt, at) {
            var J = l(lt) && this.pointClass.prototype.optionsToObject.call({ series: this }, lt) || {}, tt = J.x;
            J.id || j(tt) ? (J = this.findPointIndex(J, gt), J === -1 || typeof J > "u" ? it.push(lt) : q[J] && lt !== z.data[J] ? (q[J].update(lt, !1, null, !1), q[J].touched = !0, et && (gt = J + 1)) : q[J] && (q[J].touched = !0), (!nt || at !== J || V && V.enabled || this.hasDerivedData) && (rt = !0)) : it.push(lt);
          }, this), rt)
            for (k = q.length; k--; )
              (ct = q[k]) && !ct.touched && ct.remove && ct.remove(!1, G);
          else
            !nt || V && V.enabled ? dt = !1 : (k.forEach(function(lt, at) {
              lt !== q[at].y && q[at].update && q[at].update(
                lt,
                !1,
                null,
                !1
              );
            }), it.length = 0);
          return q.forEach(function(lt) {
            lt && (lt.touched = !1);
          }), dt ? (it.forEach(function(lt) {
            this.addPoint(lt, !1, null, null, !1);
          }, this), this.xIncrement === null && this.xData && this.xData.length && (this.xIncrement = x(this.xData), this.autoIncrement()), !0) : !1;
        }, Q.prototype.setData = function(k, G, z, V) {
          var q = this, it = q.points, et = it && it.length || 0, nt = q.options, rt = q.chart, ct = nt.dataSorting, gt = q.xAxis, dt = nt.turboThreshold, lt = this.xData, at = this.yData, J = q.pointArrayMap;
          J = J && J.length;
          var tt = nt.keys, st, ht = 0, pt = 1, yt = null;
          k = k || [];
          var vt = k.length;
          if (G = m(G, !0), ct && ct.enabled && (k = this.sortData(k)), V !== !1 && vt && et && !q.cropped && !q.hasGroupedData && q.visible && !q.isSeriesBoosting && (st = this.updateData(k, z)), !st) {
            if (q.xIncrement = null, q.colorCounter = 0, this.parallelArrays.forEach(function(Ct) {
              q[Ct + "Data"].length = 0;
            }), dt && vt > dt)
              if (yt = q.getFirstValidPoint(k), j(yt))
                for (z = 0; z < vt; z++)
                  lt[z] = this.autoIncrement(), at[z] = k[z];
              else if (D(yt))
                if (J)
                  if (yt.length === J)
                    for (z = 0; z < vt; z++)
                      lt[z] = this.autoIncrement(), at[z] = k[z];
                  else
                    for (z = 0; z < vt; z++)
                      V = k[z], lt[z] = V[0], at[z] = V.slice(
                        1,
                        J + 1
                      );
                else if (tt && (ht = tt.indexOf("x"), pt = tt.indexOf("y"), ht = 0 <= ht ? ht : 0, pt = 0 <= pt ? pt : 1), yt.length === 1 && (pt = 0), ht === pt)
                  for (z = 0; z < vt; z++)
                    lt[z] = this.autoIncrement(), at[z] = k[z][pt];
                else
                  for (z = 0; z < vt; z++)
                    V = k[z], lt[z] = V[ht], at[z] = V[pt];
              else
                t(12, !1, rt);
            else
              for (z = 0; z < vt; z++)
                typeof k[z] < "u" && (V = { series: q }, q.pointClass.prototype.applyOptions.apply(V, [k[z]]), q.updateParallelArrays(V, z));
            for (at && T(at[0]) && t(14, !0, rt), q.data = [], q.options.data = q.userOptions.data = k, z = et; z--; )
              it[z] && it[z].destroy && it[z].destroy();
            gt && (gt.minRange = gt.userMinRange), q.isDirty = rt.isDirtyBox = !0, q.isDirtyData = !!it, z = !1;
          }
          nt.legendType === "point" && (this.processData(), this.generatePoints()), G && rt.redraw(z);
        }, Q.prototype.sortData = function(k) {
          var G = this, z = G.options.dataSorting.sortKey || "y", V = function(q, it) {
            return l(it) && q.pointClass.prototype.optionsToObject.call({ series: q }, it) || {};
          };
          return k.forEach(function(q, it) {
            k[it] = V(G, q), k[it].index = it;
          }, this), k.concat().sort(function(q, it) {
            return q = _(z, q), it = _(z, it), it < q ? -1 : it > q ? 1 : 0;
          }).forEach(function(q, it) {
            q.x = it;
          }, this), G.linkedSeries && G.linkedSeries.forEach(function(q) {
            var it = q.options, et = it.data;
            it.dataSorting && it.dataSorting.enabled || !et || (et.forEach(function(nt, rt) {
              et[rt] = V(q, nt), k[rt] && (et[rt].x = k[rt].x, et[rt].index = rt);
            }), q.setData(et, !1));
          }), k;
        }, Q.prototype.getProcessedData = function(k) {
          var G = this.xAxis, z = this.options, V = z.cropThreshold, q = k || this.getExtremesFromAll || z.getExtremesFromAll, it = this.isCartesian;
          k = G && G.val2lin, z = !(!G || !G.logarithmic);
          var et = 0, nt = this.xData, rt = this.yData, ct = this.requireSorting, gt = !1, dt = nt.length;
          if (G) {
            gt = G.getExtremes();
            var lt = gt.min, at = gt.max;
            gt = G.categories && !G.names.length;
          }
          if (it && this.sorted && !q && (!V || dt > V || this.forceCrop)) {
            if (nt[dt - 1] < lt || nt[0] > at)
              nt = [], rt = [];
            else if (this.yData && (nt[0] < lt || nt[dt - 1] > at)) {
              var J = this.cropData(this.xData, this.yData, lt, at);
              nt = J.xData, rt = J.yData, et = J.start, J = !0;
            }
          }
          for (V = nt.length || 1; --V; )
            if (G = z ? k(nt[V]) - k(nt[V - 1]) : nt[V] - nt[V - 1], 0 < G && (typeof tt > "u" || G < tt))
              var tt = G;
            else
              0 > G && ct && !gt && (t(15, !1, this.chart), ct = !1);
          return { xData: nt, yData: rt, cropped: J, cropStart: et, closestPointRange: tt };
        }, Q.prototype.processData = function(k) {
          var G = this.xAxis;
          if (this.isCartesian && !this.isDirty && !G.isDirty && !this.yAxis.isDirty && !k)
            return !1;
          k = this.getProcessedData(), this.cropped = k.cropped, this.cropStart = k.cropStart, this.processedXData = k.xData, this.processedYData = k.yData, this.closestPointRange = this.basePointRange = k.closestPointRange, A(this, "afterProcessData");
        }, Q.prototype.cropData = function(k, G, z, V, q) {
          var it = k.length, et, nt = 0, rt = it;
          for (q = m(q, this.cropShoulder), et = 0; et < it; et++)
            if (k[et] >= z) {
              nt = Math.max(0, et - q);
              break;
            }
          for (z = et; z < it; z++)
            if (k[z] > V) {
              rt = z + q;
              break;
            }
          return { xData: k.slice(nt, rt), yData: G.slice(
            nt,
            rt
          ), start: nt, end: rt };
        }, Q.prototype.generatePoints = function() {
          var k = this.options, G = k.data, z = this.processedXData, V = this.processedYData, q = this.pointClass, it = z.length, et = this.cropStart || 0, nt = this.hasGroupedData, rt = k.keys, ct = [];
          k = k.dataGrouping && k.dataGrouping.groupAll ? et : 0;
          var gt, dt, lt = this.data;
          if (!lt && !nt) {
            var at = [];
            at.length = G.length, lt = this.data = at;
          }
          for (rt && nt && (this.options.keys = !1), dt = 0; dt < it; dt++) {
            if (at = et + dt, nt) {
              var J = new q().init(this, [z[dt]].concat(Y(V[dt])));
              J.dataGroup = this.groupMap[k + dt], J.dataGroup.options && (J.options = J.dataGroup.options, n(J, J.dataGroup.options), delete J.dataLabels);
            } else
              (J = lt[at]) || typeof G[at] > "u" || (lt[at] = J = new q().init(this, G[at], z[dt]));
            J && (J.index = nt ? k + dt : at, ct[dt] = J);
          }
          if (this.options.keys = rt, lt && (it !== (gt = lt.length) || nt))
            for (dt = 0; dt < gt; dt++)
              dt !== et || nt || (dt += it), lt[dt] && (lt[dt].destroyElements(), lt[dt].plotX = void 0);
          this.data = lt, this.points = ct, A(this, "afterGeneratePoints");
        }, Q.prototype.getXExtremes = function(k) {
          return { min: h(k), max: x(k) };
        }, Q.prototype.getExtremes = function(k, G) {
          var z = this.xAxis, V = this.yAxis, q = this.processedXData || this.xData, it = [], et = this.requireSorting ? this.cropShoulder : 0;
          V = V ? V.positiveValuesOnly : !1;
          var nt, rt = 0, ct = 0, gt = 0;
          k = k || this.stackedYData || this.processedYData || [];
          var dt = k.length;
          if (z) {
            var lt = z.getExtremes();
            rt = lt.min, ct = lt.max;
          }
          for (nt = 0; nt < dt; nt++) {
            var at = q[nt];
            lt = k[nt];
            var J = (j(lt) || D(lt)) && (lt.length || 0 < lt || !V);
            if (at = G || this.getExtremesFromAll || this.options.getExtremesFromAll || this.cropped || !z || (q[nt + et] || at) >= rt && (q[nt - et] || at) <= ct, J && at)
              if (J = lt.length)
                for (; J--; )
                  j(lt[J]) && (it[gt++] = lt[J]);
              else
                it[gt++] = lt;
          }
          return k = { activeYData: it, dataMin: h(it), dataMax: x(it) }, A(this, "afterGetExtremes", { dataExtremes: k }), k;
        }, Q.prototype.applyExtremes = function() {
          var k = this.getExtremes();
          return this.dataMin = k.dataMin, this.dataMax = k.dataMax, k;
        }, Q.prototype.getFirstValidPoint = function(k) {
          for (var G = k.length, z = 0, V = null; V === null && z < G; )
            V = k[z], z++;
          return V;
        }, Q.prototype.translate = function() {
          this.processedXData || this.processData(), this.generatePoints();
          var k = this.options, G = k.stacking, z = this.xAxis, V = z.categories, q = this.enabledDataSorting, it = this.yAxis, et = this.points, nt = et.length, rt = this.pointPlacementToXValue(), ct = !!rt, gt = k.threshold, dt = k.startFromThreshold ? gt : 0, lt = this.zoneAxis || "y", at, J, tt = Number.MAX_VALUE;
          for (at = 0; at < nt; at++) {
            var st = et[at], ht = st.x, pt = void 0, yt = void 0, vt = st.y, Ct = st.low, Tt = G && it.stacking && it.stacking.stacks[(this.negStacks && vt < (dt ? 0 : gt) ? "-" : "") + this.stackKey];
            if ((it.positiveValuesOnly && !it.validatePositiveValue(vt) || z.positiveValuesOnly && !z.validatePositiveValue(ht)) && (st.isNull = !0), st.plotX = J = i(c(z.translate(ht, 0, 0, 0, 1, rt, this.type === "flags"), -1e5, 1e5)), G && this.visible && Tt && Tt[ht]) {
              var kt = this.getStackIndicator(
                kt,
                ht,
                this.index
              );
              st.isNull || (pt = Tt[ht], yt = pt.points[kt.key]);
            }
            if (D(yt) && (Ct = yt[0], vt = yt[1], Ct === dt && kt.key === Tt[ht].base && (Ct = m(j(gt) && gt, it.min)), it.positiveValuesOnly && 0 >= Ct && (Ct = null), st.total = st.stackTotal = pt.total, st.percentage = pt.total && st.y / pt.total * 100, st.stackY = vt, this.irregularWidths || pt.setOffset(this.pointXOffset || 0, this.barW || 0)), st.yBottom = l(Ct) ? c(it.translate(Ct, 0, 1, 0, 1), -1e5, 1e5) : null, this.dataModify && (vt = this.dataModify.modifyValue(vt, at)), st.plotY = void 0, j(vt) && (pt = it.translate(vt, !1, !0, !1, !0), typeof pt < "u" && (st.plotY = c(
              pt,
              -1e5,
              1e5
            ))), st.isInside = this.isPointInside(st), st.clientX = ct ? i(z.translate(ht, 0, 0, 0, 1, rt)) : J, st.negative = st[lt] < (k[lt + "Threshold"] || gt || 0), st.category = V && typeof V[st.x] < "u" ? V[st.x] : st.x, !st.isNull && st.visible !== !1) {
              typeof St < "u" && (tt = Math.min(tt, Math.abs(J - St)));
              var St = J;
            }
            st.zone = this.zones.length ? st.getZone() : void 0, !st.graphic && this.group && q && (st.isNew = !0);
          }
          this.closestPointRangePx = tt, A(this, "afterTranslate");
        }, Q.prototype.getValidPoints = function(k, G, z) {
          var V = this.chart;
          return (k || this.points || []).filter(function(q) {
            return G && !V.isInsidePlot(q.plotX, q.plotY, { inverted: V.inverted }) ? !1 : q.visible !== !1 && (z || !q.isNull);
          });
        }, Q.prototype.getClipBox = function() {
          var k = this.chart, G = this.xAxis, z = this.yAxis, V = X(k.clipBox);
          return G && G.len !== k.plotSizeX && (V.width = G.len), z && z.len !== k.plotSizeY && (V.height = z.len), V;
        }, Q.prototype.getSharedClipKey = function() {
          return this.sharedClipKey = (this.options.xAxis || 0) + "," + (this.options.yAxis || 0);
        }, Q.prototype.setClip = function() {
          var k = this.chart, G = this.group, z = this.markerGroup, V = k.sharedClips;
          k = k.renderer;
          var q = this.getClipBox(), it = this.getSharedClipKey(), et = V[it];
          et ? et.animate(q) : V[it] = et = k.clipRect(q), G && G.clip(this.options.clip === !1 ? void 0 : et), z && z.clip();
        }, Q.prototype.animate = function(k) {
          var G = this.chart, z = this.group, V = this.markerGroup, q = G.inverted, it = v(this.options.animation), et = [this.getSharedClipKey(), it.duration, it.easing, it.defer].join(), nt = G.sharedClips[et], rt = G.sharedClips[et + "m"];
          if (k && z)
            it = this.getClipBox(), nt ? nt.attr("height", it.height) : (it.width = 0, q && (it.x = G.plotHeight), nt = G.renderer.clipRect(it), G.sharedClips[et] = nt, rt = G.renderer.clipRect({ x: q ? (G.plotSizeX || 0) + 99 : -99, y: q ? -G.plotLeft : -G.plotTop, width: 99, height: q ? G.chartWidth : G.chartHeight }), G.sharedClips[et + "m"] = rt), z.clip(nt), V && V.clip(rt);
          else if (nt && !nt.hasClass("highcharts-animating")) {
            G = this.getClipBox();
            var ct = it.step;
            V && V.element.childNodes.length && (it.step = function(gt, dt) {
              ct && ct.apply(dt, arguments), rt && rt.element && rt.attr(dt.prop, dt.prop === "width" ? gt + 99 : gt);
            }), nt.addClass("highcharts-animating").animate(G, it);
          }
        }, Q.prototype.afterAnimate = function() {
          var k = this;
          this.setClip(), f(
            this.chart.sharedClips,
            function(G, z, V) {
              G && !k.chart.container.querySelector('[clip-path="url(#' + G.id + ')"]') && (G.destroy(), delete V[z]);
            }
          ), this.finishedAnimating = !0, A(this, "afterAnimate");
        }, Q.prototype.drawPoints = function() {
          var k = this.points, G = this.chart, z = this.options.marker, V = this[this.specialGroup] || this.markerGroup, q = this.xAxis, it = m(z.enabled, !q || q.isRadial ? !0 : null, this.closestPointRangePx >= z.enabledThreshold * z.radius), et, nt;
          if (z.enabled !== !1 || this._hasPointMarkers)
            for (et = 0; et < k.length; et++) {
              var rt = k[et], ct = (nt = rt.graphic) ? "animate" : "attr", gt = rt.marker || {}, dt = !!rt.marker;
              if ((it && typeof gt.enabled > "u" || gt.enabled) && !rt.isNull && rt.visible !== !1) {
                var lt = m(gt.symbol, this.symbol, "rect"), at = this.markerAttribs(rt, rt.selected && "select");
                this.enabledDataSorting && (rt.startXPos = q.reversed ? -(at.width || 0) : q.width);
                var J = rt.isInside !== !1;
                nt ? nt[J ? "show" : "hide"](J).animate(at) : J && (0 < (at.width || 0) || rt.hasImage) && (rt.graphic = nt = G.renderer.symbol(lt, at.x, at.y, at.width, at.height, dt ? gt : z).add(V), this.enabledDataSorting && G.hasRendered && (nt.attr({ x: rt.startXPos }), ct = "animate")), nt && ct === "animate" && nt[J ? "show" : "hide"](J).animate(at), nt && !G.styledMode && nt[ct](this.pointAttribs(rt, rt.selected && "select")), nt && nt.addClass(rt.getClassName(), !0);
              } else
                nt && (rt.graphic = nt.destroy());
            }
        }, Q.prototype.markerAttribs = function(k, G) {
          var z = this.options, V = z.marker, q = k.marker || {}, it = q.symbol || V.symbol, et = m(q.radius, V.radius);
          return G && (V = V.states[G], G = q.states && q.states[G], et = m(G && G.radius, V && V.radius, et + (V && V.radiusPlus || 0))), k.hasImage = it && it.indexOf("url") === 0, k.hasImage && (et = 0), k = { x: z.crisp ? Math.floor(k.plotX - et) : k.plotX - et, y: k.plotY - et }, et && (k.width = k.height = 2 * et), k;
        }, Q.prototype.pointAttribs = function(k, G) {
          var z = this.options.marker, V = k && k.options, q = V && V.marker || {}, it = V && V.color, et = k && k.color, nt = k && k.zone && k.zone.color, rt = this.color;
          return k = m(q.lineWidth, z.lineWidth), V = 1, rt = it || nt || et || rt, it = q.fillColor || z.fillColor || rt, et = q.lineColor || z.lineColor || rt, G = G || "normal", z = z.states[G] || {}, G = q.states && q.states[G] || {}, k = m(G.lineWidth, z.lineWidth, k + m(G.lineWidthPlus, z.lineWidthPlus, 0)), it = G.fillColor || z.fillColor || it, et = G.lineColor || z.lineColor || et, V = m(G.opacity, z.opacity, V), { stroke: et, "stroke-width": k, fill: it, opacity: V };
        }, Q.prototype.destroy = function(k) {
          var G = this, z = G.chart, V = /AppleWebKit\/533/.test(C.navigator.userAgent), q = G.data || [], it, et, nt, rt;
          for (A(G, "destroy"), this.removeEvents(k), (G.axisTypes || []).forEach(function(ct) {
            (rt = G[ct]) && rt.series && (s(rt.series, G), rt.isDirty = rt.forceRedraw = !0);
          }), G.legendItem && G.chart.legend.destroyItem(G), et = q.length; et--; )
            (nt = q[et]) && nt.destroy && nt.destroy();
          G.clips && G.clips.forEach(function(ct) {
            return ct.destroy();
          }), M.clearTimeout(G.animationTimeout), f(G, function(ct, gt) {
            ct instanceof N && !ct.survive && (it = V && gt === "group" ? "hide" : "destroy", ct[it]());
          }), z.hoverSeries === G && (z.hoverSeries = void 0), s(z.series, G), z.orderSeries(), f(G, function(ct, gt) {
            k && gt === "hcEvents" || delete G[gt];
          });
        }, Q.prototype.applyZones = function() {
          var k = this, G = this.chart, z = G.renderer, V = this.zones, q = this.clips || [], it = this.graph, et = this.area, nt = Math.max(G.chartWidth, G.chartHeight), rt = this[(this.zoneAxis || "y") + "Axis"], ct = G.inverted, gt, dt, lt, at, J, tt, st, ht, pt = !1;
          if (V.length && (it || et) && rt && typeof rt.min < "u") {
            var yt = rt.reversed, vt = rt.horiz;
            it && !this.showLine && it.hide(), et && et.hide();
            var Ct = rt.getExtremes();
            V.forEach(function(Tt, kt) {
              gt = yt ? vt ? G.plotWidth : 0 : vt ? 0 : rt.toPixels(Ct.min) || 0, gt = c(m(dt, gt), 0, nt), dt = c(Math.round(rt.toPixels(m(Tt.value, Ct.max), !0) || 0), 0, nt), pt && (gt = dt = rt.toPixels(Ct.max)), at = Math.abs(gt - dt), J = Math.min(gt, dt), tt = Math.max(gt, dt), rt.isXAxis ? (lt = { x: ct ? tt : J, y: 0, width: at, height: nt }, vt || (lt.x = G.plotHeight - lt.x)) : (lt = { x: 0, y: ct ? tt : J, width: nt, height: at }, vt && (lt.y = G.plotWidth - lt.y)), ct && z.isVML && (lt = rt.isXAxis ? {
                x: 0,
                y: yt ? J : tt,
                height: lt.width,
                width: G.chartWidth
              } : { x: lt.y - G.plotLeft - G.spacingBox.x, y: 0, width: lt.height, height: G.chartHeight }), q[kt] ? q[kt].animate(lt) : q[kt] = z.clipRect(lt), st = k["zone-area-" + kt], ht = k["zone-graph-" + kt], it && ht && ht.clip(q[kt]), et && st && st.clip(q[kt]), pt = Tt.value > Ct.max, k.resetZones && dt === 0 && (dt = void 0);
            }), this.clips = q;
          } else
            k.visible && (it && it.show(!0), et && et.show(!0));
        }, Q.prototype.invertGroups = function(k) {
          function G() {
            ["group", "markerGroup"].forEach(function(q) {
              z[q] && (V.renderer.isVML && z[q].attr({ width: z.yAxis.len, height: z.xAxis.len }), z[q].width = z.yAxis.len, z[q].height = z.xAxis.len, z[q].invert(z.isRadialSeries ? !1 : k));
            });
          }
          var z = this, V = z.chart;
          z.xAxis && (z.eventsToUnbind.push(w(V, "resize", G)), G(), z.invertGroups = G);
        }, Q.prototype.plotGroup = function(k, G, z, V, q) {
          var it = this[k], et = !it;
          return z = { visibility: z, zIndex: V || 0.1 }, typeof this.opacity > "u" || this.chart.styledMode || this.state === "inactive" || (z.opacity = this.opacity), et && (this[k] = it = this.chart.renderer.g().add(q)), it.addClass("highcharts-" + G + " highcharts-series-" + this.index + " highcharts-" + this.type + "-series " + (l(this.colorIndex) ? "highcharts-color-" + this.colorIndex + " " : "") + (this.options.className || "") + (it.hasClass("highcharts-tracker") ? " highcharts-tracker" : ""), !0), it.attr(z)[et ? "attr" : "animate"](this.getPlotBox()), it;
        }, Q.prototype.getPlotBox = function() {
          var k = this.chart, G = this.xAxis, z = this.yAxis;
          return k.inverted && (G = z, z = this.xAxis), { translateX: G ? G.left : k.plotLeft, translateY: z ? z.top : k.plotTop, scaleX: 1, scaleY: 1 };
        }, Q.prototype.removeEvents = function(k) {
          k || L(this), this.eventsToUnbind.length && (this.eventsToUnbind.forEach(function(G) {
            G();
          }), this.eventsToUnbind.length = 0);
        }, Q.prototype.render = function() {
          var k = this, G = k.chart, z = k.options, V = v(z.animation), q = k.visible ? "inherit" : "hidden", it = z.zIndex, et = k.hasRendered, nt = G.seriesGroup, rt = G.inverted;
          G = !k.finishedAnimating && G.renderer.isSVG ? V.duration : 0, A(this, "render");
          var ct = k.plotGroup("group", "series", q, it, nt);
          k.markerGroup = k.plotGroup("markerGroup", "markers", q, it, nt), z.clip !== !1 && k.setClip(), k.animate && G && k.animate(!0), ct.inverted = m(k.invertible, k.isCartesian) ? rt : !1, k.drawGraph && (k.drawGraph(), k.applyZones()), k.visible && k.drawPoints(), k.drawDataLabels && k.drawDataLabels(), k.redrawPoints && k.redrawPoints(), k.drawTracker && k.options.enableMouseTracking !== !1 && k.drawTracker(), k.invertGroups(rt), k.animate && G && k.animate(), et || (G && V.defer && (G += V.defer), k.animationTimeout = F(function() {
            k.afterAnimate();
          }, G || 0)), k.isDirty = !1, k.hasRendered = !0, A(k, "afterRender");
        }, Q.prototype.redraw = function() {
          var k = this.chart, G = this.isDirty || this.isDirtyData, z = this.group, V = this.xAxis, q = this.yAxis;
          z && (k.inverted && z.attr({
            width: k.plotWidth,
            height: k.plotHeight
          }), z.animate({ translateX: m(V && V.left, k.plotLeft), translateY: m(q && q.top, k.plotTop) })), this.translate(), this.render(), G && delete this.kdTree;
        }, Q.prototype.searchPoint = function(k, G) {
          var z = this.xAxis, V = this.yAxis, q = this.chart.inverted;
          return this.searchKDTree({ clientX: q ? z.len - k.chartY + z.pos : k.chartX - z.pos, plotY: q ? V.len - k.chartX + V.pos : k.chartY - V.pos }, G, k);
        }, Q.prototype.buildKDTree = function(k) {
          function G(q, it, et) {
            var nt = q && q.length;
            if (nt) {
              var rt = z.kdAxisArray[it % et];
              return q.sort(function(ct, gt) {
                return ct[rt] - gt[rt];
              }), nt = Math.floor(nt / 2), { point: q[nt], left: G(q.slice(0, nt), it + 1, et), right: G(q.slice(nt + 1), it + 1, et) };
            }
          }
          this.buildingKdTree = !0;
          var z = this, V = -1 < z.options.findNearestPointBy.indexOf("y") ? 2 : 1;
          delete z.kdTree, F(function() {
            z.kdTree = G(z.getValidPoints(null, !z.directTouch), V, V), z.buildingKdTree = !1;
          }, z.options.kdNow || k && k.type === "touchstart" ? 0 : 1);
        }, Q.prototype.searchKDTree = function(k, G, z) {
          function V(rt, ct, gt, dt) {
            var lt = ct.point, at = q.kdAxisArray[gt % dt], J = lt, tt = l(rt[it]) && l(lt[it]) ? Math.pow(rt[it] - lt[it], 2) : null, st = l(rt[et]) && l(lt[et]) ? Math.pow(rt[et] - lt[et], 2) : null;
            return st = (tt || 0) + (st || 0), lt.dist = l(st) ? Math.sqrt(st) : Number.MAX_VALUE, lt.distX = l(tt) ? Math.sqrt(tt) : Number.MAX_VALUE, at = rt[at] - lt[at], st = 0 > at ? "left" : "right", tt = 0 > at ? "right" : "left", ct[st] && (st = V(rt, ct[st], gt + 1, dt), J = st[nt] < J[nt] ? st : lt), ct[tt] && Math.sqrt(at * at) < J[nt] && (rt = V(rt, ct[tt], gt + 1, dt), J = rt[nt] < J[nt] ? rt : J), J;
          }
          var q = this, it = this.kdAxisArray[0], et = this.kdAxisArray[1], nt = G ? "distX" : "dist";
          if (G = -1 < q.options.findNearestPointBy.indexOf("y") ? 2 : 1, this.kdTree || this.buildingKdTree || this.buildKDTree(z), this.kdTree)
            return V(
              k,
              this.kdTree,
              G,
              G
            );
        }, Q.prototype.pointPlacementToXValue = function() {
          var k = this.options, G = k.pointRange, z = this.xAxis;
          return k = k.pointPlacement, k === "between" && (k = z.reversed ? -0.5 : 0.5), j(k) ? k * (G || z.pointRange) : 0;
        }, Q.prototype.isPointInside = function(k) {
          var G = this.chart, z = this.xAxis, V = this.yAxis;
          return typeof k.plotY < "u" && typeof k.plotX < "u" && 0 <= k.plotY && k.plotY <= (V ? V.len : G.plotHeight) && 0 <= k.plotX && k.plotX <= (z ? z.len : G.plotWidth);
        }, Q.prototype.drawTracker = function() {
          var k = this, G = k.options, z = G.trackByArea, V = [].concat(z ? k.areaPath : k.graphPath), q = k.chart, it = q.pointer, et = q.renderer, nt = q.options.tooltip.snap, rt = k.tracker, ct = function(dt) {
            q.hoverSeries !== k && k.onMouseOver();
          }, gt = "rgba(192,192,192," + (B ? 1e-4 : 2e-3) + ")";
          rt ? rt.attr({ d: V }) : k.graph && (k.tracker = et.path(V).attr({ visibility: k.visible ? "visible" : "hidden", zIndex: 2 }).addClass(z ? "highcharts-tracker-area" : "highcharts-tracker-line").add(k.group), q.styledMode || k.tracker.attr({ "stroke-linecap": "round", "stroke-linejoin": "round", stroke: gt, fill: z ? gt : "none", "stroke-width": k.graph.strokeWidth() + (z ? 0 : 2 * nt) }), [k.tracker, k.markerGroup, k.dataLabelsGroup].forEach(function(dt) {
            dt && (dt.addClass("highcharts-tracker").on("mouseover", ct).on("mouseout", function(lt) {
              it.onTrackerMouseOut(lt);
            }), G.cursor && !q.styledMode && dt.css({ cursor: G.cursor }), O) && dt.on("touchstart", ct);
          })), A(this, "afterDrawTracker");
        }, Q.prototype.addPoint = function(k, G, z, V, q) {
          var it = this.options, et = this.data, nt = this.chart, rt = this.xAxis;
          rt = rt && rt.hasNames && rt.names;
          var ct = it.data, gt = this.xData, dt;
          G = m(G, !0);
          var lt = { series: this };
          this.pointClass.prototype.applyOptions.apply(
            lt,
            [k]
          );
          var at = lt.x, J = gt.length;
          if (this.requireSorting && at < gt[J - 1])
            for (dt = !0; J && gt[J - 1] > at; )
              J--;
          this.updateParallelArrays(lt, "splice", J, 0, 0), this.updateParallelArrays(lt, J), rt && lt.name && (rt[at] = lt.name), ct.splice(J, 0, k), dt && (this.data.splice(J, 0, null), this.processData()), it.legendType === "point" && this.generatePoints(), z && (et[0] && et[0].remove ? et[0].remove(!1) : (et.shift(), this.updateParallelArrays(lt, "shift"), ct.shift())), q !== !1 && A(this, "addPoint", { point: lt }), this.isDirtyData = this.isDirty = !0, G && nt.redraw(V);
        }, Q.prototype.removePoint = function(k, G, z) {
          var V = this, q = V.data, it = q[k], et = V.points, nt = V.chart, rt = function() {
            et && et.length === q.length && et.splice(k, 1), q.splice(k, 1), V.options.data.splice(k, 1), V.updateParallelArrays(it || { series: V }, "splice", k, 1), it && it.destroy(), V.isDirty = !0, V.isDirtyData = !0, G && nt.redraw();
          };
          u(z, nt), G = m(G, !0), it ? it.firePointEvent("remove", null, rt) : rt();
        }, Q.prototype.remove = function(k, G, z, V) {
          function q() {
            it.destroy(V), et.isDirtyLegend = et.isDirtyBox = !0, et.linkSeries(), m(k, !0) && et.redraw(G);
          }
          var it = this, et = it.chart;
          z !== !1 ? A(
            it,
            "remove",
            null,
            q
          ) : q();
        }, Q.prototype.update = function(k, G) {
          k = p(k, this.userOptions), A(this, "update", { options: k });
          var z = this, V = z.chart, q = z.userOptions, it = z.initialType || z.type, et = V.options.plotOptions, nt = b[it].prototype, rt = z.finishedAnimating && { animation: !1 }, ct = {}, gt, dt = ["eventOptions", "navigatorSeries", "baseSeries"], lt = k.type || q.type || V.options.chart.type, at = !(this.hasDerivedData || lt && lt !== this.type || typeof k.pointStart < "u" || typeof k.pointInterval < "u" || typeof k.relativeXValue < "u" || z.hasOptionChanged("dataGrouping") || z.hasOptionChanged("pointStart") || z.hasOptionChanged("pointInterval") || z.hasOptionChanged("pointIntervalUnit") || z.hasOptionChanged("keys"));
          if (lt = lt || it, at && (dt.push("data", "isDirtyData", "points", "processedXData", "processedYData", "xIncrement", "cropped", "_hasPointMarkers", "_hasPointLabels", "clips", "nodes", "layout", "mapMap", "mapData", "minY", "maxY", "minX", "maxX"), k.visible !== !1 && dt.push("area", "graph"), z.parallelArrays.forEach(function(tt) {
            dt.push(tt + "Data");
          }), k.data && (k.dataSorting && n(z.options.dataSorting, k.dataSorting), this.setData(k.data, !1))), k = X(q, rt, { index: typeof q.index > "u" ? z.index : q.index, pointStart: m(et && et.series && et.series.pointStart, q.pointStart, z.xData[0]) }, !at && { data: z.options.data }, k), at && k.data && (k.data = z.options.data), dt = ["group", "markerGroup", "dataLabelsGroup", "transformGroup"].concat(dt), dt.forEach(function(tt) {
            dt[tt] = z[tt], delete z[tt];
          }), et = !1, b[lt]) {
            if (et = lt !== z.type, z.remove(!1, !1, !1, !0), et)
              if (Object.setPrototypeOf)
                Object.setPrototypeOf(z, b[lt].prototype);
              else {
                rt = Object.hasOwnProperty.call(z, "hcEvents") && z.hcEvents;
                for (gt in nt)
                  z[gt] = void 0;
                n(z, b[lt].prototype), rt ? z.hcEvents = rt : delete z.hcEvents;
              }
          } else
            t(17, !0, V, { missingModuleFor: lt });
          if (dt.forEach(function(tt) {
            z[tt] = dt[tt];
          }), z.init(V, k), at && this.points) {
            var J = z.options;
            J.visible === !1 ? (ct.graphic = 1, ct.dataLabel = 1) : z._hasPointLabels || (k = J.marker, nt = J.dataLabels, !k || k.enabled !== !1 && (q.marker && q.marker.symbol) === k.symbol || (ct.graphic = 1), nt && nt.enabled === !1 && (ct.dataLabel = 1)), this.points.forEach(function(tt) {
              tt && tt.series && (tt.resolveColor(), Object.keys(ct).length && tt.destroyElements(ct), J.showInLegend === !1 && tt.legendItem && V.legend.destroyItem(tt));
            }, this);
          }
          z.initialType = it, V.linkSeries(), et && z.linkedSeries.length && (z.isDirtyData = !0), A(this, "afterUpdate"), m(G, !0) && V.redraw(at ? void 0 : !1);
        }, Q.prototype.setName = function(k) {
          this.name = this.options.name = this.userOptions.name = k, this.chart.isDirtyLegend = !0;
        }, Q.prototype.hasOptionChanged = function(k) {
          var G = this.options[k], z = this.chart.options.plotOptions, V = this.userOptions[k];
          return V ? G !== V : G !== m(
            z && z[this.type] && z[this.type][k],
            z && z.series && z.series[k],
            G
          );
        }, Q.prototype.onMouseOver = function() {
          var k = this.chart, G = k.hoverSeries;
          k.pointer.setHoverChartIndex(), G && G !== this && G.onMouseOut(), this.options.events.mouseOver && A(this, "mouseOver"), this.setState("hover"), k.hoverSeries = this;
        }, Q.prototype.onMouseOut = function() {
          var k = this.options, G = this.chart, z = G.tooltip, V = G.hoverPoint;
          G.hoverSeries = null, V && V.onMouseOut(), this && k.events.mouseOut && A(this, "mouseOut"), !z || this.stickyTracking || z.shared && !this.noSharedTooltip || z.hide(), G.series.forEach(function(q) {
            q.setState(
              "",
              !0
            );
          });
        }, Q.prototype.setState = function(k, G) {
          var z = this, V = z.options, q = z.graph, it = V.inactiveOtherPoints, et = V.states, nt = m(et[k || "normal"] && et[k || "normal"].animation, z.chart.options.chart.animation), rt = V.lineWidth, ct = 0, gt = V.opacity;
          if (k = k || "", z.state !== k && ([z.group, z.markerGroup, z.dataLabelsGroup].forEach(function(dt) {
            dt && (z.state && dt.removeClass("highcharts-series-" + z.state), k && dt.addClass("highcharts-series-" + k));
          }), z.state = k, !z.chart.styledMode)) {
            if (et[k] && et[k].enabled === !1)
              return;
            if (k && (rt = et[k].lineWidth || rt + (et[k].lineWidthPlus || 0), gt = m(et[k].opacity, gt)), q && !q.dashstyle)
              for (V = { "stroke-width": rt }, q.animate(V, nt); z["zone-graph-" + ct]; )
                z["zone-graph-" + ct].animate(V, nt), ct += 1;
            it || [z.group, z.markerGroup, z.dataLabelsGroup, z.labelBySeries].forEach(function(dt) {
              dt && dt.animate({ opacity: gt }, nt);
            });
          }
          G && it && z.points && z.setAllPointsToState(k || void 0);
        }, Q.prototype.setAllPointsToState = function(k) {
          this.points.forEach(function(G) {
            G.setState && G.setState(k);
          });
        }, Q.prototype.setVisible = function(k, G) {
          var z = this, V = z.chart, q = z.legendItem, it = V.options.chart.ignoreHiddenSeries, et = z.visible, nt = (z.visible = k = z.options.visible = z.userOptions.visible = typeof k > "u" ? !et : k) ? "show" : "hide";
          ["group", "dataLabelsGroup", "markerGroup", "tracker", "tt"].forEach(function(rt) {
            z[rt] && z[rt][nt]();
          }), (V.hoverSeries === z || (V.hoverPoint && V.hoverPoint.series) === z) && z.onMouseOut(), q && V.legend.colorizeItem(z, k), z.isDirty = !0, z.options.stacking && V.series.forEach(function(rt) {
            rt.options.stacking && rt.visible && (rt.isDirty = !0);
          }), z.linkedSeries.forEach(function(rt) {
            rt.setVisible(k, !1);
          }), it && (V.isDirtyBox = !0), A(z, nt), G !== !1 && V.redraw();
        }, Q.prototype.show = function() {
          this.setVisible(!0);
        }, Q.prototype.hide = function() {
          this.setVisible(!1);
        }, Q.prototype.select = function(k) {
          this.selected = k = this.options.selected = typeof k > "u" ? !this.selected : k, this.checkbox && (this.checkbox.checked = k), A(this, k ? "select" : "unselect");
        }, Q.prototype.shouldShowTooltip = function(k, G, z) {
          return z === void 0 && (z = {}), z.series = this, z.visiblePlotOnly = !0, this.chart.isInsidePlot(k, G, z);
        }, Q.defaultOptions = U, Q;
      }(), n(y.prototype, { axisTypes: [
        "xAxis",
        "yAxis"
      ], coll: "series", colorCounter: 0, cropShoulder: 1, directTouch: !1, drawLegendSymbol: H.drawLineMarker, isCartesian: !0, kdAxisArray: ["clientX", "plotY"], parallelArrays: ["x", "y"], pointClass: $, requireSorting: !0, sorted: !0 }), W.series = y, y;
    }), E(a, "Extensions/ScrollablePlotArea.js", [a["Core/Animation/AnimationUtilities.js"], a["Core/Axis/Axis.js"], a["Core/Chart/Chart.js"], a["Core/Series/Series.js"], a["Core/Renderer/RendererRegistry.js"], a["Core/Utilities.js"]], function(y, R, I, Z, H, $) {
      var U = y.stop, W = $.addEvent, N = $.createElement, M = $.merge, v = $.pick;
      W(I, "afterSetChartSize", function(u) {
        var d = this.options.chart.scrollablePlotArea, P = d && d.minWidth;
        if (d = d && d.minHeight, !this.renderer.forExport) {
          if (P) {
            if (this.scrollablePixelsX = P = Math.max(0, P - this.chartWidth)) {
              this.scrollablePlotBox = this.renderer.scrollablePlotBox = M(this.plotBox), this.plotBox.width = this.plotWidth += P, this.inverted ? this.clipBox.height += P : this.clipBox.width += P;
              var O = { 1: { name: "right", value: P } };
            }
          } else
            d && (this.scrollablePixelsY = P = Math.max(
              0,
              d - this.chartHeight
            )) && (this.scrollablePlotBox = this.renderer.scrollablePlotBox = M(this.plotBox), this.plotBox.height = this.plotHeight += P, this.inverted ? this.clipBox.width += P : this.clipBox.height += P, O = { 2: { name: "bottom", value: P } });
          O && !u.skipAxes && this.axes.forEach(function(B) {
            O[B.side] ? B.getPlotLinePath = function() {
              var C = O[B.side].name, b = this[C];
              this[C] = b - O[B.side].value;
              var w = R.prototype.getPlotLinePath.apply(this, arguments);
              return this[C] = b, w;
            } : (B.setAxisSize(), B.setAxisTranslation());
          });
        }
      }), W(I, "render", function() {
        this.scrollablePixelsX || this.scrollablePixelsY ? (this.setUpScrolling && this.setUpScrolling(), this.applyFixed()) : this.fixedDiv && this.applyFixed();
      }), I.prototype.setUpScrolling = function() {
        var u = this, d = { WebkitOverflowScrolling: "touch", overflowX: "hidden", overflowY: "hidden" };
        this.scrollablePixelsX && (d.overflowX = "auto"), this.scrollablePixelsY && (d.overflowY = "auto"), this.scrollingParent = N("div", { className: "highcharts-scrolling-parent" }, { position: "relative" }, this.renderTo), this.scrollingContainer = N(
          "div",
          { className: "highcharts-scrolling" },
          d,
          this.scrollingParent
        ), W(this.scrollingContainer, "scroll", function() {
          u.pointer && delete u.pointer.chartPosition;
        }), this.innerContainer = N("div", { className: "highcharts-inner-container" }, null, this.scrollingContainer), this.innerContainer.appendChild(this.container), this.setUpScrolling = null;
      }, I.prototype.moveFixedElements = function() {
        var u = this.container, d = this.fixedRenderer, P = ".highcharts-contextbutton .highcharts-credits .highcharts-legend .highcharts-legend-checkbox .highcharts-navigator-series .highcharts-navigator-xaxis .highcharts-navigator-yaxis .highcharts-navigator .highcharts-reset-zoom .highcharts-drillup-button .highcharts-scrollbar .highcharts-subtitle .highcharts-title".split(" "), O;
        this.scrollablePixelsX && !this.inverted ? O = ".highcharts-yaxis" : this.scrollablePixelsX && this.inverted || this.scrollablePixelsY && !this.inverted ? O = ".highcharts-xaxis" : this.scrollablePixelsY && this.inverted && (O = ".highcharts-yaxis"), O && P.push(O + ":not(.highcharts-radial-axis)", O + "-labels:not(.highcharts-radial-axis-labels)"), P.forEach(function(B) {
          [].forEach.call(u.querySelectorAll(B), function(C) {
            (C.namespaceURI === d.SVG_NS ? d.box : d.box.parentNode).appendChild(C), C.style.pointerEvents = "auto";
          });
        });
      }, I.prototype.applyFixed = function() {
        var u = !this.fixedDiv, d = this.options.chart, P = d.scrollablePlotArea, O = H.getRendererType();
        u ? (this.fixedDiv = N("div", { className: "highcharts-fixed" }, { position: "absolute", overflow: "hidden", pointerEvents: "none", zIndex: (d.style && d.style.zIndex || 0) + 2, top: 0 }, null, !0), this.scrollingContainer && this.scrollingContainer.parentNode.insertBefore(this.fixedDiv, this.scrollingContainer), this.renderTo.style.overflow = "visible", this.fixedRenderer = d = new O(
          this.fixedDiv,
          this.chartWidth,
          this.chartHeight,
          this.options.chart.style
        ), this.scrollableMask = d.path().attr({ fill: this.options.chart.backgroundColor || "#fff", "fill-opacity": v(P.opacity, 0.85), zIndex: -1 }).addClass("highcharts-scrollable-mask").add(), W(this, "afterShowResetZoom", this.moveFixedElements), W(this, "afterDrilldown", this.moveFixedElements), W(this, "afterLayOutTitles", this.moveFixedElements)) : this.fixedRenderer.setSize(this.chartWidth, this.chartHeight), (this.scrollableDirty || u) && (this.scrollableDirty = !1, this.moveFixedElements()), d = this.chartWidth + (this.scrollablePixelsX || 0), O = this.chartHeight + (this.scrollablePixelsY || 0), U(this.container), this.container.style.width = d + "px", this.container.style.height = O + "px", this.renderer.boxWrapper.attr({ width: d, height: O, viewBox: [0, 0, d, O].join(" ") }), this.chartBackground.attr({ width: d, height: O }), this.scrollingContainer.style.height = this.chartHeight + "px", u && (P.scrollPositionX && (this.scrollingContainer.scrollLeft = this.scrollablePixelsX * P.scrollPositionX), P.scrollPositionY && (this.scrollingContainer.scrollTop = this.scrollablePixelsY * P.scrollPositionY)), O = this.axisOffset, u = this.plotTop - O[0] - 1, P = this.plotLeft - O[3] - 1, d = this.plotTop + this.plotHeight + O[2] + 1, O = this.plotLeft + this.plotWidth + O[1] + 1;
        var B = this.plotLeft + this.plotWidth - (this.scrollablePixelsX || 0), C = this.plotTop + this.plotHeight - (this.scrollablePixelsY || 0);
        u = this.scrollablePixelsX ? [["M", 0, u], ["L", this.plotLeft - 1, u], ["L", this.plotLeft - 1, d], ["L", 0, d], ["Z"], ["M", B, u], ["L", this.chartWidth, u], ["L", this.chartWidth, d], ["L", B, d], ["Z"]] : this.scrollablePixelsY ? [["M", P, 0], ["L", P, this.plotTop - 1], ["L", O, this.plotTop - 1], ["L", O, 0], ["Z"], ["M", P, C], ["L", P, this.chartHeight], ["L", O, this.chartHeight], ["L", O, C], ["Z"]] : [["M", 0, 0]], this.redrawTrigger !== "adjustHeight" && this.scrollableMask.attr({ d: u });
      }, W(R, "afterInit", function() {
        this.chart.scrollableDirty = !0;
      }), W(Z, "show", function() {
        this.chart.scrollableDirty = !0;
      });
    }), E(a, "Core/Axis/StackingAxis.js", [a["Core/Animation/AnimationUtilities.js"], a["Core/Axis/Axis.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = y.getDeferredAnimation, H = I.addEvent, $ = I.destroyObjectProperties, U = I.fireEvent, W = I.isNumber, N = I.objectEach, M;
      return function(v) {
        function u() {
          var B = this.stacking;
          if (B) {
            var C = B.stacks;
            N(C, function(b, w) {
              $(b), C[w] = null;
            }), B && B.stackTotalGroup && B.stackTotalGroup.destroy();
          }
        }
        function d() {
          this.stacking || (this.stacking = new O(this));
        }
        var P = [];
        v.compose = function(B) {
          return P.indexOf(B) === -1 && (P.push(B), H(B, "init", d), H(B, "destroy", u)), B;
        };
        var O = function() {
          function B(C) {
            this.oldStacks = {}, this.stacks = {}, this.stacksTouched = 0, this.axis = C;
          }
          return B.prototype.buildStacks = function() {
            var C = this.axis, b = C.series, w = C.options.reversedStacks, x = b.length, h;
            if (!C.isXAxis) {
              for (this.usePercentage = !1, h = x; h--; ) {
                var c = b[w ? h : x - h - 1];
                c.setStackedPoints(), c.setGroupedPoints();
              }
              for (h = 0; h < x; h++)
                b[h].modifyStacks();
              U(C, "afterBuildStacks");
            }
          }, B.prototype.cleanStacks = function() {
            if (!this.axis.isXAxis) {
              if (this.oldStacks)
                var C = this.stacks = this.oldStacks;
              N(C, function(b) {
                N(b, function(w) {
                  w.cumulative = w.total;
                });
              });
            }
          }, B.prototype.resetStacks = function() {
            var C = this, b = C.stacks;
            C.axis.isXAxis || N(b, function(w) {
              N(
                w,
                function(x, h) {
                  W(x.touched) && x.touched < C.stacksTouched ? (x.destroy(), delete w[h]) : (x.total = null, x.cumulative = null);
                }
              );
            });
          }, B.prototype.renderStackTotals = function() {
            var C = this.axis, b = C.chart, w = b.renderer, x = this.stacks;
            C = Z(b, C.options.stackLabels && C.options.stackLabels.animation || !1);
            var h = this.stackTotalGroup = this.stackTotalGroup || w.g("stack-labels").attr({ visibility: "visible", zIndex: 6, opacity: 0 }).add();
            h.translate(b.plotLeft, b.plotTop), N(x, function(c) {
              N(c, function(p) {
                p.render(h);
              });
            }), h.animate(
              { opacity: 1 },
              C
            );
          }, B;
        }();
        v.Additions = O;
      }(M || (M = {})), M;
    }), E(a, "Extensions/Stacking.js", [a["Core/Axis/Axis.js"], a["Core/Chart/Chart.js"], a["Core/FormatUtilities.js"], a["Core/Globals.js"], a["Core/Series/Series.js"], a["Core/Axis/StackingAxis.js"], a["Core/Utilities.js"]], function(y, R, I, Z, H, $, U) {
      var W = I.format, N = U.correctFloat, M = U.defined, v = U.destroyObjectProperties, u = U.isArray, d = U.isNumber, P = U.objectEach, O = U.pick, B = function() {
        function C(b, w, x, h, c) {
          var p = b.chart.inverted;
          this.axis = b, this.isNegative = x, this.options = w = w || {}, this.x = h, this.total = null, this.points = {}, this.hasValidPoints = !1, this.stack = c, this.rightCliff = this.leftCliff = 0, this.alignOptions = { align: w.align || (p ? x ? "left" : "right" : "center"), verticalAlign: w.verticalAlign || (p ? "middle" : x ? "bottom" : "top"), y: w.y, x: w.x }, this.textAlign = w.textAlign || (p ? x ? "right" : "left" : "center");
        }
        return C.prototype.destroy = function() {
          v(this, this.axis);
        }, C.prototype.render = function(b) {
          var w = this.axis.chart, x = this.options, h = x.format;
          h = h ? W(h, this, w) : x.formatter.call(this), this.label ? this.label.attr({
            text: h,
            visibility: "hidden"
          }) : (this.label = w.renderer.label(h, null, null, x.shape, null, null, x.useHTML, !1, "stack-labels"), h = { r: x.borderRadius || 0, text: h, rotation: x.rotation, padding: O(x.padding, 5), visibility: "hidden" }, w.styledMode || (h.fill = x.backgroundColor, h.stroke = x.borderColor, h["stroke-width"] = x.borderWidth, this.label.css(x.style)), this.label.attr(h), this.label.added || this.label.add(b)), this.label.labelrank = w.plotSizeY;
        }, C.prototype.setOffset = function(b, w, x, h, c) {
          var p = this.axis, i = p.chart;
          h = p.translate(p.stacking.usePercentage ? 100 : h || this.total, 0, 0, 0, 1), x = p.translate(x || 0), x = M(h) && Math.abs(h - x), b = O(c, i.xAxis[0].translate(this.x)) + b, p = M(h) && this.getStackBox(i, this, b, h, w, x, p), w = this.label, x = this.isNegative, b = O(this.options.overflow, "justify") === "justify";
          var l = this.textAlign;
          w && p && (c = w.getBBox(), h = w.padding, l = l === "left" ? i.inverted ? -h : h : l === "right" ? c.width : i.inverted && l === "center" ? c.width / 2 : i.inverted ? x ? c.width + h : -h : c.width / 2, x = i.inverted ? c.height / 2 : x ? -h : c.height, this.alignOptions.x = O(this.options.x, 0), this.alignOptions.y = O(this.options.y, 0), p.x -= l, p.y -= x, w.align(this.alignOptions, null, p), i.isInsidePlot(w.alignAttr.x + l - this.alignOptions.x, w.alignAttr.y + x - this.alignOptions.y) ? w.show() : (w.alignAttr.y = -9999, b = !1), b && H.prototype.justifyDataLabel.call(this.axis, w, this.alignOptions, w.alignAttr, c, p), w.attr({ x: w.alignAttr.x, y: w.alignAttr.y }), O(!b && this.options.crop, !0) && ((i = d(w.x) && d(w.y) && i.isInsidePlot(w.x - h + w.width, w.y) && i.isInsidePlot(w.x + h, w.y)) || w.hide()));
        }, C.prototype.getStackBox = function(b, w, x, h, c, p, i) {
          var l = w.axis.reversed, s = b.inverted, t = i.height + i.pos - (s ? b.plotLeft : b.plotTop);
          return w = w.isNegative && !l || !w.isNegative && l, { x: s ? w ? h - i.right : h - p + i.pos - b.plotLeft : x + b.xAxis[0].transB - b.plotLeft, y: s ? i.height - x - c : w ? t - h - p : t - h, width: s ? p : c, height: s ? c : p };
        }, C;
      }();
      return R.prototype.getStacks = function() {
        var C = this, b = C.inverted;
        C.yAxis.forEach(function(w) {
          w.stacking && w.stacking.stacks && w.hasVisibleSeries && (w.stacking.oldStacks = w.stacking.stacks);
        }), C.series.forEach(function(w) {
          var x = w.xAxis && w.xAxis.options || {};
          !w.options.stacking || w.visible !== !0 && C.options.chart.ignoreHiddenSeries !== !1 || (w.stackKey = [w.type, O(w.options.stack, ""), b ? x.top : x.left, b ? x.height : x.width].join());
        });
      }, $.compose(y), H.prototype.setGroupedPoints = function() {
        var C = this.yAxis.stacking;
        this.options.centerInCategory && (this.is("column") || this.is("columnrange")) && !this.options.stacking && 1 < this.chart.series.length ? H.prototype.setStackedPoints.call(this, "group") : C && P(C.stacks, function(b, w) {
          w.slice(-5) === "group" && (P(b, function(x) {
            return x.destroy();
          }), delete C.stacks[w]);
        });
      }, H.prototype.setStackedPoints = function(C) {
        var b = C || this.options.stacking;
        if (b && (this.visible === !0 || this.chart.options.chart.ignoreHiddenSeries === !1)) {
          var w = this.processedXData, x = this.processedYData, h = [], c = x.length, p = this.options, i = p.threshold, l = O(p.startFromThreshold && i, 0);
          p = p.stack, C = C ? this.type + "," + b : this.stackKey;
          var s = "-" + C, t = this.negStacks, n = this.yAxis, o = n.stacking.stacks, A = n.stacking.oldStacks, _, D;
          for (n.stacking.stacksTouched += 1, D = 0; D < c; D++) {
            var j = w[D], T = x[D], X = this.getStackIndicator(
              X,
              j,
              this.index
            ), f = X.key, m = (_ = t && T < (l ? 0 : i)) ? s : C;
            o[m] || (o[m] = {}), o[m][j] || (A[m] && A[m][j] ? (o[m][j] = A[m][j], o[m][j].total = null) : o[m][j] = new B(n, n.options.stackLabels, _, j, p)), m = o[m][j], T !== null ? (m.points[f] = m.points[this.index] = [O(m.cumulative, l)], M(m.cumulative) || (m.base = f), m.touched = n.stacking.stacksTouched, 0 < X.index && this.singleStacks === !1 && (m.points[f][0] = m.points[this.index + "," + j + ",0"][0])) : m.points[f] = m.points[this.index] = null, b === "percent" ? (_ = _ ? C : s, t && o[_] && o[_][j] ? (_ = o[_][j], m.total = _.total = Math.max(_.total, m.total) + Math.abs(T) || 0) : m.total = N(m.total + (Math.abs(T) || 0))) : b === "group" ? (u(T) && (T = T[0]), T !== null && (m.total = (m.total || 0) + 1)) : m.total = N(m.total + (T || 0)), m.cumulative = b === "group" ? (m.total || 1) - 1 : O(m.cumulative, l) + (T || 0), T !== null && (m.points[f].push(m.cumulative), h[D] = m.cumulative, m.hasValidPoints = !0);
          }
          b === "percent" && (n.stacking.usePercentage = !0), b !== "group" && (this.stackedYData = h), n.stacking.oldStacks = {};
        }
      }, H.prototype.modifyStacks = function() {
        var C = this, b = C.stackKey, w = C.yAxis.stacking.stacks, x = C.processedXData, h, c = C.options.stacking;
        C[c + "Stacker"] && [b, "-" + b].forEach(function(p) {
          for (var i = x.length, l, s; i--; )
            l = x[i], h = C.getStackIndicator(h, l, C.index, p), (s = (l = w[p] && w[p][l]) && l.points[h.key]) && C[c + "Stacker"](s, l, i);
        });
      }, H.prototype.percentStacker = function(C, b, w) {
        b = b.total ? 100 / b.total : 0, C[0] = N(C[0] * b), C[1] = N(C[1] * b), this.stackedYData[w] = C[1];
      }, H.prototype.getStackIndicator = function(C, b, w, x) {
        return !M(C) || C.x !== b || x && C.key !== x ? C = { x: b, index: 0, key: x } : C.index++, C.key = [w, b, C.index].join(), C;
      }, Z.StackItem = B, Z.StackItem;
    }), E(a, "Series/Line/LineSeries.js", [a["Core/Series/Series.js"], a["Core/Series/SeriesRegistry.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = this && this.__extends || function() {
        var U = function(W, N) {
          return U = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(M, v) {
            M.__proto__ = v;
          } || function(M, v) {
            for (var u in v)
              v.hasOwnProperty(u) && (M[u] = v[u]);
          }, U(W, N);
        };
        return function(W, N) {
          function M() {
            this.constructor = W;
          }
          U(W, N), W.prototype = N === null ? Object.create(N) : (M.prototype = N.prototype, new M());
        };
      }(), H = I.defined, $ = I.merge;
      return I = function(U) {
        function W() {
          var N = U !== null && U.apply(this, arguments) || this;
          return N.data = void 0, N.options = void 0, N.points = void 0, N;
        }
        return Z(W, U), W.prototype.drawGraph = function() {
          var N = this, M = this.options, v = (this.gappedPath || this.getGraphPath).call(this), u = this.chart.styledMode, d = [["graph", "highcharts-graph"]];
          u || d[0].push(M.lineColor || this.color || "#cccccc", M.dashStyle), d = N.getZonesGraphs(d), d.forEach(function(P, O) {
            var B = P[0], C = N[B], b = C ? "animate" : "attr";
            C ? (C.endX = N.preventGraphAnimation ? null : v.xMap, C.animate({ d: v })) : v.length && (N[B] = C = N.chart.renderer.path(v).addClass(P[1]).attr({ zIndex: 1 }).add(N.group)), C && !u && (B = { stroke: P[2], "stroke-width": M.lineWidth, fill: N.fillGraph && N.color || "none" }, P[3] ? B.dashstyle = P[3] : M.linecap !== "square" && (B["stroke-linecap"] = B["stroke-linejoin"] = "round"), C[b](B).shadow(2 > O && M.shadow)), C && (C.startX = v.xMap, C.isArea = v.isArea);
          });
        }, W.prototype.getGraphPath = function(N, M, v) {
          var u = this, d = u.options, P = [], O = [], B, C = d.step;
          N = N || u.points;
          var b = N.reversed;
          return b && N.reverse(), (C = { right: 1, center: 2 }[C] || C && 3) && b && (C = 4 - C), N = this.getValidPoints(N, !1, !(d.connectNulls && !M && !v)), N.forEach(function(w, x) {
            var h = w.plotX, c = w.plotY, p = N[x - 1];
            (w.leftCliff || p && p.rightCliff) && !v && (B = !0), w.isNull && !H(M) && 0 < x ? B = !d.connectNulls : w.isNull && !M ? B = !0 : (x === 0 || B ? x = [["M", w.plotX, w.plotY]] : u.getPointSpline ? x = [u.getPointSpline(N, w, x)] : C ? (x = C === 1 ? [["L", p.plotX, c]] : C === 2 ? [["L", (p.plotX + h) / 2, p.plotY], ["L", (p.plotX + h) / 2, c]] : [["L", h, p.plotY]], x.push(["L", h, c])) : x = [["L", h, c]], O.push(w.x), C && (O.push(w.x), C === 2 && O.push(w.x)), P.push.apply(P, x), B = !1);
          }), P.xMap = O, u.graphPath = P;
        }, W.prototype.getZonesGraphs = function(N) {
          return this.zones.forEach(function(M, v) {
            v = ["zone-graph-" + v, "highcharts-graph highcharts-zone-graph-" + v + " " + (M.className || "")], this.chart.styledMode || v.push(M.color || this.color, M.dashStyle || this.options.dashStyle), N.push(v);
          }, this), N;
        }, W.defaultOptions = $(y.defaultOptions, {}), W;
      }(y), R.registerSeriesType("line", I), I;
    }), E(a, "Series/Area/AreaSeries.js", [
      a["Core/Color/Color.js"],
      a["Core/Legend/LegendSymbol.js"],
      a["Core/Series/SeriesRegistry.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I, Z) {
      var H = this && this.__extends || function() {
        var v = function(u, d) {
          return v = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(P, O) {
            P.__proto__ = O;
          } || function(P, O) {
            for (var B in O)
              O.hasOwnProperty(B) && (P[B] = O[B]);
          }, v(u, d);
        };
        return function(u, d) {
          function P() {
            this.constructor = u;
          }
          v(u, d), u.prototype = d === null ? Object.create(d) : (P.prototype = d.prototype, new P());
        };
      }(), $ = y.parse, U = I.seriesTypes.line;
      y = Z.extend;
      var W = Z.merge, N = Z.objectEach, M = Z.pick;
      return Z = function(v) {
        function u() {
          var d = v !== null && v.apply(this, arguments) || this;
          return d.data = void 0, d.options = void 0, d.points = void 0, d;
        }
        return H(u, v), u.prototype.drawGraph = function() {
          this.areaPath = [], v.prototype.drawGraph.apply(this);
          var d = this, P = this.areaPath, O = this.options, B = [["area", "highcharts-area", this.color, O.fillColor]];
          this.zones.forEach(function(C, b) {
            B.push(["zone-area-" + b, "highcharts-area highcharts-zone-area-" + b + " " + C.className, C.color || d.color, C.fillColor || O.fillColor]);
          }), B.forEach(function(C) {
            var b = C[0], w = d[b], x = w ? "animate" : "attr", h = {};
            w ? (w.endX = d.preventGraphAnimation ? null : P.xMap, w.animate({ d: P })) : (h.zIndex = 0, w = d[b] = d.chart.renderer.path(P).addClass(C[1]).add(d.group), w.isArea = !0), d.chart.styledMode || (h.fill = M(C[3], $(C[2]).setOpacity(M(O.fillOpacity, 0.75)).get())), w[x](h), w.startX = P.xMap, w.shiftUnit = O.step ? 2 : 1;
          });
        }, u.prototype.getGraphPath = function(d) {
          var P = U.prototype.getGraphPath, O = this.options, B = O.stacking, C = this.yAxis, b, w = [], x = [], h = this.index, c = C.stacking.stacks[this.stackKey], p = O.threshold, i = Math.round(C.getThreshold(O.threshold));
          O = M(O.connectNulls, B === "percent");
          var l = function(o, A, _) {
            var D = d[o];
            o = B && c[D.x].points[h];
            var j = D[_ + "Null"] || 0;
            if (_ = D[_ + "Cliff"] || 0, D = !0, _ || j) {
              var T = (j ? o[0] : o[1]) + _, X = o[0] + _;
              D = !!j;
            } else
              !B && d[A] && d[A].isNull && (T = X = p);
            typeof T < "u" && (x.push({ plotX: t, plotY: T === null ? i : C.getThreshold(T), isNull: D, isCliff: !0 }), w.push({ plotX: t, plotY: X === null ? i : C.getThreshold(X), doCurve: !1 }));
          };
          for (d = d || this.points, B && (d = this.getStackPoints(d)), b = 0; b < d.length; b++) {
            B || (d[b].leftCliff = d[b].rightCliff = d[b].leftNull = d[b].rightNull = void 0);
            var s = d[b].isNull, t = M(d[b].rectPlotX, d[b].plotX), n = B ? M(d[b].yBottom, i) : i;
            (!s || O) && (O || l(b, b - 1, "left"), s && !B && O || (x.push(d[b]), w.push({ x: b, plotX: t, plotY: n })), O || l(b, b + 1, "right"));
          }
          return b = P.call(this, x, !0, !0), w.reversed = !0, s = P.call(this, w, !0, !0), (n = s[0]) && n[0] === "M" && (s[0] = ["L", n[1], n[2]]), s = b.concat(s), s.length && s.push(["Z"]), P = P.call(this, x, !1, O), s.xMap = b.xMap, this.areaPath = s, P;
        }, u.prototype.getStackPoints = function(d) {
          var P = this, O = [], B = [], C = this.xAxis, b = this.yAxis, w = b.stacking.stacks[this.stackKey], x = {}, h = b.series, c = h.length, p = b.options.reversedStacks ? 1 : -1, i = h.indexOf(P);
          if (d = d || this.points, this.options.stacking) {
            for (var l = 0; l < d.length; l++)
              d[l].leftNull = d[l].rightNull = void 0, x[d[l].x] = d[l];
            N(w, function(t, n) {
              t.total !== null && B.push(n);
            }), B.sort(function(t, n) {
              return t - n;
            });
            var s = h.map(function(t) {
              return t.visible;
            });
            B.forEach(function(t, n) {
              var o = 0, A, _;
              if (x[t] && !x[t].isNull)
                O.push(x[t]), [-1, 1].forEach(function(j) {
                  var T = j === 1 ? "rightNull" : "leftNull", X = 0, f = w[B[n + j]];
                  if (f)
                    for (var m = i; 0 <= m && m < c; ) {
                      var L = h[m].index;
                      A = f.points[L], A || (L === P.index ? x[t][T] = !0 : s[m] && (_ = w[t].points[L]) && (X -= _[1] - _[0])), m += p;
                    }
                  x[t][j === 1 ? "rightCliff" : "leftCliff"] = X;
                });
              else {
                for (var D = i; 0 <= D && D < c; ) {
                  if (A = w[t].points[h[D].index]) {
                    o = A[1];
                    break;
                  }
                  D += p;
                }
                o = M(o, 0), o = b.translate(o, 0, 1, 0, 1), O.push({ isNull: !0, plotX: C.translate(t, 0, 0, 0, 1), x: t, plotY: o, yBottom: o });
              }
            });
          }
          return O;
        }, u.defaultOptions = W(U.defaultOptions, { threshold: 0 }), u;
      }(U), y(Z.prototype, {
        singleStacks: !1,
        drawLegendSymbol: R.drawRectangle
      }), I.registerSeriesType("area", Z), Z;
    }), E(a, "Series/Spline/SplineSeries.js", [a["Core/Series/SeriesRegistry.js"], a["Core/Utilities.js"]], function(y, R) {
      var I = this && this.__extends || function() {
        var U = function(W, N) {
          return U = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(M, v) {
            M.__proto__ = v;
          } || function(M, v) {
            for (var u in v)
              v.hasOwnProperty(u) && (M[u] = v[u]);
          }, U(W, N);
        };
        return function(W, N) {
          function M() {
            this.constructor = W;
          }
          U(W, N), W.prototype = N === null ? Object.create(N) : (M.prototype = N.prototype, new M());
        };
      }(), Z = y.seriesTypes.line, H = R.merge, $ = R.pick;
      return R = function(U) {
        function W() {
          var N = U !== null && U.apply(this, arguments) || this;
          return N.data = void 0, N.options = void 0, N.points = void 0, N;
        }
        return I(W, U), W.prototype.getPointSpline = function(N, M, v) {
          var u = M.plotX || 0, d = M.plotY || 0, P = N[v - 1];
          if (v = N[v + 1], P && !P.isNull && P.doCurve !== !1 && !M.isCliff && v && !v.isNull && v.doCurve !== !1 && !M.isCliff) {
            N = P.plotY || 0;
            var O = v.plotX || 0;
            v = v.plotY || 0;
            var B = 0, C = (1.5 * u + (P.plotX || 0)) / 2.5, b = (1.5 * d + N) / 2.5;
            O = (1.5 * u + O) / 2.5;
            var w = (1.5 * d + v) / 2.5;
            O !== C && (B = (w - b) * (O - u) / (O - C) + d - w), b += B, w += B, b > N && b > d ? (b = Math.max(N, d), w = 2 * d - b) : b < N && b < d && (b = Math.min(N, d), w = 2 * d - b), w > v && w > d ? (w = Math.max(v, d), b = 2 * d - w) : w < v && w < d && (w = Math.min(v, d), b = 2 * d - w), M.rightContX = O, M.rightContY = w;
          }
          return M = ["C", $(P.rightContX, P.plotX, 0), $(P.rightContY, P.plotY, 0), $(C, u, 0), $(b, d, 0), u, d], P.rightContX = P.rightContY = void 0, M;
        }, W.defaultOptions = H(Z.defaultOptions), W;
      }(Z), y.registerSeriesType("spline", R), R;
    }), E(
      a,
      "Series/AreaSpline/AreaSplineSeries.js",
      [a["Series/Area/AreaSeries.js"], a["Series/Spline/SplineSeries.js"], a["Core/Legend/LegendSymbol.js"], a["Core/Series/SeriesRegistry.js"], a["Core/Utilities.js"]],
      function(y, R, I, Z, H) {
        var $ = this && this.__extends || function() {
          var M = function(v, u) {
            return M = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d, P) {
              d.__proto__ = P;
            } || function(d, P) {
              for (var O in P)
                P.hasOwnProperty(O) && (d[O] = P[O]);
            }, M(v, u);
          };
          return function(v, u) {
            function d() {
              this.constructor = v;
            }
            M(v, u), v.prototype = u === null ? Object.create(u) : (d.prototype = u.prototype, new d());
          };
        }(), U = y.prototype, W = H.extend, N = H.merge;
        return H = function(M) {
          function v() {
            var u = M !== null && M.apply(this, arguments) || this;
            return u.data = void 0, u.points = void 0, u.options = void 0, u;
          }
          return $(v, M), v.defaultOptions = N(R.defaultOptions, y.defaultOptions), v;
        }(R), W(H.prototype, { getGraphPath: U.getGraphPath, getStackPoints: U.getStackPoints, drawGraph: U.drawGraph, drawLegendSymbol: I.drawRectangle }), Z.registerSeriesType("areaspline", H), H;
      }
    ), E(a, "Series/Column/ColumnSeries.js", [
      a["Core/Animation/AnimationUtilities.js"],
      a["Core/Color/Color.js"],
      a["Core/Globals.js"],
      a["Core/Legend/LegendSymbol.js"],
      a["Core/Series/Series.js"],
      a["Core/Series/SeriesRegistry.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I, Z, H, $, U) {
      var W = this && this.__extends || function() {
        var c = function(p, i) {
          return c = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(l, s) {
            l.__proto__ = s;
          } || function(l, s) {
            for (var t in s)
              s.hasOwnProperty(t) && (l[t] = s[t]);
          }, c(p, i);
        };
        return function(p, i) {
          function l() {
            this.constructor = p;
          }
          c(p, i), p.prototype = i === null ? Object.create(i) : (l.prototype = i.prototype, new l());
        };
      }(), N = y.animObject, M = R.parse, v = I.hasTouch;
      y = I.noop;
      var u = U.clamp, d = U.css, P = U.defined, O = U.extend, B = U.fireEvent, C = U.isArray, b = U.isNumber, w = U.merge, x = U.pick, h = U.objectEach;
      return U = function(c) {
        function p() {
          var i = c !== null && c.apply(this, arguments) || this;
          return i.borderWidth = void 0, i.data = void 0, i.group = void 0, i.options = void 0, i.points = void 0, i;
        }
        return W(p, c), p.prototype.animate = function(i) {
          var l = this, s = this.yAxis, t = l.options, n = this.chart.inverted, o = {}, A = n ? "translateX" : "translateY";
          if (i)
            o.scaleY = 1e-3, i = u(s.toPixels(t.threshold), s.pos, s.pos + s.len), n ? o.translateX = i - s.len : o.translateY = i, l.clipBox && l.setClip(), l.group.attr(o);
          else {
            var _ = Number(l.group.attr(A));
            l.group.animate({ scaleY: 1 }, O(N(l.options.animation), { step: function(D, j) {
              l.group && (o[A] = _ + j.pos * (s.pos - _), l.group.attr(o));
            } }));
          }
        }, p.prototype.init = function(i, l) {
          c.prototype.init.apply(this, arguments);
          var s = this;
          i = s.chart, i.hasRendered && i.series.forEach(function(t) {
            t.type === s.type && (t.isDirty = !0);
          });
        }, p.prototype.getColumnMetrics = function() {
          var i = this, l = i.options, s = i.xAxis, t = i.yAxis, n = s.options.reversedStacks;
          n = s.reversed && !n || !s.reversed && n;
          var o = {}, A, _ = 0;
          l.grouping === !1 ? _ = 1 : i.chart.series.forEach(function(X) {
            var f = X.yAxis, m = X.options;
            if (X.type === i.type && (X.visible || !i.chart.options.chart.ignoreHiddenSeries) && t.len === f.len && t.pos === f.pos) {
              if (m.stacking && m.stacking !== "group") {
                A = X.stackKey, typeof o[A] > "u" && (o[A] = _++);
                var L = o[A];
              } else
                m.grouping !== !1 && (L = _++);
              X.columnIndex = L;
            }
          });
          var D = Math.min(Math.abs(s.transA) * (s.ordinal && s.ordinal.slope || l.pointRange || s.closestPointRange || s.tickInterval || 1), s.len), j = D * l.groupPadding, T = (D - 2 * j) / (_ || 1);
          return l = Math.min(l.maxPointWidth || s.len, x(l.pointWidth, T * (1 - 2 * l.pointPadding))), i.columnMetrics = { width: l, offset: (T - l) / 2 + (j + ((i.columnIndex || 0) + (n ? 1 : 0)) * T - D / 2) * (n ? -1 : 1), paddedWidth: T, columnCount: _ }, i.columnMetrics;
        }, p.prototype.crispCol = function(i, l, s, t) {
          var n = this.chart, o = this.borderWidth, A = -(o % 2 ? 0.5 : 0);
          return o = o % 2 ? 0.5 : 1, n.inverted && n.renderer.isVML && (o += 1), this.options.crisp && (s = Math.round(i + s) + A, i = Math.round(i) + A, s -= i), t = Math.round(l + t) + o, A = 0.5 >= Math.abs(l) && 0.5 < t, l = Math.round(l) + o, t -= l, A && t && (--l, t += 1), { x: i, y: l, width: s, height: t };
        }, p.prototype.adjustForMissingColumns = function(i, l, s, t) {
          var n = this, o = this.options.stacking;
          if (!s.isNull && 1 < t.columnCount) {
            var A = 0, _ = 0;
            h(this.yAxis.stacking && this.yAxis.stacking.stacks, function(D) {
              if (typeof s.x == "number" && (D = D[s.x.toString()])) {
                var j = D.points[n.index], T = D.total;
                o ? (j && (A = _), D.hasValidPoints && _++) : C(j) && (A = j[1], _ = T || 0);
              }
            }), i = (s.plotX || 0) + ((_ - 1) * t.paddedWidth + l) / 2 - l - A * t.paddedWidth;
          }
          return i;
        }, p.prototype.translate = function() {
          var i = this, l = i.chart, s = i.options, t = i.dense = 2 > i.closestPointRange * i.xAxis.transA;
          t = i.borderWidth = x(s.borderWidth, t ? 0 : 1);
          var n = i.xAxis, o = i.yAxis, A = s.threshold, _ = i.translatedThreshold = o.getThreshold(A), D = x(s.minPointLength, 5), j = i.getColumnMetrics(), T = j.width, X = i.pointXOffset = j.offset, f = i.dataMin, m = i.dataMax, L = i.barW = Math.max(T, 1 + 2 * t);
          l.inverted && (_ -= 0.5), s.pointPadding && (L = Math.ceil(L)), H.prototype.translate.apply(i), i.points.forEach(function(Y) {
            var F = x(Y.yBottom, _), Q = 999 + Math.abs(F), k = Y.plotX || 0;
            Q = u(Y.plotY, -Q, o.len + Q);
            var G = Math.min(Q, F), z = Math.max(Q, F) - G, V = T, q = k + X, it = L;
            D && Math.abs(z) < D && (z = D, k = !o.reversed && !Y.negative || o.reversed && Y.negative, b(A) && b(m) && Y.y === A && m <= A && (o.min || 0) < A && (f !== m || (o.max || 0) <= A) && (k = !k), G = Math.abs(G - _) > D ? F - D : _ - (k ? D : 0)), P(Y.options.pointWidth) && (V = it = Math.ceil(Y.options.pointWidth), q -= Math.round((V - T) / 2)), s.centerInCategory && (q = i.adjustForMissingColumns(q, V, Y, j)), Y.barX = q, Y.pointWidth = V, Y.tooltipPos = l.inverted ? [u(o.len + o.pos - l.plotLeft - Q, o.pos - l.plotLeft, o.len + o.pos - l.plotLeft), n.len + n.pos - l.plotTop - q - it / 2, z] : [n.left - l.plotLeft + q + it / 2, u(Q + o.pos - l.plotTop, o.pos - l.plotTop, o.len + o.pos - l.plotTop), z], Y.shapeType = i.pointClass.prototype.shapeType || "rect", Y.shapeArgs = i.crispCol.apply(i, Y.isNull ? [q, _, it, 0] : [q, G, it, z]);
          });
        }, p.prototype.drawGraph = function() {
          this.group[this.dense ? "addClass" : "removeClass"]("highcharts-dense-data");
        }, p.prototype.pointAttribs = function(i, l) {
          var s = this.options, t = this.pointAttrToOptions || {}, n = t.stroke || "borderColor", o = t["stroke-width"] || "borderWidth", A = i && i.color || this.color, _ = i && i[n] || s[n] || A;
          t = i && i.options.dashStyle || s.dashStyle;
          var D = i && i[o] || s[o] || this[o] || 0, j = x(i && i.opacity, s.opacity, 1);
          if (i && this.zones.length) {
            var T = i.getZone();
            A = i.options.color || T && (T.color || i.nonZonedColor) || this.color, T && (_ = T.borderColor || _, t = T.dashStyle || t, D = T.borderWidth || D);
          }
          return l && i && (i = w(s.states[l], i.options.states && i.options.states[l] || {}), l = i.brightness, A = i.color || typeof l < "u" && M(A).brighten(i.brightness).get() || A, _ = i[n] || _, D = i[o] || D, t = i.dashStyle || t, j = x(i.opacity, j)), n = { fill: A, stroke: _, "stroke-width": D, opacity: j }, t && (n.dashstyle = t), n;
        }, p.prototype.drawPoints = function() {
          var i = this, l = this.chart, s = i.options, t = l.renderer, n = s.animationLimit || 250, o;
          i.points.forEach(function(A) {
            var _ = A.graphic, D = !!_, j = _ && l.pointCount < n ? "animate" : "attr";
            b(A.plotY) && A.y !== null ? (o = A.shapeArgs, _ && A.hasNewShapeType() && (_ = _.destroy()), i.enabledDataSorting && (A.startXPos = i.xAxis.reversed ? -(o && o.width || 0) : i.xAxis.width), _ || (A.graphic = _ = t[A.shapeType](o).add(A.group || i.group)) && i.enabledDataSorting && l.hasRendered && l.pointCount < n && (_.attr({ x: A.startXPos }), D = !0, j = "animate"), _ && D && _[j](w(o)), s.borderRadius && _[j]({ r: s.borderRadius }), l.styledMode || _[j](i.pointAttribs(A, A.selected && "select")).shadow(A.allowShadow !== !1 && s.shadow, null, s.stacking && !s.borderRadius), _ && (_.addClass(A.getClassName(), !0), _.attr({ visibility: A.visible ? "inherit" : "hidden" }))) : _ && (A.graphic = _.destroy());
          });
        }, p.prototype.drawTracker = function() {
          var i = this, l = i.chart, s = l.pointer, t = function(o) {
            var A = s.getPointFromEvent(o);
            typeof A < "u" && (s.isDirectTouch = !0, A.onMouseOver(o));
          }, n;
          i.points.forEach(function(o) {
            n = C(o.dataLabels) ? o.dataLabels : o.dataLabel ? [o.dataLabel] : [], o.graphic && (o.graphic.element.point = o), n.forEach(function(A) {
              A.div ? A.div.point = o : A.element.point = o;
            });
          }), i._hasTracking || (i.trackerGroups.forEach(function(o) {
            i[o] && (i[o].addClass("highcharts-tracker").on("mouseover", t).on("mouseout", function(A) {
              s.onTrackerMouseOut(A);
            }), v && i[o].on(
              "touchstart",
              t
            ), !l.styledMode && i.options.cursor && i[o].css(d).css({ cursor: i.options.cursor }));
          }), i._hasTracking = !0), B(this, "afterDrawTracker");
        }, p.prototype.remove = function() {
          var i = this, l = i.chart;
          l.hasRendered && l.series.forEach(function(s) {
            s.type === i.type && (s.isDirty = !0);
          }), H.prototype.remove.apply(i, arguments);
        }, p.defaultOptions = w(H.defaultOptions, { borderRadius: 0, centerInCategory: !1, groupPadding: 0.2, marker: null, pointPadding: 0.1, minPointLength: 0, cropThreshold: 50, pointRange: null, states: {
          hover: { halo: !1, brightness: 0.1 },
          select: { color: "#cccccc", borderColor: "#000000" }
        }, dataLabels: { align: void 0, verticalAlign: void 0, y: void 0 }, startFromThreshold: !0, stickyTracking: !1, tooltip: { distance: 6 }, threshold: 0, borderColor: "#ffffff" }), p;
      }(H), O(U.prototype, { cropShoulder: 0, directTouch: !0, drawLegendSymbol: Z.drawRectangle, getSymbol: y, negStacks: !0, trackerGroups: ["group", "dataLabelsGroup"] }), $.registerSeriesType("column", U), U;
    }), E(a, "Core/Series/DataLabel.js", [
      a["Core/Animation/AnimationUtilities.js"],
      a["Core/FormatUtilities.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I) {
      var Z = y.getDeferredAnimation, H = R.format, $ = I.defined, U = I.extend, W = I.fireEvent, N = I.isArray, M = I.merge, v = I.objectEach, u = I.pick, d = I.splat, P;
      return function(O) {
        function B(p, i, l, s, t) {
          var n = this, o = this.chart, A = this.isCartesian && o.inverted, _ = this.enabledDataSorting, D = u(p.dlBox && p.dlBox.centerX, p.plotX, -9999), j = u(p.plotY, -9999), T = i.getBBox(), X = l.rotation, f = l.align, m = o.isInsidePlot(D, Math.round(j), { inverted: A, paneCoordinates: !0, series: n }), L = function(k) {
            _ && n.xAxis && !Y && n.setDataLabelStartPos(
              p,
              i,
              t,
              m,
              k
            );
          }, Y = u(l.overflow, _ ? "none" : "justify") === "justify", F = this.visible && p.visible !== !1 && (p.series.forceDL || _ && !Y || m || u(l.inside, !!this.options.stacking) && s && o.isInsidePlot(D, A ? s.x + 1 : s.y + s.height - 1, { inverted: A, paneCoordinates: !0, series: n }));
          if (F) {
            var Q = o.renderer.fontMetrics(o.styledMode ? void 0 : l.style.fontSize, i).b;
            s = U({ x: A ? this.yAxis.len - j : D, y: Math.round(A ? this.xAxis.len - D : j), width: 0, height: 0 }, s), U(l, { width: T.width, height: T.height }), X ? (Y = !1, D = o.renderer.rotCorr(Q, X), D = { x: s.x + (l.x || 0) + s.width / 2 + D.x, y: s.y + (l.y || 0) + { top: 0, middle: 0.5, bottom: 1 }[l.verticalAlign] * s.height }, L(D), i[t ? "attr" : "animate"](D).attr({ align: f }), L = (X + 720) % 360, L = 180 < L && 360 > L, f === "left" ? D.y -= L ? T.height : 0 : f === "center" ? (D.x -= T.width / 2, D.y -= T.height / 2) : f === "right" && (D.x -= T.width, D.y -= L ? 0 : T.height), i.placed = !0, i.alignAttr = D) : (L(s), i.align(l, void 0, s), D = i.alignAttr), Y && 0 <= s.height ? this.justifyDataLabel(i, l, D, T, s, t) : u(l.crop, !0) && (F = o.isInsidePlot(D.x, D.y, { paneCoordinates: !0, series: n }) && o.isInsidePlot(D.x + T.width, D.y + T.height, {
              paneCoordinates: !0,
              series: n
            })), l.shape && !X && i[t ? "attr" : "animate"]({ anchorX: A ? o.plotWidth - p.plotY : p.plotX, anchorY: A ? o.plotHeight - p.plotX : p.plotY });
          }
          t && _ && (i.placed = !1), F || _ && !Y || (i.hide(!0), i.placed = !1);
        }
        function C(p, i) {
          var l = i.filter;
          return l ? (i = l.operator, p = p[l.property], l = l.value, i === ">" && p > l || i === "<" && p < l || i === ">=" && p >= l || i === "<=" && p <= l || i === "==" && p == l || i === "===" && p === l) : !0;
        }
        function b() {
          var p = this, i = p.chart, l = p.options, s = p.points, t = p.hasRendered || 0, n = i.renderer, o = l.dataLabels, A, _ = o.animation;
          if (_ = o.defer ? Z(
            i,
            _,
            p
          ) : { defer: 0, duration: 0 }, o = x(x(i.options.plotOptions && i.options.plotOptions.series && i.options.plotOptions.series.dataLabels, i.options.plotOptions && i.options.plotOptions[p.type] && i.options.plotOptions[p.type].dataLabels), o), W(this, "drawDataLabels"), N(o) || o.enabled || p._hasPointLabels) {
            var D = p.plotGroup("dataLabelsGroup", "data-labels", t ? "inherit" : "hidden", o.zIndex || 6);
            D.attr({ opacity: +t }), !t && (t = p.dataLabelsGroup) && (p.visible && D.show(!0), t[l.animation ? "animate" : "attr"]({ opacity: 1 }, _)), s.forEach(function(j) {
              A = d(x(o, j.dlOptions || j.options && j.options.dataLabels)), A.forEach(function(T, X) {
                var f = T.enabled && (!j.isNull || j.dataLabelOnNull) && C(j, T), m = j.connectors ? j.connectors[X] : j.connector, L = j.dataLabels ? j.dataLabels[X] : j.dataLabel, Y = u(T.distance, j.labelDistance), F = !L;
                if (f) {
                  var Q = j.getLabelConfig(), k = u(T[j.formatPrefix + "Format"], T.format);
                  Q = $(k) ? H(k, Q, i) : (T[j.formatPrefix + "Formatter"] || T.formatter).call(Q, T), k = T.style;
                  var G = T.rotation;
                  i.styledMode || (k.color = u(T.color, k.color, p.color, "#000000"), k.color === "contrast" ? (j.contrastColor = n.getContrast(j.color || p.color), k.color = !$(Y) && T.inside || 0 > Y || l.stacking ? j.contrastColor : "#000000") : delete j.contrastColor, l.cursor && (k.cursor = l.cursor));
                  var z = { r: T.borderRadius || 0, rotation: G, padding: T.padding, zIndex: 1 };
                  i.styledMode || (z.fill = T.backgroundColor, z.stroke = T.borderColor, z["stroke-width"] = T.borderWidth), v(z, function(V, q) {
                    typeof V > "u" && delete z[q];
                  });
                }
                !L || f && $(Q) && !!L.div == !!T.useHTML || (j.dataLabel = L = j.dataLabel && j.dataLabel.destroy(), j.dataLabels && (j.dataLabels.length === 1 ? delete j.dataLabels : delete j.dataLabels[X]), X || delete j.dataLabel, m && (j.connector = j.connector.destroy(), j.connectors && (j.connectors.length === 1 ? delete j.connectors : delete j.connectors[X]))), f && $(Q) && (L ? z.text = Q : (j.dataLabels = j.dataLabels || [], L = j.dataLabels[X] = G ? n.text(Q, 0, -9999, T.useHTML).addClass("highcharts-data-label") : n.label(Q, 0, -9999, T.shape, null, null, T.useHTML, null, "data-label"), X || (j.dataLabel = L), L.addClass(" highcharts-data-label-color-" + j.colorIndex + " " + (T.className || "") + (T.useHTML ? " highcharts-tracker" : ""))), L.options = T, L.attr(z), i.styledMode || L.css(k).shadow(T.shadow), L.added || L.add(D), T.textPath && !T.useHTML && (L.setTextPath(j.getDataLabelPath && j.getDataLabelPath(L) || j.graphic, T.textPath), j.dataLabelPath && !T.textPath.enabled && (j.dataLabelPath = j.dataLabelPath.destroy())), p.alignDataLabel(j, L, T, null, F));
              });
            });
          }
          W(this, "afterDrawDataLabels");
        }
        function w(p, i, l, s, t, n) {
          var o = this.chart, A = i.align, _ = i.verticalAlign, D = p.box ? 0 : p.padding || 0, j = i.x;
          j = j === void 0 ? 0 : j;
          var T = i.y;
          T = T === void 0 ? 0 : T;
          var X = (l.x || 0) + D;
          if (0 > X) {
            A === "right" && 0 <= j ? (i.align = "left", i.inside = !0) : j -= X;
            var f = !0;
          }
          return X = (l.x || 0) + s.width - D, X > o.plotWidth && (A === "left" && 0 >= j ? (i.align = "right", i.inside = !0) : j += o.plotWidth - X, f = !0), X = l.y + D, 0 > X && (_ === "bottom" && 0 <= T ? (i.verticalAlign = "top", i.inside = !0) : T -= X, f = !0), X = (l.y || 0) + s.height - D, X > o.plotHeight && (_ === "top" && 0 >= T ? (i.verticalAlign = "bottom", i.inside = !0) : T += o.plotHeight - X, f = !0), f && (i.x = j, i.y = T, p.placed = !n, p.align(i, void 0, t)), f;
        }
        function x(p, i) {
          var l = [], s;
          if (N(p) && !N(i))
            l = p.map(function(t) {
              return M(t, i);
            });
          else if (N(i) && !N(p))
            l = i.map(function(t) {
              return M(p, t);
            });
          else if (N(p) || N(i))
            for (s = Math.max(p.length, i.length); s--; )
              l[s] = M(p[s], i[s]);
          else
            l = M(p, i);
          return l;
        }
        function h(p, i, l, s, t) {
          var n = this.chart, o = n.inverted, A = this.xAxis, _ = A.reversed, D = o ? i.height / 2 : i.width / 2;
          p = (p = p.pointWidth) ? p / 2 : 0, i.startXPos = o ? t.x : _ ? -D - p : A.width - D + p, i.startYPos = o ? _ ? this.yAxis.height - D + p : -D - p : t.y, s ? i.visibility === "hidden" && (i.show(), i.attr({ opacity: 0 }).animate({ opacity: 1 })) : i.attr({ opacity: 1 }).animate(
            { opacity: 0 },
            void 0,
            i.hide
          ), n.hasRendered && (l && i.attr({ x: i.startXPos, y: i.startYPos }), i.placed = !0);
        }
        var c = [];
        O.compose = function(p) {
          if (c.indexOf(p) === -1) {
            var i = p.prototype;
            c.push(p), i.alignDataLabel = B, i.drawDataLabels = b, i.justifyDataLabel = w, i.setDataLabelStartPos = h;
          }
        };
      }(P || (P = {})), P;
    }), E(a, "Series/Column/ColumnDataLabel.js", [a["Core/Series/DataLabel.js"], a["Core/Series/SeriesRegistry.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = R.series, H = I.merge, $ = I.pick, U;
      return function(W) {
        function N(v, u, d, P, O) {
          var B = this.chart.inverted, C = v.series, b = (C.xAxis ? C.xAxis.len : this.chart.plotSizeX) || 0;
          C = (C.yAxis ? C.yAxis.len : this.chart.plotSizeY) || 0;
          var w = v.dlBox || v.shapeArgs, x = $(v.below, v.plotY > $(this.translatedThreshold, C)), h = $(d.inside, !!this.options.stacking);
          w && (P = H(w), 0 > P.y && (P.height += P.y, P.y = 0), w = P.y + P.height - C, 0 < w && w < P.height && (P.height -= w), B && (P = { x: C - P.y - P.height, y: b - P.x - P.width, width: P.height, height: P.width }), h || (B ? (P.x += x ? 0 : P.width, P.width = 0) : (P.y += x ? P.height : 0, P.height = 0))), d.align = $(d.align, !B || h ? "center" : x ? "right" : "left"), d.verticalAlign = $(d.verticalAlign, B || h ? "middle" : x ? "top" : "bottom"), Z.prototype.alignDataLabel.call(this, v, u, d, P, O), d.inside && v.contrastColor && u.css({ color: v.contrastColor });
        }
        var M = [];
        W.compose = function(v) {
          y.compose(Z), M.indexOf(v) === -1 && (M.push(v), v.prototype.alignDataLabel = N);
        };
      }(U || (U = {})), U;
    }), E(a, "Series/Bar/BarSeries.js", [a["Series/Column/ColumnSeries.js"], a["Core/Series/SeriesRegistry.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = this && this.__extends || function() {
        var U = function(W, N) {
          return U = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(M, v) {
            M.__proto__ = v;
          } || function(M, v) {
            for (var u in v)
              v.hasOwnProperty(u) && (M[u] = v[u]);
          }, U(W, N);
        };
        return function(W, N) {
          function M() {
            this.constructor = W;
          }
          U(W, N), W.prototype = N === null ? Object.create(N) : (M.prototype = N.prototype, new M());
        };
      }(), H = I.extend, $ = I.merge;
      return I = function(U) {
        function W() {
          var N = U !== null && U.apply(this, arguments) || this;
          return N.data = void 0, N.options = void 0, N.points = void 0, N;
        }
        return Z(W, U), W.defaultOptions = $(
          y.defaultOptions,
          {}
        ), W;
      }(y), H(I.prototype, { inverted: !0 }), R.registerSeriesType("bar", I), I;
    }), E(a, "Series/Scatter/ScatterSeries.js", [a["Series/Column/ColumnSeries.js"], a["Series/Line/LineSeries.js"], a["Core/Series/SeriesRegistry.js"], a["Core/Utilities.js"]], function(y, R, I, Z) {
      var H = this && this.__extends || function() {
        var N = function(M, v) {
          return N = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(u, d) {
            u.__proto__ = d;
          } || function(u, d) {
            for (var P in d)
              d.hasOwnProperty(P) && (u[P] = d[P]);
          }, N(M, v);
        };
        return function(M, v) {
          function u() {
            this.constructor = M;
          }
          N(M, v), M.prototype = v === null ? Object.create(v) : (u.prototype = v.prototype, new u());
        };
      }(), $ = Z.addEvent, U = Z.extend, W = Z.merge;
      return Z = function(N) {
        function M() {
          var v = N !== null && N.apply(this, arguments) || this;
          return v.data = void 0, v.options = void 0, v.points = void 0, v;
        }
        return H(M, N), M.prototype.applyJitter = function() {
          var v = this, u = this.options.jitter, d = this.points.length;
          u && this.points.forEach(function(P, O) {
            ["x", "y"].forEach(function(B, C) {
              var b = "plot" + B.toUpperCase();
              if (u[B] && !P.isNull) {
                var w = v[B + "Axis"], x = u[B] * w.transA;
                if (w && !w.isLog) {
                  var h = Math.max(0, P[b] - x);
                  w = Math.min(w.len, P[b] + x), C = 1e4 * Math.sin(O + C * d), P[b] = h + (w - h) * (C - Math.floor(C)), B === "x" && (P.clientX = P.plotX);
                }
              }
            });
          });
        }, M.prototype.drawGraph = function() {
          this.options.lineWidth ? N.prototype.drawGraph.call(this) : this.graph && (this.graph = this.graph.destroy());
        }, M.defaultOptions = W(R.defaultOptions, { lineWidth: 0, findNearestPointBy: "xy", jitter: { x: 0, y: 0 }, marker: { enabled: !0 }, tooltip: {
          headerFormat: '<span style="color:{point.color}">●</span> <span style="font-size: 10px"> {series.name}</span><br/>',
          pointFormat: "x: <b>{point.x}</b><br/>y: <b>{point.y}</b><br/>"
        } }), M;
      }(R), U(Z.prototype, { drawTracker: y.prototype.drawTracker, sorted: !1, requireSorting: !1, noSharedTooltip: !0, trackerGroups: ["group", "markerGroup", "dataLabelsGroup"], takeOrdinalPosition: !1 }), $(Z, "afterTranslate", function() {
        this.applyJitter();
      }), I.registerSeriesType("scatter", Z), Z;
    }), E(a, "Series/CenteredUtilities.js", [a["Core/Globals.js"], a["Core/Series/Series.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = y.deg2rad, H = I.isNumber, $ = I.pick, U = I.relativeLength, W;
      return function(N) {
        N.getCenter = function() {
          var M = this.options, v = this.chart, u = 2 * (M.slicedOffset || 0), d = v.plotWidth - 2 * u, P = v.plotHeight - 2 * u, O = M.center, B = Math.min(d, P), C = M.size, b = M.innerSize || 0;
          for (typeof C == "string" && (C = parseFloat(C)), typeof b == "string" && (b = parseFloat(b)), M = [$(O[0], "50%"), $(O[1], "50%"), $(C && 0 > C ? void 0 : M.size, "100%"), $(b && 0 > b ? void 0 : M.innerSize || 0, "0%")], !v.angular || this instanceof R || (M[3] = 0), O = 0; 4 > O; ++O)
            C = M[O], v = 2 > O || O === 2 && /%$/.test(C), M[O] = U(C, [d, P, B, M[2]][O]) + (v ? u : 0);
          return M[3] > M[2] && (M[3] = M[2]), M;
        }, N.getStartAndEndRadians = function(M, v) {
          return M = H(M) ? M : 0, v = H(v) && v > M && 360 > v - M ? v : M + 360, { start: Z * (M + -90), end: Z * (v + -90) };
        };
      }(W || (W = {})), W;
    }), E(a, "Series/Pie/PiePoint.js", [a["Core/Animation/AnimationUtilities.js"], a["Core/Series/Point.js"], a["Core/Utilities.js"]], function(y, R, I) {
      var Z = this && this.__extends || function() {
        var v = function(u, d) {
          return v = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(P, O) {
            P.__proto__ = O;
          } || function(P, O) {
            for (var B in O)
              O.hasOwnProperty(B) && (P[B] = O[B]);
          }, v(u, d);
        };
        return function(u, d) {
          function P() {
            this.constructor = u;
          }
          v(u, d), u.prototype = d === null ? Object.create(d) : (P.prototype = d.prototype, new P());
        };
      }(), H = y.setAnimation, $ = I.addEvent, U = I.defined;
      y = I.extend;
      var W = I.isNumber, N = I.pick, M = I.relativeLength;
      return R = function(v) {
        function u() {
          var d = v !== null && v.apply(this, arguments) || this;
          return d.labelDistance = void 0, d.options = void 0, d.series = void 0, d;
        }
        return Z(u, v), u.prototype.getConnectorPath = function() {
          var d = this.labelPosition, P = this.series.options.dataLabels, O = this.connectorShapes, B = P.connectorShape;
          return O[B] && (B = O[B]), B.call(this, { x: d.final.x, y: d.final.y, alignment: d.alignment }, d.connectorPosition, P);
        }, u.prototype.getTranslate = function() {
          return this.sliced ? this.slicedTranslation : { translateX: 0, translateY: 0 };
        }, u.prototype.haloPath = function(d) {
          var P = this.shapeArgs;
          return this.sliced || !this.visible ? [] : this.series.chart.renderer.symbols.arc(P.x, P.y, P.r + d, P.r + d, { innerR: P.r - 1, start: P.start, end: P.end });
        }, u.prototype.init = function() {
          var d = this;
          v.prototype.init.apply(
            this,
            arguments
          ), this.name = N(this.name, "Slice");
          var P = function(O) {
            d.slice(O.type === "select");
          };
          return $(this, "select", P), $(this, "unselect", P), this;
        }, u.prototype.isValid = function() {
          return W(this.y) && 0 <= this.y;
        }, u.prototype.setVisible = function(d, P) {
          var O = this, B = this.series, C = B.chart, b = B.options.ignoreHiddenPoint;
          P = N(P, b), d !== this.visible && (this.visible = this.options.visible = d = typeof d > "u" ? !this.visible : d, B.options.data[B.data.indexOf(this)] = this.options, ["graphic", "dataLabel", "connector", "shadowGroup"].forEach(function(w) {
            O[w] && O[w][d ? "show" : "hide"](d);
          }), this.legendItem && C.legend.colorizeItem(this, d), d || this.state !== "hover" || this.setState(""), b && (B.isDirty = !0), P && C.redraw());
        }, u.prototype.slice = function(d, P, O) {
          var B = this.series;
          H(O, B.chart), N(P, !0), this.sliced = this.options.sliced = U(d) ? d : !this.sliced, B.options.data[B.data.indexOf(this)] = this.options, this.graphic && this.graphic.animate(this.getTranslate()), this.shadowGroup && this.shadowGroup.animate(this.getTranslate());
        }, u;
      }(R), y(R.prototype, { connectorShapes: { fixedOffset: function(v, u, d) {
        var P = u.breakAt;
        return u = u.touchingSliceAt, [["M", v.x, v.y], d.softConnector ? ["C", v.x + (v.alignment === "left" ? -5 : 5), v.y, 2 * P.x - u.x, 2 * P.y - u.y, P.x, P.y] : ["L", P.x, P.y], ["L", u.x, u.y]];
      }, straight: function(v, u) {
        return u = u.touchingSliceAt, [["M", v.x, v.y], ["L", u.x, u.y]];
      }, crookedLine: function(v, u, d) {
        u = u.touchingSliceAt;
        var P = this.series, O = P.center[0], B = P.chart.plotWidth, C = P.chart.plotLeft;
        P = v.alignment;
        var b = this.shapeArgs.r;
        return d = M(d.crookDistance, 1), B = P === "left" ? O + b + (B + C - O - b) * (1 - d) : C + (O - b) * d, d = ["L", B, v.y], O = !0, (P === "left" ? B > v.x || B < u.x : B < v.x || B > u.x) && (O = !1), v = [["M", v.x, v.y]], O && v.push(d), v.push(["L", u.x, u.y]), v;
      } } }), R;
    }), E(a, "Series/Pie/PieSeries.js", [a["Series/CenteredUtilities.js"], a["Series/Column/ColumnSeries.js"], a["Core/Globals.js"], a["Core/Legend/LegendSymbol.js"], a["Series/Pie/PiePoint.js"], a["Core/Series/Series.js"], a["Core/Series/SeriesRegistry.js"], a["Core/Renderer/SVG/Symbols.js"], a["Core/Utilities.js"]], function(y, R, I, Z, H, $, U, W, N) {
      var M = this && this.__extends || function() {
        var b = function(w, x) {
          return b = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(h, c) {
            h.__proto__ = c;
          } || function(h, c) {
            for (var p in c)
              c.hasOwnProperty(p) && (h[p] = c[p]);
          }, b(w, x);
        };
        return function(w, x) {
          function h() {
            this.constructor = w;
          }
          b(w, x), w.prototype = x === null ? Object.create(x) : (h.prototype = x.prototype, new h());
        };
      }(), v = y.getStartAndEndRadians;
      I = I.noop;
      var u = N.clamp, d = N.extend, P = N.fireEvent, O = N.merge, B = N.pick, C = N.relativeLength;
      return N = function(b) {
        function w() {
          var x = b !== null && b.apply(this, arguments) || this;
          return x.center = void 0, x.data = void 0, x.maxLabelDistance = void 0, x.options = void 0, x.points = void 0, x;
        }
        return M(w, b), w.prototype.animate = function(x) {
          var h = this, c = h.points, p = h.startAngleRad;
          x || c.forEach(function(i) {
            var l = i.graphic, s = i.shapeArgs;
            l && s && (l.attr({ r: B(i.startR, h.center && h.center[3] / 2), start: p, end: p }), l.animate({ r: s.r, start: s.start, end: s.end }, h.options.animation));
          });
        }, w.prototype.drawEmpty = function() {
          var x = this.startAngleRad, h = this.endAngleRad, c = this.options;
          if (this.total === 0 && this.center) {
            var p = this.center[0], i = this.center[1];
            this.graph || (this.graph = this.chart.renderer.arc(p, i, this.center[1] / 2, 0, x, h).addClass("highcharts-empty-series").add(this.group)), this.graph.attr({ d: W.arc(p, i, this.center[2] / 2, 0, { start: x, end: h, innerR: this.center[3] / 2 }) }), this.chart.styledMode || this.graph.attr({ "stroke-width": c.borderWidth, fill: c.fillColor || "none", stroke: c.color || "#cccccc" });
          } else
            this.graph && (this.graph = this.graph.destroy());
        }, w.prototype.drawPoints = function() {
          var x = this.chart.renderer;
          this.points.forEach(function(h) {
            h.graphic && h.hasNewShapeType() && (h.graphic = h.graphic.destroy()), h.graphic || (h.graphic = x[h.shapeType](h.shapeArgs).add(h.series.group), h.delayedRendering = !0);
          });
        }, w.prototype.generatePoints = function() {
          b.prototype.generatePoints.call(this), this.updateTotals();
        }, w.prototype.getX = function(x, h, c) {
          var p = this.center, i = this.radii ? this.radii[c.index] || 0 : p[2] / 2;
          return x = Math.asin(u((x - p[1]) / (i + c.labelDistance), -1, 1)), p[0] + (h ? -1 : 1) * Math.cos(x) * (i + c.labelDistance) + (0 < c.labelDistance ? (h ? -1 : 1) * this.options.dataLabels.padding : 0);
        }, w.prototype.hasData = function() {
          return !!this.processedXData.length;
        }, w.prototype.redrawPoints = function() {
          var x = this, h = x.chart, c = h.renderer, p = x.options.shadow, i, l, s, t;
          this.drawEmpty(), !p || x.shadowGroup || h.styledMode || (x.shadowGroup = c.g("shadow").attr({ zIndex: -1 }).add(x.group)), x.points.forEach(function(n) {
            var o = {};
            if (l = n.graphic, !n.isNull && l) {
              var A = void 0;
              t = n.shapeArgs, i = n.getTranslate(), h.styledMode || (A = n.shadowGroup, p && !A && (A = n.shadowGroup = c.g("shadow").add(x.shadowGroup)), A && A.attr(i), s = x.pointAttribs(n, n.selected && "select")), n.delayedRendering ? (l.setRadialReference(x.center).attr(t).attr(i), h.styledMode || l.attr(s).attr({ "stroke-linejoin": "round" }).shadow(p, A), n.delayedRendering = !1) : (l.setRadialReference(x.center), h.styledMode || O(!0, o, s), O(!0, o, t, i), l.animate(o)), l.attr({ visibility: n.visible ? "inherit" : "hidden" }), l.addClass(n.getClassName(), !0);
            } else
              l && (n.graphic = l.destroy());
          });
        }, w.prototype.sortByAngle = function(x, h) {
          x.sort(function(c, p) {
            return typeof c.angle < "u" && (p.angle - c.angle) * h;
          });
        }, w.prototype.translate = function(x) {
          this.generatePoints();
          var h = this.options, c = h.slicedOffset, p = c + (h.borderWidth || 0), i = v(h.startAngle, h.endAngle), l = this.startAngleRad = i.start;
          i = (this.endAngleRad = i.end) - l;
          var s = this.points, t = h.dataLabels.distance;
          h = h.ignoreHiddenPoint;
          var n = s.length, o, A = 0;
          for (x || (this.center = x = this.getCenter()), o = 0; o < n; o++) {
            var _ = s[o], D = l + A * i;
            !_.isValid() || h && !_.visible || (A += _.percentage / 100);
            var j = l + A * i, T = { x: x[0], y: x[1], r: x[2] / 2, innerR: x[3] / 2, start: Math.round(1e3 * D) / 1e3, end: Math.round(1e3 * j) / 1e3 };
            _.shapeType = "arc", _.shapeArgs = T, _.labelDistance = B(_.options.dataLabels && _.options.dataLabels.distance, t), _.labelDistance = C(_.labelDistance, T.r), this.maxLabelDistance = Math.max(this.maxLabelDistance || 0, _.labelDistance), j = (j + D) / 2, j > 1.5 * Math.PI ? j -= 2 * Math.PI : j < -Math.PI / 2 && (j += 2 * Math.PI), _.slicedTranslation = { translateX: Math.round(Math.cos(j) * c), translateY: Math.round(Math.sin(j) * c) }, T = Math.cos(j) * x[2] / 2;
            var X = Math.sin(j) * x[2] / 2;
            _.tooltipPos = [x[0] + 0.7 * T, x[1] + 0.7 * X], _.half = j < -Math.PI / 2 || j > Math.PI / 2 ? 1 : 0, _.angle = j, D = Math.min(p, _.labelDistance / 5), _.labelPosition = { natural: { x: x[0] + T + Math.cos(j) * _.labelDistance, y: x[1] + X + Math.sin(j) * _.labelDistance }, final: {}, alignment: 0 > _.labelDistance ? "center" : _.half ? "right" : "left", connectorPosition: { breakAt: { x: x[0] + T + Math.cos(j) * D, y: x[1] + X + Math.sin(j) * D }, touchingSliceAt: { x: x[0] + T, y: x[1] + X } } };
          }
          P(this, "afterTranslate");
        }, w.prototype.updateTotals = function() {
          var x = this.points, h = x.length, c = this.options.ignoreHiddenPoint, p, i = 0;
          for (p = 0; p < h; p++) {
            var l = x[p];
            !l.isValid() || c && !l.visible || (i += l.y);
          }
          for (this.total = i, p = 0; p < h; p++)
            l = x[p], l.percentage = 0 < i && (l.visible || !c) ? l.y / i * 100 : 0, l.total = i;
        }, w.defaultOptions = O($.defaultOptions, {
          center: [null, null],
          clip: !1,
          colorByPoint: !0,
          dataLabels: { allowOverlap: !0, connectorPadding: 5, connectorShape: "fixedOffset", crookDistance: "70%", distance: 30, enabled: !0, formatter: function() {
            return this.point.isNull ? void 0 : this.point.name;
          }, softConnector: !0, x: 0 },
          fillColor: void 0,
          ignoreHiddenPoint: !0,
          inactiveOtherPoints: !0,
          legendType: "point",
          marker: null,
          size: null,
          showInLegend: !1,
          slicedOffset: 10,
          stickyTracking: !1,
          tooltip: { followPointer: !0 },
          borderColor: "#ffffff",
          borderWidth: 1,
          lineWidth: void 0,
          states: { hover: { brightness: 0.1 } }
        }), w;
      }($), d(N.prototype, { axisTypes: [], directTouch: !0, drawGraph: void 0, drawLegendSymbol: Z.drawRectangle, drawTracker: R.prototype.drawTracker, getCenter: y.getCenter, getSymbol: I, isCartesian: !1, noSharedTooltip: !0, pointAttribs: R.prototype.pointAttribs, pointClass: H, requireSorting: !1, searchPoint: I, trackerGroups: ["group", "dataLabelsGroup"] }), U.registerSeriesType("pie", N), N;
    }), E(a, "Series/Pie/PieDataLabel.js", [
      a["Core/Series/DataLabel.js"],
      a["Core/Globals.js"],
      a["Core/Renderer/RendererUtilities.js"],
      a["Core/Series/SeriesRegistry.js"],
      a["Core/Utilities.js"]
    ], function(y, R, I, Z, H) {
      var $ = R.noop, U = I.distribute, W = Z.series, N = H.arrayMax, M = H.clamp, v = H.defined, u = H.merge, d = H.pick, P = H.relativeLength, O;
      return function(B) {
        function C() {
          var c = this, p = c.data, i = c.chart, l = c.options.dataLabels || {}, s = l.connectorPadding, t = i.plotWidth, n = i.plotHeight, o = i.plotLeft, A = Math.round(i.chartWidth / 3), _ = c.center, D = _[2] / 2, j = _[1], T = [[], []], X = [0, 0, 0, 0], f = c.dataLabelPositioners, m, L, Y, F, Q, k, G, z, V, q, it, et;
          c.visible && (l.enabled || c._hasPointLabels) && (p.forEach(function(nt) {
            nt.dataLabel && nt.visible && nt.dataLabel.shortened && (nt.dataLabel.attr({ width: "auto" }).css({ width: "auto", textOverflow: "clip" }), nt.dataLabel.shortened = !1);
          }), W.prototype.drawDataLabels.apply(c), p.forEach(function(nt) {
            nt.dataLabel && (nt.visible ? (T[nt.half].push(nt), nt.dataLabel._pos = null, !v(l.style.width) && !v(nt.options.dataLabels && nt.options.dataLabels.style && nt.options.dataLabels.style.width) && nt.dataLabel.getBBox().width > A && (nt.dataLabel.css({ width: Math.round(0.7 * A) + "px" }), nt.dataLabel.shortened = !0)) : (nt.dataLabel = nt.dataLabel.destroy(), nt.dataLabels && nt.dataLabels.length === 1 && delete nt.dataLabels));
          }), T.forEach(function(nt, rt) {
            var ct = nt.length, gt = [], dt;
            if (ct) {
              if (c.sortByAngle(nt, rt - 0.5), 0 < c.maxLabelDistance) {
                var lt = Math.max(0, j - D - c.maxLabelDistance), at = Math.min(j + D + c.maxLabelDistance, i.plotHeight);
                nt.forEach(function(J) {
                  0 < J.labelDistance && J.dataLabel && (J.top = Math.max(0, j - D - J.labelDistance), J.bottom = Math.min(j + D + J.labelDistance, i.plotHeight), dt = J.dataLabel.getBBox().height || 21, J.distributeBox = { target: J.labelPosition.natural.y - J.top + dt / 2, size: dt, rank: J.y }, gt.push(J.distributeBox));
                }), lt = at + dt - lt, U(gt, lt, lt / 5);
              }
              for (it = 0; it < ct; it++) {
                if (m = nt[it], k = m.labelPosition, F = m.dataLabel, q = m.visible === !1 ? "hidden" : "inherit", V = lt = k.natural.y, gt && v(m.distributeBox) && (typeof m.distributeBox.pos > "u" ? q = "hidden" : (G = m.distributeBox.size, V = f.radialDistributionY(m))), delete m.positionIndex, l.justify)
                  z = f.justify(m, D, _);
                else
                  switch (l.alignTo) {
                    case "connectors":
                      z = f.alignToConnectors(nt, rt, t, o);
                      break;
                    case "plotEdges":
                      z = f.alignToPlotEdges(F, rt, t, o);
                      break;
                    default:
                      z = f.radialDistributionX(c, m, V, lt);
                  }
                F._attr = { visibility: q, align: k.alignment }, et = m.options.dataLabels || {}, F._pos = { x: z + d(et.x, l.x) + ({ left: s, right: -s }[k.alignment] || 0), y: V + d(et.y, l.y) - 10 }, k.final.x = z, k.final.y = V, d(l.crop, !0) && (Q = F.getBBox().width, lt = null, z - Q < s && rt === 1 ? (lt = Math.round(Q - z + s), X[3] = Math.max(lt, X[3])) : z + Q > t - s && rt === 0 && (lt = Math.round(z + Q - t + s), X[1] = Math.max(lt, X[1])), 0 > V - G / 2 ? X[0] = Math.max(Math.round(-V + G / 2), X[0]) : V + G / 2 > n && (X[2] = Math.max(Math.round(V + G / 2 - n), X[2])), F.sideOverflow = lt);
              }
            }
          }), N(X) === 0 || this.verifyDataLabelOverflow(X)) && (this.placeDataLabels(), this.points.forEach(function(nt) {
            if (et = u(l, nt.options.dataLabels), L = d(et.connectorWidth, 1)) {
              var rt;
              Y = nt.connector, (F = nt.dataLabel) && F._pos && nt.visible && 0 < nt.labelDistance ? (q = F._attr.visibility, (rt = !Y) && (nt.connector = Y = i.renderer.path().addClass("highcharts-data-label-connector  highcharts-color-" + nt.colorIndex + (nt.className ? " " + nt.className : "")).add(c.dataLabelsGroup), i.styledMode || Y.attr({ "stroke-width": L, stroke: et.connectorColor || nt.color || "#666666" })), Y[rt ? "attr" : "animate"]({ d: nt.getConnectorPath() }), Y.attr("visibility", q)) : Y && (nt.connector = Y.destroy());
            }
          }));
        }
        function b() {
          this.points.forEach(function(c) {
            var p = c.dataLabel, i;
            p && c.visible && ((i = p._pos) ? (p.sideOverflow && (p._attr.width = Math.max(p.getBBox().width - p.sideOverflow, 0), p.css({ width: p._attr.width + "px", textOverflow: (this.options.dataLabels.style || {}).textOverflow || "ellipsis" }), p.shortened = !0), p.attr(p._attr), p[p.moved ? "animate" : "attr"](i), p.moved = !0) : p && p.attr({ y: -9999 })), delete c.distributeBox;
          }, this);
        }
        function w(c) {
          var p = this.center, i = this.options, l = i.center, s = i.minSize || 80, t = i.size !== null;
          if (!t) {
            if (l[0] !== null)
              var n = Math.max(p[2] - Math.max(c[1], c[3]), s);
            else
              n = Math.max(p[2] - c[1] - c[3], s), p[0] += (c[3] - c[1]) / 2;
            l[1] !== null ? n = M(n, s, p[2] - Math.max(c[0], c[2])) : (n = M(n, s, p[2] - c[0] - c[2]), p[1] += (c[0] - c[2]) / 2), n < p[2] ? (p[2] = n, p[3] = Math.min(P(i.innerSize || 0, n), n), this.translate(p), this.drawDataLabels && this.drawDataLabels()) : t = !0;
          }
          return t;
        }
        var x = [], h = { radialDistributionY: function(c) {
          return c.top + c.distributeBox.pos;
        }, radialDistributionX: function(c, p, i, l) {
          return c.getX(i < p.top + 2 || i > p.bottom - 2 ? l : i, p.half, p);
        }, justify: function(c, p, i) {
          return i[0] + (c.half ? -1 : 1) * (p + c.labelDistance);
        }, alignToPlotEdges: function(c, p, i, l) {
          return c = c.getBBox().width, p ? c + l : i - c - l;
        }, alignToConnectors: function(c, p, i, l) {
          var s = 0, t;
          return c.forEach(function(n) {
            t = n.dataLabel.getBBox().width, t > s && (s = t);
          }), p ? s + l : i - s - l;
        } };
        B.compose = function(c) {
          y.compose(W), x.indexOf(c) === -1 && (x.push(c), c = c.prototype, c.dataLabelPositioners = h, c.alignDataLabel = $, c.drawDataLabels = C, c.placeDataLabels = b, c.verifyDataLabelOverflow = w);
        };
      }(O || (O = {})), O;
    }), E(a, "Extensions/OverlappingDataLabels.js", [a["Core/Chart/Chart.js"], a["Core/Utilities.js"]], function(y, R) {
      function I(M, v) {
        var u = !1;
        if (M) {
          var d = M.newOpacity;
          M.oldOpacity !== d && (M.alignAttr && M.placed ? (M[d ? "removeClass" : "addClass"]("highcharts-data-label-hidden"), u = !0, M.alignAttr.opacity = d, M[M.isOld ? "animate" : "attr"](M.alignAttr, null, function() {
            v.styledMode || M.css({ pointerEvents: d ? "auto" : "none" });
          }), H(v, "afterHideOverlappingLabel")) : M.attr({ opacity: d })), M.isOld = !0;
        }
        return u;
      }
      var Z = R.addEvent, H = R.fireEvent, $ = R.isArray, U = R.isNumber, W = R.objectEach, N = R.pick;
      Z(y, "render", function() {
        var M = this, v = [];
        (this.labelCollectors || []).forEach(function(u) {
          v = v.concat(u());
        }), (this.yAxis || []).forEach(function(u) {
          u.stacking && u.options.stackLabels && !u.options.stackLabels.allowOverlap && W(u.stacking.stacks, function(d) {
            W(d, function(P) {
              P.label && P.label.visibility !== "hidden" && v.push(P.label);
            });
          });
        }), (this.series || []).forEach(function(u) {
          var d = u.options.dataLabels;
          u.visible && (d.enabled !== !1 || u._hasPointLabels) && (d = function(P) {
            return P.forEach(function(O) {
              O.visible && ($(O.dataLabels) ? O.dataLabels : O.dataLabel ? [O.dataLabel] : []).forEach(function(B) {
                var C = B.options;
                B.labelrank = N(C.labelrank, O.labelrank, O.shapeArgs && O.shapeArgs.height), C.allowOverlap ? (B.oldOpacity = B.opacity, B.newOpacity = 1, I(B, M)) : v.push(B);
              });
            });
          }, d(u.nodes || []), d(u.points));
        }), this.hideOverlappingLabels(v);
      }), y.prototype.hideOverlappingLabels = function(M) {
        var v = this, u = M.length, d = v.renderer, P, O, B, C = !1, b = function(h) {
          var c, p = h.box ? 0 : h.padding || 0, i = c = 0, l;
          if (h && (!h.alignAttr || h.placed)) {
            var s = h.alignAttr || { x: h.attr("x"), y: h.attr("y") }, t = h.parentGroup;
            h.width || (c = h.getBBox(), h.width = c.width, h.height = c.height, c = d.fontMetrics(null, h.element).h);
            var n = h.width - 2 * p;
            return (l = { left: "0", center: "0.5", right: "1" }[h.alignValue]) ? i = +l * n : U(h.x) && Math.round(h.x) !== h.translateX && (i = h.x - h.translateX), { x: s.x + (t.translateX || 0) + p - (i || 0), y: s.y + (t.translateY || 0) + p - c, width: h.width - 2 * p, height: h.height - 2 * p };
          }
        };
        for (O = 0; O < u; O++)
          (P = M[O]) && (P.oldOpacity = P.opacity, P.newOpacity = 1, P.absoluteBox = b(P));
        for (M.sort(function(h, c) {
          return (c.labelrank || 0) - (h.labelrank || 0);
        }), O = 0; O < u; O++) {
          var w = (b = M[O]) && b.absoluteBox;
          for (P = O + 1; P < u; ++P) {
            var x = (B = M[P]) && B.absoluteBox;
            !w || !x || b === B || b.newOpacity === 0 || B.newOpacity === 0 || x.x >= w.x + w.width || x.x + x.width <= w.x || x.y >= w.y + w.height || x.y + x.height <= w.y || ((b.labelrank < B.labelrank ? b : B).newOpacity = 0);
          }
        }
        M.forEach(function(h) {
          I(h, v) && (C = !0);
        }), C && H(v, "afterHideAllOverlappingLabels");
      };
    }), E(
      a,
      "Core/Responsive.js",
      [a["Core/Utilities.js"]],
      function(y) {
        var R = y.extend, I = y.find, Z = y.isArray, H = y.isObject, $ = y.merge, U = y.objectEach, W = y.pick, N = y.splat, M = y.uniqueKey, v;
        return function(u) {
          var d = [];
          u.compose = function(O) {
            return d.indexOf(O) === -1 && (d.push(O), R(O.prototype, P.prototype)), O;
          };
          var P = function() {
            function O() {
            }
            return O.prototype.currentOptions = function(B) {
              function C(x, h, c, p) {
                var i;
                U(x, function(l, s) {
                  if (!p && -1 < b.collectionsWithUpdate.indexOf(s) && h[s])
                    for (l = N(l), c[s] = [], i = 0; i < Math.max(l.length, h[s].length); i++)
                      h[s][i] && (l[i] === void 0 ? c[s][i] = h[s][i] : (c[s][i] = {}, C(l[i], h[s][i], c[s][i], p + 1)));
                  else
                    H(l) ? (c[s] = Z(l) ? [] : {}, C(l, h[s] || {}, c[s], p + 1)) : c[s] = typeof h[s] > "u" ? null : h[s];
                });
              }
              var b = this, w = {};
              return C(B, this.options, w, 0), w;
            }, O.prototype.matchResponsiveRule = function(B, C) {
              var b = B.condition;
              (b.callback || function() {
                return this.chartWidth <= W(b.maxWidth, Number.MAX_VALUE) && this.chartHeight <= W(b.maxHeight, Number.MAX_VALUE) && this.chartWidth >= W(b.minWidth, 0) && this.chartHeight >= W(b.minHeight, 0);
              }).call(this) && C.push(B._id);
            }, O.prototype.setResponsive = function(B, C) {
              var b = this, w = this.options.responsive, x = this.currentResponsive, h = [];
              !C && w && w.rules && w.rules.forEach(function(c) {
                typeof c._id > "u" && (c._id = M()), b.matchResponsiveRule(c, h);
              }, this), C = $.apply(void 0, h.map(function(c) {
                return I((w || {}).rules || [], function(p) {
                  return p._id === c;
                });
              }).map(function(c) {
                return c && c.chartOptions;
              })), C.isResponsiveOptions = !0, h = h.toString() || void 0, h !== (x && x.ruleIds) && (x && this.update(x.undoOptions, B, !0), h ? (x = this.currentOptions(C), x.isResponsiveOptions = !0, this.currentResponsive = { ruleIds: h, mergedOptions: C, undoOptions: x }, this.update(C, B, !0)) : this.currentResponsive = void 0);
            }, O;
          }();
        }(v || (v = {})), v;
      }
    ), E(a, "masters/highcharts.src.js", [
      a["Core/Globals.js"],
      a["Core/Utilities.js"],
      a["Core/DefaultOptions.js"],
      a["Core/Animation/Fx.js"],
      a["Core/Animation/AnimationUtilities.js"],
      a["Core/Renderer/HTML/AST.js"],
      a["Core/FormatUtilities.js"],
      a["Core/Renderer/RendererUtilities.js"],
      a["Core/Renderer/SVG/SVGElement.js"],
      a["Core/Renderer/SVG/SVGRenderer.js"],
      a["Core/Renderer/HTML/HTMLElement.js"],
      a["Core/Renderer/HTML/HTMLRenderer.js"],
      a["Core/Axis/Axis.js"],
      a["Core/Axis/DateTimeAxis.js"],
      a["Core/Axis/LogarithmicAxis.js"],
      a["Core/Axis/PlotLineOrBand/PlotLineOrBand.js"],
      a["Core/Axis/Tick.js"],
      a["Core/Tooltip.js"],
      a["Core/Series/Point.js"],
      a["Core/Pointer.js"],
      a["Core/MSPointer.js"],
      a["Core/Legend/Legend.js"],
      a["Core/Chart/Chart.js"],
      a["Core/Series/Series.js"],
      a["Core/Series/SeriesRegistry.js"],
      a["Series/Column/ColumnSeries.js"],
      a["Series/Column/ColumnDataLabel.js"],
      a["Series/Pie/PieSeries.js"],
      a["Series/Pie/PieDataLabel.js"],
      a["Core/Series/DataLabel.js"],
      a["Core/Responsive.js"],
      a["Core/Color/Color.js"],
      a["Core/Time.js"]
    ], function(y, R, I, Z, H, $, U, W, N, M, v, u, d, P, O, B, C, b, w, x, h, c, p, i, l, s, t, n, o, A, _, D, j) {
      return y.animate = H.animate, y.animObject = H.animObject, y.getDeferredAnimation = H.getDeferredAnimation, y.setAnimation = H.setAnimation, y.stop = H.stop, y.timers = Z.timers, y.AST = $, y.Axis = d, y.Chart = p, y.chart = p.chart, y.Fx = Z, y.Legend = c, y.PlotLineOrBand = B, y.Point = w, y.Pointer = h.isRequired() ? h : x, y.Series = i, y.SVGElement = N, y.SVGRenderer = M, y.Tick = C, y.Time = j, y.Tooltip = b, y.Color = D, y.color = D.parse, u.compose(M), v.compose(N), y.defaultOptions = I.defaultOptions, y.getOptions = I.getOptions, y.time = I.defaultTime, y.setOptions = I.setOptions, y.dateFormat = U.dateFormat, y.format = U.format, y.numberFormat = U.numberFormat, y.addEvent = R.addEvent, y.arrayMax = R.arrayMax, y.arrayMin = R.arrayMin, y.attr = R.attr, y.clearTimeout = R.clearTimeout, y.correctFloat = R.correctFloat, y.createElement = R.createElement, y.css = R.css, y.defined = R.defined, y.destroyObjectProperties = R.destroyObjectProperties, y.discardElement = R.discardElement, y.distribute = W.distribute, y.erase = R.erase, y.error = R.error, y.extend = R.extend, y.extendClass = R.extendClass, y.find = R.find, y.fireEvent = R.fireEvent, y.getMagnitude = R.getMagnitude, y.getStyle = R.getStyle, y.inArray = R.inArray, y.isArray = R.isArray, y.isClass = R.isClass, y.isDOMElement = R.isDOMElement, y.isFunction = R.isFunction, y.isNumber = R.isNumber, y.isObject = R.isObject, y.isString = R.isString, y.keys = R.keys, y.merge = R.merge, y.normalizeTickInterval = R.normalizeTickInterval, y.objectEach = R.objectEach, y.offset = R.offset, y.pad = R.pad, y.pick = R.pick, y.pInt = R.pInt, y.relativeLength = R.relativeLength, y.removeEvent = R.removeEvent, y.seriesType = l.seriesType, y.splat = R.splat, y.stableSort = R.stableSort, y.syncTimeout = R.syncTimeout, y.timeUnits = R.timeUnits, y.uniqueKey = R.uniqueKey, y.useSerialIds = R.useSerialIds, y.wrap = R.wrap, t.compose(s), A.compose(i), P.compose(d), O.compose(d), o.compose(n), B.compose(d), _.compose(p), y;
    }), a["masters/highcharts.src.js"]._modules = a, a["masters/highcharts.src.js"];
  });
})(Yp);
var E0 = Yp.exports;
const Qn = /* @__PURE__ */ Cn(E0);
var Xp = { exports: {} };
(function(r) {
  (function(g) {
    r.exports ? (g.default = g, r.exports = g) : g(typeof Highcharts < "u" ? Highcharts : void 0);
  })(function(g) {
    function E(a, y, R, I) {
      a.hasOwnProperty(y) || (a[y] = I.apply(null, R));
    }
    g = g ? g._modules : {}, E(g, "Extensions/Pane.js", [
      g["Core/Chart/Chart.js"],
      g["Series/CenteredUtilities.js"],
      g["Core/Globals.js"],
      g["Core/Pointer.js"],
      g["Core/Utilities.js"]
    ], function(a, y, R, I, Z) {
      function H(v, u, d) {
        return Math.sqrt(Math.pow(v - d[0], 2) + Math.pow(u - d[1], 2)) <= d[2] / 2;
      }
      var $ = Z.addEvent, U = Z.extend, W = Z.merge, N = Z.pick, M = Z.splat;
      return a.prototype.collectionsWithUpdate.push("pane"), Z = function() {
        function v(u, d) {
          this.options = this.chart = this.center = this.background = void 0, this.coll = "pane", this.defaultOptions = { center: ["50%", "50%"], size: "85%", innerSize: "0%", startAngle: 0 }, this.defaultBackgroundOptions = { shape: "circle", borderWidth: 1, borderColor: "#cccccc", backgroundColor: { linearGradient: {
            x1: 0,
            y1: 0,
            x2: 0,
            y2: 1
          }, stops: [[0, "#ffffff"], [1, "#e6e6e6"]] }, from: -Number.MAX_VALUE, innerRadius: 0, to: Number.MAX_VALUE, outerRadius: "105%" }, this.init(u, d);
        }
        return v.prototype.init = function(u, d) {
          this.chart = d, this.background = [], d.pane.push(this), this.setOptions(u);
        }, v.prototype.setOptions = function(u) {
          this.options = W(this.defaultOptions, this.chart.angular ? { background: {} } : void 0, u);
        }, v.prototype.render = function() {
          var u = this.options, d = this.options.background, P = this.chart.renderer;
          if (this.group || (this.group = P.g("pane-group").attr({ zIndex: u.zIndex || 0 }).add()), this.updateCenter(), d)
            for (d = M(d), u = Math.max(d.length, this.background.length || 0), P = 0; P < u; P++)
              d[P] && this.axis ? this.renderBackground(W(this.defaultBackgroundOptions, d[P]), P) : this.background[P] && (this.background[P] = this.background[P].destroy(), this.background.splice(P, 1));
        }, v.prototype.renderBackground = function(u, d) {
          var P = "animate", O = { class: "highcharts-pane " + (u.className || "") };
          this.chart.styledMode || U(O, { fill: u.backgroundColor, stroke: u.borderColor, "stroke-width": u.borderWidth }), this.background[d] || (this.background[d] = this.chart.renderer.path().add(this.group), P = "attr"), this.background[d][P]({ d: this.axis.getPlotBandPath(u.from, u.to, u) }).attr(O);
        }, v.prototype.updateCenter = function(u) {
          this.center = (u || this.axis || {}).center = y.getCenter.call(this);
        }, v.prototype.update = function(u, d) {
          W(!0, this.options, u), this.setOptions(this.options), this.render(), this.chart.axes.forEach(function(P) {
            P.pane === this && (P.pane = null, P.update({}, d));
          }, this);
        }, v;
      }(), a.prototype.getHoverPane = function(v) {
        var u = this, d;
        return v && u.pane.forEach(function(P) {
          var O = v.chartX - u.plotLeft, B = v.chartY - u.plotTop;
          H(u.inverted ? B : O, u.inverted ? O : B, P.center) && (d = P);
        }), d;
      }, $(a, "afterIsInsidePlot", function(v) {
        this.polar && (v.isInsidePlot = this.pane.some(function(u) {
          return H(v.x, v.y, u.center);
        }));
      }), $(I, "beforeGetHoverData", function(v) {
        var u = this.chart;
        u.polar ? (u.hoverPane = u.getHoverPane(v), v.filter = function(d) {
          return d.visible && !(!v.shared && d.directTouch) && N(d.options.enableMouseTracking, !0) && (!u.hoverPane || d.xAxis.pane === u.hoverPane);
        }) : u.hoverPane = void 0;
      }), $(
        I,
        "afterGetHoverData",
        function(v) {
          var u = this.chart;
          v.hoverPoint && v.hoverPoint.plotX && v.hoverPoint.plotY && u.hoverPane && !H(v.hoverPoint.plotX, v.hoverPoint.plotY, u.hoverPane.center) && (v.hoverPoint = void 0);
        }
      ), R.Pane = Z, R.Pane;
    }), E(g, "Core/Axis/RadialAxis.js", [g["Core/Axis/AxisDefaults.js"], g["Core/DefaultOptions.js"], g["Core/Globals.js"], g["Core/Utilities.js"]], function(a, y, R, I) {
      var Z = y.defaultOptions, H = R.noop, $ = I.addEvent, U = I.correctFloat, W = I.defined, N = I.extend, M = I.fireEvent, v = I.merge, u = I.pick, d = I.relativeLength, P = I.wrap, O;
      return function(B) {
        function C() {
          this.autoConnect = this.isCircular && typeof u(this.userMax, this.options.max) > "u" && U(this.endAngleRad - this.startAngleRad) === U(2 * Math.PI), !this.isCircular && this.chart.inverted && this.max++, this.autoConnect && (this.max += this.categories && 1 || this.pointRange || this.closestPointRange || 0);
        }
        function b() {
          var V = this;
          return function() {
            if (V.isRadial && V.tickPositions && V.options.labels && V.options.labels.allowOverlap !== !0)
              return V.tickPositions.map(function(q) {
                return V.ticks[q] && V.ticks[q].label;
              }).filter(function(q) {
                return !!q;
              });
          };
        }
        function w() {
          return H;
        }
        function x(V, q, it) {
          var et = this.pane.center, nt = V.value;
          if (this.isCircular) {
            if (W(nt))
              V.point && (rt = V.point.shapeArgs || {}, rt.start && (nt = this.chart.inverted ? this.translate(V.point.rectPlotY, !0) : V.point.x));
            else {
              var rt = V.chartX || 0, ct = V.chartY || 0;
              nt = this.translate(Math.atan2(ct - it, rt - q) - this.startAngleRad, !0);
            }
            V = this.getPosition(nt), rt = V.x, ct = V.y;
          } else
            W(nt) || (rt = V.chartX, ct = V.chartY), W(rt) && W(ct) && (it = et[1] + this.chart.plotTop, nt = this.translate(Math.min(Math.sqrt(Math.pow(rt - q, 2) + Math.pow(ct - it, 2)), et[2] / 2) - et[3] / 2, !0));
          return [nt, rt || 0, ct || 0];
        }
        function h(V, q, it) {
          V = this.pane.center;
          var et = this.chart, nt = this.left || 0, rt = this.top || 0, ct = u(q, V[2] / 2 - this.offset);
          return typeof it > "u" && (it = this.horiz ? 0 : this.center && -this.center[3] / 2), it && (ct += it), this.isCircular || typeof q < "u" ? (q = this.chart.renderer.symbols.arc(nt + V[0], rt + V[1], ct, ct, { start: this.startAngleRad, end: this.endAngleRad, open: !0, innerR: 0 }), q.xBounds = [nt + V[0]], q.yBounds = [rt + V[1] - ct]) : (q = this.postTranslate(this.angleRad, ct), q = [["M", this.center[0] + et.plotLeft, this.center[1] + et.plotTop], ["L", q.x, q.y]]), q;
        }
        function c() {
          this.constructor.prototype.getOffset.call(this), this.chart.axisOffset[this.side] = 0;
        }
        function p(V, q, it) {
          var et = this.chart, nt = function(yt) {
            if (typeof yt == "string") {
              var vt = parseInt(yt, 10);
              return J.test(yt) && (vt = vt * gt / 100), vt;
            }
            return yt;
          }, rt = this.center, ct = this.startAngleRad, gt = rt[2] / 2, dt = Math.min(this.offset, 0), lt = this.left || 0, at = this.top || 0, J = /%$/, tt = this.isCircular, st = u(nt(it.outerRadius), gt), ht = nt(it.innerRadius);
          if (nt = u(nt(it.thickness), 10), this.options.gridLineInterpolation === "polygon")
            dt = this.getPlotLinePath({ value: V }).concat(this.getPlotLinePath({ value: q, reverse: !0 }));
          else {
            if (V = Math.max(V, this.min), q = Math.min(q, this.max), V = this.translate(V), q = this.translate(q), tt || (st = V || 0, ht = q || 0), it.shape !== "circle" && tt)
              it = ct + (V || 0), ct += q || 0;
            else {
              it = -Math.PI / 2, ct = 1.5 * Math.PI;
              var pt = !0;
            }
            st -= dt, dt = et.renderer.symbols.arc(lt + rt[0], at + rt[1], st, st, { start: Math.min(it, ct), end: Math.max(it, ct), innerR: u(ht, st - (nt - dt)), open: pt }), tt && (tt = (ct + it) / 2, lt = lt + rt[0] + rt[2] / 2 * Math.cos(tt), dt.xBounds = tt > -Math.PI / 2 && tt < Math.PI / 2 ? [lt, et.plotWidth] : [0, lt], dt.yBounds = [at + rt[1] + rt[2] / 2 * Math.sin(tt)], dt.yBounds[0] += tt > -Math.PI && 0 > tt || tt > Math.PI ? -10 : 10);
          }
          return dt;
        }
        function i(V) {
          var q = this, it = this.pane.center, et = this.chart, nt = et.inverted, rt = V.reverse, ct = this.pane.options.background ? this.pane.options.background[0] || this.pane.options.background : {}, gt = ct.innerRadius || "0%", dt = ct.outerRadius || "100%", lt = it[0] + et.plotLeft, at = it[1] + et.plotTop, J = this.height, tt = V.isCrosshair;
          ct = it[3] / 2;
          var st = V.value, ht, pt = this.getPosition(st), yt = pt.x;
          if (pt = pt.y, tt && (pt = this.getCrosshairPosition(V, lt, at), st = pt[0], yt = pt[1], pt = pt[2]), this.isCircular)
            st = Math.sqrt(Math.pow(yt - lt, 2) + Math.pow(pt - at, 2)), rt = typeof gt == "string" ? d(gt, 1) : gt / st, et = typeof dt == "string" ? d(dt, 1) : dt / st, it && ct && (ct /= st, rt < ct && (rt = ct), et < ct && (et = ct)), it = [["M", lt + rt * (yt - lt), at - rt * (at - pt)], ["L", yt - (1 - et) * (yt - lt), pt + (1 - et) * (at - pt)]];
          else if ((st = this.translate(st)) && (0 > st || st > J) && (st = 0), this.options.gridLineInterpolation === "circle")
            it = this.getLinePath(0, st, ct);
          else if (it = [], et[nt ? "yAxis" : "xAxis"].forEach(function(vt) {
            vt.pane === q.pane && (ht = vt);
          }), ht)
            for (lt = ht.tickPositions, ht.autoConnect && (lt = lt.concat([lt[0]])), rt && (lt = lt.slice().reverse()), st && (st += ct), at = 0; at < lt.length; at++)
              ct = ht.getPosition(lt[at], st), it.push(at ? ["L", ct.x, ct.y] : ["M", ct.x, ct.y]);
          return it;
        }
        function l(V, q) {
          return V = this.translate(V), this.postTranslate(this.isCircular ? V : this.angleRad, u(this.isCircular ? q : 0 > V ? 0 : V, this.center[2] / 2) - this.offset);
        }
        function s() {
          var V = this.center, q = this.chart, it = this.options.title;
          return { x: q.plotLeft + V[0] + (it.x || 0), y: q.plotTop + V[1] - { high: 0.5, middle: 0.25, low: 0 }[it.align] * V[2] + (it.y || 0) };
        }
        function t(V) {
          V.beforeSetTickPositions = C, V.createLabelCollector = b, V.getCrosshairPosition = x, V.getLinePath = h, V.getOffset = c, V.getPlotBandPath = p, V.getPlotLinePath = i, V.getPosition = l, V.getTitlePosition = s, V.postTranslate = X, V.setAxisSize = m, V.setAxisTranslation = L, V.setOptions = Y;
        }
        function n() {
          var V = this.chart, q = this.options, it = this.pane, et = it && it.options;
          V.angular && this.isXAxis || !it || !V.angular && !V.polar || (this.angleRad = (q.angle || 0) * Math.PI / 180, this.startAngleRad = (et.startAngle - 90) * Math.PI / 180, this.endAngleRad = (u(et.endAngle, et.startAngle + 360) - 90) * Math.PI / 180, this.offset = q.offset || 0);
        }
        function o(V) {
          this.isRadial && (V.align = void 0, V.preventDefault());
        }
        function A() {
          if (this.chart && this.chart.labelCollectors) {
            var V = this.labelCollector ? this.chart.labelCollectors.indexOf(this.labelCollector) : -1;
            0 <= V && this.chart.labelCollectors.splice(V, 1);
          }
        }
        function _(V) {
          var q = this.chart, it = q.inverted, et = q.angular, nt = q.polar, rt = this.isXAxis, ct = this.coll, gt = et && rt, dt = q.options;
          V = V.userOptions.pane || 0, V = this.pane = q.pane && q.pane[V];
          var lt;
          ct === "colorAxis" ? this.isRadial = !1 : (et ? (gt ? (this.isHidden = !0, this.createLabelCollector = w, this.getOffset = H, this.render = this.redraw = f, this.setTitle = this.setCategories = this.setScale = H) : t(this), (lt = !rt) && (this.defaultPolarOptions = G)) : nt && (t(this), this.defaultPolarOptions = (lt = this.horiz) ? k : v(ct === "xAxis" ? a.defaultXAxisOptions : a.defaultYAxisOptions, z), it && ct === "yAxis" && (this.defaultPolarOptions.stackLabels = a.defaultYAxisOptions.stackLabels, this.defaultPolarOptions.reversedStacks = !0)), et || nt ? (this.isRadial = !0, dt.chart.zoomType = null, this.labelCollector || (this.labelCollector = this.createLabelCollector()), this.labelCollector && q.labelCollectors.push(this.labelCollector)) : this.isRadial = !1, V && lt && (V.axis = this), this.isCircular = lt);
        }
        function D() {
          this.isRadial && this.beforeSetTickPositions();
        }
        function j(V) {
          var q = this.label;
          if (q) {
            var it = this.axis, et = q.getBBox(), nt = it.options.labels, rt = (it.translate(this.pos) + it.startAngleRad + Math.PI / 2) / Math.PI * 180 % 360, ct = Math.round(rt), gt = W(nt.y) ? 0 : 0.3 * -et.height, dt = nt.y, lt = 20, at = nt.align, J = "end", tt = 0 > ct ? ct + 360 : ct, st = tt, ht = 0, pt = 0;
            if (it.isRadial) {
              var yt = it.getPosition(this.pos, it.center[2] / 2 + d(u(nt.distance, -25), it.center[2] / 2, -it.center[2] / 2));
              nt.rotation === "auto" ? q.attr({ rotation: rt }) : W(dt) || (dt = it.chart.renderer.fontMetrics(q.styles && q.styles.fontSize).b - et.height / 2), W(at) || (it.isCircular ? (et.width > it.len * it.tickInterval / (it.max - it.min) && (lt = 0), at = rt > lt && rt < 180 - lt ? "left" : rt > 180 + lt && rt < 360 - lt ? "right" : "center") : at = "center", q.attr({ align: at })), at === "auto" && it.tickPositions.length === 2 && it.isCircular && (90 < tt && 180 > tt ? tt = 180 - tt : 270 < tt && 360 >= tt && (tt = 540 - tt), 180 < st && 360 >= st && (st = 360 - st), (it.pane.options.startAngle === ct || it.pane.options.startAngle === ct + 360 || it.pane.options.startAngle === ct - 360) && (J = "start"), at = -90 <= ct && 90 >= ct || -360 <= ct && -270 >= ct || 270 <= ct && 360 >= ct ? J === "start" ? "right" : "left" : J === "start" ? "left" : "right", 70 < st && 110 > st && (at = "center"), 15 > tt || 180 <= tt && 195 > tt ? ht = 0.3 * et.height : 15 <= tt && 35 >= tt ? ht = J === "start" ? 0 : 0.75 * et.height : 195 <= tt && 215 >= tt ? ht = J === "start" ? 0.75 * et.height : 0 : 35 < tt && 90 >= tt ? ht = J === "start" ? 0.25 * -et.height : et.height : 215 < tt && 270 >= tt && (ht = J === "start" ? et.height : 0.25 * -et.height), 15 > st ? pt = J === "start" ? 0.15 * -et.height : 0.15 * et.height : 165 < st && 180 >= st && (pt = J === "start" ? 0.15 * et.height : 0.15 * -et.height), q.attr({ align: at }), q.translate(
                pt,
                ht + gt
              )), V.pos.x = yt.x + (nt.x || 0), V.pos.y = yt.y + (dt || 0);
            }
          }
        }
        function T(V) {
          this.axis.getPosition && N(V.pos, this.axis.getPosition(this.pos));
        }
        function X(V, q) {
          var it = this.chart, et = this.center;
          return V = this.startAngleRad + V, { x: it.plotLeft + et[0] + Math.cos(V) * q, y: it.plotTop + et[1] + Math.sin(V) * q };
        }
        function f() {
          this.isDirty = !1;
        }
        function m() {
          if (this.constructor.prototype.setAxisSize.call(this), this.isRadial) {
            this.pane.updateCenter(this);
            var V = this.center = this.pane.center.slice();
            if (this.isCircular)
              this.sector = this.endAngleRad - this.startAngleRad;
            else {
              var q = this.postTranslate(this.angleRad, V[3] / 2);
              V[0] = q.x - this.chart.plotLeft, V[1] = q.y - this.chart.plotTop;
            }
            this.len = this.width = this.height = (V[2] - V[3]) * u(this.sector, 1) / 2;
          }
        }
        function L() {
          this.constructor.prototype.setAxisTranslation.call(this), this.center && (this.transA = this.isCircular ? (this.endAngleRad - this.startAngleRad) / (this.max - this.min || 1) : (this.center[2] - this.center[3]) / 2 / (this.max - this.min || 1), this.minPixelPadding = this.isXAxis ? this.transA * this.minPointOffset : 0);
        }
        function Y(V) {
          V = this.options = v(this.constructor.defaultOptions, this.defaultPolarOptions, Z[this.coll], V), V.plotBands || (V.plotBands = []), M(this, "afterSetOptions");
        }
        function F(V, q, it, et, nt, rt, ct) {
          var gt = this.axis;
          return gt.isRadial ? (V = gt.getPosition(this.pos, gt.center[2] / 2 + et), q = ["M", q, it, "L", V.x, V.y]) : q = V.call(this, q, it, et, nt, rt, ct), q;
        }
        var Q = [], k = { gridLineWidth: 1, labels: { align: void 0, distance: 15, x: 0, y: void 0, style: { textOverflow: "none" } }, maxPadding: 0, minPadding: 0, showLastLabel: !1, tickLength: 0 }, G = {
          labels: { align: "center", x: 0, y: void 0 },
          minorGridLineWidth: 0,
          minorTickInterval: "auto",
          minorTickLength: 10,
          minorTickPosition: "inside",
          minorTickWidth: 1,
          tickLength: 10,
          tickPosition: "inside",
          tickWidth: 2,
          title: { rotation: 0 },
          zIndex: 2
        }, z = { gridLineInterpolation: "circle", gridLineWidth: 1, labels: { align: "right", x: -3, y: -2 }, showLastLabel: !1, title: { x: 4, text: null, rotation: 90 } };
        B.compose = function(V, q) {
          return Q.indexOf(V) === -1 && (Q.push(V), $(V, "afterInit", n), $(V, "autoLabelAlign", o), $(V, "destroy", A), $(V, "init", _), $(V, "initialAxisTranslation", D)), Q.indexOf(q) === -1 && (Q.push(q), $(
            q,
            "afterGetLabelPosition",
            j
          ), $(q, "afterGetPosition", T), P(q.prototype, "getMarkPath", F)), V;
        };
      }(O || (O = {})), O;
    }), E(g, "Series/AreaRange/AreaRangePoint.js", [g["Series/Area/AreaSeries.js"], g["Core/Series/Point.js"], g["Core/Utilities.js"]], function(a, y, R) {
      var I = this && this.__extends || function() {
        var U = function(W, N) {
          return U = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(M, v) {
            M.__proto__ = v;
          } || function(M, v) {
            for (var u in v)
              v.hasOwnProperty(u) && (M[u] = v[u]);
          }, U(W, N);
        };
        return function(W, N) {
          function M() {
            this.constructor = W;
          }
          U(W, N), W.prototype = N === null ? Object.create(N) : (M.prototype = N.prototype, new M());
        };
      }(), Z = y.prototype, H = R.defined, $ = R.isNumber;
      return function(U) {
        function W() {
          var N = U !== null && U.apply(this, arguments) || this;
          return N.high = void 0, N.low = void 0, N.options = void 0, N.plotHigh = void 0, N.plotLow = void 0, N.plotHighX = void 0, N.plotLowX = void 0, N.plotX = void 0, N.series = void 0, N;
        }
        return I(W, U), W.prototype.setState = function() {
          var N = this.state, M = this.series, v = M.chart.polar;
          H(this.plotHigh) || (this.plotHigh = M.yAxis.toPixels(
            this.high,
            !0
          )), H(this.plotLow) || (this.plotLow = this.plotY = M.yAxis.toPixels(this.low, !0)), M.stateMarkerGraphic && (M.lowerStateMarkerGraphic = M.stateMarkerGraphic, M.stateMarkerGraphic = M.upperStateMarkerGraphic), this.graphic = this.upperGraphic, this.plotY = this.plotHigh, v && (this.plotX = this.plotHighX), Z.setState.apply(this, arguments), this.state = N, this.plotY = this.plotLow, this.graphic = this.lowerGraphic, v && (this.plotX = this.plotLowX), M.stateMarkerGraphic && (M.upperStateMarkerGraphic = M.stateMarkerGraphic, M.stateMarkerGraphic = M.lowerStateMarkerGraphic, M.lowerStateMarkerGraphic = void 0), Z.setState.apply(this, arguments);
        }, W.prototype.haloPath = function() {
          var N = this.series.chart.polar, M = [];
          return this.plotY = this.plotLow, N && (this.plotX = this.plotLowX), this.isInside && (M = Z.haloPath.apply(this, arguments)), this.plotY = this.plotHigh, N && (this.plotX = this.plotHighX), this.isTopInside && (M = M.concat(Z.haloPath.apply(this, arguments))), M;
        }, W.prototype.isValid = function() {
          return $(this.low) && $(this.high);
        }, W;
      }(a.prototype.pointClass);
    }), E(
      g,
      "Series/AreaRange/AreaRangeSeries.js",
      [g["Series/AreaRange/AreaRangePoint.js"], g["Series/Area/AreaSeries.js"], g["Series/Column/ColumnSeries.js"], g["Core/Globals.js"], g["Core/Series/Series.js"], g["Core/Series/SeriesRegistry.js"], g["Core/Utilities.js"]],
      function(a, y, R, I, Z, H, $) {
        var U = this && this.__extends || function() {
          var B = function(C, b) {
            return B = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(w, x) {
              w.__proto__ = x;
            } || function(w, x) {
              for (var h in x)
                x.hasOwnProperty(h) && (w[h] = x[h]);
            }, B(C, b);
          };
          return function(C, b) {
            function w() {
              this.constructor = C;
            }
            B(C, b), C.prototype = b === null ? Object.create(b) : (w.prototype = b.prototype, new w());
          };
        }(), W = y.prototype, N = R.prototype;
        R = I.noop;
        var M = Z.prototype, v = $.defined, u = $.extend, d = $.isArray, P = $.pick, O = $.merge;
        return Z = function(B) {
          function C() {
            var b = B !== null && B.apply(this, arguments) || this;
            return b.data = void 0, b.options = void 0, b.points = void 0, b.lowerStateMarkerGraphic = void 0, b.xAxis = void 0, b;
          }
          return U(C, B), C.prototype.toYData = function(b) {
            return [b.low, b.high];
          }, C.prototype.highToXY = function(b) {
            var w = this.chart, x = this.xAxis.postTranslate(b.rectPlotX || 0, this.yAxis.len - b.plotHigh);
            b.plotHighX = x.x - w.plotLeft, b.plotHigh = x.y - w.plotTop, b.plotLowX = b.plotX;
          }, C.prototype.translate = function() {
            var b = this, w = b.yAxis;
            W.translate.apply(b), b.points.forEach(function(x) {
              var h = x.high, c = x.plotY;
              x.isNull ? x.plotY = null : (x.plotLow = c, x.plotHigh = w.translate(b.dataModify ? b.dataModify.modifyValue(h) : h, 0, 1, 0, 1), b.dataModify && (x.yBottom = x.plotHigh));
            }), this.chart.polar && this.points.forEach(function(x) {
              b.highToXY(x), x.tooltipPos = [(x.plotHighX + x.plotLowX) / 2, (x.plotHigh + x.plotLow) / 2];
            });
          }, C.prototype.getGraphPath = function(b) {
            var w = [], x = [], h, c = W.getGraphPath, p = this.options, i = this.chart.polar, l = i && p.connectEnds !== !1, s = p.connectNulls, t = p.step;
            for (b = b || this.points, h = b.length; h--; ) {
              var n = b[h], o = i ? { plotX: n.rectPlotX, plotY: n.yBottom, doCurve: !1 } : { plotX: n.plotX, plotY: n.plotY, doCurve: !1 };
              n.isNull || l || s || b[h + 1] && !b[h + 1].isNull || x.push(o);
              var A = { polarPlotY: n.polarPlotY, rectPlotX: n.rectPlotX, yBottom: n.yBottom, plotX: P(
                n.plotHighX,
                n.plotX
              ), plotY: n.plotHigh, isNull: n.isNull };
              x.push(A), w.push(A), n.isNull || l || s || b[h - 1] && !b[h - 1].isNull || x.push(o);
            }
            return b = c.call(this, b), t && (t === !0 && (t = "left"), p.step = { left: "right", center: "center", right: "left" }[t]), w = c.call(this, w), x = c.call(this, x), p.step = t, p = [].concat(b, w), !this.chart.polar && x[0] && x[0][0] === "M" && (x[0] = ["L", x[0][1], x[0][2]]), this.graphPath = p, this.areaPath = b.concat(x), p.isArea = !0, p.xMap = b.xMap, this.areaPath.xMap = b.xMap, p;
          }, C.prototype.drawDataLabels = function() {
            var b = this.points, w = b.length, x, h = [], c = this.options.dataLabels, p, i = this.chart.inverted;
            if (c) {
              if (d(c))
                var l = c[0] || { enabled: !1 }, s = c[1] || { enabled: !1 };
              else
                l = u({}, c), l.x = c.xHigh, l.y = c.yHigh, s = u({}, c), s.x = c.xLow, s.y = c.yLow;
              if (l.enabled || this._hasPointLabels) {
                for (x = w; x--; )
                  if (p = b[x]) {
                    var t = l.inside ? p.plotHigh < p.plotLow : p.plotHigh > p.plotLow;
                    p.y = p.high, p._plotY = p.plotY, p.plotY = p.plotHigh, h[x] = p.dataLabel, p.dataLabel = p.dataLabelUpper, p.below = t, i ? l.align || (l.align = t ? "right" : "left") : l.verticalAlign || (l.verticalAlign = t ? "top" : "bottom");
                  }
                for (this.options.dataLabels = l, M.drawDataLabels && M.drawDataLabels.apply(this, arguments), x = w; x--; )
                  (p = b[x]) && (p.dataLabelUpper = p.dataLabel, p.dataLabel = h[x], delete p.dataLabels, p.y = p.low, p.plotY = p._plotY);
              }
              if (s.enabled || this._hasPointLabels) {
                for (x = w; x--; )
                  (p = b[x]) && (t = s.inside ? p.plotHigh < p.plotLow : p.plotHigh > p.plotLow, p.below = !t, i ? s.align || (s.align = t ? "left" : "right") : s.verticalAlign || (s.verticalAlign = t ? "bottom" : "top"));
                this.options.dataLabels = s, M.drawDataLabels && M.drawDataLabels.apply(this, arguments);
              }
              if (l.enabled)
                for (x = w; x--; )
                  (p = b[x]) && (p.dataLabels = [p.dataLabelUpper, p.dataLabel].filter(function(n) {
                    return !!n;
                  }));
              this.options.dataLabels = c;
            }
          }, C.prototype.alignDataLabel = function() {
            N.alignDataLabel.apply(this, arguments);
          }, C.prototype.drawPoints = function() {
            var b = this.points.length, w;
            for (M.drawPoints.apply(this, arguments), w = 0; w < b; ) {
              var x = this.points[w];
              x.origProps = { plotY: x.plotY, plotX: x.plotX, isInside: x.isInside, negative: x.negative, zone: x.zone, y: x.y }, x.lowerGraphic = x.graphic, x.graphic = x.upperGraphic, x.plotY = x.plotHigh, v(x.plotHighX) && (x.plotX = x.plotHighX), x.y = P(x.high, x.origProps.y), x.negative = x.y < (this.options.threshold || 0), this.zones.length && (x.zone = x.getZone()), this.chart.polar || (x.isInside = x.isTopInside = typeof x.plotY < "u" && 0 <= x.plotY && x.plotY <= this.yAxis.len && 0 <= x.plotX && x.plotX <= this.xAxis.len), w++;
            }
            for (M.drawPoints.apply(this, arguments), w = 0; w < b; )
              x = this.points[w], x.upperGraphic = x.graphic, x.graphic = x.lowerGraphic, x.origProps && (u(x, x.origProps), delete x.origProps), w++;
          }, C.defaultOptions = O(y.defaultOptions, {
            lineWidth: 1,
            threshold: null,
            tooltip: { pointFormat: '<span style="color:{series.color}">●</span> {series.name}: <b>{point.low}</b> - <b>{point.high}</b><br/>' },
            trackByArea: !0,
            dataLabels: { align: void 0, verticalAlign: void 0, xLow: 0, xHigh: 0, yLow: 0, yHigh: 0 }
          }), C;
        }(y), u(Z.prototype, { pointArrayMap: ["low", "high"], pointValKey: "low", deferTranslatePolar: !0, pointClass: a, setStackedPoints: R }), H.registerSeriesType("arearange", Z), Z;
      }
    ), E(g, "Series/AreaSplineRange/AreaSplineRangeSeries.js", [
      g["Series/AreaRange/AreaRangeSeries.js"],
      g["Core/Series/SeriesRegistry.js"],
      g["Core/Utilities.js"]
    ], function(a, y, R) {
      var I = this && this.__extends || function() {
        var U = function(W, N) {
          return U = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(M, v) {
            M.__proto__ = v;
          } || function(M, v) {
            for (var u in v)
              v.hasOwnProperty(u) && (M[u] = v[u]);
          }, U(W, N);
        };
        return function(W, N) {
          function M() {
            this.constructor = W;
          }
          U(W, N), W.prototype = N === null ? Object.create(N) : (M.prototype = N.prototype, new M());
        };
      }(), Z = y.seriesTypes.spline, H = R.merge;
      R = R.extend;
      var $ = function(U) {
        function W() {
          var N = U !== null && U.apply(this, arguments) || this;
          return N.options = void 0, N.data = void 0, N.points = void 0, N;
        }
        return I(W, U), W.defaultOptions = H(a.defaultOptions), W;
      }(a);
      return R($.prototype, { getPointSpline: Z.prototype.getPointSpline }), y.registerSeriesType("areasplinerange", $), $;
    }), E(g, "Series/BoxPlot/BoxPlotSeries.js", [g["Series/Column/ColumnSeries.js"], g["Core/Globals.js"], g["Core/Series/SeriesRegistry.js"], g["Core/Utilities.js"]], function(a, y, R, I) {
      var Z = this && this.__extends || function() {
        var W = function(N, M) {
          return W = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(v, u) {
            v.__proto__ = u;
          } || function(v, u) {
            for (var d in u)
              u.hasOwnProperty(d) && (v[d] = u[d]);
          }, W(N, M);
        };
        return function(N, M) {
          function v() {
            this.constructor = N;
          }
          W(N, M), N.prototype = M === null ? Object.create(M) : (v.prototype = M.prototype, new v());
        };
      }();
      y = y.noop;
      var H = I.extend, $ = I.merge, U = I.pick;
      return I = function(W) {
        function N() {
          var M = W !== null && W.apply(this, arguments) || this;
          return M.data = void 0, M.options = void 0, M.points = void 0, M;
        }
        return Z(N, W), N.prototype.pointAttribs = function() {
          return {};
        }, N.prototype.translate = function() {
          var M = this.yAxis, v = this.pointArrayMap;
          W.prototype.translate.apply(this), this.points.forEach(function(u) {
            v.forEach(function(d) {
              u[d] !== null && (u[d + "Plot"] = M.translate(u[d], 0, 1, 0, 1));
            }), u.plotHigh = u.highPlot;
          });
        }, N.prototype.drawPoints = function() {
          var M = this, v = M.options, u = M.chart, d = u.renderer, P, O, B, C, b, w, x = 0, h, c, p, i, l = M.doQuartiles !== !1, s, t = M.options.whiskerLength;
          M.points.forEach(function(n) {
            var o = n.graphic, A = o ? "animate" : "attr", _ = n.shapeArgs, D = {}, j = {}, T = {}, X = {}, f = n.color || M.color;
            typeof n.plotY < "u" && (h = Math.round(_.width), c = Math.floor(_.x), p = c + h, i = Math.round(h / 2), P = Math.floor(l ? n.q1Plot : n.lowPlot), O = Math.floor(l ? n.q3Plot : n.lowPlot), B = Math.floor(n.highPlot), C = Math.floor(n.lowPlot), o || (n.graphic = o = d.g("point").add(M.group), n.stem = d.path().addClass("highcharts-boxplot-stem").add(o), t && (n.whiskers = d.path().addClass("highcharts-boxplot-whisker").add(o)), l && (n.box = d.path(void 0).addClass("highcharts-boxplot-box").add(o)), n.medianShape = d.path(void 0).addClass("highcharts-boxplot-median").add(o)), u.styledMode || (j.stroke = n.stemColor || v.stemColor || f, j["stroke-width"] = U(n.stemWidth, v.stemWidth, v.lineWidth), j.dashstyle = n.stemDashStyle || v.stemDashStyle || v.dashStyle, n.stem.attr(j), t && (T.stroke = n.whiskerColor || v.whiskerColor || f, T["stroke-width"] = U(n.whiskerWidth, v.whiskerWidth, v.lineWidth), T.dashstyle = n.whiskerDashStyle || v.whiskerDashStyle || v.dashStyle, n.whiskers.attr(T)), l && (D.fill = n.fillColor || v.fillColor || f, D.stroke = v.lineColor || f, D["stroke-width"] = v.lineWidth || 0, D.dashstyle = n.boxDashStyle || v.boxDashStyle || v.dashStyle, n.box.attr(D)), X.stroke = n.medianColor || v.medianColor || f, X["stroke-width"] = U(n.medianWidth, v.medianWidth, v.lineWidth), X.dashstyle = n.medianDashStyle || v.medianDashStyle || v.dashStyle, n.medianShape.attr(X)), w = n.stem.strokeWidth() % 2 / 2, x = c + i + w, o = [["M", x, O], ["L", x, B], ["M", x, P], ["L", x, C]], n.stem[A]({ d: o }), l && (w = n.box.strokeWidth() % 2 / 2, P = Math.floor(P) + w, O = Math.floor(O) + w, c += w, p += w, o = [["M", c, O], ["L", c, P], ["L", p, P], ["L", p, O], ["L", c, O], ["Z"]], n.box[A]({ d: o })), t && (w = n.whiskers.strokeWidth() % 2 / 2, B += w, C += w, s = /%$/.test(t) ? i * parseFloat(t) / 100 : t / 2, o = [["M", x - s, B], ["L", x + s, B], ["M", x - s, C], ["L", x + s, C]], n.whiskers[A]({ d: o })), b = Math.round(n.medianPlot), w = n.medianShape.strokeWidth() % 2 / 2, b += w, o = [["M", c, b], ["L", p, b]], n.medianShape[A]({ d: o }));
          });
        }, N.prototype.toYData = function(M) {
          return [M.low, M.q1, M.median, M.q3, M.high];
        }, N.defaultOptions = $(a.defaultOptions, {
          threshold: null,
          tooltip: { pointFormat: '<span style="color:{point.color}">●</span> <b> {series.name}</b><br/>Maximum: {point.high}<br/>Upper quartile: {point.q3}<br/>Median: {point.median}<br/>Lower quartile: {point.q1}<br/>Minimum: {point.low}<br/>' },
          whiskerLength: "50%",
          fillColor: "#ffffff",
          lineWidth: 1,
          medianWidth: 2,
          whiskerWidth: 2
        }), N;
      }(a), H(I.prototype, { pointArrayMap: ["low", "q1", "median", "q3", "high"], pointValKey: "high", drawDataLabels: y, setStackedPoints: y }), R.registerSeriesType("boxplot", I), I;
    }), E(g, "Series/Bubble/BubbleLegendDefaults.js", [], function() {
      return { borderColor: void 0, borderWidth: 2, className: void 0, color: void 0, connectorClassName: void 0, connectorColor: void 0, connectorDistance: 60, connectorWidth: 1, enabled: !1, labels: {
        className: void 0,
        allowOverlap: !1,
        format: "",
        formatter: void 0,
        align: "right",
        style: { fontSize: "10px", color: "#000000" },
        x: 0,
        y: 0
      }, maxSize: 60, minSize: 10, legendIndex: 0, ranges: { value: void 0, borderColor: void 0, color: void 0, connectorColor: void 0 }, sizeBy: "area", sizeByAbsoluteValue: !1, zIndex: 1, zThreshold: 0 };
    }), E(g, "Series/Bubble/BubbleLegendItem.js", [g["Core/Color/Color.js"], g["Core/FormatUtilities.js"], g["Core/Globals.js"], g["Core/Utilities.js"]], function(a, y, R, I) {
      var Z = a.parse, H = R.noop, $ = I.arrayMax, U = I.arrayMin, W = I.isNumber, N = I.merge, M = I.pick, v = I.stableSort;
      return function() {
        function u(d, P) {
          this.options = this.symbols = this.visible = this.selected = this.ranges = this.movementX = this.maxLabel = this.legendSymbol = this.legendItemWidth = this.legendItemHeight = this.legendItem = this.legendGroup = this.legend = this.fontMetrics = this.chart = void 0, this.setState = H, this.init(d, P);
        }
        return u.prototype.init = function(d, P) {
          this.options = d, this.visible = !0, this.chart = P.chart, this.legend = P;
        }, u.prototype.addToLegend = function(d) {
          d.splice(
            this.options.legendIndex,
            0,
            this
          );
        }, u.prototype.drawLegendSymbol = function(d) {
          var P = this.chart, O = this.options, B = M(d.options.itemDistance, 20), C = O.ranges, b = O.connectorDistance;
          this.fontMetrics = P.renderer.fontMetrics(O.labels.style.fontSize), C && C.length && W(C[0].value) ? (v(C, function(w, x) {
            return x.value - w.value;
          }), this.ranges = C, this.setOptions(), this.render(), d = this.getMaxLabelSize(), C = this.ranges[0].radius, P = 2 * C, b = b - C + d.width, b = 0 < b ? b : 0, this.maxLabel = d, this.movementX = O.labels.align === "left" ? b : 0, this.legendItemWidth = P + b + B, this.legendItemHeight = P + this.fontMetrics.h / 2) : d.options.bubbleLegend.autoRanges = !0;
        }, u.prototype.setOptions = function() {
          var d = this.ranges, P = this.options, O = this.chart.series[P.seriesIndex], B = this.legend.baseline, C = { zIndex: P.zIndex, "stroke-width": P.borderWidth }, b = { zIndex: P.zIndex, "stroke-width": P.connectorWidth }, w = { align: this.legend.options.rtl || P.labels.align === "left" ? "right" : "left", zIndex: P.zIndex }, x = O.options.marker.fillOpacity, h = this.chart.styledMode;
          d.forEach(function(c, p) {
            h || (C.stroke = M(c.borderColor, P.borderColor, O.color), C.fill = M(c.color, P.color, x !== 1 ? Z(O.color).setOpacity(x).get("rgba") : O.color), b.stroke = M(c.connectorColor, P.connectorColor, O.color)), d[p].radius = this.getRangeRadius(c.value), d[p] = N(d[p], { center: d[0].radius - d[p].radius + B }), h || N(!0, d[p], { bubbleAttribs: N(C), connectorAttribs: N(b), labelAttribs: w });
          }, this);
        }, u.prototype.getRangeRadius = function(d) {
          var P = this.options;
          return this.chart.series[this.options.seriesIndex].getRadius.call(
            this,
            P.ranges[P.ranges.length - 1].value,
            P.ranges[0].value,
            P.minSize,
            P.maxSize,
            d
          );
        }, u.prototype.render = function() {
          var d = this.chart.renderer, P = this.options.zThreshold;
          this.symbols || (this.symbols = { connectors: [], bubbleItems: [], labels: [] }), this.legendSymbol = d.g("bubble-legend"), this.legendItem = d.g("bubble-legend-item"), this.legendSymbol.translateX = 0, this.legendSymbol.translateY = 0, this.ranges.forEach(function(O) {
            O.value >= P && this.renderRange(O);
          }, this), this.legendSymbol.add(this.legendItem), this.legendItem.add(this.legendGroup), this.hideOverlappingLabels();
        }, u.prototype.renderRange = function(d) {
          var P = this.options, O = P.labels, B = this.chart, C = B.series[P.seriesIndex], b = B.renderer, w = this.symbols;
          B = w.labels;
          var x = d.center, h = Math.abs(d.radius), c = P.connectorDistance || 0, p = O.align, i = P.connectorWidth, l = this.ranges[0].radius || 0, s = x - h - P.borderWidth / 2 + i / 2, t = this.fontMetrics;
          t = t.f / 2 - (t.h - t.f) / 2;
          var n = b.styledMode;
          c = this.legend.options.rtl || p === "left" ? -c : c, p === "center" && (c = 0, P.connectorDistance = 0, d.labelAttribs.align = "center"), p = s + P.labels.y;
          var o = l + c + P.labels.x;
          w.bubbleItems.push(b.circle(
            l,
            x + ((s % 1 ? 1 : 0.5) - (i % 2 ? 0 : 0.5)),
            h
          ).attr(n ? {} : d.bubbleAttribs).addClass((n ? "highcharts-color-" + C.colorIndex + " " : "") + "highcharts-bubble-legend-symbol " + (P.className || "")).add(this.legendSymbol)), w.connectors.push(b.path(b.crispLine([["M", l, s], ["L", l + c, s]], P.connectorWidth)).attr(n ? {} : d.connectorAttribs).addClass((n ? "highcharts-color-" + this.options.seriesIndex + " " : "") + "highcharts-bubble-legend-connectors " + (P.connectorClassName || "")).add(this.legendSymbol)), d = b.text(this.formatLabel(d), o, p + t).attr(n ? {} : d.labelAttribs).css(n ? {} : O.style).addClass("highcharts-bubble-legend-labels " + (P.labels.className || "")).add(this.legendSymbol), B.push(d), d.placed = !0, d.alignAttr = { x: o, y: p + t };
        }, u.prototype.getMaxLabelSize = function() {
          var d, P;
          return this.symbols.labels.forEach(function(O) {
            P = O.getBBox(!0), d = d ? P.width > d.width ? P : d : P;
          }), d || {};
        }, u.prototype.formatLabel = function(d) {
          var P = this.options, O = P.labels.formatter;
          P = P.labels.format;
          var B = this.chart.numberFormatter;
          return P ? y.format(P, d) : O ? O.call(d) : B(d.value, 1);
        }, u.prototype.hideOverlappingLabels = function() {
          var d = this.chart, P = this.symbols;
          !this.options.labels.allowOverlap && P && (d.hideOverlappingLabels(P.labels), P.labels.forEach(function(O, B) {
            O.newOpacity ? O.newOpacity !== O.oldOpacity && P.connectors[B].show() : P.connectors[B].hide();
          }));
        }, u.prototype.getRanges = function() {
          var d = this.legend.bubbleLegend, P = d.options.ranges, O, B = Number.MAX_VALUE, C = -Number.MAX_VALUE;
          d.chart.series.forEach(function(w) {
            w.isBubble && !w.ignoreSeries && (O = w.zData.filter(W), O.length && (B = M(w.options.zMin, Math.min(B, Math.max(
              U(O),
              w.options.displayNegative === !1 ? w.options.zThreshold : -Number.MAX_VALUE
            ))), C = M(w.options.zMax, Math.max(C, $(O)))));
          });
          var b = B === C ? [{ value: C }] : [{ value: B }, { value: (B + C) / 2 }, { value: C, autoRanges: !0 }];
          return P.length && P[0].radius && b.reverse(), b.forEach(function(w, x) {
            P && P[x] && (b[x] = N(P[x], w));
          }), b;
        }, u.prototype.predictBubbleSizes = function() {
          var d = this.chart, P = this.fontMetrics, O = d.legend.options, B = O.floating, C = (O = O.layout === "horizontal") ? d.legend.lastLineHeight : 0, b = d.plotSizeX, w = d.plotSizeY, x = d.series[this.options.seriesIndex], h = x.getPxExtremes();
          d = Math.ceil(h.minPxSize), h = Math.ceil(h.maxPxSize);
          var c = Math.min(w, b);
          return x = x.options.maxSize, B || !/%$/.test(x) ? P = h : (x = parseFloat(x), P = (c + C - P.h / 2) * x / 100 / (x / 100 + 1), (O && w - P >= b || !O && b - P >= w) && (P = h)), [d, Math.ceil(P)];
        }, u.prototype.updateRanges = function(d, P) {
          var O = this.legend.options.bubbleLegend;
          O.minSize = d, O.maxSize = P, O.ranges = this.getRanges();
        }, u.prototype.correctSizes = function() {
          var d = this.legend, P = this.chart.series[this.options.seriesIndex].getPxExtremes();
          1 < Math.abs(Math.ceil(P.maxPxSize) - this.options.maxSize) && (this.updateRanges(this.options.minSize, P.maxPxSize), d.render());
        }, u;
      }();
    }), E(g, "Series/Bubble/BubbleLegendComposition.js", [g["Series/Bubble/BubbleLegendDefaults.js"], g["Series/Bubble/BubbleLegendItem.js"], g["Core/DefaultOptions.js"], g["Core/Utilities.js"]], function(a, y, R, I) {
      var Z = R.setOptions, H = I.addEvent, $ = I.objectEach, U = I.wrap, W;
      return function(N) {
        function M(C, b, w) {
          var x = this.legend, h = 0 <= v(this);
          if (x && x.options.enabled && x.bubbleLegend && x.options.bubbleLegend.autoRanges && h) {
            var c = x.bubbleLegend.options;
            h = x.bubbleLegend.predictBubbleSizes(), x.bubbleLegend.updateRanges(h[0], h[1]), c.placed || (x.group.placed = !1, x.allItems.forEach(function(p) {
              p.legendGroup.translateY = null;
            })), x.render(), this.getMargins(), this.axes.forEach(function(p) {
              p.visible && p.render(), c.placed || (p.setScale(), p.updateNames(), $(p.ticks, function(i) {
                i.isNew = !0, i.isNewLabel = !0;
              }));
            }), c.placed = !0, this.getMargins(), C.call(this, b, w), x.bubbleLegend.correctSizes(), O(x, u(x));
          } else
            C.call(this, b, w), x && x.options.enabled && x.bubbleLegend && (x.render(), O(x, u(x)));
        }
        function v(C) {
          C = C.series;
          for (var b = 0; b < C.length; ) {
            if (C[b] && C[b].isBubble && C[b].visible && C[b].zData.length)
              return b;
            b++;
          }
          return -1;
        }
        function u(C) {
          C = C.allItems;
          var b = [], w = C.length, x, h = 0;
          for (x = 0; x < w; x++)
            if (C[x].legendItemHeight && (C[x].itemHeight = C[x].legendItemHeight), C[x] === C[w - 1] || C[x + 1] && C[x]._legendItemPos[1] !== C[x + 1]._legendItemPos[1]) {
              b.push({ height: 0 });
              var c = b[b.length - 1];
              for (h; h <= x; h++)
                C[h].itemHeight > c.height && (c.height = C[h].itemHeight);
              c.step = x;
            }
          return b;
        }
        function d(C) {
          var b = this.bubbleLegend, w = this.options, x = w.bubbleLegend, h = v(this.chart);
          b && b.ranges && b.ranges.length && (x.ranges.length && (x.autoRanges = !!x.ranges[0].autoRanges), this.destroyItem(b)), 0 <= h && w.enabled && x.enabled && (x.seriesIndex = h, this.bubbleLegend = new y(x, this), this.bubbleLegend.addToLegend(C.allItems));
        }
        function P() {
          var C = this.chart, b = this.visible, w = this.chart.legend;
          w && w.bubbleLegend && (this.visible = !b, this.ignoreSeries = b, C = 0 <= v(C), w.bubbleLegend.visible !== C && (w.update({ bubbleLegend: { enabled: C } }), w.bubbleLegend.visible = C), this.visible = b);
        }
        function O(C, b) {
          var w = C.options.rtl, x, h, c, p = 0;
          C.allItems.forEach(function(i, l) {
            x = i.legendGroup.translateX, h = i._legendItemPos[1], ((c = i.movementX) || w && i.ranges) && (c = w ? x - i.options.maxSize / 2 : x + c, i.legendGroup.attr({ translateX: c })), l > b[p].step && p++, i.legendGroup.attr({ translateY: Math.round(h + b[p].height / 2) }), i._legendItemPos[1] = h + b[p].height / 2;
          });
        }
        var B = [];
        N.compose = function(C, b, w) {
          B.indexOf(C) === -1 && (B.push(C), Z({ legend: { bubbleLegend: a } }), U(C.prototype, "drawChartBox", M)), B.indexOf(b) === -1 && (B.push(b), H(b, "afterGetAllItems", d)), B.indexOf(w) === -1 && (B.push(w), H(w, "legendItemClick", P));
        };
      }(W || (W = {})), W;
    }), E(g, "Series/Bubble/BubblePoint.js", [g["Core/Series/Point.js"], g["Core/Series/SeriesRegistry.js"], g["Core/Utilities.js"]], function(a, y, R) {
      var I = this && this.__extends || function() {
        var Z = function(H, $) {
          return Z = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(U, W) {
            U.__proto__ = W;
          } || function(U, W) {
            for (var N in W)
              W.hasOwnProperty(N) && (U[N] = W[N]);
          }, Z(H, $);
        };
        return function(H, $) {
          function U() {
            this.constructor = H;
          }
          Z(H, $), H.prototype = $ === null ? Object.create($) : (U.prototype = $.prototype, new U());
        };
      }();
      return R = R.extend, y = function(Z) {
        function H() {
          var $ = Z !== null && Z.apply(this, arguments) || this;
          return $.options = void 0, $.series = void 0, $;
        }
        return I(H, Z), H.prototype.haloPath = function($) {
          return a.prototype.haloPath.call(this, $ === 0 ? 0 : (this.marker && this.marker.radius || 0) + $);
        }, H;
      }(y.seriesTypes.scatter.prototype.pointClass), R(y.prototype, { ttBelow: !1 }), y;
    }), E(g, "Series/Bubble/BubbleSeries.js", [
      g["Core/Axis/Axis.js"],
      g["Series/Bubble/BubbleLegendComposition.js"],
      g["Series/Bubble/BubblePoint.js"],
      g["Core/Color/Color.js"],
      g["Core/Globals.js"],
      g["Core/Series/Series.js"],
      g["Core/Series/SeriesRegistry.js"],
      g["Core/Utilities.js"]
    ], function(a, y, R, I, Z, H, $, U) {
      var W = this && this.__extends || function() {
        var w = function(x, h) {
          return w = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(c, p) {
            c.__proto__ = p;
          } || function(c, p) {
            for (var i in p)
              p.hasOwnProperty(i) && (c[i] = p[i]);
          }, w(x, h);
        };
        return function(x, h) {
          function c() {
            this.constructor = x;
          }
          w(x, h), x.prototype = h === null ? Object.create(h) : (c.prototype = h.prototype, new c());
        };
      }(), N = I.parse;
      I = Z.noop;
      var M = $.seriesTypes;
      Z = M.column;
      var v = M.scatter;
      M = U.addEvent;
      var u = U.arrayMax, d = U.arrayMin, P = U.clamp, O = U.extend, B = U.isNumber, C = U.merge, b = U.pick;
      return U = function(w) {
        function x() {
          var h = w !== null && w.apply(this, arguments) || this;
          return h.data = void 0, h.maxPxSize = void 0, h.minPxSize = void 0, h.options = void 0, h.points = void 0, h.radii = void 0, h.yData = void 0, h.zData = void 0, h;
        }
        return W(x, w), x.prototype.animate = function(h) {
          !h && this.points.length < this.options.animationLimit && this.points.forEach(function(c) {
            var p = c.graphic;
            p && p.width && (this.hasRendered || p.attr({ x: c.plotX, y: c.plotY, width: 1, height: 1 }), p.animate(this.markerAttribs(c), this.options.animation));
          }, this);
        }, x.prototype.getRadii = function() {
          var h = this, c = this.zData, p = this.yData, i = [], l = this.chart.bubbleZExtremes, s = this.getPxExtremes(), t = s.minPxSize, n = s.maxPxSize;
          if (!l) {
            var o = Number.MAX_VALUE, A = -Number.MAX_VALUE, _;
            this.chart.series.forEach(function(T) {
              T.bubblePadding && (T.visible || !h.chart.options.chart.ignoreHiddenSeries) && (T = T.getZExtremes()) && (o = Math.min(o || T.zMin, T.zMin), A = Math.max(A || T.zMax, T.zMax), _ = !0);
            }), _ ? (l = { zMin: o, zMax: A }, this.chart.bubbleZExtremes = l) : l = { zMin: 0, zMax: 0 };
          }
          var D = 0;
          for (s = c.length; D < s; D++) {
            var j = c[D];
            i.push(this.getRadius(l.zMin, l.zMax, t, n, j, p[D]));
          }
          this.radii = i;
        }, x.prototype.getRadius = function(h, c, p, i, l, s) {
          var t = this.options, n = t.sizeBy !== "width", o = t.zThreshold, A = c - h, _ = 0.5;
          if (s === null || l === null)
            return null;
          if (B(l)) {
            if (t.sizeByAbsoluteValue && (l = Math.abs(l - o), A = Math.max(c - o, Math.abs(h - o)), h = 0), l < h)
              return p / 2 - 1;
            0 < A && (_ = (l - h) / A);
          }
          return n && 0 <= _ && (_ = Math.sqrt(_)), Math.ceil(p + _ * (i - p)) / 2;
        }, x.prototype.hasData = function() {
          return !!this.processedXData.length;
        }, x.prototype.pointAttribs = function(h, c) {
          var p = this.options.marker.fillOpacity;
          return h = H.prototype.pointAttribs.call(this, h, c), p !== 1 && (h.fill = N(h.fill).setOpacity(p).get("rgba")), h;
        }, x.prototype.translate = function() {
          w.prototype.translate.call(this), this.getRadii(), this.translateBubble();
        }, x.prototype.translateBubble = function() {
          for (var h = this.data, c = this.radii, p = this.getPxExtremes().minPxSize, i = h.length; i--; ) {
            var l = h[i], s = c ? c[i] : 0;
            B(s) && s >= p / 2 ? (l.marker = O(l.marker, { radius: s, width: 2 * s, height: 2 * s }), l.dlBox = { x: l.plotX - s, y: l.plotY - s, width: 2 * s, height: 2 * s }) : l.shapeArgs = l.plotY = l.dlBox = void 0;
          }
        }, x.prototype.getPxExtremes = function() {
          var h = Math.min(this.chart.plotWidth, this.chart.plotHeight), c = function(i) {
            if (typeof i == "string") {
              var l = /%$/.test(i);
              i = parseInt(i, 10);
            }
            return l ? h * i / 100 : i;
          }, p = c(b(this.options.minSize, 8));
          return c = Math.max(c(b(this.options.maxSize, "20%")), p), {
            minPxSize: p,
            maxPxSize: c
          };
        }, x.prototype.getZExtremes = function() {
          var h = this.options, c = (this.zData || []).filter(B);
          if (c.length) {
            var p = b(h.zMin, P(d(c), h.displayNegative === !1 ? h.zThreshold || 0 : -Number.MAX_VALUE, Number.MAX_VALUE));
            if (h = b(h.zMax, u(c)), B(p) && B(h))
              return { zMin: p, zMax: h };
          }
        }, x.compose = y.compose, x.defaultOptions = C(v.defaultOptions, { dataLabels: { formatter: function() {
          var h = this.series.chart.numberFormatter, c = this.point.z;
          return B(c) ? h(c, -1) : "";
        }, inside: !0, verticalAlign: "middle" }, animationLimit: 250, marker: {
          lineColor: null,
          lineWidth: 1,
          fillOpacity: 0.5,
          radius: null,
          states: { hover: { radiusPlus: 0 } },
          symbol: "circle"
        }, minSize: 8, maxSize: "20%", softThreshold: !1, states: { hover: { halo: { size: 5 } } }, tooltip: { pointFormat: "({point.x}, {point.y}), Size: {point.z}" }, turboThreshold: 0, zThreshold: 0, zoneAxis: "z" }), x;
      }(v), O(U.prototype, {
        alignDataLabel: Z.prototype.alignDataLabel,
        applyZones: I,
        bubblePadding: !0,
        buildKDTree: I,
        directTouch: !0,
        isBubble: !0,
        pointArrayMap: ["y", "z"],
        pointClass: R,
        parallelArrays: ["x", "y", "z"],
        trackerGroups: ["group", "dataLabelsGroup"],
        specialGroup: "group",
        zoneAxis: "z"
      }), M(U, "updatedData", function(w) {
        delete w.target.chart.bubbleZExtremes;
      }), a.prototype.beforePadding = function() {
        var w = this, x = this.len, h = this.chart, c = 0, p = x, i = this.isXAxis, l = i ? "xData" : "yData", s = this.min, t = this.max - s, n = x / t, o;
        this.series.forEach(function(A) {
          if (A.bubblePadding && (A.visible || !h.options.chart.ignoreHiddenSeries)) {
            o = w.allowZoomOutside = !0;
            var _ = A[l];
            if (i && A.getRadii(0, 0, A), 0 < t) {
              for (var D = _.length; D--; )
                if (B(_[D]) && w.dataMin <= _[D] && _[D] <= w.max) {
                  var j = A.radii && A.radii[D] || 0;
                  c = Math.min((_[D] - s) * n - j, c), p = Math.max((_[D] - s) * n + j, p);
                }
            }
          }
        }), o && 0 < t && !this.logarithmic && (p -= x, n *= (x + Math.max(0, c) - Math.min(p, x)) / x, [["min", "userMin", c], ["max", "userMax", p]].forEach(function(A) {
          typeof b(w.options[A[0]], w[A[1]]) > "u" && (w[A[0]] += A[2] / n);
        }));
      }, $.registerSeriesType("bubble", U), U;
    }), E(g, "Series/ColumnRange/ColumnRangePoint.js", [g["Core/Series/SeriesRegistry.js"], g["Core/Utilities.js"]], function(a, y) {
      var R = this && this.__extends || function() {
        var $ = function(U, W) {
          return $ = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(N, M) {
            N.__proto__ = M;
          } || function(N, M) {
            for (var v in M)
              M.hasOwnProperty(v) && (N[v] = M[v]);
          }, $(U, W);
        };
        return function(U, W) {
          function N() {
            this.constructor = U;
          }
          $(U, W), U.prototype = W === null ? Object.create(W) : (N.prototype = W.prototype, new N());
        };
      }(), I = a.seriesTypes;
      a = I.column.prototype.pointClass;
      var Z = y.extend, H = y.isNumber;
      return y = function($) {
        function U() {
          var W = $ !== null && $.apply(this, arguments) || this;
          return W.series = void 0, W.options = void 0, W.barX = void 0, W.pointWidth = void 0, W.shapeType = void 0, W;
        }
        return R(U, $), U.prototype.isValid = function() {
          return H(this.low);
        }, U;
      }(I.arearange.prototype.pointClass), Z(y.prototype, { setState: a.prototype.setState }), y;
    }), E(g, "Series/ColumnRange/ColumnRangeSeries.js", [g["Series/ColumnRange/ColumnRangePoint.js"], g["Core/Globals.js"], g["Core/Series/SeriesRegistry.js"], g["Core/Utilities.js"]], function(a, y, R, I) {
      var Z = this && this.__extends || function() {
        var P = function(O, B) {
          return P = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(C, b) {
            C.__proto__ = b;
          } || function(C, b) {
            for (var w in b)
              b.hasOwnProperty(w) && (C[w] = b[w]);
          }, P(O, B);
        };
        return function(O, B) {
          function C() {
            this.constructor = O;
          }
          P(O, B), O.prototype = B === null ? Object.create(B) : (C.prototype = B.prototype, new C());
        };
      }();
      y = y.noop;
      var H = R.seriesTypes, $ = H.arearange, U = H.column, W = U.prototype, N = $.prototype, M = I.clamp, v = I.merge, u = I.pick;
      I = I.extend;
      var d = { pointRange: null, marker: null, states: { hover: { halo: !1 } } };
      return H = function(P) {
        function O() {
          var B = P !== null && P.apply(this, arguments) || this;
          return B.data = void 0, B.points = void 0, B.options = void 0, B;
        }
        return Z(O, P), O.prototype.setOptions = function() {
          return v(!0, arguments[0], { stacking: void 0 }), N.setOptions.apply(this, arguments);
        }, O.prototype.translate = function() {
          var B = this, C = B.yAxis, b = B.xAxis, w = b.startAngleRad, x, h = B.chart, c = B.xAxis.isRadial, p = Math.max(h.chartWidth, h.chartHeight) + 999, i;
          W.translate.apply(B), B.points.forEach(function(l) {
            var s = l.shapeArgs || {}, t = B.options.minPointLength;
            l.plotHigh = i = M(C.translate(l.high, 0, 1, 0, 1), -p, p), l.plotLow = M(l.plotY, -p, p);
            var n = i, o = u(
              l.rectPlotY,
              l.plotY
            ) - i;
            Math.abs(o) < t ? (t -= o, o += t, n -= t / 2) : 0 > o && (o *= -1, n -= o), c ? (x = l.barX + w, l.shapeType = "arc", l.shapeArgs = B.polarArc(n + o, n, x, x + l.pointWidth)) : (s.height = o, s.y = n, t = s.x, t = t === void 0 ? 0 : t, s = s.width, s = s === void 0 ? 0 : s, l.tooltipPos = h.inverted ? [C.len + C.pos - h.plotLeft - n - o / 2, b.len + b.pos - h.plotTop - t - s / 2, o] : [b.left - h.plotLeft + t + s / 2, C.pos - h.plotTop + n + o / 2, o]);
          });
        }, O.prototype.crispCol = function() {
          return W.crispCol.apply(this, arguments);
        }, O.prototype.drawPoints = function() {
          return W.drawPoints.apply(this, arguments);
        }, O.prototype.drawTracker = function() {
          return W.drawTracker.apply(this, arguments);
        }, O.prototype.getColumnMetrics = function() {
          return W.getColumnMetrics.apply(this, arguments);
        }, O.prototype.pointAttribs = function() {
          return W.pointAttribs.apply(this, arguments);
        }, O.prototype.adjustForMissingColumns = function() {
          return W.adjustForMissingColumns.apply(this, arguments);
        }, O.prototype.animate = function() {
          return W.animate.apply(this, arguments);
        }, O.prototype.translate3dPoints = function() {
          return W.translate3dPoints.apply(this, arguments);
        }, O.prototype.translate3dShapes = function() {
          return W.translate3dShapes.apply(this, arguments);
        }, O.defaultOptions = v(U.defaultOptions, $.defaultOptions, d), O;
      }($), I(H.prototype, { directTouch: !0, trackerGroups: ["group", "dataLabelsGroup"], drawGraph: y, getSymbol: y, polarArc: function() {
        return W.polarArc.apply(this, arguments);
      }, pointClass: a }), R.registerSeriesType("columnrange", H), H;
    }), E(g, "Series/ColumnPyramid/ColumnPyramidSeries.js", [g["Series/Column/ColumnSeries.js"], g["Core/Series/SeriesRegistry.js"], g["Core/Utilities.js"]], function(a, y, R) {
      var I = this && this.__extends || function() {
        var W = function(N, M) {
          return W = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(v, u) {
            v.__proto__ = u;
          } || function(v, u) {
            for (var d in u)
              u.hasOwnProperty(d) && (v[d] = u[d]);
          }, W(N, M);
        };
        return function(N, M) {
          function v() {
            this.constructor = N;
          }
          W(N, M), N.prototype = M === null ? Object.create(M) : (v.prototype = M.prototype, new v());
        };
      }(), Z = a.prototype, H = R.clamp, $ = R.merge, U = R.pick;
      return R = function(W) {
        function N() {
          var M = W !== null && W.apply(this, arguments) || this;
          return M.data = void 0, M.options = void 0, M.points = void 0, M;
        }
        return I(N, W), N.prototype.translate = function() {
          var M = this, v = M.chart, u = M.options, d = M.dense = 2 > M.closestPointRange * M.xAxis.transA;
          d = M.borderWidth = U(u.borderWidth, d ? 0 : 1);
          var P = M.yAxis, O = u.threshold, B = M.translatedThreshold = P.getThreshold(O), C = U(u.minPointLength, 5), b = M.getColumnMetrics(), w = b.width, x = M.barW = Math.max(w, 1 + 2 * d), h = M.pointXOffset = b.offset;
          v.inverted && (B -= 0.5), u.pointPadding && (x = Math.ceil(x)), Z.translate.apply(M), M.points.forEach(function(c) {
            var p = U(c.yBottom, B), i = 999 + Math.abs(p), l = H(c.plotY, -i, P.len + i);
            i = c.plotX + h;
            var s = x / 2, t = Math.min(l, p);
            p = Math.max(l, p) - t;
            var n;
            c.barX = i, c.pointWidth = w, c.tooltipPos = v.inverted ? [P.len + P.pos - v.plotLeft - l, M.xAxis.len - i - s, p] : [i + s, l + P.pos - v.plotTop, p], l = O + (c.total || c.y), u.stacking === "percent" && (l = O + (0 > c.y) ? -100 : 100), l = P.toPixels(l, !0);
            var o = (n = v.plotHeight - l - (v.plotHeight - B)) ? s * (t - l) / n : 0, A = n ? s * (t + p - l) / n : 0;
            n = i - o + s, o = i + o + s;
            var _ = i + A + s;
            A = i - A + s;
            var D = t - C, j = t + p;
            0 > c.y && (D = t, j = t + p + C), v.inverted && (_ = P.width - t, n = l - (P.width - B), o = s * (l - _) / n, A = s * (l - (_ - p)) / n, n = i + s + o, o = n - 2 * o, _ = i - A + s, A = i + A + s, D = t, j = t + p - C, 0 > c.y && (j = t + p + C)), c.shapeType = "path", c.shapeArgs = { x: n, y: D, width: o - n, height: p, d: [["M", n, D], ["L", o, D], ["L", _, j], ["L", A, j], ["Z"]] };
          });
        }, N.defaultOptions = $(a.defaultOptions, {}), N;
      }(a), y.registerSeriesType("columnpyramid", R), R;
    }), E(g, "Series/ErrorBar/ErrorBarSeries.js", [g["Series/BoxPlot/BoxPlotSeries.js"], g["Series/Column/ColumnSeries.js"], g["Core/Series/SeriesRegistry.js"], g["Core/Utilities.js"]], function(a, y, R, I) {
      var Z = this && this.__extends || function() {
        var W = function(N, M) {
          return W = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(v, u) {
            v.__proto__ = u;
          } || function(v, u) {
            for (var d in u)
              u.hasOwnProperty(d) && (v[d] = u[d]);
          }, W(N, M);
        };
        return function(N, M) {
          function v() {
            this.constructor = N;
          }
          W(N, M), N.prototype = M === null ? Object.create(M) : (v.prototype = M.prototype, new v());
        };
      }(), H = R.seriesTypes.arearange, $ = I.merge;
      I = I.extend;
      var U = function(W) {
        function N() {
          var M = W !== null && W.apply(this, arguments) || this;
          return M.data = void 0, M.options = void 0, M.points = void 0, M;
        }
        return Z(N, W), N.prototype.getColumnMetrics = function() {
          return this.linkedParent && this.linkedParent.columnMetrics || y.prototype.getColumnMetrics.call(this);
        }, N.prototype.drawDataLabels = function() {
          var M = this.pointValKey;
          H && (H.prototype.drawDataLabels.call(this), this.data.forEach(function(v) {
            v.y = v[M];
          }));
        }, N.prototype.toYData = function(M) {
          return [M.low, M.high];
        }, N.defaultOptions = $(a.defaultOptions, {
          color: "#000000",
          grouping: !1,
          linkedTo: ":previous",
          tooltip: { pointFormat: '<span style="color:{point.color}">●</span> {series.name}: <b>{point.low}</b> - <b>{point.high}</b><br/>' },
          whiskerWidth: null
        }), N;
      }(a);
      return I(U.prototype, { pointArrayMap: ["low", "high"], pointValKey: "high", doQuartiles: !1 }), R.registerSeriesType("errorbar", U), U;
    }), E(g, "Series/Gauge/GaugePoint.js", [g["Core/Series/SeriesRegistry.js"]], function(a) {
      var y = this && this.__extends || function() {
        var R = function(I, Z) {
          return R = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(H, $) {
            H.__proto__ = $;
          } || function(H, $) {
            for (var U in $)
              $.hasOwnProperty(U) && (H[U] = $[U]);
          }, R(I, Z);
        };
        return function(I, Z) {
          function H() {
            this.constructor = I;
          }
          R(I, Z), I.prototype = Z === null ? Object.create(Z) : (H.prototype = Z.prototype, new H());
        };
      }();
      return function(R) {
        function I() {
          var Z = R !== null && R.apply(this, arguments) || this;
          return Z.options = void 0, Z.series = void 0, Z.shapeArgs = void 0, Z;
        }
        return y(I, R), I.prototype.setState = function(Z) {
          this.state = Z;
        }, I;
      }(a.series.prototype.pointClass);
    }), E(g, "Series/Gauge/GaugeSeries.js", [g["Series/Gauge/GaugePoint.js"], g["Core/Globals.js"], g["Core/Series/SeriesRegistry.js"], g["Core/Utilities.js"]], function(a, y, R, I) {
      var Z = this && this.__extends || function() {
        var d = function(P, O) {
          return d = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(B, C) {
            B.__proto__ = C;
          } || function(B, C) {
            for (var b in C)
              C.hasOwnProperty(b) && (B[b] = C[b]);
          }, d(P, O);
        };
        return function(P, O) {
          function B() {
            this.constructor = P;
          }
          d(P, O), P.prototype = O === null ? Object.create(O) : (B.prototype = O.prototype, new B());
        };
      }();
      y = y.noop;
      var H = R.series, $ = R.seriesTypes.column, U = I.clamp, W = I.isNumber, N = I.extend, M = I.merge, v = I.pick, u = I.pInt;
      return I = function(d) {
        function P() {
          var O = d !== null && d.apply(this, arguments) || this;
          return O.data = void 0, O.points = void 0, O.options = void 0, O.yAxis = void 0, O;
        }
        return Z(P, d), P.prototype.translate = function() {
          var O = this.yAxis, B = this.options, C = O.center;
          this.generatePoints(), this.points.forEach(function(b) {
            var w = M(B.dial, b.dial), x = u(v(w.radius, "80%")) * C[2] / 200, h = u(v(w.baseLength, "70%")) * x / 100, c = u(v(w.rearLength, "10%")) * x / 100, p = w.baseWidth || 3, i = w.topWidth || 1, l = B.overshoot, s = O.startAngleRad + O.translate(b.y, null, null, null, !0);
            (W(l) || B.wrap === !1) && (l = W(l) ? l / 180 * Math.PI : 0, s = U(
              s,
              O.startAngleRad - l,
              O.endAngleRad + l
            )), s = 180 * s / Math.PI, b.shapeType = "path", b.shapeArgs = { d: w.path || [["M", -c, -p / 2], ["L", h, -p / 2], ["L", x, -i / 2], ["L", x, i / 2], ["L", h, p / 2], ["L", -c, p / 2], ["Z"]], translateX: C[0], translateY: C[1], rotation: s }, b.plotX = C[0], b.plotY = C[1];
          });
        }, P.prototype.drawPoints = function() {
          var O = this, B = O.chart, C = O.yAxis.center, b = O.pivot, w = O.options, x = w.pivot, h = B.renderer;
          O.points.forEach(function(c) {
            var p = c.graphic, i = c.shapeArgs, l = i.d, s = M(w.dial, c.dial);
            p ? (p.animate(i), i.d = l) : c.graphic = h[c.shapeType](i).attr({
              rotation: i.rotation,
              zIndex: 1
            }).addClass("highcharts-dial").add(O.group), B.styledMode || c.graphic[p ? "animate" : "attr"]({ stroke: s.borderColor || "none", "stroke-width": s.borderWidth || 0, fill: s.backgroundColor || "#000000" });
          }), b ? b.animate({ translateX: C[0], translateY: C[1] }) : (O.pivot = h.circle(0, 0, v(x.radius, 5)).attr({ zIndex: 2 }).addClass("highcharts-pivot").translate(C[0], C[1]).add(O.group), B.styledMode || O.pivot.attr({ "stroke-width": x.borderWidth || 0, stroke: x.borderColor || "#cccccc", fill: x.backgroundColor || "#000000" }));
        }, P.prototype.animate = function(O) {
          var B = this;
          O || B.points.forEach(function(C) {
            var b = C.graphic;
            b && (b.attr({ rotation: 180 * B.yAxis.startAngleRad / Math.PI }), b.animate({ rotation: C.shapeArgs.rotation }, B.options.animation));
          });
        }, P.prototype.render = function() {
          this.group = this.plotGroup("group", "series", this.visible ? "visible" : "hidden", this.options.zIndex, this.chart.seriesGroup), H.prototype.render.call(this), this.group.clip(this.chart.clipRect);
        }, P.prototype.setData = function(O, B) {
          H.prototype.setData.call(this, O, !1), this.processData(), this.generatePoints(), v(B, !0) && this.chart.redraw();
        }, P.prototype.hasData = function() {
          return !!this.points.length;
        }, P.defaultOptions = M(H.defaultOptions, { dataLabels: { borderColor: "#cccccc", borderRadius: 3, borderWidth: 1, crop: !1, defer: !1, enabled: !0, verticalAlign: "top", y: 15, zIndex: 2 }, dial: {}, pivot: {}, tooltip: { headerFormat: "" }, showInLegend: !1 }), P;
      }(H), N(I.prototype, { angular: !0, directTouch: !0, drawGraph: y, drawTracker: $.prototype.drawTracker, fixedBox: !0, forceDL: !0, noSharedTooltip: !0, pointClass: a, trackerGroups: [
        "group",
        "dataLabelsGroup"
      ] }), R.registerSeriesType("gauge", I), I;
    }), E(g, "Series/PackedBubble/PackedBubblePoint.js", [g["Core/Chart/Chart.js"], g["Core/Series/Point.js"], g["Core/Series/SeriesRegistry.js"]], function(a, y, R) {
      var I = this && this.__extends || function() {
        var Z = function(H, $) {
          return Z = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(U, W) {
            U.__proto__ = W;
          } || function(U, W) {
            for (var N in W)
              W.hasOwnProperty(N) && (U[N] = W[N]);
          }, Z(H, $);
        };
        return function(H, $) {
          function U() {
            this.constructor = H;
          }
          Z(H, $), H.prototype = $ === null ? Object.create($) : (U.prototype = $.prototype, new U());
        };
      }();
      return function(Z) {
        function H() {
          var $ = Z !== null && Z.apply(this, arguments) || this;
          return $.degree = NaN, $.mass = NaN, $.radius = NaN, $.options = void 0, $.series = void 0, $.value = null, $;
        }
        return I(H, Z), H.prototype.destroy = function() {
          return this.series.layout && this.series.layout.removeElementFromCollection(this, this.series.layout.nodes), y.prototype.destroy.apply(this, arguments);
        }, H.prototype.firePointEvent = function() {
          var $ = this.series.options;
          if (this.isParentNode && $.parentNode) {
            var U = $.allowPointSelect;
            $.allowPointSelect = $.parentNode.allowPointSelect, y.prototype.firePointEvent.apply(this, arguments), $.allowPointSelect = U;
          } else
            y.prototype.firePointEvent.apply(this, arguments);
        }, H.prototype.select = function() {
          var $ = this.series.chart;
          this.isParentNode ? ($.getSelectedPoints = $.getSelectedParentNodes, y.prototype.select.apply(this, arguments), $.getSelectedPoints = a.prototype.getSelectedPoints) : y.prototype.select.apply(this, arguments);
        }, H;
      }(R.seriesTypes.bubble.prototype.pointClass);
    }), E(g, "Series/Networkgraph/DraggableNodes.js", [g["Core/Chart/Chart.js"], g["Core/Globals.js"], g["Core/Utilities.js"]], function(a, y, R) {
      var I = R.addEvent;
      y.dragNodesMixin = { onMouseDown: function(Z, H) {
        H = this.chart.pointer.normalize(H), Z.fixedPosition = { chartX: H.chartX, chartY: H.chartY, plotX: Z.plotX, plotY: Z.plotY }, Z.inDragMode = !0;
      }, onMouseMove: function(Z, H) {
        if (Z.fixedPosition && Z.inDragMode) {
          var $ = this.chart, U = $.pointer.normalize(H);
          H = Z.fixedPosition.chartX - U.chartX, U = Z.fixedPosition.chartY - U.chartY;
          var W = void 0, N = void 0, M = $.graphLayoutsLookup;
          (5 < Math.abs(H) || 5 < Math.abs(U)) && (W = Z.fixedPosition.plotX - H, N = Z.fixedPosition.plotY - U, $.isInsidePlot(W, N) && (Z.plotX = W, Z.plotY = N, Z.hasDragged = !0, this.redrawHalo(Z), M.forEach(function(v) {
            v.restartSimulation();
          })));
        }
      }, onMouseUp: function(Z, H) {
        Z.fixedPosition && (Z.hasDragged && (this.layout.enableSimulation ? this.layout.start() : this.chart.redraw()), Z.inDragMode = Z.hasDragged = !1, this.options.fixedDraggable || delete Z.fixedPosition);
      }, redrawHalo: function(Z) {
        Z && this.halo && this.halo.attr({ d: Z.haloPath(this.options.states.hover.halo.size) });
      } }, I(a, "load", function() {
        var Z = this, H, $, U;
        Z.container && (H = I(Z.container, "mousedown", function(W) {
          var N = Z.hoverPoint;
          N && N.series && N.series.hasDraggableNodes && N.series.options.draggable && (N.series.onMouseDown(N, W), $ = I(Z.container, "mousemove", function(M) {
            return N && N.series && N.series.onMouseMove(N, M);
          }), U = I(Z.container.ownerDocument, "mouseup", function(M) {
            return $(), U(), N && N.series && N.series.onMouseUp(N, M);
          }));
        })), I(Z, "destroy", function() {
          H();
        });
      });
    }), E(
      g,
      "Series/Networkgraph/Integrations.js",
      [g["Core/Globals.js"]],
      function(a) {
        a.networkgraphIntegrations = { verlet: { attractiveForceFunction: function(y, R) {
          return (R - y) / y;
        }, repulsiveForceFunction: function(y, R) {
          return (R - y) / y * (R > y ? 1 : 0);
        }, barycenter: function() {
          var y = this.options.gravitationalConstant, R = this.barycenter.xFactor, I = this.barycenter.yFactor;
          R = (R - (this.box.left + this.box.width) / 2) * y, I = (I - (this.box.top + this.box.height) / 2) * y, this.nodes.forEach(function(Z) {
            Z.fixedPosition || (Z.plotX -= R / Z.mass / Z.degree, Z.plotY -= I / Z.mass / Z.degree);
          });
        }, repulsive: function(y, R, I) {
          R = R * this.diffTemperature / y.mass / y.degree, y.fixedPosition || (y.plotX += I.x * R, y.plotY += I.y * R);
        }, attractive: function(y, R, I) {
          var Z = y.getMass(), H = -I.x * R * this.diffTemperature;
          R = -I.y * R * this.diffTemperature, y.fromNode.fixedPosition || (y.fromNode.plotX -= H * Z.fromNode / y.fromNode.degree, y.fromNode.plotY -= R * Z.fromNode / y.fromNode.degree), y.toNode.fixedPosition || (y.toNode.plotX += H * Z.toNode / y.toNode.degree, y.toNode.plotY += R * Z.toNode / y.toNode.degree);
        }, integrate: function(y, R) {
          var I = -y.options.friction, Z = y.options.maxSpeed, H = (R.plotX + R.dispX - R.prevX) * I;
          I *= R.plotY + R.dispY - R.prevY;
          var $ = Math.abs, U = $(H) / (H || 1);
          $ = $(I) / (I || 1), H = U * Math.min(Z, Math.abs(H)), I = $ * Math.min(Z, Math.abs(I)), R.prevX = R.plotX + R.dispX, R.prevY = R.plotY + R.dispY, R.plotX += H, R.plotY += I, R.temperature = y.vectorLength({ x: H, y: I });
        }, getK: function(y) {
          return Math.pow(y.box.width * y.box.height / y.nodes.length, 0.5);
        } }, euler: { attractiveForceFunction: function(y, R) {
          return y * y / R;
        }, repulsiveForceFunction: function(y, R) {
          return R * R / y;
        }, barycenter: function() {
          var y = this.options.gravitationalConstant, R = this.barycenter.xFactor, I = this.barycenter.yFactor;
          this.nodes.forEach(function(Z) {
            if (!Z.fixedPosition) {
              var H = Z.getDegree();
              H *= 1 + H / 2, Z.dispX += (R - Z.plotX) * y * H / Z.degree, Z.dispY += (I - Z.plotY) * y * H / Z.degree;
            }
          });
        }, repulsive: function(y, R, I, Z) {
          y.dispX += I.x / Z * R / y.degree, y.dispY += I.y / Z * R / y.degree;
        }, attractive: function(y, R, I, Z) {
          var H = y.getMass(), $ = I.x / Z * R;
          R *= I.y / Z, y.fromNode.fixedPosition || (y.fromNode.dispX -= $ * H.fromNode / y.fromNode.degree, y.fromNode.dispY -= R * H.fromNode / y.fromNode.degree), y.toNode.fixedPosition || (y.toNode.dispX += $ * H.toNode / y.toNode.degree, y.toNode.dispY += R * H.toNode / y.toNode.degree);
        }, integrate: function(y, R) {
          R.dispX += R.dispX * y.options.friction, R.dispY += R.dispY * y.options.friction;
          var I = R.temperature = y.vectorLength({ x: R.dispX, y: R.dispY });
          I !== 0 && (R.plotX += R.dispX / I * Math.min(Math.abs(R.dispX), y.temperature), R.plotY += R.dispY / I * Math.min(Math.abs(R.dispY), y.temperature));
        }, getK: function(y) {
          return Math.pow(y.box.width * y.box.height / y.nodes.length, 0.3);
        } } };
      }
    ), E(
      g,
      "Series/Networkgraph/QuadTree.js",
      [g["Core/Globals.js"], g["Core/Utilities.js"]],
      function(a, y) {
        y = y.extend;
        var R = a.QuadTreeNode = function(I) {
          this.box = I, this.boxSize = Math.min(I.width, I.height), this.nodes = [], this.body = this.isInternal = !1, this.isEmpty = !0;
        };
        y(R.prototype, { insert: function(I, Z) {
          this.isInternal ? this.nodes[this.getBoxPosition(I)].insert(I, Z - 1) : (this.isEmpty = !1, this.body ? Z ? (this.isInternal = !0, this.divideBox(), this.body !== !0 && (this.nodes[this.getBoxPosition(this.body)].insert(this.body, Z - 1), this.body = !0), this.nodes[this.getBoxPosition(I)].insert(I, Z - 1)) : (Z = new R({
            top: I.plotX,
            left: I.plotY,
            width: 0.1,
            height: 0.1
          }), Z.body = I, Z.isInternal = !1, this.nodes.push(Z)) : (this.isInternal = !1, this.body = I));
        }, updateMassAndCenter: function() {
          var I = 0, Z = 0, H = 0;
          this.isInternal ? (this.nodes.forEach(function($) {
            $.isEmpty || (I += $.mass, Z += $.plotX * $.mass, H += $.plotY * $.mass);
          }), Z /= I, H /= I) : this.body && (I = this.body.mass, Z = this.body.plotX, H = this.body.plotY), this.mass = I, this.plotX = Z, this.plotY = H;
        }, divideBox: function() {
          var I = this.box.width / 2, Z = this.box.height / 2;
          this.nodes[0] = new R({
            left: this.box.left,
            top: this.box.top,
            width: I,
            height: Z
          }), this.nodes[1] = new R({ left: this.box.left + I, top: this.box.top, width: I, height: Z }), this.nodes[2] = new R({ left: this.box.left + I, top: this.box.top + Z, width: I, height: Z }), this.nodes[3] = new R({ left: this.box.left, top: this.box.top + Z, width: I, height: Z });
        }, getBoxPosition: function(I) {
          var Z = I.plotY < this.box.top + this.box.height / 2;
          return I.plotX < this.box.left + this.box.width / 2 ? Z ? 0 : 3 : Z ? 1 : 2;
        } }), a = a.QuadTree = function(I, Z, H, $) {
          this.box = { left: I, top: Z, width: H, height: $ }, this.maxDepth = 25, this.root = new R(
            this.box,
            "0"
          ), this.root.isInternal = !0, this.root.isRoot = !0, this.root.divideBox();
        }, y(a.prototype, { insertNodes: function(I) {
          I.forEach(function(Z) {
            this.root.insert(Z, this.maxDepth);
          }, this);
        }, visitNodeRecursive: function(I, Z, H) {
          var $;
          I || (I = this.root), I === this.root && Z && ($ = Z(I)), $ !== !1 && (I.nodes.forEach(function(U) {
            if (U.isInternal) {
              if (Z && ($ = Z(U)), $ === !1)
                return;
              this.visitNodeRecursive(U, Z, H);
            } else
              U.body && Z && Z(U.body);
            H && H(U);
          }, this), I === this.root && H && H(I));
        }, calculateMassAndCenter: function() {
          this.visitNodeRecursive(
            null,
            null,
            function(I) {
              I.updateMassAndCenter();
            }
          );
        } });
      }
    ), E(g, "Series/Networkgraph/Layouts.js", [g["Core/Chart/Chart.js"], g["Core/Animation/AnimationUtilities.js"], g["Core/Globals.js"], g["Core/Utilities.js"]], function(a, y, R, I) {
      var Z = y.setAnimation;
      y = I.addEvent;
      var H = I.clamp, $ = I.defined, U = I.extend, W = I.isFunction, N = I.pick;
      R.layouts = { "reingold-fruchterman": function() {
      } }, U(R.layouts["reingold-fruchterman"].prototype, {
        init: function(M) {
          this.options = M, this.nodes = [], this.links = [], this.series = [], this.box = {
            x: 0,
            y: 0,
            width: 0,
            height: 0
          }, this.setInitialRendering(!0), this.integration = R.networkgraphIntegrations[M.integration], this.enableSimulation = M.enableSimulation, this.attractiveForce = N(M.attractiveForce, this.integration.attractiveForceFunction), this.repulsiveForce = N(M.repulsiveForce, this.integration.repulsiveForceFunction), this.approximation = M.approximation;
        },
        updateSimulation: function(M) {
          this.enableSimulation = N(M, this.options.enableSimulation);
        },
        start: function() {
          var M = this.series, v = this.options;
          this.currentStep = 0, this.forces = M[0] && M[0].forces || [], this.chart = M[0] && M[0].chart, this.initialRendering && (this.initPositions(), M.forEach(function(u) {
            u.finishedAnimating = !0, u.render();
          })), this.setK(), this.resetSimulation(v), this.enableSimulation && this.step();
        },
        step: function() {
          var M = this, v = this.series;
          M.currentStep++, M.approximation === "barnes-hut" && (M.createQuadTree(), M.quadTree.calculateMassAndCenter()), M.forces.forEach(function(u) {
            M[u + "Forces"](M.temperature);
          }), M.applyLimits(M.temperature), M.temperature = M.coolDown(
            M.startTemperature,
            M.diffTemperature,
            M.currentStep
          ), M.prevSystemTemperature = M.systemTemperature, M.systemTemperature = M.getSystemTemperature(), M.enableSimulation && (v.forEach(function(u) {
            u.chart && u.render();
          }), M.maxIterations-- && isFinite(M.temperature) && !M.isStable() ? (M.simulation && R.win.cancelAnimationFrame(M.simulation), M.simulation = R.win.requestAnimationFrame(function() {
            M.step();
          })) : M.simulation = !1);
        },
        stop: function() {
          this.simulation && R.win.cancelAnimationFrame(this.simulation);
        },
        setArea: function(M, v, u, d) {
          this.box = {
            left: M,
            top: v,
            width: u,
            height: d
          };
        },
        setK: function() {
          this.k = this.options.linkLength || this.integration.getK(this);
        },
        addElementsToCollection: function(M, v) {
          M.forEach(function(u) {
            v.indexOf(u) === -1 && v.push(u);
          });
        },
        removeElementFromCollection: function(M, v) {
          M = v.indexOf(M), M !== -1 && v.splice(M, 1);
        },
        clear: function() {
          this.nodes.length = 0, this.links.length = 0, this.series.length = 0, this.resetSimulation();
        },
        resetSimulation: function() {
          this.forcedStop = !1, this.systemTemperature = 0, this.setMaxIterations(), this.setTemperature(), this.setDiffTemperature();
        },
        restartSimulation: function() {
          this.simulation ? this.resetSimulation() : (this.setInitialRendering(!1), this.enableSimulation ? this.start() : this.setMaxIterations(1), this.chart && this.chart.redraw(), this.setInitialRendering(!0));
        },
        setMaxIterations: function(M) {
          this.maxIterations = N(M, this.options.maxIterations);
        },
        setTemperature: function() {
          this.temperature = this.startTemperature = Math.sqrt(this.nodes.length);
        },
        setDiffTemperature: function() {
          this.diffTemperature = this.startTemperature / (this.options.maxIterations + 1);
        },
        setInitialRendering: function(M) {
          this.initialRendering = M;
        },
        createQuadTree: function() {
          this.quadTree = new R.QuadTree(this.box.left, this.box.top, this.box.width, this.box.height), this.quadTree.insertNodes(this.nodes);
        },
        initPositions: function() {
          var M = this.options.initialPositions;
          W(M) ? (M.call(this), this.nodes.forEach(function(v) {
            $(v.prevX) || (v.prevX = v.plotX), $(v.prevY) || (v.prevY = v.plotY), v.dispX = 0, v.dispY = 0;
          })) : M === "circle" ? this.setCircularPositions() : this.setRandomPositions();
        },
        setCircularPositions: function() {
          function M(b) {
            b.linksFrom.forEach(function(w) {
              B[w.toNode.id] || (B[w.toNode.id] = !0, O.push(w.toNode), M(w.toNode));
            });
          }
          var v = this.box, u = this.nodes, d = 2 * Math.PI / (u.length + 1), P = u.filter(function(b) {
            return b.linksTo.length === 0;
          }), O = [], B = {}, C = this.options.initialPositionRadius;
          P.forEach(function(b) {
            O.push(b), M(b);
          }), O.length ? u.forEach(function(b) {
            O.indexOf(b) === -1 && O.push(b);
          }) : O = u, O.forEach(function(b, w) {
            b.plotX = b.prevX = N(b.plotX, v.width / 2 + C * Math.cos(w * d)), b.plotY = b.prevY = N(b.plotY, v.height / 2 + C * Math.sin(w * d)), b.dispX = 0, b.dispY = 0;
          });
        },
        setRandomPositions: function() {
          function M(P) {
            return P = P * P / Math.PI, P -= Math.floor(P);
          }
          var v = this.box, u = this.nodes, d = u.length + 1;
          u.forEach(function(P, O) {
            P.plotX = P.prevX = N(P.plotX, v.width * M(O)), P.plotY = P.prevY = N(P.plotY, v.height * M(d + O)), P.dispX = 0, P.dispY = 0;
          });
        },
        force: function(M) {
          this.integration[M].apply(this, Array.prototype.slice.call(arguments, 1));
        },
        barycenterForces: function() {
          this.getBarycenter(), this.force("barycenter");
        },
        getBarycenter: function() {
          var M = 0, v = 0, u = 0;
          return this.nodes.forEach(function(d) {
            v += d.plotX * d.mass, u += d.plotY * d.mass, M += d.mass;
          }), this.barycenter = { x: v, y: u, xFactor: v / M, yFactor: u / M };
        },
        barnesHutApproximation: function(M, v) {
          var u = this.getDistXY(M, v), d = this.vectorLength(u);
          if (M !== v && d !== 0)
            if (v.isInternal)
              if (v.boxSize / d < this.options.theta && d !== 0) {
                var P = this.repulsiveForce(d, this.k);
                this.force("repulsive", M, P * v.mass, u, d);
                var O = !1;
              } else
                O = !0;
            else
              P = this.repulsiveForce(d, this.k), this.force("repulsive", M, P * v.mass, u, d);
          return O;
        },
        repulsiveForces: function() {
          var M = this;
          M.approximation === "barnes-hut" ? M.nodes.forEach(function(v) {
            M.quadTree.visitNodeRecursive(
              null,
              function(u) {
                return M.barnesHutApproximation(v, u);
              }
            );
          }) : M.nodes.forEach(function(v) {
            M.nodes.forEach(function(u) {
              if (v !== u && !v.fixedPosition) {
                var d = M.getDistXY(v, u), P = M.vectorLength(d);
                if (P !== 0) {
                  var O = M.repulsiveForce(P, M.k);
                  M.force("repulsive", v, O * u.mass, d, P);
                }
              }
            });
          });
        },
        attractiveForces: function() {
          var M = this, v, u, d;
          M.links.forEach(function(P) {
            P.fromNode && P.toNode && (v = M.getDistXY(P.fromNode, P.toNode), u = M.vectorLength(v), u !== 0 && (d = M.attractiveForce(u, M.k), M.force("attractive", P, d, v, u)));
          });
        },
        applyLimits: function() {
          var M = this;
          M.nodes.forEach(function(v) {
            v.fixedPosition || (M.integration.integrate(M, v), M.applyLimitBox(v, M.box), v.dispX = 0, v.dispY = 0);
          });
        },
        applyLimitBox: function(M, v) {
          var u = M.radius;
          M.plotX = H(M.plotX, v.left + u, v.width - u), M.plotY = H(M.plotY, v.top + u, v.height - u);
        },
        coolDown: function(M, v, u) {
          return M - v * u;
        },
        isStable: function() {
          return 1e-5 > Math.abs(this.systemTemperature - this.prevSystemTemperature) || 0 >= this.temperature;
        },
        getSystemTemperature: function() {
          return this.nodes.reduce(function(M, v) {
            return M + v.temperature;
          }, 0);
        },
        vectorLength: function(M) {
          return Math.sqrt(M.x * M.x + M.y * M.y);
        },
        getDistR: function(M, v) {
          return M = this.getDistXY(M, v), this.vectorLength(M);
        },
        getDistXY: function(M, v) {
          var u = M.plotX - v.plotX;
          return M = M.plotY - v.plotY, { x: u, y: M, absX: Math.abs(u), absY: Math.abs(M) };
        }
      }), y(a, "predraw", function() {
        this.graphLayoutsLookup && this.graphLayoutsLookup.forEach(function(M) {
          M.stop();
        });
      }), y(a, "render", function() {
        function M(d) {
          d.maxIterations-- && isFinite(d.temperature) && !d.isStable() && !d.enableSimulation && (d.beforeStep && d.beforeStep(), d.step(), u = !1, v = !0);
        }
        var v = !1;
        if (this.graphLayoutsLookup) {
          for (Z(!1, this), this.graphLayoutsLookup.forEach(function(d) {
            d.start();
          }); !u; ) {
            var u = !0;
            this.graphLayoutsLookup.forEach(M);
          }
          v && this.series.forEach(function(d) {
            d && d.layout && d.render();
          });
        }
      }), y(a, "beforePrint", function() {
        this.graphLayoutsLookup && (this.graphLayoutsLookup.forEach(function(M) {
          M.updateSimulation(!1);
        }), this.redraw());
      }), y(a, "afterPrint", function() {
        this.graphLayoutsLookup && this.graphLayoutsLookup.forEach(function(M) {
          M.updateSimulation();
        }), this.redraw();
      });
    }), E(g, "Series/PackedBubble/PackedBubbleComposition.js", [g["Core/Chart/Chart.js"], g["Core/Globals.js"], g["Core/Utilities.js"]], function(a, y, R) {
      var I = y.layouts["reingold-fruchterman"], Z = R.addEvent, H = R.extendClass, $ = R.pick;
      a.prototype.getSelectedParentNodes = function() {
        var U = [];
        return this.series.forEach(function(W) {
          W.parentNode && W.parentNode.selected && U.push(W.parentNode);
        }), U;
      }, y.networkgraphIntegrations.packedbubble = { repulsiveForceFunction: function(U, W, N, M) {
        return Math.min(U, (N.marker.radius + M.marker.radius) / 2);
      }, barycenter: function() {
        var U = this, W = U.options.gravitationalConstant, N = U.box, M = U.nodes, v, u;
        M.forEach(function(d) {
          U.options.splitSeries && !d.isParentNode ? (v = d.series.parentNode.plotX, u = d.series.parentNode.plotY) : (v = N.width / 2, u = N.height / 2), d.fixedPosition || (d.plotX -= (d.plotX - v) * W / (d.mass * Math.sqrt(M.length)), d.plotY -= (d.plotY - u) * W / (d.mass * Math.sqrt(M.length)));
        });
      }, repulsive: function(U, W, N, M) {
        var v = W * this.diffTemperature / U.mass / U.degree;
        W = N.x * v, N = N.y * v, U.fixedPosition || (U.plotX += W, U.plotY += N), M.fixedPosition || (M.plotX -= W, M.plotY -= N);
      }, integrate: y.networkgraphIntegrations.verlet.integrate, getK: y.noop }, y.layouts.packedbubble = H(I, { beforeStep: function() {
        this.options.marker && this.series.forEach(function(U) {
          U && U.calculateParentRadius();
        });
      }, isStable: function() {
        var U = Math.abs(this.prevSystemTemperature - this.systemTemperature);
        return 1 > Math.abs(10 * this.systemTemperature / Math.sqrt(this.nodes.length)) && 1e-5 > U || 0 >= this.temperature;
      }, setCircularPositions: function() {
        var U = this, W = U.box, N = U.nodes, M = 2 * Math.PI / (N.length + 1), v, u, d = U.options.initialPositionRadius;
        N.forEach(function(P, O) {
          U.options.splitSeries && !P.isParentNode ? (v = P.series.parentNode.plotX, u = P.series.parentNode.plotY) : (v = W.width / 2, u = W.height / 2), P.plotX = P.prevX = $(P.plotX, v + d * Math.cos(P.index || O * M)), P.plotY = P.prevY = $(P.plotY, u + d * Math.sin(P.index || O * M)), P.dispX = 0, P.dispY = 0;
        });
      }, repulsiveForces: function() {
        var U = this, W, N, M, v = U.options.bubblePadding;
        U.nodes.forEach(function(u) {
          u.degree = u.mass, u.neighbours = 0, U.nodes.forEach(function(d) {
            W = 0, u === d || u.fixedPosition || !U.options.seriesInteraction && u.series !== d.series || (M = U.getDistXY(u, d), N = U.vectorLength(M) - (u.marker.radius + d.marker.radius + v), 0 > N && (u.degree += 0.01, u.neighbours++, W = U.repulsiveForce(-N / Math.sqrt(u.neighbours), U.k, u, d)), U.force("repulsive", u, W * d.mass, M, d, N));
          });
        });
      }, applyLimitBox: function(U) {
        if (this.options.splitSeries && !U.isParentNode && this.options.parentNodeLimit) {
          var W = this.getDistXY(U, U.series.parentNode), N = U.series.parentNodeRadius - U.marker.radius - this.vectorLength(W);
          0 > N && N > -2 * U.marker.radius && (U.plotX -= 0.01 * W.x, U.plotY -= 0.01 * W.y);
        }
        I.prototype.applyLimitBox.apply(this, arguments);
      } }), Z(a, "beforeRedraw", function() {
        this.allDataPoints && delete this.allDataPoints;
      });
    }), E(g, "Series/PackedBubble/PackedBubbleSeries.js", [g["Core/Color/Color.js"], g["Core/Globals.js"], g["Series/PackedBubble/PackedBubblePoint.js"], g["Core/Series/SeriesRegistry.js"], g["Core/Utilities.js"]], function(a, y, R, I, Z) {
      var H = this && this.__extends || function() {
        var w = function(x, h) {
          return w = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(c, p) {
            c.__proto__ = p;
          } || function(c, p) {
            for (var i in p)
              p.hasOwnProperty(i) && (c[i] = p[i]);
          }, w(x, h);
        };
        return function(x, h) {
          function c() {
            this.constructor = x;
          }
          w(x, h), x.prototype = h === null ? Object.create(h) : (c.prototype = h.prototype, new c());
        };
      }(), $ = a.parse, U = I.series, W = I.seriesTypes.bubble, N = Z.addEvent, M = Z.clamp, v = Z.defined, u = Z.extend, d = Z.fireEvent, P = Z.isArray, O = Z.isNumber, B = Z.merge, C = Z.pick, b = y.dragNodesMixin;
      return a = function(w) {
        function x() {
          var h = w !== null && w.apply(this, arguments) || this;
          return h.chart = void 0, h.data = void 0, h.layout = void 0, h.options = void 0, h.points = void 0, h.xData = void 0, h;
        }
        return H(x, w), x.prototype.accumulateAllPoints = function(h) {
          var c = h.chart, p = [], i, l;
          for (i = 0; i < c.series.length; i++)
            if (h = c.series[i], h.is("packedbubble") && h.visible || !c.options.chart.ignoreHiddenSeries)
              for (l = 0; l < h.yData.length; l++)
                p.push([null, null, h.yData[l], h.index, l, { id: l, marker: { radius: 0 } }]);
          return p;
        }, x.prototype.addLayout = function() {
          var h = this.options.layoutAlgorithm, c = this.chart.graphLayoutsStorage, p = this.chart.graphLayoutsLookup, i = this.chart.options.chart;
          c || (this.chart.graphLayoutsStorage = c = {}, this.chart.graphLayoutsLookup = p = []);
          var l = c[h.type];
          l || (h.enableSimulation = v(i.forExport) ? !i.forExport : h.enableSimulation, c[h.type] = l = new y.layouts[h.type](), l.init(h), p.splice(l.index, 0, l)), this.layout = l, this.points.forEach(function(s) {
            s.mass = 2, s.degree = 1, s.collisionNmb = 1;
          }), l.setArea(0, 0, this.chart.plotWidth, this.chart.plotHeight), l.addElementsToCollection([this], l.series), l.addElementsToCollection(this.points, l.nodes);
        }, x.prototype.addSeriesLayout = function() {
          var h = this.options.layoutAlgorithm, c = this.chart.graphLayoutsStorage, p = this.chart.graphLayoutsLookup, i = B(h, h.parentNodeOptions, { enableSimulation: this.layout.options.enableSimulation }), l = c[h.type + "-series"];
          l || (c[h.type + "-series"] = l = new y.layouts[h.type](), l.init(i), p.splice(l.index, 0, l)), this.parentNodeLayout = l, this.createParentNodes();
        }, x.prototype.calculateParentRadius = function() {
          var h = this.seriesBox();
          this.parentNodeRadius = M(Math.sqrt(2 * this.parentNodeMass / Math.PI) + 20, 20, h ? Math.max(Math.sqrt(Math.pow(
            h.width,
            2
          ) + Math.pow(h.height, 2)) / 2 + 20, 20) : Math.sqrt(2 * this.parentNodeMass / Math.PI) + 20), this.parentNode && (this.parentNode.marker.radius = this.parentNode.radius = this.parentNodeRadius);
        }, x.prototype.calculateZExtremes = function() {
          var h = this.options.zMin, c = this.options.zMax, p = 1 / 0, i = -1 / 0;
          return h && c ? [h, c] : (this.chart.series.forEach(function(l) {
            l.yData.forEach(function(s) {
              v(s) && (s > i && (i = s), s < p && (p = s));
            });
          }), h = C(h, p), c = C(c, i), [h, c]);
        }, x.prototype.checkOverlap = function(h, c) {
          var p = h[0] - c[0], i = h[1] - c[1];
          return -1e-3 > Math.sqrt(p * p + i * i) - Math.abs(h[2] + c[2]);
        }, x.prototype.createParentNodes = function() {
          var h = this, c = h.chart, p = h.parentNodeLayout, i, l = h.parentNode, s = h.pointClass, t = h.layout.options, n = { radius: h.parentNodeRadius, lineColor: h.color, fillColor: $(h.color).brighten(0.4).get() };
          t.parentNodeOptions && (n = B(t.parentNodeOptions.marker || {}, n)), h.parentNodeMass = 0, h.points.forEach(function(o) {
            h.parentNodeMass += Math.PI * Math.pow(o.marker.radius, 2);
          }), h.calculateParentRadius(), p.nodes.forEach(function(o) {
            o.seriesIndex === h.index && (i = !0);
          }), p.setArea(0, 0, c.plotWidth, c.plotHeight), i || (l || (l = new s().init(this, { mass: h.parentNodeRadius / 2, marker: n, dataLabels: { inside: !1 }, states: { normal: { marker: n }, hover: { marker: n } }, dataLabelOnNull: !0, degree: h.parentNodeRadius, isParentNode: !0, seriesIndex: h.index })), h.parentNode && (l.plotX = h.parentNode.plotX, l.plotY = h.parentNode.plotY), h.parentNode = l, p.addElementsToCollection([h], p.series), p.addElementsToCollection([l], p.nodes));
        }, x.prototype.deferLayout = function() {
          var h = this.options.layoutAlgorithm;
          this.visible && (this.addLayout(), h.splitSeries && this.addSeriesLayout());
        }, x.prototype.destroy = function() {
          this.chart.graphLayoutsLookup && this.chart.graphLayoutsLookup.forEach(function(h) {
            h.removeElementFromCollection(this, h.series);
          }, this), this.parentNode && this.parentNodeLayout && (this.parentNodeLayout.removeElementFromCollection(this.parentNode, this.parentNodeLayout.nodes), this.parentNode.dataLabel && (this.parentNode.dataLabel = this.parentNode.dataLabel.destroy())), U.prototype.destroy.apply(this, arguments);
        }, x.prototype.drawDataLabels = function() {
          var h = this.options.dataLabels.textPath, c = this.points;
          U.prototype.drawDataLabels.apply(this, arguments), this.parentNode && (this.parentNode.formatPrefix = "parentNode", this.points = [this.parentNode], this.options.dataLabels.textPath = this.options.dataLabels.parentNodeTextPath, U.prototype.drawDataLabels.apply(this, arguments), this.points = c, this.options.dataLabels.textPath = h);
        }, x.prototype.drawGraph = function() {
          if (this.layout && this.layout.options.splitSeries) {
            var h = this.chart, c = this.layout.options.parentNodeOptions.marker, p = { fill: c.fillColor || $(this.color).brighten(0.4).get(), opacity: c.fillOpacity, stroke: c.lineColor || this.color, "stroke-width": C(c.lineWidth, this.options.lineWidth) };
            this.parentNodesGroup || (this.parentNodesGroup = this.plotGroup("parentNodesGroup", "parentNode", this.visible ? "inherit" : "hidden", 0.1, h.seriesGroup), this.group.attr({ zIndex: 2 })), this.calculateParentRadius(), c = B({
              x: this.parentNode.plotX - this.parentNodeRadius,
              y: this.parentNode.plotY - this.parentNodeRadius,
              width: 2 * this.parentNodeRadius,
              height: 2 * this.parentNodeRadius
            }, p), this.parentNode.graphic || (this.graph = this.parentNode.graphic = h.renderer.symbol(p.symbol).add(this.parentNodesGroup)), this.parentNode.graphic.attr(c);
          }
        }, x.prototype.drawTracker = function() {
          var h = this.parentNode;
          if (w.prototype.drawTracker.call(this), h) {
            var c = P(h.dataLabels) ? h.dataLabels : h.dataLabel ? [h.dataLabel] : [];
            h.graphic && (h.graphic.element.point = h), c.forEach(function(p) {
              p.div ? p.div.point = h : p.element.point = h;
            });
          }
        }, x.prototype.getPointRadius = function() {
          var h = this, c = h.chart, p = h.options, i = p.useSimulation, l = Math.min(c.plotWidth, c.plotHeight), s = {}, t = [], n = c.allDataPoints, o, A, _, D;
          ["minSize", "maxSize"].forEach(function(T) {
            var X = parseInt(p[T], 10), f = /%$/.test(p[T]);
            s[T] = f ? l * X / 100 : X * Math.sqrt(n.length);
          }), c.minRadius = o = s.minSize / Math.sqrt(n.length), c.maxRadius = A = s.maxSize / Math.sqrt(n.length);
          var j = i ? h.calculateZExtremes() : [o, A];
          (n || []).forEach(function(T, X) {
            _ = i ? M(T[2], j[0], j[1]) : T[2], D = h.getRadius(j[0], j[1], o, A, _), D === 0 && (D = null), n[X][2] = D, t.push(D);
          }), h.radii = t;
        }, x.prototype.init = function() {
          return U.prototype.init.apply(this, arguments), this.eventsToUnbind.push(N(this, "updatedData", function() {
            this.chart.series.forEach(function(h) {
              h.type === this.type && (h.isDirty = !0);
            }, this);
          })), this;
        }, x.prototype.onMouseUp = function(h) {
          if (h.fixedPosition && !h.removed) {
            var c, p, i = this.layout, l = this.parentNodeLayout;
            l && i.options.dragBetweenSeries && l.nodes.forEach(function(s) {
              h && h.marker && s !== h.series.parentNode && (c = i.getDistXY(h, s), p = i.vectorLength(c) - s.marker.radius - h.marker.radius, 0 > p && (s.series.addPoint(B(h.options, { plotX: h.plotX, plotY: h.plotY }), !1), i.removeElementFromCollection(h, i.nodes), h.remove()));
            }), b.onMouseUp.apply(this, arguments);
          }
        }, x.prototype.placeBubbles = function(h) {
          var c = this.checkOverlap, p = this.positionBubble, i = [], l = 1, s = 0, t = 0, n = [], o;
          if (h = h.sort(function(A, _) {
            return _[2] - A[2];
          }), h.length) {
            if (i.push([[0, 0, h[0][2], h[0][3], h[0][4]]]), 1 < h.length)
              for (i.push([[0, 0 - h[1][2] - h[0][2], h[1][2], h[1][3], h[1][4]]]), o = 2; o < h.length; o++)
                h[o][2] = h[o][2] || 1, n = p(i[l][s], i[l - 1][t], h[o]), c(n, i[l][0]) ? (i.push([]), t = 0, i[l + 1].push(p(i[l][s], i[l][0], h[o])), l++, s = 0) : 1 < l && i[l - 1][t + 1] && c(n, i[l - 1][t + 1]) ? (t++, i[l].push(p(i[l][s], i[l - 1][t], h[o])), s++) : (s++, i[l].push(n));
            this.chart.stages = i, this.chart.rawPositions = [].concat.apply([], i), this.resizeRadius(), n = this.chart.rawPositions;
          }
          return n;
        }, x.prototype.pointAttribs = function(h, c) {
          var p = this.options, i = p.marker;
          return h && h.isParentNode && p.layoutAlgorithm && p.layoutAlgorithm.parentNodeOptions && (i = p.layoutAlgorithm.parentNodeOptions.marker), p = i.fillOpacity, h = U.prototype.pointAttribs.call(this, h, c), p !== 1 && (h["fill-opacity"] = p), h;
        }, x.prototype.positionBubble = function(h, c, p) {
          var i = Math.sqrt, l = Math.asin, s = Math.acos, t = Math.pow, n = Math.abs;
          return i = i(t(h[0] - c[0], 2) + t(h[1] - c[1], 2)), s = s((t(i, 2) + t(p[2] + c[2], 2) - t(p[2] + h[2], 2)) / (2 * (p[2] + c[2]) * i)), l = l(n(h[0] - c[0]) / i), h = (0 > h[1] - c[1] ? 0 : Math.PI) + s + l * (0 > (h[0] - c[0]) * (h[1] - c[1]) ? 1 : -1), [c[0] + (c[2] + p[2]) * Math.sin(h), c[1] - (c[2] + p[2]) * Math.cos(h), p[2], p[3], p[4]];
        }, x.prototype.render = function() {
          var h = [];
          U.prototype.render.apply(this, arguments), this.options.dataLabels.allowOverlap || (this.data.forEach(function(c) {
            P(c.dataLabels) && c.dataLabels.forEach(function(p) {
              h.push(p);
            });
          }), this.options.useSimulation && this.chart.hideOverlappingLabels(h));
        }, x.prototype.resizeRadius = function() {
          var h = this.chart, c = h.rawPositions, p = Math.min, i = Math.max, l = h.plotLeft, s = h.plotTop, t = h.plotHeight, n = h.plotWidth, o, A, _, D = o = Number.POSITIVE_INFINITY, j = A = Number.NEGATIVE_INFINITY;
          for (_ = 0; _ < c.length; _++) {
            var T = c[_][2];
            D = p(
              D,
              c[_][0] - T
            ), j = i(j, c[_][0] + T), o = p(o, c[_][1] - T), A = i(A, c[_][1] + T);
          }
          if (_ = [j - D, A - o], p = p.apply([], [(n - l) / _[0], (t - s) / _[1]]), 1e-10 < Math.abs(p - 1)) {
            for (_ = 0; _ < c.length; _++)
              c[_][2] *= p;
            this.placeBubbles(c);
          } else
            h.diffY = t / 2 + s - o - (A - o) / 2, h.diffX = n / 2 + l - D - (j - D) / 2;
        }, x.prototype.seriesBox = function() {
          var h = this.chart, c = Math.max, p = Math.min, i, l = [h.plotLeft, h.plotLeft + h.plotWidth, h.plotTop, h.plotTop + h.plotHeight];
          return this.data.forEach(function(s) {
            v(s.plotX) && v(s.plotY) && s.marker.radius && (i = s.marker.radius, l[0] = p(l[0], s.plotX - i), l[1] = c(l[1], s.plotX + i), l[2] = p(l[2], s.plotY - i), l[3] = c(l[3], s.plotY + i));
          }), O(l.width / l.height) ? l : null;
        }, x.prototype.setVisible = function() {
          var h = this;
          U.prototype.setVisible.apply(h, arguments), h.parentNodeLayout && h.graph ? h.visible ? (h.graph.show(), h.parentNode.dataLabel && h.parentNode.dataLabel.show()) : (h.graph.hide(), h.parentNodeLayout.removeElementFromCollection(h.parentNode, h.parentNodeLayout.nodes), h.parentNode.dataLabel && h.parentNode.dataLabel.hide()) : h.layout && (h.visible ? h.layout.addElementsToCollection(
            h.points,
            h.layout.nodes
          ) : h.points.forEach(function(c) {
            h.layout.removeElementFromCollection(c, h.layout.nodes);
          }));
        }, x.prototype.translate = function() {
          var h = this.chart, c = this.data, p = this.index, i, l = this.options.useSimulation;
          if (this.processedXData = this.xData, this.generatePoints(), v(h.allDataPoints) || (h.allDataPoints = this.accumulateAllPoints(this), this.getPointRadius()), l)
            var s = h.allDataPoints;
          else
            s = this.placeBubbles(h.allDataPoints), this.options.draggable = !1;
          for (i = 0; i < s.length; i++)
            if (s[i][3] === p) {
              var t = c[s[i][4]], n = C(s[i][2], void 0);
              l || (t.plotX = s[i][0] - h.plotLeft + h.diffX, t.plotY = s[i][1] - h.plotTop + h.diffY), O(n) && (t.marker = u(t.marker, { radius: n, width: 2 * n, height: 2 * n }), t.radius = n);
            }
          l && this.deferLayout(), d(this, "afterTranslate");
        }, x.defaultOptions = B(W.defaultOptions, { minSize: "10%", maxSize: "50%", sizeBy: "area", zoneAxis: "y", crisp: !1, tooltip: { pointFormat: "Value: {point.value}" }, draggable: !0, useSimulation: !0, parentNode: { allowPointSelect: !1 }, dataLabels: { formatter: function() {
          var h = this.series.chart.numberFormatter, c = this.point.value;
          return O(c) ? h(c, -1) : "";
        }, parentNodeFormatter: function() {
          return this.name;
        }, parentNodeTextPath: { enabled: !0 }, padding: 0, style: { transition: "opacity 2000ms" } }, layoutAlgorithm: { initialPositions: "circle", initialPositionRadius: 20, bubblePadding: 5, parentNodeLimit: !1, seriesInteraction: !0, dragBetweenSeries: !1, parentNodeOptions: { maxIterations: 400, gravitationalConstant: 0.03, maxSpeed: 50, initialPositionRadius: 100, seriesInteraction: !0, marker: {
          fillColor: null,
          fillOpacity: 1,
          lineWidth: null,
          lineColor: null,
          symbol: "circle"
        } }, enableSimulation: !0, type: "packedbubble", integration: "packedbubble", maxIterations: 1e3, splitSeries: !1, maxSpeed: 5, gravitationalConstant: 0.01, friction: -0.981 } }), x;
      }(W), u(a.prototype, {
        alignDataLabel: U.prototype.alignDataLabel,
        axisTypes: [],
        directTouch: !0,
        forces: ["barycenter", "repulsive"],
        hasDraggableNodes: !0,
        isCartesian: !1,
        noSharedTooltip: !0,
        onMouseDown: b.onMouseDown,
        onMouseMove: b.onMouseMove,
        pointArrayMap: ["value"],
        pointClass: R,
        pointValKey: "value",
        redrawHalo: b.redrawHalo,
        requireSorting: !1,
        searchPoint: y.noop,
        trackerGroups: ["group", "dataLabelsGroup", "parentNodesGroup"]
      }), I.registerSeriesType("packedbubble", a), a;
    }), E(g, "Series/Polygon/PolygonSeries.js", [g["Core/Globals.js"], g["Core/Legend/LegendSymbol.js"], g["Core/Series/SeriesRegistry.js"], g["Core/Utilities.js"]], function(a, y, R, I) {
      var Z = this && this.__extends || function() {
        var v = function(u, d) {
          return v = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(P, O) {
            P.__proto__ = O;
          } || function(P, O) {
            for (var B in O)
              O.hasOwnProperty(B) && (P[B] = O[B]);
          }, v(u, d);
        };
        return function(u, d) {
          function P() {
            this.constructor = u;
          }
          v(u, d), u.prototype = d === null ? Object.create(d) : (P.prototype = d.prototype, new P());
        };
      }();
      a = a.noop;
      var H = R.series, $ = R.seriesTypes, U = $.area, W = $.line, N = $.scatter;
      $ = I.extend;
      var M = I.merge;
      return I = function(v) {
        function u() {
          var d = v !== null && v.apply(this, arguments) || this;
          return d.data = void 0, d.options = void 0, d.points = void 0, d;
        }
        return Z(u, v), u.prototype.getGraphPath = function() {
          for (var d = W.prototype.getGraphPath.call(this), P = d.length + 1; P--; )
            (P === d.length || d[P][0] === "M") && 0 < P && d.splice(P, 0, ["Z"]);
          return this.areaPath = d;
        }, u.prototype.drawGraph = function() {
          this.options.fillColor = this.color, U.prototype.drawGraph.call(this);
        }, u.defaultOptions = M(N.defaultOptions, { marker: { enabled: !1, states: { hover: { enabled: !1 } } }, stickyTracking: !1, tooltip: { followPointer: !0, pointFormat: "" }, trackByArea: !0 }), u;
      }(N), $(I.prototype, { type: "polygon", drawLegendSymbol: y.drawRectangle, drawTracker: H.prototype.drawTracker, setStackedPoints: a }), R.registerSeriesType("polygon", I), I;
    }), E(g, "Core/Axis/WaterfallAxis.js", [g["Extensions/Stacking.js"], g["Core/Utilities.js"]], function(a, y) {
      var R = y.addEvent, I = y.objectEach, Z;
      return function(H) {
        function $() {
          var v = this.waterfall.stacks;
          v && (v.changed = !1, delete v.alreadyChanged);
        }
        function U() {
          var v = this.options.stackLabels;
          v && v.enabled && this.waterfall.stacks && this.waterfall.renderStackTotals();
        }
        function W() {
          for (var v = this.axes, u = this.series, d = u.length; d--; )
            u[d].options.stacking && (v.forEach(function(P) {
              P.isXAxis || (P.waterfall.stacks.changed = !0);
            }), d = 0);
        }
        function N() {
          this.waterfall || (this.waterfall = new M(this));
        }
        var M = function() {
          function v(u) {
            this.axis = u, this.stacks = { changed: !1 };
          }
          return v.prototype.renderStackTotals = function() {
            var u = this.axis, d = u.waterfall.stacks, P = u.stacking && u.stacking.stackTotalGroup, O = new a(u, u.options.stackLabels, !1, 0, void 0);
            this.dummyStackItem = O, I(d, function(B) {
              I(B, function(C) {
                O.total = C.stackTotal, C.label && (O.label = C.label), a.prototype.render.call(O, P), C.label = O.label, delete O.label;
              });
            }), O.total = null;
          }, v;
        }();
        H.Composition = M, H.compose = function(v, u) {
          R(v, "init", N), R(v, "afterBuildStacks", $), R(v, "afterRender", U), R(u, "beforeRedraw", W);
        };
      }(Z || (Z = {})), Z;
    }), E(g, "Series/Waterfall/WaterfallPoint.js", [g["Series/Column/ColumnSeries.js"], g["Core/Series/Point.js"], g["Core/Utilities.js"]], function(a, y, R) {
      var I = this && this.__extends || function() {
        var H = function($, U) {
          return H = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(W, N) {
            W.__proto__ = N;
          } || function(W, N) {
            for (var M in N)
              N.hasOwnProperty(M) && (W[M] = N[M]);
          }, H($, U);
        };
        return function($, U) {
          function W() {
            this.constructor = $;
          }
          H($, U), $.prototype = U === null ? Object.create(U) : (W.prototype = U.prototype, new W());
        };
      }(), Z = R.isNumber;
      return function(H) {
        function $() {
          var U = H !== null && H.apply(this, arguments) || this;
          return U.options = void 0, U.series = void 0, U;
        }
        return I($, H), $.prototype.getClassName = function() {
          var U = y.prototype.getClassName.call(this);
          return this.isSum ? U += " highcharts-sum" : this.isIntermediateSum && (U += " highcharts-intermediate-sum"), U;
        }, $.prototype.isValid = function() {
          return Z(this.y) || this.isSum || !!this.isIntermediateSum;
        }, $;
      }(a.prototype.pointClass);
    }), E(g, "Series/Waterfall/WaterfallSeries.js", [g["Core/Axis/Axis.js"], g["Core/Chart/Chart.js"], g["Core/Series/SeriesRegistry.js"], g["Core/Utilities.js"], g["Core/Axis/WaterfallAxis.js"], g["Series/Waterfall/WaterfallPoint.js"]], function(a, y, R, I, Z, H) {
      var $ = this && this.__extends || function() {
        var C = function(b, w) {
          return C = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(x, h) {
            x.__proto__ = h;
          } || function(x, h) {
            for (var c in h)
              h.hasOwnProperty(c) && (x[c] = h[c]);
          }, C(b, w);
        };
        return function(b, w) {
          function x() {
            this.constructor = b;
          }
          C(b, w), b.prototype = w === null ? Object.create(w) : (x.prototype = w.prototype, new x());
        };
      }(), U = R.seriesTypes, W = U.column, N = U.line, M = I.arrayMax, v = I.arrayMin, u = I.correctFloat;
      U = I.extend;
      var d = I.isNumber, P = I.merge, O = I.objectEach, B = I.pick;
      return I = function(C) {
        function b() {
          var w = C !== null && C.apply(this, arguments) || this;
          return w.chart = void 0, w.data = void 0, w.options = void 0, w.points = void 0, w.stackedYNeg = void 0, w.stackedYPos = void 0, w.stackKey = void 0, w.xData = void 0, w.yAxis = void 0, w.yData = void 0, w;
        }
        return $(b, C), b.prototype.generatePoints = function() {
          var w;
          W.prototype.generatePoints.apply(this);
          var x = 0;
          for (w = this.points.length; x < w; x++) {
            var h = this.points[x], c = this.processedYData[x];
            (h.isIntermediateSum || h.isSum) && (h.y = u(c));
          }
        }, b.prototype.translate = function() {
          var w = this.options, x = this.yAxis, h = B(w.minPointLength, 5), c = h / 2, p = w.threshold || 0, i = p, l = p;
          w = w.stacking;
          var s = x.waterfall.stacks[this.stackKey];
          W.prototype.translate.apply(this);
          for (var t = this.points, n = 0; n < t.length; n++) {
            var o = t[n], A = this.processedYData[n], _ = o.shapeArgs;
            if (_ && d(A)) {
              var D = [0, A], j = o.y;
              if (w) {
                if (s) {
                  if (D = s[n], w === "overlap") {
                    var T = D.stackState[D.stateIndex--];
                    T = 0 <= j ? T : T - j, Object.hasOwnProperty.call(D, "absolutePos") && delete D.absolutePos, Object.hasOwnProperty.call(D, "absoluteNeg") && delete D.absoluteNeg;
                  } else
                    0 <= j ? (T = D.threshold + D.posTotal, D.posTotal -= j) : (T = D.threshold + D.negTotal, D.negTotal -= j, T -= j), !D.posTotal && Object.hasOwnProperty.call(D, "absolutePos") && (D.posTotal = D.absolutePos, delete D.absolutePos), !D.negTotal && Object.hasOwnProperty.call(D, "absoluteNeg") && (D.negTotal = D.absoluteNeg, delete D.absoluteNeg);
                  o.isSum || (D.connectorThreshold = D.threshold + D.stackTotal), x.reversed ? (A = 0 <= j ? T - j : T + j, j = T) : (A = T, j = T - j), o.below = A <= p, _.y = x.translate(A, !1, !0, !1, !0) || 0, _.height = Math.abs(_.y - (x.translate(j, !1, !0, !1, !0) || 0)), (j = x.waterfall.dummyStackItem) && (j.x = n, j.label = s[n].label, j.setOffset(this.pointXOffset || 0, this.barW || 0, this.stackedYNeg[n], this.stackedYPos[n]));
                }
              } else
                T = Math.max(i, i + j) + D[0], _.y = x.translate(
                  T,
                  !1,
                  !0,
                  !1,
                  !0
                ) || 0, o.isSum ? (_.y = x.translate(D[1], !1, !0, !1, !0) || 0, _.height = Math.min(x.translate(D[0], !1, !0, !1, !0) || 0, x.len) - _.y, o.below = D[1] <= p) : o.isIntermediateSum ? (0 <= j ? (A = D[1] + l, j = l) : (A = l, j = D[1] + l), x.reversed && (A ^= j, j ^= A, A ^= j), _.y = x.translate(A, !1, !0, !1, !0) || 0, _.height = Math.abs(_.y - Math.min(x.translate(j, !1, !0, !1, !0) || 0, x.len)), l += D[1], o.below = A <= p) : (_.height = 0 < A ? (x.translate(i, !1, !0, !1, !0) || 0) - _.y : (x.translate(i, !1, !0, !1, !0) || 0) - (x.translate(i - A, !1, !0, !1, !0) || 0), i += A, o.below = i < p), 0 > _.height && (_.y += _.height, _.height *= -1);
              o.plotY = _.y = Math.round(_.y || 0) - this.borderWidth % 2 / 2, _.height = Math.max(Math.round(_.height || 0), 1e-3), o.yBottom = _.y + _.height, _.height <= h && !o.isNull ? (_.height = h, _.y -= c, o.plotY = _.y, o.minPointLengthOffset = 0 > o.y ? -c : c) : (o.isNull && (_.width = 0), o.minPointLengthOffset = 0), j = o.plotY + (o.negative ? _.height : 0), o.below && (o.plotY += _.height), o.tooltipPos && (this.chart.inverted ? o.tooltipPos[0] = x.len - j : o.tooltipPos[1] = j);
            }
          }
        }, b.prototype.processData = function(w) {
          var x = this.options, h = this.yData, c = x.data, p = h.length, i = x.threshold || 0, l, s, t, n, o;
          for (o = s = l = t = n = 0; o < p; o++) {
            var A = h[o], _ = c && c[o] ? c[o] : {};
            A === "sum" || _.isSum ? h[o] = u(s) : A === "intermediateSum" || _.isIntermediateSum ? (h[o] = u(l), l = 0) : (s += A, l += A), t = Math.min(s, t), n = Math.max(s, n);
          }
          C.prototype.processData.call(this, w), x.stacking || (this.dataMin = t + i, this.dataMax = n);
        }, b.prototype.toYData = function(w) {
          return w.isSum ? "sum" : w.isIntermediateSum ? "intermediateSum" : w.y;
        }, b.prototype.updateParallelArrays = function(w, x) {
          C.prototype.updateParallelArrays.call(this, w, x), (this.yData[0] === "sum" || this.yData[0] === "intermediateSum") && (this.yData[0] = null);
        }, b.prototype.pointAttribs = function(w, x) {
          var h = this.options.upColor;
          return h && !w.options.color && (w.color = 0 < w.y ? h : null), w = W.prototype.pointAttribs.call(this, w, x), delete w.dashstyle, w;
        }, b.prototype.getGraphPath = function() {
          return [["M", 0, 0]];
        }, b.prototype.getCrispPath = function() {
          var w = this.data, x = this.yAxis, h = w.length, c = Math.round(this.graph.strokeWidth()) % 2 / 2, p = Math.round(this.borderWidth) % 2 / 2, i = this.xAxis.reversed, l = this.yAxis.reversed, s = this.options.stacking, t = [], n;
          for (n = 1; n < h; n++) {
            var o = w[n].shapeArgs, A = w[n - 1], _ = w[n - 1].shapeArgs, D = x.waterfall.stacks[this.stackKey], j = 0 < A.y ? -_.height : 0;
            D && _ && o && (D = D[n - 1], s ? (D = D.connectorThreshold, j = Math.round(x.translate(D, 0, 1, 0, 1) + (l ? j : 0)) - c) : j = _.y + A.minPointLengthOffset + p - c, t.push(["M", (_.x || 0) + (i ? 0 : _.width || 0), j], ["L", (o.x || 0) + (i && o.width || 0), j])), _ && t.length && (!s && 0 > A.y && !l || 0 < A.y && l) && ((A = t[t.length - 2]) && typeof A[2] == "number" && (A[2] += _.height || 0), (A = t[t.length - 1]) && typeof A[2] == "number" && (A[2] += _.height || 0));
          }
          return t;
        }, b.prototype.drawGraph = function() {
          N.prototype.drawGraph.call(this), this.graph.attr({ d: this.getCrispPath() });
        }, b.prototype.setStackedPoints = function() {
          function w(F, Q, k, G) {
            if (Y)
              for (k; k < Y; k++)
                X.stackState[k] += G;
            else
              X.stackState[0] = F, Y = X.stackState.length;
            X.stackState.push(X.stackState[Y - 1] + Q);
          }
          var x = this.options, h = this.yAxis.waterfall.stacks, c = x.threshold, p = c || 0, i = p, l = this.stackKey, s = this.xData, t = s.length, n, o, A;
          this.yAxis.stacking.usePercentage = !1;
          var _ = o = A = p;
          if (this.visible || !this.chart.options.chart.ignoreHiddenSeries) {
            var D = h.changed;
            (n = h.alreadyChanged) && 0 > n.indexOf(l) && (D = !0), h[l] || (h[l] = {}), n = h[l];
            for (var j = 0; j < t; j++) {
              var T = s[j];
              (!n[T] || D) && (n[T] = { negTotal: 0, posTotal: 0, stackTotal: 0, threshold: 0, stateIndex: 0, stackState: [], label: D && n[T] ? n[T].label : void 0 });
              var X = n[T], f = this.yData[j];
              0 <= f ? X.posTotal += f : X.negTotal += f;
              var m = x.data[j];
              T = X.absolutePos = X.posTotal;
              var L = X.absoluteNeg = X.negTotal;
              X.stackTotal = T + L;
              var Y = X.stackState.length;
              m && m.isIntermediateSum ? (w(A, o, 0, A), A = o, o = c, p ^= i, i ^= p, p ^= i) : m && m.isSum ? (w(c, _, Y), p = c) : (w(p, f, 0, _), m && (_ += f, o += f)), X.stateIndex++, X.threshold = p, p += X.stackTotal;
            }
            h.changed = !1, h.alreadyChanged || (h.alreadyChanged = []), h.alreadyChanged.push(l);
          }
        }, b.prototype.getExtremes = function() {
          var w = this.options.stacking;
          if (w) {
            var x = this.yAxis;
            x = x.waterfall.stacks;
            var h = this.stackedYNeg = [], c = this.stackedYPos = [];
            return w === "overlap" ? O(x[this.stackKey], function(p) {
              h.push(v(p.stackState)), c.push(M(p.stackState));
            }) : O(x[this.stackKey], function(p) {
              h.push(p.negTotal + p.threshold), c.push(p.posTotal + p.threshold);
            }), { dataMin: v(h), dataMax: M(c) };
          }
          return { dataMin: this.dataMin, dataMax: this.dataMax };
        }, b.defaultOptions = P(W.defaultOptions, { dataLabels: { inside: !0 }, lineWidth: 1, lineColor: "#333333", dashStyle: "Dot", borderColor: "#333333", states: { hover: { lineWidthPlus: 0 } } }), b;
      }(W), U(I.prototype, { getZonesGraphs: N.prototype.getZonesGraphs, pointValKey: "y", showLine: !0, pointClass: H }), R.registerSeriesType("waterfall", I), Z.compose(a, y), I;
    }), E(g, "Extensions/Polar.js", [
      g["Core/Animation/AnimationUtilities.js"],
      g["Core/Chart/Chart.js"],
      g["Core/Globals.js"],
      g["Extensions/Pane.js"],
      g["Core/Pointer.js"],
      g["Core/Series/Series.js"],
      g["Core/Series/SeriesRegistry.js"],
      g["Core/Renderer/SVG/SVGRenderer.js"],
      g["Core/Utilities.js"]
    ], function(a, y, R, I, Z, H, $, U, W) {
      var N = a.animObject;
      $ = $.seriesTypes;
      var M = W.addEvent, v = W.defined, u = W.find, d = W.isNumber, P = W.pick, O = W.splat, B = W.uniqueKey;
      a = W.wrap;
      var C = H.prototype;
      Z = Z.prototype, C.searchPointByAngle = function(x) {
        var h = this.chart, c = this.xAxis.pane.center;
        return this.searchKDTree({ clientX: 180 + -180 / Math.PI * Math.atan2(x.chartX - c[0] - h.plotLeft, x.chartY - c[1] - h.plotTop) });
      }, C.getConnectors = function(x, h, c, p) {
        var i = p ? 1 : 0, l = 0 <= h && h <= x.length - 1 ? h : 0 > h ? x.length - 1 + h : 0;
        h = 0 > l - 1 ? x.length - (1 + i) : l - 1, i = l + 1 > x.length - 1 ? i : l + 1;
        var s = x[h];
        i = x[i];
        var t = s.plotX;
        s = s.plotY;
        var n = i.plotX, o = i.plotY;
        i = x[l].plotX, l = x[l].plotY, t = (1.5 * i + t) / 2.5, s = (1.5 * l + s) / 2.5, n = (1.5 * i + n) / 2.5;
        var A = (1.5 * l + o) / 2.5;
        o = Math.sqrt(Math.pow(t - i, 2) + Math.pow(s - l, 2));
        var _ = Math.sqrt(Math.pow(n - i, 2) + Math.pow(A - l, 2));
        return t = Math.atan2(s - l, t - i), A = Math.PI / 2 + (t + Math.atan2(A - l, n - i)) / 2, Math.abs(t - A) > Math.PI / 2 && (A -= Math.PI), t = i + Math.cos(A) * o, s = l + Math.sin(A) * o, n = i + Math.cos(Math.PI + A) * _, A = l + Math.sin(Math.PI + A) * _, i = { rightContX: n, rightContY: A, leftContX: t, leftContY: s, plotX: i, plotY: l }, c && (i.prevPointCont = this.getConnectors(x, h, !1, p)), i;
      }, C.toXY = function(x) {
        var h = this.chart, c = this.xAxis, p = this.yAxis, i = x.plotX, l = x.plotY, s = x.series, t = h.inverted, n = x.y, o = t ? i : p.len - l;
        t && s && !s.isRadialBar && (x.plotY = l = typeof n == "number" && p.translate(n) || 0), x.rectPlotX = i, x.rectPlotY = l, p.center && (o += p.center[3] / 2), d(l) && (p = t ? p.postTranslate(l, o) : c.postTranslate(i, o), x.plotX = x.polarPlotX = p.x - h.plotLeft, x.plotY = x.polarPlotY = p.y - h.plotTop), this.kdByAngle ? (h = (i / Math.PI * 180 + c.pane.options.startAngle) % 360, 0 > h && (h += 360), x.clientX = h) : x.clientX = x.plotX;
      }, $.spline && (a($.spline.prototype, "getPointSpline", function(x, h, c, p) {
        return this.chart.polar ? p ? (x = this.getConnectors(h, p, !0, this.connectEnds), h = x.prevPointCont && x.prevPointCont.rightContX, c = x.prevPointCont && x.prevPointCont.rightContY, x = ["C", d(h) ? h : x.plotX, d(c) ? c : x.plotY, d(x.leftContX) ? x.leftContX : x.plotX, d(x.leftContY) ? x.leftContY : x.plotY, x.plotX, x.plotY]) : x = ["M", c.plotX, c.plotY] : x = x.call(this, h, c, p), x;
      }), $.areasplinerange && ($.areasplinerange.prototype.getPointSpline = $.spline.prototype.getPointSpline)), M(H, "afterTranslate", function() {
        var x = this.chart;
        if (x.polar && this.xAxis) {
          if ((this.kdByAngle = x.tooltip && x.tooltip.shared) ? this.searchPoint = this.searchPointByAngle : this.options.findNearestPointBy = "xy", !this.preventPostTranslate)
            for (var h = this.points, c = h.length; c--; )
              this.toXY(h[c]), !x.hasParallelCoordinates && !this.yAxis.reversed && h[c].y < this.yAxis.min && (h[c].isNull = !0);
          this.hasClipCircleSetter || (this.hasClipCircleSetter = !!this.eventsToUnbind.push(M(this, "afterRender", function() {
            if (x.polar) {
              var p = this.yAxis.pane.center;
              this.clipCircle ? this.clipCircle.animate({ x: p[0], y: p[1], r: p[2] / 2, innerR: p[3] / 2 }) : this.clipCircle = x.renderer.clipCircle(p[0], p[1], p[2] / 2, p[3] / 2), this.group.clip(this.clipCircle), this.setClip = R.noop;
            }
          })));
        }
      }, { order: 2 }), a(
        $.line.prototype,
        "getGraphPath",
        function(x, h) {
          var c = this, p;
          if (this.chart.polar) {
            for (h = h || this.points, p = 0; p < h.length; p++)
              if (!h[p].isNull) {
                var i = p;
                break;
              }
            if (this.options.connectEnds !== !1 && typeof i < "u") {
              this.connectEnds = !0, h.splice(h.length, 0, h[i]);
              var l = !0;
            }
            h.forEach(function(s) {
              typeof s.polarPlotY > "u" && c.toXY(s);
            });
          }
          return p = x.apply(this, [].slice.call(arguments, 1)), l && h.pop(), p;
        }
      );
      var b = function(x, h) {
        var c = this, p = this.chart, i = this.options.animation, l = this.group, s = this.markerGroup, t = this.xAxis && this.xAxis.center, n = p.plotLeft, o = p.plotTop, A, _, D, j;
        if (p.polar) {
          if (c.isRadialBar)
            h || (c.startAngleRad = P(c.translatedThreshold, c.xAxis.startAngleRad), R.seriesTypes.pie.prototype.animate.call(c, h));
          else if (p.renderer.isSVG)
            if (i = N(i), c.is("column")) {
              if (!h) {
                var T = t[3] / 2;
                c.points.forEach(function(X) {
                  A = X.graphic, D = (_ = X.shapeArgs) && _.r, j = _ && _.innerR, A && _ && (A.attr({ r: T, innerR: T }), A.animate({ r: D, innerR: j }, c.options.animation));
                });
              }
            } else
              h ? (x = { translateX: t[0] + n, translateY: t[1] + o, scaleX: 1e-3, scaleY: 1e-3 }, l.attr(x), s && s.attr(x)) : (x = { translateX: n, translateY: o, scaleX: 1, scaleY: 1 }, l.animate(x, i), s && s.animate(x, i));
        } else
          x.call(this, h);
      };
      if (a(C, "animate", b), $.column) {
        var w = $.arearange.prototype;
        $ = $.column.prototype, $.polarArc = function(x, h, c, p) {
          var i = this.xAxis.center, l = this.yAxis.len, s = i[3] / 2;
          return h = l - h + s, x = l - P(x, l) + s, this.yAxis.reversed && (0 > h && (h = s), 0 > x && (x = s)), { x: i[0], y: i[1], r: h, innerR: x, start: c, end: p };
        }, a($, "animate", b), a($, "translate", function(x) {
          var h = this.options, c = h.stacking, p = this.chart, i = this.xAxis, l = this.yAxis, s = l.reversed, t = l.center, n = i.startAngleRad, o = i.endAngleRad - n;
          if (this.preventPostTranslate = !0, x.call(this), i.isRadial) {
            x = this.points, i = x.length;
            var A = l.translate(l.min), _ = l.translate(l.max);
            if (h = h.threshold || 0, p.inverted && d(h)) {
              var D = l.translate(h);
              v(D) && (0 > D ? D = 0 : D > o && (D = o), this.translatedThreshold = D + n);
            }
            for (; i--; ) {
              h = x[i];
              var j = h.barX, T = h.x, X = h.y;
              if (h.shapeType = "arc", p.inverted) {
                if (h.plotY = l.translate(X), c && l.stacking) {
                  if (X = l.stacking.stacks[(0 > X ? "-" : "") + this.stackKey], this.visible && X && X[T] && !h.isNull) {
                    var f = X[T].points[this.getStackIndicator(void 0, T, this.index).key], m = l.translate(f[0]);
                    f = l.translate(f[1]), v(m) && (m = W.clamp(m, 0, o));
                  }
                } else
                  m = D, f = h.plotY;
                m > f && (f = [m, m = f][0]), s ? f > A ? f = A : m < _ ? m = _ : (m > A || f < _) && (m = f = o) : m < A ? m = A : f > _ ? f = _ : (f < A || m > _) && (m = f = 0), l.min > l.max && (m = f = s ? o : 0), m += n, f += n, t && (h.barX = j += t[3] / 2), T = Math.max(j, 0), X = Math.max(j + h.pointWidth, 0), h.shapeArgs = { x: t && t[0], y: t && t[1], r: X, innerR: T, start: m, end: f }, h.opacity = m === f ? 0 : void 0, h.plotY = (v(this.translatedThreshold) && (m < this.translatedThreshold ? m : f)) - n;
              } else
                m = j + n, h.shapeArgs = this.polarArc(h.yBottom, h.plotY, m, m + h.pointWidth);
              this.toXY(h), p.inverted ? (j = l.postTranslate(h.rectPlotY, j + h.pointWidth / 2), h.tooltipPos = [j.x - p.plotLeft, j.y - p.plotTop]) : h.tooltipPos = [h.plotX, h.plotY], t && (h.ttBelow = h.plotY > t[1]);
            }
          }
        }), $.findAlignments = function(x, h) {
          return h.align === null && (h.align = 20 < x && 160 > x ? "left" : 200 < x && 340 > x ? "right" : "center"), h.verticalAlign === null && (h.verticalAlign = 45 > x || 315 < x ? "bottom" : 135 < x && 225 > x ? "top" : "middle"), h;
        }, w && (w.findAlignments = $.findAlignments), a($, "alignDataLabel", function(x, h, c, p, i, l) {
          var s = this.chart, t = P(p.inside, !!this.options.stacking);
          s.polar ? (x = h.rectPlotX / Math.PI * 180, s.inverted ? (this.forceDL = s.isInsidePlot(h.plotX, Math.round(h.plotY)), t && h.shapeArgs ? (i = h.shapeArgs, i = this.yAxis.postTranslate(((i.start || 0) + (i.end || 0)) / 2 - this.xAxis.startAngleRad, h.barX + h.pointWidth / 2), i = { x: i.x - s.plotLeft, y: i.y - s.plotTop }) : h.tooltipPos && (i = { x: h.tooltipPos[0], y: h.tooltipPos[1] }), p.align = P(p.align, "center"), p.verticalAlign = P(
            p.verticalAlign,
            "middle"
          )) : this.findAlignments && (p = this.findAlignments(x, p)), C.alignDataLabel.call(this, h, c, p, i, l), this.isRadialBar && h.shapeArgs && h.shapeArgs.start === h.shapeArgs.end && c.hide(!0)) : x.call(this, h, c, p, i, l);
        });
      }
      a(Z, "getCoordinates", function(x, h) {
        var c = this.chart, p = { xAxis: [], yAxis: [] };
        return c.polar ? c.axes.forEach(function(i) {
          var l = i.isXAxis, s = i.center;
          if (i.coll !== "colorAxis") {
            var t = h.chartX - s[0] - c.plotLeft;
            s = h.chartY - s[1] - c.plotTop, p[l ? "xAxis" : "yAxis"].push({ axis: i, value: i.translate(l ? Math.PI - Math.atan2(t, s) : Math.sqrt(Math.pow(
              t,
              2
            ) + Math.pow(s, 2)), !0) });
          }
        }) : p = x.call(this, h), p;
      }), U.prototype.clipCircle = function(x, h, c, p) {
        var i = B(), l = this.createElement("clipPath").attr({ id: i }).add(this.defs);
        return x = p ? this.arc(x, h, c, p, 0, 2 * Math.PI).add(l) : this.circle(x, h, c).add(l), x.id = i, x.clipPath = l, x;
      }, M(y, "getAxes", function() {
        this.pane || (this.pane = []), this.options.pane = O(this.options.pane), this.options.pane.forEach(function(x) {
          new I(x, this);
        }, this);
      }), M(y, "afterDrawChartBox", function() {
        this.pane.forEach(function(x) {
          x.render();
        });
      }), M(
        H,
        "afterInit",
        function() {
          var x = this.chart;
          x.inverted && x.polar && (this.isRadialSeries = !0, this.is("column") && (this.isRadialBar = !0));
        }
      ), a(y.prototype, "get", function(x, h) {
        return u(this.pane || [], function(c) {
          return c.options.id === h;
        }) || x.call(this, h);
      });
    }), E(g, "masters/highcharts-more.src.js", [g["Core/Globals.js"], g["Core/Axis/RadialAxis.js"], g["Series/Bubble/BubbleSeries.js"]], function(a, y, R) {
      y.compose(a.Axis, a.Tick), R.compose(a.Chart, a.Legend, a.Series);
    });
  });
})(Xp);
var O0 = Xp.exports;
const L0 = /* @__PURE__ */ Cn(O0);
var Gp = { exports: {} };
(function(r) {
  (function(g) {
    r.exports ? (g.default = g, r.exports = g) : g(typeof Highcharts < "u" ? Highcharts : void 0);
  })(function(g) {
    function E(a, y, R, I) {
      a.hasOwnProperty(y) || (a[y] = I.apply(null, R));
    }
    g = g ? g._modules : {}, E(
      g,
      "Extensions/FullScreen.js",
      [g["Core/Chart/Chart.js"], g["Core/Globals.js"], g["Core/Renderer/HTML/AST.js"], g["Core/Utilities.js"]],
      function(a, y, R, I) {
        var Z = I.addEvent;
        return I = function() {
          function H($) {
            this.chart = $, this.isOpen = !1, $ = $.renderTo, this.browserProps || (typeof $.requestFullscreen == "function" ? this.browserProps = { fullscreenChange: "fullscreenchange", requestFullscreen: "requestFullscreen", exitFullscreen: "exitFullscreen" } : $.mozRequestFullScreen ? this.browserProps = { fullscreenChange: "mozfullscreenchange", requestFullscreen: "mozRequestFullScreen", exitFullscreen: "mozCancelFullScreen" } : $.webkitRequestFullScreen ? this.browserProps = {
              fullscreenChange: "webkitfullscreenchange",
              requestFullscreen: "webkitRequestFullScreen",
              exitFullscreen: "webkitExitFullscreen"
            } : $.msRequestFullscreen && (this.browserProps = { fullscreenChange: "MSFullscreenChange", requestFullscreen: "msRequestFullscreen", exitFullscreen: "msExitFullscreen" }));
          }
          return H.prototype.close = function() {
            var $ = this.chart, U = $.options.chart;
            this.isOpen && this.browserProps && $.container.ownerDocument instanceof Document && $.container.ownerDocument[this.browserProps.exitFullscreen](), this.unbindFullscreenEvent && (this.unbindFullscreenEvent = this.unbindFullscreenEvent()), $.setSize(this.origWidth, this.origHeight, !1), this.origHeight = this.origWidth = void 0, U.width = this.origWidthOption, U.height = this.origHeightOption, this.origHeightOption = this.origWidthOption = void 0, this.isOpen = !1, this.setButtonText();
          }, H.prototype.open = function() {
            var $ = this, U = $.chart, W = U.options.chart;
            if (W && ($.origWidthOption = W.width, $.origHeightOption = W.height), $.origWidth = U.chartWidth, $.origHeight = U.chartHeight, $.browserProps) {
              var N = Z(
                U.container.ownerDocument,
                $.browserProps.fullscreenChange,
                function() {
                  $.isOpen ? ($.isOpen = !1, $.close()) : (U.setSize(null, null, !1), $.isOpen = !0, $.setButtonText());
                }
              ), M = Z(U, "destroy", N);
              $.unbindFullscreenEvent = function() {
                N(), M();
              }, (W = U.renderTo[$.browserProps.requestFullscreen]()) && W.catch(function() {
                alert("Full screen is not supported inside a frame.");
              });
            }
          }, H.prototype.setButtonText = function() {
            var $ = this.chart, U = $.exportDivElements, W = $.options.exporting, N = W && W.buttons && W.buttons.contextButton.menuItems;
            $ = $.options.lang, W && W.menuItemDefinitions && $ && $.exitFullscreen && $.viewFullscreen && N && U && (U = U[N.indexOf("viewFullscreen")]) && R.setElementHTML(U, this.isOpen ? $.exitFullscreen : W.menuItemDefinitions.viewFullscreen.text || $.viewFullscreen);
          }, H.prototype.toggle = function() {
            this.isOpen ? this.close() : this.open();
          }, H;
        }(), y.Fullscreen = I, Z(a, "beforeRender", function() {
          this.fullscreen = new y.Fullscreen(this);
        }), y.Fullscreen;
      }
    ), E(g, "Core/Chart/ChartNavigationComposition.js", [], function() {
      var a;
      return function(y) {
        y.compose = function(I) {
          return I.navigation || (I.navigation = new R(I)), I;
        };
        var R = function() {
          function I(Z) {
            this.updates = [], this.chart = Z;
          }
          return I.prototype.addUpdate = function(Z) {
            this.chart.navigation.updates.push(Z);
          }, I.prototype.update = function(Z, H) {
            var $ = this;
            this.updates.forEach(function(U) {
              U.call($.chart, Z, H);
            });
          }, I;
        }();
        y.Additions = R;
      }(a || (a = {})), a;
    }), E(g, "Extensions/Exporting/ExportingDefaults.js", [g["Core/Globals.js"]], function(a) {
      return { exporting: { type: "image/png", url: "https://export.highcharts.com/", printMaxWidth: 780, scale: 2, buttons: { contextButton: {
        className: "highcharts-contextbutton",
        menuClassName: "highcharts-contextmenu",
        symbol: "menu",
        titleKey: "contextButtonTitle",
        menuItems: "viewFullscreen printChart separator downloadPNG downloadJPEG downloadPDF downloadSVG".split(" ")
      } }, menuItemDefinitions: { viewFullscreen: { textKey: "viewFullscreen", onclick: function() {
        this.fullscreen.toggle();
      } }, printChart: { textKey: "printChart", onclick: function() {
        this.print();
      } }, separator: { separator: !0 }, downloadPNG: { textKey: "downloadPNG", onclick: function() {
        this.exportChart();
      } }, downloadJPEG: {
        textKey: "downloadJPEG",
        onclick: function() {
          this.exportChart({ type: "image/jpeg" });
        }
      }, downloadPDF: { textKey: "downloadPDF", onclick: function() {
        this.exportChart({ type: "application/pdf" });
      } }, downloadSVG: { textKey: "downloadSVG", onclick: function() {
        this.exportChart({ type: "image/svg+xml" });
      } } } }, lang: {
        viewFullscreen: "View in full screen",
        exitFullscreen: "Exit from full screen",
        printChart: "Print chart",
        downloadPNG: "Download PNG image",
        downloadJPEG: "Download JPEG image",
        downloadPDF: "Download PDF document",
        downloadSVG: "Download SVG vector image",
        contextButtonTitle: "Chart context menu"
      }, navigation: { buttonOptions: { symbolSize: 14, symbolX: 12.5, symbolY: 10.5, align: "right", buttonSpacing: 3, height: 22, verticalAlign: "top", width: 24, symbolFill: "#666666", symbolStroke: "#666666", symbolStrokeWidth: 3, theme: { padding: 5 } }, menuStyle: { border: "1px solid #999999", background: "#ffffff", padding: "5px 0" }, menuItemStyle: { padding: "0.5em 1em", color: "#333333", background: "none", fontSize: a.isTouchDevice ? "14px" : "11px", transition: "background 250ms, color 250ms" }, menuItemHoverStyle: {
        background: "#335cad",
        color: "#ffffff"
      } } };
    }), E(g, "Extensions/Exporting/ExportingSymbols.js", [], function() {
      var a;
      return function(y) {
        function R(H, $, U, W) {
          return [["M", H, $ + 2.5], ["L", H + U, $ + 2.5], ["M", H, $ + W / 2 + 0.5], ["L", H + U, $ + W / 2 + 0.5], ["M", H, $ + W - 1.5], ["L", H + U, $ + W - 1.5]];
        }
        function I(H, $, U, W) {
          return H = W / 3 - 2, W = [], W = W.concat(this.circle(U - H, $, H, H), this.circle(U - H, $ + H + 4, H, H), this.circle(U - H, $ + 2 * (H + 4), H, H));
        }
        var Z = [];
        y.compose = function(H) {
          Z.indexOf(H) === -1 && (Z.push(H), H = H.prototype.symbols, H.menu = R, H.menuball = I.bind(H));
        };
      }(a || (a = {})), a;
    }), E(g, "Core/HttpUtilities.js", [g["Core/Globals.js"], g["Core/Utilities.js"]], function(a, y) {
      var R = a.doc, I = y.createElement, Z = y.discardElement, H = y.merge, $ = y.objectEach, U = { ajax: function(W) {
        var N = H(!0, { url: !1, type: "get", dataType: "json", success: !1, error: !1, data: !1, headers: {} }, W);
        W = { json: "application/json", xml: "application/xml", text: "text/plain", octet: "application/octet-stream" };
        var M = new XMLHttpRequest();
        if (!N.url)
          return !1;
        M.open(N.type.toUpperCase(), N.url, !0), N.headers["Content-Type"] || M.setRequestHeader(
          "Content-Type",
          W[N.dataType] || W.text
        ), $(N.headers, function(v, u) {
          M.setRequestHeader(u, v);
        }), M.onreadystatechange = function() {
          if (M.readyState === 4) {
            if (M.status === 200) {
              var v = M.responseText;
              if (N.dataType === "json")
                try {
                  v = JSON.parse(v);
                } catch (u) {
                  N.error && N.error(M, u);
                  return;
                }
              return N.success && N.success(v);
            }
            N.error && N.error(M, M.responseText);
          }
        };
        try {
          N.data = JSON.stringify(N.data);
        } catch {
        }
        M.send(N.data || !0);
      }, getJSON: function(W, N) {
        U.ajax({ url: W, success: N, dataType: "json", headers: { "Content-Type": "text/plain" } });
      }, post: function(W, N, M) {
        var v = I("form", H({ method: "post", action: W, enctype: "multipart/form-data" }, M), { display: "none" }, R.body);
        $(N, function(u, d) {
          I("input", { type: "hidden", name: d, value: u }, null, v);
        }), v.submit(), Z(v);
      } };
      return U;
    }), E(g, "Extensions/Exporting/Exporting.js", [
      g["Core/Renderer/HTML/AST.js"],
      g["Core/Chart/Chart.js"],
      g["Core/Chart/ChartNavigationComposition.js"],
      g["Core/DefaultOptions.js"],
      g["Extensions/Exporting/ExportingDefaults.js"],
      g["Extensions/Exporting/ExportingSymbols.js"],
      g["Core/Globals.js"],
      g["Core/HttpUtilities.js"],
      g["Core/Utilities.js"]
    ], function(a, y, R, I, Z, H, $, U, W) {
      y = I.defaultOptions;
      var N = $.doc, M = $.win, v = W.addEvent, u = W.css, d = W.createElement, P = W.discardElement, O = W.extend, B = W.find, C = W.fireEvent, b = W.isObject, w = W.merge, x = W.objectEach, h = W.pick, c = W.removeEvent, p = W.uniqueKey, i;
      return function(l) {
        function s(nt) {
          var rt = this, ct = rt.renderer, gt = w(rt.options.navigation.buttonOptions, nt), dt = gt.onclick, lt = gt.menuItems, at = gt.symbolSize || 12;
          if (rt.btnCount || (rt.btnCount = 0), rt.exportDivElements || (rt.exportDivElements = [], rt.exportSVGElements = []), gt.enabled !== !1 && gt.theme) {
            var J = gt.theme, tt = J.states, st = tt && tt.hover;
            tt = tt && tt.select;
            var ht;
            rt.styledMode || (J.fill = h(J.fill, "#ffffff"), J.stroke = h(J.stroke, "none")), delete J.states, dt ? ht = function(vt) {
              vt && vt.stopPropagation(), dt.call(rt, vt);
            } : lt && (ht = function(vt) {
              vt && vt.stopPropagation(), rt.contextMenu(pt.menuClassName, lt, pt.translateX, pt.translateY, pt.width, pt.height, pt), pt.setState(2);
            }), gt.text && gt.symbol ? J.paddingLeft = h(J.paddingLeft, 30) : gt.text || O(J, { width: gt.width, height: gt.height, padding: 0 }), rt.styledMode || (J["stroke-linecap"] = "round", J.fill = h(J.fill, "#ffffff"), J.stroke = h(J.stroke, "none"));
            var pt = ct.button(gt.text, 0, 0, ht, J, st, tt).addClass(nt.className).attr({ title: h(rt.options.lang[gt._titleKey || gt.titleKey], "") });
            if (pt.menuClassName = nt.menuClassName || "highcharts-menu-" + rt.btnCount++, gt.symbol) {
              var yt = ct.symbol(gt.symbol, gt.symbolX - at / 2, gt.symbolY - at / 2, at, at, { width: at, height: at }).addClass("highcharts-button-symbol").attr({ zIndex: 1 }).add(pt);
              rt.styledMode || yt.attr({ stroke: gt.symbolStroke, fill: gt.symbolFill, "stroke-width": gt.symbolStrokeWidth || 1 });
            }
            pt.add(rt.exportingGroup).align(O(
              gt,
              { width: pt.width, x: h(gt.x, rt.buttonOffset) }
            ), !0, "spacingBox"), rt.buttonOffset += (pt.width + gt.buttonSpacing) * (gt.align === "right" ? -1 : 1), rt.exportSVGElements.push(pt, yt);
          }
        }
        function t() {
          if (this.printReverseInfo) {
            var nt = this.printReverseInfo, rt = nt.childNodes, ct = nt.origDisplay;
            nt = nt.resetParams, this.moveContainers(this.renderTo), [].forEach.call(rt, function(gt, dt) {
              gt.nodeType === 1 && (gt.style.display = ct[dt] || "");
            }), this.isPrinting = !1, nt && this.setSize.apply(this, nt), delete this.printReverseInfo, et = void 0, C(this, "afterPrint");
          }
        }
        function n() {
          var nt = N.body, rt = this.options.exporting.printMaxWidth, ct = { childNodes: nt.childNodes, origDisplay: [], resetParams: void 0 };
          this.isPrinting = !0, this.pointer.reset(null, 0), C(this, "beforePrint"), rt && this.chartWidth > rt && (ct.resetParams = [this.options.chart.width, void 0, !1], this.setSize(rt, void 0, !1)), [].forEach.call(ct.childNodes, function(gt, dt) {
            gt.nodeType === 1 && (ct.origDisplay[dt] = gt.style.display, gt.style.display = "none");
          }), this.moveContainers(nt), this.printReverseInfo = ct;
        }
        function o(nt) {
          nt.renderExporting(), v(nt, "redraw", nt.renderExporting), v(nt, "destroy", nt.destroyExport);
        }
        function A(nt, rt, ct, gt, dt, lt, at) {
          var J = this, tt = J.options.navigation, st = J.chartWidth, ht = J.chartHeight, pt = "cache-" + nt, yt = Math.max(dt, lt), vt = J[pt];
          if (!vt) {
            J.exportContextMenu = J[pt] = vt = d("div", { className: nt }, { position: "absolute", zIndex: 1e3, padding: yt + "px", pointerEvents: "auto" }, J.fixedDiv || J.container);
            var Ct = d("ul", { className: "highcharts-menu" }, { listStyle: "none", margin: 0, padding: 0 }, vt);
            J.styledMode || u(Ct, O(
              { MozBoxShadow: "3px 3px 10px #888", WebkitBoxShadow: "3px 3px 10px #888", boxShadow: "3px 3px 10px #888" },
              tt.menuStyle
            )), vt.hideMenu = function() {
              u(vt, { display: "none" }), at && at.setState(0), J.openMenu = !1, u(J.renderTo, { overflow: "hidden" }), u(J.container, { overflow: "hidden" }), W.clearTimeout(vt.hideTimer), C(J, "exportMenuHidden");
            }, J.exportEvents.push(v(vt, "mouseleave", function() {
              vt.hideTimer = M.setTimeout(vt.hideMenu, 500);
            }), v(vt, "mouseenter", function() {
              W.clearTimeout(vt.hideTimer);
            }), v(N, "mouseup", function(Tt) {
              J.pointer.inClass(Tt.target, nt) || vt.hideMenu();
            }), v(vt, "click", function() {
              J.openMenu && vt.hideMenu();
            })), rt.forEach(function(Tt) {
              if (typeof Tt == "string" && (Tt = J.options.exporting.menuItemDefinitions[Tt]), b(Tt, !0)) {
                var kt = void 0;
                Tt.separator ? kt = d("hr", void 0, void 0, Ct) : (Tt.textKey === "viewData" && J.isDataTableVisible && (Tt.textKey = "hideData"), kt = d("li", { className: "highcharts-menu-item", onclick: function(St) {
                  St && St.stopPropagation(), vt.hideMenu(), Tt.onclick && Tt.onclick.apply(J, arguments);
                } }, void 0, Ct), a.setElementHTML(kt, Tt.text || J.options.lang[Tt.textKey]), J.styledMode || (kt.onmouseover = function() {
                  u(this, tt.menuItemHoverStyle);
                }, kt.onmouseout = function() {
                  u(this, tt.menuItemStyle);
                }, u(kt, O({ cursor: "pointer" }, tt.menuItemStyle)))), J.exportDivElements.push(kt);
              }
            }), J.exportDivElements.push(Ct, vt), J.exportMenuWidth = vt.offsetWidth, J.exportMenuHeight = vt.offsetHeight;
          }
          rt = { display: "block" }, ct + J.exportMenuWidth > st ? rt.right = st - ct - dt - yt + "px" : rt.left = ct - yt + "px", gt + lt + J.exportMenuHeight > ht && at.alignOptions.verticalAlign !== "top" ? rt.bottom = ht - gt - yt + "px" : rt.top = gt + lt - yt + "px", u(vt, rt), u(J.renderTo, { overflow: "" }), u(J.container, { overflow: "" }), J.openMenu = !0, C(J, "exportMenuShown");
        }
        function _(nt) {
          var rt = nt ? nt.target : this, ct = rt.exportSVGElements, gt = rt.exportDivElements;
          nt = rt.exportEvents;
          var dt;
          ct && (ct.forEach(function(lt, at) {
            lt && (lt.onclick = lt.ontouchstart = null, dt = "cache-" + lt.menuClassName, rt[dt] && delete rt[dt], ct[at] = lt.destroy());
          }), ct.length = 0), rt.exportingGroup && (rt.exportingGroup.destroy(), delete rt.exportingGroup), gt && (gt.forEach(function(lt, at) {
            lt && (W.clearTimeout(lt.hideTimer), c(lt, "mouseleave"), gt[at] = lt.onmouseout = lt.onmouseover = lt.ontouchstart = lt.onclick = null, P(lt));
          }), gt.length = 0), nt && (nt.forEach(function(lt) {
            lt();
          }), nt.length = 0);
        }
        function D(nt, rt) {
          rt = this.getSVGForExport(nt, rt), nt = w(this.options.exporting, nt), U.post(nt.url, { filename: nt.filename ? nt.filename.replace(/\//g, "-") : this.getFilename(), type: nt.type, width: nt.width || 0, scale: nt.scale, svg: rt }, nt.formAttributes);
        }
        function j() {
          return this.styledMode && this.inlineStyles(), this.container.innerHTML;
        }
        function T() {
          var nt = this.userOptions.title && this.userOptions.title.text, rt = this.options.exporting.filename;
          return rt ? rt.replace(/\//g, "-") : (typeof nt == "string" && (rt = nt.toLowerCase().replace(/<\/?[^>]+(>|$)/g, "").replace(/[\s_]+/g, "-").replace(
            /[^a-z0-9\-]/g,
            ""
          ).replace(/^[\-]+/g, "").replace(/[\-]+/g, "-").substr(0, 24).replace(/[\-]+$/g, "")), (!rt || 5 > rt.length) && (rt = "chart"), rt);
        }
        function X(nt) {
          var rt, ct = w(this.options, nt);
          ct.plotOptions = w(this.userOptions.plotOptions, nt && nt.plotOptions), ct.time = w(this.userOptions.time, nt && nt.time);
          var gt = d("div", null, { position: "absolute", top: "-9999em", width: this.chartWidth + "px", height: this.chartHeight + "px" }, N.body), dt = this.renderTo.style.width, lt = this.renderTo.style.height;
          dt = ct.exporting.sourceWidth || ct.chart.width || /px$/.test(dt) && parseInt(dt, 10) || (ct.isGantt ? 800 : 600), lt = ct.exporting.sourceHeight || ct.chart.height || /px$/.test(lt) && parseInt(lt, 10) || 400, O(ct.chart, { animation: !1, renderTo: gt, forExport: !0, renderer: "SVGRenderer", width: dt, height: lt }), ct.exporting.enabled = !1, delete ct.data, ct.series = [], this.series.forEach(function(tt) {
            rt = w(tt.userOptions, { animation: !1, enableMouseTracking: !1, showCheckbox: !1, visible: tt.visible }), rt.isInternal || ct.series.push(rt);
          });
          var at = {};
          this.axes.forEach(function(tt) {
            tt.userOptions.internalKey || (tt.userOptions.internalKey = p()), tt.options.isInternal || (at[tt.coll] || (at[tt.coll] = !0, ct[tt.coll] = []), ct[tt.coll].push(w(tt.userOptions, { visible: tt.visible })));
          });
          var J = new this.constructor(ct, this.callback);
          return nt && ["xAxis", "yAxis", "series"].forEach(function(tt) {
            var st = {};
            nt[tt] && (st[tt] = nt[tt], J.update(st));
          }), this.axes.forEach(function(tt) {
            var st = B(J.axes, function(yt) {
              return yt.options.internalKey === tt.userOptions.internalKey;
            }), ht = tt.getExtremes(), pt = ht.userMin;
            ht = ht.userMax, st && (typeof pt < "u" && pt !== st.min || typeof ht < "u" && ht !== st.max) && st.setExtremes(
              pt,
              ht,
              !0,
              !1
            );
          }), lt = J.getChartHTML(), C(this, "getSVG", { chartCopy: J }), lt = this.sanitizeSVG(lt, ct), ct = null, J.destroy(), P(gt), lt;
        }
        function f(nt, rt) {
          var ct = this.options.exporting;
          return this.getSVG(w({ chart: { borderRadius: 0 } }, ct.chartOptions, rt, { exporting: { sourceWidth: nt && nt.sourceWidth || ct.sourceWidth, sourceHeight: nt && nt.sourceHeight || ct.sourceHeight } }));
        }
        function m(nt) {
          return nt.replace(/([A-Z])/g, function(rt, ct) {
            return "-" + ct.toLowerCase();
          });
        }
        function L() {
          function nt(J) {
            function tt(St, _t) {
              if (ht = pt = !1, ct.length) {
                for (yt = ct.length; yt-- && !pt; )
                  pt = ct[yt].test(_t);
                ht = !pt;
              }
              for (_t === "transform" && St === "none" && (ht = !0), yt = rt.length; yt-- && !ht; )
                ht = rt[yt].test(_t) || typeof St == "function";
              ht || Ct[_t] === St && J.nodeName !== "svg" || gt[J.nodeName][_t] === St || (q && q.indexOf(_t) === -1 ? st += m(_t) + ":" + St + ";" : St && J.setAttribute(m(_t), St));
            }
            var st = "", ht, pt, yt;
            if (J.nodeType === 1 && it.indexOf(J.nodeName) === -1) {
              var vt = M.getComputedStyle(J, null), Ct = J.nodeName === "svg" ? {} : M.getComputedStyle(J.parentNode, null);
              if (!gt[J.nodeName]) {
                dt = at.getElementsByTagName("svg")[0];
                var Tt = at.createElementNS(J.namespaceURI, J.nodeName);
                dt.appendChild(Tt), gt[J.nodeName] = w(M.getComputedStyle(Tt, null)), J.nodeName === "text" && delete gt.text.fill, dt.removeChild(Tt);
              }
              if ($.isFirefox || $.isMS)
                for (var kt in vt)
                  tt(vt[kt], kt);
              else
                x(vt, tt);
              st && (vt = J.getAttribute("style"), J.setAttribute("style", (vt ? vt + ";" : "") + st)), J.nodeName === "svg" && J.setAttribute("stroke-width", "1px"), J.nodeName !== "text" && [].forEach.call(J.children || J.childNodes, nt);
            }
          }
          var rt = V, ct = l.inlineWhitelist, gt = {}, dt, lt = N.createElement("iframe");
          u(lt, { width: "1px", height: "1px", visibility: "hidden" }), N.body.appendChild(lt);
          var at = lt.contentWindow.document;
          at.open(), at.write('<svg xmlns="http://www.w3.org/2000/svg"></svg>'), at.close(), nt(this.container.querySelector("svg")), dt.parentNode.removeChild(dt), lt.parentNode.removeChild(lt);
        }
        function Y(nt) {
          (this.fixedDiv ? [this.fixedDiv, this.scrollingContainer] : [this.container]).forEach(function(rt) {
            nt.appendChild(rt);
          });
        }
        function F() {
          var nt = this;
          nt.exporting = { update: function(rt, ct) {
            nt.isDirtyExporting = !0, w(!0, nt.options.exporting, rt), h(ct, !0) && nt.redraw();
          } }, R.compose(nt).navigation.addUpdate(function(rt, ct) {
            nt.isDirtyExporting = !0, w(!0, nt.options.navigation, rt), h(ct, !0) && nt.redraw();
          });
        }
        function Q() {
          var nt = this;
          nt.isPrinting || (et = nt, $.isSafari || nt.beforePrint(), setTimeout(function() {
            M.focus(), M.print(), $.isSafari || setTimeout(function() {
              nt.afterPrint();
            }, 1e3);
          }, 1));
        }
        function k() {
          var nt = this, rt = nt.options.exporting, ct = rt.buttons, gt = nt.isDirtyExporting || !nt.exportSVGElements;
          nt.buttonOffset = 0, nt.isDirtyExporting && nt.destroyExport(), gt && rt.enabled !== !1 && (nt.exportEvents = [], nt.exportingGroup = nt.exportingGroup || nt.renderer.g("exporting-group").attr({ zIndex: 3 }).add(), x(ct, function(dt) {
            nt.addButton(dt);
          }), nt.isDirtyExporting = !1);
        }
        function G(nt, rt) {
          var ct = nt.indexOf("</svg>") + 6, gt = nt.substr(ct);
          return nt = nt.substr(0, ct), rt && rt.exporting && rt.exporting.allowHTML && gt && (gt = '<foreignObject x="0" y="0" width="' + rt.chart.width + '" height="' + rt.chart.height + '"><body xmlns="http://www.w3.org/1999/xhtml">' + gt.replace(/(<(?:img|br).*?(?=>))>/g, "$1 />") + "</body></foreignObject>", nt = nt.replace("</svg>", gt + "</svg>")), nt = nt.replace(/zIndex="[^"]+"/g, "").replace(/symbolName="[^"]+"/g, "").replace(
            /jQuery[0-9]+="[^"]+"/g,
            ""
          ).replace(/url\(("|&quot;)(.*?)("|&quot;);?\)/g, "url($2)").replace(/url\([^#]+#/g, "url(#").replace(/<svg /, '<svg xmlns:xlink="http://www.w3.org/1999/xlink" ').replace(/ (|NS[0-9]+:)href=/g, " xlink:href=").replace(/\n/, " ").replace(/(fill|stroke)="rgba\(([ 0-9]+,[ 0-9]+,[ 0-9]+),([ 0-9\.]+)\)"/g, '$1="rgb($2)" $1-opacity="$3"').replace(/&nbsp;/g, " ").replace(/&shy;/g, "­"), this.ieSanitizeSVG && (nt = this.ieSanitizeSVG(nt)), nt;
        }
        var z = [], V = [
          /-/,
          /^(clipPath|cssText|d|height|width)$/,
          /^font$/,
          /[lL]ogical(Width|Height)$/,
          /perspective/,
          /TapHighlightColor/,
          /^transition/,
          /^length$/
        ], q = "fill stroke strokeLinecap strokeLinejoin strokeWidth textAnchor x y".split(" ");
        l.inlineWhitelist = [];
        var it = ["clipPath", "defs", "desc"], et;
        l.compose = function(nt, rt) {
          H.compose(rt), z.indexOf(nt) === -1 && (z.push(nt), rt = nt.prototype, rt.afterPrint = t, rt.exportChart = D, rt.inlineStyles = L, rt.print = Q, rt.sanitizeSVG = G, rt.getChartHTML = j, rt.getSVG = X, rt.getSVGForExport = f, rt.getFilename = T, rt.moveContainers = Y, rt.beforePrint = n, rt.contextMenu = A, rt.addButton = s, rt.destroyExport = _, rt.renderExporting = k, rt.callbacks.push(o), v(nt, "init", F), $.isSafari && $.win.matchMedia("print").addListener(function(ct) {
            et && (ct.matches ? et.beforePrint() : et.afterPrint());
          }));
        };
      }(i || (i = {})), y.exporting = w(Z.exporting, y.exporting), y.lang = w(Z.lang, y.lang), y.navigation = w(Z.navigation, y.navigation), i;
    }), E(g, "masters/modules/exporting.src.js", [g["Core/Globals.js"], g["Extensions/Exporting/Exporting.js"], g["Core/HttpUtilities.js"]], function(a, y, R) {
      a.HttpUtilities = R, a.ajax = R.ajax, a.getJSON = R.getJSON, a.post = R.post, y.compose(a.Chart, a.Renderer);
    });
  });
})(Gp);
var _0 = Gp.exports;
const D0 = /* @__PURE__ */ Cn(_0);
var Hp = { exports: {} };
(function(r) {
  (function(g) {
    r.exports ? (g.default = g, r.exports = g) : g(typeof Highcharts < "u" ? Highcharts : void 0);
  })(function(g) {
    function E(a, y, R, I) {
      a.hasOwnProperty(y) || (a[y] = I.apply(null, R));
    }
    g = g ? g._modules : {}, E(g, "Extensions/Boost/Boostables.js", [], function() {
      return "area arearange column columnrange bar line scatter heatmap bubble treemap".split(" ");
    }), E(g, "Extensions/Boost/BoostableMap.js", [g["Extensions/Boost/Boostables.js"]], function(a) {
      var y = {};
      return a.forEach(function(R) {
        y[R] = 1;
      }), y;
    }), E(g, "Extensions/Boost/WGLShader.js", [g["Core/Utilities.js"]], function(a) {
      var y = a.clamp, R = a.error, I = a.pick;
      return function(Z) {
        function H() {
          x.length && R("[highcharts boost] shader error - " + x.join(`
`));
        }
        function $(c, p) {
          var i = Z.createShader(p === "vertex" ? Z.VERTEX_SHADER : Z.FRAGMENT_SHADER);
          return Z.shaderSource(i, c), Z.compileShader(i), Z.getShaderParameter(i, Z.COMPILE_STATUS) ? i : (x.push("when compiling " + p + ` shader:
` + Z.getShaderInfoLog(i)), !1);
        }
        function U() {
          function c(l) {
            return Z.getUniformLocation(M, l);
          }
          var p = $(
            `#version 100
#define LN10 2.302585092994046
precision highp float;
attribute vec4 aVertexPosition;
attribute vec4 aColor;
varying highp vec2 position;
varying highp vec4 vColor;
uniform mat4 uPMatrix;
uniform float pSize;
uniform float translatedThreshold;
uniform bool hasThreshold;
uniform bool skipTranslation;
uniform float xAxisTrans;
uniform float xAxisMin;
uniform float xAxisMinPad;
uniform float xAxisPointRange;
uniform float xAxisLen;
uniform bool  xAxisPostTranslate;
uniform float xAxisOrdinalSlope;
uniform float xAxisOrdinalOffset;
uniform float xAxisPos;
uniform bool  xAxisCVSCoord;
uniform bool  xAxisIsLog;
uniform bool  xAxisReversed;
uniform float yAxisTrans;
uniform float yAxisMin;
uniform float yAxisMinPad;
uniform float yAxisPointRange;
uniform float yAxisLen;
uniform bool  yAxisPostTranslate;
uniform float yAxisOrdinalSlope;
uniform float yAxisOrdinalOffset;
uniform float yAxisPos;
uniform bool  yAxisCVSCoord;
uniform bool  yAxisIsLog;
uniform bool  yAxisReversed;
uniform bool  isBubble;
uniform bool  bubbleSizeByArea;
uniform float bubbleZMin;
uniform float bubbleZMax;
uniform float bubbleZThreshold;
uniform float bubbleMinSize;
uniform float bubbleMaxSize;
uniform bool  bubbleSizeAbs;
uniform bool  isInverted;
float bubbleRadius(){
float value = aVertexPosition.w;
float zMax = bubbleZMax;
float zMin = bubbleZMin;
float radius = 0.0;
float pos = 0.0;
float zRange = zMax - zMin;
if (bubbleSizeAbs){
value = value - bubbleZThreshold;
zMax = max(zMax - bubbleZThreshold, zMin - bubbleZThreshold);
zMin = 0.0;
}
if (value < zMin){
radius = bubbleZMin / 2.0 - 1.0;
} else {
pos = zRange > 0.0 ? (value - zMin) / zRange : 0.5;
if (bubbleSizeByArea && pos > 0.0){
pos = sqrt(pos);
}
radius = ceil(bubbleMinSize + pos * (bubbleMaxSize - bubbleMinSize)) / 2.0;
}
return radius * 2.0;
}
float translate(float val,
float pointPlacement,
float localA,
float localMin,
float minPixelPadding,
float pointRange,
float len,
bool  cvsCoord,
bool  isLog,
bool  reversed
){
float sign = 1.0;
float cvsOffset = 0.0;
if (cvsCoord) {
sign *= -1.0;
cvsOffset = len;
}
if (isLog) {
val = log(val) / LN10;
}
if (reversed) {
sign *= -1.0;
cvsOffset -= sign * len;
}
return sign * (val - localMin) * localA + cvsOffset + 
(sign * minPixelPadding);
}
float xToPixels(float value) {
if (skipTranslation){
return value;// + xAxisPos;
}
return translate(value, 0.0, xAxisTrans, xAxisMin, xAxisMinPad, xAxisPointRange, xAxisLen, xAxisCVSCoord, xAxisIsLog, xAxisReversed);// + xAxisPos;
}
float yToPixels(float value, float checkTreshold) {
float v;
if (skipTranslation){
v = value;// + yAxisPos;
} else {
v = translate(value, 0.0, yAxisTrans, yAxisMin, yAxisMinPad, yAxisPointRange, yAxisLen, yAxisCVSCoord, yAxisIsLog, yAxisReversed);// + yAxisPos;
if (v > yAxisLen) {
v = yAxisLen;
}
}
if (checkTreshold > 0.0 && hasThreshold) {
v = min(v, translatedThreshold);
}
return v;
}
void main(void) {
if (isBubble){
gl_PointSize = bubbleRadius();
} else {
gl_PointSize = pSize;
}
vColor = aColor;
if (skipTranslation && isInverted) {
gl_Position = uPMatrix * vec4(aVertexPosition.y + yAxisPos, aVertexPosition.x + xAxisPos, 0.0, 1.0);
} else if (isInverted) {
gl_Position = uPMatrix * vec4(yToPixels(aVertexPosition.y, aVertexPosition.z) + yAxisPos, xToPixels(aVertexPosition.x) + xAxisPos, 0.0, 1.0);
} else {
gl_Position = uPMatrix * vec4(xToPixels(aVertexPosition.x) + xAxisPos, yToPixels(aVertexPosition.y, aVertexPosition.z) + yAxisPos, 0.0, 1.0);
}
}`,
            "vertex"
          ), i = $(`precision highp float;
uniform vec4 fillColor;
varying highp vec2 position;
varying highp vec4 vColor;
uniform sampler2D uSampler;
uniform bool isCircle;
uniform bool hasColor;
void main(void) {
vec4 col = fillColor;
vec4 tcol = texture2D(uSampler, gl_PointCoord.st);
if (hasColor) {
col = vColor;
}
if (isCircle) {
col *= tcol;
if (tcol.r < 0.0) {
discard;
} else {
gl_FragColor = col;
}
} else {
gl_FragColor = col;
}
}`, "fragment");
          return !p || !i ? (M = !1, H(), !1) : (M = Z.createProgram(), Z.attachShader(M, p), Z.attachShader(M, i), Z.linkProgram(M), Z.getProgramParameter(M, Z.LINK_STATUS) ? (Z.useProgram(M), Z.bindAttribLocation(M, 0, "aVertexPosition"), v = c("uPMatrix"), u = c("pSize"), d = c("fillColor"), P = c("isBubble"), O = c("bubbleSizeAbs"), B = c("bubbleSizeByArea"), h = c("uSampler"), C = c("skipTranslation"), b = c("isCircle"), w = c("isInverted"), !0) : (x.push(Z.getProgramInfoLog(M)), H(), M = !1));
        }
        function W(c, p) {
          Z && M && (c = N[c] = N[c] || Z.getUniformLocation(M, c), Z.uniform1f(c, p));
        }
        var N = {}, M, v, u, d, P, O, B, C, b, w, x = [], h;
        return Z && !U() ? !1 : { psUniform: function() {
          return u;
        }, pUniform: function() {
          return v;
        }, fillColorUniform: function() {
          return d;
        }, setBubbleUniforms: function(c, p, i) {
          var l = c.options, s = Number.MAX_VALUE, t = -Number.MAX_VALUE;
          if (Z && M && c.is("bubble")) {
            var n = c.getPxExtremes();
            s = I(l.zMin, y(p, l.displayNegative === !1 ? l.zThreshold : -Number.MAX_VALUE, s)), t = I(l.zMax, Math.max(t, i)), Z.uniform1i(P, 1), Z.uniform1i(b, 1), Z.uniform1i(B, c.options.sizeBy !== "width"), Z.uniform1i(O, c.options.sizeByAbsoluteValue), W("bubbleZMin", s), W("bubbleZMax", t), W("bubbleZThreshold", c.options.zThreshold), W("bubbleMinSize", n.minPxSize), W("bubbleMaxSize", n.maxPxSize);
          }
        }, bind: function() {
          Z && M && Z.useProgram(M);
        }, program: function() {
          return M;
        }, create: U, setUniform: W, setPMatrix: function(c) {
          Z && M && Z.uniformMatrix4fv(v, !1, c);
        }, setColor: function(c) {
          Z && M && Z.uniform4f(d, c[0] / 255, c[1] / 255, c[2] / 255, c[3]);
        }, setPointSize: function(c) {
          Z && M && Z.uniform1f(u, c);
        }, setSkipTranslation: function(c) {
          Z && M && Z.uniform1i(C, c === !0 ? 1 : 0);
        }, setTexture: function(c) {
          Z && M && Z.uniform1i(h, c);
        }, setDrawAsCircle: function(c) {
          Z && M && Z.uniform1i(b, c ? 1 : 0);
        }, reset: function() {
          Z && M && (Z.uniform1i(P, 0), Z.uniform1i(b, 0));
        }, setInverted: function(c) {
          Z && M && Z.uniform1i(w, c);
        }, destroy: function() {
          Z && M && (Z.deleteProgram(M), M = !1);
        } };
      };
    }), E(g, "Extensions/Boost/WGLVBuffer.js", [], function() {
      return function(a, y, R) {
        function I() {
          Z && (a.deleteBuffer(Z), H = Z = !1), W = 0, $ = R || 2, N = [];
        }
        var Z = !1, H = !1, $ = R || 2, U = !1, W = 0, N;
        return {
          destroy: I,
          bind: function() {
            if (!Z)
              return !1;
            a.vertexAttribPointer(H, $, a.FLOAT, !1, 0, 0);
          },
          data: N,
          build: function(M, v, u) {
            var d;
            return N = M || [], N && N.length !== 0 || U ? ($ = u || $, Z && a.deleteBuffer(Z), U || (d = new Float32Array(N)), Z = a.createBuffer(), a.bindBuffer(a.ARRAY_BUFFER, Z), a.bufferData(a.ARRAY_BUFFER, U || d, a.STATIC_DRAW), H = a.getAttribLocation(y.program(), v), a.enableVertexAttribArray(H), !0) : (I(), !1);
          },
          render: function(M, v, u) {
            var d = U ? U.length : N.length;
            return !Z || !d || ((!M || M > d || 0 > M) && (M = 0), (!v || v > d) && (v = d), M >= v) ? !1 : (a.drawArrays(a[(u || "points").toUpperCase()], M / $, (v - M) / $), !0);
          },
          allocate: function(M) {
            W = -1, U = new Float32Array(4 * M);
          },
          push: function(M, v, u, d) {
            U && (U[++W] = M, U[++W] = v, U[++W] = u, U[++W] = d);
          }
        };
      };
    }), E(g, "Extensions/Boost/WGLRenderer.js", [g["Core/Color/Color.js"], g["Extensions/Boost/WGLShader.js"], g["Extensions/Boost/WGLVBuffer.js"], g["Core/Globals.js"], g["Core/Utilities.js"]], function(a, y, R, I, Z) {
      var H = a.parse, $ = I.doc, U = Z.isNumber, W = Z.isObject, N = Z.merge, M = Z.objectEach, v = Z.pick;
      return function(u) {
        function d(m) {
          if (m.isSeriesBoosting) {
            var L = !!m.options.stacking, Y = m.xData || m.options.xData || m.processedXData;
            return L = (L ? m.data : Y || m.options.data).length, m.type === "treemap" ? L *= 12 : m.type === "heatmap" ? L *= 6 : T[m.type] && (L *= 2), L;
          }
          return 0;
        }
        function P() {
          l.clear(l.COLOR_BUFFER_BIT | l.DEPTH_BUFFER_BIT);
        }
        function O(m, L) {
          function Y($t) {
            $t && (L.colorData.push($t[0]), L.colorData.push($t[1]), L.colorData.push($t[2]), L.colorData.push($t[3]));
          }
          function F($t, ue, ge, De, Le) {
            Y(Le), f.usePreallocated ? (p.push($t, ue, ge ? 1 : 0, De || 1), i += 4) : (n.push($t), n.push(ue), n.push(ge ? 1 : 0), n.push(De || 1));
          }
          function Q() {
            L.segments.length && (L.segments[L.segments.length - 1].to = n.length || i);
          }
          function k() {
            L.segments.length && L.segments[L.segments.length - 1].from === (n.length || i) || (Q(), L.segments.push({ from: n.length || i }));
          }
          function G($t, ue, ge, De, Le) {
            Y(Le), F($t + ge, ue), Y(Le), F($t, ue), Y(Le), F($t, ue + De), Y(Le), F($t, ue + De), Y(Le), F($t + ge, ue + De), Y(Le), F($t + ge, ue);
          }
          function z($t, ue) {
            f.useGPUTranslations || (L.skipTranslation = !0, $t.x = ht.toPixels($t.x, !0), $t.y = st.toPixels($t.y, !0)), ue ? n = [$t.x, $t.y, 0, 2].concat(n) : F($t.x, $t.y, 0, 2);
          }
          var V = m.pointArrayMap && m.pointArrayMap.join(",") === "low,high", q = m.chart, it = m.options, et = !!it.stacking, nt = it.data, rt = m.xAxis.getExtremes(), ct = rt.min, gt = rt.max;
          rt = m.yAxis.getExtremes();
          var dt = rt.min, lt = rt.max, at = m.xData || it.xData || m.processedXData, J = m.yData || it.yData || m.processedYData, tt = m.zData || it.zData || m.processedZData, st = m.yAxis, ht = m.xAxis, pt = m.chart.plotWidth, yt = !at || at.length === 0, vt = it.connectNulls;
          rt = m.points || !1;
          var Ct = !1, Tt = !1, kt, St, _t = et ? m.data : at || nt, Lt = { x: Number.MAX_VALUE, y: 0 }, Nt = { x: -Number.MAX_VALUE, y: 0 }, Et = 0, Kt = !1, Gt, Wt, Jt, be, zt = -1, Vt = !1, Me = !1, Lr, co = typeof q.index > "u", Pn = !1, En = !1, $e = !1, On = T[m.type], Ln = !1, Zr = !0, po = !0, Xs = it.zoneAxis || "y", _r = it.zones || !1, zi = !1, uo = it.threshold, _n = !1;
          if (!(it.boostData && 0 < it.boostData.length)) {
            if (it.gapSize && (_n = it.gapUnit !== "value" ? it.gapSize * m.closestPointRange : it.gapSize), _r) {
              var Dr = [];
              _r.forEach(function($t, ue) {
                if ($t.color) {
                  var ge = H($t.color).rgba;
                  ge[0] /= 255, ge[1] /= 255, ge[2] /= 255, Dr[ue] = ge, zi || typeof $t.value < "u" || (zi = ge);
                }
              }), zi || (at = m.pointAttribs && m.pointAttribs().fill || m.color, zi = H(at).rgba, zi[0] /= 255, zi[1] /= 255, zi[2] /= 255);
            }
            if (q.inverted && (pt = m.chart.plotHeight), m.closestPointRangePx = Number.MAX_VALUE, k(), rt && 0 < rt.length)
              L.skipTranslation = !0, L.drawMode = "triangles", rt[0].node && rt[0].node.levelDynamic && rt.sort(function($t, ue) {
                if ($t.node) {
                  if ($t.node.levelDynamic > ue.node.levelDynamic)
                    return 1;
                  if ($t.node.levelDynamic < ue.node.levelDynamic)
                    return -1;
                }
                return 0;
              }), rt.forEach(function($t) {
                var ue = $t.plotY;
                if (typeof ue < "u" && !isNaN(ue) && $t.y !== null && $t.shapeArgs) {
                  var ge = $t.shapeArgs;
                  ue = ge.x, ue = ue === void 0 ? 0 : ue;
                  var De = ge.y;
                  De = De === void 0 ? 0 : De;
                  var Le = ge.width;
                  Le = Le === void 0 ? 0 : Le, ge = ge.height, ge = ge === void 0 ? 0 : ge;
                  var Kr = q.styledMode ? $t.series.colorAttribs($t) : Kr = $t.series.pointAttribs($t);
                  $t = Kr["stroke-width"] || 0, $e = H(Kr.fill).rgba, $e[0] /= 255, $e[1] /= 255, $e[2] /= 255, m.type === "treemap" && ($t = $t || 1, St = H(Kr.stroke).rgba, St[0] /= 255, St[1] /= 255, St[2] /= 255, G(ue, De, Le, ge, St), $t /= 2), m.type === "heatmap" && q.inverted && (ue = ht.len - ue, De = st.len - De, Le = -Le, ge = -ge), G(ue + $t, De + $t, Le - 2 * $t, ge - 2 * $t, $e);
                }
              });
            else {
              for (rt = function() {
                if (Jt = _t[++zt], typeof Jt > "u")
                  return "continue";
                if (co)
                  return "break";
                var $t = nt && nt[zt];
                if (!yt && W($t, !0) && $t.color && ($e = H($t.color).rgba, $e[0] /= 255, $e[1] /= 255, $e[2] /= 255), yt ? (Gt = Jt[0], Wt = Jt[1], _t[zt + 1] && (Me = _t[zt + 1][0]), _t[zt - 1] && (Vt = _t[zt - 1][0]), 3 <= Jt.length && (be = Jt[2], Jt[2] > L.zMax && (L.zMax = Jt[2]), Jt[2] < L.zMin && (L.zMin = Jt[2]))) : (Gt = Jt, Wt = J[zt], _t[zt + 1] && (Me = _t[zt + 1]), _t[zt - 1] && (Vt = _t[zt - 1]), tt && tt.length && (be = tt[zt], tt[zt] > L.zMax && (L.zMax = tt[zt]), tt[zt] < L.zMin && (L.zMin = tt[zt]))), !vt && (Gt === null || Wt === null))
                  return k(), "continue";
                if (Me && Me >= ct && Me <= gt && (Pn = !0), Vt && Vt >= ct && Vt <= gt && (En = !0), V ? (yt && (Wt = Jt.slice(1, 3)), Lr = Wt[0], Wt = Wt[1]) : et && (Gt = Jt.x, Wt = Jt.stackY, Lr = Wt - Jt.y), dt !== null && typeof dt < "u" && lt !== null && typeof lt < "u" && (Zr = Wt >= dt && Wt <= lt), Gt > gt && Nt.x < gt && (Nt.x = Gt, Nt.y = Wt), Gt < ct && Lt.x > ct && (Lt.x = Gt, Lt.y = Wt), Wt === null && vt)
                  return "continue";
                if (Wt === null || !Zr && !Pn && !En)
                  return k(), "continue";
                if ((Me >= ct || Gt >= ct) && (Vt <= gt || Gt <= gt) && (Ln = !0), !Ln && !Pn && !En)
                  return "continue";
                if (_n && Gt - Vt > _n && k(), _r) {
                  var ue;
                  _r.some(function(ge, De) {
                    var Le = _r[De - 1];
                    return Xs === "x" ? typeof ge.value < "u" && Gt <= ge.value ? (Dr[De] && (!Le || Gt >= Le.value) && (ue = Dr[De]), !0) : !1 : typeof ge.value < "u" && Wt <= ge.value ? (Dr[De] && (!Le || Wt >= Le.value) && (ue = Dr[De]), !0) : !1;
                  }), $e = ue || zi || $e;
                }
                if (!f.useGPUTranslations && (L.skipTranslation = !0, Gt = ht.toPixels(Gt, !0), Wt = st.toPixels(Wt, !0), Gt > pt && L.drawMode === "points"))
                  return "continue";
                if (L.hasMarkers && Ln && Ct !== !1 && (m.closestPointRangePx = Math.min(m.closestPointRangePx, Math.abs(Gt - Ct))), !f.useGPUTranslations && !f.usePreallocated && Ct && 1 > Math.abs(Gt - Ct) && Tt && 1 > Math.abs(Wt - Tt))
                  return f.debug.showSkipSummary && ++Et, "continue";
                On && (kt = Lr, (Lr === !1 || typeof Lr > "u") && (kt = 0 > Wt ? Wt : 0), V || et || (kt = Math.max(uo === null ? dt : uo, dt)), f.useGPUTranslations || (kt = st.toPixels(kt, !0)), F(Gt, kt, 0, 0, $e)), it.step && !po && F(Gt, Tt, 0, 2, $e), F(Gt, Wt, 0, m.type === "bubble" ? be || 1 : 2, $e), Ct = Gt, Tt = Wt, Kt = !0, po = !1;
              }; zt < _t.length - 1 && rt() !== "break"; )
                ;
              f.debug.showSkipSummary && console.log("skipped points:", Et), Kt || vt === !1 || m.drawMode !== "line_strip" || (Lt.x < Number.MAX_VALUE && z(Lt, !0), Nt.x > -Number.MAX_VALUE && z(Nt));
            }
            Q();
          }
        }
        function B() {
          D = [], A.data = n = [], o = [], p && p.destroy();
        }
        function C(m) {
          c && (c.setUniform("xAxisTrans", m.transA), c.setUniform("xAxisMin", m.min), c.setUniform("xAxisMinPad", m.minPixelPadding), c.setUniform("xAxisPointRange", m.pointRange), c.setUniform("xAxisLen", m.len), c.setUniform(
            "xAxisPos",
            m.pos
          ), c.setUniform("xAxisCVSCoord", !m.horiz), c.setUniform("xAxisIsLog", !!m.logarithmic), c.setUniform("xAxisReversed", !!m.reversed));
        }
        function b(m) {
          c && (c.setUniform("yAxisTrans", m.transA), c.setUniform("yAxisMin", m.min), c.setUniform("yAxisMinPad", m.minPixelPadding), c.setUniform("yAxisPointRange", m.pointRange), c.setUniform("yAxisLen", m.len), c.setUniform("yAxisPos", m.pos), c.setUniform("yAxisCVSCoord", !m.horiz), c.setUniform("yAxisIsLog", !!m.logarithmic), c.setUniform("yAxisReversed", !!m.reversed));
        }
        function w(m, L) {
          c.setUniform("hasThreshold", m), c.setUniform("translatedThreshold", L);
        }
        function x(m) {
          if (m)
            s = m.chartWidth || 800, t = m.chartHeight || 400;
          else
            return !1;
          if (!(l && s && t && c))
            return !1;
          f.debug.timeRendering && console.time("gl rendering"), l.canvas.width = s, l.canvas.height = t, c.bind(), l.viewport(0, 0, s, t), c.setPMatrix([2 / s, 0, 0, 0, 0, -(2 / t), 0, 0, 0, 0, -2, 0, -1, 1, -1, 1]), 1 < f.lineWidth && !I.isMS && l.lineWidth(f.lineWidth), p.build(A.data, "aVertexPosition", 4), p.bind(), c.setInverted(m.inverted), D.forEach(function(L, Y) {
            var F = L.series.options, Q = F.marker, k = typeof F.lineWidth < "u" ? F.lineWidth : 1, G = F.threshold, z = U(G), V = L.series.yAxis.getThreshold(G);
            if (G = v(F.marker ? F.marker.enabled : null, L.series.xAxis.isRadial ? !0 : null, L.series.closestPointRangePx > 2 * ((F.marker ? F.marker.radius : 10) || 10)), Q = j[Q && Q.symbol || L.series.symbol] || j.circle, L.segments.length !== 0 && L.segments[0].from !== L.segments[0].to) {
              if (Q.isReady && (l.bindTexture(l.TEXTURE_2D, Q.handle), c.setTexture(Q.handle)), m.styledMode ? Q = L.series.markerGroup && L.series.markerGroup.getStyle("fill") : (Q = L.drawMode === "points" && L.series.pointAttribs && L.series.pointAttribs().fill || L.series.color, F.colorByPoint && (Q = L.series.chart.options.colors[Y])), L.series.fillOpacity && F.fillOpacity && (Q = new a(Q).setOpacity(v(F.fillOpacity, 1)).get()), Q = H(Q).rgba, f.useAlpha || (Q[3] = 1), L.drawMode === "lines" && f.useAlpha && 1 > Q[3] && (Q[3] /= 10), F.boostBlending === "add" ? (l.blendFunc(l.SRC_ALPHA, l.ONE), l.blendEquation(l.FUNC_ADD)) : F.boostBlending === "mult" || F.boostBlending === "multiply" ? l.blendFunc(l.DST_COLOR, l.ZERO) : F.boostBlending === "darken" ? (l.blendFunc(l.ONE, l.ONE), l.blendEquation(l.FUNC_MIN)) : l.blendFuncSeparate(l.SRC_ALPHA, l.ONE_MINUS_SRC_ALPHA, l.ONE, l.ONE_MINUS_SRC_ALPHA), c.reset(), 0 < L.colorData.length ? (c.setUniform("hasColor", 1), Y = R(l, c), Y.build(L.colorData, "aColor", 4), Y.bind()) : l.disableVertexAttribArray(l.getAttribLocation(c.program(), "aColor")), c.setColor(Q), C(L.series.xAxis), b(L.series.yAxis), w(z, V), L.drawMode === "points" && (F.marker && U(F.marker.radius) ? c.setPointSize(2 * F.marker.radius) : c.setPointSize(1)), c.setSkipTranslation(L.skipTranslation), L.series.type === "bubble" && c.setBubbleUniforms(L.series, L.zMin, L.zMax), c.setDrawAsCircle(X[L.series.type] || !1), 0 < k || L.drawMode !== "line_strip")
                for (k = 0; k < L.segments.length; k++)
                  p.render(L.segments[k].from, L.segments[k].to, L.drawMode);
              if (L.hasMarkers && G)
                for (F.marker && U(F.marker.radius) ? c.setPointSize(2 * F.marker.radius) : c.setPointSize(10), c.setDrawAsCircle(!0), k = 0; k < L.segments.length; k++)
                  p.render(L.segments[k].from, L.segments[k].to, "POINTS");
            }
          }), f.debug.timeRendering && console.timeEnd("gl rendering"), u && u(), B();
        }
        function h(m) {
          if (P(), m.renderer.forExport)
            return x(m);
          _ ? x(m) : setTimeout(function() {
            h(m);
          }, 1);
        }
        var c = !1, p = !1, i = 0, l = !1, s = 0, t = 0, n = !1, o = !1, A = {}, _ = !1, D = [], j = {}, T = { column: !0, columnrange: !0, bar: !0, area: !0, arearange: !0 }, X = { scatter: !0, bubble: !0 }, f = { pointSize: 1, lineWidth: 1, fillColor: "#AA00AA", useAlpha: !0, usePreallocated: !1, useGPUTranslations: !1, debug: { timeRendering: !1, timeSeriesProcessing: !1, timeSetup: !1, timeBufferCopy: !1, timeKDTree: !1, showSkipSummary: !1 } };
        return A = { allocateBufferForSingleSeries: function(m) {
          var L = 0;
          f.usePreallocated && (m.isSeriesBoosting && (L = d(m)), p.allocate(L));
        }, pushSeries: function(m) {
          0 < D.length && D[D.length - 1].hasMarkers && (D[D.length - 1].markerTo = o.length), f.debug.timeSeriesProcessing && console.time("building " + m.type + " series");
          var L = { segments: [], markerFrom: o.length, colorData: [], series: m, zMin: Number.MAX_VALUE, zMax: -Number.MAX_VALUE, hasMarkers: m.options.marker ? m.options.marker.enabled !== !1 : !1, showMarkers: !0, drawMode: {
            area: "lines",
            arearange: "lines",
            areaspline: "line_strip",
            column: "lines",
            columnrange: "lines",
            bar: "lines",
            line: "line_strip",
            scatter: "points",
            heatmap: "triangles",
            treemap: "triangles",
            bubble: "points"
          }[m.type] || "line_strip" };
          m.index >= D.length ? D.push(L) : D[m.index] = L, O(m, L), f.debug.timeSeriesProcessing && console.timeEnd("building " + m.type + " series");
        }, setSize: function(m, L) {
          s === m && t === L || !c || (s = m, t = L, c.bind(), c.setPMatrix([2 / s, 0, 0, 0, 0, -(2 / t), 0, 0, 0, 0, -2, 0, -1, 1, -1, 1]));
        }, inited: function() {
          return _;
        }, setThreshold: w, init: function(m, L) {
          function Y(k, G) {
            var z = { isReady: !1, texture: $.createElement("canvas"), handle: l.createTexture() }, V = z.texture.getContext("2d");
            j[k] = z, z.texture.width = 512, z.texture.height = 512, V.mozImageSmoothingEnabled = !1, V.webkitImageSmoothingEnabled = !1, V.msImageSmoothingEnabled = !1, V.imageSmoothingEnabled = !1, V.strokeStyle = "rgba(255, 255, 255, 0)", V.fillStyle = "#FFF", G(V);
            try {
              l.activeTexture(l.TEXTURE0), l.bindTexture(l.TEXTURE_2D, z.handle), l.texImage2D(l.TEXTURE_2D, 0, l.RGBA, l.RGBA, l.UNSIGNED_BYTE, z.texture), l.texParameteri(l.TEXTURE_2D, l.TEXTURE_WRAP_S, l.CLAMP_TO_EDGE), l.texParameteri(
                l.TEXTURE_2D,
                l.TEXTURE_WRAP_T,
                l.CLAMP_TO_EDGE
              ), l.texParameteri(l.TEXTURE_2D, l.TEXTURE_MAG_FILTER, l.LINEAR), l.texParameteri(l.TEXTURE_2D, l.TEXTURE_MIN_FILTER, l.LINEAR), l.bindTexture(l.TEXTURE_2D, null), z.isReady = !0;
            } catch {
            }
          }
          var F = 0, Q = ["webgl", "experimental-webgl", "moz-webgl", "webkit-3d"];
          if (_ = !1, !m)
            return !1;
          for (f.debug.timeSetup && console.time("gl setup"); F < Q.length && !(l = m.getContext(Q[F], {})); F++)
            ;
          if (l)
            L || B();
          else
            return !1;
          return l.enable(l.BLEND), l.blendFunc(l.SRC_ALPHA, l.ONE_MINUS_SRC_ALPHA), l.disable(l.DEPTH_TEST), l.depthFunc(l.LESS), c = y(l), c ? (p = R(l, c), Y("circle", function(k) {
            k.beginPath(), k.arc(256, 256, 256, 0, 2 * Math.PI), k.stroke(), k.fill();
          }), Y("square", function(k) {
            k.fillRect(0, 0, 512, 512);
          }), Y("diamond", function(k) {
            k.beginPath(), k.moveTo(256, 0), k.lineTo(512, 256), k.lineTo(256, 512), k.lineTo(0, 256), k.lineTo(256, 0), k.fill();
          }), Y("triangle", function(k) {
            k.beginPath(), k.moveTo(0, 512), k.lineTo(256, 0), k.lineTo(512, 512), k.lineTo(0, 512), k.fill();
          }), Y("triangle-down", function(k) {
            k.beginPath(), k.moveTo(0, 0), k.lineTo(256, 512), k.lineTo(
              512,
              0
            ), k.lineTo(0, 0), k.fill();
          }), _ = !0, f.debug.timeSetup && console.timeEnd("gl setup"), !0) : !1;
        }, render: h, settings: f, valid: function() {
          return l !== !1;
        }, clear: P, flush: B, setXAxis: C, setYAxis: b, data: n, gl: function() {
          return l;
        }, allocateBuffer: function(m) {
          var L = 0;
          f.usePreallocated && (m.series.forEach(function(Y) {
            Y.isSeriesBoosting && (L += d(Y));
          }), p.allocate(L));
        }, destroy: function() {
          B(), p.destroy(), c.destroy(), l && (M(j, function(m) {
            m.handle && l.deleteTexture(m.handle);
          }), l.canvas.width = 1, l.canvas.height = 1);
        }, setOptions: function(m) {
          N(
            !0,
            f,
            m
          );
        } };
      };
    }), E(g, "Extensions/Boost/BoostAttach.js", [g["Core/Chart/Chart.js"], g["Extensions/Boost/WGLRenderer.js"], g["Core/Globals.js"], g["Core/Utilities.js"]], function(a, y, R, I) {
      var Z = R.doc, H = I.error, $;
      return function(U, W) {
        var N = U.chartWidth, M = U.chartHeight, v = U, u = U.seriesGroup || W.group, d = Z.implementation.hasFeature("www.http://w3.org/TR/SVG11/feature#Extensibility", "1.1");
        return v = U.isChartSeriesBoosting() ? U : W, d = !1, $ || ($ = Z.createElement("canvas")), v.renderTarget || (v.canvas = $, U.renderer.forExport || !d ? (v.renderTarget = U.renderer.image("", 0, 0, N, M).addClass("highcharts-boost-canvas").add(u), v.boostClear = function() {
          v.renderTarget.attr({ href: "" });
        }, v.boostCopy = function() {
          v.boostResizeTarget(), v.renderTarget.attr({ href: v.canvas.toDataURL("image/png") });
        }) : (v.renderTargetFo = U.renderer.createElement("foreignObject").add(u), v.renderTarget = Z.createElement("canvas"), v.renderTargetCtx = v.renderTarget.getContext("2d"), v.renderTargetFo.element.appendChild(v.renderTarget), v.boostClear = function() {
          v.renderTarget.width = v.canvas.width, v.renderTarget.height = v.canvas.height;
        }, v.boostCopy = function() {
          v.renderTarget.width = v.canvas.width, v.renderTarget.height = v.canvas.height, v.renderTargetCtx.drawImage(v.canvas, 0, 0);
        }), v.boostResizeTarget = function() {
          N = U.chartWidth, M = U.chartHeight, (v.renderTargetFo || v.renderTarget).attr({ x: 0, y: 0, width: N, height: M }).css({ pointerEvents: "none", mixedBlendMode: "normal", opacity: 1 }), v instanceof a && v.markerGroup.translate(U.plotLeft, U.plotTop);
        }, v.boostClipRect = U.renderer.clipRect(), (v.renderTargetFo || v.renderTarget).clip(v.boostClipRect), v instanceof a && (v.markerGroup = v.renderer.g().add(u), v.markerGroup.translate(W.xAxis.pos, W.yAxis.pos))), v.canvas.width = N, v.canvas.height = M, v.boostClipRect.attr(U.getBoostClipRect(v)), v.boostResizeTarget(), v.boostClear(), v.ogl || (v.ogl = y(function() {
          v.ogl.settings.debug.timeBufferCopy && console.time("buffer copy"), v.boostCopy(), v.ogl.settings.debug.timeBufferCopy && console.timeEnd("buffer copy");
        }), v.ogl.init(v.canvas) || H("[highcharts boost] - unable to init WebGL renderer"), v.ogl.setOptions(U.options.boost || {}), v instanceof a && v.ogl.allocateBuffer(U)), v.ogl.setSize(N, M), v.ogl;
      };
    }), E(g, "Extensions/Boost/BoostUtils.js", [g["Core/Globals.js"], g["Extensions/Boost/BoostableMap.js"], g["Extensions/Boost/BoostAttach.js"], g["Core/Utilities.js"]], function(a, y, R, I) {
      function Z() {
        for (var u = [], d = 0; d < arguments.length; d++)
          u[d] = arguments[d];
        var P = -Number.MAX_VALUE;
        return u.forEach(function(O) {
          if (typeof O < "u" && O !== null && typeof O.length < "u" && 0 < O.length)
            return P = O.length, !0;
        }), P;
      }
      function H(u, d, P) {
        u && d.renderTarget && d.canvas && !(P || d.chart).isChartSeriesBoosting() && u.render(P || d.chart);
      }
      function $(u, d) {
        u && d.renderTarget && d.canvas && !d.chart.isChartSeriesBoosting() && u.allocateBufferForSingleSeries(d);
      }
      function U(u, d, P, O, B, C) {
        B = B || 0, O = O || 3e3;
        for (var b = B + O, w = !0; w && B < b && B < u.length; )
          w = d(u[B], B), ++B;
        w && (B < u.length ? C ? U(u, d, P, O, B, C) : N.requestAnimationFrame ? N.requestAnimationFrame(function() {
          U(u, d, P, O, B);
        }) : setTimeout(function() {
          U(u, d, P, O, B);
        }) : P && P());
      }
      function W() {
        var u = 0, d, P = [
          "webgl",
          "experimental-webgl",
          "moz-webgl",
          "webkit-3d"
        ], O = !1;
        if (typeof N.WebGLRenderingContext < "u")
          for (d = M.createElement("canvas"); u < P.length; u++)
            try {
              if (O = d.getContext(P[u]), typeof O < "u" && O !== null)
                return !0;
            } catch {
            }
        return !1;
      }
      var N = a.win, M = a.doc, v = I.pick;
      return I = { patientMax: Z, boostEnabled: function(u) {
        return v(u && u.options && u.options.boost && u.options.boost.enabled, !0);
      }, shouldForceChartSeriesBoosting: function(u) {
        var d = 0, P = 0, O = v(u.options.boost && u.options.boost.allowForce, !0);
        if (typeof u.boostForceChartBoost < "u")
          return u.boostForceChartBoost;
        if (1 < u.series.length)
          for (var B = 0; B < u.series.length; B++) {
            var C = u.series[B];
            C.options.boostThreshold !== 0 && C.visible !== !1 && C.type !== "heatmap" && (y[C.type] && ++P, Z(C.processedXData, C.options.data, C.points) >= (C.options.boostThreshold || Number.MAX_VALUE) && ++d);
          }
        return u.boostForceChartBoost = O && (P === u.series.length && 0 < d || 5 < d), u.boostForceChartBoost;
      }, renderIfNotSeriesBoosting: H, allocateIfNotSeriesBoosting: $, eachAsync: U, hasWebGLSupport: W, pointDrawHandler: function(u) {
        var d = !0;
        if (this.chart.options && this.chart.options.boost && (d = typeof this.chart.options.boost.enabled > "u" ? !0 : this.chart.options.boost.enabled), !d || !this.isSeriesBoosting)
          return u.call(this);
        this.chart.isBoosting = !0, (u = R(this.chart, this)) && ($(u, this), u.pushSeries(this)), H(u, this);
      } }, a.hasWebGLSupport = W, I;
    }), E(
      g,
      "Extensions/Boost/BoostInit.js",
      [g["Core/Chart/Chart.js"], g["Core/Globals.js"], g["Core/Series/Series.js"], g["Core/Series/SeriesRegistry.js"], g["Core/Utilities.js"], g["Extensions/Boost/BoostUtils.js"], g["Extensions/Boost/BoostAttach.js"]],
      function(a, y, R, I, Z, H, $) {
        var U = y.noop, W = I.seriesTypes, N = Z.addEvent, M = Z.extend, v = Z.fireEvent, u = Z.wrap, d = H.eachAsync, P = H.pointDrawHandler, O = H.allocateIfNotSeriesBoosting, B = H.renderIfNotSeriesBoosting, C = H.shouldForceChartSeriesBoosting, b;
        return function() {
          M(R.prototype, { renderCanvas: function() {
            function w(dt, lt) {
              var at = !1, J = typeof i.index > "u", tt = !0;
              if (typeof dt > "u")
                return !0;
              if (!J) {
                if (G)
                  var st = dt[0], ht = dt[1];
                else
                  st = dt, ht = n[lt];
                Y ? (G && (ht = dt.slice(1, 3)), at = ht[0], ht = ht[1]) : F && (st = dt.x, ht = dt.stackY, at = ht - dt.y), k || (tt = ht >= D && ht <= j), ht !== null && st >= A && st <= _ && tt && (dt = l.toPixels(st, !0), f ? ((typeof q > "u" || dt === X) && (Y || (at = ht), (typeof it > "u" || ht > V) && (V = ht, it = lt), (typeof q > "u" || at < z) && (z = at, q = lt)), dt !== X && (typeof q < "u" && (ht = s.toPixels(V, !0), L = s.toPixels(z, !0), rt(dt, ht, it), L !== ht && rt(dt, L, q)), q = it = void 0, X = dt)) : (ht = Math.ceil(s.toPixels(ht, !0)), rt(dt, ht, lt)));
              }
              return !J;
            }
            function x() {
              v(h, "renderedCanvas"), delete h.buildKDTree, h.buildKDTree(), ct.debug.timeKDTree && console.timeEnd("kd tree building");
            }
            var h = this, c = h.options || {}, p = !1, i = h.chart, l = this.xAxis, s = this.yAxis, t = c.xData || h.processedXData, n = c.yData || h.processedYData, o = c.data;
            p = l.getExtremes();
            var A = p.min, _ = p.max;
            p = s.getExtremes();
            var D = p.min, j = p.max, T = {}, X, f = !!h.sampling, m = c.enableMouseTracking !== !1, L = s.getThreshold(c.threshold), Y = h.pointArrayMap && h.pointArrayMap.join(",") === "low,high", F = !!c.stacking, Q = h.cropStart || 0, k = h.requireSorting, G = !t, z, V, q, it, et = c.findNearestPointBy === "x", nt = this.xData || this.options.xData || this.processedXData || !1, rt = function(dt, lt, at) {
              dt = Math.ceil(dt), b = et ? dt : dt + "," + lt, m && !T[b] && (T[b] = !0, i.inverted && (dt = l.len - dt, lt = s.len - lt), gt.push({ x: nt ? nt[Q + at] : !1, clientX: dt, plotX: dt, plotY: lt, i: Q + at }));
            };
            p = $(i, h), i.isBoosting = !0;
            var ct = p.settings;
            if (this.visible) {
              (this.points || this.graph) && this.destroyGraphics(), i.isChartSeriesBoosting() ? (this.markerGroup && this.markerGroup !== i.markerGroup && this.markerGroup.destroy(), this.markerGroup = i.markerGroup, this.renderTarget && (this.renderTarget = this.renderTarget.destroy())) : (this.markerGroup === i.markerGroup && (this.markerGroup = void 0), this.markerGroup = h.plotGroup("markerGroup", "markers", !0, 1, i.seriesGroup));
              var gt = this.points = [];
              h.buildKDTree = U, p && (O(p, this), p.pushSeries(h), B(p, this, i)), i.renderer.forExport || (ct.debug.timeKDTree && console.time("kd tree building"), d(F ? h.data : t || o, w, x));
            }
          } }), ["heatmap", "treemap"].forEach(function(w) {
            W[w] && u(W[w].prototype, "drawPoints", P);
          }), W.bubble && (delete W.bubble.prototype.buildKDTree, u(W.bubble.prototype, "markerAttribs", function(w) {
            return this.isSeriesBoosting ? !1 : w.apply(this, [].slice.call(arguments, 1));
          })), W.scatter.prototype.fill = !0, M(W.area.prototype, { fill: !0, fillOpacity: !0, sampling: !0 }), M(W.column.prototype, { fill: !0, sampling: !0 }), a.prototype.propsRequireUpdateSeries.push("boost"), a.prototype.callbacks.push(function(w) {
            N(w, "predraw", function() {
              w.boostForceChartBoost = void 0, w.boostForceChartBoost = C(w), w.isBoosting = !1, !w.isChartSeriesBoosting() && w.didBoost && (w.didBoost = !1), w.boostClear && w.boostClear(), w.canvas && w.ogl && w.isChartSeriesBoosting() && (w.didBoost = !0, w.ogl.allocateBuffer(w)), w.markerGroup && w.xAxis && 0 < w.xAxis.length && w.yAxis && 0 < w.yAxis.length && w.markerGroup.translate(w.xAxis[0].pos, w.yAxis[0].pos);
            }), N(w, "render", function() {
              w.ogl && w.isChartSeriesBoosting() && w.ogl.render(w);
            });
            var x = -1, h = -1;
            N(w.pointer, "afterGetHoverData", function() {
              var c = w.hoverSeries;
              if (w.markerGroup && c) {
                var p = w.inverted ? c.yAxis : c.xAxis;
                c = w.inverted ? c.xAxis : c.yAxis, (p && p.pos !== x || c && c.pos !== h) && (w.markerGroup.translate(p.pos, c.pos), x = p.pos, h = c.pos);
              }
            });
          });
        };
      }
    ), E(
      g,
      "Extensions/BoostCanvas.js",
      [g["Core/Chart/Chart.js"], g["Core/Color/Color.js"], g["Core/Globals.js"], g["Core/Series/Series.js"], g["Core/Series/SeriesRegistry.js"], g["Core/Utilities.js"]],
      function(a, y, R, I, Z, H) {
        var $ = y.parse, U = R.doc, W = R.noop, N = Z.seriesTypes, M = H.addEvent, v = H.extend, u = H.fireEvent, d = H.isNumber, P = H.merge, O = H.pick, B = H.wrap, C;
        return function() {
          R.seriesTypes.heatmap && B(R.seriesTypes.heatmap.prototype, "drawPoints", function() {
            var b = this.chart, w = this.getContext(), x = this.chart.inverted, h = this.xAxis, c = this.yAxis;
            w ? (this.points.forEach(function(p) {
              var i = p.plotY;
              if (typeof i < "u" && !isNaN(i) && p.y !== null && w) {
                var l = p.shapeArgs || {};
                i = l.x, i = i === void 0 ? 0 : i;
                var s = l.y;
                s = s === void 0 ? 0 : s;
                var t = l.width;
                t = t === void 0 ? 0 : t, l = l.height, l = l === void 0 ? 0 : l, p = b.styledMode ? p.series.colorAttribs(p) : p.series.pointAttribs(p), w.fillStyle = p.fill, x ? w.fillRect(c.len - s + h.left, h.len - i + c.top, -l, -t) : w.fillRect(i + h.left, s + c.top, t, l);
              }
            }), this.canvasToSVG()) : this.chart.showLoading("Your browser doesn't support HTML5 canvas, <br>please use a modern browser");
          }), v(I.prototype, { getContext: function() {
            var b = this.chart, w = b.chartWidth, x = b.chartHeight, h = b.seriesGroup || this.group, c = this, p = function(l, s, t, n, o, A, _) {
              l.call(this, t, s, n, o, A, _);
            };
            b.isChartSeriesBoosting() && (c = b, h = b.seriesGroup);
            var i = c.ctx;
            return c.canvas || (c.canvas = U.createElement("canvas"), c.renderTarget = b.renderer.image("", 0, 0, w, x).addClass("highcharts-boost-canvas").add(h), c.ctx = i = c.canvas.getContext("2d"), b.inverted && ["moveTo", "lineTo", "rect", "arc"].forEach(function(l) {
              B(i, l, p);
            }), c.boostCopy = function() {
              c.renderTarget.attr({ href: c.canvas.toDataURL("image/png") });
            }, c.boostClear = function() {
              i.clearRect(0, 0, c.canvas.width, c.canvas.height), c === this && c.renderTarget.attr({ href: "" });
            }, c.boostClipRect = b.renderer.clipRect(), c.renderTarget.clip(c.boostClipRect)), c.canvas.width !== w && (c.canvas.width = w), c.canvas.height !== x && (c.canvas.height = x), c.renderTarget.attr({ x: 0, y: 0, width: w, height: x, style: "pointer-events: none", href: "" }), c.boostClipRect.attr(b.getBoostClipRect(c)), i;
          }, canvasToSVG: function() {
            this.chart.isChartSeriesBoosting() ? this.boostClear && this.boostClear() : (this.boostCopy || this.chart.boostCopy) && (this.boostCopy || this.chart.boostCopy)();
          }, cvsLineTo: function(b, w, x) {
            b.lineTo(w, x);
          }, renderCanvas: function() {
            var b = this, w = b.options, x = b.chart, h = this.xAxis, c = this.yAxis, p = (x.options.boost || {}).timeRendering || !1, i = 0, l = b.processedXData, s = b.processedYData, t = w.data, n = h.getExtremes(), o = n.min, A = n.max;
            n = c.getExtremes();
            var _ = n.min, D = n.max, j = {}, T, X = !!b.sampling, f = w.marker && w.marker.radius, m = this.cvsDrawPoint, L = w.lineWidth ? this.cvsLineTo : void 0, Y = f && 1 >= f ? this.cvsMarkerSquare : this.cvsMarkerCircle, F = this.cvsStrokeBatch || 1e3, Q = w.enableMouseTracking !== !1, k;
            n = w.threshold;
            var G = c.getThreshold(n), z = d(n), V = G, q = this.fill, it = b.pointArrayMap && b.pointArrayMap.join(",") === "low,high", et = !!w.stacking, nt = b.cropStart || 0;
            n = x.options.loading;
            var rt = b.requireSorting, ct, gt = w.connectNulls, dt = !l, lt, at, J, tt, st, ht = et ? b.data : l || t, pt = b.fillOpacity ? y.parse(b.color).setOpacity(O(w.fillOpacity, 0.75)).get() : b.color, yt = function() {
              q ? (_t.fillStyle = pt, _t.fill()) : (_t.strokeStyle = b.color, _t.lineWidth = w.lineWidth, _t.stroke());
            }, vt = function(Lt, Nt, Et, Kt) {
              i === 0 && (_t.beginPath(), L && (_t.lineJoin = "round")), x.scroller && b.options.className === "highcharts-navigator-series" ? (Nt += x.scroller.top, Et && (Et += x.scroller.top)) : Nt += x.plotTop, Lt += x.plotLeft, ct ? _t.moveTo(Lt, Nt) : m ? m(_t, Lt, Nt, Et, k) : L ? L(_t, Lt, Nt) : Y && Y.call(b, _t, Lt, Nt, f, Kt), i += 1, i === F && (yt(), i = 0), k = { clientX: Lt, plotY: Nt, yBottom: Et };
            }, Ct = w.findNearestPointBy === "x", Tt = this.xData || this.options.xData || this.processedXData || !1, kt = function(Lt, Nt, Et) {
              st = Ct ? Lt : Lt + "," + Nt, Q && !j[st] && (j[st] = !0, x.inverted && (Lt = h.len - Lt, Nt = c.len - Nt), St.push({ x: Tt ? Tt[nt + Et] : !1, clientX: Lt, plotX: Lt, plotY: Nt, i: nt + Et }));
            };
            this.renderTarget && this.renderTarget.attr({ href: "" }), (this.points || this.graph) && this.destroyGraphics(), b.plotGroup("group", "series", b.visible ? "visible" : "hidden", w.zIndex, x.seriesGroup), b.markerGroup = b.group, M(b, "destroy", function() {
              b.markerGroup = null;
            });
            var St = this.points = [], _t = this.getContext();
            b.buildKDTree = W, this.boostClear && this.boostClear(), this.visible && (99999 < t.length && (x.options.loading = P(n, { labelStyle: {
              backgroundColor: $("#ffffff").setOpacity(0.75).get(),
              padding: "1em",
              borderRadius: "0.5em"
            }, style: { backgroundColor: "none", opacity: 1 } }), H.clearTimeout(C), x.showLoading("Drawing..."), x.options.loading = n), p && console.time("canvas rendering"), R.eachAsync(ht, function(Lt, Nt) {
              var Et = !1, Kt = !1, Gt = !1, Wt = !1, Jt = typeof x.index > "u", be = !0;
              if (!Jt) {
                if (dt) {
                  var zt = Lt[0], Vt = Lt[1];
                  ht[Nt + 1] && (Gt = ht[Nt + 1][0]), ht[Nt - 1] && (Wt = ht[Nt - 1][0]);
                } else
                  zt = Lt, Vt = s[Nt], ht[Nt + 1] && (Gt = ht[Nt + 1]), ht[Nt - 1] && (Wt = ht[Nt - 1]);
                if (Gt && Gt >= o && Gt <= A && (Et = !0), Wt && Wt >= o && Wt <= A && (Kt = !0), it) {
                  dt && (Vt = Lt.slice(1, 3));
                  var Me = Vt[0];
                  Vt = Vt[1];
                } else
                  et && (zt = Lt.x, Vt = Lt.stackY, Me = Vt - Lt.y);
                Lt = Vt === null, rt || (be = Vt >= _ && Vt <= D), !Lt && (zt >= o && zt <= A && be || Et || Kt) && (zt = Math.round(h.toPixels(zt, !0)), X ? ((typeof J > "u" || zt === T) && (it || (Me = Vt), (typeof tt > "u" || Vt > at) && (at = Vt, tt = Nt), (typeof J > "u" || Me < lt) && (lt = Me, J = Nt)), zt !== T && (typeof J < "u" && (Vt = c.toPixels(at, !0), G = c.toPixels(lt, !0), vt(zt, z ? Math.min(Vt, V) : Vt, z ? Math.max(G, V) : G, Nt), kt(zt, Vt, tt), G !== Vt && kt(zt, G, J)), J = tt = void 0, T = zt)) : (Vt = Math.round(c.toPixels(Vt, !0)), vt(zt, Vt, G, Nt), kt(zt, Vt, Nt))), ct = Lt && !gt, Nt % 5e4 === 0 && (b.boostCopy || b.chart.boostCopy) && (b.boostCopy || b.chart.boostCopy)();
              }
              return !Jt;
            }, function() {
              var Lt = x.loadingDiv, Nt = x.loadingShown;
              yt(), b.canvasToSVG(), p && console.timeEnd("canvas rendering"), u(b, "renderedCanvas"), Nt && (v(Lt.style, { transition: "opacity 250ms", opacity: 0 }), x.loadingShown = !1, C = setTimeout(function() {
                Lt.parentNode && Lt.parentNode.removeChild(Lt), x.loadingDiv = x.loadingSpan = null;
              }, 250)), delete b.buildKDTree, b.buildKDTree();
            }, x.renderer.forExport ? Number.MAX_VALUE : void 0));
          } }), N.scatter.prototype.cvsMarkerCircle = function(b, w, x, h) {
            b.moveTo(w, x), b.arc(w, x, h, 0, 2 * Math.PI, !1);
          }, N.scatter.prototype.cvsMarkerSquare = function(b, w, x, h) {
            b.rect(w - h, x - h, 2 * h, 2 * h);
          }, N.scatter.prototype.fill = !0, N.bubble && (N.bubble.prototype.cvsMarkerCircle = function(b, w, x, h, c) {
            b.moveTo(w, x), b.arc(w, x, this.radii && this.radii[c], 0, 2 * Math.PI, !1);
          }, N.bubble.prototype.cvsStrokeBatch = 1), v(N.area.prototype, {
            cvsDrawPoint: function(b, w, x, h, c) {
              c && w !== c.clientX && (b.moveTo(c.clientX, c.yBottom), b.lineTo(c.clientX, c.plotY), b.lineTo(w, x), b.lineTo(w, h));
            },
            fill: !0,
            fillOpacity: !0,
            sampling: !0
          }), v(N.column.prototype, { cvsDrawPoint: function(b, w, x, h) {
            b.rect(w - 1, x, 1, h - x);
          }, fill: !0, sampling: !0 }), a.prototype.callbacks.push(function(b) {
            M(b, "predraw", function() {
              b.renderTarget && b.renderTarget.attr({ href: "" }), b.canvas && b.canvas.getContext("2d").clearRect(0, 0, b.canvas.width, b.canvas.height);
            }), M(b, "render", function() {
              b.boostCopy && b.boostCopy();
            });
          });
        };
      }
    ), E(g, "Extensions/Boost/BoostOverrides.js", [
      g["Core/Chart/Chart.js"],
      g["Core/DefaultOptions.js"],
      g["Core/Series/Point.js"],
      g["Core/Series/Series.js"],
      g["Core/Series/SeriesRegistry.js"],
      g["Core/Utilities.js"],
      g["Extensions/Boost/BoostUtils.js"],
      g["Extensions/Boost/Boostables.js"],
      g["Extensions/Boost/BoostableMap.js"]
    ], function(a, y, R, I, Z, H, $, U, W) {
      y = y.getOptions;
      var N = Z.seriesTypes;
      Z = H.addEvent;
      var M = H.error, v = H.isArray, u = H.isNumber, d = H.pick, P = H.wrap, O = $.boostEnabled, B = $.shouldForceChartSeriesBoosting, C = y().plotOptions;
      a.prototype.isChartSeriesBoosting = function() {
        return d(this.options.boost && this.options.boost.seriesThreshold, 50) <= this.series.length || B(this);
      }, a.prototype.getBoostClipRect = function(b) {
        var w = { x: this.plotLeft, y: this.plotTop, width: this.plotWidth, height: this.plotHeight };
        return b === this && (b = this.inverted ? this.xAxis : this.yAxis, 1 >= b.length ? (w.y = Math.min(b[0].pos, w.y), w.height = b[0].pos - this.plotTop + b[0].len) : w.height = this.plotHeight), w;
      }, I.prototype.getPoint = function(b) {
        var w = b, x = this.xData || this.options.xData || this.processedXData || !1;
        return !b || b instanceof this.pointClass || (w = new this.pointClass().init(this, this.options.data[b.i], x ? x[b.i] : void 0), w.category = d(this.xAxis.categories ? this.xAxis.categories[w.x] : w.x, w.x), w.dist = b.dist, w.distX = b.distX, w.plotX = b.plotX, w.plotY = b.plotY, w.index = b.i, w.isInside = this.isPointInside(b)), w;
      }, P(I.prototype, "searchPoint", function(b) {
        return this.getPoint(b.apply(this, [].slice.call(arguments, 1)));
      }), P(R.prototype, "haloPath", function(b) {
        var w = this.series, x = this.plotX, h = this.plotY, c = w.chart.inverted;
        w.isSeriesBoosting && c && (this.plotX = w.yAxis.len - h, this.plotY = w.xAxis.len - x);
        var p = b.apply(this, Array.prototype.slice.call(
          arguments,
          1
        ));
        return w.isSeriesBoosting && c && (this.plotX = x, this.plotY = h), p;
      }), P(I.prototype, "markerAttribs", function(b, w) {
        var x = w.plotX, h = w.plotY, c = this.chart.inverted;
        this.isSeriesBoosting && c && (w.plotX = this.yAxis.len - h, w.plotY = this.xAxis.len - x);
        var p = b.apply(this, Array.prototype.slice.call(arguments, 1));
        return this.isSeriesBoosting && c && (w.plotX = x, w.plotY = h), p;
      }), Z(I, "destroy", function() {
        var b = this, w = b.chart;
        w.markerGroup === b.markerGroup && (b.markerGroup = null), w.hoverPoints && (w.hoverPoints = w.hoverPoints.filter(function(x) {
          return x.series === b;
        })), w.hoverPoint && w.hoverPoint.series === b && (w.hoverPoint = null);
      }), P(I.prototype, "getExtremes", function(b) {
        return this.isSeriesBoosting && this.hasExtremes && this.hasExtremes() ? {} : b.apply(this, Array.prototype.slice.call(arguments, 1));
      }), ["translate", "generatePoints", "drawTracker", "drawPoints", "render"].forEach(function(b) {
        function w(x) {
          var h = this.options.stacking && (b === "translate" || b === "generatePoints");
          !this.isSeriesBoosting || h || !O(this.chart) || this.type === "heatmap" || this.type === "treemap" || !W[this.type] || this.options.boostThreshold === 0 ? x.call(this) : this[b + "Canvas"] && this[b + "Canvas"]();
        }
        P(I.prototype, b, w), b === "translate" && "column bar arearange columnrange heatmap treemap".split(" ").forEach(function(x) {
          N[x] && P(N[x].prototype, b, w);
        });
      }), P(I.prototype, "processData", function(b) {
        function w(c) {
          return x.forceCrop ? !1 : x.chart.isChartSeriesBoosting() || (c ? c.length : 0) >= (x.options.boostThreshold || Number.MAX_VALUE);
        }
        var x = this, h = this.options.data;
        O(this.chart) && W[this.type] ? (w(h) && this.type !== "heatmap" && this.type !== "treemap" && !this.options.stacking && this.hasExtremes && this.hasExtremes(!0) || (b.apply(this, Array.prototype.slice.call(arguments, 1)), h = this.processedXData), (this.isSeriesBoosting = w(h)) ? (h = void 0, this.options.data && this.options.data.length && (h = this.getFirstValidPoint(this.options.data), u(h) || v(h) || M(12, !1, this.chart)), this.enterBoost()) : this.exitBoost && this.exitBoost()) : b.apply(this, Array.prototype.slice.call(arguments, 1));
      }), Z(I, "hide", function() {
        this.canvas && this.renderTarget && (this.ogl && this.ogl.clear(), this.boostClear());
      }), I.prototype.enterBoost = function() {
        this.alteredByBoost = [], ["allowDG", "directTouch", "stickyTracking"].forEach(function(b) {
          this.alteredByBoost.push({ prop: b, val: this[b], own: Object.hasOwnProperty.call(this, b) });
        }, this), this.directTouch = this.allowDG = !1, this.finishedAnimating = this.stickyTracking = !0, this.labelBySeries && (this.labelBySeries = this.labelBySeries.destroy());
      }, I.prototype.exitBoost = function() {
        (this.alteredByBoost || []).forEach(
          function(b) {
            b.own ? this[b.prop] = b.val : delete this[b.prop];
          },
          this
        ), this.boostClear && this.boostClear();
      }, I.prototype.hasExtremes = function(b) {
        var w = this.options, x = this.xAxis && this.xAxis.options, h = this.yAxis && this.yAxis.options, c = this.colorAxis && this.colorAxis.options;
        return w.data.length > (w.boostThreshold || Number.MAX_VALUE) && u(h.min) && u(h.max) && (!b || u(x.min) && u(x.max)) && (!c || u(c.min) && u(c.max));
      }, I.prototype.destroyGraphics = function() {
        var b = this, w = this, x = this.points, h, c;
        if (x)
          for (c = 0; c < x.length; c += 1)
            (h = x[c]) && h.destroyElements && h.destroyElements();
        [
          "graph",
          "area",
          "tracker"
        ].forEach(function(p) {
          w[p] && (w[p] = w[p].destroy());
        }), this.getZonesGraphs && this.getZonesGraphs([["graph", "highcharts-graph"]]).forEach(function(p) {
          var i = b[p[0]];
          i && (b[p[0]] = i.destroy());
        });
      }, U.forEach(function(b) {
        C[b] && (C[b].boostThreshold = 5e3, C[b].boostData = [], N[b].prototype.fillOpacity = !0);
      });
    }), E(g, "Extensions/Boost/NamedColors.js", [g["Core/Color/Color.js"]], function(a) {
      var y = {
        aliceblue: "#f0f8ff",
        antiquewhite: "#faebd7",
        aqua: "#00ffff",
        aquamarine: "#7fffd4",
        azure: "#f0ffff",
        beige: "#f5f5dc",
        bisque: "#ffe4c4",
        black: "#000000",
        blanchedalmond: "#ffebcd",
        blue: "#0000ff",
        blueviolet: "#8a2be2",
        brown: "#a52a2a",
        burlywood: "#deb887",
        cadetblue: "#5f9ea0",
        chartreuse: "#7fff00",
        chocolate: "#d2691e",
        coral: "#ff7f50",
        cornflowerblue: "#6495ed",
        cornsilk: "#fff8dc",
        crimson: "#dc143c",
        cyan: "#00ffff",
        darkblue: "#00008b",
        darkcyan: "#008b8b",
        darkgoldenrod: "#b8860b",
        darkgray: "#a9a9a9",
        darkgreen: "#006400",
        darkkhaki: "#bdb76b",
        darkmagenta: "#8b008b",
        darkolivegreen: "#556b2f",
        darkorange: "#ff8c00",
        darkorchid: "#9932cc",
        darkred: "#8b0000",
        darksalmon: "#e9967a",
        darkseagreen: "#8fbc8f",
        darkslateblue: "#483d8b",
        darkslategray: "#2f4f4f",
        darkturquoise: "#00ced1",
        darkviolet: "#9400d3",
        deeppink: "#ff1493",
        deepskyblue: "#00bfff",
        dimgray: "#696969",
        dodgerblue: "#1e90ff",
        feldspar: "#d19275",
        firebrick: "#b22222",
        floralwhite: "#fffaf0",
        forestgreen: "#228b22",
        fuchsia: "#ff00ff",
        gainsboro: "#dcdcdc",
        ghostwhite: "#f8f8ff",
        gold: "#ffd700",
        goldenrod: "#daa520",
        gray: "#808080",
        green: "#008000",
        greenyellow: "#adff2f",
        honeydew: "#f0fff0",
        hotpink: "#ff69b4",
        indianred: "#cd5c5c",
        indigo: "#4b0082",
        ivory: "#fffff0",
        khaki: "#f0e68c",
        lavender: "#e6e6fa",
        lavenderblush: "#fff0f5",
        lawngreen: "#7cfc00",
        lemonchiffon: "#fffacd",
        lightblue: "#add8e6",
        lightcoral: "#f08080",
        lightcyan: "#e0ffff",
        lightgoldenrodyellow: "#fafad2",
        lightgrey: "#d3d3d3",
        lightgreen: "#90ee90",
        lightpink: "#ffb6c1",
        lightsalmon: "#ffa07a",
        lightseagreen: "#20b2aa",
        lightskyblue: "#87cefa",
        lightslateblue: "#8470ff",
        lightslategray: "#778899",
        lightsteelblue: "#b0c4de",
        lightyellow: "#ffffe0",
        lime: "#00ff00",
        limegreen: "#32cd32",
        linen: "#faf0e6",
        magenta: "#ff00ff",
        maroon: "#800000",
        mediumaquamarine: "#66cdaa",
        mediumblue: "#0000cd",
        mediumorchid: "#ba55d3",
        mediumpurple: "#9370d8",
        mediumseagreen: "#3cb371",
        mediumslateblue: "#7b68ee",
        mediumspringgreen: "#00fa9a",
        mediumturquoise: "#48d1cc",
        mediumvioletred: "#c71585",
        midnightblue: "#191970",
        mintcream: "#f5fffa",
        mistyrose: "#ffe4e1",
        moccasin: "#ffe4b5",
        navajowhite: "#ffdead",
        navy: "#000080",
        oldlace: "#fdf5e6",
        olive: "#808000",
        olivedrab: "#6b8e23",
        orange: "#ffa500",
        orangered: "#ff4500",
        orchid: "#da70d6",
        palegoldenrod: "#eee8aa",
        palegreen: "#98fb98",
        paleturquoise: "#afeeee",
        palevioletred: "#d87093",
        papayawhip: "#ffefd5",
        peachpuff: "#ffdab9",
        peru: "#cd853f",
        pink: "#ffc0cb",
        plum: "#dda0dd",
        powderblue: "#b0e0e6",
        purple: "#800080",
        red: "#ff0000",
        rosybrown: "#bc8f8f",
        royalblue: "#4169e1",
        saddlebrown: "#8b4513",
        salmon: "#fa8072",
        sandybrown: "#f4a460",
        seagreen: "#2e8b57",
        seashell: "#fff5ee",
        sienna: "#a0522d",
        silver: "#c0c0c0",
        skyblue: "#87ceeb",
        slateblue: "#6a5acd",
        slategray: "#708090",
        snow: "#fffafa",
        springgreen: "#00ff7f",
        steelblue: "#4682b4",
        tan: "#d2b48c",
        teal: "#008080",
        thistle: "#d8bfd8",
        tomato: "#ff6347",
        turquoise: "#40e0d0",
        violet: "#ee82ee",
        violetred: "#d02090",
        wheat: "#f5deb3",
        white: "#ffffff",
        whitesmoke: "#f5f5f5",
        yellow: "#ffff00",
        yellowgreen: "#9acd32"
      };
      return a.names = y;
    }), E(g, "Extensions/Boost/Boost.js", [g["Extensions/Boost/BoostUtils.js"], g["Extensions/Boost/BoostInit.js"], g["Extensions/BoostCanvas.js"], g["Core/Utilities.js"]], function(a, y, R, I) {
      I = I.error, a = a.hasWebGLSupport, a() ? y() : typeof R < "u" ? R() : I(26);
    }), E(g, "masters/modules/boost.src.js", [], function() {
    });
  });
})(Hp);
var I0 = Hp.exports;
const R0 = /* @__PURE__ */ Cn(I0), N0 = (r) => {
  let g = window.location.protocol;
  /^http(s)?:&/.test(g) || (g = "http:");
  let E = {
    lang: {
      // Highcharts
      contextButtonTitle: "图表导出菜单",
      decimalPoint: ".",
      downloadJPEG: "下载 JPEG 图片",
      downloadPDF: "下载 PDF 文件",
      downloadPNG: "下载 PNG 文件",
      downloadSVG: "下载 SVG 文件",
      downloadXLS: "下载 XLS 文件",
      drillUpText: "◁ 返回 {series.name}",
      exitFullscreen: "退出全屏",
      exportData: {
        categoryDatetimeHeader: "时间",
        categoryHeader: "类别"
      },
      openInCloud: "在 Highcharts Cloud 中打开",
      invalidDate: "无效的时间",
      loading: "加载中...",
      months: [
        "一月",
        "二月",
        "三月",
        "四月",
        "五月",
        "六月",
        "七月",
        "八月",
        "九月",
        "十月",
        "十一月",
        "十二月"
      ],
      navigation: {
        popup: {
          addButton: "新增",
          arrowLine: "直线",
          arrowRay: "射线",
          arrowSegment: "线段",
          background: "背景",
          backgroundColor: "背景颜色",
          backgroundColors: "背景颜色",
          borderColor: "边框颜色",
          borderRadius: "圆角",
          borderWidth: "边框大小",
          circle: "圆",
          color: "颜色",
          connector: "连接",
          crooked3: "Crooked 3 line",
          crooked5: "Crooked 5 line",
          crosshairX: "竖直准星线",
          crosshairY: "水平准星线",
          editButton: "编辑",
          elliott3: "Elliott 3 line",
          elliott5: "Elliott 5 line",
          fibonacci: "斐波纳契",
          fill: "填充颜色",
          flags: "标志",
          fontSize: "字体大小",
          format: "文本",
          height: "高度",
          horizontalLine: "水平线",
          infinityLine: "无限线",
          innerBackground: "内背景",
          label: "文字标签",
          labelOptions: "文字标签配置",
          labels: "文字标签",
          line: "线",
          lines: "线条",
          measure: "Measure",
          measureX: "Measure X",
          measureXY: "Measure XY",
          measureY: "Measure Y",
          name: "名字",
          outerBackground: "外背景",
          padding: "内间距",
          parallelChannel: "并行通道",
          pitchfork: "杈子",
          ray: "射线",
          rectangle: "矩形",
          removeButton: "删除",
          saveButton: "保存",
          segment: "段落",
          series: "数据列",
          shapeOptions: "图形配置",
          shapes: "图形",
          simpleShapes: "简单图形",
          stroke: "线条颜色",
          strokeWidth: "线条粗细",
          style: "样式",
          title: "标题",
          tunnel: "通道",
          typeOptions: "详情",
          verticalArrow: "竖直箭头",
          verticalCounter: "竖直计数器",
          verticalLabel: "竖直标签",
          verticalLine: "竖直线",
          volume: "成交量"
        }
      },
      noData: "暂无数据",
      numericSymbols: null,
      printChart: "打印图表",
      resetZoom: "重置缩放比例",
      resetZoomTitle: "重置为原始大小",
      shortMonths: [
        "一月",
        "二月",
        "三月",
        "四月",
        "五月",
        "六月",
        "七月",
        "八月",
        "九月",
        "十月",
        "十一月",
        "十二月"
      ],
      thousandsSep: ",",
      viewData: "查看数据表格",
      viewFullscreen: "全屏查看",
      weekdays: [
        "星期天",
        "星期一",
        "星期二",
        "星期三",
        "星期四",
        "星期五",
        "星期六"
      ],
      viewData: "查看数据表格",
      // Highstock
      rangeSelectorFrom: "开始时间",
      rangeSelectorTo: "结束时间",
      rangeSelectorZoom: "范围",
      // Highmaps
      zoomIn: "缩小",
      zoomOut: "放大"
    },
    global: {
      // 不使用 UTC时间
      useUTC: !1,
      timezoneOffset: -8 * 60,
      canvasToolsURL: g + "//cdn.hcharts.cn/highcharts/modules/canvas-tools.js",
      VMLRadialGradientURL: g + +"//cdn.hcharts.cn/highcharts/gfx/vml-radial-gradient.png"
    },
    exporting: {
      url: g + "//export.highcharts.com.cn"
    },
    credits: {
      text: "Highcharts.com.cn",
      href: "https://www.highcharts.com.cn"
    },
    /**
     * Highstock
     */
    rangeSelector: {
      inputDateFormat: "%Y-%m-%d",
      buttons: [
        {
          type: "month",
          count: 1,
          text: "月"
        },
        {
          type: "month",
          count: 3,
          text: "季度"
        },
        {
          type: "month",
          count: 6,
          text: "半年"
        },
        {
          type: "ytd",
          text: "YTD"
        },
        {
          type: "year",
          count: 1,
          text: "年"
        },
        {
          type: "all",
          text: "所有"
        }
      ]
    },
    plotOptions: {
      series: {
        dataGrouping: {
          dateTimeLabelFormats: {
            /* millisecond: [
              '%Y-%m-%d %H:%M:%S.%L',
              '%Y-%m-%d %H:%M:%S.%L',
              ' ~ %H:%M:%S.%L',
            ],
            second: ['%Y-%m-%d %H:%M:%S', '%Y-%m-%d %H:%M:%S', ' ~ %H:%M:%S'],
            minute: ['%Y-%m-%d %H:%M', '%Y-%m-%d %H:%M', ' ~ %H:%M'],
            hour: ['%Y-%m-%d %H:%M', '%Y-%m-%d %H:%M', ' ~ %H:%M'], */
            day: ["%Y/%m/%d", "%Y/%m/%d", " ~ %Y/%m/%d"],
            week: ["%Y/%m/%d", "%Y/%m/%d", " ~ %Y/%m/%d"],
            month: ["%Y/%m", "%Y/%m", " ~ %Y/%m"],
            year: ["%Y", "%Y", " ~ %Y"]
          }
        }
      }
    }
  };
  r.setOptions(E);
};
//! moment.js
//! version : 2.29.4
//! authors : Tim Wood, Iskren Chernev, Moment.js contributors
//! license : MIT
//! momentjs.com
var Up;
function Xt() {
  return Up.apply(null, arguments);
}
function B0(r) {
  Up = r;
}
function Bi(r) {
  return r instanceof Array || Object.prototype.toString.call(r) === "[object Array]";
}
function Vr(r) {
  return r != null && Object.prototype.toString.call(r) === "[object Object]";
}
function me(r, g) {
  return Object.prototype.hasOwnProperty.call(r, g);
}
function wh(r) {
  if (Object.getOwnPropertyNames)
    return Object.getOwnPropertyNames(r).length === 0;
  var g;
  for (g in r)
    if (me(r, g))
      return !1;
  return !0;
}
function li(r) {
  return r === void 0;
}
function dr(r) {
  return typeof r == "number" || Object.prototype.toString.call(r) === "[object Number]";
}
function no(r) {
  return r instanceof Date || Object.prototype.toString.call(r) === "[object Date]";
}
function Fp(r, g) {
  var E = [], a, y = r.length;
  for (a = 0; a < y; ++a)
    E.push(g(r[a], a));
  return E;
}
function Tr(r, g) {
  for (var E in g)
    me(g, E) && (r[E] = g[E]);
  return me(g, "toString") && (r.toString = g.toString), me(g, "valueOf") && (r.valueOf = g.valueOf), r;
}
function $i(r, g, E, a) {
  return mu(r, g, E, a, !0).utc();
}
function j0() {
  return {
    empty: !1,
    unusedTokens: [],
    unusedInput: [],
    overflow: -2,
    charsLeftOver: 0,
    nullInput: !1,
    invalidEra: null,
    invalidMonth: null,
    invalidFormat: !1,
    userInvalidated: !1,
    iso: !1,
    parsedDateParts: [],
    era: null,
    meridiem: null,
    rfc2822: !1,
    weekdayMismatch: !1
  };
}
function oe(r) {
  return r._pf == null && (r._pf = j0()), r._pf;
}
var ph;
Array.prototype.some ? ph = Array.prototype.some : ph = function(r) {
  var g = Object(this), E = g.length >>> 0, a;
  for (a = 0; a < E; a++)
    if (a in g && r.call(this, g[a], a, g))
      return !0;
  return !1;
};
function Mh(r) {
  if (r._isValid == null) {
    var g = oe(r), E = ph.call(g.parsedDateParts, function(y) {
      return y != null;
    }), a = !isNaN(r._d.getTime()) && g.overflow < 0 && !g.empty && !g.invalidEra && !g.invalidMonth && !g.invalidWeekday && !g.weekdayMismatch && !g.nullInput && !g.invalidFormat && !g.userInvalidated && (!g.meridiem || g.meridiem && E);
    if (r._strict && (a = a && g.charsLeftOver === 0 && g.unusedTokens.length === 0 && g.bigHour === void 0), Object.isFrozen == null || !Object.isFrozen(r))
      r._isValid = a;
    else
      return a;
  }
  return r._isValid;
}
function ks(r) {
  var g = $i(NaN);
  return r != null ? Tr(oe(g), r) : oe(g).userInvalidated = !0, g;
}
var Sp = Xt.momentProperties = [], th = !1;
function Ch(r, g) {
  var E, a, y, R = Sp.length;
  if (li(g._isAMomentObject) || (r._isAMomentObject = g._isAMomentObject), li(g._i) || (r._i = g._i), li(g._f) || (r._f = g._f), li(g._l) || (r._l = g._l), li(g._strict) || (r._strict = g._strict), li(g._tzm) || (r._tzm = g._tzm), li(g._isUTC) || (r._isUTC = g._isUTC), li(g._offset) || (r._offset = g._offset), li(g._pf) || (r._pf = oe(g)), li(g._locale) || (r._locale = g._locale), R > 0)
    for (E = 0; E < R; E++)
      a = Sp[E], y = g[a], li(y) || (r[a] = y);
  return r;
}
function oo(r) {
  Ch(this, r), this._d = new Date(r._d != null ? r._d.getTime() : NaN), this.isValid() || (this._d = /* @__PURE__ */ new Date(NaN)), th === !1 && (th = !0, Xt.updateOffset(this), th = !1);
}
function ji(r) {
  return r instanceof oo || r != null && r._isAMomentObject != null;
}
function Vp(r) {
  Xt.suppressDeprecationWarnings === !1 && typeof console < "u" && console.warn && console.warn("Deprecation warning: " + r);
}
function Ei(r, g) {
  var E = !0;
  return Tr(function() {
    if (Xt.deprecationHandler != null && Xt.deprecationHandler(null, r), E) {
      var a = [], y, R, I, Z = arguments.length;
      for (R = 0; R < Z; R++) {
        if (y = "", typeof arguments[R] == "object") {
          y += `
[` + R + "] ";
          for (I in arguments[0])
            me(arguments[0], I) && (y += I + ": " + arguments[0][I] + ", ");
          y = y.slice(0, -2);
        } else
          y = arguments[R];
        a.push(y);
      }
      Vp(
        r + `
Arguments: ` + Array.prototype.slice.call(a).join("") + `
` + new Error().stack
      ), E = !1;
    }
    return g.apply(this, arguments);
  }, g);
}
var wp = {};
function $p(r, g) {
  Xt.deprecationHandler != null && Xt.deprecationHandler(r, g), wp[r] || (Vp(g), wp[r] = !0);
}
Xt.suppressDeprecationWarnings = !1;
Xt.deprecationHandler = null;
function Zi(r) {
  return typeof Function < "u" && r instanceof Function || Object.prototype.toString.call(r) === "[object Function]";
}
function W0(r) {
  var g, E;
  for (E in r)
    me(r, E) && (g = r[E], Zi(g) ? this[E] = g : this["_" + E] = g);
  this._config = r, this._dayOfMonthOrdinalParseLenient = new RegExp(
    (this._dayOfMonthOrdinalParse.source || this._ordinalParse.source) + "|" + /\d{1,2}/.source
  );
}
function uh(r, g) {
  var E = Tr({}, r), a;
  for (a in g)
    me(g, a) && (Vr(r[a]) && Vr(g[a]) ? (E[a] = {}, Tr(E[a], r[a]), Tr(E[a], g[a])) : g[a] != null ? E[a] = g[a] : delete E[a]);
  for (a in r)
    me(r, a) && !me(g, a) && Vr(r[a]) && (E[a] = Tr({}, E[a]));
  return E;
}
function kh(r) {
  r != null && this.set(r);
}
var dh;
Object.keys ? dh = Object.keys : dh = function(r) {
  var g, E = [];
  for (g in r)
    me(r, g) && E.push(g);
  return E;
};
var z0 = {
  sameDay: "[Today at] LT",
  nextDay: "[Tomorrow at] LT",
  nextWeek: "dddd [at] LT",
  lastDay: "[Yesterday at] LT",
  lastWeek: "[Last] dddd [at] LT",
  sameElse: "L"
};
function Y0(r, g, E) {
  var a = this._calendar[r] || this._calendar.sameElse;
  return Zi(a) ? a.call(g, E) : a;
}
function Ui(r, g, E) {
  var a = "" + Math.abs(r), y = g - a.length, R = r >= 0;
  return (R ? E ? "+" : "" : "-") + Math.pow(10, Math.max(0, y)).toString().substr(1) + a;
}
var Ah = /(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|N{1,5}|YYYYYY|YYYYY|YYYY|YY|y{2,4}|yo?|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g, is = /(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g, eh = {}, yn = {};
function Zt(r, g, E, a) {
  var y = a;
  typeof a == "string" && (y = function() {
    return this[a]();
  }), r && (yn[r] = y), g && (yn[g[0]] = function() {
    return Ui(y.apply(this, arguments), g[1], g[2]);
  }), E && (yn[E] = function() {
    return this.localeData().ordinal(
      y.apply(this, arguments),
      r
    );
  });
}
function X0(r) {
  return r.match(/\[[\s\S]/) ? r.replace(/^\[|\]$/g, "") : r.replace(/\\/g, "");
}
function G0(r) {
  var g = r.match(Ah), E, a;
  for (E = 0, a = g.length; E < a; E++)
    yn[g[E]] ? g[E] = yn[g[E]] : g[E] = X0(g[E]);
  return function(y) {
    var R = "", I;
    for (I = 0; I < a; I++)
      R += Zi(g[I]) ? g[I].call(y, r) : g[I];
    return R;
  };
}
function ss(r, g) {
  return r.isValid() ? (g = Zp(g, r.localeData()), eh[g] = eh[g] || G0(g), eh[g](r)) : r.localeData().invalidDate();
}
function Zp(r, g) {
  var E = 5;
  function a(y) {
    return g.longDateFormat(y) || y;
  }
  for (is.lastIndex = 0; E >= 0 && is.test(r); )
    r = r.replace(
      is,
      a
    ), is.lastIndex = 0, E -= 1;
  return r;
}
var H0 = {
  LTS: "h:mm:ss A",
  LT: "h:mm A",
  L: "MM/DD/YYYY",
  LL: "MMMM D, YYYY",
  LLL: "MMMM D, YYYY h:mm A",
  LLLL: "dddd, MMMM D, YYYY h:mm A"
};
function U0(r) {
  var g = this._longDateFormat[r], E = this._longDateFormat[r.toUpperCase()];
  return g || !E ? g : (this._longDateFormat[r] = E.match(Ah).map(function(a) {
    return a === "MMMM" || a === "MM" || a === "DD" || a === "dddd" ? a.slice(1) : a;
  }).join(""), this._longDateFormat[r]);
}
var F0 = "Invalid date";
function V0() {
  return this._invalidDate;
}
var $0 = "%d", Z0 = /\d{1,2}/;
function K0(r) {
  return this._ordinal.replace("%d", r);
}
var J0 = {
  future: "in %s",
  past: "%s ago",
  s: "a few seconds",
  ss: "%d seconds",
  m: "a minute",
  mm: "%d minutes",
  h: "an hour",
  hh: "%d hours",
  d: "a day",
  dd: "%d days",
  w: "a week",
  ww: "%d weeks",
  M: "a month",
  MM: "%d months",
  y: "a year",
  yy: "%d years"
};
function q0(r, g, E, a) {
  var y = this._relativeTime[E];
  return Zi(y) ? y(r, g, E, a) : y.replace(/%d/i, r);
}
function Q0(r, g) {
  var E = this._relativeTime[r > 0 ? "future" : "past"];
  return Zi(E) ? E(g) : E.replace(/%s/i, g);
}
var Jn = {};
function qe(r, g) {
  var E = r.toLowerCase();
  Jn[E] = Jn[E + "s"] = Jn[g] = r;
}
function Oi(r) {
  return typeof r == "string" ? Jn[r] || Jn[r.toLowerCase()] : void 0;
}
function Th(r) {
  var g = {}, E, a;
  for (a in r)
    me(r, a) && (E = Oi(a), E && (g[E] = r[a]));
  return g;
}
var Kp = {};
function Qe(r, g) {
  Kp[r] = g;
}
function t1(r) {
  var g = [], E;
  for (E in r)
    me(r, E) && g.push({ unit: E, priority: Kp[E] });
  return g.sort(function(a, y) {
    return a.priority - y.priority;
  }), g;
}
function As(r) {
  return r % 4 === 0 && r % 100 !== 0 || r % 400 === 0;
}
function Ti(r) {
  return r < 0 ? Math.ceil(r) || 0 : Math.floor(r);
}
function he(r) {
  var g = +r, E = 0;
  return g !== 0 && isFinite(g) && (E = Ti(g)), E;
}
function kn(r, g) {
  return function(E) {
    return E != null ? (Jp(this, r, E), Xt.updateOffset(this, g), this) : gs(this, r);
  };
}
function gs(r, g) {
  return r.isValid() ? r._d["get" + (r._isUTC ? "UTC" : "") + g]() : NaN;
}
function Jp(r, g, E) {
  r.isValid() && !isNaN(E) && (g === "FullYear" && As(r.year()) && r.month() === 1 && r.date() === 29 ? (E = he(E), r._d["set" + (r._isUTC ? "UTC" : "") + g](
    E,
    r.month(),
    _s(E, r.month())
  )) : r._d["set" + (r._isUTC ? "UTC" : "") + g](E));
}
function e1(r) {
  return r = Oi(r), Zi(this[r]) ? this[r]() : this;
}
function i1(r, g) {
  if (typeof r == "object") {
    r = Th(r);
    var E = t1(r), a, y = E.length;
    for (a = 0; a < y; a++)
      this[E[a].unit](r[E[a].unit]);
  } else if (r = Oi(r), Zi(this[r]))
    return this[r](g);
  return this;
}
var qp = /\d/, vi = /\d\d/, Qp = /\d{3}/, Ph = /\d{4}/, Ts = /[+-]?\d{6}/, Pe = /\d\d?/, tu = /\d\d\d\d?/, eu = /\d\d\d\d\d\d?/, Ps = /\d{1,3}/, Eh = /\d{1,4}/, Es = /[+-]?\d{1,6}/, An = /\d+/, Os = /[+-]?\d+/, r1 = /Z|[+-]\d\d:?\d\d/gi, Ls = /Z|[+-]\d\d(?::?\d\d)?/gi, n1 = /[+-]?\d+(\.\d{1,3})?/, so = /[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i, ms;
ms = {};
function Ut(r, g, E) {
  ms[r] = Zi(g) ? g : function(a, y) {
    return a && E ? E : g;
  };
}
function o1(r, g) {
  return me(ms, r) ? ms[r](g._strict, g._locale) : new RegExp(s1(r));
}
function s1(r) {
  return yi(
    r.replace("\\", "").replace(
      /\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,
      function(g, E, a, y, R) {
        return E || a || y || R;
      }
    )
  );
}
function yi(r) {
  return r.replace(/[-\/\\^$*+?.()|[\]{}]/g, "\\$&");
}
var fh = {};
function we(r, g) {
  var E, a = g, y;
  for (typeof r == "string" && (r = [r]), dr(g) && (a = function(R, I) {
    I[g] = he(R);
  }), y = r.length, E = 0; E < y; E++)
    fh[r[E]] = a;
}
function ao(r, g) {
  we(r, function(E, a, y, R) {
    y._w = y._w || {}, g(E, y._w, y, R);
  });
}
function a1(r, g, E) {
  g != null && me(fh, r) && fh[r](g, E._a, E, r);
}
var Je = 0, lr = 1, Hi = 2, Ge = 3, Ri = 4, cr = 5, Fr = 6, h1 = 7, l1 = 8;
function c1(r, g) {
  return (r % g + g) % g;
}
var je;
Array.prototype.indexOf ? je = Array.prototype.indexOf : je = function(r) {
  var g;
  for (g = 0; g < this.length; ++g)
    if (this[g] === r)
      return g;
  return -1;
};
function _s(r, g) {
  if (isNaN(r) || isNaN(g))
    return NaN;
  var E = c1(g, 12);
  return r += (g - E) / 12, E === 1 ? As(r) ? 29 : 28 : 31 - E % 7 % 2;
}
Zt("M", ["MM", 2], "Mo", function() {
  return this.month() + 1;
});
Zt("MMM", 0, 0, function(r) {
  return this.localeData().monthsShort(this, r);
});
Zt("MMMM", 0, 0, function(r) {
  return this.localeData().months(this, r);
});
qe("month", "M");
Qe("month", 8);
Ut("M", Pe);
Ut("MM", Pe, vi);
Ut("MMM", function(r, g) {
  return g.monthsShortRegex(r);
});
Ut("MMMM", function(r, g) {
  return g.monthsRegex(r);
});
we(["M", "MM"], function(r, g) {
  g[lr] = he(r) - 1;
});
we(["MMM", "MMMM"], function(r, g, E, a) {
  var y = E._locale.monthsParse(r, a, E._strict);
  y != null ? g[lr] = y : oe(E).invalidMonth = r;
});
var p1 = "January_February_March_April_May_June_July_August_September_October_November_December".split(
  "_"
), iu = "Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_"), ru = /D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/, u1 = so, d1 = so;
function f1(r, g) {
  return r ? Bi(this._months) ? this._months[r.month()] : this._months[(this._months.isFormat || ru).test(g) ? "format" : "standalone"][r.month()] : Bi(this._months) ? this._months : this._months.standalone;
}
function g1(r, g) {
  return r ? Bi(this._monthsShort) ? this._monthsShort[r.month()] : this._monthsShort[ru.test(g) ? "format" : "standalone"][r.month()] : Bi(this._monthsShort) ? this._monthsShort : this._monthsShort.standalone;
}
function m1(r, g, E) {
  var a, y, R, I = r.toLocaleLowerCase();
  if (!this._monthsParse)
    for (this._monthsParse = [], this._longMonthsParse = [], this._shortMonthsParse = [], a = 0; a < 12; ++a)
      R = $i([2e3, a]), this._shortMonthsParse[a] = this.monthsShort(
        R,
        ""
      ).toLocaleLowerCase(), this._longMonthsParse[a] = this.months(R, "").toLocaleLowerCase();
  return E ? g === "MMM" ? (y = je.call(this._shortMonthsParse, I), y !== -1 ? y : null) : (y = je.call(this._longMonthsParse, I), y !== -1 ? y : null) : g === "MMM" ? (y = je.call(this._shortMonthsParse, I), y !== -1 ? y : (y = je.call(this._longMonthsParse, I), y !== -1 ? y : null)) : (y = je.call(this._longMonthsParse, I), y !== -1 ? y : (y = je.call(this._shortMonthsParse, I), y !== -1 ? y : null));
}
function y1(r, g, E) {
  var a, y, R;
  if (this._monthsParseExact)
    return m1.call(this, r, g, E);
  for (this._monthsParse || (this._monthsParse = [], this._longMonthsParse = [], this._shortMonthsParse = []), a = 0; a < 12; a++) {
    if (y = $i([2e3, a]), E && !this._longMonthsParse[a] && (this._longMonthsParse[a] = new RegExp(
      "^" + this.months(y, "").replace(".", "") + "$",
      "i"
    ), this._shortMonthsParse[a] = new RegExp(
      "^" + this.monthsShort(y, "").replace(".", "") + "$",
      "i"
    )), !E && !this._monthsParse[a] && (R = "^" + this.months(y, "") + "|^" + this.monthsShort(y, ""), this._monthsParse[a] = new RegExp(R.replace(".", ""), "i")), E && g === "MMMM" && this._longMonthsParse[a].test(r))
      return a;
    if (E && g === "MMM" && this._shortMonthsParse[a].test(r))
      return a;
    if (!E && this._monthsParse[a].test(r))
      return a;
  }
}
function nu(r, g) {
  var E;
  if (!r.isValid())
    return r;
  if (typeof g == "string") {
    if (/^\d+$/.test(g))
      g = he(g);
    else if (g = r.localeData().monthsParse(g), !dr(g))
      return r;
  }
  return E = Math.min(r.date(), _s(r.year(), g)), r._d["set" + (r._isUTC ? "UTC" : "") + "Month"](g, E), r;
}
function ou(r) {
  return r != null ? (nu(this, r), Xt.updateOffset(this, !0), this) : gs(this, "Month");
}
function v1() {
  return _s(this.year(), this.month());
}
function x1(r) {
  return this._monthsParseExact ? (me(this, "_monthsRegex") || su.call(this), r ? this._monthsShortStrictRegex : this._monthsShortRegex) : (me(this, "_monthsShortRegex") || (this._monthsShortRegex = u1), this._monthsShortStrictRegex && r ? this._monthsShortStrictRegex : this._monthsShortRegex);
}
function b1(r) {
  return this._monthsParseExact ? (me(this, "_monthsRegex") || su.call(this), r ? this._monthsStrictRegex : this._monthsRegex) : (me(this, "_monthsRegex") || (this._monthsRegex = d1), this._monthsStrictRegex && r ? this._monthsStrictRegex : this._monthsRegex);
}
function su() {
  function r(I, Z) {
    return Z.length - I.length;
  }
  var g = [], E = [], a = [], y, R;
  for (y = 0; y < 12; y++)
    R = $i([2e3, y]), g.push(this.monthsShort(R, "")), E.push(this.months(R, "")), a.push(this.months(R, "")), a.push(this.monthsShort(R, ""));
  for (g.sort(r), E.sort(r), a.sort(r), y = 0; y < 12; y++)
    g[y] = yi(g[y]), E[y] = yi(E[y]);
  for (y = 0; y < 24; y++)
    a[y] = yi(a[y]);
  this._monthsRegex = new RegExp("^(" + a.join("|") + ")", "i"), this._monthsShortRegex = this._monthsRegex, this._monthsStrictRegex = new RegExp(
    "^(" + E.join("|") + ")",
    "i"
  ), this._monthsShortStrictRegex = new RegExp(
    "^(" + g.join("|") + ")",
    "i"
  );
}
Zt("Y", 0, 0, function() {
  var r = this.year();
  return r <= 9999 ? Ui(r, 4) : "+" + r;
});
Zt(0, ["YY", 2], 0, function() {
  return this.year() % 100;
});
Zt(0, ["YYYY", 4], 0, "year");
Zt(0, ["YYYYY", 5], 0, "year");
Zt(0, ["YYYYYY", 6, !0], 0, "year");
qe("year", "y");
Qe("year", 1);
Ut("Y", Os);
Ut("YY", Pe, vi);
Ut("YYYY", Eh, Ph);
Ut("YYYYY", Es, Ts);
Ut("YYYYYY", Es, Ts);
we(["YYYYY", "YYYYYY"], Je);
we("YYYY", function(r, g) {
  g[Je] = r.length === 2 ? Xt.parseTwoDigitYear(r) : he(r);
});
we("YY", function(r, g) {
  g[Je] = Xt.parseTwoDigitYear(r);
});
we("Y", function(r, g) {
  g[Je] = parseInt(r, 10);
});
function qn(r) {
  return As(r) ? 366 : 365;
}
Xt.parseTwoDigitYear = function(r) {
  return he(r) + (he(r) > 68 ? 1900 : 2e3);
};
var au = kn("FullYear", !0);
function S1() {
  return As(this.year());
}
function w1(r, g, E, a, y, R, I) {
  var Z;
  return r < 100 && r >= 0 ? (Z = new Date(r + 400, g, E, a, y, R, I), isFinite(Z.getFullYear()) && Z.setFullYear(r)) : Z = new Date(r, g, E, a, y, R, I), Z;
}
function to(r) {
  var g, E;
  return r < 100 && r >= 0 ? (E = Array.prototype.slice.call(arguments), E[0] = r + 400, g = new Date(Date.UTC.apply(null, E)), isFinite(g.getUTCFullYear()) && g.setUTCFullYear(r)) : g = new Date(Date.UTC.apply(null, arguments)), g;
}
function ys(r, g, E) {
  var a = 7 + g - E, y = (7 + to(r, 0, a).getUTCDay() - g) % 7;
  return -y + a - 1;
}
function hu(r, g, E, a, y) {
  var R = (7 + E - a) % 7, I = ys(r, a, y), Z = 1 + 7 * (g - 1) + R + I, H, $;
  return Z <= 0 ? (H = r - 1, $ = qn(H) + Z) : Z > qn(r) ? (H = r + 1, $ = Z - qn(r)) : (H = r, $ = Z), {
    year: H,
    dayOfYear: $
  };
}
function eo(r, g, E) {
  var a = ys(r.year(), g, E), y = Math.floor((r.dayOfYear() - a - 1) / 7) + 1, R, I;
  return y < 1 ? (I = r.year() - 1, R = y + pr(I, g, E)) : y > pr(r.year(), g, E) ? (R = y - pr(r.year(), g, E), I = r.year() + 1) : (I = r.year(), R = y), {
    week: R,
    year: I
  };
}
function pr(r, g, E) {
  var a = ys(r, g, E), y = ys(r + 1, g, E);
  return (qn(r) - a + y) / 7;
}
Zt("w", ["ww", 2], "wo", "week");
Zt("W", ["WW", 2], "Wo", "isoWeek");
qe("week", "w");
qe("isoWeek", "W");
Qe("week", 5);
Qe("isoWeek", 5);
Ut("w", Pe);
Ut("ww", Pe, vi);
Ut("W", Pe);
Ut("WW", Pe, vi);
ao(
  ["w", "ww", "W", "WW"],
  function(r, g, E, a) {
    g[a.substr(0, 1)] = he(r);
  }
);
function M1(r) {
  return eo(r, this._week.dow, this._week.doy).week;
}
var C1 = {
  dow: 0,
  // Sunday is the first day of the week.
  doy: 6
  // The week that contains Jan 6th is the first week of the year.
};
function k1() {
  return this._week.dow;
}
function A1() {
  return this._week.doy;
}
function T1(r) {
  var g = this.localeData().week(this);
  return r == null ? g : this.add((r - g) * 7, "d");
}
function P1(r) {
  var g = eo(this, 1, 4).week;
  return r == null ? g : this.add((r - g) * 7, "d");
}
Zt("d", 0, "do", "day");
Zt("dd", 0, 0, function(r) {
  return this.localeData().weekdaysMin(this, r);
});
Zt("ddd", 0, 0, function(r) {
  return this.localeData().weekdaysShort(this, r);
});
Zt("dddd", 0, 0, function(r) {
  return this.localeData().weekdays(this, r);
});
Zt("e", 0, 0, "weekday");
Zt("E", 0, 0, "isoWeekday");
qe("day", "d");
qe("weekday", "e");
qe("isoWeekday", "E");
Qe("day", 11);
Qe("weekday", 11);
Qe("isoWeekday", 11);
Ut("d", Pe);
Ut("e", Pe);
Ut("E", Pe);
Ut("dd", function(r, g) {
  return g.weekdaysMinRegex(r);
});
Ut("ddd", function(r, g) {
  return g.weekdaysShortRegex(r);
});
Ut("dddd", function(r, g) {
  return g.weekdaysRegex(r);
});
ao(["dd", "ddd", "dddd"], function(r, g, E, a) {
  var y = E._locale.weekdaysParse(r, a, E._strict);
  y != null ? g.d = y : oe(E).invalidWeekday = r;
});
ao(["d", "e", "E"], function(r, g, E, a) {
  g[a] = he(r);
});
function E1(r, g) {
  return typeof r != "string" ? r : isNaN(r) ? (r = g.weekdaysParse(r), typeof r == "number" ? r : null) : parseInt(r, 10);
}
function O1(r, g) {
  return typeof r == "string" ? g.weekdaysParse(r) % 7 || 7 : isNaN(r) ? null : r;
}
function Oh(r, g) {
  return r.slice(g, 7).concat(r.slice(0, g));
}
var L1 = "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"), lu = "Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"), _1 = "Su_Mo_Tu_We_Th_Fr_Sa".split("_"), D1 = so, I1 = so, R1 = so;
function N1(r, g) {
  var E = Bi(this._weekdays) ? this._weekdays : this._weekdays[r && r !== !0 && this._weekdays.isFormat.test(g) ? "format" : "standalone"];
  return r === !0 ? Oh(E, this._week.dow) : r ? E[r.day()] : E;
}
function B1(r) {
  return r === !0 ? Oh(this._weekdaysShort, this._week.dow) : r ? this._weekdaysShort[r.day()] : this._weekdaysShort;
}
function j1(r) {
  return r === !0 ? Oh(this._weekdaysMin, this._week.dow) : r ? this._weekdaysMin[r.day()] : this._weekdaysMin;
}
function W1(r, g, E) {
  var a, y, R, I = r.toLocaleLowerCase();
  if (!this._weekdaysParse)
    for (this._weekdaysParse = [], this._shortWeekdaysParse = [], this._minWeekdaysParse = [], a = 0; a < 7; ++a)
      R = $i([2e3, 1]).day(a), this._minWeekdaysParse[a] = this.weekdaysMin(
        R,
        ""
      ).toLocaleLowerCase(), this._shortWeekdaysParse[a] = this.weekdaysShort(
        R,
        ""
      ).toLocaleLowerCase(), this._weekdaysParse[a] = this.weekdays(R, "").toLocaleLowerCase();
  return E ? g === "dddd" ? (y = je.call(this._weekdaysParse, I), y !== -1 ? y : null) : g === "ddd" ? (y = je.call(this._shortWeekdaysParse, I), y !== -1 ? y : null) : (y = je.call(this._minWeekdaysParse, I), y !== -1 ? y : null) : g === "dddd" ? (y = je.call(this._weekdaysParse, I), y !== -1 || (y = je.call(this._shortWeekdaysParse, I), y !== -1) ? y : (y = je.call(this._minWeekdaysParse, I), y !== -1 ? y : null)) : g === "ddd" ? (y = je.call(this._shortWeekdaysParse, I), y !== -1 || (y = je.call(this._weekdaysParse, I), y !== -1) ? y : (y = je.call(this._minWeekdaysParse, I), y !== -1 ? y : null)) : (y = je.call(this._minWeekdaysParse, I), y !== -1 || (y = je.call(this._weekdaysParse, I), y !== -1) ? y : (y = je.call(this._shortWeekdaysParse, I), y !== -1 ? y : null));
}
function z1(r, g, E) {
  var a, y, R;
  if (this._weekdaysParseExact)
    return W1.call(this, r, g, E);
  for (this._weekdaysParse || (this._weekdaysParse = [], this._minWeekdaysParse = [], this._shortWeekdaysParse = [], this._fullWeekdaysParse = []), a = 0; a < 7; a++) {
    if (y = $i([2e3, 1]).day(a), E && !this._fullWeekdaysParse[a] && (this._fullWeekdaysParse[a] = new RegExp(
      "^" + this.weekdays(y, "").replace(".", "\\.?") + "$",
      "i"
    ), this._shortWeekdaysParse[a] = new RegExp(
      "^" + this.weekdaysShort(y, "").replace(".", "\\.?") + "$",
      "i"
    ), this._minWeekdaysParse[a] = new RegExp(
      "^" + this.weekdaysMin(y, "").replace(".", "\\.?") + "$",
      "i"
    )), this._weekdaysParse[a] || (R = "^" + this.weekdays(y, "") + "|^" + this.weekdaysShort(y, "") + "|^" + this.weekdaysMin(y, ""), this._weekdaysParse[a] = new RegExp(R.replace(".", ""), "i")), E && g === "dddd" && this._fullWeekdaysParse[a].test(r))
      return a;
    if (E && g === "ddd" && this._shortWeekdaysParse[a].test(r))
      return a;
    if (E && g === "dd" && this._minWeekdaysParse[a].test(r))
      return a;
    if (!E && this._weekdaysParse[a].test(r))
      return a;
  }
}
function Y1(r) {
  if (!this.isValid())
    return r != null ? this : NaN;
  var g = this._isUTC ? this._d.getUTCDay() : this._d.getDay();
  return r != null ? (r = E1(r, this.localeData()), this.add(r - g, "d")) : g;
}
function X1(r) {
  if (!this.isValid())
    return r != null ? this : NaN;
  var g = (this.day() + 7 - this.localeData()._week.dow) % 7;
  return r == null ? g : this.add(r - g, "d");
}
function G1(r) {
  if (!this.isValid())
    return r != null ? this : NaN;
  if (r != null) {
    var g = O1(r, this.localeData());
    return this.day(this.day() % 7 ? g : g - 7);
  } else
    return this.day() || 7;
}
function H1(r) {
  return this._weekdaysParseExact ? (me(this, "_weekdaysRegex") || Lh.call(this), r ? this._weekdaysStrictRegex : this._weekdaysRegex) : (me(this, "_weekdaysRegex") || (this._weekdaysRegex = D1), this._weekdaysStrictRegex && r ? this._weekdaysStrictRegex : this._weekdaysRegex);
}
function U1(r) {
  return this._weekdaysParseExact ? (me(this, "_weekdaysRegex") || Lh.call(this), r ? this._weekdaysShortStrictRegex : this._weekdaysShortRegex) : (me(this, "_weekdaysShortRegex") || (this._weekdaysShortRegex = I1), this._weekdaysShortStrictRegex && r ? this._weekdaysShortStrictRegex : this._weekdaysShortRegex);
}
function F1(r) {
  return this._weekdaysParseExact ? (me(this, "_weekdaysRegex") || Lh.call(this), r ? this._weekdaysMinStrictRegex : this._weekdaysMinRegex) : (me(this, "_weekdaysMinRegex") || (this._weekdaysMinRegex = R1), this._weekdaysMinStrictRegex && r ? this._weekdaysMinStrictRegex : this._weekdaysMinRegex);
}
function Lh() {
  function r(U, W) {
    return W.length - U.length;
  }
  var g = [], E = [], a = [], y = [], R, I, Z, H, $;
  for (R = 0; R < 7; R++)
    I = $i([2e3, 1]).day(R), Z = yi(this.weekdaysMin(I, "")), H = yi(this.weekdaysShort(I, "")), $ = yi(this.weekdays(I, "")), g.push(Z), E.push(H), a.push($), y.push(Z), y.push(H), y.push($);
  g.sort(r), E.sort(r), a.sort(r), y.sort(r), this._weekdaysRegex = new RegExp("^(" + y.join("|") + ")", "i"), this._weekdaysShortRegex = this._weekdaysRegex, this._weekdaysMinRegex = this._weekdaysRegex, this._weekdaysStrictRegex = new RegExp(
    "^(" + a.join("|") + ")",
    "i"
  ), this._weekdaysShortStrictRegex = new RegExp(
    "^(" + E.join("|") + ")",
    "i"
  ), this._weekdaysMinStrictRegex = new RegExp(
    "^(" + g.join("|") + ")",
    "i"
  );
}
function _h() {
  return this.hours() % 12 || 12;
}
function V1() {
  return this.hours() || 24;
}
Zt("H", ["HH", 2], 0, "hour");
Zt("h", ["hh", 2], 0, _h);
Zt("k", ["kk", 2], 0, V1);
Zt("hmm", 0, 0, function() {
  return "" + _h.apply(this) + Ui(this.minutes(), 2);
});
Zt("hmmss", 0, 0, function() {
  return "" + _h.apply(this) + Ui(this.minutes(), 2) + Ui(this.seconds(), 2);
});
Zt("Hmm", 0, 0, function() {
  return "" + this.hours() + Ui(this.minutes(), 2);
});
Zt("Hmmss", 0, 0, function() {
  return "" + this.hours() + Ui(this.minutes(), 2) + Ui(this.seconds(), 2);
});
function cu(r, g) {
  Zt(r, 0, 0, function() {
    return this.localeData().meridiem(
      this.hours(),
      this.minutes(),
      g
    );
  });
}
cu("a", !0);
cu("A", !1);
qe("hour", "h");
Qe("hour", 13);
function pu(r, g) {
  return g._meridiemParse;
}
Ut("a", pu);
Ut("A", pu);
Ut("H", Pe);
Ut("h", Pe);
Ut("k", Pe);
Ut("HH", Pe, vi);
Ut("hh", Pe, vi);
Ut("kk", Pe, vi);
Ut("hmm", tu);
Ut("hmmss", eu);
Ut("Hmm", tu);
Ut("Hmmss", eu);
we(["H", "HH"], Ge);
we(["k", "kk"], function(r, g, E) {
  var a = he(r);
  g[Ge] = a === 24 ? 0 : a;
});
we(["a", "A"], function(r, g, E) {
  E._isPm = E._locale.isPM(r), E._meridiem = r;
});
we(["h", "hh"], function(r, g, E) {
  g[Ge] = he(r), oe(E).bigHour = !0;
});
we("hmm", function(r, g, E) {
  var a = r.length - 2;
  g[Ge] = he(r.substr(0, a)), g[Ri] = he(r.substr(a)), oe(E).bigHour = !0;
});
we("hmmss", function(r, g, E) {
  var a = r.length - 4, y = r.length - 2;
  g[Ge] = he(r.substr(0, a)), g[Ri] = he(r.substr(a, 2)), g[cr] = he(r.substr(y)), oe(E).bigHour = !0;
});
we("Hmm", function(r, g, E) {
  var a = r.length - 2;
  g[Ge] = he(r.substr(0, a)), g[Ri] = he(r.substr(a));
});
we("Hmmss", function(r, g, E) {
  var a = r.length - 4, y = r.length - 2;
  g[Ge] = he(r.substr(0, a)), g[Ri] = he(r.substr(a, 2)), g[cr] = he(r.substr(y));
});
function $1(r) {
  return (r + "").toLowerCase().charAt(0) === "p";
}
var Z1 = /[ap]\.?m?\.?/i, K1 = kn("Hours", !0);
function J1(r, g, E) {
  return r > 11 ? E ? "pm" : "PM" : E ? "am" : "AM";
}
var uu = {
  calendar: z0,
  longDateFormat: H0,
  invalidDate: F0,
  ordinal: $0,
  dayOfMonthOrdinalParse: Z0,
  relativeTime: J0,
  months: p1,
  monthsShort: iu,
  week: C1,
  weekdays: L1,
  weekdaysMin: _1,
  weekdaysShort: lu,
  meridiemParse: Z1
}, Oe = {}, $n = {}, io;
function q1(r, g) {
  var E, a = Math.min(r.length, g.length);
  for (E = 0; E < a; E += 1)
    if (r[E] !== g[E])
      return E;
  return a;
}
function Mp(r) {
  return r && r.toLowerCase().replace("_", "-");
}
function Q1(r) {
  for (var g = 0, E, a, y, R; g < r.length; ) {
    for (R = Mp(r[g]).split("-"), E = R.length, a = Mp(r[g + 1]), a = a ? a.split("-") : null; E > 0; ) {
      if (y = Ds(R.slice(0, E).join("-")), y)
        return y;
      if (a && a.length >= E && q1(R, a) >= E - 1)
        break;
      E--;
    }
    g++;
  }
  return io;
}
function tb(r) {
  return r.match("^[^/\\\\]*$") != null;
}
function Ds(r) {
  var g = null, E;
  if (Oe[r] === void 0 && typeof module < "u" && module && module.exports && tb(r))
    try {
      g = io._abbr, E = require, E("./locale/" + r), Er(g);
    } catch {
      Oe[r] = null;
    }
  return Oe[r];
}
function Er(r, g) {
  var E;
  return r && (li(g) ? E = fr(r) : E = Dh(r, g), E ? io = E : typeof console < "u" && console.warn && console.warn(
    "Locale " + r + " not found. Did you forget to load it?"
  )), io._abbr;
}
function Dh(r, g) {
  if (g !== null) {
    var E, a = uu;
    if (g.abbr = r, Oe[r] != null)
      $p(
        "defineLocaleOverride",
        "use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."
      ), a = Oe[r]._config;
    else if (g.parentLocale != null)
      if (Oe[g.parentLocale] != null)
        a = Oe[g.parentLocale]._config;
      else if (E = Ds(g.parentLocale), E != null)
        a = E._config;
      else
        return $n[g.parentLocale] || ($n[g.parentLocale] = []), $n[g.parentLocale].push({
          name: r,
          config: g
        }), null;
    return Oe[r] = new kh(uh(a, g)), $n[r] && $n[r].forEach(function(y) {
      Dh(y.name, y.config);
    }), Er(r), Oe[r];
  } else
    return delete Oe[r], null;
}
function eb(r, g) {
  if (g != null) {
    var E, a, y = uu;
    Oe[r] != null && Oe[r].parentLocale != null ? Oe[r].set(uh(Oe[r]._config, g)) : (a = Ds(r), a != null && (y = a._config), g = uh(y, g), a == null && (g.abbr = r), E = new kh(g), E.parentLocale = Oe[r], Oe[r] = E), Er(r);
  } else
    Oe[r] != null && (Oe[r].parentLocale != null ? (Oe[r] = Oe[r].parentLocale, r === Er() && Er(r)) : Oe[r] != null && delete Oe[r]);
  return Oe[r];
}
function fr(r) {
  var g;
  if (r && r._locale && r._locale._abbr && (r = r._locale._abbr), !r)
    return io;
  if (!Bi(r)) {
    if (g = Ds(r), g)
      return g;
    r = [r];
  }
  return Q1(r);
}
function ib() {
  return dh(Oe);
}
function Ih(r) {
  var g, E = r._a;
  return E && oe(r).overflow === -2 && (g = E[lr] < 0 || E[lr] > 11 ? lr : E[Hi] < 1 || E[Hi] > _s(E[Je], E[lr]) ? Hi : E[Ge] < 0 || E[Ge] > 24 || E[Ge] === 24 && (E[Ri] !== 0 || E[cr] !== 0 || E[Fr] !== 0) ? Ge : E[Ri] < 0 || E[Ri] > 59 ? Ri : E[cr] < 0 || E[cr] > 59 ? cr : E[Fr] < 0 || E[Fr] > 999 ? Fr : -1, oe(r)._overflowDayOfYear && (g < Je || g > Hi) && (g = Hi), oe(r)._overflowWeeks && g === -1 && (g = h1), oe(r)._overflowWeekday && g === -1 && (g = l1), oe(r).overflow = g), r;
}
var rb = /^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/, nb = /^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d|))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/, ob = /Z|[+-]\d\d(?::?\d\d)?/, rs = [
  ["YYYYYY-MM-DD", /[+-]\d{6}-\d\d-\d\d/],
  ["YYYY-MM-DD", /\d{4}-\d\d-\d\d/],
  ["GGGG-[W]WW-E", /\d{4}-W\d\d-\d/],
  ["GGGG-[W]WW", /\d{4}-W\d\d/, !1],
  ["YYYY-DDD", /\d{4}-\d{3}/],
  ["YYYY-MM", /\d{4}-\d\d/, !1],
  ["YYYYYYMMDD", /[+-]\d{10}/],
  ["YYYYMMDD", /\d{8}/],
  ["GGGG[W]WWE", /\d{4}W\d{3}/],
  ["GGGG[W]WW", /\d{4}W\d{2}/, !1],
  ["YYYYDDD", /\d{7}/],
  ["YYYYMM", /\d{6}/, !1],
  ["YYYY", /\d{4}/, !1]
], ih = [
  ["HH:mm:ss.SSSS", /\d\d:\d\d:\d\d\.\d+/],
  ["HH:mm:ss,SSSS", /\d\d:\d\d:\d\d,\d+/],
  ["HH:mm:ss", /\d\d:\d\d:\d\d/],
  ["HH:mm", /\d\d:\d\d/],
  ["HHmmss.SSSS", /\d\d\d\d\d\d\.\d+/],
  ["HHmmss,SSSS", /\d\d\d\d\d\d,\d+/],
  ["HHmmss", /\d\d\d\d\d\d/],
  ["HHmm", /\d\d\d\d/],
  ["HH", /\d\d/]
], sb = /^\/?Date\((-?\d+)/i, ab = /^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/, hb = {
  UT: 0,
  GMT: 0,
  EDT: -4 * 60,
  EST: -5 * 60,
  CDT: -5 * 60,
  CST: -6 * 60,
  MDT: -6 * 60,
  MST: -7 * 60,
  PDT: -7 * 60,
  PST: -8 * 60
};
function du(r) {
  var g, E, a = r._i, y = rb.exec(a) || nb.exec(a), R, I, Z, H, $ = rs.length, U = ih.length;
  if (y) {
    for (oe(r).iso = !0, g = 0, E = $; g < E; g++)
      if (rs[g][1].exec(y[1])) {
        I = rs[g][0], R = rs[g][2] !== !1;
        break;
      }
    if (I == null) {
      r._isValid = !1;
      return;
    }
    if (y[3]) {
      for (g = 0, E = U; g < E; g++)
        if (ih[g][1].exec(y[3])) {
          Z = (y[2] || " ") + ih[g][0];
          break;
        }
      if (Z == null) {
        r._isValid = !1;
        return;
      }
    }
    if (!R && Z != null) {
      r._isValid = !1;
      return;
    }
    if (y[4])
      if (ob.exec(y[4]))
        H = "Z";
      else {
        r._isValid = !1;
        return;
      }
    r._f = I + (Z || "") + (H || ""), Nh(r);
  } else
    r._isValid = !1;
}
function lb(r, g, E, a, y, R) {
  var I = [
    cb(r),
    iu.indexOf(g),
    parseInt(E, 10),
    parseInt(a, 10),
    parseInt(y, 10)
  ];
  return R && I.push(parseInt(R, 10)), I;
}
function cb(r) {
  var g = parseInt(r, 10);
  return g <= 49 ? 2e3 + g : g <= 999 ? 1900 + g : g;
}
function pb(r) {
  return r.replace(/\([^()]*\)|[\n\t]/g, " ").replace(/(\s\s+)/g, " ").replace(/^\s\s*/, "").replace(/\s\s*$/, "");
}
function ub(r, g, E) {
  if (r) {
    var a = lu.indexOf(r), y = new Date(
      g[0],
      g[1],
      g[2]
    ).getDay();
    if (a !== y)
      return oe(E).weekdayMismatch = !0, E._isValid = !1, !1;
  }
  return !0;
}
function db(r, g, E) {
  if (r)
    return hb[r];
  if (g)
    return 0;
  var a = parseInt(E, 10), y = a % 100, R = (a - y) / 100;
  return R * 60 + y;
}
function fu(r) {
  var g = ab.exec(pb(r._i)), E;
  if (g) {
    if (E = lb(
      g[4],
      g[3],
      g[2],
      g[5],
      g[6],
      g[7]
    ), !ub(g[1], E, r))
      return;
    r._a = E, r._tzm = db(g[8], g[9], g[10]), r._d = to.apply(null, r._a), r._d.setUTCMinutes(r._d.getUTCMinutes() - r._tzm), oe(r).rfc2822 = !0;
  } else
    r._isValid = !1;
}
function fb(r) {
  var g = sb.exec(r._i);
  if (g !== null) {
    r._d = /* @__PURE__ */ new Date(+g[1]);
    return;
  }
  if (du(r), r._isValid === !1)
    delete r._isValid;
  else
    return;
  if (fu(r), r._isValid === !1)
    delete r._isValid;
  else
    return;
  r._strict ? r._isValid = !1 : Xt.createFromInputFallback(r);
}
Xt.createFromInputFallback = Ei(
  "value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",
  function(r) {
    r._d = /* @__PURE__ */ new Date(r._i + (r._useUTC ? " UTC" : ""));
  }
);
function dn(r, g, E) {
  return r ?? g ?? E;
}
function gb(r) {
  var g = new Date(Xt.now());
  return r._useUTC ? [
    g.getUTCFullYear(),
    g.getUTCMonth(),
    g.getUTCDate()
  ] : [g.getFullYear(), g.getMonth(), g.getDate()];
}
function Rh(r) {
  var g, E, a = [], y, R, I;
  if (!r._d) {
    for (y = gb(r), r._w && r._a[Hi] == null && r._a[lr] == null && mb(r), r._dayOfYear != null && (I = dn(r._a[Je], y[Je]), (r._dayOfYear > qn(I) || r._dayOfYear === 0) && (oe(r)._overflowDayOfYear = !0), E = to(I, 0, r._dayOfYear), r._a[lr] = E.getUTCMonth(), r._a[Hi] = E.getUTCDate()), g = 0; g < 3 && r._a[g] == null; ++g)
      r._a[g] = a[g] = y[g];
    for (; g < 7; g++)
      r._a[g] = a[g] = r._a[g] == null ? g === 2 ? 1 : 0 : r._a[g];
    r._a[Ge] === 24 && r._a[Ri] === 0 && r._a[cr] === 0 && r._a[Fr] === 0 && (r._nextDay = !0, r._a[Ge] = 0), r._d = (r._useUTC ? to : w1).apply(
      null,
      a
    ), R = r._useUTC ? r._d.getUTCDay() : r._d.getDay(), r._tzm != null && r._d.setUTCMinutes(r._d.getUTCMinutes() - r._tzm), r._nextDay && (r._a[Ge] = 24), r._w && typeof r._w.d < "u" && r._w.d !== R && (oe(r).weekdayMismatch = !0);
  }
}
function mb(r) {
  var g, E, a, y, R, I, Z, H, $;
  g = r._w, g.GG != null || g.W != null || g.E != null ? (R = 1, I = 4, E = dn(
    g.GG,
    r._a[Je],
    eo(Te(), 1, 4).year
  ), a = dn(g.W, 1), y = dn(g.E, 1), (y < 1 || y > 7) && (H = !0)) : (R = r._locale._week.dow, I = r._locale._week.doy, $ = eo(Te(), R, I), E = dn(g.gg, r._a[Je], $.year), a = dn(g.w, $.week), g.d != null ? (y = g.d, (y < 0 || y > 6) && (H = !0)) : g.e != null ? (y = g.e + R, (g.e < 0 || g.e > 6) && (H = !0)) : y = R), a < 1 || a > pr(E, R, I) ? oe(r)._overflowWeeks = !0 : H != null ? oe(r)._overflowWeekday = !0 : (Z = hu(E, a, y, R, I), r._a[Je] = Z.year, r._dayOfYear = Z.dayOfYear);
}
Xt.ISO_8601 = function() {
};
Xt.RFC_2822 = function() {
};
function Nh(r) {
  if (r._f === Xt.ISO_8601) {
    du(r);
    return;
  }
  if (r._f === Xt.RFC_2822) {
    fu(r);
    return;
  }
  r._a = [], oe(r).empty = !0;
  var g = "" + r._i, E, a, y, R, I, Z = g.length, H = 0, $, U;
  for (y = Zp(r._f, r._locale).match(Ah) || [], U = y.length, E = 0; E < U; E++)
    R = y[E], a = (g.match(o1(R, r)) || [])[0], a && (I = g.substr(0, g.indexOf(a)), I.length > 0 && oe(r).unusedInput.push(I), g = g.slice(
      g.indexOf(a) + a.length
    ), H += a.length), yn[R] ? (a ? oe(r).empty = !1 : oe(r).unusedTokens.push(R), a1(R, a, r)) : r._strict && !a && oe(r).unusedTokens.push(R);
  oe(r).charsLeftOver = Z - H, g.length > 0 && oe(r).unusedInput.push(g), r._a[Ge] <= 12 && oe(r).bigHour === !0 && r._a[Ge] > 0 && (oe(r).bigHour = void 0), oe(r).parsedDateParts = r._a.slice(0), oe(r).meridiem = r._meridiem, r._a[Ge] = yb(
    r._locale,
    r._a[Ge],
    r._meridiem
  ), $ = oe(r).era, $ !== null && (r._a[Je] = r._locale.erasConvertYear($, r._a[Je])), Rh(r), Ih(r);
}
function yb(r, g, E) {
  var a;
  return E == null ? g : r.meridiemHour != null ? r.meridiemHour(g, E) : (r.isPM != null && (a = r.isPM(E), a && g < 12 && (g += 12), !a && g === 12 && (g = 0)), g);
}
function vb(r) {
  var g, E, a, y, R, I, Z = !1, H = r._f.length;
  if (H === 0) {
    oe(r).invalidFormat = !0, r._d = /* @__PURE__ */ new Date(NaN);
    return;
  }
  for (y = 0; y < H; y++)
    R = 0, I = !1, g = Ch({}, r), r._useUTC != null && (g._useUTC = r._useUTC), g._f = r._f[y], Nh(g), Mh(g) && (I = !0), R += oe(g).charsLeftOver, R += oe(g).unusedTokens.length * 10, oe(g).score = R, Z ? R < a && (a = R, E = g) : (a == null || R < a || I) && (a = R, E = g, I && (Z = !0));
  Tr(r, E || g);
}
function xb(r) {
  if (!r._d) {
    var g = Th(r._i), E = g.day === void 0 ? g.date : g.day;
    r._a = Fp(
      [g.year, g.month, E, g.hour, g.minute, g.second, g.millisecond],
      function(a) {
        return a && parseInt(a, 10);
      }
    ), Rh(r);
  }
}
function bb(r) {
  var g = new oo(Ih(gu(r)));
  return g._nextDay && (g.add(1, "d"), g._nextDay = void 0), g;
}
function gu(r) {
  var g = r._i, E = r._f;
  return r._locale = r._locale || fr(r._l), g === null || E === void 0 && g === "" ? ks({ nullInput: !0 }) : (typeof g == "string" && (r._i = g = r._locale.preparse(g)), ji(g) ? new oo(Ih(g)) : (no(g) ? r._d = g : Bi(E) ? vb(r) : E ? Nh(r) : Sb(r), Mh(r) || (r._d = null), r));
}
function Sb(r) {
  var g = r._i;
  li(g) ? r._d = new Date(Xt.now()) : no(g) ? r._d = new Date(g.valueOf()) : typeof g == "string" ? fb(r) : Bi(g) ? (r._a = Fp(g.slice(0), function(E) {
    return parseInt(E, 10);
  }), Rh(r)) : Vr(g) ? xb(r) : dr(g) ? r._d = new Date(g) : Xt.createFromInputFallback(r);
}
function mu(r, g, E, a, y) {
  var R = {};
  return (g === !0 || g === !1) && (a = g, g = void 0), (E === !0 || E === !1) && (a = E, E = void 0), (Vr(r) && wh(r) || Bi(r) && r.length === 0) && (r = void 0), R._isAMomentObject = !0, R._useUTC = R._isUTC = y, R._l = E, R._i = r, R._f = g, R._strict = a, bb(R);
}
function Te(r, g, E, a) {
  return mu(r, g, E, a, !1);
}
var wb = Ei(
  "moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",
  function() {
    var r = Te.apply(null, arguments);
    return this.isValid() && r.isValid() ? r < this ? this : r : ks();
  }
), Mb = Ei(
  "moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",
  function() {
    var r = Te.apply(null, arguments);
    return this.isValid() && r.isValid() ? r > this ? this : r : ks();
  }
);
function yu(r, g) {
  var E, a;
  if (g.length === 1 && Bi(g[0]) && (g = g[0]), !g.length)
    return Te();
  for (E = g[0], a = 1; a < g.length; ++a)
    (!g[a].isValid() || g[a][r](E)) && (E = g[a]);
  return E;
}
function Cb() {
  var r = [].slice.call(arguments, 0);
  return yu("isBefore", r);
}
function kb() {
  var r = [].slice.call(arguments, 0);
  return yu("isAfter", r);
}
var Ab = function() {
  return Date.now ? Date.now() : +/* @__PURE__ */ new Date();
}, Zn = [
  "year",
  "quarter",
  "month",
  "week",
  "day",
  "hour",
  "minute",
  "second",
  "millisecond"
];
function Tb(r) {
  var g, E = !1, a, y = Zn.length;
  for (g in r)
    if (me(r, g) && !(je.call(Zn, g) !== -1 && (r[g] == null || !isNaN(r[g]))))
      return !1;
  for (a = 0; a < y; ++a)
    if (r[Zn[a]]) {
      if (E)
        return !1;
      parseFloat(r[Zn[a]]) !== he(r[Zn[a]]) && (E = !0);
    }
  return !0;
}
function Pb() {
  return this._isValid;
}
function Eb() {
  return Wi(NaN);
}
function Is(r) {
  var g = Th(r), E = g.year || 0, a = g.quarter || 0, y = g.month || 0, R = g.week || g.isoWeek || 0, I = g.day || 0, Z = g.hour || 0, H = g.minute || 0, $ = g.second || 0, U = g.millisecond || 0;
  this._isValid = Tb(g), this._milliseconds = +U + $ * 1e3 + // 1000
  H * 6e4 + // 1000 * 60
  Z * 1e3 * 60 * 60, this._days = +I + R * 7, this._months = +y + a * 3 + E * 12, this._data = {}, this._locale = fr(), this._bubble();
}
function as(r) {
  return r instanceof Is;
}
function gh(r) {
  return r < 0 ? Math.round(-1 * r) * -1 : Math.round(r);
}
function Ob(r, g, E) {
  var a = Math.min(r.length, g.length), y = Math.abs(r.length - g.length), R = 0, I;
  for (I = 0; I < a; I++)
    (E && r[I] !== g[I] || !E && he(r[I]) !== he(g[I])) && R++;
  return R + y;
}
function vu(r, g) {
  Zt(r, 0, 0, function() {
    var E = this.utcOffset(), a = "+";
    return E < 0 && (E = -E, a = "-"), a + Ui(~~(E / 60), 2) + g + Ui(~~E % 60, 2);
  });
}
vu("Z", ":");
vu("ZZ", "");
Ut("Z", Ls);
Ut("ZZ", Ls);
we(["Z", "ZZ"], function(r, g, E) {
  E._useUTC = !0, E._tzm = Bh(Ls, r);
});
var Lb = /([\+\-]|\d\d)/gi;
function Bh(r, g) {
  var E = (g || "").match(r), a, y, R;
  return E === null ? null : (a = E[E.length - 1] || [], y = (a + "").match(Lb) || ["-", 0, 0], R = +(y[1] * 60) + he(y[2]), R === 0 ? 0 : y[0] === "+" ? R : -R);
}
function jh(r, g) {
  var E, a;
  return g._isUTC ? (E = g.clone(), a = (ji(r) || no(r) ? r.valueOf() : Te(r).valueOf()) - E.valueOf(), E._d.setTime(E._d.valueOf() + a), Xt.updateOffset(E, !1), E) : Te(r).local();
}
function mh(r) {
  return -Math.round(r._d.getTimezoneOffset());
}
Xt.updateOffset = function() {
};
function _b(r, g, E) {
  var a = this._offset || 0, y;
  if (!this.isValid())
    return r != null ? this : NaN;
  if (r != null) {
    if (typeof r == "string") {
      if (r = Bh(Ls, r), r === null)
        return this;
    } else
      Math.abs(r) < 16 && !E && (r = r * 60);
    return !this._isUTC && g && (y = mh(this)), this._offset = r, this._isUTC = !0, y != null && this.add(y, "m"), a !== r && (!g || this._changeInProgress ? Su(
      this,
      Wi(r - a, "m"),
      1,
      !1
    ) : this._changeInProgress || (this._changeInProgress = !0, Xt.updateOffset(this, !0), this._changeInProgress = null)), this;
  } else
    return this._isUTC ? a : mh(this);
}
function Db(r, g) {
  return r != null ? (typeof r != "string" && (r = -r), this.utcOffset(r, g), this) : -this.utcOffset();
}
function Ib(r) {
  return this.utcOffset(0, r);
}
function Rb(r) {
  return this._isUTC && (this.utcOffset(0, r), this._isUTC = !1, r && this.subtract(mh(this), "m")), this;
}
function Nb() {
  if (this._tzm != null)
    this.utcOffset(this._tzm, !1, !0);
  else if (typeof this._i == "string") {
    var r = Bh(r1, this._i);
    r != null ? this.utcOffset(r) : this.utcOffset(0, !0);
  }
  return this;
}
function Bb(r) {
  return this.isValid() ? (r = r ? Te(r).utcOffset() : 0, (this.utcOffset() - r) % 60 === 0) : !1;
}
function jb() {
  return this.utcOffset() > this.clone().month(0).utcOffset() || this.utcOffset() > this.clone().month(5).utcOffset();
}
function Wb() {
  if (!li(this._isDSTShifted))
    return this._isDSTShifted;
  var r = {}, g;
  return Ch(r, this), r = gu(r), r._a ? (g = r._isUTC ? $i(r._a) : Te(r._a), this._isDSTShifted = this.isValid() && Ob(r._a, g.toArray()) > 0) : this._isDSTShifted = !1, this._isDSTShifted;
}
function zb() {
  return this.isValid() ? !this._isUTC : !1;
}
function Yb() {
  return this.isValid() ? this._isUTC : !1;
}
function xu() {
  return this.isValid() ? this._isUTC && this._offset === 0 : !1;
}
var Xb = /^(-|\+)?(?:(\d*)[. ])?(\d+):(\d+)(?::(\d+)(\.\d*)?)?$/, Gb = /^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;
function Wi(r, g) {
  var E = r, a = null, y, R, I;
  return as(r) ? E = {
    ms: r._milliseconds,
    d: r._days,
    M: r._months
  } : dr(r) || !isNaN(+r) ? (E = {}, g ? E[g] = +r : E.milliseconds = +r) : (a = Xb.exec(r)) ? (y = a[1] === "-" ? -1 : 1, E = {
    y: 0,
    d: he(a[Hi]) * y,
    h: he(a[Ge]) * y,
    m: he(a[Ri]) * y,
    s: he(a[cr]) * y,
    ms: he(gh(a[Fr] * 1e3)) * y
    // the millisecond decimal point is included in the match
  }) : (a = Gb.exec(r)) ? (y = a[1] === "-" ? -1 : 1, E = {
    y: Gr(a[2], y),
    M: Gr(a[3], y),
    w: Gr(a[4], y),
    d: Gr(a[5], y),
    h: Gr(a[6], y),
    m: Gr(a[7], y),
    s: Gr(a[8], y)
  }) : E == null ? E = {} : typeof E == "object" && ("from" in E || "to" in E) && (I = Hb(
    Te(E.from),
    Te(E.to)
  ), E = {}, E.ms = I.milliseconds, E.M = I.months), R = new Is(E), as(r) && me(r, "_locale") && (R._locale = r._locale), as(r) && me(r, "_isValid") && (R._isValid = r._isValid), R;
}
Wi.fn = Is.prototype;
Wi.invalid = Eb;
function Gr(r, g) {
  var E = r && parseFloat(r.replace(",", "."));
  return (isNaN(E) ? 0 : E) * g;
}
function Cp(r, g) {
  var E = {};
  return E.months = g.month() - r.month() + (g.year() - r.year()) * 12, r.clone().add(E.months, "M").isAfter(g) && --E.months, E.milliseconds = +g - +r.clone().add(E.months, "M"), E;
}
function Hb(r, g) {
  var E;
  return r.isValid() && g.isValid() ? (g = jh(g, r), r.isBefore(g) ? E = Cp(r, g) : (E = Cp(g, r), E.milliseconds = -E.milliseconds, E.months = -E.months), E) : { milliseconds: 0, months: 0 };
}
function bu(r, g) {
  return function(E, a) {
    var y, R;
    return a !== null && !isNaN(+a) && ($p(
      g,
      "moment()." + g + "(period, number) is deprecated. Please use moment()." + g + "(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."
    ), R = E, E = a, a = R), y = Wi(E, a), Su(this, y, r), this;
  };
}
function Su(r, g, E, a) {
  var y = g._milliseconds, R = gh(g._days), I = gh(g._months);
  r.isValid() && (a = a ?? !0, I && nu(r, gs(r, "Month") + I * E), R && Jp(r, "Date", gs(r, "Date") + R * E), y && r._d.setTime(r._d.valueOf() + y * E), a && Xt.updateOffset(r, R || I));
}
var Ub = bu(1, "add"), Fb = bu(-1, "subtract");
function wu(r) {
  return typeof r == "string" || r instanceof String;
}
function Vb(r) {
  return ji(r) || no(r) || wu(r) || dr(r) || Zb(r) || $b(r) || r === null || r === void 0;
}
function $b(r) {
  var g = Vr(r) && !wh(r), E = !1, a = [
    "years",
    "year",
    "y",
    "months",
    "month",
    "M",
    "days",
    "day",
    "d",
    "dates",
    "date",
    "D",
    "hours",
    "hour",
    "h",
    "minutes",
    "minute",
    "m",
    "seconds",
    "second",
    "s",
    "milliseconds",
    "millisecond",
    "ms"
  ], y, R, I = a.length;
  for (y = 0; y < I; y += 1)
    R = a[y], E = E || me(r, R);
  return g && E;
}
function Zb(r) {
  var g = Bi(r), E = !1;
  return g && (E = r.filter(function(a) {
    return !dr(a) && wu(r);
  }).length === 0), g && E;
}
function Kb(r) {
  var g = Vr(r) && !wh(r), E = !1, a = [
    "sameDay",
    "nextDay",
    "lastDay",
    "nextWeek",
    "lastWeek",
    "sameElse"
  ], y, R;
  for (y = 0; y < a.length; y += 1)
    R = a[y], E = E || me(r, R);
  return g && E;
}
function Jb(r, g) {
  var E = r.diff(g, "days", !0);
  return E < -6 ? "sameElse" : E < -1 ? "lastWeek" : E < 0 ? "lastDay" : E < 1 ? "sameDay" : E < 2 ? "nextDay" : E < 7 ? "nextWeek" : "sameElse";
}
function qb(r, g) {
  arguments.length === 1 && (arguments[0] ? Vb(arguments[0]) ? (r = arguments[0], g = void 0) : Kb(arguments[0]) && (g = arguments[0], r = void 0) : (r = void 0, g = void 0));
  var E = r || Te(), a = jh(E, this).startOf("day"), y = Xt.calendarFormat(this, a) || "sameElse", R = g && (Zi(g[y]) ? g[y].call(this, E) : g[y]);
  return this.format(
    R || this.localeData().calendar(y, this, Te(E))
  );
}
function Qb() {
  return new oo(this);
}
function tS(r, g) {
  var E = ji(r) ? r : Te(r);
  return this.isValid() && E.isValid() ? (g = Oi(g) || "millisecond", g === "millisecond" ? this.valueOf() > E.valueOf() : E.valueOf() < this.clone().startOf(g).valueOf()) : !1;
}
function eS(r, g) {
  var E = ji(r) ? r : Te(r);
  return this.isValid() && E.isValid() ? (g = Oi(g) || "millisecond", g === "millisecond" ? this.valueOf() < E.valueOf() : this.clone().endOf(g).valueOf() < E.valueOf()) : !1;
}
function iS(r, g, E, a) {
  var y = ji(r) ? r : Te(r), R = ji(g) ? g : Te(g);
  return this.isValid() && y.isValid() && R.isValid() ? (a = a || "()", (a[0] === "(" ? this.isAfter(y, E) : !this.isBefore(y, E)) && (a[1] === ")" ? this.isBefore(R, E) : !this.isAfter(R, E))) : !1;
}
function rS(r, g) {
  var E = ji(r) ? r : Te(r), a;
  return this.isValid() && E.isValid() ? (g = Oi(g) || "millisecond", g === "millisecond" ? this.valueOf() === E.valueOf() : (a = E.valueOf(), this.clone().startOf(g).valueOf() <= a && a <= this.clone().endOf(g).valueOf())) : !1;
}
function nS(r, g) {
  return this.isSame(r, g) || this.isAfter(r, g);
}
function oS(r, g) {
  return this.isSame(r, g) || this.isBefore(r, g);
}
function sS(r, g, E) {
  var a, y, R;
  if (!this.isValid())
    return NaN;
  if (a = jh(r, this), !a.isValid())
    return NaN;
  switch (y = (a.utcOffset() - this.utcOffset()) * 6e4, g = Oi(g), g) {
    case "year":
      R = hs(this, a) / 12;
      break;
    case "month":
      R = hs(this, a);
      break;
    case "quarter":
      R = hs(this, a) / 3;
      break;
    case "second":
      R = (this - a) / 1e3;
      break;
    case "minute":
      R = (this - a) / 6e4;
      break;
    case "hour":
      R = (this - a) / 36e5;
      break;
    case "day":
      R = (this - a - y) / 864e5;
      break;
    case "week":
      R = (this - a - y) / 6048e5;
      break;
    default:
      R = this - a;
  }
  return E ? R : Ti(R);
}
function hs(r, g) {
  if (r.date() < g.date())
    return -hs(g, r);
  var E = (g.year() - r.year()) * 12 + (g.month() - r.month()), a = r.clone().add(E, "months"), y, R;
  return g - a < 0 ? (y = r.clone().add(E - 1, "months"), R = (g - a) / (a - y)) : (y = r.clone().add(E + 1, "months"), R = (g - a) / (y - a)), -(E + R) || 0;
}
Xt.defaultFormat = "YYYY-MM-DDTHH:mm:ssZ";
Xt.defaultFormatUtc = "YYYY-MM-DDTHH:mm:ss[Z]";
function aS() {
  return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ");
}
function hS(r) {
  if (!this.isValid())
    return null;
  var g = r !== !0, E = g ? this.clone().utc() : this;
  return E.year() < 0 || E.year() > 9999 ? ss(
    E,
    g ? "YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]" : "YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"
  ) : Zi(Date.prototype.toISOString) ? g ? this.toDate().toISOString() : new Date(this.valueOf() + this.utcOffset() * 60 * 1e3).toISOString().replace("Z", ss(E, "Z")) : ss(
    E,
    g ? "YYYY-MM-DD[T]HH:mm:ss.SSS[Z]" : "YYYY-MM-DD[T]HH:mm:ss.SSSZ"
  );
}
function lS() {
  if (!this.isValid())
    return "moment.invalid(/* " + this._i + " */)";
  var r = "moment", g = "", E, a, y, R;
  return this.isLocal() || (r = this.utcOffset() === 0 ? "moment.utc" : "moment.parseZone", g = "Z"), E = "[" + r + '("]', a = 0 <= this.year() && this.year() <= 9999 ? "YYYY" : "YYYYYY", y = "-MM-DD[T]HH:mm:ss.SSS", R = g + '[")]', this.format(E + a + y + R);
}
function cS(r) {
  r || (r = this.isUtc() ? Xt.defaultFormatUtc : Xt.defaultFormat);
  var g = ss(this, r);
  return this.localeData().postformat(g);
}
function pS(r, g) {
  return this.isValid() && (ji(r) && r.isValid() || Te(r).isValid()) ? Wi({ to: this, from: r }).locale(this.locale()).humanize(!g) : this.localeData().invalidDate();
}
function uS(r) {
  return this.from(Te(), r);
}
function dS(r, g) {
  return this.isValid() && (ji(r) && r.isValid() || Te(r).isValid()) ? Wi({ from: this, to: r }).locale(this.locale()).humanize(!g) : this.localeData().invalidDate();
}
function fS(r) {
  return this.to(Te(), r);
}
function Mu(r) {
  var g;
  return r === void 0 ? this._locale._abbr : (g = fr(r), g != null && (this._locale = g), this);
}
var Cu = Ei(
  "moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",
  function(r) {
    return r === void 0 ? this.localeData() : this.locale(r);
  }
);
function ku() {
  return this._locale;
}
var vs = 1e3, vn = 60 * vs, xs = 60 * vn, Au = (365 * 400 + 97) * 24 * xs;
function xn(r, g) {
  return (r % g + g) % g;
}
function Tu(r, g, E) {
  return r < 100 && r >= 0 ? new Date(r + 400, g, E) - Au : new Date(r, g, E).valueOf();
}
function Pu(r, g, E) {
  return r < 100 && r >= 0 ? Date.UTC(r + 400, g, E) - Au : Date.UTC(r, g, E);
}
function gS(r) {
  var g, E;
  if (r = Oi(r), r === void 0 || r === "millisecond" || !this.isValid())
    return this;
  switch (E = this._isUTC ? Pu : Tu, r) {
    case "year":
      g = E(this.year(), 0, 1);
      break;
    case "quarter":
      g = E(
        this.year(),
        this.month() - this.month() % 3,
        1
      );
      break;
    case "month":
      g = E(this.year(), this.month(), 1);
      break;
    case "week":
      g = E(
        this.year(),
        this.month(),
        this.date() - this.weekday()
      );
      break;
    case "isoWeek":
      g = E(
        this.year(),
        this.month(),
        this.date() - (this.isoWeekday() - 1)
      );
      break;
    case "day":
    case "date":
      g = E(this.year(), this.month(), this.date());
      break;
    case "hour":
      g = this._d.valueOf(), g -= xn(
        g + (this._isUTC ? 0 : this.utcOffset() * vn),
        xs
      );
      break;
    case "minute":
      g = this._d.valueOf(), g -= xn(g, vn);
      break;
    case "second":
      g = this._d.valueOf(), g -= xn(g, vs);
      break;
  }
  return this._d.setTime(g), Xt.updateOffset(this, !0), this;
}
function mS(r) {
  var g, E;
  if (r = Oi(r), r === void 0 || r === "millisecond" || !this.isValid())
    return this;
  switch (E = this._isUTC ? Pu : Tu, r) {
    case "year":
      g = E(this.year() + 1, 0, 1) - 1;
      break;
    case "quarter":
      g = E(
        this.year(),
        this.month() - this.month() % 3 + 3,
        1
      ) - 1;
      break;
    case "month":
      g = E(this.year(), this.month() + 1, 1) - 1;
      break;
    case "week":
      g = E(
        this.year(),
        this.month(),
        this.date() - this.weekday() + 7
      ) - 1;
      break;
    case "isoWeek":
      g = E(
        this.year(),
        this.month(),
        this.date() - (this.isoWeekday() - 1) + 7
      ) - 1;
      break;
    case "day":
    case "date":
      g = E(this.year(), this.month(), this.date() + 1) - 1;
      break;
    case "hour":
      g = this._d.valueOf(), g += xs - xn(
        g + (this._isUTC ? 0 : this.utcOffset() * vn),
        xs
      ) - 1;
      break;
    case "minute":
      g = this._d.valueOf(), g += vn - xn(g, vn) - 1;
      break;
    case "second":
      g = this._d.valueOf(), g += vs - xn(g, vs) - 1;
      break;
  }
  return this._d.setTime(g), Xt.updateOffset(this, !0), this;
}
function yS() {
  return this._d.valueOf() - (this._offset || 0) * 6e4;
}
function vS() {
  return Math.floor(this.valueOf() / 1e3);
}
function xS() {
  return new Date(this.valueOf());
}
function bS() {
  var r = this;
  return [
    r.year(),
    r.month(),
    r.date(),
    r.hour(),
    r.minute(),
    r.second(),
    r.millisecond()
  ];
}
function SS() {
  var r = this;
  return {
    years: r.year(),
    months: r.month(),
    date: r.date(),
    hours: r.hours(),
    minutes: r.minutes(),
    seconds: r.seconds(),
    milliseconds: r.milliseconds()
  };
}
function wS() {
  return this.isValid() ? this.toISOString() : null;
}
function MS() {
  return Mh(this);
}
function CS() {
  return Tr({}, oe(this));
}
function kS() {
  return oe(this).overflow;
}
function AS() {
  return {
    input: this._i,
    format: this._f,
    locale: this._locale,
    isUTC: this._isUTC,
    strict: this._strict
  };
}
Zt("N", 0, 0, "eraAbbr");
Zt("NN", 0, 0, "eraAbbr");
Zt("NNN", 0, 0, "eraAbbr");
Zt("NNNN", 0, 0, "eraName");
Zt("NNNNN", 0, 0, "eraNarrow");
Zt("y", ["y", 1], "yo", "eraYear");
Zt("y", ["yy", 2], 0, "eraYear");
Zt("y", ["yyy", 3], 0, "eraYear");
Zt("y", ["yyyy", 4], 0, "eraYear");
Ut("N", Wh);
Ut("NN", Wh);
Ut("NNN", Wh);
Ut("NNNN", BS);
Ut("NNNNN", jS);
we(
  ["N", "NN", "NNN", "NNNN", "NNNNN"],
  function(r, g, E, a) {
    var y = E._locale.erasParse(r, a, E._strict);
    y ? oe(E).era = y : oe(E).invalidEra = r;
  }
);
Ut("y", An);
Ut("yy", An);
Ut("yyy", An);
Ut("yyyy", An);
Ut("yo", WS);
we(["y", "yy", "yyy", "yyyy"], Je);
we(["yo"], function(r, g, E, a) {
  var y;
  E._locale._eraYearOrdinalRegex && (y = r.match(E._locale._eraYearOrdinalRegex)), E._locale.eraYearOrdinalParse ? g[Je] = E._locale.eraYearOrdinalParse(r, y) : g[Je] = parseInt(r, 10);
});
function TS(r, g) {
  var E, a, y, R = this._eras || fr("en")._eras;
  for (E = 0, a = R.length; E < a; ++E) {
    switch (typeof R[E].since) {
      case "string":
        y = Xt(R[E].since).startOf("day"), R[E].since = y.valueOf();
        break;
    }
    switch (typeof R[E].until) {
      case "undefined":
        R[E].until = 1 / 0;
        break;
      case "string":
        y = Xt(R[E].until).startOf("day").valueOf(), R[E].until = y.valueOf();
        break;
    }
  }
  return R;
}
function PS(r, g, E) {
  var a, y, R = this.eras(), I, Z, H;
  for (r = r.toUpperCase(), a = 0, y = R.length; a < y; ++a)
    if (I = R[a].name.toUpperCase(), Z = R[a].abbr.toUpperCase(), H = R[a].narrow.toUpperCase(), E)
      switch (g) {
        case "N":
        case "NN":
        case "NNN":
          if (Z === r)
            return R[a];
          break;
        case "NNNN":
          if (I === r)
            return R[a];
          break;
        case "NNNNN":
          if (H === r)
            return R[a];
          break;
      }
    else if ([I, Z, H].indexOf(r) >= 0)
      return R[a];
}
function ES(r, g) {
  var E = r.since <= r.until ? 1 : -1;
  return g === void 0 ? Xt(r.since).year() : Xt(r.since).year() + (g - r.offset) * E;
}
function OS() {
  var r, g, E, a = this.localeData().eras();
  for (r = 0, g = a.length; r < g; ++r)
    if (E = this.clone().startOf("day").valueOf(), a[r].since <= E && E <= a[r].until || a[r].until <= E && E <= a[r].since)
      return a[r].name;
  return "";
}
function LS() {
  var r, g, E, a = this.localeData().eras();
  for (r = 0, g = a.length; r < g; ++r)
    if (E = this.clone().startOf("day").valueOf(), a[r].since <= E && E <= a[r].until || a[r].until <= E && E <= a[r].since)
      return a[r].narrow;
  return "";
}
function _S() {
  var r, g, E, a = this.localeData().eras();
  for (r = 0, g = a.length; r < g; ++r)
    if (E = this.clone().startOf("day").valueOf(), a[r].since <= E && E <= a[r].until || a[r].until <= E && E <= a[r].since)
      return a[r].abbr;
  return "";
}
function DS() {
  var r, g, E, a, y = this.localeData().eras();
  for (r = 0, g = y.length; r < g; ++r)
    if (E = y[r].since <= y[r].until ? 1 : -1, a = this.clone().startOf("day").valueOf(), y[r].since <= a && a <= y[r].until || y[r].until <= a && a <= y[r].since)
      return (this.year() - Xt(y[r].since).year()) * E + y[r].offset;
  return this.year();
}
function IS(r) {
  return me(this, "_erasNameRegex") || zh.call(this), r ? this._erasNameRegex : this._erasRegex;
}
function RS(r) {
  return me(this, "_erasAbbrRegex") || zh.call(this), r ? this._erasAbbrRegex : this._erasRegex;
}
function NS(r) {
  return me(this, "_erasNarrowRegex") || zh.call(this), r ? this._erasNarrowRegex : this._erasRegex;
}
function Wh(r, g) {
  return g.erasAbbrRegex(r);
}
function BS(r, g) {
  return g.erasNameRegex(r);
}
function jS(r, g) {
  return g.erasNarrowRegex(r);
}
function WS(r, g) {
  return g._eraYearOrdinalRegex || An;
}
function zh() {
  var r = [], g = [], E = [], a = [], y, R, I = this.eras();
  for (y = 0, R = I.length; y < R; ++y)
    g.push(yi(I[y].name)), r.push(yi(I[y].abbr)), E.push(yi(I[y].narrow)), a.push(yi(I[y].name)), a.push(yi(I[y].abbr)), a.push(yi(I[y].narrow));
  this._erasRegex = new RegExp("^(" + a.join("|") + ")", "i"), this._erasNameRegex = new RegExp("^(" + g.join("|") + ")", "i"), this._erasAbbrRegex = new RegExp("^(" + r.join("|") + ")", "i"), this._erasNarrowRegex = new RegExp(
    "^(" + E.join("|") + ")",
    "i"
  );
}
Zt(0, ["gg", 2], 0, function() {
  return this.weekYear() % 100;
});
Zt(0, ["GG", 2], 0, function() {
  return this.isoWeekYear() % 100;
});
function Rs(r, g) {
  Zt(0, [r, r.length], 0, g);
}
Rs("gggg", "weekYear");
Rs("ggggg", "weekYear");
Rs("GGGG", "isoWeekYear");
Rs("GGGGG", "isoWeekYear");
qe("weekYear", "gg");
qe("isoWeekYear", "GG");
Qe("weekYear", 1);
Qe("isoWeekYear", 1);
Ut("G", Os);
Ut("g", Os);
Ut("GG", Pe, vi);
Ut("gg", Pe, vi);
Ut("GGGG", Eh, Ph);
Ut("gggg", Eh, Ph);
Ut("GGGGG", Es, Ts);
Ut("ggggg", Es, Ts);
ao(
  ["gggg", "ggggg", "GGGG", "GGGGG"],
  function(r, g, E, a) {
    g[a.substr(0, 2)] = he(r);
  }
);
ao(["gg", "GG"], function(r, g, E, a) {
  g[a] = Xt.parseTwoDigitYear(r);
});
function zS(r) {
  return Eu.call(
    this,
    r,
    this.week(),
    this.weekday(),
    this.localeData()._week.dow,
    this.localeData()._week.doy
  );
}
function YS(r) {
  return Eu.call(
    this,
    r,
    this.isoWeek(),
    this.isoWeekday(),
    1,
    4
  );
}
function XS() {
  return pr(this.year(), 1, 4);
}
function GS() {
  return pr(this.isoWeekYear(), 1, 4);
}
function HS() {
  var r = this.localeData()._week;
  return pr(this.year(), r.dow, r.doy);
}
function US() {
  var r = this.localeData()._week;
  return pr(this.weekYear(), r.dow, r.doy);
}
function Eu(r, g, E, a, y) {
  var R;
  return r == null ? eo(this, a, y).year : (R = pr(r, a, y), g > R && (g = R), FS.call(this, r, g, E, a, y));
}
function FS(r, g, E, a, y) {
  var R = hu(r, g, E, a, y), I = to(R.year, 0, R.dayOfYear);
  return this.year(I.getUTCFullYear()), this.month(I.getUTCMonth()), this.date(I.getUTCDate()), this;
}
Zt("Q", 0, "Qo", "quarter");
qe("quarter", "Q");
Qe("quarter", 7);
Ut("Q", qp);
we("Q", function(r, g) {
  g[lr] = (he(r) - 1) * 3;
});
function VS(r) {
  return r == null ? Math.ceil((this.month() + 1) / 3) : this.month((r - 1) * 3 + this.month() % 3);
}
Zt("D", ["DD", 2], "Do", "date");
qe("date", "D");
Qe("date", 9);
Ut("D", Pe);
Ut("DD", Pe, vi);
Ut("Do", function(r, g) {
  return r ? g._dayOfMonthOrdinalParse || g._ordinalParse : g._dayOfMonthOrdinalParseLenient;
});
we(["D", "DD"], Hi);
we("Do", function(r, g) {
  g[Hi] = he(r.match(Pe)[0]);
});
var Ou = kn("Date", !0);
Zt("DDD", ["DDDD", 3], "DDDo", "dayOfYear");
qe("dayOfYear", "DDD");
Qe("dayOfYear", 4);
Ut("DDD", Ps);
Ut("DDDD", Qp);
we(["DDD", "DDDD"], function(r, g, E) {
  E._dayOfYear = he(r);
});
function $S(r) {
  var g = Math.round(
    (this.clone().startOf("day") - this.clone().startOf("year")) / 864e5
  ) + 1;
  return r == null ? g : this.add(r - g, "d");
}
Zt("m", ["mm", 2], 0, "minute");
qe("minute", "m");
Qe("minute", 14);
Ut("m", Pe);
Ut("mm", Pe, vi);
we(["m", "mm"], Ri);
var ZS = kn("Minutes", !1);
Zt("s", ["ss", 2], 0, "second");
qe("second", "s");
Qe("second", 15);
Ut("s", Pe);
Ut("ss", Pe, vi);
we(["s", "ss"], cr);
var KS = kn("Seconds", !1);
Zt("S", 0, 0, function() {
  return ~~(this.millisecond() / 100);
});
Zt(0, ["SS", 2], 0, function() {
  return ~~(this.millisecond() / 10);
});
Zt(0, ["SSS", 3], 0, "millisecond");
Zt(0, ["SSSS", 4], 0, function() {
  return this.millisecond() * 10;
});
Zt(0, ["SSSSS", 5], 0, function() {
  return this.millisecond() * 100;
});
Zt(0, ["SSSSSS", 6], 0, function() {
  return this.millisecond() * 1e3;
});
Zt(0, ["SSSSSSS", 7], 0, function() {
  return this.millisecond() * 1e4;
});
Zt(0, ["SSSSSSSS", 8], 0, function() {
  return this.millisecond() * 1e5;
});
Zt(0, ["SSSSSSSSS", 9], 0, function() {
  return this.millisecond() * 1e6;
});
qe("millisecond", "ms");
Qe("millisecond", 16);
Ut("S", Ps, qp);
Ut("SS", Ps, vi);
Ut("SSS", Ps, Qp);
var Pr, Lu;
for (Pr = "SSSS"; Pr.length <= 9; Pr += "S")
  Ut(Pr, An);
function JS(r, g) {
  g[Fr] = he(("0." + r) * 1e3);
}
for (Pr = "S"; Pr.length <= 9; Pr += "S")
  we(Pr, JS);
Lu = kn("Milliseconds", !1);
Zt("z", 0, 0, "zoneAbbr");
Zt("zz", 0, 0, "zoneName");
function qS() {
  return this._isUTC ? "UTC" : "";
}
function QS() {
  return this._isUTC ? "Coordinated Universal Time" : "";
}
var jt = oo.prototype;
jt.add = Ub;
jt.calendar = qb;
jt.clone = Qb;
jt.diff = sS;
jt.endOf = mS;
jt.format = cS;
jt.from = pS;
jt.fromNow = uS;
jt.to = dS;
jt.toNow = fS;
jt.get = e1;
jt.invalidAt = kS;
jt.isAfter = tS;
jt.isBefore = eS;
jt.isBetween = iS;
jt.isSame = rS;
jt.isSameOrAfter = nS;
jt.isSameOrBefore = oS;
jt.isValid = MS;
jt.lang = Cu;
jt.locale = Mu;
jt.localeData = ku;
jt.max = Mb;
jt.min = wb;
jt.parsingFlags = CS;
jt.set = i1;
jt.startOf = gS;
jt.subtract = Fb;
jt.toArray = bS;
jt.toObject = SS;
jt.toDate = xS;
jt.toISOString = hS;
jt.inspect = lS;
typeof Symbol < "u" && Symbol.for != null && (jt[Symbol.for("nodejs.util.inspect.custom")] = function() {
  return "Moment<" + this.format() + ">";
});
jt.toJSON = wS;
jt.toString = aS;
jt.unix = vS;
jt.valueOf = yS;
jt.creationData = AS;
jt.eraName = OS;
jt.eraNarrow = LS;
jt.eraAbbr = _S;
jt.eraYear = DS;
jt.year = au;
jt.isLeapYear = S1;
jt.weekYear = zS;
jt.isoWeekYear = YS;
jt.quarter = jt.quarters = VS;
jt.month = ou;
jt.daysInMonth = v1;
jt.week = jt.weeks = T1;
jt.isoWeek = jt.isoWeeks = P1;
jt.weeksInYear = HS;
jt.weeksInWeekYear = US;
jt.isoWeeksInYear = XS;
jt.isoWeeksInISOWeekYear = GS;
jt.date = Ou;
jt.day = jt.days = Y1;
jt.weekday = X1;
jt.isoWeekday = G1;
jt.dayOfYear = $S;
jt.hour = jt.hours = K1;
jt.minute = jt.minutes = ZS;
jt.second = jt.seconds = KS;
jt.millisecond = jt.milliseconds = Lu;
jt.utcOffset = _b;
jt.utc = Ib;
jt.local = Rb;
jt.parseZone = Nb;
jt.hasAlignedHourOffset = Bb;
jt.isDST = jb;
jt.isLocal = zb;
jt.isUtcOffset = Yb;
jt.isUtc = xu;
jt.isUTC = xu;
jt.zoneAbbr = qS;
jt.zoneName = QS;
jt.dates = Ei(
  "dates accessor is deprecated. Use date instead.",
  Ou
);
jt.months = Ei(
  "months accessor is deprecated. Use month instead",
  ou
);
jt.years = Ei(
  "years accessor is deprecated. Use year instead",
  au
);
jt.zone = Ei(
  "moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",
  Db
);
jt.isDSTShifted = Ei(
  "isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",
  Wb
);
function tw(r) {
  return Te(r * 1e3);
}
function ew() {
  return Te.apply(null, arguments).parseZone();
}
function _u(r) {
  return r;
}
var ye = kh.prototype;
ye.calendar = Y0;
ye.longDateFormat = U0;
ye.invalidDate = V0;
ye.ordinal = K0;
ye.preparse = _u;
ye.postformat = _u;
ye.relativeTime = q0;
ye.pastFuture = Q0;
ye.set = W0;
ye.eras = TS;
ye.erasParse = PS;
ye.erasConvertYear = ES;
ye.erasAbbrRegex = RS;
ye.erasNameRegex = IS;
ye.erasNarrowRegex = NS;
ye.months = f1;
ye.monthsShort = g1;
ye.monthsParse = y1;
ye.monthsRegex = b1;
ye.monthsShortRegex = x1;
ye.week = M1;
ye.firstDayOfYear = A1;
ye.firstDayOfWeek = k1;
ye.weekdays = N1;
ye.weekdaysMin = j1;
ye.weekdaysShort = B1;
ye.weekdaysParse = z1;
ye.weekdaysRegex = H1;
ye.weekdaysShortRegex = U1;
ye.weekdaysMinRegex = F1;
ye.isPM = $1;
ye.meridiem = J1;
function bs(r, g, E, a) {
  var y = fr(), R = $i().set(a, g);
  return y[E](R, r);
}
function Du(r, g, E) {
  if (dr(r) && (g = r, r = void 0), r = r || "", g != null)
    return bs(r, g, E, "month");
  var a, y = [];
  for (a = 0; a < 12; a++)
    y[a] = bs(r, a, E, "month");
  return y;
}
function Yh(r, g, E, a) {
  typeof r == "boolean" ? (dr(g) && (E = g, g = void 0), g = g || "") : (g = r, E = g, r = !1, dr(g) && (E = g, g = void 0), g = g || "");
  var y = fr(), R = r ? y._week.dow : 0, I, Z = [];
  if (E != null)
    return bs(g, (E + R) % 7, a, "day");
  for (I = 0; I < 7; I++)
    Z[I] = bs(g, (I + R) % 7, a, "day");
  return Z;
}
function iw(r, g) {
  return Du(r, g, "months");
}
function rw(r, g) {
  return Du(r, g, "monthsShort");
}
function nw(r, g, E) {
  return Yh(r, g, E, "weekdays");
}
function ow(r, g, E) {
  return Yh(r, g, E, "weekdaysShort");
}
function sw(r, g, E) {
  return Yh(r, g, E, "weekdaysMin");
}
Er("en", {
  eras: [
    {
      since: "0001-01-01",
      until: 1 / 0,
      offset: 1,
      name: "Anno Domini",
      narrow: "AD",
      abbr: "AD"
    },
    {
      since: "0000-12-31",
      until: -1 / 0,
      offset: 1,
      name: "Before Christ",
      narrow: "BC",
      abbr: "BC"
    }
  ],
  dayOfMonthOrdinalParse: /\d{1,2}(th|st|nd|rd)/,
  ordinal: function(r) {
    var g = r % 10, E = he(r % 100 / 10) === 1 ? "th" : g === 1 ? "st" : g === 2 ? "nd" : g === 3 ? "rd" : "th";
    return r + E;
  }
});
Xt.lang = Ei(
  "moment.lang is deprecated. Use moment.locale instead.",
  Er
);
Xt.langData = Ei(
  "moment.langData is deprecated. Use moment.localeData instead.",
  fr
);
var sr = Math.abs;
function aw() {
  var r = this._data;
  return this._milliseconds = sr(this._milliseconds), this._days = sr(this._days), this._months = sr(this._months), r.milliseconds = sr(r.milliseconds), r.seconds = sr(r.seconds), r.minutes = sr(r.minutes), r.hours = sr(r.hours), r.months = sr(r.months), r.years = sr(r.years), this;
}
function Iu(r, g, E, a) {
  var y = Wi(g, E);
  return r._milliseconds += a * y._milliseconds, r._days += a * y._days, r._months += a * y._months, r._bubble();
}
function hw(r, g) {
  return Iu(this, r, g, 1);
}
function lw(r, g) {
  return Iu(this, r, g, -1);
}
function kp(r) {
  return r < 0 ? Math.floor(r) : Math.ceil(r);
}
function cw() {
  var r = this._milliseconds, g = this._days, E = this._months, a = this._data, y, R, I, Z, H;
  return r >= 0 && g >= 0 && E >= 0 || r <= 0 && g <= 0 && E <= 0 || (r += kp(yh(E) + g) * 864e5, g = 0, E = 0), a.milliseconds = r % 1e3, y = Ti(r / 1e3), a.seconds = y % 60, R = Ti(y / 60), a.minutes = R % 60, I = Ti(R / 60), a.hours = I % 24, g += Ti(I / 24), H = Ti(Ru(g)), E += H, g -= kp(yh(H)), Z = Ti(E / 12), E %= 12, a.days = g, a.months = E, a.years = Z, this;
}
function Ru(r) {
  return r * 4800 / 146097;
}
function yh(r) {
  return r * 146097 / 4800;
}
function pw(r) {
  if (!this.isValid())
    return NaN;
  var g, E, a = this._milliseconds;
  if (r = Oi(r), r === "month" || r === "quarter" || r === "year")
    switch (g = this._days + a / 864e5, E = this._months + Ru(g), r) {
      case "month":
        return E;
      case "quarter":
        return E / 3;
      case "year":
        return E / 12;
    }
  else
    switch (g = this._days + Math.round(yh(this._months)), r) {
      case "week":
        return g / 7 + a / 6048e5;
      case "day":
        return g + a / 864e5;
      case "hour":
        return g * 24 + a / 36e5;
      case "minute":
        return g * 1440 + a / 6e4;
      case "second":
        return g * 86400 + a / 1e3;
      case "millisecond":
        return Math.floor(g * 864e5) + a;
      default:
        throw new Error("Unknown unit " + r);
    }
}
function uw() {
  return this.isValid() ? this._milliseconds + this._days * 864e5 + this._months % 12 * 2592e6 + he(this._months / 12) * 31536e6 : NaN;
}
function gr(r) {
  return function() {
    return this.as(r);
  };
}
var dw = gr("ms"), fw = gr("s"), gw = gr("m"), mw = gr("h"), yw = gr("d"), vw = gr("w"), xw = gr("M"), bw = gr("Q"), Sw = gr("y");
function ww() {
  return Wi(this);
}
function Mw(r) {
  return r = Oi(r), this.isValid() ? this[r + "s"]() : NaN;
}
function $r(r) {
  return function() {
    return this.isValid() ? this._data[r] : NaN;
  };
}
var Cw = $r("milliseconds"), kw = $r("seconds"), Aw = $r("minutes"), Tw = $r("hours"), Pw = $r("days"), Ew = $r("months"), Ow = $r("years");
function Lw() {
  return Ti(this.days() / 7);
}
var ar = Math.round, fn = {
  ss: 44,
  // a few seconds to seconds
  s: 45,
  // seconds to minute
  m: 45,
  // minutes to hour
  h: 22,
  // hours to day
  d: 26,
  // days to month/week
  w: null,
  // weeks to month
  M: 11
  // months to year
};
function _w(r, g, E, a, y) {
  return y.relativeTime(g || 1, !!E, r, a);
}
function Dw(r, g, E, a) {
  var y = Wi(r).abs(), R = ar(y.as("s")), I = ar(y.as("m")), Z = ar(y.as("h")), H = ar(y.as("d")), $ = ar(y.as("M")), U = ar(y.as("w")), W = ar(y.as("y")), N = R <= E.ss && ["s", R] || R < E.s && ["ss", R] || I <= 1 && ["m"] || I < E.m && ["mm", I] || Z <= 1 && ["h"] || Z < E.h && ["hh", Z] || H <= 1 && ["d"] || H < E.d && ["dd", H];
  return E.w != null && (N = N || U <= 1 && ["w"] || U < E.w && ["ww", U]), N = N || $ <= 1 && ["M"] || $ < E.M && ["MM", $] || W <= 1 && ["y"] || ["yy", W], N[2] = g, N[3] = +r > 0, N[4] = a, _w.apply(null, N);
}
function Iw(r) {
  return r === void 0 ? ar : typeof r == "function" ? (ar = r, !0) : !1;
}
function Rw(r, g) {
  return fn[r] === void 0 ? !1 : g === void 0 ? fn[r] : (fn[r] = g, r === "s" && (fn.ss = g - 1), !0);
}
function Nw(r, g) {
  if (!this.isValid())
    return this.localeData().invalidDate();
  var E = !1, a = fn, y, R;
  return typeof r == "object" && (g = r, r = !1), typeof r == "boolean" && (E = r), typeof g == "object" && (a = Object.assign({}, fn, g), g.s != null && g.ss == null && (a.ss = g.s - 1)), y = this.localeData(), R = Dw(this, !E, a, y), E && (R = y.pastFuture(+this, R)), y.postformat(R);
}
var rh = Math.abs;
function un(r) {
  return (r > 0) - (r < 0) || +r;
}
function Ns() {
  if (!this.isValid())
    return this.localeData().invalidDate();
  var r = rh(this._milliseconds) / 1e3, g = rh(this._days), E = rh(this._months), a, y, R, I, Z = this.asSeconds(), H, $, U, W;
  return Z ? (a = Ti(r / 60), y = Ti(a / 60), r %= 60, a %= 60, R = Ti(E / 12), E %= 12, I = r ? r.toFixed(3).replace(/\.?0+$/, "") : "", H = Z < 0 ? "-" : "", $ = un(this._months) !== un(Z) ? "-" : "", U = un(this._days) !== un(Z) ? "-" : "", W = un(this._milliseconds) !== un(Z) ? "-" : "", H + "P" + (R ? $ + R + "Y" : "") + (E ? $ + E + "M" : "") + (g ? U + g + "D" : "") + (y || a || r ? "T" : "") + (y ? W + y + "H" : "") + (a ? W + a + "M" : "") + (r ? W + I + "S" : "")) : "P0D";
}
var de = Is.prototype;
de.isValid = Pb;
de.abs = aw;
de.add = hw;
de.subtract = lw;
de.as = pw;
de.asMilliseconds = dw;
de.asSeconds = fw;
de.asMinutes = gw;
de.asHours = mw;
de.asDays = yw;
de.asWeeks = vw;
de.asMonths = xw;
de.asQuarters = bw;
de.asYears = Sw;
de.valueOf = uw;
de._bubble = cw;
de.clone = ww;
de.get = Mw;
de.milliseconds = Cw;
de.seconds = kw;
de.minutes = Aw;
de.hours = Tw;
de.days = Pw;
de.weeks = Lw;
de.months = Ew;
de.years = Ow;
de.humanize = Nw;
de.toISOString = Ns;
de.toString = Ns;
de.toJSON = Ns;
de.locale = Mu;
de.localeData = ku;
de.toIsoString = Ei(
  "toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",
  Ns
);
de.lang = Cu;
Zt("X", 0, 0, "unix");
Zt("x", 0, 0, "valueOf");
Ut("x", Os);
Ut("X", n1);
we("X", function(r, g, E) {
  E._d = new Date(parseFloat(r) * 1e3);
});
we("x", function(r, g, E) {
  E._d = new Date(he(r));
});
//! moment.js
Xt.version = "2.29.4";
B0(Te);
Xt.fn = jt;
Xt.min = Cb;
Xt.max = kb;
Xt.now = Ab;
Xt.utc = $i;
Xt.unix = tw;
Xt.months = iw;
Xt.isDate = no;
Xt.locale = Er;
Xt.invalid = ks;
Xt.duration = Wi;
Xt.isMoment = ji;
Xt.weekdays = nw;
Xt.parseZone = ew;
Xt.localeData = fr;
Xt.isDuration = as;
Xt.monthsShort = rw;
Xt.weekdaysMin = sw;
Xt.defineLocale = Dh;
Xt.updateLocale = eb;
Xt.locales = ib;
Xt.weekdaysShort = ow;
Xt.normalizeUnits = Oi;
Xt.relativeTimeRounding = Iw;
Xt.relativeTimeThreshold = Rw;
Xt.calendarFormat = Jb;
Xt.prototype = jt;
Xt.HTML5_FMT = {
  DATETIME_LOCAL: "YYYY-MM-DDTHH:mm",
  // <input type="datetime-local" />
  DATETIME_LOCAL_SECONDS: "YYYY-MM-DDTHH:mm:ss",
  // <input type="datetime-local" step="1" />
  DATETIME_LOCAL_MS: "YYYY-MM-DDTHH:mm:ss.SSS",
  // <input type="datetime-local" step="0.001" />
  DATE: "YYYY-MM-DD",
  // <input type="date" />
  TIME: "HH:mm",
  // <input type="time" />
  TIME_SECONDS: "HH:mm:ss",
  // <input type="time" step="1" />
  TIME_MS: "HH:mm:ss.SSS",
  // <input type="time" step="0.001" />
  WEEK: "GGGG-[W]WW",
  // <input type="week" />
  MONTH: "YYYY-MM"
  // <input type="month" />
};
var Ss = { exports: {} };
/**
 * @license
 * Lodash <https://lodash.com/>
 * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */
Ss.exports;
(function(r, g) {
  (function() {
    var E, a = "4.17.21", y = 200, R = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", I = "Expected a function", Z = "Invalid `variable` option passed into `_.template`", H = "__lodash_hash_undefined__", $ = 500, U = "__lodash_placeholder__", W = 1, N = 2, M = 4, v = 1, u = 2, d = 1, P = 2, O = 4, B = 8, C = 16, b = 32, w = 64, x = 128, h = 256, c = 512, p = 30, i = "...", l = 800, s = 16, t = 1, n = 2, o = 3, A = 1 / 0, _ = 9007199254740991, D = 17976931348623157e292, j = 0 / 0, T = 4294967295, X = T - 1, f = T >>> 1, m = [
      ["ary", x],
      ["bind", d],
      ["bindKey", P],
      ["curry", B],
      ["curryRight", C],
      ["flip", c],
      ["partial", b],
      ["partialRight", w],
      ["rearg", h]
    ], L = "[object Arguments]", Y = "[object Array]", F = "[object AsyncFunction]", Q = "[object Boolean]", k = "[object Date]", G = "[object DOMException]", z = "[object Error]", V = "[object Function]", q = "[object GeneratorFunction]", it = "[object Map]", et = "[object Number]", nt = "[object Null]", rt = "[object Object]", ct = "[object Promise]", gt = "[object Proxy]", dt = "[object RegExp]", lt = "[object Set]", at = "[object String]", J = "[object Symbol]", tt = "[object Undefined]", st = "[object WeakMap]", ht = "[object WeakSet]", pt = "[object ArrayBuffer]", yt = "[object DataView]", vt = "[object Float32Array]", Ct = "[object Float64Array]", Tt = "[object Int8Array]", kt = "[object Int16Array]", St = "[object Int32Array]", _t = "[object Uint8Array]", Lt = "[object Uint8ClampedArray]", Nt = "[object Uint16Array]", Et = "[object Uint32Array]", Kt = /\b__p \+= '';/g, Gt = /\b(__p \+=) '' \+/g, Wt = /(__e\(.*?\)|\b__t\)) \+\n'';/g, Jt = /&(?:amp|lt|gt|quot|#39);/g, be = /[&<>"']/g, zt = RegExp(Jt.source), Vt = RegExp(be.source), Me = /<%-([\s\S]+?)%>/g, Lr = /<%([\s\S]+?)%>/g, co = /<%=([\s\S]+?)%>/g, Pn = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, En = /^\w*$/, $e = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, On = /[\\^$.*+?()[\]{}|]/g, Ln = RegExp(On.source), Zr = /^\s+/, po = /\s/, Xs = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, _r = /\{\n\/\* \[wrapped with (.+)\] \*/, zi = /,? & /, uo = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, _n = /[()=,{}\[\]\/\s]/, Dr = /\\(\\)?/g, $t = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, ue = /\w*$/, ge = /^[-+]0x[0-9a-f]+$/i, De = /^0b[01]+$/i, Le = /^\[object .+?Constructor\]$/, Kr = /^0o[0-7]+$/i, ud = /^(?:0|[1-9]\d*)$/, dd = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, fo = /($^)/, fd = /['\n\r\u2028\u2029\\]/g, go = "\\ud800-\\udfff", gd = "\\u0300-\\u036f", md = "\\ufe20-\\ufe2f", yd = "\\u20d0-\\u20ff", Zh = gd + md + yd, Kh = "\\u2700-\\u27bf", Jh = "a-z\\xdf-\\xf6\\xf8-\\xff", vd = "\\xac\\xb1\\xd7\\xf7", xd = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", bd = "\\u2000-\\u206f", Sd = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", qh = "A-Z\\xc0-\\xd6\\xd8-\\xde", Qh = "\\ufe0e\\ufe0f", tl = vd + xd + bd + Sd, Gs = "['’]", wd = "[" + go + "]", el = "[" + tl + "]", mo = "[" + Zh + "]", il = "\\d+", Md = "[" + Kh + "]", rl = "[" + Jh + "]", nl = "[^" + go + tl + il + Kh + Jh + qh + "]", Hs = "\\ud83c[\\udffb-\\udfff]", Cd = "(?:" + mo + "|" + Hs + ")", ol = "[^" + go + "]", Us = "(?:\\ud83c[\\udde6-\\uddff]){2}", Fs = "[\\ud800-\\udbff][\\udc00-\\udfff]", Jr = "[" + qh + "]", sl = "\\u200d", al = "(?:" + rl + "|" + nl + ")", kd = "(?:" + Jr + "|" + nl + ")", hl = "(?:" + Gs + "(?:d|ll|m|re|s|t|ve))?", ll = "(?:" + Gs + "(?:D|LL|M|RE|S|T|VE))?", cl = Cd + "?", pl = "[" + Qh + "]?", Ad = "(?:" + sl + "(?:" + [ol, Us, Fs].join("|") + ")" + pl + cl + ")*", Td = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", Pd = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", ul = pl + cl + Ad, Ed = "(?:" + [Md, Us, Fs].join("|") + ")" + ul, Od = "(?:" + [ol + mo + "?", mo, Us, Fs, wd].join("|") + ")", Ld = RegExp(Gs, "g"), _d = RegExp(mo, "g"), Vs = RegExp(Hs + "(?=" + Hs + ")|" + Od + ul, "g"), Dd = RegExp([
      Jr + "?" + rl + "+" + hl + "(?=" + [el, Jr, "$"].join("|") + ")",
      kd + "+" + ll + "(?=" + [el, Jr + al, "$"].join("|") + ")",
      Jr + "?" + al + "+" + hl,
      Jr + "+" + ll,
      Pd,
      Td,
      il,
      Ed
    ].join("|"), "g"), Id = RegExp("[" + sl + go + Zh + Qh + "]"), Rd = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, Nd = [
      "Array",
      "Buffer",
      "DataView",
      "Date",
      "Error",
      "Float32Array",
      "Float64Array",
      "Function",
      "Int8Array",
      "Int16Array",
      "Int32Array",
      "Map",
      "Math",
      "Object",
      "Promise",
      "RegExp",
      "Set",
      "String",
      "Symbol",
      "TypeError",
      "Uint8Array",
      "Uint8ClampedArray",
      "Uint16Array",
      "Uint32Array",
      "WeakMap",
      "_",
      "clearTimeout",
      "isFinite",
      "parseInt",
      "setTimeout"
    ], Bd = -1, Ae = {};
    Ae[vt] = Ae[Ct] = Ae[Tt] = Ae[kt] = Ae[St] = Ae[_t] = Ae[Lt] = Ae[Nt] = Ae[Et] = !0, Ae[L] = Ae[Y] = Ae[pt] = Ae[Q] = Ae[yt] = Ae[k] = Ae[z] = Ae[V] = Ae[it] = Ae[et] = Ae[rt] = Ae[dt] = Ae[lt] = Ae[at] = Ae[st] = !1;
    var ke = {};
    ke[L] = ke[Y] = ke[pt] = ke[yt] = ke[Q] = ke[k] = ke[vt] = ke[Ct] = ke[Tt] = ke[kt] = ke[St] = ke[it] = ke[et] = ke[rt] = ke[dt] = ke[lt] = ke[at] = ke[J] = ke[_t] = ke[Lt] = ke[Nt] = ke[Et] = !0, ke[z] = ke[V] = ke[st] = !1;
    var jd = {
      // Latin-1 Supplement block.
      À: "A",
      Á: "A",
      Â: "A",
      Ã: "A",
      Ä: "A",
      Å: "A",
      à: "a",
      á: "a",
      â: "a",
      ã: "a",
      ä: "a",
      å: "a",
      Ç: "C",
      ç: "c",
      Ð: "D",
      ð: "d",
      È: "E",
      É: "E",
      Ê: "E",
      Ë: "E",
      è: "e",
      é: "e",
      ê: "e",
      ë: "e",
      Ì: "I",
      Í: "I",
      Î: "I",
      Ï: "I",
      ì: "i",
      í: "i",
      î: "i",
      ï: "i",
      Ñ: "N",
      ñ: "n",
      Ò: "O",
      Ó: "O",
      Ô: "O",
      Õ: "O",
      Ö: "O",
      Ø: "O",
      ò: "o",
      ó: "o",
      ô: "o",
      õ: "o",
      ö: "o",
      ø: "o",
      Ù: "U",
      Ú: "U",
      Û: "U",
      Ü: "U",
      ù: "u",
      ú: "u",
      û: "u",
      ü: "u",
      Ý: "Y",
      ý: "y",
      ÿ: "y",
      Æ: "Ae",
      æ: "ae",
      Þ: "Th",
      þ: "th",
      ß: "ss",
      // Latin Extended-A block.
      Ā: "A",
      Ă: "A",
      Ą: "A",
      ā: "a",
      ă: "a",
      ą: "a",
      Ć: "C",
      Ĉ: "C",
      Ċ: "C",
      Č: "C",
      ć: "c",
      ĉ: "c",
      ċ: "c",
      č: "c",
      Ď: "D",
      Đ: "D",
      ď: "d",
      đ: "d",
      Ē: "E",
      Ĕ: "E",
      Ė: "E",
      Ę: "E",
      Ě: "E",
      ē: "e",
      ĕ: "e",
      ė: "e",
      ę: "e",
      ě: "e",
      Ĝ: "G",
      Ğ: "G",
      Ġ: "G",
      Ģ: "G",
      ĝ: "g",
      ğ: "g",
      ġ: "g",
      ģ: "g",
      Ĥ: "H",
      Ħ: "H",
      ĥ: "h",
      ħ: "h",
      Ĩ: "I",
      Ī: "I",
      Ĭ: "I",
      Į: "I",
      İ: "I",
      ĩ: "i",
      ī: "i",
      ĭ: "i",
      į: "i",
      ı: "i",
      Ĵ: "J",
      ĵ: "j",
      Ķ: "K",
      ķ: "k",
      ĸ: "k",
      Ĺ: "L",
      Ļ: "L",
      Ľ: "L",
      Ŀ: "L",
      Ł: "L",
      ĺ: "l",
      ļ: "l",
      ľ: "l",
      ŀ: "l",
      ł: "l",
      Ń: "N",
      Ņ: "N",
      Ň: "N",
      Ŋ: "N",
      ń: "n",
      ņ: "n",
      ň: "n",
      ŋ: "n",
      Ō: "O",
      Ŏ: "O",
      Ő: "O",
      ō: "o",
      ŏ: "o",
      ő: "o",
      Ŕ: "R",
      Ŗ: "R",
      Ř: "R",
      ŕ: "r",
      ŗ: "r",
      ř: "r",
      Ś: "S",
      Ŝ: "S",
      Ş: "S",
      Š: "S",
      ś: "s",
      ŝ: "s",
      ş: "s",
      š: "s",
      Ţ: "T",
      Ť: "T",
      Ŧ: "T",
      ţ: "t",
      ť: "t",
      ŧ: "t",
      Ũ: "U",
      Ū: "U",
      Ŭ: "U",
      Ů: "U",
      Ű: "U",
      Ų: "U",
      ũ: "u",
      ū: "u",
      ŭ: "u",
      ů: "u",
      ű: "u",
      ų: "u",
      Ŵ: "W",
      ŵ: "w",
      Ŷ: "Y",
      ŷ: "y",
      Ÿ: "Y",
      Ź: "Z",
      Ż: "Z",
      Ž: "Z",
      ź: "z",
      ż: "z",
      ž: "z",
      Ĳ: "IJ",
      ĳ: "ij",
      Œ: "Oe",
      œ: "oe",
      ŉ: "'n",
      ſ: "s"
    }, Wd = {
      "&": "&amp;",
      "<": "&lt;",
      ">": "&gt;",
      '"': "&quot;",
      "'": "&#39;"
    }, zd = {
      "&amp;": "&",
      "&lt;": "<",
      "&gt;": ">",
      "&quot;": '"',
      "&#39;": "'"
    }, Yd = {
      "\\": "\\",
      "'": "'",
      "\n": "n",
      "\r": "r",
      "\u2028": "u2028",
      "\u2029": "u2029"
    }, Xd = parseFloat, Gd = parseInt, dl = typeof Hr == "object" && Hr && Hr.Object === Object && Hr, Hd = typeof self == "object" && self && self.Object === Object && self, Fe = dl || Hd || Function("return this")(), $s = g && !g.nodeType && g, Ir = $s && !0 && r && !r.nodeType && r, fl = Ir && Ir.exports === $s, Zs = fl && dl.process, xi = function() {
      try {
        var wt = Ir && Ir.require && Ir.require("util").types;
        return wt || Zs && Zs.binding && Zs.binding("util");
      } catch {
      }
    }(), gl = xi && xi.isArrayBuffer, ml = xi && xi.isDate, yl = xi && xi.isMap, vl = xi && xi.isRegExp, xl = xi && xi.isSet, bl = xi && xi.isTypedArray;
    function pi(wt, Ot, At) {
      switch (At.length) {
        case 0:
          return wt.call(Ot);
        case 1:
          return wt.call(Ot, At[0]);
        case 2:
          return wt.call(Ot, At[0], At[1]);
        case 3:
          return wt.call(Ot, At[0], At[1], At[2]);
      }
      return wt.apply(Ot, At);
    }
    function Ud(wt, Ot, At, Ht) {
      for (var ie = -1, ve = wt == null ? 0 : wt.length; ++ie < ve; ) {
        var ze = wt[ie];
        Ot(Ht, ze, At(ze), wt);
      }
      return Ht;
    }
    function bi(wt, Ot) {
      for (var At = -1, Ht = wt == null ? 0 : wt.length; ++At < Ht && Ot(wt[At], At, wt) !== !1; )
        ;
      return wt;
    }
    function Fd(wt, Ot) {
      for (var At = wt == null ? 0 : wt.length; At-- && Ot(wt[At], At, wt) !== !1; )
        ;
      return wt;
    }
    function Sl(wt, Ot) {
      for (var At = -1, Ht = wt == null ? 0 : wt.length; ++At < Ht; )
        if (!Ot(wt[At], At, wt))
          return !1;
      return !0;
    }
    function mr(wt, Ot) {
      for (var At = -1, Ht = wt == null ? 0 : wt.length, ie = 0, ve = []; ++At < Ht; ) {
        var ze = wt[At];
        Ot(ze, At, wt) && (ve[ie++] = ze);
      }
      return ve;
    }
    function yo(wt, Ot) {
      var At = wt == null ? 0 : wt.length;
      return !!At && qr(wt, Ot, 0) > -1;
    }
    function Ks(wt, Ot, At) {
      for (var Ht = -1, ie = wt == null ? 0 : wt.length; ++Ht < ie; )
        if (At(Ot, wt[Ht]))
          return !0;
      return !1;
    }
    function Ee(wt, Ot) {
      for (var At = -1, Ht = wt == null ? 0 : wt.length, ie = Array(Ht); ++At < Ht; )
        ie[At] = Ot(wt[At], At, wt);
      return ie;
    }
    function yr(wt, Ot) {
      for (var At = -1, Ht = Ot.length, ie = wt.length; ++At < Ht; )
        wt[ie + At] = Ot[At];
      return wt;
    }
    function Js(wt, Ot, At, Ht) {
      var ie = -1, ve = wt == null ? 0 : wt.length;
      for (Ht && ve && (At = wt[++ie]); ++ie < ve; )
        At = Ot(At, wt[ie], ie, wt);
      return At;
    }
    function Vd(wt, Ot, At, Ht) {
      var ie = wt == null ? 0 : wt.length;
      for (Ht && ie && (At = wt[--ie]); ie--; )
        At = Ot(At, wt[ie], ie, wt);
      return At;
    }
    function qs(wt, Ot) {
      for (var At = -1, Ht = wt == null ? 0 : wt.length; ++At < Ht; )
        if (Ot(wt[At], At, wt))
          return !0;
      return !1;
    }
    var $d = Qs("length");
    function Zd(wt) {
      return wt.split("");
    }
    function Kd(wt) {
      return wt.match(uo) || [];
    }
    function wl(wt, Ot, At) {
      var Ht;
      return At(wt, function(ie, ve, ze) {
        if (Ot(ie, ve, ze))
          return Ht = ve, !1;
      }), Ht;
    }
    function vo(wt, Ot, At, Ht) {
      for (var ie = wt.length, ve = At + (Ht ? 1 : -1); Ht ? ve-- : ++ve < ie; )
        if (Ot(wt[ve], ve, wt))
          return ve;
      return -1;
    }
    function qr(wt, Ot, At) {
      return Ot === Ot ? lf(wt, Ot, At) : vo(wt, Ml, At);
    }
    function Jd(wt, Ot, At, Ht) {
      for (var ie = At - 1, ve = wt.length; ++ie < ve; )
        if (Ht(wt[ie], Ot))
          return ie;
      return -1;
    }
    function Ml(wt) {
      return wt !== wt;
    }
    function Cl(wt, Ot) {
      var At = wt == null ? 0 : wt.length;
      return At ? ea(wt, Ot) / At : j;
    }
    function Qs(wt) {
      return function(Ot) {
        return Ot == null ? E : Ot[wt];
      };
    }
    function ta(wt) {
      return function(Ot) {
        return wt == null ? E : wt[Ot];
      };
    }
    function kl(wt, Ot, At, Ht, ie) {
      return ie(wt, function(ve, ze, Ce) {
        At = Ht ? (Ht = !1, ve) : Ot(At, ve, ze, Ce);
      }), At;
    }
    function qd(wt, Ot) {
      var At = wt.length;
      for (wt.sort(Ot); At--; )
        wt[At] = wt[At].value;
      return wt;
    }
    function ea(wt, Ot) {
      for (var At, Ht = -1, ie = wt.length; ++Ht < ie; ) {
        var ve = Ot(wt[Ht]);
        ve !== E && (At = At === E ? ve : At + ve);
      }
      return At;
    }
    function ia(wt, Ot) {
      for (var At = -1, Ht = Array(wt); ++At < wt; )
        Ht[At] = Ot(At);
      return Ht;
    }
    function Qd(wt, Ot) {
      return Ee(Ot, function(At) {
        return [At, wt[At]];
      });
    }
    function Al(wt) {
      return wt && wt.slice(0, Ol(wt) + 1).replace(Zr, "");
    }
    function ui(wt) {
      return function(Ot) {
        return wt(Ot);
      };
    }
    function ra(wt, Ot) {
      return Ee(Ot, function(At) {
        return wt[At];
      });
    }
    function Dn(wt, Ot) {
      return wt.has(Ot);
    }
    function Tl(wt, Ot) {
      for (var At = -1, Ht = wt.length; ++At < Ht && qr(Ot, wt[At], 0) > -1; )
        ;
      return At;
    }
    function Pl(wt, Ot) {
      for (var At = wt.length; At-- && qr(Ot, wt[At], 0) > -1; )
        ;
      return At;
    }
    function tf(wt, Ot) {
      for (var At = wt.length, Ht = 0; At--; )
        wt[At] === Ot && ++Ht;
      return Ht;
    }
    var ef = ta(jd), rf = ta(Wd);
    function nf(wt) {
      return "\\" + Yd[wt];
    }
    function of(wt, Ot) {
      return wt == null ? E : wt[Ot];
    }
    function Qr(wt) {
      return Id.test(wt);
    }
    function sf(wt) {
      return Rd.test(wt);
    }
    function af(wt) {
      for (var Ot, At = []; !(Ot = wt.next()).done; )
        At.push(Ot.value);
      return At;
    }
    function na(wt) {
      var Ot = -1, At = Array(wt.size);
      return wt.forEach(function(Ht, ie) {
        At[++Ot] = [ie, Ht];
      }), At;
    }
    function El(wt, Ot) {
      return function(At) {
        return wt(Ot(At));
      };
    }
    function vr(wt, Ot) {
      for (var At = -1, Ht = wt.length, ie = 0, ve = []; ++At < Ht; ) {
        var ze = wt[At];
        (ze === Ot || ze === U) && (wt[At] = U, ve[ie++] = At);
      }
      return ve;
    }
    function xo(wt) {
      var Ot = -1, At = Array(wt.size);
      return wt.forEach(function(Ht) {
        At[++Ot] = Ht;
      }), At;
    }
    function hf(wt) {
      var Ot = -1, At = Array(wt.size);
      return wt.forEach(function(Ht) {
        At[++Ot] = [Ht, Ht];
      }), At;
    }
    function lf(wt, Ot, At) {
      for (var Ht = At - 1, ie = wt.length; ++Ht < ie; )
        if (wt[Ht] === Ot)
          return Ht;
      return -1;
    }
    function cf(wt, Ot, At) {
      for (var Ht = At + 1; Ht--; )
        if (wt[Ht] === Ot)
          return Ht;
      return Ht;
    }
    function tn(wt) {
      return Qr(wt) ? uf(wt) : $d(wt);
    }
    function Li(wt) {
      return Qr(wt) ? df(wt) : Zd(wt);
    }
    function Ol(wt) {
      for (var Ot = wt.length; Ot-- && po.test(wt.charAt(Ot)); )
        ;
      return Ot;
    }
    var pf = ta(zd);
    function uf(wt) {
      for (var Ot = Vs.lastIndex = 0; Vs.test(wt); )
        ++Ot;
      return Ot;
    }
    function df(wt) {
      return wt.match(Vs) || [];
    }
    function ff(wt) {
      return wt.match(Dd) || [];
    }
    var gf = function wt(Ot) {
      Ot = Ot == null ? Fe : en.defaults(Fe.Object(), Ot, en.pick(Fe, Nd));
      var At = Ot.Array, Ht = Ot.Date, ie = Ot.Error, ve = Ot.Function, ze = Ot.Math, Ce = Ot.Object, oa = Ot.RegExp, mf = Ot.String, Si = Ot.TypeError, bo = At.prototype, yf = ve.prototype, rn = Ce.prototype, So = Ot["__core-js_shared__"], wo = yf.toString, Se = rn.hasOwnProperty, vf = 0, Ll = function() {
        var e = /[^.]+$/.exec(So && So.keys && So.keys.IE_PROTO || "");
        return e ? "Symbol(src)_1." + e : "";
      }(), Mo = rn.toString, xf = wo.call(Ce), bf = Fe._, Sf = oa(
        "^" + wo.call(Se).replace(On, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
      ), Co = fl ? Ot.Buffer : E, xr = Ot.Symbol, ko = Ot.Uint8Array, _l = Co ? Co.allocUnsafe : E, Ao = El(Ce.getPrototypeOf, Ce), Dl = Ce.create, Il = rn.propertyIsEnumerable, To = bo.splice, Rl = xr ? xr.isConcatSpreadable : E, In = xr ? xr.iterator : E, Rr = xr ? xr.toStringTag : E, Po = function() {
        try {
          var e = zr(Ce, "defineProperty");
          return e({}, "", {}), e;
        } catch {
        }
      }(), wf = Ot.clearTimeout !== Fe.clearTimeout && Ot.clearTimeout, Mf = Ht && Ht.now !== Fe.Date.now && Ht.now, Cf = Ot.setTimeout !== Fe.setTimeout && Ot.setTimeout, Eo = ze.ceil, Oo = ze.floor, sa = Ce.getOwnPropertySymbols, kf = Co ? Co.isBuffer : E, Nl = Ot.isFinite, Af = bo.join, Tf = El(Ce.keys, Ce), Ye = ze.max, Ze = ze.min, Pf = Ht.now, Ef = Ot.parseInt, Bl = ze.random, Of = bo.reverse, aa = zr(Ot, "DataView"), Rn = zr(Ot, "Map"), ha = zr(Ot, "Promise"), nn = zr(Ot, "Set"), Nn = zr(Ot, "WeakMap"), Bn = zr(Ce, "create"), Lo = Nn && new Nn(), on = {}, Lf = Yr(aa), _f = Yr(Rn), Df = Yr(ha), If = Yr(nn), Rf = Yr(Nn), _o = xr ? xr.prototype : E, jn = _o ? _o.valueOf : E, jl = _o ? _o.toString : E;
      function ft(e) {
        if (Ie(e) && !re(e) && !(e instanceof ce)) {
          if (e instanceof wi)
            return e;
          if (Se.call(e, "__wrapped__"))
            return Wc(e);
        }
        return new wi(e);
      }
      var sn = function() {
        function e() {
        }
        return function(S) {
          if (!_e(S))
            return {};
          if (Dl)
            return Dl(S);
          e.prototype = S;
          var K = new e();
          return e.prototype = E, K;
        };
      }();
      function Do() {
      }
      function wi(e, S) {
        this.__wrapped__ = e, this.__actions__ = [], this.__chain__ = !!S, this.__index__ = 0, this.__values__ = E;
      }
      ft.templateSettings = {
        /**
         * Used to detect `data` property values to be HTML-escaped.
         *
         * @memberOf _.templateSettings
         * @type {RegExp}
         */
        escape: Me,
        /**
         * Used to detect code to be evaluated.
         *
         * @memberOf _.templateSettings
         * @type {RegExp}
         */
        evaluate: Lr,
        /**
         * Used to detect `data` property values to inject.
         *
         * @memberOf _.templateSettings
         * @type {RegExp}
         */
        interpolate: co,
        /**
         * Used to reference the data object in the template text.
         *
         * @memberOf _.templateSettings
         * @type {string}
         */
        variable: "",
        /**
         * Used to import variables into the compiled template.
         *
         * @memberOf _.templateSettings
         * @type {Object}
         */
        imports: {
          /**
           * A reference to the `lodash` function.
           *
           * @memberOf _.templateSettings.imports
           * @type {Function}
           */
          _: ft
        }
      }, ft.prototype = Do.prototype, ft.prototype.constructor = ft, wi.prototype = sn(Do.prototype), wi.prototype.constructor = wi;
      function ce(e) {
        this.__wrapped__ = e, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = !1, this.__iteratees__ = [], this.__takeCount__ = T, this.__views__ = [];
      }
      function Nf() {
        var e = new ce(this.__wrapped__);
        return e.__actions__ = oi(this.__actions__), e.__dir__ = this.__dir__, e.__filtered__ = this.__filtered__, e.__iteratees__ = oi(this.__iteratees__), e.__takeCount__ = this.__takeCount__, e.__views__ = oi(this.__views__), e;
      }
      function Bf() {
        if (this.__filtered__) {
          var e = new ce(this);
          e.__dir__ = -1, e.__filtered__ = !0;
        } else
          e = this.clone(), e.__dir__ *= -1;
        return e;
      }
      function jf() {
        var e = this.__wrapped__.value(), S = this.__dir__, K = re(e), ot = S < 0, ut = K ? e.length : 0, mt = Kg(0, ut, this.__views__), xt = mt.start, bt = mt.end, Mt = bt - xt, Dt = ot ? bt : xt - 1, Rt = this.__iteratees__, Bt = Rt.length, Yt = 0, Ft = Ze(Mt, this.__takeCount__);
        if (!K || !ot && ut == Mt && Ft == Mt)
          return hc(e, this.__actions__);
        var Qt = [];
        t:
          for (; Mt-- && Yt < Ft; ) {
            Dt += S;
            for (var se = -1, te = e[Dt]; ++se < Bt; ) {
              var le = Rt[se], pe = le.iteratee, gi = le.type, ii = pe(te);
              if (gi == n)
                te = ii;
              else if (!ii) {
                if (gi == t)
                  continue t;
                break t;
              }
            }
            Qt[Yt++] = te;
          }
        return Qt;
      }
      ce.prototype = sn(Do.prototype), ce.prototype.constructor = ce;
      function Nr(e) {
        var S = -1, K = e == null ? 0 : e.length;
        for (this.clear(); ++S < K; ) {
          var ot = e[S];
          this.set(ot[0], ot[1]);
        }
      }
      function Wf() {
        this.__data__ = Bn ? Bn(null) : {}, this.size = 0;
      }
      function zf(e) {
        var S = this.has(e) && delete this.__data__[e];
        return this.size -= S ? 1 : 0, S;
      }
      function Yf(e) {
        var S = this.__data__;
        if (Bn) {
          var K = S[e];
          return K === H ? E : K;
        }
        return Se.call(S, e) ? S[e] : E;
      }
      function Xf(e) {
        var S = this.__data__;
        return Bn ? S[e] !== E : Se.call(S, e);
      }
      function Gf(e, S) {
        var K = this.__data__;
        return this.size += this.has(e) ? 0 : 1, K[e] = Bn && S === E ? H : S, this;
      }
      Nr.prototype.clear = Wf, Nr.prototype.delete = zf, Nr.prototype.get = Yf, Nr.prototype.has = Xf, Nr.prototype.set = Gf;
      function Ji(e) {
        var S = -1, K = e == null ? 0 : e.length;
        for (this.clear(); ++S < K; ) {
          var ot = e[S];
          this.set(ot[0], ot[1]);
        }
      }
      function Hf() {
        this.__data__ = [], this.size = 0;
      }
      function Uf(e) {
        var S = this.__data__, K = Io(S, e);
        if (K < 0)
          return !1;
        var ot = S.length - 1;
        return K == ot ? S.pop() : To.call(S, K, 1), --this.size, !0;
      }
      function Ff(e) {
        var S = this.__data__, K = Io(S, e);
        return K < 0 ? E : S[K][1];
      }
      function Vf(e) {
        return Io(this.__data__, e) > -1;
      }
      function $f(e, S) {
        var K = this.__data__, ot = Io(K, e);
        return ot < 0 ? (++this.size, K.push([e, S])) : K[ot][1] = S, this;
      }
      Ji.prototype.clear = Hf, Ji.prototype.delete = Uf, Ji.prototype.get = Ff, Ji.prototype.has = Vf, Ji.prototype.set = $f;
      function qi(e) {
        var S = -1, K = e == null ? 0 : e.length;
        for (this.clear(); ++S < K; ) {
          var ot = e[S];
          this.set(ot[0], ot[1]);
        }
      }
      function Zf() {
        this.size = 0, this.__data__ = {
          hash: new Nr(),
          map: new (Rn || Ji)(),
          string: new Nr()
        };
      }
      function Kf(e) {
        var S = Fo(this, e).delete(e);
        return this.size -= S ? 1 : 0, S;
      }
      function Jf(e) {
        return Fo(this, e).get(e);
      }
      function qf(e) {
        return Fo(this, e).has(e);
      }
      function Qf(e, S) {
        var K = Fo(this, e), ot = K.size;
        return K.set(e, S), this.size += K.size == ot ? 0 : 1, this;
      }
      qi.prototype.clear = Zf, qi.prototype.delete = Kf, qi.prototype.get = Jf, qi.prototype.has = qf, qi.prototype.set = Qf;
      function Br(e) {
        var S = -1, K = e == null ? 0 : e.length;
        for (this.__data__ = new qi(); ++S < K; )
          this.add(e[S]);
      }
      function tg(e) {
        return this.__data__.set(e, H), this;
      }
      function eg(e) {
        return this.__data__.has(e);
      }
      Br.prototype.add = Br.prototype.push = tg, Br.prototype.has = eg;
      function _i(e) {
        var S = this.__data__ = new Ji(e);
        this.size = S.size;
      }
      function ig() {
        this.__data__ = new Ji(), this.size = 0;
      }
      function rg(e) {
        var S = this.__data__, K = S.delete(e);
        return this.size = S.size, K;
      }
      function ng(e) {
        return this.__data__.get(e);
      }
      function og(e) {
        return this.__data__.has(e);
      }
      function sg(e, S) {
        var K = this.__data__;
        if (K instanceof Ji) {
          var ot = K.__data__;
          if (!Rn || ot.length < y - 1)
            return ot.push([e, S]), this.size = ++K.size, this;
          K = this.__data__ = new qi(ot);
        }
        return K.set(e, S), this.size = K.size, this;
      }
      _i.prototype.clear = ig, _i.prototype.delete = rg, _i.prototype.get = ng, _i.prototype.has = og, _i.prototype.set = sg;
      function Wl(e, S) {
        var K = re(e), ot = !K && Xr(e), ut = !K && !ot && Cr(e), mt = !K && !ot && !ut && cn(e), xt = K || ot || ut || mt, bt = xt ? ia(e.length, mf) : [], Mt = bt.length;
        for (var Dt in e)
          (S || Se.call(e, Dt)) && !(xt && // Safari 9 has enumerable `arguments.length` in strict mode.
          (Dt == "length" || // Node.js 0.10 has enumerable non-index properties on buffers.
          ut && (Dt == "offset" || Dt == "parent") || // PhantomJS 2 has enumerable non-index properties on typed arrays.
          mt && (Dt == "buffer" || Dt == "byteLength" || Dt == "byteOffset") || // Skip index properties.
          ir(Dt, Mt))) && bt.push(Dt);
        return bt;
      }
      function zl(e) {
        var S = e.length;
        return S ? e[xa(0, S - 1)] : E;
      }
      function ag(e, S) {
        return Vo(oi(e), jr(S, 0, e.length));
      }
      function hg(e) {
        return Vo(oi(e));
      }
      function la(e, S, K) {
        (K !== E && !Di(e[S], K) || K === E && !(S in e)) && Qi(e, S, K);
      }
      function Wn(e, S, K) {
        var ot = e[S];
        (!(Se.call(e, S) && Di(ot, K)) || K === E && !(S in e)) && Qi(e, S, K);
      }
      function Io(e, S) {
        for (var K = e.length; K--; )
          if (Di(e[K][0], S))
            return K;
        return -1;
      }
      function lg(e, S, K, ot) {
        return br(e, function(ut, mt, xt) {
          S(ot, ut, K(ut), xt);
        }), ot;
      }
      function Yl(e, S) {
        return e && Xi(S, Ue(S), e);
      }
      function cg(e, S) {
        return e && Xi(S, ai(S), e);
      }
      function Qi(e, S, K) {
        S == "__proto__" && Po ? Po(e, S, {
          configurable: !0,
          enumerable: !0,
          value: K,
          writable: !0
        }) : e[S] = K;
      }
      function ca(e, S) {
        for (var K = -1, ot = S.length, ut = At(ot), mt = e == null; ++K < ot; )
          ut[K] = mt ? E : Ha(e, S[K]);
        return ut;
      }
      function jr(e, S, K) {
        return e === e && (K !== E && (e = e <= K ? e : K), S !== E && (e = e >= S ? e : S)), e;
      }
      function Mi(e, S, K, ot, ut, mt) {
        var xt, bt = S & W, Mt = S & N, Dt = S & M;
        if (K && (xt = ut ? K(e, ot, ut, mt) : K(e)), xt !== E)
          return xt;
        if (!_e(e))
          return e;
        var Rt = re(e);
        if (Rt) {
          if (xt = qg(e), !bt)
            return oi(e, xt);
        } else {
          var Bt = Ke(e), Yt = Bt == V || Bt == q;
          if (Cr(e))
            return pc(e, bt);
          if (Bt == rt || Bt == L || Yt && !ut) {
            if (xt = Mt || Yt ? {} : Oc(e), !bt)
              return Mt ? Yg(e, cg(xt, e)) : zg(e, Yl(xt, e));
          } else {
            if (!ke[Bt])
              return ut ? e : {};
            xt = Qg(e, Bt, bt);
          }
        }
        mt || (mt = new _i());
        var Ft = mt.get(e);
        if (Ft)
          return Ft;
        mt.set(e, xt), op(e) ? e.forEach(function(te) {
          xt.add(Mi(te, S, K, te, e, mt));
        }) : rp(e) && e.forEach(function(te, le) {
          xt.set(le, Mi(te, S, K, le, e, mt));
        });
        var Qt = Dt ? Mt ? Oa : Ea : Mt ? ai : Ue, se = Rt ? E : Qt(e);
        return bi(se || e, function(te, le) {
          se && (le = te, te = e[le]), Wn(xt, le, Mi(te, S, K, le, e, mt));
        }), xt;
      }
      function pg(e) {
        var S = Ue(e);
        return function(K) {
          return Xl(K, e, S);
        };
      }
      function Xl(e, S, K) {
        var ot = K.length;
        if (e == null)
          return !ot;
        for (e = Ce(e); ot--; ) {
          var ut = K[ot], mt = S[ut], xt = e[ut];
          if (xt === E && !(ut in e) || !mt(xt))
            return !1;
        }
        return !0;
      }
      function Gl(e, S, K) {
        if (typeof e != "function")
          throw new Si(I);
        return Fn(function() {
          e.apply(E, K);
        }, S);
      }
      function zn(e, S, K, ot) {
        var ut = -1, mt = yo, xt = !0, bt = e.length, Mt = [], Dt = S.length;
        if (!bt)
          return Mt;
        K && (S = Ee(S, ui(K))), ot ? (mt = Ks, xt = !1) : S.length >= y && (mt = Dn, xt = !1, S = new Br(S));
        t:
          for (; ++ut < bt; ) {
            var Rt = e[ut], Bt = K == null ? Rt : K(Rt);
            if (Rt = ot || Rt !== 0 ? Rt : 0, xt && Bt === Bt) {
              for (var Yt = Dt; Yt--; )
                if (S[Yt] === Bt)
                  continue t;
              Mt.push(Rt);
            } else
              mt(S, Bt, ot) || Mt.push(Rt);
          }
        return Mt;
      }
      var br = mc(Yi), Hl = mc(ua, !0);
      function ug(e, S) {
        var K = !0;
        return br(e, function(ot, ut, mt) {
          return K = !!S(ot, ut, mt), K;
        }), K;
      }
      function Ro(e, S, K) {
        for (var ot = -1, ut = e.length; ++ot < ut; ) {
          var mt = e[ot], xt = S(mt);
          if (xt != null && (bt === E ? xt === xt && !fi(xt) : K(xt, bt)))
            var bt = xt, Mt = mt;
        }
        return Mt;
      }
      function dg(e, S, K, ot) {
        var ut = e.length;
        for (K = ne(K), K < 0 && (K = -K > ut ? 0 : ut + K), ot = ot === E || ot > ut ? ut : ne(ot), ot < 0 && (ot += ut), ot = K > ot ? 0 : ap(ot); K < ot; )
          e[K++] = S;
        return e;
      }
      function Ul(e, S) {
        var K = [];
        return br(e, function(ot, ut, mt) {
          S(ot, ut, mt) && K.push(ot);
        }), K;
      }
      function Ve(e, S, K, ot, ut) {
        var mt = -1, xt = e.length;
        for (K || (K = em), ut || (ut = []); ++mt < xt; ) {
          var bt = e[mt];
          S > 0 && K(bt) ? S > 1 ? Ve(bt, S - 1, K, ot, ut) : yr(ut, bt) : ot || (ut[ut.length] = bt);
        }
        return ut;
      }
      var pa = yc(), Fl = yc(!0);
      function Yi(e, S) {
        return e && pa(e, S, Ue);
      }
      function ua(e, S) {
        return e && Fl(e, S, Ue);
      }
      function No(e, S) {
        return mr(S, function(K) {
          return rr(e[K]);
        });
      }
      function Wr(e, S) {
        S = wr(S, e);
        for (var K = 0, ot = S.length; e != null && K < ot; )
          e = e[Gi(S[K++])];
        return K && K == ot ? e : E;
      }
      function Vl(e, S, K) {
        var ot = S(e);
        return re(e) ? ot : yr(ot, K(e));
      }
      function ti(e) {
        return e == null ? e === E ? tt : nt : Rr && Rr in Ce(e) ? Zg(e) : hm(e);
      }
      function da(e, S) {
        return e > S;
      }
      function fg(e, S) {
        return e != null && Se.call(e, S);
      }
      function gg(e, S) {
        return e != null && S in Ce(e);
      }
      function mg(e, S, K) {
        return e >= Ze(S, K) && e < Ye(S, K);
      }
      function fa(e, S, K) {
        for (var ot = K ? Ks : yo, ut = e[0].length, mt = e.length, xt = mt, bt = At(mt), Mt = 1 / 0, Dt = []; xt--; ) {
          var Rt = e[xt];
          xt && S && (Rt = Ee(Rt, ui(S))), Mt = Ze(Rt.length, Mt), bt[xt] = !K && (S || ut >= 120 && Rt.length >= 120) ? new Br(xt && Rt) : E;
        }
        Rt = e[0];
        var Bt = -1, Yt = bt[0];
        t:
          for (; ++Bt < ut && Dt.length < Mt; ) {
            var Ft = Rt[Bt], Qt = S ? S(Ft) : Ft;
            if (Ft = K || Ft !== 0 ? Ft : 0, !(Yt ? Dn(Yt, Qt) : ot(Dt, Qt, K))) {
              for (xt = mt; --xt; ) {
                var se = bt[xt];
                if (!(se ? Dn(se, Qt) : ot(e[xt], Qt, K)))
                  continue t;
              }
              Yt && Yt.push(Qt), Dt.push(Ft);
            }
          }
        return Dt;
      }
      function yg(e, S, K, ot) {
        return Yi(e, function(ut, mt, xt) {
          S(ot, K(ut), mt, xt);
        }), ot;
      }
      function Yn(e, S, K) {
        S = wr(S, e), e = Ic(e, S);
        var ot = e == null ? e : e[Gi(ki(S))];
        return ot == null ? E : pi(ot, e, K);
      }
      function $l(e) {
        return Ie(e) && ti(e) == L;
      }
      function vg(e) {
        return Ie(e) && ti(e) == pt;
      }
      function xg(e) {
        return Ie(e) && ti(e) == k;
      }
      function Xn(e, S, K, ot, ut) {
        return e === S ? !0 : e == null || S == null || !Ie(e) && !Ie(S) ? e !== e && S !== S : bg(e, S, K, ot, Xn, ut);
      }
      function bg(e, S, K, ot, ut, mt) {
        var xt = re(e), bt = re(S), Mt = xt ? Y : Ke(e), Dt = bt ? Y : Ke(S);
        Mt = Mt == L ? rt : Mt, Dt = Dt == L ? rt : Dt;
        var Rt = Mt == rt, Bt = Dt == rt, Yt = Mt == Dt;
        if (Yt && Cr(e)) {
          if (!Cr(S))
            return !1;
          xt = !0, Rt = !1;
        }
        if (Yt && !Rt)
          return mt || (mt = new _i()), xt || cn(e) ? Tc(e, S, K, ot, ut, mt) : Vg(e, S, Mt, K, ot, ut, mt);
        if (!(K & v)) {
          var Ft = Rt && Se.call(e, "__wrapped__"), Qt = Bt && Se.call(S, "__wrapped__");
          if (Ft || Qt) {
            var se = Ft ? e.value() : e, te = Qt ? S.value() : S;
            return mt || (mt = new _i()), ut(se, te, K, ot, mt);
          }
        }
        return Yt ? (mt || (mt = new _i()), $g(e, S, K, ot, ut, mt)) : !1;
      }
      function Sg(e) {
        return Ie(e) && Ke(e) == it;
      }
      function ga(e, S, K, ot) {
        var ut = K.length, mt = ut, xt = !ot;
        if (e == null)
          return !mt;
        for (e = Ce(e); ut--; ) {
          var bt = K[ut];
          if (xt && bt[2] ? bt[1] !== e[bt[0]] : !(bt[0] in e))
            return !1;
        }
        for (; ++ut < mt; ) {
          bt = K[ut];
          var Mt = bt[0], Dt = e[Mt], Rt = bt[1];
          if (xt && bt[2]) {
            if (Dt === E && !(Mt in e))
              return !1;
          } else {
            var Bt = new _i();
            if (ot)
              var Yt = ot(Dt, Rt, Mt, e, S, Bt);
            if (!(Yt === E ? Xn(Rt, Dt, v | u, ot, Bt) : Yt))
              return !1;
          }
        }
        return !0;
      }
      function Zl(e) {
        if (!_e(e) || rm(e))
          return !1;
        var S = rr(e) ? Sf : Le;
        return S.test(Yr(e));
      }
      function wg(e) {
        return Ie(e) && ti(e) == dt;
      }
      function Mg(e) {
        return Ie(e) && Ke(e) == lt;
      }
      function Cg(e) {
        return Ie(e) && Qo(e.length) && !!Ae[ti(e)];
      }
      function Kl(e) {
        return typeof e == "function" ? e : e == null ? hi : typeof e == "object" ? re(e) ? Ql(e[0], e[1]) : ql(e) : vp(e);
      }
      function ma(e) {
        if (!Un(e))
          return Tf(e);
        var S = [];
        for (var K in Ce(e))
          Se.call(e, K) && K != "constructor" && S.push(K);
        return S;
      }
      function kg(e) {
        if (!_e(e))
          return am(e);
        var S = Un(e), K = [];
        for (var ot in e)
          ot == "constructor" && (S || !Se.call(e, ot)) || K.push(ot);
        return K;
      }
      function ya(e, S) {
        return e < S;
      }
      function Jl(e, S) {
        var K = -1, ot = si(e) ? At(e.length) : [];
        return br(e, function(ut, mt, xt) {
          ot[++K] = S(ut, mt, xt);
        }), ot;
      }
      function ql(e) {
        var S = _a(e);
        return S.length == 1 && S[0][2] ? _c(S[0][0], S[0][1]) : function(K) {
          return K === e || ga(K, e, S);
        };
      }
      function Ql(e, S) {
        return Ia(e) && Lc(S) ? _c(Gi(e), S) : function(K) {
          var ot = Ha(K, e);
          return ot === E && ot === S ? Ua(K, e) : Xn(S, ot, v | u);
        };
      }
      function Bo(e, S, K, ot, ut) {
        e !== S && pa(S, function(mt, xt) {
          if (ut || (ut = new _i()), _e(mt))
            Ag(e, S, xt, K, Bo, ot, ut);
          else {
            var bt = ot ? ot(Na(e, xt), mt, xt + "", e, S, ut) : E;
            bt === E && (bt = mt), la(e, xt, bt);
          }
        }, ai);
      }
      function Ag(e, S, K, ot, ut, mt, xt) {
        var bt = Na(e, K), Mt = Na(S, K), Dt = xt.get(Mt);
        if (Dt) {
          la(e, K, Dt);
          return;
        }
        var Rt = mt ? mt(bt, Mt, K + "", e, S, xt) : E, Bt = Rt === E;
        if (Bt) {
          var Yt = re(Mt), Ft = !Yt && Cr(Mt), Qt = !Yt && !Ft && cn(Mt);
          Rt = Mt, Yt || Ft || Qt ? re(bt) ? Rt = bt : Ne(bt) ? Rt = oi(bt) : Ft ? (Bt = !1, Rt = pc(Mt, !0)) : Qt ? (Bt = !1, Rt = uc(Mt, !0)) : Rt = [] : Vn(Mt) || Xr(Mt) ? (Rt = bt, Xr(bt) ? Rt = hp(bt) : (!_e(bt) || rr(bt)) && (Rt = Oc(Mt))) : Bt = !1;
        }
        Bt && (xt.set(Mt, Rt), ut(Rt, Mt, ot, mt, xt), xt.delete(Mt)), la(e, K, Rt);
      }
      function tc(e, S) {
        var K = e.length;
        if (K)
          return S += S < 0 ? K : 0, ir(S, K) ? e[S] : E;
      }
      function ec(e, S, K) {
        S.length ? S = Ee(S, function(mt) {
          return re(mt) ? function(xt) {
            return Wr(xt, mt.length === 1 ? mt[0] : mt);
          } : mt;
        }) : S = [hi];
        var ot = -1;
        S = Ee(S, ui(qt()));
        var ut = Jl(e, function(mt, xt, bt) {
          var Mt = Ee(S, function(Dt) {
            return Dt(mt);
          });
          return { criteria: Mt, index: ++ot, value: mt };
        });
        return qd(ut, function(mt, xt) {
          return Wg(mt, xt, K);
        });
      }
      function Tg(e, S) {
        return ic(e, S, function(K, ot) {
          return Ua(e, ot);
        });
      }
      function ic(e, S, K) {
        for (var ot = -1, ut = S.length, mt = {}; ++ot < ut; ) {
          var xt = S[ot], bt = Wr(e, xt);
          K(bt, xt) && Gn(mt, wr(xt, e), bt);
        }
        return mt;
      }
      function Pg(e) {
        return function(S) {
          return Wr(S, e);
        };
      }
      function va(e, S, K, ot) {
        var ut = ot ? Jd : qr, mt = -1, xt = S.length, bt = e;
        for (e === S && (S = oi(S)), K && (bt = Ee(e, ui(K))); ++mt < xt; )
          for (var Mt = 0, Dt = S[mt], Rt = K ? K(Dt) : Dt; (Mt = ut(bt, Rt, Mt, ot)) > -1; )
            bt !== e && To.call(bt, Mt, 1), To.call(e, Mt, 1);
        return e;
      }
      function rc(e, S) {
        for (var K = e ? S.length : 0, ot = K - 1; K--; ) {
          var ut = S[K];
          if (K == ot || ut !== mt) {
            var mt = ut;
            ir(ut) ? To.call(e, ut, 1) : wa(e, ut);
          }
        }
        return e;
      }
      function xa(e, S) {
        return e + Oo(Bl() * (S - e + 1));
      }
      function Eg(e, S, K, ot) {
        for (var ut = -1, mt = Ye(Eo((S - e) / (K || 1)), 0), xt = At(mt); mt--; )
          xt[ot ? mt : ++ut] = e, e += K;
        return xt;
      }
      function ba(e, S) {
        var K = "";
        if (!e || S < 1 || S > _)
          return K;
        do
          S % 2 && (K += e), S = Oo(S / 2), S && (e += e);
        while (S);
        return K;
      }
      function ae(e, S) {
        return Ba(Dc(e, S, hi), e + "");
      }
      function Og(e) {
        return zl(pn(e));
      }
      function Lg(e, S) {
        var K = pn(e);
        return Vo(K, jr(S, 0, K.length));
      }
      function Gn(e, S, K, ot) {
        if (!_e(e))
          return e;
        S = wr(S, e);
        for (var ut = -1, mt = S.length, xt = mt - 1, bt = e; bt != null && ++ut < mt; ) {
          var Mt = Gi(S[ut]), Dt = K;
          if (Mt === "__proto__" || Mt === "constructor" || Mt === "prototype")
            return e;
          if (ut != xt) {
            var Rt = bt[Mt];
            Dt = ot ? ot(Rt, Mt, bt) : E, Dt === E && (Dt = _e(Rt) ? Rt : ir(S[ut + 1]) ? [] : {});
          }
          Wn(bt, Mt, Dt), bt = bt[Mt];
        }
        return e;
      }
      var nc = Lo ? function(e, S) {
        return Lo.set(e, S), e;
      } : hi, _g = Po ? function(e, S) {
        return Po(e, "toString", {
          configurable: !0,
          enumerable: !1,
          value: Va(S),
          writable: !0
        });
      } : hi;
      function Dg(e) {
        return Vo(pn(e));
      }
      function Ci(e, S, K) {
        var ot = -1, ut = e.length;
        S < 0 && (S = -S > ut ? 0 : ut + S), K = K > ut ? ut : K, K < 0 && (K += ut), ut = S > K ? 0 : K - S >>> 0, S >>>= 0;
        for (var mt = At(ut); ++ot < ut; )
          mt[ot] = e[ot + S];
        return mt;
      }
      function Ig(e, S) {
        var K;
        return br(e, function(ot, ut, mt) {
          return K = S(ot, ut, mt), !K;
        }), !!K;
      }
      function jo(e, S, K) {
        var ot = 0, ut = e == null ? ot : e.length;
        if (typeof S == "number" && S === S && ut <= f) {
          for (; ot < ut; ) {
            var mt = ot + ut >>> 1, xt = e[mt];
            xt !== null && !fi(xt) && (K ? xt <= S : xt < S) ? ot = mt + 1 : ut = mt;
          }
          return ut;
        }
        return Sa(e, S, hi, K);
      }
      function Sa(e, S, K, ot) {
        var ut = 0, mt = e == null ? 0 : e.length;
        if (mt === 0)
          return 0;
        S = K(S);
        for (var xt = S !== S, bt = S === null, Mt = fi(S), Dt = S === E; ut < mt; ) {
          var Rt = Oo((ut + mt) / 2), Bt = K(e[Rt]), Yt = Bt !== E, Ft = Bt === null, Qt = Bt === Bt, se = fi(Bt);
          if (xt)
            var te = ot || Qt;
          else
            Dt ? te = Qt && (ot || Yt) : bt ? te = Qt && Yt && (ot || !Ft) : Mt ? te = Qt && Yt && !Ft && (ot || !se) : Ft || se ? te = !1 : te = ot ? Bt <= S : Bt < S;
          te ? ut = Rt + 1 : mt = Rt;
        }
        return Ze(mt, X);
      }
      function oc(e, S) {
        for (var K = -1, ot = e.length, ut = 0, mt = []; ++K < ot; ) {
          var xt = e[K], bt = S ? S(xt) : xt;
          if (!K || !Di(bt, Mt)) {
            var Mt = bt;
            mt[ut++] = xt === 0 ? 0 : xt;
          }
        }
        return mt;
      }
      function sc(e) {
        return typeof e == "number" ? e : fi(e) ? j : +e;
      }
      function di(e) {
        if (typeof e == "string")
          return e;
        if (re(e))
          return Ee(e, di) + "";
        if (fi(e))
          return jl ? jl.call(e) : "";
        var S = e + "";
        return S == "0" && 1 / e == -A ? "-0" : S;
      }
      function Sr(e, S, K) {
        var ot = -1, ut = yo, mt = e.length, xt = !0, bt = [], Mt = bt;
        if (K)
          xt = !1, ut = Ks;
        else if (mt >= y) {
          var Dt = S ? null : Ug(e);
          if (Dt)
            return xo(Dt);
          xt = !1, ut = Dn, Mt = new Br();
        } else
          Mt = S ? [] : bt;
        t:
          for (; ++ot < mt; ) {
            var Rt = e[ot], Bt = S ? S(Rt) : Rt;
            if (Rt = K || Rt !== 0 ? Rt : 0, xt && Bt === Bt) {
              for (var Yt = Mt.length; Yt--; )
                if (Mt[Yt] === Bt)
                  continue t;
              S && Mt.push(Bt), bt.push(Rt);
            } else
              ut(Mt, Bt, K) || (Mt !== bt && Mt.push(Bt), bt.push(Rt));
          }
        return bt;
      }
      function wa(e, S) {
        return S = wr(S, e), e = Ic(e, S), e == null || delete e[Gi(ki(S))];
      }
      function ac(e, S, K, ot) {
        return Gn(e, S, K(Wr(e, S)), ot);
      }
      function Wo(e, S, K, ot) {
        for (var ut = e.length, mt = ot ? ut : -1; (ot ? mt-- : ++mt < ut) && S(e[mt], mt, e); )
          ;
        return K ? Ci(e, ot ? 0 : mt, ot ? mt + 1 : ut) : Ci(e, ot ? mt + 1 : 0, ot ? ut : mt);
      }
      function hc(e, S) {
        var K = e;
        return K instanceof ce && (K = K.value()), Js(S, function(ot, ut) {
          return ut.func.apply(ut.thisArg, yr([ot], ut.args));
        }, K);
      }
      function Ma(e, S, K) {
        var ot = e.length;
        if (ot < 2)
          return ot ? Sr(e[0]) : [];
        for (var ut = -1, mt = At(ot); ++ut < ot; )
          for (var xt = e[ut], bt = -1; ++bt < ot; )
            bt != ut && (mt[ut] = zn(mt[ut] || xt, e[bt], S, K));
        return Sr(Ve(mt, 1), S, K);
      }
      function lc(e, S, K) {
        for (var ot = -1, ut = e.length, mt = S.length, xt = {}; ++ot < ut; ) {
          var bt = ot < mt ? S[ot] : E;
          K(xt, e[ot], bt);
        }
        return xt;
      }
      function Ca(e) {
        return Ne(e) ? e : [];
      }
      function ka(e) {
        return typeof e == "function" ? e : hi;
      }
      function wr(e, S) {
        return re(e) ? e : Ia(e, S) ? [e] : jc(xe(e));
      }
      var Rg = ae;
      function Mr(e, S, K) {
        var ot = e.length;
        return K = K === E ? ot : K, !S && K >= ot ? e : Ci(e, S, K);
      }
      var cc = wf || function(e) {
        return Fe.clearTimeout(e);
      };
      function pc(e, S) {
        if (S)
          return e.slice();
        var K = e.length, ot = _l ? _l(K) : new e.constructor(K);
        return e.copy(ot), ot;
      }
      function Aa(e) {
        var S = new e.constructor(e.byteLength);
        return new ko(S).set(new ko(e)), S;
      }
      function Ng(e, S) {
        var K = S ? Aa(e.buffer) : e.buffer;
        return new e.constructor(K, e.byteOffset, e.byteLength);
      }
      function Bg(e) {
        var S = new e.constructor(e.source, ue.exec(e));
        return S.lastIndex = e.lastIndex, S;
      }
      function jg(e) {
        return jn ? Ce(jn.call(e)) : {};
      }
      function uc(e, S) {
        var K = S ? Aa(e.buffer) : e.buffer;
        return new e.constructor(K, e.byteOffset, e.length);
      }
      function dc(e, S) {
        if (e !== S) {
          var K = e !== E, ot = e === null, ut = e === e, mt = fi(e), xt = S !== E, bt = S === null, Mt = S === S, Dt = fi(S);
          if (!bt && !Dt && !mt && e > S || mt && xt && Mt && !bt && !Dt || ot && xt && Mt || !K && Mt || !ut)
            return 1;
          if (!ot && !mt && !Dt && e < S || Dt && K && ut && !ot && !mt || bt && K && ut || !xt && ut || !Mt)
            return -1;
        }
        return 0;
      }
      function Wg(e, S, K) {
        for (var ot = -1, ut = e.criteria, mt = S.criteria, xt = ut.length, bt = K.length; ++ot < xt; ) {
          var Mt = dc(ut[ot], mt[ot]);
          if (Mt) {
            if (ot >= bt)
              return Mt;
            var Dt = K[ot];
            return Mt * (Dt == "desc" ? -1 : 1);
          }
        }
        return e.index - S.index;
      }
      function fc(e, S, K, ot) {
        for (var ut = -1, mt = e.length, xt = K.length, bt = -1, Mt = S.length, Dt = Ye(mt - xt, 0), Rt = At(Mt + Dt), Bt = !ot; ++bt < Mt; )
          Rt[bt] = S[bt];
        for (; ++ut < xt; )
          (Bt || ut < mt) && (Rt[K[ut]] = e[ut]);
        for (; Dt--; )
          Rt[bt++] = e[ut++];
        return Rt;
      }
      function gc(e, S, K, ot) {
        for (var ut = -1, mt = e.length, xt = -1, bt = K.length, Mt = -1, Dt = S.length, Rt = Ye(mt - bt, 0), Bt = At(Rt + Dt), Yt = !ot; ++ut < Rt; )
          Bt[ut] = e[ut];
        for (var Ft = ut; ++Mt < Dt; )
          Bt[Ft + Mt] = S[Mt];
        for (; ++xt < bt; )
          (Yt || ut < mt) && (Bt[Ft + K[xt]] = e[ut++]);
        return Bt;
      }
      function oi(e, S) {
        var K = -1, ot = e.length;
        for (S || (S = At(ot)); ++K < ot; )
          S[K] = e[K];
        return S;
      }
      function Xi(e, S, K, ot) {
        var ut = !K;
        K || (K = {});
        for (var mt = -1, xt = S.length; ++mt < xt; ) {
          var bt = S[mt], Mt = ot ? ot(K[bt], e[bt], bt, K, e) : E;
          Mt === E && (Mt = e[bt]), ut ? Qi(K, bt, Mt) : Wn(K, bt, Mt);
        }
        return K;
      }
      function zg(e, S) {
        return Xi(e, Da(e), S);
      }
      function Yg(e, S) {
        return Xi(e, Pc(e), S);
      }
      function zo(e, S) {
        return function(K, ot) {
          var ut = re(K) ? Ud : lg, mt = S ? S() : {};
          return ut(K, e, qt(ot, 2), mt);
        };
      }
      function an(e) {
        return ae(function(S, K) {
          var ot = -1, ut = K.length, mt = ut > 1 ? K[ut - 1] : E, xt = ut > 2 ? K[2] : E;
          for (mt = e.length > 3 && typeof mt == "function" ? (ut--, mt) : E, xt && ei(K[0], K[1], xt) && (mt = ut < 3 ? E : mt, ut = 1), S = Ce(S); ++ot < ut; ) {
            var bt = K[ot];
            bt && e(S, bt, ot, mt);
          }
          return S;
        });
      }
      function mc(e, S) {
        return function(K, ot) {
          if (K == null)
            return K;
          if (!si(K))
            return e(K, ot);
          for (var ut = K.length, mt = S ? ut : -1, xt = Ce(K); (S ? mt-- : ++mt < ut) && ot(xt[mt], mt, xt) !== !1; )
            ;
          return K;
        };
      }
      function yc(e) {
        return function(S, K, ot) {
          for (var ut = -1, mt = Ce(S), xt = ot(S), bt = xt.length; bt--; ) {
            var Mt = xt[e ? bt : ++ut];
            if (K(mt[Mt], Mt, mt) === !1)
              break;
          }
          return S;
        };
      }
      function Xg(e, S, K) {
        var ot = S & d, ut = Hn(e);
        function mt() {
          var xt = this && this !== Fe && this instanceof mt ? ut : e;
          return xt.apply(ot ? K : this, arguments);
        }
        return mt;
      }
      function vc(e) {
        return function(S) {
          S = xe(S);
          var K = Qr(S) ? Li(S) : E, ot = K ? K[0] : S.charAt(0), ut = K ? Mr(K, 1).join("") : S.slice(1);
          return ot[e]() + ut;
        };
      }
      function hn(e) {
        return function(S) {
          return Js(mp(gp(S).replace(Ld, "")), e, "");
        };
      }
      function Hn(e) {
        return function() {
          var S = arguments;
          switch (S.length) {
            case 0:
              return new e();
            case 1:
              return new e(S[0]);
            case 2:
              return new e(S[0], S[1]);
            case 3:
              return new e(S[0], S[1], S[2]);
            case 4:
              return new e(S[0], S[1], S[2], S[3]);
            case 5:
              return new e(S[0], S[1], S[2], S[3], S[4]);
            case 6:
              return new e(S[0], S[1], S[2], S[3], S[4], S[5]);
            case 7:
              return new e(S[0], S[1], S[2], S[3], S[4], S[5], S[6]);
          }
          var K = sn(e.prototype), ot = e.apply(K, S);
          return _e(ot) ? ot : K;
        };
      }
      function Gg(e, S, K) {
        var ot = Hn(e);
        function ut() {
          for (var mt = arguments.length, xt = At(mt), bt = mt, Mt = ln(ut); bt--; )
            xt[bt] = arguments[bt];
          var Dt = mt < 3 && xt[0] !== Mt && xt[mt - 1] !== Mt ? [] : vr(xt, Mt);
          if (mt -= Dt.length, mt < K)
            return Mc(
              e,
              S,
              Yo,
              ut.placeholder,
              E,
              xt,
              Dt,
              E,
              E,
              K - mt
            );
          var Rt = this && this !== Fe && this instanceof ut ? ot : e;
          return pi(Rt, this, xt);
        }
        return ut;
      }
      function xc(e) {
        return function(S, K, ot) {
          var ut = Ce(S);
          if (!si(S)) {
            var mt = qt(K, 3);
            S = Ue(S), K = function(bt) {
              return mt(ut[bt], bt, ut);
            };
          }
          var xt = e(S, K, ot);
          return xt > -1 ? ut[mt ? S[xt] : xt] : E;
        };
      }
      function bc(e) {
        return er(function(S) {
          var K = S.length, ot = K, ut = wi.prototype.thru;
          for (e && S.reverse(); ot--; ) {
            var mt = S[ot];
            if (typeof mt != "function")
              throw new Si(I);
            if (ut && !xt && Uo(mt) == "wrapper")
              var xt = new wi([], !0);
          }
          for (ot = xt ? ot : K; ++ot < K; ) {
            mt = S[ot];
            var bt = Uo(mt), Mt = bt == "wrapper" ? La(mt) : E;
            Mt && Ra(Mt[0]) && Mt[1] == (x | B | b | h) && !Mt[4].length && Mt[9] == 1 ? xt = xt[Uo(Mt[0])].apply(xt, Mt[3]) : xt = mt.length == 1 && Ra(mt) ? xt[bt]() : xt.thru(mt);
          }
          return function() {
            var Dt = arguments, Rt = Dt[0];
            if (xt && Dt.length == 1 && re(Rt))
              return xt.plant(Rt).value();
            for (var Bt = 0, Yt = K ? S[Bt].apply(this, Dt) : Rt; ++Bt < K; )
              Yt = S[Bt].call(this, Yt);
            return Yt;
          };
        });
      }
      function Yo(e, S, K, ot, ut, mt, xt, bt, Mt, Dt) {
        var Rt = S & x, Bt = S & d, Yt = S & P, Ft = S & (B | C), Qt = S & c, se = Yt ? E : Hn(e);
        function te() {
          for (var le = arguments.length, pe = At(le), gi = le; gi--; )
            pe[gi] = arguments[gi];
          if (Ft)
            var ii = ln(te), mi = tf(pe, ii);
          if (ot && (pe = fc(pe, ot, ut, Ft)), mt && (pe = gc(pe, mt, xt, Ft)), le -= mi, Ft && le < Dt) {
            var Be = vr(pe, ii);
            return Mc(
              e,
              S,
              Yo,
              te.placeholder,
              K,
              pe,
              Be,
              bt,
              Mt,
              Dt - le
            );
          }
          var Ii = Bt ? K : this, or = Yt ? Ii[e] : e;
          return le = pe.length, bt ? pe = lm(pe, bt) : Qt && le > 1 && pe.reverse(), Rt && Mt < le && (pe.length = Mt), this && this !== Fe && this instanceof te && (or = se || Hn(or)), or.apply(Ii, pe);
        }
        return te;
      }
      function Sc(e, S) {
        return function(K, ot) {
          return yg(K, e, S(ot), {});
        };
      }
      function Xo(e, S) {
        return function(K, ot) {
          var ut;
          if (K === E && ot === E)
            return S;
          if (K !== E && (ut = K), ot !== E) {
            if (ut === E)
              return ot;
            typeof K == "string" || typeof ot == "string" ? (K = di(K), ot = di(ot)) : (K = sc(K), ot = sc(ot)), ut = e(K, ot);
          }
          return ut;
        };
      }
      function Ta(e) {
        return er(function(S) {
          return S = Ee(S, ui(qt())), ae(function(K) {
            var ot = this;
            return e(S, function(ut) {
              return pi(ut, ot, K);
            });
          });
        });
      }
      function Go(e, S) {
        S = S === E ? " " : di(S);
        var K = S.length;
        if (K < 2)
          return K ? ba(S, e) : S;
        var ot = ba(S, Eo(e / tn(S)));
        return Qr(S) ? Mr(Li(ot), 0, e).join("") : ot.slice(0, e);
      }
      function Hg(e, S, K, ot) {
        var ut = S & d, mt = Hn(e);
        function xt() {
          for (var bt = -1, Mt = arguments.length, Dt = -1, Rt = ot.length, Bt = At(Rt + Mt), Yt = this && this !== Fe && this instanceof xt ? mt : e; ++Dt < Rt; )
            Bt[Dt] = ot[Dt];
          for (; Mt--; )
            Bt[Dt++] = arguments[++bt];
          return pi(Yt, ut ? K : this, Bt);
        }
        return xt;
      }
      function wc(e) {
        return function(S, K, ot) {
          return ot && typeof ot != "number" && ei(S, K, ot) && (K = ot = E), S = nr(S), K === E ? (K = S, S = 0) : K = nr(K), ot = ot === E ? S < K ? 1 : -1 : nr(ot), Eg(S, K, ot, e);
        };
      }
      function Ho(e) {
        return function(S, K) {
          return typeof S == "string" && typeof K == "string" || (S = Ai(S), K = Ai(K)), e(S, K);
        };
      }
      function Mc(e, S, K, ot, ut, mt, xt, bt, Mt, Dt) {
        var Rt = S & B, Bt = Rt ? xt : E, Yt = Rt ? E : xt, Ft = Rt ? mt : E, Qt = Rt ? E : mt;
        S |= Rt ? b : w, S &= ~(Rt ? w : b), S & O || (S &= ~(d | P));
        var se = [
          e,
          S,
          ut,
          Ft,
          Bt,
          Qt,
          Yt,
          bt,
          Mt,
          Dt
        ], te = K.apply(E, se);
        return Ra(e) && Rc(te, se), te.placeholder = ot, Nc(te, e, S);
      }
      function Pa(e) {
        var S = ze[e];
        return function(K, ot) {
          if (K = Ai(K), ot = ot == null ? 0 : Ze(ne(ot), 292), ot && Nl(K)) {
            var ut = (xe(K) + "e").split("e"), mt = S(ut[0] + "e" + (+ut[1] + ot));
            return ut = (xe(mt) + "e").split("e"), +(ut[0] + "e" + (+ut[1] - ot));
          }
          return S(K);
        };
      }
      var Ug = nn && 1 / xo(new nn([, -0]))[1] == A ? function(e) {
        return new nn(e);
      } : Ka;
      function Cc(e) {
        return function(S) {
          var K = Ke(S);
          return K == it ? na(S) : K == lt ? hf(S) : Qd(S, e(S));
        };
      }
      function tr(e, S, K, ot, ut, mt, xt, bt) {
        var Mt = S & P;
        if (!Mt && typeof e != "function")
          throw new Si(I);
        var Dt = ot ? ot.length : 0;
        if (Dt || (S &= ~(b | w), ot = ut = E), xt = xt === E ? xt : Ye(ne(xt), 0), bt = bt === E ? bt : ne(bt), Dt -= ut ? ut.length : 0, S & w) {
          var Rt = ot, Bt = ut;
          ot = ut = E;
        }
        var Yt = Mt ? E : La(e), Ft = [
          e,
          S,
          K,
          ot,
          ut,
          Rt,
          Bt,
          mt,
          xt,
          bt
        ];
        if (Yt && sm(Ft, Yt), e = Ft[0], S = Ft[1], K = Ft[2], ot = Ft[3], ut = Ft[4], bt = Ft[9] = Ft[9] === E ? Mt ? 0 : e.length : Ye(Ft[9] - Dt, 0), !bt && S & (B | C) && (S &= ~(B | C)), !S || S == d)
          var Qt = Xg(e, S, K);
        else
          S == B || S == C ? Qt = Gg(e, S, bt) : (S == b || S == (d | b)) && !ut.length ? Qt = Hg(e, S, K, ot) : Qt = Yo.apply(E, Ft);
        var se = Yt ? nc : Rc;
        return Nc(se(Qt, Ft), e, S);
      }
      function kc(e, S, K, ot) {
        return e === E || Di(e, rn[K]) && !Se.call(ot, K) ? S : e;
      }
      function Ac(e, S, K, ot, ut, mt) {
        return _e(e) && _e(S) && (mt.set(S, e), Bo(e, S, E, Ac, mt), mt.delete(S)), e;
      }
      function Fg(e) {
        return Vn(e) ? E : e;
      }
      function Tc(e, S, K, ot, ut, mt) {
        var xt = K & v, bt = e.length, Mt = S.length;
        if (bt != Mt && !(xt && Mt > bt))
          return !1;
        var Dt = mt.get(e), Rt = mt.get(S);
        if (Dt && Rt)
          return Dt == S && Rt == e;
        var Bt = -1, Yt = !0, Ft = K & u ? new Br() : E;
        for (mt.set(e, S), mt.set(S, e); ++Bt < bt; ) {
          var Qt = e[Bt], se = S[Bt];
          if (ot)
            var te = xt ? ot(se, Qt, Bt, S, e, mt) : ot(Qt, se, Bt, e, S, mt);
          if (te !== E) {
            if (te)
              continue;
            Yt = !1;
            break;
          }
          if (Ft) {
            if (!qs(S, function(le, pe) {
              if (!Dn(Ft, pe) && (Qt === le || ut(Qt, le, K, ot, mt)))
                return Ft.push(pe);
            })) {
              Yt = !1;
              break;
            }
          } else if (!(Qt === se || ut(Qt, se, K, ot, mt))) {
            Yt = !1;
            break;
          }
        }
        return mt.delete(e), mt.delete(S), Yt;
      }
      function Vg(e, S, K, ot, ut, mt, xt) {
        switch (K) {
          case yt:
            if (e.byteLength != S.byteLength || e.byteOffset != S.byteOffset)
              return !1;
            e = e.buffer, S = S.buffer;
          case pt:
            return !(e.byteLength != S.byteLength || !mt(new ko(e), new ko(S)));
          case Q:
          case k:
          case et:
            return Di(+e, +S);
          case z:
            return e.name == S.name && e.message == S.message;
          case dt:
          case at:
            return e == S + "";
          case it:
            var bt = na;
          case lt:
            var Mt = ot & v;
            if (bt || (bt = xo), e.size != S.size && !Mt)
              return !1;
            var Dt = xt.get(e);
            if (Dt)
              return Dt == S;
            ot |= u, xt.set(e, S);
            var Rt = Tc(bt(e), bt(S), ot, ut, mt, xt);
            return xt.delete(e), Rt;
          case J:
            if (jn)
              return jn.call(e) == jn.call(S);
        }
        return !1;
      }
      function $g(e, S, K, ot, ut, mt) {
        var xt = K & v, bt = Ea(e), Mt = bt.length, Dt = Ea(S), Rt = Dt.length;
        if (Mt != Rt && !xt)
          return !1;
        for (var Bt = Mt; Bt--; ) {
          var Yt = bt[Bt];
          if (!(xt ? Yt in S : Se.call(S, Yt)))
            return !1;
        }
        var Ft = mt.get(e), Qt = mt.get(S);
        if (Ft && Qt)
          return Ft == S && Qt == e;
        var se = !0;
        mt.set(e, S), mt.set(S, e);
        for (var te = xt; ++Bt < Mt; ) {
          Yt = bt[Bt];
          var le = e[Yt], pe = S[Yt];
          if (ot)
            var gi = xt ? ot(pe, le, Yt, S, e, mt) : ot(le, pe, Yt, e, S, mt);
          if (!(gi === E ? le === pe || ut(le, pe, K, ot, mt) : gi)) {
            se = !1;
            break;
          }
          te || (te = Yt == "constructor");
        }
        if (se && !te) {
          var ii = e.constructor, mi = S.constructor;
          ii != mi && "constructor" in e && "constructor" in S && !(typeof ii == "function" && ii instanceof ii && typeof mi == "function" && mi instanceof mi) && (se = !1);
        }
        return mt.delete(e), mt.delete(S), se;
      }
      function er(e) {
        return Ba(Dc(e, E, Xc), e + "");
      }
      function Ea(e) {
        return Vl(e, Ue, Da);
      }
      function Oa(e) {
        return Vl(e, ai, Pc);
      }
      var La = Lo ? function(e) {
        return Lo.get(e);
      } : Ka;
      function Uo(e) {
        for (var S = e.name + "", K = on[S], ot = Se.call(on, S) ? K.length : 0; ot--; ) {
          var ut = K[ot], mt = ut.func;
          if (mt == null || mt == e)
            return ut.name;
        }
        return S;
      }
      function ln(e) {
        var S = Se.call(ft, "placeholder") ? ft : e;
        return S.placeholder;
      }
      function qt() {
        var e = ft.iteratee || $a;
        return e = e === $a ? Kl : e, arguments.length ? e(arguments[0], arguments[1]) : e;
      }
      function Fo(e, S) {
        var K = e.__data__;
        return im(S) ? K[typeof S == "string" ? "string" : "hash"] : K.map;
      }
      function _a(e) {
        for (var S = Ue(e), K = S.length; K--; ) {
          var ot = S[K], ut = e[ot];
          S[K] = [ot, ut, Lc(ut)];
        }
        return S;
      }
      function zr(e, S) {
        var K = of(e, S);
        return Zl(K) ? K : E;
      }
      function Zg(e) {
        var S = Se.call(e, Rr), K = e[Rr];
        try {
          e[Rr] = E;
          var ot = !0;
        } catch {
        }
        var ut = Mo.call(e);
        return ot && (S ? e[Rr] = K : delete e[Rr]), ut;
      }
      var Da = sa ? function(e) {
        return e == null ? [] : (e = Ce(e), mr(sa(e), function(S) {
          return Il.call(e, S);
        }));
      } : Ja, Pc = sa ? function(e) {
        for (var S = []; e; )
          yr(S, Da(e)), e = Ao(e);
        return S;
      } : Ja, Ke = ti;
      (aa && Ke(new aa(new ArrayBuffer(1))) != yt || Rn && Ke(new Rn()) != it || ha && Ke(ha.resolve()) != ct || nn && Ke(new nn()) != lt || Nn && Ke(new Nn()) != st) && (Ke = function(e) {
        var S = ti(e), K = S == rt ? e.constructor : E, ot = K ? Yr(K) : "";
        if (ot)
          switch (ot) {
            case Lf:
              return yt;
            case _f:
              return it;
            case Df:
              return ct;
            case If:
              return lt;
            case Rf:
              return st;
          }
        return S;
      });
      function Kg(e, S, K) {
        for (var ot = -1, ut = K.length; ++ot < ut; ) {
          var mt = K[ot], xt = mt.size;
          switch (mt.type) {
            case "drop":
              e += xt;
              break;
            case "dropRight":
              S -= xt;
              break;
            case "take":
              S = Ze(S, e + xt);
              break;
            case "takeRight":
              e = Ye(e, S - xt);
              break;
          }
        }
        return { start: e, end: S };
      }
      function Jg(e) {
        var S = e.match(_r);
        return S ? S[1].split(zi) : [];
      }
      function Ec(e, S, K) {
        S = wr(S, e);
        for (var ot = -1, ut = S.length, mt = !1; ++ot < ut; ) {
          var xt = Gi(S[ot]);
          if (!(mt = e != null && K(e, xt)))
            break;
          e = e[xt];
        }
        return mt || ++ot != ut ? mt : (ut = e == null ? 0 : e.length, !!ut && Qo(ut) && ir(xt, ut) && (re(e) || Xr(e)));
      }
      function qg(e) {
        var S = e.length, K = new e.constructor(S);
        return S && typeof e[0] == "string" && Se.call(e, "index") && (K.index = e.index, K.input = e.input), K;
      }
      function Oc(e) {
        return typeof e.constructor == "function" && !Un(e) ? sn(Ao(e)) : {};
      }
      function Qg(e, S, K) {
        var ot = e.constructor;
        switch (S) {
          case pt:
            return Aa(e);
          case Q:
          case k:
            return new ot(+e);
          case yt:
            return Ng(e, K);
          case vt:
          case Ct:
          case Tt:
          case kt:
          case St:
          case _t:
          case Lt:
          case Nt:
          case Et:
            return uc(e, K);
          case it:
            return new ot();
          case et:
          case at:
            return new ot(e);
          case dt:
            return Bg(e);
          case lt:
            return new ot();
          case J:
            return jg(e);
        }
      }
      function tm(e, S) {
        var K = S.length;
        if (!K)
          return e;
        var ot = K - 1;
        return S[ot] = (K > 1 ? "& " : "") + S[ot], S = S.join(K > 2 ? ", " : " "), e.replace(Xs, `{
/* [wrapped with ` + S + `] */
`);
      }
      function em(e) {
        return re(e) || Xr(e) || !!(Rl && e && e[Rl]);
      }
      function ir(e, S) {
        var K = typeof e;
        return S = S ?? _, !!S && (K == "number" || K != "symbol" && ud.test(e)) && e > -1 && e % 1 == 0 && e < S;
      }
      function ei(e, S, K) {
        if (!_e(K))
          return !1;
        var ot = typeof S;
        return (ot == "number" ? si(K) && ir(S, K.length) : ot == "string" && S in K) ? Di(K[S], e) : !1;
      }
      function Ia(e, S) {
        if (re(e))
          return !1;
        var K = typeof e;
        return K == "number" || K == "symbol" || K == "boolean" || e == null || fi(e) ? !0 : En.test(e) || !Pn.test(e) || S != null && e in Ce(S);
      }
      function im(e) {
        var S = typeof e;
        return S == "string" || S == "number" || S == "symbol" || S == "boolean" ? e !== "__proto__" : e === null;
      }
      function Ra(e) {
        var S = Uo(e), K = ft[S];
        if (typeof K != "function" || !(S in ce.prototype))
          return !1;
        if (e === K)
          return !0;
        var ot = La(K);
        return !!ot && e === ot[0];
      }
      function rm(e) {
        return !!Ll && Ll in e;
      }
      var nm = So ? rr : qa;
      function Un(e) {
        var S = e && e.constructor, K = typeof S == "function" && S.prototype || rn;
        return e === K;
      }
      function Lc(e) {
        return e === e && !_e(e);
      }
      function _c(e, S) {
        return function(K) {
          return K == null ? !1 : K[e] === S && (S !== E || e in Ce(K));
        };
      }
      function om(e) {
        var S = Jo(e, function(ot) {
          return K.size === $ && K.clear(), ot;
        }), K = S.cache;
        return S;
      }
      function sm(e, S) {
        var K = e[1], ot = S[1], ut = K | ot, mt = ut < (d | P | x), xt = ot == x && K == B || ot == x && K == h && e[7].length <= S[8] || ot == (x | h) && S[7].length <= S[8] && K == B;
        if (!(mt || xt))
          return e;
        ot & d && (e[2] = S[2], ut |= K & d ? 0 : O);
        var bt = S[3];
        if (bt) {
          var Mt = e[3];
          e[3] = Mt ? fc(Mt, bt, S[4]) : bt, e[4] = Mt ? vr(e[3], U) : S[4];
        }
        return bt = S[5], bt && (Mt = e[5], e[5] = Mt ? gc(Mt, bt, S[6]) : bt, e[6] = Mt ? vr(e[5], U) : S[6]), bt = S[7], bt && (e[7] = bt), ot & x && (e[8] = e[8] == null ? S[8] : Ze(e[8], S[8])), e[9] == null && (e[9] = S[9]), e[0] = S[0], e[1] = ut, e;
      }
      function am(e) {
        var S = [];
        if (e != null)
          for (var K in Ce(e))
            S.push(K);
        return S;
      }
      function hm(e) {
        return Mo.call(e);
      }
      function Dc(e, S, K) {
        return S = Ye(S === E ? e.length - 1 : S, 0), function() {
          for (var ot = arguments, ut = -1, mt = Ye(ot.length - S, 0), xt = At(mt); ++ut < mt; )
            xt[ut] = ot[S + ut];
          ut = -1;
          for (var bt = At(S + 1); ++ut < S; )
            bt[ut] = ot[ut];
          return bt[S] = K(xt), pi(e, this, bt);
        };
      }
      function Ic(e, S) {
        return S.length < 2 ? e : Wr(e, Ci(S, 0, -1));
      }
      function lm(e, S) {
        for (var K = e.length, ot = Ze(S.length, K), ut = oi(e); ot--; ) {
          var mt = S[ot];
          e[ot] = ir(mt, K) ? ut[mt] : E;
        }
        return e;
      }
      function Na(e, S) {
        if (!(S === "constructor" && typeof e[S] == "function") && S != "__proto__")
          return e[S];
      }
      var Rc = Bc(nc), Fn = Cf || function(e, S) {
        return Fe.setTimeout(e, S);
      }, Ba = Bc(_g);
      function Nc(e, S, K) {
        var ot = S + "";
        return Ba(e, tm(ot, cm(Jg(ot), K)));
      }
      function Bc(e) {
        var S = 0, K = 0;
        return function() {
          var ot = Pf(), ut = s - (ot - K);
          if (K = ot, ut > 0) {
            if (++S >= l)
              return arguments[0];
          } else
            S = 0;
          return e.apply(E, arguments);
        };
      }
      function Vo(e, S) {
        var K = -1, ot = e.length, ut = ot - 1;
        for (S = S === E ? ot : S; ++K < S; ) {
          var mt = xa(K, ut), xt = e[mt];
          e[mt] = e[K], e[K] = xt;
        }
        return e.length = S, e;
      }
      var jc = om(function(e) {
        var S = [];
        return e.charCodeAt(0) === 46 && S.push(""), e.replace($e, function(K, ot, ut, mt) {
          S.push(ut ? mt.replace(Dr, "$1") : ot || K);
        }), S;
      });
      function Gi(e) {
        if (typeof e == "string" || fi(e))
          return e;
        var S = e + "";
        return S == "0" && 1 / e == -A ? "-0" : S;
      }
      function Yr(e) {
        if (e != null) {
          try {
            return wo.call(e);
          } catch {
          }
          try {
            return e + "";
          } catch {
          }
        }
        return "";
      }
      function cm(e, S) {
        return bi(m, function(K) {
          var ot = "_." + K[0];
          S & K[1] && !yo(e, ot) && e.push(ot);
        }), e.sort();
      }
      function Wc(e) {
        if (e instanceof ce)
          return e.clone();
        var S = new wi(e.__wrapped__, e.__chain__);
        return S.__actions__ = oi(e.__actions__), S.__index__ = e.__index__, S.__values__ = e.__values__, S;
      }
      function pm(e, S, K) {
        (K ? ei(e, S, K) : S === E) ? S = 1 : S = Ye(ne(S), 0);
        var ot = e == null ? 0 : e.length;
        if (!ot || S < 1)
          return [];
        for (var ut = 0, mt = 0, xt = At(Eo(ot / S)); ut < ot; )
          xt[mt++] = Ci(e, ut, ut += S);
        return xt;
      }
      function um(e) {
        for (var S = -1, K = e == null ? 0 : e.length, ot = 0, ut = []; ++S < K; ) {
          var mt = e[S];
          mt && (ut[ot++] = mt);
        }
        return ut;
      }
      function dm() {
        var e = arguments.length;
        if (!e)
          return [];
        for (var S = At(e - 1), K = arguments[0], ot = e; ot--; )
          S[ot - 1] = arguments[ot];
        return yr(re(K) ? oi(K) : [K], Ve(S, 1));
      }
      var fm = ae(function(e, S) {
        return Ne(e) ? zn(e, Ve(S, 1, Ne, !0)) : [];
      }), gm = ae(function(e, S) {
        var K = ki(S);
        return Ne(K) && (K = E), Ne(e) ? zn(e, Ve(S, 1, Ne, !0), qt(K, 2)) : [];
      }), mm = ae(function(e, S) {
        var K = ki(S);
        return Ne(K) && (K = E), Ne(e) ? zn(e, Ve(S, 1, Ne, !0), E, K) : [];
      });
      function ym(e, S, K) {
        var ot = e == null ? 0 : e.length;
        return ot ? (S = K || S === E ? 1 : ne(S), Ci(e, S < 0 ? 0 : S, ot)) : [];
      }
      function vm(e, S, K) {
        var ot = e == null ? 0 : e.length;
        return ot ? (S = K || S === E ? 1 : ne(S), S = ot - S, Ci(e, 0, S < 0 ? 0 : S)) : [];
      }
      function xm(e, S) {
        return e && e.length ? Wo(e, qt(S, 3), !0, !0) : [];
      }
      function bm(e, S) {
        return e && e.length ? Wo(e, qt(S, 3), !0) : [];
      }
      function Sm(e, S, K, ot) {
        var ut = e == null ? 0 : e.length;
        return ut ? (K && typeof K != "number" && ei(e, S, K) && (K = 0, ot = ut), dg(e, S, K, ot)) : [];
      }
      function zc(e, S, K) {
        var ot = e == null ? 0 : e.length;
        if (!ot)
          return -1;
        var ut = K == null ? 0 : ne(K);
        return ut < 0 && (ut = Ye(ot + ut, 0)), vo(e, qt(S, 3), ut);
      }
      function Yc(e, S, K) {
        var ot = e == null ? 0 : e.length;
        if (!ot)
          return -1;
        var ut = ot - 1;
        return K !== E && (ut = ne(K), ut = K < 0 ? Ye(ot + ut, 0) : Ze(ut, ot - 1)), vo(e, qt(S, 3), ut, !0);
      }
      function Xc(e) {
        var S = e == null ? 0 : e.length;
        return S ? Ve(e, 1) : [];
      }
      function wm(e) {
        var S = e == null ? 0 : e.length;
        return S ? Ve(e, A) : [];
      }
      function Mm(e, S) {
        var K = e == null ? 0 : e.length;
        return K ? (S = S === E ? 1 : ne(S), Ve(e, S)) : [];
      }
      function Cm(e) {
        for (var S = -1, K = e == null ? 0 : e.length, ot = {}; ++S < K; ) {
          var ut = e[S];
          ot[ut[0]] = ut[1];
        }
        return ot;
      }
      function Gc(e) {
        return e && e.length ? e[0] : E;
      }
      function km(e, S, K) {
        var ot = e == null ? 0 : e.length;
        if (!ot)
          return -1;
        var ut = K == null ? 0 : ne(K);
        return ut < 0 && (ut = Ye(ot + ut, 0)), qr(e, S, ut);
      }
      function Am(e) {
        var S = e == null ? 0 : e.length;
        return S ? Ci(e, 0, -1) : [];
      }
      var Tm = ae(function(e) {
        var S = Ee(e, Ca);
        return S.length && S[0] === e[0] ? fa(S) : [];
      }), Pm = ae(function(e) {
        var S = ki(e), K = Ee(e, Ca);
        return S === ki(K) ? S = E : K.pop(), K.length && K[0] === e[0] ? fa(K, qt(S, 2)) : [];
      }), Em = ae(function(e) {
        var S = ki(e), K = Ee(e, Ca);
        return S = typeof S == "function" ? S : E, S && K.pop(), K.length && K[0] === e[0] ? fa(K, E, S) : [];
      });
      function Om(e, S) {
        return e == null ? "" : Af.call(e, S);
      }
      function ki(e) {
        var S = e == null ? 0 : e.length;
        return S ? e[S - 1] : E;
      }
      function Lm(e, S, K) {
        var ot = e == null ? 0 : e.length;
        if (!ot)
          return -1;
        var ut = ot;
        return K !== E && (ut = ne(K), ut = ut < 0 ? Ye(ot + ut, 0) : Ze(ut, ot - 1)), S === S ? cf(e, S, ut) : vo(e, Ml, ut, !0);
      }
      function _m(e, S) {
        return e && e.length ? tc(e, ne(S)) : E;
      }
      var Dm = ae(Hc);
      function Hc(e, S) {
        return e && e.length && S && S.length ? va(e, S) : e;
      }
      function Im(e, S, K) {
        return e && e.length && S && S.length ? va(e, S, qt(K, 2)) : e;
      }
      function Rm(e, S, K) {
        return e && e.length && S && S.length ? va(e, S, E, K) : e;
      }
      var Nm = er(function(e, S) {
        var K = e == null ? 0 : e.length, ot = ca(e, S);
        return rc(e, Ee(S, function(ut) {
          return ir(ut, K) ? +ut : ut;
        }).sort(dc)), ot;
      });
      function Bm(e, S) {
        var K = [];
        if (!(e && e.length))
          return K;
        var ot = -1, ut = [], mt = e.length;
        for (S = qt(S, 3); ++ot < mt; ) {
          var xt = e[ot];
          S(xt, ot, e) && (K.push(xt), ut.push(ot));
        }
        return rc(e, ut), K;
      }
      function ja(e) {
        return e == null ? e : Of.call(e);
      }
      function jm(e, S, K) {
        var ot = e == null ? 0 : e.length;
        return ot ? (K && typeof K != "number" && ei(e, S, K) ? (S = 0, K = ot) : (S = S == null ? 0 : ne(S), K = K === E ? ot : ne(K)), Ci(e, S, K)) : [];
      }
      function Wm(e, S) {
        return jo(e, S);
      }
      function zm(e, S, K) {
        return Sa(e, S, qt(K, 2));
      }
      function Ym(e, S) {
        var K = e == null ? 0 : e.length;
        if (K) {
          var ot = jo(e, S);
          if (ot < K && Di(e[ot], S))
            return ot;
        }
        return -1;
      }
      function Xm(e, S) {
        return jo(e, S, !0);
      }
      function Gm(e, S, K) {
        return Sa(e, S, qt(K, 2), !0);
      }
      function Hm(e, S) {
        var K = e == null ? 0 : e.length;
        if (K) {
          var ot = jo(e, S, !0) - 1;
          if (Di(e[ot], S))
            return ot;
        }
        return -1;
      }
      function Um(e) {
        return e && e.length ? oc(e) : [];
      }
      function Fm(e, S) {
        return e && e.length ? oc(e, qt(S, 2)) : [];
      }
      function Vm(e) {
        var S = e == null ? 0 : e.length;
        return S ? Ci(e, 1, S) : [];
      }
      function $m(e, S, K) {
        return e && e.length ? (S = K || S === E ? 1 : ne(S), Ci(e, 0, S < 0 ? 0 : S)) : [];
      }
      function Zm(e, S, K) {
        var ot = e == null ? 0 : e.length;
        return ot ? (S = K || S === E ? 1 : ne(S), S = ot - S, Ci(e, S < 0 ? 0 : S, ot)) : [];
      }
      function Km(e, S) {
        return e && e.length ? Wo(e, qt(S, 3), !1, !0) : [];
      }
      function Jm(e, S) {
        return e && e.length ? Wo(e, qt(S, 3)) : [];
      }
      var qm = ae(function(e) {
        return Sr(Ve(e, 1, Ne, !0));
      }), Qm = ae(function(e) {
        var S = ki(e);
        return Ne(S) && (S = E), Sr(Ve(e, 1, Ne, !0), qt(S, 2));
      }), ty = ae(function(e) {
        var S = ki(e);
        return S = typeof S == "function" ? S : E, Sr(Ve(e, 1, Ne, !0), E, S);
      });
      function ey(e) {
        return e && e.length ? Sr(e) : [];
      }
      function iy(e, S) {
        return e && e.length ? Sr(e, qt(S, 2)) : [];
      }
      function ry(e, S) {
        return S = typeof S == "function" ? S : E, e && e.length ? Sr(e, E, S) : [];
      }
      function Wa(e) {
        if (!(e && e.length))
          return [];
        var S = 0;
        return e = mr(e, function(K) {
          if (Ne(K))
            return S = Ye(K.length, S), !0;
        }), ia(S, function(K) {
          return Ee(e, Qs(K));
        });
      }
      function Uc(e, S) {
        if (!(e && e.length))
          return [];
        var K = Wa(e);
        return S == null ? K : Ee(K, function(ot) {
          return pi(S, E, ot);
        });
      }
      var ny = ae(function(e, S) {
        return Ne(e) ? zn(e, S) : [];
      }), oy = ae(function(e) {
        return Ma(mr(e, Ne));
      }), sy = ae(function(e) {
        var S = ki(e);
        return Ne(S) && (S = E), Ma(mr(e, Ne), qt(S, 2));
      }), ay = ae(function(e) {
        var S = ki(e);
        return S = typeof S == "function" ? S : E, Ma(mr(e, Ne), E, S);
      }), hy = ae(Wa);
      function ly(e, S) {
        return lc(e || [], S || [], Wn);
      }
      function cy(e, S) {
        return lc(e || [], S || [], Gn);
      }
      var py = ae(function(e) {
        var S = e.length, K = S > 1 ? e[S - 1] : E;
        return K = typeof K == "function" ? (e.pop(), K) : E, Uc(e, K);
      });
      function Fc(e) {
        var S = ft(e);
        return S.__chain__ = !0, S;
      }
      function uy(e, S) {
        return S(e), e;
      }
      function $o(e, S) {
        return S(e);
      }
      var dy = er(function(e) {
        var S = e.length, K = S ? e[0] : 0, ot = this.__wrapped__, ut = function(mt) {
          return ca(mt, e);
        };
        return S > 1 || this.__actions__.length || !(ot instanceof ce) || !ir(K) ? this.thru(ut) : (ot = ot.slice(K, +K + (S ? 1 : 0)), ot.__actions__.push({
          func: $o,
          args: [ut],
          thisArg: E
        }), new wi(ot, this.__chain__).thru(function(mt) {
          return S && !mt.length && mt.push(E), mt;
        }));
      });
      function fy() {
        return Fc(this);
      }
      function gy() {
        return new wi(this.value(), this.__chain__);
      }
      function my() {
        this.__values__ === E && (this.__values__ = sp(this.value()));
        var e = this.__index__ >= this.__values__.length, S = e ? E : this.__values__[this.__index__++];
        return { done: e, value: S };
      }
      function yy() {
        return this;
      }
      function vy(e) {
        for (var S, K = this; K instanceof Do; ) {
          var ot = Wc(K);
          ot.__index__ = 0, ot.__values__ = E, S ? ut.__wrapped__ = ot : S = ot;
          var ut = ot;
          K = K.__wrapped__;
        }
        return ut.__wrapped__ = e, S;
      }
      function xy() {
        var e = this.__wrapped__;
        if (e instanceof ce) {
          var S = e;
          return this.__actions__.length && (S = new ce(this)), S = S.reverse(), S.__actions__.push({
            func: $o,
            args: [ja],
            thisArg: E
          }), new wi(S, this.__chain__);
        }
        return this.thru(ja);
      }
      function by() {
        return hc(this.__wrapped__, this.__actions__);
      }
      var Sy = zo(function(e, S, K) {
        Se.call(e, K) ? ++e[K] : Qi(e, K, 1);
      });
      function wy(e, S, K) {
        var ot = re(e) ? Sl : ug;
        return K && ei(e, S, K) && (S = E), ot(e, qt(S, 3));
      }
      function My(e, S) {
        var K = re(e) ? mr : Ul;
        return K(e, qt(S, 3));
      }
      var Cy = xc(zc), ky = xc(Yc);
      function Ay(e, S) {
        return Ve(Zo(e, S), 1);
      }
      function Ty(e, S) {
        return Ve(Zo(e, S), A);
      }
      function Py(e, S, K) {
        return K = K === E ? 1 : ne(K), Ve(Zo(e, S), K);
      }
      function Vc(e, S) {
        var K = re(e) ? bi : br;
        return K(e, qt(S, 3));
      }
      function $c(e, S) {
        var K = re(e) ? Fd : Hl;
        return K(e, qt(S, 3));
      }
      var Ey = zo(function(e, S, K) {
        Se.call(e, K) ? e[K].push(S) : Qi(e, K, [S]);
      });
      function Oy(e, S, K, ot) {
        e = si(e) ? e : pn(e), K = K && !ot ? ne(K) : 0;
        var ut = e.length;
        return K < 0 && (K = Ye(ut + K, 0)), ts(e) ? K <= ut && e.indexOf(S, K) > -1 : !!ut && qr(e, S, K) > -1;
      }
      var Ly = ae(function(e, S, K) {
        var ot = -1, ut = typeof S == "function", mt = si(e) ? At(e.length) : [];
        return br(e, function(xt) {
          mt[++ot] = ut ? pi(S, xt, K) : Yn(xt, S, K);
        }), mt;
      }), _y = zo(function(e, S, K) {
        Qi(e, K, S);
      });
      function Zo(e, S) {
        var K = re(e) ? Ee : Jl;
        return K(e, qt(S, 3));
      }
      function Dy(e, S, K, ot) {
        return e == null ? [] : (re(S) || (S = S == null ? [] : [S]), K = ot ? E : K, re(K) || (K = K == null ? [] : [K]), ec(e, S, K));
      }
      var Iy = zo(function(e, S, K) {
        e[K ? 0 : 1].push(S);
      }, function() {
        return [[], []];
      });
      function Ry(e, S, K) {
        var ot = re(e) ? Js : kl, ut = arguments.length < 3;
        return ot(e, qt(S, 4), K, ut, br);
      }
      function Ny(e, S, K) {
        var ot = re(e) ? Vd : kl, ut = arguments.length < 3;
        return ot(e, qt(S, 4), K, ut, Hl);
      }
      function By(e, S) {
        var K = re(e) ? mr : Ul;
        return K(e, qo(qt(S, 3)));
      }
      function jy(e) {
        var S = re(e) ? zl : Og;
        return S(e);
      }
      function Wy(e, S, K) {
        (K ? ei(e, S, K) : S === E) ? S = 1 : S = ne(S);
        var ot = re(e) ? ag : Lg;
        return ot(e, S);
      }
      function zy(e) {
        var S = re(e) ? hg : Dg;
        return S(e);
      }
      function Yy(e) {
        if (e == null)
          return 0;
        if (si(e))
          return ts(e) ? tn(e) : e.length;
        var S = Ke(e);
        return S == it || S == lt ? e.size : ma(e).length;
      }
      function Xy(e, S, K) {
        var ot = re(e) ? qs : Ig;
        return K && ei(e, S, K) && (S = E), ot(e, qt(S, 3));
      }
      var Gy = ae(function(e, S) {
        if (e == null)
          return [];
        var K = S.length;
        return K > 1 && ei(e, S[0], S[1]) ? S = [] : K > 2 && ei(S[0], S[1], S[2]) && (S = [S[0]]), ec(e, Ve(S, 1), []);
      }), Ko = Mf || function() {
        return Fe.Date.now();
      };
      function Hy(e, S) {
        if (typeof S != "function")
          throw new Si(I);
        return e = ne(e), function() {
          if (--e < 1)
            return S.apply(this, arguments);
        };
      }
      function Zc(e, S, K) {
        return S = K ? E : S, S = e && S == null ? e.length : S, tr(e, x, E, E, E, E, S);
      }
      function Kc(e, S) {
        var K;
        if (typeof S != "function")
          throw new Si(I);
        return e = ne(e), function() {
          return --e > 0 && (K = S.apply(this, arguments)), e <= 1 && (S = E), K;
        };
      }
      var za = ae(function(e, S, K) {
        var ot = d;
        if (K.length) {
          var ut = vr(K, ln(za));
          ot |= b;
        }
        return tr(e, ot, S, K, ut);
      }), Jc = ae(function(e, S, K) {
        var ot = d | P;
        if (K.length) {
          var ut = vr(K, ln(Jc));
          ot |= b;
        }
        return tr(S, ot, e, K, ut);
      });
      function qc(e, S, K) {
        S = K ? E : S;
        var ot = tr(e, B, E, E, E, E, E, S);
        return ot.placeholder = qc.placeholder, ot;
      }
      function Qc(e, S, K) {
        S = K ? E : S;
        var ot = tr(e, C, E, E, E, E, E, S);
        return ot.placeholder = Qc.placeholder, ot;
      }
      function tp(e, S, K) {
        var ot, ut, mt, xt, bt, Mt, Dt = 0, Rt = !1, Bt = !1, Yt = !0;
        if (typeof e != "function")
          throw new Si(I);
        S = Ai(S) || 0, _e(K) && (Rt = !!K.leading, Bt = "maxWait" in K, mt = Bt ? Ye(Ai(K.maxWait) || 0, S) : mt, Yt = "trailing" in K ? !!K.trailing : Yt);
        function Ft(Be) {
          var Ii = ot, or = ut;
          return ot = ut = E, Dt = Be, xt = e.apply(or, Ii), xt;
        }
        function Qt(Be) {
          return Dt = Be, bt = Fn(le, S), Rt ? Ft(Be) : xt;
        }
        function se(Be) {
          var Ii = Be - Mt, or = Be - Dt, xp = S - Ii;
          return Bt ? Ze(xp, mt - or) : xp;
        }
        function te(Be) {
          var Ii = Be - Mt, or = Be - Dt;
          return Mt === E || Ii >= S || Ii < 0 || Bt && or >= mt;
        }
        function le() {
          var Be = Ko();
          if (te(Be))
            return pe(Be);
          bt = Fn(le, se(Be));
        }
        function pe(Be) {
          return bt = E, Yt && ot ? Ft(Be) : (ot = ut = E, xt);
        }
        function gi() {
          bt !== E && cc(bt), Dt = 0, ot = Mt = ut = bt = E;
        }
        function ii() {
          return bt === E ? xt : pe(Ko());
        }
        function mi() {
          var Be = Ko(), Ii = te(Be);
          if (ot = arguments, ut = this, Mt = Be, Ii) {
            if (bt === E)
              return Qt(Mt);
            if (Bt)
              return cc(bt), bt = Fn(le, S), Ft(Mt);
          }
          return bt === E && (bt = Fn(le, S)), xt;
        }
        return mi.cancel = gi, mi.flush = ii, mi;
      }
      var Uy = ae(function(e, S) {
        return Gl(e, 1, S);
      }), Fy = ae(function(e, S, K) {
        return Gl(e, Ai(S) || 0, K);
      });
      function Vy(e) {
        return tr(e, c);
      }
      function Jo(e, S) {
        if (typeof e != "function" || S != null && typeof S != "function")
          throw new Si(I);
        var K = function() {
          var ot = arguments, ut = S ? S.apply(this, ot) : ot[0], mt = K.cache;
          if (mt.has(ut))
            return mt.get(ut);
          var xt = e.apply(this, ot);
          return K.cache = mt.set(ut, xt) || mt, xt;
        };
        return K.cache = new (Jo.Cache || qi)(), K;
      }
      Jo.Cache = qi;
      function qo(e) {
        if (typeof e != "function")
          throw new Si(I);
        return function() {
          var S = arguments;
          switch (S.length) {
            case 0:
              return !e.call(this);
            case 1:
              return !e.call(this, S[0]);
            case 2:
              return !e.call(this, S[0], S[1]);
            case 3:
              return !e.call(this, S[0], S[1], S[2]);
          }
          return !e.apply(this, S);
        };
      }
      function $y(e) {
        return Kc(2, e);
      }
      var Zy = Rg(function(e, S) {
        S = S.length == 1 && re(S[0]) ? Ee(S[0], ui(qt())) : Ee(Ve(S, 1), ui(qt()));
        var K = S.length;
        return ae(function(ot) {
          for (var ut = -1, mt = Ze(ot.length, K); ++ut < mt; )
            ot[ut] = S[ut].call(this, ot[ut]);
          return pi(e, this, ot);
        });
      }), Ya = ae(function(e, S) {
        var K = vr(S, ln(Ya));
        return tr(e, b, E, S, K);
      }), ep = ae(function(e, S) {
        var K = vr(S, ln(ep));
        return tr(e, w, E, S, K);
      }), Ky = er(function(e, S) {
        return tr(e, h, E, E, E, S);
      });
      function Jy(e, S) {
        if (typeof e != "function")
          throw new Si(I);
        return S = S === E ? S : ne(S), ae(e, S);
      }
      function qy(e, S) {
        if (typeof e != "function")
          throw new Si(I);
        return S = S == null ? 0 : Ye(ne(S), 0), ae(function(K) {
          var ot = K[S], ut = Mr(K, 0, S);
          return ot && yr(ut, ot), pi(e, this, ut);
        });
      }
      function Qy(e, S, K) {
        var ot = !0, ut = !0;
        if (typeof e != "function")
          throw new Si(I);
        return _e(K) && (ot = "leading" in K ? !!K.leading : ot, ut = "trailing" in K ? !!K.trailing : ut), tp(e, S, {
          leading: ot,
          maxWait: S,
          trailing: ut
        });
      }
      function tv(e) {
        return Zc(e, 1);
      }
      function ev(e, S) {
        return Ya(ka(S), e);
      }
      function iv() {
        if (!arguments.length)
          return [];
        var e = arguments[0];
        return re(e) ? e : [e];
      }
      function rv(e) {
        return Mi(e, M);
      }
      function nv(e, S) {
        return S = typeof S == "function" ? S : E, Mi(e, M, S);
      }
      function ov(e) {
        return Mi(e, W | M);
      }
      function sv(e, S) {
        return S = typeof S == "function" ? S : E, Mi(e, W | M, S);
      }
      function av(e, S) {
        return S == null || Xl(e, S, Ue(S));
      }
      function Di(e, S) {
        return e === S || e !== e && S !== S;
      }
      var hv = Ho(da), lv = Ho(function(e, S) {
        return e >= S;
      }), Xr = $l(function() {
        return arguments;
      }()) ? $l : function(e) {
        return Ie(e) && Se.call(e, "callee") && !Il.call(e, "callee");
      }, re = At.isArray, cv = gl ? ui(gl) : vg;
      function si(e) {
        return e != null && Qo(e.length) && !rr(e);
      }
      function Ne(e) {
        return Ie(e) && si(e);
      }
      function pv(e) {
        return e === !0 || e === !1 || Ie(e) && ti(e) == Q;
      }
      var Cr = kf || qa, uv = ml ? ui(ml) : xg;
      function dv(e) {
        return Ie(e) && e.nodeType === 1 && !Vn(e);
      }
      function fv(e) {
        if (e == null)
          return !0;
        if (si(e) && (re(e) || typeof e == "string" || typeof e.splice == "function" || Cr(e) || cn(e) || Xr(e)))
          return !e.length;
        var S = Ke(e);
        if (S == it || S == lt)
          return !e.size;
        if (Un(e))
          return !ma(e).length;
        for (var K in e)
          if (Se.call(e, K))
            return !1;
        return !0;
      }
      function gv(e, S) {
        return Xn(e, S);
      }
      function mv(e, S, K) {
        K = typeof K == "function" ? K : E;
        var ot = K ? K(e, S) : E;
        return ot === E ? Xn(e, S, E, K) : !!ot;
      }
      function Xa(e) {
        if (!Ie(e))
          return !1;
        var S = ti(e);
        return S == z || S == G || typeof e.message == "string" && typeof e.name == "string" && !Vn(e);
      }
      function yv(e) {
        return typeof e == "number" && Nl(e);
      }
      function rr(e) {
        if (!_e(e))
          return !1;
        var S = ti(e);
        return S == V || S == q || S == F || S == gt;
      }
      function ip(e) {
        return typeof e == "number" && e == ne(e);
      }
      function Qo(e) {
        return typeof e == "number" && e > -1 && e % 1 == 0 && e <= _;
      }
      function _e(e) {
        var S = typeof e;
        return e != null && (S == "object" || S == "function");
      }
      function Ie(e) {
        return e != null && typeof e == "object";
      }
      var rp = yl ? ui(yl) : Sg;
      function vv(e, S) {
        return e === S || ga(e, S, _a(S));
      }
      function xv(e, S, K) {
        return K = typeof K == "function" ? K : E, ga(e, S, _a(S), K);
      }
      function bv(e) {
        return np(e) && e != +e;
      }
      function Sv(e) {
        if (nm(e))
          throw new ie(R);
        return Zl(e);
      }
      function wv(e) {
        return e === null;
      }
      function Mv(e) {
        return e == null;
      }
      function np(e) {
        return typeof e == "number" || Ie(e) && ti(e) == et;
      }
      function Vn(e) {
        if (!Ie(e) || ti(e) != rt)
          return !1;
        var S = Ao(e);
        if (S === null)
          return !0;
        var K = Se.call(S, "constructor") && S.constructor;
        return typeof K == "function" && K instanceof K && wo.call(K) == xf;
      }
      var Ga = vl ? ui(vl) : wg;
      function Cv(e) {
        return ip(e) && e >= -_ && e <= _;
      }
      var op = xl ? ui(xl) : Mg;
      function ts(e) {
        return typeof e == "string" || !re(e) && Ie(e) && ti(e) == at;
      }
      function fi(e) {
        return typeof e == "symbol" || Ie(e) && ti(e) == J;
      }
      var cn = bl ? ui(bl) : Cg;
      function kv(e) {
        return e === E;
      }
      function Av(e) {
        return Ie(e) && Ke(e) == st;
      }
      function Tv(e) {
        return Ie(e) && ti(e) == ht;
      }
      var Pv = Ho(ya), Ev = Ho(function(e, S) {
        return e <= S;
      });
      function sp(e) {
        if (!e)
          return [];
        if (si(e))
          return ts(e) ? Li(e) : oi(e);
        if (In && e[In])
          return af(e[In]());
        var S = Ke(e), K = S == it ? na : S == lt ? xo : pn;
        return K(e);
      }
      function nr(e) {
        if (!e)
          return e === 0 ? e : 0;
        if (e = Ai(e), e === A || e === -A) {
          var S = e < 0 ? -1 : 1;
          return S * D;
        }
        return e === e ? e : 0;
      }
      function ne(e) {
        var S = nr(e), K = S % 1;
        return S === S ? K ? S - K : S : 0;
      }
      function ap(e) {
        return e ? jr(ne(e), 0, T) : 0;
      }
      function Ai(e) {
        if (typeof e == "number")
          return e;
        if (fi(e))
          return j;
        if (_e(e)) {
          var S = typeof e.valueOf == "function" ? e.valueOf() : e;
          e = _e(S) ? S + "" : S;
        }
        if (typeof e != "string")
          return e === 0 ? e : +e;
        e = Al(e);
        var K = De.test(e);
        return K || Kr.test(e) ? Gd(e.slice(2), K ? 2 : 8) : ge.test(e) ? j : +e;
      }
      function hp(e) {
        return Xi(e, ai(e));
      }
      function Ov(e) {
        return e ? jr(ne(e), -_, _) : e === 0 ? e : 0;
      }
      function xe(e) {
        return e == null ? "" : di(e);
      }
      var Lv = an(function(e, S) {
        if (Un(S) || si(S)) {
          Xi(S, Ue(S), e);
          return;
        }
        for (var K in S)
          Se.call(S, K) && Wn(e, K, S[K]);
      }), lp = an(function(e, S) {
        Xi(S, ai(S), e);
      }), es = an(function(e, S, K, ot) {
        Xi(S, ai(S), e, ot);
      }), _v = an(function(e, S, K, ot) {
        Xi(S, Ue(S), e, ot);
      }), Dv = er(ca);
      function Iv(e, S) {
        var K = sn(e);
        return S == null ? K : Yl(K, S);
      }
      var Rv = ae(function(e, S) {
        e = Ce(e);
        var K = -1, ot = S.length, ut = ot > 2 ? S[2] : E;
        for (ut && ei(S[0], S[1], ut) && (ot = 1); ++K < ot; )
          for (var mt = S[K], xt = ai(mt), bt = -1, Mt = xt.length; ++bt < Mt; ) {
            var Dt = xt[bt], Rt = e[Dt];
            (Rt === E || Di(Rt, rn[Dt]) && !Se.call(e, Dt)) && (e[Dt] = mt[Dt]);
          }
        return e;
      }), Nv = ae(function(e) {
        return e.push(E, Ac), pi(cp, E, e);
      });
      function Bv(e, S) {
        return wl(e, qt(S, 3), Yi);
      }
      function jv(e, S) {
        return wl(e, qt(S, 3), ua);
      }
      function Wv(e, S) {
        return e == null ? e : pa(e, qt(S, 3), ai);
      }
      function zv(e, S) {
        return e == null ? e : Fl(e, qt(S, 3), ai);
      }
      function Yv(e, S) {
        return e && Yi(e, qt(S, 3));
      }
      function Xv(e, S) {
        return e && ua(e, qt(S, 3));
      }
      function Gv(e) {
        return e == null ? [] : No(e, Ue(e));
      }
      function Hv(e) {
        return e == null ? [] : No(e, ai(e));
      }
      function Ha(e, S, K) {
        var ot = e == null ? E : Wr(e, S);
        return ot === E ? K : ot;
      }
      function Uv(e, S) {
        return e != null && Ec(e, S, fg);
      }
      function Ua(e, S) {
        return e != null && Ec(e, S, gg);
      }
      var Fv = Sc(function(e, S, K) {
        S != null && typeof S.toString != "function" && (S = Mo.call(S)), e[S] = K;
      }, Va(hi)), Vv = Sc(function(e, S, K) {
        S != null && typeof S.toString != "function" && (S = Mo.call(S)), Se.call(e, S) ? e[S].push(K) : e[S] = [K];
      }, qt), $v = ae(Yn);
      function Ue(e) {
        return si(e) ? Wl(e) : ma(e);
      }
      function ai(e) {
        return si(e) ? Wl(e, !0) : kg(e);
      }
      function Zv(e, S) {
        var K = {};
        return S = qt(S, 3), Yi(e, function(ot, ut, mt) {
          Qi(K, S(ot, ut, mt), ot);
        }), K;
      }
      function Kv(e, S) {
        var K = {};
        return S = qt(S, 3), Yi(e, function(ot, ut, mt) {
          Qi(K, ut, S(ot, ut, mt));
        }), K;
      }
      var Jv = an(function(e, S, K) {
        Bo(e, S, K);
      }), cp = an(function(e, S, K, ot) {
        Bo(e, S, K, ot);
      }), qv = er(function(e, S) {
        var K = {};
        if (e == null)
          return K;
        var ot = !1;
        S = Ee(S, function(mt) {
          return mt = wr(mt, e), ot || (ot = mt.length > 1), mt;
        }), Xi(e, Oa(e), K), ot && (K = Mi(K, W | N | M, Fg));
        for (var ut = S.length; ut--; )
          wa(K, S[ut]);
        return K;
      });
      function Qv(e, S) {
        return pp(e, qo(qt(S)));
      }
      var tx = er(function(e, S) {
        return e == null ? {} : Tg(e, S);
      });
      function pp(e, S) {
        if (e == null)
          return {};
        var K = Ee(Oa(e), function(ot) {
          return [ot];
        });
        return S = qt(S), ic(e, K, function(ot, ut) {
          return S(ot, ut[0]);
        });
      }
      function ex(e, S, K) {
        S = wr(S, e);
        var ot = -1, ut = S.length;
        for (ut || (ut = 1, e = E); ++ot < ut; ) {
          var mt = e == null ? E : e[Gi(S[ot])];
          mt === E && (ot = ut, mt = K), e = rr(mt) ? mt.call(e) : mt;
        }
        return e;
      }
      function ix(e, S, K) {
        return e == null ? e : Gn(e, S, K);
      }
      function rx(e, S, K, ot) {
        return ot = typeof ot == "function" ? ot : E, e == null ? e : Gn(e, S, K, ot);
      }
      var up = Cc(Ue), dp = Cc(ai);
      function nx(e, S, K) {
        var ot = re(e), ut = ot || Cr(e) || cn(e);
        if (S = qt(S, 4), K == null) {
          var mt = e && e.constructor;
          ut ? K = ot ? new mt() : [] : _e(e) ? K = rr(mt) ? sn(Ao(e)) : {} : K = {};
        }
        return (ut ? bi : Yi)(e, function(xt, bt, Mt) {
          return S(K, xt, bt, Mt);
        }), K;
      }
      function ox(e, S) {
        return e == null ? !0 : wa(e, S);
      }
      function sx(e, S, K) {
        return e == null ? e : ac(e, S, ka(K));
      }
      function ax(e, S, K, ot) {
        return ot = typeof ot == "function" ? ot : E, e == null ? e : ac(e, S, ka(K), ot);
      }
      function pn(e) {
        return e == null ? [] : ra(e, Ue(e));
      }
      function hx(e) {
        return e == null ? [] : ra(e, ai(e));
      }
      function lx(e, S, K) {
        return K === E && (K = S, S = E), K !== E && (K = Ai(K), K = K === K ? K : 0), S !== E && (S = Ai(S), S = S === S ? S : 0), jr(Ai(e), S, K);
      }
      function cx(e, S, K) {
        return S = nr(S), K === E ? (K = S, S = 0) : K = nr(K), e = Ai(e), mg(e, S, K);
      }
      function px(e, S, K) {
        if (K && typeof K != "boolean" && ei(e, S, K) && (S = K = E), K === E && (typeof S == "boolean" ? (K = S, S = E) : typeof e == "boolean" && (K = e, e = E)), e === E && S === E ? (e = 0, S = 1) : (e = nr(e), S === E ? (S = e, e = 0) : S = nr(S)), e > S) {
          var ot = e;
          e = S, S = ot;
        }
        if (K || e % 1 || S % 1) {
          var ut = Bl();
          return Ze(e + ut * (S - e + Xd("1e-" + ((ut + "").length - 1))), S);
        }
        return xa(e, S);
      }
      var ux = hn(function(e, S, K) {
        return S = S.toLowerCase(), e + (K ? fp(S) : S);
      });
      function fp(e) {
        return Fa(xe(e).toLowerCase());
      }
      function gp(e) {
        return e = xe(e), e && e.replace(dd, ef).replace(_d, "");
      }
      function dx(e, S, K) {
        e = xe(e), S = di(S);
        var ot = e.length;
        K = K === E ? ot : jr(ne(K), 0, ot);
        var ut = K;
        return K -= S.length, K >= 0 && e.slice(K, ut) == S;
      }
      function fx(e) {
        return e = xe(e), e && Vt.test(e) ? e.replace(be, rf) : e;
      }
      function gx(e) {
        return e = xe(e), e && Ln.test(e) ? e.replace(On, "\\$&") : e;
      }
      var mx = hn(function(e, S, K) {
        return e + (K ? "-" : "") + S.toLowerCase();
      }), yx = hn(function(e, S, K) {
        return e + (K ? " " : "") + S.toLowerCase();
      }), vx = vc("toLowerCase");
      function xx(e, S, K) {
        e = xe(e), S = ne(S);
        var ot = S ? tn(e) : 0;
        if (!S || ot >= S)
          return e;
        var ut = (S - ot) / 2;
        return Go(Oo(ut), K) + e + Go(Eo(ut), K);
      }
      function bx(e, S, K) {
        e = xe(e), S = ne(S);
        var ot = S ? tn(e) : 0;
        return S && ot < S ? e + Go(S - ot, K) : e;
      }
      function Sx(e, S, K) {
        e = xe(e), S = ne(S);
        var ot = S ? tn(e) : 0;
        return S && ot < S ? Go(S - ot, K) + e : e;
      }
      function wx(e, S, K) {
        return K || S == null ? S = 0 : S && (S = +S), Ef(xe(e).replace(Zr, ""), S || 0);
      }
      function Mx(e, S, K) {
        return (K ? ei(e, S, K) : S === E) ? S = 1 : S = ne(S), ba(xe(e), S);
      }
      function Cx() {
        var e = arguments, S = xe(e[0]);
        return e.length < 3 ? S : S.replace(e[1], e[2]);
      }
      var kx = hn(function(e, S, K) {
        return e + (K ? "_" : "") + S.toLowerCase();
      });
      function Ax(e, S, K) {
        return K && typeof K != "number" && ei(e, S, K) && (S = K = E), K = K === E ? T : K >>> 0, K ? (e = xe(e), e && (typeof S == "string" || S != null && !Ga(S)) && (S = di(S), !S && Qr(e)) ? Mr(Li(e), 0, K) : e.split(S, K)) : [];
      }
      var Tx = hn(function(e, S, K) {
        return e + (K ? " " : "") + Fa(S);
      });
      function Px(e, S, K) {
        return e = xe(e), K = K == null ? 0 : jr(ne(K), 0, e.length), S = di(S), e.slice(K, K + S.length) == S;
      }
      function Ex(e, S, K) {
        var ot = ft.templateSettings;
        K && ei(e, S, K) && (S = E), e = xe(e), S = es({}, S, ot, kc);
        var ut = es({}, S.imports, ot.imports, kc), mt = Ue(ut), xt = ra(ut, mt), bt, Mt, Dt = 0, Rt = S.interpolate || fo, Bt = "__p += '", Yt = oa(
          (S.escape || fo).source + "|" + Rt.source + "|" + (Rt === co ? $t : fo).source + "|" + (S.evaluate || fo).source + "|$",
          "g"
        ), Ft = "//# sourceURL=" + (Se.call(S, "sourceURL") ? (S.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++Bd + "]") + `
`;
        e.replace(Yt, function(te, le, pe, gi, ii, mi) {
          return pe || (pe = gi), Bt += e.slice(Dt, mi).replace(fd, nf), le && (bt = !0, Bt += `' +
__e(` + le + `) +
'`), ii && (Mt = !0, Bt += `';
` + ii + `;
__p += '`), pe && (Bt += `' +
((__t = (` + pe + `)) == null ? '' : __t) +
'`), Dt = mi + te.length, te;
        }), Bt += `';
`;
        var Qt = Se.call(S, "variable") && S.variable;
        if (!Qt)
          Bt = `with (obj) {
` + Bt + `
}
`;
        else if (_n.test(Qt))
          throw new ie(Z);
        Bt = (Mt ? Bt.replace(Kt, "") : Bt).replace(Gt, "$1").replace(Wt, "$1;"), Bt = "function(" + (Qt || "obj") + `) {
` + (Qt ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (bt ? ", __e = _.escape" : "") + (Mt ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + Bt + `return __p
}`;
        var se = yp(function() {
          return ve(mt, Ft + "return " + Bt).apply(E, xt);
        });
        if (se.source = Bt, Xa(se))
          throw se;
        return se;
      }
      function Ox(e) {
        return xe(e).toLowerCase();
      }
      function Lx(e) {
        return xe(e).toUpperCase();
      }
      function _x(e, S, K) {
        if (e = xe(e), e && (K || S === E))
          return Al(e);
        if (!e || !(S = di(S)))
          return e;
        var ot = Li(e), ut = Li(S), mt = Tl(ot, ut), xt = Pl(ot, ut) + 1;
        return Mr(ot, mt, xt).join("");
      }
      function Dx(e, S, K) {
        if (e = xe(e), e && (K || S === E))
          return e.slice(0, Ol(e) + 1);
        if (!e || !(S = di(S)))
          return e;
        var ot = Li(e), ut = Pl(ot, Li(S)) + 1;
        return Mr(ot, 0, ut).join("");
      }
      function Ix(e, S, K) {
        if (e = xe(e), e && (K || S === E))
          return e.replace(Zr, "");
        if (!e || !(S = di(S)))
          return e;
        var ot = Li(e), ut = Tl(ot, Li(S));
        return Mr(ot, ut).join("");
      }
      function Rx(e, S) {
        var K = p, ot = i;
        if (_e(S)) {
          var ut = "separator" in S ? S.separator : ut;
          K = "length" in S ? ne(S.length) : K, ot = "omission" in S ? di(S.omission) : ot;
        }
        e = xe(e);
        var mt = e.length;
        if (Qr(e)) {
          var xt = Li(e);
          mt = xt.length;
        }
        if (K >= mt)
          return e;
        var bt = K - tn(ot);
        if (bt < 1)
          return ot;
        var Mt = xt ? Mr(xt, 0, bt).join("") : e.slice(0, bt);
        if (ut === E)
          return Mt + ot;
        if (xt && (bt += Mt.length - bt), Ga(ut)) {
          if (e.slice(bt).search(ut)) {
            var Dt, Rt = Mt;
            for (ut.global || (ut = oa(ut.source, xe(ue.exec(ut)) + "g")), ut.lastIndex = 0; Dt = ut.exec(Rt); )
              var Bt = Dt.index;
            Mt = Mt.slice(0, Bt === E ? bt : Bt);
          }
        } else if (e.indexOf(di(ut), bt) != bt) {
          var Yt = Mt.lastIndexOf(ut);
          Yt > -1 && (Mt = Mt.slice(0, Yt));
        }
        return Mt + ot;
      }
      function Nx(e) {
        return e = xe(e), e && zt.test(e) ? e.replace(Jt, pf) : e;
      }
      var Bx = hn(function(e, S, K) {
        return e + (K ? " " : "") + S.toUpperCase();
      }), Fa = vc("toUpperCase");
      function mp(e, S, K) {
        return e = xe(e), S = K ? E : S, S === E ? sf(e) ? ff(e) : Kd(e) : e.match(S) || [];
      }
      var yp = ae(function(e, S) {
        try {
          return pi(e, E, S);
        } catch (K) {
          return Xa(K) ? K : new ie(K);
        }
      }), jx = er(function(e, S) {
        return bi(S, function(K) {
          K = Gi(K), Qi(e, K, za(e[K], e));
        }), e;
      });
      function Wx(e) {
        var S = e == null ? 0 : e.length, K = qt();
        return e = S ? Ee(e, function(ot) {
          if (typeof ot[1] != "function")
            throw new Si(I);
          return [K(ot[0]), ot[1]];
        }) : [], ae(function(ot) {
          for (var ut = -1; ++ut < S; ) {
            var mt = e[ut];
            if (pi(mt[0], this, ot))
              return pi(mt[1], this, ot);
          }
        });
      }
      function zx(e) {
        return pg(Mi(e, W));
      }
      function Va(e) {
        return function() {
          return e;
        };
      }
      function Yx(e, S) {
        return e == null || e !== e ? S : e;
      }
      var Xx = bc(), Gx = bc(!0);
      function hi(e) {
        return e;
      }
      function $a(e) {
        return Kl(typeof e == "function" ? e : Mi(e, W));
      }
      function Hx(e) {
        return ql(Mi(e, W));
      }
      function Ux(e, S) {
        return Ql(e, Mi(S, W));
      }
      var Fx = ae(function(e, S) {
        return function(K) {
          return Yn(K, e, S);
        };
      }), Vx = ae(function(e, S) {
        return function(K) {
          return Yn(e, K, S);
        };
      });
      function Za(e, S, K) {
        var ot = Ue(S), ut = No(S, ot);
        K == null && !(_e(S) && (ut.length || !ot.length)) && (K = S, S = e, e = this, ut = No(S, Ue(S)));
        var mt = !(_e(K) && "chain" in K) || !!K.chain, xt = rr(e);
        return bi(ut, function(bt) {
          var Mt = S[bt];
          e[bt] = Mt, xt && (e.prototype[bt] = function() {
            var Dt = this.__chain__;
            if (mt || Dt) {
              var Rt = e(this.__wrapped__), Bt = Rt.__actions__ = oi(this.__actions__);
              return Bt.push({ func: Mt, args: arguments, thisArg: e }), Rt.__chain__ = Dt, Rt;
            }
            return Mt.apply(e, yr([this.value()], arguments));
          });
        }), e;
      }
      function $x() {
        return Fe._ === this && (Fe._ = bf), this;
      }
      function Ka() {
      }
      function Zx(e) {
        return e = ne(e), ae(function(S) {
          return tc(S, e);
        });
      }
      var Kx = Ta(Ee), Jx = Ta(Sl), qx = Ta(qs);
      function vp(e) {
        return Ia(e) ? Qs(Gi(e)) : Pg(e);
      }
      function Qx(e) {
        return function(S) {
          return e == null ? E : Wr(e, S);
        };
      }
      var t0 = wc(), e0 = wc(!0);
      function Ja() {
        return [];
      }
      function qa() {
        return !1;
      }
      function i0() {
        return {};
      }
      function r0() {
        return "";
      }
      function n0() {
        return !0;
      }
      function o0(e, S) {
        if (e = ne(e), e < 1 || e > _)
          return [];
        var K = T, ot = Ze(e, T);
        S = qt(S), e -= T;
        for (var ut = ia(ot, S); ++K < e; )
          S(K);
        return ut;
      }
      function s0(e) {
        return re(e) ? Ee(e, Gi) : fi(e) ? [e] : oi(jc(xe(e)));
      }
      function a0(e) {
        var S = ++vf;
        return xe(e) + S;
      }
      var h0 = Xo(function(e, S) {
        return e + S;
      }, 0), l0 = Pa("ceil"), c0 = Xo(function(e, S) {
        return e / S;
      }, 1), p0 = Pa("floor");
      function u0(e) {
        return e && e.length ? Ro(e, hi, da) : E;
      }
      function d0(e, S) {
        return e && e.length ? Ro(e, qt(S, 2), da) : E;
      }
      function f0(e) {
        return Cl(e, hi);
      }
      function g0(e, S) {
        return Cl(e, qt(S, 2));
      }
      function m0(e) {
        return e && e.length ? Ro(e, hi, ya) : E;
      }
      function y0(e, S) {
        return e && e.length ? Ro(e, qt(S, 2), ya) : E;
      }
      var v0 = Xo(function(e, S) {
        return e * S;
      }, 1), x0 = Pa("round"), b0 = Xo(function(e, S) {
        return e - S;
      }, 0);
      function S0(e) {
        return e && e.length ? ea(e, hi) : 0;
      }
      function w0(e, S) {
        return e && e.length ? ea(e, qt(S, 2)) : 0;
      }
      return ft.after = Hy, ft.ary = Zc, ft.assign = Lv, ft.assignIn = lp, ft.assignInWith = es, ft.assignWith = _v, ft.at = Dv, ft.before = Kc, ft.bind = za, ft.bindAll = jx, ft.bindKey = Jc, ft.castArray = iv, ft.chain = Fc, ft.chunk = pm, ft.compact = um, ft.concat = dm, ft.cond = Wx, ft.conforms = zx, ft.constant = Va, ft.countBy = Sy, ft.create = Iv, ft.curry = qc, ft.curryRight = Qc, ft.debounce = tp, ft.defaults = Rv, ft.defaultsDeep = Nv, ft.defer = Uy, ft.delay = Fy, ft.difference = fm, ft.differenceBy = gm, ft.differenceWith = mm, ft.drop = ym, ft.dropRight = vm, ft.dropRightWhile = xm, ft.dropWhile = bm, ft.fill = Sm, ft.filter = My, ft.flatMap = Ay, ft.flatMapDeep = Ty, ft.flatMapDepth = Py, ft.flatten = Xc, ft.flattenDeep = wm, ft.flattenDepth = Mm, ft.flip = Vy, ft.flow = Xx, ft.flowRight = Gx, ft.fromPairs = Cm, ft.functions = Gv, ft.functionsIn = Hv, ft.groupBy = Ey, ft.initial = Am, ft.intersection = Tm, ft.intersectionBy = Pm, ft.intersectionWith = Em, ft.invert = Fv, ft.invertBy = Vv, ft.invokeMap = Ly, ft.iteratee = $a, ft.keyBy = _y, ft.keys = Ue, ft.keysIn = ai, ft.map = Zo, ft.mapKeys = Zv, ft.mapValues = Kv, ft.matches = Hx, ft.matchesProperty = Ux, ft.memoize = Jo, ft.merge = Jv, ft.mergeWith = cp, ft.method = Fx, ft.methodOf = Vx, ft.mixin = Za, ft.negate = qo, ft.nthArg = Zx, ft.omit = qv, ft.omitBy = Qv, ft.once = $y, ft.orderBy = Dy, ft.over = Kx, ft.overArgs = Zy, ft.overEvery = Jx, ft.overSome = qx, ft.partial = Ya, ft.partialRight = ep, ft.partition = Iy, ft.pick = tx, ft.pickBy = pp, ft.property = vp, ft.propertyOf = Qx, ft.pull = Dm, ft.pullAll = Hc, ft.pullAllBy = Im, ft.pullAllWith = Rm, ft.pullAt = Nm, ft.range = t0, ft.rangeRight = e0, ft.rearg = Ky, ft.reject = By, ft.remove = Bm, ft.rest = Jy, ft.reverse = ja, ft.sampleSize = Wy, ft.set = ix, ft.setWith = rx, ft.shuffle = zy, ft.slice = jm, ft.sortBy = Gy, ft.sortedUniq = Um, ft.sortedUniqBy = Fm, ft.split = Ax, ft.spread = qy, ft.tail = Vm, ft.take = $m, ft.takeRight = Zm, ft.takeRightWhile = Km, ft.takeWhile = Jm, ft.tap = uy, ft.throttle = Qy, ft.thru = $o, ft.toArray = sp, ft.toPairs = up, ft.toPairsIn = dp, ft.toPath = s0, ft.toPlainObject = hp, ft.transform = nx, ft.unary = tv, ft.union = qm, ft.unionBy = Qm, ft.unionWith = ty, ft.uniq = ey, ft.uniqBy = iy, ft.uniqWith = ry, ft.unset = ox, ft.unzip = Wa, ft.unzipWith = Uc, ft.update = sx, ft.updateWith = ax, ft.values = pn, ft.valuesIn = hx, ft.without = ny, ft.words = mp, ft.wrap = ev, ft.xor = oy, ft.xorBy = sy, ft.xorWith = ay, ft.zip = hy, ft.zipObject = ly, ft.zipObjectDeep = cy, ft.zipWith = py, ft.entries = up, ft.entriesIn = dp, ft.extend = lp, ft.extendWith = es, Za(ft, ft), ft.add = h0, ft.attempt = yp, ft.camelCase = ux, ft.capitalize = fp, ft.ceil = l0, ft.clamp = lx, ft.clone = rv, ft.cloneDeep = ov, ft.cloneDeepWith = sv, ft.cloneWith = nv, ft.conformsTo = av, ft.deburr = gp, ft.defaultTo = Yx, ft.divide = c0, ft.endsWith = dx, ft.eq = Di, ft.escape = fx, ft.escapeRegExp = gx, ft.every = wy, ft.find = Cy, ft.findIndex = zc, ft.findKey = Bv, ft.findLast = ky, ft.findLastIndex = Yc, ft.findLastKey = jv, ft.floor = p0, ft.forEach = Vc, ft.forEachRight = $c, ft.forIn = Wv, ft.forInRight = zv, ft.forOwn = Yv, ft.forOwnRight = Xv, ft.get = Ha, ft.gt = hv, ft.gte = lv, ft.has = Uv, ft.hasIn = Ua, ft.head = Gc, ft.identity = hi, ft.includes = Oy, ft.indexOf = km, ft.inRange = cx, ft.invoke = $v, ft.isArguments = Xr, ft.isArray = re, ft.isArrayBuffer = cv, ft.isArrayLike = si, ft.isArrayLikeObject = Ne, ft.isBoolean = pv, ft.isBuffer = Cr, ft.isDate = uv, ft.isElement = dv, ft.isEmpty = fv, ft.isEqual = gv, ft.isEqualWith = mv, ft.isError = Xa, ft.isFinite = yv, ft.isFunction = rr, ft.isInteger = ip, ft.isLength = Qo, ft.isMap = rp, ft.isMatch = vv, ft.isMatchWith = xv, ft.isNaN = bv, ft.isNative = Sv, ft.isNil = Mv, ft.isNull = wv, ft.isNumber = np, ft.isObject = _e, ft.isObjectLike = Ie, ft.isPlainObject = Vn, ft.isRegExp = Ga, ft.isSafeInteger = Cv, ft.isSet = op, ft.isString = ts, ft.isSymbol = fi, ft.isTypedArray = cn, ft.isUndefined = kv, ft.isWeakMap = Av, ft.isWeakSet = Tv, ft.join = Om, ft.kebabCase = mx, ft.last = ki, ft.lastIndexOf = Lm, ft.lowerCase = yx, ft.lowerFirst = vx, ft.lt = Pv, ft.lte = Ev, ft.max = u0, ft.maxBy = d0, ft.mean = f0, ft.meanBy = g0, ft.min = m0, ft.minBy = y0, ft.stubArray = Ja, ft.stubFalse = qa, ft.stubObject = i0, ft.stubString = r0, ft.stubTrue = n0, ft.multiply = v0, ft.nth = _m, ft.noConflict = $x, ft.noop = Ka, ft.now = Ko, ft.pad = xx, ft.padEnd = bx, ft.padStart = Sx, ft.parseInt = wx, ft.random = px, ft.reduce = Ry, ft.reduceRight = Ny, ft.repeat = Mx, ft.replace = Cx, ft.result = ex, ft.round = x0, ft.runInContext = wt, ft.sample = jy, ft.size = Yy, ft.snakeCase = kx, ft.some = Xy, ft.sortedIndex = Wm, ft.sortedIndexBy = zm, ft.sortedIndexOf = Ym, ft.sortedLastIndex = Xm, ft.sortedLastIndexBy = Gm, ft.sortedLastIndexOf = Hm, ft.startCase = Tx, ft.startsWith = Px, ft.subtract = b0, ft.sum = S0, ft.sumBy = w0, ft.template = Ex, ft.times = o0, ft.toFinite = nr, ft.toInteger = ne, ft.toLength = ap, ft.toLower = Ox, ft.toNumber = Ai, ft.toSafeInteger = Ov, ft.toString = xe, ft.toUpper = Lx, ft.trim = _x, ft.trimEnd = Dx, ft.trimStart = Ix, ft.truncate = Rx, ft.unescape = Nx, ft.uniqueId = a0, ft.upperCase = Bx, ft.upperFirst = Fa, ft.each = Vc, ft.eachRight = $c, ft.first = Gc, Za(ft, function() {
        var e = {};
        return Yi(ft, function(S, K) {
          Se.call(ft.prototype, K) || (e[K] = S);
        }), e;
      }(), { chain: !1 }), ft.VERSION = a, bi(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(e) {
        ft[e].placeholder = ft;
      }), bi(["drop", "take"], function(e, S) {
        ce.prototype[e] = function(K) {
          K = K === E ? 1 : Ye(ne(K), 0);
          var ot = this.__filtered__ && !S ? new ce(this) : this.clone();
          return ot.__filtered__ ? ot.__takeCount__ = Ze(K, ot.__takeCount__) : ot.__views__.push({
            size: Ze(K, T),
            type: e + (ot.__dir__ < 0 ? "Right" : "")
          }), ot;
        }, ce.prototype[e + "Right"] = function(K) {
          return this.reverse()[e](K).reverse();
        };
      }), bi(["filter", "map", "takeWhile"], function(e, S) {
        var K = S + 1, ot = K == t || K == o;
        ce.prototype[e] = function(ut) {
          var mt = this.clone();
          return mt.__iteratees__.push({
            iteratee: qt(ut, 3),
            type: K
          }), mt.__filtered__ = mt.__filtered__ || ot, mt;
        };
      }), bi(["head", "last"], function(e, S) {
        var K = "take" + (S ? "Right" : "");
        ce.prototype[e] = function() {
          return this[K](1).value()[0];
        };
      }), bi(["initial", "tail"], function(e, S) {
        var K = "drop" + (S ? "" : "Right");
        ce.prototype[e] = function() {
          return this.__filtered__ ? new ce(this) : this[K](1);
        };
      }), ce.prototype.compact = function() {
        return this.filter(hi);
      }, ce.prototype.find = function(e) {
        return this.filter(e).head();
      }, ce.prototype.findLast = function(e) {
        return this.reverse().find(e);
      }, ce.prototype.invokeMap = ae(function(e, S) {
        return typeof e == "function" ? new ce(this) : this.map(function(K) {
          return Yn(K, e, S);
        });
      }), ce.prototype.reject = function(e) {
        return this.filter(qo(qt(e)));
      }, ce.prototype.slice = function(e, S) {
        e = ne(e);
        var K = this;
        return K.__filtered__ && (e > 0 || S < 0) ? new ce(K) : (e < 0 ? K = K.takeRight(-e) : e && (K = K.drop(e)), S !== E && (S = ne(S), K = S < 0 ? K.dropRight(-S) : K.take(S - e)), K);
      }, ce.prototype.takeRightWhile = function(e) {
        return this.reverse().takeWhile(e).reverse();
      }, ce.prototype.toArray = function() {
        return this.take(T);
      }, Yi(ce.prototype, function(e, S) {
        var K = /^(?:filter|find|map|reject)|While$/.test(S), ot = /^(?:head|last)$/.test(S), ut = ft[ot ? "take" + (S == "last" ? "Right" : "") : S], mt = ot || /^find/.test(S);
        ut && (ft.prototype[S] = function() {
          var xt = this.__wrapped__, bt = ot ? [1] : arguments, Mt = xt instanceof ce, Dt = bt[0], Rt = Mt || re(xt), Bt = function(le) {
            var pe = ut.apply(ft, yr([le], bt));
            return ot && Yt ? pe[0] : pe;
          };
          Rt && K && typeof Dt == "function" && Dt.length != 1 && (Mt = Rt = !1);
          var Yt = this.__chain__, Ft = !!this.__actions__.length, Qt = mt && !Yt, se = Mt && !Ft;
          if (!mt && Rt) {
            xt = se ? xt : new ce(this);
            var te = e.apply(xt, bt);
            return te.__actions__.push({ func: $o, args: [Bt], thisArg: E }), new wi(te, Yt);
          }
          return Qt && se ? e.apply(this, bt) : (te = this.thru(Bt), Qt ? ot ? te.value()[0] : te.value() : te);
        });
      }), bi(["pop", "push", "shift", "sort", "splice", "unshift"], function(e) {
        var S = bo[e], K = /^(?:push|sort|unshift)$/.test(e) ? "tap" : "thru", ot = /^(?:pop|shift)$/.test(e);
        ft.prototype[e] = function() {
          var ut = arguments;
          if (ot && !this.__chain__) {
            var mt = this.value();
            return S.apply(re(mt) ? mt : [], ut);
          }
          return this[K](function(xt) {
            return S.apply(re(xt) ? xt : [], ut);
          });
        };
      }), Yi(ce.prototype, function(e, S) {
        var K = ft[S];
        if (K) {
          var ot = K.name + "";
          Se.call(on, ot) || (on[ot] = []), on[ot].push({ name: S, func: K });
        }
      }), on[Yo(E, P).name] = [{
        name: "wrapper",
        func: E
      }], ce.prototype.clone = Nf, ce.prototype.reverse = Bf, ce.prototype.value = jf, ft.prototype.at = dy, ft.prototype.chain = fy, ft.prototype.commit = gy, ft.prototype.next = my, ft.prototype.plant = vy, ft.prototype.reverse = xy, ft.prototype.toJSON = ft.prototype.valueOf = ft.prototype.value = by, ft.prototype.first = ft.prototype.head, In && (ft.prototype[In] = yy), ft;
    }, en = gf();
    Ir ? ((Ir.exports = en)._ = en, $s._ = en) : Fe._ = en;
  }).call(Hr);
})(Ss, Ss.exports);
var Bw = Ss.exports;
const ws = /* @__PURE__ */ Cn(Bw);
N0(Sn);
D0(Sn);
L0(Sn);
R0(Sn);
let ls = null, He = Xe(null), Re = Xe("zh"), nh = Xe(""), ee = Xe(null);
const Pt = M0({
  //极值数据
  leftIndex: -1,
  //左侧上下限对应下标
  rightIndex: -1,
  //右侧上下限对应下标
  rightTwoIndex: -1,
  //右2上下限对应下标
  hasLeftAxis: !1,
  hasRightAxis: !1,
  hasRightTwoAxis: !1,
  hasXAxis: !1,
  leftMin: 0,
  leftMax: 0,
  rightMin: 0,
  rightMax: 0,
  rightTwoMin: 0,
  rightTwoMax: 0,
  xMin: 0,
  xMax: 0
});
let ci = !1, Nu = Xe(!1);
function jw() {
  return {
    options: ee,
    axisLimitState: Pt,
    chartRender: Ww,
    setLimitData: oM,
    isUseSelfLimit: Nu
  };
}
function Ww({ data: r, renderId: g, lang: E = "zh", changeLangIsCheck: a, showChartTitle: y = !0, shouldUseSelfLimit: R = !1 }) {
  Pt.leftIndex = -1, Pt.rightIndex = -1, Pt.rightTwoIndex = -1, Pt.hasLeftAxis = !1, Pt.hasRightAxis = !1, Pt.hasRightTwoAxis = !1, Pt.hasXAxis = !1, Nu.value || (Pt.leftMin = 0, Pt.leftMax = 0, Pt.rightMin = 0, Pt.rightMax = 0, Pt.rightTwoMin = 0, Pt.rightTwoMax = 0, Pt.xMin = 0, Pt.xMax = 0);
  let I = {};
  Re.value = E, nh.value = g, He.value = r, ci = R, r.ChartInfo.Source === 1 ? I = {
    1: Ap,
    2: Fw,
    3: sh,
    4: sh,
    5: Vw,
    6: sh,
    7: Kw,
    10: eM,
    11: rM
  }[r.ChartInfo.ChartType](r) : [2, 5].includes(r.ChartInfo.Source) ? I = Qw(r) : [3].includes(r.ChartInfo.Source) ? I = tM(r) : [4, 6, 7, 8].includes(r.ChartInfo.Source) ? I = Ap(r) : [9].includes(r.ChartInfo.Source) ? I = Uw(r) : r.ChartInfo.Source === 10 && (Pt.hasLeftAxis = !0, Pt.leftMin = r.ChartInfo.LeftMin ? Number(r.ChartInfo.LeftMin) : Number(r.DataResp.YMinValue), Pt.leftMax = r.ChartInfo.LeftMax ? Number(r.ChartInfo.LeftMax) : Number(r.DataResp.YMaxValue), Pt.hasXAxis = !0, Pt.xMin = r.ChartInfo.XMin ? Number(r.ChartInfo.XMin) : Number(r.DataResp.XMinValue), Pt.xMax = r.ChartInfo.XMax ? Number(r.ChartInfo.XMax) : Number(r.DataResp.XMaxValue), I = iM(r));
  let Z = zw();
  return ee.value = { ...fs, ...Z, ...I }, Hw(y), Gw(a), (I.series ? I.series.some(($) => $.chartType === "linear") : !1) ? ls = Sn.chart(nh.value, ee.value) : ls = Sn.stockChart(nh.value, ee.value), ls;
}
function zw() {
  if (!He.value.ChartInfo.ChartThemeStyle)
    return {};
  let r = JSON.parse(He.value.ChartInfo.ChartThemeStyle);
  return {
    legend: {
      ...fs.legend,
      ...r.legendOptions
    },
    chart: {
      ...fs.chart,
      ...r.drawOption
    },
    colors: r.colorsOptions
  };
}
function Fi(r, g) {
  const { MarkersLines: E, ChartType: a } = He.value.ChartInfo, { EdbInfoList: y } = He.value;
  return E ? JSON.parse(E).filter((H) => H.isShow && H.axis === r).map((H) => {
    let $ = r === 3 && g === "datetime", U;
    if ($) {
      let W = a === 2 ? new Date(y[0].DataList[1].DataList[0].DataTimestamp).getFullYear() : "";
      U = a === 2 ? (/* @__PURE__ */ new Date(`${W}-${H.value}`)).getTime() : new Date(H.value).getTime();
    } else
      U = Number(H.value);
    return {
      value: U,
      dashStyle: H.dashStyle,
      width: Number(H.lineWidth),
      color: H.color,
      label: {
        text: H.text || "",
        verticalAlign: H.textPosition,
        style: {
          color: H.textColor,
          fontSize: H.textFontSize
        }
      }
    };
  }) : [];
}
function Vi(r, g) {
  const { MarkersAreas: E, ChartType: a } = He.value.ChartInfo, { EdbInfoList: y } = He.value;
  return E ? JSON.parse(E).filter((H) => H.isShow && H.axis === r).map((H) => {
    let $ = r === 3 && g === "datetime", U, W;
    if ($) {
      let M = a === 2 ? new Date(y[0].DataList[1].DataList[0].DataTimestamp).getFullYear() : "";
      U = a === 2 ? (/* @__PURE__ */ new Date(`${M}-${H.fromValue}`)).getTime() : new Date(H.fromValue).getTime(), W = a === 2 ? (/* @__PURE__ */ new Date(`${M}-${H.toValue}`)).getTime() : new Date(H.toValue).getTime();
    } else
      U = Number(H.fromValue), W = Number(H.toValue);
    let N = {
      top: 12,
      middle: 0,
      bottom: -10
    };
    return {
      from: U,
      to: W,
      color: H.color,
      label: {
        text: H.text || "",
        verticalAlign: H.textPosition,
        y: N[H.textPosition],
        style: {
          color: H.textColor,
          fontSize: H.textFontSize
        }
      }
    };
  }) : [];
}
function Bu({ LatestDate: r, PredictChartColor: g }) {
  return {
    zoneAxis: "x",
    zones: [{
      value: new Date(r).getTime() + 1
    }, {
      dashStyle: "ShortDot",
      color: g
    }]
  };
}
function Yw(r) {
  return r ? {
    zoneAxis: "x",
    zones: [{
      value: new Date(r).getTime() + 1
    }, {
      dashStyle: "ShortDot"
    }]
  } : {};
}
function ju(r, g) {
  return Xt(g).diff(Xt(r), "years", !0) <= 1;
}
function oh(r, g) {
  const { IsAxis: E, IsOrder: a, EdbInfoType: y, LeadValue: R, LeadUnit: I } = r, Z = g == "zh" ? {
    0: "右轴",
    2: "右2轴"
  } : {
    0: "RHS",
    2: "2-RHS"
  }, H = g == "zh" ? {
    1: "逆序"
  } : {
    1: "REV"
  }, $ = g == "zh" ? {
    0: "领先"
  } : {
    0: "Lead"
  }, U = g === "zh" ? I : T0[I];
  let W = Z[E] || "", N = H[Number(a)] ? `${W ? "，" : ""}${H[Number(a)]}` : "", M = $[y] ? `${W || N ? "，" : ""}${$[y]}${R}${U}` : "";
  return W || N || M ? `(${W}${N}${M})` : "";
}
function Ms(r, g, E = "zh") {
  let a = "";
  const y = r.EdbNameEn ? `${r.EdbNameEn}${oh(r, "en")}` : "", R = g.length > 1 ? `${r.EdbAliasName || r.EdbName}(${r.SourceName})${oh(r, "zh")}` : `${r.EdbAliasName || r.EdbName}${oh(r, "zh")}`;
  if (a = E == "zh" ? R : y || R, a.length > 20) {
    let I = [];
    for (let Z = 0; Z < a.length / 20; Z++)
      I.push(a.slice(Z * 20, Z * 20 + 20));
    a = I.join("<br>");
  }
  return a;
}
function Wu(r) {
  let g = r.filter((y) => y.IsAxis === 1), E = r.filter((y) => !y.IsAxis), a = r.filter((y) => y.IsAxis === 2);
  return [g, E, a].flat(1 / 0);
}
function Xw() {
  let r = !0;
  return He.value.ChartInfo.ChartNameEn || (r = !1), He.value.EdbInfoList.forEach((g) => {
    g.EdbNameEn || (r = !1), He.value.ChartInfo.ChartType !== 10 && g.Unit && !g.UnitEn && (r = !1);
  }), r;
}
function Gw(r) {
  if (r && !Xw())
    return;
  const { ChartType: g, Source: E } = He.value.ChartInfo;
  E == 1 && (g == 5 ? (ee.value.yAxis.title.text = Re.value == "zh" ? ee.value.yAxis.title.textZh : ee.value.yAxis.title.textEn, ee.value.yAxis.title.style = Re.value == "zh" ? {} : ee.value.yAxis.title.styleEn, ee.value.xAxis.title.text = Re.value == "zh" ? ee.value.xAxis.title.textZh : ee.value.xAxis.title.textEn, ee.value.xAxis.title.style = Re.value == "zh" ? {} : ee.value.xAxis.title.styleEn, ee.value.series.forEach((a) => {
    a.name = Re.value == "zh" ? a.nameZh : a.nameEn;
  }), ee.value.tooltip.formatter = Re.value == "zh" ? ee.value.tooltip.formatterZh : ee.value.tooltip.formatterEn) : (ee.value.yAxis.forEach((a) => {
    a.title.text = Re.value == "zh" ? a.title.textZh : a.title.textEn, a.title.style = Re.value == "zh" ? {} : a.title.styleEn || {};
  }), g != 2 && ee.value.series.forEach((a) => {
    a.name = Re.value == "zh" ? a.nameZh : a.nameEn != "无英文名称" ? a.nameEn : `<span style="color:#999">${a.nameEn}</span>`;
  }), g === 10 && (ee.value.xAxis.title.text = Re.value == "zh" ? ee.value.xAxis.title.textZh : ee.value.xAxis.title.textEn, ee.value.xAxis.title.style = Re.value == "zh" ? {} : ee.value.xAxis.title.styleEn, ee.value.tooltip.formatter = Re.value == "zh" ? ee.value.tooltip.formatterCh : ee.value.tooltip.formatterEn, ee.value.series.forEach((a) => {
    a.linkedTo || a.data.forEach((y) => {
      y.dataLabels.format = Re.value == "zh" ? y.dataLabels.formatZh : y.dataLabels.formatEn || "无英文标签", y.dataLabels.color = Re.value === "en" && !y.dataLabels.formatEn ? "#999" : "#333";
    });
  })), [7, 11].includes(g) && (ee.value.xAxis.categories = He.value.XEdbIdValue.map((a) => Re.value == "zh" ? He.value.EdbInfoList.find((y) => y.EdbInfoId === a).EdbAliasName : He.value.EdbInfoList.find((y) => y.EdbInfoId === a).EdbNameEn)))), [2, 3, 4].includes(E) && (ee.value.yAxis.forEach((a) => {
    a.title.text = Re.value == "zh" ? a.title.textZh : a.title.textEn;
  }), ee.value.series.forEach((a) => {
    a.name = Re.value == "en" ? a.nameEn : a.nameZh;
  }), ee.value.tooltip.formatter = Re.value == "en" ? ee.value.tooltip.formatterEn : ee.value.tooltip.formatterZh, E == 2 && (ee.value.xAxis.categories = gn.value.map((a) => {
    Re.value == "en" ? a.NameEn : a.Name;
  })), [3].includes(E) && (ee.value.xAxis.title.text = Re.value == "en" ? ee.value.xAxis.title.textEn : ee.value.xAxis.title.textZh));
}
function Hw(r) {
  if (r) {
    const g = He.value.ChartInfo;
    ee.value.title.textZh = g.ChartName, ee.value.title.textEn = g.ChartNameEn, ee.value.title.text = Re.value == "zh" ? ee.value.title.textZh : ee.value.title.textEn || ee.value.title.textZh;
  } else
    ee.value.title.text = "";
}
function Uw(r) {
  Pt.leftIndex = -1, Pt.rightIndex = -1, Pt.rightTwoIndex = -1;
  const g = r.ChartInfo.ChartThemeStyle ? JSON.parse(r.ChartInfo.ChartThemeStyle) : null, { DataList: E, LeftMaxValue: a, LeftMinValue: y, RightMaxValue: R, RightMinValue: I } = r.DataResp, Z = {
    ...Mn,
    tickWidth: 1,
    labels: {
      style: {
        ...g && g.xAxisOptions.style
      }
    }
  };
  let H = [], $ = [];
  return E.forEach((W, N) => {
    let M = {
      ...Or,
      title: {
        text: W.Unit,
        textCh: W.Unit,
        // 中文
        textEn: W.UnitEn || W.Unit,
        align: "high",
        rotation: 0,
        y: -15,
        reserveSpace: !1,
        style: {
          ...g && g.yAxisOptions.style
        }
      },
      labels: {
        style: {
          ...g && g.yAxisOptions.style
        }
      },
      opposite: W.IsAxis !== 1,
      min: Number(N === 0 ? y : I),
      max: Number(N === 0 ? a : R),
      tickWidth: 1
    }, v = {
      data: W.Value.map((u) => [u.X, u.Y]),
      dashStyle: g && g.lineOptions.dashStyle || "Solid",
      type: g && g.lineOptions.lineType || "spline",
      yAxis: N,
      name: W.Name,
      nameZh: W.Name,
      nameEn: W.NameEn || W.Name,
      color: W.Color,
      lineWidth: g && g.lineOptions.lineWidth || 3,
      chartType: "linear",
      zIndex: 1
    };
    $.push(v), H.push(M);
  }), {
    title: {
      text: ""
    },
    tooltip: {
      formatter: function() {
        let W = E[0].Value.map((u) => u.X), N = W[1] - W[0], v = `<b>${`[${this.x},${this.x + N}]`}</b>`;
        return this.points.forEach((u) => {
          v += `<br><span style="color:${u.color}">●</span>${u.series.name}: ${u.y}%<br>`;
        }), v;
      },
      shared: !0
    },
    series: $,
    yAxis: H,
    xAxis: Z
  };
}
function Ap(r) {
  const g = r.ChartInfo.Source === 1, E = [4, 6, 7, 8].includes(r.ChartInfo.Source) ? [r.DataResp] : r.EdbInfoList;
  let a = [], y = [], R = {}, I = E.findIndex((u) => u.IsAxis === 1), Z = E.findIndex((u) => !u.IsAxis), H = E.findIndex((u) => u.IsAxis === 2);
  Pt.leftIndex = I, Pt.rightIndex = Z, Pt.rightTwoIndex = H;
  const $ = r.ChartInfo.ChartThemeStyle ? JSON.parse(r.ChartInfo.ChartThemeStyle) : null;
  let U = [], W = E.some((u) => u.IsAxis === 2) ? Wu(E) : E;
  W.forEach((u, d) => {
    let P = W.findIndex((s) => s.IsAxis === u.IsAxis), O = u.EdbName, B = W.filter(
      (s) => O === s.EdbName
    ), C = Ms(u, B, "zh"), b = Ms(u, B, "en"), w = u.EdbInfoCategoryType === 1 ? Bu(u) : {}, x = {
      data: [],
      dataGrouping: {
        enabled: !1
      },
      type: $ && $.lineOptions.lineType || "spline",
      dashStyle: $ && $.lineOptions.dashStyle || "Solid",
      yAxis: d,
      name: C,
      nameZh: C,
      nameEn: b,
      color: u.ChartColor,
      lineWidth: Number(u.ChartWidth),
      visible: !0,
      LatestDate: u.LatestDate,
      LatestValue: u.LatestValue,
      ...w
    };
    u.DataList = u.DataList || [];
    for (let s of u.DataList)
      x.data.push([s.DataTimestamp, s.Value]);
    a.push(x), u.IsAxis, console.log("useSelfLimit", ci);
    let h = 0, c = 0;
    if ((!ci || !g) && (h = u.MinData, c = u.MaxData), ci && g) {
      const s = {
        0: ["rightMin", "rightMax"],
        1: ["leftMin", "leftMax"],
        2: ["rightTwoMin", "rightTwoMax"]
      };
      s[u.IsAxis] && (h = Pt[`${s[u.IsAxis][0]}`] || 0, c = Pt[`${s[u.IsAxis][1]}`] || 0);
    }
    const p = u.ConvertUnit || u.Unit, i = u.ConvertEnUnit || u.UnitEn || u.ConvertUnit || u.Unit;
    let l = {
      ...Or,
      IsAxis: u.IsAxis,
      labels: {
        formatter: function(s) {
          return P !== d ? "" : s.value;
        },
        align: "center",
        x: [0, 2].includes(u.IsAxis) ? 5 : -5,
        style: {
          ...$ && $.yAxisOptions.style
        }
      },
      tickWidth: P !== d ? 0 : 1,
      title: {
        text: P !== d ? "" : `${p}`,
        textZh: p,
        //中文单位
        textEn: p ? i : "",
        //英文单位，但如果无中文单位则不显示
        align: "high",
        rotation: 0,
        y: -15,
        x: u.IsAxis === 0 && H > -1 ? -W[H].Unit.length * 12 : 0,
        textAlign: u.IsAxis === 1 ? "left" : "right",
        reserveSpace: !1,
        style: {
          ...$ && $.yAxisOptions.style
        }
      },
      opposite: [0, 2].includes(u.IsAxis),
      reversed: u.IsOrder,
      min: Number(h),
      max: Number(c),
      visible: P === d,
      chartEdbInfo: u,
      //指标数据用于在保存时读取指标数据
      plotBands: Vi(u.IsAxis),
      plotLines: Fi(u.IsAxis)
    };
    y.push(l), u.DataList.length > 0 && (U.push(u.DataList[0].DataTimestamp), U.push(u.DataList[u.DataList.length - 1].DataTimestamp));
  });
  let N = Math.min.apply(null, U), M = Math.max.apply(null, U);
  const v = ju(N, M);
  return R = {
    ...Wp,
    labels: {
      formatter: function(u) {
        return v ? Qn.dateFormat("%m/%d", u.value) : Qn.dateFormat("%y/%m", u.value);
      },
      style: {
        ...$ && $.xAxisOptions.style
      }
    },
    tickInterval: (M - N) / 6 / (24 * 3600 * 1e3) > 30 ? (M - N) / 6 : 24 * 3600 * 1e3 * 30,
    plotBands: Vi(3, "datetime"),
    plotLines: Fi(3, "datetime")
  }, y.forEach((u) => {
    u.IsAxis === 1 ? (Pt.hasLeftAxis = !0, (!ci || !g) && (Pt.leftMin = E[I].MinData, Pt.leftMax = E[I].MaxData, u.min = E[I].MinData, u.max = E[I].MaxData)) : u.IsAxis === 2 ? (Pt.hasRightTwoAxis = !0, (!ci || !g) && (Pt.rightTwoMin = E[H].MinData, Pt.rightTwoMax = E[H].MaxData, u.min = E[H].MinData, u.max = E[H].MaxData)) : (Pt.hasRightAxis = !0, (!ci || !g) && (Pt.rightMin = E[Z].MinData, Pt.rightMax = E[Z].MaxData, u.min = E[Z].MinData, u.max = E[Z].MaxData));
  }), {
    series: a,
    xAxis: [R],
    yAxis: y,
    rangeSelector: { enabled: !1 }
  };
}
function Fw(r) {
  Pt.leftIndex = 0, Pt.rightIndex = -1, Pt.rightTwoIndex = -1;
  const g = r.ChartInfo.ChartThemeStyle ? JSON.parse(r.ChartInfo.ChartThemeStyle) : null;
  let E = {};
  const a = r.EdbInfoList[0], y = r.ChartInfo.Calendar || "公历", R = g && g.colorsOptions.reverse();
  let I = [], Z = [];
  const H = y === "农历" ? a.DataList.filter((v, u) => u > 0) : a.DataList;
  H.forEach((v, u) => {
    let d = a.EdbInfoCategoryType === 1 ? Yw(v.CuttingDataTimestamp) : {}, P = {
      data: [],
      dataGrouping: {
        enabled: !1
      },
      type: g && g.lineOptions.lineType || a.ChartStyle,
      dashStyle: g && g.lineOptions.dashStyle || "Solid",
      yAxis: 0,
      name: v.ChartLegend,
      lineWidth: g && g.lineOptions.lineWidth || 1,
      color: R.slice(-H.length)[u],
      visible: !0,
      ...d
    };
    v.DataList = v.DataList || [];
    for (let O of v.DataList)
      P.data.push([O.DataTimestamp, O.Value]);
    I.push(P);
  });
  let $ = 0, U = 0;
  ci ? ($ = Pt.leftMin || 0, U = Pt.leftMax || 0) : ($ = a.MinData, U = a.MaxData);
  const W = a.ConvertUnit || a.Unit, N = a.ConvertEnUnit || a.UnitEn || a.ConvertUnit || a.Unit;
  Z = [{
    IsAxis: a.IsAxis,
    labels: {
      align: "center",
      y: 5,
      style: {
        ...g && g.yAxisOptions.style
      }
    },
    title: {
      text: `${W}`,
      textZh: W,
      // 中文
      // 中文不存在，无论英文有无都显示空
      textEn: W ? N || "英文单位" : "",
      // 英文
      align: "high",
      rotation: 0,
      y: -5,
      x: 0,
      textAlign: "left",
      reserveSpace: !1,
      style: {
        ...g && g.yAxisOptions.style
      }
    },
    max: Number(U),
    min: Number($),
    plotBands: Vi(1),
    plotLines: Fi(1),
    lineWidth: 1,
    lineColor: "#bfbfbf",
    tickColor: "#bfbfbf",
    offset: 0,
    opposite: !1,
    reversed: !1,
    visible: !0,
    gridLineWidth: 0,
    tickWidth: 1,
    tickLength: 5,
    tickPosition: "inside",
    endOnTick: !1,
    startOnTick: !1,
    showLastLabel: !0,
    //显示最后刻度值
    tickPixelInterval: 50
    // chartEdbInfo:item//指标数据
  }], E.series = I, E.yAxis = Z, Pt.hasLeftAxis = !0, ci || (Pt.leftMin = Number(a.MinData), Pt.leftMax = Number(a.MaxData));
  let M = {
    tickPosition: "inside",
    lineColor: "#bfbfbf",
    tickColor: "#bfbfbf",
    tickLength: 5,
    type: "datetime",
    ordinal: !1,
    dateTimeLabelFormats: {
      day: "%y/%m",
      week: "%y/%m",
      month: "%y/%m",
      year: "%y/%m"
    },
    labels: {
      formatter: (v) => Qn.dateFormat("%m/%d", v.value),
      style: {
        ...g && g.xAxisOptions.style
      }
    },
    tickInterval: 24 * 3600 * 1e3 * 60,
    //季节图
    plotBands: Vi(3, "datetime"),
    plotLines: Fi(3, "datetime")
  };
  return E.xAxis = [M], E.tooltip = {
    split: !1,
    shared: !0,
    dateTimeLabelFormats: {
      // 时间格式化字符
      day: "%m/%d",
      week: "%m/%d",
      month: "%m/%d",
      year: "%m/%d"
    },
    xDateFormat: "%m/%d"
  }, {
    ...E
    // title: {
    //     enabled: true,
    //     text:e.ChartInfo.ChartName
    // },
    // legend:{
    //     enabled:true,
    //     verticalAlign: 'top',
    //     y:-10,
    //     x:(10 * data.Unit.length)/2
    // }
  };
}
function sh(r) {
  const g = r.EdbInfoList;
  let a = {
    3: "areaspline",
    4: "column",
    6: ""
  }[r.ChartInfo.ChartType];
  const y = r.ChartInfo.ChartThemeStyle ? JSON.parse(r.ChartInfo.ChartThemeStyle) : null;
  let R = [], I = [], Z = {}, H, $, U, W = [], N = g.some((d) => d.IsAxis === 2) ? Wu(g) : g;
  N.forEach((d, P) => {
    let O = N.findIndex((n) => n.IsAxis === d.IsAxis), B = P;
    [3, 4].includes(r.ChartInfo.ChartType) ? B = 0 : r.ChartInfo.ChartType === 6 && ["areaspline", "column"].includes(d.ChartStyle) && (B = N.findIndex((n) => n.ChartStyle === d.ChartStyle)), d.IsAxis = B === P ? d.IsAxis : N[B].IsAxis, d.IsOrder = B === P ? d.IsOrder : N[B].IsOrder, H = [3, 4].includes(r.ChartInfo.ChartType) ? N[B].IsAxis ? B : -1 : g.findIndex((n) => n.IsAxis === 1), $ = [3, 4].includes(r.ChartInfo.ChartType) ? N[B].IsAxis ? -1 : B : g.findIndex((n) => !n.IsAxis), U = [3, 4].includes(r.ChartInfo.ChartType) ? -1 : g.findIndex((n) => n.IsAxis === 2), Pt.leftIndex = H, Pt.rightIndex = $, Pt.rightTwoIndex = U;
    let C = d.EdbName, b = N.filter(
      (n) => C === n.EdbName
    ), w = Ms(d, b, "zh"), x = Ms(d, b, "en"), h = d.EdbInfoCategoryType === 1 ? Bu(d) : {}, c = {
      data: [],
      dataGrouping: {
        enabled: !1
      },
      type: a || d.ChartStyle,
      yAxis: B,
      name: w,
      nameZh: w,
      nameEn: x,
      color: d.ChartColor,
      lineWidth: Number(d.ChartWidth),
      fillColor: r.ChartInfo.ChartType === 3 || r.ChartInfo.ChartType === 6 && d.ChartStyle === "areaspline" ? d.ChartColor : void 0,
      visible: !0,
      LatestDate: d.LatestDate,
      LatestValue: d.LatestValue,
      ...h
    };
    d.DataList = d.DataList || [];
    for (let n of d.DataList)
      c.data.push([n.DataTimestamp, n.Value]);
    R.push(c);
    let p = 0, i = 0;
    if (!ci)
      p = N[O].MinData, i = N[O].MaxData;
    else {
      const n = {
        0: ["rightMin", "rightMax"],
        1: ["leftMin", "leftMax"],
        2: ["rightTwoMin", "rightTwoMax"]
      };
      n[d.IsAxis] && (p = Pt[`${n[d.IsAxis][0]}`] || 0, i = Pt[`${n[d.IsAxis][1]}`] || 0);
    }
    d.IsAxis;
    const l = d.ConvertUnit || d.Unit, s = d.ConvertEnUnit || d.UnitEn || d.ConvertUnit || d.Unit;
    let t = {
      ...Or,
      IsAxis: d.IsAxis,
      labels: {
        formatter: function(n) {
          return O !== P ? "" : n.value;
        },
        align: "center",
        x: [0, 2].includes(d.IsAxis) ? 5 : -5,
        style: {
          ...y && y.yAxisOptions.style
        }
      },
      title: {
        // text:  sameSideIndex !== index ? '' : `${item.Unit}`,
        text: l,
        textZh: l,
        // 中文
        // 中文不存在，无论英文有无都显示空
        textEn: l ? s || "英文单位" : "",
        // 英文
        align: "high",
        rotation: 0,
        y: -15,
        x: d.IsAxis === 0 && U > -1 ? -N[U].Unit.length * 12 : 0,
        textAlign: d.IsAxis === 1 ? "left" : "right",
        reserveSpace: !1,
        style: {
          ...y && y.yAxisOptions.style
        }
      },
      opposite: [0, 2].includes(d.IsAxis),
      reversed: d.IsOrder,
      min: Number(p),
      max: Number(i),
      tickWidth: O !== P ? 0 : 1,
      visible: B === P && O === P,
      plotBands: Vi(d.IsAxis),
      plotLines: Fi(d.IsAxis),
      chartEdbInfo: d
      //指标数据用于在保存时读取指标数据
    };
    I.push(t), d.DataList.length > 0 && (W.push(d.DataList[0].DataTimestamp), W.push(d.DataList[d.DataList.length - 1].DataTimestamp));
  });
  let M = Math.min.apply(null, W), v = Math.max.apply(null, W);
  const u = ju(M, v);
  return Z = {
    ...Wp,
    labels: {
      formatter: function(d) {
        return u ? Qn.dateFormat("%m/%d", d.value) : Qn.dateFormat("%y/%m", d.value);
      },
      style: {
        ...y && y.xAxisOptions.style
      }
    },
    tickInterval: (v - M) / 6 / (24 * 3600 * 1e3) > 30 ? (v - M) / 6 : 24 * 3600 * 1e3 * 30,
    plotBands: Vi(3, "datetime"),
    plotLines: Fi(3, "datetime")
  }, I.forEach((d) => {
    d.IsAxis === 1 ? (Pt.hasLeftAxis = !0, ci || (Pt.leftMin = g[H].MinData, Pt.leftMax = g[H].MaxData, d.min = g[H].MinData, d.max = g[H].MaxData)) : d.IsAxis === 2 ? (Pt.hasRightTwoAxis = !0, ci || (Pt.rightTwoMin = g[U].MinData, Pt.rightTwoMax = g[U].MaxData, d.min = g[U].MinData, d.max = g[U].MaxData)) : (Pt.hasRightAxis = !0, ci || (Pt.rightMin = g[$].MinData, Pt.rightMax = g[$].MaxData, d.min = g[$].MinData, d.max = g[$].MaxData));
  }), {
    series: R,
    xAxis: Z,
    yAxis: I,
    rangeSelector: { enabled: !1 }
  };
}
function Vw(r) {
  Pt.leftIndex = 1, Pt.rightIndex = -1, Pt.rightTwoIndex = -1;
  const g = r.EdbInfoList, { ChartInfo: E } = r, a = E.ChartThemeStyle ? JSON.parse(E.ChartThemeStyle) : null;
  Pt.hasLeftAxis = !0;
  const y = [];
  let R = {}, I = ws.cloneDeep(g)[0].DataList || [], Z = ws.cloneDeep(g)[1].DataList || [];
  I.forEach((B) => {
    Z.forEach((C) => {
      if (B.DataTimestamp === C.DataTimestamp) {
        let b = B.Value + "_" + C.Value;
        R[b] ? R[b].push(Xt(B.DataTimestamp).format("YYYY/MM/DD")) : R[b] = [Xt(B.DataTimestamp).format("YYYY/MM/DD")], y.push({
          x: B.Value,
          y: C.Value
        });
      }
    });
  }), y.sort((B, C) => B - C);
  let H = {
    formatter: function() {
      return `<strong>${R[this.x + "_" + this.y].length > 4 ? R[this.x + "_" + this.y].slice(0, 4).join() + "..." : R[this.x + "_" + this.y].join()}</strong><br>
            ${g[0].EdbName}: <span style="font-weight: 600">	${this.x}</span><br>
            ${g[1].EdbName}: <span style="font-weight: 600">	${this.y}</span>
            `;
    },
    // 中文
    formatterCh: function() {
      return `<strong>${R[this.x + "_" + this.y].length > 4 ? R[this.x + "_" + this.y].slice(0, 4).join() + "..." : R[this.x + "_" + this.y].join()}</strong><br>
            ${g[0].EdbName}: <span style="font-weight: 600">	${this.x}</span><br>
            ${g[1].EdbName}: <span style="font-weight: 600">	${this.y}</span>
            `;
    },
    // 英文
    formatterEn: function() {
      let B = `${g[0].EdbNameEn}`, C = `${g[1].EdbNameEn}`;
      return `<strong>${R[this.x + "_" + this.y].length > 4 ? R[this.x + "_" + this.y].slice(0, 4).join() + "..." : R[this.x + "_" + this.y].join()}</strong><br>
            ${B}: <span style="font-weight: 600">	${this.x}</span><br>
            ${C}: <span style="font-weight: 600">	${this.y}</span>
            `;
    }
  };
  const { IsOrder: $, ChartColor: U } = g[0];
  let W = 0, N = 0;
  ci ? (W = Pt.leftMin || 0, N = Pt.leftMax || 0) : (W = r.ChartInfo.LeftMin || 0, N = r.ChartInfo.LeftMax || 0), console.log("check limit", W, N);
  const M = g[1].ConvertUnit || g[1].Unit, v = g[1].ConvertEnUnit || g[1].UnitEn || g[1].ConvertUnit || g[1].Unit;
  let u = {
    title: {
      text: `${M}`,
      textZh: M,
      textEn: M ? v : "",
      align: "high",
      rotation: 0,
      y: -15,
      x: 0,
      textAlign: "left",
      reserveSpace: !1,
      style: {
        ...a && a.yAxisOptions.style
      }
    },
    labels: {
      formatter: function(B) {
        return B.value;
      },
      align: "center",
      style: {
        ...a && a.yAxisOptions.style
      }
    },
    opposite: !1,
    reversed: $,
    min: Number(W),
    max: Number(N),
    tickWidth: 1,
    tickLength: 5,
    lineWidth: 1,
    lineColor: "#bfbfbf",
    tickColor: "#bfbfbf",
    offset: 0,
    visible: !0,
    gridLineWidth: 0,
    tickPosition: "inside",
    endOnTick: !1,
    startOnTick: !1,
    showLastLabel: !0,
    tickPixelInterval: 50,
    plotBands: Vi(1),
    plotLines: Fi(1)
  }, d = {
    data: [],
    type: "scatter",
    name: `${E.ChartName}${$ ? "(逆序)" : ""}`,
    nameZh: `${E.ChartName}${$ ? "(逆序)" : ""}`,
    nameEn: E.ChartNameEn ? `${E.ChartNameEn}${$ ? "(reverse)" : ""}` : "",
    color: U,
    visible: !0,
    chartType: "linear",
    marker: {
      radius: a && a.lineOptions.radius || 5
    }
  };
  y.forEach((B) => {
    d.data.push([B.x, B.y]);
  });
  const P = g[0].ConvertUnit || g[0].Unit, O = g[0].ConvertEnUnit || g[0].UnitEn || g[0].ConvertUnit || g[0].Unit;
  return {
    title: {
      text: ""
    },
    series: [d],
    yAxis: u,
    xAxis: {
      ...Mn,
      title: {
        text: `${P}`,
        textZh: P,
        textEn: P ? O : "",
        align: "high",
        rotation: 0,
        x: 0,
        offset: 20,
        style: {
          ...a && a.xAxisOptions.style
        }
      },
      labels: {
        style: {
          ...a && a.xAxisOptions.style
        }
      }
    },
    tooltip: H
  };
}
const zu = Xe([]), Yu = Xe([]), $w = Xe([]);
function Zw(r) {
  let g = [];
  const E = ws.cloneDeep(zu.value), a = r.ChartInfo.ChartThemeStyle ? JSON.parse(r.ChartInfo.ChartThemeStyle) : null;
  let y = {
    ...Mn,
    categories: Yu.value,
    tickWidth: 1,
    labels: {
      style: {
        ...a && a.xAxisOptions.style
      }
    }
  };
  const { leftMin: R, leftMax: I } = Pt;
  let Z = {
    ...Or,
    title: {
      text: "",
      textZh: "",
      textEn: "",
      align: "high",
      rotation: 0,
      y: -15,
      x: 0,
      textAlign: "left",
      reserveSpace: !1,
      style: {
        ...a && a.yAxisOptions.style
      }
    },
    labels: {
      formatter: function(H) {
        return H.value;
      },
      align: "center",
      style: {
        ...a && a.yAxisOptions.style
      }
    },
    min: Number(R),
    max: Number(I),
    opposite: !1,
    tickWidth: 1,
    plotBands: Vi(1),
    plotLines: Fi(1)
  };
  return E.forEach((H) => {
    let $ = {
      data: H.Value,
      type: "column",
      yAxis: 0,
      name: H.Name || H.Date,
      nameZh: H.Name || H.Date,
      nameEn: H.Date,
      color: H.Color,
      chartType: "linear",
      visible: !0
    };
    g.push($);
  }), {
    title: {
      text: ""
    },
    plotOptions: {
      column: {
        stacking: null
      }
    },
    series: g,
    yAxis: [Z],
    xAxis: y
  };
}
function Kw(r) {
  const { XEdbIdValue: g, YDataList: E, EdbInfoList: a, ChartInfo: y } = r;
  let R = g.map((I) => a.find((Z) => Z.EdbInfoId === I).EdbAliasName);
  return Pt.leftIndex = -1, Pt.rightIndex = -1, Pt.rightTwoIndex = -1, zu.value = E, Yu.value = R, $w.value = a, Pt.hasLeftAxis = !0, Pt.leftMin = Number(y.LeftMin), Pt.leftMax = Number(y.LeftMax), Zw(r);
}
const Xu = Xe([]), gn = Xe([]), Ar = Xe([]), Jw = (r, g) => {
  Pt.leftIndex = -1, Pt.rightIndex = -1, Pt.rightTwoIndex = -1;
  const E = He.value.ChartInfo.ChartThemeStyle ? JSON.parse(He.value.ChartInfo.ChartThemeStyle) : null;
  let a = [];
  const y = ws.cloneDeep(Xu.value);
  console.log(y);
  let R = {
    ...Mn,
    categories: gn.value.map((H) => H.Name),
    tickWidth: 1,
    labels: {
      style: {
        ...E && E.xAxisOptions.style
      }
    }
  }, I = {
    ...Or,
    title: {
      text: Ar.value[0].Unit,
      textZh: Ar.value[0].Unit,
      textEn: Ar.value[0].Unit ? Ar.value[0].UnitEn || "英文单位" : "",
      align: "high",
      rotation: 0,
      y: -15,
      textAlign: "left",
      reserveSpace: !1,
      style: {
        ...E && E.yAxisOptions.style
      }
    },
    labels: {
      formatter: function(H) {
        return H.value;
      },
      align: "center",
      style: {
        ...E && E.yAxisOptions.style
      }
    },
    min: Number(r),
    max: Number(g),
    opposite: !1,
    tickWidth: 1
  };
  return y.forEach((H) => {
    let U = {
      data: qw(H),
      type: E && E.lineOptions.lineType || "spline",
      dashStyle: E && E.lineOptions.dashStyle || "Solid",
      yAxis: 0,
      name: H.Name,
      nameZh: H.Name,
      nameEn: H.NameEn,
      color: H.Color,
      chartType: "linear",
      lineWidth: E && E.lineOptions.lineWidth || 3,
      visible: !0,
      marker: {
        enabled: !1
      }
    };
    a.push(U);
  }), {
    title: {
      text: ""
    },
    series: a,
    yAxis: [I],
    xAxis: R,
    tooltip: {
      formatter: function() {
        const H = this;
        let $ = "";
        return H.points.forEach((U) => {
          let W = y.find((v) => v.Name === U.series.name), N = gn.value.findIndex((v) => v.Name === H.x);
          if (W.XEdbInfoIdList[N]) {
            let v = He.value.ChartInfo.Source === 5 ? N === 0 ? W.NameList[N] : `${He.value.DataResp.ProfitName}(${W.NameList[N]})` : Ar.value.find((u) => u.EdbInfoId === W.XEdbInfoIdList[N]).EdbName;
            $ += `<b>${v}</b>`, W.NoDataEdbList.includes(W.XEdbInfoIdList[N]) ? $ += `<br><span style="color:${U.color}">●</span>${W.Date}: 无<br>` : $ += `<br><span style="color:${U.color}">●</span>${W.Date}: ${U.y}<br>`;
          }
        }), $ || "无合约";
      },
      formatterCh: function() {
        let H = "";
        return this.points.forEach(($) => {
          let U = y.find((N) => N.Name === $.series.name), W = gn.value.findIndex((N) => N.Name === this.x);
          H += `<b>${Ar.value.find((N) => N.EdbInfoId === U.XEdbInfoIdList[W]).EdbName}</b>`, U.NoDataEdbList.includes(U.XEdbInfoIdList[W]) ? H += `<br><span style="color:${$.color}">●</span>${U.Date}: 无<br>` : H += `<br><span style="color:${$.color}">●</span>${U.Date}: ${$.y}<br>`;
        }), H;
      },
      formatterEn: function() {
        let H = "";
        return this.points.forEach(($) => {
          let U = y.find((N) => N.NameEn === $.series.name), W = gn.value.findIndex((N) => N.NameEn === this.x);
          H += `<b>${Ar.value.find((N) => N.EdbInfoId === U.XEdbInfoIdList[W]).EdbNameEn}</b>`, U.NoDataEdbList.includes(U.XEdbInfoIdList[W]) ? H += `<br><span style="color:${$.color}">●</span>${U.Date}: 无<br>` : H += `<br><span style="color:${$.color}">●</span>${U.Date}: ${$.y}<br>`;
        }), H;
      },
      shared: !0
    }
  };
};
function qw(r) {
  let g = r.XEdbInfoIdList.filter((R) => !r.NoDataEdbList.includes(R)), E = r.XEdbInfoIdList.findIndex((R) => R === g[0]), a = r.XEdbInfoIdList.findIndex((R) => R === g[g.length - 1]);
  return r.Value.map((R, I) => I < E || I > a ? null : R);
}
function Qw(r) {
  const { XDataList: g, YDataList: E, EdbInfoList: a, ChartInfo: y, DataResp: R } = r;
  return Ar.value = a, Xu.value = y.Source === 5 ? R.YDataList : E, gn.value = y.Source === 5 ? R.XDataList : g, Pt.hasLeftAxis = !0, Pt.leftMin = Number(y.LeftMin), Pt.leftMax = Number(y.LeftMax), Jw(y.LeftMin, y.LeftMax);
}
function tM(r) {
  const g = r.ChartInfo.ChartThemeStyle ? JSON.parse(r.ChartInfo.ChartThemeStyle) : null;
  Pt.leftIndex = -1, Pt.rightIndex = -1, Pt.rightTwoIndex = -1;
  let E = {
    categories: r.ChartInfo.Source === 3 ? r.XEdbIdValue : r.DataResp.XDateTimeValue,
    tickWidth: 1,
    title: {
      text: r.ChartInfo.Source === 3 ? `期数（${r.CorrelationChartInfo.LeadUnit}）` : null,
      textZh: r.ChartInfo.Source === 3 ? `期数（${r.CorrelationChartInfo.LeadUnit}）` : null,
      textEn: r.ChartInfo.Source === 3 ? `stage（${bp[r.CorrelationChartInfo.LeadUnit]}）` : null,
      align: "high",
      rotation: 0,
      x: 0,
      y: 10,
      offset: 20,
      style: {
        ...g && g.xAxisOptions.style
      }
    },
    labels: {
      style: {
        ...g && g.xAxisOptions.style
      }
    },
    tickInterval: 1,
    offset: 0,
    tickmarkPlacement: "on"
  }, a = {
    ...Or,
    title: {
      text: "相关性系数",
      textZh: "相关性系数",
      textEn: "Correlation coefficient",
      align: "high",
      rotation: 0,
      y: -15,
      textAlign: "left",
      reserveSpace: !1,
      style: {
        ...g && g.yAxisOptions.style
      }
    },
    labels: {
      formatter: function($) {
        return $.value;
      },
      align: "center",
      style: {
        ...g && g.yAxisOptions.style
      }
    },
    opposite: !1,
    tickWidth: 1
  }, y = [];
  r.YDataList.forEach(($) => {
    let U = {
      data: $.Value,
      type: g && g.lineOptions.lineType || "spline",
      dashStyle: g && g.lineOptions.dashStyle || "Solid",
      yAxis: 0,
      name: r.ChartInfo.ChartName,
      nameZh: r.ChartInfo.ChartName,
      nameEn: r.ChartInfo.ChartNameEn,
      color: "#00f",
      chartType: "linear",
      lineWidth: g && g.lineOptions.lineWidth || 3,
      visible: !0,
      marker: {
        enabled: !1
      }
    };
    y.push(U);
  });
  const { LeadValue: R, LeadUnit: I } = r.CorrelationChartInfo, { Source: Z } = r.ChartInfo;
  let H = {
    formatter: function() {
      return `<p>相关性系数：${this.y.toFixed(4)}</p><br><p>领先${Z === 3 ? this.x + "期" : R + I}</p>`;
    },
    formatterCh: function() {
      return `<p>相关性系数：${this.y.toFixed(4)}</p><br><p>领先${Z === 3 ? this.x + "期" : R + I}</p>`;
    },
    formatterEn: function() {
      return `<p>Correlation coefficient：${this.y.toFixed(4)}</p><br><p>lead${Z === 3 ? this.x + "stage" : R + bp[I]}</p>`;
    }
  };
  return Bp(() => {
    ee.value = {
      isRelevanceChart: r.ChartInfo.Source === 3,
      title: {
        text: ""
      },
      series: y,
      yAxis: [a],
      xAxis: E,
      tooltip: H
    }, ls.update(ee.value, !0);
  }), {
    isRelevanceChart: !0,
    title: {
      text: ""
    },
    series: y,
    yAxis: [a],
    xAxis: E,
    tooltip: H
  };
}
function eM({ DataResp: r, ChartInfo: g }) {
  Pt.leftIndex = -1, Pt.rightIndex = -1, Pt.rightTwoIndex = -1;
  const E = g.ChartThemeStyle ? JSON.parse(g.ChartThemeStyle) : null, { DataList: a, XName: y, XNameEn: R, XUnitName: I, XUnitNameEn: Z, YName: H, YNameEn: $, YUnitName: U, YUnitNameEn: W } = r, N = Number(r.YMinValue), M = Number(r.YMaxValue), v = Number(r.XMinValue), u = Number(r.XMaxValue);
  Pt.hasLeftAxis = !0, Pt.hasXAxis = !0, Pt.leftMin = N, Pt.leftMax = M, Pt.xMin = v, Pt.xMax = u;
  let d = {
    ...Or,
    title: {
      text: H,
      textZh: H,
      // 中文
      textEn: $ || "",
      style: {
        ...E && E.yAxisOptions.style
      },
      align: "middle"
    },
    labels: {
      style: {
        ...E && E.yAxisOptions.style
      }
    },
    opposite: !1,
    reversed: !1,
    min: Number(N),
    max: Number(M),
    tickWidth: 1,
    plotBands: Vi(1),
    plotLines: Fi(1)
  }, P = {
    ...Mn,
    title: {
      text: y,
      textZh: y,
      // 中文
      textEn: R || "",
      style: {
        ...E && E.xAxisOptions.style
      },
      align: "middle"
    },
    labels: {
      style: {
        ...E && E.xAxisOptions.style
      }
    },
    min: Number(v),
    max: Number(u),
    plotBands: Vi(3),
    plotLines: Fi(3)
  }, O = [];
  return a.forEach((C) => {
    let b = {
      data: [],
      type: "scatter",
      name: C.Name,
      nameZh: C.Name,
      nameEn: C.NameEn,
      color: C.Color,
      lineWidth: 0,
      chartType: "linear",
      zIndex: 1,
      visible: !0,
      marker: {
        radius: E && E.lineOptions.radius || 5
      }
    };
    if (C.EdbInfoList.forEach((w) => {
      b.data.push({
        x: w.XValue,
        y: w.YValue,
        dataLabels: {
          enabled: w.IsShow,
          allowOverlap: !0,
          align: "left",
          format: w.Name,
          formatZh: w.Name,
          formatEn: w.NameEn
        }
      });
    }), O.push(b), C.ShowTrendLine) {
      let x = {
        data: C.TrendLimitData.map((h, c) => c === C.TrendLimitData.length - 1 ? {
          x: h.X,
          y: h.Y,
          dataLabels: {
            enabled: C.ShowRSquare || C.ShowFitEquation,
            align: "left",
            color: "#666",
            x: 20,
            y: 30,
            zIndex: 9,
            allowOverlap: !0,
            formatter: function() {
              let p = "";
              return C.ShowRSquare && C.ShowFitEquation ? p = `<span>${C.TrendLine}</span><br><span>R²=${C.RSquare}</span>` : C.ShowRSquare && !C.ShowFitEquation ? p = `<span>R²=${C.RSquare}</span>` : C.ShowFitEquation && !C.ShowRSquare && (p = `<span>${C.TrendLine}</span>`), p;
            }
          }
        } : {
          x: h.X,
          y: h.Y
        }),
        type: "spline",
        linkedTo: ":previous",
        color: C.Color,
        lineWidth: 1,
        chartType: "linear",
        enableMouseTracking: !1,
        dashStyle: "Dash",
        zIndex: 2,
        visible: !0,
        marker: {
          enabled: !1
        }
      };
      O.push(x);
    }
  }), {
    title: {
      text: ""
    },
    series: O,
    yAxis: [d],
    xAxis: P,
    tooltip: {
      formatter: function() {
        let b = a.find((x) => x.Name === this.series.name).EdbInfoList.find((x) => x.XValue === this.x && x.YValue === this.y), w = `<b>${b.Name}</b>`;
        return w += `<br><span style="color:${this.color}">●</span>${b.XName}: ${this.x} ${b.XDate}<br>`, w += `<span style="color:${this.color}">●</span>${b.YName}: ${this.y} (${b.YDate})`, w;
      },
      formatterCh: function() {
        let b = a.find((x) => x.Name === this.series.name).EdbInfoList.find((x) => x.XValue === this.x && x.YValue === this.y), w = `<b>${b.Name}</b>`;
        return w += `<br><span style="color:${this.color}">●</span>${b.XName}: ${this.x} ${b.XDate}<br>`, w += `<span style="color:${this.color}">●</span>${b.YName}: ${this.y} (${b.YDate})`, w;
      },
      formatterEn: function() {
        let b = a.find((x) => x.NameEn === this.series.name).EdbInfoList.find((x) => x.XValue === this.x && x.YValue === this.y), w = `<b>${b.NameEn}</b>`;
        return w += `<br><span style="color:${this.color}">●</span>${b.XNameEn}: ${this.x} ${b.XDate}<br>`, w += `<span style="color:${this.color}">●</span>${b.YNameEn}: ${this.y} ${b.YDate}`, w;
      }
    }
  };
}
function iM({ DataResp: r, EdbInfoList: g, ChartInfo: E }) {
  Pt.leftIndex = -1, Pt.rightIndex = -1, Pt.rightTwoIndex = -1;
  const a = E.ChartThemeStyle ? JSON.parse(E.ChartThemeStyle) : null, { DataList: y, XName: R, YName: I, XNameEn: Z, YNameEn: H, XMaxValue: $, XMinValue: U, YMaxValue: W, YMinValue: N } = r, { leftMin: M, leftMax: v, xMin: u, xMax: d } = Pt;
  let P = {
    ...Or,
    title: {
      text: I,
      textCh: I,
      // 中文
      textEn: H || I,
      align: "middle",
      style: {
        ...a && a.xAxisOptions.style
      }
    },
    labels: {
      style: {
        ...a && a.xAxisOptions.style
      }
    },
    opposite: !1,
    reversed: !1,
    min: Number(M),
    max: Number(v),
    tickWidth: 1
  }, O = {
    ...Mn,
    title: {
      text: R,
      textCh: R,
      // 中文
      textEn: Z || R,
      align: "middle",
      style: {
        ...a && a.xAxisOptions.style
      }
    },
    labels: {
      style: {
        ...a && a.xAxisOptions.style
      }
    },
    min: Number(u),
    max: Number(d)
  }, B = [];
  const C = {
    //标签对应文字
    1: "最新",
    3: "Fix"
  };
  return y.forEach((w) => {
    let x = {
      data: [],
      type: "scatter",
      name: w.Name,
      nameZh: w.Name,
      nameEn: w.NameEn || w.Name,
      color: w.Color,
      lineWidth: 0,
      chartType: "linear",
      zIndex: 1
    };
    w.CoordinatePointData.forEach((h) => {
      x.data.push({
        x: h.X,
        y: h.Y,
        dataLabels: {
          enabled: h.ShowTips === 1,
          allowOverlap: !0,
          align: "left",
          format: C[h.DateType] || `-${h.DaysAgo}D`
        }
      });
    }), B.push(x);
  }), {
    title: {
      text: ""
    },
    series: B,
    yAxis: [P],
    xAxis: O,
    tooltip: {
      formatter: function() {
        let x = y.find((i) => i.Name === this.series.name).CoordinatePointData.find((i) => i.X === this.x && i.Y === this.y), h = g.find((i) => i.EdbInfoId === x.XEdbInfoId), c = g.find((i) => i.EdbInfoId === x.YEdbInfoId), p = `<b>${this.series.name}</b>`;
        return p += `<br><span style="color:${this.color}">●</span>${h.EdbName}: ${this.x} ${x.XDate}<br>`, p += `<span style="color:${this.color}">●</span>${c.EdbName}: ${this.y} ${x.YDate}`, p;
      },
      formatterCh: function() {
        let x = y.find((i) => i.Name === this.series.name).CoordinatePointData.find((i) => i.X === this.x && i.Y === this.y), h = g.find((i) => i.EdbInfoId === x.XEdbInfoId), c = g.find((i) => i.EdbInfoId === x.YEdbInfoId), p = `<b>${this.series.name}</b>`;
        return p += `<br><span style="color:${this.color}">●</span>${h.EdbName}: ${this.x} ${x.XDate}<br>`, p += `<span style="color:${this.color}">●</span>${c.EdbName}: ${this.y} ${x.YDate}`, p;
      },
      formatterEn: function() {
        let x = y.find((i) => i.NameEn === this.series.name).CoordinatePointData.find((i) => i.X === this.x && i.Y === this.y), h = g.find((i) => i.EdbInfoId === x.XEdbInfoId), c = g.find((i) => i.EdbInfoId === x.YEdbInfoId), p = `<b>${this.series.name}</b>`;
        return p += `<br><span style="color:${this.color}">●</span>${h.EdbNameEn}: ${this.x} ${x.XDate}<br>`, p += `<span style="color:${this.color}">●</span>${c.EdbNameEn}: ${this.y} ${x.YDate}`, p;
      }
    }
  };
}
function rM({ DataResp: r, EdbInfoList: g, ChartInfo: E }) {
  Pt.leftIndex = -1, Pt.rightIndex = -1, Pt.rightTwoIndex = -1;
  const { YDataList: a, XEdbIdValue: y } = r;
  let R = g.filter((U) => y.includes(U.EdbInfoId));
  Pt.hasLeftAxis = !0, Pt.leftMin = Number(E.LeftMin), Pt.leftMax = Number(E.LeftMax);
  const I = E.ChartThemeStyle ? JSON.parse(E.ChartThemeStyle) : null;
  let Z = {
    lineWidth: 0,
    tickLength: 0,
    tickmarkPlacement: "on",
    categories: R.map((U) => U.EdbAliasName || U.EdbName),
    labels: {
      allowOverlap: !0,
      autoRotationLimit: 40,
      style: {
        ...I && I.xAxisOptions.style
      }
    }
  }, H = [{
    gridLineInterpolation: "polygon",
    gridLineWidth: 1,
    lineWidth: 0,
    endOnTick: !1,
    startOnTick: !1,
    showLastLabel: !0,
    // tickAmount:4,
    title: {
      text: E.Unit,
      textCh: E.Unit,
      textEn: E.UnitEn,
      align: "high",
      rotation: 0,
      y: 5,
      x: 10,
      textAlign: "left",
      reserveSpace: !1,
      style: {
        ...I && I.yAxisOptions.style
      }
    },
    labels: {
      allowOverlap: !0,
      style: {
        ...I && I.yAxisOptions.style
      }
    },
    min: Number(E.LeftMin),
    max: Number(E.LeftMax)
  }], $ = [];
  return a.forEach((U) => {
    let W = {
      name: U.Name || U.Date,
      nameZh: U.Name || U.Date,
      nameEn: U.Date,
      data: U.Value,
      pointPlacement: "on",
      type: I && I.lineOptions.lineType || "line",
      dashStyle: I && I.lineOptions.dashStyle || "Solid",
      yAxis: 0,
      color: U.Color,
      lineWidth: I && I.lineOptions.lineWidth || 1,
      chartType: "linear"
    };
    $.push(W);
  }), {
    chart: {
      ...fs.chart,
      ...I == null ? void 0 : I.drawOption,
      spacing: [2, 10, 2, 10],
      polar: !0
    },
    title: {
      text: ""
    },
    pane: {
      size: "85%"
    },
    series: $,
    yAxis: H,
    xAxis: Z
  };
}
function nM(r = [], g) {
  if (g.ChartType === 5) {
    r[1] && (Pt.leftMin = r[1].MinData, Pt.leftMax = r[1].MaxData);
    return;
  }
  const E = r.filter((R) => R.IsAxis === 1).map((R) => [Number(R.MinData), Number(R.MaxData)]), a = r.filter((R) => !R.IsAxis).map((R) => [Number(R.MinData), Number(R.MaxData)]), y = r.filter((R) => R.IsAxis === 2).map((R) => [Number(R.MinData), Number(R.MaxData)]);
  if (E.length) {
    const {
      Max: R,
      Min: I
    } = bn(E.flat());
    Pt.leftMin = I, Pt.leftMax = R;
  }
  if (a.length) {
    const {
      Max: R,
      Min: I
    } = bn(a.flat());
    Pt.rightMin = I, Pt.rightMax = R;
  }
  if (y.length) {
    const {
      Max: R,
      Min: I
    } = bn(y.flat());
    Pt.rightTwoMin = I, Pt.rightTwoMax = R;
  }
}
function bn(r) {
  return {
    Max: Math.max(...r),
    Min: Math.min(...r)
  };
}
function oM({ EdbInfoList: r, ChartInfo: g }) {
  const {
    //左右轴极值字段 
    LeftMin: E = 0,
    LeftMax: a = 0,
    RightMin: y = 0,
    RightMax: R = 0,
    Right2Min: I = 0,
    Right2Max: Z = 0,
    MinMaxSave: H
  } = g;
  H ? (Pt.leftMin = Number(E), Pt.leftMax = Number(a), Pt.rightMin = Number(y), Pt.rightMax = Number(R), Pt.rightTwoMin = Number(I), Pt.rightTwoMax = Number(Z), sM(r, g), console.log("check", Pt.leftMin, Pt.leftMax)) : nM(r, g);
}
function sM(r = [], g) {
  if (g.ChartType === 5) {
    r[1] && Number(Pt.leftMin) === 0 && Number(Pt.leftMax) === 0 && (Pt.leftMin = r[1].MinData, Pt.leftMax = r[1].MaxData);
    return;
  }
  if (Number(Pt.leftMin) === 0 && Number(Pt.leftMax) === 0) {
    const E = r.filter((a) => a.IsAxis === 1).map((a) => [Number(a.MinData), Number(a.MaxData)]);
    if (E.length) {
      const { Max: a, Min: y } = bn(E.flat());
      Pt.leftMin = y, Pt.leftMax = a;
    }
  }
  if (Number(Pt.rightMin) === 0 && Number(Pt.rightMax) === 0) {
    const E = r.filter((a) => !a.IsAxis).map((a) => [Number(a.MinData), Number(a.MaxData)]);
    if (E.length) {
      const { Max: a, Min: y } = bn(E.flat());
      Pt.rightMin = y, Pt.rightMax = a;
    }
  }
  if (Number(Pt.rightTwoMin) === 0 && Number(Pt.rightTwoMax) === 0) {
    const E = r.filter((a) => a.IsAxis === 2).map((a) => [Number(a.MinData), Number(a.MaxData)]);
    if (E.length) {
      const { Max: a, Min: y } = bn(E.flat());
      Pt.rightTwoMin = y, Pt.rightTwoMax = a;
    }
  }
}
function Gu(r, g) {
  return function() {
    return r.apply(g, arguments);
  };
}
const { toString: aM } = Object.prototype, { getPrototypeOf: Xh } = Object, Bs = ((r) => (g) => {
  const E = aM.call(g);
  return r[E] || (r[E] = E.slice(8, -1).toLowerCase());
})(/* @__PURE__ */ Object.create(null)), Ki = (r) => (r = r.toLowerCase(), (g) => Bs(g) === r), js = (r) => (g) => typeof g === r, { isArray: Tn } = Array, ro = js("undefined");
function hM(r) {
  return r !== null && !ro(r) && r.constructor !== null && !ro(r.constructor) && Pi(r.constructor.isBuffer) && r.constructor.isBuffer(r);
}
const Hu = Ki("ArrayBuffer");
function lM(r) {
  let g;
  return typeof ArrayBuffer < "u" && ArrayBuffer.isView ? g = ArrayBuffer.isView(r) : g = r && r.buffer && Hu(r.buffer), g;
}
const cM = js("string"), Pi = js("function"), Uu = js("number"), Ws = (r) => r !== null && typeof r == "object", pM = (r) => r === !0 || r === !1, cs = (r) => {
  if (Bs(r) !== "object")
    return !1;
  const g = Xh(r);
  return (g === null || g === Object.prototype || Object.getPrototypeOf(g) === null) && !(Symbol.toStringTag in r) && !(Symbol.iterator in r);
}, uM = Ki("Date"), dM = Ki("File"), fM = Ki("Blob"), gM = Ki("FileList"), mM = (r) => Ws(r) && Pi(r.pipe), yM = (r) => {
  let g;
  return r && (typeof FormData == "function" && r instanceof FormData || Pi(r.append) && ((g = Bs(r)) === "formdata" || // detect form-data instance
  g === "object" && Pi(r.toString) && r.toString() === "[object FormData]"));
}, vM = Ki("URLSearchParams"), xM = (r) => r.trim ? r.trim() : r.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
function ho(r, g, { allOwnKeys: E = !1 } = {}) {
  if (r === null || typeof r > "u")
    return;
  let a, y;
  if (typeof r != "object" && (r = [r]), Tn(r))
    for (a = 0, y = r.length; a < y; a++)
      g.call(null, r[a], a, r);
  else {
    const R = E ? Object.getOwnPropertyNames(r) : Object.keys(r), I = R.length;
    let Z;
    for (a = 0; a < I; a++)
      Z = R[a], g.call(null, r[Z], Z, r);
  }
}
function Fu(r, g) {
  g = g.toLowerCase();
  const E = Object.keys(r);
  let a = E.length, y;
  for (; a-- > 0; )
    if (y = E[a], g === y.toLowerCase())
      return y;
  return null;
}
const Vu = (() => typeof globalThis < "u" ? globalThis : typeof self < "u" ? self : typeof window < "u" ? window : global)(), $u = (r) => !ro(r) && r !== Vu;
function vh() {
  const { caseless: r } = $u(this) && this || {}, g = {}, E = (a, y) => {
    const R = r && Fu(g, y) || y;
    cs(g[R]) && cs(a) ? g[R] = vh(g[R], a) : cs(a) ? g[R] = vh({}, a) : Tn(a) ? g[R] = a.slice() : g[R] = a;
  };
  for (let a = 0, y = arguments.length; a < y; a++)
    arguments[a] && ho(arguments[a], E);
  return g;
}
const bM = (r, g, E, { allOwnKeys: a } = {}) => (ho(g, (y, R) => {
  E && Pi(y) ? r[R] = Gu(y, E) : r[R] = y;
}, { allOwnKeys: a }), r), SM = (r) => (r.charCodeAt(0) === 65279 && (r = r.slice(1)), r), wM = (r, g, E, a) => {
  r.prototype = Object.create(g.prototype, a), r.prototype.constructor = r, Object.defineProperty(r, "super", {
    value: g.prototype
  }), E && Object.assign(r.prototype, E);
}, MM = (r, g, E, a) => {
  let y, R, I;
  const Z = {};
  if (g = g || {}, r == null)
    return g;
  do {
    for (y = Object.getOwnPropertyNames(r), R = y.length; R-- > 0; )
      I = y[R], (!a || a(I, r, g)) && !Z[I] && (g[I] = r[I], Z[I] = !0);
    r = E !== !1 && Xh(r);
  } while (r && (!E || E(r, g)) && r !== Object.prototype);
  return g;
}, CM = (r, g, E) => {
  r = String(r), (E === void 0 || E > r.length) && (E = r.length), E -= g.length;
  const a = r.indexOf(g, E);
  return a !== -1 && a === E;
}, kM = (r) => {
  if (!r)
    return null;
  if (Tn(r))
    return r;
  let g = r.length;
  if (!Uu(g))
    return null;
  const E = new Array(g);
  for (; g-- > 0; )
    E[g] = r[g];
  return E;
}, AM = ((r) => (g) => r && g instanceof r)(typeof Uint8Array < "u" && Xh(Uint8Array)), TM = (r, g) => {
  const a = (r && r[Symbol.iterator]).call(r);
  let y;
  for (; (y = a.next()) && !y.done; ) {
    const R = y.value;
    g.call(r, R[0], R[1]);
  }
}, PM = (r, g) => {
  let E;
  const a = [];
  for (; (E = r.exec(g)) !== null; )
    a.push(E);
  return a;
}, EM = Ki("HTMLFormElement"), OM = (r) => r.toLowerCase().replace(
  /[-_\s]([a-z\d])(\w*)/g,
  function(E, a, y) {
    return a.toUpperCase() + y;
  }
), Tp = (({ hasOwnProperty: r }) => (g, E) => r.call(g, E))(Object.prototype), LM = Ki("RegExp"), Zu = (r, g) => {
  const E = Object.getOwnPropertyDescriptors(r), a = {};
  ho(E, (y, R) => {
    let I;
    (I = g(y, R, r)) !== !1 && (a[R] = I || y);
  }), Object.defineProperties(r, a);
}, _M = (r) => {
  Zu(r, (g, E) => {
    if (Pi(r) && ["arguments", "caller", "callee"].indexOf(E) !== -1)
      return !1;
    const a = r[E];
    if (Pi(a)) {
      if (g.enumerable = !1, "writable" in g) {
        g.writable = !1;
        return;
      }
      g.set || (g.set = () => {
        throw Error("Can not rewrite read-only method '" + E + "'");
      });
    }
  });
}, DM = (r, g) => {
  const E = {}, a = (y) => {
    y.forEach((R) => {
      E[R] = !0;
    });
  };
  return Tn(r) ? a(r) : a(String(r).split(g)), E;
}, IM = () => {
}, RM = (r, g) => (r = +r, Number.isFinite(r) ? r : g), ah = "abcdefghijklmnopqrstuvwxyz", Pp = "0123456789", Ku = {
  DIGIT: Pp,
  ALPHA: ah,
  ALPHA_DIGIT: ah + ah.toUpperCase() + Pp
}, NM = (r = 16, g = Ku.ALPHA_DIGIT) => {
  let E = "";
  const { length: a } = g;
  for (; r--; )
    E += g[Math.random() * a | 0];
  return E;
};
function BM(r) {
  return !!(r && Pi(r.append) && r[Symbol.toStringTag] === "FormData" && r[Symbol.iterator]);
}
const jM = (r) => {
  const g = new Array(10), E = (a, y) => {
    if (Ws(a)) {
      if (g.indexOf(a) >= 0)
        return;
      if (!("toJSON" in a)) {
        g[y] = a;
        const R = Tn(a) ? [] : {};
        return ho(a, (I, Z) => {
          const H = E(I, y + 1);
          !ro(H) && (R[Z] = H);
        }), g[y] = void 0, R;
      }
    }
    return a;
  };
  return E(r, 0);
}, WM = Ki("AsyncFunction"), zM = (r) => r && (Ws(r) || Pi(r)) && Pi(r.then) && Pi(r.catch), It = {
  isArray: Tn,
  isArrayBuffer: Hu,
  isBuffer: hM,
  isFormData: yM,
  isArrayBufferView: lM,
  isString: cM,
  isNumber: Uu,
  isBoolean: pM,
  isObject: Ws,
  isPlainObject: cs,
  isUndefined: ro,
  isDate: uM,
  isFile: dM,
  isBlob: fM,
  isRegExp: LM,
  isFunction: Pi,
  isStream: mM,
  isURLSearchParams: vM,
  isTypedArray: AM,
  isFileList: gM,
  forEach: ho,
  merge: vh,
  extend: bM,
  trim: xM,
  stripBOM: SM,
  inherits: wM,
  toFlatObject: MM,
  kindOf: Bs,
  kindOfTest: Ki,
  endsWith: CM,
  toArray: kM,
  forEachEntry: TM,
  matchAll: PM,
  isHTMLForm: EM,
  hasOwnProperty: Tp,
  hasOwnProp: Tp,
  // an alias to avoid ESLint no-prototype-builtins detection
  reduceDescriptors: Zu,
  freezeMethods: _M,
  toObjectSet: DM,
  toCamelCase: OM,
  noop: IM,
  toFiniteNumber: RM,
  findKey: Fu,
  global: Vu,
  isContextDefined: $u,
  ALPHABET: Ku,
  generateString: NM,
  isSpecCompliantForm: BM,
  toJSONObject: jM,
  isAsyncFn: WM,
  isThenable: zM
};
function fe(r, g, E, a, y) {
  Error.call(this), Error.captureStackTrace ? Error.captureStackTrace(this, this.constructor) : this.stack = new Error().stack, this.message = r, this.name = "AxiosError", g && (this.code = g), E && (this.config = E), a && (this.request = a), y && (this.response = y);
}
It.inherits(fe, Error, {
  toJSON: function() {
    return {
      // Standard
      message: this.message,
      name: this.name,
      // Microsoft
      description: this.description,
      number: this.number,
      // Mozilla
      fileName: this.fileName,
      lineNumber: this.lineNumber,
      columnNumber: this.columnNumber,
      stack: this.stack,
      // Axios
      config: It.toJSONObject(this.config),
      code: this.code,
      status: this.response && this.response.status ? this.response.status : null
    };
  }
});
const Ju = fe.prototype, qu = {};
[
  "ERR_BAD_OPTION_VALUE",
  "ERR_BAD_OPTION",
  "ECONNABORTED",
  "ETIMEDOUT",
  "ERR_NETWORK",
  "ERR_FR_TOO_MANY_REDIRECTS",
  "ERR_DEPRECATED",
  "ERR_BAD_RESPONSE",
  "ERR_BAD_REQUEST",
  "ERR_CANCELED",
  "ERR_NOT_SUPPORT",
  "ERR_INVALID_URL"
  // eslint-disable-next-line func-names
].forEach((r) => {
  qu[r] = { value: r };
});
Object.defineProperties(fe, qu);
Object.defineProperty(Ju, "isAxiosError", { value: !0 });
fe.from = (r, g, E, a, y, R) => {
  const I = Object.create(Ju);
  return It.toFlatObject(r, I, function(H) {
    return H !== Error.prototype;
  }, (Z) => Z !== "isAxiosError"), fe.call(I, r.message, g, E, a, y), I.cause = r, I.name = r.name, R && Object.assign(I, R), I;
};
const YM = null;
function xh(r) {
  return It.isPlainObject(r) || It.isArray(r);
}
function Qu(r) {
  return It.endsWith(r, "[]") ? r.slice(0, -2) : r;
}
function Ep(r, g, E) {
  return r ? r.concat(g).map(function(y, R) {
    return y = Qu(y), !E && R ? "[" + y + "]" : y;
  }).join(E ? "." : "") : g;
}
function XM(r) {
  return It.isArray(r) && !r.some(xh);
}
const GM = It.toFlatObject(It, {}, null, function(g) {
  return /^is[A-Z]/.test(g);
});
function zs(r, g, E) {
  if (!It.isObject(r))
    throw new TypeError("target must be an object");
  g = g || new FormData(), E = It.toFlatObject(E, {
    metaTokens: !0,
    dots: !1,
    indexes: !1
  }, !1, function(u, d) {
    return !It.isUndefined(d[u]);
  });
  const a = E.metaTokens, y = E.visitor || U, R = E.dots, I = E.indexes, H = (E.Blob || typeof Blob < "u" && Blob) && It.isSpecCompliantForm(g);
  if (!It.isFunction(y))
    throw new TypeError("visitor must be a function");
  function $(v) {
    if (v === null)
      return "";
    if (It.isDate(v))
      return v.toISOString();
    if (!H && It.isBlob(v))
      throw new fe("Blob is not supported. Use a Buffer instead.");
    return It.isArrayBuffer(v) || It.isTypedArray(v) ? H && typeof Blob == "function" ? new Blob([v]) : Buffer.from(v) : v;
  }
  function U(v, u, d) {
    let P = v;
    if (v && !d && typeof v == "object") {
      if (It.endsWith(u, "{}"))
        u = a ? u : u.slice(0, -2), v = JSON.stringify(v);
      else if (It.isArray(v) && XM(v) || (It.isFileList(v) || It.endsWith(u, "[]")) && (P = It.toArray(v)))
        return u = Qu(u), P.forEach(function(B, C) {
          !(It.isUndefined(B) || B === null) && g.append(
            // eslint-disable-next-line no-nested-ternary
            I === !0 ? Ep([u], C, R) : I === null ? u : u + "[]",
            $(B)
          );
        }), !1;
    }
    return xh(v) ? !0 : (g.append(Ep(d, u, R), $(v)), !1);
  }
  const W = [], N = Object.assign(GM, {
    defaultVisitor: U,
    convertValue: $,
    isVisitable: xh
  });
  function M(v, u) {
    if (!It.isUndefined(v)) {
      if (W.indexOf(v) !== -1)
        throw Error("Circular reference detected in " + u.join("."));
      W.push(v), It.forEach(v, function(P, O) {
        (!(It.isUndefined(P) || P === null) && y.call(
          g,
          P,
          It.isString(O) ? O.trim() : O,
          u,
          N
        )) === !0 && M(P, u ? u.concat(O) : [O]);
      }), W.pop();
    }
  }
  if (!It.isObject(r))
    throw new TypeError("data must be an object");
  return M(r), g;
}
function Op(r) {
  const g = {
    "!": "%21",
    "'": "%27",
    "(": "%28",
    ")": "%29",
    "~": "%7E",
    "%20": "+",
    "%00": "\0"
  };
  return encodeURIComponent(r).replace(/[!'()~]|%20|%00/g, function(a) {
    return g[a];
  });
}
function Gh(r, g) {
  this._pairs = [], r && zs(r, this, g);
}
const td = Gh.prototype;
td.append = function(g, E) {
  this._pairs.push([g, E]);
};
td.toString = function(g) {
  const E = g ? function(a) {
    return g.call(this, a, Op);
  } : Op;
  return this._pairs.map(function(y) {
    return E(y[0]) + "=" + E(y[1]);
  }, "").join("&");
};
function HM(r) {
  return encodeURIComponent(r).replace(/%3A/gi, ":").replace(/%24/g, "$").replace(/%2C/gi, ",").replace(/%20/g, "+").replace(/%5B/gi, "[").replace(/%5D/gi, "]");
}
function ed(r, g, E) {
  if (!g)
    return r;
  const a = E && E.encode || HM, y = E && E.serialize;
  let R;
  if (y ? R = y(g, E) : R = It.isURLSearchParams(g) ? g.toString() : new Gh(g, E).toString(a), R) {
    const I = r.indexOf("#");
    I !== -1 && (r = r.slice(0, I)), r += (r.indexOf("?") === -1 ? "?" : "&") + R;
  }
  return r;
}
class UM {
  constructor() {
    this.handlers = [];
  }
  /**
   * Add a new interceptor to the stack
   *
   * @param {Function} fulfilled The function to handle `then` for a `Promise`
   * @param {Function} rejected The function to handle `reject` for a `Promise`
   *
   * @return {Number} An ID used to remove interceptor later
   */
  use(g, E, a) {
    return this.handlers.push({
      fulfilled: g,
      rejected: E,
      synchronous: a ? a.synchronous : !1,
      runWhen: a ? a.runWhen : null
    }), this.handlers.length - 1;
  }
  /**
   * Remove an interceptor from the stack
   *
   * @param {Number} id The ID that was returned by `use`
   *
   * @returns {Boolean} `true` if the interceptor was removed, `false` otherwise
   */
  eject(g) {
    this.handlers[g] && (this.handlers[g] = null);
  }
  /**
   * Clear all interceptors from the stack
   *
   * @returns {void}
   */
  clear() {
    this.handlers && (this.handlers = []);
  }
  /**
   * Iterate over all the registered interceptors
   *
   * This method is particularly useful for skipping over any
   * interceptors that may have become `null` calling `eject`.
   *
   * @param {Function} fn The function to call for each interceptor
   *
   * @returns {void}
   */
  forEach(g) {
    It.forEach(this.handlers, function(a) {
      a !== null && g(a);
    });
  }
}
const Lp = UM, id = {
  silentJSONParsing: !0,
  forcedJSONParsing: !0,
  clarifyTimeoutError: !1
}, FM = typeof URLSearchParams < "u" ? URLSearchParams : Gh, VM = typeof FormData < "u" ? FormData : null, $M = typeof Blob < "u" ? Blob : null, ZM = (() => {
  let r;
  return typeof navigator < "u" && ((r = navigator.product) === "ReactNative" || r === "NativeScript" || r === "NS") ? !1 : typeof window < "u" && typeof document < "u";
})(), KM = (() => typeof WorkerGlobalScope < "u" && // eslint-disable-next-line no-undef
self instanceof WorkerGlobalScope && typeof self.importScripts == "function")(), Ni = {
  isBrowser: !0,
  classes: {
    URLSearchParams: FM,
    FormData: VM,
    Blob: $M
  },
  isStandardBrowserEnv: ZM,
  isStandardBrowserWebWorkerEnv: KM,
  protocols: ["http", "https", "file", "blob", "url", "data"]
};
function JM(r, g) {
  return zs(r, new Ni.classes.URLSearchParams(), Object.assign({
    visitor: function(E, a, y, R) {
      return Ni.isNode && It.isBuffer(E) ? (this.append(a, E.toString("base64")), !1) : R.defaultVisitor.apply(this, arguments);
    }
  }, g));
}
function qM(r) {
  return It.matchAll(/\w+|\[(\w*)]/g, r).map((g) => g[0] === "[]" ? "" : g[1] || g[0]);
}
function QM(r) {
  const g = {}, E = Object.keys(r);
  let a;
  const y = E.length;
  let R;
  for (a = 0; a < y; a++)
    R = E[a], g[R] = r[R];
  return g;
}
function rd(r) {
  function g(E, a, y, R) {
    let I = E[R++];
    const Z = Number.isFinite(+I), H = R >= E.length;
    return I = !I && It.isArray(y) ? y.length : I, H ? (It.hasOwnProp(y, I) ? y[I] = [y[I], a] : y[I] = a, !Z) : ((!y[I] || !It.isObject(y[I])) && (y[I] = []), g(E, a, y[I], R) && It.isArray(y[I]) && (y[I] = QM(y[I])), !Z);
  }
  if (It.isFormData(r) && It.isFunction(r.entries)) {
    const E = {};
    return It.forEachEntry(r, (a, y) => {
      g(qM(a), y, E, 0);
    }), E;
  }
  return null;
}
function tC(r, g, E) {
  if (It.isString(r))
    try {
      return (g || JSON.parse)(r), It.trim(r);
    } catch (a) {
      if (a.name !== "SyntaxError")
        throw a;
    }
  return (E || JSON.stringify)(r);
}
const Hh = {
  transitional: id,
  adapter: Ni.isNode ? "http" : "xhr",
  transformRequest: [function(g, E) {
    const a = E.getContentType() || "", y = a.indexOf("application/json") > -1, R = It.isObject(g);
    if (R && It.isHTMLForm(g) && (g = new FormData(g)), It.isFormData(g))
      return y && y ? JSON.stringify(rd(g)) : g;
    if (It.isArrayBuffer(g) || It.isBuffer(g) || It.isStream(g) || It.isFile(g) || It.isBlob(g))
      return g;
    if (It.isArrayBufferView(g))
      return g.buffer;
    if (It.isURLSearchParams(g))
      return E.setContentType("application/x-www-form-urlencoded;charset=utf-8", !1), g.toString();
    let Z;
    if (R) {
      if (a.indexOf("application/x-www-form-urlencoded") > -1)
        return JM(g, this.formSerializer).toString();
      if ((Z = It.isFileList(g)) || a.indexOf("multipart/form-data") > -1) {
        const H = this.env && this.env.FormData;
        return zs(
          Z ? { "files[]": g } : g,
          H && new H(),
          this.formSerializer
        );
      }
    }
    return R || y ? (E.setContentType("application/json", !1), tC(g)) : g;
  }],
  transformResponse: [function(g) {
    const E = this.transitional || Hh.transitional, a = E && E.forcedJSONParsing, y = this.responseType === "json";
    if (g && It.isString(g) && (a && !this.responseType || y)) {
      const I = !(E && E.silentJSONParsing) && y;
      try {
        return JSON.parse(g);
      } catch (Z) {
        if (I)
          throw Z.name === "SyntaxError" ? fe.from(Z, fe.ERR_BAD_RESPONSE, this, null, this.response) : Z;
      }
    }
    return g;
  }],
  /**
   * A timeout in milliseconds to abort a request. If set to 0 (default) a
   * timeout is not created.
   */
  timeout: 0,
  xsrfCookieName: "XSRF-TOKEN",
  xsrfHeaderName: "X-XSRF-TOKEN",
  maxContentLength: -1,
  maxBodyLength: -1,
  env: {
    FormData: Ni.classes.FormData,
    Blob: Ni.classes.Blob
  },
  validateStatus: function(g) {
    return g >= 200 && g < 300;
  },
  headers: {
    common: {
      Accept: "application/json, text/plain, */*",
      "Content-Type": void 0
    }
  }
};
It.forEach(["delete", "get", "head", "post", "put", "patch"], (r) => {
  Hh.headers[r] = {};
});
const Uh = Hh, eC = It.toObjectSet([
  "age",
  "authorization",
  "content-length",
  "content-type",
  "etag",
  "expires",
  "from",
  "host",
  "if-modified-since",
  "if-unmodified-since",
  "last-modified",
  "location",
  "max-forwards",
  "proxy-authorization",
  "referer",
  "retry-after",
  "user-agent"
]), iC = (r) => {
  const g = {};
  let E, a, y;
  return r && r.split(`
`).forEach(function(I) {
    y = I.indexOf(":"), E = I.substring(0, y).trim().toLowerCase(), a = I.substring(y + 1).trim(), !(!E || g[E] && eC[E]) && (E === "set-cookie" ? g[E] ? g[E].push(a) : g[E] = [a] : g[E] = g[E] ? g[E] + ", " + a : a);
  }), g;
}, _p = Symbol("internals");
function Kn(r) {
  return r && String(r).trim().toLowerCase();
}
function ps(r) {
  return r === !1 || r == null ? r : It.isArray(r) ? r.map(ps) : String(r);
}
function rC(r) {
  const g = /* @__PURE__ */ Object.create(null), E = /([^\s,;=]+)\s*(?:=\s*([^,;]+))?/g;
  let a;
  for (; a = E.exec(r); )
    g[a[1]] = a[2];
  return g;
}
const nC = (r) => /^[-_a-zA-Z0-9^`|~,!#$%&'*+.]+$/.test(r.trim());
function hh(r, g, E, a, y) {
  if (It.isFunction(a))
    return a.call(this, g, E);
  if (y && (g = E), !!It.isString(g)) {
    if (It.isString(a))
      return g.indexOf(a) !== -1;
    if (It.isRegExp(a))
      return a.test(g);
  }
}
function oC(r) {
  return r.trim().toLowerCase().replace(/([a-z\d])(\w*)/g, (g, E, a) => E.toUpperCase() + a);
}
function sC(r, g) {
  const E = It.toCamelCase(" " + g);
  ["get", "set", "has"].forEach((a) => {
    Object.defineProperty(r, a + E, {
      value: function(y, R, I) {
        return this[a].call(this, g, y, R, I);
      },
      configurable: !0
    });
  });
}
class Ys {
  constructor(g) {
    g && this.set(g);
  }
  set(g, E, a) {
    const y = this;
    function R(Z, H, $) {
      const U = Kn(H);
      if (!U)
        throw new Error("header name must be a non-empty string");
      const W = It.findKey(y, U);
      (!W || y[W] === void 0 || $ === !0 || $ === void 0 && y[W] !== !1) && (y[W || H] = ps(Z));
    }
    const I = (Z, H) => It.forEach(Z, ($, U) => R($, U, H));
    return It.isPlainObject(g) || g instanceof this.constructor ? I(g, E) : It.isString(g) && (g = g.trim()) && !nC(g) ? I(iC(g), E) : g != null && R(E, g, a), this;
  }
  get(g, E) {
    if (g = Kn(g), g) {
      const a = It.findKey(this, g);
      if (a) {
        const y = this[a];
        if (!E)
          return y;
        if (E === !0)
          return rC(y);
        if (It.isFunction(E))
          return E.call(this, y, a);
        if (It.isRegExp(E))
          return E.exec(y);
        throw new TypeError("parser must be boolean|regexp|function");
      }
    }
  }
  has(g, E) {
    if (g = Kn(g), g) {
      const a = It.findKey(this, g);
      return !!(a && this[a] !== void 0 && (!E || hh(this, this[a], a, E)));
    }
    return !1;
  }
  delete(g, E) {
    const a = this;
    let y = !1;
    function R(I) {
      if (I = Kn(I), I) {
        const Z = It.findKey(a, I);
        Z && (!E || hh(a, a[Z], Z, E)) && (delete a[Z], y = !0);
      }
    }
    return It.isArray(g) ? g.forEach(R) : R(g), y;
  }
  clear(g) {
    const E = Object.keys(this);
    let a = E.length, y = !1;
    for (; a--; ) {
      const R = E[a];
      (!g || hh(this, this[R], R, g, !0)) && (delete this[R], y = !0);
    }
    return y;
  }
  normalize(g) {
    const E = this, a = {};
    return It.forEach(this, (y, R) => {
      const I = It.findKey(a, R);
      if (I) {
        E[I] = ps(y), delete E[R];
        return;
      }
      const Z = g ? oC(R) : String(R).trim();
      Z !== R && delete E[R], E[Z] = ps(y), a[Z] = !0;
    }), this;
  }
  concat(...g) {
    return this.constructor.concat(this, ...g);
  }
  toJSON(g) {
    const E = /* @__PURE__ */ Object.create(null);
    return It.forEach(this, (a, y) => {
      a != null && a !== !1 && (E[y] = g && It.isArray(a) ? a.join(", ") : a);
    }), E;
  }
  [Symbol.iterator]() {
    return Object.entries(this.toJSON())[Symbol.iterator]();
  }
  toString() {
    return Object.entries(this.toJSON()).map(([g, E]) => g + ": " + E).join(`
`);
  }
  get [Symbol.toStringTag]() {
    return "AxiosHeaders";
  }
  static from(g) {
    return g instanceof this ? g : new this(g);
  }
  static concat(g, ...E) {
    const a = new this(g);
    return E.forEach((y) => a.set(y)), a;
  }
  static accessor(g) {
    const a = (this[_p] = this[_p] = {
      accessors: {}
    }).accessors, y = this.prototype;
    function R(I) {
      const Z = Kn(I);
      a[Z] || (sC(y, I), a[Z] = !0);
    }
    return It.isArray(g) ? g.forEach(R) : R(g), this;
  }
}
Ys.accessor(["Content-Type", "Content-Length", "Accept", "Accept-Encoding", "User-Agent", "Authorization"]);
It.reduceDescriptors(Ys.prototype, ({ value: r }, g) => {
  let E = g[0].toUpperCase() + g.slice(1);
  return {
    get: () => r,
    set(a) {
      this[E] = a;
    }
  };
});
It.freezeMethods(Ys);
const ur = Ys;
function lh(r, g) {
  const E = this || Uh, a = g || E, y = ur.from(a.headers);
  let R = a.data;
  return It.forEach(r, function(Z) {
    R = Z.call(E, R, y.normalize(), g ? g.status : void 0);
  }), y.normalize(), R;
}
function nd(r) {
  return !!(r && r.__CANCEL__);
}
function lo(r, g, E) {
  fe.call(this, r ?? "canceled", fe.ERR_CANCELED, g, E), this.name = "CanceledError";
}
It.inherits(lo, fe, {
  __CANCEL__: !0
});
function aC(r, g, E) {
  const a = E.config.validateStatus;
  !E.status || !a || a(E.status) ? r(E) : g(new fe(
    "Request failed with status code " + E.status,
    [fe.ERR_BAD_REQUEST, fe.ERR_BAD_RESPONSE][Math.floor(E.status / 100) - 4],
    E.config,
    E.request,
    E
  ));
}
const hC = Ni.isStandardBrowserEnv ? (
  // Standard browser envs support document.cookie
  function() {
    return {
      write: function(E, a, y, R, I, Z) {
        const H = [];
        H.push(E + "=" + encodeURIComponent(a)), It.isNumber(y) && H.push("expires=" + new Date(y).toGMTString()), It.isString(R) && H.push("path=" + R), It.isString(I) && H.push("domain=" + I), Z === !0 && H.push("secure"), document.cookie = H.join("; ");
      },
      read: function(E) {
        const a = document.cookie.match(new RegExp("(^|;\\s*)(" + E + ")=([^;]*)"));
        return a ? decodeURIComponent(a[3]) : null;
      },
      remove: function(E) {
        this.write(E, "", Date.now() - 864e5);
      }
    };
  }()
) : (
  // Non standard browser env (web workers, react-native) lack needed support.
  function() {
    return {
      write: function() {
      },
      read: function() {
        return null;
      },
      remove: function() {
      }
    };
  }()
);
function lC(r) {
  return /^([a-z][a-z\d+\-.]*:)?\/\//i.test(r);
}
function cC(r, g) {
  return g ? r.replace(/\/+$/, "") + "/" + g.replace(/^\/+/, "") : r;
}
function od(r, g) {
  return r && !lC(g) ? cC(r, g) : g;
}
const pC = Ni.isStandardBrowserEnv ? (
  // Standard browser envs have full support of the APIs needed to test
  // whether the request URL is of the same origin as current location.
  function() {
    const g = /(msie|trident)/i.test(navigator.userAgent), E = document.createElement("a");
    let a;
    function y(R) {
      let I = R;
      return g && (E.setAttribute("href", I), I = E.href), E.setAttribute("href", I), {
        href: E.href,
        protocol: E.protocol ? E.protocol.replace(/:$/, "") : "",
        host: E.host,
        search: E.search ? E.search.replace(/^\?/, "") : "",
        hash: E.hash ? E.hash.replace(/^#/, "") : "",
        hostname: E.hostname,
        port: E.port,
        pathname: E.pathname.charAt(0) === "/" ? E.pathname : "/" + E.pathname
      };
    }
    return a = y(window.location.href), function(I) {
      const Z = It.isString(I) ? y(I) : I;
      return Z.protocol === a.protocol && Z.host === a.host;
    };
  }()
) : (
  // Non standard browser envs (web workers, react-native) lack needed support.
  function() {
    return function() {
      return !0;
    };
  }()
);
function uC(r) {
  const g = /^([-+\w]{1,25})(:?\/\/|:)/.exec(r);
  return g && g[1] || "";
}
function dC(r, g) {
  r = r || 10;
  const E = new Array(r), a = new Array(r);
  let y = 0, R = 0, I;
  return g = g !== void 0 ? g : 1e3, function(H) {
    const $ = Date.now(), U = a[R];
    I || (I = $), E[y] = H, a[y] = $;
    let W = R, N = 0;
    for (; W !== y; )
      N += E[W++], W = W % r;
    if (y = (y + 1) % r, y === R && (R = (R + 1) % r), $ - I < g)
      return;
    const M = U && $ - U;
    return M ? Math.round(N * 1e3 / M) : void 0;
  };
}
function Dp(r, g) {
  let E = 0;
  const a = dC(50, 250);
  return (y) => {
    const R = y.loaded, I = y.lengthComputable ? y.total : void 0, Z = R - E, H = a(Z), $ = R <= I;
    E = R;
    const U = {
      loaded: R,
      total: I,
      progress: I ? R / I : void 0,
      bytes: Z,
      rate: H || void 0,
      estimated: H && I && $ ? (I - R) / H : void 0,
      event: y
    };
    U[g ? "download" : "upload"] = !0, r(U);
  };
}
const fC = typeof XMLHttpRequest < "u", gC = fC && function(r) {
  return new Promise(function(E, a) {
    let y = r.data;
    const R = ur.from(r.headers).normalize(), I = r.responseType;
    let Z;
    function H() {
      r.cancelToken && r.cancelToken.unsubscribe(Z), r.signal && r.signal.removeEventListener("abort", Z);
    }
    It.isFormData(y) && (Ni.isStandardBrowserEnv || Ni.isStandardBrowserWebWorkerEnv ? R.setContentType(!1) : R.setContentType("multipart/form-data;", !1));
    let $ = new XMLHttpRequest();
    if (r.auth) {
      const M = r.auth.username || "", v = r.auth.password ? unescape(encodeURIComponent(r.auth.password)) : "";
      R.set("Authorization", "Basic " + btoa(M + ":" + v));
    }
    const U = od(r.baseURL, r.url);
    $.open(r.method.toUpperCase(), ed(U, r.params, r.paramsSerializer), !0), $.timeout = r.timeout;
    function W() {
      if (!$)
        return;
      const M = ur.from(
        "getAllResponseHeaders" in $ && $.getAllResponseHeaders()
      ), u = {
        data: !I || I === "text" || I === "json" ? $.responseText : $.response,
        status: $.status,
        statusText: $.statusText,
        headers: M,
        config: r,
        request: $
      };
      aC(function(P) {
        E(P), H();
      }, function(P) {
        a(P), H();
      }, u), $ = null;
    }
    if ("onloadend" in $ ? $.onloadend = W : $.onreadystatechange = function() {
      !$ || $.readyState !== 4 || $.status === 0 && !($.responseURL && $.responseURL.indexOf("file:") === 0) || setTimeout(W);
    }, $.onabort = function() {
      $ && (a(new fe("Request aborted", fe.ECONNABORTED, r, $)), $ = null);
    }, $.onerror = function() {
      a(new fe("Network Error", fe.ERR_NETWORK, r, $)), $ = null;
    }, $.ontimeout = function() {
      let v = r.timeout ? "timeout of " + r.timeout + "ms exceeded" : "timeout exceeded";
      const u = r.transitional || id;
      r.timeoutErrorMessage && (v = r.timeoutErrorMessage), a(new fe(
        v,
        u.clarifyTimeoutError ? fe.ETIMEDOUT : fe.ECONNABORTED,
        r,
        $
      )), $ = null;
    }, Ni.isStandardBrowserEnv) {
      const M = (r.withCredentials || pC(U)) && r.xsrfCookieName && hC.read(r.xsrfCookieName);
      M && R.set(r.xsrfHeaderName, M);
    }
    y === void 0 && R.setContentType(null), "setRequestHeader" in $ && It.forEach(R.toJSON(), function(v, u) {
      $.setRequestHeader(u, v);
    }), It.isUndefined(r.withCredentials) || ($.withCredentials = !!r.withCredentials), I && I !== "json" && ($.responseType = r.responseType), typeof r.onDownloadProgress == "function" && $.addEventListener("progress", Dp(r.onDownloadProgress, !0)), typeof r.onUploadProgress == "function" && $.upload && $.upload.addEventListener("progress", Dp(r.onUploadProgress)), (r.cancelToken || r.signal) && (Z = (M) => {
      $ && (a(!M || M.type ? new lo(null, r, $) : M), $.abort(), $ = null);
    }, r.cancelToken && r.cancelToken.subscribe(Z), r.signal && (r.signal.aborted ? Z() : r.signal.addEventListener("abort", Z)));
    const N = uC(U);
    if (N && Ni.protocols.indexOf(N) === -1) {
      a(new fe("Unsupported protocol " + N + ":", fe.ERR_BAD_REQUEST, r));
      return;
    }
    $.send(y || null);
  });
}, us = {
  http: YM,
  xhr: gC
};
It.forEach(us, (r, g) => {
  if (r) {
    try {
      Object.defineProperty(r, "name", { value: g });
    } catch {
    }
    Object.defineProperty(r, "adapterName", { value: g });
  }
});
const sd = {
  getAdapter: (r) => {
    r = It.isArray(r) ? r : [r];
    const { length: g } = r;
    let E, a;
    for (let y = 0; y < g && (E = r[y], !(a = It.isString(E) ? us[E.toLowerCase()] : E)); y++)
      ;
    if (!a)
      throw a === !1 ? new fe(
        `Adapter ${E} is not supported by the environment`,
        "ERR_NOT_SUPPORT"
      ) : new Error(
        It.hasOwnProp(us, E) ? `Adapter '${E}' is not available in the build` : `Unknown adapter '${E}'`
      );
    if (!It.isFunction(a))
      throw new TypeError("adapter is not a function");
    return a;
  },
  adapters: us
};
function ch(r) {
  if (r.cancelToken && r.cancelToken.throwIfRequested(), r.signal && r.signal.aborted)
    throw new lo(null, r);
}
function Ip(r) {
  return ch(r), r.headers = ur.from(r.headers), r.data = lh.call(
    r,
    r.transformRequest
  ), ["post", "put", "patch"].indexOf(r.method) !== -1 && r.headers.setContentType("application/x-www-form-urlencoded", !1), sd.getAdapter(r.adapter || Uh.adapter)(r).then(function(a) {
    return ch(r), a.data = lh.call(
      r,
      r.transformResponse,
      a
    ), a.headers = ur.from(a.headers), a;
  }, function(a) {
    return nd(a) || (ch(r), a && a.response && (a.response.data = lh.call(
      r,
      r.transformResponse,
      a.response
    ), a.response.headers = ur.from(a.response.headers))), Promise.reject(a);
  });
}
const Rp = (r) => r instanceof ur ? r.toJSON() : r;
function wn(r, g) {
  g = g || {};
  const E = {};
  function a($, U, W) {
    return It.isPlainObject($) && It.isPlainObject(U) ? It.merge.call({ caseless: W }, $, U) : It.isPlainObject(U) ? It.merge({}, U) : It.isArray(U) ? U.slice() : U;
  }
  function y($, U, W) {
    if (It.isUndefined(U)) {
      if (!It.isUndefined($))
        return a(void 0, $, W);
    } else
      return a($, U, W);
  }
  function R($, U) {
    if (!It.isUndefined(U))
      return a(void 0, U);
  }
  function I($, U) {
    if (It.isUndefined(U)) {
      if (!It.isUndefined($))
        return a(void 0, $);
    } else
      return a(void 0, U);
  }
  function Z($, U, W) {
    if (W in g)
      return a($, U);
    if (W in r)
      return a(void 0, $);
  }
  const H = {
    url: R,
    method: R,
    data: R,
    baseURL: I,
    transformRequest: I,
    transformResponse: I,
    paramsSerializer: I,
    timeout: I,
    timeoutMessage: I,
    withCredentials: I,
    adapter: I,
    responseType: I,
    xsrfCookieName: I,
    xsrfHeaderName: I,
    onUploadProgress: I,
    onDownloadProgress: I,
    decompress: I,
    maxContentLength: I,
    maxBodyLength: I,
    beforeRedirect: I,
    transport: I,
    httpAgent: I,
    httpsAgent: I,
    cancelToken: I,
    socketPath: I,
    responseEncoding: I,
    validateStatus: Z,
    headers: ($, U) => y(Rp($), Rp(U), !0)
  };
  return It.forEach(Object.keys(Object.assign({}, r, g)), function(U) {
    const W = H[U] || y, N = W(r[U], g[U], U);
    It.isUndefined(N) && W !== Z || (E[U] = N);
  }), E;
}
const ad = "1.5.0", Fh = {};
["object", "boolean", "number", "function", "string", "symbol"].forEach((r, g) => {
  Fh[r] = function(a) {
    return typeof a === r || "a" + (g < 1 ? "n " : " ") + r;
  };
});
const Np = {};
Fh.transitional = function(g, E, a) {
  function y(R, I) {
    return "[Axios v" + ad + "] Transitional option '" + R + "'" + I + (a ? ". " + a : "");
  }
  return (R, I, Z) => {
    if (g === !1)
      throw new fe(
        y(I, " has been removed" + (E ? " in " + E : "")),
        fe.ERR_DEPRECATED
      );
    return E && !Np[I] && (Np[I] = !0, console.warn(
      y(
        I,
        " has been deprecated since v" + E + " and will be removed in the near future"
      )
    )), g ? g(R, I, Z) : !0;
  };
};
function mC(r, g, E) {
  if (typeof r != "object")
    throw new fe("options must be an object", fe.ERR_BAD_OPTION_VALUE);
  const a = Object.keys(r);
  let y = a.length;
  for (; y-- > 0; ) {
    const R = a[y], I = g[R];
    if (I) {
      const Z = r[R], H = Z === void 0 || I(Z, R, r);
      if (H !== !0)
        throw new fe("option " + R + " must be " + H, fe.ERR_BAD_OPTION_VALUE);
      continue;
    }
    if (E !== !0)
      throw new fe("Unknown option " + R, fe.ERR_BAD_OPTION);
  }
}
const bh = {
  assertOptions: mC,
  validators: Fh
}, kr = bh.validators;
class Cs {
  constructor(g) {
    this.defaults = g, this.interceptors = {
      request: new Lp(),
      response: new Lp()
    };
  }
  /**
   * Dispatch a request
   *
   * @param {String|Object} configOrUrl The config specific for this request (merged with this.defaults)
   * @param {?Object} config
   *
   * @returns {Promise} The Promise to be fulfilled
   */
  request(g, E) {
    typeof g == "string" ? (E = E || {}, E.url = g) : E = g || {}, E = wn(this.defaults, E);
    const { transitional: a, paramsSerializer: y, headers: R } = E;
    a !== void 0 && bh.assertOptions(a, {
      silentJSONParsing: kr.transitional(kr.boolean),
      forcedJSONParsing: kr.transitional(kr.boolean),
      clarifyTimeoutError: kr.transitional(kr.boolean)
    }, !1), y != null && (It.isFunction(y) ? E.paramsSerializer = {
      serialize: y
    } : bh.assertOptions(y, {
      encode: kr.function,
      serialize: kr.function
    }, !0)), E.method = (E.method || this.defaults.method || "get").toLowerCase();
    let I = R && It.merge(
      R.common,
      R[E.method]
    );
    R && It.forEach(
      ["delete", "get", "head", "post", "put", "patch", "common"],
      (v) => {
        delete R[v];
      }
    ), E.headers = ur.concat(I, R);
    const Z = [];
    let H = !0;
    this.interceptors.request.forEach(function(u) {
      typeof u.runWhen == "function" && u.runWhen(E) === !1 || (H = H && u.synchronous, Z.unshift(u.fulfilled, u.rejected));
    });
    const $ = [];
    this.interceptors.response.forEach(function(u) {
      $.push(u.fulfilled, u.rejected);
    });
    let U, W = 0, N;
    if (!H) {
      const v = [Ip.bind(this), void 0];
      for (v.unshift.apply(v, Z), v.push.apply(v, $), N = v.length, U = Promise.resolve(E); W < N; )
        U = U.then(v[W++], v[W++]);
      return U;
    }
    N = Z.length;
    let M = E;
    for (W = 0; W < N; ) {
      const v = Z[W++], u = Z[W++];
      try {
        M = v(M);
      } catch (d) {
        u.call(this, d);
        break;
      }
    }
    try {
      U = Ip.call(this, M);
    } catch (v) {
      return Promise.reject(v);
    }
    for (W = 0, N = $.length; W < N; )
      U = U.then($[W++], $[W++]);
    return U;
  }
  getUri(g) {
    g = wn(this.defaults, g);
    const E = od(g.baseURL, g.url);
    return ed(E, g.params, g.paramsSerializer);
  }
}
It.forEach(["delete", "get", "head", "options"], function(g) {
  Cs.prototype[g] = function(E, a) {
    return this.request(wn(a || {}, {
      method: g,
      url: E,
      data: (a || {}).data
    }));
  };
});
It.forEach(["post", "put", "patch"], function(g) {
  function E(a) {
    return function(R, I, Z) {
      return this.request(wn(Z || {}, {
        method: g,
        headers: a ? {
          "Content-Type": "multipart/form-data"
        } : {},
        url: R,
        data: I
      }));
    };
  }
  Cs.prototype[g] = E(), Cs.prototype[g + "Form"] = E(!0);
});
const ds = Cs;
class Vh {
  constructor(g) {
    if (typeof g != "function")
      throw new TypeError("executor must be a function.");
    let E;
    this.promise = new Promise(function(R) {
      E = R;
    });
    const a = this;
    this.promise.then((y) => {
      if (!a._listeners)
        return;
      let R = a._listeners.length;
      for (; R-- > 0; )
        a._listeners[R](y);
      a._listeners = null;
    }), this.promise.then = (y) => {
      let R;
      const I = new Promise((Z) => {
        a.subscribe(Z), R = Z;
      }).then(y);
      return I.cancel = function() {
        a.unsubscribe(R);
      }, I;
    }, g(function(R, I, Z) {
      a.reason || (a.reason = new lo(R, I, Z), E(a.reason));
    });
  }
  /**
   * Throws a `CanceledError` if cancellation has been requested.
   */
  throwIfRequested() {
    if (this.reason)
      throw this.reason;
  }
  /**
   * Subscribe to the cancel signal
   */
  subscribe(g) {
    if (this.reason) {
      g(this.reason);
      return;
    }
    this._listeners ? this._listeners.push(g) : this._listeners = [g];
  }
  /**
   * Unsubscribe from the cancel signal
   */
  unsubscribe(g) {
    if (!this._listeners)
      return;
    const E = this._listeners.indexOf(g);
    E !== -1 && this._listeners.splice(E, 1);
  }
  /**
   * Returns an object that contains a new `CancelToken` and a function that, when called,
   * cancels the `CancelToken`.
   */
  static source() {
    let g;
    return {
      token: new Vh(function(y) {
        g = y;
      }),
      cancel: g
    };
  }
}
const yC = Vh;
function vC(r) {
  return function(E) {
    return r.apply(null, E);
  };
}
function xC(r) {
  return It.isObject(r) && r.isAxiosError === !0;
}
const Sh = {
  Continue: 100,
  SwitchingProtocols: 101,
  Processing: 102,
  EarlyHints: 103,
  Ok: 200,
  Created: 201,
  Accepted: 202,
  NonAuthoritativeInformation: 203,
  NoContent: 204,
  ResetContent: 205,
  PartialContent: 206,
  MultiStatus: 207,
  AlreadyReported: 208,
  ImUsed: 226,
  MultipleChoices: 300,
  MovedPermanently: 301,
  Found: 302,
  SeeOther: 303,
  NotModified: 304,
  UseProxy: 305,
  Unused: 306,
  TemporaryRedirect: 307,
  PermanentRedirect: 308,
  BadRequest: 400,
  Unauthorized: 401,
  PaymentRequired: 402,
  Forbidden: 403,
  NotFound: 404,
  MethodNotAllowed: 405,
  NotAcceptable: 406,
  ProxyAuthenticationRequired: 407,
  RequestTimeout: 408,
  Conflict: 409,
  Gone: 410,
  LengthRequired: 411,
  PreconditionFailed: 412,
  PayloadTooLarge: 413,
  UriTooLong: 414,
  UnsupportedMediaType: 415,
  RangeNotSatisfiable: 416,
  ExpectationFailed: 417,
  ImATeapot: 418,
  MisdirectedRequest: 421,
  UnprocessableEntity: 422,
  Locked: 423,
  FailedDependency: 424,
  TooEarly: 425,
  UpgradeRequired: 426,
  PreconditionRequired: 428,
  TooManyRequests: 429,
  RequestHeaderFieldsTooLarge: 431,
  UnavailableForLegalReasons: 451,
  InternalServerError: 500,
  NotImplemented: 501,
  BadGateway: 502,
  ServiceUnavailable: 503,
  GatewayTimeout: 504,
  HttpVersionNotSupported: 505,
  VariantAlsoNegotiates: 506,
  InsufficientStorage: 507,
  LoopDetected: 508,
  NotExtended: 510,
  NetworkAuthenticationRequired: 511
};
Object.entries(Sh).forEach(([r, g]) => {
  Sh[g] = r;
});
const bC = Sh;
function hd(r) {
  const g = new ds(r), E = Gu(ds.prototype.request, g);
  return It.extend(E, ds.prototype, g, { allOwnKeys: !0 }), It.extend(E, g, null, { allOwnKeys: !0 }), E.create = function(y) {
    return hd(wn(r, y));
  }, E;
}
const We = hd(Uh);
We.Axios = ds;
We.CanceledError = lo;
We.CancelToken = yC;
We.isCancel = nd;
We.VERSION = ad;
We.toFormData = zs;
We.AxiosError = fe;
We.Cancel = We.CanceledError;
We.all = function(g) {
  return Promise.all(g);
};
We.spread = vC;
We.isAxiosError = xC;
We.mergeConfig = wn;
We.AxiosHeaders = ur;
We.formToJSON = (r) => rd(It.isHTMLForm(r) ? new FormData(r) : r);
We.getAdapter = sd.getAdapter;
We.HttpStatusCode = bC;
We.default = We;
const SC = We;
let wC = {
  baseURL: "/api",
  timeout: 10 * 60 * 1e3
};
const $h = SC.create(wC);
$h.interceptors.request.use(
  function(r) {
    return r;
  },
  function(r) {
    return console.error(r), Promise.reject(r);
  }
);
$h.interceptors.response.use(
  function(r) {
    let g = r.data;
    return r.status !== 200 && console.error("网络异常"), g || console.error("服务器开了个小差"), g.Ret === 408 && console.error(g.Msg), g.Ret === 403 && console.error(g.Msg || "网络异常"), g;
  },
  function(r) {
    return console.error(r), Promise.reject(r);
  }
);
const ld = (r, g) => $h.post(r, g), MC = (r) => ld("/chart/detail", r), CC = (r) => ld("/excel/detail", r);
function cd(r) {
  if (r.indexOf("?") === -1)
    return {};
  const E = r.split("?")[1].split("&"), a = {};
  return E.forEach((y) => {
    const [R, I] = y.split("=");
    a[R] = decodeURIComponent(I);
  }), a;
}
const kC = `div[data-v-36c08c2e]{box-sizing:border-box}.hz-chart-wrap[data-v-36c08c2e]{font:initial;page-break-inside:avoid;max-width:1200PX;height:100%;overflow:hidden;position:relative;margin:0 auto;border:1PX solid rgba(0,0,0,.125)!important;background:#fff;border-radius:5PX;display:flex;flex-direction:column}.hz-chart-wrap .hz-chart-head[data-v-36c08c2e]{box-sizing:border-box;background-color:#f2f2f2;border-bottom:1px solid rgba(0,0,0,.125);cursor:pointer;min-height:40PX;display:flex;align-items:center;padding:2PX 10PX}.hz-chart-wrap .hz-chart-head .chart-title[data-v-36c08c2e]{width:100%}.hz-chart-wrap .hz-chart-content[data-v-36c08c2e]{width:100%;flex:1}.hz-chart-wrap .mark[data-v-36c08c2e]{position:absolute;left:50%;top:50%;transform:translate(-50%,-50%);background-image:none;background-position:center center;background-repeat:no-repeat;background-size:contain;pointer-events:none;width:580PX;height:60PX}.hz-chart-wrap .notfound[data-v-36c08c2e]{flex:1;overflow:hidden;padding:10PX;color:#777;text-align:center}.hz-chart-wrap .chart-bottom-info[data-v-36c08c2e]{padding-right:10PX;padding-bottom:0;padding-left:25PX;display:flex}.hz-chart-wrap .chart-bottom-info .chart-instruction[data-v-36c08c2e]{max-width:80%;flex:1;text-align:right;margin-left:auto}.hz-chart-wrap .hz-chart-footer[data-v-36c08c2e]{padding-left:25PX;padding-right:10PX;padding-bottom:10PX;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.hz-chart-wrap .text_oneLine[data-v-36c08c2e]{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}
`, pd = (r, g) => {
  const E = r.__vccOpts || r;
  for (const [a, y] of g)
    E[a] = y;
  return E;
}, AC = { class: "hz-chart-head" }, TC = ["id"], PC = {
  key: 1,
  class: "notfound"
}, EC = {
  key: 2,
  class: "chart-bottom-info bootom-source"
}, OC = ["textContent"], LC = {
  __name: "EtaChart.ce",
  props: {
    src: "",
    width: "",
    height: "",
    style: ""
  },
  setup(r) {
    const g = r, { chartRender: E } = jw(), a = cd(g.src), y = Xe(null), R = Xe(""), I = Xe(null), Z = Xe(null), H = Xe(!1), $ = Xe(null);
    async function U() {
      if (!a.code) {
        H.value = !1;
        return;
      }
      try {
        const N = await MC({
          UniqueCode: a.code
        });
        if (N.Ret !== 200)
          return;
        I.value = N.Data.ChartInfo, Z.value = N.Data.ChartInfo.Source === 1 ? N.Data.EdbInfoList : [N.Data.EdbInfoList[0]], R.value = `hz-chart_${a.code}_${(/* @__PURE__ */ new Date()).getTime()}`, W(), H.value = !0, Bp(() => {
          E({
            data: {
              ...N.Data,
              ChartInfo: {
                ...N.Data.ChartInfo,
                Calendar: "公历"
              }
            },
            renderId: y.value,
            lang: a.language,
            changeLangIsCheck: !1,
            showChartTitle: !1
          }), N.Data.WaterMark && ($.value.style.backgroundImage = `url(${N.Data.WaterMark})`);
        });
      } catch {
        H.value = !1;
      }
    }
    const W = () => {
      a.language = a.fromPage || a.lang || "zh";
    };
    return U(), (N, M) => {
      var v, u, d, P;
      return ri(), ni("div", {
        class: "hz-chart-wrap",
        style: Ur([g.style + ";height:" + g.height + "px", { margin: "0 0 10px 0" }])
      }, [
        hr("header", AC, [
          I.value ? (ri(), ni("span", {
            key: 0,
            class: "chart-title",
            style: Ur(I.value.ChartThemeStyle ? `
                text-align:${JSON.parse(I.value.ChartThemeStyle).titleOptions.align};
                font-size:${JSON.parse(I.value.ChartThemeStyle).titleOptions.style.fontSize}px;
                color:${JSON.parse(I.value.ChartThemeStyle).titleOptions.style.color}
                ` : "")
          }, mn(C0(a).language === "en" ? I.value.ChartNameEn : I.value.ChartName), 5)) : ns("", !0)
        ]),
        H.value ? (ri(), ni(os, { key: 0 }, [
          hr("div", {
            id: R.value,
            ref_key: "chartContentEl",
            ref: y,
            class: "hz-chart-content"
          }, null, 8, TC),
          hr("div", {
            class: "mark",
            ref_key: "markDom",
            ref: $
          }, null, 512)
        ], 64)) : (ri(), ni("div", PC, " 哎吆，你的图飞了，赶快去找管理员救命吧~ ")),
        (v = I.value) != null && v.Instructions && JSON.parse((u = I.value) == null ? void 0 : u.Instructions).isShow ? (ri(), ni("div", EC, [
          hr("div", {
            class: "chart-instruction text_oneLine",
            textContent: mn(JSON.parse(I.value.Instructions).text),
            style: Ur(`
                color: ${JSON.parse(I.value.Instructions).color};
                font-size: ${JSON.parse(I.value.Instructions).fontSize}px
                `)
          }, null, 12, OC)
        ])) : ns("", !0),
        (d = I.value) != null && d.SourcesFrom && ((P = JSON.parse(I.value.SourcesFrom)) != null && P.isShow) ? (ri(), ni("div", {
          key: 3,
          class: "hz-chart-footer",
          style: Ur(`
            color: ${JSON.parse(I.value.SourcesFrom).color};
            font-size: ${JSON.parse(I.value.SourcesFrom).fontSize}px;
        `)
        }, [
          k0(" source："),
          hr("em", null, mn(JSON.parse(I.value.SourcesFrom).text), 1)
        ], 4)) : ns("", !0)
      ], 4);
    };
  }
}, _C = /* @__PURE__ */ pd(LC, [["styles", [kC]], ["__scopeId", "data-v-36c08c2e"]]), DC = `.sheet-show-wrapper[data-v-571bd118]{max-width:1200PX;overflow:hidden;position:relative;margin:0 auto;background:#fff}.sheet-show-wrapper .title[data-v-571bd118]{font-size:17PX;font-weight:400;padding:0 10PX;margin:0 0 8PX}.sheet-show-wrapper .table-wrapper[data-v-571bd118]{max-width:calc(100vw - 20PX);margin:0 auto;overflow:auto}.sheet-show-wrapper .table-wrapper table[data-v-571bd118]{width:100%;font-size:14PX;color:#333;table-layout:auto}.sheet-show-wrapper .table-wrapper table td[data-v-571bd118],.sheet-show-wrapper .table-wrapper table th[data-v-571bd118]{width:auto;height:auto;padding:.4em 0;word-break:break-all;word-wrap:break-word;line-height:1.2em;border:1PX solid #dcdfe6;text-align:center;background-color:#fff;border-left:none;border-top:none}.sheet-show-wrapper .table-wrapper table td[data-v-571bd118]:first-child,.sheet-show-wrapper .table-wrapper table th[data-v-571bd118]:first-child{border-left:1PX solid #dcdfe6}.sheet-show-wrapper .table-wrapper table .data-cell[data-v-571bd118]{color:#333}.sheet-show-wrapper .table-wrapper table .data-cell.one-bg[data-v-571bd118]{background-color:#efeef1}.sheet-show-wrapper .table-wrapper table .data-cell.two-bg[data-v-571bd118]{background-color:#fff}.sheet-show-wrapper .table-wrapper table .thead-sticky[data-v-571bd118]{position:sticky;top:0}.sheet-show-wrapper .table-wrapper table .head-column[data-v-571bd118]{background-color:#505b78;color:#fff}.sheet-show-wrapper .table-wrapper table .split-word span[data-v-571bd118]{display:inline}
`, IC = {
  key: 0,
  class: "sheet-show-wrapper"
}, RC = { class: "title" }, NC = { class: "table-wrapper" }, BC = ["colspan", "rowspan"], jC = {
  key: 0,
  class: "split-word"
}, WC = { key: 1 }, zC = {
  __name: "EtaTable.ce",
  props: {
    src: "",
    width: "",
    height: "",
    style: ""
  },
  setup(r) {
    const E = cd(r.src), a = Xe({}), y = Xe(!1);
    async function R() {
      const I = await CC({ UniqueCode: E.code, FromScene: Number(E.fromScene || "") });
      I.Ret === 200 && (a.value = I.Data, y.value = !0);
    }
    return R(), (I, Z) => {
      var H, $;
      return y.value ? (ri(), ni("div", IC, [
        hr("h3", RC, mn(a.value.ExcelName), 1),
        hr("div", NC, [
          hr("table", {
            cellpadding: "0",
            cellspacing: "0",
            style: Ur(`font-size: ${((H = a.value.Config) == null ? void 0 : H.FontSize) || 12}PX`)
          }, [
            hr("tbody", null, [
              (ri(!0), ni(os, null, Qa(($ = a.value.TableInfo) == null ? void 0 : $.TableDataList, (U, W) => (ri(), ni("tr", { key: W }, [
                (ri(!0), ni(os, null, Qa(U, (N, M) => (ri(), ni("td", {
                  class: A0(["data-cell", {
                    "one-bg": (W + 1) % 2 && W > 0,
                    "tow-bg": (W + 1) % 2 !== 0 && W > 0,
                    "head-column": W === 0
                  }]),
                  key: M,
                  colspan: N.mc.cs || 1,
                  rowspan: N.mc.rs || 1,
                  style: Ur(`
                        color: ${N.fc};
                        font-weight: ${N.bl ? "bold" : "normal"};
                        font-style: ${N.it ? "italic" : "normal"};
                        background: ${N.bg};
                    `)
                }, [
                  N.ct.s ? (ri(), ni("div", jC, [
                    (ri(!0), ni(os, null, Qa(N.ct.s, (v, u) => (ri(), ni("span", {
                      key: `${W}_${M}_${u}`,
                      style: Ur(`
                            color: ${v.fc};
                            font-weight: ${v.bl ? "bold" : "normal"};
                            font-style: ${v.it ? "italic" : "normal"};
                        `)
                    }, mn(v.v), 5))), 128))
                  ])) : (ri(), ni("div", WC, mn(N.m), 1))
                ], 14, BC))), 128))
              ]))), 128))
            ])
          ], 4)
        ])
      ])) : ns("", !0);
    };
  }
}, YC = /* @__PURE__ */ pd(zC, [["styles", [DC]], ["__scopeId", "data-v-571bd118"]]), XC = jp(_C), GC = jp(YC);
function UC() {
  customElements.define("eta-chart", XC), customElements.define("eta-table", GC);
}
export {
  UC as registerEtaComp
};
